"use strict";/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var be=["exports","require","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/path","vs/base/common/types","vs/base/common/errors","vs/platform/log/common/log","vs/nls","vs/nls!vs/server/node/server.main","vs/base/common/network","vs/base/common/async","vs/base/common/buffer","vs/platform/files/common/files","vs/base/common/strings","vs/base/common/arrays","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/uuid","vs/base/node/pfs","vs/base/common/objects","vs/platform/configuration/common/configuration","vs/platform/environment/common/environment","vs/platform/product/common/productService","vs/base/common/map","vs/base/common/process","os","vs/platform/extensionManagement/common/extensionManagement","vs/platform/telemetry/common/telemetry","vs/platform/userDataProfile/common/userDataProfile","fs","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/uriIdentity/common/uriIdentity","vs/platform/telemetry/common/telemetryUtils","vs/base/common/extpath","vs/base/common/errorMessage","vs/platform/registry/common/platform","vs/server/node/serverEnvironmentService","vs/base/common/performance","vs/base/parts/ipc/common/ipc","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/stream","vs/base/common/codicons","vs/base/common/uriIpc","child_process","vs/editor/common/core/range","vs/base/common/semver/semver","vs/platform/product/common/product","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteHosts","vs/platform/request/common/request","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/iterator","vs/base/common/mime","vs/base/common/processes","vs/base/common/severity","vs/base/common/ternarySearchTree","vs/base/common/marshalling","vs/base/parts/ipc/node/ipc.net","vs/platform/environment/node/argv","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/files/node/diskFileSystemProvider","vs/platform/policy/common/policy","vs/workbench/api/node/uriTransformer","vs/workbench/contrib/testing/common/testId","vs/base/common/functional","vs/base/common/json","vs/base/common/glob","vs/platform/extensions/common/extensionValidator","vs/platform/credentials/common/credentials","vs/platform/download/common/download","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","url","vs/platform/shell/node/shellEnv","vs/platform/terminal/common/environmentVariableShared","vs/platform/workspace/common/workspace","vs/server/node/remoteLanguagePacks","vs/workbench/common/editor","vs/workbench/contrib/testing/common/testTypes","vs/base/node/zip","vs/base/common/decorators","vs/base/common/assert","vs/base/common/linkedList","vs/base/common/normalization","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/themables","vs/base/common/htmlContent","path","vs/base/node/id","net","vs/base/node/powershell","vs/base/node/processes","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.cp","vs/editor/common/core/position","vs/platform/environment/node/environmentService","vs/platform/contextkey/common/contextkey","vs/platform/files/common/io","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/fileService","vs/platform/log/common/logIpc","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/languagePacks/node/languagePacks","crypto","vs/platform/terminal/common/environmentVariable","vs/platform/terminal/common/environmentVariableCollection","vs/platform/terminal/common/terminal","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/server/node/extensionHostStatusService","vs/server/node/extensionsScannerService","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/editor/common/editorService","vs/server/node/extensionHostConnection","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/remote/common/remoteAgentService","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","vs/base/common/amd","vs/base/common/lazy","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/skipList","vs/base/common/cache","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/console","vs/base/common/labels","vs/base/common/dataTransfer","vs/base/node/languagePacks","vs/base/node/macAddress","vs/base/node/extpath","vs/base/node/ports","vs/base/node/shell","vs/base/parts/storage/common/storage","vs/editor/common/tokenizationRegistry","vs/editor/common/languages","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/server/node/serverEnvironmentService","vs/nls!vs/server/node/serverServices","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsUtil","vs/platform/contextkey/common/scanner","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/download/common/downloadIpc","vs/platform/environment/common/environmentService","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/extensionManagement/common/extensionNls","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/diagnostics/common/diagnostics","vs/platform/encryption/common/encryptionService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/label/common/label","vs/platform/credentials/common/credentialsMainService","vs/platform/encryption/node/encryptionMainService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/node/diskFileSystemProviderServer","vs/platform/log/node/loggerService","vs/platform/markers/common/markers","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/remote/common/remoteExtensionsScanner","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","vs/platform/state/node/state","vs/platform/state/node/stateService","vs/platform/telemetry/common/errorTelemetry","vs/platform/telemetry/common/remoteTelemetryChannel","vs/platform/diagnostics/node/diagnosticsService","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/common/serverTelemetryService","vs/platform/telemetry/node/1dsAppender","https","vs/platform/telemetry/node/errorTelemetry","vs/platform/terminal/common/requestStore","vs/platform/terminal/common/terminalEnvironment","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalEnvironment","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/storage/common/storage","vs/platform/userDataProfile/common/userDataProfileIpc","vs/server/node/remoteExtensionManagement","vs/server/node/serverConnectionToken","cookie","vs/platform/credentials/node/credentialsMainService","vs/server/node/telemetryClient","http","vs/server/node/webClientServer","vs/workbench/api/common/extHostInitDataService","vs/workbench/api/common/extHostRpcService","vs/server/node/remoteAgentEnvironmentImpl","vs/server/node/remoteFileSystemProviderServer","vs/workbench/contrib/terminal/common/environmentVariable","vs/workbench/contrib/terminal/common/terminalEnvironment","vs/workbench/services/configuration/common/configuration","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/contrib/terminal/common/remoteTerminalChannel","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostTelemetry","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostTestItem","vs/workbench/services/extensions/common/extensionsUtil","vs/server/node/remoteExtensionsScanner","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostCommands","vs/workbench/api/node/extHostCLIServer","vs/server/node/remoteTerminalChannel","vs/workbench/services/remote/common/remoteFileSystemProviderClient","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementUtil","vs/server/node/remoteExtensionHostAgentCli","vs/server/node/serverServices","vs/server/node/remoteExtensionHostAgentServer","perf_hooks","util","minimist","assert","graceful-fs","@microsoft/1ds-core-js","yauzl","yazl","zlib","vs/server/node/server.main"],Ee=function(oe){for(var e=[],E=0,A=oe.length;E<A;E++)e[E]=be[oe[E]];return e};define(be[140],Ee([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoaderStats=void 0;class E{static get(){const l=new Map,w=new Map,S=new Map,P=new Map;function y(d,m){d.has(m.detail)||d.set(m.detail,-m.timestamp)}function b(d,m){const p=d.get(m.detail);!p||p>=0||d.set(m.detail,p+m.timestamp)}let k=[];typeof oe.getStats=="function"&&(k=oe.getStats().slice(0).sort((d,m)=>d.timestamp-m.timestamp));for(const d of k)switch(d.type){case 10:y(l,d);break;case 11:case 12:b(l,d);break;case 21:y(w,d);break;case 22:b(w,d);break;case 33:y(S,d);break;case 34:b(S,d);break;case 31:y(P,d);break;case 32:b(P,d);break}let I=0;S.forEach(d=>I+=d);function v(d){const m=[];return d.forEach((p,c)=>m.push([c,p])),m}return{amdLoad:v(l),amdInvoke:v(w),nodeRequire:v(S),nodeEval:v(P),nodeRequireTotal:I}}static toMarkdownTable(l,w){let S="";const P=[];return l.forEach((y,b)=>{P[b]=y.length}),w.forEach(y=>{y.forEach((b,k)=>{typeof b>"u"&&(b=y[k]="-");const I=b.toString().length;P[k]=Math.max(I,P[k])})}),l.forEach((y,b)=>{S+=`| ${y+" ".repeat(P[b]-y.toString().length)} `}),S+=`|
`,l.forEach((y,b)=>{S+=`| ${"-".repeat(P[b])} `}),S+=`|
`,w.forEach(y=>{y.forEach((b,k)=>{typeof b<"u"&&(S+=`| ${b+" ".repeat(P[k]-b.toString().length)} `)}),S+=`|
`}),S}}e.LoaderStats=E}),define(be[87],Ee([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function E(S){return(P,y,b)=>{let k=null,I=null;if(typeof b.value=="function"?(k="value",I=b.value):typeof b.get=="function"&&(k="get",I=b.get),!I)throw new Error("not supported");b[k]=S(I,y)}}function A(S,P,y){let b=null,k=null;if(typeof y.value=="function"?(b="value",k=y.value,k.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof y.get=="function"&&(b="get",k=y.get),!k)throw new Error("not supported");const I=`$memoize$${P}`;y[b]=function(...v){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:k.apply(this,v)}),this[I]}}e.memoize=A;function l(S,P,y){return E((b,k)=>{const I=`$debounce$${k}`,v=`$debounce$result$${k}`;return function(...d){this[v]||(this[v]=y?y():void 0),clearTimeout(this[I]),P&&(this[v]=P(this[v],...d),d=[this[v]]),this[I]=setTimeout(()=>{b.apply(this,d),this[v]=y?y():void 0},S)}})}e.debounce=l;function w(S,P,y){return E((b,k)=>{const I=`$throttle$timer$${k}`,v=`$throttle$result$${k}`,d=`$throttle$lastRun$${k}`,m=`$throttle$pending$${k}`;return function(...p){if(this[v]||(this[v]=y?y():void 0),(this[d]===null||this[d]===void 0)&&(this[d]=-Number.MAX_VALUE),P&&(this[v]=P(this[v],...p)),this[m])return;const c=this[d]+S;c<=Date.now()?(this[d]=Date.now(),b.apply(this,[this[v]]),this[v]=y?y():void 0):(this[m]=!0,this[I]=setTimeout(()=>{this[m]=!1,this[d]=Date.now(),b.apply(this,[this[v]]),this[v]=y?y():void 0},c-Date.now()))}})}e.throttle=w}),define(be[9],Ee([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class E{constructor(){this.b=[],this.a=function(r){setTimeout(()=>{throw r.stack?D.isErrorNoTelemetry(r)?new D(r.message+`

`+r.stack):new Error(r.message+`

`+r.stack):r},0)}}addListener(r){return this.b.push(r),()=>{this.d(r)}}c(r){this.b.forEach(i=>{i(r)})}d(r){this.b.splice(this.b.indexOf(r),1)}setUnexpectedErrorHandler(r){this.a=r}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(r){this.a(r),this.c(r)}onUnexpectedExternalError(r){this.a(r)}}e.ErrorHandler=E,e.errorHandler=new E;function A(t){e.errorHandler.setUnexpectedErrorHandler(t)}e.setUnexpectedErrorHandler=A;function l(t){if(!t||typeof t!="object")return!1;const r=t;return r.code==="EPIPE"&&r.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=l;function w(t){b(t)||e.errorHandler.onUnexpectedError(t)}e.onUnexpectedError=w;function S(t){b(t)||e.errorHandler.onUnexpectedExternalError(t)}e.onUnexpectedExternalError=S;function P(t){if(t instanceof Error){const{name:r,message:i}=t,n=t.stacktrace||t.stack;return{$isError:!0,name:r,message:i,stack:n,noTelemetry:D.isErrorNoTelemetry(t)}}return t}e.transformErrorForSerialization=P;const y="Canceled";function b(t){return t instanceof k?!0:t instanceof Error&&t.name===y&&t.message===y}e.isCancellationError=b;class k extends Error{constructor(){super(y),this.name=this.message}}e.CancellationError=k;function I(){const t=new Error(y);return t.name=t.message,t}e.canceled=I;function v(t){return t?new Error(`Illegal argument: ${t}`):new Error("Illegal argument")}e.illegalArgument=v;function d(t){return t?new Error(`Illegal state: ${t}`):new Error("Illegal state")}e.illegalState=d;function m(t){return t?new Error(`readonly property '${t} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=m;function p(t){const r=new Error(`${t} has been disposed`);return r.name="DISPOSED",r}e.disposed=p;function c(t){return t?t.message?t.message:t.stack?t.stack.split(`
`)[0]:String(t):"Error"}e.getErrorMessage=c;class h extends Error{constructor(r){super("NotImplemented"),r&&(this.message=r)}}e.NotImplementedError=h;class g extends Error{constructor(r){super("NotSupported"),r&&(this.message=r)}}e.NotSupportedError=g;class f extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=f;class D extends Error{constructor(r){super(r),this.name="CodeExpectedError"}static fromError(r){if(r instanceof D)return r;const i=new D;return i.message=r.message,i.stack=r.stack,i}static isErrorNoTelemetry(r){return r.name==="CodeExpectedError"}}e.ErrorNoTelemetry=D;class R extends Error{constructor(r){super(r||"An unexpected bug occurred."),Object.setPrototypeOf(this,R.prototype);debugger}}e.BugIndicatingError=R}),define(be[18],Ee([1,0,9]),function(oe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function A(j,K=0){return j[j.length-(1+K)]}e.tail=A;function l(j){if(j.length===0)throw new Error("Invalid tail call");return[j.slice(0,j.length-1),j[j.length-1]]}e.tail2=l;function w(j,K,Q=(x,_)=>x===_){if(j===K)return!0;if(!j||!K||j.length!==K.length)return!1;for(let x=0,_=j.length;x<_;x++)if(!Q(j[x],K[x]))return!1;return!0}e.equals=w;function S(j,K){const Q=j.length-1;K<Q&&(j[K]=j[Q]),j.pop()}e.removeFastWithoutKeepingOrder=S;function P(j,K,Q){return y(j.length,x=>Q(j[x],K))}e.binarySearch=P;function y(j,K){let Q=0,x=j-1;for(;Q<=x;){const _=(Q+x)/2|0,Y=K(_);if(Y<0)Q=_+1;else if(Y>0)x=_-1;else return _}return-(Q+1)}e.binarySearch2=y;function b(j,K){let Q=0,x=j.length;if(x===0)return 0;for(;Q<x;){const _=Math.floor((Q+x)/2);K(j[_])?x=_:Q=_+1}return Q}e.findFirstInSorted=b;function k(j,K,Q){if(j=j|0,j>=K.length)throw new TypeError("invalid index");const x=K[Math.floor(K.length*Math.random())],_=[],Y=[],Z=[];for(const ae of K){const ve=Q(ae,x);ve<0?_.push(ae):ve>0?Y.push(ae):Z.push(ae)}return j<_.length?k(j,_,Q):j<_.length+Z.length?Z[0]:k(j-(_.length+Z.length),Y,Q)}e.quickSelect=k;function I(j,K){const Q=[];let x;for(const _ of j.slice(0).sort(K))!x||K(x[0],_)!==0?(x=[_],Q.push(x)):x.push(_);return Q}e.groupBy=I;function v(j,K,Q){const x=[];function _(ae,ve,Pe){if(ve===0&&Pe.length===0)return;const ke=x[x.length-1];ke&&ke.start+ke.deleteCount===ae?(ke.deleteCount+=ve,ke.toInsert.push(...Pe)):x.push({start:ae,deleteCount:ve,toInsert:Pe})}let Y=0,Z=0;for(;;){if(Y===j.length){_(Y,0,K.slice(Z));break}if(Z===K.length){_(Y,j.length-Y,[]);break}const ae=j[Y],ve=K[Z],Pe=Q(ae,ve);Pe===0?(Y+=1,Z+=1):Pe<0?(_(Y,1,[]),Y+=1):Pe>0&&(_(Y,0,[ve]),Z+=1)}return x}e.sortedDiff=v;function d(j,K,Q){const x=v(j,K,Q),_=[],Y=[];for(const Z of x)_.push(...j.slice(Z.start,Z.start+Z.deleteCount)),Y.push(...Z.toInsert);return{removed:_,added:Y}}e.delta=d;function m(j,K,Q){if(Q===0)return[];const x=j.slice(0,Q).sort(K);return c(j,K,x,Q,j.length),x}e.top=m;function p(j,K,Q,x,_){return Q===0?Promise.resolve([]):new Promise((Y,Z)=>{(async()=>{const ae=j.length,ve=j.slice(0,Q).sort(K);for(let Pe=Q,ke=Math.min(Q+x,ae);Pe<ae;Pe=ke,ke=Math.min(ke+x,ae)){if(Pe>Q&&await new Promise(Me=>setTimeout(Me)),_&&_.isCancellationRequested)throw new E.CancellationError;c(j,K,ve,Pe,ke)}return ve})().then(Y,Z)})}e.topAsync=p;function c(j,K,Q,x,_){for(const Y=Q.length;x<_;x++){const Z=j[x];if(K(Z,Q[Y-1])<0){Q.pop();const ae=b(Q,ve=>K(Z,ve)<0);Q.splice(ae,0,Z)}}}function h(j){return j.filter(K=>!!K)}e.coalesce=h;function g(j){let K=0;for(let Q=0;Q<j.length;Q++)j[Q]&&(j[K]=j[Q],K+=1);j.length=K}e.coalesceInPlace=g;function f(j,K,Q){j.splice(Q,0,j.splice(K,1)[0])}e.move=f;function D(j){return!Array.isArray(j)||j.length===0}e.isFalsyOrEmpty=D;function R(j){return Array.isArray(j)&&j.length>0}e.isNonEmptyArray=R;function t(j,K=Q=>Q){const Q=new Set;return j.filter(x=>{const _=K(x);return Q.has(_)?!1:(Q.add(_),!0)})}e.distinct=t;function r(j){const K=new Set;return Q=>{const x=j(Q);return K.has(x)?!1:(K.add(x),!0)}}e.uniqueFilter=r;function i(j,K){const Q=n(j,K);if(Q!==-1)return j[Q]}e.findLast=i;function n(j,K){for(let Q=j.length-1;Q>=0;Q--){const x=j[Q];if(K(x))return Q}return-1}e.lastIndex=n;function o(j,K){return j.length>0?j[0]:K}e.firstOrDefault=o;function u(j,K){return j.length>0?j[j.length-1]:K}e.lastOrDefault=u;function a(j,K,Q=(x,_)=>x===_){let x=0;for(let _=0,Y=Math.min(j.length,K.length);_<Y&&Q(j[_],K[_]);_++)x++;return x}e.commonPrefixLength=a;function s(j){return[].concat(...j)}e.flatten=s;function C(j,K){let Q=typeof K=="number"?j:0;typeof K=="number"?Q=j:(Q=0,K=j);const x=[];if(Q<=K)for(let _=Q;_<K;_++)x.push(_);else for(let _=Q;_>K;_--)x.push(_);return x}e.range=C;function L(j,K,Q){return j.reduce((x,_)=>(x[K(_)]=Q?Q(_):_,x),Object.create(null))}e.index=L;function O(j,K){return j.push(K),()=>W(j,K)}e.insert=O;function W(j,K){const Q=j.indexOf(K);if(Q>-1)return j.splice(Q,1),K}e.remove=W;function X(j,K,Q){const x=j.slice(0,K),_=j.slice(K);return x.concat(Q,_)}e.arrayInsert=X;function se(j,K){let Q;if(typeof K=="number"){let x=K;Q=()=>{const _=Math.sin(x++)*179426549;return _-Math.floor(_)}}else Q=Math.random;for(let x=j.length-1;x>0;x-=1){const _=Math.floor(Q()*(x+1)),Y=j[x];j[x]=j[_],j[_]=Y}}e.shuffle=se;function fe(j,K){const Q=j.indexOf(K);Q>-1&&(j.splice(Q,1),j.unshift(K))}e.pushToStart=fe;function ce(j,K){const Q=j.indexOf(K);Q>-1&&(j.splice(Q,1),j.push(K))}e.pushToEnd=ce;function V(j,K){for(const Q of K)j.push(Q)}e.pushMany=V;function T(j,K){return Array.isArray(j)?j.map(K):K(j)}e.mapArrayOrNot=T;function z(j){return Array.isArray(j)?j:[j]}e.asArray=z;function he(j){return j[Math.floor(Math.random()*j.length)]}e.getRandomElement=he;function H(j,K){for(const Q of j){const x=K(Q);if(x!==void 0)return x}}e.mapFind=H;function q(j,K,Q){const x=ee(j,K),_=j.length,Y=Q.length;j.length=_+Y;for(let Z=_-1;Z>=x;Z--)j[Z+Y]=j[Z];for(let Z=0;Z<Y;Z++)j[Z+x]=Q[Z]}e.insertInto=q;function M(j,K,Q,x){const _=ee(j,K),Y=j.splice(_,Q);return q(j,_,x),Y}e.splice=M;function ee(j,K){return K<0?Math.max(K+j.length,0):Math.min(K,j.length)}var ie;(function(j){function K(_){return _<0}j.isLessThan=K;function Q(_){return _>0}j.isGreaterThan=Q;function x(_){return _===0}j.isNeitherLessOrGreaterThan=x,j.greaterThan=1,j.lessThan=-1,j.neitherLessOrGreaterThan=0})(ie=e.CompareResult||(e.CompareResult={}));function me(j,K){return(Q,x)=>K(j(Q),j(x))}e.compareBy=me;function ne(...j){return(K,Q)=>{for(const x of j){const _=x(K,Q);if(!ie.isNeitherLessOrGreaterThan(_))return _}return ie.neitherLessOrGreaterThan}}e.tieBreakComparators=ne;const B=(j,K)=>j-K;e.numberComparator=B;function N(j,K){if(j.length===0)return;let Q=j[0];for(let x=1;x<j.length;x++){const _=j[x];K(_,Q)>0&&(Q=_)}return Q}e.findMaxBy=N;function U(j,K){if(j.length===0)return;let Q=j[0];for(let x=1;x<j.length;x++){const _=j[x];K(_,Q)>=0&&(Q=_)}return Q}e.findLastMaxBy=U;function G(j,K){return N(j,(Q,x)=>-K(Q,x))}e.findMinBy=G;class te{constructor(K){this.f=K,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(K){let Q=this.c;for(;Q<this.f.length&&K(this.f[Q]);)Q++;const x=Q===this.c?null:this.f.slice(this.c,Q);return this.c=Q,x}takeFromEndWhile(K){let Q=this.d;for(;Q>=0&&K(this.f[Q]);)Q--;const x=Q===this.d?null:this.f.slice(Q+1,this.d+1);return this.d=Q,x}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const K=this.f[this.c];return this.c++,K}removeLast(){const K=this.f[this.d];return this.d--,K}takeCount(K){const Q=this.f.slice(this.c,this.c+K);return this.c+=K,Q}}e.ArrayQueue=te;class le{constructor(K){this.iterate=K}forEach(K){this.iterate(Q=>(K(Q),!0))}toArray(){const K=[];return this.iterate(Q=>(K.push(Q),!0)),K}filter(K){return new le(Q=>this.iterate(x=>K(x)?Q(x):!0))}map(K){return new le(Q=>this.iterate(x=>Q(K(x))))}some(K){let Q=!1;return this.iterate(x=>(Q=K(x),!Q)),Q}findFirst(K){let Q;return this.iterate(x=>K(x)?(Q=x,!1):!0),Q}findLast(K){let Q;return this.iterate(x=>(K(x)&&(Q=x),!0)),Q}findLastMaxBy(K){let Q,x=!0;return this.iterate(_=>((x||ie.isGreaterThan(K(_,Q)))&&(x=!1,Q=_),!0)),Q}}le.empty=new le(j=>{}),e.CallbackIterable=le}),define(be[88],Ee([1,0,9]),function(oe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function A(y,b){if(!y)throw new Error(b?`Assertion failed (${b})`:"Assertion Failed")}e.ok=A;function l(y,b="Unreachable"){throw new Error(b)}e.assertNever=l;function w(y){if(!y)throw new E.BugIndicatingError("Assertion Failed")}e.assert=w;function S(y){if(!y()){debugger;y(),(0,E.onUnexpectedError)(new E.BugIndicatingError("Assertion Failed"))}}e.assertFn=S;function P(y,b){let k=0;for(;k<y.length-1;){const I=y[k],v=y[k+1];if(!b(I,v))return!1;k++}return!0}e.checkAdjacentItems=P}),define(be[70],Ee([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function E(A){const l=this;let w=!1,S;return function(){return w||(w=!0,S=A.apply(l,arguments)),S}}e.once=E}),define(be[56],Ee([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var E;(function(A){function l(D){return D&&typeof D=="object"&&typeof D[Symbol.iterator]=="function"}A.is=l;const w=Object.freeze([]);function S(){return w}A.empty=S;function*P(D){yield D}A.single=P;function y(D){return l(D)?D:P(D)}A.wrap=y;function b(D){return D||w}A.from=b;function k(D){return!D||D[Symbol.iterator]().next().done===!0}A.isEmpty=k;function I(D){return D[Symbol.iterator]().next().value}A.first=I;function v(D,R){for(const t of D)if(R(t))return!0;return!1}A.some=v;function d(D,R){for(const t of D)if(R(t))return t}A.find=d;function*m(D,R){for(const t of D)R(t)&&(yield t)}A.filter=m;function*p(D,R){let t=0;for(const r of D)yield R(r,t++)}A.map=p;function*c(...D){for(const R of D)for(const t of R)yield t}A.concat=c;function h(D,R,t){let r=t;for(const i of D)r=R(r,i);return r}A.reduce=h;function*g(D,R,t=D.length){for(R<0&&(R+=D.length),t<0?t+=D.length:t>D.length&&(t=D.length);R<t;R++)yield D[R]}A.slice=g;function f(D,R=Number.POSITIVE_INFINITY){const t=[];if(R===0)return[t,D];const r=D[Symbol.iterator]();for(let i=0;i<R;i++){const n=r.next();if(n.done)return[t,A.empty()];t.push(n.value)}return[t,{[Symbol.iterator](){return r}}]}A.consume=f})(E=e.Iterable||(e.Iterable={}))}),define(be[71],Ee([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var E;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(E=e.ScanError||(e.ScanError={}));var A;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(A=e.SyntaxKind||(e.SyntaxKind={}));var l;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(l=e.ParseErrorCode||(e.ParseErrorCode={}));var w;(function(t){t.DEFAULT={allowTrailingComma:!0}})(w=e.ParseOptions||(e.ParseOptions={}));function S(t,r=!1){let i=0;const n=t.length;let o="",u=0,a=16,s=0;function C(ce){let V=0,T=0;for(;V<ce;){const z=t.charCodeAt(i);if(z>=48&&z<=57)T=T*16+z-48;else if(z>=65&&z<=70)T=T*16+z-65+10;else if(z>=97&&z<=102)T=T*16+z-97+10;else break;i++,V++}return V<ce&&(T=-1),T}function L(ce){i=ce,o="",u=0,a=16,s=0}function O(){const ce=i;if(t.charCodeAt(i)===48)i++;else for(i++;i<t.length&&b(t.charCodeAt(i));)i++;if(i<t.length&&t.charCodeAt(i)===46)if(i++,i<t.length&&b(t.charCodeAt(i)))for(i++;i<t.length&&b(t.charCodeAt(i));)i++;else return s=3,t.substring(ce,i);let V=i;if(i<t.length&&(t.charCodeAt(i)===69||t.charCodeAt(i)===101))if(i++,(i<t.length&&t.charCodeAt(i)===43||t.charCodeAt(i)===45)&&i++,i<t.length&&b(t.charCodeAt(i))){for(i++;i<t.length&&b(t.charCodeAt(i));)i++;V=i}else s=3;return t.substring(ce,V)}function W(){let ce="",V=i;for(;;){if(i>=n){ce+=t.substring(V,i),s=2;break}const T=t.charCodeAt(i);if(T===34){ce+=t.substring(V,i),i++;break}if(T===92){if(ce+=t.substring(V,i),i++,i>=n){s=2;break}switch(t.charCodeAt(i++)){case 34:ce+='"';break;case 92:ce+="\\";break;case 47:ce+="/";break;case 98:ce+="\b";break;case 102:ce+="\f";break;case 110:ce+=`
`;break;case 114:ce+="\r";break;case 116:ce+="	";break;case 117:{const he=C(4);he>=0?ce+=String.fromCharCode(he):s=4;break}default:s=5}V=i;continue}if(T>=0&&T<=31)if(y(T)){ce+=t.substring(V,i),s=2;break}else s=6;i++}return ce}function X(){if(o="",s=0,u=i,i>=n)return u=n,a=17;let ce=t.charCodeAt(i);if(P(ce)){do i++,o+=String.fromCharCode(ce),ce=t.charCodeAt(i);while(P(ce));return a=15}if(y(ce))return i++,o+=String.fromCharCode(ce),ce===13&&t.charCodeAt(i)===10&&(i++,o+=`
`),a=14;switch(ce){case 123:return i++,a=1;case 125:return i++,a=2;case 91:return i++,a=3;case 93:return i++,a=4;case 58:return i++,a=6;case 44:return i++,a=5;case 34:return i++,o=W(),a=10;case 47:{const V=i-1;if(t.charCodeAt(i+1)===47){for(i+=2;i<n&&!y(t.charCodeAt(i));)i++;return o=t.substring(V,i),a=12}if(t.charCodeAt(i+1)===42){i+=2;const T=n-1;let z=!1;for(;i<T;){if(t.charCodeAt(i)===42&&t.charCodeAt(i+1)===47){i+=2,z=!0;break}i++}return z||(i++,s=1),o=t.substring(V,i),a=13}return o+=String.fromCharCode(ce),i++,a=16}case 45:if(o+=String.fromCharCode(ce),i++,i===n||!b(t.charCodeAt(i)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=O(),a=11;default:for(;i<n&&se(ce);)i++,ce=t.charCodeAt(i);if(u!==i){switch(o=t.substring(u,i),o){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return o+=String.fromCharCode(ce),i++,a=16}}function se(ce){if(P(ce)||y(ce))return!1;switch(ce){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function fe(){let ce;do ce=X();while(ce>=12&&ce<=15);return ce}return{setPosition:L,getPosition:()=>i,scan:r?fe:X,getToken:()=>a,getTokenValue:()=>o,getTokenOffset:()=>u,getTokenLength:()=>i-u,getTokenError:()=>s}}e.createScanner=S;function P(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function y(t){return t===10||t===13||t===8232||t===8233}function b(t){return t>=48&&t<=57}var k;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(k||(k={}));function I(t,r){const i=[],n=new Object;let o;const u={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function s(C,L,O,W){u.value=C,u.offset=L,u.length=O,u.type=W,u.colonOffset=void 0,o=u}try{f(t,{onObjectBegin:(C,L)=>{if(r<=C)throw n;o=void 0,a=r>C,i.push("")},onObjectProperty:(C,L,O)=>{if(r<L||(s(C,L,O,"property"),i[i.length-1]=C,r<=L+O))throw n},onObjectEnd:(C,L)=>{if(r<=C)throw n;o=void 0,i.pop()},onArrayBegin:(C,L)=>{if(r<=C)throw n;o=void 0,i.push(0)},onArrayEnd:(C,L)=>{if(r<=C)throw n;o=void 0,i.pop()},onLiteralValue:(C,L,O)=>{if(r<L||(s(C,L,O,R(C)),r<=L+O))throw n},onSeparator:(C,L,O)=>{if(r<=L)throw n;if(C===":"&&o&&o.type==="property")o.colonOffset=L,a=!1,o=void 0;else if(C===","){const W=i[i.length-1];typeof W=="number"?i[i.length-1]=W+1:(a=!0,i[i.length-1]=""),o=void 0}}})}catch(C){if(C!==n)throw C}return{path:i,previousNode:o,isAtPropertyKey:a,matches:C=>{let L=0;for(let O=0;L<C.length&&O<i.length;O++)if(C[L]===i[O]||C[L]==="*")L++;else if(C[L]!=="**")return!1;return L===C.length}}}e.getLocation=I;function v(t,r=[],i=w.DEFAULT){let n=null,o=[];const u=[];function a(C){Array.isArray(o)?o.push(C):n!==null&&(o[n]=C)}return f(t,{onObjectBegin:()=>{const C={};a(C),u.push(o),o=C,n=null},onObjectProperty:C=>{n=C},onObjectEnd:()=>{o=u.pop()},onArrayBegin:()=>{const C=[];a(C),u.push(o),o=C,n=null},onArrayEnd:()=>{o=u.pop()},onLiteralValue:a,onError:(C,L,O)=>{r.push({error:C,offset:L,length:O})}},i),o[0]}e.parse=v;function d(t,r=[],i=w.DEFAULT){let n={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(C){n.type==="property"&&(n.length=C-n.offset,n=n.parent)}function u(C){return n.children.push(C),C}f(t,{onObjectBegin:C=>{n=u({type:"object",offset:C,length:-1,parent:n,children:[]})},onObjectProperty:(C,L,O)=>{n=u({type:"property",offset:L,length:-1,parent:n,children:[]}),n.children.push({type:"string",value:C,offset:L,length:O,parent:n})},onObjectEnd:(C,L)=>{n.length=C+L-n.offset,n=n.parent,o(C+L)},onArrayBegin:(C,L)=>{n=u({type:"array",offset:C,length:-1,parent:n,children:[]})},onArrayEnd:(C,L)=>{n.length=C+L-n.offset,n=n.parent,o(C+L)},onLiteralValue:(C,L,O)=>{u({type:R(C),offset:L,length:O,parent:n,value:C}),o(L+O)},onSeparator:(C,L,O)=>{n.type==="property"&&(C===":"?n.colonOffset=L:C===","&&o(L))},onError:(C,L,O)=>{r.push({error:C,offset:L,length:O})}},i);const s=n.children[0];return s&&delete s.parent,s}e.parseTree=d;function m(t,r){if(!t)return;let i=t;for(const n of r)if(typeof n=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let o=!1;for(const u of i.children)if(Array.isArray(u.children)&&u.children[0].value===n){i=u.children[1],o=!0;break}if(!o)return}else{const o=n;if(i.type!=="array"||o<0||!Array.isArray(i.children)||o>=i.children.length)return;i=i.children[o]}return i}e.findNodeAtLocation=m;function p(t){if(!t.parent||!t.parent.children)return[];const r=p(t.parent);if(t.parent.type==="property"){const i=t.parent.children[0].value;r.push(i)}else if(t.parent.type==="array"){const i=t.parent.children.indexOf(t);i!==-1&&r.push(i)}return r}e.getNodePath=p;function c(t){switch(t.type){case"array":return t.children.map(c);case"object":{const r=Object.create(null);for(const i of t.children){const n=i.children[1];n&&(r[i.children[0].value]=c(n))}return r}case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=c;function h(t,r,i=!1){return r>=t.offset&&r<t.offset+t.length||i&&r===t.offset+t.length}e.contains=h;function g(t,r,i=!1){if(h(t,r,i)){const n=t.children;if(Array.isArray(n))for(let o=0;o<n.length&&n[o].offset<=r;o++){const u=g(n[o],r,i);if(u)return u}return t}}e.findNodeAtOffset=g;function f(t,r,i=w.DEFAULT){const n=S(t,!1);function o(me){return me?()=>me(n.getTokenOffset(),n.getTokenLength()):()=>!0}function u(me){return me?ne=>me(ne,n.getTokenOffset(),n.getTokenLength()):()=>!0}const a=o(r.onObjectBegin),s=u(r.onObjectProperty),C=o(r.onObjectEnd),L=o(r.onArrayBegin),O=o(r.onArrayEnd),W=u(r.onLiteralValue),X=u(r.onSeparator),se=o(r.onComment),fe=u(r.onError),ce=i&&i.disallowComments,V=i&&i.allowTrailingComma;function T(){for(;;){const me=n.scan();switch(n.getTokenError()){case 4:z(14);break;case 5:z(15);break;case 3:z(13);break;case 1:ce||z(11);break;case 2:z(12);break;case 6:z(16);break}switch(me){case 12:case 13:ce?z(10):se();break;case 16:z(1);break;case 15:case 14:break;default:return me}}}function z(me,ne=[],B=[]){if(fe(me),ne.length+B.length>0){let N=n.getToken();for(;N!==17;){if(ne.indexOf(N)!==-1){T();break}else if(B.indexOf(N)!==-1)break;N=T()}}}function he(me){const ne=n.getTokenValue();return me?W(ne):s(ne),T(),!0}function H(){switch(n.getToken()){case 11:{let me=0;try{me=JSON.parse(n.getTokenValue()),typeof me!="number"&&(z(2),me=0)}catch{z(2)}W(me);break}case 7:W(null);break;case 8:W(!0);break;case 9:W(!1);break;default:return!1}return T(),!0}function q(){return n.getToken()!==10?(z(3,[],[2,5]),!1):(he(!1),n.getToken()===6?(X(":"),T(),ie()||z(4,[],[2,5])):z(5,[],[2,5]),!0)}function M(){a(),T();let me=!1;for(;n.getToken()!==2&&n.getToken()!==17;){if(n.getToken()===5){if(me||z(4,[],[]),X(","),T(),n.getToken()===2&&V)break}else me&&z(6,[],[]);q()||z(4,[],[2,5]),me=!0}return C(),n.getToken()!==2?z(7,[2],[]):T(),!0}function ee(){L(),T();let me=!1;for(;n.getToken()!==4&&n.getToken()!==17;){if(n.getToken()===5){if(me||z(4,[],[]),X(","),T(),n.getToken()===4&&V)break}else me&&z(6,[],[]);ie()||z(4,[],[4,5]),me=!0}return O(),n.getToken()!==4?z(8,[4],[]):T(),!0}function ie(){switch(n.getToken()){case 3:return ee();case 1:return M();case 10:return he(!0);default:return H()}}return T(),n.getToken()===17?i.allowEmptyContent?!0:(z(4,[],[]),!1):ie()?(n.getToken()!==17&&z(9,[],[]),!0):(z(4,[],[]),!1)}e.visit=f;function D(t,r){const i=S(t),n=[];let o,u=0,a;do switch(a=i.getPosition(),o=i.scan(),o){case 12:case 13:case 17:u!==a&&n.push(t.substring(u,a)),r!==void 0&&n.push(i.getTokenValue().replace(/[^\r\n]/g,r)),u=i.getPosition();break}while(o!==17);return n.join("")}e.stripComments=D;function R(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=R}),define(be[141],Ee([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class E{constructor(l){this.d=l,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(l){this.c=l}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.Lazy=E}),define(be[2],Ee([1,0,70,56]),function(oe,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const l=!1;let w=null;function S(u){w=u}if(e.setDisposableTracker=S,l){const u="__is_disposable_tracked__";S(new class{trackDisposable(a){const s=new Error("Potentially leaked disposable").stack;setTimeout(()=>{a[u]||console.log(s)},3e3)}setParent(a,s){if(a&&a!==g.None)try{a[u]=!0}catch{}}markAsDisposed(a){if(a&&a!==g.None)try{a[u]=!0}catch{}}markAsSingleton(a){}})}function P(u){return w?.trackDisposable(u),u}function y(u){w?.markAsDisposed(u)}function b(u,a){w?.setParent(u,a)}function k(u,a){if(!!w)for(const s of u)w.setParent(s,a)}function I(u){return w?.markAsSingleton(u),u}e.markAsSingleton=I;function v(u){return typeof u.dispose=="function"&&u.dispose.length===0}e.isDisposable=v;function d(u){if(A.Iterable.is(u)){const a=[];for(const s of u)if(s)try{s.dispose()}catch(C){a.push(C)}if(a.length===1)throw a[0];if(a.length>1)throw new AggregateError(a,"Encountered errors while disposing of store");return Array.isArray(u)?[]:u}else if(u)return u.dispose(),u}e.dispose=d;function m(u){for(const a of u)v(a)&&a.dispose();return[]}e.disposeIfDisposable=m;function p(...u){const a=c(()=>d(u));return k(u,a),a}e.combinedDisposable=p;function c(u){const a=P({dispose:(0,E.once)(()=>{y(a),u()})});return a}e.toDisposable=c;class h{constructor(){this.c=new Set,this.f=!1,P(this)}dispose(){this.f||(y(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{d(this.c)}finally{this.c.clear()}}add(a){if(!a)return a;if(a===this)throw new Error("Cannot register a disposable on itself!");return b(a,this),this.f?h.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(a),a}}h.DISABLE_DISPOSED_WARNING=!1,e.DisposableStore=h;class g{constructor(){this.q=new h,P(this),b(this.q,this)}dispose(){y(this),this.q.dispose()}B(a){if(a===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(a)}}g.None=Object.freeze({dispose(){}}),e.Disposable=g;class f{constructor(){this.b=!1,P(this)}get value(){return this.b?void 0:this.a}set value(a){this.b||a===this.a||(this.a?.dispose(),a&&b(a,this),this.a=a)}clear(){this.value=void 0}dispose(){this.b=!0,y(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const a=this.a;return this.a=void 0,a&&b(a,null),a}}e.MutableDisposable=f;class D{constructor(a){this.b=a,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.RefCountedDisposable=D;class R{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,P(this)}set(a){let s=a;return this.unset=()=>s=void 0,this.isset=()=>s!==void 0,this.dispose=()=>{s&&(s(),s=void 0,y(this))},this}}e.SafeDisposable=R;class t{constructor(){this.a=new Map}acquire(a,...s){let C=this.a.get(a);C||(C={counter:0,object:this.b(a,...s)},this.a.set(a,C));const{object:L}=C,O=(0,E.once)(()=>{--C.counter===0&&(this.c(a,C.object),this.a.delete(a))});return C.counter++,{object:L,dispose:O}}}e.ReferenceCollection=t;class r{constructor(a){this.a=a}async acquire(a,...s){const C=this.a.acquire(a,...s);try{return{object:await C.object,dispose:()=>C.dispose()}}catch(L){throw C.dispose(),L}}}e.AsyncReferenceCollection=r;class i{constructor(a){this.object=a}dispose(){}}e.ImmortalReference=i;function n(u){const a=new h;try{u(a)}finally{a.dispose()}}e.disposeOnReturn=n;class o{constructor(){this.a=new Map,this.b=!1,P(this)}dispose(){y(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{d(this.a.values())}finally{this.a.clear()}}has(a){return this.a.has(a)}get(a){return this.a.get(a)}set(a,s,C=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),C||this.a.get(a)?.dispose(),this.a.set(a,s)}deleteAndDispose(a){this.a.get(a)?.dispose(),this.a.delete(a)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.DisposableMap=o}),define(be[89],Ee([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class E{constructor(w){this.element=w,this.next=E.Undefined,this.prev=E.Undefined}}E.Undefined=new E(void 0);class A{constructor(){this.a=E.Undefined,this.b=E.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===E.Undefined}clear(){let w=this.a;for(;w!==E.Undefined;){const S=w.next;w.prev=E.Undefined,w.next=E.Undefined,w=S}this.a=E.Undefined,this.b=E.Undefined,this.c=0}unshift(w){return this.d(w,!1)}push(w){return this.d(w,!0)}d(w,S){const P=new E(w);if(this.a===E.Undefined)this.a=P,this.b=P;else if(S){const b=this.b;this.b=P,P.prev=b,b.next=P}else{const b=this.a;this.a=P,P.next=b,b.prev=P}this.c+=1;let y=!1;return()=>{y||(y=!0,this.e(P))}}shift(){if(this.a!==E.Undefined){const w=this.a.element;return this.e(this.a),w}}pop(){if(this.b!==E.Undefined){const w=this.b.element;return this.e(this.b),w}}e(w){if(w.prev!==E.Undefined&&w.next!==E.Undefined){const S=w.prev;S.next=w.next,w.next.prev=S}else w.prev===E.Undefined&&w.next===E.Undefined?(this.a=E.Undefined,this.b=E.Undefined):w.next===E.Undefined?(this.b=this.b.prev,this.b.next=E.Undefined):w.prev===E.Undefined&&(this.a=this.a.next,this.a.prev=E.Undefined);this.c-=1}*[Symbol.iterator](){let w=this.a;for(;w!==E.Undefined;)yield w.element,w=w.next}}e.LinkedList=A}),define(be[27],Ee([1,0]),function(oe,e){"use strict";var E,A,l;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function w(m,p,c){let h=m.get(p);return h===void 0&&(h=c,m.set(p,h)),h}e.getOrSet=w;function S(m){const p=[];return m.forEach((c,h)=>{p.push(`${h} => ${c}`)}),`Map(${m.size}) {${p.join(", ")}}`}e.mapToString=S;function P(m){const p=[];return m.forEach(c=>{p.push(c)}),`Set(${m.size}) {${p.join(", ")}}`}e.setToString=P;class y{constructor(p,c){this.uri=p,this.value=c}}class b{constructor(p,c){this[E]="ResourceMap",p instanceof b?(this.b=new Map(p.b),this.c=c??b.a):(this.b=new Map,this.c=p??b.a)}set(p,c){return this.b.set(this.c(p),new y(p,c)),this}get(p){return this.b.get(this.c(p))?.value}has(p){return this.b.has(this.c(p))}get size(){return this.b.size}clear(){this.b.clear()}delete(p){return this.b.delete(this.c(p))}forEach(p,c){typeof c<"u"&&(p=p.bind(c));for(const[h,g]of this.b)p(g.value,g.uri,this)}*values(){for(const p of this.b.values())yield p.value}*keys(){for(const p of this.b.values())yield p.uri}*entries(){for(const p of this.b.values())yield[p.uri,p.value]}*[(E=Symbol.toStringTag,Symbol.iterator)](){for(const[,p]of this.b)yield[p.uri,p.value]}}b.a=m=>m.toString(),e.ResourceMap=b;class k{constructor(p,c){this[A]="ResourceSet",!p||typeof p=="function"?this.a=new b(p):(this.a=new b(c),p.forEach(this.add,this))}get size(){return this.a.size}add(p){return this.a.set(p,p),this}clear(){this.a.clear()}delete(p){return this.a.delete(p)}forEach(p,c){this.a.forEach((h,g)=>p.call(c,g,g,this))}has(p){return this.a.has(p)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=k;var I;(function(m){m[m.None=0]="None",m[m.AsOld=1]="AsOld",m[m.AsNew=2]="AsNew"})(I=e.Touch||(e.Touch={}));class v{constructor(){this[l]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(p){return this.a.has(p)}get(p,c=0){const h=this.a.get(p);if(!!h)return c!==0&&this.j(h,c),h.value}set(p,c,h=0){let g=this.a.get(p);if(g)g.value=c,h!==0&&this.j(g,h);else{switch(g={key:p,value:c,next:void 0,previous:void 0},h){case 0:this.h(g);break;case 1:this.g(g);break;case 2:this.h(g);break;default:this.h(g);break}this.a.set(p,g),this.d++}return this}delete(p){return!!this.remove(p)}remove(p){const c=this.a.get(p);if(!!c)return this.a.delete(p),this.i(c),this.d--,c.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const p=this.b;return this.a.delete(p.key),this.i(p),this.d--,p.value}forEach(p,c){const h=this.e;let g=this.b;for(;g;){if(c?p.bind(c)(g.value,g.key,this):p(g.value,g.key,this),this.e!==h)throw new Error("LinkedMap got modified during iteration.");g=g.next}}keys(){const p=this,c=this.e;let h=this.b;const g={[Symbol.iterator](){return g},next(){if(p.e!==c)throw new Error("LinkedMap got modified during iteration.");if(h){const f={value:h.key,done:!1};return h=h.next,f}else return{value:void 0,done:!0}}};return g}values(){const p=this,c=this.e;let h=this.b;const g={[Symbol.iterator](){return g},next(){if(p.e!==c)throw new Error("LinkedMap got modified during iteration.");if(h){const f={value:h.value,done:!1};return h=h.next,f}else return{value:void 0,done:!0}}};return g}entries(){const p=this,c=this.e;let h=this.b;const g={[Symbol.iterator](){return g},next(){if(p.e!==c)throw new Error("LinkedMap got modified during iteration.");if(h){const f={value:[h.key,h.value],done:!1};return h=h.next,f}else return{value:void 0,done:!0}}};return g}[(l=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(p){if(p>=this.size)return;if(p===0){this.clear();return}let c=this.b,h=this.size;for(;c&&h>p;)this.a.delete(c.key),c=c.next,h--;this.b=c,this.d=h,c&&(c.previous=void 0),this.e++}g(p){if(!this.b&&!this.c)this.c=p;else if(this.b)p.next=this.b,this.b.previous=p;else throw new Error("Invalid list");this.b=p,this.e++}h(p){if(!this.b&&!this.c)this.b=p;else if(this.c)p.previous=this.c,this.c.next=p;else throw new Error("Invalid list");this.c=p,this.e++}i(p){if(p===this.b&&p===this.c)this.b=void 0,this.c=void 0;else if(p===this.b){if(!p.next)throw new Error("Invalid list");p.next.previous=void 0,this.b=p.next}else if(p===this.c){if(!p.previous)throw new Error("Invalid list");p.previous.next=void 0,this.c=p.previous}else{const c=p.next,h=p.previous;if(!c||!h)throw new Error("Invalid list");c.previous=h,h.next=c}p.next=void 0,p.previous=void 0,this.e++}j(p,c){if(!this.b||!this.c)throw new Error("Invalid list");if(!(c!==1&&c!==2)){if(c===1){if(p===this.b)return;const h=p.next,g=p.previous;p===this.c?(g.next=void 0,this.c=g):(h.previous=g,g.next=h),p.previous=void 0,p.next=this.b,this.b.previous=p,this.b=p,this.e++}else if(c===2){if(p===this.c)return;const h=p.next,g=p.previous;p===this.b?(h.previous=void 0,this.b=h):(h.previous=g,g.next=h),p.next=void 0,p.previous=this.c,this.c.next=p,this.c=p,this.e++}}}toJSON(){const p=[];return this.forEach((c,h)=>{p.push([h,c])}),p}fromJSON(p){this.clear();for(const[c,h]of p)this.set(c,h)}}e.LinkedMap=v;class d extends v{constructor(p,c=1){super(),this.k=p,this.l=Math.min(Math.max(0,c),1)}get limit(){return this.k}set limit(p){this.k=p,this.m()}get ratio(){return this.l}set ratio(p){this.l=Math.min(Math.max(0,p),1),this.m()}get(p,c=2){return super.get(p,c)}peek(p){return super.get(p,0)}set(p,c){return super.set(p,c,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=d}),function(oe,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(be[142],Ee([0]),e):(oe=typeof globalThis<"u"?globalThis:oe||self,e(oe.marked={}))}(this,function(oe){"use strict";function e(j,K){for(var Q=0;Q<K.length;Q++){var x=K[Q];x.enumerable=x.enumerable||!1,x.configurable=!0,"value"in x&&(x.writable=!0),Object.defineProperty(j,x.key,x)}}function E(j,K,Q){return K&&e(j.prototype,K),Q&&e(j,Q),Object.defineProperty(j,"prototype",{writable:!1}),j}function A(j,K){if(!!j){if(typeof j=="string")return l(j,K);var Q=Object.prototype.toString.call(j).slice(8,-1);if(Q==="Object"&&j.constructor&&(Q=j.constructor.name),Q==="Map"||Q==="Set")return Array.from(j);if(Q==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Q))return l(j,K)}}function l(j,K){(K==null||K>j.length)&&(K=j.length);for(var Q=0,x=new Array(K);Q<K;Q++)x[Q]=j[Q];return x}function w(j,K){var Q=typeof Symbol<"u"&&j[Symbol.iterator]||j["@@iterator"];if(Q)return(Q=Q.call(j)).next.bind(Q);if(Array.isArray(j)||(Q=A(j))||K&&j&&typeof j.length=="number"){Q&&(j=Q);var x=0;return function(){return x>=j.length?{done:!0}:{done:!1,value:j[x++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function S(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}oe.defaults=S();function P(j){oe.defaults=j}var y=/[&<>"']/,b=/[&<>"']/g,k=/[<>"']|&(?!#?\w+;)/,I=/[<>"']|&(?!#?\w+;)/g,v={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},d=function(K){return v[K]};function m(j,K){if(K){if(y.test(j))return j.replace(b,d)}else if(k.test(j))return j.replace(I,d);return j}var p=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function c(j){return j.replace(p,function(K,Q){return Q=Q.toLowerCase(),Q==="colon"?":":Q.charAt(0)==="#"?Q.charAt(1)==="x"?String.fromCharCode(parseInt(Q.substring(2),16)):String.fromCharCode(+Q.substring(1)):""})}var h=/(^|[^\[])\^/g;function g(j,K){j=typeof j=="string"?j:j.source,K=K||"";var Q={replace:function(_,Y){return Y=Y.source||Y,Y=Y.replace(h,"$1"),j=j.replace(_,Y),Q},getRegex:function(){return new RegExp(j,K)}};return Q}var f=/[^\w:]/g,D=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function R(j,K,Q){if(j){var x;try{x=decodeURIComponent(c(Q)).replace(f,"").toLowerCase()}catch{return null}if(x.indexOf("javascript:")===0||x.indexOf("vbscript:")===0||x.indexOf("data:")===0)return null}K&&!D.test(Q)&&(Q=o(K,Q));try{Q=encodeURI(Q).replace(/%25/g,"%")}catch{return null}return Q}var t={},r=/^[^:]+:\/*[^/]*$/,i=/^([^:]+:)[\s\S]*$/,n=/^([^:]+:\/*[^/]*)[\s\S]*$/;function o(j,K){t[" "+j]||(r.test(j)?t[" "+j]=j+"/":t[" "+j]=C(j,"/",!0)),j=t[" "+j];var Q=j.indexOf(":")===-1;return K.substring(0,2)==="//"?Q?K:j.replace(i,"$1")+K:K.charAt(0)==="/"?Q?K:j.replace(n,"$1")+K:j+K}var u={exec:function(){}};function a(j){for(var K=1,Q,x;K<arguments.length;K++){Q=arguments[K];for(x in Q)Object.prototype.hasOwnProperty.call(Q,x)&&(j[x]=Q[x])}return j}function s(j,K){var Q=j.replace(/\|/g,function(Y,Z,ae){for(var ve=!1,Pe=Z;--Pe>=0&&ae[Pe]==="\\";)ve=!ve;return ve?"|":" |"}),x=Q.split(/ \|/),_=0;if(x[0].trim()||x.shift(),x.length>0&&!x[x.length-1].trim()&&x.pop(),x.length>K)x.splice(K);else for(;x.length<K;)x.push("");for(;_<x.length;_++)x[_]=x[_].trim().replace(/\\\|/g,"|");return x}function C(j,K,Q){var x=j.length;if(x===0)return"";for(var _=0;_<x;){var Y=j.charAt(x-_-1);if(Y===K&&!Q)_++;else if(Y!==K&&Q)_++;else break}return j.slice(0,x-_)}function L(j,K){if(j.indexOf(K[1])===-1)return-1;for(var Q=j.length,x=0,_=0;_<Q;_++)if(j[_]==="\\")_++;else if(j[_]===K[0])x++;else if(j[_]===K[1]&&(x--,x<0))return _;return-1}function O(j){j&&j.sanitize&&!j.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function W(j,K){if(K<1)return"";for(var Q="";K>1;)K&1&&(Q+=j),K>>=1,j+=j;return Q+j}function X(j,K,Q,x){var _=K.href,Y=K.title?m(K.title):null,Z=j[1].replace(/\\([\[\]])/g,"$1");if(j[0].charAt(0)!=="!"){x.state.inLink=!0;var ae={type:"link",raw:Q,href:_,title:Y,text:Z,tokens:x.inlineTokens(Z)};return x.state.inLink=!1,ae}return{type:"image",raw:Q,href:_,title:Y,text:m(Z)}}function se(j,K){var Q=j.match(/^(\s+)(?:```)/);if(Q===null)return K;var x=Q[1];return K.split(`
`).map(function(_){var Y=_.match(/^\s+/);if(Y===null)return _;var Z=Y[0];return Z.length>=x.length?_.slice(x.length):_}).join(`
`)}var fe=function(){function j(Q){this.options=Q||oe.defaults}var K=j.prototype;return K.space=function(x){var _=this.rules.block.newline.exec(x);if(_&&_[0].length>0)return{type:"space",raw:_[0]}},K.code=function(x){var _=this.rules.block.code.exec(x);if(_){var Y=_[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:_[0],codeBlockStyle:"indented",text:this.options.pedantic?Y:C(Y,`
`)}}},K.fences=function(x){var _=this.rules.block.fences.exec(x);if(_){var Y=_[0],Z=se(Y,_[3]||"");return{type:"code",raw:Y,lang:_[2]?_[2].trim():_[2],text:Z}}},K.heading=function(x){var _=this.rules.block.heading.exec(x);if(_){var Y=_[2].trim();if(/#$/.test(Y)){var Z=C(Y,"#");(this.options.pedantic||!Z||/ $/.test(Z))&&(Y=Z.trim())}return{type:"heading",raw:_[0],depth:_[1].length,text:Y,tokens:this.lexer.inline(Y)}}},K.hr=function(x){var _=this.rules.block.hr.exec(x);if(_)return{type:"hr",raw:_[0]}},K.blockquote=function(x){var _=this.rules.block.blockquote.exec(x);if(_){var Y=_[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:_[0],tokens:this.lexer.blockTokens(Y,[]),text:Y}}},K.list=function(x){var _=this.rules.block.list.exec(x);if(_){var Y,Z,ae,ve,Pe,ke,Me,je,ge,we,ye,Fe,$e=_[1].trim(),tt=$e.length>1,Ve={type:"list",raw:"",ordered:tt,start:tt?+$e.slice(0,-1):"",loose:!1,items:[]};$e=tt?"\\d{1,9}\\"+$e.slice(-1):"\\"+$e,this.options.pedantic&&($e=tt?$e:"[*+-]");for(var Je=new RegExp("^( {0,3}"+$e+")((?:[	 ][^\\n]*)?(?:\\n|$))");x&&(Fe=!1,!(!(_=Je.exec(x))||this.rules.block.hr.test(x)));){if(Y=_[0],x=x.substring(Y.length),je=_[2].split(`
`,1)[0],ge=x.split(`
`,1)[0],this.options.pedantic?(ve=2,ye=je.trimLeft()):(ve=_[2].search(/[^ ]/),ve=ve>4?1:ve,ye=je.slice(ve),ve+=_[1].length),ke=!1,!je&&/^ *$/.test(ge)&&(Y+=ge+`
`,x=x.substring(ge.length+1),Fe=!0),!Fe)for(var Xe=new RegExp("^ {0,"+Math.min(3,ve-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),_e=new RegExp("^ {0,"+Math.min(3,ve-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),Ke=new RegExp("^ {0,"+Math.min(3,ve-1)+"}(?:```|~~~)"),ue=new RegExp("^ {0,"+Math.min(3,ve-1)+"}#");x&&(we=x.split(`
`,1)[0],je=we,this.options.pedantic&&(je=je.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Ke.test(je)||ue.test(je)||Xe.test(je)||_e.test(x)));){if(je.search(/[^ ]/)>=ve||!je.trim())ye+=`
`+je.slice(ve);else if(!ke)ye+=`
`+je;else break;!ke&&!je.trim()&&(ke=!0),Y+=we+`
`,x=x.substring(we.length+1)}Ve.loose||(Me?Ve.loose=!0:/\n *\n *$/.test(Y)&&(Me=!0)),this.options.gfm&&(Z=/^\[[ xX]\] /.exec(ye),Z&&(ae=Z[0]!=="[ ] ",ye=ye.replace(/^\[[ xX]\] +/,""))),Ve.items.push({type:"list_item",raw:Y,task:!!Z,checked:ae,loose:!1,text:ye}),Ve.raw+=Y}Ve.items[Ve.items.length-1].raw=Y.trimRight(),Ve.items[Ve.items.length-1].text=ye.trimRight(),Ve.raw=Ve.raw.trimRight();var De=Ve.items.length;for(Pe=0;Pe<De;Pe++){this.lexer.state.top=!1,Ve.items[Pe].tokens=this.lexer.blockTokens(Ve.items[Pe].text,[]);var Re=Ve.items[Pe].tokens.filter(function(Oe){return Oe.type==="space"}),Ne=Re.every(function(Oe){for(var ze=Oe.raw.split(""),We=0,qe=w(ze),Ge;!(Ge=qe()).done;){var et=Ge.value;if(et===`
`&&(We+=1),We>1)return!0}return!1});!Ve.loose&&Re.length&&Ne&&(Ve.loose=!0,Ve.items[Pe].loose=!0)}return Ve}},K.html=function(x){var _=this.rules.block.html.exec(x);if(_){var Y={type:"html",raw:_[0],pre:!this.options.sanitizer&&(_[1]==="pre"||_[1]==="script"||_[1]==="style"),text:_[0]};if(this.options.sanitize){var Z=this.options.sanitizer?this.options.sanitizer(_[0]):m(_[0]);Y.type="paragraph",Y.text=Z,Y.tokens=this.lexer.inline(Z)}return Y}},K.def=function(x){var _=this.rules.block.def.exec(x);if(_){_[3]&&(_[3]=_[3].substring(1,_[3].length-1));var Y=_[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:Y,raw:_[0],href:_[2],title:_[3]}}},K.table=function(x){var _=this.rules.block.table.exec(x);if(_){var Y={type:"table",header:s(_[1]).map(function(Me){return{text:Me}}),align:_[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:_[3]&&_[3].trim()?_[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(Y.header.length===Y.align.length){Y.raw=_[0];var Z=Y.align.length,ae,ve,Pe,ke;for(ae=0;ae<Z;ae++)/^ *-+: *$/.test(Y.align[ae])?Y.align[ae]="right":/^ *:-+: *$/.test(Y.align[ae])?Y.align[ae]="center":/^ *:-+ *$/.test(Y.align[ae])?Y.align[ae]="left":Y.align[ae]=null;for(Z=Y.rows.length,ae=0;ae<Z;ae++)Y.rows[ae]=s(Y.rows[ae],Y.header.length).map(function(Me){return{text:Me}});for(Z=Y.header.length,ve=0;ve<Z;ve++)Y.header[ve].tokens=this.lexer.inline(Y.header[ve].text);for(Z=Y.rows.length,ve=0;ve<Z;ve++)for(ke=Y.rows[ve],Pe=0;Pe<ke.length;Pe++)ke[Pe].tokens=this.lexer.inline(ke[Pe].text);return Y}}},K.lheading=function(x){var _=this.rules.block.lheading.exec(x);if(_)return{type:"heading",raw:_[0],depth:_[2].charAt(0)==="="?1:2,text:_[1],tokens:this.lexer.inline(_[1])}},K.paragraph=function(x){var _=this.rules.block.paragraph.exec(x);if(_){var Y=_[1].charAt(_[1].length-1)===`
`?_[1].slice(0,-1):_[1];return{type:"paragraph",raw:_[0],text:Y,tokens:this.lexer.inline(Y)}}},K.text=function(x){var _=this.rules.block.text.exec(x);if(_)return{type:"text",raw:_[0],text:_[0],tokens:this.lexer.inline(_[0])}},K.escape=function(x){var _=this.rules.inline.escape.exec(x);if(_)return{type:"escape",raw:_[0],text:m(_[1])}},K.tag=function(x){var _=this.rules.inline.tag.exec(x);if(_)return!this.lexer.state.inLink&&/^<a /i.test(_[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(_[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(_[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(_[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:_[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(_[0]):m(_[0]):_[0]}},K.link=function(x){var _=this.rules.inline.link.exec(x);if(_){var Y=_[2].trim();if(!this.options.pedantic&&/^</.test(Y)){if(!/>$/.test(Y))return;var Z=C(Y.slice(0,-1),"\\");if((Y.length-Z.length)%2===0)return}else{var ae=L(_[2],"()");if(ae>-1){var ve=_[0].indexOf("!")===0?5:4,Pe=ve+_[1].length+ae;_[2]=_[2].substring(0,ae),_[0]=_[0].substring(0,Pe).trim(),_[3]=""}}var ke=_[2],Me="";if(this.options.pedantic){var je=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(ke);je&&(ke=je[1],Me=je[3])}else Me=_[3]?_[3].slice(1,-1):"";return ke=ke.trim(),/^</.test(ke)&&(this.options.pedantic&&!/>$/.test(Y)?ke=ke.slice(1):ke=ke.slice(1,-1)),X(_,{href:ke&&ke.replace(this.rules.inline._escapes,"$1"),title:Me&&Me.replace(this.rules.inline._escapes,"$1")},_[0],this.lexer)}},K.reflink=function(x,_){var Y;if((Y=this.rules.inline.reflink.exec(x))||(Y=this.rules.inline.nolink.exec(x))){var Z=(Y[2]||Y[1]).replace(/\s+/g," ");if(Z=_[Z.toLowerCase()],!Z||!Z.href){var ae=Y[0].charAt(0);return{type:"text",raw:ae,text:ae}}return X(Y,Z,Y[0],this.lexer)}},K.emStrong=function(x,_,Y){Y===void 0&&(Y="");var Z=this.rules.inline.emStrong.lDelim.exec(x);if(!!Z&&!(Z[3]&&Y.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var ae=Z[1]||Z[2]||"";if(!ae||ae&&(Y===""||this.rules.inline.punctuation.exec(Y))){var ve=Z[0].length-1,Pe,ke,Me=ve,je=0,ge=Z[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ge.lastIndex=0,_=_.slice(-1*x.length+ve);(Z=ge.exec(_))!=null;)if(Pe=Z[1]||Z[2]||Z[3]||Z[4]||Z[5]||Z[6],!!Pe){if(ke=Pe.length,Z[3]||Z[4]){Me+=ke;continue}else if((Z[5]||Z[6])&&ve%3&&!((ve+ke)%3)){je+=ke;continue}if(Me-=ke,!(Me>0)){if(ke=Math.min(ke,ke+Me+je),Math.min(ve,ke)%2){var we=x.slice(1,ve+Z.index+ke);return{type:"em",raw:x.slice(0,ve+Z.index+ke+1),text:we,tokens:this.lexer.inlineTokens(we)}}var ye=x.slice(2,ve+Z.index+ke-1);return{type:"strong",raw:x.slice(0,ve+Z.index+ke+1),text:ye,tokens:this.lexer.inlineTokens(ye)}}}}}},K.codespan=function(x){var _=this.rules.inline.code.exec(x);if(_){var Y=_[2].replace(/\n/g," "),Z=/[^ ]/.test(Y),ae=/^ /.test(Y)&&/ $/.test(Y);return Z&&ae&&(Y=Y.substring(1,Y.length-1)),Y=m(Y,!0),{type:"codespan",raw:_[0],text:Y}}},K.br=function(x){var _=this.rules.inline.br.exec(x);if(_)return{type:"br",raw:_[0]}},K.del=function(x){var _=this.rules.inline.del.exec(x);if(_)return{type:"del",raw:_[0],text:_[2],tokens:this.lexer.inlineTokens(_[2])}},K.autolink=function(x,_){var Y=this.rules.inline.autolink.exec(x);if(Y){var Z,ae;return Y[2]==="@"?(Z=m(this.options.mangle?_(Y[1]):Y[1]),ae="mailto:"+Z):(Z=m(Y[1]),ae=Z),{type:"link",raw:Y[0],text:Z,href:ae,tokens:[{type:"text",raw:Z,text:Z}]}}},K.url=function(x,_){var Y;if(Y=this.rules.inline.url.exec(x)){var Z,ae;if(Y[2]==="@")Z=m(this.options.mangle?_(Y[0]):Y[0]),ae="mailto:"+Z;else{var ve;do ve=Y[0],Y[0]=this.rules.inline._backpedal.exec(Y[0])[0];while(ve!==Y[0]);Z=m(Y[0]),Y[1]==="www."?ae="http://"+Z:ae=Z}return{type:"link",raw:Y[0],text:Z,href:ae,tokens:[{type:"text",raw:Z,text:Z}]}}},K.inlineText=function(x,_){var Y=this.rules.inline.text.exec(x);if(Y){var Z;return this.lexer.state.inRawBlock?Z=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Y[0]):m(Y[0]):Y[0]:Z=m(this.options.smartypants?_(Y[0]):Y[0]),{type:"text",raw:Y[0],text:Z}}},j}(),ce={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:u,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};ce._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,ce._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,ce.def=g(ce.def).replace("label",ce._label).replace("title",ce._title).getRegex(),ce.bullet=/(?:[*+-]|\d{1,9}[.)])/,ce.listItemStart=g(/^( *)(bull) */).replace("bull",ce.bullet).getRegex(),ce.list=g(ce.list).replace(/bull/g,ce.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+ce.def.source+")").getRegex(),ce._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",ce._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,ce.html=g(ce.html,"i").replace("comment",ce._comment).replace("tag",ce._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),ce.paragraph=g(ce._paragraph).replace("hr",ce.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ce._tag).getRegex(),ce.blockquote=g(ce.blockquote).replace("paragraph",ce.paragraph).getRegex(),ce.normal=a({},ce),ce.gfm=a({},ce.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),ce.gfm.table=g(ce.gfm.table).replace("hr",ce.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ce._tag).getRegex(),ce.gfm.paragraph=g(ce._paragraph).replace("hr",ce.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",ce.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ce._tag).getRegex(),ce.pedantic=a({},ce.normal,{html:g(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",ce._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:u,paragraph:g(ce.normal._paragraph).replace("hr",ce.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",ce.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var V={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:u,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:u,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};V._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",V.punctuation=g(V.punctuation).replace(/punctuation/g,V._punctuation).getRegex(),V.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,V.escapedEmSt=/\\\*|\\_/g,V._comment=g(ce._comment).replace("(?:-->|$)","-->").getRegex(),V.emStrong.lDelim=g(V.emStrong.lDelim).replace(/punct/g,V._punctuation).getRegex(),V.emStrong.rDelimAst=g(V.emStrong.rDelimAst,"g").replace(/punct/g,V._punctuation).getRegex(),V.emStrong.rDelimUnd=g(V.emStrong.rDelimUnd,"g").replace(/punct/g,V._punctuation).getRegex(),V._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,V._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,V._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,V.autolink=g(V.autolink).replace("scheme",V._scheme).replace("email",V._email).getRegex(),V._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,V.tag=g(V.tag).replace("comment",V._comment).replace("attribute",V._attribute).getRegex(),V._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,V._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,V._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,V.link=g(V.link).replace("label",V._label).replace("href",V._href).replace("title",V._title).getRegex(),V.reflink=g(V.reflink).replace("label",V._label).replace("ref",ce._label).getRegex(),V.nolink=g(V.nolink).replace("ref",ce._label).getRegex(),V.reflinkSearch=g(V.reflinkSearch,"g").replace("reflink",V.reflink).replace("nolink",V.nolink).getRegex(),V.normal=a({},V),V.pedantic=a({},V.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:g(/^!?\[(label)\]\((.*?)\)/).replace("label",V._label).getRegex(),reflink:g(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",V._label).getRegex()}),V.gfm=a({},V.normal,{escape:g(V.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),V.gfm.url=g(V.gfm.url,"i").replace("email",V.gfm._extended_email).getRegex(),V.breaks=a({},V.gfm,{br:g(V.br).replace("{2,}","*").getRegex(),text:g(V.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function T(j){return j.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function z(j){var K="",Q,x,_=j.length;for(Q=0;Q<_;Q++)x=j.charCodeAt(Q),Math.random()>.5&&(x="x"+x.toString(16)),K+="&#"+x+";";return K}var he=function(){function j(Q){this.tokens=[],this.tokens.links=Object.create(null),this.options=Q||oe.defaults,this.options.tokenizer=this.options.tokenizer||new fe,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var x={block:ce.normal,inline:V.normal};this.options.pedantic?(x.block=ce.pedantic,x.inline=V.pedantic):this.options.gfm&&(x.block=ce.gfm,this.options.breaks?x.inline=V.breaks:x.inline=V.gfm),this.tokenizer.rules=x}j.lex=function(x,_){var Y=new j(_);return Y.lex(x)},j.lexInline=function(x,_){var Y=new j(_);return Y.inlineTokens(x)};var K=j.prototype;return K.lex=function(x){x=x.replace(/\r\n|\r/g,`
`),this.blockTokens(x,this.tokens);for(var _;_=this.inlineQueue.shift();)this.inlineTokens(_.src,_.tokens);return this.tokens},K.blockTokens=function(x,_){var Y=this;_===void 0&&(_=[]),this.options.pedantic?x=x.replace(/\t/g,"    ").replace(/^ +$/gm,""):x=x.replace(/^( *)(\t+)/gm,function(Me,je,ge){return je+"    ".repeat(ge.length)});for(var Z,ae,ve,Pe;x;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Me){return(Z=Me.call({lexer:Y},x,_))?(x=x.substring(Z.raw.length),_.push(Z),!0):!1}))){if(Z=this.tokenizer.space(x)){x=x.substring(Z.raw.length),Z.raw.length===1&&_.length>0?_[_.length-1].raw+=`
`:_.push(Z);continue}if(Z=this.tokenizer.code(x)){x=x.substring(Z.raw.length),ae=_[_.length-1],ae&&(ae.type==="paragraph"||ae.type==="text")?(ae.raw+=`
`+Z.raw,ae.text+=`
`+Z.text,this.inlineQueue[this.inlineQueue.length-1].src=ae.text):_.push(Z);continue}if(Z=this.tokenizer.fences(x)){x=x.substring(Z.raw.length),_.push(Z);continue}if(Z=this.tokenizer.heading(x)){x=x.substring(Z.raw.length),_.push(Z);continue}if(Z=this.tokenizer.hr(x)){x=x.substring(Z.raw.length),_.push(Z);continue}if(Z=this.tokenizer.blockquote(x)){x=x.substring(Z.raw.length),_.push(Z);continue}if(Z=this.tokenizer.list(x)){x=x.substring(Z.raw.length),_.push(Z);continue}if(Z=this.tokenizer.html(x)){x=x.substring(Z.raw.length),_.push(Z);continue}if(Z=this.tokenizer.def(x)){x=x.substring(Z.raw.length),ae=_[_.length-1],ae&&(ae.type==="paragraph"||ae.type==="text")?(ae.raw+=`
`+Z.raw,ae.text+=`
`+Z.raw,this.inlineQueue[this.inlineQueue.length-1].src=ae.text):this.tokens.links[Z.tag]||(this.tokens.links[Z.tag]={href:Z.href,title:Z.title});continue}if(Z=this.tokenizer.table(x)){x=x.substring(Z.raw.length),_.push(Z);continue}if(Z=this.tokenizer.lheading(x)){x=x.substring(Z.raw.length),_.push(Z);continue}if(ve=x,this.options.extensions&&this.options.extensions.startBlock&&function(){var Me=1/0,je=x.slice(1),ge=void 0;Y.options.extensions.startBlock.forEach(function(we){ge=we.call({lexer:this},je),typeof ge=="number"&&ge>=0&&(Me=Math.min(Me,ge))}),Me<1/0&&Me>=0&&(ve=x.substring(0,Me+1))}(),this.state.top&&(Z=this.tokenizer.paragraph(ve))){ae=_[_.length-1],Pe&&ae.type==="paragraph"?(ae.raw+=`
`+Z.raw,ae.text+=`
`+Z.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=ae.text):_.push(Z),Pe=ve.length!==x.length,x=x.substring(Z.raw.length);continue}if(Z=this.tokenizer.text(x)){x=x.substring(Z.raw.length),ae=_[_.length-1],ae&&ae.type==="text"?(ae.raw+=`
`+Z.raw,ae.text+=`
`+Z.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=ae.text):_.push(Z);continue}if(x){var ke="Infinite loop on byte: "+x.charCodeAt(0);if(this.options.silent){console.error(ke);break}else throw new Error(ke)}}return this.state.top=!0,_},K.inline=function(x,_){return _===void 0&&(_=[]),this.inlineQueue.push({src:x,tokens:_}),_},K.inlineTokens=function(x,_){var Y=this;_===void 0&&(_=[]);var Z,ae,ve,Pe=x,ke,Me,je;if(this.tokens.links){var ge=Object.keys(this.tokens.links);if(ge.length>0)for(;(ke=this.tokenizer.rules.inline.reflinkSearch.exec(Pe))!=null;)ge.includes(ke[0].slice(ke[0].lastIndexOf("[")+1,-1))&&(Pe=Pe.slice(0,ke.index)+"["+W("a",ke[0].length-2)+"]"+Pe.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(ke=this.tokenizer.rules.inline.blockSkip.exec(Pe))!=null;)Pe=Pe.slice(0,ke.index)+"["+W("a",ke[0].length-2)+"]"+Pe.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(ke=this.tokenizer.rules.inline.escapedEmSt.exec(Pe))!=null;)Pe=Pe.slice(0,ke.index)+"++"+Pe.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;x;)if(Me||(je=""),Me=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ye){return(Z=ye.call({lexer:Y},x,_))?(x=x.substring(Z.raw.length),_.push(Z),!0):!1}))){if(Z=this.tokenizer.escape(x)){x=x.substring(Z.raw.length),_.push(Z);continue}if(Z=this.tokenizer.tag(x)){x=x.substring(Z.raw.length),ae=_[_.length-1],ae&&Z.type==="text"&&ae.type==="text"?(ae.raw+=Z.raw,ae.text+=Z.text):_.push(Z);continue}if(Z=this.tokenizer.link(x)){x=x.substring(Z.raw.length),_.push(Z);continue}if(Z=this.tokenizer.reflink(x,this.tokens.links)){x=x.substring(Z.raw.length),ae=_[_.length-1],ae&&Z.type==="text"&&ae.type==="text"?(ae.raw+=Z.raw,ae.text+=Z.text):_.push(Z);continue}if(Z=this.tokenizer.emStrong(x,Pe,je)){x=x.substring(Z.raw.length),_.push(Z);continue}if(Z=this.tokenizer.codespan(x)){x=x.substring(Z.raw.length),_.push(Z);continue}if(Z=this.tokenizer.br(x)){x=x.substring(Z.raw.length),_.push(Z);continue}if(Z=this.tokenizer.del(x)){x=x.substring(Z.raw.length),_.push(Z);continue}if(Z=this.tokenizer.autolink(x,z)){x=x.substring(Z.raw.length),_.push(Z);continue}if(!this.state.inLink&&(Z=this.tokenizer.url(x,z))){x=x.substring(Z.raw.length),_.push(Z);continue}if(ve=x,this.options.extensions&&this.options.extensions.startInline&&function(){var ye=1/0,Fe=x.slice(1),$e=void 0;Y.options.extensions.startInline.forEach(function(tt){$e=tt.call({lexer:this},Fe),typeof $e=="number"&&$e>=0&&(ye=Math.min(ye,$e))}),ye<1/0&&ye>=0&&(ve=x.substring(0,ye+1))}(),Z=this.tokenizer.inlineText(ve,T)){x=x.substring(Z.raw.length),Z.raw.slice(-1)!=="_"&&(je=Z.raw.slice(-1)),Me=!0,ae=_[_.length-1],ae&&ae.type==="text"?(ae.raw+=Z.raw,ae.text+=Z.text):_.push(Z);continue}if(x){var we="Infinite loop on byte: "+x.charCodeAt(0);if(this.options.silent){console.error(we);break}else throw new Error(we)}}return _},E(j,null,[{key:"rules",get:function(){return{block:ce,inline:V}}}]),j}(),H=function(){function j(Q){this.options=Q||oe.defaults}var K=j.prototype;return K.code=function(x,_,Y){var Z=(_||"").match(/\S*/)[0];if(this.options.highlight){var ae=this.options.highlight(x,Z);ae!=null&&ae!==x&&(Y=!0,x=ae)}return x=x.replace(/\n$/,"")+`
`,Z?'<pre><code class="'+this.options.langPrefix+m(Z,!0)+'">'+(Y?x:m(x,!0))+`</code></pre>
`:"<pre><code>"+(Y?x:m(x,!0))+`</code></pre>
`},K.blockquote=function(x){return`<blockquote>
`+x+`</blockquote>
`},K.html=function(x){return x},K.heading=function(x,_,Y,Z){if(this.options.headerIds){var ae=this.options.headerPrefix+Z.slug(Y);return"<h"+_+' id="'+ae+'">'+x+"</h"+_+`>
`}return"<h"+_+">"+x+"</h"+_+`>
`},K.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},K.list=function(x,_,Y){var Z=_?"ol":"ul",ae=_&&Y!==1?' start="'+Y+'"':"";return"<"+Z+ae+`>
`+x+"</"+Z+`>
`},K.listitem=function(x){return"<li>"+x+`</li>
`},K.checkbox=function(x){return"<input "+(x?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},K.paragraph=function(x){return"<p>"+x+`</p>
`},K.table=function(x,_){return _&&(_="<tbody>"+_+"</tbody>"),`<table>
<thead>
`+x+`</thead>
`+_+`</table>
`},K.tablerow=function(x){return`<tr>
`+x+`</tr>
`},K.tablecell=function(x,_){var Y=_.header?"th":"td",Z=_.align?"<"+Y+' align="'+_.align+'">':"<"+Y+">";return Z+x+("</"+Y+`>
`)},K.strong=function(x){return"<strong>"+x+"</strong>"},K.em=function(x){return"<em>"+x+"</em>"},K.codespan=function(x){return"<code>"+x+"</code>"},K.br=function(){return this.options.xhtml?"<br/>":"<br>"},K.del=function(x){return"<del>"+x+"</del>"},K.link=function(x,_,Y){if(x=R(this.options.sanitize,this.options.baseUrl,x),x===null)return Y;var Z='<a href="'+m(x)+'"';return _&&(Z+=' title="'+_+'"'),Z+=">"+Y+"</a>",Z},K.image=function(x,_,Y){if(x=R(this.options.sanitize,this.options.baseUrl,x),x===null)return Y;var Z='<img src="'+x+'" alt="'+Y+'"';return _&&(Z+=' title="'+_+'"'),Z+=this.options.xhtml?"/>":">",Z},K.text=function(x){return x},j}(),q=function(){function j(){}var K=j.prototype;return K.strong=function(x){return x},K.em=function(x){return x},K.codespan=function(x){return x},K.del=function(x){return x},K.html=function(x){return x},K.text=function(x){return x},K.link=function(x,_,Y){return""+Y},K.image=function(x,_,Y){return""+Y},K.br=function(){return""},j}(),M=function(){function j(){this.seen={}}var K=j.prototype;return K.serialize=function(x){return x.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},K.getNextSafeSlug=function(x,_){var Y=x,Z=0;if(this.seen.hasOwnProperty(Y)){Z=this.seen[x];do Z++,Y=x+"-"+Z;while(this.seen.hasOwnProperty(Y))}return _||(this.seen[x]=Z,this.seen[Y]=0),Y},K.slug=function(x,_){_===void 0&&(_={});var Y=this.serialize(x);return this.getNextSafeSlug(Y,_.dryrun)},j}(),ee=function(){function j(Q){this.options=Q||oe.defaults,this.options.renderer=this.options.renderer||new H,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new q,this.slugger=new M}j.parse=function(x,_){var Y=new j(_);return Y.parse(x)},j.parseInline=function(x,_){var Y=new j(_);return Y.parseInline(x)};var K=j.prototype;return K.parse=function(x,_){_===void 0&&(_=!0);var Y="",Z,ae,ve,Pe,ke,Me,je,ge,we,ye,Fe,$e,tt,Ve,Je,Xe,_e,Ke,ue,De=x.length;for(Z=0;Z<De;Z++){if(ye=x[Z],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ye.type]&&(ue=this.options.extensions.renderers[ye.type].call({parser:this},ye),ue!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ye.type))){Y+=ue||"";continue}switch(ye.type){case"space":continue;case"hr":{Y+=this.renderer.hr();continue}case"heading":{Y+=this.renderer.heading(this.parseInline(ye.tokens),ye.depth,c(this.parseInline(ye.tokens,this.textRenderer)),this.slugger);continue}case"code":{Y+=this.renderer.code(ye.text,ye.lang,ye.escaped);continue}case"table":{for(ge="",je="",Pe=ye.header.length,ae=0;ae<Pe;ae++)je+=this.renderer.tablecell(this.parseInline(ye.header[ae].tokens),{header:!0,align:ye.align[ae]});for(ge+=this.renderer.tablerow(je),we="",Pe=ye.rows.length,ae=0;ae<Pe;ae++){for(Me=ye.rows[ae],je="",ke=Me.length,ve=0;ve<ke;ve++)je+=this.renderer.tablecell(this.parseInline(Me[ve].tokens),{header:!1,align:ye.align[ve]});we+=this.renderer.tablerow(je)}Y+=this.renderer.table(ge,we);continue}case"blockquote":{we=this.parse(ye.tokens),Y+=this.renderer.blockquote(we);continue}case"list":{for(Fe=ye.ordered,$e=ye.start,tt=ye.loose,Pe=ye.items.length,we="",ae=0;ae<Pe;ae++)Je=ye.items[ae],Xe=Je.checked,_e=Je.task,Ve="",Je.task&&(Ke=this.renderer.checkbox(Xe),tt?Je.tokens.length>0&&Je.tokens[0].type==="paragraph"?(Je.tokens[0].text=Ke+" "+Je.tokens[0].text,Je.tokens[0].tokens&&Je.tokens[0].tokens.length>0&&Je.tokens[0].tokens[0].type==="text"&&(Je.tokens[0].tokens[0].text=Ke+" "+Je.tokens[0].tokens[0].text)):Je.tokens.unshift({type:"text",text:Ke}):Ve+=Ke),Ve+=this.parse(Je.tokens,tt),we+=this.renderer.listitem(Ve,_e,Xe);Y+=this.renderer.list(we,Fe,$e);continue}case"html":{Y+=this.renderer.html(ye.text);continue}case"paragraph":{Y+=this.renderer.paragraph(this.parseInline(ye.tokens));continue}case"text":{for(we=ye.tokens?this.parseInline(ye.tokens):ye.text;Z+1<De&&x[Z+1].type==="text";)ye=x[++Z],we+=`
`+(ye.tokens?this.parseInline(ye.tokens):ye.text);Y+=_?this.renderer.paragraph(we):we;continue}default:{var Re='Token with "'+ye.type+'" type was not found.';if(this.options.silent){console.error(Re);return}else throw new Error(Re)}}}return Y},K.parseInline=function(x,_){_=_||this.renderer;var Y="",Z,ae,ve,Pe=x.length;for(Z=0;Z<Pe;Z++){if(ae=x[Z],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ae.type]&&(ve=this.options.extensions.renderers[ae.type].call({parser:this},ae),ve!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(ae.type))){Y+=ve||"";continue}switch(ae.type){case"escape":{Y+=_.text(ae.text);break}case"html":{Y+=_.html(ae.text);break}case"link":{Y+=_.link(ae.href,ae.title,this.parseInline(ae.tokens,_));break}case"image":{Y+=_.image(ae.href,ae.title,ae.text);break}case"strong":{Y+=_.strong(this.parseInline(ae.tokens,_));break}case"em":{Y+=_.em(this.parseInline(ae.tokens,_));break}case"codespan":{Y+=_.codespan(ae.text);break}case"br":{Y+=_.br();break}case"del":{Y+=_.del(this.parseInline(ae.tokens,_));break}case"text":{Y+=_.text(ae.text);break}default:{var ke='Token with "'+ae.type+'" type was not found.';if(this.options.silent){console.error(ke);return}else throw new Error(ke)}}}return Y},j}();function ie(j,K,Q){if(typeof j>"u"||j===null)throw new Error("marked(): input parameter is undefined or null");if(typeof j!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(j)+", string expected");if(typeof K=="function"&&(Q=K,K=null),K=a({},ie.defaults,K||{}),O(K),Q){var x=K.highlight,_;try{_=he.lex(j,K)}catch(Pe){return Q(Pe)}var Y=function(ke){var Me;if(!ke)try{K.walkTokens&&ie.walkTokens(_,K.walkTokens),Me=ee.parse(_,K)}catch(je){ke=je}return K.highlight=x,ke?Q(ke):Q(null,Me)};if(!x||x.length<3||(delete K.highlight,!_.length))return Y();var Z=0;ie.walkTokens(_,function(Pe){Pe.type==="code"&&(Z++,setTimeout(function(){x(Pe.text,Pe.lang,function(ke,Me){if(ke)return Y(ke);Me!=null&&Me!==Pe.text&&(Pe.text=Me,Pe.escaped=!0),Z--,Z===0&&Y()})},0))}),Z===0&&Y();return}function ae(Pe){if(Pe.message+=`
Please report this to https://github.com/markedjs/marked.`,K.silent)return"<p>An error occurred:</p><pre>"+m(Pe.message+"",!0)+"</pre>";throw Pe}try{var ve=he.lex(j,K);if(K.walkTokens){if(K.async)return Promise.all(ie.walkTokens(ve,K.walkTokens)).then(function(){return ee.parse(ve,K)}).catch(ae);ie.walkTokens(ve,K.walkTokens)}return ee.parse(ve,K)}catch(Pe){ae(Pe)}}ie.options=ie.setOptions=function(j){return a(ie.defaults,j),P(ie.defaults),ie},ie.getDefaults=S,ie.defaults=oe.defaults,ie.use=function(){for(var j=arguments.length,K=new Array(j),Q=0;Q<j;Q++)K[Q]=arguments[Q];var x=a.apply(void 0,[{}].concat(K)),_=ie.defaults.extensions||{renderers:{},childTokens:{}},Y;K.forEach(function(Z){if(Z.extensions&&(Y=!0,Z.extensions.forEach(function(ve){if(!ve.name)throw new Error("extension name required");if(ve.renderer){var Pe=_.renderers?_.renderers[ve.name]:null;Pe?_.renderers[ve.name]=function(){for(var ke=arguments.length,Me=new Array(ke),je=0;je<ke;je++)Me[je]=arguments[je];var ge=ve.renderer.apply(this,Me);return ge===!1&&(ge=Pe.apply(this,Me)),ge}:_.renderers[ve.name]=ve.renderer}if(ve.tokenizer){if(!ve.level||ve.level!=="block"&&ve.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");_[ve.level]?_[ve.level].unshift(ve.tokenizer):_[ve.level]=[ve.tokenizer],ve.start&&(ve.level==="block"?_.startBlock?_.startBlock.push(ve.start):_.startBlock=[ve.start]:ve.level==="inline"&&(_.startInline?_.startInline.push(ve.start):_.startInline=[ve.start]))}ve.childTokens&&(_.childTokens[ve.name]=ve.childTokens)})),Z.renderer&&function(){var ve=ie.defaults.renderer||new H,Pe=function(je){var ge=ve[je];ve[je]=function(){for(var we=arguments.length,ye=new Array(we),Fe=0;Fe<we;Fe++)ye[Fe]=arguments[Fe];var $e=Z.renderer[je].apply(ve,ye);return $e===!1&&($e=ge.apply(ve,ye)),$e}};for(var ke in Z.renderer)Pe(ke);x.renderer=ve}(),Z.tokenizer&&function(){var ve=ie.defaults.tokenizer||new fe,Pe=function(je){var ge=ve[je];ve[je]=function(){for(var we=arguments.length,ye=new Array(we),Fe=0;Fe<we;Fe++)ye[Fe]=arguments[Fe];var $e=Z.tokenizer[je].apply(ve,ye);return $e===!1&&($e=ge.apply(ve,ye)),$e}};for(var ke in Z.tokenizer)Pe(ke);x.tokenizer=ve}(),Z.walkTokens){var ae=ie.defaults.walkTokens;x.walkTokens=function(ve){var Pe=[];return Pe.push(Z.walkTokens.call(this,ve)),ae&&(Pe=Pe.concat(ae.call(this,ve))),Pe}}Y&&(x.extensions=_),ie.setOptions(x)})},ie.walkTokens=function(j,K){for(var Q=[],x=function(){var ae=Y.value;switch(Q=Q.concat(K.call(ie,ae)),ae.type){case"table":{for(var ve=w(ae.header),Pe;!(Pe=ve()).done;){var ke=Pe.value;Q=Q.concat(ie.walkTokens(ke.tokens,K))}for(var Me=w(ae.rows),je;!(je=Me()).done;)for(var ge=je.value,we=w(ge),ye;!(ye=we()).done;){var Fe=ye.value;Q=Q.concat(ie.walkTokens(Fe.tokens,K))}break}case"list":{Q=Q.concat(ie.walkTokens(ae.items,K));break}default:ie.defaults.extensions&&ie.defaults.extensions.childTokens&&ie.defaults.extensions.childTokens[ae.type]?ie.defaults.extensions.childTokens[ae.type].forEach(function($e){Q=Q.concat(ie.walkTokens(ae[$e],K))}):ae.tokens&&(Q=Q.concat(ie.walkTokens(ae.tokens,K)))}},_=w(j),Y;!(Y=_()).done;)x();return Q},ie.parseInline=function(j,K){if(typeof j>"u"||j===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof j!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(j)+", string expected");K=a({},ie.defaults,K||{}),O(K);try{var Q=he.lexInline(j,K);return K.walkTokens&&ie.walkTokens(Q,K.walkTokens),ee.parseInline(Q,K)}catch(x){if(x.message+=`
Please report this to https://github.com/markedjs/marked.`,K.silent)return"<p>An error occurred:</p><pre>"+m(x.message+"",!0)+"</pre>";throw x}},ie.Parser=ee,ie.parser=ee.parse,ie.Renderer=H,ie.TextRenderer=q,ie.Lexer=he,ie.lexer=he.lex,ie.Tokenizer=fe,ie.Slugger=M,ie.parse=ie;var me=ie.options,ne=ie.setOptions,B=ie.use,N=ie.walkTokens,U=ie.parseInline,G=ie,te=ee.parse,le=he.lex;oe.Lexer=he,oe.Parser=ee,oe.Renderer=H,oe.Slugger=M,oe.TextRenderer=q,oe.Tokenizer=fe,oe.getDefaults=S,oe.lexer=le,oe.marked=ie,oe.options=me,oe.parse=G,oe.parseInline=U,oe.parser=te,oe.setOptions=ne,oe.use=B,oe.walkTokens=N,Object.defineProperty(oe,"__esModule",{value:!0})}),define(be[90],Ee([1,0,27]),function(oe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const A=new E.LRUCache(1e4);function l(b){return y(b,"NFC",A)}e.normalizeNFC=l;const w=new E.LRUCache(1e4);function S(b){return y(b,"NFD",w)}e.normalizeNFD=S;const P=/[^\u0000-\u0080]/;function y(b,k,I){if(!b)return b;const v=I.get(b);if(v)return v;let d;return P.test(b)?d=b.normalize(k):d=b,I.set(b,d),d}e.removeAccents=function(){const b=/[\u0300-\u036f]/g;return function(k){return S(k).replace(b,"")}}()}),define(be[143],Ee([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function E(P,y,b){return Math.min(Math.max(P,y),b)}e.clamp=E;function A(P,y){return(y+P%y)%y}e.rot=A;class l{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=l;class w{constructor(){this.a=1,this.b=0}update(y){return this.b=this.b+(y-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=w;class S{constructor(y){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(y),this.c.fill(0,0,y)}update(y){const b=this.c[this.d];return this.c[this.d]=y,this.d=(this.d+1)%this.c.length,this.e-=b,this.e+=y,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=S}),function(){function oe(l){const w=[];typeof l=="number"&&w.push("code/timeOrigin",l);function S(y){w.push(y,Date.now())}function P(){const y=[];for(let b=0;b<w.length;b+=2)y.push({name:w[b],startTime:w[b+1]});return y}return{mark:S,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?oe():{mark(l){performance.mark(l)},getMarks(){let l=performance.timeOrigin;typeof l!="number"&&(l=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const w=[{name:"code/timeOrigin",startTime:Math.round(l)}];for(const S of performance.getEntriesByType("mark"))w.push({name:S.name,startTime:Math.round(l+S.startTime)});return w}};if(typeof process=="object"){const l=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return oe(l)}else return console.trace("perf-util loaded in UNKNOWN environment"),oe()}function E(l){return l.MonacoPerformanceMarks||(l.MonacoPerformanceMarks=e()),l.MonacoPerformanceMarks}var A;typeof global=="object"?A=global:typeof self=="object"?A=self:A={},typeof define=="function"?define("vs/base/common/performance",[],function(){return E(A)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=E(A):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),A.perf=E(A))}(),define(be[3],Ee([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let E=!1,A=!1,l=!1,w=!1,S=!1,P=!1,y=!1,b=!1,k=!1,I=!1,v,d=e.LANGUAGE_DEFAULT,m,p;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let c;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?c=e.globals.vscode.process:typeof process<"u"&&(c=process);const h=typeof c?.versions?.electron=="string",g=h&&c?.type==="renderer";if(typeof navigator=="object"&&!g){p=navigator.userAgent,E=p.indexOf("Windows")>=0,A=p.indexOf("Macintosh")>=0,b=(p.indexOf("Macintosh")>=0||p.indexOf("iPad")>=0||p.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,l=p.indexOf("Linux")>=0,I=p?.indexOf("Mobi")>=0,P=!0,v=e.LANGUAGE_DEFAULT,d=v;const u=typeof document<"u"&&document.getElementById("vscode-remote-nls-configuration"),a=u&&u.getAttribute("data-settings");if(a)try{const s=JSON.parse(a);v=s.locale,m=s._translationsConfigFile,d=s.availableLanguages["*"]||e.LANGUAGE_DEFAULT}catch{}}else if(typeof c=="object"){E=c.platform==="win32",A=c.platform==="darwin",l=c.platform==="linux",w=l&&!!c.env.SNAP&&!!c.env.SNAP_REVISION,y=h,k=!!c.env.CI||!!c.env.BUILD_ARTIFACTSTAGINGDIRECTORY,v=e.LANGUAGE_DEFAULT,d=e.LANGUAGE_DEFAULT;const u=c.env.VSCODE_NLS_CONFIG;if(u)try{const a=JSON.parse(u),s=a.availableLanguages["*"];v=a.locale,d=s||e.LANGUAGE_DEFAULT,m=a._translationsConfigFile}catch{}S=!0}else console.error("Unable to resolve platform.");var f;(function(u){u[u.Web=0]="Web",u[u.Mac=1]="Mac",u[u.Linux=2]="Linux",u[u.Windows=3]="Windows"})(f=e.Platform||(e.Platform={}));function D(u){switch(u){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=D;let R=0;A?R=1:E?R=3:l&&(R=2),e.isWindows=E,e.isMacintosh=A,e.isLinux=l,e.isLinuxSnap=w,e.isNative=S,e.isElectron=y,e.isWeb=P,e.isWebWorker=P&&typeof e.globals.importScripts=="function",e.isIOS=b,e.isMobile=I,e.isCI=k,e.platform=R,e.userAgent=p,e.language=d;var t;(function(u){function a(){return e.language}u.value=a;function s(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}u.isDefaultVariant=s;function C(){return e.language==="en"}u.isDefault=C})(t=e.Language||(e.Language={})),e.locale=v,e.translationsConfigFile=m,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const u=[];e.globals.addEventListener("message",s=>{if(s.data&&s.data.vscodeScheduleAsyncWork)for(let C=0,L=u.length;C<L;C++){const O=u[C];if(O.id===s.data.vscodeScheduleAsyncWork){u.splice(C,1),O.callback();return}}});let a=0;return s=>{const C=++a;u.push({id:C,callback:s}),e.globals.postMessage({vscodeScheduleAsyncWork:C},"*")}}return u=>setTimeout(u)})();var r;(function(u){u[u.Windows=1]="Windows",u[u.Macintosh=2]="Macintosh",u[u.Linux=3]="Linux"})(r=e.OperatingSystem||(e.OperatingSystem={})),e.OS=A||b?2:E?1:3;let i=!0,n=!1;function o(){if(!n){n=!0;const u=new Uint8Array(2);u[0]=1,u[1]=2,i=new Uint16Array(u.buffer)[0]===(2<<8)+1}return i}e.isLittleEndian=o,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(be[28],Ee([1,0,3]),function(oe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let A;if(typeof E.globals.vscode<"u"&&typeof E.globals.vscode.process<"u"){const l=E.globals.vscode.process;A={get platform(){return l.platform},get arch(){return l.arch},get env(){return l.env},cwd(){return l.cwd()}}}else typeof process<"u"?A={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:A={get platform(){return E.isWindows?"win32":E.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=A.cwd,e.env=A.env,e.platform=A.platform,e.arch=A.arch}),define(be[7],Ee([1,0,28]),function(oe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const A=65,l=97,w=90,S=122,P=46,y=47,b=92,k=58,I=63;class v extends Error{constructor(r,i,n){let o;typeof i=="string"&&i.indexOf("not ")===0?(o="must not be",i=i.replace(/^not /,"")):o="must be";const u=r.indexOf(".")!==-1?"property":"argument";let a=`The "${r}" ${u} ${o} of type ${i}`;a+=`. Received type ${typeof n}`,super(a),this.code="ERR_INVALID_ARG_TYPE"}}function d(t,r){if(t===null||typeof t!="object")throw new v(r,"Object",t)}function m(t,r){if(typeof t!="string")throw new v(r,"string",t)}const p=E.platform==="win32";function c(t){return t===y||t===b}function h(t){return t===y}function g(t){return t>=A&&t<=w||t>=l&&t<=S}function f(t,r,i,n){let o="",u=0,a=-1,s=0,C=0;for(let L=0;L<=t.length;++L){if(L<t.length)C=t.charCodeAt(L);else{if(n(C))break;C=y}if(n(C)){if(!(a===L-1||s===1))if(s===2){if(o.length<2||u!==2||o.charCodeAt(o.length-1)!==P||o.charCodeAt(o.length-2)!==P){if(o.length>2){const O=o.lastIndexOf(i);O===-1?(o="",u=0):(o=o.slice(0,O),u=o.length-1-o.lastIndexOf(i)),a=L,s=0;continue}else if(o.length!==0){o="",u=0,a=L,s=0;continue}}r&&(o+=o.length>0?`${i}..`:"..",u=2)}else o.length>0?o+=`${i}${t.slice(a+1,L)}`:o=t.slice(a+1,L),u=L-a-1;a=L,s=0}else C===P&&s!==-1?++s:s=-1}return o}function D(t,r){d(r,"pathObject");const i=r.dir||r.root,n=r.base||`${r.name||""}${r.ext||""}`;return i?i===r.root?`${i}${n}`:`${i}${t}${n}`:n}e.win32={resolve(...t){let r="",i="",n=!1;for(let o=t.length-1;o>=-1;o--){let u;if(o>=0){if(u=t[o],m(u,"path"),u.length===0)continue}else r.length===0?u=E.cwd():(u=E.env[`=${r}`]||E.cwd(),(u===void 0||u.slice(0,2).toLowerCase()!==r.toLowerCase()&&u.charCodeAt(2)===b)&&(u=`${r}\\`));const a=u.length;let s=0,C="",L=!1;const O=u.charCodeAt(0);if(a===1)c(O)&&(s=1,L=!0);else if(c(O))if(L=!0,c(u.charCodeAt(1))){let W=2,X=W;for(;W<a&&!c(u.charCodeAt(W));)W++;if(W<a&&W!==X){const se=u.slice(X,W);for(X=W;W<a&&c(u.charCodeAt(W));)W++;if(W<a&&W!==X){for(X=W;W<a&&!c(u.charCodeAt(W));)W++;(W===a||W!==X)&&(C=`\\\\${se}\\${u.slice(X,W)}`,s=W)}}}else s=1;else g(O)&&u.charCodeAt(1)===k&&(C=u.slice(0,2),s=2,a>2&&c(u.charCodeAt(2))&&(L=!0,s=3));if(C.length>0)if(r.length>0){if(C.toLowerCase()!==r.toLowerCase())continue}else r=C;if(n){if(r.length>0)break}else if(i=`${u.slice(s)}\\${i}`,n=L,L&&r.length>0)break}return i=f(i,!n,"\\",c),n?`${r}\\${i}`:`${r}${i}`||"."},normalize(t){m(t,"path");const r=t.length;if(r===0)return".";let i=0,n,o=!1;const u=t.charCodeAt(0);if(r===1)return h(u)?"\\":t;if(c(u))if(o=!0,c(t.charCodeAt(1))){let s=2,C=s;for(;s<r&&!c(t.charCodeAt(s));)s++;if(s<r&&s!==C){const L=t.slice(C,s);for(C=s;s<r&&c(t.charCodeAt(s));)s++;if(s<r&&s!==C){for(C=s;s<r&&!c(t.charCodeAt(s));)s++;if(s===r)return`\\\\${L}\\${t.slice(C)}\\`;s!==C&&(n=`\\\\${L}\\${t.slice(C,s)}`,i=s)}}}else i=1;else g(u)&&t.charCodeAt(1)===k&&(n=t.slice(0,2),i=2,r>2&&c(t.charCodeAt(2))&&(o=!0,i=3));let a=i<r?f(t.slice(i),!o,"\\",c):"";return a.length===0&&!o&&(a="."),a.length>0&&c(t.charCodeAt(r-1))&&(a+="\\"),n===void 0?o?`\\${a}`:a:o?`${n}\\${a}`:`${n}${a}`},isAbsolute(t){m(t,"path");const r=t.length;if(r===0)return!1;const i=t.charCodeAt(0);return c(i)||r>2&&g(i)&&t.charCodeAt(1)===k&&c(t.charCodeAt(2))},join(...t){if(t.length===0)return".";let r,i;for(let u=0;u<t.length;++u){const a=t[u];m(a,"path"),a.length>0&&(r===void 0?r=i=a:r+=`\\${a}`)}if(r===void 0)return".";let n=!0,o=0;if(typeof i=="string"&&c(i.charCodeAt(0))){++o;const u=i.length;u>1&&c(i.charCodeAt(1))&&(++o,u>2&&(c(i.charCodeAt(2))?++o:n=!1))}if(n){for(;o<r.length&&c(r.charCodeAt(o));)o++;o>=2&&(r=`\\${r.slice(o)}`)}return e.win32.normalize(r)},relative(t,r){if(m(t,"from"),m(r,"to"),t===r)return"";const i=e.win32.resolve(t),n=e.win32.resolve(r);if(i===n||(t=i.toLowerCase(),r=n.toLowerCase(),t===r))return"";let o=0;for(;o<t.length&&t.charCodeAt(o)===b;)o++;let u=t.length;for(;u-1>o&&t.charCodeAt(u-1)===b;)u--;const a=u-o;let s=0;for(;s<r.length&&r.charCodeAt(s)===b;)s++;let C=r.length;for(;C-1>s&&r.charCodeAt(C-1)===b;)C--;const L=C-s,O=a<L?a:L;let W=-1,X=0;for(;X<O;X++){const fe=t.charCodeAt(o+X);if(fe!==r.charCodeAt(s+X))break;fe===b&&(W=X)}if(X!==O){if(W===-1)return n}else{if(L>O){if(r.charCodeAt(s+X)===b)return n.slice(s+X+1);if(X===2)return n.slice(s+X)}a>O&&(t.charCodeAt(o+X)===b?W=X:X===2&&(W=3)),W===-1&&(W=0)}let se="";for(X=o+W+1;X<=u;++X)(X===u||t.charCodeAt(X)===b)&&(se+=se.length===0?"..":"\\..");return s+=W,se.length>0?`${se}${n.slice(s,C)}`:(n.charCodeAt(s)===b&&++s,n.slice(s,C))},toNamespacedPath(t){if(typeof t!="string"||t.length===0)return t;const r=e.win32.resolve(t);if(r.length<=2)return t;if(r.charCodeAt(0)===b){if(r.charCodeAt(1)===b){const i=r.charCodeAt(2);if(i!==I&&i!==P)return`\\\\?\\UNC\\${r.slice(2)}`}}else if(g(r.charCodeAt(0))&&r.charCodeAt(1)===k&&r.charCodeAt(2)===b)return`\\\\?\\${r}`;return t},dirname(t){m(t,"path");const r=t.length;if(r===0)return".";let i=-1,n=0;const o=t.charCodeAt(0);if(r===1)return c(o)?t:".";if(c(o)){if(i=n=1,c(t.charCodeAt(1))){let s=2,C=s;for(;s<r&&!c(t.charCodeAt(s));)s++;if(s<r&&s!==C){for(C=s;s<r&&c(t.charCodeAt(s));)s++;if(s<r&&s!==C){for(C=s;s<r&&!c(t.charCodeAt(s));)s++;if(s===r)return t;s!==C&&(i=n=s+1)}}}}else g(o)&&t.charCodeAt(1)===k&&(i=r>2&&c(t.charCodeAt(2))?3:2,n=i);let u=-1,a=!0;for(let s=r-1;s>=n;--s)if(c(t.charCodeAt(s))){if(!a){u=s;break}}else a=!1;if(u===-1){if(i===-1)return".";u=i}return t.slice(0,u)},basename(t,r){r!==void 0&&m(r,"ext"),m(t,"path");let i=0,n=-1,o=!0,u;if(t.length>=2&&g(t.charCodeAt(0))&&t.charCodeAt(1)===k&&(i=2),r!==void 0&&r.length>0&&r.length<=t.length){if(r===t)return"";let a=r.length-1,s=-1;for(u=t.length-1;u>=i;--u){const C=t.charCodeAt(u);if(c(C)){if(!o){i=u+1;break}}else s===-1&&(o=!1,s=u+1),a>=0&&(C===r.charCodeAt(a)?--a===-1&&(n=u):(a=-1,n=s))}return i===n?n=s:n===-1&&(n=t.length),t.slice(i,n)}for(u=t.length-1;u>=i;--u)if(c(t.charCodeAt(u))){if(!o){i=u+1;break}}else n===-1&&(o=!1,n=u+1);return n===-1?"":t.slice(i,n)},extname(t){m(t,"path");let r=0,i=-1,n=0,o=-1,u=!0,a=0;t.length>=2&&t.charCodeAt(1)===k&&g(t.charCodeAt(0))&&(r=n=2);for(let s=t.length-1;s>=r;--s){const C=t.charCodeAt(s);if(c(C)){if(!u){n=s+1;break}continue}o===-1&&(u=!1,o=s+1),C===P?i===-1?i=s:a!==1&&(a=1):i!==-1&&(a=-1)}return i===-1||o===-1||a===0||a===1&&i===o-1&&i===n+1?"":t.slice(i,o)},format:D.bind(null,"\\"),parse(t){m(t,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return r;const i=t.length;let n=0,o=t.charCodeAt(0);if(i===1)return c(o)?(r.root=r.dir=t,r):(r.base=r.name=t,r);if(c(o)){if(n=1,c(t.charCodeAt(1))){let W=2,X=W;for(;W<i&&!c(t.charCodeAt(W));)W++;if(W<i&&W!==X){for(X=W;W<i&&c(t.charCodeAt(W));)W++;if(W<i&&W!==X){for(X=W;W<i&&!c(t.charCodeAt(W));)W++;W===i?n=W:W!==X&&(n=W+1)}}}}else if(g(o)&&t.charCodeAt(1)===k){if(i<=2)return r.root=r.dir=t,r;if(n=2,c(t.charCodeAt(2))){if(i===3)return r.root=r.dir=t,r;n=3}}n>0&&(r.root=t.slice(0,n));let u=-1,a=n,s=-1,C=!0,L=t.length-1,O=0;for(;L>=n;--L){if(o=t.charCodeAt(L),c(o)){if(!C){a=L+1;break}continue}s===-1&&(C=!1,s=L+1),o===P?u===-1?u=L:O!==1&&(O=1):u!==-1&&(O=-1)}return s!==-1&&(u===-1||O===0||O===1&&u===s-1&&u===a+1?r.base=r.name=t.slice(a,s):(r.name=t.slice(a,u),r.base=t.slice(a,s),r.ext=t.slice(u,s))),a>0&&a!==n?r.dir=t.slice(0,a-1):r.dir=r.root,r},sep:"\\",delimiter:";",win32:null,posix:null};const R=(()=>{if(p){const t=/\\/g;return()=>{const r=E.cwd().replace(t,"/");return r.slice(r.indexOf("/"))}}return()=>E.cwd()})();e.posix={resolve(...t){let r="",i=!1;for(let n=t.length-1;n>=-1&&!i;n--){const o=n>=0?t[n]:R();m(o,"path"),o.length!==0&&(r=`${o}/${r}`,i=o.charCodeAt(0)===y)}return r=f(r,!i,"/",h),i?`/${r}`:r.length>0?r:"."},normalize(t){if(m(t,"path"),t.length===0)return".";const r=t.charCodeAt(0)===y,i=t.charCodeAt(t.length-1)===y;return t=f(t,!r,"/",h),t.length===0?r?"/":i?"./":".":(i&&(t+="/"),r?`/${t}`:t)},isAbsolute(t){return m(t,"path"),t.length>0&&t.charCodeAt(0)===y},join(...t){if(t.length===0)return".";let r;for(let i=0;i<t.length;++i){const n=t[i];m(n,"path"),n.length>0&&(r===void 0?r=n:r+=`/${n}`)}return r===void 0?".":e.posix.normalize(r)},relative(t,r){if(m(t,"from"),m(r,"to"),t===r||(t=e.posix.resolve(t),r=e.posix.resolve(r),t===r))return"";const i=1,n=t.length,o=n-i,u=1,a=r.length-u,s=o<a?o:a;let C=-1,L=0;for(;L<s;L++){const W=t.charCodeAt(i+L);if(W!==r.charCodeAt(u+L))break;W===y&&(C=L)}if(L===s)if(a>s){if(r.charCodeAt(u+L)===y)return r.slice(u+L+1);if(L===0)return r.slice(u+L)}else o>s&&(t.charCodeAt(i+L)===y?C=L:L===0&&(C=0));let O="";for(L=i+C+1;L<=n;++L)(L===n||t.charCodeAt(L)===y)&&(O+=O.length===0?"..":"/..");return`${O}${r.slice(u+C)}`},toNamespacedPath(t){return t},dirname(t){if(m(t,"path"),t.length===0)return".";const r=t.charCodeAt(0)===y;let i=-1,n=!0;for(let o=t.length-1;o>=1;--o)if(t.charCodeAt(o)===y){if(!n){i=o;break}}else n=!1;return i===-1?r?"/":".":r&&i===1?"//":t.slice(0,i)},basename(t,r){r!==void 0&&m(r,"ext"),m(t,"path");let i=0,n=-1,o=!0,u;if(r!==void 0&&r.length>0&&r.length<=t.length){if(r===t)return"";let a=r.length-1,s=-1;for(u=t.length-1;u>=0;--u){const C=t.charCodeAt(u);if(C===y){if(!o){i=u+1;break}}else s===-1&&(o=!1,s=u+1),a>=0&&(C===r.charCodeAt(a)?--a===-1&&(n=u):(a=-1,n=s))}return i===n?n=s:n===-1&&(n=t.length),t.slice(i,n)}for(u=t.length-1;u>=0;--u)if(t.charCodeAt(u)===y){if(!o){i=u+1;break}}else n===-1&&(o=!1,n=u+1);return n===-1?"":t.slice(i,n)},extname(t){m(t,"path");let r=-1,i=0,n=-1,o=!0,u=0;for(let a=t.length-1;a>=0;--a){const s=t.charCodeAt(a);if(s===y){if(!o){i=a+1;break}continue}n===-1&&(o=!1,n=a+1),s===P?r===-1?r=a:u!==1&&(u=1):r!==-1&&(u=-1)}return r===-1||n===-1||u===0||u===1&&r===n-1&&r===i+1?"":t.slice(r,n)},format:D.bind(null,"/"),parse(t){m(t,"path");const r={root:"",dir:"",base:"",ext:"",name:""};if(t.length===0)return r;const i=t.charCodeAt(0)===y;let n;i?(r.root="/",n=1):n=0;let o=-1,u=0,a=-1,s=!0,C=t.length-1,L=0;for(;C>=n;--C){const O=t.charCodeAt(C);if(O===y){if(!s){u=C+1;break}continue}a===-1&&(s=!1,a=C+1),O===P?o===-1?o=C:L!==1&&(L=1):o!==-1&&(L=-1)}if(a!==-1){const O=u===0&&i?1:u;o===-1||L===0||L===1&&o===a-1&&o===u+1?r.base=r.name=t.slice(O,a):(r.name=t.slice(O,o),r.base=t.slice(O,a),r.ext=t.slice(o,a))}return u>0?r.dir=t.slice(0,u-1):i&&(r.dir="/"),r},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=p?e.win32.normalize:e.posix.normalize,e.isAbsolute=p?e.win32.isAbsolute:e.posix.isAbsolute,e.join=p?e.win32.join:e.posix.join,e.resolve=p?e.win32.resolve:e.posix.resolve,e.relative=p?e.win32.relative:e.posix.relative,e.dirname=p?e.win32.dirname:e.posix.dirname,e.basename=p?e.win32.basename:e.posix.basename,e.extname=p?e.win32.extname:e.posix.extname,e.format=p?e.win32.format:e.posix.format,e.parse=p?e.win32.parse:e.posix.parse,e.toNamespacedPath=p?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=p?e.win32.sep:e.posix.sep,e.delimiter=p?e.win32.delimiter:e.posix.delimiter}),define(be[57],Ee([1,0,7]),function(oe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const A={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},l={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function w(k){const I=(0,E.extname)(k),v=A[I.toLowerCase()];return v!==void 0?v:S(k)}e.getMediaOrTextMime=w;function S(k){const I=(0,E.extname)(k);return l[I.toLowerCase()]}e.getMediaMime=S;function P(k){for(const I in l)if(l[I]===k)return I}e.getExtensionForMimeType=P;const y=/^(.+)\/(.+?)(;.+)?$/;function b(k,I){const v=y.exec(k);return v?`${v[1].toLowerCase()}/${v[2].toLowerCase()}${v[3]??""}`:I?void 0:k}e.normalizeMimeType=b}),define(be[58],Ee([1,0,3]),function(oe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var A;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(A=e.Source||(e.Source={}));var l;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(l=e.TerminateResponseCode||(e.TerminateResponseCode={}));function w(P,...y){const b=y.reduce((v,d)=>(v[d]=!0,v),{}),k=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/,/^CODE_SERVER_.+$/,/^CS_.+$/];Object.keys(P).filter(v=>!b[v]).forEach(v=>{for(let d=0;d<k.length;d++)if(v.search(k[d])!==-1){delete P[v];break}})}e.sanitizeProcessEnvironment=w;function S(P){!P||(delete P.DEBUG,E.isMacintosh&&delete P.DYLD_LIBRARY_PATH,E.isLinux&&delete P.LD_PRELOAD)}e.removeDangerousEnvVariables=S}),function(oe,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var E=e();for(var A in E)(typeof exports=="object"?exports:oe)[A]=E[A]}}(typeof self<"u"?self:this,function(){return function(oe){var e={};function E(A){if(e[A])return e[A].exports;var l=e[A]={i:A,l:!1,exports:{}};return oe[A].call(l.exports,l,l.exports,E),l.l=!0,l.exports}return E.m=oe,E.c=e,E.d=function(A,l,w){E.o(A,l)||Object.defineProperty(A,l,{enumerable:!0,get:w})},E.r=function(A){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(A,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(A,"__esModule",{value:!0})},E.t=function(A,l){if(1&l&&(A=E(A)),8&l||4&l&&typeof A=="object"&&A&&A.__esModule)return A;var w=Object.create(null);if(E.r(w),Object.defineProperty(w,"default",{enumerable:!0,value:A}),2&l&&typeof A!="string")for(var S in A)E.d(w,S,function(P){return A[P]}.bind(null,S));return w},E.n=function(A){var l=A&&A.__esModule?function(){return A.default}:function(){return A};return E.d(l,"a",l),l},E.o=function(A,l){return Object.prototype.hasOwnProperty.call(A,l)},E.p="",E(E.s=0)}([function(oe,e,E){(function(A){var l;e=oe.exports=B,l=typeof A=="object"&&A.env&&A.env.NODE_DEBUG&&/\bsemver\b/i.test(A.env.NODE_DEBUG)?function(){var ge=Array.prototype.slice.call(arguments,0);ge.unshift("SEMVER"),console.log.apply(console,ge)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var w=256,S=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],y=e.src=[],b=0,k=b++;y[k]="0|[1-9]\\d*";var I=b++;y[I]="[0-9]+";var v=b++;y[v]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var d=b++;y[d]="("+y[k]+")\\.("+y[k]+")\\.("+y[k]+")";var m=b++;y[m]="("+y[I]+")\\.("+y[I]+")\\.("+y[I]+")";var p=b++;y[p]="(?:"+y[k]+"|"+y[v]+")";var c=b++;y[c]="(?:"+y[I]+"|"+y[v]+")";var h=b++;y[h]="(?:-("+y[p]+"(?:\\."+y[p]+")*))";var g=b++;y[g]="(?:-?("+y[c]+"(?:\\."+y[c]+")*))";var f=b++;y[f]="[0-9A-Za-z-]+";var D=b++;y[D]="(?:\\+("+y[f]+"(?:\\."+y[f]+")*))";var R=b++,t="v?"+y[d]+y[h]+"?"+y[D]+"?";y[R]="^"+t+"$";var r="[v=\\s]*"+y[m]+y[g]+"?"+y[D]+"?",i=b++;y[i]="^"+r+"$";var n=b++;y[n]="((?:<|>)?=?)";var o=b++;y[o]=y[I]+"|x|X|\\*";var u=b++;y[u]=y[k]+"|x|X|\\*";var a=b++;y[a]="[v=\\s]*("+y[u]+")(?:\\.("+y[u]+")(?:\\.("+y[u]+")(?:"+y[h]+")?"+y[D]+"?)?)?";var s=b++;y[s]="[v=\\s]*("+y[o]+")(?:\\.("+y[o]+")(?:\\.("+y[o]+")(?:"+y[g]+")?"+y[D]+"?)?)?";var C=b++;y[C]="^"+y[n]+"\\s*"+y[a]+"$";var L=b++;y[L]="^"+y[n]+"\\s*"+y[s]+"$";var O=b++;y[O]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var W=b++;y[W]="(?:~>?)";var X=b++;y[X]="(\\s*)"+y[W]+"\\s+",P[X]=new RegExp(y[X],"g");var se=b++;y[se]="^"+y[W]+y[a]+"$";var fe=b++;y[fe]="^"+y[W]+y[s]+"$";var ce=b++;y[ce]="(?:\\^)";var V=b++;y[V]="(\\s*)"+y[ce]+"\\s+",P[V]=new RegExp(y[V],"g");var T=b++;y[T]="^"+y[ce]+y[a]+"$";var z=b++;y[z]="^"+y[ce]+y[s]+"$";var he=b++;y[he]="^"+y[n]+"\\s*("+r+")$|^$";var H=b++;y[H]="^"+y[n]+"\\s*("+t+")$|^$";var q=b++;y[q]="(\\s*)"+y[n]+"\\s*("+r+"|"+y[a]+")",P[q]=new RegExp(y[q],"g");var M=b++;y[M]="^\\s*("+y[a]+")\\s+-\\s+("+y[a]+")\\s*$";var ee=b++;y[ee]="^\\s*("+y[s]+")\\s+-\\s+("+y[s]+")\\s*$";var ie=b++;y[ie]="(<|>)?=?\\s*\\*";for(var me=0;me<35;me++)l(me,y[me]),P[me]||(P[me]=new RegExp(y[me]));function ne(ge,we){if(ge instanceof B)return ge;if(typeof ge!="string"||ge.length>w||!(we?P[i]:P[R]).test(ge))return null;try{return new B(ge,we)}catch{return null}}function B(ge,we){if(ge instanceof B){if(ge.loose===we)return ge;ge=ge.version}else if(typeof ge!="string")throw new TypeError("Invalid Version: "+ge);if(ge.length>w)throw new TypeError("version is longer than "+w+" characters");if(!(this instanceof B))return new B(ge,we);l("SemVer",ge,we),this.loose=we;var ye=ge.trim().match(we?P[i]:P[R]);if(!ye)throw new TypeError("Invalid Version: "+ge);if(this.raw=ge,this.major=+ye[1],this.minor=+ye[2],this.patch=+ye[3],this.major>S||this.major<0)throw new TypeError("Invalid major version");if(this.minor>S||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>S||this.patch<0)throw new TypeError("Invalid patch version");ye[4]?this.prerelease=ye[4].split(".").map(function(Fe){if(/^[0-9]+$/.test(Fe)){var $e=+Fe;if($e>=0&&$e<S)return $e}return Fe}):this.prerelease=[],this.build=ye[5]?ye[5].split("."):[],this.format()}e.parse=ne,e.valid=function(ge,we){var ye=ne(ge,we);return ye?ye.version:null},e.clean=function(ge,we){var ye=ne(ge.trim().replace(/^[=v]+/,""),we);return ye?ye.version:null},e.SemVer=B,B.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},B.prototype.toString=function(){return this.version},B.prototype.compare=function(ge){return l("SemVer.compare",this.version,this.loose,ge),ge instanceof B||(ge=new B(ge,this.loose)),this.compareMain(ge)||this.comparePre(ge)},B.prototype.compareMain=function(ge){return ge instanceof B||(ge=new B(ge,this.loose)),U(this.major,ge.major)||U(this.minor,ge.minor)||U(this.patch,ge.patch)},B.prototype.comparePre=function(ge){if(ge instanceof B||(ge=new B(ge,this.loose)),this.prerelease.length&&!ge.prerelease.length)return-1;if(!this.prerelease.length&&ge.prerelease.length)return 1;if(!this.prerelease.length&&!ge.prerelease.length)return 0;var we=0;do{var ye=this.prerelease[we],Fe=ge.prerelease[we];if(l("prerelease compare",we,ye,Fe),ye===void 0&&Fe===void 0)return 0;if(Fe===void 0)return 1;if(ye===void 0)return-1;if(ye!==Fe)return U(ye,Fe)}while(++we)},B.prototype.inc=function(ge,we){switch(ge){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",we);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",we);break;case"prepatch":this.prerelease.length=0,this.inc("patch",we),this.inc("pre",we);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",we),this.inc("pre",we);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ye=this.prerelease.length;--ye>=0;)typeof this.prerelease[ye]=="number"&&(this.prerelease[ye]++,ye=-2);ye===-1&&this.prerelease.push(0)}we&&(this.prerelease[0]===we?isNaN(this.prerelease[1])&&(this.prerelease=[we,0]):this.prerelease=[we,0]);break;default:throw new Error("invalid increment argument: "+ge)}return this.format(),this.raw=this.version,this},e.inc=function(ge,we,ye,Fe){typeof ye=="string"&&(Fe=ye,ye=void 0);try{return new B(ge,ye).inc(we,Fe).version}catch{return null}},e.diff=function(ge,we){if(j(ge,we))return null;var ye=ne(ge),Fe=ne(we);if(ye.prerelease.length||Fe.prerelease.length){for(var $e in ye)if(($e==="major"||$e==="minor"||$e==="patch")&&ye[$e]!==Fe[$e])return"pre"+$e;return"prerelease"}for(var $e in ye)if(($e==="major"||$e==="minor"||$e==="patch")&&ye[$e]!==Fe[$e])return $e},e.compareIdentifiers=U;var N=/^[0-9]+$/;function U(ge,we){var ye=N.test(ge),Fe=N.test(we);return ye&&Fe&&(ge=+ge,we=+we),ye&&!Fe?-1:Fe&&!ye?1:ge<we?-1:ge>we?1:0}function G(ge,we,ye){return new B(ge,ye).compare(new B(we,ye))}function te(ge,we,ye){return G(ge,we,ye)>0}function le(ge,we,ye){return G(ge,we,ye)<0}function j(ge,we,ye){return G(ge,we,ye)===0}function K(ge,we,ye){return G(ge,we,ye)!==0}function Q(ge,we,ye){return G(ge,we,ye)>=0}function x(ge,we,ye){return G(ge,we,ye)<=0}function _(ge,we,ye,Fe){var $e;switch(we){case"===":typeof ge=="object"&&(ge=ge.version),typeof ye=="object"&&(ye=ye.version),$e=ge===ye;break;case"!==":typeof ge=="object"&&(ge=ge.version),typeof ye=="object"&&(ye=ye.version),$e=ge!==ye;break;case"":case"=":case"==":$e=j(ge,ye,Fe);break;case"!=":$e=K(ge,ye,Fe);break;case">":$e=te(ge,ye,Fe);break;case">=":$e=Q(ge,ye,Fe);break;case"<":$e=le(ge,ye,Fe);break;case"<=":$e=x(ge,ye,Fe);break;default:throw new TypeError("Invalid operator: "+we)}return $e}function Y(ge,we){if(ge instanceof Y){if(ge.loose===we)return ge;ge=ge.value}if(!(this instanceof Y))return new Y(ge,we);l("comparator",ge,we),this.loose=we,this.parse(ge),this.semver===Z?this.value="":this.value=this.operator+this.semver.version,l("comp",this)}e.rcompareIdentifiers=function(ge,we){return U(we,ge)},e.major=function(ge,we){return new B(ge,we).major},e.minor=function(ge,we){return new B(ge,we).minor},e.patch=function(ge,we){return new B(ge,we).patch},e.compare=G,e.compareLoose=function(ge,we){return G(ge,we,!0)},e.rcompare=function(ge,we,ye){return G(we,ge,ye)},e.sort=function(ge,we){return ge.sort(function(ye,Fe){return e.compare(ye,Fe,we)})},e.rsort=function(ge,we){return ge.sort(function(ye,Fe){return e.rcompare(ye,Fe,we)})},e.gt=te,e.lt=le,e.eq=j,e.neq=K,e.gte=Q,e.lte=x,e.cmp=_,e.Comparator=Y;var Z={};function ae(ge,we){if(ge instanceof ae)return ge.loose===we?ge:new ae(ge.raw,we);if(ge instanceof Y)return new ae(ge.value,we);if(!(this instanceof ae))return new ae(ge,we);if(this.loose=we,this.raw=ge,this.set=ge.split(/\s*\|\|\s*/).map(function(ye){return this.parseRange(ye.trim())},this).filter(function(ye){return ye.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ge);this.format()}function ve(ge){return!ge||ge.toLowerCase()==="x"||ge==="*"}function Pe(ge,we,ye,Fe,$e,tt,Ve,Je,Xe,_e,Ke,ue,De){return((we=ve(ye)?"":ve(Fe)?">="+ye+".0.0":ve($e)?">="+ye+"."+Fe+".0":">="+we)+" "+(Je=ve(Xe)?"":ve(_e)?"<"+(+Xe+1)+".0.0":ve(Ke)?"<"+Xe+"."+(+_e+1)+".0":ue?"<="+Xe+"."+_e+"."+Ke+"-"+ue:"<="+Je)).trim()}function ke(ge,we){for(var ye=0;ye<ge.length;ye++)if(!ge[ye].test(we))return!1;if(we.prerelease.length){for(ye=0;ye<ge.length;ye++)if(l(ge[ye].semver),ge[ye].semver!==Z&&ge[ye].semver.prerelease.length>0){var Fe=ge[ye].semver;if(Fe.major===we.major&&Fe.minor===we.minor&&Fe.patch===we.patch)return!0}return!1}return!0}function Me(ge,we,ye){try{we=new ae(we,ye)}catch{return!1}return we.test(ge)}function je(ge,we,ye,Fe){var $e,tt,Ve,Je,Xe;switch(ge=new B(ge,Fe),we=new ae(we,Fe),ye){case">":$e=te,tt=x,Ve=le,Je=">",Xe=">=";break;case"<":$e=le,tt=Q,Ve=te,Je="<",Xe="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Me(ge,we,Fe))return!1;for(var _e=0;_e<we.set.length;++_e){var Ke=we.set[_e],ue=null,De=null;if(Ke.forEach(function(Re){Re.semver===Z&&(Re=new Y(">=0.0.0")),ue=ue||Re,De=De||Re,$e(Re.semver,ue.semver,Fe)?ue=Re:Ve(Re.semver,De.semver,Fe)&&(De=Re)}),ue.operator===Je||ue.operator===Xe||(!De.operator||De.operator===Je)&&tt(ge,De.semver)||De.operator===Xe&&Ve(ge,De.semver))return!1}return!0}Y.prototype.parse=function(ge){var we=this.loose?P[he]:P[H],ye=ge.match(we);if(!ye)throw new TypeError("Invalid comparator: "+ge);this.operator=ye[1],this.operator==="="&&(this.operator=""),ye[2]?this.semver=new B(ye[2],this.loose):this.semver=Z},Y.prototype.toString=function(){return this.value},Y.prototype.test=function(ge){return l("Comparator.test",ge,this.loose),this.semver===Z||(typeof ge=="string"&&(ge=new B(ge,this.loose)),_(ge,this.operator,this.semver,this.loose))},Y.prototype.intersects=function(ge,we){if(!(ge instanceof Y))throw new TypeError("a Comparator is required");var ye;if(this.operator==="")return ye=new ae(ge.value,we),Me(this.value,ye,we);if(ge.operator==="")return ye=new ae(this.value,we),Me(ge.semver,ye,we);var Fe=!(this.operator!==">="&&this.operator!==">"||ge.operator!==">="&&ge.operator!==">"),$e=!(this.operator!=="<="&&this.operator!=="<"||ge.operator!=="<="&&ge.operator!=="<"),tt=this.semver.version===ge.semver.version,Ve=!(this.operator!==">="&&this.operator!=="<="||ge.operator!==">="&&ge.operator!=="<="),Je=_(this.semver,"<",ge.semver,we)&&(this.operator===">="||this.operator===">")&&(ge.operator==="<="||ge.operator==="<"),Xe=_(this.semver,">",ge.semver,we)&&(this.operator==="<="||this.operator==="<")&&(ge.operator===">="||ge.operator===">");return Fe||$e||tt&&Ve||Je||Xe},e.Range=ae,ae.prototype.format=function(){return this.range=this.set.map(function(ge){return ge.join(" ").trim()}).join("||").trim(),this.range},ae.prototype.toString=function(){return this.range},ae.prototype.parseRange=function(ge){var we=this.loose;ge=ge.trim(),l("range",ge,we);var ye=we?P[ee]:P[M];ge=ge.replace(ye,Pe),l("hyphen replace",ge),ge=ge.replace(P[q],"$1$2$3"),l("comparator trim",ge,P[q]),ge=(ge=(ge=ge.replace(P[X],"$1~")).replace(P[V],"$1^")).split(/\s+/).join(" ");var Fe=we?P[he]:P[H],$e=ge.split(" ").map(function(tt){return function(Ve,Je){return l("comp",Ve),Ve=function(Xe,_e){return Xe.trim().split(/\s+/).map(function(Ke){return function(ue,De){l("caret",ue,De);var Re=De?P[z]:P[T];return ue.replace(Re,function(Ne,Oe,ze,We,qe){var Ge;return l("caret",ue,Ne,Oe,ze,We,qe),ve(Oe)?Ge="":ve(ze)?Ge=">="+Oe+".0.0 <"+(+Oe+1)+".0.0":ve(We)?Ge=Oe==="0"?">="+Oe+"."+ze+".0 <"+Oe+"."+(+ze+1)+".0":">="+Oe+"."+ze+".0 <"+(+Oe+1)+".0.0":qe?(l("replaceCaret pr",qe),qe.charAt(0)!=="-"&&(qe="-"+qe),Ge=Oe==="0"?ze==="0"?">="+Oe+"."+ze+"."+We+qe+" <"+Oe+"."+ze+"."+(+We+1):">="+Oe+"."+ze+"."+We+qe+" <"+Oe+"."+(+ze+1)+".0":">="+Oe+"."+ze+"."+We+qe+" <"+(+Oe+1)+".0.0"):(l("no pr"),Ge=Oe==="0"?ze==="0"?">="+Oe+"."+ze+"."+We+" <"+Oe+"."+ze+"."+(+We+1):">="+Oe+"."+ze+"."+We+" <"+Oe+"."+(+ze+1)+".0":">="+Oe+"."+ze+"."+We+" <"+(+Oe+1)+".0.0"),l("caret return",Ge),Ge})}(Ke,_e)}).join(" ")}(Ve,Je),l("caret",Ve),Ve=function(Xe,_e){return Xe.trim().split(/\s+/).map(function(Ke){return function(ue,De){var Re=De?P[fe]:P[se];return ue.replace(Re,function(Ne,Oe,ze,We,qe){var Ge;return l("tilde",ue,Ne,Oe,ze,We,qe),ve(Oe)?Ge="":ve(ze)?Ge=">="+Oe+".0.0 <"+(+Oe+1)+".0.0":ve(We)?Ge=">="+Oe+"."+ze+".0 <"+Oe+"."+(+ze+1)+".0":qe?(l("replaceTilde pr",qe),qe.charAt(0)!=="-"&&(qe="-"+qe),Ge=">="+Oe+"."+ze+"."+We+qe+" <"+Oe+"."+(+ze+1)+".0"):Ge=">="+Oe+"."+ze+"."+We+" <"+Oe+"."+(+ze+1)+".0",l("tilde return",Ge),Ge})}(Ke,_e)}).join(" ")}(Ve,Je),l("tildes",Ve),Ve=function(Xe,_e){return l("replaceXRanges",Xe,_e),Xe.split(/\s+/).map(function(Ke){return function(ue,De){ue=ue.trim();var Re=De?P[L]:P[C];return ue.replace(Re,function(Ne,Oe,ze,We,qe,Ge){l("xRange",ue,Ne,Oe,ze,We,qe,Ge);var et=ve(ze),Ye=et||ve(We),Qe=Ye||ve(qe);return Oe==="="&&Qe&&(Oe=""),et?Ne=Oe===">"||Oe==="<"?"<0.0.0":"*":Oe&&Qe?(Ye&&(We=0),Qe&&(qe=0),Oe===">"?(Oe=">=",Ye?(ze=+ze+1,We=0,qe=0):Qe&&(We=+We+1,qe=0)):Oe==="<="&&(Oe="<",Ye?ze=+ze+1:We=+We+1),Ne=Oe+ze+"."+We+"."+qe):Ye?Ne=">="+ze+".0.0 <"+(+ze+1)+".0.0":Qe&&(Ne=">="+ze+"."+We+".0 <"+ze+"."+(+We+1)+".0"),l("xRange return",Ne),Ne})}(Ke,_e)}).join(" ")}(Ve,Je),l("xrange",Ve),Ve=function(Xe,_e){return l("replaceStars",Xe,_e),Xe.trim().replace(P[ie],"")}(Ve,Je),l("stars",Ve),Ve}(tt,we)}).join(" ").split(/\s+/);return this.loose&&($e=$e.filter(function(tt){return!!tt.match(Fe)})),$e=$e.map(function(tt){return new Y(tt,we)})},ae.prototype.intersects=function(ge,we){if(!(ge instanceof ae))throw new TypeError("a Range is required");return this.set.some(function(ye){return ye.every(function(Fe){return ge.set.some(function($e){return $e.every(function(tt){return Fe.intersects(tt,we)})})})})},e.toComparators=function(ge,we){return new ae(ge,we).set.map(function(ye){return ye.map(function(Fe){return Fe.value}).join(" ").trim().split(" ")})},ae.prototype.test=function(ge){if(!ge)return!1;typeof ge=="string"&&(ge=new B(ge,this.loose));for(var we=0;we<this.set.length;we++)if(ke(this.set[we],ge))return!0;return!1},e.satisfies=Me,e.maxSatisfying=function(ge,we,ye){var Fe=null,$e=null;try{var tt=new ae(we,ye)}catch{return null}return ge.forEach(function(Ve){tt.test(Ve)&&(Fe&&$e.compare(Ve)!==-1||($e=new B(Fe=Ve,ye)))}),Fe},e.minSatisfying=function(ge,we,ye){var Fe=null,$e=null;try{var tt=new ae(we,ye)}catch{return null}return ge.forEach(function(Ve){tt.test(Ve)&&(Fe&&$e.compare(Ve)!==1||($e=new B(Fe=Ve,ye)))}),Fe},e.validRange=function(ge,we){try{return new ae(ge,we).range||"*"}catch{return null}},e.ltr=function(ge,we,ye){return je(ge,we,"<",ye)},e.gtr=function(ge,we,ye){return je(ge,we,">",ye)},e.outside=je,e.prerelease=function(ge,we){var ye=ne(ge,we);return ye&&ye.prerelease.length?ye.prerelease:null},e.intersects=function(ge,we,ye){return ge=new ae(ge,ye),we=new ae(we,ye),ge.intersects(we)},e.coerce=function(ge){if(ge instanceof B)return ge;if(typeof ge!="string")return null;var we=ge.match(P[O]);return we==null?null:ne((we[1]||"0")+"."+(we[2]||"0")+"."+(we[3]||"0"))}}).call(this,E(1))},function(oe,e){var E,A,l=oe.exports={};function w(){throw new Error("setTimeout has not been defined")}function S(){throw new Error("clearTimeout has not been defined")}function P(c){if(E===setTimeout)return setTimeout(c,0);if((E===w||!E)&&setTimeout)return E=setTimeout,setTimeout(c,0);try{return E(c,0)}catch{try{return E.call(null,c,0)}catch{return E.call(this,c,0)}}}(function(){try{E=typeof setTimeout=="function"?setTimeout:w}catch{E=w}try{A=typeof clearTimeout=="function"?clearTimeout:S}catch{A=S}})();var y,b=[],k=!1,I=-1;function v(){k&&y&&(k=!1,y.length?b=y.concat(b):I=-1,b.length&&d())}function d(){if(!k){var c=P(v);k=!0;for(var h=b.length;h;){for(y=b,b=[];++I<h;)y&&y[I].run();I=-1,h=b.length}y=null,k=!1,function(g){if(A===clearTimeout)return clearTimeout(g);if((A===S||!A)&&clearTimeout)return A=clearTimeout,clearTimeout(g);try{A(g)}catch{try{return A.call(null,g)}catch{return A.call(this,g)}}}(c)}}function m(c,h){this.fun=c,this.array=h}function p(){}l.nextTick=function(c){var h=new Array(arguments.length-1);if(arguments.length>1)for(var g=1;g<arguments.length;g++)h[g-1]=arguments[g];b.push(new m(c,h)),b.length!==1||k||P(d)},m.prototype.run=function(){this.fun.apply(null,this.array)},l.title="browser",l.browser=!0,l.env={},l.argv=[],l.version="",l.versions={},l.on=p,l.addListener=p,l.once=p,l.off=p,l.removeListener=p,l.removeAllListeners=p,l.emit=p,l.prependListener=p,l.prependOnceListener=p,l.listeners=function(c){return[]},l.binding=function(c){throw new Error("process.binding is not supported")},l.cwd=function(){return"/"},l.chdir=function(c){throw new Error("process.chdir is not supported")},l.umask=function(){return 0}}])}),define(be[144],Ee([1,0]),function(oe,e){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class A{constructor(P,y,b){this.level=P,this.key=y,this.value=b,this.forward=[]}}const l=void 0;class w{constructor(P,y=2**16){this.comparator=P,this[E]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(y)|0),this.e=new A(this.c,l,l)}get size(){return this.f}clear(){this.e=new A(this.c,l,l)}has(P){return Boolean(w.g(this,P,this.comparator))}get(P){return w.g(this,P,this.comparator)?.value}set(P,y){return w.h(this,P,y,this.comparator)&&(this.f+=1),this}delete(P){const y=w.k(this,P,this.comparator);return y&&(this.f-=1),y}forEach(P,y){let b=this.e.forward[0];for(;b;)P.call(y,b.value,b.key,this),b=b.forward[0]}[(E=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let P=this.e.forward[0];for(;P;)yield[P.key,P.value],P=P.forward[0]}*keys(){let P=this.e.forward[0];for(;P;)yield P.key,P=P.forward[0]}*values(){let P=this.e.forward[0];for(;P;)yield P.value,P=P.forward[0]}toString(){let P="[SkipList]:",y=this.e.forward[0];for(;y;)P+=`node(${y.key}, ${y.value}, lvl:${y.level})`,y=y.forward[0];return P}static g(P,y,b){let k=P.e;for(let I=P.d-1;I>=0;I--)for(;k.forward[I]&&b(k.forward[I].key,y)<0;)k=k.forward[I];if(k=k.forward[0],k&&b(k.key,y)===0)return k}static h(P,y,b,k){const I=[];let v=P.e;for(let d=P.d-1;d>=0;d--){for(;v.forward[d]&&k(v.forward[d].key,y)<0;)v=v.forward[d];I[d]=v}if(v=v.forward[0],v&&k(v.key,y)===0)return v.value=b,!1;{const d=w.j(P);if(d>P.d){for(let m=P.d;m<d;m++)I[m]=P.e;P.d=d}v=new A(d,y,b);for(let m=0;m<d;m++)v.forward[m]=I[m].forward[m],I[m].forward[m]=v;return!0}}static j(P,y=.5){let b=1;for(;Math.random()<y&&b<P.c;)b+=1;return b}static k(P,y,b){const k=[];let I=P.e;for(let v=P.d-1;v>=0;v--){for(;I.forward[v]&&b(I.forward[v].key,y)<0;)I=I.forward[v];k[v]=I}if(I=I.forward[0],!I||b(I.key,y)!==0)return!1;for(let v=0;v<P.d&&k[v].forward[v]===I;v++)k[v].forward[v]=I.forward[v];for(;P.d>0&&P.e.forward[P.d-1]===l;)P.d-=1;return!0}}e.SkipList=w}),define(be[91],Ee([1,0,3]),function(oe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const A=E.globals.performance&&typeof E.globals.performance.now=="function";class l{static create(S=!0){return new l(S)}constructor(S){this.a=A&&S,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?E.globals.performance.now():Date.now()}}e.StopWatch=l}),define(be[6],Ee([1,0,9,70,2,89,91]),function(oe,e,E,A,l,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const P=!1,y=!1;var b;(function(u){u.None=()=>l.Disposable.None;function a(G){if(y){const{onDidAddListener:te}=G,le=m.create();let j=0;G.onDidAddListener=()=>{++j===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),le.print()),te?.()}}}function s(G,te){return V(G,()=>{},0,void 0,!0,void 0,te)}u.defer=s;function C(G){return(te,le=null,j)=>{let K=!1,Q;return Q=G(x=>{if(!K)return Q?Q.dispose():K=!0,te.call(le,x)},null,j),K&&Q.dispose(),Q}}u.once=C;function L(G,te,le){return ce((j,K=null,Q)=>G(x=>j.call(K,te(x)),null,Q),le)}u.map=L;function O(G,te,le){return ce((j,K=null,Q)=>G(x=>{te(x),j.call(K,x)},null,Q),le)}u.forEach=O;function W(G,te,le){return ce((j,K=null,Q)=>G(x=>te(x)&&j.call(K,x),null,Q),le)}u.filter=W;function X(G){return G}u.signal=X;function se(...G){return(te,le=null,j)=>(0,l.combinedDisposable)(...G.map(K=>K(Q=>te.call(le,Q),null,j)))}u.any=se;function fe(G,te,le,j){let K=le;return L(G,Q=>(K=te(K,Q),K),j)}u.reduce=fe;function ce(G,te){let le;const j={onWillAddFirstListener(){le=G(K.fire,K)},onDidRemoveLastListener(){le?.dispose()}};te||a(j);const K=new c(j);return te?.add(K),K.event}function V(G,te,le=100,j=!1,K=!1,Q,x){let _,Y,Z,ae=0,ve;const Pe={leakWarningThreshold:Q,onWillAddFirstListener(){_=G(Me=>{ae++,Y=te(Y,Me),j&&!Z&&(ke.fire(Y),Y=void 0),ve=()=>{const je=Y;Y=void 0,Z=void 0,(!j||ae>1)&&ke.fire(je),ae=0},typeof le=="number"?(clearTimeout(Z),Z=setTimeout(ve,le)):Z===void 0&&(Z=0,queueMicrotask(ve))})},onWillRemoveListener(){K&&ae>0&&ve?.()},onDidRemoveLastListener(){ve=void 0,_.dispose()}};x||a(Pe);const ke=new c(Pe);return x?.add(ke),ke.event}u.debounce=V;function T(G,te=0,le){return u.debounce(G,(j,K)=>j?(j.push(K),j):[K],te,void 0,!0,void 0,le)}u.accumulate=T;function z(G,te=(j,K)=>j===K,le){let j=!0,K;return W(G,Q=>{const x=j||!te(Q,K);return j=!1,K=Q,x},le)}u.latch=z;function he(G,te,le){return[u.filter(G,te,le),u.filter(G,j=>!te(j),le)]}u.split=he;function H(G,te=!1,le=[]){let j=le.slice(),K=G(_=>{j?j.push(_):x.fire(_)});const Q=()=>{j?.forEach(_=>x.fire(_)),j=null},x=new c({onWillAddFirstListener(){K||(K=G(_=>x.fire(_)))},onDidAddFirstListener(){j&&(te?setTimeout(Q):Q())},onDidRemoveLastListener(){K&&K.dispose(),K=null}});return x.event}u.buffer=H;class q{constructor(te){this.event=te,this.c=new l.DisposableStore}map(te){return new q(L(this.event,te,this.c))}forEach(te){return new q(O(this.event,te,this.c))}filter(te){return new q(W(this.event,te,this.c))}reduce(te,le){return new q(fe(this.event,te,le,this.c))}latch(){return new q(z(this.event,void 0,this.c))}debounce(te,le=100,j=!1,K=!1,Q){return new q(V(this.event,te,le,j,K,Q,this.c))}on(te,le,j){return this.event(te,le,j)}once(te,le,j){return C(this.event)(te,le,j)}dispose(){this.c.dispose()}}function M(G){return new q(G)}u.chain=M;function ee(G,te,le=j=>j){const j=(..._)=>x.fire(le(..._)),K=()=>G.on(te,j),Q=()=>G.removeListener(te,j),x=new c({onWillAddFirstListener:K,onDidRemoveLastListener:Q});return x.event}u.fromNodeEventEmitter=ee;function ie(G,te,le=j=>j){const j=(..._)=>x.fire(le(..._)),K=()=>G.addEventListener(te,j),Q=()=>G.removeEventListener(te,j),x=new c({onWillAddFirstListener:K,onDidRemoveLastListener:Q});return x.event}u.fromDOMEventEmitter=ie;function me(G){return new Promise(te=>C(G)(te))}u.toPromise=me;function ne(G,te){return te(void 0),G(le=>te(le))}u.runAndSubscribe=ne;function B(G,te){let le=null;function j(Q){le?.dispose(),le=new l.DisposableStore,te(Q,le)}j(void 0);const K=G(Q=>j(Q));return(0,l.toDisposable)(()=>{K.dispose(),le?.dispose()})}u.runAndSubscribeWithStore=B;class N{constructor(te,le){this.obs=te,this.c=0,this.d=!1;const j={onWillAddFirstListener:()=>{te.addObserver(this)},onDidRemoveLastListener:()=>{te.removeObserver(this)}};le||a(j),this.emitter=new c(j),le&&le.add(this.emitter)}beginUpdate(te){this.c++}handleChange(te,le){this.d=!0}endUpdate(te){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function U(G,te){return new N(G,te).emitter.event}u.fromObservable=U})(b=e.Event||(e.Event={}));class k{constructor(a){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${a}_${k.c++}`,k.all.add(this)}start(a){this.d=new S.StopWatch(!0),this.listenerCount=a}stop(){if(this.d){const a=this.d.elapsed();this.durations.push(a),this.elapsedOverall+=a,this.invocationCount+=1,this.d=void 0}}}k.all=new Set,k.c=0,e.EventProfiling=k;let I=-1;function v(u){const a=I;return I=u,{dispose(){I=a}}}e.setGlobalLeakWarningThreshold=v;class d{constructor(a,s=Math.random().toString(18).slice(2,5)){this.threshold=a,this.name=s,this.d=0}dispose(){this.c?.clear()}check(a,s){const C=this.threshold;if(C<=0||s<C)return;this.c||(this.c=new Map);const L=this.c.get(a.value)||0;if(this.c.set(a.value,L+1),this.d-=1,this.d<=0){this.d=C*.5;let O,W=0;for(const[X,se]of this.c)(!O||W<se)&&(O=X,W=se);console.warn(`[${this.name}] potential listener LEAK detected, having ${s} listeners already. MOST frequent listener (${W}):`),console.warn(O)}return()=>{const O=this.c.get(a.value)||0;this.c.set(a.value,O-1)}}}class m{static create(){return new m(new Error().stack??"")}constructor(a){this.value=a}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class p{constructor(a,s,C){this.callback=a,this.callbackThis=s,this.stack=C,this.subscription=new l.SafeDisposable}invoke(a){this.callback.call(this.callbackThis,a)}}class c{constructor(a){this.j=!1,this.d=a,this.f=I>0||this.d?.leakWarningThreshold?new d(this.d?.leakWarningThreshold??I):void 0,this.g=this.d?._profName?new k(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(P){const a=Array.from(this.q);queueMicrotask(()=>{for(const s of a)s.subscription.isset()&&(s.subscription.unset(),s.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(a,s,C)=>{if(this.q||(this.q=new w.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),l.Disposable.None;const L=this.q.isEmpty();L&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let O,W;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(W=m.create(),O=this.f.check(W,this.q.size+1)),P&&(W=W??m.create());const X=new p(a,s,W),se=this.q.push(X);L&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,a,s);const fe=X.subscription.set(()=>{O?.(),this.j||(this.d?.onWillRemoveListener?.(this),se(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return C instanceof l.DisposableStore?C.add(fe):Array.isArray(C)&&C.push(fe),fe}),this.l}fire(a){if(this.q){this.m||(this.m=new g);for(const s of this.q)this.m.push(this,s,a);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}e.Emitter=c;class h{constructor(){this.c=new w.LinkedList}get size(){return this.c.size}push(a,s,C){this.c.push(new f(a,s,C))}clear(a){const s=new w.LinkedList;for(const C of this.c)C.emitter!==a&&s.push(C);this.c=s}deliver(){for(;this.c.size>0;){const a=this.c.shift();try{a.listener.invoke(a.event)}catch(s){(0,E.onUnexpectedError)(s)}}}}e.EventDeliveryQueue=h;class g extends h{clear(a){this.c.clear()}}class f{constructor(a,s,C){this.emitter=a,this.listener=s,this.event=C}}class D extends c{async fireAsync(a,s,C){if(!!this.q){this.c||(this.c=new w.LinkedList);for(const L of this.q)this.c.push([L,a]);for(;this.c.size>0&&!s.isCancellationRequested;){const[L,O]=this.c.shift(),W=[],X={...O,token:s,waitUntil:se=>{if(Object.isFrozen(W))throw new Error("waitUntil can NOT be called asynchronous");C&&(se=C(se,L.callback)),W.push(se)}};try{L.invoke(X)}catch(se){(0,E.onUnexpectedError)(se);continue}Object.freeze(W),await Promise.allSettled(W).then(se=>{for(const fe of se)fe.status==="rejected"&&(0,E.onUnexpectedError)(fe.reason)})}}}}e.AsyncEmitter=D;class R extends c{constructor(a){super(a),this.h=0,this.s=new w.LinkedList,this.t=a?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const a=Array.from(this.s);this.s.clear(),super.fire(this.t(a))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(a){this.q&&(this.h!==0?this.s.push(a):super.fire(a))}}e.PauseableEmitter=R;class t extends R{constructor(a){super(a),this.c=a.delay??100}fire(a){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(a)}}e.DebounceEmitter=t;class r extends c{constructor(a){super(a),this.c=[],this.h=a?.merge}fire(a){!this.hasListeners()||(this.c.push(a),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(s=>super.fire(s)),this.c=[]}))}}e.MicrotaskEmitter=r;class i{constructor(){this.d=!1,this.f=[],this.c=new c({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(a){const s={event:a,listener:null};this.f.push(s),this.d&&this.j(s);const C=()=>{this.d&&this.k(s);const L=this.f.indexOf(s);this.f.splice(L,1)};return(0,l.toDisposable)((0,A.once)(C))}g(){this.d=!0,this.f.forEach(a=>this.j(a))}h(){this.d=!1,this.f.forEach(a=>this.k(a))}j(a){a.listener=a.event(s=>this.c.fire(s))}k(a){a.listener&&a.listener.dispose(),a.listener=null}dispose(){this.c.dispose()}}e.EventMultiplexer=i;class n{constructor(){this.c=[]}wrapEvent(a){return(s,C,L)=>a(O=>{const W=this.c[this.c.length-1];W?W.push(()=>s.call(C,O)):s.call(C,O)},void 0,L)}bufferEvents(a){const s=[];this.c.push(s);const C=a();return this.c.pop(),s.forEach(L=>L()),C}}e.EventBufferer=n;class o{constructor(){this.c=!1,this.d=b.None,this.f=l.Disposable.None,this.g=new c({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(a){this.d=a,this.c&&(this.f.dispose(),this.f=a(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}e.Relay=o}),define(be[19],Ee([1,0,6]),function(oe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const A=Object.freeze(function(P,y){const b=setTimeout(P.bind(y),0);return{dispose(){clearTimeout(b)}}});var l;(function(P){function y(b){return b===P.None||b===P.Cancelled||b instanceof w?!0:!b||typeof b!="object"?!1:typeof b.isCancellationRequested=="boolean"&&typeof b.onCancellationRequested=="function"}P.isCancellationToken=y,P.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:E.Event.None}),P.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:A})})(l=e.CancellationToken||(e.CancellationToken={}));class w{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?A:(this.b||(this.b=new E.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class S{constructor(y){this.a=void 0,this.b=void 0,this.b=y&&y.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new w),this.a}cancel(){this.a?this.a instanceof w&&this.a.cancel():this.a=l.Cancelled}dispose(y=!1){y&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof w&&this.a.dispose():this.a=l.None}}e.CancellationTokenSource=S}),define(be[145],Ee([1,0,19]),function(oe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class A{constructor(P){this.b=P,this.a=null}get(){if(this.a)return this.a;const P=new E.CancellationTokenSource,y=this.b(P.token);return this.a={promise:y,dispose:()=>{this.a=null,P.cancel(),P.dispose()}},this.a}}e.Cache=A;class l{constructor(P){this.c=P,this.a=void 0,this.b=void 0}get(P){const y=JSON.stringify(P);return this.b!==y&&(this.b=y,this.a=this.c(P)),this.a}}e.LRUCachedFunction=l;class w{get cachedValues(){return this.a}constructor(P){this.b=P,this.a=new Map}get(P){if(this.a.has(P))return this.a.get(P);const y=this.b(P);return this.a.set(P,y),y}}e.CachedFunction=w}),define(be[45],Ee([1,0,9,2]),function(oe,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function l(D){const R=D;return R?typeof R.read=="function":!1}e.isReadable=l;function w(D){const R=D;return R?[R.on,R.pause,R.resume,R.destroy].every(t=>typeof t=="function"):!1}e.isReadableStream=w;function S(D){const R=D;return R?w(R.stream)&&Array.isArray(R.buffer)&&typeof R.ended=="boolean":!1}e.isReadableBufferedStream=S;function P(D,R){return new y(D,R)}e.newWriteableStream=P;class y{constructor(R,t){this.e=R,this.f=t,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(R){if(!this.a.destroyed){if(this.a.flowing)this.g(R);else if(this.b.data.push(R),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(t=>this.d.push(t))}}error(R){this.a.destroyed||(this.a.flowing?this.h(R):this.b.error.push(R))}end(R){this.a.destroyed||(typeof R<"u"&&this.write(R),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(R){this.c.data.slice(0).forEach(t=>t(R))}h(R){this.c.error.length===0?(0,E.onUnexpectedError)(R):this.c.error.slice(0).forEach(t=>t(R))}i(){this.c.end.slice(0).forEach(R=>R())}on(R,t){if(!this.a.destroyed)switch(R){case"data":this.c.data.push(t),this.resume();break;case"end":this.c.end.push(t),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(t),this.a.flowing&&this.k();break}}removeListener(R,t){if(this.a.destroyed)return;let r;switch(R){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const i=r.indexOf(t);i>=0&&r.splice(i,1)}}j(){if(this.b.data.length>0){const R=this.e(this.b.data);this.g(R),this.b.data.length=0;const t=[...this.d];this.d.length=0,t.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const R of this.b.error)this.h(R);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function b(D,R){const t=[];let r;for(;(r=D.read())!==null;)t.push(r);return R(t)}e.consumeReadable=b;function k(D,R,t){const r=[];let i;for(;(i=D.read())!==null&&r.length<t;)r.push(i);return i===null&&r.length>0?R(r):{read:()=>{if(r.length>0)return r.shift();if(typeof i<"u"){const n=i;return i=void 0,n}return D.read()}}}e.peekReadable=k;function I(D,R){return new Promise((t,r)=>{const i=[];v(D,{onData:n=>{R&&i.push(n)},onError:n=>{R?r(n):t(void 0)},onEnd:()=>{t(R?R(i):void 0)}})})}e.consumeStream=I;function v(D,R){let t=!1;return D.on("error",r=>{t||R.onError(r)}),D.on("end",()=>{t||R.onEnd()}),D.on("data",r=>{t||R.onData(r)}),(0,A.toDisposable)(()=>t=!0)}e.listenStream=v;function d(D,R){return new Promise((t,r)=>{const i=new A.DisposableStore,n=[],o=s=>{if(n.push(s),n.length>R)return i.dispose(),D.pause(),t({stream:D,buffer:n,ended:!1})},u=s=>r(s),a=()=>t({stream:D,buffer:n,ended:!0});i.add((0,A.toDisposable)(()=>D.removeListener("error",u))),D.on("error",u),i.add((0,A.toDisposable)(()=>D.removeListener("end",a))),D.on("end",a),i.add((0,A.toDisposable)(()=>D.removeListener("data",o))),D.on("data",o)})}e.peekStream=d;function m(D,R){const t=P(R);return t.end(D),t}e.toStream=m;function p(){const D=P(()=>{throw new Error("not supported")});return D.end(),D}e.emptyStream=p;function c(D){let R=!1;return{read:()=>R?null:(R=!0,D)}}e.toReadable=c;function h(D,R,t){const r=P(t);return v(D,{onData:i=>r.write(R.data(i)),onError:i=>r.error(R.error?R.error(i):i),onEnd:()=>r.end()}),r}e.transform=h;function g(D,R,t){let r=!1;return{read:()=>{const i=R.read();return r?i:(r=!0,i!==null?t([D,i]):D)}}}e.prefixedReadable=g;function f(D,R,t){let r=!1;const i=P(t);return v(R,{onData:n=>r?i.write(n):(r=!0,i.write(t([D,n]))),onError:n=>i.error(n),onEnd:()=>{r||(r=!0,i.write(D)),i.end()}}),i}e.prefixedStream=f}),define(be[15],Ee([1,0,45]),function(oe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const A=typeof Buffer<"u";let l,w;class S{static alloc(s){return A?new S(Buffer.allocUnsafe(s)):new S(new Uint8Array(s))}static wrap(s){return A&&!Buffer.isBuffer(s)&&(s=Buffer.from(s.buffer,s.byteOffset,s.byteLength)),new S(s)}static fromString(s,C){return!(C?.dontUseNodeBuffer||!1)&&A?new S(Buffer.from(s)):(l||(l=new TextEncoder),new S(l.encode(s)))}static fromByteArray(s){const C=S.alloc(s.length);for(let L=0,O=s.length;L<O;L++)C.buffer[L]=s[L];return C}static concat(s,C){if(typeof C>"u"){C=0;for(let W=0,X=s.length;W<X;W++)C+=s[W].byteLength}const L=S.alloc(C);let O=0;for(let W=0,X=s.length;W<X;W++){const se=s[W];L.set(se,O),O+=se.byteLength}return L}constructor(s){this.buffer=s,this.byteLength=this.buffer.byteLength}clone(){const s=S.alloc(this.byteLength);return s.set(this),s}toString(){return A?this.buffer.toString():(w||(w=new TextDecoder),w.decode(this.buffer))}slice(s,C){return new S(this.buffer.subarray(s,C))}set(s,C){if(s instanceof S)this.buffer.set(s.buffer,C);else if(s instanceof Uint8Array)this.buffer.set(s,C);else if(s instanceof ArrayBuffer)this.buffer.set(new Uint8Array(s),C);else if(ArrayBuffer.isView(s))this.buffer.set(new Uint8Array(s.buffer,s.byteOffset,s.byteLength),C);else throw new Error("Unknown argument 'array'")}readUInt32BE(s){return b(this.buffer,s)}writeUInt32BE(s,C){k(this.buffer,s,C)}readUInt32LE(s){return I(this.buffer,s)}writeUInt32LE(s,C){v(this.buffer,s,C)}readUInt8(s){return d(this.buffer,s)}writeUInt8(s,C){m(this.buffer,s,C)}}e.VSBuffer=S;function P(a,s){return a[s+0]<<0>>>0|a[s+1]<<8>>>0}e.readUInt16LE=P;function y(a,s,C){a[C+0]=s&255,s=s>>>8,a[C+1]=s&255}e.writeUInt16LE=y;function b(a,s){return a[s]*2**24+a[s+1]*2**16+a[s+2]*2**8+a[s+3]}e.readUInt32BE=b;function k(a,s,C){a[C+3]=s,s=s>>>8,a[C+2]=s,s=s>>>8,a[C+1]=s,s=s>>>8,a[C]=s}e.writeUInt32BE=k;function I(a,s){return a[s+0]<<0>>>0|a[s+1]<<8>>>0|a[s+2]<<16>>>0|a[s+3]<<24>>>0}e.readUInt32LE=I;function v(a,s,C){a[C+0]=s&255,s=s>>>8,a[C+1]=s&255,s=s>>>8,a[C+2]=s&255,s=s>>>8,a[C+3]=s&255}e.writeUInt32LE=v;function d(a,s){return a[s]}e.readUInt8=d;function m(a,s,C){a[C]=s}e.writeUInt8=m;function p(a){return E.consumeReadable(a,s=>S.concat(s))}e.readableToBuffer=p;function c(a){return E.toReadable(a)}e.bufferToReadable=c;function h(a){return E.consumeStream(a,s=>S.concat(s))}e.streamToBuffer=h;async function g(a){return a.ended?S.concat(a.buffer):S.concat([...a.buffer,await h(a.stream)])}e.bufferedStreamToBuffer=g;function f(a){return E.toStream(a,s=>S.concat(s))}e.bufferToStream=f;function D(a){return E.transform(a,{data:s=>typeof s=="string"?S.fromString(s):S.wrap(s)},s=>S.concat(s))}e.streamToBufferReadableStream=D;function R(a){return E.newWriteableStream(s=>S.concat(s),a)}e.newWriteableBufferStream=R;function t(a,s){return E.prefixedReadable(a,s,C=>S.concat(C))}e.prefixedBufferReadable=t;function r(a,s){return E.prefixedStream(a,s,C=>S.concat(C))}e.prefixedBufferStream=r;function i(a){let s=0,C=0,L=0;const O=new Uint8Array(Math.floor(a.length/4*3)),W=se=>{switch(C){case 3:O[L++]=s|se,C=0;break;case 2:O[L++]=s|se>>>2,s=se<<6,C=3;break;case 1:O[L++]=s|se>>>4,s=se<<4,C=2;break;default:s=se<<2,C=1}};for(let se=0;se<a.length;se++){const fe=a.charCodeAt(se);if(fe>=65&&fe<=90)W(fe-65);else if(fe>=97&&fe<=122)W(fe-97+26);else if(fe>=48&&fe<=57)W(fe-48+52);else if(fe===43||fe===45)W(62);else if(fe===47||fe===95)W(63);else{if(fe===61)break;throw new SyntaxError(`Unexpected base64 character ${a[se]}`)}}const X=L;for(;C>0;)W(0);return S.wrap(O).slice(0,X)}e.decodeBase64=i;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function u({buffer:a},s=!0,C=!1){const L=C?o:n;let O="";const W=a.byteLength%3;let X=0;for(;X<a.byteLength-W;X+=3){const se=a[X+0],fe=a[X+1],ce=a[X+2];O+=L[se>>>2],O+=L[(se<<4|fe>>>4)&63],O+=L[(fe<<2|ce>>>6)&63],O+=L[ce&63]}if(W===1){const se=a[X+0];O+=L[se>>>2],O+=L[se<<4&63],s&&(O+="==")}else if(W===2){const se=a[X+0],fe=a[X+1];O+=L[se>>>2],O+=L[(se<<4|fe>>>4)&63],O+=L[fe<<2&63],s&&(O+="=")}return O}e.encodeBase64=u}),define(be[17],Ee([1,0,145,141]),function(oe,e,E,A){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function w(ue){return!ue||typeof ue!="string"?!0:ue.trim().length===0}e.isFalsyOrWhitespace=w;const S=/{(\d+)}/g;function P(ue,...De){return De.length===0?ue:ue.replace(S,function(Re,Ne){const Oe=parseInt(Ne,10);return isNaN(Oe)||Oe<0||Oe>=De.length?Re:De[Oe]})}e.format=P;const y=/{([^}]+)}/g;function b(ue,De){return ue.replace(y,(Re,Ne)=>De[Ne]??Re)}e.format2=b;function k(ue){return ue.replace(/[<>&]/g,function(De){switch(De){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return De}})}e.escape=k;function I(ue){return ue.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=I;function v(ue,De){let Re=0;const Ne=De.charCodeAt(0);for(let Oe=ue.length-1;Oe>=0;Oe--)ue.charCodeAt(Oe)===Ne&&Re++;return Re}e.count=v;function d(ue,De,Re="\u2026"){return ue.length<=De?ue:`${ue.substr(0,De)}${Re}`}e.truncate=d;function m(ue,De=" "){const Re=p(ue,De);return c(Re,De)}e.trim=m;function p(ue,De){if(!ue||!De)return ue;const Re=De.length;if(Re===0||ue.length===0)return ue;let Ne=0;for(;ue.indexOf(De,Ne)===Ne;)Ne=Ne+Re;return ue.substring(Ne)}e.ltrim=p;function c(ue,De){if(!ue||!De)return ue;const Re=De.length,Ne=ue.length;if(Re===0||Ne===0)return ue;let Oe=Ne,ze=-1;for(;ze=ue.lastIndexOf(De,Oe-1),!(ze===-1||ze+Re!==Oe);){if(ze===0)return"";Oe=ze}return ue.substring(0,Oe)}e.rtrim=c;function h(ue){return ue.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=h;function g(ue){return ue.replace(/\*/g,"")}e.stripWildcards=g;function f(ue,De,Re={}){if(!ue)throw new Error("Cannot create regex from empty string");De||(ue=I(ue)),Re.wholeWord&&(/\B/.test(ue.charAt(0))||(ue="\\b"+ue),/\B/.test(ue.charAt(ue.length-1))||(ue=ue+"\\b"));let Ne="";return Re.global&&(Ne+="g"),Re.matchCase||(Ne+="i"),Re.multiline&&(Ne+="m"),Re.unicode&&(Ne+="u"),new RegExp(ue,Ne)}e.createRegExp=f;function D(ue){return ue.source==="^"||ue.source==="^$"||ue.source==="$"||ue.source==="^\\s*$"?!1:!!(ue.exec("")&&ue.lastIndex===0)}e.regExpLeadsToEndlessLoop=D;function R(ue){return!!ue.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=R;function t(ue){return(ue.global?"g":"")+(ue.ignoreCase?"i":"")+(ue.multiline?"m":"")+(ue.unicode?"u":"")}e.regExpFlags=t;function r(ue){return ue.split(/\r\n|\r|\n/)}e.splitLines=r;function i(ue){for(let De=0,Re=ue.length;De<Re;De++){const Ne=ue.charCodeAt(De);if(Ne!==32&&Ne!==9)return De}return-1}e.firstNonWhitespaceIndex=i;function n(ue,De=0,Re=ue.length){for(let Ne=De;Ne<Re;Ne++){const Oe=ue.charCodeAt(Ne);if(Oe!==32&&Oe!==9)return ue.substring(De,Ne)}return ue.substring(De,Re)}e.getLeadingWhitespace=n;function o(ue,De=ue.length-1){for(let Re=De;Re>=0;Re--){const Ne=ue.charCodeAt(Re);if(Ne!==32&&Ne!==9)return Re}return-1}e.lastNonWhitespaceIndex=o;function u(ue,De,Re){const Ne=[];let Oe=0;for(const ze of ue.matchAll(De)){if(Ne.push(ue.slice(Oe,ze.index)),ze.index===void 0)throw new Error("match.index should be defined");Oe=ze.index+ze[0].length,Ne.push(Re(ze[0],...ze.slice(1),ze.index,ue,ze.groups))}return Ne.push(ue.slice(Oe)),Promise.all(Ne).then(ze=>ze.join(""))}e.replaceAsync=u;function a(ue,De){return ue<De?-1:ue>De?1:0}e.compare=a;function s(ue,De,Re=0,Ne=ue.length,Oe=0,ze=De.length){for(;Re<Ne&&Oe<ze;Re++,Oe++){const Ge=ue.charCodeAt(Re),et=De.charCodeAt(Oe);if(Ge<et)return-1;if(Ge>et)return 1}const We=Ne-Re,qe=ze-Oe;return We<qe?-1:We>qe?1:0}e.compareSubstring=s;function C(ue,De){return L(ue,De,0,ue.length,0,De.length)}e.compareIgnoreCase=C;function L(ue,De,Re=0,Ne=ue.length,Oe=0,ze=De.length){for(;Re<Ne&&Oe<ze;Re++,Oe++){let Ge=ue.charCodeAt(Re),et=De.charCodeAt(Oe);if(Ge===et)continue;if(Ge>=128||et>=128)return s(ue.toLowerCase(),De.toLowerCase(),Re,Ne,Oe,ze);W(Ge)&&(Ge-=32),W(et)&&(et-=32);const Ye=Ge-et;if(Ye!==0)return Ye}const We=Ne-Re,qe=ze-Oe;return We<qe?-1:We>qe?1:0}e.compareSubstringIgnoreCase=L;function O(ue){return ue>=48&&ue<=57}e.isAsciiDigit=O;function W(ue){return ue>=97&&ue<=122}e.isLowerAsciiLetter=W;function X(ue){return ue>=65&&ue<=90}e.isUpperAsciiLetter=X;function se(ue,De){return ue.length===De.length&&L(ue,De)===0}e.equalsIgnoreCase=se;function fe(ue,De){const Re=De.length;return De.length>ue.length?!1:L(ue,De,0,Re)===0}e.startsWithIgnoreCase=fe;function ce(ue,De){const Re=Math.min(ue.length,De.length);let Ne;for(Ne=0;Ne<Re;Ne++)if(ue.charCodeAt(Ne)!==De.charCodeAt(Ne))return Ne;return Re}e.commonPrefixLength=ce;function V(ue,De){const Re=Math.min(ue.length,De.length);let Ne;const Oe=ue.length-1,ze=De.length-1;for(Ne=0;Ne<Re;Ne++)if(ue.charCodeAt(Oe-Ne)!==De.charCodeAt(ze-Ne))return Ne;return Re}e.commonSuffixLength=V;function T(ue){return 55296<=ue&&ue<=56319}e.isHighSurrogate=T;function z(ue){return 56320<=ue&&ue<=57343}e.isLowSurrogate=z;function he(ue,De){return(ue-55296<<10)+(De-56320)+65536}e.computeCodePoint=he;function H(ue,De,Re){const Ne=ue.charCodeAt(Re);if(T(Ne)&&Re+1<De){const Oe=ue.charCodeAt(Re+1);if(z(Oe))return he(Ne,Oe)}return Ne}e.getNextCodePoint=H;function q(ue,De){const Re=ue.charCodeAt(De-1);if(z(Re)&&De>1){const Ne=ue.charCodeAt(De-2);if(T(Ne))return he(Ne,Re)}return Re}class M{get offset(){return this.e}constructor(De,Re=0){this.c=De,this.d=De.length,this.e=Re}setOffset(De){this.e=De}prevCodePoint(){const De=q(this.c,this.e);return this.e-=De>=65536?2:1,De}nextCodePoint(){const De=H(this.c,this.d,this.e);return this.e+=De>=65536?2:1,De}eol(){return this.e>=this.d}}e.CodePointIterator=M;class ee{get offset(){return this.c.offset}constructor(De,Re=0){this.c=new M(De,Re)}nextGraphemeLength(){const De=Fe.getInstance(),Re=this.c,Ne=Re.offset;let Oe=De.getGraphemeBreakType(Re.nextCodePoint());for(;!Re.eol();){const ze=Re.offset,We=De.getGraphemeBreakType(Re.nextCodePoint());if(we(Oe,We)){Re.setOffset(ze);break}Oe=We}return Re.offset-Ne}prevGraphemeLength(){const De=Fe.getInstance(),Re=this.c,Ne=Re.offset;let Oe=De.getGraphemeBreakType(Re.prevCodePoint());for(;Re.offset>0;){const ze=Re.offset,We=De.getGraphemeBreakType(Re.prevCodePoint());if(we(We,Oe)){Re.setOffset(ze);break}Oe=We}return Ne-Re.offset}eol(){return this.c.eol()}}e.GraphemeIterator=ee;function ie(ue,De){return new ee(ue,De).nextGraphemeLength()}e.nextCharLength=ie;function me(ue,De){return new ee(ue,De).prevGraphemeLength()}e.prevCharLength=me;function ne(ue,De){De>0&&z(ue.charCodeAt(De))&&De--;const Re=De+ie(ue,De);return[Re-me(ue,Re),Re]}e.getCharContainingOffset=ne;function B(ue){const De=new ee(ue);let Re=0;for(;!De.eol();)Re++,De.nextGraphemeLength();return Re}e.charCount=B;let N;function U(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function G(ue){return N||(N=U()),N.test(ue)}e.containsRTL=G;const te=/^[\t\n\r\x20-\x7E]*$/;function le(ue){return te.test(ue)}e.isBasicASCII=le,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function j(ue){return e.UNUSUAL_LINE_TERMINATORS.test(ue)}e.containsUnusualLineTerminators=j;function K(ue){return ue>=11904&&ue<=55215||ue>=63744&&ue<=64255||ue>=65281&&ue<=65374}e.isFullWidthCharacter=K;function Q(ue){return ue>=127462&&ue<=127487||ue===8986||ue===8987||ue===9200||ue===9203||ue>=9728&&ue<=10175||ue===11088||ue===11093||ue>=127744&&ue<=128591||ue>=128640&&ue<=128764||ue>=128992&&ue<=129008||ue>=129280&&ue<=129535||ue>=129648&&ue<=129782}e.isEmojiImprecise=Q;function x(ue,De){if(ue.length<De)return ue;const Re=/\b/g;let Ne=0;for(;Re.test(ue)&&!(ue.length-Re.lastIndex<De);)Ne=Re.lastIndex,Re.lastIndex+=1;return ue.substring(Ne).replace(/^\s/,"")}e.lcut=x;const _=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g;function Y(ue){return ue&&(ue=ue.replace(_,"")),ue}e.removeAnsiEscapeCodes=Y,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Z(ue){return!!(ue&&ue.length>0&&ue.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Z;function ae(ue){return Z(ue)?ue.substr(1):ue}e.stripUTF8BOM=ae;function ve(ue,De){if(!ue||!De||ue.length<De.length)return!1;const Re=De.length,Ne=ue.toLowerCase();let Oe=0,ze=-1;for(;Oe<Re;){const We=Ne.indexOf(De[Oe],ze+1);if(We<0)return!1;ze=We,Oe++}return!0}e.fuzzyContains=ve;function Pe(ue,De=!1){return ue?(De&&(ue=ue.replace(/\\./g,"")),ue.toLowerCase()!==ue):!1}e.containsUppercaseCharacter=Pe;function ke(ue){return ue.charAt(0).toUpperCase()+ue.slice(1)}e.uppercaseFirstLetter=ke;function Me(ue,De=1){if(De===0)return"";let Re=-1;do Re=ue.indexOf(`
`,Re+1),De--;while(De>0&&Re>=0);return Re===-1?ue:(ue[Re-1]==="\r"&&Re--,ue.substr(0,Re))}e.getNLines=Me;function je(ue){return ue=ue%(2*26),ue<26?String.fromCharCode(97+ue):String.fromCharCode(65+ue-26)}e.singleLetterHash=je;function ge(ue){return Fe.getInstance().getGraphemeBreakType(ue)}e.getGraphemeBreakType=ge;function we(ue,De){return ue===0?De!==5&&De!==7:ue===2&&De===3?!1:ue===4||ue===2||ue===3||De===4||De===2||De===3?!0:!(ue===8&&(De===8||De===9||De===11||De===12)||(ue===11||ue===9)&&(De===9||De===10)||(ue===12||ue===10)&&De===10||De===5||De===13||De===7||ue===1||ue===13&&De===14||ue===6&&De===6)}var ye;(function(ue){ue[ue.Other=0]="Other",ue[ue.Prepend=1]="Prepend",ue[ue.CR=2]="CR",ue[ue.LF=3]="LF",ue[ue.Control=4]="Control",ue[ue.Extend=5]="Extend",ue[ue.Regional_Indicator=6]="Regional_Indicator",ue[ue.SpacingMark=7]="SpacingMark",ue[ue.L=8]="L",ue[ue.V=9]="V",ue[ue.T=10]="T",ue[ue.LV=11]="LV",ue[ue.LVT=12]="LVT",ue[ue.ZWJ=13]="ZWJ",ue[ue.Extended_Pictographic=14]="Extended_Pictographic"})(ye=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Fe{static getInstance(){return Fe.c||(Fe.c=new Fe),Fe.c}constructor(){this.d=$e()}getGraphemeBreakType(De){if(De<32)return De===10?3:De===13?2:4;if(De<127)return 0;const Re=this.d,Ne=Re.length/3;let Oe=1;for(;Oe<=Ne;)if(De<Re[3*Oe])Oe=2*Oe;else if(De>Re[3*Oe+1])Oe=2*Oe+1;else return Re[3*Oe+2];return 0}}Fe.c=null;function $e(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function tt(ue,De){if(ue===0)return 0;const Re=Ve(ue,De);if(Re!==void 0)return Re;const Ne=new M(De,ue);return Ne.prevCodePoint(),Ne.offset}e.getLeftDeleteOffset=tt;function Ve(ue,De){const Re=new M(De,ue);let Ne=Re.prevCodePoint();for(;Je(Ne)||Ne===65039||Ne===8419;){if(Re.offset===0)return;Ne=Re.prevCodePoint()}if(!Q(Ne))return;let Oe=Re.offset;return Oe>0&&Re.prevCodePoint()===8205&&(Oe=Re.offset),Oe}function Je(ue){return 127995<=ue&&ue<=127999}var Xe;(function(ue){ue[ue.zwj=8205]="zwj",ue[ue.emojiVariantSelector=65039]="emojiVariantSelector",ue[ue.enclosingKeyCap=8419]="enclosingKeyCap"})(Xe||(Xe={})),e.noBreakWhitespace="\xA0";class _e{static getInstance(De){return _e.d.get(Array.from(De))}static getLocales(){return _e.e.value}constructor(De){this.f=De}isAmbiguous(De){return this.f.has(De)}getPrimaryConfusable(De){return this.f.get(De)}getConfusableCodePoints(){return new Set(this.f.keys())}}l=_e,_e.c=new A.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),_e.d=new E.LRUCachedFunction(ue=>{function De(et){const Ye=new Map;for(let Qe=0;Qe<et.length;Qe+=2)Ye.set(et[Qe],et[Qe+1]);return Ye}function Re(et,Ye){const Qe=new Map(et);for(const[ot,rt]of Ye)Qe.set(ot,rt);return Qe}function Ne(et,Ye){if(!et)return Ye;const Qe=new Map;for(const[ot,rt]of et)Ye.has(ot)&&Qe.set(ot,rt);return Qe}const Oe=l.c.value;let ze=ue.filter(et=>!et.startsWith("_")&&et in Oe);ze.length===0&&(ze=["_default"]);let We;for(const et of ze){const Ye=De(Oe[et]);We=Ne(We,Ye)}const qe=De(Oe._common),Ge=Re(qe,We);return new _e(Ge)}),_e.e=new A.Lazy(()=>Object.keys(_e.c.value).filter(ue=>!ue.startsWith("_"))),e.AmbiguousCharacters=_e;class Ke{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(Ke.c())),this.d}static isInvisibleCharacter(De){return Ke.e().has(De)}static get codePoints(){return Ke.e()}}Ke.d=void 0,e.InvisibleCharacters=Ke}),define(be[146],Ee([1,0,27,17]),function(oe,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function l(...Y){return function(Z,ae){for(let ve=0,Pe=Y.length;ve<Pe;ve++){const ke=Y[ve](Z,ae);if(ke)return ke}return null}}e.or=l,e.matchesStrictPrefix=w.bind(void 0,!1),e.matchesPrefix=w.bind(void 0,!0);function w(Y,Z,ae){if(!ae||ae.length<Z.length)return null;let ve;return Y?ve=A.startsWithIgnoreCase(ae,Z):ve=ae.indexOf(Z)===0,ve?Z.length>0?[{start:0,end:Z.length}]:[]:null}function S(Y,Z){const ae=Z.toLowerCase().indexOf(Y.toLowerCase());return ae===-1?null:[{start:ae,end:ae+Y.length}]}e.matchesContiguousSubString=S;function P(Y,Z){return y(Y.toLowerCase(),Z.toLowerCase(),0,0)}e.matchesSubString=P;function y(Y,Z,ae,ve){if(ae===Y.length)return[];if(ve===Z.length)return null;if(Y[ae]===Z[ve]){let Pe=null;return(Pe=y(Y,Z,ae+1,ve+1))?h({start:ve,end:ve+1},Pe):null}return y(Y,Z,ae,ve+1)}function b(Y){return 97<=Y&&Y<=122}function k(Y){return 65<=Y&&Y<=90}e.isUpper=k;function I(Y){return 48<=Y&&Y<=57}function v(Y){return Y===32||Y===9||Y===10||Y===13}const d=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(Y=>d.add(Y.charCodeAt(0)));function m(Y){return v(Y)||d.has(Y)}function p(Y,Z){return Y===Z||m(Y)&&m(Z)}function c(Y){return b(Y)||k(Y)||I(Y)}function h(Y,Z){return Z.length===0?Z=[Y]:Y.end===Z[0].start?Z[0].start=Y.start:Z.unshift(Y),Z}function g(Y,Z){for(let ae=Z;ae<Y.length;ae++){const ve=Y.charCodeAt(ae);if(k(ve)||I(ve)||ae>0&&!c(Y.charCodeAt(ae-1)))return ae}return Y.length}function f(Y,Z,ae,ve){if(ae===Y.length)return[];if(ve===Z.length)return null;if(Y[ae]!==Z[ve].toLowerCase())return null;{let Pe=null,ke=ve+1;for(Pe=f(Y,Z,ae+1,ve+1);!Pe&&(ke=g(Z,ke))<Z.length;)Pe=f(Y,Z,ae+1,ke),ke++;return Pe===null?null:h({start:ve,end:ve+1},Pe)}}function D(Y){let Z=0,ae=0,ve=0,Pe=0,ke=0;for(let ye=0;ye<Y.length;ye++)ke=Y.charCodeAt(ye),k(ke)&&Z++,b(ke)&&ae++,c(ke)&&ve++,I(ke)&&Pe++;const Me=Z/Y.length,je=ae/Y.length,ge=ve/Y.length,we=Pe/Y.length;return{upperPercent:Me,lowerPercent:je,alphaPercent:ge,numericPercent:we}}function R(Y){const{upperPercent:Z,lowerPercent:ae}=Y;return ae===0&&Z>.6}function t(Y){const{upperPercent:Z,lowerPercent:ae,alphaPercent:ve,numericPercent:Pe}=Y;return ae>.2&&Z<.8&&ve>.6&&Pe<.2}function r(Y){let Z=0,ae=0,ve=0,Pe=0;for(let ke=0;ke<Y.length;ke++)ve=Y.charCodeAt(ke),k(ve)&&Z++,b(ve)&&ae++,v(ve)&&Pe++;return(Z===0||ae===0)&&Pe===0?Y.length<=30:Z<=5}function i(Y,Z){if(!Z||(Z=Z.trim(),Z.length===0)||!r(Y)||Z.length>60)return null;const ae=D(Z);if(!t(ae)){if(!R(ae))return null;Z=Z.toLowerCase()}let ve=null,Pe=0;for(Y=Y.toLowerCase();Pe<Z.length&&(ve=f(Y,Z,0,Pe))===null;)Pe=g(Z,Pe+1);return ve}e.matchesCamelCase=i;function n(Y,Z,ae=!1){if(!Z||Z.length===0)return null;let ve=null,Pe=0;for(Y=Y.toLowerCase(),Z=Z.toLowerCase();Pe<Z.length&&(ve=o(Y,Z,0,Pe,ae))===null;)Pe=u(Z,Pe+1);return ve}e.matchesWords=n;function o(Y,Z,ae,ve,Pe){if(ae===Y.length)return[];if(ve===Z.length)return null;if(p(Y.charCodeAt(ae),Z.charCodeAt(ve))){let ke=null,Me=ve+1;if(ke=o(Y,Z,ae+1,ve+1,Pe),!Pe)for(;!ke&&(Me=u(Z,Me))<Z.length;)ke=o(Y,Z,ae+1,Me,Pe),Me++;return ke?Y.charCodeAt(ae)!==Z.charCodeAt(ve)?ke:h({start:ve,end:ve+1},ke):null}else return null}function u(Y,Z){for(let ae=Z;ae<Y.length;ae++)if(m(Y.charCodeAt(ae))||ae>0&&m(Y.charCodeAt(ae-1)))return ae;return Y.length}const a=l(e.matchesPrefix,i,S),s=l(e.matchesPrefix,i,P),C=new E.LRUCache(1e4);function L(Y,Z,ae=!1){if(typeof Y!="string"||typeof Z!="string")return null;let ve=C.get(Y);ve||(ve=new RegExp(A.convertSimple2RegExpPattern(Y),"i"),C.set(Y,ve));const Pe=ve.exec(Z);return Pe?[{start:Pe.index,end:Pe.index+Pe[0].length}]:ae?s(Y,Z):a(Y,Z)}e.matchesFuzzy=L;function O(Y,Z){const ae=te(Y,Y.toLowerCase(),0,Z,Z.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return ae?X(ae):null}e.matchesFuzzy2=O;function W(Y,Z,ae,ve,Pe,ke){const Me=Math.min(13,Y.length);for(;ae<Me;ae++){const je=te(Y,Z,ae,ve,Pe,ke,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(je)return je}return[0,ke]}e.anyScore=W;function X(Y){if(typeof Y>"u")return[];const Z=[],ae=Y[1];for(let ve=Y.length-1;ve>1;ve--){const Pe=Y[ve]+ae,ke=Z[Z.length-1];ke&&ke.end===Pe?ke.end=Pe+1:Z.push({start:Pe,end:Pe+1})}return Z}e.createMatches=X;const se=128;function fe(){const Y=[],Z=[];for(let ae=0;ae<=se;ae++)Z[ae]=0;for(let ae=0;ae<=se;ae++)Y.push(Z.slice(0));return Y}function ce(Y){const Z=[];for(let ae=0;ae<=Y;ae++)Z[ae]=0;return Z}const V=ce(2*se),T=ce(2*se),z=fe(),he=fe(),H=fe(),q=!1;function M(Y,Z,ae,ve,Pe){function ke(je,ge,we=" "){for(;je.length<ge;)je=we+je;return je}let Me=` |   |${ve.split("").map(je=>ke(je,3)).join("|")}
`;for(let je=0;je<=ae;je++)je===0?Me+=" |":Me+=`${Z[je-1]}|`,Me+=Y[je].slice(0,Pe+1).map(ge=>ke(ge.toString(),3)).join("|")+`
`;return Me}function ee(Y,Z,ae,ve){Y=Y.substr(Z),ae=ae.substr(ve),console.log(M(he,Y,Y.length,ae,ae.length)),console.log(M(H,Y,Y.length,ae,ae.length)),console.log(M(z,Y,Y.length,ae,ae.length))}function ie(Y,Z){if(Z<0||Z>=Y.length)return!1;const ae=Y.codePointAt(Z);switch(ae){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!A.isEmojiImprecise(ae)}}function me(Y,Z){if(Z<0||Z>=Y.length)return!1;switch(Y.charCodeAt(Z)){case 32:case 9:return!0;default:return!1}}function ne(Y,Z,ae){return Z[Y]!==ae[Y]}function B(Y,Z,ae,ve,Pe,ke,Me=!1){for(;Z<ae&&Pe<ke;)Y[Z]===ve[Pe]&&(Me&&(V[Z]=Pe),Z+=1),Pe+=1;return Z===ae}e.isPatternInWord=B;var N;(function(Y){Y[Y.Diag=1]="Diag",Y[Y.Left=2]="Left",Y[Y.LeftLeft=3]="LeftLeft"})(N||(N={}));var U;(function(Y){Y.Default=[-100,0];function Z(ae){return!ae||ae.length===2&&ae[0]===-100&&ae[1]===0}Y.isDefault=Z})(U=e.FuzzyScore||(e.FuzzyScore={}));class G{constructor(Z,ae){this.firstMatchCanBeWeak=Z,this.boostFullMatch=ae}}G.default={boostFullMatch:!0,firstMatchCanBeWeak:!1},e.FuzzyScoreOptions=G;function te(Y,Z,ae,ve,Pe,ke,Me=G.default){const je=Y.length>se?se:Y.length,ge=ve.length>se?se:ve.length;if(ae>=je||ke>=ge||je-ae>ge-ke||!B(Z,ae,je,Pe,ke,ge,!0))return;le(je,ge,ae,ke,Z,Pe);let we=1,ye=1,Fe=ae,$e=ke;const tt=[!1];for(we=1,Fe=ae;Fe<je;we++,Fe++){const Ke=V[Fe],ue=T[Fe],De=Fe+1<je?T[Fe+1]:ge;for(ye=Ke-ke+1,$e=Ke;$e<De;ye++,$e++){let Re=Number.MIN_SAFE_INTEGER,Ne=!1;$e<=ue&&(Re=j(Y,Z,Fe,ae,ve,Pe,$e,ge,ke,z[we-1][ye-1]===0,tt));let Oe=0;Re!==Number.MAX_SAFE_INTEGER&&(Ne=!0,Oe=Re+he[we-1][ye-1]);const ze=$e>Ke,We=ze?he[we][ye-1]+(z[we][ye-1]>0?-5:0):0,qe=$e>Ke+1&&z[we][ye-1]>0,Ge=qe?he[we][ye-2]+(z[we][ye-2]>0?-5:0):0;if(qe&&(!ze||Ge>=We)&&(!Ne||Ge>=Oe))he[we][ye]=Ge,H[we][ye]=3,z[we][ye]=0;else if(ze&&(!Ne||We>=Oe))he[we][ye]=We,H[we][ye]=2,z[we][ye]=0;else if(Ne)he[we][ye]=Oe,H[we][ye]=1,z[we][ye]=z[we-1][ye-1]+1;else throw new Error("not possible")}}if(q&&ee(Y,ae,ve,ke),!tt[0]&&!Me.firstMatchCanBeWeak)return;we--,ye--;const Ve=[he[we][ye],ke];let Je=0,Xe=0;for(;we>=1;){let Ke=ye;do{const ue=H[we][Ke];if(ue===3)Ke=Ke-2;else if(ue===2)Ke=Ke-1;else break}while(Ke>=1);Je>1&&Z[ae+we-1]===Pe[ke+ye-1]&&!ne(Ke+ke-1,ve,Pe)&&Je+1>z[we][Ke]&&(Ke=ye),Ke===ye?Je++:Je=1,Xe||(Xe=Ke),we--,ye=Ke-1,Ve.push(ye)}ge===je&&Me.boostFullMatch&&(Ve[0]+=2);const _e=Xe-je;return Ve[0]-=_e,Ve}e.fuzzyScore=te;function le(Y,Z,ae,ve,Pe,ke){let Me=Y-1,je=Z-1;for(;Me>=ae&&je>=ve;)Pe[Me]===ke[je]&&(T[Me]=je,Me--),je--}function j(Y,Z,ae,ve,Pe,ke,Me,je,ge,we,ye){if(Z[ae]!==ke[Me])return Number.MIN_SAFE_INTEGER;let Fe=1,$e=!1;return Me===ae-ve?Fe=Y[ae]===Pe[Me]?7:5:ne(Me,Pe,ke)&&(Me===0||!ne(Me-1,Pe,ke))?(Fe=Y[ae]===Pe[Me]?7:5,$e=!0):ie(ke,Me)&&(Me===0||!ie(ke,Me-1))?Fe=5:(ie(ke,Me-1)||me(ke,Me-1))&&(Fe=5,$e=!0),Fe>1&&ae===ve&&(ye[0]=!0),$e||($e=ne(Me,Pe,ke)||ie(ke,Me-1)||me(ke,Me-1)),ae===ve?Me>ge&&(Fe-=$e?3:5):we?Fe+=$e?2:0:Fe+=$e?0:1,Me+1===je&&(Fe-=$e?3:5),Fe}function K(Y,Z,ae,ve,Pe,ke,Me){return x(Y,Z,ae,ve,Pe,ke,!0,Me)}e.fuzzyScoreGracefulAggressive=K;function Q(Y,Z,ae,ve,Pe,ke,Me){return x(Y,Z,ae,ve,Pe,ke,!1,Me)}e.fuzzyScoreGraceful=Q;function x(Y,Z,ae,ve,Pe,ke,Me,je){let ge=te(Y,Z,ae,ve,Pe,ke,je);if(ge&&!Me)return ge;if(Y.length>=3){const we=Math.min(7,Y.length-1);for(let ye=ae+1;ye<we;ye++){const Fe=_(Y,ye);if(Fe){const $e=te(Fe,Fe.toLowerCase(),ae,ve,Pe,ke,je);$e&&($e[0]-=3,(!ge||$e[0]>ge[0])&&(ge=$e))}}}return ge}function _(Y,Z){if(Z+1>=Y.length)return;const ae=Y[Z],ve=Y[Z+1];if(ae!==ve)return Y.slice(0,Z)+ve+ae+Y.slice(Z+2)}}),define(be[92],Ee([1,0,17]),function(oe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function A(h){return l(h,0)}e.hash=A;function l(h,g){switch(typeof h){case"object":return h===null?w(349,g):Array.isArray(h)?y(h,g):b(h,g);case"string":return P(h,g);case"boolean":return S(h,g);case"number":return w(h,g);case"undefined":return w(937,g);default:return w(617,g)}}e.doHash=l;function w(h,g){return(g<<5)-g+h|0}e.numberHash=w;function S(h,g){return w(h?433:863,g)}function P(h,g){g=w(149417,g);for(let f=0,D=h.length;f<D;f++)g=w(h.charCodeAt(f),g);return g}e.stringHash=P;function y(h,g){return g=w(104579,g),h.reduce((f,D)=>l(D,f),g)}function b(h,g){return g=w(181387,g),Object.keys(h).sort().reduce((f,D)=>(f=P(D,f),l(h[D],f)),g)}class k{constructor(){this.g=0}get value(){return this.g}hash(g){return this.g=l(g,this.g),this.g}}e.Hasher=k;var I;(function(h){h[h.BLOCK_SIZE=64]="BLOCK_SIZE",h[h.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function v(h,g,f=32){const D=f-g,R=~((1<<D)-1);return(h<<g|(R&h)>>>D)>>>0}function d(h,g=0,f=h.byteLength,D=0){for(let R=0;R<f;R++)h[g+R]=D}function m(h,g,f="0"){for(;h.length<g;)h=f+h;return h}function p(h,g=32){return h instanceof ArrayBuffer?Array.from(new Uint8Array(h)).map(f=>f.toString(16).padStart(2,"0")).join(""):m((h>>>0).toString(16),g/4)}e.toHexString=p;class c{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(g){const f=g.length;if(f===0)return;const D=this.p;let R=this.r,t=this.u,r,i;for(t!==0?(r=t,i=-1,t=0):(r=g.charCodeAt(0),i=0);;){let n=r;if(E.isHighSurrogate(r))if(i+1<f){const o=g.charCodeAt(i+1);E.isLowSurrogate(o)?(i++,n=E.computeCodePoint(r,o)):n=65533}else{t=r;break}else E.isLowSurrogate(r)&&(n=65533);if(R=this.w(D,R,n),i++,i<f)r=g.charCodeAt(i);else break}this.r=R,this.u=t}w(g,f,D){return D<128?g[f++]=D:D<2048?(g[f++]=192|(D&1984)>>>6,g[f++]=128|(D&63)>>>0):D<65536?(g[f++]=224|(D&61440)>>>12,g[f++]=128|(D&4032)>>>6,g[f++]=128|(D&63)>>>0):(g[f++]=240|(D&1835008)>>>18,g[f++]=128|(D&258048)>>>12,g[f++]=128|(D&4032)>>>6,g[f++]=128|(D&63)>>>0),f>=64&&(this.y(),f-=64,this.t+=64,g[0]=g[64+0],g[1]=g[64+1],g[2]=g[64+2]),f}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),p(this.h)+p(this.l)+p(this.m)+p(this.n)+p(this.o)}x(){this.p[this.r++]=128,d(this.p,this.r),this.r>56&&(this.y(),d(this.p));const g=8*this.t;this.q.setUint32(56,Math.floor(g/4294967296),!1),this.q.setUint32(60,g%4294967296,!1),this.y()}y(){const g=c.g,f=this.q;for(let a=0;a<64;a+=4)g.setUint32(a,f.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)g.setUint32(a,v(g.getUint32(a-12,!1)^g.getUint32(a-32,!1)^g.getUint32(a-56,!1)^g.getUint32(a-64,!1),1),!1);let D=this.h,R=this.l,t=this.m,r=this.n,i=this.o,n,o,u;for(let a=0;a<80;a++)a<20?(n=R&t|~R&r,o=1518500249):a<40?(n=R^t^r,o=1859775393):a<60?(n=R&t|R&r|t&r,o=2400959708):(n=R^t^r,o=3395469782),u=v(D,5)+n+i+o+g.getUint32(a*4,!1)&4294967295,i=r,r=t,t=v(R,30),R=D,D=u;this.h=this.h+D&4294967295,this.l=this.l+R&4294967295,this.m=this.m+t&4294967295,this.n=this.n+r&4294967295,this.o=this.o+i&4294967295}}c.g=new DataView(new ArrayBuffer(320)),e.StringSHA1=c}),define(be[59],Ee([1,0,17]),function(oe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var A;(function(l){l[l.Ignore=0]="Ignore",l[l.Info=1]="Info",l[l.Warning=2]="Warning",l[l.Error=3]="Error"})(A||(A={})),function(l){const w="error",S="warning",P="warn",y="info",b="ignore";function k(v){return v?E.equalsIgnoreCase(w,v)?l.Error:E.equalsIgnoreCase(S,v)||E.equalsIgnoreCase(P,v)?l.Warning:E.equalsIgnoreCase(y,v)?l.Info:l.Ignore:l.Ignore}l.fromValue=k;function I(v){switch(v){case l.Error:return w;case l.Warning:return S;case l.Info:return y;default:return b}}l.toString=I}(A||(A={})),e.default=A}),define(be[147],Ee([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(be[60],Ee([1,0,18,17]),function(oe,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class l{constructor(){this.b="",this.c=0}reset(d){return this.b=d,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(d){const m=d.charCodeAt(0),p=this.b.charCodeAt(this.c);return m-p}value(){return this.b[this.c]}}e.StringIterator=l;class w{constructor(d=!0){this.e=d}reset(d){return this.b=d,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let d=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(d)this.c++;else break;else d=!1;return this}cmp(d){return this.e?(0,A.compareSubstring)(d,this.b,0,d.length,this.c,this.d):(0,A.compareSubstringIgnoreCase)(d,this.b,0,d.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=w;class S{constructor(d=!0,m=!0){this.f=d,this.g=m}reset(d){this.d=0,this.e=0,this.b=d,this.c=d.length;for(let m=d.length-1;m>=0;m--,this.c--){const p=this.b.charCodeAt(m);if(!(p===47||this.f&&p===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let d=!0;for(;this.e<this.c;this.e++){const m=this.b.charCodeAt(this.e);if(m===47||this.f&&m===92)if(d)this.d++;else break;else d=!1}return this}cmp(d){return this.g?(0,A.compareSubstring)(d,this.b,0,d.length,this.d,this.e):(0,A.compareSubstringIgnoreCase)(d,this.b,0,d.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=S;var P;(function(v){v[v.Scheme=1]="Scheme",v[v.Authority=2]="Authority",v[v.Path=3]="Path",v[v.Query=4]="Query",v[v.Fragment=5]="Fragment"})(P||(P={}));class y{constructor(d,m){this.f=d,this.g=m,this.d=[],this.e=0}reset(d){return this.c=d,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new S(!1,!this.f(d)),this.b.reset(d.path),this.b.value()&&this.d.push(3)),this.g(d)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(d){if(this.d[this.e]===1)return(0,A.compareIgnoreCase)(d,this.c.scheme);if(this.d[this.e]===2)return(0,A.compareIgnoreCase)(d,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(d);if(this.d[this.e]===4)return(0,A.compare)(d,this.c.query);if(this.d[this.e]===5)return(0,A.compare)(d,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=y;class b{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const d=this.right;return this.right=d.left,d.left=this,this.updateHeight(),d.updateHeight(),d}rotateRight(){const d=this.left;return this.left=d.right,d.right=this,this.updateHeight(),d.updateHeight(),d}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var k;(function(v){v[v.Left=-1]="Left",v[v.Mid=0]="Mid",v[v.Right=1]="Right"})(k||(k={}));class I{static forUris(d=()=>!1,m=()=>!1){return new I(new y(d,m))}static forPaths(d=!1){return new I(new S(void 0,!d))}static forStrings(){return new I(new l)}static forConfigKeys(){return new I(new w)}constructor(d){this.b=d}clear(){this.c=void 0}fill(d,m){if(m){const p=m.slice(0);(0,E.shuffle)(p);for(const c of p)this.set(c,d)}else{const p=d.slice(0);(0,E.shuffle)(p);for(const c of p)this.set(c[0],c[1])}}set(d,m){const p=this.b.reset(d);let c;this.c||(this.c=new b,this.c.segment=p.value());const h=[];for(c=this.c;;){const f=p.cmp(c.segment);if(f>0)c.left||(c.left=new b,c.left.segment=p.value()),h.push([-1,c]),c=c.left;else if(f<0)c.right||(c.right=new b,c.right.segment=p.value()),h.push([1,c]),c=c.right;else if(p.hasNext())p.next(),c.mid||(c.mid=new b,c.mid.segment=p.value()),h.push([0,c]),c=c.mid;else break}const g=c.value;c.value=m,c.key=d;for(let f=h.length-1;f>=0;f--){const D=h[f][1];D.updateHeight();const R=D.balanceFactor();if(R<-1||R>1){const t=h[f][0],r=h[f+1][0];if(t===1&&r===1)h[f][1]=D.rotateLeft();else if(t===-1&&r===-1)h[f][1]=D.rotateRight();else if(t===1&&r===-1)D.right=h[f+1][1]=h[f+1][1].rotateRight(),h[f][1]=D.rotateLeft();else if(t===-1&&r===1)D.left=h[f+1][1]=h[f+1][1].rotateLeft(),h[f][1]=D.rotateRight();else throw new Error;if(f>0)switch(h[f-1][0]){case-1:h[f-1][1].left=h[f][1];break;case 1:h[f-1][1].right=h[f][1];break;case 0:h[f-1][1].mid=h[f][1];break}else this.c=h[0][1]}}return g}get(d){return this.d(d)?.value}d(d){const m=this.b.reset(d);let p=this.c;for(;p;){const c=m.cmp(p.segment);if(c>0)p=p.left;else if(c<0)p=p.right;else if(m.hasNext())m.next(),p=p.mid;else break}return p}has(d){const m=this.d(d);return!(m?.value===void 0&&m?.mid===void 0)}delete(d){return this.e(d,!1)}deleteSuperstr(d){return this.e(d,!0)}e(d,m){const p=this.b.reset(d),c=[];let h=this.c;for(;h;){const g=p.cmp(h.segment);if(g>0)c.push([-1,h]),h=h.left;else if(g<0)c.push([1,h]),h=h.right;else if(p.hasNext())p.next(),c.push([0,h]),h=h.mid;else break}if(!!h){if(m?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const g=this.f(h.right);if(g.key){const{key:f,value:D,segment:R}=g;this.e(g.key,!1),h.key=f,h.value=D,h.segment=R}}else{const g=h.left??h.right;if(c.length>0){const[f,D]=c[c.length-1];switch(f){case-1:D.left=g;break;case 0:D.mid=g;break;case 1:D.right=g;break}}else this.c=g}for(let g=c.length-1;g>=0;g--){const f=c[g][1];f.updateHeight();const D=f.balanceFactor();if(D>1?(f.right.balanceFactor()>=0||(f.right=f.right.rotateRight()),c[g][1]=f.rotateLeft()):D<-1&&(f.left.balanceFactor()<=0||(f.left=f.left.rotateLeft()),c[g][1]=f.rotateRight()),g>0)switch(c[g-1][0]){case-1:c[g-1][1].left=c[g][1];break;case 1:c[g-1][1].right=c[g][1];break;case 0:c[g-1][1].mid=c[g][1];break}else this.c=c[0][1]}}}f(d){for(;d.left;)d=d.left;return d}findSubstr(d){const m=this.b.reset(d);let p=this.c,c;for(;p;){const h=m.cmp(p.segment);if(h>0)p=p.left;else if(h<0)p=p.right;else if(m.hasNext())m.next(),c=p.value||c,p=p.mid;else break}return p&&p.value||c}findSuperstr(d){return this.g(d,!1)}g(d,m){const p=this.b.reset(d);let c=this.c;for(;c;){const h=p.cmp(c.segment);if(h>0)c=c.left;else if(h<0)c=c.right;else if(p.hasNext())p.next(),c=c.mid;else return c.mid?this.h(c.mid):m?c.value:void 0}}hasElementOrSubtree(d){return this.g(d,!0)!==void 0}forEach(d){for(const[m,p]of this)d(p,m)}*[Symbol.iterator](){yield*this.h(this.c)}h(d){const m=[];return this.j(d,m),m[Symbol.iterator]()}j(d,m){!d||(d.left&&this.j(d.left,m),d.value&&m.push([d.key,d.value]),d.mid&&this.j(d.mid,m),d.right&&this.j(d.right,m))}_isBalanced(){const d=m=>{if(!m)return!0;const p=m.balanceFactor();return p<-1||p>1?!1:d(m.left)&&d(m.right)};return d(this.c)}}e.TernarySearchTree=I}),define(be[8],Ee([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function E(r){return typeof r=="string"}e.isString=E;function A(r){return Array.isArray(r)&&r.every(i=>E(i))}e.isStringArray=A;function l(r){return typeof r=="object"&&r!==null&&!Array.isArray(r)&&!(r instanceof RegExp)&&!(r instanceof Date)}e.isObject=l;function w(r){const i=Object.getPrototypeOf(Uint8Array);return typeof r=="object"&&r instanceof i}e.isTypedArray=w;function S(r){return typeof r=="number"&&!isNaN(r)}e.isNumber=S;function P(r){return!!r&&typeof r[Symbol.iterator]=="function"}e.isIterable=P;function y(r){return r===!0||r===!1}e.isBoolean=y;function b(r){return typeof r>"u"}e.isUndefined=b;function k(r){return!I(r)}e.isDefined=k;function I(r){return b(r)||r===null}e.isUndefinedOrNull=I;function v(r,i){if(!r)throw new Error(i?`Unexpected type, expected '${i}'`:"Unexpected type")}e.assertType=v;function d(r){if(I(r))throw new Error("Assertion Failed: argument is undefined or null");return r}e.assertIsDefined=d;function m(...r){const i=[];for(let n=0;n<r.length;n++){const o=r[n];if(I(o))throw new Error(`Assertion Failed: argument at index ${n} is undefined or null`);i.push(o)}return i}e.assertAllDefined=m;const p=Object.prototype.hasOwnProperty;function c(r){if(!l(r))return!1;for(const i in r)if(p.call(r,i))return!1;return!0}e.isEmptyObject=c;function h(r){return typeof r=="function"}e.isFunction=h;function g(...r){return r.length>0&&r.every(h)}e.areFunctions=g;function f(r,i){const n=Math.min(r.length,i.length);for(let o=0;o<n;o++)D(r[o],i[o])}e.validateConstraints=f;function D(r,i){if(E(i)){if(typeof r!==i)throw new Error(`argument does not match constraint: typeof ${i}`)}else if(h(i)){try{if(r instanceof i)return}catch{}if(!I(r)&&r.constructor===i||i.length===1&&i.call(void 0,r)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=D;function R(r){return r===null?void 0:r}e.withNullAsUndefined=R;function t(r){return typeof r>"u"?null:r}e.withUndefinedAsNull=t}),define(be[46],Ee([1,0,8]),function(oe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.getAllCodicons=e.getCodiconFontCharacters=void 0;const A=Object.create(null);function l(P,y){if((0,E.isString)(y)){const b=A[y];if(b===void 0)throw new Error(`${P} references an unknown codicon: ${y}`);y=b}return A[P]=y,{id:P}}function w(){return A}e.getCodiconFontCharacters=w;function S(){return Object.values(e.Codicon)}e.getAllCodicons=S,e.Codicon={add:l("add",6e4),plus:l("plus",6e4),gistNew:l("gist-new",6e4),repoCreate:l("repo-create",6e4),lightbulb:l("lightbulb",60001),lightBulb:l("light-bulb",60001),repo:l("repo",60002),repoDelete:l("repo-delete",60002),gistFork:l("gist-fork",60003),repoForked:l("repo-forked",60003),gitPullRequest:l("git-pull-request",60004),gitPullRequestAbandoned:l("git-pull-request-abandoned",60004),recordKeys:l("record-keys",60005),keyboard:l("keyboard",60005),tag:l("tag",60006),tagAdd:l("tag-add",60006),tagRemove:l("tag-remove",60006),person:l("person",60007),personFollow:l("person-follow",60007),personOutline:l("person-outline",60007),personFilled:l("person-filled",60007),gitBranch:l("git-branch",60008),gitBranchCreate:l("git-branch-create",60008),gitBranchDelete:l("git-branch-delete",60008),sourceControl:l("source-control",60008),mirror:l("mirror",60009),mirrorPublic:l("mirror-public",60009),star:l("star",60010),starAdd:l("star-add",60010),starDelete:l("star-delete",60010),starEmpty:l("star-empty",60010),comment:l("comment",60011),commentAdd:l("comment-add",60011),alert:l("alert",60012),warning:l("warning",60012),search:l("search",60013),searchSave:l("search-save",60013),logOut:l("log-out",60014),signOut:l("sign-out",60014),logIn:l("log-in",60015),signIn:l("sign-in",60015),eye:l("eye",60016),eyeUnwatch:l("eye-unwatch",60016),eyeWatch:l("eye-watch",60016),circleFilled:l("circle-filled",60017),primitiveDot:l("primitive-dot",60017),closeDirty:l("close-dirty",60017),debugBreakpoint:l("debug-breakpoint",60017),debugBreakpointDisabled:l("debug-breakpoint-disabled",60017),debugHint:l("debug-hint",60017),primitiveSquare:l("primitive-square",60018),edit:l("edit",60019),pencil:l("pencil",60019),info:l("info",60020),issueOpened:l("issue-opened",60020),gistPrivate:l("gist-private",60021),gitForkPrivate:l("git-fork-private",60021),lock:l("lock",60021),mirrorPrivate:l("mirror-private",60021),close:l("close",60022),removeClose:l("remove-close",60022),x:l("x",60022),repoSync:l("repo-sync",60023),sync:l("sync",60023),clone:l("clone",60024),desktopDownload:l("desktop-download",60024),beaker:l("beaker",60025),microscope:l("microscope",60025),vm:l("vm",60026),deviceDesktop:l("device-desktop",60026),file:l("file",60027),fileText:l("file-text",60027),more:l("more",60028),ellipsis:l("ellipsis",60028),kebabHorizontal:l("kebab-horizontal",60028),mailReply:l("mail-reply",60029),reply:l("reply",60029),organization:l("organization",60030),organizationFilled:l("organization-filled",60030),organizationOutline:l("organization-outline",60030),newFile:l("new-file",60031),fileAdd:l("file-add",60031),newFolder:l("new-folder",60032),fileDirectoryCreate:l("file-directory-create",60032),trash:l("trash",60033),trashcan:l("trashcan",60033),history:l("history",60034),clock:l("clock",60034),folder:l("folder",60035),fileDirectory:l("file-directory",60035),symbolFolder:l("symbol-folder",60035),logoGithub:l("logo-github",60036),markGithub:l("mark-github",60036),github:l("github",60036),terminal:l("terminal",60037),console:l("console",60037),repl:l("repl",60037),zap:l("zap",60038),symbolEvent:l("symbol-event",60038),error:l("error",60039),stop:l("stop",60039),variable:l("variable",60040),symbolVariable:l("symbol-variable",60040),array:l("array",60042),symbolArray:l("symbol-array",60042),symbolModule:l("symbol-module",60043),symbolPackage:l("symbol-package",60043),symbolNamespace:l("symbol-namespace",60043),symbolObject:l("symbol-object",60043),symbolMethod:l("symbol-method",60044),symbolFunction:l("symbol-function",60044),symbolConstructor:l("symbol-constructor",60044),symbolBoolean:l("symbol-boolean",60047),symbolNull:l("symbol-null",60047),symbolNumeric:l("symbol-numeric",60048),symbolNumber:l("symbol-number",60048),symbolStructure:l("symbol-structure",60049),symbolStruct:l("symbol-struct",60049),symbolParameter:l("symbol-parameter",60050),symbolTypeParameter:l("symbol-type-parameter",60050),symbolKey:l("symbol-key",60051),symbolText:l("symbol-text",60051),symbolReference:l("symbol-reference",60052),goToFile:l("go-to-file",60052),symbolEnum:l("symbol-enum",60053),symbolValue:l("symbol-value",60053),symbolRuler:l("symbol-ruler",60054),symbolUnit:l("symbol-unit",60054),activateBreakpoints:l("activate-breakpoints",60055),archive:l("archive",60056),arrowBoth:l("arrow-both",60057),arrowDown:l("arrow-down",60058),arrowLeft:l("arrow-left",60059),arrowRight:l("arrow-right",60060),arrowSmallDown:l("arrow-small-down",60061),arrowSmallLeft:l("arrow-small-left",60062),arrowSmallRight:l("arrow-small-right",60063),arrowSmallUp:l("arrow-small-up",60064),arrowUp:l("arrow-up",60065),bell:l("bell",60066),bold:l("bold",60067),book:l("book",60068),bookmark:l("bookmark",60069),debugBreakpointConditionalUnverified:l("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:l("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:l("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:l("debug-breakpoint-data-unverified",60072),debugBreakpointData:l("debug-breakpoint-data",60073),debugBreakpointDataDisabled:l("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:l("debug-breakpoint-log-unverified",60074),debugBreakpointLog:l("debug-breakpoint-log",60075),debugBreakpointLogDisabled:l("debug-breakpoint-log-disabled",60075),briefcase:l("briefcase",60076),broadcast:l("broadcast",60077),browser:l("browser",60078),bug:l("bug",60079),calendar:l("calendar",60080),caseSensitive:l("case-sensitive",60081),check:l("check",60082),checklist:l("checklist",60083),chevronDown:l("chevron-down",60084),dropDownButton:l("drop-down-button",60084),chevronLeft:l("chevron-left",60085),chevronRight:l("chevron-right",60086),chevronUp:l("chevron-up",60087),chromeClose:l("chrome-close",60088),chromeMaximize:l("chrome-maximize",60089),chromeMinimize:l("chrome-minimize",60090),chromeRestore:l("chrome-restore",60091),circle:l("circle",60092),circleOutline:l("circle-outline",60092),debugBreakpointUnverified:l("debug-breakpoint-unverified",60092),circleSlash:l("circle-slash",60093),circuitBoard:l("circuit-board",60094),clearAll:l("clear-all",60095),clippy:l("clippy",60096),closeAll:l("close-all",60097),cloudDownload:l("cloud-download",60098),cloudUpload:l("cloud-upload",60099),code:l("code",60100),collapseAll:l("collapse-all",60101),colorMode:l("color-mode",60102),commentDiscussion:l("comment-discussion",60103),compareChanges:l("compare-changes",60157),creditCard:l("credit-card",60105),dash:l("dash",60108),dashboard:l("dashboard",60109),database:l("database",60110),debugContinue:l("debug-continue",60111),debugDisconnect:l("debug-disconnect",60112),debugPause:l("debug-pause",60113),debugRestart:l("debug-restart",60114),debugStart:l("debug-start",60115),debugStepInto:l("debug-step-into",60116),debugStepOut:l("debug-step-out",60117),debugStepOver:l("debug-step-over",60118),debugStop:l("debug-stop",60119),debug:l("debug",60120),deviceCameraVideo:l("device-camera-video",60121),deviceCamera:l("device-camera",60122),deviceMobile:l("device-mobile",60123),diffAdded:l("diff-added",60124),diffIgnored:l("diff-ignored",60125),diffModified:l("diff-modified",60126),diffRemoved:l("diff-removed",60127),diffRenamed:l("diff-renamed",60128),diff:l("diff",60129),discard:l("discard",60130),editorLayout:l("editor-layout",60131),emptyWindow:l("empty-window",60132),exclude:l("exclude",60133),extensions:l("extensions",60134),eyeClosed:l("eye-closed",60135),fileBinary:l("file-binary",60136),fileCode:l("file-code",60137),fileMedia:l("file-media",60138),filePdf:l("file-pdf",60139),fileSubmodule:l("file-submodule",60140),fileSymlinkDirectory:l("file-symlink-directory",60141),fileSymlinkFile:l("file-symlink-file",60142),fileZip:l("file-zip",60143),files:l("files",60144),filter:l("filter",60145),flame:l("flame",60146),foldDown:l("fold-down",60147),foldUp:l("fold-up",60148),fold:l("fold",60149),folderActive:l("folder-active",60150),folderOpened:l("folder-opened",60151),gear:l("gear",60152),gift:l("gift",60153),gistSecret:l("gist-secret",60154),gist:l("gist",60155),gitCommit:l("git-commit",60156),gitCompare:l("git-compare",60157),gitMerge:l("git-merge",60158),githubAction:l("github-action",60159),githubAlt:l("github-alt",60160),globe:l("globe",60161),grabber:l("grabber",60162),graph:l("graph",60163),gripper:l("gripper",60164),heart:l("heart",60165),home:l("home",60166),horizontalRule:l("horizontal-rule",60167),hubot:l("hubot",60168),inbox:l("inbox",60169),issueClosed:l("issue-closed",60324),issueReopened:l("issue-reopened",60171),issues:l("issues",60172),italic:l("italic",60173),jersey:l("jersey",60174),json:l("json",60175),bracket:l("bracket",60175),kebabVertical:l("kebab-vertical",60176),key:l("key",60177),law:l("law",60178),lightbulbAutofix:l("lightbulb-autofix",60179),linkExternal:l("link-external",60180),link:l("link",60181),listOrdered:l("list-ordered",60182),listUnordered:l("list-unordered",60183),liveShare:l("live-share",60184),loading:l("loading",60185),location:l("location",60186),mailRead:l("mail-read",60187),mail:l("mail",60188),markdown:l("markdown",60189),megaphone:l("megaphone",60190),mention:l("mention",60191),milestone:l("milestone",60192),mortarBoard:l("mortar-board",60193),move:l("move",60194),multipleWindows:l("multiple-windows",60195),mute:l("mute",60196),noNewline:l("no-newline",60197),note:l("note",60198),octoface:l("octoface",60199),openPreview:l("open-preview",60200),package_:l("package",60201),paintcan:l("paintcan",60202),pin:l("pin",60203),play:l("play",60204),run:l("run",60204),plug:l("plug",60205),preserveCase:l("preserve-case",60206),preview:l("preview",60207),project:l("project",60208),pulse:l("pulse",60209),question:l("question",60210),quote:l("quote",60211),radioTower:l("radio-tower",60212),reactions:l("reactions",60213),references:l("references",60214),refresh:l("refresh",60215),regex:l("regex",60216),remoteExplorer:l("remote-explorer",60217),remote:l("remote",60218),remove:l("remove",60219),replaceAll:l("replace-all",60220),replace:l("replace",60221),repoClone:l("repo-clone",60222),repoForcePush:l("repo-force-push",60223),repoPull:l("repo-pull",60224),repoPush:l("repo-push",60225),report:l("report",60226),requestChanges:l("request-changes",60227),rocket:l("rocket",60228),rootFolderOpened:l("root-folder-opened",60229),rootFolder:l("root-folder",60230),rss:l("rss",60231),ruby:l("ruby",60232),saveAll:l("save-all",60233),saveAs:l("save-as",60234),save:l("save",60235),screenFull:l("screen-full",60236),screenNormal:l("screen-normal",60237),searchStop:l("search-stop",60238),server:l("server",60240),settingsGear:l("settings-gear",60241),settings:l("settings",60242),shield:l("shield",60243),smiley:l("smiley",60244),sortPrecedence:l("sort-precedence",60245),splitHorizontal:l("split-horizontal",60246),splitVertical:l("split-vertical",60247),squirrel:l("squirrel",60248),starFull:l("star-full",60249),starHalf:l("star-half",60250),symbolClass:l("symbol-class",60251),symbolColor:l("symbol-color",60252),symbolCustomColor:l("symbol-customcolor",60252),symbolConstant:l("symbol-constant",60253),symbolEnumMember:l("symbol-enum-member",60254),symbolField:l("symbol-field",60255),symbolFile:l("symbol-file",60256),symbolInterface:l("symbol-interface",60257),symbolKeyword:l("symbol-keyword",60258),symbolMisc:l("symbol-misc",60259),symbolOperator:l("symbol-operator",60260),symbolProperty:l("symbol-property",60261),wrench:l("wrench",60261),wrenchSubaction:l("wrench-subaction",60261),symbolSnippet:l("symbol-snippet",60262),tasklist:l("tasklist",60263),telescope:l("telescope",60264),textSize:l("text-size",60265),threeBars:l("three-bars",60266),thumbsdown:l("thumbsdown",60267),thumbsup:l("thumbsup",60268),tools:l("tools",60269),triangleDown:l("triangle-down",60270),triangleLeft:l("triangle-left",60271),triangleRight:l("triangle-right",60272),triangleUp:l("triangle-up",60273),twitter:l("twitter",60274),unfold:l("unfold",60275),unlock:l("unlock",60276),unmute:l("unmute",60277),unverified:l("unverified",60278),verified:l("verified",60279),versions:l("versions",60280),vmActive:l("vm-active",60281),vmOutline:l("vm-outline",60282),vmRunning:l("vm-running",60283),watch:l("watch",60284),whitespace:l("whitespace",60285),wholeWord:l("whole-word",60286),window:l("window",60287),wordWrap:l("word-wrap",60288),zoomIn:l("zoom-in",60289),zoomOut:l("zoom-out",60290),listFilter:l("list-filter",60291),listFlat:l("list-flat",60292),listSelection:l("list-selection",60293),selection:l("selection",60293),listTree:l("list-tree",60294),debugBreakpointFunctionUnverified:l("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:l("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:l("debug-breakpoint-function-disabled",60296),debugStackframeActive:l("debug-stackframe-active",60297),circleSmallFilled:l("circle-small-filled",60298),debugStackframeDot:l("debug-stackframe-dot",60298),debugStackframe:l("debug-stackframe",60299),debugStackframeFocused:l("debug-stackframe-focused",60299),debugBreakpointUnsupported:l("debug-breakpoint-unsupported",60300),symbolString:l("symbol-string",60301),debugReverseContinue:l("debug-reverse-continue",60302),debugStepBack:l("debug-step-back",60303),debugRestartFrame:l("debug-restart-frame",60304),callIncoming:l("call-incoming",60306),callOutgoing:l("call-outgoing",60307),menu:l("menu",60308),expandAll:l("expand-all",60309),feedback:l("feedback",60310),groupByRefType:l("group-by-ref-type",60311),ungroupByRefType:l("ungroup-by-ref-type",60312),account:l("account",60313),bellDot:l("bell-dot",60314),debugConsole:l("debug-console",60315),library:l("library",60316),output:l("output",60317),runAll:l("run-all",60318),syncIgnored:l("sync-ignored",60319),pinned:l("pinned",60320),githubInverted:l("github-inverted",60321),debugAlt:l("debug-alt",60305),serverProcess:l("server-process",60322),serverEnvironment:l("server-environment",60323),pass:l("pass",60324),stopCircle:l("stop-circle",60325),playCircle:l("play-circle",60326),record:l("record",60327),debugAltSmall:l("debug-alt-small",60328),vmConnect:l("vm-connect",60329),cloud:l("cloud",60330),merge:l("merge",60331),exportIcon:l("export",60332),graphLeft:l("graph-left",60333),magnet:l("magnet",60334),notebook:l("notebook",60335),redo:l("redo",60336),checkAll:l("check-all",60337),pinnedDirty:l("pinned-dirty",60338),passFilled:l("pass-filled",60339),circleLargeFilled:l("circle-large-filled",60340),circleLarge:l("circle-large",60341),circleLargeOutline:l("circle-large-outline",60341),combine:l("combine",60342),gather:l("gather",60342),table:l("table",60343),variableGroup:l("variable-group",60344),typeHierarchy:l("type-hierarchy",60345),typeHierarchySub:l("type-hierarchy-sub",60346),typeHierarchySuper:l("type-hierarchy-super",60347),gitPullRequestCreate:l("git-pull-request-create",60348),runAbove:l("run-above",60349),runBelow:l("run-below",60350),notebookTemplate:l("notebook-template",60351),debugRerun:l("debug-rerun",60352),workspaceTrusted:l("workspace-trusted",60353),workspaceUntrusted:l("workspace-untrusted",60354),workspaceUnspecified:l("workspace-unspecified",60355),terminalCmd:l("terminal-cmd",60356),terminalDebian:l("terminal-debian",60357),terminalLinux:l("terminal-linux",60358),terminalPowershell:l("terminal-powershell",60359),terminalTmux:l("terminal-tmux",60360),terminalUbuntu:l("terminal-ubuntu",60361),terminalBash:l("terminal-bash",60362),arrowSwap:l("arrow-swap",60363),copy:l("copy",60364),personAdd:l("person-add",60365),filterFilled:l("filter-filled",60366),wand:l("wand",60367),debugLineByLine:l("debug-line-by-line",60368),inspect:l("inspect",60369),layers:l("layers",60370),layersDot:l("layers-dot",60371),layersActive:l("layers-active",60372),compass:l("compass",60373),compassDot:l("compass-dot",60374),compassActive:l("compass-active",60375),azure:l("azure",60376),issueDraft:l("issue-draft",60377),gitPullRequestClosed:l("git-pull-request-closed",60378),gitPullRequestDraft:l("git-pull-request-draft",60379),debugAll:l("debug-all",60380),debugCoverage:l("debug-coverage",60381),runErrors:l("run-errors",60382),folderLibrary:l("folder-library",60383),debugContinueSmall:l("debug-continue-small",60384),beakerStop:l("beaker-stop",60385),graphLine:l("graph-line",60386),graphScatter:l("graph-scatter",60387),pieChart:l("pie-chart",60388),bracketDot:l("bracket-dot",60389),bracketError:l("bracket-error",60390),lockSmall:l("lock-small",60391),azureDevops:l("azure-devops",60392),verifiedFilled:l("verified-filled",60393),newLine:l("newline",60394),layout:l("layout",60395),layoutActivitybarLeft:l("layout-activitybar-left",60396),layoutActivitybarRight:l("layout-activitybar-right",60397),layoutPanelLeft:l("layout-panel-left",60398),layoutPanelCenter:l("layout-panel-center",60399),layoutPanelJustify:l("layout-panel-justify",60400),layoutPanelRight:l("layout-panel-right",60401),layoutPanel:l("layout-panel",60402),layoutSidebarLeft:l("layout-sidebar-left",60403),layoutSidebarRight:l("layout-sidebar-right",60404),layoutStatusbar:l("layout-statusbar",60405),layoutMenubar:l("layout-menubar",60406),layoutCentered:l("layout-centered",60407),layoutSidebarRightOff:l("layout-sidebar-right-off",60416),layoutPanelOff:l("layout-panel-off",60417),layoutSidebarLeftOff:l("layout-sidebar-left-off",60418),target:l("target",60408),indent:l("indent",60409),recordSmall:l("record-small",60410),errorSmall:l("error-small",60411),arrowCircleDown:l("arrow-circle-down",60412),arrowCircleLeft:l("arrow-circle-left",60413),arrowCircleRight:l("arrow-circle-right",60414),arrowCircleUp:l("arrow-circle-up",60415),heartFilled:l("heart-filled",60420),map:l("map",60421),mapFilled:l("map-filled",60422),circleSmall:l("circle-small",60423),bellSlash:l("bell-slash",60424),bellSlashDot:l("bell-slash-dot",60425),commentUnresolved:l("comment-unresolved",60426),gitPullRequestGoToChanges:l("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:l("git-pull-request-new-changes",60428),searchFuzzy:l("search-fuzzy",60429),commentDraft:l("comment-draft",60430),dialogError:l("dialog-error","error"),dialogWarning:l("dialog-warning","warning"),dialogInfo:l("dialog-info","info"),dialogClose:l("dialog-close","close"),treeItemExpanded:l("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:l("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:l("tree-filter-on-type-off","list-selection"),treeFilterClear:l("tree-filter-clear","close"),treeItemLoading:l("tree-item-loading","loading"),menuSelection:l("menu-selection","check"),menuSubmenu:l("menu-submenu","chevron-right"),menuBarMore:l("menubar-more","more"),scrollbarButtonLeft:l("scrollbar-button-left","triangle-left"),scrollbarButtonRight:l("scrollbar-button-right","triangle-right"),scrollbarButtonUp:l("scrollbar-button-up","triangle-up"),scrollbarButtonDown:l("scrollbar-button-down","triangle-down"),toolBarMore:l("toolbar-more","more"),quickInputBack:l("quick-input-back","arrow-left")}}),define(be[38],Ee([1,0,7,3,17,8]),function(oe,e,E,A,l,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function S(o){return o===47||o===92}e.isPathSeparator=S;function P(o){return o.replace(/[\\/]/g,E.posix.sep)}e.toSlashes=P;function y(o){return o.indexOf("/")===-1&&(o=P(o)),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o),o}e.toPosixPath=y;function b(o,u=E.posix.sep){if(!o)return"";const a=o.length,s=o.charCodeAt(0);if(S(s)){if(S(o.charCodeAt(1))&&!S(o.charCodeAt(2))){let L=3;const O=L;for(;L<a&&!S(o.charCodeAt(L));L++);if(O!==L&&!S(o.charCodeAt(L+1))){for(L+=1;L<a;L++)if(S(o.charCodeAt(L)))return o.slice(0,L+1).replace(/[\\/]/g,u)}}return u}else if(h(s)&&o.charCodeAt(1)===58)return S(o.charCodeAt(2))?o.slice(0,2)+u:o.slice(0,2);let C=o.indexOf("://");if(C!==-1){for(C+=3;C<a;C++)if(S(o.charCodeAt(C)))return o.slice(0,C+1)}return""}e.getRoot=b;function k(o){if(!A.isWindows||!o||o.length<5)return!1;let u=o.charCodeAt(0);if(u!==92||(u=o.charCodeAt(1),u!==92))return!1;let a=2;const s=a;for(;a<o.length&&(u=o.charCodeAt(a),u!==92);a++);return!(s===a||(u=o.charCodeAt(a+1),isNaN(u)||u===92))}e.isUNC=k;const I=/[\\/:\*\?"<>\|]/g,v=/[\\/]/g,d=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function m(o,u=A.isWindows){const a=u?I:v;return!(!o||o.length===0||/^\s+$/.test(o)||(a.lastIndex=0,a.test(o))||u&&d.test(o)||o==="."||o===".."||u&&o[o.length-1]==="."||u&&o.length!==o.trim().length||o.length>255)}e.isValidBasename=m;function p(o,u,a){const s=o===u;return!a||s?s:!o||!u?!1:(0,l.equalsIgnoreCase)(o,u)}e.isEqual=p;function c(o,u,a,s=E.sep){if(o===u)return!0;if(!o||!u||u.length>o.length)return!1;if(a){if(!(0,l.startsWithIgnoreCase)(o,u))return!1;if(u.length===o.length)return!0;let L=u.length;return u.charAt(u.length-1)===s&&L--,o.charAt(L)===s}return u.charAt(u.length-1)!==s&&(u+=s),o.indexOf(u)===0}e.isEqualOrParent=c;function h(o){return o>=65&&o<=90||o>=97&&o<=122}e.isWindowsDriveLetter=h;function g(o,u){return A.isWindows&&o.endsWith(":")&&(o+=E.sep),(0,E.isAbsolute)(o)||(o=(0,E.join)(u,o)),o=(0,E.normalize)(o),A.isWindows?(o=(0,l.rtrim)(o,E.sep),o.endsWith(":")&&(o+=E.sep)):(o=(0,l.rtrim)(o,E.sep),o||(o=E.sep)),o}e.sanitizeFilePath=g;function f(o){const u=(0,E.normalize)(o);return A.isWindows?o.length>3?!1:D(u)&&(o.length===2||u.charCodeAt(2)===92):u===E.posix.sep}e.isRootOrDriveLetter=f;function D(o,u=A.isWindows){return u?h(o.charCodeAt(0))&&o.charCodeAt(1)===58:!1}e.hasDriveLetter=D;function R(o){return D(o)?o[0]:void 0}e.getDriveLetter=R;function t(o,u,a){return u.length>o.length?-1:o===u?0:(a&&(o=o.toLowerCase(),u=u.toLowerCase()),o.indexOf(u))}e.indexOfPath=t;function r(o){const u=o.split(":");let a,s,C;for(const L of u){const O=Number(L);(0,w.isNumber)(O)?s===void 0?s=O:C===void 0&&(C=O):a=a?[a,L].join(":"):L}if(!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:s!==void 0?s:void 0,column:C!==void 0?C:s!==void 0?1:void 0}}e.parseLineAndColumnAware=r;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function n(o,u,a=8){let s="";for(let L=0;L<a;L++)s+=i.charAt(Math.floor(Math.random()*i.length));let C;return u?C=`${u}-${s}`:C=s,o?(0,E.join)(o,C):C}e.randomPath=n}),define(be[23],Ee([1,0,8]),function(oe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function A(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const g=Array.isArray(h)?[]:{};return Object.entries(h).forEach(([f,D])=>{g[f]=D&&typeof D=="object"?A(D):D}),g}e.deepClone=A;function l(h){if(!h||typeof h!="object")return h;const g=[h];for(;g.length>0;){const f=g.shift();Object.freeze(f);for(const D in f)if(w.call(f,D)){const R=f[D];typeof R=="object"&&!Object.isFrozen(R)&&!(0,E.isTypedArray)(R)&&g.push(R)}}return h}e.deepFreeze=l;const w=Object.prototype.hasOwnProperty;function S(h,g){return P(h,g,new Set)}e.cloneAndChange=S;function P(h,g,f){if((0,E.isUndefinedOrNull)(h))return h;const D=g(h);if(typeof D<"u")return D;if(Array.isArray(h)){const R=[];for(const t of h)R.push(P(t,g,f));return R}if((0,E.isObject)(h)){if(f.has(h))throw new Error("Cannot clone recursive data-structure");f.add(h);const R={};for(const t in h)w.call(h,t)&&(R[t]=P(h[t],g,f));return f.delete(h),R}return h}function y(h,g,f=!0){return(0,E.isObject)(h)?((0,E.isObject)(g)&&Object.keys(g).forEach(D=>{D in h?f&&((0,E.isObject)(h[D])&&(0,E.isObject)(g[D])?y(h[D],g[D],f):h[D]=g[D]):h[D]=g[D]}),h):g}e.mixin=y;function b(h,g){if(h===g)return!0;if(h==null||g===null||g===void 0||typeof h!=typeof g||typeof h!="object"||Array.isArray(h)!==Array.isArray(g))return!1;let f,D;if(Array.isArray(h)){if(h.length!==g.length)return!1;for(f=0;f<h.length;f++)if(!b(h[f],g[f]))return!1}else{const R=[];for(D in h)R.push(D);R.sort();const t=[];for(D in g)t.push(D);if(t.sort(),!b(R,t))return!1;for(f=0;f<R.length;f++)if(!b(h[R[f]],g[R[f]]))return!1}return!0}e.equals=b;function k(h){const g=new Set;return JSON.stringify(h,(f,D)=>{if((0,E.isObject)(D)||Array.isArray(D)){if(g.has(D))return"[Circular]";g.add(D)}return D})}e.safeStringify=k;function I(h,g){const f=Object.create(null);return!h||!g||Object.keys(g).forEach(R=>{const t=h[R],r=g[R];b(t,r)||(f[R]=r)}),f}e.distinct=I;function v(h,g){const f=g.toLowerCase(),D=Object.keys(h).find(R=>R.toLowerCase()===f);return D?h[D]:h[g]}e.getCaseInsensitive=v;function d(h,g){const f=Object.create(null);for(const[D,R]of Object.entries(h))g(D,R)&&(f[D]=R);return f}e.filter=d;function m(h){let g=[],f=Object.getPrototypeOf(h);for(;Object.prototype!==f;)g=g.concat(Object.getOwnPropertyNames(f)),f=Object.getPrototypeOf(f);return g}e.getAllPropertyNames=m;function p(h){const g=[];for(const f of m(h))typeof h[f]=="function"&&g.push(f);return g}e.getAllMethodNames=p;function c(h,g){const f=R=>function(){const t=Array.prototype.slice.call(arguments,0);return g(R,t)},D={};for(const R of h)D[R]=f(R);return D}e.createProxyObject=c}),define(be[93],Ee([1,0,46]),function(oe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var A;(function(S){function P(y){return y&&typeof y=="object"&&typeof y.id=="string"}S.isThemeColor=P})(A=e.ThemeColor||(e.ThemeColor={}));function l(S){return{id:S}}e.themeColorFromId=l;var w;(function(S){S.iconNameSegment="[A-Za-z0-9]+",S.iconNameExpression="[A-Za-z0-9-]+",S.iconModifierExpression="~[A-Za-z]+",S.iconNameCharacter="[A-Za-z0-9~-]";const P=new RegExp(`^(${S.iconNameExpression})(${S.iconModifierExpression})?$`);function y(g){const f=P.exec(g.id);if(!f)return y(E.Codicon.error);const[,D,R]=f,t=["codicon","codicon-"+D];return R&&t.push("codicon-modifier-"+R.substring(1)),t}S.asClassNameArray=y;function b(g){return y(g).join(" ")}S.asClassName=b;function k(g){return"."+y(g).join(".")}S.asCSSSelector=k;function I(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(typeof g.color>"u"||A.isThemeColor(g.color))}S.isThemeIcon=I;const v=new RegExp(`^\\$\\((${S.iconNameExpression}(?:${S.iconModifierExpression})?)\\)$`);function d(g){const f=v.exec(g);if(!f)return;const[,D]=f;return{id:D}}S.fromString=d;function m(g){return{id:g}}S.fromId=m;function p(g,f){let D=g.id;const R=D.lastIndexOf("~");return R!==-1&&(D=D.substring(0,R)),f&&(D=`${D}~${f}`),{id:D}}S.modify=p;function c(g){const f=g.id.lastIndexOf("~");if(f!==-1)return g.id.substring(f+1)}S.getModifier=c;function h(g,f){return g.id===f.id&&g.color?.id===f.color?.id}S.isEqual=h})(w=e.ThemeIcon||(e.ThemeIcon={}))}),define(be[148],Ee([1,0,146,17,93]),function(oe,e,E,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.getCodiconAriaLabel=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const w="$(",S=new RegExp(`\\$\\(${l.ThemeIcon.iconNameExpression}(?:${l.ThemeIcon.iconModifierExpression})?\\)`,"g"),P=new RegExp(`(\\\\)?${S.source}`,"g");function y(h){return h.replace(P,(g,f)=>f?g:`\\${g}`)}e.escapeIcons=y;const b=new RegExp(`\\\\${S.source}`,"g");function k(h){return h.replace(b,g=>`\\${g}`)}e.markdownEscapeEscapedIcons=k;const I=new RegExp(`(\\s)?(\\\\)?${S.source}(\\s)?`,"g");function v(h){return h.indexOf(w)===-1?h:h.replace(I,(g,f,D,R)=>D?g:f||R||"")}e.stripIcons=v;function d(h){return h?h.replace(/\$\((.*?)\)/g,(g,f)=>` ${f} `).trim():""}e.getCodiconAriaLabel=d;const m=new RegExp(`\\$\\(${l.ThemeIcon.iconNameCharacter}+\\)`,"g");function p(h){m.lastIndex=0;let g="";const f=[];let D=0;for(;;){const R=m.lastIndex,t=m.exec(h),r=h.substring(R,t?.index);if(r.length>0){g+=r;for(let i=0;i<r.length;i++)f.push(D)}if(!t)break;D+=t[0].length}return{text:g,iconOffsets:f}}e.parseLabelWithIcons=p;function c(h,g,f=!1){const{text:D,iconOffsets:R}=g;if(!R||R.length===0)return(0,E.matchesFuzzy)(h,D,f);const t=(0,A.ltrim)(D," "),r=D.length-t.length,i=(0,E.matchesFuzzy)(h,t,f);if(i)for(const n of i){const o=R[n.start+r]+r;n.start+=o,n.end+=o}return i}e.matchesFuzzyIconAware=c}),define(be[4],Ee([1,0,7,3]),function(oe,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const l=/^\w[\w\d+.-]*$/,w=/^\//,S=/^\/\//;function P(i,n){if(!i.scheme&&n)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${i.authority}", path: "${i.path}", query: "${i.query}", fragment: "${i.fragment}"}`);if(i.scheme&&!l.test(i.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(i.path){if(i.authority){if(!w.test(i.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(S.test(i.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function y(i,n){return!i&&!n?"file":i}function b(i,n){switch(i){case"https":case"http":case"file":n?n[0]!==I&&(n=I+n):n=I;break}return n}const k="",I="/",v=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class d{static isUri(n){return n instanceof d?!0:n?typeof n.authority=="string"&&typeof n.fragment=="string"&&typeof n.path=="string"&&typeof n.query=="string"&&typeof n.scheme=="string"&&typeof n.fsPath=="string"&&typeof n.with=="function"&&typeof n.toString=="function":!1}constructor(n,o,u,a,s,C=!1){typeof n=="object"?(this.scheme=n.scheme||k,this.authority=n.authority||k,this.path=n.path||k,this.query=n.query||k,this.fragment=n.fragment||k):(this.scheme=y(n,C),this.authority=o||k,this.path=b(this.scheme,u||k),this.query=a||k,this.fragment=s||k,P(this,C))}get fsPath(){return f(this,!1)}with(n){if(!n)return this;let{scheme:o,authority:u,path:a,query:s,fragment:C}=n;return o===void 0?o=this.scheme:o===null&&(o=k),u===void 0?u=this.authority:u===null&&(u=k),a===void 0?a=this.path:a===null&&(a=k),s===void 0?s=this.query:s===null&&(s=k),C===void 0?C=this.fragment:C===null&&(C=k),o===this.scheme&&u===this.authority&&a===this.path&&s===this.query&&C===this.fragment?this:new p(o,u,a,s,C)}static parse(n,o=!1){const u=v.exec(n);return u?new p(u[2]||k,r(u[4]||k),r(u[5]||k),r(u[7]||k),r(u[9]||k),o):new p(k,k,k,k,k)}static file(n){let o=k;if(A.isWindows&&(n=n.replace(/\\/g,I)),n[0]===I&&n[1]===I){const u=n.indexOf(I,2);u===-1?(o=n.substring(2),n=I):(o=n.substring(2,u),n=n.substring(u)||I)}return new p("file",o,n,k,k)}static from(n){const o=new p(n.scheme,n.authority,n.path,n.query,n.fragment);return P(o,!0),o}static joinPath(n,...o){if(!n.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let u;return A.isWindows&&n.scheme==="file"?u=d.file(E.win32.join(f(n,!0),...o)).path:u=E.posix.join(n.path,...o),n.with({path:u})}toString(n=!1){return D(this,n)}toJSON(){return this}static revive(n){if(n){if(n instanceof d)return n;{const o=new p(n);return o._formatted=n.external,o._fsPath=n._sep===m?n.fsPath:null,o}}else return n}}e.URI=d;const m=A.isWindows?1:void 0;class p extends d{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=f(this,!1)),this._fsPath}toString(n=!1){return n?D(this,!0):(this._formatted||(this._formatted=D(this,!1)),this._formatted)}toJSON(){const n={$mid:1};return this._fsPath&&(n.fsPath=this._fsPath,n._sep=m),this._formatted&&(n.external=this._formatted),this.path&&(n.path=this.path),this.scheme&&(n.scheme=this.scheme),this.authority&&(n.authority=this.authority),this.query&&(n.query=this.query),this.fragment&&(n.fragment=this.fragment),n}}const c={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function h(i,n,o){let u,a=-1;for(let s=0;s<i.length;s++){const C=i.charCodeAt(s);if(C>=97&&C<=122||C>=65&&C<=90||C>=48&&C<=57||C===45||C===46||C===95||C===126||n&&C===47||o&&C===91||o&&C===93||o&&C===58)a!==-1&&(u+=encodeURIComponent(i.substring(a,s)),a=-1),u!==void 0&&(u+=i.charAt(s));else{u===void 0&&(u=i.substr(0,s));const L=c[C];L!==void 0?(a!==-1&&(u+=encodeURIComponent(i.substring(a,s)),a=-1),u+=L):a===-1&&(a=s)}}return a!==-1&&(u+=encodeURIComponent(i.substring(a))),u!==void 0?u:i}function g(i){let n;for(let o=0;o<i.length;o++){const u=i.charCodeAt(o);u===35||u===63?(n===void 0&&(n=i.substr(0,o)),n+=c[u]):n!==void 0&&(n+=i[o])}return n!==void 0?n:i}function f(i,n){let o;return i.authority&&i.path.length>1&&i.scheme==="file"?o=`//${i.authority}${i.path}`:i.path.charCodeAt(0)===47&&(i.path.charCodeAt(1)>=65&&i.path.charCodeAt(1)<=90||i.path.charCodeAt(1)>=97&&i.path.charCodeAt(1)<=122)&&i.path.charCodeAt(2)===58?n?o=i.path.substr(1):o=i.path[1].toLowerCase()+i.path.substr(2):o=i.path,A.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=f;function D(i,n){const o=n?g:h;let u="",{scheme:a,authority:s,path:C,query:L,fragment:O}=i;if(a&&(u+=a,u+=":"),(s||a==="file")&&(u+=I,u+=I),s){let W=s.indexOf("@");if(W!==-1){const X=s.substr(0,W);s=s.substr(W+1),W=X.lastIndexOf(":"),W===-1?u+=o(X,!1,!1):(u+=o(X.substr(0,W),!1,!1),u+=":",u+=o(X.substr(W+1),!1,!0)),u+="@"}s=s.toLowerCase(),W=s.lastIndexOf(":"),W===-1?u+=o(s,!1,!0):(u+=o(s.substr(0,W),!1,!0),u+=s.substr(W))}if(C){if(C.length>=3&&C.charCodeAt(0)===47&&C.charCodeAt(2)===58){const W=C.charCodeAt(1);W>=65&&W<=90&&(C=`/${String.fromCharCode(W+32)}:${C.substr(3)}`)}else if(C.length>=2&&C.charCodeAt(1)===58){const W=C.charCodeAt(0);W>=65&&W<=90&&(C=`${String.fromCharCode(W+32)}:${C.substr(2)}`)}u+=o(C,!0,!1)}return L&&(u+="?",u+=o(L,!1,!1)),O&&(u+="#",u+=n?O:h(O,!1,!1)),u}function R(i){try{return decodeURIComponent(i)}catch{return i.length>3?i.substr(0,3)+R(i.substr(3)):i}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(i){return i.match(t)?i.replace(t,n=>R(n)):i}}),define(be[149],Ee([1,0,4]),function(oe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function A(b){const k=b;return k&&typeof k.type=="string"&&typeof k.severity=="string"}e.isRemoteConsoleLog=A;function l(b){const k=[];let I;try{const v=JSON.parse(b.arguments),d=v[v.length-1];d&&d.__$stack&&(v.pop(),I=d.__$stack),k.push(...v)}catch{k.push("Unable to log remote console arguments",b.arguments)}return{args:k,stack:I}}e.parse=l;function w(b){if(typeof b!="string")return w(l(b).stack);const k=b;if(k){const I=S(k),v=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(I||"");if(v&&v.length===4)return{uri:E.URI.file(v[1]),line:Number(v[2]),column:Number(v[3])}}}e.getFirstFrame=w;function S(b){if(!b)return b;const k=b.indexOf(`
`);return k===-1?b:b.substring(0,k)}function P(b,k){const{args:I,stack:v}=l(b),d=typeof I[0]=="string"&&I.length===1;let m=S(v);m&&(m=`(${m.trim()})`);let p=[];if(typeof I[0]=="string"?m&&d?p=[`%c[${k}] %c${I[0]} %c${m}`,y("blue"),y(""),y("grey")]:p=[`%c[${k}] %c${I[0]}`,y("blue"),y(""),...I.slice(1)]:p=[`%c[${k}]%`,y("blue"),...I],m&&!d&&p.push(m),typeof console[b.severity]!="function")throw new Error("Unknown console method");console[b.severity].apply(console,p)}e.log=P;function y(b){return`color: ${b}`}}),define(be[61],Ee([1,0,15,17,4]),function(oe,e,E,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function w(b){return JSON.stringify(b,P)}e.stringify=w;function S(b){let k=JSON.parse(b);return k=y(k),k}e.parse=S;function P(b,k){return k instanceof RegExp?{$mid:2,source:k.source,flags:(0,A.regExpFlags)(k)}:k}function y(b,k=0){if(!b||k>200)return b;if(typeof b=="object"){switch(b.$mid){case 1:return l.URI.revive(b);case 2:return new RegExp(b.source,b.flags);case 16:return new Date(b.source)}if(b instanceof E.VSBuffer||b instanceof Uint8Array)return b;if(Array.isArray(b))for(let I=0;I<b.length;++I)b[I]=y(b[I],k+1);else for(const I in b)Object.hasOwnProperty.call(b,I)&&(b[I]=y(b[I],k+1))}return b}e.revive=y}),define(be[13],Ee([1,0,9,3,4]),function(oe,e,E,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var w;(function(b){b.inMemory="inmemory",b.vscode="vscode",b.internal="private",b.walkThrough="walkThrough",b.walkThroughSnippet="walkThroughSnippet",b.http="http",b.https="https",b.file="file",b.mailto="mailto",b.untitled="untitled",b.data="data",b.command="command",b.vscodeRemote="vscode-remote",b.vscodeRemoteResource="vscode-remote-resource",b.vscodeUserData="vscode-userdata",b.vscodeCustomEditor="vscode-custom-editor",b.vscodeNotebookCell="vscode-notebook-cell",b.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",b.vscodeNotebookCellOutput="vscode-notebook-cell-output",b.vscodeInteractive="vscode-interactive",b.vscodeInteractiveInput="vscode-interactive-input",b.vscodeSettings="vscode-settings",b.vscodeWorkspaceTrust="vscode-workspace-trust",b.vscodeTerminal="vscode-terminal",b.webviewPanel="webview-panel",b.vscodeWebview="vscode-webview",b.extension="extension",b.vscodeFileResource="vscode-file",b.tmp="tmp",b.vsls="vsls",b.vscodeSourceControl="vscode-scm"})(w=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class S{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${w.vscodeRemoteResource}`}setPreferredWebSchema(k){this.d=k}setDelegate(k){this.e=k}setServerRootPath(k){this.f=`${k}/${w.vscodeRemoteResource}`}set(k,I,v){this.a[k]=I,this.b[k]=v}setConnectionToken(k,I){this.c[k]=I}getPreferredWebSchema(){return this.d}rewrite(k){if(this.e)try{return this.e(k)}catch(c){return E.onUnexpectedError(c),k}const I=k.authority;let v=this.a[I];v&&v.indexOf(":")!==-1&&v.indexOf("[")===-1&&(v=`[${v}]`);const d=this.b[I],m=this.c[I];let p=`path=${encodeURIComponent(k.path)}`;return typeof m=="string"&&(p+=`&${e.connectionTokenQueryName}=${encodeURIComponent(m)}`),l.URI.from({scheme:A.isWeb?this.d:w.vscodeRemoteResource,authority:`${v}:${d}`,path:A.isWeb?(window.location.pathname+"/"+this.f).replace(/\/\/+/g,"/"):this.f,query:p})}}e.RemoteAuthorities=new S,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class P{asBrowserUri(k){const I=this.b(k,oe);return this.uriToBrowserUri(I)}uriToBrowserUri(k){return k.scheme===w.vscodeRemote?e.RemoteAuthorities.rewrite(k):k.scheme===w.file&&(A.isNative||A.isWebWorker&&A.globals.origin===`${w.vscodeFileResource}://${P.a}`)?k.with({scheme:w.vscodeFileResource,authority:k.authority||P.a,query:null,fragment:null}):k}asFileUri(k){const I=this.b(k,oe);return this.uriToFileUri(I)}uriToFileUri(k){return k.scheme===w.vscodeFileResource?k.with({scheme:w.file,authority:k.authority!==P.a?k.authority:null,query:null,fragment:null}):k}b(k,I){return l.URI.isUri(k)?k:l.URI.parse(I.toUrl(k))}}P.a="vscode-app",e.FileAccess=new P;var y;(function(b){const k=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);b.CoopAndCoep=Object.freeze(k.get("3"));const I="vscode-coi";function v(m){let p;typeof m=="string"?p=new URL(m).searchParams:m instanceof URL?p=m.searchParams:l.URI.isUri(m)&&(p=new URL(m.toString(!0)).searchParams);const c=p?.get(I);if(!!c)return k.get(c)}b.getHeadersFromQuery=v;function d(m,p,c){if(!globalThis.crossOriginIsolated)return;const h=p&&c?"3":c?"2":"1";m instanceof URLSearchParams?m.set(I,h):m[I]=h}b.addSearchParam=d})(y=e.COI||(e.COI={}))}),define(be[20],Ee([1,0,38,13,7,3,17,4]),function(oe,e,E,A,l,w,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(d){return(0,P.uriToFsPath)(d,!0)}e.originalFSPath=y;class b{constructor(m){this.a=m}compare(m,p,c=!1){return m===p?0:(0,S.compare)(this.getComparisonKey(m,c),this.getComparisonKey(p,c))}isEqual(m,p,c=!1){return m===p?!0:!m||!p?!1:this.getComparisonKey(m,c)===this.getComparisonKey(p,c)}getComparisonKey(m,p=!1){return m.with({path:this.a(m)?m.path.toLowerCase():void 0,fragment:p?null:void 0}).toString()}ignorePathCasing(m){return this.a(m)}isEqualOrParent(m,p,c=!1){if(m.scheme===p.scheme){if(m.scheme===A.Schemas.file)return E.isEqualOrParent(y(m),y(p),this.a(m))&&m.query===p.query&&(c||m.fragment===p.fragment);if((0,e.isEqualAuthority)(m.authority,p.authority))return E.isEqualOrParent(m.path,p.path,this.a(m),"/")&&m.query===p.query&&(c||m.fragment===p.fragment)}return!1}joinPath(m,...p){return P.URI.joinPath(m,...p)}basenameOrAuthority(m){return(0,e.basename)(m)||m.authority}basename(m){return l.posix.basename(m.path)}extname(m){return l.posix.extname(m.path)}dirname(m){if(m.path.length===0)return m;let p;return m.scheme===A.Schemas.file?p=P.URI.file(l.dirname(y(m))).path:(p=l.posix.dirname(m.path),m.authority&&p.length&&p.charCodeAt(0)!==47&&(console.error(`dirname("${m.toString})) resulted in a relative path`),p="/")),m.with({path:p})}normalizePath(m){if(!m.path.length)return m;let p;return m.scheme===A.Schemas.file?p=P.URI.file(l.normalize(y(m))).path:p=l.posix.normalize(m.path),m.with({path:p})}relativePath(m,p){if(m.scheme!==p.scheme||!(0,e.isEqualAuthority)(m.authority,p.authority))return;if(m.scheme===A.Schemas.file){const g=l.relative(y(m),y(p));return w.isWindows?E.toSlashes(g):g}let c=m.path||"/";const h=p.path||"/";if(this.a(m)){let g=0;for(const f=Math.min(c.length,h.length);g<f&&!(c.charCodeAt(g)!==h.charCodeAt(g)&&c.charAt(g).toLowerCase()!==h.charAt(g).toLowerCase());g++);c=h.substr(0,g)+c.substr(g)}return l.posix.relative(c,h)}resolvePath(m,p){if(m.scheme===A.Schemas.file){const c=P.URI.file(l.resolve(y(m),p));return m.with({authority:c.authority,path:c.path})}return p=E.toPosixPath(p),m.with({path:l.posix.resolve(m.path,p)})}isAbsolutePath(m){return!!m.path&&m.path[0]==="/"}isEqualAuthority(m,p){return m===p||m!==void 0&&p!==void 0&&(0,S.equalsIgnoreCase)(m,p)}hasTrailingPathSeparator(m,p=l.sep){if(m.scheme===A.Schemas.file){const c=y(m);return c.length>E.getRoot(c).length&&c[c.length-1]===p}else{const c=m.path;return c.length>1&&c.charCodeAt(c.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(m.fsPath)}}removeTrailingPathSeparator(m,p=l.sep){return(0,e.hasTrailingPathSeparator)(m,p)?m.with({path:m.path.substr(0,m.path.length-1)}):m}addTrailingPathSeparator(m,p=l.sep){let c=!1;if(m.scheme===A.Schemas.file){const h=y(m);c=h!==void 0&&h.length===E.getRoot(h).length&&h[h.length-1]===p}else{p="/";const h=m.path;c=h.length===1&&h.charCodeAt(h.length-1)===47}return!c&&!(0,e.hasTrailingPathSeparator)(m,p)?m.with({path:m.path+"/"}):m}}e.ExtUri=b,e.extUri=new b(()=>!1),e.extUriBiasedIgnorePathCase=new b(d=>d.scheme===A.Schemas.file?!w.isLinux:!0),e.extUriIgnorePathCase=new b(d=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function k(d,m){const p=[];for(let c=0;c<d.length;c++){const h=m(d[c]);d.some((g,f)=>f===c?!1:(0,e.isEqualOrParent)(h,m(g)))||p.push(d[c])}return p}e.distinctParents=k;var I;(function(d){d.META_DATA_LABEL="label",d.META_DATA_DESCRIPTION="description",d.META_DATA_SIZE="size",d.META_DATA_MIME="mime";function m(p){const c=new Map;p.path.substring(p.path.indexOf(";")+1,p.path.lastIndexOf(";")).split(";").forEach(f=>{const[D,R]=f.split(":");D&&R&&c.set(D,R)});const g=p.path.substring(0,p.path.indexOf(";"));return g&&c.set(d.META_DATA_MIME,g),c}d.parseMetaData=m})(I=e.DataUri||(e.DataUri={}));function v(d,m,p){if(m){let c=d.path;return c&&c[0]!==l.posix.sep&&(c=l.posix.sep+c),d.with({scheme:p,authority:m,path:c})}return d.with({scheme:p})}e.toLocalResource=v}),define(be[14],Ee([1,0,19,9,6,2,20,3,147]),function(oe,e,E,A,l,w,S,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function b(B){return!!B&&typeof B.then=="function"}e.isThenable=b;function k(B){const N=new E.CancellationTokenSource,U=B(N.token),G=new Promise((te,le)=>{const j=N.token.onCancellationRequested(()=>{j.dispose(),N.dispose(),le(new A.CancellationError)});Promise.resolve(U).then(K=>{j.dispose(),N.dispose(),te(K)},K=>{j.dispose(),N.dispose(),le(K)})});return new class{cancel(){N.cancel()}then(te,le){return G.then(te,le)}catch(te){return this.then(void 0,te)}finally(te){return G.finally(te)}}}e.createCancelablePromise=k;function I(B,N,U){return new Promise((G,te)=>{const le=N.onCancellationRequested(()=>{le.dispose(),G(U)});B.then(G,te).finally(()=>le.dispose())})}e.raceCancellation=I;function v(B,N){return new Promise((U,G)=>{const te=N.onCancellationRequested(()=>{te.dispose(),G(new A.CancellationError)});B.then(U,G).finally(()=>te.dispose())})}e.raceCancellationError=v;async function d(B){let N=-1;const U=B.map((te,le)=>te.then(j=>(N=le,j))),G=await Promise.race(U);return B.forEach((te,le)=>{le!==N&&te.cancel()}),G}e.raceCancellablePromises=d;function m(B,N,U){let G;const te=setTimeout(()=>{G?.(void 0),U?.()},N);return Promise.race([B.finally(()=>clearTimeout(te)),new Promise(le=>G=le)])}e.raceTimeout=m;function p(B){return new Promise((N,U)=>{const G=B();b(G)?G.then(N,U):N(G)})}e.asPromise=p;class c{constructor(){this.a=null,this.b=null,this.d=null}queue(N){if(this.a){if(this.d=N,!this.b){const U=()=>{this.b=null;const G=this.queue(this.d);return this.d=null,G};this.b=new Promise(G=>{this.a.then(U,U).then(G)})}return new Promise((U,G)=>{this.b.then(U,G)})}return this.a=N(),new Promise((U,G)=>{this.a.then(te=>{this.a=null,U(te)},te=>{this.a=null,G(te)})})}}e.Throttler=c;class h{constructor(){this.a=Promise.resolve(null)}queue(N){return this.a=this.a.then(()=>N(),()=>N())}}e.Sequencer=h;class g{constructor(){this.a=new Map}queue(N,U){const te=(this.a.get(N)??Promise.resolve()).catch(()=>{}).then(U).finally(()=>{this.a.get(N)===te&&this.a.delete(N)});return this.a.set(N,te),te}}e.SequencerByKey=g;const f=(B,N)=>{let U=!0;const G=setTimeout(()=>{U=!1,N()},B);return{isTriggered:()=>U,dispose:()=>{clearTimeout(G),U=!1}}},D=B=>{let N=!0;return queueMicrotask(()=>{N&&(N=!1,B())}),{isTriggered:()=>N,dispose:()=>{N=!1}}};class R{constructor(N){this.defaultDelay=N,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(N,U=this.defaultDelay){this.g=N,this.h(),this.b||(this.b=new Promise((te,le)=>{this.d=te,this.f=le}).then(()=>{if(this.b=null,this.d=null,this.g){const te=this.g;return this.g=null,te()}}));const G=()=>{this.a=null,this.d?.(null)};return this.a=U===y.MicrotaskDelay?D(G):f(U,G),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new A.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=R;class t{constructor(N){this.a=new R(N),this.b=new c}trigger(N,U){return this.a.trigger(()=>this.b.queue(N),U)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=t;class r{constructor(){this.a=!1,this.b=new Promise((N,U)=>{this.d=N})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=r;class i extends r{constructor(N){super(),this.f=setTimeout(()=>this.open(),N)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=i;function n(B,N){return N?new Promise((U,G)=>{const te=setTimeout(()=>{le.dispose(),U()},B),le=N.onCancellationRequested(()=>{clearTimeout(te),le.dispose(),G(new A.CancellationError)})}):k(U=>n(B,U))}e.timeout=n;function o(B,N=0){const U=setTimeout(B,N);return(0,w.toDisposable)(()=>clearTimeout(U))}e.disposableTimeout=o;function u(B){const N=[];let U=0;const G=B.length;function te(){return U<G?B[U++]():null}function le(j){j!=null&&N.push(j);const K=te();return K?K.then(le):Promise.resolve(N)}return Promise.resolve(null).then(le)}e.sequence=u;function a(B,N=G=>!!G,U=null){let G=0;const te=B.length,le=()=>{if(G>=te)return Promise.resolve(U);const j=B[G++];return Promise.resolve(j()).then(Q=>N(Q)?Promise.resolve(Q):le())};return le()}e.first=a;function s(B,N=G=>!!G,U=null){if(B.length===0)return Promise.resolve(U);let G=B.length;const te=()=>{G=-1;for(const le of B)le.cancel?.()};return new Promise((le,j)=>{for(const K of B)K.then(Q=>{--G>=0&&N(Q)?(te(),le(Q)):G===0&&le(U)}).catch(Q=>{--G>=0&&(te(),j(Q))})})}e.firstParallel=s;class C{constructor(N){this.a=0,this.d=N,this.f=[],this.b=0,this.g=new l.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(N){return this.a++,new Promise((U,G)=>{this.f.push({factory:N,c:U,e:G}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const N=this.f.shift();this.b++;const U=N.factory();U.then(N.c,N.e),U.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=C;class L extends C{constructor(){super(1)}}e.Queue=L;class O{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const N=new q;return this.b.add(N),N.p}d(){for(const[,N]of this.a)if(N.size>0)return!1;return!0}queueFor(N,U=S.extUri){const G=U.getComparisonKey(N);let te=this.a.get(G);return te||(te=new L,l.Event.once(te.onDrained)(()=>{te?.dispose(),this.a.delete(G),this.f()}),this.a.set(G,te)),te}f(){!this.d()||this.g()}g(){for(const N of this.b)N.complete();this.b.clear()}dispose(){for(const[,N]of this.a)N.dispose();this.a.clear(),this.g()}}e.ResourceQueue=O;class W{constructor(N,U){this.a=-1,typeof N=="function"&&typeof U=="number"&&this.setIfNotSet(N,U)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(N,U){this.cancel(),this.a=setTimeout(()=>{this.a=-1,N()},U)}setIfNotSet(N,U){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,N()},U))}}e.TimeoutTimer=W;class X{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(N,U){this.cancel(),this.a=setInterval(()=>{N()},U)}}e.IntervalTimer=X;class se{constructor(N,U){this.b=-1,this.a=N,this.d=U,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(N=this.d){this.cancel(),this.b=setTimeout(this.f,N)}get delay(){return this.d}set delay(N){this.d=N}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=se;class fe{constructor(N,U){U%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${U}ms is not a multiple of 1000ms.`),this.a=N,this.b=U,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(N=this.b){N%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${N}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(N/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=fe;class ce extends se{constructor(N,U){super(N,U),this.j=[]}work(N){this.j.push(N),this.isScheduled()||this.schedule()}h(){const N=this.j;this.j=[],this.a?.(N)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=ce;class V extends w.Disposable{constructor(N,U){super(),this.g=N,this.h=U,this.a=[],this.b=this.B(new w.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(N){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+N.length>this.g.maxBufferedWork)return!1}else if(this.pending+N.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const U of N)this.a.push(U);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new se(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=V,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=B=>{(0,P.setTimeout0)(()=>{if(N)return;const U=Date.now()+15;B(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,U-Date.now())}}))});let N=!1;return{dispose(){N||(N=!0)}}}:e.runWhenIdle=(B,N)=>{const U=requestIdleCallback(B,typeof N=="number"?{timeout:N}:void 0);let G=!1;return{dispose(){G||(G=!0,cancelIdleCallback(U))}}}}();class T{constructor(N){this.d=!1,this.a=()=>{try{this.f=N()}catch(U){this.g=U}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=T;async function z(B,N,U){let G;for(let te=0;te<U;te++)try{return await B()}catch(le){G=le,await n(N)}throw G}e.retry=z;class he{hasPending(N){return this.a?typeof N=="number"?this.a.taskId===N:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(N,U,G){return this.a={taskId:N,cancel:()=>G?.(),promise:U},U.then(()=>this.d(N),()=>this.d(N)),U}d(N){this.a&&N===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const N=this.b;this.b=void 0,N.run().then(N.promiseResolve,N.promiseReject)}}setNext(N){if(this.b)this.b.run=N;else{let U,G;const te=new Promise((le,j)=>{U=le,G=j});this.b={run:N,promise:te,promiseResolve:U,promiseReject:G}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=he;class H{constructor(N,U=()=>Date.now()){this.d=N,this.f=U,this.a=0,this.b=0}increment(){const N=this.f();return N-this.a>this.d&&(this.a=N,this.b=0),this.b++,this.b}}e.IntervalCounter=H;class q{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((N,U)=>{this.a=N,this.b=U})}complete(N){return new Promise(U=>{this.a(N),this.f=!0,U()})}error(N){return new Promise(U=>{this.b(N),this.d=!0,U()})}cancel(){new Promise(N=>{this.b(new A.CancellationError),this.d=!0,N()})}}e.DeferredPromise=q;var M;(function(B){async function N(G){let te;const le=await Promise.all(G.map(j=>j.then(K=>K,K=>{te||(te=K)})));if(typeof te<"u")throw te;return le}B.settled=N;function U(G){return new Promise(async(te,le)=>{try{await G(te,le)}catch(j){le(j)}})}B.withAsyncBody=U})(M=e.Promises||(e.Promises={}));var ee;(function(B){B[B.Initial=0]="Initial",B[B.DoneOK=1]="DoneOK",B[B.DoneError=2]="DoneError"})(ee||(ee={}));class ie{static fromArray(N){return new ie(U=>{U.emitMany(N)})}static fromPromise(N){return new ie(async U=>{U.emitMany(await N)})}static fromPromises(N){return new ie(async U=>{await Promise.all(N.map(async G=>U.emitOne(await G)))})}static merge(N){return new ie(async U=>{await Promise.all(N.map(async G=>{for await(const te of G)U.emitOne(te)}))})}constructor(N){this.a=0,this.b=[],this.d=null,this.f=new l.Emitter,queueMicrotask(async()=>{const U={emitOne:G=>this.g(G),emitMany:G=>this.h(G),reject:G=>this.k(G)};try{await Promise.resolve(N(U)),this.j()}catch(G){this.k(G)}finally{U.emitOne=void 0,U.emitMany=void 0,U.reject=void 0}})}[Symbol.asyncIterator](){let N=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(N<this.b.length)return{done:!1,value:this.b[N++]};if(this.a===1)return{done:!0,value:void 0};await l.Event.toPromise(this.f.event)}while(!0)}}}static map(N,U){return new ie(async G=>{for await(const te of N)G.emitOne(U(te))})}map(N){return ie.map(this,N)}static filter(N,U){return new ie(async G=>{for await(const te of N)U(te)&&G.emitOne(te)})}filter(N){return ie.filter(this,N)}static coalesce(N){return ie.filter(N,U=>!!U)}coalesce(){return ie.coalesce(this)}static async toPromise(N){const U=[];for await(const G of N)U.push(G);return U}toPromise(){return ie.toPromise(this)}g(N){this.a===0&&(this.b.push(N),this.f.fire())}h(N){this.a===0&&(this.b=this.b.concat(N),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(N){this.a===0&&(this.a=2,this.d=N,this.f.fire())}}ie.EMPTY=ie.fromArray([]),e.AsyncIterableObject=ie;class me extends ie{constructor(N,U){super(U),this.l=N}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=me;function ne(B){const N=new E.CancellationTokenSource,U=B(N.token);return new me(N,async G=>{const te=N.token.onCancellationRequested(()=>{te.dispose(),N.dispose(),G.reject(new A.CancellationError)});try{for await(const le of U){if(N.token.isCancellationRequested)return;G.emitOne(le)}te.dispose(),N.dispose()}catch(le){te.dispose(),N.dispose(),G.reject(le)}})}e.createCancelableAsyncIterable=ne}),define(be[72],Ee([1,0,18,14,38,27,7,3,17]),function(oe,e,E,A,l,w,S,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function b(){return Object.create(null)}e.getEmptyExpression=b,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const k="[/\\\\]",I="[^/\\\\]",v=/\//g;function d(H,q){switch(H){case 0:return"";case 1:return`${I}*?`;default:return`(?:${k}|${I}+${k}${q?`|${k}${I}+`:""})*?`}}function m(H,q){if(!H)return[];const M=[];let ee=!1,ie=!1,me="";for(const ne of H){switch(ne){case q:if(!ee&&!ie){M.push(me),me="";continue}break;case"{":ee=!0;break;case"}":ee=!1;break;case"[":ie=!0;break;case"]":ie=!1;break}me+=ne}return me&&M.push(me),M}e.splitGlobAware=m;function p(H){if(!H)return"";let q="";const M=m(H,e.GLOB_SPLIT);if(M.every(ee=>ee===e.GLOBSTAR))q=".*";else{let ee=!1;M.forEach((ie,me)=>{if(ie===e.GLOBSTAR){if(ee)return;q+=d(2,me===M.length-1)}else{let ne=!1,B="",N=!1,U="";for(const G of ie){if(G!=="}"&&ne){B+=G;continue}if(N&&(G!=="]"||!U)){let te;G==="-"?te=G:(G==="^"||G==="!")&&!U?te="^":G===e.GLOB_SPLIT?te="":te=(0,y.escapeRegExpCharacters)(G),U+=te;continue}switch(G){case"{":ne=!0;continue;case"[":N=!0;continue;case"}":{q+=`(?:${m(B,",").map(j=>p(j)).join("|")})`,ne=!1,B="";break}case"]":{q+="["+U+"]",N=!1,U="";break}case"?":q+=I;continue;case"*":q+=d(1);continue;default:q+=(0,y.escapeRegExpCharacters)(G)}}me<M.length-1&&(M[me+1]!==e.GLOBSTAR||me+2<M.length)&&(q+=k)}ee=ie===e.GLOBSTAR})}return q}const c=/^\*\*\/\*\.[\w\.-]+$/,h=/^\*\*\/([\w\.-]+)\/?$/,g=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,f=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,D=/^\*\*((\/[\w\.-]+)+)\/?$/,R=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new w.LRUCache(1e4),r=function(){return!1},i=function(){return null};function n(H,q){if(!H)return i;let M;typeof H!="string"?M=H.pattern:M=H,M=M.trim();const ee=`${M}_${!!q.trimForExclusions}`;let ie=t.get(ee);if(ie)return o(ie,H);let me;return c.test(M)?ie=a(M.substr(4),M):(me=h.exec(u(M,q)))?ie=s(me[1],M):(q.trimForExclusions?f:g).test(M)?ie=C(M,q):(me=D.exec(u(M,q)))?ie=L(me[1].substr(1),M,!0):(me=R.exec(u(M,q)))?ie=L(me[1],M,!1):ie=O(M),t.set(ee,ie),o(ie,H)}function o(H,q){if(typeof q=="string")return H;const M=function(ee,ie){return(0,l.isEqualOrParent)(ee,q.base,!P.isLinux)?H((0,y.ltrim)(ee.substr(q.base.length),S.sep),ie):null};return M.allBasenames=H.allBasenames,M.allPaths=H.allPaths,M.basenames=H.basenames,M.patterns=H.patterns,M}function u(H,q){return q.trimForExclusions&&H.endsWith("/**")?H.substr(0,H.length-2):H}function a(H,q){return function(M,ee){return typeof M=="string"&&M.endsWith(H)?q:null}}function s(H,q){const M=`/${H}`,ee=`\\${H}`,ie=function(ne,B){return typeof ne!="string"?null:B?B===H?q:null:ne===H||ne.endsWith(M)||ne.endsWith(ee)?q:null},me=[H];return ie.basenames=me,ie.patterns=[q],ie.allBasenames=me,ie}function C(H,q){const M=z(H.slice(1,-1).split(",").map(B=>n(B,q)).filter(B=>B!==i),H),ee=M.length;if(!ee)return i;if(ee===1)return M[0];const ie=function(B,N){for(let U=0,G=M.length;U<G;U++)if(M[U](B,N))return H;return null},me=M.find(B=>!!B.allBasenames);me&&(ie.allBasenames=me.allBasenames);const ne=M.reduce((B,N)=>N.allPaths?B.concat(N.allPaths):B,[]);return ne.length&&(ie.allPaths=ne),ie}function L(H,q,M){const ee=S.sep===S.posix.sep,ie=ee?H:H.replace(v,S.sep),me=S.sep+ie,ne=S.posix.sep+H;let B;return M?B=function(N,U){return typeof N=="string"&&(N===ie||N.endsWith(me)||!ee&&(N===H||N.endsWith(ne)))?q:null}:B=function(N,U){return typeof N=="string"&&(N===ie||!ee&&N===H)?q:null},B.allPaths=[(M?"*/":"./")+H],B}function O(H){try{const q=new RegExp(`^${p(H)}$`);return function(M){return q.lastIndex=0,typeof M=="string"&&q.test(M)?H:null}}catch{return i}}function W(H,q,M){return!H||typeof q!="string"?!1:X(H)(q,void 0,M)}e.match=W;function X(H,q={}){if(!H)return r;if(typeof H=="string"||se(H)){const M=n(H,q);if(M===i)return r;const ee=function(ie,me){return!!M(ie,me)};return M.allBasenames&&(ee.allBasenames=M.allBasenames),M.allPaths&&(ee.allPaths=M.allPaths),ee}return V(H,q)}e.parse=X;function se(H){const q=H;return q?typeof q.base=="string"&&typeof q.pattern=="string":!1}e.isRelativePattern=se;function fe(H){return H.allBasenames||[]}e.getBasenameTerms=fe;function ce(H){return H.allPaths||[]}e.getPathTerms=ce;function V(H,q){const M=z(Object.getOwnPropertyNames(H).map(B=>T(B,H[B],q)).filter(B=>B!==i)),ee=M.length;if(!ee)return i;if(!M.some(B=>!!B.requiresSiblings)){if(ee===1)return M[0];const B=function(G,te){let le;for(let j=0,K=M.length;j<K;j++){const Q=M[j](G,te);if(typeof Q=="string")return Q;(0,A.isThenable)(Q)&&(le||(le=[]),le.push(Q))}return le?(async()=>{for(const j of le){const K=await j;if(typeof K=="string")return K}return null})():null},N=M.find(G=>!!G.allBasenames);N&&(B.allBasenames=N.allBasenames);const U=M.reduce((G,te)=>te.allPaths?G.concat(te.allPaths):G,[]);return U.length&&(B.allPaths=U),B}const ie=function(B,N,U){let G,te;for(let le=0,j=M.length;le<j;le++){const K=M[le];K.requiresSiblings&&U&&(N||(N=(0,S.basename)(B)),G||(G=N.substr(0,N.length-(0,S.extname)(B).length)));const Q=K(B,N,G,U);if(typeof Q=="string")return Q;(0,A.isThenable)(Q)&&(te||(te=[]),te.push(Q))}return te?(async()=>{for(const le of te){const j=await le;if(typeof j=="string")return j}return null})():null},me=M.find(B=>!!B.allBasenames);me&&(ie.allBasenames=me.allBasenames);const ne=M.reduce((B,N)=>N.allPaths?B.concat(N.allPaths):B,[]);return ne.length&&(ie.allPaths=ne),ie}function T(H,q,M){if(q===!1)return i;const ee=n(H,M);if(ee===i)return i;if(typeof q=="boolean")return ee;if(q){const ie=q.when;if(typeof ie=="string"){const me=(ne,B,N,U)=>{if(!U||!ee(ne,B))return null;const G=ie.replace("$(basename)",()=>N),te=U(G);return(0,A.isThenable)(te)?te.then(le=>le?H:null):te?H:null};return me.requiresSiblings=!0,me}}return ee}function z(H,q){const M=H.filter(B=>!!B.basenames);if(M.length<2)return H;const ee=M.reduce((B,N)=>{const U=N.basenames;return U?B.concat(U):B},[]);let ie;if(q){ie=[];for(let B=0,N=ee.length;B<N;B++)ie.push(q)}else ie=M.reduce((B,N)=>{const U=N.patterns;return U?B.concat(U):B},[]);const me=function(B,N){if(typeof B!="string")return null;if(!N){let G;for(G=B.length;G>0;G--){const te=B.charCodeAt(G-1);if(te===47||te===92)break}N=B.substr(G)}const U=ee.indexOf(N);return U!==-1?ie[U]:null};me.basenames=ee,me.patterns=ie,me.allBasenames=ee;const ne=H.filter(B=>!B.basenames);return ne.push(me),ne}function he(H,q){return(0,E.equals)(H,q,(M,ee)=>typeof M=="string"&&typeof ee=="string"?M===ee:typeof M!="string"&&typeof ee!="string"?M.base===ee.base&&M.pattern===ee.pattern:!1)}e.patternsEquals=he}),define(be[94],Ee([1,0,9,148,20,17,4]),function(oe,e,E,A,l,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var P;(function(c){c[c.Paragraph=0]="Paragraph",c[c.Break=1]="Break"})(P=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class y{constructor(h="",g=!1){if(this.value=h,typeof this.value!="string")throw(0,E.illegalArgument)("value");typeof g=="boolean"?(this.isTrusted=g,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=g.isTrusted??void 0,this.supportThemeIcons=g.supportThemeIcons??!1,this.supportHtml=g.supportHtml??!1)}appendText(h,g=0){return this.value+=v(this.supportThemeIcons?(0,A.escapeIcons)(h):h).replace(/([ \t]+)/g,(f,D)=>"&nbsp;".repeat(D.length)).replace(/\>/gm,"\\>").replace(/\n/g,g===1?`\\
`:`

`),this}appendMarkdown(h){return this.value+=h,this}appendCodeblock(h,g){return this.value+="\n```",this.value+=h,this.value+=`
`,this.value+=g,this.value+="\n```\n",this}appendLink(h,g,f){return this.value+="[",this.value+=this.c(g,"]"),this.value+="](",this.value+=this.c(String(h),")"),f&&(this.value+=` "${this.c(this.c(f,'"'),")")}"`),this.value+=")",this}c(h,g){const f=new RegExp((0,w.escapeRegExpCharacters)(g),"g");return h.replace(f,(D,R)=>h.charAt(R-1)!=="\\"?`\\${D}`:D)}}e.MarkdownString=y;function b(c){return k(c)?!c.value:Array.isArray(c)?c.every(b):!0}e.isEmptyMarkdownString=b;function k(c){return c instanceof y?!0:c&&typeof c=="object"?typeof c.value=="string"&&(typeof c.isTrusted=="boolean"||c.isTrusted===void 0)&&(typeof c.supportThemeIcons=="boolean"||c.supportThemeIcons===void 0):!1}e.isMarkdownString=k;function I(c,h){return c===h?!0:!c||!h?!1:c.value===h.value&&c.isTrusted===h.isTrusted&&c.supportThemeIcons===h.supportThemeIcons&&c.supportHtml===h.supportHtml&&(c.baseUri===h.baseUri||!!c.baseUri&&!!h.baseUri&&(0,l.isEqual)(S.URI.from(c.baseUri),S.URI.from(h.baseUri)))}e.markdownStringEqual=I;function v(c){return c.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=v;function d(c){return c.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=d;function m(c){return c&&c.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.removeMarkdownEscapes=m;function p(c){const h=[],g=c.split("|").map(D=>D.trim());c=g[0];const f=g[1];if(f){const D=/height=(\d+)/.exec(f),R=/width=(\d+)/.exec(f),t=D?D[1]:"",r=R?R[1]:"",i=isFinite(parseInt(r)),n=isFinite(parseInt(t));i&&h.push(`width="${r}"`),n&&h.push(`height="${t}"`)}return{href:c,dimensions:h}}e.parseHrefAndDimensions=p}),define(be[150],Ee([1,0,18,38,7,3,20,17]),function(oe,e,E,A,l,w,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function y(i,n){const{os:o,tildify:u,relative:a}=n;if(a){const L=b(i,a,o);if(typeof L=="string")return L}let s=i.fsPath;if(o===1&&!w.isWindows?s=s.replace(/\//g,"\\"):o!==1&&w.isWindows&&(s=s.replace(/\\/g,"/")),o!==1&&u?.userHome){const L=u.userHome.fsPath;let O;i.scheme!==u.userHome.scheme&&i.path.startsWith(l.posix.sep)?O=u.userHome.with({path:i.path}).fsPath:O=i.fsPath,s=v(O,L,o)}return(o===1?l.win32:l.posix).normalize(k(s,o===1))}e.getPathLabel=y;function b(i,n,o){const u=o===1?l.win32:l.posix,a=o===3?S.extUri:S.extUriIgnorePathCase,s=n.getWorkspace(),C=(0,E.firstOrDefault)(s.folders);if(!C)return;i.scheme!==C.uri.scheme&&i.path.startsWith(l.posix.sep)&&(i=C.uri.with({path:i.path}));const L=n.getWorkspaceFolder(i);if(!L)return;let O;if(a.isEqual(L.uri,i)?O="":O=a.relativePath(L.uri,i)??"",O&&(O=u.normalize(O)),s.folders.length>1&&!n.noPrefix){const W=L.name?L.name:a.basenameOrAuthority(L.uri);O=O?`${W} \u2022 ${O}`:W}return O}function k(i,n=w.isWindows){return(0,A.hasDriveLetter)(i,n)?i.charAt(0).toUpperCase()+i.slice(1):i}e.normalizeDriveLetter=k;let I=Object.create(null);function v(i,n,o=w.OS){if(o===1||!i||!n)return i;let u=I.original===n?I.normalized:void 0;u||(u=n,w.isWindows&&(u=(0,A.toSlashes)(u)),u=`${(0,P.rtrim)(u,l.posix.sep)}${l.posix.sep}`,I={original:n,normalized:u});let a=i;return w.isWindows&&(a=(0,A.toSlashes)(a)),(o===3?a.startsWith(u):(0,P.startsWithIgnoreCase)(a,u))?`~/${a.substr(u.length)}`:i}e.tildify=v;function d(i,n){return i.replace(/^~($|\/|\\)/,`${n}$1`)}e.untildify=d;const m="\u2026",p="\\\\",c="~";function h(i,n=l.sep){const o=new Array(i.length);let u=!1;for(let a=0;a<i.length;a++){const s=i[a];if(s===""){o[a]=`.${n}`;continue}if(!s){o[a]=s;continue}u=!0;let C="",L=s;L.indexOf(p)===0?(C=L.substr(0,L.indexOf(p)+p.length),L=L.substr(L.indexOf(p)+p.length)):L.indexOf(n)===0?(C=L.substr(0,L.indexOf(n)+n.length),L=L.substr(L.indexOf(n)+n.length)):L.indexOf(c)===0&&(C=L.substr(0,L.indexOf(c)+c.length),L=L.substr(L.indexOf(c)+c.length));const O=L.split(n);for(let W=1;u&&W<=O.length;W++)for(let X=O.length-W;u&&X>=0;X--){u=!1;let se=O.slice(X,X+W).join(n);for(let fe=0;!u&&fe<i.length;fe++)if(fe!==a&&i[fe]&&i[fe].indexOf(se)>-1){const ce=X+W===O.length,V=X>0&&i[fe].indexOf(n)>-1?n+se:se,T=i[fe].endsWith(V);u=!ce||T}if(!u){let fe="";(O[0].endsWith(":")||C!=="")&&(X===1&&(X=0,W++,se=O[0]+n+se),X>0&&(fe=O[0]+n),fe=C+fe),X>0&&(fe=fe+m+n),fe=fe+se,X+W<O.length&&(fe=fe+n+m),o[a]=fe}}u&&(o[a]=s)}return o}e.shorten=h;var g;(function(i){i[i.TEXT=0]="TEXT",i[i.VARIABLE=1]="VARIABLE",i[i.SEPARATOR=2]="SEPARATOR"})(g||(g={}));function f(i,n=Object.create(null)){const o=[];let u=!1,a="";for(const s of i)if(s==="$"||u&&s==="{")a&&o.push({value:a,type:g.TEXT}),a="",u=!0;else if(s==="}"&&u){const C=n[a];if(typeof C=="string")C.length&&o.push({value:C,type:g.VARIABLE});else if(C){const L=o[o.length-1];(!L||L.type!==g.SEPARATOR)&&o.push({value:C.label,type:g.SEPARATOR})}a="",u=!1}else a+=s;return a&&!u&&o.push({value:a,type:g.TEXT}),o.filter((s,C)=>{if(s.type===g.SEPARATOR){const L=o[C-1],O=o[C+1];return[L,O].every(W=>W&&(W.type===g.VARIABLE||W.type===g.TEXT)&&W.value.length>0)}return!0}).map(s=>s.value).join("")}e.template=f;function D(i,n){return w.isMacintosh||n?i.replace(/\(&&\w\)|&&/g,"").replace(/&/g,w.isMacintosh?"&":"&&"):i.replace(/&&|&/g,o=>o==="&"?"&&":"&")}e.mnemonicMenuLabel=D;function R(i,n){return w.isMacintosh||n?i.replace(/\(&&\w\)|&&/g,""):w.isWindows?i.replace(/&&|&/g,o=>o==="&"?"&&":"&"):i.replace(/&&/g,"_")}e.mnemonicButtonLabel=R;function t(i){return i.replace(/&/g,"&&")}e.unmnemonicLabel=t;function r(i){const n=i.indexOf("/")!==-1?l.posix:l.win32,o=n.basename(i),u=n.dirname(i);return o.length?{name:o,parentPath:u}:{name:u,parentPath:""}}e.splitName=r}),define(be[47],Ee([1,0,15,4]),function(oe,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function l(I){return I.toJSON()}class w{constructor(v){this.a=v}transformIncoming(v){const d=this.a.transformIncoming(v);return d===v?v:l(A.URI.from(d))}transformOutgoing(v){const d=this.a.transformOutgoing(v);return d===v?v:l(A.URI.from(d))}transformOutgoingURI(v){const d=this.a.transformOutgoing(v);return d===v?v:A.URI.from(d)}transformOutgoingScheme(v){return this.a.transformOutgoingScheme(v)}}e.URITransformer=w,e.DefaultURITransformer=new class{transformIncoming(I){return I}transformOutgoing(I){return I}transformOutgoingURI(I){return I}transformOutgoingScheme(I){return I}};function S(I,v,d){if(!I||d>200)return null;if(typeof I=="object"){if(I instanceof A.URI)return v.transformOutgoing(I);for(const m in I)if(Object.hasOwnProperty.call(I,m)){const p=S(I[m],v,d+1);p!==null&&(I[m]=p)}}return null}function P(I,v){const d=S(I,v,0);return d===null?I:d}e.transformOutgoingURIs=P;function y(I,v,d,m){if(!I||m>200)return null;if(typeof I=="object"){if(I.$mid===1)return d?A.URI.revive(v.transformIncoming(I)):v.transformIncoming(I);if(I instanceof E.VSBuffer)return null;for(const p in I)if(Object.hasOwnProperty.call(I,p)){const c=y(I[p],v,d,m+1);c!==null&&(I[p]=c)}}return null}function b(I,v){const d=y(I,v,!1,0);return d===null?I:d}e.transformIncomingURIs=b;function k(I,v){const d=y(I,v,!0,0);return d===null?I:d}e.transformAndReviveIncomingURIs=k}),define(be[21],Ee([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const E=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function A(l){return E.test(l)}e.isUUID=A,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let l;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?l=crypto.getRandomValues.bind(crypto):l=function(P){for(let y=0;y<P.length;y++)P[y]=Math.floor(Math.random()*256);return P};const w=new Uint8Array(16),S=[];for(let P=0;P<256;P++)S.push(P.toString(16).padStart(2,"0"));return function(){l(w),w[6]=w[6]&15|64,w[8]=w[8]&63|128;let y=0,b="";return b+=S[w[y++]],b+=S[w[y++]],b+=S[w[y++]],b+=S[w[y++]],b+="-",b+=S[w[y++]],b+=S[w[y++]],b+="-",b+=S[w[y++]],b+=S[w[y++]],b+="-",b+=S[w[y++]],b+=S[w[y++]],b+="-",b+=S[w[y++]],b+=S[w[y++]],b+=S[w[y++]],b+=S[w[y++]],b+=S[w[y++]],b+=S[w[y++]],b}}()}),define(be[151],Ee([1,0,18,21]),function(oe,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function l(P){return{id:(0,A.generateUuid)(),asString:async()=>P,asFile:()=>{},value:typeof P=="string"?P:void 0}}e.createStringDataTransferItem=l;function w(P,y,b){return{id:(0,A.generateUuid)(),asString:async()=>"",asFile:()=>({name:P,uri:y,data:b}),value:void 0}}e.createFileDataTransferItem=w;class S{constructor(){this.a=new Map}get size(){return this.a.size}has(y){return this.a.has(this.b(y))}get(y){return this.a.get(this.b(y))?.[0]}append(y,b){const k=this.a.get(y);k?k.push(b):this.a.set(this.b(y),[b])}replace(y,b){this.a.set(this.b(y),[b])}delete(y){this.a.delete(this.b(y))}*entries(){for(const[y,b]of this.a.entries())for(const k of b)yield[y,k]}values(){return Array.from(this.a.values()).flat()}forEach(y){for(const[b,k]of this.entries())y(k,b)}b(y){return y.toLowerCase()}}e.VSDataTransfer=S,e.UriList=Object.freeze({create:P=>(0,E.distinct)(P.map(y=>y.toString())).join(`\r
`),split:P=>P.split(`\r
`),parse:P=>e.UriList.split(P).filter(y=>!y.startsWith("#"))})}),function(){"use strict";function oe(e,E,A){function l(d){return new Promise(m=>E.exists(d,m))}function w(d){return new Promise((m,p)=>{const c=new Date;E.utimes(d,c,c,h=>h?p(h):m())})}function S(d){return new Promise((m,p)=>E.mkdir(d,{recursive:!0},c=>c&&c.code!=="EEXIST"?p(c):m(d)))}function P(d){return new Promise((m,p)=>E.rm(d,{recursive:!0,force:!0,maxRetries:3},c=>c?p(c):m()))}function y(d){return new Promise((m,p)=>E.readFile(d,"utf8",(c,h)=>c?p(c):m(h)))}function b(d,m){return new Promise((p,c)=>E.writeFile(d,m,"utf8",h=>h?c(h):p()))}async function k(d){const m=e.join(d,"languagepacks.json");try{return JSON.parse(await y(m))}catch{}}function I(d,m){try{for(;m;){if(d[m])return m;{const p=m.lastIndexOf("-");if(p>0)m=m.substring(0,p);else return}}}catch(p){console.error("Resolving language pack configuration failed.",p)}}function v(d,m,p,c,h){const g=function(f){return A.mark("code/didGenerateNls"),Promise.resolve({locale:f,availableLanguages:{}})};if(A.mark("code/willGenerateNls"),process.env.VSCODE_DEV||!d||!h||h==="en"||h==="en-us")return g(c);try{return k(m).then(f=>{if(!f||(h=I(f,h),!h))return g(c);const D=f[h];let R;return!D||typeof D.hash!="string"||!D.translations||typeof(R=D.translations.vscode)!="string"?g(c):l(R).then(t=>{if(!t)return g(c);const r=D.hash+"."+h,i=e.join(m,"clp",r),n=e.join(i,d),o=e.join(i,"tcf.json"),u=e.join(i,"corrupted.info"),a={locale:c,availableLanguages:{"*":h},_languagePackId:r,_translationsConfigFile:o,_cacheRoot:i,_corruptedFile:u,_resolvedLanguagePackCoreLocation:n};return l(u).then(s=>{let C;return s?C=P(i):C=Promise.resolve(void 0),C.then(()=>l(n).then(L=>L?(w(n).catch(()=>{}),A.mark("code/didGenerateNls"),a):S(n).then(()=>Promise.all([y(p),y(R)])).then(O=>{const W=JSON.parse(O[0]),X=JSON.parse(O[1]).contents,se=Object.keys(W.bundles),fe=[];for(const ce of se){const V=W.bundles[ce],T=Object.create(null);for(const z of V){const he=W.keys[z],H=W.messages[z],q=X[z];let M;if(q){M=[];for(let ee=0;ee<he.length;ee++){const ie=he[ee],me=typeof ie=="string"?ie:ie.key;let ne=q[me];ne===void 0&&(ne=H[ee]),M.push(ne)}}else M=H;T[z]=M}fe.push(b(e.join(n,ce.replace(/\//g,"!")+".nls.json"),JSON.stringify(T)))}return fe.push(b(o,JSON.stringify(D.translations))),Promise.all(fe)}).then(()=>(A.mark("code/didGenerateNls"),a)).catch(O=>(console.error("Generating translation files failed.",O),g(c)))))})})})}catch(f){return console.error("Generating translation files failed.",f),g(c)}}return{getNLSConfiguration:v}}if(typeof define=="function")define(be[152],Ee([95,33,42]),function(e,E,A){return oe(e,E,A)});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),E=require("fs"),A=require("../common/performance");module.exports=oe(e,E,A)}else throw new Error("Unknown context")}(),define(be[153],Ee([1,0,29]),function(oe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const A=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function l(S){const P=S.replace(/\-/g,":").toLowerCase();return!A.has(P)}function w(){const S=(0,E.networkInterfaces)();for(const P in S){const y=S[P];if(y){for(const{mac:b}of y)if(l(b))return b}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=w}),define(be[96],Ee([1,0,29,9,60,21,153]),function(oe,e,E,A,l,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{c(k){return this.a||(this.a=l.TernarySearchTree.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(k)}value(){if(this.b===void 0){let k=0,I=0;const v=(0,E.networkInterfaces)();for(const d in v){const m=v[d];if(m)for(const{mac:p,internal:c}of m)c||(I+=1,this.c(p.toUpperCase())&&(k+=1))}this.b=I>0?k/I:0}return this.b}};let P;async function y(){return P||(P=(async()=>await b()||w.generateUuid())()),P}e.getMachineId=y;async function b(){try{const k=await new Promise((v,d)=>{oe(["crypto"],v,d)}),I=(0,S.getMac)();return k.createHash("sha256").update(I,"utf8").digest("hex")}catch(k){A.onUnexpectedError(k);return}}}),define(be[22],Ee([1,0,33,29,290,14,38,90,7,3,20,4]),function(oe,e,E,A,l,w,S,P,y,b,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var v;(function(V){V[V.UNLINK=0]="UNLINK",V[V.MOVE=1]="MOVE"})(v=e.RimRafMode||(e.RimRafMode={}));async function d(V,T=v.UNLINK){if((0,S.isRootOrDriveLetter)(V))throw new Error("rimraf - will refuse to recursively delete root");return T===v.UNLINK?p(V):m(V)}async function m(V){try{const T=(0,S.randomPath)((0,A.tmpdir)());try{await E.promises.rename(V,T)}catch(z){return z.code==="ENOENT"?void 0:p(V)}p(T).catch(z=>{})}catch(T){if(T.code!=="ENOENT")throw T}}async function p(V){return(0,l.promisify)(E.rm)(V,{recursive:!0,force:!0,maxRetries:3})}function c(V){if((0,S.isRootOrDriveLetter)(V))throw new Error("rimraf - will refuse to recursively delete root");E.rmSync(V,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=c;async function h(V,T){return D(await(T?g(V):(0,l.promisify)(E.readdir)(V)))}async function g(V){try{return await(0,l.promisify)(E.readdir)(V,{withFileTypes:!0})}catch(he){console.warn("[node.js fs] readdir with filetypes failed with error: ",he)}const T=[],z=await h(V);for(const he of z){let H=!1,q=!1,M=!1;try{const ee=await e.Promises.lstat((0,y.join)(V,he));H=ee.isFile(),q=ee.isDirectory(),M=ee.isSymbolicLink()}catch(ee){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ee)}T.push({name:he,isFile:()=>H,isDirectory:()=>q,isSymbolicLink:()=>M})}return T}function f(V){return D(E.readdirSync(V))}e.readdirSync=f;function D(V){return V.map(T=>typeof T=="string"?b.isMacintosh?(0,P.normalizeNFC)(T):T:(T.name=b.isMacintosh?(0,P.normalizeNFC)(T.name):T.name,T))}async function R(V){const T=await h(V),z=[];for(const he of T)await r.existsDirectory((0,y.join)(V,he))&&z.push(he);return z}function t(V,T=1e3){return new Promise(z=>{let he=!1;const H=setInterval(()=>{he||(he=!0,E.access(V,q=>{he=!1,q&&(clearInterval(H),z(void 0))}))},T)})}e.whenDeleted=t;var r;(function(V){async function T(H){let q;try{if(q=await e.Promises.lstat(H),!q.isSymbolicLink())return{stat:q}}catch{}try{return{stat:await e.Promises.stat(H),symbolicLink:q?.isSymbolicLink()?{dangling:!1}:void 0}}catch(M){if(M.code==="ENOENT"&&q)return{stat:q,symbolicLink:{dangling:!0}};if(b.isWindows&&M.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(H)),symbolicLink:{dangling:!1}}}catch(ee){if(ee.code==="ENOENT"&&q)return{stat:q,symbolicLink:{dangling:!0}};throw ee}throw M}}V.stat=T;async function z(H){try{const{stat:q,symbolicLink:M}=await V.stat(H);return q.isFile()&&M?.dangling!==!0}catch{}return!1}V.existsFile=z;async function he(H){try{const{stat:q,symbolicLink:M}=await V.stat(H);return q.isDirectory()&&M?.dangling!==!0}catch{}return!1}V.existsDirectory=he})(r=e.SymlinkSupport||(e.SymlinkSupport={}));const i=new w.ResourceQueue;function n(V,T,z){return i.queueFor(I.URI.file(V),k.extUriBiasedIgnorePathCase).queue(()=>{const he=C(z);return new Promise((H,q)=>a(V,T,he,M=>M?q(M):H()))})}let o=!0;function u(V){o=V}e.configureFlushOnWrite=u;function a(V,T,z,he){if(!o)return E.writeFile(V,T,{mode:z.mode,flag:z.flag},he);E.open(V,z.flag,z.mode,(H,q)=>{if(H)return he(H);E.writeFile(q,T,M=>{if(M)return E.close(q,()=>he(M));E.fdatasync(q,ee=>(ee&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ee),u(!1)),E.close(q,ie=>he(ie))))})})}function s(V,T,z){const he=C(z);if(!o)return E.writeFileSync(V,T,{mode:he.mode,flag:he.flag});const H=E.openSync(V,he.flag,he.mode);try{E.writeFileSync(H,T);try{E.fdatasyncSync(H)}catch(q){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",q),u(!1)}}finally{E.closeSync(H)}}e.writeFileSync=s;function C(V){return V?{mode:typeof V.mode=="number"?V.mode:438,flag:typeof V.flag=="string"?V.flag:"w"}:{mode:438,flag:"w"}}async function L(V,T){if(V!==T)try{await e.Promises.rename(V,T)}catch(z){if(V.toLowerCase()!==T.toLowerCase()&&z.code==="EXDEV"||V.endsWith("."))await O(V,T,{preserveSymlinks:!1}),await d(V,v.MOVE);else throw z}}async function O(V,T,z){return X(V,T,{root:{source:V,target:T},options:z,handledSourcePaths:new Set})}const W=511;async function X(V,T,z){if(z.handledSourcePaths.has(V))return;z.handledSourcePaths.add(V);const{stat:he,symbolicLink:H}=await r.stat(V);if(H){if(z.options.preserveSymlinks)try{return await ce(V,T,z)}catch(q){console.warn("[node.js fs] copy of symlink failed: ",q)}if(H.dangling)return}return he.isDirectory()?se(V,T,he.mode&W,z):fe(V,T,he.mode&W)}async function se(V,T,z,he){await e.Promises.mkdir(T,{recursive:!0,mode:z});const H=await h(V);for(const q of H)await X((0,y.join)(V,q),(0,y.join)(T,q),he)}async function fe(V,T,z){await e.Promises.copyFile(V,T),await e.Promises.chmod(T,z)}async function ce(V,T,z){let he=await e.Promises.readlink(V);(0,S.isEqualOrParent)(he,z.root.source,!b.isLinux)&&(he=(0,y.join)(z.root.target,he.substr(z.root.source.length+1))),await e.Promises.symlink(he,T)}e.Promises=new class{get access(){return(0,l.promisify)(E.access)}get stat(){return(0,l.promisify)(E.stat)}get lstat(){return(0,l.promisify)(E.lstat)}get utimes(){return(0,l.promisify)(E.utimes)}get read(){return(V,T,z,he,H)=>new Promise((q,M)=>{E.read(V,T,z,he,H,(ee,ie,me)=>ee?M(ee):q({bytesRead:ie,buffer:me}))})}get readFile(){return(0,l.promisify)(E.readFile)}get write(){return(V,T,z,he,H)=>new Promise((q,M)=>{E.write(V,T,z,he,H,(ee,ie,me)=>ee?M(ee):q({bytesWritten:ie,buffer:me}))})}get appendFile(){return(0,l.promisify)(E.appendFile)}get fdatasync(){return(0,l.promisify)(E.fdatasync)}get truncate(){return(0,l.promisify)(E.truncate)}get rename(){return(0,l.promisify)(E.rename)}get copyFile(){return(0,l.promisify)(E.copyFile)}get open(){return(0,l.promisify)(E.open)}get close(){return(0,l.promisify)(E.close)}get symlink(){return(0,l.promisify)(E.symlink)}get readlink(){return(0,l.promisify)(E.readlink)}get chmod(){return(0,l.promisify)(E.chmod)}get mkdir(){return(0,l.promisify)(E.mkdir)}get unlink(){return(0,l.promisify)(E.unlink)}get rmdir(){return(0,l.promisify)(E.rmdir)}get realpath(){return(0,l.promisify)(E.realpath)}async exists(V){try{return await e.Promises.access(V),!0}catch{return!1}}get readdir(){return h}get readDirsInDir(){return R}get writeFile(){return n}get rm(){return d}get move(){return L}get copy(){return O}}}),define(be[154],Ee([1,0,33,7,3,17,22]),function(oe,e,E,A,l,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function P(v){if(l.isLinux)return v;const d=(0,A.dirname)(v);if(v===d)return v;const m=((0,A.basename)(v)||v).toLowerCase();try{const c=(0,S.readdirSync)(d).filter(h=>h.toLowerCase()===m);if(c.length===1){const h=P(d);if(h)return(0,A.join)(h,c[0])}else if(c.length>1){const h=c.indexOf(m);if(h>=0){const g=P(d);if(g)return(0,A.join)(g,c[h])}}}catch{}return null}e.realcaseSync=P;async function y(v){if(l.isLinux)return v;const d=(0,A.dirname)(v);if(v===d)return v;const m=((0,A.basename)(v)||v).toLowerCase();try{const c=(await S.Promises.readdir(d)).filter(h=>h.toLowerCase()===m);if(c.length===1){const h=await y(d);if(h)return(0,A.join)(h,c[0])}else if(c.length>1){const h=c.indexOf(m);if(h>=0){const g=await y(d);if(g)return(0,A.join)(g,c[h])}}}catch{}return null}e.realcase=y;async function b(v){try{return await S.Promises.realpath(v)}catch{const m=I(v);return await S.Promises.access(m,E.constants.R_OK),m}}e.realpath=b;function k(v){try{return E.realpathSync(v)}catch{const m=I(v);return E.accessSync(m,E.constants.R_OK),m}}e.realpathSync=k;function I(v){return(0,w.rtrim)((0,A.normalize)(v),A.sep)}}),define(be[155],Ee([1,0,97]),function(oe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function A(P,y,b,k=1){let I=!1;return new Promise(v=>{const d=setTimeout(()=>{if(!I)return I=!0,v(0)},b);l(P,y,k,m=>{if(!I)return I=!0,clearTimeout(d),v(m)})})}e.findFreePort=A;function l(P,y,b,k){if(y===0)return k(0);const I=new E.Socket;I.once("connect",()=>(S(I),l(P+b,y-1,b,k))),I.once("data",()=>{}),I.once("error",v=>(S(I),v.code!=="ECONNREFUSED"?l(P+b,y-1,b,k):k(P))),I.connect(P,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function w(P,y,b,k="127.0.0.1"){let I=!1,v,d=1;const m=E.createServer({pauseOnConnect:!0});function p(c,h){I||(I=!0,m.removeAllListeners(),m.close(),v&&clearTimeout(v),h(c))}return new Promise(c=>{v=setTimeout(()=>{p(0,c)},b),m.on("listening",()=>{p(P,c)}),m.on("error",h=>{h&&(h.code==="EADDRINUSE"||h.code==="EACCES")&&d<y?(P++,d++,m.listen(P,k)):p(0,c)}),m.on("close",()=>{p(0,c)}),m.listen(P,k)})}e.findFreePortFaster=w;function S(P){try{P.removeAllListeners("connect"),P.removeAllListeners("error"),P.end(),P.destroy(),P.unref()}catch(y){console.error(y)}}}),define(be[98],Ee([1,0,29,7,22]),function(oe,e,E,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const w=/^\d+$/,S=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var y;(function(D){D[D.x64=0]="x64",D[D.x86=1]="x86",D[D.ARM=2]="ARM"})(y||(y={}));let b;switch(process.arch){case"ia32":case"x32":b=1;break;case"arm":case"arm64":b=2;break;default:b=0;break}let k;process.env.PROCESSOR_ARCHITEW6432?k=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?k=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?k=1:k=0;class I{constructor(R,t,r){this.exePath=R,this.displayName=t,this.a=r}async exists(){return this.a===void 0&&(this.a=await l.SymlinkSupport.existsFile(this.exePath)),this.a}}function v({useAlternateBitness:D=!1}={}){return D?b===0?process.env["ProgramFiles(x86)"]||null:k===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function d({useAlternateBitness:D=!1,findPreview:R=!1}={}){const t=v({useAlternateBitness:D});if(!t)return null;const r=A.join(t,"PowerShell");if(!await l.SymlinkSupport.existsDirectory(r))return null;let i=-1,n=null;for(const a of await l.Promises.readdir(r)){let s=-1;if(R){const L=a.indexOf("-");if(L<0)continue;const O=a.substring(0,L);if(!w.test(O)||a.substring(L+1)!=="preview")continue;s=parseInt(O,10)}else{if(!w.test(a))continue;s=parseInt(a,10)}if(s<=i)continue;const C=A.join(r,a,"pwsh.exe");!await l.SymlinkSupport.existsFile(C)||(n=C,i=s)}if(!n)return null;const o=t.includes("x86")?" (x86)":"",u=R?" Preview":"";return new I(n,`PowerShell${u}${o}`,!0)}async function m({findPreview:D}={}){if(!process.env.LOCALAPPDATA)return null;const R=A.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await l.SymlinkSupport.existsDirectory(R))return null;const{pwshMsixDirRegex:t,pwshMsixName:r}=D?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:S,pwshMsixName:"PowerShell (Store)"};for(const i of await l.Promises.readdir(R))if(t.test(i)){const n=A.join(R,i,"pwsh.exe");return new I(n,r)}return null}function p(){const D=A.join(E.homedir(),".dotnet","tools","pwsh.exe");return new I(D,".NET Core PowerShell Global Tool")}function c(){const D=A.join(process.env.windir,b===1&&k!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new I(D,"Windows PowerShell",!0)}async function*h(){let D=await d();D&&(yield D),D=await d({useAlternateBitness:!0}),D&&(yield D),D=await m(),D&&(yield D),D=p(),D&&(yield D),D=await d({findPreview:!0}),D&&(yield D),D=await m({findPreview:!0}),D&&(yield D),D=await d({useAlternateBitness:!0,findPreview:!0}),D&&(yield D),D=c(),D&&(yield D)}async function*g(){for await(const D of h())await D.exists()&&(yield D)}e.enumeratePowerShellInstallations=g;async function f(){for await(const D of g())return D;return null}e.getFirstAvailablePowerShellInstallation=f}),define(be[99],Ee([1,0,7,3,28,58,8,22]),function(oe,e,E,A,l,w,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return w.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return w.TerminateResponseCode}});function y(I=l.env){return I.comspec||"cmd.exe"}e.getWindowsShell=y;function b(I){let v=[],d=!1;const m=function(p){if(d){v.push(p);return}(!I.send(p,h=>{if(h&&console.error(h),d=!1,v.length>0){const g=v.slice(0);v=[],g.forEach(f=>m(f))}})||A.isWindows)&&(d=!0)};return{send:m}}e.createQueuedSender=b;var k;(function(I){async function v(d,m,p){if(E.isAbsolute(d))return d;if(m===void 0&&(m=l.cwd()),E.dirname(d)!=="."||(p===void 0&&S.isString(l.env.PATH)&&(p=l.env.PATH.split(E.delimiter)),p===void 0||p.length===0))return E.join(m,d);async function h(g){if(await P.Promises.exists(g)){let f;try{f=await P.Promises.stat(g)}catch(D){D.message.startsWith("EACCES")&&(f=await P.Promises.lstat(g))}return f?!f.isDirectory():!1}return!1}for(const g of p){let f;if(E.isAbsolute(g)?f=E.join(g,d):f=E.join(m,g,d),await h(f))return f;let D=f+".com";if(await h(D)||(D=f+".exe",await h(D)))return D}return E.join(m,d)}I.findExecutable=v})(k=e.win32||(e.win32={}))}),define(be[100],Ee([1,0,48,13]),function(oe,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function l(S){return new Promise((P,y)=>{let b;const k=new Map;function I(d,m,p,c,h){const g=k.get(m);if(d===S||g){const f={name:v(p),cmd:p,pid:d,ppid:m,load:c,mem:h};k.set(d,f),d===S&&(b=f),g&&(g.children||(g.children=[]),g.children.push(f),g.children.length>1&&(g.children=g.children.sort((D,R)=>D.pid-R.pid)))}}function v(d){const m=/--vscode-window-kind=shared-process/i,p=/--vscode-window-kind=issue-reporter/i,c=/--vscode-window-kind=process-explorer/i,h=/--utility-sub-type=network/i,g=/--vscode-utility-kind=extensionHost/i,f=/--vscode-utility-kind=fileWatcher/i,D=/--vscode-utility-kind=shared-process/i,R=/--ms-enable-electron-run-as-node/i,t=/--crashes-directory/i,r=/\\pipe\\winpty-control/i,i=/conhost\.exe/i,n=/--type=([a-zA-Z-]+)/;if(t.exec(d))return"electron-crash-reporter";if(r.exec(d))return"winpty-process";if(i.exec(d))return"console-window-host (Windows internal process)";let o=n.exec(d);if(o&&o.length===2)return o[1]==="renderer"?m.exec(d)?"shared-process":p.exec(d)?"issue-reporter":c.exec(d)?"process-explorer":"window":o[1]==="utility"?h.exec(d)?"utility-network-service":g.exec(d)?"extension-host":f.exec(d)?"file-watcher":D.exec(d)?"shared-process":"utility-process":o[1]==="extensionHost"?"extension-host":o[1];const u=/[a-zA-Z-]+\.js/g;let a="";do o=u.exec(d),o&&(a+=o+" ");while(o);return a&&d.indexOf("node ")<0&&d.indexOf("node.exe")<0?`electron-nodejs (${a})`:R.exec(d)?`electron-nodejs (${d})`:d}if(process.platform==="win32"){const d=m=>m.indexOf("\\\\?\\")===0||m.indexOf("\\??\\")===0?m.substr(4):m.indexOf('"\\\\?\\')===0||m.indexOf('"\\??\\')===0?'"'+m.substr(5):m;new Promise((m,p)=>{oe(["windows-process-tree"],m,p)}).then(m=>{m.getProcessList(S,p=>{if(!p){y(new Error(`Root process ${S} not found`));return}m.getProcessCpuUsage(p,c=>{const h=new Map;c.forEach(g=>{const f=d(g.commandLine||"");h.set(g.pid,{name:v(f),cmd:f,pid:g.pid,ppid:g.ppid,load:g.cpu||0,mem:g.memory||0})}),b=h.get(S),b?(h.forEach(g=>{const f=h.get(g.ppid);f&&(f.children||(f.children=[]),f.children.push(g))}),h.forEach(g=>{g.children&&(g.children=g.children.sort((f,D)=>f.pid-D.pid))}),P(b)):y(new Error(`Root process ${S} not found`))})},m.ProcessDataFlag.CommandLine|m.ProcessDataFlag.Memory)})}else{let d=function(){let m=[b];const p=[];for(;m.length;){const h=m.shift();h&&(p.push(h.pid),h.children&&(m=m.concat(h.children)))}let c=JSON.stringify(A.FileAccess.asFileUri("vs/base/node/cpuUsage.sh").fsPath);c+=" "+p.join(" "),(0,E.exec)(c,{},(h,g,f)=>{if(h||f)y(h||new Error(f.toString()));else{const D=g.toString().split(`
`);for(let R=0;R<p.length;R++){const t=k.get(p[R]);t.load=parseFloat(D[R])}if(!b){y(new Error(`Root process ${S} not found`));return}P(b)}})};(0,E.exec)("which ps",{},(m,p,c)=>{if(m||c)if(process.platform!=="linux")y(m||new Error(c.toString()));else{const h=JSON.stringify(A.FileAccess.asFileUri("vs/base/node/ps.sh").fsPath);(0,E.exec)(h,{},(g,f,D)=>{g||D?y(g||new Error(D.toString())):(w(f,I),d())})}else{const h=p.toString().trim(),g="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,E.exec)(`${h} ${g}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(f,D,R)=>{f||R&&!R.includes("screen size is bogus")?y(f||new Error(R.toString())):(w(D,I),process.platform==="linux"?d():b?P(b):y(new Error(`Root process ${S} not found`)))})}})}})}e.listProcesses=l;function w(S,P){const y=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,b=S.toString().split(`
`);for(const k of b){const I=y.exec(k.trim());I&&I.length===6&&P(parseInt(I[1]),parseInt(I[2]),I[5],parseFloat(I[3]),parseFloat(I[4]))}}}),define(be[156],Ee([1,0,29,3,98,99]),function(oe,e,E,A,l,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShell=void 0;async function S(I,v){return I===1?A.isWindows?k():w.getWindowsShell(v):y(I,v)}e.getSystemShell=S;let P=null;function y(I,v){if(A.isLinux&&I===2||A.isMacintosh&&I===3)return"/bin/bash";if(!P){let d;if(A.isWindows)d="/bin/bash";else{if(d=v.SHELL,!d)try{d=(0,E.userInfo)().shell}catch{}d||(d="sh"),d==="/bin/false"&&(d="/bin/bash")}P=d}return P}let b=null;async function k(){return b||(b=(await(0,l.getFirstAvailablePowerShellInstallation)()).exePath),b}});var Te=this&&this.__decorate||function(oe,e,E,A){var l=arguments.length,w=l<3?e:A===null?A=Object.getOwnPropertyDescriptor(e,E):A,S;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")w=Reflect.decorate(oe,e,E,A);else for(var P=oe.length-1;P>=0;P--)(S=oe[P])&&(w=(l<3?S(w):l>3?S(e,E,w):S(e,E))||w);return l>3&&w&&Object.defineProperty(e,E,w),w};define(be[43],Ee([1,0,18,14,15,19,87,9,6,2,61,17,8]),function(oe,e,E,A,l,w,S,P,y,b,k,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var d;(function(q){q[q.Promise=100]="Promise",q[q.PromiseCancel=101]="PromiseCancel",q[q.EventListen=102]="EventListen",q[q.EventDispose=103]="EventDispose"})(d||(d={}));function m(q){switch(q){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var p;(function(q){q[q.Initialize=200]="Initialize",q[q.PromiseSuccess=201]="PromiseSuccess",q[q.PromiseError=202]="PromiseError",q[q.PromiseErrorObj=203]="PromiseErrorObj",q[q.EventFire=204]="EventFire"})(p||(p={}));function c(q){switch(q){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var h;(function(q){q[q.Uninitialized=0]="Uninitialized",q[q.Idle=1]="Idle"})(h||(h={}));function g(q){let M=0;for(let ee=0;;ee+=7){const ie=q.read(1);if(M|=(ie.buffer[0]&127)<<ee,!(ie.buffer[0]&128))return M}}const f=i(0);function D(q,M){if(M===0){q.write(f);return}let ee=0;for(let me=M;me!==0;me=me>>>7)ee++;const ie=l.VSBuffer.alloc(ee);for(let me=0;M!==0;me++)ie.buffer[me]=M&127,M=M>>>7,M>0&&(ie.buffer[me]|=128);q.write(ie)}class R{constructor(M){this.b=M,this.a=0}read(M){const ee=this.b.slice(this.a,this.a+M);return this.a+=ee.byteLength,ee}}e.BufferReader=R;class t{constructor(){this.a=[]}get buffer(){return l.VSBuffer.concat(this.a)}write(M){this.a.push(M)}}e.BufferWriter=t;var r;(function(q){q[q.Undefined=0]="Undefined",q[q.String=1]="String",q[q.Buffer=2]="Buffer",q[q.VSBuffer=3]="VSBuffer",q[q.Array=4]="Array",q[q.Object=5]="Object",q[q.Int=6]="Int"})(r||(r={}));function i(q){const M=l.VSBuffer.alloc(1);return M.writeUInt8(q,0),M}const n={Undefined:i(r.Undefined),String:i(r.String),Buffer:i(r.Buffer),VSBuffer:i(r.VSBuffer),Array:i(r.Array),Object:i(r.Object),Uint:i(r.Int)},o=typeof Buffer<"u";function u(q,M){if(typeof M>"u")q.write(n.Undefined);else if(typeof M=="string"){const ee=l.VSBuffer.fromString(M);q.write(n.String),D(q,ee.byteLength),q.write(ee)}else if(o&&Buffer.isBuffer(M)){const ee=l.VSBuffer.wrap(M);q.write(n.Buffer),D(q,ee.byteLength),q.write(ee)}else if(M instanceof l.VSBuffer)q.write(n.VSBuffer),D(q,M.byteLength),q.write(M);else if(Array.isArray(M)){q.write(n.Array),D(q,M.length);for(const ee of M)u(q,ee)}else if(typeof M=="number"&&(M|0)===M)q.write(n.Uint),D(q,M);else{const ee=l.VSBuffer.fromString(JSON.stringify(M));q.write(n.Object),D(q,ee.byteLength),q.write(ee)}}e.serialize=u;function a(q){switch(q.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return q.read(g(q)).toString();case r.Buffer:return q.read(g(q)).buffer;case r.VSBuffer:return q.read(g(q));case r.Array:{const ee=g(q),ie=[];for(let me=0;me<ee;me++)ie.push(a(q));return ie}case r.Object:return JSON.parse(q.read(g(q)).toString());case r.Int:return g(q)}}e.deserialize=a;class s{constructor(M,ee,ie=null,me=1e3){this.h=M,this.j=ee,this.k=ie,this.l=me,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(ne=>this.q(ne)),this.m({type:200})}registerChannel(M,ee){this.b.set(M,ee),setTimeout(()=>this.w(M),0)}m(M){switch(M.type){case 200:{const ee=this.o([M.type]);this.k?.logOutgoing(ee,0,1,c(M.type));return}case 201:case 202:case 204:case 203:{const ee=this.o([M.type,M.id],M.data);this.k?.logOutgoing(ee,M.id,1,c(M.type),M.data);return}}}o(M,ee=void 0){const ie=new t;return u(ie,M),u(ie,ee),this.p(ie.buffer)}p(M){try{return this.h.send(M),M.byteLength}catch{return 0}}q(M){const ee=new R(M),ie=a(ee),me=a(ee),ne=ie[0];switch(ne){case 100:return this.k?.logIncoming(M.byteLength,ie[1],1,`${m(ne)}: ${ie[2]}.${ie[3]}`,me),this.s({type:ne,id:ie[1],channelName:ie[2],name:ie[3],arg:me});case 102:return this.k?.logIncoming(M.byteLength,ie[1],1,`${m(ne)}: ${ie[2]}.${ie[3]}`,me),this.t({type:ne,id:ie[1],channelName:ie[2],name:ie[3],arg:me});case 101:return this.k?.logIncoming(M.byteLength,ie[1],1,`${m(ne)}`),this.u({type:ne,id:ie[1]});case 103:return this.k?.logIncoming(M.byteLength,ie[1],1,`${m(ne)}`),this.u({type:ne,id:ie[1]})}}s(M){const ee=this.b.get(M.channelName);if(!ee){this.v(M);return}const ie=new w.CancellationTokenSource;let me;try{me=ee.call(this.j,M.name,M.arg,ie.token)}catch(N){me=Promise.reject(N)}const ne=M.id;me.then(N=>{this.m({id:ne,data:N,type:201}),this.d.delete(M.id)},N=>{N instanceof Error?this.m({id:ne,data:{message:N.message,name:N.name,stack:N.stack?N.stack.split?N.stack.split(`
`):N.stack:void 0},type:202}):this.m({id:ne,data:N,type:203}),this.d.delete(M.id)});const B=(0,b.toDisposable)(()=>ie.cancel());this.d.set(M.id,B)}t(M){const ee=this.b.get(M.channelName);if(!ee){this.v(M);return}const ie=M.id,ne=ee.listen(this.j,M.name,M.arg)(B=>this.m({id:ie,data:B,type:204}));this.d.set(M.id,ne)}u(M){const ee=this.d.get(M.id);ee&&(ee.dispose(),this.d.delete(M.id))}v(M){let ee=this.g.get(M.channelName);ee||(ee=[],this.g.set(M.channelName,ee));const ie=setTimeout(()=>{console.error(`Unknown channel: ${M.channelName}`),M.type===100&&this.m({id:M.id,data:{name:"Unknown channel",message:`Channel name '${M.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);ee.push({request:M,timeoutTimer:ie})}w(M){const ee=this.g.get(M);if(ee){for(const ie of ee)switch(clearTimeout(ie.timeoutTimer),ie.request.type){case 100:this.s(ie.request);break;case 102:this.t(ie.request);break}this.g.delete(M)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,b.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=s;var C;(function(q){q[q.LocalSide=0]="LocalSide",q[q.OtherSide=1]="OtherSide"})(C=e.RequestInitiator||(e.RequestInitiator={}));class L{constructor(M,ee=null){this.l=M,this.a=!1,this.b=h.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new y.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ie=>this.s(ie)),this.j=ee}getChannel(M){const ee=this;return{call(ie,me,ne){return ee.a?Promise.reject(new P.CancellationError):ee.m(M,ie,me,ne)},listen(ie,me){return ee.a?y.Event.None:ee.o(M,ie,me)}}}m(M,ee,ie,me=w.CancellationToken.None){const ne=this.g++,N={id:ne,type:100,channelName:M,name:ee,arg:ie};if(me.isCancellationRequested)return Promise.reject(new P.CancellationError);let U;return new Promise((te,le)=>{if(me.isCancellationRequested)return le(new P.CancellationError);const j=()=>{const _=Y=>{switch(Y.type){case 201:this.f.delete(ne),te(Y.data);break;case 202:{this.f.delete(ne);const Z=new Error(Y.data.message);Z.stack=Array.isArray(Y.data.stack)?Y.data.stack.join(`
`):Y.data.stack,Z.name=Y.data.name,le(Z);break}case 203:this.f.delete(ne),le(Y.data);break}};this.f.set(ne,_),this.p(N)};let K=null;this.b===h.Idle?j():(K=(0,A.createCancelablePromise)(_=>this.u()),K.then(()=>{K=null,j()}));const Q=()=>{K?(K.cancel(),K=null):this.p({id:ne,type:101}),le(new P.CancellationError)},x=me.onCancellationRequested(Q);U=(0,b.combinedDisposable)((0,b.toDisposable)(Q),x),this.d.add(U)}).finally(()=>{this.d.delete(U)})}o(M,ee,ie){const me=this.g++,B={id:me,type:102,channelName:M,name:ee,arg:ie};let N=null;const U=new y.Emitter({onWillAddFirstListener:()=>{N=(0,A.createCancelablePromise)(te=>this.u()),N.then(()=>{N=null,this.d.add(U),this.p(B)})},onDidRemoveLastListener:()=>{N?(N.cancel(),N=null):(this.d.delete(U),this.p({id:me,type:103}))}}),G=te=>U.fire(te.data);return this.f.set(me,G),U.event}p(M){switch(M.type){case 100:case 102:{const ee=this.q([M.type,M.id,M.channelName,M.name],M.arg);this.j?.logOutgoing(ee,M.id,0,`${m(M.type)}: ${M.channelName}.${M.name}`,M.arg);return}case 101:case 103:{const ee=this.q([M.type,M.id]);this.j?.logOutgoing(ee,M.id,0,m(M.type));return}}}q(M,ee=void 0){const ie=new t;return u(ie,M),u(ie,ee),this.r(ie.buffer)}r(M){try{return this.l.send(M),M.byteLength}catch{return 0}}s(M){const ee=new R(M),ie=a(ee),me=a(ee),ne=ie[0];switch(ne){case 200:return this.j?.logIncoming(M.byteLength,0,0,c(ne)),this.t({type:ie[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(M.byteLength,ie[1],0,c(ne),me),this.t({type:ie[0],id:ie[1],data:me})}}t(M){if(M.type===200){this.b=h.Idle,this.k.fire();return}this.f.get(M.id)?.(M)}get onDidInitializePromise(){return y.Event.toPromise(this.onDidInitialize)}u(){return this.b===h.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,b.dispose)(this.d.values()),this.d.clear()}}Te([S.memoize],L.prototype,"onDidInitializePromise",null),e.ChannelClient=L;class O{get connections(){const M=[];return this.f.forEach(ee=>M.push(ee)),M}constructor(M){this.a=new Map,this.f=new Set,this.g=new y.Emitter,this.onDidAddConnection=this.g.event,this.h=new y.Emitter,this.onDidRemoveConnection=this.h.event,M(({protocol:ee,onDidClientDisconnect:ie})=>{y.Event.once(ee.onMessage)(ne=>{const B=new R(ne),N=a(B),U=new s(ee,N),G=new L(ee);this.a.forEach((le,j)=>U.registerChannel(j,le));const te={channelServer:U,channelClient:G,ctx:N};this.f.add(te),this.g.fire(te),ie(()=>{U.dispose(),G.dispose(),this.f.delete(te),this.h.fire(te)})})})}getChannel(M,ee){const ie=this;return{call(me,ne,B){let N;if((0,v.isFunction)(ee)){const G=(0,E.getRandomElement)(ie.connections.filter(ee));N=G?Promise.resolve(G):y.Event.toPromise(y.Event.filter(ie.onDidAddConnection,ee))}else N=ee.routeCall(ie,me,ne);const U=N.then(G=>G.channelClient.getChannel(M));return X(U).call(me,ne,B)},listen(me,ne){if((0,v.isFunction)(ee))return ie.j(M,ee,me,ne);const B=ee.routeEvent(ie,me,ne).then(N=>N.channelClient.getChannel(M));return X(B).listen(me,ne)}}}j(M,ee,ie,me){const ne=this;let B=new b.DisposableStore;const N=new y.Emitter({onWillAddFirstListener:()=>{B=new b.DisposableStore;const U=new y.EventMultiplexer,G=new Map,te=j=>{const Q=j.channelClient.getChannel(M).listen(ie,me),x=U.add(Q);G.set(j,x)},le=j=>{const K=G.get(j);!K||(K.dispose(),G.delete(j))};ne.connections.filter(ee).forEach(te),y.Event.filter(ne.onDidAddConnection,ee)(te,void 0,B),ne.onDidRemoveConnection(le,void 0,B),U.event(N.fire,N,B),B.add(U)},onDidRemoveLastListener:()=>{B.dispose()}});return N.event}registerChannel(M,ee){this.a.set(M,ee),this.f.forEach(ie=>{ie.channelServer.registerChannel(M,ee)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=O;class W{constructor(M,ee,ie=null){const me=new t;u(me,ee),M.send(me.buffer),this.a=new L(M,ie),this.d=new s(M,ee,ie)}getChannel(M){return this.a.getChannel(M)}registerChannel(M,ee){this.d.registerChannel(M,ee)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=W;function X(q){return{call(M,ee,ie){return q.then(me=>me.call(M,ee,ie))},listen(M,ee){const ie=new y.Relay;return q.then(me=>ie.input=me.listen(M,ee)),ie.event}}}e.getDelayedChannel=X;function se(q){let M=!1;return{call(ee,ie,me){return M?q.call(ee,ie,me):(0,A.timeout)(0).then(()=>M=!0).then(()=>q.call(ee,ie,me))},listen(ee,ie){if(M)return q.listen(ee,ie);const me=new y.Relay;return(0,A.timeout)(0).then(()=>M=!0).then(()=>me.input=q.listen(ee,ie)),me.event}}}e.getNextTickChannel=se;class fe{constructor(M){this.a=M}routeCall(M){return this.b(M)}routeEvent(M){return this.b(M)}async b(M){for(const ee of M.connections)if(await Promise.resolve(this.a(ee.ctx)))return Promise.resolve(ee);return await y.Event.toPromise(M.onDidAddConnection),await this.b(M)}}e.StaticRouter=fe;var ce;(function(q){function M(ne,B){const N=ne,U=B&&B.disableMarshalling,G=new Map;for(const te in N)ie(te)&&G.set(te,y.Event.buffer(N[te],!0));return new class{listen(te,le,j){const K=G.get(le);if(K)return K;if(me(le)){const Q=N[le];if(typeof Q=="function")return Q.call(N,j)}throw new Error(`Event not found: ${le}`)}call(te,le,j){const K=N[le];if(typeof K=="function"){if(!U&&Array.isArray(j))for(let Q=0;Q<j.length;Q++)j[Q]=(0,k.revive)(j[Q]);return K.apply(N,j)}throw new Error(`Method not found: ${le}`)}}}q.fromService=M;function ee(ne,B){const N=B&&B.disableMarshalling;return new Proxy({},{get(U,G){if(typeof G=="string")return B?.properties?.has(G)?B.properties.get(G):me(G)?function(te){return ne.listen(G,te)}:ie(G)?ne.listen(G):async function(...te){let le;B&&!(0,v.isUndefinedOrNull)(B.context)?le=[B.context,...te]:le=te;const j=await ne.call(G,le);return N?j:(0,k.revive)(j)};throw new Error(`Property not found: ${String(G)}`)}})}q.toService=ee;function ie(ne){return ne[0]==="o"&&ne[1]==="n"&&I.isUpperAsciiLetter(ne.charCodeAt(2))}function me(ne){return/^onDynamic/.test(ne)&&I.isUpperAsciiLetter(ne.charCodeAt(9))}})(ce=e.ProxyChannel||(e.ProxyChannel={}));const V=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function T(q){if(Array.isArray(q))return q;if(q&&typeof q=="object"&&typeof q.toString=="function"){const M=q.toString();if(M!=="[object Object]")return M}return q}function z(q){return Array.isArray(q)?q.map(T):T(q)}function he(q,M,ee,ie,me,ne,B){B=z(B);const N=V[me],U=N[ie%N.length];let G=[`%c[${q}]%c[${String(M).padStart(7," ")}]%c[len: ${String(ee).padStart(5," ")}]%c${String(ie).padStart(5," ")} - ${ne}`,"color: darkgreen","color: grey","color: grey",`color: ${U}`];/\($/.test(ne)?(G=G.concat(B),G.push(")")):G.push(B),console.log.apply(console,G)}class H{constructor(M,ee){this.d=M,this.f=ee,this.a=0,this.b=0}logOutgoing(M,ee,ie,me,ne){this.b+=M,he(this.d,this.b,M,ee,ie,me,ne)}logIncoming(M,ee,ie,me,ne){this.a+=M,he(this.f,this.a,M,ee,ie,me,ne)}}e.IPCLogger=H}),define(be[101],Ee([1,0,14,15,6,2,43]),function(oe,e,E,A,l,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.HighRoundTripTimeEvent=e.ConnectionHealthChangedEvent=e.connectionHealthToString=e.ConnectionHealth=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var P;(function(L){L.Created="created",L.Read="read",L.Write="write",L.Open="open",L.Error="error",L.Close="close",L.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",L.NodeEndReceived="nodeEndReceived",L.NodeEndSent="nodeEndSent",L.NodeDrainBegin="nodeDrainBegin",L.NodeDrainEnd="nodeDrainEnd",L.zlibInflateError="zlibInflateError",L.zlibInflateData="zlibInflateData",L.zlibInflateInitialWrite="zlibInflateInitialWrite",L.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",L.zlibInflateWrite="zlibInflateWrite",L.zlibInflateFlushFired="zlibInflateFlushFired",L.zlibDeflateError="zlibDeflateError",L.zlibDeflateData="zlibDeflateData",L.zlibDeflateWrite="zlibDeflateWrite",L.zlibDeflateFlushFired="zlibDeflateFlushFired",L.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",L.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",L.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",L.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",L.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",L.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",L.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",L.ProtocolHeaderRead="protocolHeaderRead",L.ProtocolMessageRead="protocolMessageRead",L.ProtocolHeaderWrite="protocolHeaderWrite",L.ProtocolMessageWrite="protocolMessageWrite",L.ProtocolWrite="protocolWrite"})(P=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var y;(function(L){L.enableDiagnostics=!1,L.records=[];const O=new WeakMap;let W=0;function X(fe,ce){if(!O.has(fe)){const V=String(++W);O.set(fe,V)}return O.get(fe)}function se(fe,ce,V,T){if(!L.enableDiagnostics)return;const z=X(fe,ce);if(T instanceof A.VSBuffer||T instanceof Uint8Array||T instanceof ArrayBuffer||ArrayBuffer.isView(T)){const he=A.VSBuffer.alloc(T.byteLength);he.set(T),L.records.push({timestamp:Date.now(),id:z,label:ce,type:V,buff:he})}else L.records.push({timestamp:Date.now(),id:z,label:ce,type:V,data:T})}L.traceSocketEvent=se})(y=e.SocketDiagnostics||(e.SocketDiagnostics={}));var b;(function(L){L[L.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",L[L.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(b=e.SocketCloseEventType||(e.SocketCloseEventType={}));let k=null;function I(){return k||(k=A.VSBuffer.alloc(0)),k}class v{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(O){this.a.push(O),this.b+=O.byteLength}read(O){return this.c(O,!0)}peek(O){return this.c(O,!1)}c(O,W){if(O===0)return I();if(O>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===O){const ce=this.a[0];return W&&(this.a.shift(),this.b-=O),ce}if(this.a[0].byteLength>O){const ce=this.a[0].slice(0,O);return W&&(this.a[0]=this.a[0].slice(O),this.b-=O),ce}const X=A.VSBuffer.alloc(O);let se=0,fe=0;for(;O>0;){const ce=this.a[fe];if(ce.byteLength>O){const V=ce.slice(0,O);X.set(V,se),se+=O,W&&(this.a[fe]=ce.slice(O),this.b-=O),O-=O}else X.set(ce,se),se+=ce.byteLength,W?(this.a.shift(),this.b-=ce.byteLength):fe++,O-=ce.byteLength}return X}}e.ChunkStream=v;var d;(function(L){L[L.None=0]="None",L[L.Regular=1]="Regular",L[L.Control=2]="Control",L[L.Ack=3]="Ack",L[L.Disconnect=5]="Disconnect",L[L.ReplayRequest=6]="ReplayRequest",L[L.Pause=7]="Pause",L[L.Resume=8]="Resume",L[L.KeepAlive=9]="KeepAlive",L[L.LatencyMeasurementRequest=10]="LatencyMeasurementRequest",L[L.LatencyMeasurementResponse=11]="LatencyMeasurementResponse"})(d||(d={}));function m(L){switch(L){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive";case 10:return"LatencyMeasurementRequest";case 11:return"LatencyMeasurementResponse"}}var p;(function(L){L[L.HeaderLength=13]="HeaderLength",L[L.AcknowledgeTime=2e3]="AcknowledgeTime",L[L.TimeoutTime=2e4]="TimeoutTime",L[L.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",L[L.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",L[L.KeepAliveSendTime=5e3]="KeepAliveSendTime",L[L.LatencySampleTime=6e4]="LatencySampleTime",L[L.LatencySampleCount=5]="LatencySampleCount",L[L.HighLatencyTimeThreshold=1e3]="HighLatencyTimeThreshold",L[L.HighLatencySampleThreshold=3]="HighLatencySampleThreshold"})(p=e.ProtocolConstants||(e.ProtocolConstants={}));class c{constructor(O,W,X,se){this.type=O,this.id=W,this.ack=X,this.data=se,this.writtenTime=0}get size(){return this.data.byteLength}}class h extends w.Disposable{constructor(O){super(),this.f=this.B(new l.Emitter),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=O,this.b=!1,this.c=new v,this.B(this.a.onData(W=>this.acceptChunk(W))),this.lastReadTime=Date.now()}acceptChunk(O){if(!(!O||O.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(O);this.c.byteLength>=this.g.readLen;){const W=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=W.readUInt32BE(9),this.g.messageType=W.readUInt8(0),this.g.id=W.readUInt32BE(1),this.g.ack=W.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:m(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const X=this.g.messageType,se=this.g.id,fe=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",W),this.f.fire(new c(X,se,fe,W)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class g{constructor(O){this.k=null,this.a=!1,this.b=!1,this.c=O,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(O){if(this.a)return;O.writtenTime=Date.now(),this.lastWriteTime=Date.now();const W=A.VSBuffer.alloc(13);W.writeUInt8(O.type,0),W.writeUInt32BE(O.id,1),W.writeUInt32BE(O.ack,5),W.writeUInt32BE(O.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:m(O.type),id:O.id,ack:O.ack,messageSize:O.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",O.data),this.j(W,O.data)}g(O,W){const X=this.f===0;return this.d.push(O,W),this.f+=O.byteLength+W.byteLength,X}h(){const O=A.VSBuffer.concat(this.d,this.f);return this.d.length=0,this.f=0,O}j(O,W){this.g(O,W)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const O=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:O.byteLength}),this.c.write(O)}}class f extends w.Disposable{constructor(O){super(),this.f=new l.Emitter,this.onMessage=this.f.event,this.g=new l.Emitter,this.onDidDispose=this.g.event,this.a=O,this.b=this.B(new g(this.a)),this.c=this.B(new h(this.a)),this.B(this.c.onMessage(W=>{W.type===1&&this.f.fire(W.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(O){this.b.write(new c(1,0,0,O))}}e.Protocol=f;class D extends S.IPCClient{static fromSocket(O,W){return new D(new f(O),W)}get onDidDispose(){return this.b.onDidDispose}constructor(O,W,X=null){super(O,W,X),this.b=O}dispose(){super.dispose();const O=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),O.end()}}e.Client=D;class R{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new l.Emitter({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(O){this.b?this.d.length>0?this.d.push(O):this.a.fire(O):this.d.push(O)}flushBuffer(){this.d=[]}}e.BufferedEmitter=R;class t{constructor(O){this.data=O,this.next=null}}class r{constructor(){this.a=null,this.b=null}length(){let O=0,W=this.a;for(;W;)W=W.next,O++;return O}peek(){return this.a?this.a.data:null}toArray(){const O=[];let W=0,X=this.a;for(;X;)O[W++]=X.data,X=X.next;return O}pop(){if(!!this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(O){const W=new t(O);if(!this.a){this.a=W,this.b=W;return}this.b.next=W,this.b=W}}class i{static getInstance(){return i.b||(i.b=new i),i.b}constructor(){this.c=[];const O=Date.now();for(let W=0;W<i.a;W++)this.c[W]=O-1e3*W;setInterval(()=>{for(let W=i.a;W>=1;W--)this.c[W]=this.c[W-1];this.c[0]=Date.now()},1e3)}d(){const O=Date.now(),W=(1+i.a)*1e3;let X=0;for(let se=0;se<i.a;se++)O-this.c[se]<=W&&X++;return 1-X/i.a}hasHighLoad(){return this.d()>=.5}}i.a=10,i.b=null;var n;(function(L){L[L.Good=0]="Good",L[L.Poor=1]="Poor"})(n=e.ConnectionHealth||(e.ConnectionHealth={}));function o(L){switch(L){case 0:return"good";case 1:return"poor"}}e.connectionHealthToString=o;class u{constructor(O){this.connectionHealth=O}}e.ConnectionHealthChangedEvent=u;class a{constructor(O,W){this.roundTripTime=O,this.recentHighRoundTripCount=W}}e.HighRoundTripTimeEvent=a;class s{get unacknowledgedCount(){return this.c-this.d}constructor(O){this.x=new R,this.onControlMessage=this.x.event,this.y=new R,this.onMessage=this.y.event,this.z=new R,this.onDidDispose=this.z.event,this.A=new R,this.onSocketClose=this.A.event,this.B=new R,this.onSocketTimeout=this.B.event,this.C=new R,this.onHighRoundTripTime=this.C.event,this.D=new R,this.onDidChangeConnectionHealth=this.D.event,this.u=O.loadEstimator??i.getInstance(),this.v=O.measureRoundTripTime??!1,this.w=O.sendKeepAlive??!0,this.a=!1,this.b=new r,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.t=new w.DisposableStore,this.o=O.socket,this.p=this.t.add(new g(this.o)),this.q=this.t.add(new h(this.o)),this.t.add(this.q.onMessage(W=>this.E(W))),this.t.add(this.o.onClose(W=>this.A.fire(W))),this.r=this.t.add(new C),this.t.add(this.r.onSendLatencyRequest(W=>this.J(W))),this.t.add(this.r.onHighRoundTripTime(W=>this.C.fire(W))),this.t.add(this.r.onDidChangeConnectionHealth(W=>this.D.fire(W))),this.v&&this.r.start(),O.initialChunk&&this.q.acceptChunk(O.initialChunk),this.w?this.l=setInterval(()=>{this.I()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.t.dispose()}drain(){return this.p.drain()}sendDisconnect(){const O=new c(5,0,0,I());this.p.write(O),this.p.flush()}sendPause(){const O=new c(7,0,0,I());this.p.write(O)}sendResume(){const O=new c(8,0,0,I());this.p.write(O)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(O,W){this.a=!0,this.t.dispose(),this.t=new w.DisposableStore,this.x.flushBuffer(),this.A.flushBuffer(),this.B.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=O,this.p=this.t.add(new g(this.o)),this.q=this.t.add(new h(this.o)),this.t.add(this.q.onMessage(X=>this.E(X))),this.t.add(this.o.onClose(X=>this.A.fire(X))),this.r=this.t.add(new C),this.t.add(this.r.onSendLatencyRequest(X=>this.J(X))),this.t.add(this.r.onHighRoundTripTime(X=>this.C.fire(X))),this.t.add(this.r.onDidChangeConnectionHealth(X=>this.D.fire(X))),this.q.acceptChunk(W)}endAcceptReconnection(){this.a=!1,this.v&&this.r.start(),this.h=this.g;const O=new c(3,0,this.h,I());this.p.write(O);const W=this.b.toArray();for(let X=0,se=W.length;X<se;X++)this.p.write(W[X]);this.G()}acceptDisconnect(){this.z.fire()}E(O){if(O.ack>this.d){this.d=O.ack;do{const W=this.b.peek();if(W&&W.id<=O.ack)this.b.pop();else break}while(!0)}switch(O.type){case 0:break;case 1:{if(O.id>this.g)if(O.id!==this.g+1){const W=Date.now();W-this.m>1e4&&(this.m=W,this.p.write(new c(6,0,0,I())))}else this.g=O.id,this.j=Date.now(),this.F(),this.y.fire(O.data);break}case 2:{this.x.fire(O.data);break}case 3:break;case 5:{this.z.fire();break}case 6:{const W=this.b.toArray();for(let X=0,se=W.length;X<se;X++)this.p.write(W[X]);this.G();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break;case 10:{this.K(O.data);break}case 11:{this.r.handleResponse(O.data);break}}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(O){const W=++this.c;this.h=this.g;const X=new c(1,W,this.h,O);this.b.push(X),this.a||(this.p.write(X),this.G())}sendControl(O){const W=new c(2,0,0,O);this.p.write(W)}F(){if(this.g<=this.h||this.k)return;const O=Date.now()-this.j;if(O>=2e3){this.H();return}this.k=setTimeout(()=>{this.k=null,this.F()},2e3-O+5)}G(){if(this.c<=this.d||this.f||this.a)return;const O=this.b.peek(),W=Date.now()-O.writtenTime,X=Date.now()-this.q.lastReadTime,se=Date.now()-this.n;if(W>=2e4&&X>=2e4&&se>=2e4&&!this.u.hasHighLoad()){this.n=Date.now(),this.B.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:W,timeSinceLastReceivedSomeData:X});return}const fe=Math.max(2e4-W,2e4-X,2e4-se,500);this.f=setTimeout(()=>{this.f=null,this.G()},fe)}H(){if(this.g<=this.h)return;this.h=this.g;const O=new c(3,0,this.h,I());this.p.write(O)}I(){this.h=this.g;const O=new c(9,0,this.h,I());this.p.write(O)}J(O){this.h=this.g;const W=new c(10,0,this.h,O);this.p.write(W)}K(O){this.h=this.g;const W=new c(11,0,this.h,O);this.p.write(W)}}e.PersistentProtocol=s;class C extends w.Disposable{constructor(){super(),this.a=this.B(new l.Emitter),this.onSendLatencyRequest=this.a.event,this.b=this.B(new l.Emitter),this.onHighRoundTripTime=this.b.event,this.c=this.B(new l.Emitter),this.onDidChangeConnectionHealth=this.c.event,this.f=this.B(new E.IntervalTimer),this.g=-1,this.h=0,this.j=Array.from({length:5},O=>0),this.k=0,this.l=0}start(){this.f.cancelAndSet(()=>{this.g=Date.now();const O=++this.h,W=A.VSBuffer.alloc(4);W.writeUInt32BE(O,0),this.a.fire(W)},6e4)}handleResponse(O){if(O.byteLength!==4)return;const W=O.readUInt32BE(0);if(this.g<=0||W!==this.h)return;const X=Date.now()-this.g,se=this.k++;this.j[se%this.j.length]=X;const fe=this.l,ce=this.j.filter(V=>V>=1e3).length;this.l=ce>=3?1:0,X>1e3&&this.b.fire(new a(X,ce)),fe!==this.l&&this.c.fire(this.l)}}}),define(be[102],Ee([1,0,48,14,15,19,149,9,6,2,23,99,58,43]),function(oe,e,E,A,l,w,S,P,y,b,k,I,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class m extends d.ChannelServer{constructor(h){super({send:g=>{try{process.send?.(g.buffer.toString("base64"))}catch{}},onMessage:y.Event.fromNodeEventEmitter(process,"message",g=>l.VSBuffer.wrap(Buffer.from(g,"base64")))},h),process.once("disconnect",()=>this.dispose())}}e.Server=m;class p{constructor(h,g){this.i=h,this.j=g,this.c=new Set,this.g=new Map,this.h=new y.Emitter,this.onDidProcessExit=this.h.event;const f=g&&g.timeout?g.timeout:6e4;this.b=new A.Delayer(f),this.d=null,this.f=null}getChannel(h){const g=this;return{call(f,D,R){return g.k(h,f,D,R)},listen(f,D){return g.l(h,f,D)}}}k(h,g,f,D=w.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(D.isCancellationRequested)return Promise.reject(P.canceled());this.b.cancel();const R=this.n(h),t=(0,A.createCancelablePromise)(n=>R.call(g,f,n)),r=D.onCancellationRequested(()=>t.cancel()),i=(0,b.toDisposable)(()=>t.cancel());return this.c.add(i),t.finally(()=>{r.dispose(),this.c.delete(i),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),t}l(h,g,f){if(!this.b)return y.Event.None;this.b.cancel();let D;const R=new y.Emitter({onWillAddFirstListener:()=>{D=this.n(h).listen(g,f)(R.fire,R),this.c.add(D)},onDidRemoveLastListener:()=>{this.c.delete(D),D.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return R.event}get m(){if(!this.f){const h=this.j&&this.j.args?this.j.args:[],g=Object.create(null);g.env={...(0,k.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(g.env={...g.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(g.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(g.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(g.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),g.execArgv===void 0&&(g.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o)).filter(o=>!o.startsWith("--vscode-"))),(0,v.removeDangerousEnvVariables)(g.env),this.d=(0,E.fork)(this.i,h,g);const f=new y.Emitter;y.Event.fromNodeEventEmitter(this.d,"message",o=>o)(o=>{if((0,S.isRemoteConsoleLog)(o)){(0,S.log)(o,`IPC Library: ${this.j.serverName}`);return}f.fire(l.VSBuffer.wrap(Buffer.from(o,"base64")))});const R=this.j.useQueue?(0,I.createQueuedSender)(this.d):this.d,t=o=>this.d&&this.d.connected&&R.send(o.buffer.toString("base64")),r=f.event,i={send:t,onMessage:r};this.f=new d.ChannelClient(i);const n=()=>this.o();process.once("exit",n),this.d.on("error",o=>console.warn('IPC "'+this.j.serverName+'" errored with '+o)),this.d.on("exit",(o,u)=>{process.removeListener("exit",n),this.c.forEach(a=>(0,b.dispose)(a)),this.c.clear(),o!==0&&u!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+o+" and signal "+u),this.b?.cancel(),this.o(),this.h.fire({code:o,signal:u})})}return this.f}n(h){let g=this.g.get(h);return g||(g=this.m.getChannel(h),this.g.set(h,g)),g}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.Client=p}),define(be[62],Ee([1,0,15,9,6,2,7,3,21,43,101]),function(oe,e,E,A,l,w,S,P,y,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function I(){return{crypto:globalThis._VSCODE_NODE_MODULES.crypto,zlib:globalThis._VSCODE_NODE_MODULES.zlib,net:globalThis._VSCODE_NODE_MODULES.net,os:globalThis._VSCODE_NODE_MODULES.os}}class v{traceSocketEvent(a,s){k.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,a,s)}constructor(a,s=""){this.f=!0,this.debugLabel=s,this.socket=a,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=C=>{if(this.traceSocketEvent("error",{code:C?.code,message:C?.message}),C){if(C.code==="EPIPE")return;(0,A.onUnexpectedError)(C)}},this.socket.on("error",this.a),this.b=C=>{this.traceSocketEvent("close",{hadError:C}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(a){const s=C=>{this.traceSocketEvent("read",C),a(E.VSBuffer.wrap(C))};return this.socket.on("data",s),{dispose:()=>this.socket.off("data",s)}}onClose(a){const s=C=>{a({type:0,hadError:C,error:void 0})};return this.socket.on("close",s),{dispose:()=>this.socket.off("close",s)}}onEnd(a){const s=()=>{a()};return this.socket.on("end",s),{dispose:()=>this.socket.off("end",s)}}write(a){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",a),this.socket.write(a.buffer,s=>{if(s){if(s.code==="EPIPE")return;(0,A.onUnexpectedError)(s)}})}catch(s){if(s.code==="EPIPE")return;(0,A.onUnexpectedError)(s)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((a,s)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),a();return}const C=()=>{this.socket.off("close",C),this.socket.off("end",C),this.socket.off("error",C),this.socket.off("timeout",C),this.socket.off("drain",C),this.traceSocketEvent("nodeDrainEnd"),a()};this.socket.on("close",C),this.socket.on("end",C),this.socket.on("error",C),this.socket.on("timeout",C),this.socket.on("drain",C)})}}e.NodeSocket=v;var d;(function(u){u[u.MinHeaderByteSize=2]="MinHeaderByteSize",u[u.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(d||(d={}));var m;(function(u){u[u.PeekHeader=1]="PeekHeader",u[u.ReadHeader=2]="ReadHeader",u[u.ReadBody=3]="ReadBody",u[u.Fin=4]="Fin"})(m||(m={}));class p extends w.Disposable{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(a,s){this.socket.traceSocketEvent(a,s)}constructor(a,s,C,L){super(),this.f=this.B(new l.Emitter),this.g=this.B(new l.Emitter),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=a,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:s,inflateBytesLength:C?.byteLength||0,recordInflateBytes:L}),this.a=this.B(new c(this,s,C,L,this.f,(O,W)=>this.k(O,W))),this.B(this.a.onError(O=>{console.error(O),(0,A.onUnexpectedError)(O),this.g.fire({type:0,hadError:!0,error:O})})),this.b=new k.ChunkStream,this.B(this.socket.onData(O=>this.l(O))),this.B(this.socket.onClose(async O=>{this.a.isProcessingReadQueue()&&await l.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(O)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(a){return this.f.event(a)}onClose(a){return this.g.event(a)}onEnd(a){return this.socket.onEnd(a)}write(a){let s=0;for(;s<a.byteLength;)this.a.writeMessage(a.slice(s,Math.min(s+262144,a.byteLength))),s+=262144}k(a,s){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",a);let C=2;a.byteLength<126?C+=0:a.byteLength<2**16?C+=2:C+=8;const L=E.VSBuffer.alloc(C);if(s?L.writeUInt8(194,0):L.writeUInt8(130,0),a.byteLength<126)L.writeUInt8(a.byteLength,1);else if(a.byteLength<2**16){L.writeUInt8(126,1);let O=1;L.writeUInt8(a.byteLength>>>8&255,++O),L.writeUInt8(a.byteLength>>>0&255,++O)}else{L.writeUInt8(127,1);let O=1;L.writeUInt8(0,++O),L.writeUInt8(0,++O),L.writeUInt8(0,++O),L.writeUInt8(0,++O),L.writeUInt8(a.byteLength>>>24&255,++O),L.writeUInt8(a.byteLength>>>16&255,++O),L.writeUInt8(a.byteLength>>>8&255,++O),L.writeUInt8(a.byteLength>>>0&255,++O)}this.socket.write(E.VSBuffer.concat([L,a]))}end(){this.h=!0,this.socket.end()}l(a){if(a.byteLength!==0){for(this.b.acceptChunk(a);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const s=this.b.peek(this.j.readLen),C=s.readUInt8(0),L=(C&128)>>>7,O=(C&64)>>>6,W=s.readUInt8(1),X=(W&128)>>>7,se=W&127;this.j.state=2,this.j.readLen=2+(X?4:0)+(se===126?2:0)+(se===127?8:0),this.j.fin=L,this.j.firstFrameOfMessage&&(this.j.compressed=Boolean(O)),this.j.firstFrameOfMessage=Boolean(L),this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const s=this.b.read(this.j.readLen),C=s.readUInt8(1),L=(C&128)>>>7;let O=C&127,W=1;O===126?O=s.readUInt8(++W)*2**8+s.readUInt8(++W):O===127&&(O=s.readUInt8(++W)*0+s.readUInt8(++W)*0+s.readUInt8(++W)*0+s.readUInt8(++W)*0+s.readUInt8(++W)*2**24+s.readUInt8(++W)*2**16+s.readUInt8(++W)*2**8+s.readUInt8(++W));let X=0;L&&(X=s.readUInt8(++W)*2**24+s.readUInt8(++W)*2**16+s.readUInt8(++W)*2**8+s.readUInt8(++W)),this.j.state=3,this.j.readLen=O,this.j.mask=X,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const s=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",s),f(s,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",s),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(s,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await l.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=p;class c extends w.Disposable{get permessageDeflate(){return Boolean(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:E.VSBuffer.alloc(0)}constructor(a,s,C,L,O,W){super(),this.l=a,this.m=O,this.n=W,this.a=this.B(new l.Emitter),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new l.Emitter),this.onDidFinishProcessingReadQueue=this.j.event,this.k=this.B(new l.Emitter),this.onDidFinishProcessingWriteQueue=this.k.event,this.p=!1,this.t=!1,s?(this.b=this.B(new h(this.l,L,C,{windowBits:15})),this.f=this.B(new g(this.l,{windowBits:15})),this.B(this.b.onError(X=>this.a.fire(X))),this.B(this.f.onError(X=>this.a.fire(X)))):(this.b=null,this.f=null)}writeMessage(a){this.g.push(a),this.r()}async r(){if(!this.p){for(this.p=!0;this.g.length>0;){const a=this.g.shift();if(this.f){const s=await this.s(this.f,a);this.n(s,!0)}else this.n(a,!1)}this.p=!1,this.k.fire()}}isProcessingWriteQueue(){return this.p}s(a,s){return new Promise((C,L)=>{a.write(s),a.flush(O=>C(O))})}acceptFrame(a,s,C){this.h.push({data:a,isCompressed:s,isLastFrameOfMessage:C}),this.u()}async u(){if(!this.t){for(this.t=!0;this.h.length>0;){const a=this.h.shift();if(this.b&&a.isCompressed){const s=await this.w(this.b,a.data,a.isLastFrameOfMessage);this.m.fire(s)}else this.m.fire(a.data)}this.t=!1,this.j.fire()}}isProcessingReadQueue(){return this.t}w(a,s,C){return new Promise((L,O)=>{a.write(s),C&&a.write(E.VSBuffer.fromByteArray([0,0,255,255])),a.flush(W=>L(W))})}}class h extends w.Disposable{get recordedInflateBytes(){return this.j?E.VSBuffer.concat(this.f):E.VSBuffer.alloc(0)}constructor(a,s,C,L){super(),this.h=a,this.j=s,this.a=this.B(new l.Emitter),this.onError=this.a.event,this.f=[],this.g=[],this.b=I().zlib.createInflateRaw(L),this.b.on("error",O=>{this.h.traceSocketEvent("zlibInflateError",{message:O?.message,code:O?.code}),this.a.fire(O)}),this.b.on("data",O=>{this.h.traceSocketEvent("zlibInflateData",O),this.g.push(E.VSBuffer.wrap(O))}),C&&(this.h.traceSocketEvent("zlibInflateInitialWrite",C.buffer),this.b.write(C.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(a){this.j&&this.f.push(a.clone()),this.h.traceSocketEvent("zlibInflateWrite",a),this.b.write(a.buffer)}flush(a){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const s=E.VSBuffer.concat(this.g);this.g.length=0,a(s)})}}class g extends w.Disposable{constructor(a,s){super(),this.g=a,this.a=this.B(new l.Emitter),this.onError=this.a.event,this.f=[],this.b=I().zlib.createDeflateRaw({windowBits:15}),this.b.on("error",C=>{this.g.traceSocketEvent("zlibDeflateError",{message:C?.message,code:C?.code}),this.a.fire(C)}),this.b.on("data",C=>{this.g.traceSocketEvent("zlibDeflateData",C),this.f.push(E.VSBuffer.wrap(C))})}write(a){this.g.traceSocketEvent("zlibDeflateWrite",a.buffer),this.b.write(a.buffer)}flush(a){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let s=E.VSBuffer.concat(this.f);this.f.length=0,s=s.slice(0,s.byteLength-4),a(s)})}}function f(u,a){if(a===0)return;const s=u.byteLength>>>2;for(let se=0;se<s;se++){const fe=u.readUInt32BE(se*4);u.writeUInt32BE(fe^a,se*4)}const C=s*4,L=u.byteLength-C,O=a>>>24&255,W=a>>>16&255,X=a>>>8&255;L>=1&&u.writeUInt8(u.readUInt8(C)^O,C),L>=2&&u.writeUInt8(u.readUInt8(C+1)^W,C+1),L>=3&&u.writeUInt8(u.readUInt8(C+2)^X,C+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const D={[2]:107,[1]:103};function R(){const u=(0,y.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${u}-sock`;let a;return e.XDG_RUNTIME_DIR?a=(0,S.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${u}.sock`):a=(0,S.join)(I().os.tmpdir(),`vscode-ipc-${u}.sock`),r(a),a}e.createRandomIPCHandle=R;function t(u,a,s){const C=I().crypto.createHash("md5").update(u).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${C}-${s}-${a}-sock`;const L=s.substr(0,4),O=a.substr(0,6),W=C.substr(0,8);let X;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?X=(0,S.join)(e.XDG_RUNTIME_DIR,`vscode-${W}-${L}-${O}.sock`):X=(0,S.join)(u,`${L}-${O}.sock`),r(X),X}e.createStaticIPCHandle=t;function r(u){const a=D[P.platform];typeof a=="number"&&u.length>=a&&console.warn(`WARNING: IPC handle "${u}" is longer than ${a} chars, try a shorter --user-data-dir`)}class i extends b.IPCServer{static b(a){const s=l.Event.fromNodeEventEmitter(a,"connection");return l.Event.map(s,C=>({protocol:new k.Protocol(new v(C,"ipc-server-connection")),onDidClientDisconnect:l.Event.once(l.Event.fromNodeEventEmitter(C,"close"))}))}constructor(a){super(i.b(a)),this.d=a}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.Server=i;function n(u){return new Promise((a,s)=>{const C=I().net.createServer();C.on("error",s),C.listen(u,()=>{C.removeListener("error",s),a(new i(C))})})}e.serve=n;function o(u,a){return new Promise((s,C)=>{const L=I().net.createConnection(u,()=>{L.removeListener("error",C),s(k.Client.fromSocket(new v(L,`ipc-client${a}`),a))});L.once("error",C)})}e.connect=o}),define(be[157],Ee([1,0,14,6,2,8]),function(oe,e,E,A,l,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var S;(function(I){I[I.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",I[I.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(S=e.StorageHint||(e.StorageHint={}));function P(I){const v=I;return v?.changed instanceof Map||v?.deleted instanceof Set}e.isStorageItemsChangeEvent=P;var y;(function(I){I[I.None=0]="None",I[I.Initialized=1]="Initialized",I[I.Closed=2]="Closed"})(y=e.StorageState||(e.StorageState={}));class b extends l.Disposable{constructor(v,d=Object.create(null)){super(),this.m=v,this.n=d,this.b=this.B(new A.Emitter),this.onDidChangeStorage=this.b.event,this.c=y.None,this.f=new Map,this.g=new E.ThrottledDelayer(b.a),this.h=new Set,this.j=new Map,this.k=void 0,this.l=[],this.p()}p(){this.B(this.m.onDidChangeItemsExternal(v=>this.r(v)))}r(v){v.changed?.forEach((d,m)=>this.s(m,d)),v.deleted?.forEach(d=>this.s(d,void 0))}s(v,d){if(this.c===y.Closed)return;let m=!1;(0,w.isUndefinedOrNull)(d)?m=this.f.delete(v):this.f.get(v)!==d&&(this.f.set(v,d),m=!0),m&&this.b.fire(v)}get items(){return this.f}get size(){return this.f.size}async init(){this.c===y.None&&(this.c=y.Initialized,this.n.hint!==S.STORAGE_DOES_NOT_EXIST&&(this.f=await this.m.getItems()))}get(v,d){const m=this.f.get(v);return(0,w.isUndefinedOrNull)(m)?d:m}getBoolean(v,d){const m=this.get(v);return(0,w.isUndefinedOrNull)(m)?d:m==="true"}getNumber(v,d){const m=this.get(v);return(0,w.isUndefinedOrNull)(m)?d:parseInt(m,10)}async set(v,d){if(this.c===y.Closed)return;if((0,w.isUndefinedOrNull)(d))return this.delete(v);const m=String(d);if(this.f.get(v)!==m)return this.f.set(v,m),this.j.set(v,m),this.h.delete(v),this.b.fire(v),this.w()}async delete(v){if(!(this.c===y.Closed||!this.f.delete(v)))return this.h.has(v)||this.h.add(v),this.j.delete(v),this.b.fire(v),this.w()}async close(){return this.k||(this.k=this.t()),this.k}async t(){this.c=y.Closed;try{await this.w(0)}catch{}await this.m.close(()=>this.f)}get u(){return this.j.size>0||this.h.size>0}async v(){if(!this.u)return;const v={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.m.updateItems(v).finally(()=>{if(!this.u)for(;this.l.length;)this.l.pop()?.()})}async flush(v){if(!!this.u)return this.w(v)}async w(v){return this.g.trigger(()=>this.v(),v)}async whenFlushed(){if(!!this.u)return new Promise(v=>this.l.push(v))}isInMemory(){return this.n.hint===S.STORAGE_IN_MEMORY}dispose(){this.g.dispose(),super.dispose()}}b.a=100,e.Storage=b;class k{constructor(){this.onDidChangeItemsExternal=A.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(v){v.insert?.forEach((d,m)=>this.a.set(m,d)),v.delete?.forEach(d=>this.a.delete(d))}async close(){}}e.InMemoryStorageDatabase=k}),define(be[103],Ee([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class E{constructor(l,w){this.lineNumber=l,this.column=w}with(l=this.lineNumber,w=this.column){return l===this.lineNumber&&w===this.column?this:new E(l,w)}delta(l=0,w=0){return this.with(this.lineNumber+l,this.column+w)}equals(l){return E.equals(this,l)}static equals(l,w){return!l&&!w?!0:!!l&&!!w&&l.lineNumber===w.lineNumber&&l.column===w.column}isBefore(l){return E.isBefore(this,l)}static isBefore(l,w){return l.lineNumber<w.lineNumber?!0:w.lineNumber<l.lineNumber?!1:l.column<w.column}isBeforeOrEqual(l){return E.isBeforeOrEqual(this,l)}static isBeforeOrEqual(l,w){return l.lineNumber<w.lineNumber?!0:w.lineNumber<l.lineNumber?!1:l.column<=w.column}static compare(l,w){const S=l.lineNumber|0,P=w.lineNumber|0;if(S===P){const y=l.column|0,b=w.column|0;return y-b}return S-P}clone(){return new E(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(l){return new E(l.lineNumber,l.column)}static isIPosition(l){return l&&typeof l.lineNumber=="number"&&typeof l.column=="number"}}e.Position=E}),define(be[49],Ee([1,0,103]),function(oe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class A{constructor(w,S,P,y){w>P||w===P&&S>y?(this.startLineNumber=P,this.startColumn=y,this.endLineNumber=w,this.endColumn=S):(this.startLineNumber=w,this.startColumn=S,this.endLineNumber=P,this.endColumn=y)}isEmpty(){return A.isEmpty(this)}static isEmpty(w){return w.startLineNumber===w.endLineNumber&&w.startColumn===w.endColumn}containsPosition(w){return A.containsPosition(this,w)}static containsPosition(w,S){return!(S.lineNumber<w.startLineNumber||S.lineNumber>w.endLineNumber||S.lineNumber===w.startLineNumber&&S.column<w.startColumn||S.lineNumber===w.endLineNumber&&S.column>w.endColumn)}static strictContainsPosition(w,S){return!(S.lineNumber<w.startLineNumber||S.lineNumber>w.endLineNumber||S.lineNumber===w.startLineNumber&&S.column<=w.startColumn||S.lineNumber===w.endLineNumber&&S.column>=w.endColumn)}containsRange(w){return A.containsRange(this,w)}static containsRange(w,S){return!(S.startLineNumber<w.startLineNumber||S.endLineNumber<w.startLineNumber||S.startLineNumber>w.endLineNumber||S.endLineNumber>w.endLineNumber||S.startLineNumber===w.startLineNumber&&S.startColumn<w.startColumn||S.endLineNumber===w.endLineNumber&&S.endColumn>w.endColumn)}strictContainsRange(w){return A.strictContainsRange(this,w)}static strictContainsRange(w,S){return!(S.startLineNumber<w.startLineNumber||S.endLineNumber<w.startLineNumber||S.startLineNumber>w.endLineNumber||S.endLineNumber>w.endLineNumber||S.startLineNumber===w.startLineNumber&&S.startColumn<=w.startColumn||S.endLineNumber===w.endLineNumber&&S.endColumn>=w.endColumn)}plusRange(w){return A.plusRange(this,w)}static plusRange(w,S){let P,y,b,k;return S.startLineNumber<w.startLineNumber?(P=S.startLineNumber,y=S.startColumn):S.startLineNumber===w.startLineNumber?(P=S.startLineNumber,y=Math.min(S.startColumn,w.startColumn)):(P=w.startLineNumber,y=w.startColumn),S.endLineNumber>w.endLineNumber?(b=S.endLineNumber,k=S.endColumn):S.endLineNumber===w.endLineNumber?(b=S.endLineNumber,k=Math.max(S.endColumn,w.endColumn)):(b=w.endLineNumber,k=w.endColumn),new A(P,y,b,k)}intersectRanges(w){return A.intersectRanges(this,w)}static intersectRanges(w,S){let P=w.startLineNumber,y=w.startColumn,b=w.endLineNumber,k=w.endColumn;const I=S.startLineNumber,v=S.startColumn,d=S.endLineNumber,m=S.endColumn;return P<I?(P=I,y=v):P===I&&(y=Math.max(y,v)),b>d?(b=d,k=m):b===d&&(k=Math.min(k,m)),P>b||P===b&&y>k?null:new A(P,y,b,k)}equalsRange(w){return A.equalsRange(this,w)}static equalsRange(w,S){return!w&&!S?!0:!!w&&!!S&&w.startLineNumber===S.startLineNumber&&w.startColumn===S.startColumn&&w.endLineNumber===S.endLineNumber&&w.endColumn===S.endColumn}getEndPosition(){return A.getEndPosition(this)}static getEndPosition(w){return new E.Position(w.endLineNumber,w.endColumn)}getStartPosition(){return A.getStartPosition(this)}static getStartPosition(w){return new E.Position(w.startLineNumber,w.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(w,S){return new A(this.startLineNumber,this.startColumn,w,S)}setStartPosition(w,S){return new A(w,S,this.endLineNumber,this.endColumn)}collapseToStart(){return A.collapseToStart(this)}static collapseToStart(w){return new A(w.startLineNumber,w.startColumn,w.startLineNumber,w.startColumn)}collapseToEnd(){return A.collapseToEnd(this)}static collapseToEnd(w){return new A(w.endLineNumber,w.endColumn,w.endLineNumber,w.endColumn)}delta(w){return new A(this.startLineNumber+w,this.startColumn,this.endLineNumber+w,this.endColumn)}static fromPositions(w,S=w){return new A(w.lineNumber,w.column,S.lineNumber,S.column)}static lift(w){return w?new A(w.startLineNumber,w.startColumn,w.endLineNumber,w.endColumn):null}static isIRange(w){return w&&typeof w.startLineNumber=="number"&&typeof w.startColumn=="number"&&typeof w.endLineNumber=="number"&&typeof w.endColumn=="number"}static areIntersectingOrTouching(w,S){return!(w.endLineNumber<S.startLineNumber||w.endLineNumber===S.startLineNumber&&w.endColumn<S.startColumn||S.endLineNumber<w.startLineNumber||S.endLineNumber===w.startLineNumber&&S.endColumn<w.startColumn)}static areIntersecting(w,S){return!(w.endLineNumber<S.startLineNumber||w.endLineNumber===S.startLineNumber&&w.endColumn<=S.startColumn||S.endLineNumber<w.startLineNumber||S.endLineNumber===w.startLineNumber&&S.endColumn<=w.startColumn)}static compareRangesUsingStarts(w,S){if(w&&S){const b=w.startLineNumber|0,k=S.startLineNumber|0;if(b===k){const I=w.startColumn|0,v=S.startColumn|0;if(I===v){const d=w.endLineNumber|0,m=S.endLineNumber|0;if(d===m){const p=w.endColumn|0,c=S.endColumn|0;return p-c}return d-m}return I-v}return b-k}return(w?1:0)-(S?1:0)}static compareRangesUsingEnds(w,S){return w.endLineNumber===S.endLineNumber?w.endColumn===S.endColumn?w.startLineNumber===S.startLineNumber?w.startColumn-S.startColumn:w.startLineNumber-S.startLineNumber:w.endColumn-S.endColumn:w.endLineNumber-S.endLineNumber}static spansMultipleLines(w){return w.endLineNumber>w.startLineNumber}toJSON(){return this}}e.Range=A}),define(be[158],Ee([1,0,6,2]),function(oe,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class l{constructor(){this.a=new Map,this.b=new Map,this.c=new E.Emitter,this.onDidChange=this.c.event,this.d=null}fire(P){this.c.fire({changedLanguages:P,changedColorMap:!1})}register(P,y){return this.a.set(P,y),this.fire([P]),(0,A.toDisposable)(()=>{this.a.get(P)===y&&(this.a.delete(P),this.fire([P]))})}registerFactory(P,y){this.b.get(P)?.dispose();const b=new w(this,P,y);return this.b.set(P,b),(0,A.toDisposable)(()=>{const k=this.b.get(P);!k||k!==b||(this.b.delete(P),k.dispose())})}async getOrCreate(P){const y=this.get(P);if(y)return y;const b=this.b.get(P);return!b||b.isResolved?null:(await b.resolve(),this.get(P))}get(P){return this.a.get(P)||null}isResolved(P){if(this.get(P))return!0;const b=this.b.get(P);return!!(!b||b.isResolved)}setColorMap(P){this.d=P,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.TokenizationRegistry=l;class w extends A.Disposable{get isResolved(){return this.c}constructor(P,y,b){super(),this.f=P,this.g=y,this.h=b,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.i()),this.b}async i(){const P=await Promise.resolve(this.h.createTokenizationSupport());this.c=!0,P&&!this.a&&this.B(this.f.register(this.g,P))}}}),define(be[159],Ee([1,0,46,4,49,158]),function(oe,e,E,A,l,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=void 0;class S{constructor(C,L,O){this.offset=C,this.type=L,this.language=O,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=S;class P{constructor(C,L){this.tokens=C,this.endState=L,this._tokenizationResultBrand=void 0}}e.TokenizationResult=P;class y{constructor(C,L){this.tokens=C,this.endState=L,this._encodedTokenizationResultBrand=void 0}}e.EncodedTokenizationResult=y;var b;(function(s){s[s.Method=0]="Method",s[s.Function=1]="Function",s[s.Constructor=2]="Constructor",s[s.Field=3]="Field",s[s.Variable=4]="Variable",s[s.Class=5]="Class",s[s.Struct=6]="Struct",s[s.Interface=7]="Interface",s[s.Module=8]="Module",s[s.Property=9]="Property",s[s.Event=10]="Event",s[s.Operator=11]="Operator",s[s.Unit=12]="Unit",s[s.Value=13]="Value",s[s.Constant=14]="Constant",s[s.Enum=15]="Enum",s[s.EnumMember=16]="EnumMember",s[s.Keyword=17]="Keyword",s[s.Text=18]="Text",s[s.Color=19]="Color",s[s.File=20]="File",s[s.Reference=21]="Reference",s[s.Customcolor=22]="Customcolor",s[s.Folder=23]="Folder",s[s.TypeParameter=24]="TypeParameter",s[s.User=25]="User",s[s.Issue=26]="Issue",s[s.Snippet=27]="Snippet"})(b=e.CompletionItemKind||(e.CompletionItemKind={}));var k;(function(s){const C=new Map;C.set(0,E.Codicon.symbolMethod),C.set(1,E.Codicon.symbolFunction),C.set(2,E.Codicon.symbolConstructor),C.set(3,E.Codicon.symbolField),C.set(4,E.Codicon.symbolVariable),C.set(5,E.Codicon.symbolClass),C.set(6,E.Codicon.symbolStruct),C.set(7,E.Codicon.symbolInterface),C.set(8,E.Codicon.symbolModule),C.set(9,E.Codicon.symbolProperty),C.set(10,E.Codicon.symbolEvent),C.set(11,E.Codicon.symbolOperator),C.set(12,E.Codicon.symbolUnit),C.set(13,E.Codicon.symbolValue),C.set(15,E.Codicon.symbolEnum),C.set(14,E.Codicon.symbolConstant),C.set(15,E.Codicon.symbolEnum),C.set(16,E.Codicon.symbolEnumMember),C.set(17,E.Codicon.symbolKeyword),C.set(27,E.Codicon.symbolSnippet),C.set(18,E.Codicon.symbolText),C.set(19,E.Codicon.symbolColor),C.set(20,E.Codicon.symbolFile),C.set(21,E.Codicon.symbolReference),C.set(22,E.Codicon.symbolCustomColor),C.set(23,E.Codicon.symbolFolder),C.set(24,E.Codicon.symbolTypeParameter),C.set(25,E.Codicon.account),C.set(26,E.Codicon.issues);function L(X){let se=C.get(X);return se||(console.info("No codicon found for CompletionItemKind "+X),se=E.Codicon.symbolProperty),se}s.toIcon=L;const O=new Map;O.set("method",0),O.set("function",1),O.set("constructor",2),O.set("field",3),O.set("variable",4),O.set("class",5),O.set("struct",6),O.set("interface",7),O.set("module",8),O.set("property",9),O.set("event",10),O.set("operator",11),O.set("unit",12),O.set("value",13),O.set("constant",14),O.set("enum",15),O.set("enum-member",16),O.set("enumMember",16),O.set("keyword",17),O.set("snippet",27),O.set("text",18),O.set("color",19),O.set("file",20),O.set("reference",21),O.set("customcolor",22),O.set("folder",23),O.set("type-parameter",24),O.set("typeParameter",24),O.set("account",25),O.set("issue",26);function W(X,se){let fe=O.get(X);return typeof fe>"u"&&!se&&(fe=9),fe}s.fromString=W})(k=e.CompletionItemKinds||(e.CompletionItemKinds={}));var I;(function(s){s[s.Deprecated=1]="Deprecated"})(I=e.CompletionItemTag||(e.CompletionItemTag={}));var v;(function(s){s[s.None=0]="None",s[s.KeepWhitespace=1]="KeepWhitespace",s[s.InsertAsSnippet=4]="InsertAsSnippet"})(v=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var d;(function(s){s[s.Invoke=0]="Invoke",s[s.TriggerCharacter=1]="TriggerCharacter",s[s.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(d=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var m;(function(s){s[s.Automatic=0]="Automatic",s[s.Explicit=1]="Explicit"})(m=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var p;(function(s){s[s.Invoke=1]="Invoke",s[s.Auto=2]="Auto"})(p=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var c;(function(s){s[s.Invoke=1]="Invoke",s[s.TriggerCharacter=2]="TriggerCharacter",s[s.ContentChange=3]="ContentChange"})(c=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var h;(function(s){s[s.Text=0]="Text",s[s.Read=1]="Read",s[s.Write=2]="Write"})(h=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function g(s){return s&&A.URI.isUri(s.uri)&&l.Range.isIRange(s.range)&&(l.Range.isIRange(s.originSelectionRange)||l.Range.isIRange(s.targetSelectionRange))}e.isLocationLink=g;var f;(function(s){s[s.File=0]="File",s[s.Module=1]="Module",s[s.Namespace=2]="Namespace",s[s.Package=3]="Package",s[s.Class=4]="Class",s[s.Method=5]="Method",s[s.Property=6]="Property",s[s.Field=7]="Field",s[s.Constructor=8]="Constructor",s[s.Enum=9]="Enum",s[s.Interface=10]="Interface",s[s.Function=11]="Function",s[s.Variable=12]="Variable",s[s.Constant=13]="Constant",s[s.String=14]="String",s[s.Number=15]="Number",s[s.Boolean=16]="Boolean",s[s.Array=17]="Array",s[s.Object=18]="Object",s[s.Key=19]="Key",s[s.Null=20]="Null",s[s.EnumMember=21]="EnumMember",s[s.Struct=22]="Struct",s[s.Event=23]="Event",s[s.Operator=24]="Operator",s[s.TypeParameter=25]="TypeParameter"})(f=e.SymbolKind||(e.SymbolKind={}));var D;(function(s){s[s.Deprecated=1]="Deprecated"})(D=e.SymbolTag||(e.SymbolTag={}));var R;(function(s){const C=new Map;C.set(0,E.Codicon.symbolFile),C.set(1,E.Codicon.symbolModule),C.set(2,E.Codicon.symbolNamespace),C.set(3,E.Codicon.symbolPackage),C.set(4,E.Codicon.symbolClass),C.set(5,E.Codicon.symbolMethod),C.set(6,E.Codicon.symbolProperty),C.set(7,E.Codicon.symbolField),C.set(8,E.Codicon.symbolConstructor),C.set(9,E.Codicon.symbolEnum),C.set(10,E.Codicon.symbolInterface),C.set(11,E.Codicon.symbolFunction),C.set(12,E.Codicon.symbolVariable),C.set(13,E.Codicon.symbolConstant),C.set(14,E.Codicon.symbolString),C.set(15,E.Codicon.symbolNumber),C.set(16,E.Codicon.symbolBoolean),C.set(17,E.Codicon.symbolArray),C.set(18,E.Codicon.symbolObject),C.set(19,E.Codicon.symbolKey),C.set(20,E.Codicon.symbolNull),C.set(21,E.Codicon.symbolEnumMember),C.set(22,E.Codicon.symbolStruct),C.set(23,E.Codicon.symbolEvent),C.set(24,E.Codicon.symbolOperator),C.set(25,E.Codicon.symbolTypeParameter);function L(O){let W=C.get(O);return W||(console.info("No codicon found for SymbolKind "+O),W=E.Codicon.symbolProperty),W}s.toIcon=L})(R=e.SymbolKinds||(e.SymbolKinds={}));class t{static fromValue(C){switch(C){case"comment":return t.Comment;case"imports":return t.Imports;case"region":return t.Region}return new t(C)}constructor(C){this.value=C}}t.Comment=new t("comment"),t.Imports=new t("imports"),t.Region=new t("region"),e.FoldingRangeKind=t;var r;(function(s){function C(L){return!L||typeof L!="object"?!1:typeof L.id=="string"&&typeof L.title=="string"}s.is=C})(r=e.Command||(e.Command={}));var i;(function(s){s[s.Collapsed=0]="Collapsed",s[s.Expanded=1]="Expanded"})(i=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var n;(function(s){s[s.Unresolved=0]="Unresolved",s[s.Resolved=1]="Resolved"})(n=e.CommentThreadState||(e.CommentThreadState={}));var o;(function(s){s[s.Editing=0]="Editing",s[s.Preview=1]="Preview"})(o=e.CommentMode||(e.CommentMode={}));var u;(function(s){s[s.Type=1]="Type",s[s.Parameter=2]="Parameter"})(u=e.InlayHintKind||(e.InlayHintKind={})),e.TokenizationRegistry=new w.TokenizationRegistry;var a;(function(s){s[s.None=0]="None",s[s.Option=1]="Option",s[s.Default=2]="Default",s[s.Preferred=3]="Preferred"})(a=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(be[160],Ee([11,12]),function(oe,e){return oe.create("vs/base/common/actions",e)}),define(be[161],Ee([1,0,6,2,160]),function(oe,e,E,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toAction=e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0;class w extends A.Disposable{constructor(v,d="",m="",p=!0,c){super(),this.h=this.B(new E.Emitter),this.onDidChange=this.h.event,this.w=!0,this.j=v,this.m=d,this.u=m,this.w=p,this.C=c}get id(){return this.j}get label(){return this.m}set label(v){this.D(v)}D(v){this.m!==v&&(this.m=v,this.h.fire({label:v}))}get tooltip(){return this.n||""}set tooltip(v){this.F(v)}F(v){this.n!==v&&(this.n=v,this.h.fire({tooltip:v}))}get class(){return this.u}set class(v){this.G(v)}G(v){this.u!==v&&(this.u=v,this.h.fire({class:v}))}get enabled(){return this.w}set enabled(v){this.H(v)}H(v){this.w!==v&&(this.w=v,this.h.fire({enabled:v}))}get checked(){return this.z}set checked(v){this.I(v)}I(v){this.z!==v&&(this.z=v,this.h.fire({checked:v}))}async run(v,d){this.C&&await this.C(v)}}e.Action=w;class S extends A.Disposable{constructor(){super(...arguments),this.f=this.B(new E.Emitter),this.onWillRun=this.f.event,this.h=this.B(new E.Emitter),this.onDidRun=this.h.event}async run(v,d){if(!v.enabled)return;this.f.fire({action:v});let m;try{await this.runAction(v,d)}catch(p){m=p}this.h.fire({action:v,error:m})}async runAction(v,d){await v.run(d)}}e.ActionRunner=S;class P{constructor(){this.id=P.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...v){let d=[];for(const m of v)m.length&&(d.length?d=[...d,new P,...m]:d=m);return d}async run(){}}P.ID="vs.actions.separator",e.Separator=P;class y{get actions(){return this.a}constructor(v,d,m,p){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=v,this.label=d,this.class=p,this.a=m}async run(){}}e.SubmenuAction=y;class b extends w{constructor(){super(b.ID,l.localize(0,null),void 0,!1)}}b.ID="vs.actions.empty",e.EmptySubmenuAction=b;function k(I){return{id:I.id,label:I.label,class:void 0,enabled:I.enabled??!0,checked:I.checked??!1,run:async()=>I.run(),tooltip:I.label}}e.toAction=k}),define(be[162],Ee([11,12]),function(oe,e){return oe.create("vs/base/common/date",e)}),define(be[163],Ee([1,0,162]),function(oe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const A=60,l=A*60,w=l*24,S=w*7,P=w*30,y=w*365;function b(I,v,d,m){typeof I!="number"&&(I=I.getTime());const p=Math.round((new Date().getTime()-I)/1e3);if(p<-30)return(0,E.localize)(0,null,b(new Date().getTime()+p*1e3,!1));if(!m&&p<30)return(0,E.localize)(1,null);let c;return p<A?(c=p,v?c===1?d?(0,E.localize)(2,null,c):(0,E.localize)(3,null,c):d?(0,E.localize)(4,null,c):(0,E.localize)(5,null,c):c===1?d?(0,E.localize)(6,null,c):(0,E.localize)(7,null,c):d?(0,E.localize)(8,null,c):(0,E.localize)(9,null,c)):p<l?(c=Math.floor(p/A),v?c===1?d?(0,E.localize)(10,null,c):(0,E.localize)(11,null,c):d?(0,E.localize)(12,null,c):(0,E.localize)(13,null,c):c===1?d?(0,E.localize)(14,null,c):(0,E.localize)(15,null,c):d?(0,E.localize)(16,null,c):(0,E.localize)(17,null,c)):p<w?(c=Math.floor(p/l),v?c===1?d?(0,E.localize)(18,null,c):(0,E.localize)(19,null,c):d?(0,E.localize)(20,null,c):(0,E.localize)(21,null,c):c===1?d?(0,E.localize)(22,null,c):(0,E.localize)(23,null,c):d?(0,E.localize)(24,null,c):(0,E.localize)(25,null,c)):p<S?(c=Math.floor(p/w),v?c===1?(0,E.localize)(26,null,c):(0,E.localize)(27,null,c):c===1?(0,E.localize)(28,null,c):(0,E.localize)(29,null,c)):p<P?(c=Math.floor(p/S),v?c===1?d?(0,E.localize)(30,null,c):(0,E.localize)(31,null,c):d?(0,E.localize)(32,null,c):(0,E.localize)(33,null,c):c===1?d?(0,E.localize)(34,null,c):(0,E.localize)(35,null,c):d?(0,E.localize)(36,null,c):(0,E.localize)(37,null,c)):p<y?(c=Math.floor(p/P),v?c===1?d?(0,E.localize)(38,null,c):(0,E.localize)(39,null,c):d?(0,E.localize)(40,null,c):(0,E.localize)(41,null,c):c===1?d?(0,E.localize)(42,null,c):(0,E.localize)(43,null,c):d?(0,E.localize)(44,null,c):(0,E.localize)(45,null,c)):(c=Math.floor(p/y),v?c===1?d?(0,E.localize)(46,null,c):(0,E.localize)(47,null,c):d?(0,E.localize)(48,null,c):(0,E.localize)(49,null,c):c===1?d?(0,E.localize)(50,null,c):(0,E.localize)(51,null,c):d?(0,E.localize)(52,null,c):(0,E.localize)(53,null,c))}e.fromNow=b;function k(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=k}),define(be[164],Ee([11,12]),function(oe,e){return oe.create("vs/base/common/errorMessage",e)}),define(be[39],Ee([1,0,18,8,164]),function(oe,e,E,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function w(I,v){return v&&(I.stack||I.stacktrace)?l.localize(0,null,P(I),S(I.stack)||S(I.stacktrace)):P(I)}function S(I){return Array.isArray(I)?I.join(`
`):I}function P(I){return typeof I.code=="string"&&typeof I.errno=="number"&&typeof I.syscall=="string"?l.localize(1,null,I.message):I.message||l.localize(2,null)}function y(I=null,v=!1){if(!I)return l.localize(3,null);if(Array.isArray(I)){const d=E.coalesce(I),m=y(d[0],v);return d.length>1?l.localize(4,null,m,d.length):m}if(A.isString(I))return I;if(I.detail){const d=I.detail;if(d.error)return w(d.error,v);if(d.exception)return w(d.exception,v)}return I.stack?w(I,v):I.message?I.message:l.localize(5,null)}e.toErrorMessage=y;function b(I){const v=I;return v instanceof Error&&Array.isArray(v.actions)}e.isErrorWithActions=b;function k(I,v){let d;return typeof I=="string"?d=new Error(I):d=I,d.actions=v,d}e.createErrorWithActions=k}),define(be[165],Ee([11,12]),function(oe,e){return oe.create("vs/base/common/jsonErrorMessages",e)}),define(be[166],Ee([1,0,165]),function(oe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function A(l){switch(l){case 1:return(0,E.localize)(0,null);case 2:return(0,E.localize)(1,null);case 3:return(0,E.localize)(2,null);case 4:return(0,E.localize)(3,null);case 5:return(0,E.localize)(4,null);case 6:return(0,E.localize)(5,null);case 7:return(0,E.localize)(6,null);case 8:return(0,E.localize)(7,null);case 9:return(0,E.localize)(8,null);default:return""}}e.getParseErrorMessage=A}),define(be[167],Ee([11,12]),function(oe,e){return oe.create("vs/base/node/zip",e)}),define(be[168],Ee([11,12]),function(oe,e){return oe.create("vs/platform/configuration/common/configurationRegistry",e)}),define(be[169],Ee([11,12]),function(oe,e){return oe.create("vs/platform/environment/node/argv",e)}),define(be[170],Ee([11,12]),function(oe,e){return oe.create("vs/platform/environment/node/argvHelper",e)}),define(be[171],Ee([11,12]),function(oe,e){return oe.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(be[172],Ee([11,12]),function(oe,e){return oe.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(be[173],Ee([11,12]),function(oe,e){return oe.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(be[174],Ee([11,12]),function(oe,e){return oe.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(be[175],Ee([11,12]),function(oe,e){return oe.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(be[176],Ee([11,12]),function(oe,e){return oe.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(be[177],Ee([11,12]),function(oe,e){return oe.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(be[178],Ee([11,12]),function(oe,e){return oe.create("vs/platform/extensions/common/extensionValidator",e)}),define(be[179],Ee([11,12]),function(oe,e){return oe.create("vs/platform/files/common/fileService",e)}),define(be[180],Ee([11,12]),function(oe,e){return oe.create("vs/platform/files/common/files",e)}),define(be[181],Ee([11,12]),function(oe,e){return oe.create("vs/platform/files/common/io",e)}),define(be[182],Ee([11,12]),function(oe,e){return oe.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(be[183],Ee([11,12]),function(oe,e){return oe.create("vs/platform/languagePacks/common/languagePacks",e)}),define(be[184],Ee([11,12]),function(oe,e){return oe.create("vs/platform/markers/common/markers",e)}),define(be[185],Ee([11,12]),function(oe,e){return oe.create("vs/platform/request/common/request",e)}),define(be[186],Ee([11,12]),function(oe,e){return oe.create("vs/platform/shell/node/shellEnv",e)}),define(be[187],Ee([11,12]),function(oe,e){return oe.create("vs/platform/telemetry/common/telemetryService",e)}),define(be[188],Ee([11,12]),function(oe,e){return oe.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(be[189],Ee([11,12]),function(oe,e){return oe.create("vs/platform/terminal/common/terminalProfiles",e)}),define(be[190],Ee([11,12]),function(oe,e){return oe.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(be[191],Ee([11,12]),function(oe,e){return oe.create("vs/platform/workspace/common/workspace",e)}),define(be[192],Ee([11,12]),function(oe,e){return oe.create("vs/server/node/serverEnvironmentService",e)}),define(be[193],Ee([11,12]),function(oe,e){return oe.create("vs/server/node/serverServices",e)}),define(be[194],Ee([11,12]),function(oe,e){return oe.create("vs/workbench/api/common/extHostTelemetry",e)}),define(be[195],Ee([11,12]),function(oe,e){return oe.create("vs/workbench/common/editor",e)}),define(be[196],Ee([11,12]),function(oe,e){return oe.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(be[197],Ee([11,12]),function(oe,e){return oe.create("vs/workbench/services/extensions/common/extensionsUtil",e)}),define(be[198],Ee([1,0,9]),function(oe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var A;(function(w){w[w.LParen=0]="LParen",w[w.RParen=1]="RParen",w[w.Neg=2]="Neg",w[w.Eq=3]="Eq",w[w.NotEq=4]="NotEq",w[w.Lt=5]="Lt",w[w.LtEq=6]="LtEq",w[w.Gt=7]="Gt",w[w.GtEq=8]="GtEq",w[w.RegexOp=9]="RegexOp",w[w.RegexStr=10]="RegexStr",w[w.True=11]="True",w[w.False=12]="False",w[w.In=13]="In",w[w.Not=14]="Not",w[w.And=15]="And",w[w.Or=16]="Or",w[w.Str=17]="Str",w[w.QuotedStr=18]="QuotedStr",w[w.Error=19]="Error",w[w.EOF=20]="EOF"})(A=e.TokenType||(e.TokenType={}));class l{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static reportError(S){if(S.type!==19)throw(0,E.illegalArgument)(`expected an error token but got ${JSON.stringify(S)}`);switch(S.lexeme){case"=":return`Unexpected token '${S.lexeme}' at offset ${S.offset}. Did you mean '==' or '=~'?`;case"&":return`Unexpected token '${S.lexeme}' at offset ${S.offset}. Did you mean '&&'?`;case"|":return`Unexpected token '${S.lexeme}' at offset ${S.offset}. Did you mean '||'?`;default:{const P=S.lexeme;return P&&P.length>1&&P.startsWith("'")?`Unexpected token '${S.lexeme}' at offset ${S.offset}. Did you forget to close the string?`:P&&P.length>1&&P.endsWith("'")?`Unexpected token '${S.lexeme}' at offset ${S.offset}. Did you forget to open the string?`:`Unexpected token '${S.lexeme}' at offset ${S.offset}`}}}static getLexeme(S){switch(S.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return"==";case 4:return"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return S.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return S.lexeme;case 18:return S.lexeme;case 19:return S.lexeme;case 20:return"EOF";default:throw(0,E.illegalState)(`unhandled token type: ${JSON.stringify(S)}; have you forgotten to add a case?`)}}get errorTokens(){return this.g}reset(S){return this.c=S,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:this.k(this.h(61)?4:2);break;case 39:this.o();break;case 47:this.q();break;case 61:this.h(61)?this.k(3):this.h(126)?this.k(9):this.l();break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l();break;case 124:this.h(124)?this.k(16):this.l();break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(S){return this.r()||this.c.charCodeAt(this.e)!==S?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(S){this.f.push({type:S,offset:this.d})}l(){const S={type:19,offset:this.d,lexeme:this.c.substring(this.d,this.e)};this.g.push(S),this.f.push(S)}n(){this.m.lastIndex=this.d;const S=this.m.exec(this.c);if(S){this.e=this.d+S[0].length;const P=this.c.substring(this.d,this.e),y=l.b.get(P);y?this.k(y):this.f.push({type:17,lexeme:P,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l();return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let S=this.e,P=!1,y=!1;for(;;){if(S>=this.c.length){this.e=S,this.l();return}const k=this.c.charCodeAt(S);if(P)P=!1;else if(k===47&&!y){S++;break}else k===91?y=!0:k===92?P=!0:k===93&&(y=!1);S++}for(;S<this.c.length&&l.a.has(this.c.charCodeAt(S));)S++;this.e=S;const b=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:b,offset:this.d})}r(){return this.e>=this.c.length}}l.a=new Set(["i","g","s","m","y","u"].map(w=>w.charCodeAt(0))),l.b=new Map([["not",14],["in",13],["false",12],["true",11]]),e.Scanner=l}),define(be[199],Ee([1,0,6,2]),function(oe,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class l{constructor(){this.a=new E.Emitter,this.b=new E.Emitter,this.c=new E.Emitter,this.d=new E.Emitter}call(P,y,b){switch(y){case"close":return Promise.resolve(this.a.fire({sessionId:b[0]}));case"reload":return Promise.resolve(this.b.fire({sessionId:b[0]}));case"terminate":return Promise.resolve(this.c.fire({sessionId:b[0]}));case"attach":return Promise.resolve(this.d.fire({sessionId:b[0],port:b[1],subId:b[2]}))}throw new Error("Method not implemented.")}listen(P,y,b){switch(y){case"close":return this.a.event;case"reload":return this.b.event;case"terminate":return this.c.event;case"attach":return this.d.event}throw new Error("Method not implemented.")}}l.ChannelName="extensionhostdebugservice",e.ExtensionHostDebugBroadcastChannel=l;class w extends A.Disposable{constructor(P){super(),this.b=P}reload(P){this.b.call("reload",[P])}get onReload(){return this.b.listen("reload")}close(P){this.b.call("close",[P])}get onClose(){return this.b.listen("close")}attachSession(P,y,b){this.b.call("attach",[P,y,b])}get onAttachSession(){return this.b.listen("attach")}terminateSession(P,y){this.b.call("terminate",[P,y])}get onTerminateSession(){return this.b.listen("terminate")}openExtensionDevelopmentHostWindow(P,y){return this.b.call("openExtensionDevelopmentHostWindow",[P,y])}}e.ExtensionHostDebugChannelClient=w}),define(be[200],Ee([1,0,4]),function(oe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadServiceChannelClient=e.DownloadServiceChannel=void 0;class A{constructor(S){this.a=S}listen(S,P,y){throw new Error("Invalid listen")}call(S,P,y){switch(P){case"download":return this.a.download(E.URI.revive(y[0]),E.URI.revive(y[1]))}throw new Error("Invalid call")}}e.DownloadServiceChannel=A;class l{constructor(S,P){this.a=S,this.b=P}async download(S,P){const y=this.b();y&&(S=y.transformOutgoingURI(S),P=y.transformOutgoingURI(P)),await this.a.call("download",[S,P])}}e.DownloadServiceChannelClient=l}),define(be[201],Ee([1,0,163,87,13,7,28,20,4]),function(oe,e,E,A,l,w,S,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseDebugParams=e.parseExtensionHostDebugPort=e.AbstractNativeEnvironmentService=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=void 0,e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX=/^([^.]+\..+):(.+)$/;class b{get appRoot(){return(0,w.dirname)(l.FileAccess.asFileUri("").fsPath)}get userHome(){return y.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return y.URI.file((0,w.join)(this.userDataPath,"User"))}get tmpDir(){return y.URI.file(this.b.tmpDir)}get cacheHome(){return y.URI.file(this.userDataPath)}get stateResource(){return(0,P.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,P.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const d=(0,E.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,w.join)(this.userDataPath,"logs",d)}return this.args.logsPath}get userDataSyncLogResource(){return y.URI.file((0,w.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return y.URI.file((0,w.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.joinPath)(y.URI.file((0,w.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,P.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,P.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,P.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const d=S.env.VSCODE_PORTABLE;return d?y.URI.file((0,w.join)(d,"argv.json")):(0,P.joinPath)(this.appSettingsHome,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return y.URI.file((0,w.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,w.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const d=this.args["builtin-extensions-dir"];return d?(0,w.resolve)(d):(0,w.normalize)((0,w.join)(l.FileAccess.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const d=this.args["extensions-download-dir"];return d?y.URI.file((0,w.resolve)(d)):y.URI.file((0,w.join)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const d=this.args["extensions-dir"];if(d)return(0,w.resolve)(d);const m=S.env.VSCODE_EXTENSIONS;if(m)return m;const p=S.env.VSCODE_PORTABLE;return p?(0,w.join)(p,"extensions"):(0,P.joinPath)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const d=this.args.extensionDevelopmentPath;if(Array.isArray(d))return d.map(m=>/^[^:/?#]+?:\/\//.test(m)?y.URI.parse(m):y.URI.file((0,w.normalize)(m)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(d=>d==="ui"||d==="workspace"||d==="web"?d:"workspace")}get extensionTestsLocationURI(){const d=this.args.extensionTestsPath;if(d)return/^[^:/?#]+?:\/\//.test(d)?y.URI.parse(d):y.URI.file((0,w.normalize)(d))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const d=this.args["disable-extension"];if(d){if(typeof d=="string")return[d];if(Array.isArray(d)&&d.length>0)return d}return!1}get debugExtensionHost(){return k(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!S.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(d=>!e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.test(d))}get extensionLogLevel(){const d=[];for(const m of this.args.log||[]){const p=e.EXTENSION_IDENTIFIER_WITH_LOG_REGEX.exec(m);p&&p[1]&&p[2]&&d.push([p[1],p[2]])}return d.length?d:void 0}get serviceMachineIdResource(){return(0,P.joinPath)(y.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return y.URI.file((0,w.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const d=S.env.VSCODE_PORTABLE;return d?y.URI.file((0,w.join)(d,"policy.json")):(0,P.joinPath)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(d){this.args.continueOn=d}get args(){return this.a}constructor(d,m,p){this.a=d,this.b=m,this.c=p,this.editSessionId=this.args.editSessionId}}Te([A.memoize],b.prototype,"appRoot",null),Te([A.memoize],b.prototype,"userHome",null),Te([A.memoize],b.prototype,"userDataPath",null),Te([A.memoize],b.prototype,"appSettingsHome",null),Te([A.memoize],b.prototype,"tmpDir",null),Te([A.memoize],b.prototype,"cacheHome",null),Te([A.memoize],b.prototype,"stateResource",null),Te([A.memoize],b.prototype,"userRoamingDataHome",null),Te([A.memoize],b.prototype,"userDataSyncHome",null),Te([A.memoize],b.prototype,"userDataSyncLogResource",null),Te([A.memoize],b.prototype,"editSessionsLogResource",null),Te([A.memoize],b.prototype,"sync",null),Te([A.memoize],b.prototype,"machineSettingsResource",null),Te([A.memoize],b.prototype,"workspaceStorageHome",null),Te([A.memoize],b.prototype,"localHistoryHome",null),Te([A.memoize],b.prototype,"keyboardLayoutResource",null),Te([A.memoize],b.prototype,"argvResource",null),Te([A.memoize],b.prototype,"isExtensionDevelopment",null),Te([A.memoize],b.prototype,"untitledWorkspacesHome",null),Te([A.memoize],b.prototype,"installSourcePath",null),Te([A.memoize],b.prototype,"builtinExtensionsPath",null),Te([A.memoize],b.prototype,"extensionsPath",null),Te([A.memoize],b.prototype,"extensionDevelopmentLocationURI",null),Te([A.memoize],b.prototype,"extensionDevelopmentKind",null),Te([A.memoize],b.prototype,"extensionTestsLocationURI",null),Te([A.memoize],b.prototype,"debugExtensionHost",null),Te([A.memoize],b.prototype,"logLevel",null),Te([A.memoize],b.prototype,"extensionLogLevel",null),Te([A.memoize],b.prototype,"serviceMachineIdResource",null),Te([A.memoize],b.prototype,"telemetryLogResource",null),Te([A.memoize],b.prototype,"disableWorkspaceTrust",null),Te([A.memoize],b.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=b;function k(v,d){return I(v["inspect-extensions"],v["inspect-brk-extensions"],5870,d,v.debugId,v.extensionEnvironment)}e.parseExtensionHostDebugPort=k;function I(v,d,m,p,c,h){const f=Number(d||v)||(p?null:m),D=f?Boolean(!!d):!1;let R;if(h)try{R=JSON.parse(h)}catch{}return{port:f,break:D,debugId:c,env:R}}e.parseDebugParams=I}),define(be[63],Ee([1,0,291,3,169]),function(oe,e,E,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const w={o:(0,l.localize)(0,null),e:(0,l.localize)(1,null),t:(0,l.localize)(2,null)};e.OPTIONS={tunnel:{type:"subcommand",description:"Make the current machine accessible from vscode.dev or other machines through a secure tunnel",options:{"cli-data-dir":{type:"string",args:"dir",description:(0,l.localize)(3,null)},"disable-telemetry":{type:"boolean"},"telemetry-level":{type:"string"},user:{type:"subcommand",options:{login:{type:"subcommand",options:{provider:{type:"string"},"access-token":{type:"string"}}}}}}},diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,l.localize)(4,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,l.localize)(5,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,l.localize)(6,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,l.localize)(7,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,l.localize)(8,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,l.localize)(9,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,l.localize)(10,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,l.localize)(11,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,l.localize)(12,null)},profile:{type:"string",cat:"o",args:"profileName",description:(0,l.localize)(13,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,l.localize)(14,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,l.localize)(15,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,l.localize)(16,null)},"show-versions":{type:"boolean",cat:"e",description:(0,l.localize)(17,null)},category:{type:"string",cat:"e",description:(0,l.localize)(18,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,l.localize)(19,null)},"pre-release":{type:"boolean",cat:"e",description:(0,l.localize)(20,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,l.localize)(21,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,l.localize)(22,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,l.localize)(23,null)},verbose:{type:"boolean",cat:"t",global:!0,description:(0,l.localize)(24,null)},log:{type:"string[]",cat:"t",args:"level",global:!0,description:(0,l.localize)(25,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,l.localize)(26,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,l.localize)(27,null)},"prof-append-timers":{type:"string"},"prof-duration-markers":{type:"string[]"},"prof-duration-markers-file":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,l.localize)(28,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,l.localize)(29,null)},sync:{type:"string",cat:"t",description:(0,l.localize)(30,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,l.localize)(31,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,l.localize)(32,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,l.localize)(33,null)},"ms-enable-electron-run-as-node":{type:"boolean",global:!0},"max-memory":{type:"string",cat:"t",description:(0,l.localize)(34,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,l.localize)(35,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"inspect-sharedprocess":{type:"string",allowEmptyValue:!0},"inspect-brk-sharedprocess":{type:"string",allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},"disable-gpu-sandbox":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},continueOn:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh","fish"]},"enable-coi":{type:"boolean"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},"profile-temp":{type:"boolean"},_:{type:"string[]"}};const S={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function P(p,c,h=S){const g=p.find(u=>u.length>0&&u[0]!=="-"),f={},D=["_"],R=[],t={};let r;for(const u in c){const a=c[u];a.type==="subcommand"?u===g&&(r=a):(a.alias&&(f[u]=a.alias),a.type==="string"||a.type==="string[]"?(D.push(u),a.deprecates&&D.push(...a.deprecates)):a.type==="boolean"&&(R.push(u),a.deprecates&&R.push(...a.deprecates)),a.global&&(t[u]=a))}if(r&&g){const u=t;for(const L in r.options)u[L]=r.options[L];const a=p.filter(L=>L!==g),s=h.getSubcommandReporter?h.getSubcommandReporter(g):void 0,C=P(a,u,s);return{[g]:C,_:[]}}const i=E(p,{string:D,boolean:R,alias:f}),n={},o=i;n._=i._.map(u=>String(u)).filter(u=>u.length>0),delete o._;for(const u in c){const a=c[u];if(a.type==="subcommand")continue;a.alias&&delete o[a.alias];let s=o[u];if(a.deprecates)for(const C of a.deprecates)o.hasOwnProperty(C)&&(s||(s=o[C],s&&h.onDeprecatedOption(C,a.deprecationMessage||(0,l.localize)(36,null,u))),delete o[C]);if(typeof s<"u"){if(a.type==="string[]"){if(Array.isArray(s)||(s=[s]),!a.allowEmptyValue){const C=s.filter(L=>L.length>0);C.length!==s.length&&(h.onEmptyValue(u),s=C.length>0?C:void 0)}}else a.type==="string"&&(Array.isArray(s)?(s=s.pop(),h.onMultipleValues(u,s)):!s&&!a.allowEmptyValue&&(h.onEmptyValue(u),s=void 0));n[u]=s,a.deprecationMessage&&h.onDeprecatedOption(u,a.deprecationMessage)}delete o[u]}for(const u in o)h.onUnknownOption(u);return n}e.parseArgs=P;function y(p,c){let h="";return c.args&&(Array.isArray(c.args)?h=` <${c.args.join("> <")}>`:h=` <${c.args}>`),c.alias?`-${c.alias} --${p}${h}`:`--${p}${h}`}function b(p,c){const h=[];for(const g in p){const f=p[g],D=y(g,f);h.push([D,f.description])}return k(h,c)}e.formatOptions=b;function k(p,c){const g=p.reduce((R,t)=>Math.max(R,t[0].length),12)+2+1;if(c-g<25)return p.reduce((R,t)=>R.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);const f=c-g-1,D=[];for(const R of p){const t=R[0],r=v(R[1],f),i=I(g-t.length-2);D.push("  "+t+i+r[0]);for(let n=1;n<r.length;n++)D.push(I(g)+r[n])}return D}function I(p){return" ".repeat(p)}function v(p,c){const h=[];for(;p.length;){const g=p.length<c?p.length:p.lastIndexOf(" ",c),f=p.slice(0,g).trim();p=p.slice(g),h.push(f)}return h}function d(p,c,h,g,f){const D=process.stdout.isTTY&&process.stdout.columns||80,R=f?.noInputFiles!==!0?`[${(0,l.localize)(37,null)}...]`:"",t=[`${p} ${h}`];t.push(""),t.push(`${(0,l.localize)(38,null)}: ${c} [${(0,l.localize)(39,null)}]${R}`),t.push(""),f?.noPipe!==!0&&(A.isWindows?t.push((0,l.localize)(40,null,c)):t.push((0,l.localize)(41,null,c)),t.push(""));const r={},i=[];for(const n in g){const o=g[n];if(o.type==="subcommand")o.description&&i.push({command:n,description:o.description});else if(o.description&&o.cat){let u=r[o.cat];u||(r[o.cat]=u={}),u[n]=o}}for(const n in r){const o=n,u=r[o];u&&(t.push(w[o]),t.push(...b(u,D)),t.push(""))}return i.length&&(t.push((0,l.localize)(42,null)),t.push(...k(i.map(n=>[n.command,n.description]),D)),t.push("")),t.join(`
`)}e.buildHelpMessage=d;function m(p,c){return`${p||(0,l.localize)(43,null)}
${c||(0,l.localize)(44,null)}
${process.arch}`}e.buildVersionMessage=m}),define(be[202],Ee([1,0,292,170,63]),function(oe,e,E,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const w=2048;function S(v,d){const m=(D,R)=>{console.warn((0,A.localize)(0,null,D,R))},p=D=>{console.warn((0,A.localize)(1,null,D))},c=(D,R)=>{console.warn((0,A.localize)(2,null,D,R))},h=D=>({onUnknownOption:R=>{D!=="tunnel"&&console.warn((0,A.localize)(3,null,R,D))},onMultipleValues:m,onEmptyValue:p,onDeprecatedOption:c,getSubcommandReporter:D!=="tunnel"?h:void 0}),g={onUnknownOption:D=>{console.warn((0,A.localize)(4,null,D))},onMultipleValues:m,onEmptyValue:p,onDeprecatedOption:c,getSubcommandReporter:h},f=(0,l.parseArgs)(v,l.OPTIONS,d?g:void 0);return f.goto&&f._.forEach(D=>E(/^(\w:)?[^:]+(:\d*){0,2}$/.test(D),(0,A.localize)(5,null))),f["max-memory"]&&E(parseInt(f["max-memory"])>=w,`The max-memory argument cannot be specified lower than ${w} MB.`),f}function P(v){const d=v.findIndex(m=>!/^-/.test(m));if(d>-1)return[...v.slice(0,d),...v.slice(d+1)]}function y(v){let[,...d]=v;process.env.VSCODE_DEV&&(d=P(d)||[]);const m=!I(process.env);return S(d,m)}e.parseMainProcessArgv=y;function b(v){let[,,...d]=v;return process.env.VSCODE_DEV&&(d=P(d)||[]),S(d,!0)}e.parseCLIProcessArgv=b;function k(v,...d){const m=v.indexOf("--");return m===-1?v.push(...d):v.splice(m,0,...d),v}e.addArg=k;function I(v){return v.VSCODE_CLI==="1"}e.isLaunchedFromCli=I}),function(){"use strict";function oe(e,E,A){function l(S,P){const y=w(S,P),b=[y];return e.isAbsolute(y)||b.unshift(A),e.resolve(...b)}function w(S,P){process.env.VSCODE_DEV&&(P="code-oss-dev");const y=process.env.VSCODE_PORTABLE;if(y)return e.join(y,"user-data");let b=process.env.VSCODE_APPDATA;if(b)return e.join(b,P);const k=S["user-data-dir"];if(k)return k;switch(process.platform){case"win32":if(b=process.env.APPDATA,!b){const I=process.env.USERPROFILE;if(typeof I!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");b=e.join(I,"AppData","Roaming")}break;case"darwin":b=e.join(E.homedir(),"Library","Application Support");break;case"linux":b=process.env.XDG_CONFIG_HOME||e.join(E.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(b,P)}return{getUserDataPath:l}}if(typeof define=="function")define(be[203],Ee([95,29,28]),function(e,E,A){return oe(e,E,A.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),E=require("os");module.exports=oe(e,E,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(be[104],Ee([1,0,29,201,203]),function(oe,e,E,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSharedProcessDebugPort=e.parsePtyHostDebugPort=e.NativeEnvironmentService=void 0;class w extends A.AbstractNativeEnvironmentService{constructor(b,k){super(b,{homeDir:(0,E.homedir)(),tmpDir:(0,E.tmpdir)(),userDataDir:(0,l.getUserDataPath)(b,k.nameShort)},k)}}e.NativeEnvironmentService=w;function S(y,b){return(0,A.parseDebugParams)(y["inspect-ptyhost"],y["inspect-brk-ptyhost"],5877,b,y.extensionEnvironment)}e.parsePtyHostDebugPort=S;function P(y,b){return(0,A.parseDebugParams)(y["inspect-sharedprocess"],y["inspect-brk-sharedprocess"],5879,b,y.extensionEnvironment)}e.parseSharedProcessDebugPort=P}),define(be[204],Ee([1,0,8,174]),function(oe,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;function l(S,P,y){try{w(S,P,y)}catch(b){console.error(b?.message??b)}return S}e.localizeManifest=l;function w(S,P,y){const b=(k,I,v)=>{const d=k[I];if((0,E.isString)(d)){const m=d,p=m.length;if(p>1&&m[0]==="%"&&m[p-1]==="%"){const c=m.substr(1,p-2);let h=P[c];h===void 0&&y&&(h=y[c]);const g=typeof h=="string"?h:h?.message,f=y?.[c],D=typeof f=="string"?f:f?.message;if(!g){D||console.warn(`[${S.name}]: ${(0,A.localize)(0,null,c)}`);return}if(v&&(I==="title"||I==="category")&&D&&D!==g){const R={value:g,original:D};k[I]=R}else k[I]=g}}else if((0,E.isObject)(d))for(const m in d)d.hasOwnProperty(m)&&(m==="commands"?b(d,m,!0):b(d,m,v));else if(Array.isArray(d))for(let m=0;m<d.length;m++)b(d,m,v)};for(const k in S)S.hasOwnProperty(k)&&b(S,k)}}),define(be[205],Ee([1,0,9]),function(oe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class A{constructor(){this.a=new Map}register(w,S){this.a.set(w,S)}updateManifest(w){if(!(typeof w.main>"u"&&typeof w.browser>"u")&&(w.activationEvents===void 0&&Object.assign(w,{activationEvents:[]}),!(!Array.isArray(w.activationEvents)||!w.contributes)))for(const S in w.contributes){const P=this.a.get(S);if(!P)continue;const y=w.contributes[S],b=Array.isArray(y)?y:[y];try{P(b,w.activationEvents)}catch(k){(0,E.onUnexpectedError)(k)}}}}e.ImplicitActivationEventsImpl=A,e.ImplicitActivationEvents=new A}),define(be[73],Ee([1,0,20,59,178,50]),function(oe,e,E,A,l,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const S=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function y(h){return h=h.trim(),h==="*"||S.test(h)}e.isValidVersionStr=y;function b(h){if(!y(h))return null;if(h=h.trim(),h==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const g=h.match(S);return g?{hasCaret:g[1]==="^",hasGreaterEquals:g[1]===">=",majorBase:g[2]==="x"?0:parseInt(g[2],10),majorMustEqual:g[2]!=="x",minorBase:g[4]==="x"?0:parseInt(g[4],10),minorMustEqual:g[4]!=="x",patchBase:g[6]==="x"?0:parseInt(g[6],10),patchMustEqual:g[6]!=="x",preRelease:g[8]||null}:null}e.parseVersion=b;function k(h){if(!h)return null;const g=h.majorBase,f=h.majorMustEqual,D=h.minorBase;let R=h.minorMustEqual;const t=h.patchBase;let r=h.patchMustEqual;h.hasCaret&&(g===0||(R=!1),r=!1);let i=0;if(h.preRelease){const n=P.exec(h.preRelease);if(n){const[,o,u,a]=n;i=Date.UTC(Number(o),Number(u)-1,Number(a))}}return{majorBase:g,majorMustEqual:f,minorBase:D,minorMustEqual:R,patchBase:t,patchMustEqual:r,isMinimum:h.hasGreaterEquals,notBefore:i}}e.normalizeVersion=k;function I(h,g,f){let D;typeof h=="string"?D=k(b(h)):D=h;let R;g instanceof Date?R=g.getTime():typeof g=="string"&&(R=new Date(g).getTime());let t;if(typeof f=="string"?t=k(b(f)):t=f,!D||!t)return!1;const r=D.majorBase,i=D.minorBase,n=D.patchBase;let o=t.majorBase,u=t.minorBase,a=t.patchBase;const s=t.notBefore;let C=t.majorMustEqual,L=t.minorMustEqual,O=t.patchMustEqual;return t.isMinimum?r>o?!0:r<o?!1:i>u?!0:i<u||R&&R<s?!1:n>=a:(r===1&&o===0&&(!C||!L||!O)&&(o=1,u=0,a=0,C=!0,L=!1,O=!1),r<o?!1:r>o?!C:i<u?!1:i>u?!L:n<a?!1:n>a?!O:!(R&&R<s))}e.isValidVersion=I;function v(h,g,f,D,R){const t=[];if(typeof D.publisher<"u"&&typeof D.publisher!="string")return t.push([A.default.Error,l.localize(0,null)]),t;if(typeof D.name!="string")return t.push([A.default.Error,l.localize(1,null,"name")]),t;if(typeof D.version!="string")return t.push([A.default.Error,l.localize(2,null,"version")]),t;if(!D.engines)return t.push([A.default.Error,l.localize(3,null,"engines")]),t;if(typeof D.engines.vscode!="string")return t.push([A.default.Error,l.localize(4,null,"engines.vscode")]),t;if(typeof D.extensionDependencies<"u"&&!c(D.extensionDependencies))return t.push([A.default.Error,l.localize(5,null,"extensionDependencies")]),t;if(typeof D.activationEvents<"u"){if(!c(D.activationEvents))return t.push([A.default.Error,l.localize(6,null,"activationEvents")]),t;if(typeof D.main>"u"&&typeof D.browser>"u")return t.push([A.default.Error,l.localize(7,null,"activationEvents","main")]),t}if(typeof D.extensionKind<"u"&&typeof D.main>"u"&&t.push([A.default.Warning,l.localize(8,null,"extensionKind")]),typeof D.main<"u"){if(typeof D.main!="string")return t.push([A.default.Error,l.localize(9,null,"main")]),t;{const n=(0,E.joinPath)(f,D.main);(0,E.isEqualOrParent)(n,f)||t.push([A.default.Warning,l.localize(10,null,n.path,f.path)])}if(typeof D.activationEvents>"u")return t.push([A.default.Error,l.localize(11,null,"activationEvents","main")]),t}if(typeof D.browser<"u"){if(typeof D.browser!="string")return t.push([A.default.Error,l.localize(12,null,"browser")]),t;{const n=(0,E.joinPath)(f,D.browser);(0,E.isEqualOrParent)(n,f)||t.push([A.default.Warning,l.localize(13,null,n.path,f.path)])}if(typeof D.activationEvents>"u")return t.push([A.default.Error,l.localize(14,null,"activationEvents","browser")]),t}if(!w.valid(D.version))return t.push([A.default.Error,l.localize(15,null)]),t;const r=[];if(!d(h,g,D,R,r))for(const n of r)t.push([A.default.Error,n]);return t}e.validateExtensionManifest=v;function d(h,g,f,D,R){return D||typeof f.main>"u"&&typeof f.browser>"u"?!0:p(h,g,f.engines.vscode,R)}e.isValidExtensionVersion=d;function m(h,g,f){return h==="*"||p(g,f,h)}e.isEngineValid=m;function p(h,g,f,D=[]){const R=k(b(f));if(!R)return D.push(l.localize(16,null,f)),!1;if(R.majorBase===0){if(!R.majorMustEqual||!R.minorMustEqual)return D.push(l.localize(17,null,f)),!1}else if(!R.majorMustEqual)return D.push(l.localize(18,null,f)),!1;return I(h,g,R)?!0:(D.push(l.localize(19,null,h,f)),!1)}function c(h){if(!Array.isArray(h))return!1;for(let g=0,f=h.length;g<f;g++)if(typeof h[g]!="string")return!1;return!0}}),define(be[206],Ee([1,0,15,21]),function(oe,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function l(w,S,P){let y=P&&P.get("storage.serviceMachineId",-1)||null;if(y)return y;try{const k=(await S.readFile(w.serviceMachineIdResource)).value.toString();y=(0,A.isUUID)(k)?k:null}catch{y=null}if(!y){y=(0,A.generateUuid)();try{await S.writeFile(w.serviceMachineIdResource,E.VSBuffer.fromString(y))}catch{}}return P?.store("storage.serviceMachineId",y,-1,1),y}e.getServiceMachineId=l}),define(be[64],Ee([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class E{constructor(l,w=[],S=!1){this.ctor=l,this.staticArguments=w,this.supportsDelayedInstantiation=S}}e.SyncDescriptor=E}),define(be[207],Ee([1,0,64]),function(oe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const A=[];var l;(function(P){P[P.Eager=0]="Eager",P[P.Delayed=1]="Delayed"})(l=e.InstantiationType||(e.InstantiationType={}));function w(P,y,b){y instanceof E.SyncDescriptor||(y=new E.SyncDescriptor(y,[],Boolean(b))),A.push([P,y])}e.registerSingleton=w;function S(){return A}e.getSingletonServiceDescriptors=S}),define(be[208],Ee([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class E{constructor(w,S){this.key=w,this.data=S,this.incoming=new Map,this.outgoing=new Map}}e.Node=E;class A{constructor(w){this.b=w,this.a=new Map}roots(){const w=[];for(const S of this.a.values())S.outgoing.size===0&&w.push(S);return w}insertEdge(w,S){const P=this.lookupOrInsertNode(w),y=this.lookupOrInsertNode(S);P.outgoing.set(y.key,y),y.incoming.set(P.key,P)}removeNode(w){const S=this.b(w);this.a.delete(S);for(const P of this.a.values())P.outgoing.delete(S),P.incoming.delete(S)}lookupOrInsertNode(w){const S=this.b(w);let P=this.a.get(S);return P||(P=new E(S,w),this.a.set(S,P)),P}lookup(w){return this.a.get(this.b(w))}isEmpty(){return this.a.size===0}toString(){const w=[];for(const[S,P]of this.a)w.push(`${S}
	(-> incoming)[${[...P.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...P.outgoing.keys()].join(",")}]
`);return w.join(`
`)}findCycleSlow(){for(const[w,S]of this.a){const P=new Set([w]),y=this.c(S,P);if(y)return y}}c(w,S){for(const[P,y]of w.outgoing){if(S.has(P))return[...S,P].join(" -> ");S.add(P);const b=this.c(y,S);if(b)return b;S.delete(P)}}}e.Graph=A}),define(be[5],Ee([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var E;(function(S){S.serviceIds=new Map,S.DI_TARGET="$di$target",S.DI_DEPENDENCIES="$di$dependencies";function P(y){return y[S.DI_DEPENDENCIES]||[]}S.getServiceDependencies=P})(E=e._util||(e._util={})),e.IInstantiationService=l("instantiationService");function A(S,P,y){P[E.DI_TARGET]===P?P[E.DI_DEPENDENCIES].push({id:S,index:y}):(P[E.DI_DEPENDENCIES]=[{id:S,index:y}],P[E.DI_TARGET]=P)}function l(S){if(E.serviceIds.has(S))return E.serviceIds.get(S);const P=function(y,b,k){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");A(P,y,k)};return P.toString=()=>S,E.serviceIds.set(S,P),P}e.createDecorator=l;function w(S){return S}e.refineServiceDecorator=w}),define(be[24],Ee([1,0,8,4,5]),function(oe,e,E,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,l.createDecorator)("configurationService");function w(c){return c&&typeof c=="object"&&(!c.overrideIdentifier||typeof c.overrideIdentifier=="string")&&(!c.resource||c.resource instanceof A.URI)}e.isConfigurationOverrides=w;function S(c){return c&&typeof c=="object"&&(!c.overrideIdentifiers||Array.isArray(c.overrideIdentifiers))&&!c.overrideIdentifier&&(!c.resource||c.resource instanceof A.URI)}e.isConfigurationUpdateOverrides=S;var P;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.USER=2]="USER",c[c.USER_LOCAL=3]="USER_LOCAL",c[c.USER_REMOTE=4]="USER_REMOTE",c[c.WORKSPACE=5]="WORKSPACE",c[c.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",c[c.DEFAULT=7]="DEFAULT",c[c.MEMORY=8]="MEMORY"})(P=e.ConfigurationTarget||(e.ConfigurationTarget={}));function y(c){switch(c){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=y;function b(c,h){const g=Object.create(null);for(const f in c)k(g,f,c[f],h);return g}e.toValuesTree=b;function k(c,h,g,f){const D=h.split("."),R=D.pop();let t=c;for(let r=0;r<D.length;r++){const i=D[r];let n=t[i];switch(typeof n){case"undefined":n=t[i]=Object.create(null);break;case"object":break;default:f(`Ignoring ${h} as ${D.slice(0,r+1).join(".")} is ${JSON.stringify(n)}`);return}t=n}if(typeof t=="object"&&t!==null)try{t[R]=g}catch{f(`Ignoring ${h} as ${D.join(".")} is ${JSON.stringify(t)}`)}else f(`Ignoring ${h} as ${D.join(".")} is ${JSON.stringify(t)}`)}e.addToValueTree=k;function I(c,h){const g=h.split(".");v(c,g)}e.removeFromValueTree=I;function v(c,h){const g=h.shift();if(h.length===0){delete c[g];return}if(Object.keys(c).indexOf(g)!==-1){const f=c[g];typeof f=="object"&&!Array.isArray(f)&&(v(f,h),Object.keys(f).length===0&&delete c[g])}}function d(c,h,g){function f(t,r){let i=t;for(const n of r){if(typeof i!="object"||i===null)return;i=i[n]}return i}const D=h.split("."),R=f(c,D);return typeof R>"u"?g:R}e.getConfigurationValue=d;function m(c,h,g){Object.keys(h).forEach(f=>{f!=="__proto__"&&(f in c?E.isObject(c[f])&&E.isObject(h[f])?m(c[f],h[f],g):g&&(c[f]=h[f]):c[f]=h[f])})}e.merge=m;function p(c){return c.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=p}),define(be[105],Ee([1,0,3,17,198,5]),function(oe,e,E,A,l,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.Parser=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const S=new Map;S.set("false",!1),S.set("true",!0),S.set("isMac",E.isMacintosh),S.set("isLinux",E.isLinux),S.set("isWindows",E.isWindows),S.set("isWeb",E.isWeb),S.set("isMacNative",E.isMacintosh&&!E.isWeb),S.set("isEdge",E.isEdge),S.set("isFirefox",E.isFirefox),S.set("isChrome",E.isChrome),S.set("isSafari",E.isSafari);const P=Object.prototype.hasOwnProperty;var y;(function(V){V[V.False=0]="False",V[V.True=1]="True",V[V.Defined=2]="Defined",V[V.Not=3]="Not",V[V.Equals=4]="Equals",V[V.NotEquals=5]="NotEquals",V[V.And=6]="And",V[V.Regex=7]="Regex",V[V.NotRegex=8]="NotRegex",V[V.Or=9]="Or",V[V.In=10]="In",V[V.NotIn=11]="NotIn",V[V.Greater=12]="Greater",V[V.GreaterEquals=13]="GreaterEquals",V[V.Smaller=14]="Smaller",V[V.SmallerEquals=15]="SmallerEquals"})(y=e.ContextKeyExprType||(e.ContextKeyExprType={}));class b{static false(){return m.INSTANCE}static true(){return p.INSTANCE}static has(T){return c.create(T)}static equals(T,z){return h.create(T,z)}static notEquals(T,z){return D.create(T,z)}static regex(T,z){return u.create(T,z)}static in(T,z){return g.create(T,z)}static notIn(T,z){return f.create(T,z)}static not(T){return R.create(T)}static and(...T){return C.create(T,null,!0)}static or(...T){return L.create(T,null,!0)}static greater(T,z){return r.create(T,z)}static greaterEquals(T,z){return i.create(T,z)}static smaller(T,z){return n.create(T,z)}static smallerEquals(T,z){return o.create(T,z)}static deserializeOrErrorNew(T){if(!T)return{type:"error",lexingErrors:[],parsingErrors:[]};const z=new I,he=z.parse(T);return he===void 0?{type:"error",lexingErrors:z.lexingErrors.map(H=>l.Scanner.reportError(H)),parsingErrors:z.parsingErrors}:{type:"ok",expr:he}}static deserialize(T){if(!!T)return this.c(T)}static c(T){const z=T.split("||");return L.create(z.map(he=>this.d(he)),null,!0)}static d(T){const z=T.split("&&");return C.create(z.map(he=>this.f(he)),null,!0)}static f(T){if(T=T.trim(),T.indexOf("!=")>=0){const z=T.split("!=");return D.create(z[0].trim(),this.g(z[1]))}if(T.indexOf("==")>=0){const z=T.split("==");return h.create(z[0].trim(),this.g(z[1]))}if(T.indexOf("=~")>=0){const z=T.split("=~");return u.create(z[0].trim(),this.h(z[1]))}if(T.indexOf(" not in ")>=0){const z=T.split(" not in ");return f.create(z[0].trim(),this.g(z[1]))}if(T.indexOf(" in ")>=0){const z=T.split(" in ");return g.create(z[0].trim(),this.g(z[1]))}if(/^[^<=>]+>=[^<=>]+$/.test(T)){const z=T.split(">=");return i.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(T)){const z=T.split(">");return r.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(T)){const z=T.split("<=");return o.create(z[0].trim(),z[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(T)){const z=T.split("<");return n.create(z[0].trim(),z[1].trim())}return/^\!\s*/.test(T)?R.create(T.substr(1).trim()):c.create(T)}static g(T){if(T=T.trim(),T==="true")return!0;if(T==="false")return!1;const z=/^'([^']*)'$/.exec(T);return z?z[1].trim():T}static h(T){if((0,A.isFalsyOrWhitespace)(T))return null;const z=T.indexOf("/"),he=T.lastIndexOf("/");if(z===he||z<0)return null;const H=T.slice(z+1,he),q=T[he+1]==="i"?"i":"";try{return new RegExp(H,q)}catch{return null}}}e.ContextKeyExpr=b;class k extends Error{}class I{constructor(){this.c=new l.Scanner,this.d=[],this.f=0,this.g=[]}get lexingErrors(){return this.c.errorTokens}get parsingErrors(){return this.g}parse(T){if(T===""){this.g.push("Expected an expression but got an empty string");return}this.d=this.c.reset(T).scan(),this.f=0,this.g=[];try{const z=this.h();if(!this.D())throw this.z(this.C());return z}catch(z){if(!(z instanceof k)){const he=this.C();this.g.push(`Unexpected error: ${z} for token ${l.Scanner.getLexeme(he)} at offset ${he.offset}.`)}return}}h(){return this.k()}k(){const T=[this.l()];for(;this.v(16);){const z=this.l();T.push(z)}return T.length===1?T[0]:b.or(...T)}l(){const T=[this.o()];for(;this.v(15);){const z=this.o();T.push(z)}return T.length===1?T[0]:b.and(...T)}o(){if(this.v(2)){const T=this.C();switch(T.type){case 17:return this.w(),b.not(T.lexeme);case 11:return this.w(),b.false();case 12:return this.w(),b.true();default:throw this.y("KEY, 'true', or 'false'",T)}}return this.s()}s(){const T=this.C();switch(T.type){case 11:return this.w(),b.true();case 12:return this.w(),b.false();case 0:{this.w();const z=this.h();return this.x(1,"')'"),z}case 17:{const z=T.lexeme;if(this.w(),this.v(9)){const H=this.C();switch(H.type){case 10:case 19:{const q=[H.lexeme];this.w();let M=this.C(),ee=0;for(let N=0;N<H.lexeme.length;N++)H.lexeme.charCodeAt(N)===40?ee++:H.lexeme.charCodeAt(N)===41&&ee--;for(;!this.D()&&M.type!==15&&M.type!==16;){switch(M.type){case 0:ee++;break;case 1:ee--;break;case 10:case 18:for(let N=0;N<M.lexeme.length;N++)M.lexeme.charCodeAt(N)===40?ee++:H.lexeme.charCodeAt(N)===41&&ee--}if(ee<0)break;q.push(l.Scanner.getLexeme(M)),this.w(),M=this.C()}const ie=q.join(""),me=ie.lastIndexOf("/"),ne=me===ie.length-1?void 0:ie.substring(me+1),B=new RegExp(ie.substring(1,me),ne);return b.regex(z,B)}case 18:{const q=H.lexeme;this.w();let M=null;if(!(0,A.isFalsyOrWhitespace)(q)){const ee=q.indexOf("/"),ie=q.lastIndexOf("/");if(ee!==ie&&ee>=0){const me=q.slice(ee+1,ie),ne=q[ie+1]==="i"?"i":"";try{M=new RegExp(me,ne)}catch{}}}if(M===null)throw this.y("REGEX",H);return u.create(z,M)}default:throw this.y("REGEX",this.C())}}if(this.v(14)){this.x(13,"'in' after 'not'");const H=this.t();return b.notIn(z,H)}switch(this.C().type){case 3:{this.w();const H=this.t();switch(H){case"true":return b.has(z);case"false":return b.not(z);default:return b.equals(z,H)}}case 4:{this.w();const H=this.t();switch(H){case"true":return b.not(z);case"false":return b.has(z);default:return b.notEquals(z,H)}}case 5:return this.w(),n.create(z,this.t());case 6:return this.w(),o.create(z,this.t());case 7:return this.w(),r.create(z,this.t());case 8:return this.w(),i.create(z,this.t());case 13:return this.w(),b.in(z,this.t());default:return b.has(z)}}default:throw this.y("'true', 'false', '(', KEY, KEY '=~' regex, KEY [ ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value ]",this.C())}}t(){const T=this.C();switch(T.type){case 17:case 18:return this.w(),T.lexeme;case 11:return this.w(),"true";case 12:return this.w(),"false";case 13:return this.w(),"in";default:return""}}u(){return this.d[this.f-1]}v(T){return this.B(T)?(this.w(),!0):!1}w(){return this.D()||this.f++,this.u()}x(T,z){if(this.B(T))return this.w();throw this.y(z,this.C())}y(T,z){return this.A(`Expected ${T} but got '${l.Scanner.getLexeme(z)}' at offset ${z.offset}.`)}z(T){return this.A(`Unexpected '${l.Scanner.getLexeme(T)}' at offset ${T.offset}.`)}A(T){return this.g.push(T),new k}B(T){return this.C().type===T}C(){return this.d[this.f]}D(){return this.C().type===20}}e.Parser=I;function v(V,T){const z=V?V.substituteConstants():void 0,he=T?T.substituteConstants():void 0;return!z&&!he?!0:!z||!he?!1:z.equals(he)}e.expressionsAreEqualWithConstantSubstitution=v;function d(V,T){return V.cmp(T)}class m{constructor(){this.type=0}cmp(T){return this.type-T.type}equals(T){return T.type===this.type}substituteConstants(){return this}evaluate(T){return!1}serialize(){return"false"}keys(){return[]}map(T){return this}negate(){return p.INSTANCE}}m.INSTANCE=new m,e.ContextKeyFalseExpr=m;class p{constructor(){this.type=1}cmp(T){return this.type-T.type}equals(T){return T.type===this.type}substituteConstants(){return this}evaluate(T){return!0}serialize(){return"true"}keys(){return[]}map(T){return this}negate(){return m.INSTANCE}}p.INSTANCE=new p,e.ContextKeyTrueExpr=p;class c{static create(T,z=null){const he=S.get(T);return typeof he=="boolean"?he?p.INSTANCE:m.INSTANCE:new c(T,z)}constructor(T,z){this.key=T,this.c=z,this.type=2}cmp(T){return T.type!==this.type?this.type-T.type:W(this.key,T.key)}equals(T){return T.type===this.type?this.key===T.key:!1}substituteConstants(){const T=S.get(this.key);return typeof T=="boolean"?T?p.INSTANCE:m.INSTANCE:this}evaluate(T){return!!T.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(T){return T.mapDefined(this.key)}negate(){return this.c||(this.c=R.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=c;class h{static create(T,z,he=null){if(typeof z=="boolean")return z?c.create(T,he):R.create(T,he);const H=S.get(T);return typeof H=="boolean"?z===(H?"true":"false")?p.INSTANCE:m.INSTANCE:new h(T,z,he)}constructor(T,z,he){this.c=T,this.d=z,this.f=he,this.type=4}cmp(T){return T.type!==this.type?this.type-T.type:X(this.c,this.d,T.c,T.d)}equals(T){return T.type===this.type?this.c===T.c&&this.d===T.d:!1}substituteConstants(){const T=S.get(this.c);if(typeof T=="boolean"){const z=T?"true":"false";return this.d===z?p.INSTANCE:m.INSTANCE}return this}evaluate(T){return T.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(T){return T.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=D.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=h;class g{static create(T,z){return new g(T,z)}constructor(T,z){this.d=T,this.f=z,this.type=10,this.c=null}cmp(T){return T.type!==this.type?this.type-T.type:X(this.d,this.f,T.d,T.f)}equals(T){return T.type===this.type?this.d===T.d&&this.f===T.f:!1}substituteConstants(){return this}evaluate(T){const z=T.getValue(this.f),he=T.getValue(this.d);return Array.isArray(z)?z.includes(he):typeof he=="string"&&typeof z=="object"&&z!==null?P.call(z,he):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(T){return T.mapIn(this.d,this.f)}negate(){return this.c||(this.c=f.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=g;class f{static create(T,z){return new f(T,z)}constructor(T,z){this.d=T,this.f=z,this.type=11,this.c=g.create(T,z)}cmp(T){return T.type!==this.type?this.type-T.type:this.c.cmp(T.c)}equals(T){return T.type===this.type?this.c.equals(T.c):!1}substituteConstants(){return this}evaluate(T){return!this.c.evaluate(T)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(T){return T.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=f;class D{static create(T,z,he=null){if(typeof z=="boolean")return z?R.create(T,he):c.create(T,he);const H=S.get(T);return typeof H=="boolean"?z===(H?"true":"false")?m.INSTANCE:p.INSTANCE:new D(T,z,he)}constructor(T,z,he){this.c=T,this.d=z,this.f=he,this.type=5}cmp(T){return T.type!==this.type?this.type-T.type:X(this.c,this.d,T.c,T.d)}equals(T){return T.type===this.type?this.c===T.c&&this.d===T.d:!1}substituteConstants(){const T=S.get(this.c);if(typeof T=="boolean"){const z=T?"true":"false";return this.d===z?m.INSTANCE:p.INSTANCE}return this}evaluate(T){return T.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(T){return T.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=h.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=D;class R{static create(T,z=null){const he=S.get(T);return typeof he=="boolean"?he?m.INSTANCE:p.INSTANCE:new R(T,z)}constructor(T,z){this.c=T,this.d=z,this.type=3}cmp(T){return T.type!==this.type?this.type-T.type:W(this.c,T.c)}equals(T){return T.type===this.type?this.c===T.c:!1}substituteConstants(){const T=S.get(this.c);return typeof T=="boolean"?T?m.INSTANCE:p.INSTANCE:this}evaluate(T){return!T.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(T){return T.mapNot(this.c)}negate(){return this.d||(this.d=c.create(this.c,this)),this.d}}e.ContextKeyNotExpr=R;function t(V,T){if(typeof V=="string"){const z=parseFloat(V);isNaN(z)||(V=z)}return typeof V=="string"||typeof V=="number"?T(V):m.INSTANCE}class r{static create(T,z,he=null){return t(z,H=>new r(T,H,he))}constructor(T,z,he){this.c=T,this.d=z,this.f=he,this.type=12}cmp(T){return T.type!==this.type?this.type-T.type:X(this.c,this.d,T.c,T.d)}equals(T){return T.type===this.type?this.c===T.c&&this.d===T.d:!1}substituteConstants(){return this}evaluate(T){return typeof this.d=="string"?!1:parseFloat(T.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(T){return T.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=o.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=r;class i{static create(T,z,he=null){return t(z,H=>new i(T,H,he))}constructor(T,z,he){this.c=T,this.d=z,this.f=he,this.type=13}cmp(T){return T.type!==this.type?this.type-T.type:X(this.c,this.d,T.c,T.d)}equals(T){return T.type===this.type?this.c===T.c&&this.d===T.d:!1}substituteConstants(){return this}evaluate(T){return typeof this.d=="string"?!1:parseFloat(T.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(T){return T.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=n.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=i;class n{static create(T,z,he=null){return t(z,H=>new n(T,H,he))}constructor(T,z,he){this.c=T,this.d=z,this.f=he,this.type=14}cmp(T){return T.type!==this.type?this.type-T.type:X(this.c,this.d,T.c,T.d)}equals(T){return T.type===this.type?this.c===T.c&&this.d===T.d:!1}substituteConstants(){return this}evaluate(T){return typeof this.d=="string"?!1:parseFloat(T.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(T){return T.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=i.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=n;class o{static create(T,z,he=null){return t(z,H=>new o(T,H,he))}constructor(T,z,he){this.c=T,this.d=z,this.f=he,this.type=15}cmp(T){return T.type!==this.type?this.type-T.type:X(this.c,this.d,T.c,T.d)}equals(T){return T.type===this.type?this.c===T.c&&this.d===T.d:!1}substituteConstants(){return this}evaluate(T){return typeof this.d=="string"?!1:parseFloat(T.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(T){return T.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=r.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=o;class u{static create(T,z){return new u(T,z)}constructor(T,z){this.d=T,this.f=z,this.type=7,this.c=null}cmp(T){if(T.type!==this.type)return this.type-T.type;if(this.d<T.d)return-1;if(this.d>T.d)return 1;const z=this.f?this.f.source:"",he=T.f?T.f.source:"";return z<he?-1:z>he?1:0}equals(T){if(T.type===this.type){const z=this.f?this.f.source:"",he=T.f?T.f.source:"";return this.d===T.d&&z===he}return!1}substituteConstants(){return this}evaluate(T){const z=T.getValue(this.d);return this.f?this.f.test(z):!1}serialize(){const T=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${T}`}keys(){return[this.d]}map(T){return T.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=a.create(this)),this.c}}e.ContextKeyRegexExpr=u;class a{static create(T){return new a(T)}constructor(T){this.c=T,this.type=8}cmp(T){return T.type!==this.type?this.type-T.type:this.c.cmp(T.c)}equals(T){return T.type===this.type?this.c.equals(T.c):!1}substituteConstants(){return this}evaluate(T){return!this.c.evaluate(T)}serialize(){throw new Error("Method not implemented.")}keys(){return this.c.keys()}map(T){return new a(this.c.map(T))}negate(){return this.c}}e.ContextKeyNotRegexExpr=a;function s(V){let T=null;for(let z=0,he=V.length;z<he;z++){const H=V[z].substituteConstants();if(V[z]!==H&&T===null){T=[];for(let q=0;q<z;q++)T[q]=V[q]}T!==null&&(T[z]=H)}return T===null?V:T}class C{static create(T,z,he){return C.d(T,z,he)}constructor(T,z){this.expr=T,this.c=z,this.type=6}cmp(T){if(T.type!==this.type)return this.type-T.type;if(this.expr.length<T.expr.length)return-1;if(this.expr.length>T.expr.length)return 1;for(let z=0,he=this.expr.length;z<he;z++){const H=d(this.expr[z],T.expr[z]);if(H!==0)return H}return 0}equals(T){if(T.type===this.type){if(this.expr.length!==T.expr.length)return!1;for(let z=0,he=this.expr.length;z<he;z++)if(!this.expr[z].equals(T.expr[z]))return!1;return!0}return!1}substituteConstants(){const T=s(this.expr);return T===this.expr?this:C.create(T,this.c,!1)}evaluate(T){for(let z=0,he=this.expr.length;z<he;z++)if(!this.expr[z].evaluate(T))return!1;return!0}static d(T,z,he){const H=[];let q=!1;for(const M of T)if(!!M){if(M.type===1){q=!0;continue}if(M.type===0)return m.INSTANCE;if(M.type===6){H.push(...M.expr);continue}H.push(M)}if(H.length===0&&q)return p.INSTANCE;if(H.length!==0){if(H.length===1)return H[0];H.sort(d);for(let M=1;M<H.length;M++)H[M-1].equals(H[M])&&(H.splice(M,1),M--);if(H.length===1)return H[0];for(;H.length>1;){const M=H[H.length-1];if(M.type!==9)break;H.pop();const ee=H.pop(),ie=H.length===0,me=L.create(M.expr.map(ne=>C.create([ne,ee],null,he)),null,ie);me&&(H.push(me),H.sort(d))}if(H.length===1)return H[0];if(he){for(let M=0;M<H.length;M++)for(let ee=M+1;ee<H.length;ee++)if(H[M].negate().equals(H[ee]))return m.INSTANCE;if(H.length===1)return H[0]}return new C(H,z)}}serialize(){return this.expr.map(T=>T.serialize()).join(" && ")}keys(){const T=[];for(const z of this.expr)T.push(...z.keys());return T}map(T){return new C(this.expr.map(z=>z.map(T)),null)}negate(){if(!this.c){const T=[];for(const z of this.expr)T.push(z.negate());this.c=L.create(T,this,!0)}return this.c}}class L{static create(T,z,he){return L.d(T,z,he)}constructor(T,z){this.expr=T,this.c=z,this.type=9}cmp(T){if(T.type!==this.type)return this.type-T.type;if(this.expr.length<T.expr.length)return-1;if(this.expr.length>T.expr.length)return 1;for(let z=0,he=this.expr.length;z<he;z++){const H=d(this.expr[z],T.expr[z]);if(H!==0)return H}return 0}equals(T){if(T.type===this.type){if(this.expr.length!==T.expr.length)return!1;for(let z=0,he=this.expr.length;z<he;z++)if(!this.expr[z].equals(T.expr[z]))return!1;return!0}return!1}substituteConstants(){const T=s(this.expr);return T===this.expr?this:L.create(T,this.c,!1)}evaluate(T){for(let z=0,he=this.expr.length;z<he;z++)if(this.expr[z].evaluate(T))return!0;return!1}static d(T,z,he){let H=[],q=!1;if(T){for(let M=0,ee=T.length;M<ee;M++){const ie=T[M];if(!!ie){if(ie.type===0){q=!0;continue}if(ie.type===1)return p.INSTANCE;if(ie.type===9){H=H.concat(ie.expr);continue}H.push(ie)}}if(H.length===0&&q)return m.INSTANCE;H.sort(d)}if(H.length!==0){if(H.length===1)return H[0];for(let M=1;M<H.length;M++)H[M-1].equals(H[M])&&(H.splice(M,1),M--);if(H.length===1)return H[0];if(he){for(let M=0;M<H.length;M++)for(let ee=M+1;ee<H.length;ee++)if(H[M].negate().equals(H[ee]))return p.INSTANCE;if(H.length===1)return H[0]}return new L(H,z)}}serialize(){return this.expr.map(T=>T.serialize()).join(" || ")}keys(){const T=[];for(const z of this.expr)T.push(...z.keys());return T}map(T){return new L(this.expr.map(z=>z.map(T)),null)}negate(){if(!this.c){const T=[];for(const z of this.expr)T.push(z.negate());for(;T.length>1;){const z=T.shift(),he=T.shift(),H=[];for(const q of ce(z))for(const M of ce(he))H.push(C.create([q,M],null,!1));T.unshift(L.create(H,null,!1))}this.c=L.create(T,this,!0)}return this.c}}class O extends c{static all(){return O.d.values()}constructor(T,z,he){super(T,null),this.f=z,typeof he=="object"?O.d.push({...he,key:T}):he!==!0&&O.d.push({key:T,description:he,type:z!=null?typeof z:void 0})}bindTo(T){return T.createKey(this.key,this.f)}getValue(T){return T.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(T){return h.create(this.key,T)}notEqualsTo(T){return D.create(this.key,T)}}O.d=[],e.RawContextKey=O,e.IContextKeyService=(0,w.createDecorator)("contextKeyService");function W(V,T){return V<T?-1:V>T?1:0}function X(V,T,z,he){return V<z?-1:V>z?1:T<he?-1:T>he?1:0}function se(V,T){if(V.type===0||T.type===1)return!0;if(V.type===9)return T.type===9?fe(V.expr,T.expr):!1;if(T.type===9){for(const z of T.expr)if(se(V,z))return!0;return!1}if(V.type===6){if(T.type===6)return fe(T.expr,V.expr);for(const z of V.expr)if(se(z,T))return!0;return!1}return V.equals(T)}e.implies=se;function fe(V,T){let z=0,he=0;for(;z<V.length&&he<T.length;){const H=V[z].cmp(T[he]);if(H<0)return!1;H===0&&z++,he++}return z===V.length}function ce(V){return V.type===9?V.expr:[V]}}),define(be[74],Ee([1,0,5]),function(oe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryCredentialsProvider=e.ICredentialsMainService=e.ICredentialsService=void 0,e.ICredentialsService=(0,E.createDecorator)("credentialsService"),e.ICredentialsMainService=(0,E.createDecorator)("credentialsMainService");class A{constructor(){this.a={}}async getPassword(w,S){return this.a[w]?.[S]??null}async setPassword(w,S,P){this.a[w]=this.a[w]??{},this.a[w][S]=P}async deletePassword(w,S){return this.a[w]?.[S]?(delete this.a[w][S],Object.keys(this.a[w]).length===0&&delete this.a[w],!0):!1}async findPassword(w){return JSON.stringify(this.a[w])??null}async findCredentials(w){const S=[];for(const P of Object.keys(this.a[w]||{}))S.push({account:P,password:this.a[w][P]});return S}async clear(){this.a={}}}e.InMemoryCredentialsProvider=A}),define(be[209],Ee([1,0,5]),function(oe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,E.createDecorator)(e.ID);function A(w){return!!w.hostName&&!!w.errorMessage}e.isRemoteDiagnosticError=A;class l{async getPerformanceInfo(S,P){return{}}async getSystemInfo(S,P){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(S,P){return""}async getWorkspaceFileExtensions(S){return{extensions:[]}}async reportWorkspaceStats(S){}}e.NullDiagnosticsService=l}),define(be[75],Ee([1,0,5]),function(oe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,E.createDecorator)("downloadService")}),define(be[210],Ee([1,0,5]),function(oe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,E.createDecorator)("encryptionMainService")}),define(be[25],Ee([1,0,5]),function(oe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,E.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,E.refineServiceDecorator)(e.IEnvironmentService)}),define(be[30],Ee([1,0,172,5]),function(oe,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function l(h){switch(h){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=l;function w(h){switch(h){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=w;function S(h,g){switch(h){case 3:return g==="x64"?"win32-x64":g==="ia32"?"win32-ia32":g==="arm64"?"win32-arm64":"unknown";case 2:return g==="x64"?"linux-x64":g==="arm64"?"linux-arm64":g==="arm"?"linux-armhf":"unknown";case"alpine":return g==="x64"?"alpine-x64":g==="arm64"?"alpine-arm64":"unknown";case 1:return g==="x64"?"darwin-x64":g==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=S;function P(h,g){return g==="web"&&!h.includes("web")}e.isNotWebExtensionInWebTargetPlatform=P;function y(h,g,f){return P(g,f)?!1:h==="undefined"||h==="universal"?!0:h==="unknown"?!1:h===f?!0:b(f).includes(h)}e.isTargetPlatformCompatible=y;function b(h){switch(h){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=b;function k(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}e.isIExtensionIdentifier=k;var I;(function(h){h[h.NoneOrRelevance=0]="NoneOrRelevance",h[h.LastUpdatedDate=1]="LastUpdatedDate",h[h.Title=2]="Title",h[h.PublisherName=3]="PublisherName",h[h.InstallCount=4]="InstallCount",h[h.PublishedDate=10]="PublishedDate",h[h.AverageRating=6]="AverageRating",h[h.WeightedRating=12]="WeightedRating"})(I=e.SortBy||(e.SortBy={}));var v;(function(h){h[h.Default=0]="Default",h[h.Ascending=1]="Ascending",h[h.Descending=2]="Descending"})(v=e.SortOrder||(e.SortOrder={}));var d;(function(h){h.Install="install",h.Uninstall="uninstall"})(d=e.StatisticType||(e.StatisticType={}));var m;(function(h){h[h.None=1]="None",h[h.Install=2]="Install",h[h.Update=3]="Update",h[h.Migrate=4]="Migrate"})(m=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,A.createDecorator)("extensionGalleryService");var p;(function(h){h.Unsupported="Unsupported",h.Deprecated="Deprecated",h.Malicious="Malicious",h.Incompatible="Incompatible",h.IncompatiblePreRelease="IncompatiblePreRelease",h.IncompatibleTargetPlatform="IncompatibleTargetPlatform",h.ReleaseVersionNotFound="ReleaseVersionNotFound",h.Invalid="Invalid",h.Download="Download",h.Extract="Extract",h.Delete="Delete",h.Rename="Rename",h.CorruptZip="CorruptZip",h.IncompleteZip="IncompleteZip",h.Internal="Internal",h.Signature="Signature"})(p=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class c extends Error{constructor(g,f){super(g),this.code=f,this.name=f}}e.ExtensionManagementError=c,e.IExtensionManagementService=(0,A.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,A.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,A.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,E.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,E.localize)(1,null),original:"Preferences"}}),define(be[211],Ee([1,0,6,2,23,4,47,30]),function(oe,e,E,A,l,w,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function y(c,h){return c?w.URI.revive(h?h.transformIncoming(c):c):void 0}function b(c,h){return h?h.transformOutgoingURI(c):c}function k(c,h){h=h||S.DefaultURITransformer;const g=c.manifest;return{...(0,S.transformAndReviveIncomingURIs)({...c,manifest:void 0},h),manifest:g}}function I(c,h){return c?.profileLocation?(0,S.transformAndReviveIncomingURIs)(c,h??S.DefaultURITransformer):c}function v(c,h){return h?(0,l.cloneAndChange)(c,g=>g instanceof w.URI?h.transformOutgoingURI(g):void 0):c}class d{constructor(h,g){this.a=h,this.b=g,this.onInstallExtension=E.Event.buffer(h.onInstallExtension,!0),this.onDidInstallExtensions=E.Event.buffer(h.onDidInstallExtensions,!0),this.onUninstallExtension=E.Event.buffer(h.onUninstallExtension,!0),this.onDidUninstallExtension=E.Event.buffer(h.onDidUninstallExtension,!0),this.onDidUpdateExtensionMetadata=E.Event.buffer(h.onDidUpdateExtensionMetadata,!0)}listen(h,g){const f=this.b(h);switch(g){case"onInstallExtension":return E.Event.map(this.onInstallExtension,D=>({...D,profileLocation:D.profileLocation?b(D.profileLocation,f):D.profileLocation}));case"onDidInstallExtensions":return E.Event.map(this.onDidInstallExtensions,D=>D.map(R=>({...R,local:R.local?v(R.local,f):R.local,profileLocation:R.profileLocation?b(R.profileLocation,f):R.profileLocation})));case"onUninstallExtension":return E.Event.map(this.onUninstallExtension,D=>({...D,profileLocation:D.profileLocation?b(D.profileLocation,f):D.profileLocation}));case"onDidUninstallExtension":return E.Event.map(this.onDidUninstallExtension,D=>({...D,profileLocation:D.profileLocation?b(D.profileLocation,f):D.profileLocation}));case"onDidUpdateExtensionMetadata":return E.Event.map(this.onDidUpdateExtensionMetadata,D=>v(D,f))}throw new Error("Invalid listen")}async call(h,g,f){const D=this.b(h);switch(g){case"zip":{const R=k(f[0],D),t=await this.a.zip(R);return b(t,D)}case"unzip":return this.a.unzip(y(f[0],D));case"install":return this.a.install(y(f[0],D),I(f[1],D));case"installFromLocation":return this.a.installFromLocation(y(f[0],D),y(f[1],D));case"installExtensionsFromProfile":return this.a.installExtensionsFromProfile(f[0],y(f[1],D),y(f[2],D));case"getManifest":return this.a.getManifest(y(f[0],D));case"getTargetPlatform":return this.a.getTargetPlatform();case"canInstall":return this.a.canInstall(f[0]);case"installFromGallery":return this.a.installFromGallery(f[0],I(f[1],D));case"uninstall":return this.a.uninstall(k(f[0],D),I(f[1],D));case"reinstallFromGallery":return this.a.reinstallFromGallery(k(f[0],D));case"getInstalled":return(await this.a.getInstalled(f[0],y(f[1],D))).map(t=>v(t,D));case"copyExtensions":return this.a.copyExtensions(y(f[0],D),y(f[1],D));case"updateMetadata":{const R=await this.a.updateMetadata(k(f[0],D),f[1],y(f[2],D));return v(R,D)}case"getExtensionsControlManifest":return this.a.getExtensionsControlManifest();case"download":return this.a.download(f[0],f[1]);case"cleanUp":return this.a.cleanUp()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=d;class m extends A.Disposable{get onInstallExtension(){return this.c.event}get onDidInstallExtensions(){return this.f.event}get onUninstallExtension(){return this.g.event}get onDidUninstallExtension(){return this.h.event}get onDidUpdateExtensionMetadata(){return this.j.event}constructor(h){super(),this.k=h,this.c=this.B(new E.Emitter),this.f=this.B(new E.Emitter),this.g=this.B(new E.Emitter),this.h=this.B(new E.Emitter),this.j=this.B(new E.Emitter),this.B(this.k.listen("onInstallExtension")(g=>this.l(this.c,{...g,source:this.m(g.source)?w.URI.revive(g.source):g.source,profileLocation:w.URI.revive(g.profileLocation)}))),this.B(this.k.listen("onDidInstallExtensions")(g=>this.l(this.f,g.map(f=>({...f,local:f.local?k(f.local,null):f.local,source:this.m(f.source)?w.URI.revive(f.source):f.source,profileLocation:w.URI.revive(f.profileLocation)}))))),this.B(this.k.listen("onUninstallExtension")(g=>this.l(this.g,{...g,profileLocation:w.URI.revive(g.profileLocation)}))),this.B(this.k.listen("onDidUninstallExtension")(g=>this.l(this.h,{...g,profileLocation:w.URI.revive(g.profileLocation)}))),this.B(this.k.listen("onDidUpdateExtensionMetadata")(g=>this.j.fire(k(g,null))))}l(h,g){h.fire(g)}m(h){return h?typeof h.path=="string"&&typeof h.scheme=="string":!1}getTargetPlatform(){return this.n||(this.n=this.k.call("getTargetPlatform")),this.n}async canInstall(h){const g=await this.getTargetPlatform();return h.allTargetPlatforms.some(f=>(0,P.isTargetPlatformCompatible)(f,h.allTargetPlatforms,g))}zip(h){return Promise.resolve(this.k.call("zip",[h]).then(g=>w.URI.revive(g)))}unzip(h){return Promise.resolve(this.k.call("unzip",[h]))}install(h,g){return Promise.resolve(this.k.call("install",[h,g])).then(f=>k(f,null))}installFromLocation(h,g){return Promise.resolve(this.k.call("installFromLocation",[h,g])).then(f=>k(f,null))}async installExtensionsFromProfile(h,g,f){return(await this.k.call("installExtensionsFromProfile",[h,g,f])).map(R=>k(R,null))}getManifest(h){return Promise.resolve(this.k.call("getManifest",[h]))}installFromGallery(h,g){return Promise.resolve(this.k.call("installFromGallery",[h,g])).then(f=>k(f,null))}uninstall(h,g){return Promise.resolve(this.k.call("uninstall",[h,g]))}reinstallFromGallery(h){return Promise.resolve(this.k.call("reinstallFromGallery",[h])).then(g=>k(g,null))}getInstalled(h=null,g){return Promise.resolve(this.k.call("getInstalled",[h,g])).then(f=>f.map(D=>k(D,null)))}updateMetadata(h,g,f){return Promise.resolve(this.k.call("updateMetadata",[h,g,f])).then(D=>k(D,null))}copyExtensions(h,g){return this.k.call("copyExtensions",[h,g])}getExtensionsControlManifest(){return Promise.resolve(this.k.call("getExtensionsControlManifest"))}async download(h,g){const f=await this.k.call("download",[h,g]);return w.URI.revive(f)}async cleanUp(){return this.k.call("cleanUp")}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=m;class p{constructor(h){this.a=h}listen(h,g){throw new Error("Invalid listen")}call(h,g,f){switch(g){case"getConfigBasedTips":return this.a.getConfigBasedTips(w.URI.revive(f[0]));case"getImportantExecutableBasedTips":return this.a.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.a.getOtherExecutableBasedTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=p}),define(be[76],Ee([1,0,5]),function(oe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSignatureVerificationService=e.IExtensionSignatureVerificationService=void 0,e.IExtensionSignatureVerificationService=(0,E.createDecorator)("IExtensionSignatureVerificationService");class A{b(){return this.a||(this.a=new Promise((w,S)=>oe(["node-vsce-sign"],async P=>w(P),S))),this.a}async verify(w,S,P){let y;try{y=await this.b()}catch{return!1}return y.verify(w,S,P)}}e.ExtensionSignatureVerificationService=A}),define(be[16],Ee([1,0,60,7,17,8,4,180,5,3,13]),function(oe,e,E,A,l,w,S,P,y,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.getPlatformFileLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,y.createDecorator)("fileService");function I(M){return M.create===!0}e.isFileOpenForWriteOptions=I;var v;(function(M){M[M.Unknown=0]="Unknown",M[M.File=1]="File",M[M.Directory=2]="Directory",M[M.SymbolicLink=64]="SymbolicLink"})(v=e.FileType||(e.FileType={}));var d;(function(M){M[M.Readonly=1]="Readonly"})(d=e.FilePermission||(e.FilePermission={}));var m;(function(M){M[M.None=0]="None",M[M.FileReadWrite=2]="FileReadWrite",M[M.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",M[M.FileReadStream=16]="FileReadStream",M[M.FileFolderCopy=8]="FileFolderCopy",M[M.PathCaseSensitive=1024]="PathCaseSensitive",M[M.Readonly=2048]="Readonly",M[M.Trash=4096]="Trash",M[M.FileWriteUnlock=8192]="FileWriteUnlock",M[M.FileAtomicRead=16384]="FileAtomicRead",M[M.FileClone=32768]="FileClone"})(m=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function p(M){return!!(M.capabilities&2)}e.hasReadWriteCapability=p;function c(M){return!!(M.capabilities&8)}e.hasFileFolderCopyCapability=c;function h(M){return!!(M.capabilities&32768)}e.hasFileCloneCapability=h;function g(M){return!!(M.capabilities&4)}e.hasOpenReadWriteCloseCapability=g;function f(M){return!!(M.capabilities&16)}e.hasFileReadStreamCapability=f;function D(M){return p(M)?!!(M.capabilities&16384):!1}e.hasFileAtomicReadCapability=D;var R;(function(M){M.FileExists="EntryExists",M.FileNotFound="EntryNotFound",M.FileNotADirectory="EntryNotADirectory",M.FileIsADirectory="EntryIsADirectory",M.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",M.FileTooLarge="EntryTooLarge",M.FileWriteLocked="EntryWriteLocked",M.NoPermissions="NoPermissions",M.Unavailable="Unavailable",M.Unknown="Unknown"})(R=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class t extends Error{static create(ee,ie){const me=new t(ee.toString(),ie);return n(me,ie),me}constructor(ee,ie){super(ee),this.code=ie}}e.FileSystemProviderError=t;function r(M,ee){return t.create(M,ee)}e.createFileSystemProviderError=r;function i(M){return M||r((0,P.localize)(0,null),R.Unknown)}e.ensureFileSystemProviderError=i;function n(M,ee){return M.name=ee?`${ee} (FileSystemError)`:"FileSystemError",M}e.markAsFileSystemProviderError=n;function o(M){if(!M)return R.Unknown;if(M instanceof t)return M.code;const ee=/^(.+) \(FileSystemError\)$/.exec(M.name);if(!ee)return R.Unknown;switch(ee[1]){case R.FileExists:return R.FileExists;case R.FileIsADirectory:return R.FileIsADirectory;case R.FileNotADirectory:return R.FileNotADirectory;case R.FileNotFound:return R.FileNotFound;case R.FileExceedsMemoryLimit:return R.FileExceedsMemoryLimit;case R.FileTooLarge:return R.FileTooLarge;case R.FileWriteLocked:return R.FileWriteLocked;case R.NoPermissions:return R.NoPermissions;case R.Unavailable:return R.Unavailable}return R.Unknown}e.toFileSystemProviderErrorCode=o;function u(M){if(M instanceof W)return M.fileOperationResult;switch(o(M)){case R.FileNotFound:return 1;case R.FileIsADirectory:return 0;case R.FileNotADirectory:return 10;case R.FileWriteLocked:return 5;case R.NoPermissions:return 6;case R.FileExists:return 4;case R.FileExceedsMemoryLimit:return 9;case R.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=u;var a;(function(M){M[M.CREATE=0]="CREATE",M[M.DELETE=1]="DELETE",M[M.MOVE=2]="MOVE",M[M.COPY=3]="COPY",M[M.WRITE=4]="WRITE"})(a=e.FileOperation||(e.FileOperation={}));class s{constructor(ee,ie,me){this.resource=ee,this.operation=ie,this.target=me}isOperation(ee){return this.operation===ee}}e.FileOperationEvent=s;var C;(function(M){M[M.UPDATED=0]="UPDATED",M[M.ADDED=1]="ADDED",M[M.DELETED=2]="DELETED"})(C=e.FileChangeType||(e.FileChangeType={}));class L{constructor(ee,ie){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const me=new Map;for(const ne of ee){const B=me.get(ne.type);switch(B?B.push([ne.resource,ne]):me.set(ne.type,[[ne.resource,ne]]),ne.type){case 1:this.rawAdded.push(ne.resource);break;case 0:this.rawUpdated.push(ne.resource);break;case 2:this.rawDeleted.push(ne.resource);break}}for(const[ne,B]of me)switch(ne){case 1:this.a=E.TernarySearchTree.forUris(()=>ie),this.a.fill(B);break;case 0:this.b=E.TernarySearchTree.forUris(()=>ie),this.b.fill(B);break;case 2:this.c=E.TernarySearchTree.forUris(()=>ie),this.c.fill(B);break}}contains(ee,...ie){return this.d(ee,{includeChildren:!1},...ie)}affects(ee,...ie){return this.d(ee,{includeChildren:!0},...ie)}d(ee,ie,...me){if(!ee)return!1;const ne=me.length>0;return!!((!ne||me.includes(1))&&(this.a?.get(ee)||ie.includeChildren&&this.a?.findSuperstr(ee))||(!ne||me.includes(0))&&(this.b?.get(ee)||ie.includeChildren&&this.b?.findSuperstr(ee))||(!ne||me.includes(2))&&(this.c?.findSubstr(ee)||ie.includeChildren&&this.c?.findSuperstr(ee)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=L;function O(M,ee,ie){return!M||!ee||M===ee||ee.length>M.length?!1:(ee.charAt(ee.length-1)!==A.sep&&(ee+=A.sep),ie?(0,l.startsWithIgnoreCase)(M,ee):M.indexOf(ee)===0)}e.isParent=O;class W extends Error{constructor(ee,ie,me){super(ee),this.fileOperationResult=ie,this.options=me}}e.FileOperationError=W;class X extends W{constructor(ee,ie,me,ne){super(ee,ie,ne),this.fileOperationResult=ie,this.size=me}}e.TooLargeFileOperationError=X;class se extends W{constructor(ee,ie,me){super(ee,2,me),this.stat=ie}}e.NotModifiedSinceFileOperationError=se;var fe;(function(M){M[M.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",M[M.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",M[M.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",M[M.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",M[M.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",M[M.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",M[M.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",M[M.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",M[M.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",M[M.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",M[M.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",M[M.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(fe=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var ce;(function(M){M[M.FILE=0]="FILE",M[M.FOLDER=1]="FOLDER",M[M.ROOT_FOLDER=2]="ROOT_FOLDER"})(ce=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function V(M){if(!(typeof M.size!="number"||typeof M.mtime!="number"))return M.mtime.toString(29)+M.size.toString(31)}e.etag=V;async function T(M,ee){if(!ee.hasProvider(S.URI.from({scheme:M.scheme})))return new Promise(ie=>{const me=ee.onDidChangeFileSystemProviderRegistrations(ne=>{ne.scheme===M.scheme&&ne.added&&(me.dispose(),ie())})})}e.whenProviderRegistered=T,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class z{static formatSize(ee){return(0,w.isNumber)(ee)||(ee=0),ee<z.KB?(0,P.localize)(1,null,ee.toFixed(0)):ee<z.MB?(0,P.localize)(2,null,(ee/z.KB).toFixed(2)):ee<z.GB?(0,P.localize)(3,null,(ee/z.MB).toFixed(2)):ee<z.TB?(0,P.localize)(4,null,(ee/z.GB).toFixed(2)):(0,P.localize)(5,null,(ee/z.TB).toFixed(2))}}z.KB=1024,z.MB=z.KB*z.KB,z.GB=z.MB*z.KB,z.TB=z.GB*z.KB,e.ByteSize=z;var he;(function(M){M[M.IA32=0]="IA32",M[M.OTHER=1]="OTHER"})(he=e.Arch||(e.Arch={}));function H(M){return{maxFileSize:M===0?300*z.MB:16*z.GB,maxHeapSize:M===0?700*z.MB:2*700*z.MB}}e.getPlatformFileLimits=H;function q(M){const ee=typeof M=="string"||M?.scheme===k.Schemas.vscodeRemote;return typeof M!="string"&&M?.scheme===k.Schemas.file?1024*z.MB:ee?10*z.MB:b.isWeb?50*z.MB:1024*z.MB}e.getLargeFileConfirmationLimit=q}),define(be[212],Ee([1,0,15,39,9,6,2,45,4,21,16]),function(oe,e,E,A,l,w,S,P,y,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class I extends S.Disposable{constructor(d,m){super(),this.a=d,this.b=m,this.onDidChangeCapabilities=w.Event.None,this.f=this.B(new w.Emitter),this.onDidChangeFile=this.f.event,this.g=this.B(new w.Emitter),this.onDidWatchError=this.g.event,this.h=(0,b.generateUuid)(),this.i()}get capabilities(){return this.c||(this.c=57374,this.b.pathCaseSensitive&&(this.c|=1024),this.b.trash&&(this.c|=4096)),this.c}stat(d){return this.a.call("stat",[d])}readdir(d){return this.a.call("readdir",[d])}async readFile(d,m){const{buffer:p}=await this.a.call("readFile",[d,m]);return p}readFileStream(d,m,p){const c=(0,P.newWriteableStream)(g=>E.VSBuffer.concat(g.map(f=>E.VSBuffer.wrap(f))).buffer),h=this.a.listen("readFileStream",[d,m])(g=>{if(g instanceof E.VSBuffer)c.write(g.buffer);else{if(g==="end")c.end();else{let f;if(g instanceof Error)f=g;else{const D=g;f=(0,k.createFileSystemProviderError)(D.message??(0,A.toErrorMessage)(D),D.code??k.FileSystemProviderErrorCode.Unknown)}c.error(f),c.end()}h.dispose()}});return p.onCancellationRequested(()=>{c.error((0,l.canceled)()),c.end(),h.dispose()}),c}writeFile(d,m,p){return this.a.call("writeFile",[d,E.VSBuffer.wrap(m),p])}open(d,m){return this.a.call("open",[d,m])}close(d){return this.a.call("close",[d])}async read(d,m,p,c,h){const[g,f]=await this.a.call("read",[d,m,h]);return p.set(g.buffer.slice(0,f),c),f}write(d,m,p,c,h){return this.a.call("write",[d,m,E.VSBuffer.wrap(p),c,h])}mkdir(d){return this.a.call("mkdir",[d])}delete(d,m){return this.a.call("delete",[d,m])}rename(d,m,p){return this.a.call("rename",[d,m,p])}copy(d,m,p){return this.a.call("copy",[d,m,p])}cloneFile(d,m){return this.a.call("cloneFile",[d,m])}i(){this.B(this.a.listen("fileChange",[this.h])(d=>{if(Array.isArray(d)){const m=d;this.f.fire(m.map(p=>({resource:y.URI.revive(p.resource),type:p.type})))}else{const m=d;this.g.fire(m)}}))}watch(d,m){const p=(0,b.generateUuid)();return this.a.call("watch",[this.h,p,d,m]),(0,S.toDisposable)(()=>this.a.call("unwatch",[this.h,p]))}}e.DiskFileSystemProviderClient=I}),define(be[106],Ee([1,0,15,9,181,16]),function(oe,e,E,A,l,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function S(k,I,v,d,m,p){let c;try{await P(k,I,v,d,m,p)}catch(h){c=h}finally{c&&m.errorTransformer&&(c=m.errorTransformer(c)),typeof c<"u"&&v.error(c),v.end()}}e.readFileIntoStream=S;async function P(k,I,v,d,m,p){y(p);const c=await k.open(I,{create:!1});try{y(p);let h=0,g=0,f=m&&typeof m.length=="number"?m.length:void 0,D=E.VSBuffer.alloc(Math.min(m.bufferSize,typeof f=="number"?f:m.bufferSize)),R=m&&typeof m.position=="number"?m.position:0,t=0;do g=await k.read(c,R,D.buffer,t,D.byteLength-t),R+=g,t+=g,h+=g,typeof f=="number"&&(f-=g),t===D.byteLength&&(await v.write(d(D)),D=E.VSBuffer.alloc(Math.min(m.bufferSize,typeof f=="number"?f:m.bufferSize)),t=0);while(g>0&&(typeof f!="number"||f>0)&&y(p)&&b(h,m));if(t>0){let r=t;typeof f=="number"&&(r=Math.min(t,f)),v.write(d(D.slice(0,r)))}}catch(h){throw(0,w.ensureFileSystemProviderError)(h)}finally{await k.close(c)}}function y(k){if(k.isCancellationRequested)throw(0,A.canceled)();return!0}function b(k,I){if(I?.limits){if(typeof I.limits.memory=="number"&&k>I.limits.memory)throw(0,w.createFileSystemProviderError)((0,l.localize)(0,null),w.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof I.limits.size=="number"&&k>I.limits.size)throw(0,w.createFileSystemProviderError)((0,l.localize)(1,null),w.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(be[65],Ee([1,0,72,2,7,3,4,16]),function(oe,e,E,A,l,w,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function y(h){return h.recursive===!0}e.isRecursiveWatchRequest=y;class b extends A.Disposable{constructor(g,f,D,R){super(),this.h=g,this.i=f,this.j=D,this.k=R,this.c=this.B(new A.MutableDisposable),this.f=void 0,this.g=0}m(){const g=new A.DisposableStore;this.c.value=g,this.b=this.l(g),this.b.setVerboseLogging(this.j),g.add(this.b.onDidChangeFile(f=>this.h(f))),g.add(this.b.onDidLogMessage(f=>this.i(f))),g.add(this.b.onDidError(f=>this.n(f)))}n(g){this.k.restartOnError?this.g<b.a&&this.f?(this.r(`restarting watcher after error: ${g}`),this.p(this.f)):this.r(`gave up attempting to restart watcher after error: ${g}`):this.r(g)}p(g){this.g++,this.m(),this.watch(g)}async watch(g){this.f=g,await this.b?.watch(g)}async setVerboseLogging(g){this.j=g,await this.b?.setVerboseLogging(g)}r(g){this.i({type:"error",message:`[File Watcher (${this.k.type})] ${g}`})}s(g){this.i({type:"trace",message:`[File Watcher (${this.k.type})] ${g}`})}dispose(){return this.b=void 0,super.dispose()}}b.a=5,e.AbstractWatcherClient=b;class k extends b{constructor(g,f,D){super(g,f,D,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=k;class I extends b{constructor(g,f,D){super(g,f,D,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=I;function v(h){return h.map(g=>({type:g.type,resource:S.URI.file(g.path)}))}e.toFileChanges=v;function d(h){const g=new c;for(const f of h)g.processEvent(f);return g.coalesce()}e.coalesceEvents=d;function m(h,g){return typeof g=="string"&&!g.startsWith(E.GLOBSTAR)&&!(0,l.isAbsolute)(g)?{base:h,pattern:g}:g}e.normalizeWatcherPattern=m;function p(h,g){const f=[];for(const D of g)f.push((0,E.parse)(m(h,D)));return f}e.parseWatcherPatterns=p;class c{constructor(){this.a=new Set,this.b=new Map}c(g){return w.isLinux?g.path:g.path.toLowerCase()}processEvent(g){const f=this.b.get(this.c(g));let D=!1;if(f){const R=f.type,t=g.type;f.path!==g.path&&(g.type===2||g.type===1)?D=!0:R===1&&t===2?(this.b.delete(this.c(g)),this.a.delete(f)):R===2&&t===1?f.type=0:R===1&&t===0||(f.type=t)}else D=!0;D&&(this.a.add(g),this.b.set(this.c(g),g))}coalesce(){const g=[],f=[];return Array.from(this.a).filter(D=>D.type!==2?(g.push(D),!1):!0).sort((D,R)=>D.path.length-R.path.length).filter(D=>f.some(R=>(0,P.isParent)(D.path,R,!w.isLinux))?!1:(f.push(D.path),!0)).concat(g)}}}),define(be[213],Ee([1,0,33,14,19,38,2,90,7,3,154,22,65]),function(oe,e,E,A,l,w,S,P,y,b,k,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class d extends S.Disposable{constructor(c,h,g,f){super(),this.j=c,this.k=h,this.l=g,this.m=f,this.c=this.B(new A.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},D=>this.k(D))),this.f=this.B(new A.RunOnceWorker(D=>this.u(D),d.b)),this.g=(0,v.parseWatcherPatterns)(this.j.path,this.j.excludes),this.h=this.j.includes?(0,v.parseWatcherPatterns)(this.j.path,this.j.includes):void 0,this.i=new l.CancellationTokenSource,this.ready=this.n()}async n(){try{const c=await this.r(this.j);if(this.i.token.isCancellationRequested)return;const h=await I.Promises.stat(c);this.B(await this.s(c,h.isDirectory()))}catch(c){c.code!=="ENOENT"?this.w(c):this.z(c)}}async r(c){let h=c.path;try{h=await I.Promises.realpath(c.path),c.path===h&&(h=await(0,k.realcase)(c.path)??c.path),c.path!==h&&this.z(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${c.path}, real: ${h})`)}catch{}return h}async s(c,h){if(b.isMacintosh&&(0,w.isEqualOrParent)(c,"/Volumes/",!0))return this.w(`Refusing to watch ${c} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),S.Disposable.None;const g=new l.CancellationTokenSource(this.i.token),f=new S.DisposableStore;try{const D=(0,y.basename)(c),R=(0,E.watch)(c);f.add((0,S.toDisposable)(()=>{R.removeAllListeners(),R.close()})),this.z(`Started watching: '${c}'`);const t=new Set;if(h)try{for(const i of await I.Promises.readdir(c))t.add(i)}catch(i){this.w(i)}const r=new Map;f.add((0,S.toDisposable)(()=>{for(const[,i]of r)i.dispose();r.clear()})),R.on("error",(i,n)=>{this.w(`Failed to watch ${c} for changes using fs.watch() (${i}, ${n})`),this.dispose()}),R.on("change",(i,n)=>{if(g.token.isCancellationRequested)return;this.z(`[raw] ["${i}"] ${n}`);let o="";if(n&&(o=n.toString(),b.isMacintosh&&(o=(0,P.normalizeNFC)(o))),!(!o||i!=="change"&&i!=="rename"))if(h)if(i==="rename"){r.get(o)?.dispose();const u=setTimeout(async()=>{if(r.delete(o),o===D&&!await I.Promises.exists(c)){this.y("Watcher shutdown because watched path got deleted"),this.dispose();return}const a=await this.v((0,y.join)(c,o));if(g.token.isCancellationRequested)return;let s;a?t.has(o)?s=0:(s=1,t.add(o)):(t.delete(o),s=2),this.t({path:(0,y.join)(this.j.path,o),type:s})},d.a);r.set(o,(0,S.toDisposable)(()=>clearTimeout(u)))}else{let u;t.has(o)?u=0:(u=1,t.add(o)),this.t({path:(0,y.join)(this.j.path,o),type:u})}else if(i==="rename"||o!==D){const u=setTimeout(async()=>{const a=await I.Promises.exists(c);g.token.isCancellationRequested||(a?(this.t({path:this.j.path,type:0},!0),f.add(await this.s(c,!1))):(this.t({path:this.j.path,type:2},!0),this.f.flush(),this.dispose()))},d.a);f.clear(),f.add((0,S.toDisposable)(()=>clearTimeout(u)))}else this.t({path:this.j.path,type:0},!0)})}catch(D){await I.Promises.exists(c)&&!g.token.isCancellationRequested&&this.w(`Failed to watch ${c} for changes using fs.watch() (${D.toString()})`)}return(0,S.toDisposable)(()=>{g.dispose(!0),f.dispose()})}t(c,h=!1){this.i.token.isCancellationRequested||(this.m&&this.z(`${c.type===1?"[ADDED]":c.type===2?"[DELETED]":"[CHANGED]"} ${c.path}`),!h&&this.g.some(g=>g(c.path))?this.m&&this.z(` >> ignored (excluded) ${c.path}`):!h&&this.h&&this.h.length>0&&!this.h.some(g=>g(c.path))?this.m&&this.z(` >> ignored (not included) ${c.path}`):this.f.work(c))}u(c){const h=(0,v.coalesceEvents)(c);if(h.length>0){if(this.m)for(const f of h)this.z(`>> normalized ${f.type===1?"[ADDED]":f.type===2?"[DELETED]":"[CHANGED]"} ${f.path}`);this.c.work(h)?this.c.pending>0&&this.z(`started throttling events due to large amount of file change events at once (pending: ${this.c.pending}, most recent change: ${h[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.y(`started ignoring events due to too many file change events at once (incoming: ${h.length}, most recent change: ${h[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}async v(c){if(b.isLinux)return I.Promises.exists(c);try{const h=(0,y.basename)(c);return(await I.Promises.readdir((0,y.dirname)(c))).some(f=>f===h)}catch(h){return this.z(h),!1}}setVerboseLogging(c){this.m=c}w(c){this.i.token.isCancellationRequested||this.l?.({type:"error",message:`[File Watcher (node.js)] ${c}`})}y(c){this.i.token.isCancellationRequested||this.l?.({type:"warn",message:`[File Watcher (node.js)] ${c}`})}z(c){!this.i.token.isCancellationRequested&&this.m&&this.l?.({type:"trace",message:`[File Watcher (node.js)] ${c}`})}dispose(){this.z(`stopping file watcher on ${this.j.path}`),this.i.dispose(!0),super.dispose()}}d.a=100,d.b=75,e.NodeJSFileWatcherLibrary=d;async function m(p,c,h,g,f=512){const D=await I.Promises.open(p,"r"),R=Buffer.allocUnsafe(f),t=new l.CancellationTokenSource(g);let r,i=!1;const n={path:p,excludes:[],recursive:!1},o=new d(n,u=>{(async()=>{for(const{type:a}of u)if(a===0){if(i)return;i=!0;try{for(;!t.token.isCancellationRequested;){const{bytesRead:s}=await I.Promises.read(D,R,0,f,null);if(!s||t.token.isCancellationRequested)break;c(R.slice(0,s))}}catch(s){r=new Error(s),t.dispose(!0)}finally{i=!1}}})()});return await o.ready,h(),new Promise((u,a)=>{t.token.onCancellationRequested(async()=>{o.dispose();try{await I.Promises.close(D)}catch(s){r=new Error(s)}r?a(r):u()})})}e.watchFileContents=m}),define(be[214],Ee([1,0,6,72,2,3,213]),function(oe,e,E,A,l,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class P extends l.Disposable{constructor(){super(...arguments),this.a=this.B(new E.Emitter),this.onDidChangeFile=this.a.event,this.b=this.B(new E.Emitter),this.onDidLogMessage=this.b.event,this.onDidError=E.Event.None,this.c=new Map,this.f=!1}async watch(b){const k=this.i(b),I=k.filter(d=>{const m=this.c.get(d.path);return m?!(0,A.patternsEquals)(m.request.excludes,d.excludes)||!(0,A.patternsEquals)(m.request.includes,d.includes):!0}),v=Array.from(this.c.values()).filter(({request:d})=>!k.find(m=>m.path===d.path&&(0,A.patternsEquals)(m.excludes,d.excludes)&&(0,A.patternsEquals)(m.includes,d.includes))).map(({request:d})=>d.path);I.length&&this.j(`Request to start watching: ${I.map(d=>`${d.path} (excludes: ${d.excludes.length>0?d.excludes:"<none>"}, includes: ${d.includes&&d.includes.length>0?JSON.stringify(d.includes):"<all>"})`).join(",")}`),v.length&&this.j(`Request to stop watching: ${v.join(",")}`);for(const d of v)this.h(d);for(const d of I)this.g(d)}g(b){const k=new S.NodeJSFileWatcherLibrary(b,v=>this.a.fire(v),v=>this.b.fire(v),this.f),I={request:b,instance:k};this.c.set(b.path,I)}async stop(){for(const[b]of this.c)this.h(b);this.c.clear()}h(b){const k=this.c.get(b);k&&(this.c.delete(b),k.instance.dispose())}i(b){const k=new Map;for(const I of b){const v=w.isLinux?I.path:I.path.toLowerCase();k.set(v,I)}return Array.from(k.values())}async setVerboseLogging(b){this.f=b;for(const[,k]of this.c)k.instance.setVerboseLogging(b)}j(b){this.f&&this.b.fire({type:"trace",message:this.k(b)})}k(b,k){return k?`[File Watcher (node.js)] ${b} (path: ${k.request.path})`:`[File Watcher (node.js)] ${b}`}}e.NodeJSWatcher=P}),define(be[215],Ee([1,0,65,214]),function(oe,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class l extends E.AbstractNonRecursiveWatcherClient{constructor(S,P,y){super(S,P,y),this.m()}l(){return new A.NodeJSWatcher}}e.NodeJSWatcherClient=l}),define(be[216],Ee([1,0,13,43,102,65]),function(oe,e,E,A,l,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class S extends w.AbstractUniversalWatcherClient{constructor(y,b,k){super(y,b,k),this.m()}l(y){const b=y.add(new l.Client(E.FileAccess.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return y.add(b.onDidProcessExit(({code:k,signal:I})=>this.n(`terminated by itself with code ${k}, signal: ${I}`))),A.ProxyChannel.toService((0,A.getNextTickChannel)(b.getChannel("watcher")))}}e.UniversalWatcherClient=S}),define(be[77],Ee([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class E{constructor(...l){this.a=new Map;for(const[w,S]of l)this.set(w,S)}set(l,w){const S=this.a.get(l);return this.a.set(l,w),S}has(l){return this.a.has(l)}get(l){return this.a.get(l)}}e.ServiceCollection=E}),define(be[107],Ee([1,0,14,9,2,64,208,5,77,89]),function(oe,e,E,A,l,w,S,P,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const k=!1;class I extends Error{constructor(c){super("cyclic dependency between services"),this.message=c.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${c.toString()}`}}class v{constructor(c=new y.ServiceCollection,h=!1,g,f=k){this.f=c,this.g=h,this.h=g,this.i=f,this.o=new Set,this.f.set(P.IInstantiationService,this),this._globalGraph=f?g?._globalGraph??new S.Graph(D=>D):void 0}createChild(c){return new v(c,this.g,this,this.i)}invokeFunction(c,...h){const g=m.traceInvocation(this.i,c);let f=!1;try{return c({get:R=>{if(f)throw(0,A.illegalState)("service accessor is only valid during the invocation of its target method");const t=this.m(R,g);if(!t)throw new Error(`[invokeFunction] unknown service '${R}'`);return t}},...h)}finally{f=!0,g.stop()}}createInstance(c,...h){let g,f;return c instanceof w.SyncDescriptor?(g=m.traceCreation(this.i,c.ctor),f=this.j(c.ctor,c.staticArguments.concat(h),g)):(g=m.traceCreation(this.i,c),f=this.j(c,h,g)),g.stop(),f}j(c,h=[],g){const f=P._util.getServiceDependencies(c).sort((t,r)=>t.index-r.index),D=[];for(const t of f){const r=this.m(t.id,g);r||this.u(`[createInstance] ${c.name} depends on UNKNOWN service ${t.id}.`,!1),D.push(r)}const R=f.length>0?f[0].index:h.length;if(h.length!==R){console.trace(`[createInstance] First service dependency of ${c.name} at position ${R+1} conflicts with ${h.length} static arguments`);const t=R-h.length;t>0?h=h.concat(new Array(t)):h=h.slice(0,R)}return Reflect.construct(c,h.concat(D))}k(c,h){if(this.f.get(c)instanceof w.SyncDescriptor)this.f.set(c,h);else if(this.h)this.h.k(c,h);else throw new Error("illegalState - setting UNKNOWN service instance")}l(c){const h=this.f.get(c);return!h&&this.h?this.h.l(c):h}m(c,h){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(c));const g=this.l(c);return g instanceof w.SyncDescriptor?this.q(c,g,h.branch(c,!0)):(h.branch(c,!1),g)}q(c,h,g){if(this.o.has(c))throw new Error(`illegal state - RECURSIVELY instantiating service '${c}'`);this.o.add(c);try{return this.r(c,h,g)}finally{this.o.delete(c)}}r(c,h,g){const f=new S.Graph(t=>t.id.toString());let D=0;const R=[{id:c,desc:h,_trace:g}];for(;R.length;){const t=R.pop();if(f.lookupOrInsertNode(t),D++>1e3)throw new I(f);for(const r of P._util.getServiceDependencies(t.desc.ctor)){const i=this.l(r.id);if(i||this.u(`[createInstance] ${c} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(t.id),String(r.id)),i instanceof w.SyncDescriptor){const n={id:r.id,desc:i,_trace:t._trace.branch(r.id,!0)};f.insertEdge(t,n),R.push(n)}}}for(;;){const t=f.roots();if(t.length===0){if(!f.isEmpty())throw new I(f);break}for(const{data:r}of t){if(this.l(r.id)instanceof w.SyncDescriptor){const n=this.s(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.k(r.id,n)}f.removeNode(r)}}return this.l(c)}s(c,h,g=[],f,D){if(this.f.get(c)instanceof w.SyncDescriptor)return this.t(c,h,g,f,D);if(this.h)return this.h.s(c,h,g,f,D);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}t(c,h,g=[],f,D){if(f){const R=new v(void 0,this.g,this,this.i);R.c=String(c);const t=new Map,r=new E.IdleValue(()=>{const i=R.j(h,g,D);for(const[n,o]of t){const u=i[n];if(typeof u=="function")for(const a of o)u.apply(i,a)}return t.clear(),i});return new Proxy(Object.create(null),{get(i,n){if(!r.isInitialized&&typeof n=="string"&&(n.startsWith("onDid")||n.startsWith("onWill"))){let a=t.get(n);return a||(a=new b.LinkedList,t.set(n,a)),(C,L,O)=>{const W=a.push([C,L,O]);return(0,l.toDisposable)(W)}}if(n in i)return i[n];const o=r.value;let u=o[n];return typeof u!="function"||(u=u.bind(o),i[n]=u),u},set(i,n,o){return r.value[n]=o,!0},getPrototypeOf(i){return h.prototype}})}else return this.j(h,g,D)}u(c,h){if(h&&console.warn(c),this.g)throw new Error(c)}}e.InstantiationService=v;var d;(function(p){p[p.None=0]="None",p[p.Creation=1]="Creation",p[p.Invocation=2]="Invocation",p[p.Branch=3]="Branch"})(d||(d={}));class m{static traceInvocation(c,h){return c?new m(2,h.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):m.c}static traceCreation(c,h){return c?new m(1,h.name):m.c}constructor(c,h){this.type=c,this.name=h,this.g=Date.now(),this.h=[]}branch(c,h){const g=new m(3,c.toString());return this.h.push([c,h,g]),g}stop(){const c=Date.now()-this.g;m.f+=c;let h=!1;function g(D,R){const t=[],r=new Array(D+1).join("	");for(const[i,n,o]of R.h)if(n&&o){h=!0,t.push(`${r}CREATES -> ${i}`);const u=g(D+1,o);u&&t.push(u)}else t.push(`${r}uses -> ${i}`);return t.join(`
`)}const f=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${g(1,this)}`,`DONE, took ${c.toFixed(2)}ms (grand total ${m.f.toFixed(2)}ms)`];(c>2||h)&&m.all.add(f.join(`
`))}}m.all=new Set,m.c=new class extends m{constructor(){super(0,null)}stop(){}branch(){return this}},m.f=0,e.Trace=m}),define(be[217],Ee([1,0,5]),function(oe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Verbosity=e.ILabelService=void 0,e.ILabelService=(0,E.createDecorator)("labelService");var A;(function(l){l[l.SHORT=0]="SHORT",l[l.MEDIUM=1]="MEDIUM",l[l.LONG=2]="LONG"})(A=e.Verbosity||(e.Verbosity={}))});var Ae=this&&this.__param||function(oe,e){return function(E,A){e(E,A,oe)}};define(be[78],Ee([1,0,19,2,3,183,30,5]),function(oe,e,E,A,l,w,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=e.getLocale=void 0;function y(k){return k.tags.find(I=>I.startsWith("lp-"))?.split("lp-")[1]}e.getLocale=y,e.ILanguagePackService=(0,P.createDecorator)("languagePackService");let b=class extends A.Disposable{constructor(I){super(),this.c=I}async getAvailableLanguages(){const I=new E.CancellationTokenSource;setTimeout(()=>I.cancel(),1e3);let v;try{v=await this.c.query({text:'category:"language packs"',pageSize:20},I.token)}catch{return[]}const m=v.firstPage.filter(p=>p.properties.localizedLanguages?.length&&p.tags.some(c=>c.startsWith("lp-"))).map(p=>{const c=p.properties.localizedLanguages?.[0],h=y(p);return{...this.f(h,c,p),extensionId:p.identifier.id,galleryExtension:p}});return m.push(this.f("en","English")),m}f(I,v,d){const m=v??I;let p;if(m!==I&&(p=`(${I})`),I.toLowerCase()===l.language.toLowerCase()&&(p??="",p+=(0,w.localize)(0,null)),d?.installCount){p??="";const c=d.installCount;let h;c>1e6?h=`${Math.floor(c/1e5)/10}M`:c>1e3?h=`${Math.floor(c/1e3)}K`:h=String(c),p+=` $(cloud-download) ${h}`}return{id:I,label:m,description:p}}};b=Te([Ae(0,S.IExtensionGalleryService)],b),e.LanguagePackBaseService=b}),define(be[10],Ee([1,0,39,6,2,27,3,8,4,5]),function(oe,e,E,A,l,w,S,P,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,b.createDecorator)("logService"),e.ILoggerService=(0,b.createDecorator)("loggerService");function k(){return new Date().toISOString()}function I(a){return(0,P.isNumber)(a)}e.isLogLevel=I;var v;(function(a){a[a.Off=0]="Off",a[a.Trace=1]="Trace",a[a.Debug=2]="Debug",a[a.Info=3]="Info",a[a.Warning=4]="Warning",a[a.Error=5]="Error"})(v=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=v.Info;function d(a,s,C){switch(s){case v.Trace:a.trace(C);break;case v.Debug:a.debug(C);break;case v.Info:a.info(C);break;case v.Warning:a.warn(C);break;case v.Error:a.error(C);break;case v.Off:break;default:throw new Error(`Invalid log level ${s}`)}}e.log=d;function m(a){let s="";for(let C=0;C<a.length;C++){let L=a[C];if(typeof L=="object")try{L=JSON.stringify(L)}catch{}s+=(C>0?" ":"")+L}return s}e.format=m;class p extends l.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new A.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(s){this.b!==s&&(this.b=s,this.c.fire(this.b))}getLevel(){return this.b}f(s){return this.b!==v.Off&&this.b<=s}}e.AbstractLogger=p;class c extends p{constructor(s){super(),this.h=s}f(s){return this.h||super.f(s)}trace(s,...C){this.f(v.Trace)&&this.g(v.Trace,m([s,...C]))}debug(s,...C){this.f(v.Debug)&&this.g(v.Debug,m([s,...C]))}info(s,...C){this.f(v.Info)&&this.g(v.Info,m([s,...C]))}warn(s,...C){this.f(v.Warning)&&this.g(v.Warning,m([s,...C]))}error(s,...C){if(this.f(v.Error))if(s instanceof Error){const L=Array.prototype.slice.call(arguments);L[0]=s.stack,this.g(v.Error,m(L))}else this.g(v.Error,m([s,...C]))}flush(){}}e.AbstractMessageLogger=c;class h extends p{constructor(s=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(s),this.g=!S.isWindows}trace(s,...C){this.f(v.Trace)&&(this.g?console.log(`\x1B[90m[main ${k()}]\x1B[0m`,s,...C):console.log(`[main ${k()}]`,s,...C))}debug(s,...C){this.f(v.Debug)&&(this.g?console.log(`\x1B[90m[main ${k()}]\x1B[0m`,s,...C):console.log(`[main ${k()}]`,s,...C))}info(s,...C){this.f(v.Info)&&(this.g?console.log(`\x1B[90m[main ${k()}]\x1B[0m`,s,...C):console.log(`[main ${k()}]`,s,...C))}warn(s,...C){this.f(v.Warning)&&(this.g?console.warn(`\x1B[93m[main ${k()}]\x1B[0m`,s,...C):console.warn(`[main ${k()}]`,s,...C))}error(s,...C){this.f(v.Error)&&(this.g?console.error(`\x1B[91m[main ${k()}]\x1B[0m`,s,...C):console.error(`[main ${k()}]`,s,...C))}dispose(){}flush(){}}e.ConsoleMainLogger=h;class g extends p{constructor(s=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(s)}trace(s,...C){this.f(v.Trace)&&console.log("%cTRACE","color: #888",s,...C)}debug(s,...C){this.f(v.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",s,...C)}info(s,...C){this.f(v.Info)&&console.log("%c INFO","color: #33f",s,...C)}warn(s,...C){this.f(v.Warning)&&console.log("%c WARN","color: #993",s,...C)}error(s,...C){this.f(v.Error)&&console.log("%c  ERR","color: #f33",s,...C)}dispose(){}flush(){}}e.ConsoleLogger=g;class f extends p{constructor(s,C=e.DEFAULT_LOG_LEVEL){super(),this.g=s,this.setLevel(C)}trace(s,...C){this.f(v.Trace)&&this.g.log(v.Trace,[this.h(s),...C])}debug(s,...C){this.f(v.Debug)&&this.g.log(v.Debug,[this.h(s),...C])}info(s,...C){this.f(v.Info)&&this.g.log(v.Info,[this.h(s),...C])}warn(s,...C){this.f(v.Warning)&&this.g.log(v.Warning,[this.h(s),...C])}error(s,...C){this.f(v.Error)&&this.g.log(v.Error,[this.h(s),...C])}h(s){return typeof s=="string"?s:(0,E.toErrorMessage)(s,this.f(v.Trace))}dispose(){}flush(){}}e.AdapterLogger=f;class D extends p{constructor(s){super(),this.g=s,s.length&&this.setLevel(s[0].getLevel())}setLevel(s){for(const C of this.g)C.setLevel(s);super.setLevel(s)}trace(s,...C){for(const L of this.g)L.trace(s,...C)}debug(s,...C){for(const L of this.g)L.debug(s,...C)}info(s,...C){for(const L of this.g)L.info(s,...C)}warn(s,...C){for(const L of this.g)L.warn(s,...C)}error(s,...C){for(const L of this.g)L.error(s,...C)}flush(){for(const s of this.g)s.flush()}dispose(){for(const s of this.g)s.dispose()}}e.MultiplexLogger=D;class R extends l.Disposable{constructor(s,C){if(super(),this.j=s,this.b=new w.ResourceMap,this.c=new w.ResourceMap,this.f=this.B(new A.Emitter),this.onDidChangeLoggers=this.f.event,this.g=this.B(new A.Emitter),this.onDidChangeLogLevel=this.g.event,this.h=this.B(new A.Emitter),this.onDidChangeVisibility=this.h.event,C)for(const L of C)this.c.set(L.resource,L)}getLogger(s){return this.b.get(s)}createLogger(s,C){let L=this.b.get(s);const O=C?.logLevel==="always"?v.Trace:C?.logLevel;return L||(L=this.k(s,O??this.getLogLevel(s)??this.j,C),this.b.set(s,L)),this.registerLogger({resource:s,id:C?.id??s.toString(),logLevel:O,name:C?.name,hidden:C?.hidden,extensionId:C?.extensionId}),L}setLogLevel(s,C){if(y.URI.isUri(s)){const L=s,O=C,W=this.c.get(L);W&&O!==W.logLevel&&(W.logLevel=O===this.j?void 0:O,this.b.get(L)?.setLevel(O),this.c.set(W.resource,W),this.g.fire([L,O]))}else{this.j=s;for(const[L,O]of this.b.entries())this.c.get(L)?.logLevel===void 0&&O.setLevel(this.j);this.g.fire(this.j)}}setVisibility(s,C){const L=this.c.get(s);L&&C!==!L.hidden&&(L.hidden=!C,this.c.set(L.resource,L),this.h.fire([s,C]))}getLogLevel(s){let C;return s&&(C=this.c.get(s)?.logLevel),C??this.j}registerLogger(s){const C=this.c.get(s.resource);C?C.hidden!==s.hidden&&this.setVisibility(s.resource,!s.hidden):(this.c.set(s.resource,s),this.f.fire({added:[s],removed:[]}))}deregisterLogger(s){const C=this.c.get(s);if(C){this.c.delete(s);const L=this.b.get(s);L&&(this.b.delete(s),L.dispose()),this.f.fire({added:[],removed:[C]})}}getRegisteredLoggers(){return this.c.values()}getRegisteredLogger(s){return this.c.get(s)}dispose(){this.b.forEach(s=>s.dispose()),this.b.clear(),this.c.clear(),super.dispose()}}e.AbstractLoggerService=R;class t{constructor(){this.onDidChangeLogLevel=new A.Emitter().event}setLevel(s){}getLevel(){return v.Info}trace(s,...C){}debug(s,...C){}info(s,...C){}warn(s,...C){}error(s,...C){}critical(s,...C){}dispose(){}flush(){}}e.NullLogger=t;class r extends t{}e.NullLogService=r;class i extends R{constructor(){super(v.Info)}k(s,C,L){return new t}}e.NullLoggerService=i;function n(a){if(a.verbose)return v.Trace;if(typeof a.logLevel=="string"){const s=u(a.logLevel.toLowerCase());if(s!==void 0)return s}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=n;function o(a){switch(a){case v.Trace:return"trace";case v.Debug:return"debug";case v.Info:return"info";case v.Warning:return"warn";case v.Error:return"error";case v.Off:return"off"}}e.LogLevelToString=o;function u(a){switch(a){case"trace":return v.Trace;case"debug":return v.Debug;case"info":return v.Info;case"warn":return v.Warning;case"error":return v.Error;case"critical":return v.Error;case"off":return v.Off}}e.parseLogLevel=u}),define(be[218],Ee([1,0,74,6,2,10,3,14]),function(oe,e,E,A,l,w,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseCredentialsMainService=void 0;let y=class Gt extends l.Disposable{constructor(k){super(),this.g=k,this.c=this.B(new A.Emitter),this.onDidChangePassword=this.c.event}async getPassword(k,I){this.g.trace("Getting password from keytar:",k,I);let v;try{v=await this.h()}catch{return null}const d=await(0,P.retry)(()=>v.getPassword(k,I),50,3);if(!d)return this.g.trace("Did not get a password from keytar for account:",I),d;let m,p;try{const c=JSON.parse(d);m=c.content,p=c.hasNextChunk}catch{}if(!m||!p)return this.g.trace("Got password from keytar for account:",I),d;try{let c=1;for(;p;){const h=await(0,P.retry)(()=>v.getPassword(k,`${I}-${c}`),50,3),g=JSON.parse(h);m+=g.content,p=g.hasNextChunk,c++}return this.g.trace(`Got ${c}-chunked password from keytar for account:`,I),m}catch(c){return this.g.error(c),d}}async setPassword(k,I,v){this.g.trace("Setting password using keytar:",k,I);let d;try{d=await this.h()}catch(m){throw this.i?.(m),m}if(S.isWindows&&v.length>Gt.a){let m=0,p=0,c=!0;for(;c;){const h=v.substring(m,m+Gt.b);m+=Gt.b,c=v.length-m>0;const g={content:h,hasNextChunk:c};await(0,P.retry)(()=>d.setPassword(k,p?`${I}-${p}`:I,JSON.stringify(g)),50,3),p++}this.g.trace(`Got${p?` ${p}-chunked`:""} password from keytar for account:`,I)}else await(0,P.retry)(()=>d.setPassword(k,I,v),50,3),this.g.trace("Got password from keytar for account:",I);this.c.fire({service:k,account:I})}async deletePassword(k,I){this.g.trace("Deleting password using keytar:",k,I);let v;try{v=await this.h()}catch(h){throw this.i?.(h),h}const d=await v.getPassword(k,I);if(!d)return this.g.trace("Did not get a password to delete from keytar for account:",I),!1;let m,p;try{const h=JSON.parse(d);m=h.content,p=h.hasNextChunk}catch{}let c=0;if(m&&p)try{for(c++;p;){const h=`${I}-${c}`,g=await v.getPassword(k,h);await v.deletePassword(k,h),p=JSON.parse(g).hasNextChunk,c++}}catch(h){this.g.error(h)}return await v.deletePassword(k,I)?(this.c.fire({service:k,account:I}),this.g.trace(`Deleted${c?` ${c}-chunked`:""} password from keytar for account:`,I),!0):(this.g.trace(`Keytar failed to delete${c?` ${c}-chunked`:""} password for account:`,I),!1)}async findPassword(k){let I;try{I=await this.h()}catch{return null}return await I.findPassword(k)}async findCredentials(k){let I;try{I=await this.h()}catch{return[]}return await I.findCredentials(k)}clear(){return this.f instanceof E.InMemoryCredentialsProvider?this.f.clear():Promise.resolve()}};y.a=2500,y.b=y.a-100,y=Te([Ae(0,w.ILogService)],y),e.BaseCredentialsMainService=y}),define(be[219],Ee([1,0,10]),function(oe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=void 0;let A=class{constructor(w,S){this.a=w,this.b=S}c(){return new Promise((w,S)=>oe(["vscode-encrypt"],w,S))}async encrypt(w){let S;try{S=await this.c()}catch{return w}try{return S.encrypt(this.a,w)}catch(P){return this.b.error(P),w}}async decrypt(w){let S;try{S=await this.c()}catch{return w}try{return S.decrypt(this.a,w)}catch(P){return this.b.error(P),w}}};A=Te([Ae(1,E.ILogService)],A),e.EncryptionMainService=A}),define(be[220],Ee([1,0,18,14,9,6,2,7,65,10]),function(oe,e,E,A,l,w,S,P,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class k extends S.Disposable{constructor(v,d){super(),this.a=v,this.b=d,this.c=this.B(new w.Emitter),this.onDidChangeFile=this.c.event,this.g=this.B(new w.Emitter),this.onDidWatchError=this.g.event,this.j=[],this.k=this.B(new A.ThrottledDelayer(0)),this.s=[],this.t=this.B(new A.ThrottledDelayer(0))}watch(v,d){return d.recursive||this.b?.watcher?.forceUniversal?this.l(v,d):this.u(v,d)}l(v,d){const m={path:this.C(v),excludes:d.excludes,includes:d.includes,recursive:d.recursive},p=(0,E.insert)(this.j,m);return this.m(),(0,S.toDisposable)(()=>{p(),this.m()})}m(){this.k.trigger(()=>this.n()).catch(v=>(0,l.onUnexpectedError)(v))}n(){this.h||(this.h=this.B(this.p(d=>this.c.fire((0,y.toFileChanges)(d)),d=>this.z(d),this.a.getLevel()===b.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===b.LogLevel.Trace)})));const v=this.b?.watcher?.recursive?.usePolling;if(v===!0)for(const d of this.j)(0,y.isRecursiveWatchRequest)(d)&&(d.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(v))for(const d of this.j)(0,y.isRecursiveWatchRequest)(d)&&v.includes(d.path)&&(d.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}u(v,d){const m={path:this.C(v),excludes:d.excludes,includes:d.includes,recursive:!1},p=(0,E.insert)(this.s,m);return this.v(),(0,S.toDisposable)(()=>{p(),this.v()})}v(){this.t.trigger(()=>this.w()).catch(v=>(0,l.onUnexpectedError)(v))}w(){return this.r||(this.r=this.B(this.y(v=>this.c.fire((0,y.toFileChanges)(v)),v=>this.z(v),this.a.getLevel()===b.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.r?.setVerboseLogging(this.a.getLevel()===b.LogLevel.Trace)}))),this.r.watch(this.s)}z(v){v.type==="error"&&this.g.fire(v.message),this.a[v.type](v.message)}C(v){return(0,P.normalize)(v.fsPath)}}e.AbstractDiskFileSystemProvider=k}),define(be[108],Ee([1,0,18,14,15,19,6,92,56,2,60,13,42,20,45,179,16,106,10,9]),function(oe,e,E,A,l,w,S,P,y,b,k,I,v,d,m,p,c,h,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let D=class extends b.Disposable{constructor(t){super(),this.b=t,this.a=256*1024,this.c=this.B(new S.Emitter),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new S.Emitter),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new S.Emitter),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.m=this.B(new S.Emitter),this.onDidRunOperation=this.m.event,this.R=this.B(new S.Emitter),this.onDidFilesChange=this.R.event,this.S=this.B(new S.Emitter),this.onDidWatchError=this.S.event,this.U=new Map,this.X=this.B(new A.ResourceQueue)}registerProvider(t,r){if(this.h.has(t))throw new Error(`A filesystem provider for the scheme '${t}' is already registered.`);(0,v.mark)(`code/registerFilesystem/${t}`);const i=new b.DisposableStore;return this.h.set(t,r),this.c.fire({added:!0,scheme:t,provider:r}),i.add(r.onDidChangeFile(n=>this.R.fire(new c.FileChangesEvent(n,!this.O(r))))),typeof r.onDidWatchError=="function"&&i.add(r.onDidWatchError(n=>this.S.fire(new Error(n)))),i.add(r.onDidChangeCapabilities(()=>this.g.fire({provider:r,scheme:t}))),(0,b.toDisposable)(()=>{this.c.fire({added:!1,scheme:t,provider:r}),this.h.delete(t),(0,b.dispose)(i)})}getProvider(t){return this.h.get(t)}async activateProvider(t){const r=[];this.f.fire({scheme:t,join(i){r.push(i)}}),!this.h.has(t)&&await A.Promises.settled(r)}async canHandleResource(t){return await this.activateProvider(t.scheme),this.hasProvider(t)}hasProvider(t){return this.h.has(t.scheme)}hasCapability(t,r){const i=this.h.get(t.scheme);return!!(i&&i.capabilities&r)}listCapabilities(){return y.Iterable.map(this.h,([t,r])=>({scheme:t,capabilities:r.capabilities}))}async j(t){if(!(0,d.isAbsolutePath)(t))throw new c.FileOperationError((0,p.localize)(0,null,this.nb(t)),8);await this.activateProvider(t.scheme);const r=this.h.get(t.scheme);if(!r){const i=new f.ErrorNoTelemetry;throw i.message=(0,p.localize)(1,null,t.toString()),i}return r}async k(t){const r=await this.j(t);if((0,c.hasOpenReadWriteCloseCapability)(r)||(0,c.hasReadWriteCapability)(r)||(0,c.hasFileReadStreamCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async l(t){const r=await this.j(t);if((0,c.hasOpenReadWriteCloseCapability)(r)||(0,c.hasReadWriteCapability)(r))return r;throw new Error(`Filesystem provider for scheme '${t.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(t,r){try{return await this.n(t,r)}catch(i){throw(0,c.toFileSystemProviderErrorCode)(i)===c.FileSystemProviderErrorCode.FileNotFound?new c.FileOperationError((0,p.localize)(2,null,this.nb(t)),1):(0,c.ensureFileSystemProviderError)(i)}}async n(t,r){const i=await this.j(t),n=this.O(i),o=r?.resolveTo,u=r?.resolveSingleChildDescendants,a=r?.resolveMetadata,s=await i.stat(t);let C;return this.p(i,t,s,void 0,!!a,(L,O)=>(C||(C=k.TernarySearchTree.forUris(()=>!n),C.set(t,!0),o&&C.fill(!0,o)),C.get(L.resource)||C.findSuperstr(L.resource.with({query:null,fragment:null}))?!0:L.isDirectory&&u?O===1:!1))}async p(t,r,i,n,o,u){const{providerExtUri:a}=this.N(t),s={resource:r,name:a.basename(r),isFile:(i.type&c.FileType.File)!==0,isDirectory:(i.type&c.FileType.Directory)!==0,isSymbolicLink:(i.type&c.FileType.SymbolicLink)!==0,mtime:i.mtime,ctime:i.ctime,size:i.size,readonly:Boolean((i.permissions??0)&c.FilePermission.Readonly)||Boolean(t.capabilities&2048),etag:(0,c.etag)({mtime:i.mtime,size:i.size}),children:void 0};if(s.isDirectory&&u(s,n)){try{const C=await t.readdir(r),L=await A.Promises.settled(C.map(async([O,W])=>{try{const X=a.joinPath(r,O),se=o?await t.stat(X):{type:W};return await this.p(t,X,se,C.length,o,u)}catch(X){return this.b.trace(X),null}}));s.children=(0,E.coalesce)(L)}catch(C){this.b.trace(C),s.children=[]}return s}return s}async resolveAll(t){return A.Promises.settled(t.map(async r=>{try{return{stat:await this.n(r.resource,r.options),success:!0}}catch(i){return this.b.trace(i),{stat:void 0,success:!1}}}))}async stat(t){const r=await this.j(t),i=await r.stat(t);return this.p(r,t,i,void 0,!0,()=>!1)}async exists(t){const r=await this.j(t);try{return!!await r.stat(t)}catch{return!1}}async canCreateFile(t,r){try{await this.r(t,r)}catch(i){return i}return!0}async r(t,r){if(!r?.overwrite&&await this.exists(t))throw new c.FileOperationError((0,p.localize)(3,null,this.nb(t)),3,r)}async createFile(t,r=l.VSBuffer.fromString(""),i){await this.r(t,i);const n=await this.writeFile(t,r);return this.m.fire(new c.FileOperationEvent(t,0,n)),n}async writeFile(t,r,i){const n=this.lb(await this.l(t),t),{providerExtUri:o}=this.N(n);try{await this.s(n,t,i)||await this.P(n,o.dirname(t));let a;if((0,c.hasReadWriteCapability)(n)&&!(r instanceof l.VSBuffer))if((0,m.isReadableStream)(r)){const s=await(0,m.peekStream)(r,3);s.ended?a=l.VSBuffer.concat(s.buffer):a=s}else a=(0,m.peekReadable)(r,s=>l.VSBuffer.concat(s),3);else a=r;!(0,c.hasOpenReadWriteCloseCapability)(n)||(0,c.hasReadWriteCapability)(n)&&a instanceof l.VSBuffer?await this.cb(n,t,i,a):await this.Y(n,t,i,a instanceof l.VSBuffer?(0,l.bufferToReadable)(a):a),this.m.fire(new c.FileOperationEvent(t,4))}catch(u){throw new c.FileOperationError((0,p.localize)(4,null,this.nb(t),(0,c.ensureFileSystemProviderError)(u).toString()),(0,c.toFileOperationResult)(u),i)}return this.resolve(t,{resolveMetadata:!0})}async s(t,r,i){if(!!i?.unlock&&!(t.capabilities&8192))throw new Error((0,p.localize)(5,null,this.nb(r)));let o;try{o=await t.stat(r)}catch{return}if((o.type&c.FileType.Directory)!==0)throw new c.FileOperationError((0,p.localize)(6,null,this.nb(r)),0,i);if(this.mb(r,o),typeof i?.mtime=="number"&&typeof i.etag=="string"&&i.etag!==c.ETAG_DISABLED&&typeof o.mtime=="number"&&typeof o.size=="number"&&i.mtime<o.mtime&&i.etag!==(0,c.etag)({mtime:i.mtime,size:o.size}))throw new c.FileOperationError((0,p.localize)(7,null),3,i);return o}async readFile(t,r,i){const n=await this.k(t);return r?.atomic?this.t(n,t,r,i):this.u(n,t,r,i)}async t(t,r,i,n){return new Promise((o,u)=>{this.X.queueFor(r,this.N(t).providerExtUri).queue(async()=>{try{const a=await this.u(t,r,i,n);o(a)}catch(a){u(a)}})})}async u(t,r,i,n){const o=await this.v(t,r,{...i,preferUnbuffered:!0},n);return{...o,value:await(0,l.streamToBuffer)(o.value)}}async readFileStream(t,r,i){const n=await this.k(t);return this.v(n,t,r,i)}async v(t,r,i,n){const o=new w.CancellationTokenSource(n),u=this.F(r,i).then(s=>s,s=>{throw o.cancel(),s});let a;try{return typeof i?.etag=="string"&&i.etag!==c.ETAG_DISABLED&&await u,i?.atomic&&(0,c.hasFileAtomicReadCapability)(t)||!((0,c.hasOpenReadWriteCloseCapability)(t)||(0,c.hasFileReadStreamCapability)(t))||(0,c.hasReadWriteCapability)(t)&&i?.preferUnbuffered?a=this.D(t,r,i):(0,c.hasFileReadStreamCapability)(t)?a=this.z(t,r,o.token,i):a=this.C(t,r,o.token,i),{...await u,value:a}}catch(s){throw a&&await(0,m.consumeStream)(a),this.w(s,r,i)}}w(t,r,i){const n=(0,p.localize)(8,null,this.nb(r),(0,c.ensureFileSystemProviderError)(t).toString());return t instanceof c.NotModifiedSinceFileOperationError?new c.NotModifiedSinceFileOperationError(n,t.stat,i):t instanceof c.TooLargeFileOperationError?new c.TooLargeFileOperationError(n,t.fileOperationResult,t.size,t.options):new c.FileOperationError(n,(0,c.toFileOperationResult)(t),i)}z(t,r,i,n=Object.create(null)){const o=t.readFileStream(r,n,i);return(0,m.transform)(o,{data:u=>u instanceof l.VSBuffer?u:l.VSBuffer.wrap(u),error:u=>this.w(u,r,n)},u=>l.VSBuffer.concat(u))}C(t,r,i,n=Object.create(null)){const o=(0,l.newWriteableBufferStream)();return(0,h.readFileIntoStream)(t,r,o,u=>u,{...n,bufferSize:this.a,errorTransformer:u=>this.w(u,r,n)},i),o}D(t,r,i){const n=(0,m.newWriteableStream)(o=>l.VSBuffer.concat(o));return(async()=>{try{let o;i?.atomic&&(0,c.hasFileAtomicReadCapability)(t)?o=await t.readFile(r,{atomic:!0}):o=await t.readFile(r),typeof i?.position=="number"&&(o=o.slice(i.position)),typeof i?.length=="number"&&(o=o.slice(0,i.length)),this.G(r,o.byteLength,i),n.end(l.VSBuffer.wrap(o))}catch(o){n.error(o),n.end()}})(),n}async F(t,r){const i=await this.resolve(t,{resolveMetadata:!0});if(i.isDirectory)throw new c.FileOperationError((0,p.localize)(9,null,this.nb(t)),0,r);if(typeof r?.etag=="string"&&r.etag!==c.ETAG_DISABLED&&r.etag===i.etag)throw new c.NotModifiedSinceFileOperationError((0,p.localize)(10,null),i,r);return this.G(t,i.size,r),i}G(t,r,i){if(i?.limits){let n;if(typeof i.limits.memory=="number"&&r>i.limits.memory&&(n=9),typeof i.limits.size=="number"&&r>i.limits.size&&(n=7),typeof n=="number")throw new c.TooLargeFileOperationError((0,p.localize)(11,null,this.nb(t)),n,r,i)}}async canMove(t,r,i){return this.H(t,r,"move",i)}async canCopy(t,r,i){return this.H(t,r,"copy",i)}async H(t,r,i,n){if(t.toString()!==r.toString())try{const o=i==="move"?this.lb(await this.l(t),t):await this.k(t),u=this.lb(await this.l(r),r);await this.M(o,t,u,r,i,n)}catch(o){return o}return!0}async move(t,r,i){const n=this.lb(await this.l(t),t),o=this.lb(await this.l(r),r),u=await this.I(n,t,o,r,"move",!!i),a=await this.resolve(r,{resolveMetadata:!0});return this.m.fire(new c.FileOperationEvent(t,u==="move"?2:3,a)),a}async copy(t,r,i){const n=await this.k(t),o=this.lb(await this.l(r),r),u=await this.I(n,t,o,r,"copy",!!i),a=await this.resolve(r,{resolveMetadata:!0});return this.m.fire(new c.FileOperationEvent(t,u==="copy"?3:2,a)),a}async I(t,r,i,n,o,u){if(r.toString()===n.toString())return o;const{exists:a,isSameResourceWithDifferentPathCase:s}=await this.M(t,r,i,n,o,u);if(a&&!s&&u&&await this.del(n,{recursive:!0}),await this.P(i,this.N(i).providerExtUri.dirname(n)),o==="copy"){if(t===i&&(0,c.hasFileFolderCopyCapability)(t))await t.copy(r,n,{overwrite:u});else{const C=await this.resolve(r);C.isDirectory?await this.L(t,C,i,n):await this.J(t,r,i,n)}return o}else return t===i?(await t.rename(r,n,{overwrite:u}),o):(await this.I(t,r,i,n,"copy",u),await this.del(r,{recursive:!0}),"copy")}async J(t,r,i,n){if((0,c.hasOpenReadWriteCloseCapability)(t)&&(0,c.hasOpenReadWriteCloseCapability)(i))return this.eb(t,r,i,n);if((0,c.hasOpenReadWriteCloseCapability)(t)&&(0,c.hasReadWriteCapability)(i))return this.kb(t,r,i,n);if((0,c.hasReadWriteCapability)(t)&&(0,c.hasOpenReadWriteCloseCapability)(i))return this.ib(t,r,i,n);if((0,c.hasReadWriteCapability)(t)&&(0,c.hasReadWriteCapability)(i))return this.gb(t,r,i,n)}async L(t,r,i,n){await i.mkdir(n),Array.isArray(r.children)&&await A.Promises.settled(r.children.map(async o=>{const u=this.N(i).providerExtUri.joinPath(n,o.name);return o.isDirectory?this.L(t,await this.resolve(o.resource),i,u):this.J(t,o.resource,i,u)}))}async M(t,r,i,n,o,u){let a=!1;if(t===i){const{providerExtUri:C,isPathCaseSensitive:L}=this.N(t);if(L||(a=C.isEqual(r,n)),a&&o==="copy")throw new Error((0,p.localize)(12,null,this.nb(r),this.nb(n)));if(!a&&C.isEqualOrParent(n,r))throw new Error((0,p.localize)(13,null,this.nb(r),this.nb(n)))}const s=await this.exists(n);if(s&&!a){if(!u)throw new c.FileOperationError((0,p.localize)(14,null,this.nb(r),this.nb(n)),4);if(t===i){const{providerExtUri:C}=this.N(t);if(C.isEqualOrParent(r,n))throw new Error((0,p.localize)(15,null,this.nb(r),this.nb(n)))}}return{exists:s,isSameResourceWithDifferentPathCase:a}}N(t){const r=this.O(t);return{providerExtUri:r?d.extUri:d.extUriIgnorePathCase,isPathCaseSensitive:r}}O(t){return!!(t.capabilities&1024)}async createFolder(t){const r=this.lb(await this.j(t),t);await this.P(r,t);const i=await this.resolve(t,{resolveMetadata:!0});return this.m.fire(new c.FileOperationEvent(t,0,i)),i}async P(t,r){const i=[],{providerExtUri:n}=this.N(t);for(;!n.isEqual(r,n.dirname(r));)try{if(((await t.stat(r)).type&c.FileType.Directory)===0)throw new Error((0,p.localize)(16,null,this.nb(r)));break}catch(o){if((0,c.toFileSystemProviderErrorCode)(o)!==c.FileSystemProviderErrorCode.FileNotFound)throw o;i.push(n.basename(r)),r=n.dirname(r)}for(let o=i.length-1;o>=0;o--){r=n.joinPath(r,i[o]);try{await t.mkdir(r)}catch(u){if((0,c.toFileSystemProviderErrorCode)(u)!==c.FileSystemProviderErrorCode.FileExists)throw u}}}async canDelete(t,r){try{await this.Q(t,r)}catch(i){return i}return!0}async Q(t,r){const i=this.lb(await this.j(t),t);if(!!r?.useTrash&&!(i.capabilities&4096))throw new Error((0,p.localize)(17,null,this.nb(t)));let o;try{o=await i.stat(t)}catch{}if(o)this.mb(t,o);else throw new c.FileOperationError((0,p.localize)(18,null,this.nb(t)),1);if(!!!r?.recursive){const a=await this.resolve(t);if(a.isDirectory&&Array.isArray(a.children)&&a.children.length>0)throw new Error((0,p.localize)(19,null,this.nb(t)))}return i}async del(t,r){const i=await this.Q(t,r),n=!!r?.useTrash,o=!!r?.recursive;await i.delete(t,{recursive:o,useTrash:n}),this.m.fire(new c.FileOperationEvent(t,1))}async cloneFile(t,r){const i=await this.j(t),n=this.lb(await this.l(r),r);if(i===n&&this.N(i).providerExtUri.isEqual(t,r))return;if(i===n&&(0,c.hasFileCloneCapability)(i))return i.cloneFile(t,r);await this.P(n,this.N(n).providerExtUri.dirname(r));const o=this.X.queueFor(t,this.N(i).providerExtUri);return i===n&&(0,c.hasFileFolderCopyCapability)(i)?o.queue(()=>i.copy(t,r,{overwrite:!0})):o.queue(()=>this.J(i,t,n,r))}watch(t,r={recursive:!1,excludes:[]}){const i=new b.DisposableStore;let n=!1,o=()=>{n=!0};return i.add((0,b.toDisposable)(()=>o())),(async()=>{try{const u=await this.W(t,r);n?(0,b.dispose)(u):o=()=>(0,b.dispose)(u)}catch(u){this.b.error(u)}})(),i}async W(t,r){const i=await this.j(t),n=(0,P.hash)([this.N(i).providerExtUri.getComparisonKey(t),r]);let o=this.U.get(n);return o||(o={count:0,disposable:i.watch(t,r)},this.U.set(n,o)),o.count+=1,(0,b.toDisposable)(()=>{o&&(o.count--,o.count===0&&((0,b.dispose)(o.disposable),this.U.delete(n)))})}dispose(){super.dispose();for(const[,t]of this.U)(0,b.dispose)(t.disposable);this.U.clear()}async Y(t,r,i,n){return this.X.queueFor(r,this.N(t).providerExtUri).queue(async()=>{const o=await t.open(r,{create:!0,unlock:i?.unlock??!1});try{(0,m.isReadableStream)(n)||(0,m.isReadableBufferedStream)(n)?await this.Z(t,o,n):await this.ab(t,o,n)}catch(u){throw(0,c.ensureFileSystemProviderError)(u)}finally{await t.close(o)}})}async Z(t,r,i){let n=0,o;if((0,m.isReadableBufferedStream)(i)){if(i.buffer.length>0){const u=l.VSBuffer.concat(i.buffer);await this.bb(t,r,u,u.byteLength,n,0),n+=u.byteLength}if(i.ended)return;o=i.stream}else o=i;return new Promise((u,a)=>{(0,m.listenStream)(o,{onData:async s=>{o.pause();try{await this.bb(t,r,s,s.byteLength,n,0)}catch(C){return a(C)}n+=s.byteLength,setTimeout(()=>o.resume())},onError:s=>a(s),onEnd:()=>u()})})}async ab(t,r,i){let n=0,o;for(;(o=i.read())!==null;)await this.bb(t,r,o,o.byteLength,n,0),n+=o.byteLength}async bb(t,r,i,n,o,u){let a=0;for(;a<n;)a+=await t.write(r,o+a,i.buffer,u+a,n-a)}async cb(t,r,i,n){return this.X.queueFor(r,this.N(t).providerExtUri).queue(()=>this.db(t,r,i,n))}async db(t,r,i,n){let o;n instanceof l.VSBuffer?o=n:(0,m.isReadableStream)(n)?o=await(0,l.streamToBuffer)(n):(0,m.isReadableBufferedStream)(n)?o=await(0,l.bufferedStreamToBuffer)(n):o=(0,l.readableToBuffer)(n),await t.writeFile(r,o.buffer,{create:!0,overwrite:!0,unlock:i?.unlock??!1})}async eb(t,r,i,n){return this.X.queueFor(n,this.N(i).providerExtUri).queue(()=>this.fb(t,r,i,n))}async fb(t,r,i,n){let o,u;try{o=await t.open(r,{create:!1}),u=await i.open(n,{create:!0,unlock:!1});const a=l.VSBuffer.alloc(this.a);let s=0,C=0,L=0;do L=await t.read(o,s,a.buffer,C,a.byteLength-C),await this.bb(i,u,a,L,s,C),s+=L,C+=L,C===a.byteLength&&(C=0);while(L>0)}catch(a){throw(0,c.ensureFileSystemProviderError)(a)}finally{await A.Promises.settled([typeof o=="number"?t.close(o):Promise.resolve(),typeof u=="number"?i.close(u):Promise.resolve()])}}async gb(t,r,i,n){return this.X.queueFor(n,this.N(i).providerExtUri).queue(()=>this.hb(t,r,i,n))}async hb(t,r,i,n){return i.writeFile(n,await t.readFile(r),{create:!0,overwrite:!0,unlock:!1})}async ib(t,r,i,n){return this.X.queueFor(n,this.N(i).providerExtUri).queue(()=>this.jb(t,r,i,n))}async jb(t,r,i,n){const o=await i.open(n,{create:!0,unlock:!1});try{const u=await t.readFile(r);await this.bb(i,o,l.VSBuffer.wrap(u),u.byteLength,0,0)}catch(u){throw(0,c.ensureFileSystemProviderError)(u)}finally{await i.close(o)}}async kb(t,r,i,n){const o=await(0,l.streamToBuffer)(this.C(t,r,w.CancellationToken.None));await this.cb(i,n,void 0,o)}lb(t,r){if(t.capabilities&2048)throw new c.FileOperationError((0,p.localize)(20,null,this.nb(r)),6);return t}mb(t,r){if((r.permissions??0)&c.FilePermission.Readonly)throw new c.FileOperationError((0,p.localize)(21,null,this.nb(t)),6)}nb(t){return t.scheme===I.Schemas.file?t.fsPath:t.toString(!0)}};D=Te([Ae(0,g.ILogService)],D),e.FileService=D}),define(be[66],Ee([1,0,33,293,14,27,15,6,38,2,7,3,20,45,22,182,16,106,220,39,216,215]),function(oe,e,E,A,l,w,S,P,y,b,k,I,v,d,m,p,c,h,g,f,D,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,A.gracefulify)(E)}catch(r){console.error(`Error enabling graceful-fs: ${(0,f.toErrorMessage)(r)}`)}})();class t extends g.AbstractDiskFileSystemProvider{constructor(i,n){super(i,n),this.onDidChangeCapabilities=P.Event.None,this.H=new w.ResourceMap(o=>v.extUriBiasedIgnorePathCase.getComparisonKey(o)),this.L=new Map,this.M=new Map,this.N=new Map}get capabilities(){return this.F||(this.F=57374,I.isLinux&&(this.F|=1024)),this.F}async stat(i){try{const{stat:n,symbolicLink:o}=await m.SymlinkSupport.stat(this.C(i));return{type:this.G(n,o),ctime:n.birthtime.getTime(),mtime:n.mtime.getTime(),size:n.size}}catch(n){throw this.Y(n)}}async readdir(i){try{const n=await m.Promises.readdir(this.C(i),{withFileTypes:!0}),o=[];return await Promise.all(n.map(async u=>{try{let a;u.isSymbolicLink()?a=(await this.stat((0,v.joinPath)(i,u.name))).type:a=this.G(u),o.push([u.name,a])}catch(a){this.a.trace(a)}})),o}catch(n){throw this.Y(n)}}G(i,n){let o;return n?.dangling?o=c.FileType.Unknown:i.isFile()?o=c.FileType.File:i.isDirectory()?o=c.FileType.Directory:o=c.FileType.Unknown,n&&(o|=c.FileType.SymbolicLink),o}async I(i){const n=this.C(i);this.J(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${n})`);let o;for(;o=this.H.get(i);)this.J(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${n})`),await o.wait();const u=new l.Barrier;return this.H.set(i,u),this.J(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${n})`),(0,b.toDisposable)(()=>{this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${n})`),this.H.get(i)===u&&(this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${n})`),this.H.delete(i)),this.J(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${n})`),u.open()})}async readFile(i,n){let o;try{n?.atomic&&(this.J(`[Disk FileSystemProvider]: atomic read operation started (${this.C(i)})`),o=await this.I(i));const u=this.C(i);return await m.Promises.readFile(u)}catch(u){throw this.Y(u)}finally{o?.dispose()}}J(i){t.D&&this.a.trace(i)}readFileStream(i,n,o){const u=(0,d.newWriteableStream)(a=>S.VSBuffer.concat(a.map(s=>S.VSBuffer.wrap(s))).buffer);return(0,h.readFileIntoStream)(this,i,u,a=>a.buffer,{...n,bufferSize:256*1024},o),u}async writeFile(i,n,o){let u;try{const a=this.C(i);if(!o.create||!o.overwrite){if(await m.Promises.exists(a)){if(!o.overwrite)throw(0,c.createFileSystemProviderError)((0,p.localize)(0,null),c.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,c.createFileSystemProviderError)((0,p.localize)(1,null),c.FileSystemProviderErrorCode.FileNotFound)}u=await this.open(i,{create:!0,unlock:o.unlock}),await this.write(u,0,n,0,n.byteLength)}catch(a){throw await this.Z(i,a)}finally{typeof u=="number"&&await this.close(u)}}static configureFlushOnWrite(i){t.O=i}async open(i,n){const o=this.C(i);let u;(0,c.isFileOpenForWriteOptions)(n)&&(u=await this.I(i));let a;try{if((0,c.isFileOpenForWriteOptions)(n)&&n.unlock)try{const{stat:C}=await m.SymlinkSupport.stat(o);C.mode&128||await m.Promises.chmod(o,C.mode|128)}catch(C){this.a.trace(C)}let s;if((0,c.isFileOpenForWriteOptions)(n)){if(I.isWindows)try{await m.Promises.truncate(o,0),s="r+"}catch(C){C.code!=="ENOENT"&&this.a.trace(C)}s||(s="w")}else s="r";a=await m.Promises.open(o,s)}catch(s){throw u?.dispose(),(0,c.isFileOpenForWriteOptions)(n)?await this.Z(i,s):this.Y(s)}if(this.L.set(a,0),(0,c.isFileOpenForWriteOptions)(n)&&this.N.set(a,i),u){const s=this.M.get(a);this.J(`[Disk FileSystemProvider]: open() - storing lock for handle ${a} (${o})`),this.M.set(a,u),s&&(this.J(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${a} (${o})`),s.dispose())}return a}async close(i){const n=this.M.get(i);try{if(this.L.delete(i),this.N.delete(i)&&t.O)try{await m.Promises.fdatasync(i)}catch(o){t.configureFlushOnWrite(!1),this.a.error(o)}return await m.Promises.close(i)}catch(o){throw this.Y(o)}finally{n&&(this.M.get(i)===n&&(this.J(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.M.delete(i)),this.J(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),n.dispose())}}async read(i,n,o,u,a){const s=this.P(i,n);let C=null;try{C=(await m.Promises.read(i,o,u,a,s)).bytesRead}catch(L){throw this.Y(L)}finally{this.Q(i,s,C)}return C}P(i,n){return n===this.L.get(i)?null:n}Q(i,n,o){const u=this.L.get(i);typeof u=="number"&&(typeof n=="number"||(typeof o=="number"?this.L.set(i,u+o):this.L.delete(i)))}async write(i,n,o,u,a){return(0,l.retry)(()=>this.R(i,n,o,u,a),100,3)}async R(i,n,o,u,a){const s=this.P(i,n);let C=null;try{C=(await m.Promises.write(i,o,u,a,s)).bytesWritten}catch(L){throw await this.Z(this.N.get(i),L)}finally{this.Q(i,s,C)}return C}async mkdir(i){try{await m.Promises.mkdir(this.C(i))}catch(n){throw this.Y(n)}}async delete(i,n){try{const o=this.C(i);n.recursive?await m.Promises.rm(o,m.RimRafMode.MOVE):await m.Promises.unlink(o)}catch(o){throw this.Y(o)}}async rename(i,n,o){const u=this.C(i),a=this.C(n);if(u!==a)try{await this.S(i,n,"move",o.overwrite),await m.Promises.move(u,a)}catch(s){throw(s.code==="EINVAL"||s.code==="EBUSY"||s.code==="ENAMETOOLONG")&&(s=new Error((0,p.localize)(2,null,(0,k.basename)(u),(0,k.basename)((0,k.dirname)(a)),s.toString()))),this.Y(s)}}async copy(i,n,o){const u=this.C(i),a=this.C(n);if(u!==a)try{await this.S(i,n,"copy",o.overwrite),await m.Promises.copy(u,a,{preserveSymlinks:!0})}catch(s){throw(s.code==="EINVAL"||s.code==="EBUSY"||s.code==="ENAMETOOLONG")&&(s=new Error((0,p.localize)(3,null,(0,k.basename)(u),(0,k.basename)((0,k.dirname)(a)),s.toString()))),this.Y(s)}}async S(i,n,o,u){const a=this.C(i),s=this.C(n);let C=!1;if(!!(this.capabilities&1024)||(C=(0,y.isEqual)(a,s,!0)),C&&o==="copy")throw(0,c.createFileSystemProviderError)((0,p.localize)(4,null),c.FileSystemProviderErrorCode.FileExists);if(!C&&await m.Promises.exists(s)){if(!u)throw(0,c.createFileSystemProviderError)((0,p.localize)(5,null),c.FileSystemProviderErrorCode.FileExists);await this.delete(n,{recursive:!0,useTrash:!1})}}async cloneFile(i,n){return this.U(i,n,!1)}async U(i,n,o){const u=this.C(i),a=this.C(n),s=!!(this.capabilities&1024);if((0,y.isEqual)(u,a,!s))return;const C=new b.DisposableStore;try{const[L,O]=await Promise.all([this.I(i),this.I(n)]);C.add(L),C.add(O),o&&await m.Promises.mkdir((0,k.dirname)(a),{recursive:!0}),await m.Promises.copyFile(u,a)}catch(L){if(L.code==="ENOENT"&&!o)return this.U(i,n,!0);throw this.Y(L)}finally{C.dispose()}}p(i,n,o){return new D.UniversalWatcherClient(u=>i(u),u=>n(u),o)}y(i,n,o){return new R.NodeJSWatcherClient(u=>i(u),u=>n(u),o)}Y(i){if(i instanceof c.FileSystemProviderError)return i;let n;switch(i.code){case"ENOENT":n=c.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":n=c.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":n=c.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":n=c.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":n=c.FileSystemProviderErrorCode.NoPermissions;break;default:n=c.FileSystemProviderErrorCode.Unknown}return(0,c.createFileSystemProviderError)(i,n)}async Z(i,n){let o=this.Y(n);if(i&&o.code===c.FileSystemProviderErrorCode.NoPermissions)try{const{stat:u}=await m.SymlinkSupport.stat(this.C(i));u.mode&128||(o=(0,c.createFileSystemProviderError)(n,c.FileSystemProviderErrorCode.FileWriteLocked))}catch(u){this.a.trace(u)}return o}}t.D=!1,t.O=!0,e.DiskFileSystemProvider=t}),define(be[221],Ee([1,0,6,66,2,15,45,19]),function(oe,e,E,A,l,w,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractSessionFileWatcher=e.AbstractDiskFileSystemProviderChannel=void 0;class y extends l.Disposable{constructor(I,v){super(),this.a=I,this.b=v,this.w=new Map,this.y=new Map}call(I,v,d){const m=this.c(I);switch(v){case"stat":return this.g(m,d[0]);case"readdir":return this.h(m,d[0]);case"open":return this.l(m,d[0],d[1]);case"close":return this.m(d[0]);case"read":return this.n(d[0],d[1],d[2]);case"readFile":return this.i(m,d[0],d[1]);case"write":return this.p(d[0],d[1],d[2],d[3],d[4]);case"writeFile":return this.k(m,d[0],d[1],d[2]);case"rename":return this.t(m,d[0],d[1],d[2]);case"copy":return this.u(m,d[0],d[1],d[2]);case"cloneFile":return this.v(m,d[0],d[1]);case"mkdir":return this.r(m,d[0]);case"delete":return this.s(m,d[0],d[1]);case"watch":return this.C(m,d[0],d[1],d[2],d[3]);case"unwatch":return this.D(d[0],d[1])}throw new Error(`IPC Command ${v} not found`)}listen(I,v,d){const m=this.c(I);switch(v){case"fileChange":return this.z(m,d[0]);case"readFileStream":return this.j(m,d[0],d[1])}throw new Error(`Unknown event ${v}`)}g(I,v){const d=this.f(I,v,!0);return this.a.stat(d)}h(I,v){const d=this.f(I,v);return this.a.readdir(d)}async i(I,v,d){const m=this.f(I,v,!0),p=await this.a.readFile(m,d);return w.VSBuffer.wrap(p)}j(I,v,d){const m=this.f(I,v,!0),p=new P.CancellationTokenSource,c=new E.Emitter({onDidRemoveLastListener:()=>{p.cancel()}}),h=this.a.readFileStream(m,d,p.token);return(0,S.listenStream)(h,{onData:g=>c.fire(w.VSBuffer.wrap(g)),onError:g=>c.fire(g),onEnd:()=>{c.fire("end"),c.dispose(),p.dispose()}}),c.event}k(I,v,d,m){const p=this.f(I,v);return this.a.writeFile(p,d.buffer,m)}l(I,v,d){const m=this.f(I,v,!0);return this.a.open(m,d)}m(I){return this.a.close(I)}async n(I,v,d){const m=w.VSBuffer.alloc(d),p=0,c=await this.a.read(I,v,m.buffer,p,d);return[m,c]}p(I,v,d,m,p){return this.a.write(I,v,d.buffer,m,p)}r(I,v){const d=this.f(I,v);return this.a.mkdir(d)}s(I,v,d){const m=this.f(I,v);return this.a.delete(m,d)}t(I,v,d,m){const p=this.f(I,v),c=this.f(I,d);return this.a.rename(p,c,m)}u(I,v,d,m){const p=this.f(I,v),c=this.f(I,d);return this.a.copy(p,c,m)}v(I,v,d){const m=this.f(I,v),p=this.f(I,d);return this.a.cloneFile(m,p)}z(I,v){const d=new E.Emitter({onWillAddFirstListener:()=>{this.w.set(v,this.F(I,d))},onDidRemoveLastListener:()=>{(0,l.dispose)(this.w.get(v)),this.w.delete(v)}});return d.event}async C(I,v,d,m,p){const c=this.w.get(v);if(c){const h=this.f(I,m),g=c.watch(d,h,p);this.y.set(v+d,g)}}async D(I,v){const d=I+v,m=this.y.get(d);m&&((0,l.dispose)(m),this.y.delete(d))}dispose(){super.dispose();for(const[,I]of this.y)I.dispose();this.y.clear();for(const[,I]of this.w)I.dispose();this.w.clear()}}e.AbstractDiskFileSystemProviderChannel=y;class b extends l.Disposable{constructor(I,v,d,m){super(),this.c=I,this.f=d,this.g=m,this.a=new Map,this.b=this.B(new A.DiskFileSystemProvider(this.f,{watcher:{recursive:this.i(this.g)}})),this.h(v)}h(I){const v=this.B(new E.Emitter);this.B(v.event(d=>{I.fire(d.map(m=>({resource:this.c.transformOutgoingURI(m.resource),type:m.type})))})),this.B(this.b.onDidChangeFile(d=>v.fire(d))),this.B(this.b.onDidWatchError(d=>I.fire(d)))}i(I){}j(I){}watch(I,v,d){const m=this.j(this.g);return Array.isArray(m)&&(d.excludes=[...d.excludes,...m]),this.a.set(I,this.b.watch(v,d)),(0,l.toDisposable)(()=>{(0,l.dispose)(this.a.get(I)),this.a.delete(I)})}dispose(){super.dispose();for(const[,I]of this.a)I.dispose();this.a.clear()}}e.AbstractSessionFileWatcher=b}),define(be[109],Ee([1,0,4,6,10,2]),function(oe,e,E,A,l,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteLoggerChannelClient=e.LoggerChannel=e.LoggerChannelClient=void 0;class S extends l.AbstractLoggerService{constructor(I,v,d,m){super(v,d),this.l=I,this.m=m,this.B(m.listen("onDidChangeLogLevel",I)(p=>{(0,l.isLogLevel)(p)?super.setLogLevel(p):super.setLogLevel(E.URI.revive(p[0]),p[1])})),this.B(m.listen("onDidChangeVisibility",I)(([p,c])=>super.setVisibility(E.URI.revive(p),c))),this.B(m.listen("onDidChangeLoggers",I)(({added:p,removed:c})=>{for(const h of p)super.registerLogger({...h,resource:E.URI.revive(h.resource)});for(const h of c)super.deregisterLogger(h.resource)}))}createConsoleMainLogger(){return new l.AdapterLogger({log:(I,v)=>{this.m.call("consoleLog",[I,v])}})}registerLogger(I){super.registerLogger(I),this.m.call("registerLogger",[I,this.l])}deregisterLogger(I){super.deregisterLogger(I),this.m.call("deregisterLogger",[I,this.l])}setLogLevel(I,v){super.setLogLevel(I,v),this.m.call("setLogLevel",[I,v])}setVisibility(I,v){super.setVisibility(I,v),this.m.call("setVisibility",[I,v])}k(I,v,d){return new P(this.m,I,v,d,this.l)}static setLogLevel(I,v,d){return I.call("setLogLevel",[v,d])}}e.LoggerChannelClient=S;class P extends l.AbstractMessageLogger{constructor(I,v,d,m,p){super(m?.logLevel==="always"),this.m=I,this.n=v,this.k=!1,this.l=[],this.setLevel(d),this.m.call("createLogger",[v,m,p]).then(()=>{this.r(this.l),this.k=!0})}g(I,v){const d=[[I,v]];this.k?this.r(d):this.l.push(...d)}r(I){this.m.call("log",[this.n,I])}}class y{constructor(I,v){this.a=I,this.b=v}listen(I,v){const d=this.b(I);switch(v){case"onDidChangeLoggers":return A.Event.map(this.a.onDidChangeLoggers,m=>({added:[...m.added].map(p=>this.c(p,d)),removed:[...m.removed].map(p=>this.c(p,d))}));case"onDidChangeVisibility":return A.Event.map(this.a.onDidChangeVisibility,m=>[d.transformOutgoingURI(m[0]),m[1]]);case"onDidChangeLogLevel":return A.Event.map(this.a.onDidChangeLogLevel,m=>(0,l.isLogLevel)(m)?m:[d.transformOutgoingURI(m[0]),m[1]])}throw new Error(`Event not found: ${v}`)}async call(I,v,d){const m=this.b(I);switch(v){case"setLogLevel":return(0,l.isLogLevel)(d[0])?this.a.setLogLevel(d[0]):this.a.setLogLevel(E.URI.revive(m.transformIncoming(d[0][0])),d[0][1]);case"getRegisteredLoggers":return Promise.resolve([...this.a.getRegisteredLoggers()].map(p=>this.c(p,m)))}throw new Error(`Call not found: ${v}`)}c(I,v){return{...I,resource:v.transformOutgoingURI(I.resource)}}}e.LoggerChannel=y;class b extends w.Disposable{constructor(I,v){super(),v.call("setLogLevel",[I.getLogLevel()]),this.B(I.onDidChangeLogLevel(d=>v.call("setLogLevel",[d]))),v.call("getRegisteredLoggers").then(d=>{for(const m of d)I.registerLogger({...m,resource:E.URI.revive(m.resource)})}),this.B(v.listen("onDidChangeVisibility")(([d,m])=>I.setVisibility(E.URI.revive(d),m))),this.B(v.listen("onDidChangeLoggers")(({added:d,removed:m})=>{for(const p of d)I.registerLogger({...p,resource:E.URI.revive(p.resource)});for(const p of m)I.deregisterLogger(p.resource)}))}}e.RemoteLoggerChannelClient=b}),define(be[110],Ee([1,0,2,10]),function(oe,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class l extends E.Disposable{constructor(S,P=[]){super(),this.a=new A.MultiplexLogger([S,...P]),this.B(S.onDidChangeLogLevel(y=>this.setLevel(y)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(S){this.a.setLevel(S)}getLevel(){return this.a.getLevel()}trace(S,...P){this.a.trace(S,...P)}debug(S,...P){this.a.debug(S,...P)}info(S,...P){this.a.info(S,...P)}warn(S,...P){this.a.warn(S,...P)}error(S,...P){this.a.error(S,...P)}flush(){this.a.flush()}}e.LogService=l}),define(be[111],Ee([1,0,16,10]),function(oe,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var l;(function(b){b[b.Trace=0]="Trace",b[b.Debug=1]="Debug",b[b.Info=2]="Info",b[b.Warning=3]="Warning",b[b.Error=4]="Error",b[b.Critical=5]="Critical",b[b.Off=6]="Off"})(l||(l={}));async function w(b,k,I,v,d){try{const m=await new Promise((c,h)=>{oe(["spdlog"],c,h)});m.setFlushOn(l.Trace);const p=await m.createAsyncRotatingLogger(b,k,I,v);return d?p.clearFormatters():p.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),p}catch(m){console.error(m)}return null}function S(b,k,I){switch(k){case A.LogLevel.Trace:b.trace(I);break;case A.LogLevel.Debug:b.debug(I);break;case A.LogLevel.Info:b.info(I);break;case A.LogLevel.Warning:b.warn(I);break;case A.LogLevel.Error:b.error(I);break;case A.LogLevel.Off:break;default:throw new Error(`Invalid log level ${k}`)}}function P(b,k){switch(k){case A.LogLevel.Trace:b.setLevel(l.Trace);break;case A.LogLevel.Debug:b.setLevel(l.Debug);break;case A.LogLevel.Info:b.setLevel(l.Info);break;case A.LogLevel.Warning:b.setLevel(l.Warning);break;case A.LogLevel.Error:b.setLevel(l.Error);break;case A.LogLevel.Off:b.setLevel(l.Off);break;default:throw new Error(`Invalid log level ${k}`)}}class y extends A.AbstractMessageLogger{constructor(k,I,v,d,m){super(),this.k=[],this.setLevel(m),this.l=this.n(k,I,v,d),this.B(this.onDidChangeLogLevel(p=>{this.m&&P(this.m,p)}))}async n(k,I,v,d){const m=v?6:1,p=30/m*E.ByteSize.MB,c=await w(k,I,p,m,d);if(c){this.m=c,P(this.m,this.getLevel());for(const{level:h,message:g}of this.k)S(this.m,h,g);this.k=[]}}g(k,I){this.m?S(this.m,k,I):this.getLevel()<=k&&this.k.push({level:k,message:I})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.SpdLogLogger=y}),define(be[222],Ee([1,0,21,10,111]),function(oe,e,E,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;class w extends A.AbstractLoggerService{k(P,y,b){return new l.SpdLogLogger((0,E.generateUuid)(),P.fsPath,!b?.donotRotate,!!b?.donotUseFormatters,y)}}e.LoggerService=w}),define(be[223],Ee([1,0,59,184,5]),function(oe,e,E,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var w;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(w=e.MarkerTag||(e.MarkerTag={}));var S;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(S=e.MarkerSeverity||(e.MarkerSeverity={})),function(y){function b(m,p){return p-m}y.compare=b;const k=Object.create(null);k[y.Error]=(0,A.localize)(0,null),k[y.Warning]=(0,A.localize)(1,null),k[y.Info]=(0,A.localize)(2,null);function I(m){return k[m]||""}y.toString=I;function v(m){switch(m){case E.default.Error:return y.Error;case E.default.Warning:return y.Warning;case E.default.Info:return y.Info;case E.default.Ignore:return y.Hint}}y.fromSeverity=v;function d(m){switch(m){case y.Error:return E.default.Error;case y.Warning:return E.default.Warning;case y.Info:return E.default.Info;case y.Hint:return E.default.Ignore}}y.toSeverity=d}(S=e.MarkerSeverity||(e.MarkerSeverity={}));var P;(function(y){const b="";function k(v){return I(v,!0)}y.makeKey=k;function I(v,d){const m=[b];return v.source?m.push(v.source.replace("\xA6","\\\xA6")):m.push(b),v.code?typeof v.code=="string"?m.push(v.code.replace("\xA6","\\\xA6")):m.push(v.code.value.replace("\xA6","\\\xA6")):m.push(b),v.severity!==void 0&&v.severity!==null?m.push(S.toString(v.severity)):m.push(b),v.message&&d?m.push(v.message.replace("\xA6","\\\xA6")):m.push(b),v.startLineNumber!==void 0&&v.startLineNumber!==null?m.push(v.startLineNumber.toString()):m.push(b),v.startColumn!==void 0&&v.startColumn!==null?m.push(v.startColumn.toString()):m.push(b),v.endLineNumber!==void 0&&v.endLineNumber!==null?m.push(v.endLineNumber.toString()):m.push(b),v.endColumn!==void 0&&v.endColumn!==null?m.push(v.endColumn.toString()):m.push(b),m.push(b),m.join("\xA6")}y.makeKeyOptionalMessage=I})(P=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,l.createDecorator)("markerService")}),define(be[67],Ee([1,0,6,56,2,5]),function(oe,e,E,A,l,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,w.createDecorator)("policy");class S extends l.Disposable{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new E.Emitter),this.onDidChange=this.h.event}async updatePolicyDefinitions(b){const k=Object.keys(this.f).length;return this.f={...b,...this.f},k!==Object.keys(this.f).length&&await this.i(b),A.Iterable.reduce(this.g.entries(),(I,[v,d])=>({...I,[v]:d}),{})}getPolicyValue(b){return this.g.get(b)}serialize(){return A.Iterable.reduce(Object.entries(this.f),(b,[k,I])=>({...b,[k]:{definition:I,value:this.g.get(k)}}),{})}}e.AbstractPolicyService=S;class P{constructor(){this.onDidChange=E.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=P}),define(be[51],Ee([1,0,3,28]),function(oe,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let l;if(typeof E.globals.vscode<"u"&&typeof E.globals.vscode.context<"u"){const w=E.globals.vscode.context.configuration();if(w)l=w.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(l=globalThis._VSCODE_PRODUCT_JSON,A.env.VSCODE_DEV&&Object.assign(l,{nameShort:`${l.nameShort} Dev`,nameLong:`${l.nameLong} Dev`,dataFolderName:`${l.dataFolderName}-dev`,serverDataFolderName:l.serverDataFolderName?`${l.serverDataFolderName}-dev`:void 0}),!l.version){const w=globalThis._VSCODE_PACKAGE_JSON;Object.assign(l,{version:w.version})}Object.assign(l,{extensionsGallery:A.env.EXTENSIONS_GALLERY?JSON.parse(A.env.EXTENSIONS_GALLERY):l.extensionsGallery||{serviceUrl:"https://open-vsx.org/vscode/gallery",itemUrl:"https://open-vsx.org/vscode/item",resourceUrlTemplate:"https://open-vsx.org/vscode/asset/{publisher}/{name}/{version}/Microsoft.VisualStudio.Code.WebResources/{path}",controlUrl:"",recommendationsUrl:""}})}else l={nameShort:"code-server",nameLong:"code-server",applicationName:"code-server",dataFolderName:".code-server",win32MutexName:"codeserver",licenseName:"MIT",licenseUrl:"https://github.com/coder/code-server/blob/main/LICENSE",serverGreeting:[],serverLicense:[],serverLicensePrompt:"",serverApplicationName:"code-server-oss",serverDataFolderName:".vscode-server-oss",tunnelApplicationName:"code-tunnel-oss",win32DirName:"code-server",win32NameVersion:"code-server",win32RegValueName:"CodeOSS",win32AppId:"{{E34003BB-9E10-4501-8C11-BE3FAA83F23F}",win32x64AppId:"{{D77B7E06-80BA-4137-BCF4-654B95CCEBC5}",win32arm64AppId:"{{D1ACE434-89C5-48D1-88D3-E2991DF85475}",win32UserAppId:"{{C6065F05-9603-4FC4-8101-B9781A25D88E}",win32x64UserAppId:"{{CC6B787D-37A0-49E8-AE24-8559A032BE0C}",win32arm64UserAppId:"{{3AEBF0C8-F733-4AD4-BADE-FDB816D53D7B}",win32AppUserModelId:"coder.code-server",win32ShellNameShort:"c&ode-server",darwinBundleIdentifier:"com.coder.code.server",linuxIconName:"com.coder.code.server",licenseFileName:"LICENSE.txt",reportIssueUrl:"https://github.com/coder/code-server/issues/new",urlProtocol:"code-oss",webviewContentExternalBaseUrlTemplate:"https://{{uuid}}.vscode-cdn.net/insider/ef65ac1ba57f57f2a3961bfe94aa20481caca4c6/out/vs/workbench/contrib/webview/browser/pre/",builtInExtensions:[{name:"ms-vscode.js-debug-companion",version:"1.0.18",repo:"https://github.com/microsoft/vscode-js-debug-companion",metadata:{id:"99cb0b7f-7354-4278-b8da-6cc79972169d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug",version:"1.76.0",repo:"https://github.com/microsoft/vscode-js-debug",metadata:{id:"25629058-ddac-4e17-abba-74678e126c5d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.vscode-js-profile-table",version:"1.0.3",repo:"https://github.com/microsoft/vscode-js-profile-visualizer",metadata:{id:"7e52b41b-71ad-457b-ab7e-0620f1fc4feb",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}}],enableTelemetry:!0,quality:"stable",codeServerVersion:"0.0.0",documentationUrl:"https://go.microsoft.com/fwlink/?LinkID=533484#vscode",keyboardShortcutsUrlMac:"https://go.microsoft.com/fwlink/?linkid=832143",keyboardShortcutsUrlLinux:"https://go.microsoft.com/fwlink/?linkid=832144",keyboardShortcutsUrlWin:"https://go.microsoft.com/fwlink/?linkid=832145",introductoryVideosUrl:"https://go.microsoft.com/fwlink/?linkid=832146",tipsAndTricksUrl:"https://go.microsoft.com/fwlink/?linkid=852118",newsletterSignupUrl:"https://www.research.net/r/vsc-newsletter",linkProtectionTrustedDomains:["https://open-vsx.org"],aiConfig:{ariaKey:"code-server"},version:"1.76.1",commit:"5e805b79fcb6ba4c2d23712967df89a089da575b",date:"2023-03-14T20:11:32.198Z"},Object.keys(l).length===0&&Object.assign(l,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=l}),define(be[26],Ee([1,0,5]),function(oe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,E.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(be[40],Ee([1,0,88,8]),function(oe,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class l{constructor(){this.a=new Map}add(S,P){E.ok(A.isString(S)),E.ok(A.isObject(P)),E.ok(!this.a.has(S),"There is already an extension with this id"),this.a.set(S,P)}knows(S){return this.a.has(S)}as(S){return this.a.get(S)||null}}e.Registry=new l}),define(be[224],Ee([1,0,6,40]),function(oe,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function l(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class w{constructor(){this.b=new E.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(y,b){this.a[l(y)]=b,this.b.fire(y)}notifySchemaChanged(y){this.b.fire(y)}getSchemaContributions(){return{schemas:this.a}}}const S=new w;A.Registry.add(e.Extensions.JSONContribution,S)}),define(be[52],Ee([1,0,18,6,8,168,24,224,40]),function(oe,e,E,A,l,w,S,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var b;(function(R){R.Multiline="multilineText",R.Singleline="singlelineText"})(b=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var k;(function(R){R[R.APPLICATION=1]="APPLICATION",R[R.MACHINE=2]="MACHINE",R[R.WINDOW=3]="WINDOW",R[R.RESOURCE=4]="RESOURCE",R[R.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",R[R.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(k=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const I=y.Registry.as(P.Extensions.JSONContribution);class v{constructor(){this.h=new Set,this.i=new A.Emitter,this.onDidSchemaChange=this.i.event,this.j=new A.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:w.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},I.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(t,r=!0){this.registerConfigurations([t],r)}registerConfigurations(t,r=!0){const i=new Set;this.n(t,r,i),I.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:i})}deregisterConfigurations(t){const r=new Set;this.o(t,r),I.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:t,remove:r}){const i=new Set;this.o(r,i),this.n(t,!1,i),I.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:i})}registerDefaultConfigurations(t){const r=new Set;this.k(t,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}k(t,r){const i=[];for(const{overrides:n,source:o}of t)for(const u in n)if(r.add(u),e.OVERRIDE_PROPERTY_REGEX.test(u)){const a=this.a.get(u),s=a?.valuesSources??new Map;if(o)for(const W of Object.keys(n[u]))s.set(W,o);const C={...a?.value||{},...n[u]};this.a.set(u,{source:o,value:C,valuesSources:s});const L=(0,S.getLanguageTagSettingPlainKey)(u),O={type:"object",default:C,description:w.localize(1,null,L),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:C,source:l.isString(o)?void 0:o,defaultValueSource:o};i.push(...p(u)),this.d[u]=O,this.b.properties[u]=O}else{this.a.set(u,{value:n[u],source:o});const a=this.d[u];a&&(this.w(u,a),this.r(u,a))}this.m(i)}deregisterDefaultConfigurations(t){const r=new Set;this.l(t,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}l(t,r){for(const{overrides:i,source:n}of t)for(const o in i){const u=this.a.get(o),a=l.isString(n)?n:n?.id,s=l.isString(u?.source)?u?.source:u?.source?.id;if(a===s)if(r.add(o),this.a.delete(o),e.OVERRIDE_PROPERTY_REGEX.test(o))delete this.d[o],delete this.b.properties[o];else{const C=this.d[o];C&&(this.w(o,C),this.r(o,C))}}this.u()}deltaConfiguration(t){let r=!1;const i=new Set;t.removedDefaults&&(this.l(t.removedDefaults,i),r=!0),t.addedDefaults&&(this.k(t.addedDefaults,i),r=!0),t.removedConfigurations&&this.o(t.removedConfigurations,i),t.addedConfigurations&&this.n(t.addedConfigurations,!1,i),this.i.fire(),this.j.fire({properties:i,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...t){this.i.fire()}registerOverrideIdentifiers(t){this.m(t),this.i.fire()}m(t){for(const r of t)this.h.add(r);this.u()}n(t,r,i){t.forEach(n=>{this.p(n,r,n.extensionInfo,n.restrictedProperties,void 0,i),this.c.push(n),this.q(n)})}o(t,r){const i=n=>{if(n.properties)for(const o in n.properties){r.add(o);const u=this.d[o];u?.policy?.name&&this.e.delete(u.policy.name),delete this.d[o],this.s(o,n.properties[o])}n.allOf?.forEach(o=>i(o))};for(const n of t){i(n);const o=this.c.indexOf(n);o!==-1&&this.c.splice(o,1)}}p(t,r=!0,i,n,o=3,u){o=l.isUndefinedOrNull(t.scope)?o:t.scope;const a=t.properties;if(a)for(const C in a){const L=a[C];if(r&&f(C,L)){delete a[C];continue}if(L.source=i,L.defaultDefaultValue=a[C].default,this.w(C,L),e.OVERRIDE_PROPERTY_REGEX.test(C)?L.scope=void 0:(L.scope=l.isUndefinedOrNull(L.scope)?o:L.scope,L.restricted=l.isUndefinedOrNull(L.restricted)?!!n?.includes(C):L.restricted),a[C].hasOwnProperty("included")&&!a[C].included){this.f[C]=a[C],delete a[C];continue}else this.d[C]=a[C],a[C].policy?.name&&this.e.set(a[C].policy.name,C);!a[C].deprecationMessage&&a[C].markdownDeprecationMessage&&(a[C].deprecationMessage=a[C].markdownDeprecationMessage),u.add(C)}const s=t.allOf;if(s)for(const C of s)this.p(C,r,i,n,o,u)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(t){const r=i=>{const n=i.properties;if(n)for(const u in n)this.r(u,n[u]);i.allOf?.forEach(r)};r(t)}r(t,r){switch(e.allSettings.properties[t]=r,r.scope){case 1:e.applicationSettings.properties[t]=r;break;case 2:e.machineSettings.properties[t]=r;break;case 6:e.machineOverridableSettings.properties[t]=r;break;case 3:e.windowSettings.properties[t]=r;break;case 4:e.resourceSettings.properties[t]=r;break;case 5:e.resourceSettings.properties[t]=r,this.g.properties[t]=r;break}}s(t,r){switch(delete e.allSettings.properties[t],r.scope){case 1:delete e.applicationSettings.properties[t];break;case 2:delete e.machineSettings.properties[t];break;case 6:delete e.machineOverridableSettings.properties[t];break;case 3:delete e.windowSettings.properties[t];break;case 4:case 5:delete e.resourceSettings.properties[t],delete this.g.properties[t];break}}u(){for(const t of this.h.values()){const r=`[${t}]`,i={type:"object",description:w.localize(2,null),errorMessage:w.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(r,i),e.allSettings.properties[r]=i,e.applicationSettings.properties[r]=i,e.machineSettings.properties[r]=i,e.machineOverridableSettings.properties[r]=i,e.windowSettings.properties[r]=i,e.resourceSettings.properties[r]=i}}v(){const t={type:"object",description:w.localize(4,null),errorMessage:w.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=t,this.i.fire()}w(t,r){const i=this.a.get(t);let n=i?.value,o=i?.source;l.isUndefined(n)&&(n=r.defaultDefaultValue,o=void 0),l.isUndefined(n)&&(n=h(r.type)),r.default=n,r.defaultValueSource=o}}const d="\\[([^\\]]+)\\]",m=new RegExp(d,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${d})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function p(R){const t=[];if(e.OVERRIDE_PROPERTY_REGEX.test(R)){let r=m.exec(R);for(;r?.length;){const i=r[1].trim();i&&t.push(i),r=m.exec(R)}}return(0,E.distinct)(t)}e.overrideIdentifiersFromKey=p;function c(R){return R.reduce((t,r)=>`${t}[${r}]`,"")}e.keyFromOverrideIdentifiers=c;function h(R){switch(Array.isArray(R)?R[0]:R){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=h;const g=new v;y.Registry.add(e.Extensions.Configuration,g);function f(R,t){return R.trim()?e.OVERRIDE_PROPERTY_REGEX.test(R)?w.localize(7,null,R):g.getConfigurationProperties()[R]!==void 0?w.localize(8,null,R):t.policy?.name&&g.getPolicyConfigurations().get(t.policy?.name)!==void 0?w.localize(9,null,R,t.policy?.name,g.getPolicyConfigurations().get(t.policy?.name)):null:w.localize(6,null)}e.validateProperty=f;function D(){const R=[],t=g.getConfigurationProperties();for(const r of Object.keys(t))R.push([r,t[r].scope]);return R.push(["launch",4]),R.push(["task",4]),R}e.getScopes=D}),define(be[112],Ee([1,0,18,6,71,2,27,23,8,4,24,52,40]),function(oe,e,E,A,l,w,S,P,y,b,k,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function d(r){return Object.isFrozen(r)?r:P.deepFreeze(r)}class m{constructor(i={},n=[],o=[],u){this.b=i,this.c=n,this.d=o,this.raw=u,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const i=this.raw.map(n=>{if(n instanceof m)return n;const o=new p("");return o.parseRaw(n),o.configurationModel});this.f=i.reduce((n,o)=>o===n?o:n.merge(o),i[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(i){return i?(0,k.getConfigurationValue)(this.contents,i):this.contents}inspect(i,n){const o=this.rawConfiguration.getValue(i),u=n?this.rawConfiguration.getOverrideValue(i,n):void 0,a=n?this.rawConfiguration.override(n).getValue(i):o;return{value:o,override:u,merged:a}}getOverrideValue(i,n){const o=this.i(n);return o?i?(0,k.getConfigurationValue)(o,i):o:void 0}getKeysForOverrideIdentifier(i){const n=[];for(const o of this.overrides)o.identifiers.includes(i)&&n.push(...o.keys);return E.distinct(n)}getAllOverrideIdentifiers(){const i=[];for(const n of this.overrides)i.push(...n.identifiers);return E.distinct(i)}override(i){let n=this.a.get(i);return n||(n=this.g(i),this.a.set(i,n)),n}merge(...i){const n=P.deepClone(this.contents),o=P.deepClone(this.overrides),u=[...this.keys],a=this.raw?.length?[...this.raw]:[this];for(const s of i)if(a.push(...s.raw?.length?s.raw:[s]),!s.isEmpty()){this.h(n,s.contents);for(const C of s.overrides){const[L]=o.filter(O=>E.equals(O.identifiers,C.identifiers));L?(this.h(L.contents,C.contents),L.keys.push(...C.keys),L.keys=E.distinct(L.keys)):o.push(P.deepClone(C))}for(const C of s.keys)u.indexOf(C)===-1&&u.push(C)}return new m(n,u,o,a.every(s=>s instanceof m)?void 0:a)}g(i){const n=this.i(i);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const o={};for(const u of E.distinct([...Object.keys(this.contents),...Object.keys(n)])){let a=this.contents[u];const s=n[u];s&&(typeof a=="object"&&typeof s=="object"?(a=P.deepClone(a),this.h(a,s)):a=s),o[u]=a}return new m(o,this.keys,this.overrides)}h(i,n){for(const o of Object.keys(n)){if(o in i&&y.isObject(i[o])&&y.isObject(n[o])){this.h(i[o],n[o]);continue}i[o]=P.deepClone(n[o])}}i(i){let n=null,o=null;const u=a=>{a&&(o?this.h(o,a):o=P.deepClone(a))};for(const a of this.overrides)E.equals(a.identifiers,[i])?n=a.contents:a.identifiers.includes(i)&&u(a.contents);return u(n),o}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(i,n){this.j(i,n,!0)}setValue(i,n){this.j(i,n,!1)}removeValue(i){const n=this.keys.indexOf(i);n!==-1&&(this.keys.splice(n,1),(0,k.removeFromValueTree)(this.contents,i),I.OVERRIDE_PROPERTY_REGEX.test(i)&&this.overrides.splice(this.overrides.findIndex(o=>E.equals(o.identifiers,(0,I.overrideIdentifiersFromKey)(i))),1))}j(i,n,o){(0,k.addToValueTree)(this.contents,i,n,u=>console.error(u)),o=o||this.keys.indexOf(i)===-1,o&&this.keys.push(i),I.OVERRIDE_PROPERTY_REGEX.test(i)&&this.overrides.push({identifiers:(0,I.overrideIdentifiersFromKey)(i),keys:Object.keys(this.contents[i]),contents:(0,k.toValuesTree)(this.contents[i],u=>console.error(u))})}}e.ConfigurationModel=m;class p{constructor(i){this.f=i,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new m}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(i,n){if(!y.isUndefinedOrNull(i)){const o=this.g(i);this.parseRaw(o,n)}}reparse(i){this.a&&this.parseRaw(this.a,i)}parseRaw(i,n){this.a=i;const{contents:o,keys:u,overrides:a,restricted:s,hasExcludedProperties:C}=this.h(i,n);this.b=new m(o,u,a,C?[i]:void 0),this.c=s||[]}g(i){let n={},o=null,u=[];const a=[],s=[];function C(O){Array.isArray(u)?u.push(O):o!==null&&(u[o]=O)}const L={onObjectBegin:()=>{const O={};C(O),a.push(u),u=O,o=null},onObjectProperty:O=>{o=O},onObjectEnd:()=>{u=a.pop()},onArrayBegin:()=>{const O=[];C(O),a.push(u),u=O,o=null},onArrayEnd:()=>{u=a.pop()},onLiteralValue:C,onError:(O,W,X)=>{s.push({error:O,offset:W,length:X})}};if(i)try{l.visit(i,L),n=u[0]||{}}catch(O){console.error(`Error while parsing settings file ${this.f}: ${O}`),this.d=[O]}return n}h(i,n){const o=v.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),u=this.i(i,o,!0,n);i=u.raw;const a=(0,k.toValuesTree)(i,L=>console.error(`Conflict in settings file ${this.f}: ${L}`)),s=Object.keys(i),C=this.j(i,L=>console.error(`Conflict in settings file ${this.f}: ${L}`));return{contents:a,keys:s,overrides:C,restricted:u.restricted,hasExcludedProperties:u.hasExcludedProperties}}i(i,n,o,u){let a=!1;if(!u?.scopes&&!u?.skipRestricted)return{raw:i,restricted:[],hasExcludedProperties:a};const s={},C=[];for(const L in i)if(I.OVERRIDE_PROPERTY_REGEX.test(L)&&o){const O=this.i(i[L],n,!1,u);s[L]=O.raw,a=a||O.hasExcludedProperties,C.push(...O.restricted)}else{const O=n[L],W=O?typeof O.scope<"u"?O.scope:3:void 0;O?.restricted&&C.push(L),(W===void 0||u.scopes===void 0||u.scopes.includes(W))&&!(u.skipRestricted&&O?.restricted)?s[L]=i[L]:a=!0}return{raw:s,restricted:C,hasExcludedProperties:a}}j(i,n){const o=[];for(const u of Object.keys(i))if(I.OVERRIDE_PROPERTY_REGEX.test(u)){const a={};for(const s in i[u])a[s]=i[u][s];o.push({identifiers:(0,I.overrideIdentifiersFromKey)(u),keys:Object.keys(a),contents:(0,k.toValuesTree)(a,n)})}return o}}e.ConfigurationModelParser=p;class c extends w.Disposable{constructor(i,n,o,u){super(),this.f=i,this.g=n,this.h=u,this.c=this.B(new A.Emitter),this.onDidChange=this.c.event,this.a=new p(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(o.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(A.Event.any(A.Event.filter(this.h.onDidFilesChange,a=>a.contains(this.f)),A.Event.filter(this.h.onDidRunOperation,a=>(a.isOperation(0)||a.isOperation(3)||a.isOperation(1)||a.isOperation(4))&&o.isEqual(a.resource,i)))(()=>this.c.fire()))}async loadConfiguration(){try{const i=await this.h.readFile(this.f);return this.a.parse(i.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new m}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=c;class h{constructor(i,n,o,u,a,s,C,L,O,W,X,se,fe){this.a=i,this.b=n,this.c=o,this.overrideIdentifiers=u,this.d=a,this.f=s,this.g=C,this.h=L,this.i=O,this.j=W,this.k=X,this.l=se,this.m=fe}get value(){return d(this.c)}n(i,n,o){const u=i.inspect(n,o);return{get value(){return d(u.value)},get override(){return d(u.override)},get merged(){return d(u.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class g{constructor(i,n,o,u,a=new m,s=new m,C=new S.ResourceMap,L=new m,O=new S.ResourceMap){this.c=i,this.d=n,this.f=o,this.g=u,this.h=a,this.i=s,this.j=C,this.l=L,this.m=O,this.a=null,this.b=new S.ResourceMap,this.n=null}getValue(i,n,o){return this.q(i,n,o).getValue(i)}updateValue(i,n,o={}){let u;o.resource?(u=this.m.get(o.resource),u||(u=new m,this.m.set(o.resource,u))):u=this.l,n===void 0?u.removeValue(i):u.setValue(i,n),o.resource||(this.a=null)}inspect(i,n,o){const u=this.q(i,n,o),a=this.u(n.resource,o),s=n.resource?this.m.get(n.resource)||this.l:this.l,C=new Set;for(const L of u.overrides)for(const O of L.identifiers)u.getOverrideValue(i,O)!==void 0&&C.add(O);return new h(i,n,u.getValue(i),C.size?[...C]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,o?this.i:void 0,a||void 0,s)}keys(i){const n=this.u(void 0,i);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:n?n.keys.slice(0):[]}}updateDefaultConfiguration(i){this.c=i,this.a=null,this.b.clear()}updatePolicyConfiguration(i){this.d=i}updateApplicationConfiguration(i){this.f=i,this.a=null,this.b.clear()}updateLocalUserConfiguration(i){this.g=i,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(i){this.h=i,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(i){this.i=i,this.a=null,this.b.clear()}updateFolderConfiguration(i,n){this.j.set(i,n),this.b.delete(i)}deleteFolderConfiguration(i){this.p.delete(i),this.b.delete(i)}compareAndUpdateDefaultConfiguration(i,n){const o=[];if(!n){const{added:u,updated:a,removed:s}=R(this.c,i);n=[...u,...a,...s]}for(const u of n)for(const a of(0,I.overrideIdentifiersFromKey)(u)){const s=this.c.getKeysForOverrideIdentifier(a),C=i.getKeysForOverrideIdentifier(a),L=[...C.filter(O=>s.indexOf(O)===-1),...s.filter(O=>C.indexOf(O)===-1),...s.filter(O=>!P.equals(this.c.override(a).getValue(O),i.override(a).getValue(O)))];o.push([a,L])}return this.updateDefaultConfiguration(i),{keys:n,overrides:o}}compareAndUpdatePolicyConfiguration(i){const{added:n,updated:o,removed:u}=R(this.d,i),a=[...n,...o,...u];return a.length&&this.updatePolicyConfiguration(i),{keys:a,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:n,updated:o,removed:u,overrides:a}=R(this.applicationConfiguration,i),s=[...n,...o,...u];return s.length&&this.updateApplicationConfiguration(i),{keys:s,overrides:a}}compareAndUpdateLocalUserConfiguration(i){const{added:n,updated:o,removed:u,overrides:a}=R(this.localUserConfiguration,i),s=[...n,...o,...u];return s.length&&this.updateLocalUserConfiguration(i),{keys:s,overrides:a}}compareAndUpdateRemoteUserConfiguration(i){const{added:n,updated:o,removed:u,overrides:a}=R(this.remoteUserConfiguration,i),s=[...n,...o,...u];return s.length&&this.updateRemoteUserConfiguration(i),{keys:s,overrides:a}}compareAndUpdateWorkspaceConfiguration(i){const{added:n,updated:o,removed:u,overrides:a}=R(this.workspaceConfiguration,i),s=[...n,...o,...u];return s.length&&this.updateWorkspaceConfiguration(i),{keys:s,overrides:a}}compareAndUpdateFolderConfiguration(i,n){const o=this.p.get(i),{added:u,updated:a,removed:s,overrides:C}=R(o,n),L=[...u,...a,...s];return(L.length||!o)&&this.updateFolderConfiguration(i,n),{keys:L,overrides:C}}compareAndDeleteFolderConfiguration(i){const n=this.p.get(i);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:o,updated:u,removed:a,overrides:s}=R(n,void 0);return{keys:[...o,...u,...a],overrides:s}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(i,n,o){let u=this.r(n,o);return n.overrideIdentifier&&(u=u.override(n.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(i)!==void 0&&(u=u.merge(this.d)),u}r({resource:i},n){let o=this.s();if(n&&i){const u=n.getFolder(i);u&&(o=this.t(u.uri)||o);const a=this.m.get(i);a&&(o=o.merge(a))}return o}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(i){let n=this.b.get(i);if(!n){const o=this.s(),u=this.j.get(i);u?(n=o.merge(u),this.b.set(i,n)):n=o}return n}u(i,n){if(n&&i){const o=n.getFolder(i);if(o)return this.j.get(o.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((i,n)=>{const{contents:o,overrides:u,keys:a}=this.j.get(n);return i.push([n,{contents:o,overrides:u,keys:a}]),i},[])}}allKeys(){const i=new Set;return this.c.keys.forEach(n=>i.add(n)),this.userConfiguration.keys.forEach(n=>i.add(n)),this.i.keys.forEach(n=>i.add(n)),this.j.forEach(n=>n.keys.forEach(o=>i.add(o))),[...i.values()]}v(){const i=new Set;return this.c.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.userConfiguration.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.i.getAllOverrideIdentifiers().forEach(n=>i.add(n)),this.j.forEach(n=>n.getAllOverrideIdentifiers().forEach(o=>i.add(o))),[...i.values()]}w(i){const n=new Set;return this.c.getKeysForOverrideIdentifier(i).forEach(o=>n.add(o)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(o=>n.add(o)),this.i.getKeysForOverrideIdentifier(i).forEach(o=>n.add(o)),this.j.forEach(o=>o.getKeysForOverrideIdentifier(i).forEach(u=>n.add(u))),[...n.values()]}static parse(i){const n=this.x(i.defaults),o=this.x(i.policy),u=this.x(i.application),a=this.x(i.user),s=this.x(i.workspace),C=i.folders.reduce((L,O)=>(L.set(b.URI.revive(O[0]),this.x(O[1])),L),new S.ResourceMap);return new g(n,o,u,a,new m,s,C,new m,new S.ResourceMap)}static x(i){return new m(i.contents,i.keys,i.overrides)}}e.Configuration=g;function f(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const i=new Set,n=new Map;for(const u of r)u.keys.forEach(a=>i.add(a)),u.overrides.forEach(([a,s])=>{const C=(0,S.getOrSet)(n,a,new Set);s.forEach(L=>C.add(L))});const o=[];return n.forEach((u,a)=>o.push([a,[...u.values()]])),{keys:[...i.values()],overrides:o}}e.mergeChanges=f;class D{constructor(i,n,o,u){this.change=i,this.f=n,this.g=o,this.h=u,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const a of i.keys)this.affectedKeys.add(a);for(const[,a]of i.overrides)for(const s of a)this.affectedKeys.add(s);this.d=this.a;for(const a of this.affectedKeys)this.d+=a+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=g.parse(this.f.data)),this.i}affectsConfiguration(i,n){const o=this.a+i,u=this.d.indexOf(o);if(u<0)return!1;const a=u+o.length;if(a>=this.d.length)return!1;const s=this.d.charCodeAt(a);if(s!==this.b&&s!==this.c)return!1;if(n){const C=this.previousConfiguration?this.previousConfiguration.getValue(i,n,this.f?.workspace):void 0,L=this.g.getValue(i,n,this.h);return!P.equals(C,L)}return!0}}e.ConfigurationChangeEvent=D;function R(r,i){const{added:n,removed:o,updated:u}=t(i?.rawConfiguration,r?.rawConfiguration),a=[],s=r?.getAllOverrideIdentifiers()||[],C=i?.getAllOverrideIdentifiers()||[];if(i){const L=C.filter(O=>!s.includes(O));for(const O of L)a.push([O,i.getKeysForOverrideIdentifier(O)])}if(r){const L=s.filter(O=>!C.includes(O));for(const O of L)a.push([O,r.getKeysForOverrideIdentifier(O)])}if(i&&r){for(const L of s)if(C.includes(L)){const O=t({contents:r.getOverrideValue(void 0,L)||{},keys:r.getKeysForOverrideIdentifier(L)},{contents:i.getOverrideValue(void 0,L)||{},keys:i.getKeysForOverrideIdentifier(L)});a.push([L,[...O.added,...O.removed,...O.updated]])}}return{added:n,removed:o,updated:u,overrides:a}}function t(r,i){const n=r?i?r.keys.filter(a=>i.keys.indexOf(a)===-1):[...r.keys]:[],o=i?r?i.keys.filter(a=>r.keys.indexOf(a)===-1):[...i.keys]:[],u=[];if(r&&i){for(const a of i.keys)if(r.keys.indexOf(a)!==-1){const s=(0,k.getConfigurationValue)(i.contents,a),C=(0,k.getConfigurationValue)(r.contents,a);P.equals(s,C)||u.push(a)}}return{added:n,removed:o,updated:u}}}),define(be[225],Ee([1,0,18,6,2,23,8,112,52,10,67,40]),function(oe,e,E,A,l,w,S,P,y,b,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfiguration=void 0;class v extends l.Disposable{constructor(){super(...arguments),this.a=this.B(new A.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new P.ConfigurationModel}get configurationModel(){return this.b}async initialize(){return this.g(),this.B(I.Registry.as(y.Extensions.Configuration).onDidUpdateConfiguration(({properties:c,defaultsOverrides:h})=>this.c(Array.from(c),h))),this.configurationModel}reload(){return this.g(),this.configurationModel}c(c,h){this.h(c,I.Registry.as(y.Extensions.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:c})}f(){return{}}g(){this.b=new P.ConfigurationModel;const c=I.Registry.as(y.Extensions.Configuration).getConfigurationProperties();this.h(Object.keys(c),c)}h(c,h){const g=this.f();for(const f of c){const D=g[f],R=h[f];D!==void 0?this.b.addValue(f,D):R?this.b.addValue(f,R.default):this.b.removeValue(f)}}}e.DefaultConfiguration=v;class d{constructor(){this.onDidChangeConfiguration=A.Event.None,this.configurationModel=new P.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=d;let m=class extends l.Disposable{get configurationModel(){return this.b}constructor(c,h,g){super(),this.c=c,this.f=h,this.g=g,this.a=this.B(new A.Emitter),this.onDidChangeConfiguration=this.a.event,this.b=new P.ConfigurationModel}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.j(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(c=>this.i(c))),this.B(this.c.onDidChangeConfiguration(async({properties:c})=>this.j(await this.h(c),!0))),this.b}async h(c){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",c);const h={},g=[],f=I.Registry.as(y.Extensions.Configuration).getConfigurationProperties();for(const D of c){const R=f[D];if(!R){g.push(D);continue}if(R.policy){if(R.type!=="string"&&R.type!=="number"){this.g.warn(`Policy ${R.policy.name} has unsupported type ${R.type}`);continue}g.push(D),h[R.policy.name]={type:R.type}}}return(0,S.isEmptyObject)(h)||await this.f.updatePolicyDefinitions(h),g}i(c){this.g.trace("PolicyConfiguration#onDidChangePolicies",c);const h=I.Registry.as(y.Extensions.Configuration).getPolicyConfigurations(),g=(0,E.coalesce)(c.map(f=>h.get(f)));this.j(g,!0)}j(c,h){this.g.trace("PolicyConfiguration#update",c);const g=I.Registry.as(y.Extensions.Configuration).getConfigurationProperties(),f=[],D=this.b.isEmpty();for(const R of c){const t=g[R]?.policy?.name;if(t){const r=this.f.getPolicyValue(t);(D?r!==void 0:!(0,w.equals)(this.b.getValue(R),r))&&f.push([R,r])}else this.b.getValue(R)!==void 0&&f.push([R,void 0])}if(f.length){this.g.trace("PolicyConfiguration#changed",f);const R=this.b;this.b=new P.ConfigurationModel;for(const t of R.keys)this.b.setValue(t,R.getValue(t));for(const[t,r]of f)r===void 0?this.b.removeValue(t):this.b.setValue(t,r);h&&this.a.fire(this.b)}}};m=Te([Ae(1,k.IPolicyService),Ae(2,b.ILogService)],m),e.PolicyConfiguration=m}),define(be[113],Ee([1,0,14,6,2,20,24,112,225,67]),function(oe,e,E,A,l,w,S,P,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class k extends l.Disposable{constructor(v,d,m,p){super(),this.i=v,this.h=this.B(new A.Emitter),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new y.DefaultConfiguration),this.c=m instanceof b.NullPolicyService?new y.NullPolicyConfiguration:this.B(new y.PolicyConfiguration(this.b,m,p)),this.f=this.B(new P.UserSettings(this.i,void 0,w.extUriBiasedIgnorePathCase,d)),this.a=new P.Configuration(this.b.configurationModel,this.c.configurationModel,new P.ConfigurationModel,new P.ConfigurationModel),this.g=this.B(new E.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:c,properties:h})=>this.k(c,h))),this.B(this.c.onDidChangeConfiguration(c=>this.l(c))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[v,d,m]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new P.Configuration(v,d,new P.ConfigurationModel,m)}getConfigurationData(){return this.a.toData()}getValue(v,d){const m=typeof v=="string"?v:void 0,p=(0,S.isConfigurationOverrides)(v)?v:(0,S.isConfigurationOverrides)(d)?d:{};return this.a.getValue(m,p,void 0)}updateValue(v,d,m,p){return Promise.reject(new Error("not supported"))}inspect(v){return this.a.inspect(v,{},void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const v=await this.f.loadConfiguration();this.j(v)}j(v){const d=this.a.toData(),m=this.a.compareAndUpdateLocalUserConfiguration(v);this.m(m,d,2)}k(v,d){const m=this.a.toData(),p=this.a.compareAndUpdateDefaultConfiguration(v,d);this.m(p,m,7)}l(v){const d=this.a.toData(),m=this.a.compareAndUpdatePolicyConfiguration(v);this.m(m,d,7)}m(v,d,m){const p=new P.ConfigurationChangeEvent(v,{data:d},this.a);p.source=m,p.sourceConfig=this.n(m),this.h.fire(p)}n(v){switch(v){case 7:return this.a.defaults.contents;case 2:return this.a.localUserConfiguration.contents}return{}}}e.ConfigurationService=k}),define(be[114],Ee([1,0,9,5]),function(oe,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,A.createDecorator)("remoteAuthorityResolverService");var l;(function(P){P.Unknown="Unknown",P.NotAvailable="NotAvailable",P.TemporarilyNotAvailable="TemporarilyNotAvailable",P.NoResolverFound="NoResolverFound"})(l=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class w extends E.ErrorNoTelemetry{static isNotAvailable(y){return y instanceof w&&y._code===l.NotAvailable}static isTemporarilyNotAvailable(y){return y instanceof w&&y._code===l.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof w&&y._code===l.NoResolverFound}static isHandled(y){return y instanceof w&&y.isHandled}constructor(y,b=l.Unknown,k){super(y),this._message=y,this._code=b,this._detail=k,this.isHandled=b===l.NotAvailable&&k===!0,Object.setPrototypeOf(this,w.prototype)}}e.RemoteAuthorityResolverError=w;function S(P){const y=P.indexOf("+");return y===-1?P:P.substring(0,y)}e.getRemoteAuthorityPrefix=S}),define(be[226],Ee([1,0,5]),function(oe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteExtensionsScannerChannelName=e.IRemoteExtensionsScannerService=void 0,e.IRemoteExtensionsScannerService=(0,E.createDecorator)("IRemoteExtensionsScannerService"),e.RemoteExtensionsScannerChannelName="remoteExtensionsScanner"}),define(be[53],Ee([1,0,13]),function(oe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function A(b){return b.scheme===E.Schemas.vscodeRemote?b.authority:void 0}e.getRemoteAuthority=A;function l(b){if(!b)return;const k=b.indexOf("+");return k<0?b:b.substr(0,k)}e.getRemoteName=l;function w(b){return`/${b.quality??"oss"}-${b.commit??"dev"}`}e.getRemoteServerRootPath=w;function S(b){const{host:k,port:I}=y(b);if(typeof I>"u")throw new Error("Remote authority doesn't contain a port!");return{host:k,port:I}}e.parseAuthorityWithPort=S;function P(b,k){let{host:I,port:v}=y(b);return typeof v>"u"&&(v=k),{host:I,port:v}}e.parseAuthorityWithOptionalPort=P;function y(b){const k=b.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(k)return{host:k[1],port:parseInt(k[2],10)};const I=b.match(/^(\[[0-9a-z:]+\])$/);if(I)return{host:I[1],port:void 0};const v=b.match(/(.*):(\d+)$/);return v?{host:v[1],port:parseInt(v[2],10)}:{host:b,port:void 0}}}),define(be[34],Ee([1,0,17,5,53]),function(oe,e,E,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function w(d){if(typeof d=="object"&&d!==null&&d.supported!==!0)return d.description}e.getWorkspaceSupportTypeMessage=w,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var S;(function(d){d[d.System=0]="System",d[d.User=1]="User"})(S=e.ExtensionType||(e.ExtensionType={}));var P;(function(d){d.WIN32_X64="win32-x64",d.WIN32_IA32="win32-ia32",d.WIN32_ARM64="win32-arm64",d.LINUX_X64="linux-x64",d.LINUX_ARM64="linux-arm64",d.LINUX_ARMHF="linux-armhf",d.ALPINE_X64="alpine-x64",d.ALPINE_ARM64="alpine-arm64",d.DARWIN_X64="darwin-x64",d.DARWIN_ARM64="darwin-arm64",d.WEB="web",d.UNIVERSAL="universal",d.UNKNOWN="unknown",d.UNDEFINED="undefined"})(P=e.TargetPlatform||(e.TargetPlatform={}));class y{constructor(m){this.value=m,this.c=m.toLowerCase()}static equals(m,p){if(typeof m>"u"||m===null)return typeof p>"u"||p===null;if(typeof p>"u"||p===null)return!1;if(typeof m=="string"||typeof p=="string"){const c=typeof m=="string"?m:m.value,h=typeof p=="string"?p:p.value;return E.equalsIgnoreCase(c,h)}return m.c===p.c}static toKey(m){return typeof m=="string"?m.toLowerCase():m.c}}e.ExtensionIdentifier=y;function b(d){return k(d)}e.isApplicationScopedExtension=b;function k(d){return d.contributes&&d.contributes.localizations?d.contributes.localizations.length>0:!1}e.isLanguagePackExtension=k;function I(d){return d.contributes&&d.contributes.authentication?d.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=I;function v(d,m){if(m){const p=`onResolveRemoteAuthority:${(0,l.getRemoteName)(m)}`;return!!d.activationEvents?.includes(p)}return!1}e.isResolverExtension=v,e.IBuiltinExtensionsScannerService=(0,A.createDecorator)("IBuiltinExtensionsScannerService")}),define(be[227],Ee([1,0,2,7,22,34]),function(oe,e,E,A,l,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class S extends E.Disposable{constructor(y,b){super(),this.b=y,this.a=(0,A.join)(this.b.userDataPath,w.MANIFEST_CACHE_FOLDER,w.USER_MANIFEST_CACHE_FILE),this.B(b.onDidInstallExtensions(k=>this.c(k))),this.B(b.onDidUninstallExtension(k=>this.f(k)))}c(y){y.some(b=>!!b.local)&&this.invalidate()}f(y){y.error||this.invalidate()}invalidate(){l.Promises.rm(this.a,l.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=S}),define(be[54],Ee([1,0,15,185,52,5,40]),function(oe,e,E,A,l,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,w.createDecorator)("requestService");function P(p){return p.res.statusCode&&p.res.statusCode>=200&&p.res.statusCode<300||p.res.statusCode===1223}e.isSuccess=P;function y(p){return p.res.statusCode===204}async function b(p){return y(p)?null:(await(0,E.streamToBuffer)(p.stream)).toString()}e.asText=b;async function k(p){if(!P(p))throw new Error("Server returned "+p.res.statusCode);return b(p)}e.asTextOrError=k;async function I(p){if(!P(p))throw new Error("Server returned "+p.res.statusCode);if(y(p))return null;const h=(await(0,E.streamToBuffer)(p.stream)).toString();try{return JSON.parse(h)}catch(g){throw g.message+=`:
`+h,g}}e.asJson=I;function v(p){m(p)}e.updateProxyConfigurationsScope=v;let d;function m(p){const c=S.Registry.as(l.Extensions.Configuration),h=d;d={id:"http",order:15,title:(0,A.localize)(0,null),type:"object",scope:p,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,A.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,A.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,A.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,A.localize)(4,null),(0,A.localize)(5,null),(0,A.localize)(6,null),(0,A.localize)(7,null)],default:"override",description:(0,A.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,A.localize)(9,null),restricted:!0}}},c.updateConfigurations({add:[d],remove:h?[h]:[]})}m(2)}),define(be[228],Ee([1,0,19,13,16,54]),function(oe,e,E,A,l,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let S=class{constructor(y,b){this.a=y,this.b=b}async download(y,b,k=E.CancellationToken.None){if(y.scheme===A.Schemas.file||y.scheme===A.Schemas.vscodeRemote){await this.b.copy(y,b);return}const I={type:"GET",url:y.toString(!0)},v=await this.a.request(I,k);if(v.res.statusCode===200)await this.b.writeFile(b,v.stream);else{const d=await(0,w.asTextOrError)(v);throw new Error(`Expected 200, got back ${v.res.statusCode} instead.

${d}`)}}};S=Te([Ae(0,w.IRequestService),Ae(1,l.IFileService)],S),e.DownloadService=S}),define(be[229],Ee([1,0,15,19]),function(oe,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class l{constructor(P){this.a=P}listen(P,y){throw new Error("Invalid listen")}call(P,y,b,k=A.CancellationToken.None){switch(y){case"request":return this.a.request(b[0],k).then(async({res:I,stream:v})=>{const d=await(0,E.streamToBuffer)(v);return[{statusCode:I.statusCode,headers:I.headers},d]});case"resolveProxy":return this.a.resolveProxy(b[0])}throw new Error("Invalid call")}}e.RequestChannel=l;class w{constructor(P){this.a=P}async request(P,y){const[b,k]=await this.a.call("request",[P],y);return{res:b,stream:(0,E.bufferToStream)(k)}}async resolveProxy(P){return this.a.call("resolveProxy",[P])}}e.RequestChannelClient=w}),define(be[230],Ee([1,0,79,8]),function(oe,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function l(S,P){return S.protocol==="http:"?P.HTTP_PROXY||P.http_proxy||null:S.protocol==="https:"&&(P.HTTPS_PROXY||P.https_proxy||P.HTTP_PROXY||P.http_proxy)||null}async function w(S,P,y={}){const b=(0,E.parse)(S),k=y.proxyUrl||l(b,P);if(!k)return null;const I=(0,E.parse)(k);if(!/^https?:$/.test(I.protocol||""))return null;const v={host:I.hostname||"",port:I.port||(I.protocol==="https"?"443":"80"),auth:I.auth,rejectUnauthorized:(0,A.isBoolean)(y.strictSSL)?y.strictSSL:!0};return b.protocol==="http:"?new(await new Promise((d,m)=>{oe(["http-proxy-agent"],d,m)}))(v):new(await new Promise((d,m)=>{oe(["https-proxy-agent"],d,m)}))(v)}e.getProxyAgent=w}),define(be[80],Ee([1,0,48,7,186,19,39,9,3,21,156,202,14,143]),function(oe,e,E,A,l,w,S,P,y,b,k,I,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;let m;async function p(h,g,f,D){return f["force-disable-user-env"]?(g.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):y.isWindows?(g.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,I.isLaunchedFromCli)(D)&&!f["force-user-env"]?(g.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,I.isLaunchedFromCli)(D)?g.trace("resolveShellEnv(): running (--force-user-env)"):g.trace("resolveShellEnv(): running (macOS/Linux)"),m||(m=v.Promises.withAsyncBody(async(R,t)=>{const r=new w.CancellationTokenSource;let i=1e4;const n=h.getValue("application.shellEnvironmentResolutionTimeout");typeof n=="number"&&(i=(0,d.clamp)(n,1,120)*1e3);const o=setTimeout(()=>{r.dispose(!0),t(new Error((0,l.localize)(0,null)))},i);try{R(await c(g,r.token))}catch(u){!(0,P.isCancellationError)(u)&&!r.token.isCancellationRequested?t(new Error((0,l.localize)(1,null,(0,S.toErrorMessage)(u)))):R({})}finally{clearTimeout(o),r.dispose()}})),m)}e.getResolvedShellEnv=p;async function c(h,g){const f=process.env.ELECTRON_RUN_AS_NODE;h.trace("getUnixShellEnvironment#runAsNode",f);const D=process.env.ELECTRON_NO_ATTACH_CONSOLE;h.trace("getUnixShellEnvironment#noAttach",D);const R=(0,b.generateUuid)().replace(/-/g,"").substr(0,12),t=new RegExp(R+"({.*})"+R),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};h.trace("getUnixShellEnvironment#env",r);const i=await(0,k.getSystemShell)(y.OS,r);return h.trace("getUnixShellEnvironment#shell",i),new Promise((n,o)=>{if(g.isCancellationRequested)return o(new P.CancellationError);const u=(0,A.basename)(i);let a,s;const C=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(u)?(a=`& '${process.execPath}' ${C} -p '''${R}'' + JSON.stringify(process.env) + ''${R}'''`,s=["-Login","-Command"]):(a=`'${process.execPath}' ${C} -p '"${R}" + JSON.stringify(process.env) + "${R}"'`,u==="tcsh"||u==="csh"?s=["-ic"]:s=["-i","-l","-c"]),h.trace("getUnixShellEnvironment#spawn",JSON.stringify(s),a);const L=(0,E.spawn)(i,[...s,a],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});g.onCancellationRequested(()=>(L.kill(),o(new P.CancellationError))),L.on("error",X=>{h.error("getUnixShellEnvironment#errorChildProcess",(0,S.toErrorMessage)(X)),o(X)});const O=[];L.stdout.on("data",X=>O.push(X));const W=[];L.stderr.on("data",X=>W.push(X)),L.on("close",(X,se)=>{const fe=Buffer.concat(O).toString("utf8");h.trace("getUnixShellEnvironment#raw",fe);const ce=Buffer.concat(W).toString("utf8");if(ce.trim()&&h.trace("getUnixShellEnvironment#stderr",ce),X||se)return o(new Error((0,l.localize)(2,null,X,se)));const V=t.exec(fe),T=V?V[1]:"{}";try{const z=JSON.parse(T);f?z.ELECTRON_RUN_AS_NODE=f:delete z.ELECTRON_RUN_AS_NODE,D?z.ELECTRON_NO_ATTACH_CONSOLE=D:delete z.ELECTRON_NO_ATTACH_CONSOLE,delete z.VSCODE_RESOLVING_ENVIRONMENT,delete z.XDG_RUNTIME_DIR,h.trace("getUnixShellEnvironment#result",z),n(z)}catch(z){h.error("getUnixShellEnvironment#errorCaught",(0,S.toErrorMessage)(z)),o(z)}})})}}),define(be[231],Ee([1,0,5]),function(oe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateService=e.IStateReadService=void 0,e.IStateReadService=(0,E.createDecorator)("stateReadService"),e.IStateService=(0,E.createDecorator)("stateService")}),define(be[232],Ee([1,0,14,15,8,25,16,10]),function(oe,e,E,A,l,w,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateService=e.StateReadonlyService=e.FileStorage=e.SaveStrategy=void 0;var y;(function(v){v[v.IMMEDIATE=0]="IMMEDIATE",v[v.DELAYED=1]="DELAYED"})(y=e.SaveStrategy||(e.SaveStrategy={}));class b{constructor(d,m,p,c){this.f=d,this.g=p,this.h=c,this.a=Object.create(null),this.b="",this.d=void 0,this.e=void 0,this.c=m===0?void 0:new E.ThrottledDelayer(100)}init(){return this.d||(this.d=this.i()),this.d}async i(){try{this.b=(await this.h.readFile(this.f)).value.toString(),this.a=JSON.parse(this.b)}catch(d){d.fileOperationResult!==1&&this.g.error(d)}}getItem(d,m){const p=this.a[d];return(0,l.isUndefinedOrNull)(p)?m:p}setItem(d,m){this.setItems([{key:d,data:m}])}setItems(d){let m=!1;for(const{key:p,data:c}of d)this.a[p]!==c&&((0,l.isUndefinedOrNull)(c)?(0,l.isUndefined)(this.a[p])||(this.a[p]=void 0,m=!0):(this.a[p]=c,m=!0));m&&this.j()}removeItem(d){(0,l.isUndefined)(this.a[d])||(this.a[d]=void 0,this.j())}async j(){if(!this.e)return this.c?this.c.trigger(()=>this.k()):this.k()}async k(){if(!this.d)return;await this.d;const d=JSON.stringify(this.a,null,4);if(d!==this.b)try{await this.h.writeFile(this.f,A.VSBuffer.fromString(d)),this.b=d}catch(m){this.g.error(m)}}async close(){return this.e||(this.e=this.c?this.c.trigger(()=>this.k(),0):this.k()),this.e}}e.FileStorage=b;let k=class{constructor(d,m,p,c){this.a=new b(m.stateResource,d,p,c)}async init(){await this.a.init()}getItem(d,m){return this.a.getItem(d,m)}};k=Te([Ae(1,w.IEnvironmentService),Ae(2,P.ILogService),Ae(3,S.IFileService)],k),e.StateReadonlyService=k;class I extends k{setItem(d,m){this.a.setItem(d,m)}setItems(d){this.a.setItems(d)}removeItem(d){this.a.removeItem(d)}close(){return this.a.close()}}e.StateService=I}),define(be[115],Ee([1,0,3,28,4,21]),function(oe,e,E,A,l,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function S(b){if(E.platform===2&&/^penguin(\.|$)/i.test(b))return"chromebook"}async function P(b,k,I,v,d,m,p,c,h,g){const f=Object.create(null);f["common.machineId"]=p,f.sessionID=(0,w.generateUuid)()+Date.now(),f.commitHash=d,f.version=m,f["common.platformVersion"]=(k||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),f["common.platform"]=(0,E.PlatformToString)(E.platform),f["common.nodePlatform"]=A.platform,f["common.nodeArch"]=v,f["common.product"]=g||"desktop",c&&(f["common.msftInternal"]=c);let D=0;const R=Date.now();Object.defineProperties(f,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-R,enumerable:!0},"common.sequence":{get:()=>D++,enumerable:!0}}),E.isLinuxSnap&&(f["common.snap"]="true");const t=S(I);t&&(f["common.platformDetail"]=t);try{const r=await b.readFile(l.URI.file(h));f["common.source"]=r.value.toString().slice(0,30)}catch{}return f}e.resolveCommonProperties=P;function y(b){const k=A.env.USERDNSDOMAIN;if(!k)return!1;const I=k.toLowerCase();return b.some(v=>I===v)}e.verifyMicrosoftInternalDomain=y}),define(be[233],Ee([1,0,18,9,2,23,16]),function(oe,e,E,A,l,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ErrorEvent=void 0;var P;(function(b){function k(I,v){return I.callstack<v.callstack?-1:I.callstack>v.callstack?1:0}b.compare=k})(P=e.ErrorEvent||(e.ErrorEvent={}));class y{constructor(k,I=y.ERROR_FLUSH_TIMEOUT){this.f=-1,this.g=[],this.h=new l.DisposableStore,this.c=k,this.d=I;const v=A.errorHandler.addListener(d=>this.j(d));this.h.add((0,l.toDisposable)(v)),this.i()}dispose(){clearTimeout(this.f),this.l(),this.h.dispose()}i(){}j(k){if(!k||(k.detail&&k.detail.stack&&(k=k.detail),A.ErrorNoTelemetry.isErrorNoTelemetry(k)||k instanceof S.FileOperationError||k?.message?.includes("Unable to read file")))return;const I=Array.isArray(k.stack)?k.stack.join(`
`):k.stack,v=k.message?k.message:(0,w.safeStringify)(k);!I||this.k({msg:v,callstack:I})}k(k){const I=(0,E.binarySearch)(this.g,k,P.compare);I<0?(k.count=1,this.g.splice(~I,0,k)):(this.g[I].count||(this.g[I].count=0),this.g[I].count+=1),this.f===-1&&(this.f=setTimeout(()=>{this.l(),this.f=-1},this.d))}l(){for(const k of this.g)this.c.publicLogError2("UnhandledError",k);this.g.length=0}}y.ERROR_FLUSH_TIMEOUT=5*1e3,e.default=y}),define(be[234],Ee([1,0,2]),function(oe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerTelemetryChannel=void 0;class A extends E.Disposable{constructor(w,S){super(),this.a=w,this.b=S}async call(w,S,P){switch(S){case"updateTelemetryLevel":{const{telemetryLevel:y}=P;return this.a.updateInjectedTelemetryLevel(y)}case"logTelemetry":{const{eventName:y,data:b}=P;return this.b?this.b.log(y,b):Promise.resolve()}case"flushTelemetry":return this.b?this.b.flush():Promise.resolve();case"ping":return}throw new Error(`IPC Command ${S} not found`)}listen(w,S,P){throw new Error("Not supported")}dispose(){this.a.updateInjectedTelemetryLevel(0),super.dispose()}}e.ServerTelemetryChannel=A}),define(be[31],Ee([1,0,5]),function(oe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,E.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,E.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var A;(function(w){w[w.NONE=0]="NONE",w[w.CRASH=1]="CRASH",w[w.ERROR=2]="ERROR",w[w.USAGE=3]="USAGE"})(A=e.TelemetryLevel||(e.TelemetryLevel={}));var l;(function(w){w.OFF="off",w.CRASH="crash",w.ERROR="error",w.ON="all"})(l=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(be[235],Ee([1,0,29,14,71,13,7,3,4,96,22,100,209,16,26,31]),function(oe,e,E,A,l,w,S,P,y,b,k,I,v,d,m,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const c=new Map;async function h(t,r){const i=`${t}::${r.join(":")}`,n=c.get(i);if(n)return n;const o=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],u=new Map,a=new Map,s=2e4;function C(O,W,X,se){const fe=W.substring(O.length+1);return A.Promises.withAsyncBody(async ce=>{let V;try{V=await k.Promises.readdir(W,{withFileTypes:!0})}catch{ce();return}if(se.count>=s){se.count+=V.length,se.maxReached=!0,ce();return}let T=V.length;if(T===0){ce();return}let z=V;se.count+V.length>s&&(se.maxReached=!0,T=s-se.count,z=V.slice(0,T)),se.count+=V.length;for(const he of z)if(he.isDirectory()){if(X.includes(he.name)||await C(O,(0,S.join)(W,he.name),X,se),--T===0){ce();return}}else{const H=he.name.lastIndexOf(".");if(H>=0){const q=he.name.substring(H+1);q&&u.set(q,(u.get(q)??0)+1)}for(const q of o)q.relativePathPattern?.test(fe)!==!1&&q.filePattern.test(he.name)&&a.set(q.tag,(a.get(q.tag)??0)+1);if(--T===0){ce();return}}})}const L=A.Promises.withAsyncBody(async O=>{const W={count:0,maxReached:!1};await C(t,t,r,W);const X=await D(t);O({configFiles:g(a),fileTypes:g(u),fileCount:W.count,maxFilesReached:W.maxReached,launchConfigFiles:X})});return c.set(i,L),L}e.collectWorkspaceStats=h;function g(t){return Array.from(t.entries(),([r,i])=>({name:r,count:i})).sort((r,i)=>i.count-r.count)}function f(){const t={os:`${E.type()} ${E.arch()} ${E.release()}`,memory:`${(E.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(E.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(b.virtualMachineHint.value()*100)}%`},r=E.cpus();return r&&r.length>0&&(t.cpus=`${r[0].model} (${r.length} x ${r[0].speed})`),t}e.getMachineInfo=f;async function D(t){try{const r=new Map,i=(0,S.join)(t,".vscode","launch.json"),n=await k.Promises.readFile(i),o=[],u=(0,l.parse)(n.toString(),o);if(o.length)return console.log(`Unable to parse ${i}`),[];if((0,l.getNodeType)(u)==="object"&&u.configurations)for(const a of u.configurations){const s=a.type;s&&(r.has(s)?r.set(s,r.get(s)+1):r.set(s,1))}return g(r)}catch{return[]}}e.collectLaunchConfigs=D;let R=class{constructor(r,i){this.c=r,this.d=i}f(r){const i=[];return i.push(`OS Version:       ${r.os}`),i.push(`CPUs:             ${r.cpus}`),i.push(`Memory (System):  ${r.memory}`),i.push(`VM:               ${r.vmHint}`),i.join(`
`)}g(r){const i=[];i.push(`Version:          ${this.d.nameShort} ${this.d.version} (${this.d.commit||"Commit unknown"}, ${this.d.date||"Date unknown"})`),i.push(`OS Version:       ${E.type()} ${E.arch()} ${E.release()}`);const n=E.cpus();return n&&n.length>0&&i.push(`CPUs:             ${n[0].model} (${n.length} x ${n[0].speed})`),i.push(`Memory (System):  ${(E.totalmem()/d.ByteSize.GB).toFixed(2)}GB (${(E.freemem()/d.ByteSize.GB).toFixed(2)}GB free)`),P.isWindows||i.push(`Load (avg):       ${E.loadavg().map(o=>Math.round(o)).join(", ")}`),i.push(`VM:               ${Math.round(b.virtualMachineHint.value()*100)}%`),i.push(`Screen Reader:    ${r.screenReader?"yes":"no"}`),i.push(`Process Argv:     ${r.mainArguments.join(" ")}`),i.push(`GPU Status:       ${this.j(r.gpuFeatureStatus)}`),i.join(`
`)}async getPerformanceInfo(r,i){return Promise.all([(0,I.listProcesses)(r.mainPID),this.k(r)]).then(async n=>{let[o,u]=n,a=this.m(r,o);return i.forEach(s=>{if((0,v.isRemoteDiagnosticError)(s))a+=`
${s.errorMessage}`,u+=`
${s.errorMessage}`;else if(a+=`

Remote: ${s.hostName}`,s.processes&&(a+=`
${this.m(r,s.processes)}`),s.workspaceMetadata){u+=`
|  Remote: ${s.hostName}`;for(const C of Object.keys(s.workspaceMetadata)){const L=s.workspaceMetadata[C];let O=`${L.fileCount} files`;L.maxFilesReached&&(O=`more than ${O}`),u+=`|    Folder (${C}): ${O}`,u+=this.h(L)}}}),{processInfo:a,workspaceInfo:u}})}async getSystemInfo(r,i){const{memory:n,vmHint:o,os:u,cpus:a}=f(),s={os:u,memory:n,cpus:a,vmHint:o,processArgs:`${r.mainArguments.join(" ")}`,gpuStatus:r.gpuFeatureStatus,screenReader:`${r.screenReader?"yes":"no"}`,remoteData:i};return P.isWindows||(s.load=`${E.loadavg().map(C=>Math.round(C)).join(", ")}`),P.isLinux&&(s.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(s)}async getDiagnostics(r,i){const n=[];return(0,I.listProcesses)(r.mainPID).then(async o=>(n.push(""),n.push(this.g(r)),n.push(""),n.push(this.m(r,o)),r.windows.some(u=>u.folderURIs&&u.folderURIs.length>0&&!u.remoteAuthority)&&(n.push(""),n.push("Workspace Stats: "),n.push(await this.k(r))),i.forEach(u=>{if((0,v.isRemoteDiagnosticError)(u))n.push(`
${u.errorMessage}`);else if(n.push(`

`),n.push(`Remote:           ${u.hostName}`),n.push(this.f(u.machineInfo)),u.processes&&n.push(this.m(r,u.processes)),u.workspaceMetadata)for(const a of Object.keys(u.workspaceMetadata)){const s=u.workspaceMetadata[a];let C=`${s.fileCount} files`;s.maxFilesReached&&(C=`more than ${C}`),n.push(`Folder (${a}): ${C}`),n.push(this.h(s))}}),n.push(""),n.push(""),n.join(`
`)))}h(r){const i=[];let o=0;const u=(L,O)=>{const W=` ${L}(${O})`;o+W.length>60?(i.push(a),a="|                 ",o=a.length):o+=W.length,a+=W};let a="|      File types:";const s=10,C=r.fileTypes.length>s?s:r.fileTypes.length;for(let L=0;L<C;L++){const O=r.fileTypes[L];u(O.name,O.count)}if(i.push(a),r.configFiles.length>=0&&(a="|      Conf files:",o=0,r.configFiles.forEach(L=>{u(L.name,L.count)}),i.push(a)),r.launchConfigFiles.length>0){let L="|      Launch Configs:";r.launchConfigFiles.forEach(O=>{L+=O.count>1?` ${O.name}(${O.count})`:` ${O.name}`}),i.push(L)}return i.join(`
`)}j(r){const i=Math.max(...Object.keys(r).map(n=>n.length));return Object.keys(r).map(n=>`${n}:  ${" ".repeat(i-n.length)}  ${r[n]}`).join(`
                  `)}k(r){const i=[],n=[];return r.windows.forEach(o=>{o.folderURIs.length===0||!!o.remoteAuthority||(i.push(`|  Window (${o.title})`),o.folderURIs.forEach(u=>{const a=y.URI.revive(u);if(a.scheme===w.Schemas.file){const s=a.fsPath;n.push(h(s,["node_modules",".git"]).then(C=>{let L=`${C.fileCount} files`;C.maxFilesReached&&(L=`more than ${L}`),i.push(`|    Folder (${(0,S.basename)(s)}): ${L}`),i.push(this.h(C))}).catch(C=>{i.push(`|      Error: Unable to collect workspace stats for folder ${s} (${C.toString()})`)}))}else i.push(`|    Folder (${a.toString()}): Workspace stats not available.`)}))}),Promise.all(n).then(o=>i.join(`
`)).catch(o=>`Unable to collect workspace stats: ${o}`)}m(r,i){const n=new Map;r.windows.forEach(u=>n.set(u.pid,u.title));const o=[];return o.push("CPU %	Mem MB	   PID	Process"),i&&this.n(r.mainPID,n,o,i,0),o.join(`
`)}n(r,i,n,o,u){const a=u===0;let s;a?s=o.pid===r?`${this.d.applicationName} main`:"remote agent":(s=`${"  ".repeat(u)} ${o.name}`,o.name==="window"&&(s=`${s} (${i.get(o.pid)})`));const C=process.platform==="win32"?o.mem:E.totalmem()*(o.mem/100);n.push(`${o.load.toFixed(0).padStart(5," ")}	${(C/d.ByteSize.MB).toFixed(0).padStart(6," ")}	${o.pid.toFixed(0).padStart(6," ")}	${s}`),Array.isArray(o.children)&&o.children.forEach(L=>this.n(r,i,n,L,u+1))}async getWorkspaceFileExtensions(r){const i=new Set;for(const{uri:n}of r.folders){const o=y.URI.revive(n);if(o.scheme!==w.Schemas.file)continue;const u=o.fsPath;try{(await h(u,["node_modules",".git"])).fileTypes.forEach(s=>i.add(s.name))}catch{}}return{extensions:[...i]}}async reportWorkspaceStats(r){for(const{uri:i}of r.folders){const n=y.URI.revive(i);if(n.scheme!==w.Schemas.file)continue;const o=n.fsPath;try{const u=await h(o,["node_modules",".git"]);this.c.publicLog2("workspace.stats",{"workspace.id":r.telemetryId,rendererSessionId:r.rendererSessionId}),u.fileTypes.forEach(a=>{this.c.publicLog2("workspace.stats.file",{rendererSessionId:r.rendererSessionId,type:a.name,count:a.count})}),u.launchConfigFiles.forEach(a=>{this.c.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:r.rendererSessionId,type:a.name,count:a.count})}),u.configFiles.forEach(a=>{this.c.publicLog2("workspace.stats.configFiles",{rendererSessionId:r.rendererSessionId,type:a.name,count:a.count})})}catch{}}}};R=Te([Ae(0,p.ITelemetryService),Ae(1,m.IProductService)],R),e.DiagnosticsService=R}),define(be[37],Ee([1,0,23,8,6,24,53,115,31]),function(oe,e,E,A,l,w,S,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogChannelId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class b{constructor(o){this.value=o}}e.TelemetryTrustedValue=b;class k{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(o,u){return Promise.resolve(void 0)}publicLog2(o,u){return this.publicLog(o,u)}publicLogError(o,u){return Promise.resolve(void 0)}publicLogError2(o,u){return this.publicLogError(o,u)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=k,e.NullTelemetryService=new k;class I{async publicLog(o,u,a){}async publicLogError(o,u,a){}}e.NullEndpointTelemetryService=I,e.telemetryLogChannelId="telemetryLog",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function v(n,o){return l.Event.debounce(o.onDidChangeConfiguration,(a,s)=>{const C=a?new Set([...a.affectedKeys,...s.affectedKeys]):s.affectedKeys;return{...s,affectedKeys:C}},1e3,!0)(a=>{a.source!==7&&n.publicLog2("updateConfiguration",{configurationSource:(0,w.ConfigurationTargetToString)(a.source),configurationKeys:Array.from(a.affectedKeys)})})}e.configurationTelemetry=v;function d(n,o){return!o.isBuilt&&!o.disableTelemetry?!0:!(o.disableTelemetry||!n.enableTelemetry||o.extensionTestsLocationURI)}e.supportsTelemetry=d;function m(n,o){return!(o.isBuilt||o.disableTelemetry||n.enableTelemetry&&n.aiConfig?.ariaKey)}e.isLoggingOnly=m;function p(n){const o=n.getValue(y.TELEMETRY_SETTING_ID),u=n.getValue(y.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(n.getValue(y.TELEMETRY_OLD_SETTING_ID)===!1||u===!1)return 0;switch(o??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=p;function c(n){const o={},u={},a={};f(n,a);for(let s in a){s=s.length>150?s.substr(s.length-149):s;const C=a[s];typeof C=="number"?u[s]=C:typeof C=="boolean"?u[s]=C?1:0:typeof C=="string"?(C.length>8192&&console.warn(`Telemetry property: ${s} has been trimmed to 8192, the original length is ${C.length}`),o[s]=C.substring(0,8191)):typeof C<"u"&&C!==null&&(o[s]=C)}return{properties:o,measurements:u}}e.validateTelemetryData=c;const h=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function g(n){if(!n)return"none";const o=(0,S.getRemoteName)(n);return h.has(o)?o:"other"}e.cleanRemoteAuthority=g;function f(n,o,u=0,a){if(!!n)for(const s of Object.getOwnPropertyNames(n)){const C=n[s],L=a?a+s:s;Array.isArray(C)?o[L]=(0,E.safeStringify)(C):C instanceof Date?o[L]=C.toISOString():(0,A.isObject)(C)?u<2?f(C,o,u+1,L+"."):o[L]=(0,E.safeStringify)(C):o[L]=C}}function D(n,o){const u=n.msftInternalDomains||[],a=o.getValue("telemetry.internalTesting");return(0,P.verifyMicrosoftInternalDomain)(u)||a}e.isInternalTelemetry=D;function R(n){return[n.appRoot,n.extensionsPath,n.userHome.fsPath,n.tmpDir.fsPath,n.userDataPath]}e.getPiiPathsFromEnvironment=R;function t(n,o){if(!n||!n.includes("/")&&!n.includes("\\"))return n;let u=n;const a=[];for(const O of o)for(;;){const W=O.exec(n);if(!W)break;a.push([W.index,O.lastIndex])}const s=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,C=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let L=0;for(u="";;){const O=C.exec(n);if(!O)break;const W=a.some(([X,se])=>O.index<se&&X<C.lastIndex);!s.test(O[0])&&!W&&(u+=n.substring(L,O.index)+"<REDACTED: user-file-path>",L=C.lastIndex)}return L<n.length&&(u+=n.substr(L)),u}function r(n){if(!n)return n;const o=n.toLowerCase(),u=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const a of u)if(a.regex.test(o))return`<REDACTED: ${a.label}>`;return n}function i(n,o){return(0,E.cloneAndChange)(n,u=>{if(u instanceof b)return u.value;if(typeof u=="string"){let a=u.replaceAll("%20"," ");a=t(a,o);for(const s of o)a=a.replace(s,"");return a=r(a),a}})}e.cleanData=i}),define(be[35],Ee([1,0,17,30,34,3,4,9,28,37]),function(oe,e,E,A,l,w,S,P,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function k(i,n){return i.uuid&&n.uuid?i.uuid===n.uuid:i.id===n.id?!0:(0,E.compareIgnoreCase)(i.id,n.id)===0}e.areSameExtensions=k;const I=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class v{static create(n){const o=n.manifest?n.manifest.version:n.version,u=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new v(n.identifier,o,u)}static parse(n){const o=I.exec(n);return o&&o[1]&&o[2]?new v({id:o[1]},o[2],o[4]||void 0):null}constructor(n,o,u="undefined"){this.version=o,this.targetPlatform=u,this.id=n.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof v?k(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.ExtensionKey=v;const d=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function m(i){const n=d.exec(i);return n&&n[1]?[c(n[1]),n[2]]:[c(i),void 0]}e.getIdAndVersion=m;function p(i,n){return`${i}.${n}`}e.getExtensionId=p;function c(i){return i.toLocaleLowerCase()}e.adoptToGalleryExtensionId=c;function h(i,n){return c(p(i,n))}e.getGalleryExtensionId=h;function g(i,n){const o=[],u=a=>{for(const s of o)if(s.some(C=>k(n(C),n(a))))return s;return null};for(const a of i){const s=u(a);s?s.push(a):o.push([a])}return o}e.groupByExtension=g;function f(i){return{id:i.identifier.id,name:i.manifest.name,galleryId:null,publisherId:i.publisherId,publisherName:i.manifest.publisher,publisherDisplayName:i.publisherDisplayName,dependencies:i.manifest.extensionDependencies&&i.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=f;function D(i){return{id:new b.TelemetryTrustedValue(i.identifier.id),name:new b.TelemetryTrustedValue(i.name),galleryId:i.identifier.uuid,publisherId:i.publisherId,publisherName:i.publisher,publisherDisplayName:i.publisherDisplayName,isPreReleaseVersion:i.properties.isPreReleaseVersion,dependencies:!!(i.properties.dependencies&&i.properties.dependencies.length>0),isSigned:i.isSigned,...i.telemetryData}}e.getGalleryExtensionTelemetryData=D,e.BetterMergeId=new l.ExtensionIdentifier("pprice.better-merge");function R(i,n){const o=[],u=n.manifest.extensionDependencies?.slice(0)??[];for(;u.length;){const a=u.shift();if(a&&o.every(s=>!k(s.identifier,{id:a}))){const s=i.filter(C=>k(C.identifier,{id:a}));s.length===1&&(o.push(s[0]),u.push(...s[0].manifest.extensionDependencies?.slice(0)??[]))}}return o}e.getExtensionDependencies=R;async function t(i,n){if(!w.isLinux)return!1;let o;try{o=(await i.readFile(S.URI.file("/etc/os-release"))).value.toString()}catch{try{o=(await i.readFile(S.URI.file("/usr/lib/os-release"))).value.toString()}catch(a){n.debug("Error while getting the os-release file.",(0,P.getErrorMessage)(a))}}return!!o&&(o.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function r(i,n){const o=await t(i,n),u=(0,A.getTargetPlatform)(o?"alpine":w.platform,y.arch);return n.debug("ComputeTargetPlatform:",u),u}e.computeTargetPlatform=r}),define(be[116],Ee([1,0,19,9,13,20,50,4,173,30,35,34]),function(oe,e,E,A,l,w,S,P,y,b,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementCLI=void 0;const v=c=>(0,y.localize)(0,null,c),d=(0,y.localize)(1,null,"ms-dotnettools.csharp");function m(c,h){return h?`${c.publisher}.${c.name}@${c.version}`:`${c.publisher}.${c.name}`}let p=class{constructor(h,g){this.a=h,this.b=g}get d(){}async listExtensions(h,g,f,D=console){let R=await this.a.getInstalled(1,f);const t=I.EXTENSION_CATEGORIES.map(i=>i.toLowerCase());if(g&&g!==""){if(t.indexOf(g.toLowerCase())<0){D.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}R=R.filter(i=>i.manifest.categories?i.manifest.categories.map(o=>o.toLowerCase()).indexOf(g.toLowerCase())>-1:!1)}else if(g===""){D.log("Possible Categories: "),t.forEach(i=>{D.log(i)});return}this.d&&D.log((0,y.localize)(2,null,this.d)),R=R.sort((i,n)=>i.identifier.id.localeCompare(n.identifier.id));let r;for(const i of R)r!==i.identifier.id&&(r=i.identifier.id,D.log(m(i.manifest,h)))}async installExtensions(h,g,f,D,R=console){const t=[],r=[];h.length&&R.log(this.d?(0,y.localize)(3,null,this.d):(0,y.localize)(4,null));const i=await this.a.getInstalled(1,f.profileLocation),n=(s,C)=>{const L=i.find(O=>(0,k.areSameExtensions)(O.identifier,{id:s}));if(L){if(!D&&(!C||C==="prerelease"&&L.preRelease))return R.log((0,y.localize)(5,null,s,L.manifest.version,s)),!1;if(C&&L.manifest.version===C)return R.log((0,y.localize)(6,null,`${s}@${C}`)),!1}return!0},o=(s,C,L)=>{a.push({id:s,version:C!=="prerelease"?C:void 0,installOptions:{...f,isBuiltin:L,installPreReleaseVersion:C==="prerelease"||f.installPreReleaseVersion}})},u=[],a=[];for(const s of h)if(s instanceof P.URI)u.push(s);else{const[C,L]=(0,k.getIdAndVersion)(s);n(C,L)&&o(C,L,!1)}for(const s of g){const[C,L]=(0,k.getIdAndVersion)(s);n(C,L)&&o(C,L,!0)}if(u.length&&await Promise.all(u.map(async s=>{try{const C=await this.f(s,{...f,isBuiltin:!1},D,R);C&&r.push(C)}catch(C){R.error(C.message||C.stack||C),t.push(s.toString())}})),a.length){const s=await this.g(a);await Promise.all(a.map(async C=>{const L=s.get(C.id.toLowerCase());if(L)try{const O=await this.h(C,L,i,D,R);O&&r.push(O)}catch(O){R.error(O.message||O.stack||O),t.push(C.id)}else R.error(`${v(C.version?`${C.id}@${C.version}`:C.id)}
${d}`),t.push(C.id)}))}if(t.length)throw new Error((0,y.localize)(7,null,t.join(", ")))}async f(h,g,f,D){const R=await this.a.getManifest(h);if(!R)throw new Error("Invalid vsix");if(await this.k(R,f,g.profileLocation,D))try{return await this.a.install(h,g),D.log((0,y.localize)(8,null,(0,w.basename)(h))),R}catch(r){if((0,A.isCancellationError)(r))return D.log((0,y.localize)(9,null,(0,w.basename)(h))),null;throw r}return null}async g(h){const g=new Map,f=h.some(R=>R.installOptions.installPreReleaseVersion),D=await this.b.getExtensions(h.map(R=>({...R,preRelease:f})),E.CancellationToken.None);for(const R of D)g.set(R.identifier.id.toLowerCase(),R);return g}async h({id:h,version:g,installOptions:f},D,R,t,r){const i=await this.b.getManifest(D,E.CancellationToken.None);if(i&&!this.j(i,r))return null;const n=R.find(o=>(0,k.areSameExtensions)(o.identifier,D.identifier));if(n){if(D.version===n.manifest.version)return r.log((0,y.localize)(10,null,g?`${h}@${g}`:h)),null;r.log((0,y.localize)(11,null,h,D.version))}try{f.isBuiltin?r.log(g?(0,y.localize)(12,null,h,g):(0,y.localize)(13,null,h)):r.log(g?(0,y.localize)(14,null,h,g):(0,y.localize)(15,null,h));const o=await this.a.installFromGallery(D,{...f,installGivenVersion:!!g});return r.log((0,y.localize)(16,null,h,o.manifest.version)),i}catch(o){if((0,A.isCancellationError)(o))return r.log((0,y.localize)(17,null,h)),null;throw o}}j(h,g){return!0}async k(h,g,f,D){const R={id:(0,k.getGalleryExtensionId)(h.publisher,h.name)},r=(await this.a.getInstalled(1,f)).find(i=>(0,k.areSameExtensions)(R,i.identifier)&&(0,S.gt)(i.manifest.version,h.version));return r&&!g?(D.log((0,y.localize)(18,null,r.identifier.id,r.manifest.version,h.version)),!1):this.j(h,D)}async uninstallExtensions(h,g,f,D=console){const R=async r=>{if(r instanceof P.URI){const i=await this.a.getManifest(r);return m(i)}return r},t=[];for(const r of h){const i=await R(r),o=(await this.a.getInstalled(void 0,f)).filter(u=>(0,k.areSameExtensions)(u.identifier,{id:i}));if(!o.length)throw new Error(`${this.l(i)}
${d}`);if(o.some(u=>u.type===0)){D.log((0,y.localize)(19,null,i));return}if(!g&&o.some(u=>u.isBuiltin)){D.log((0,y.localize)(20,null,i));return}D.log((0,y.localize)(21,null,i));for(const u of o)await this.a.uninstall(u,{profileLocation:f}),t.push(u);this.d?D.log((0,y.localize)(22,null,i,this.d)):D.log((0,y.localize)(23,null,i))}}async locateExtension(h,g=console){const f=await this.a.getInstalled();h.forEach(D=>{f.forEach(R=>{if(R.identifier.id===D&&R.location.scheme===l.Schemas.file){g.log(R.location.fsPath);return}})})}l(h){return this.d?(0,y.localize)(24,null,h,this.d):(0,y.localize)(25,null,h)}};p=Te([Ae(0,b.IExtensionManagementService),Ae(1,b.IExtensionGalleryService)],p),e.ExtensionManagementCLI=p}),define(be[236],Ee([1,0,6,2,27,35,34]),function(oe,e,E,A,l,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;class P extends A.Disposable{constructor(b,k,I,v,d,m,p){super(),this.f=b,this.g=k,this.h=I,this.i=v,this.j=d,this.k=m,this.l=p,this.a=this.B(new E.Emitter),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new A.DisposableMap),this.m().then(null,c=>p.error(c))}async m(){await this.g.initializeDefaultProfileExtensions(),await this.p(this.h.profiles,[]),this.n(),await this.C()}n(){this.B(this.h.onDidChangeProfiles(b=>this.p(b.added,b.removed))),this.B(this.i.onAddExtensions(b=>this.r(b))),this.B(this.i.onDidAddExtensions(b=>this.s(b))),this.B(this.i.onRemoveExtensions(b=>this.t(b))),this.B(this.i.onDidRemoveExtensions(b=>this.u(b))),this.B(this.k.onDidFilesChange(b=>this.v(b)))}async p(b,k){try{await Promise.all(k.map(I=>(this.c.deleteAndDispose(I.id),this.z(I.extensionsResource)))),b.length&&await Promise.all(b.map(I=>(this.c.set(I.id,(0,A.combinedDisposable)(this.k.watch(this.j.extUri.dirname(I.extensionsResource)),this.k.watch(I.extensionsResource))),this.y(I.extensionsResource))))}catch(I){throw this.l.error(I),I}}async r(b){for(const k of b.extensions)this.D(this.G(k.identifier,k.version),b.profileLocation)}async s(b){for(const k of b.extensions){const I=this.G(k.identifier,k.version);b.error?this.F(I,b.profileLocation):this.D(I,b.profileLocation)}}async t(b){for(const k of b.extensions)this.F(this.G(k.identifier,k.version),b.profileLocation)}async u(b){const k=[],I=[];for(const v of b.extensions){const d=this.G(v.identifier,v.version);b.error?this.D(d,b.profileLocation):(this.F(d,b.profileLocation),this.b.has(d)||(this.l.debug("Extension is removed from all profiles",v.identifier.id,v.version),I.push(this.f.scanInstalledExtensionAtLocation(v.location).then(m=>{m?k.push(m):this.l.info("Extension not found at the location",v.location.toString())},m=>this.l.error(m)))))}try{await Promise.all(I),k.length&&await this.C(k)}catch(v){this.l.error(v)}}v(b){for(const k of this.h.profiles)b.contains(k.extensionsResource,0,1)&&this.w(k.extensionsResource)}async w(b){const k=[],I=[],v=await this.i.scanProfileExtensions(b),d=new Set,m=new Set;for(const[p,c]of this.b)c.has(b)&&m.add(p);for(const p of v){const c=this.G(p.identifier,p.version);d.add(c),m.has(c)||(k.push(p.identifier),this.D(c,b))}for(const p of m)if(!d.has(p)){const c=this.H(p);c&&(I.push(c.identifier),this.F(p,b))}(k.length||I.length)&&this.a.fire({added:k.length?{extensions:k,profileLocation:b}:void 0,removed:I.length?{extensions:I,profileLocation:b}:void 0})}async y(b){const k=await this.i.scanProfileExtensions(b);for(const I of k)this.D(this.G(I.identifier,I.version),b)}async z(b){for(const k of[...this.b.keys()])this.F(k,b);await this.C()}async C(b){b||(b=(await this.f.scanAllUserInstalledExtensions()).filter(I=>!this.b.has(this.G(I.identifier,I.manifest.version)))),b.length&&await this.f.markAsUninstalled(...b)}D(b,k){let I=this.b.get(b);I||this.b.set(b,I=new l.ResourceSet(v=>this.j.extUri.getComparisonKey(v))),I.add(k)}F(b,k){const I=this.b.get(b);I&&I.delete(k),I?.size||this.b.delete(b)}G(b,k){return`${S.ExtensionIdentifier.toKey(b.id)}@${k}`}H(b){const[k,I]=(0,w.getIdAndVersion)(b);return I?{identifier:{id:k},version:I}:void 0}}e.ExtensionsWatcher=P}),define(be[237],Ee([1,0,206,37]),function(oe,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function l(w,S,P,y,b,k,I){const v={"X-Market-Client-Id":`VSCode ${w}`,"User-Agent":`VSCode ${w} (${S.nameShort})`};if((0,A.supportsTelemetry)(S,P)&&(0,A.getTelemetryLevel)(y)===3){const d=await(0,E.getServiceMachineId)(P,b,k),{machineId:m}=await I.getTelemetryInfo();v["X-Market-User-Id"]=d,v["VSCode-SessionId"]=m||d}return v}e.resolveMarketplaceHeaders=l}),define(be[117],Ee([1,0,118,18,14,2,13,7,22,25,30,35,10,78,4]),function(oe,e,E,A,l,w,S,P,y,b,k,I,v,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let p=class extends d.LanguagePackBaseService{constructor(f,D,R,t){super(R),this.h=f,this.i=t,this.g=this.B(new c(D,t)),this.h.registerParticipant({postInstall:async r=>this.j(r),postUninstall:async r=>this.k(r)})}async getBuiltInExtensionTranslationsUri(f,D){const t=(await this.g.getLanguagePacks())[D];if(!t){this.i.warn(`No language pack found for ${D}`);return}const r=t.translations[f];return r?m.URI.file(r):void 0}async getInstalledLanguages(){const f=await this.g.getLanguagePacks(),D=Object.keys(f).map(R=>{const t=f[R];return{...this.f(R,t.label),extensionId:t.extensions[0].extensionIdentifier.id}});return D.push(this.f("en","English")),D.sort((R,t)=>R.label.localeCompare(t.label)),D}async j(f){f&&f.manifest&&f.manifest.contributes&&f.manifest.contributes.localizations&&f.manifest.contributes.localizations.length&&(this.i.info("Adding language packs from the extension",f.identifier.id),await this.update())}async k(f){const D=await this.g.getLanguagePacks();Object.keys(D).some(R=>D[R]&&D[R].extensions.some(t=>(0,I.areSameExtensions)(t.extensionIdentifier,f.identifier)))&&(this.i.info("Removing language packs from the extension",f.identifier.id),await this.update())}async update(){const[f,D]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),R=await this.g.update(D);return!(0,A.equals)(Object.keys(f),Object.keys(R))}};p=Te([Ae(0,k.IExtensionManagementService),Ae(1,b.INativeEnvironmentService),Ae(2,k.IExtensionGalleryService),Ae(3,v.ILogService)],p),e.NativeLanguagePackService=p;let c=class extends w.Disposable{constructor(f,D){super(),this.i=D,this.c={},this.f=(0,P.join)(f.userDataPath,"languagepacks.json"),this.g=new l.Queue}getLanguagePacks(){return this.g.size||!this.h?this.m().then(()=>this.c):Promise.resolve(this.c)}update(f){return this.m(D=>{Object.keys(D).forEach(R=>delete D[R]),this.j(D,...f)}).then(()=>this.c)}j(f,...D){for(const R of D)R&&R.manifest&&R.manifest.contributes&&R.manifest.contributes.localizations&&R.manifest.contributes.localizations.length&&this.k(f,R);Object.keys(f).forEach(R=>this.l(f[R]))}k(f,D){const R=D.identifier,t=D.manifest.contributes&&D.manifest.contributes.localizations?D.manifest.contributes.localizations:[];for(const r of t)if(D.location.scheme===S.Schemas.file&&h(r)){let i=f[r.languageId];i||(i={hash:"",extensions:[],translations:{},label:r.localizedLanguageName??r.languageName},f[r.languageId]=i);const n=i.extensions.filter(o=>(0,I.areSameExtensions)(o.extensionIdentifier,R))[0];n?n.version=D.manifest.version:i.extensions.push({extensionIdentifier:R,version:D.manifest.version});for(const o of r.translations)i.translations[o.id]=(0,P.join)(D.location.fsPath,o.path)}}l(f){if(f){const D=(0,E.createHash)("md5");for(const R of f.extensions)D.update(R.extensionIdentifier.uuid||R.extensionIdentifier.id).update(R.version);f.hash=D.digest("hex")}}m(f=()=>null){return this.g.queue(()=>{let D=null;return y.Promises.readFile(this.f,"utf8").then(void 0,R=>R.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(R)).then(R=>{try{return JSON.parse(R)}catch{return{}}}).then(R=>(D=f(R),R)).then(R=>{for(const r of Object.keys(R))R[r]||delete R[r];this.c=R,this.h=!0;const t=JSON.stringify(this.c);return this.i.debug("Writing language packs",t),y.Promises.writeFile(this.f,t)}).then(()=>D,R=>this.i.error(R))})}};c=Te([Ae(0,b.INativeEnvironmentService),Ae(1,v.ILogService)],c);function h(g){if(typeof g.languageId!="string"||!Array.isArray(g.translations)||g.translations.length===0)return!1;for(const f of g.translations)if(typeof f.id!="string"||typeof f.path!="string")return!1;return!(g.languageName&&typeof g.languageName!="string"||g.localizedLanguageName&&typeof g.localizedLanguageName!="string")}}),define(be[238],Ee([1,0,9,23,37]),function(oe,e,E,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const w="https://mobile.events.data.microsoft.com/OneCollector/1.0",S="https://mobile.events.data.microsoft.com/ping";async function P(b,k,I){const v=await new Promise((h,g)=>{oe(["@microsoft/1ds-core-js"],h,g)}),d=await new Promise((h,g)=>{oe(["@microsoft/1ds-post-js"],h,g)}),m=new v.AppInsightsCore,p=new d.PostChannel,c={instrumentationKey:b,endpointUrl:w,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[p]]};if(I){c.extensionConfig={};const h={alwaysUseXhrOverride:!0,httpXHROverride:I};c.extensionConfig[p.identifier]=h}return m.initialize(c,[]),m.addTelemetryInitializer(h=>{k&&(h.ext=h.ext??{},h.ext.utc=h.ext.utc??{},h.ext.utc.flags=8462029)}),m}class y{constructor(k,I,v,d,m){this.e=k,this.f=I,this.g=v,this.h=m,this.c=w,this.d=S,this.g||(this.g={}),typeof d=="function"?this.a=d():this.a=d,this.b=null}i(k){if(!!this.a){if(typeof this.a!="string"){k(this.a);return}this.b||(this.b=P(this.a,this.e,this.h)),this.b.then(I=>{k(I)},I=>{(0,E.onUnexpectedError)(I),console.error(I)})}}log(k,I){if(!this.a)return;I=(0,A.mixin)(I,this.g),I=(0,l.validateTelemetryData)(I);const v=this.f+"/"+k;try{this.i(d=>{d.pluginVersionString=I?.properties.version??"Unknown",d.track({name:v,baseData:{name:v,properties:I?.properties,measurements:I?.measurements}})})}catch{}}flush(){return this.a?new Promise(k=>{this.i(I=>{I.unload(!0,()=>{this.a=void 0,k(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=y}),define(be[239],Ee([1,0,2,23,3,17,187,24,52,51,26,40,31,37]),function(oe,e,E,A,l,w,S,P,y,b,k,I,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let m=class{constructor(h,g,f){this.k=g,this.l=f,this.d={},this.i=new E.DisposableStore,this.j=[],this.b=h.appenders,this.c=h.commonProperties||Promise.resolve({}),this.f=h.piiPaths||[],this.g=3,this.h=!!h.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const D of this.f)this.j.push(new RegExp((0,w.escapeRegExpCharacters)(D),"gi")),D.indexOf("\\")>=0&&this.j.push(new RegExp((0,w.escapeRegExpCharacters)(D.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(D=>{(D.affectsConfiguration(v.TELEMETRY_SETTING_ID)||D.affectsConfiguration(v.TELEMETRY_OLD_SETTING_ID)||D.affectsConfiguration(v.TELEMETRY_CRASH_REPORTER_SETTING_ID))&&this.m()}))}setExperimentProperty(h,g){this.d[h]=g}m(){let h=(0,d.getTelemetryLevel)(this.k);const g=this.l.enabledTelemetryLevels;if(g){this.h=this.sendErrorTelemetry?g.error:!1;const f=g.usage?3:g.error?2:0;h=Math.min(h,f)}this.g=h}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}async getTelemetryInfo(){const h=await this.c,g=h.sessionID,f=h["common.machineId"],D=h["common.firstSessionDate"],R=h["common.msftInternal"];return{sessionId:g,machineId:f,firstSessionDate:D,msftInternal:R}}dispose(){this.i.dispose()}n(h,g,f){return this.g<g?Promise.resolve(void 0):this.c.then(D=>{f=(0,A.mixin)(f,this.d),f=(0,d.cleanData)(f,this.j),f=(0,A.mixin)(f,D),this.b.forEach(R=>R.log(h,f))},D=>{console.error(D)})}publicLog(h,g){return this.n(h,3,g)}publicLog2(h,g){return this.publicLog(h,g)}publicLogError(h,g){return this.h?this.n(h,2,g):Promise.resolve(void 0)}publicLogError2(h,g){return this.publicLogError(h,g)}};m.IDLE_START_EVENT_NAME="UserIdleStart",m.IDLE_STOP_EVENT_NAME="UserIdleStop",m=Te([Ae(1,P.IConfigurationService),Ae(2,k.IProductService)],m),e.TelemetryService=m;function p(){const c=(0,S.localize)(0,null,b.default.nameLong),h=b.default.privacyStatementUrl?(0,S.localize)(2,null,"https://aka.ms/vscode-telemetry",b.default.privacyStatementUrl):(0,S.localize)(1,null,"https://aka.ms/vscode-telemetry"),g=l.isWeb?"":(0,S.localize)(3,null),f=(0,S.localize)(4,null),D=(0,S.localize)(5,null),R=(0,S.localize)(6,null),t=(0,S.localize)(7,null),r=`
|       | ${f} | ${D} | ${R} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,i=(0,S.localize)(8,null);return`
${c} ${h} ${g}

&nbsp;

${t}
${r}

&nbsp;

${i}
`}I.Registry.as(y.Extensions.Configuration).registerConfiguration({id:v.TELEMETRY_SECTION_ID,order:1,type:"object",title:(0,S.localize)(9,null),properties:{[v.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,S.localize)(10,null),(0,S.localize)(11,null),(0,S.localize)(12,null),(0,S.localize)(13,null)],markdownDescription:p(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),I.Registry.as(y.Extensions.Configuration).registerConfiguration({id:v.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,S.localize)(14,null),properties:{[v.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:b.default.privacyStatementUrl?(0,S.localize)(16,null,b.default.nameLong,b.default.privacyStatementUrl):(0,S.localize)(15,null,b.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,S.localize)(17,null,`\`#${v.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(be[240],Ee([1,0,24,5,26,31,239,37]),function(oe,e,E,A,l,w,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IServerTelemetryService=e.ServerNullTelemetryService=e.ServerTelemetryService=void 0;let y=class extends S.TelemetryService{constructor(k,I,v,d){super(k,v,d),this.o=I}publicLog(k,I){return this.o<3?Promise.resolve(void 0):super.publicLog(k,I)}publicLog2(k,I){return this.publicLog(k,I)}publicLogError(k,I){return this.o<2?Promise.resolve(void 0):super.publicLogError(k,I)}publicLogError2(k,I){return this.publicLogError(k,I)}async updateInjectedTelemetryLevel(k){if(k===void 0)throw this.o=0,new Error("Telemetry level cannot be undefined. This will cause infinite looping!");this.o=this.o?Math.min(this.o,k):k,this.o===0&&this.dispose()}};y=Te([Ae(2,E.IConfigurationService),Ae(3,l.IProductService)],y),e.ServerTelemetryService=y,e.ServerNullTelemetryService=new class extends P.NullTelemetryServiceShape{async updateInjectedTelemetryLevel(){}},e.IServerTelemetryService=(0,A.refineServiceDecorator)(w.ITelemetryService)}),define(be[241],Ee([1,0,242,238]),function(oe,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemAppender=void 0;class l extends A.AbstractOneDataSystemAppender{constructor(S,P,y,b){const k={sendPOST:(I,v)=>{const d={method:"POST",headers:{...I.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(I.data)}};try{const m=E.request(I.urlString,d,p=>{p.on("data",function(c){v(p.statusCode??200,p.headers,c.toString())}),p.on("error",function(c){v(0,{})})});m.write(I.data),m.end()}catch{v(0,{})}}};super(S,P,y,b,k)}}e.OneDataSystemAppender=l}),define(be[243],Ee([1,0,9,233]),function(oe,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class l extends A.default{i(){(0,E.setUnexpectedErrorHandler)(P=>console.error(P));const S=[];process.on("unhandledRejection",(P,y)=>{S.push(y),setTimeout(()=>{const b=S.indexOf(y);b>=0&&y.catch(k=>{S.splice(b,1),(0,E.isCancellationError)(k)||(console.warn(`rejected promise not handled within 1 second: ${k}`),k.stack&&console.warn(`stack trace: ${k.stack}`),P&&(0,E.onUnexpectedError)(P))})},1e3)}),process.on("rejectionHandled",P=>{const y=S.indexOf(P);y>=0&&S.splice(y,1)}),process.on("uncaughtException",P=>{(0,E.isSigPipeError)(P)||(0,E.onUnexpectedError)(P)})}}e.default=l}),define(be[119],Ee([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=void 0;var E;(function(A){A[A.Replace=1]="Replace",A[A.Append=2]="Append",A[A.Prepend=3]="Prepend"})(E=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}))}),define(be[120],Ee([1,0,3,119]),function(oe,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MergedEnvironmentVariableCollection=void 0;class l{constructor(y){this.collections=y,this.map=new Map,y.forEach((b,k)=>{const I=b.map.entries();let v=I.next();for(;!v.done;){const d=v.value[0];let m=this.map.get(d);if(m||(m=[],this.map.set(d,m)),m.length>0&&m[0].type===A.EnvironmentVariableMutatorType.Replace){v=I.next();continue}const p=v.value[1];m.unshift({extensionIdentifier:k,value:p.value,type:p.type}),v=I.next()}})}async applyToProcessEnvironment(y,b){let k;E.isWindows&&(k={},Object.keys(y).forEach(I=>k[I.toLowerCase()]=I));for(const[I,v]of this.map){const d=E.isWindows&&k[I.toLowerCase()]||I;for(const m of v){const p=b?await b(m.value):m.value;switch(m.type){case A.EnvironmentVariableMutatorType.Append:y[d]=(y[d]||"")+p;break;case A.EnvironmentVariableMutatorType.Prepend:y[d]=p+(y[d]||"");break;case A.EnvironmentVariableMutatorType.Replace:y[d]=p;break}}}}diff(y){const b=new Map,k=new Map,I=new Map;if(y.map.forEach((v,d)=>{const m=this.map.get(d),p=w(v,m);p&&b.set(d,p)}),this.map.forEach((v,d)=>{const m=y.map.get(d),p=w(v,m);p&&I.set(d,p)}),this.map.forEach((v,d)=>{const m=y.map.get(d),p=S(v,m);p&&k.set(d,p)}),!(b.size===0&&k.size===0&&I.size===0))return{added:b,changed:k,removed:I}}}e.MergedEnvironmentVariableCollection=l;function w(P,y){if(!y)return P;const b=new Set;y.forEach(I=>b.add(I.extensionIdentifier));const k=[];return P.forEach(I=>{b.has(I.extensionIdentifier)||k.push(I)}),k.length===0?void 0:k}function S(P,y){if(!y)return;const b=new Map;y.forEach(I=>b.set(I.extensionIdentifier,I));const k=[];return P.forEach(I=>{const v=b.get(I.extensionIdentifier);v&&(I.type!==v.type||I.value!==v.value)&&k.push(v)}),k.length===0?void 0:k}}),define(be[81],Ee([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function E(S){return[...S.entries()]}e.serializeEnvironmentVariableCollection=E;function A(S){return new Map(S)}e.deserializeEnvironmentVariableCollection=A;function l(S){return Array.from(S.entries()).map(P=>[P[0],E(P[1].map)])}e.serializeEnvironmentVariableCollections=l;function w(S){return new Map(S.map(P=>[P[0],{map:A(P[1])}]))}e.deserializeEnvironmentVariableCollections=w}),define(be[244],Ee([1,0,14,19,6,2,10]),function(oe,e,E,A,l,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let P=class extends w.Disposable{constructor(b,k){super(),this.h=k,this.a=0,this.c=new Map,this.f=new Map,this.g=this.B(new l.Emitter),this.onCreateRequest=this.g.event,this.b=b===void 0?15e3:b}createRequest(b){return new Promise((k,I)=>{const v=++this.a;this.c.set(v,k),this.g.fire({requestId:v,...b});const d=new A.CancellationTokenSource;(0,E.timeout)(this.b,d.token).then(()=>I(`Request ${v} timed out (${this.b}ms)`)),this.f.set(v,[(0,w.toDisposable)(()=>d.cancel())])})}acceptReply(b,k){const I=this.c.get(b);I?(this.c.delete(b),(0,w.dispose)(this.f.get(b)||[]),this.f.delete(b),I(k)):this.h.warn(`RequestStore#acceptReply was called without receiving a matching request ${b}`)}};P=Te([Ae(1,S.ILogService)],P),e.RequestStore=P}),define(be[121],Ee([1,0,5]),function(oe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalLogConstants=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var A;(function(f){f.Shell="terminal.integrated.shell.",f.ShellArgs="terminal.integrated.shellArgs.",f.DefaultProfile="terminal.integrated.defaultProfile.",f.Profiles="terminal.integrated.profiles."})(A=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var l;(function(f){f.ShellLinux="terminal.integrated.shell.linux",f.ShellMacOs="terminal.integrated.shell.osx",f.ShellWindows="terminal.integrated.shell.windows",f.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",f.AutomationShellLinux="terminal.integrated.automationShell.linux",f.AutomationShellMacOs="terminal.integrated.automationShell.osx",f.AutomationShellWindows="terminal.integrated.automationShell.windows",f.AutomationProfileLinux="terminal.integrated.automationProfile.linux",f.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",f.AutomationProfileWindows="terminal.integrated.automationProfile.windows",f.ShellArgsLinux="terminal.integrated.shellArgs.linux",f.ShellArgsMacOs="terminal.integrated.shellArgs.osx",f.ShellArgsWindows="terminal.integrated.shellArgs.windows",f.ProfilesWindows="terminal.integrated.profiles.windows",f.ProfilesMacOs="terminal.integrated.profiles.osx",f.ProfilesLinux="terminal.integrated.profiles.linux",f.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",f.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",f.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",f.UseWslProfiles="terminal.integrated.useWslProfiles",f.TabsDefaultColor="terminal.integrated.tabs.defaultColor",f.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",f.TabsEnabled="terminal.integrated.tabs.enabled",f.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",f.TabsHideCondition="terminal.integrated.tabs.hideCondition",f.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",f.TabsShowActions="terminal.integrated.tabs.showActions",f.TabsLocation="terminal.integrated.tabs.location",f.TabsFocusMode="terminal.integrated.tabs.focusMode",f.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",f.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",f.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",f.CopyOnSelection="terminal.integrated.copyOnSelection",f.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",f.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",f.FontFamily="terminal.integrated.fontFamily",f.FontSize="terminal.integrated.fontSize",f.LetterSpacing="terminal.integrated.letterSpacing",f.LineHeight="terminal.integrated.lineHeight",f.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",f.TabStopWidth="terminal.integrated.tabStopWidth",f.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",f.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",f.BellDuration="terminal.integrated.bellDuration",f.FontWeight="terminal.integrated.fontWeight",f.FontWeightBold="terminal.integrated.fontWeightBold",f.CursorBlinking="terminal.integrated.cursorBlinking",f.CursorStyle="terminal.integrated.cursorStyle",f.CursorWidth="terminal.integrated.cursorWidth",f.Scrollback="terminal.integrated.scrollback",f.DetectLocale="terminal.integrated.detectLocale",f.DefaultLocation="terminal.integrated.defaultLocation",f.GpuAcceleration="terminal.integrated.gpuAcceleration",f.TerminalTitleSeparator="terminal.integrated.tabs.separator",f.TerminalTitle="terminal.integrated.tabs.title",f.TerminalDescription="terminal.integrated.tabs.description",f.RightClickBehavior="terminal.integrated.rightClickBehavior",f.Cwd="terminal.integrated.cwd",f.ConfirmOnExit="terminal.integrated.confirmOnExit",f.ConfirmOnKill="terminal.integrated.confirmOnKill",f.EnableBell="terminal.integrated.enableBell",f.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",f.AllowChords="terminal.integrated.allowChords",f.AllowMnemonics="terminal.integrated.allowMnemonics",f.TabFocusMode="terminal.integrated.tabFocusMode",f.EnvMacOs="terminal.integrated.env.osx",f.EnvLinux="terminal.integrated.env.linux",f.EnvWindows="terminal.integrated.env.windows",f.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",f.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",f.ShowExitAlert="terminal.integrated.showExitAlert",f.SplitCwd="terminal.integrated.splitCwd",f.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",f.WordSeparators="terminal.integrated.wordSeparators",f.EnableFileLinks="terminal.integrated.enableFileLinks",f.UnicodeVersion="terminal.integrated.unicodeVersion",f.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",f.LocalEchoEnabled="terminal.integrated.localEchoEnabled",f.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",f.LocalEchoStyle="terminal.integrated.localEchoStyle",f.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",f.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",f.CustomGlyphs="terminal.integrated.customGlyphs",f.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",f.InheritEnv="terminal.integrated.inheritEnv",f.ShowLinkHover="terminal.integrated.showLinkHover",f.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",f.AutoReplies="terminal.integrated.autoReplies",f.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",f.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",f.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",f.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",f.ShellIntegrationSuggestEnabled="terminal.integrated.shellIntegration.suggestEnabled",f.SmoothScrolling="terminal.integrated.smoothScrolling"})(l=e.TerminalSettingId||(e.TerminalSettingId={}));var w;(function(f){f.FileName="ptyhost"})(w=e.TerminalLogConstants||(e.TerminalLogConstants={}));var S;(function(f){f.PowerShell="pwsh",f.Bash="bash",f.Fish="fish",f.Sh="sh",f.Csh="csh",f.Ksh="ksh",f.Zsh="zsh"})(S=e.PosixShellType||(e.PosixShellType={}));var P;(function(f){f.CommandPrompt="cmd",f.PowerShell="pwsh",f.Wsl="wsl",f.GitBash="gitbash"})(P=e.WindowsShellType||(e.WindowsShellType={}));var y;(function(f){f[f.Api=0]="Api",f[f.Process=1]="Process",f[f.Sequence=2]="Sequence",f[f.Config=3]="Config"})(y=e.TitleEventSource||(e.TitleEventSource={}));var b;(function(f){f.LocalPty="localPty",f.PtyHost="ptyHost",f.Logger="logger",f.Heartbeat="heartbeat"})(b=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,E.createDecorator)("ptyService");var k;(function(f){f.Cwd="cwd",f.InitialCwd="initialCwd",f.FixedDimensions="fixedDimensions",f.Title="title",f.ShellType="shellType",f.HasChildProcesses="hasChildProcesses",f.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",f.OverrideDimensions="overrideDimensions",f.FailedShellIntegrationActivation="failedShellIntegrationActivation",f.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(k=e.ProcessPropertyType||(e.ProcessPropertyType={}));var I;(function(f){f[f.BeatInterval=5e3]="BeatInterval",f[f.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",f[f.SecondWaitMultiplier=1]="SecondWaitMultiplier",f[f.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(I=e.HeartbeatConstants||(e.HeartbeatConstants={}));var v;(function(f){f[f.Panel=1]="Panel",f[f.Editor=2]="Editor"})(v=e.TerminalLocation||(e.TerminalLocation={}));var d;(function(f){f.TerminalView="view",f.Editor="editor"})(d=e.TerminalLocationString||(e.TerminalLocationString={}));var m;(function(f){f[f.GraceTime=6e4]="GraceTime",f[f.ShortGraceTime=6e3]="ShortGraceTime"})(m=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var p;(function(f){f[f.HighWatermarkChars=1e5]="HighWatermarkChars",f[f.LowWatermarkChars=5e3]="LowWatermarkChars",f[f.CharCountAckSize=5e3]="CharCountAckSize"})(p=e.FlowControlConstants||(e.FlowControlConstants={}));var c;(function(f){f.GitBash="Git Bash",f.Pwsh="PowerShell"})(c=e.ProfileSource||(e.ProfileSource={}));var h;(function(f){f[f.Off=0]="Off",f[f.FinalTerm=1]="FinalTerm",f[f.VSCode=2]="VSCode"})(h=e.ShellIntegrationStatus||(e.ShellIntegrationStatus={}));var g;(function(f){f[f.Unknown=0]="Unknown",f[f.Shutdown=1]="Shutdown",f[f.Process=2]="Process",f[f.User=3]="User",f[f.Extension=4]="Extension"})(g=e.TerminalExitReason||(e.TerminalExitReason={}))}),define(be[245],Ee([1,0,3]),function(oe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeCwd=e.collapseTildePath=e.escapeNonWindowsPath=void 0;function A(S){let P=S;P.includes("\\")&&(P=P.replace(/\\/g,"\\\\"));const y=/[\`\$\|\&\>\~\#\!\^\*\;\<\"\']/g;return P=P.replace(y,""),`'${P}'`}e.escapeNonWindowsPath=A;function l(S,P,y){if(!S)return"";if(!P)return S;P.match(/[\/\\]$/)&&(P=P.slice(0,P.length-1));const b=S.replace(/\\/g,"/").toLowerCase(),k=P.replace(/\\/g,"/").toLowerCase();return b.includes(k)?`~${y}${S.slice(P.length+1)}`:S}e.collapseTildePath=l;function w(S){return S.match(/^['"].*['"]$/)&&(S=S.substring(1,S.length-1)),E.OS===1&&S&&S[1]===":"?S[0].toUpperCase()+S.substring(1):S}e.sanitizeCwd=w}),define(be[246],Ee([1,0,46,4,189,93]),function(oe,e,E,A,l,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function S(v,d){const m=[{name:null,description:(0,l.localize)(0,null)}];return m.push(...v.map(p=>({name:p.profileName,description:P(p)}))),d&&m.push(...d.map(p=>({name:p.title,description:y(p)}))),{values:m.map(p=>p.name),markdownDescriptions:m.map(p=>p.description)}}e.createProfileSchemaEnums=S;function P(v){let d=`$(${w.ThemeIcon.isThemeIcon(v.icon)?v.icon.id:v.icon?v.icon:E.Codicon.terminal.id}) ${v.profileName}
- path: ${v.path}`;return v.args&&(typeof v.args=="string"?d+=`
- args: "${v.args}"`:d+=`
- args: [${v.args.length===0?"":`'${v.args.join("','")}'`}]`),v.overrideName!==void 0&&(d+=`
- overrideName: ${v.overrideName}`),v.color&&(d+=`
- color: ${v.color}`),v.env&&(d+=`
- env: ${JSON.stringify(v.env)}`),d}function y(v){return`$(${w.ThemeIcon.isThemeIcon(v.icon)?v.icon.id:v.icon?v.icon:E.Codicon.terminal.id}) ${v.title}
- extensionIdentifier: ${v.extensionIdentifier}`}function b(v,d){if(!v&&!d)return!0;if(typeof v=="string"&&typeof d=="string")return v===d;if(Array.isArray(v)&&Array.isArray(d)){if(v.length!==d.length)return!1;for(let m=0;m<v.length;m++)if(v[m]!==d[m])return!1;return!0}return!1}e.terminalProfileArgsMatch=b;function k(v,d){if(!v&&!d)return!0;if(!v||!d)return!1;if(w.ThemeIcon.isThemeIcon(v)&&w.ThemeIcon.isThemeIcon(d))return v.id===d.id&&v.color===d.color;if(typeof v=="object"&&"light"in v&&"dark"in v&&typeof d=="object"&&"light"in d&&"dark"in d){const m=v,p=d;if((A.URI.isUri(m.light)||I(m.light))&&(A.URI.isUri(m.dark)||I(m.dark))&&(A.URI.isUri(p.light)||I(p.light))&&(A.URI.isUri(p.dark)||I(p.dark)))return m.light.path===p.light.path&&m.dark.path===p.dark.path}if(A.URI.isUri(v)&&A.URI.isUri(d)||I(v)||I(d)){const m=v,p=d;return m.path===p.path&&m.scheme===p.scheme}return!1}e.terminalIconsEqual=k;function I(v){return v?typeof v.path=="string"&&typeof v.scheme=="string":!1}e.isUriComponents=I}),define(be[247],Ee([1,0,46,188,52,40,246]),function(oe,e,E,A,l,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=e.terminalIconSchema=e.terminalColorSchema=void 0,e.terminalColorSchema={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.terminalIconSchema={type:"string",enum:Array.from((0,E.getAllCodicons)(),D=>D.id),markdownEnumDescriptions:Array.from((0,E.getAllCodicons)(),D=>`$(${D.id})`)};const P={args:{description:(0,A.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,A.localize)(1,null),type:"boolean"},icon:{description:(0,A.localize)(2,null),...e.terminalIconSchema},color:{description:(0,A.localize)(3,null),...e.terminalColorSchema},env:{markdownDescription:(0,A.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},y={type:"object",required:["path"],properties:{path:{description:(0,A.localize)(5,null),type:["string","array"],items:{type:"string"}},...P}},b={type:"object",required:["path"],properties:{path:{description:(0,A.localize)(6,null),type:["string"],items:{type:"string"}},...P}},k=(0,A.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),I=(0,A.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),v=(0,A.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),d=(0,A.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),m=(0,A.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),p=(0,A.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),c={id:"terminal",order:100,title:(0,A.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,A.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:d},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,A.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:m},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,A.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:p},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,A.localize)(17,null,"`terminal.integrated.automationShell.linux`"),type:["object","null"],default:null,anyOf:[{type:"null"},b],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,A.localize)(18,null,"`terminal.integrated.automationShell.osx`"),type:["object","null"],default:null,anyOf:[{type:"null"},b],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,A.localize)(19,null,"`terminal.integrated.automationShell.windows`"),type:["object","null"],default:null,anyOf:[{type:"null"},b],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,A.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:k},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,A.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:I},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,A.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:v},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,A.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:k},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,A.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:I},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,A.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,A.localize)(26,null)}},{type:"string",markdownDescription:(0,A.localize)(27,null)}],default:[],markdownDeprecationMessage:v},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,A.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,A.localize)(29,null),enum:["PowerShell","Git Bash"]},...P}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,A.localize)(30,null),type:"string"},id:{description:(0,A.localize)(31,null),type:"string"},title:{description:(0,A.localize)(32,null),type:"string"},...P}},{type:"null"},y]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,A.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,A.localize)(34,null),type:"string"},id:{description:(0,A.localize)(35,null),type:"string"},title:{description:(0,A.localize)(36,null),type:"string"},...P}},{type:"null"},y]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,A.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,A.localize)(38,null),type:"string"},id:{description:(0,A.localize)(39,null),type:"string"},title:{description:(0,A.localize)(40,null),type:"string"},...P}},{type:"null"},y]}},["terminal.integrated.useWslProfiles"]:{description:(0,A.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,A.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,A.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,A.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,A.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function h(){w.Registry.as(l.Extensions.Configuration).registerConfiguration(c),f()}e.registerTerminalPlatformConfiguration=h;let g;function f(D,R){const t=w.Registry.as(l.Extensions.Configuration);let r;D&&(r=(0,S.createProfileSchemaEnums)(D?.profiles,R));const i=g;g={id:"terminal",order:100,title:(0,A.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,A.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:D?.os===3?r?.values:void 0,markdownEnumDescriptions:D?.os===3?r?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,A.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:D?.os===2?r?.values:void 0,markdownEnumDescriptions:D?.os===2?r?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,A.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:D?.os===1?r?.values:void 0,markdownEnumDescriptions:D?.os===1?r?.markdownDescriptions:void 0}}},t.updateConfigurations({add:[g],remove:i?[i]:[]})}e.registerTerminalDefaultProfileConfiguration=f}),define(be[248],Ee([1,0,29,13,23,7,3,28,17,8,22,119,81,120]),function(oe,e,E,A,l,w,S,P,y,b,k,I,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getShellIntegrationInjection=e.findExecutable=e.getWindowsBuildNumber=void 0;function m(){const n=/(\d+)\.(\d+)\.(\d+)/g.exec(E.release());let o=0;return n&&n.length===4&&(o=parseInt(n[3])),o}e.getWindowsBuildNumber=m;async function p(n,o,u,a=P.env,s=k.Promises.exists){if(w.isAbsolute(n))return await s(n)?n:void 0;if(o===void 0&&(o=P.cwd()),w.dirname(n)!=="."){const W=w.join(o,n);return await s(W)?W:void 0}const L=(0,l.getCaseInsensitive)(a,"PATH");if(u===void 0&&(0,b.isString)(L)&&(u=L.split(w.delimiter)),u===void 0||u.length===0){const W=w.join(o,n);return await s(W)?W:void 0}for(const W of u){let X;if(w.isAbsolute(W)?X=w.join(W,n):X=w.join(o,W,n),await s(X))return X;if(S.isWindows){let se=X+".com";if(await s(se)||(se=X+".exe",await s(se)))return se}}const O=w.join(o,n);return await s(O)?O:void 0}e.findExecutable=p;function c(n,o,u,a,s){const C=S.isWindows&&(!o.windowsEnableConpty||m()<18309);if(!o.shellIntegration.enabled||!n.executable||n.isFeatureTerminal||n.hideFromUser||n.ignoreShellIntegration||C)return;const L=n.args,O=P.platform==="win32"?w.basename(n.executable).toLowerCase():w.basename(n.executable),W=w.dirname(A.FileAccess.asFileUri("").fsPath);let X;const se={VSCODE_INJECTION:"1"};if(S.isWindows){if(O==="pwsh.exe"||O==="powershell.exe")return!L||r(L)?X=f.get(g.WindowsPwsh):t(L)&&(X=f.get(g.WindowsPwshLogin)),X?(X=[...X],X[X.length-1]=(0,y.format)(X[X.length-1],W,""),o.shellIntegration.suggestEnabled&&(se.VSCODE_SUGGEST="1"),{newArgs:X,envMixin:se}):void 0;a.warn(`Shell integration cannot be enabled for executable "${n.executable}" and args`,n.args);return}switch(O){case"bash":return!L||L.length===0?X=f.get(g.Bash):i(L)&&(se.VSCODE_SHELL_LOGIN="1",h(o,se),X=f.get(g.Bash)),X?(X=[...X],X[X.length-1]=(0,y.format)(X[X.length-1],W),{newArgs:X,envMixin:se}):void 0;case"fish":{const fe=u?.XDG_DATA_DIRS??"/usr/local/share:/usr/share",ce=w.join(W,"out/vs/workbench/contrib/xdg_data");return se.XDG_DATA_DIRS=`${fe}:${ce}`,h(o,se),{newArgs:void 0,envMixin:se}}case"pwsh":return!L||r(L)?X=f.get(g.Pwsh):t(L)&&(X=f.get(g.PwshLogin)),X?(o.shellIntegration.suggestEnabled&&(se.VSCODE_SUGGEST="1"),X=[...X],X[X.length-1]=(0,y.format)(X[X.length-1],W,""),{newArgs:X,envMixin:se}):void 0;case"zsh":{if(!L||L.length===0?X=f.get(g.Zsh):i(L)?(X=f.get(g.ZshLogin),h(o,se)):(L===f.get(g.Zsh)||L===f.get(g.ZshLogin))&&(X=L),!X)return;X=[...X],X[X.length-1]=(0,y.format)(X[X.length-1],W);let fe;try{fe=E.userInfo().username}catch{fe="unknown"}const ce=w.join(E.tmpdir(),`${fe}-${s.applicationName}-zsh`);se.ZDOTDIR=ce;const V=u?.ZDOTDIR??E.homedir()??"~";se.USER_ZDOTDIR=V;const T=[];return T.push({source:w.join(W,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:w.join(ce,".zshrc")}),T.push({source:w.join(W,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:w.join(ce,".zprofile")}),T.push({source:w.join(W,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:w.join(ce,".zshenv")}),T.push({source:w.join(W,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:w.join(ce,".zlogin")}),{newArgs:X,envMixin:se,filesToCopy:T}}}a.warn(`Shell integration cannot be enabled for executable "${n.executable}" and args`,n.args)}e.getShellIntegrationInjection=c;function h(n,o){if(S.isMacintosh&&n.environmentVariableCollections){const u=(0,v.deserializeEnvironmentVariableCollections)(n.environmentVariableCollections),s=new d.MergedEnvironmentVariableCollection(u).map.get("PATH"),C=[];if(s)for(const L of s)L.type===I.EnvironmentVariableMutatorType.Prepend&&C.push(L.value);C.length>0&&(o.VSCODE_PATH_PREFIX=C.join(""))}}var g;(function(n){n.WindowsPwsh="windows-pwsh",n.WindowsPwshLogin="windows-pwsh-login",n.Pwsh="pwsh",n.PwshLogin="pwsh-login",n.Zsh="zsh",n.ZshLogin="zsh-login",n.Bash="bash"})(g||(g={}));const f=new Map;f.set(g.WindowsPwsh,["-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),f.set(g.WindowsPwshLogin,["-l","-noexit","-command",'try { . "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1" } catch {}{1}']),f.set(g.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),f.set(g.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),f.set(g.Zsh,["-i"]),f.set(g.ZshLogin,["-il"]),f.set(g.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const D=["-login","-l"],R=["-nol","-nologo"];function t(n){return typeof n=="string"?D.includes(n.toLowerCase()):n.length===1&&D.includes(n[0].toLowerCase())||n.length===2&&(D.includes(n[0].toLowerCase())||D.includes(n[1].toLowerCase()))&&(R.includes(n[0].toLowerCase())||R.includes(n[1].toLowerCase()))}function r(n){return typeof n=="string"?R.includes(n.toLowerCase()):n.length===0||n?.length===1&&R.includes(n[0].toLowerCase())}function i(n){return n==="string"&&D.includes(n.toLowerCase())||typeof n!="string"&&n.length===1&&D.includes(n[0].toLowerCase())}}),define(be[249],Ee([1,0,48,46,7,3,8,22,98,248]),function(oe,e,E,A,l,w,S,P,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let k,I=!0;function v(r,i,n,o,u=process.env,a,s,C,L){return a=a||{existsFile:P.SymlinkSupport.existsFile,readFile:P.Promises.readFile},w.isWindows?d(n,a,u,s,o.getValue("terminal.integrated.useWslProfiles")!==!1,r&&typeof r=="object"?{...r}:o.getValue("terminal.integrated.profiles.windows"),typeof i=="string"?i:o.getValue("terminal.integrated.defaultProfile.windows"),L,C):D(a,s,n,r&&typeof r=="object"?{...r}:o.getValue(w.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof i=="string"?i:o.getValue(w.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),L,C,u)}e.detectAvailableProfiles=v;async function d(r,i,n,o,u,a,s,C,L){const O=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),W=`${process.env.windir}\\${O?"Sysnative":"System32"}`;let X=!1;(0,b.getWindowsBuildNumber)()>=16299&&(X=!0),await c(C);const se=new Map;if(r){se.set("PowerShell",{source:"PowerShell",icon:A.Codicon.terminalPowershell,isAutoDetected:!0}),se.set("Windows PowerShell",{path:`${W}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:A.Codicon.terminalPowershell,isAutoDetected:!0}),se.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),se.set("Command Prompt",{path:`${W}\\cmd.exe`,icon:A.Codicon.terminalCmd,isAutoDetected:!0}),se.set("Cygwin",{path:[{path:`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,isUnsafe:!0},{path:`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`,isUnsafe:!0}],args:["--login"],isAutoDetected:!0}),se.set("bash (MSYS2)",{path:[{path:`${process.env.HOMEDRIVE}\\msys64\\usr\\bin\\bash.exe`,isUnsafe:!0}],args:["--login","-i"],icon:A.Codicon.terminalBash,isAutoDetected:!0});const ce=`${process.env.CMDER_ROOT||`${process.env.HOMEDRIVE}\\cmder`}\\vendor\\bin\\vscode_init.cmd`;se.set("Cmder",{path:`${W}\\cmd.exe`,args:["/K",ce],requiresPath:process.env.CMDER_ROOT?ce:{path:ce,isUnsafe:!0},isAutoDetected:!0})}R(a,se);const fe=await m(se.entries(),s,i,n,o,L);if(r||u)try{const ce=await g(`${W}\\${X?"wsl":"bash"}.exe`,s);for(const V of ce)(!a||!(V.profileName in a))&&fe.push(V)}catch{I&&(o?.info("WSL is not installed, so could not detect WSL profiles"),I=!1)}return fe}async function m(r,i,n,o=process.env,u,a){const s=[];for(const[C,L]of r){if(L===null)continue;let O,W,X;if("source"in L){const V=k?.get(L.source);if(!V)continue;O=V.paths,W=L.args||V.args,L.icon?X=p(L.icon):V.icon&&(X=V.icon)}else O=Array.isArray(L.path)?L.path:[L.path],W=w.isWindows||Array.isArray(L.args)?L.args:void 0,X=p(L.icon);let se;if(a){const V=O.map(z=>typeof z=="string"?z:z.path),T=await a(V);se=new Array(O.length);for(let z=0;z<O.length;z++)typeof O[z]=="string"?se[z]=T[z]:se[z]={path:T[z],isUnsafe:!0}}else se=O.slice();let fe;if(L.requiresPath){let V;if((0,S.isString)(L.requiresPath)?V=L.requiresPath:(V=L.requiresPath.path,L.requiresPath.isUnsafe&&(fe=V)),!await n.existsFile(V))continue}const ce=await t(C,i,se,n,o,W,L.env,L.overrideName,L.isAutoDetected,fe);ce?(ce.isAutoDetected=L.isAutoDetected,ce.icon=X,ce.color=L.color,s.push(ce)):u?.debug("Terminal profile not validated",C,O)}return u?.debug("Validated terminal profiles",s),s}function p(r){return typeof r=="string"?{id:r}:r}async function c(r){k&&!r||(k=new Map,k.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\bin\\bash.exe`,`${process.env["ProgramFiles(X86)"]}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login","-i"]}),k.set("PowerShell",{profileName:"PowerShell",paths:r||await h(),icon:A.Codicon.terminalPowershell}))}async function h(){const r=[];for await(const i of(0,y.enumeratePowerShellInstallations)())r.push(i.exePath);return r}async function g(r,i){const n=[],o=await new Promise((s,C)=>{E.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(L,O)=>{if(L)return C("Problem occurred when getting wsl distros");s(O)})});if(!o)return[];const u=new RegExp(/[\r?\n]/),a=o.split(u).filter(s=>s.trim().length>0&&s!=="");for(const s of a){if(s===""||s.startsWith("docker-desktop"))continue;const C=`${s} (WSL)`,L={profileName:C,path:r,args:["-d",`${s}`],isDefault:C===i,icon:f(s),isAutoDetected:!1};n.push(L)}return n}function f(r){return r.includes("Ubuntu")?A.Codicon.terminalUbuntu:r.includes("Debian")?A.Codicon.terminalDebian:A.Codicon.terminalLinux}async function D(r,i,n,o,u,a,s,C){const L=new Map;if(n){const O=(await r.readFile("/etc/shells")).toString(),W=a||O.split(`
`).filter(se=>se.trim().includes("#")&&se.trim().length>0),X=new Map;for(const se of W){let fe=(0,l.basename)(se),ce=X.get(fe)||0;ce++,ce>1&&(fe=`${fe} (${ce})`),X.set(fe,ce),L.set(fe,{path:se,isAutoDetected:!0})}}return R(o,L),await m(L.entries(),u,r,C,i,s)}function R(r,i){if(!!r)for(const[n,o]of Object.entries(r))o===null||typeof o!="object"||!("path"in o)&&!("source"in o)?i.delete(n):(o.icon=o.icon||i.get(n)?.icon,i.set(n,o))}async function t(r,i,n,o,u,a,s,C,L,O){if(n.length===0)return Promise.resolve(void 0);const W=n.shift();if(W==="")return t(r,i,n,o,u,a,s,C,L);const X=typeof W!="string"&&W.isUnsafe,se=typeof W=="string"?W:W.path,fe={profileName:r,path:se,args:a,env:s,overrideName:C,isAutoDetected:L,isDefault:r===i,isUnsafePath:X,requiresUnsafePath:O};if((0,l.basename)(se)===se){const V=u.PATH?u.PATH.split(l.delimiter):void 0,T=await(0,b.findExecutable)(se,void 0,V,void 0,o.existsFile);return T?(fe.path=T,fe.isFromPath=!0,fe):t(r,i,n,o,u,a)}return await o.existsFile((0,l.normalize)(se))?fe:t(r,i,n,o,u,a,s,C,L)}}),define(be[250],Ee([1,0,6,2,13,3,43,102,24,25,104,80,10,244,121,247,249,109]),function(oe,e,E,A,l,w,S,P,y,b,k,I,v,d,m,p,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var g;(function(R){R[R.MaxRestarts=5]="MaxRestarts"})(g||(g={}));let f=0,D=class extends A.Disposable{constructor(t,r,i,n,o,u){super(),this.C=t,this.D=r,this.F=i,this.G=n,this.H=o,this.I=u,this.g=0,this.h=!0,this.i=!1,this.l=this.B(new E.Emitter),this.onPtyHostExit=this.l.event,this.m=this.B(new E.Emitter),this.onPtyHostStart=this.m.event,this.n=this.B(new E.Emitter),this.onPtyHostUnresponsive=this.n.event,this.p=this.B(new E.Emitter),this.onPtyHostResponsive=this.p.event,this.r=this.B(new E.Emitter),this.onPtyHostRequestResolveVariables=this.r.event,this.s=this.B(new E.Emitter),this.onProcessData=this.s.event,this.t=this.B(new E.Emitter),this.onProcessReady=this.t.event,this.u=this.B(new E.Emitter),this.onProcessReplay=this.u.event,this.v=this.B(new E.Emitter),this.onProcessOrphanQuestion=this.v.event,this.w=this.B(new E.Emitter),this.onDidRequestDetach=this.w.event,this.y=this.B(new E.Emitter),this.onDidChangeProperty=this.y.event,this.z=this.B(new E.Emitter),this.onProcessExit=this.z.event,(0,p.registerTerminalPlatformConfiguration)(),this.c=this.M(),this.B((0,A.toDisposable)(()=>this.O())),this.f=this.B(new d.RequestStore(void 0,this.H)),this.f.onCreateRequest(this.r.fire,this.r),[this.a,this.b]=this.N(),this.B(this.F.onDidChangeConfiguration(async a=>{a.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this.L()}))}initialize(){this.L()}get J(){return this.F.getValue("terminal.integrated.ignoreProcessNames")}async L(){return this.b.refreshIgnoreProcessNames?.(this.J)}async M(){if(w.isWindows)return process.env;try{return await(0,I.getResolvedShellEnv)(this.F,this.H,{_:[]},process.env)}catch(t){return this.H.error("ptyHost was unable to resolve shell environment",t),{}}}N(){const t={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this.G.logsPath],env:{VSCODE_LAST_PTY_ID:f,VSCODE_PTY_LOG_NAME:this.D,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this.C.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this.C.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this.C.scrollback}},r=(0,k.parsePtyHostDebugPort)(this.G.args,this.G.isBuilt);r&&(r.break&&r.port?t.debugBrk=r.port:!r.break&&r.port&&(t.debug=r.port));const i=new P.Client(l.FileAccess.asFileUri("bootstrap-fork").fsPath,t);this.m.fire(),S.ProxyChannel.toService(i.getChannel(m.TerminalIpcChannels.Heartbeat)).onBeat(()=>this.P()),this.P(),this.B(i.onDidProcessExit(u=>{this.l.fire(u.code),this.i||(this.g<=g.MaxRestarts?(this.H.error(`ptyHost terminated unexpectedly with code ${u.code}`),this.g++,this.restartPtyHost()):this.H.error(`ptyHost terminated unexpectedly with code ${u.code}, giving up`))})),this.B(new h.RemoteLoggerChannelClient(this.I,i.getChannel(m.TerminalIpcChannels.Logger)));const o=S.ProxyChannel.toService(i.getChannel(m.TerminalIpcChannels.PtyHost));return this.B(o.onProcessData(u=>this.s.fire(u))),this.B(o.onProcessReady(u=>this.t.fire(u))),this.B(o.onProcessExit(u=>this.z.fire(u))),this.B(o.onDidChangeProperty(u=>this.y.fire(u))),this.B(o.onProcessReplay(u=>this.u.fire(u))),this.B(o.onProcessOrphanQuestion(u=>this.v.fire(u))),this.B(o.onDidRequestDetach(u=>this.w.fire(u))),[i,o]}dispose(){this.i=!0,super.dispose()}async createProcess(t,r,i,n,o,u,a,s,C,L,O){const W=setTimeout(()=>this.S(),m.HeartbeatConstants.CreateProcessTimeout),X=await this.b.createProcess(t,r,i,n,o,u,a,s,C,L,O);return clearTimeout(W),f=Math.max(f,X),X}updateTitle(t,r,i){return this.b.updateTitle(t,r,i)}updateIcon(t,r,i,n){return this.b.updateIcon(t,r,i,n)}attachToProcess(t){return this.b.attachToProcess(t)}detachFromProcess(t,r){return this.b.detachFromProcess(t,r)}listProcesses(){return this.b.listProcesses()}reduceConnectionGraceTime(){return this.b.reduceConnectionGraceTime()}start(t){return this.b.start(t)}shutdown(t,r){return this.b.shutdown(t,r)}input(t,r){return this.b.input(t,r)}processBinary(t,r){return this.b.processBinary(t,r)}resize(t,r,i){return this.b.resize(t,r,i)}acknowledgeDataEvent(t,r){return this.b.acknowledgeDataEvent(t,r)}setUnicodeVersion(t,r){return this.b.setUnicodeVersion(t,r)}getInitialCwd(t){return this.b.getInitialCwd(t)}getCwd(t){return this.b.getCwd(t)}getLatency(t){return this.b.getLatency(t)}orphanQuestionReply(t){return this.b.orphanQuestionReply(t)}installAutoReply(t,r){return this.b.installAutoReply(t,r)}uninstallAllAutoReplies(){return this.b.uninstallAllAutoReplies()}uninstallAutoReply(t){return this.b.uninstallAutoReply(t)}getDefaultSystemShell(t){return this.b.getDefaultSystemShell(t)}async getProfiles(t,r,i,n=!1){const o=await this.c;return(0,c.detectAvailableProfiles)(r,i,n,this.F,o,void 0,this.H,this.W.bind(this,t))}getEnvironment(){return this.b.getEnvironment()}getWslPath(t,r){return this.b.getWslPath(t,r)}getRevivedPtyNewId(t){return this.b.getRevivedPtyNewId(t)}setTerminalLayoutInfo(t){return this.b.setTerminalLayoutInfo(t)}async getTerminalLayoutInfo(t){return await this.b.getTerminalLayoutInfo(t)}async requestDetachInstance(t,r){return this.b.requestDetachInstance(t,r)}async acceptDetachInstanceReply(t,r){return this.b.acceptDetachInstanceReply(t,r)}async freePortKillProcess(t){if(!this.b.freePortKillProcess)throw new Error("freePortKillProcess does not exist on the pty proxy");return this.b.freePortKillProcess(t)}async serializeTerminalState(t){return this.b.serializeTerminalState(t)}async reviveTerminalProcesses(t,r){return this.b.reviveTerminalProcesses(t,r)}async refreshProperty(t,r){return this.b.refreshProperty(t,r)}async updateProperty(t,r,i){return this.b.updateProperty(t,r,i)}async restartPtyHost(){this.h=!0,this.O(),[this.a,this.b]=this.N()}O(){this.b.shutdownAll?.(),this.a.dispose()}P(){this.U(),this.j=setTimeout(()=>this.Q(),m.HeartbeatConstants.BeatInterval*m.HeartbeatConstants.FirstWaitMultiplier),this.h||(this.h=!0,this.p.fire())}Q(){this.H.warn(`No ptyHost heartbeat after ${m.HeartbeatConstants.BeatInterval*m.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this.j=void 0,this.k=setTimeout(()=>this.R(),m.HeartbeatConstants.BeatInterval*m.HeartbeatConstants.SecondWaitMultiplier)}R(){this.H.error(`No ptyHost heartbeat after ${(m.HeartbeatConstants.BeatInterval*m.HeartbeatConstants.FirstWaitMultiplier+m.HeartbeatConstants.BeatInterval*m.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this.k=void 0,this.h&&(this.h=!1,this.n.fire())}S(){this.U(),this.H.error(`No ptyHost response to createProcess after ${m.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this.h&&(this.h=!1,this.n.fire())}U(){this.j&&(clearTimeout(this.j),this.j=void 0),this.k&&(clearTimeout(this.k),this.k=void 0)}W(t,r){return this.f.createRequest({workspaceId:t,originalText:r})}async acceptPtyHostResolvedVariables(t,r){this.f.acceptReply(t,r)}};D=Te([Ae(2,y.IConfigurationService),Ae(3,b.IEnvironmentService),Ae(4,v.ILogService),Ae(5,v.ILoggerService)],D),e.PtyHostService=D}),define(be[36],Ee([1,0,5]),function(oe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,E.createDecorator)("IUriIdentityService")}),define(be[122],Ee([1,0,36,207,16,20,144,6,2]),function(oe,e,E,A,l,w,S,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class b{constructor(v){this.uri=v,this.time=b._clock++}touch(){return this.time=b._clock++,this}}b._clock=0;let k=class{constructor(v){this.g=v,this.c=new y.DisposableStore,this.f=2**16;const d=new Map,m=p=>{let c=d.get(p.scheme);return c===void 0&&(c=v.hasProvider(p)&&!this.g.hasCapability(p,1024),d.set(p.scheme,c)),c};this.c.add(P.Event.any(v.onDidChangeFileSystemProviderRegistrations,v.onDidChangeFileSystemProviderCapabilities)(p=>{d.delete(p.scheme)})),this.extUri=new w.ExtUri(m),this.d=new S.SkipList((p,c)=>this.extUri.compare(p,c,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(v){this.g.hasProvider(v)&&(v=(0,w.normalizePath)(v));const d=this.d.get(v);return d?d.touch().uri.with({fragment:v.fragment}):(this.d.set(v,new b(v)),this.h(),v)}h(){if(this.d.size<this.f)return;const v=[...this.d.entries()].sort((m,p)=>m[1].time<p[1].time?1:m[1].time>p[1].time?-1:0);b._clock=0,this.d.clear();const d=this.f*.5;for(let m=0;m<d;m++)this.d.set(v[m][0],v[m][1].touch())}};k=Te([Ae(0,l.IFileService)],k),e.UriIdentityService=k,(0,A.registerSingleton)(E.IUriIdentityService,k,1)}),define(be[82],Ee([1,0,191,7,60,20,4,5,13]),function(oe,e,E,A,l,w,S,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,P.createDecorator)("contextService");function b(i){const n=i;return typeof n?.id=="string"&&S.URI.isUri(n.uri)}e.isSingleFolderWorkspaceIdentifier=b;function k(i){return typeof i?.id=="string"&&!b(i)&&!v(i)}e.isEmptyWorkspaceIdentifier=k,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function I(i,n){if(typeof i=="string"||typeof i>"u")return typeof i=="string"?{id:(0,A.basename)(i)}:n?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const o=i;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}e.toWorkspaceIdentifier=I;function v(i){const n=i;return typeof n?.id=="string"&&S.URI.isUri(n.configPath)}e.isWorkspaceIdentifier=v;function d(i){const n=i;if(n?.uri)return{id:n.id,uri:S.URI.revive(n.uri)};const o=i;if(o?.configPath)return{id:o.id,configPath:S.URI.revive(o.configPath)};if(i?.id)return{id:i.id}}e.reviveIdentifier=d;var m;(function(i){i[i.EMPTY=1]="EMPTY",i[i.FOLDER=2]="FOLDER",i[i.WORKSPACE=3]="WORKSPACE"})(m=e.WorkbenchState||(e.WorkbenchState={}));function p(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&Array.isArray(n.folders))}e.isWorkspace=p;function c(i){const n=i;return!!(n&&typeof n=="object"&&S.URI.isUri(n.uri)&&typeof n.name=="string"&&typeof n.toResource=="function")}e.isWorkspaceFolder=c;class h{constructor(n,o,u,a,s){this.h=n,this.j=u,this.k=a,this.l=s,this.c=l.TernarySearchTree.forUris(this.l,()=>!0),this.folders=o}update(n){this.h=n.id,this.k=n.configuration,this.j=n.transient,this.l=n.l,this.folders=n.folders}get folders(){return this.g}set folders(n){this.g=n,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(n){this.k=n}getFolder(n){return n&&this.c.findSubstr(n)||null}n(){this.c=l.TernarySearchTree.forUris(this.l,()=>!0);for(const n of this.folders)this.c.set(n.uri,n)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=h;class g{constructor(n,o){this.raw=o,this.uri=n.uri,this.index=n.index,this.name=n.name}toResource(n){return(0,w.joinPath)(this.uri,n)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=g;function f(i){return new g({uri:i,index:0,name:(0,w.basenameOrAuthority)(i)},{uri:i.toString()})}e.toWorkspaceFolder=f,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,E.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function D(i,n){return w.extUriBiasedIgnorePathCase.isEqualOrParent(i,n.untitledWorkspacesHome)}e.isUntitledWorkspace=D;function R(i){let n;return S.URI.isUri(i)?n=i:n=i.configuration,n?.scheme===y.Schemas.tmp}e.isTemporaryWorkspace=R;function t(i,n){return!D(i,n)&&!R(i)}e.isSavedWorkspace=t;function r(i){return(typeof i=="string"?(0,A.extname)(i):(0,w.extname)(i))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=r}),define(be[32],Ee([1,0,92,6,2,20,4,190,25,16,5,10,82,27,36,14,21,17,8]),function(oe,e,E,A,l,w,S,P,y,b,k,I,v,d,m,p,c,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryUserDataProfilesService=e.UserDataProfilesService=e.toUserDataProfile=e.reviveProfile=e.IUserDataProfilesService=e.isUserDataProfile=void 0;function f(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&S.URI.isUri(n.location)&&S.URI.isUri(n.globalStorageHome)&&S.URI.isUri(n.settingsResource)&&S.URI.isUri(n.keybindingsResource)&&S.URI.isUri(n.tasksResource)&&S.URI.isUri(n.snippetsHome)&&S.URI.isUri(n.extensionsResource))}e.isUserDataProfile=f,e.IUserDataProfilesService=(0,k.createDecorator)("IUserDataProfilesService");function D(i,n){return{id:i.id,isDefault:i.isDefault,name:i.name,shortName:i.shortName,location:S.URI.revive(i.location).with({scheme:n}),globalStorageHome:S.URI.revive(i.globalStorageHome).with({scheme:n}),settingsResource:S.URI.revive(i.settingsResource).with({scheme:n}),keybindingsResource:S.URI.revive(i.keybindingsResource).with({scheme:n}),tasksResource:S.URI.revive(i.tasksResource).with({scheme:n}),snippetsHome:S.URI.revive(i.snippetsHome).with({scheme:n}),extensionsResource:S.URI.revive(i.extensionsResource)?.with({scheme:n}),useDefaultFlags:i.useDefaultFlags,isTransient:i.isTransient}}e.reviveProfile=D;function R(i,n,o,u){return{id:i,name:n,location:o,isDefault:!1,shortName:u?.shortName,globalStorageHome:(0,w.joinPath)(o,"globalStorage"),settingsResource:(0,w.joinPath)(o,"settings.json"),keybindingsResource:(0,w.joinPath)(o,"keybindings.json"),tasksResource:(0,w.joinPath)(o,"tasks.json"),snippetsHome:(0,w.joinPath)(o,"snippets"),extensionsResource:(0,w.joinPath)(o,"extensions.json"),useDefaultFlags:u?.useDefaultFlags,isTransient:u?.transient}}e.toUserDataProfile=R;let t=class extends l.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.u.profiles,...this.l.profiles]}constructor(n,o,u,a){super(),this.m=n,this.n=o,this.r=u,this.s=a,this.f=!0,this.g=this.B(new A.Emitter),this.onDidChangeProfiles=this.g.event,this.h=this.B(new A.Emitter),this.onWillCreateProfile=this.h.event,this.i=this.B(new A.Emitter),this.onWillRemoveProfile=this.i.event,this.j=this.B(new A.Emitter),this.onDidResetWorkspaces=this.j.event,this.k=new Map,this.l={profiles:[],workspaces:new d.ResourceMap,emptyWindows:new Map},this.profilesHome=(0,w.joinPath)(this.m.userRoamingDataHome,"profiles")}init(){this.t=void 0}setEnablement(n){this.f!==n&&(this.t=void 0,this.f=n)}isEnabled(){return this.f}get u(){if(!this.t){const n=[];if(this.f)try{for(const s of this.I()){if(!s.name||!(0,g.isString)(s.name)||!s.location){this.s.warn("Skipping the invalid stored profile",s.location||s.name);continue}n.push(R((0,w.basename)(s.location),s.name,s.location,{shortName:s.shortName,useDefaultFlags:s.useDefaultFlags}))}}catch(s){this.s.error(s)}const o=new d.ResourceMap,u=new Map,a=this.v();if(n.unshift({...a,extensionsResource:this.N()??a.extensionsResource,isDefault:!0}),n.length)try{const s=this.L();if(s.workspaces)for(const[C,L]of Object.entries(s.workspaces)){const O=S.URI.parse(C),W=n.find(X=>X.id===L);W&&o.set(O,W)}if(s.emptyWindows)for(const[C,L]of Object.entries(s.emptyWindows)){const O=n.find(W=>W.id===L);O&&u.set(C,O)}}catch(s){this.s.error(s)}this.t={profiles:n,workspaces:o,emptyWindows:u}}return this.t}v(){return R("__default__profile__",(0,P.localize)(0,null),this.m.userRoamingDataHome)}async createTransientProfile(n){const o="Temp",u=new RegExp(`${(0,h.escapeRegExpCharacters)(o)}\\s(\\d+)`);let a=0;for(const C of this.profiles){const L=u.exec(C.name),O=L?parseInt(L[1]):0;a=O>a?O:a}const s=`${o} ${a+1}`;return this.createProfile((0,E.hash)((0,c.generateUuid)()).toString(16),s,{transient:!0},n)}async createNamedProfile(n,o,u){return this.createProfile((0,E.hash)((0,c.generateUuid)()).toString(16),n,o,u)}async createProfile(n,o,u,a){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const s=await this.w(n,o,u);return a&&await this.setProfileForWorkspace(a,s),s}async w(n,o,u){if(!(0,g.isString)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let a=this.k.get(o);return a||(a=(async()=>{try{const s=this.profiles.find(O=>O.name===o||O.id===n);if(s)return s;const C=R(n,o,(0,w.joinPath)(this.profilesHome,n),u);await this.n.createFolder(C.location);const L=[];return this.h.fire({profile:C,join(O){L.push(O)}}),await p.Promises.settled(L),this.C([C],[],[]),C}finally{this.k.delete(o)}})(),this.k.set(o,a)),a}async updateProfile(n,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let u=this.profiles.find(a=>a.id===n.id);if(!u)throw new Error(`Profile '${n.name}' does not exist`);return u=R(u.id,o.name??u.name,u.location,{shortName:o.shortName??u.shortName,transient:o.transient??u.isTransient,useDefaultFlags:o.useDefaultFlags??u.useDefaultFlags}),this.C([],[],[u]),u}async removeProfile(n){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(n.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(a=>a.id===n.id);if(!o)throw new Error(`Profile '${n.name}' does not exist`);const u=[];this.i.fire({profile:o,join(a){u.push(a)}});try{await Promise.allSettled(u)}catch(a){this.s.error(a)}for(const a of[...this.u.emptyWindows.keys()])o.id===this.u.emptyWindows.get(a)?.id&&this.u.emptyWindows.delete(a);for(const a of[...this.u.workspaces.keys()])o.id===this.u.workspaces.get(a)?.id&&this.u.workspaces.delete(a);this.G(),this.C([],[o],[]);try{this.profiles.length===1?await this.n.del(this.profilesHome,{recursive:!0}):await this.n.del(o.location,{recursive:!0})}catch(a){this.s.error(a)}}async setProfileForWorkspace(n,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const u=this.profiles.find(a=>a.id===o.id);if(!u)throw new Error(`Profile '${o.name}' does not exist`);this.F(n,u)}unsetWorkspace(n,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.F(n,void 0,o)}async resetWorkspaces(){this.l.workspaces.clear(),this.l.emptyWindows.clear(),this.u.workspaces.clear(),this.u.emptyWindows.clear(),this.G(),this.j.fire()}async cleanUp(){if(!!this.f&&await this.n.exists(this.profilesHome)){const n=await this.n.resolve(this.profilesHome);await Promise.all((n.children||[]).filter(o=>o.isDirectory&&this.profiles.every(u=>!this.r.extUri.isEqual(u.location,o.resource))).map(o=>this.n.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const n=this.l.profiles.filter(o=>!this.z(o));await Promise.allSettled(n.map(o=>this.removeProfile(o)))}getProfileForWorkspace(n){const o=this.y(n);return S.URI.isUri(o)?this.l.workspaces.get(o)??this.u.workspaces.get(o):this.l.emptyWindows.get(o)??this.u.emptyWindows.get(o)}y(n){return(0,v.isSingleFolderWorkspaceIdentifier)(n)?n.uri:(0,v.isWorkspaceIdentifier)(n)?n.configPath:n.id}z(n){return!!([...this.l.emptyWindows.values()].some(o=>this.r.extUri.isEqual(o.location,n.location))||[...this.l.workspaces.values()].some(o=>this.r.extUri.isEqual(o.location,n.location))||[...this.u.emptyWindows.values()].some(o=>this.r.extUri.isEqual(o.location,n.location))||[...this.u.workspaces.values()].some(o=>this.r.extUri.isEqual(o.location,n.location)))}C(n,o,u){const a=[...this.profiles,...n],s=[];this.l.profiles=[];for(let C of a)C.isDefault||o.some(L=>C.id===L.id)||(C=u.find(L=>C.id===L.id)??C,C.isTransient?this.l.profiles.push(C):s.push({location:C.location,name:C.name,shortName:C.shortName,useDefaultFlags:C.useDefaultFlags}));this.J(s),this.t=void 0,this.D(n,o,u)}D(n,o,u){this.g.fire({added:n,removed:o,updated:u,all:this.profiles})}F(n,o,u){u=o?.isTransient?!0:u,u||this.F(n,void 0,!0);const a=this.y(n),s=u?this.l:this.u;S.URI.isUri(a)?(s.workspaces.delete(a),o&&s.workspaces.set(a,o)):(s.emptyWindows.delete(a),o&&s.emptyWindows.set(a,o)),u||this.G()}G(){const n={};for(const[u,a]of this.u.workspaces.entries())n[u.toString()]=a.id;const o={};for(const[u,a]of this.u.emptyWindows.entries())o[u.toString()]=a.id;this.M({workspaces:n,emptyWindows:o}),this.t=void 0}H(n){const o={},u=this.v();if(n.workspaces)for(const[s,C]of Object.entries(n.workspaces)){const L=S.URI.parse(C);o[s]=this.r.extUri.isEqual(L,u.location)?u.id:this.r.extUri.basename(L)}const a={};if(n.emptyWindows)for(const[s,C]of Object.entries(n.emptyWindows)){const L=S.URI.parse(C);a[s]=this.r.extUri.isEqual(L,u.location)?u.id:this.r.extUri.basename(L)}return{workspaces:o,emptyWindows:a}}I(){return[]}J(n){throw new Error("not implemented")}L(){return{}}M(n){throw new Error("not implemented")}N(){}};t.b="userDataProfiles",t.c="profileAssociations",t=Te([Ae(0,y.IEnvironmentService),Ae(1,b.IFileService),Ae(2,m.IUriIdentityService),Ae(3,I.ILogService)],t),e.UserDataProfilesService=t;class r extends t{constructor(){super(...arguments),this.a=[],this.Q={}}I(){return this.a}J(n){this.a=n}L(){return this.Q}M(n){this.Q=n}}e.InMemoryUserDataProfilesService=r}),define(be[251],Ee([1,0,18,14,19,9,6,2,3,4,171,30,35,34,10,26,31,32]),function(oe,e,E,A,l,w,S,P,y,b,k,I,v,d,m,p,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.joinErrors=e.AbstractExtensionManagementService=e.ExtensionVerificationStatus=void 0;var g;(function(i){i.Verified="Verified",i.Unverified="Unverified",i.UnknownError="UnknownError"})(g=e.ExtensionVerificationStatus||(e.ExtensionVerificationStatus={}));let f=class extends P.Disposable{get onInstallExtension(){return this.l.event}get onDidInstallExtensions(){return this.m.event}get onUninstallExtension(){return this.n.event}get onDidUninstallExtension(){return this.p.event}constructor(n,o,u,a,s){super(),this.t=n,this.u=o,this.v=u,this.w=a,this.y=s,this.h=0,this.j=new Map,this.k=new Map,this.l=this.B(new S.Emitter),this.m=this.B(new S.Emitter),this.n=this.B(new S.Emitter),this.p=this.B(new S.Emitter),this.s=[],this.B((0,P.toDisposable)(()=>{this.j.forEach(({task:C})=>C.cancel()),this.k.forEach(C=>C.cancel()),this.j.clear(),this.k.clear()}))}async canInstall(n){const o=await this.getTargetPlatform();return n.allTargetPlatforms.some(u=>(0,I.isTargetPlatformCompatible)(u,n.allTargetPlatforms,o))}async installFromGallery(n,o={}){try{if(!this.t.isEnabled())throw new I.ExtensionManagementError(k.localize(0,null),I.ExtensionManagementErrorCode.Internal);const u=await this.G(n,!!o.installGivenVersion,!!o.installPreReleaseVersion);return await this.z(u.manifest,u.extension,o)}catch(u){throw t(this.u,"extensionGallery:install",{extensionData:(0,v.getGalleryExtensionTelemetryData)(n),error:u}),this.v.error("Failed to install extension.",n.identifier.id),this.v.error(u),R(u)}}async uninstall(n,o={}){return this.v.trace("ExtensionManagementService#uninstall",n.identifier.id),this.I(n,o)}getExtensionsControlManifest(){const n=new Date().getTime();return(!this.g||n-this.h>1e3*60*5)&&(this.g=this.O(),this.h=n),this.g}registerParticipant(n){this.s.push(n)}async z(n,o,u){const a={...u,installOnlyNewlyAddedFromExtensionPack:b.URI.isUri(o)?u.installOnlyNewlyAddedFromExtensionPack:!0,profileLocation:(0,d.isApplicationScopedExtension)(n)?this.y.defaultProfile.extensionsResource:u.profileLocation??this.P()},s=se=>`${v.ExtensionKey.create(se).toString()}${a.profileLocation?`-${a.profileLocation.toString()}`:""}`;if(!b.URI.isUri(o)){const se=this.j.get(s(o));if(se)return this.v.info("Extensions is already requested to install",o.identifier.id),se.task.waitUntilTaskIsFinished()}const C=[],L=[],O=[],W=this.Q(n,o,a);b.URI.isUri(o)||this.j.set(s(o),{task:W,waitingTasks:[]}),this.l.fire({identifier:W.identifier,source:o,profileLocation:a.profileLocation}),this.v.info("Installing extension:",W.identifier.id),C.push({task:W,manifest:n});let X=!1;try{if(a.donotIncludePackAndDependencies)this.v.info("Installing the extension without checking dependencies and pack",W.identifier.id);else try{const fe=await this.F(W.identifier,n,!!a.installOnlyNewlyAddedFromExtensionPack,!!a.installPreReleaseVersion,a.profileLocation),ce=await this.getInstalled(void 0,a.profileLocation);for(const{gallery:V,manifest:T}of(0,E.distinct)(fe,({gallery:z})=>z.identifier.id)){X=X||!!T.extensionDependencies?.some(H=>(0,v.areSameExtensions)({id:H},W.identifier));const z=s(V),he=this.j.get(z);if(he){if(this.C(W,he.task)){const H=he.task.identifier;this.v.info("Waiting for already requested installing extension",H.id,W.identifier.id),he.waitingTasks.push(W),L.push(S.Event.toPromise(S.Event.filter(this.onDidInstallExtensions,q=>q.some(M=>(0,v.areSameExtensions)(M.identifier,H)))).then(q=>{if(this.v.info("Finished waiting for already requested installing extension",H.id,W.identifier.id),!q.find(ee=>(0,v.areSameExtensions)(ee.identifier,H))?.local)throw new Error(`Extension ${H.id} is not installed`)}))}}else if(!ce.some(({identifier:H})=>(0,v.areSameExtensions)(H,V.identifier))){const H=this.Q(T,V,{...a,donotIncludePackAndDependencies:!0});this.j.set(z,{task:H,waitingTasks:[W]}),this.l.fire({identifier:H.identifier,source:V,profileLocation:a.profileLocation}),this.v.info("Installing extension:",H.identifier.id,W.identifier.id),C.push({task:H,manifest:T})}}}catch(fe){if(b.URI.isUri(W.source))(0,E.isNonEmptyArray)(n.extensionDependencies)&&this.v.warn("Cannot install dependencies of extension:",W.identifier.id,fe.message),(0,E.isNonEmptyArray)(n.extensionPack)&&this.v.warn("Cannot install packed extensions of extension:",W.identifier.id,fe.message);else throw this.v.error("Error while preparing to install dependencies and extension packs of the extension:",W.identifier.id),fe}const se=C.reduce((fe,{task:ce,manifest:V})=>(fe.set(ce.identifier.id.toLowerCase(),{task:ce,manifest:V}),fe),new Map);for(;se.size;){let fe;const ce=[...se.values()].filter(({manifest:V})=>!V.extensionDependencies?.some(T=>se.has(T.toLowerCase())));ce.length?fe=se.size===1?ce:ce.filter(({task:V})=>!(V===W&&!X)):(this.v.info("Found extensions with circular dependencies",ce.map(({task:V})=>V.identifier.id)),fe=[...se.values()]),await this.D(fe.map(async({task:V})=>{const T=new Date().getTime();try{const z=await V.run();if(await this.D(this.s.map(he=>he.postInstall(z,V.source,a,l.CancellationToken.None))),!b.URI.isUri(V.source)){const he=V.operation===3,H=he?void 0:(new Date().getTime()-V.source.lastUpdated)/1e3;if(t(this.u,he?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,v.getGalleryExtensionTelemetryData)(V.source),verificationStatus:V.verificationStatus,duration:new Date().getTime()-T,durationSinceUpdate:H}),y.isWeb&&V.operation!==3)try{await this.t.reportStatistic(z.manifest.publisher,z.manifest.name,z.manifest.version,"install")}catch{}}O.push({local:z,identifier:V.identifier,operation:V.operation,source:V.source,context:a.context,profileLocation:a.profileLocation,applicationScoped:z.isApplicationScoped})}catch(z){throw b.URI.isUri(V.source)||t(this.u,V.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,v.getGalleryExtensionTelemetryData)(V.source),verificationStatus:V.verificationStatus,duration:new Date().getTime()-T,error:z}),this.v.error("Error while installing the extension:",V.identifier.id),z}finally{se.delete(V.identifier.id.toLowerCase())}}))}return L.length&&await this.D(L),O.forEach(({identifier:fe})=>this.v.info("Extension installed successfully:",fe.id)),this.m.fire(O),O.filter(({identifier:fe})=>(0,v.areSameExtensions)(fe,W.identifier))[0].local}catch(se){if(C.forEach(({task:fe})=>fe.cancel()),O.length)try{const fe=await Promise.allSettled(O.map(({local:ce})=>this.R(ce,{versionOnly:!0,profileLocation:a.profileLocation}).run()));for(let ce=0;ce<fe.length;ce++){const V=fe[ce],{identifier:T}=O[ce];V.status==="fulfilled"?this.v.info("Rollback: Uninstalled extension",T.id):this.v.warn("Rollback: Error while uninstalling extension",T.id,(0,w.getErrorMessage)(V.reason))}}catch(fe){this.v.warn("Error while rolling back extensions",(0,w.getErrorMessage)(fe),O.map(({identifier:ce})=>ce.id))}throw this.m.fire(C.map(({task:fe})=>({identifier:fe.identifier,operation:2,source:fe.source,context:a.context,profileLocation:a.profileLocation}))),se}finally{for(const{task:se}of C)se.source&&!b.URI.isUri(se.source)&&this.j.delete(s(se.source))}}C(n,o){for(const[,{task:u,waitingTasks:a}]of this.j.entries())if(u===n&&(a.includes(o)||a.some(s=>this.C(s,o)))||u===o&&a[0]&&!this.C(n,a[0]))return!1;return!0}async D(n){const o=[],u=[],a=await Promise.allSettled(n);for(const s of a)s.status==="fulfilled"?o.push(s.value):u.push(s.reason);if(u.length)throw D(u);return o}async F(n,o,u,a,s){if(!this.t.isEnabled())return[];const C=await this.getInstalled(void 0,s),L=[],O=[],W=async(X,se)=>{L.push(X);const fe=se.extensionDependencies||[],ce=[...fe];if(se.extensionPack){const V=u?C.find(T=>(0,v.areSameExtensions)(T.identifier,X)):void 0;for(const T of se.extensionPack)V&&V.manifest.extensionPack&&V.manifest.extensionPack.some(z=>(0,v.areSameExtensions)({id:z},{id:T}))||ce.every(z=>!(0,v.areSameExtensions)({id:z},{id:T}))&&ce.push(T)}if(ce.length){const V=ce.filter(T=>L.every(z=>!(0,v.areSameExtensions)(z,{id:T})));if(V.length){const T=await this.t.getExtensions(V.map(z=>({id:z,preRelease:a})),l.CancellationToken.None);for(const z of T){if(L.find(q=>(0,v.areSameExtensions)(q,z.identifier)))continue;const he=fe.some(q=>(0,v.areSameExtensions)({id:q},z.identifier));let H;try{H=await this.G(z,!1,a)}catch(q){if(q instanceof I.ExtensionManagementError&&q.code===I.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!he){this.v.info("Skipping the packed extension as it cannot be installed",z.identifier.id);continue}else throw q}O.push({gallery:H.extension,manifest:H.manifest}),await W(H.extension.identifier,H.manifest)}}}};return await W(n,o),O}async G(n,o,u){if((await this.getExtensionsControlManifest()).malicious.some(L=>(0,v.areSameExtensions)(n.identifier,L)))throw new I.ExtensionManagementError(k.localize(1,null,n.identifier.id),I.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(n)){const L=await this.getTargetPlatform();throw new I.ExtensionManagementError(k.localize(2,null,n.identifier.id,this.w.nameLong,(0,I.TargetPlatformToString)(L)),I.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const s=await this.H(n,o,u);if(s){if(u&&!o&&n.hasPreReleaseVersion&&!s.properties.isPreReleaseVersion)throw new I.ExtensionManagementError(k.localize(3,null,n.identifier.id,this.w.nameLong,this.w.version),I.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!u&&n.properties.isPreReleaseVersion&&(await this.t.getExtensions([n.identifier],l.CancellationToken.None))[0]?new I.ExtensionManagementError(k.localize(4,null,n.identifier.id),I.ExtensionManagementErrorCode.ReleaseVersionNotFound):new I.ExtensionManagementError(k.localize(5,null,n.identifier.id,this.w.nameLong,this.w.version),I.ExtensionManagementErrorCode.Incompatible);this.v.info("Getting Manifest...",s.identifier.id);const C=await this.t.getManifest(s,l.CancellationToken.None);if(C===null)throw new I.ExtensionManagementError(`Missing manifest for extension ${n.identifier.id}`,I.ExtensionManagementErrorCode.Invalid);if(C.version!==s.version)throw new I.ExtensionManagementError(`Cannot install '${n.identifier.id}' extension because of version mismatch in Marketplace`,I.ExtensionManagementErrorCode.Invalid);return{extension:s,manifest:C}}async H(n,o,u){const a=await this.getTargetPlatform();let s=null;return!o&&n.hasPreReleaseVersion&&n.properties.isPreReleaseVersion!==u&&(s=(await this.t.getExtensions([{...n.identifier,preRelease:u}],{targetPlatform:a,compatible:!0},l.CancellationToken.None))[0]||null),!s&&await this.t.isExtensionCompatible(n,u,a)&&(s=n),s||(o?s=(await this.t.getExtensions([{...n.identifier,version:n.version}],{targetPlatform:a,compatible:!0},l.CancellationToken.None))[0]||null:s=await this.t.getCompatibleExtension(n,u,a)),s}async I(n,o){const u={...o,profileLocation:n.isApplicationScoped?this.y.defaultProfile.extensionsResource:o.profileLocation??this.P()},a=X=>`${X.id.toLowerCase()}${u.versionOnly?`-${n.manifest.version}`:""}${u.profileLocation?`@${u.profileLocation.toString()}`:""}`,s=this.k.get(a(n.identifier));if(s)return this.v.info("Extensions is already requested to uninstall",n.identifier.id),s.waitUntilTaskIsFinished();const C=X=>{const se=this.R(X,u);return this.k.set(a(se.extension.identifier),se),u.profileLocation?this.v.info("Uninstalling extension from the profile:",`${X.identifier.id}@${X.manifest.version}`,u.profileLocation.toString()):this.v.info("Uninstalling extension:",`${X.identifier.id}@${X.manifest.version}`),this.n.fire({identifier:X.identifier,profileLocation:u.profileLocation,applicationScoped:X.isApplicationScoped}),se},L=(X,se)=>{se?u.profileLocation?this.v.error("Failed to uninstall extension from the profile:",`${X.identifier.id}@${X.manifest.version}`,u.profileLocation.toString(),se.message):this.v.error("Failed to uninstall extension:",`${X.identifier.id}@${X.manifest.version}`,se.message):u.profileLocation?this.v.info("Successfully uninstalled extension from the profile",`${X.identifier.id}@${X.manifest.version}`,u.profileLocation.toString()):this.v.info("Successfully uninstalled extension:",`${X.identifier.id}@${X.manifest.version}`),t(this.u,"extensionGallery:uninstall",{extensionData:(0,v.getLocalExtensionTelemetryData)(X),error:se}),this.p.fire({identifier:X.identifier,error:se?.code,profileLocation:u.profileLocation,applicationScoped:X.isApplicationScoped})},O=[],W=[];try{O.push(C(n));const X=await this.getInstalled(1,u.profileLocation);if(u.donotIncludePack)this.v.info("Uninstalling the extension without including packed extension",`${n.identifier.id}@${n.manifest.version}`);else{const se=this.M(n,X);for(const fe of se)this.k.has(a(fe.identifier))?this.v.info("Extensions is already requested to uninstall",fe.identifier.id):O.push(C(fe))}u.donotCheckDependents?this.v.info("Uninstalling the extension without checking dependents",`${n.identifier.id}@${n.manifest.version}`):this.J(O.map(se=>se.extension),X,n),await this.D(O.map(async se=>{try{if(await se.run(),await this.D(this.s.map(fe=>fe.postUninstall(se.extension,u,l.CancellationToken.None))),se.extension.identifier.uuid)try{await this.t.reportStatistic(se.extension.manifest.publisher,se.extension.manifest.name,se.extension.manifest.version,"uninstall")}catch{}L(se.extension)}catch(fe){const ce=fe instanceof I.ExtensionManagementError?fe:new I.ExtensionManagementError((0,w.getErrorMessage)(fe),I.ExtensionManagementErrorCode.Internal);throw L(se.extension,ce),ce}finally{W.push(se)}}))}catch(X){const se=X instanceof I.ExtensionManagementError?X:new I.ExtensionManagementError((0,w.getErrorMessage)(X),I.ExtensionManagementErrorCode.Internal);for(const fe of O){try{fe.cancel()}catch{}W.includes(fe)||L(fe.extension,se)}throw se}finally{for(const X of O)this.k.delete(a(X.extension.identifier))||this.v.warn("Uninstallation task is not found in the cache",X.extension.identifier.id)}}J(n,o,u){for(const a of n){const s=this.N(a,o);if(s.length){const C=s.filter(L=>!n.some(O=>(0,v.areSameExtensions)(O.identifier,L.identifier)));if(C.length)throw new Error(this.L(a,C,u))}}}L(n,o,u){return u===n?o.length===1?k.localize(6,null,u.manifest.displayName||u.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?k.localize(7,null,u.manifest.displayName||u.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):k.localize(8,null,u.manifest.displayName||u.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):o.length===1?k.localize(9,null,u.manifest.displayName||u.manifest.name,n.manifest.displayName||n.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?k.localize(10,null,u.manifest.displayName||u.manifest.name,n.manifest.displayName||n.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):k.localize(11,null,u.manifest.displayName||u.manifest.name,n.manifest.displayName||n.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name)}M(n,o,u=[]){if(u.indexOf(n)!==-1)return[];u.push(n);const a=n.manifest.extensionPack?n.manifest.extensionPack:[];if(a.length){const s=o.filter(L=>!L.isBuiltin&&a.some(O=>(0,v.areSameExtensions)({id:O},L.identifier))),C=[];for(const L of s)C.push(...this.M(L,o,u));return[...s,...C]}return[]}N(n,o){return o.filter(u=>u.manifest.extensionDependencies&&u.manifest.extensionDependencies.some(a=>(0,v.areSameExtensions)({id:a},n.identifier)))}async O(){try{this.v.trace("ExtensionManagementService.refreshReportedCache");const n=await this.t.getExtensionsControlManifest();return this.v.trace("ExtensionManagementService.refreshControlCache",n),n}catch{return this.v.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}};f=Te([Ae(0,I.IExtensionGalleryService),Ae(1,c.ITelemetryService),Ae(2,m.ILogService),Ae(3,p.IProductService),Ae(4,h.IUserDataProfilesService)],f),e.AbstractExtensionManagementService=f;function D(i){const n=Array.isArray(i)?i:[i];return n.length===1?n[0]instanceof Error?n[0]:new Error(n[0]):n.reduce((o,u)=>new Error(`${o.message}${o.message?",":""}${u instanceof Error?u.message:u}`),new Error(""))}e.joinErrors=D;function R(i){if(i instanceof I.ExtensionManagementError)return i;const n=new I.ExtensionManagementError(i.message,I.ExtensionManagementErrorCode.Internal);return n.stack=i.stack,n}function t(i,n,{extensionData:o,verificationStatus:u,duration:a,error:s,durationSinceUpdate:C}){let L,O;s&&(s instanceof I.ExtensionManagementError?(L=s.code,s.code===I.ExtensionManagementErrorCode.Signature&&(O=s.message)):L=I.ExtensionManagementErrorCode.Internal),i.publicLog(n,{...o,verificationStatus:u,success:!s,duration:a,errorcode:L,errorcodeDetail:O,durationSinceUpdate:C})}class r{constructor(){this.d=new A.Barrier}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}async run(){return this.g||(this.g=(0,A.createCancelablePromise)(n=>this.h(n))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,A.createCancelablePromise)(n=>new Promise((o,u)=>{const a=n.onCancellationRequested(()=>{a.dispose(),u(new w.CancellationError)})})),this.d.open()),this.g.cancel()}}e.AbstractExtensionTask=r}),define(be[44],Ee([1,0,14,15,2,6,27,4,30,35,16,5,10,32,36,8,9,31]),function(oe,e,E,A,l,w,S,P,y,b,k,I,v,d,m,p,c,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsProfileScannerService=e.IExtensionsProfileScannerService=e.ExtensionsProfileScanningError=e.ExtensionsProfileScanningErrorCode=void 0;var g;(function(r){r.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",r.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(g=e.ExtensionsProfileScanningErrorCode||(e.ExtensionsProfileScanningErrorCode={}));class f extends Error{constructor(i,n){super(i),this.code=n}}e.ExtensionsProfileScanningError=f,e.IExtensionsProfileScannerService=(0,I.createDecorator)("IExtensionsProfileScannerService");let D=class extends l.Disposable{constructor(i,n,o,u,a,s){super(),this.i=i,this.j=n,this.k=o,this.l=u,this.m=a,this.n=s,this.b=this.B(new w.Emitter),this.onAddExtensions=this.b.event,this.c=this.B(new w.Emitter),this.onDidAddExtensions=this.c.event,this.f=this.B(new w.Emitter),this.onRemoveExtensions=this.f.event,this.g=this.B(new w.Emitter),this.onDidRemoveExtensions=this.g.event,this.h=new S.ResourceMap}scanProfileExtensions(i,n){return this.p(i,void 0,n)}async addExtensionsToProfile(i,n){const o=[],u=[];try{return await this.p(n,a=>{const s=[];for(const C of a)i.some(([L])=>(0,b.areSameExtensions)(L.identifier,C.identifier)&&L.manifest.version!==C.version)?o.push(C):s.push(C);for(const[C,L]of i)if(!s.some(O=>(0,b.areSameExtensions)(O.identifier,C.identifier)&&O.version===C.manifest.version)){const O={identifier:C.identifier,version:C.manifest.version,location:C.location,metadata:L};u.push(O),s.push(O)}return u.length&&this.b.fire({extensions:u,profileLocation:n}),o.length&&this.f.fire({extensions:o,profileLocation:n}),s}),u.length&&this.c.fire({extensions:u,profileLocation:n}),o.length&&this.g.fire({extensions:o,profileLocation:n}),u}catch(a){throw u.length&&this.c.fire({extensions:u,error:a,profileLocation:n}),o.length&&this.g.fire({extensions:o,error:a,profileLocation:n}),a}}async updateMetadata(i,n){const o=[];return await this.p(n,u=>{const a=[];for(const s of u){const C=i.find(([L])=>(0,b.areSameExtensions)(L.identifier,s.identifier)&&L.manifest.version===s.version);C&&(s.metadata={...s.metadata,...C[1]},o.push(s)),a.push(s)}return a}),o}async removeExtensionFromProfile(i,n){const o=[];this.f.fire({extensions:o,profileLocation:n});try{await this.p(n,u=>{const a=[];for(const s of u)(0,b.areSameExtensions)(s.identifier,i.identifier)?o.push(s):a.push(s);return o.length&&this.f.fire({extensions:o,profileLocation:n}),a}),o.length&&this.g.fire({extensions:o,profileLocation:n})}catch(u){throw o.length&&this.g.fire({extensions:o,error:u,profileLocation:n}),u}}async p(i,n,o){return this.w(i).queue(async()=>{let u=[],a;try{const s=await this.j.readFile(i);a=JSON.parse(s.value.toString().trim()||"[]")}catch(s){if((0,k.toFileOperationResult)(s)!==1)throw s;if(this.l.extUri.isEqual(i,this.k.defaultProfile.extensionsResource)&&(a=await this.v()),!a&&o?.bailOutWhenFileNotFound)throw new f((0,c.getErrorMessage)(s),"ERROR_PROFILE_NOT_FOUND")}if(a){Array.isArray(a)||this.r(i);let s=!1;for(const C of a){R(C)||this.r(i);let L;if((0,p.isString)(C.relativeLocation)&&C.relativeLocation)L=this.t(C.relativeLocation);else if((0,p.isString)(C.location))L=this.t(C.location),s=!0,C.relativeLocation=C.location,C.location=L.toJSON();else{L=P.URI.revive(C.location);const O=this.s(L);O&&(s=!0,C.relativeLocation=O)}u.push({identifier:C.identifier,location:L,version:C.version,metadata:C.metadata})}s&&await this.j.writeFile(i,A.VSBuffer.fromString(JSON.stringify(a)))}if(n){u=n(u);const s=u.map(C=>({identifier:C.identifier,version:C.version,location:C.location.toJSON(),relativeLocation:this.s(C.location),metadata:C.metadata}));await this.j.writeFile(i,A.VSBuffer.fromString(JSON.stringify(s)))}return u})}r(i){const n=new f(`Invalid extensions content in ${i.toString()}`,"ERROR_INVALID_CONTENT");throw this.m.publicLogError2("extensionsProfileScanningError",{code:n.code}),n}s(i){return this.l.extUri.isEqual(this.l.extUri.dirname(i),this.i)?this.l.extUri.basename(i):void 0}t(i){return this.l.extUri.joinPath(this.i,i)}async v(){return this.u||(this.u=(async()=>{const i=this.l.extUri.joinPath(this.k.defaultProfile.location,"extensions.json"),n=this.l.extUri.joinPath(this.i,".init-default-profile-extensions");let o;try{o=(await this.j.readFile(i)).value.toString()}catch(a){if((0,k.toFileOperationResult)(a)===1)return;throw a}this.n.info("Migrating extensions from old default profile location",i.toString());let u;try{const a=JSON.parse(o);Array.isArray(a)&&a.every(s=>R(s))?u=a:this.n.warn("Skipping migrating from old default profile locaiton: Found invalid data",a)}catch(a){this.n.error(a)}if(u)try{await this.j.createFile(this.k.defaultProfile.extensionsResource,A.VSBuffer.fromString(JSON.stringify(u)),{overwrite:!1}),this.n.info("Migrated extensions from old default profile location to new location",i.toString(),this.k.defaultProfile.extensionsResource.toString())}catch(a){if((0,k.toFileOperationResult)(a)===3)this.n.info("Migration from old default profile location to new location is done by another window",i.toString(),this.k.defaultProfile.extensionsResource.toString());else throw a}try{await this.j.del(i)}catch(a){(0,k.toFileOperationResult)(a)!==1&&this.n.error(a)}try{await this.j.del(n)}catch(a){(0,k.toFileOperationResult)(a)!==1&&this.n.error(a)}return u})()),this.u}w(i){let n=this.h.get(i);return n||(n=new E.Queue,this.h.set(i,n)),n}};D=Te([Ae(1,k.IFileService),Ae(2,d.IUserDataProfilesService),Ae(3,m.IUriIdentityService),Ae(4,h.ITelemetryService),Ae(5,v.ILogService)],D),e.AbstractExtensionsProfileScannerService=D;function R(r){return(0,p.isObject)(r)&&(0,y.isIExtensionIdentifier)(r.identifier)&&(t(r.location)||(0,p.isString)(r.location)&&r.location)&&((0,p.isUndefined)(r.relativeLocation)||(0,p.isString)(r.relativeLocation))&&r.version&&(0,p.isString)(r.version)}function t(r){return r?(0,p.isString)(r.path)&&(0,p.isString)(r.scheme):!1}}),define(be[55],Ee([1,0,18,14,23,15,9,71,166,2,13,7,3,20,50,59,8,4,175,25,35,34,73,16,5,10,26,6,61,44,32,36,204,205]),function(oe,e,E,A,l,w,S,P,y,b,k,I,v,d,m,p,c,h,g,f,D,R,t,r,i,n,o,u,a,s,C,L,O,W){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.ExtensionScannerInput=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var X;(function(he){function H(q,M){if(q===M)return!0;const ee=Object.keys(q),ie=new Set;for(const me of Object.keys(M))ie.add(me);if(ee.length!==ie.size)return!1;for(const me of ee){if(q[me]!==M[me])return!1;ie.delete(me)}return ie.size===0}he.equals=H})(X=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,i.createDecorator)("IExtensionsScannerService");let se=class extends b.Disposable{constructor(H,q,M,ee,ie,me,ne,B,N,U,G,te){super(),this.systemExtensionsLocation=H,this.userExtensionsLocation=q,this.l=M,this.m=ee,this.n=ie,this.p=me,this.r=ne,this.s=B,this.t=N,this.u=U,this.v=G,this.w=te,this.g=this.B(new u.Emitter),this.onDidChangeCache=this.g.event,this.h=(0,d.joinPath)(this.userExtensionsLocation,".obsolete"),this.i=this.B(this.w.createInstance(V,(0,d.joinPath)(this.m,R.BUILTIN_MANIFEST_CACHE_FILE),this.h)),this.j=this.B(this.w.createInstance(V,(0,d.joinPath)(this.m,R.USER_MANIFEST_CACHE_FILE),this.h)),this.k=this.B(this.w.createInstance(ce,this.h)),this.z=void 0,this.B(this.i.onDidChangeCache(()=>this.g.fire(0))),this.B(this.j.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.y||(this.y=(0,D.computeTargetPlatform)(this.r,this.s)),this.y}async scanAllExtensions(H,q,M){const[ee,ie]=await Promise.all([this.scanSystemExtensions(H),this.scanUserExtensions(q)]),me=M?await this.scanExtensionsUnderDevelopment(H,[...ee,...ie]):[];return this.F(ee,ie,me,await this.getTargetPlatform(),!0)}async scanSystemExtensions(H){const q=[];q.push(this.G(!!H.useCache,H.language)),q.push(this.H(H.language,!!H.checkControlFile));const[M,ee]=await Promise.all(q);return this.D([...M,...ee],0,H,!1)}async scanUserExtensions(H){const q=H.profileLocation??this.userExtensionsLocation;this.s.trace("Started scanning user extensions",q);const M=this.v.extUri.isEqual(H.profileLocation,this.n.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,ee=await this.J(q,!!H.profileLocation,1,!H.includeUninstalled,H.language,!0,M),ie=H.useCache&&!ee.devMode&&ee.excludeObsolete?this.j:this.k;let me;try{me=await ie.scanExtensions(ee)}catch(ne){if(ne instanceof s.ExtensionsProfileScanningError&&ne.code==="ERROR_PROFILE_NOT_FOUND")await this.C(),me=await ie.scanExtensions(ee);else throw ne}return me=await this.D(me,1,H,!0),this.s.trace("Scanned user extensions:",me.length),me}async scanExtensionsUnderDevelopment(H,q){if(this.t.isExtensionDevelopment&&this.t.extensionDevelopmentLocationURI){const M=(await Promise.all(this.t.extensionDevelopmentLocationURI.filter(ee=>ee.scheme===k.Schemas.file).map(async ee=>{const ie=await this.J(ee,!1,1,!0,H.language,!1,void 0);return(await this.k.scanOneOrMultipleExtensions(ie)).map(ne=>(ne.type=q.find(B=>(0,D.areSameExtensions)(B.identifier,ne.identifier))?.type??ne.type,this.k.validate(ne,ie)))}))).flat();return this.D(M,"development",H,!0)}return[]}async scanExistingExtension(H,q,M){const ee=await this.J(H,!1,q,!0,M.language,!0,void 0),ie=await this.k.scanExtension(ee);return!ie||!M.includeInvalid&&!ie.isValid?null:ie}async scanOneOrMultipleExtensions(H,q,M){const ee=await this.J(H,!1,q,!0,M.language,!0,void 0),ie=await this.k.scanOneOrMultipleExtensions(ee);return this.D(ie,q,M,!0)}async scanMetadata(H){const q=(0,d.joinPath)(H,"package.json"),M=(await this.r.readFile(q)).value.toString();return JSON.parse(M).__metadata}async updateMetadata(H,q){const M=(0,d.joinPath)(H,"package.json"),ee=(await this.r.readFile(M)).value.toString(),ie=JSON.parse(ee);q.isMachineScoped=q.isMachineScoped||void 0,q.isBuiltin=q.isBuiltin||void 0,ie.__metadata={...ie.__metadata,...q},await this.r.writeFile((0,d.joinPath)(H,"package.json"),w.VSBuffer.fromString(JSON.stringify(ie,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.p.scanProfileExtensions(this.n.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(H){if(H instanceof s.ExtensionsProfileScanningError&&H.code==="ERROR_PROFILE_NOT_FOUND")await this.C();else throw H}}async C(){return this.z||(this.z=(async()=>{try{this.s.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const H=await this.scanUserExtensions({includeInvalid:!0});if(H.length)await this.p.addExtensionsToProfile(H.map(q=>[q,q.metadata]),this.n.defaultProfile.extensionsResource);else try{await this.r.createFile(this.n.defaultProfile.extensionsResource,w.VSBuffer.fromString(JSON.stringify([])))}catch(q){(0,r.toFileOperationResult)(q)!==1&&this.s.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,S.getErrorMessage)(q))}this.s.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(H){this.s.error(H)}finally{this.z=void 0}})()),this.z}async D(H,q,M,ee){return M.includeAllVersions||(H=this.F(q===0?H:void 0,q===1?H:void 0,q==="development"?H:void 0,await this.getTargetPlatform(),ee)),M.includeInvalid||(H=H.filter(ie=>ie.isValid)),H.sort((ie,me)=>{const ne=I.basename(ie.location.fsPath),B=I.basename(me.location.fsPath);return ne<B?-1:ne>B?1:0})}F(H,q,M,ee,ie){const me=(B,N,U)=>{if(B.isValid&&!N.isValid)return!1;if(B.isValid===N.isValid){if(ie&&m.gt(B.manifest.version,N.manifest.version))return this.s.debug(`Skipping extension ${N.location.path} with lower version ${N.manifest.version} in favour of ${B.location.path} with version ${B.manifest.version}`),!1;if(m.eq(B.manifest.version,N.manifest.version)){if(B.type===0)return this.s.debug(`Skipping extension ${N.location.path} in favour of system extension ${B.location.path} with same version`),!1;if(B.targetPlatform===ee)return this.s.debug(`Skipping extension ${N.location.path} from different target platform ${N.targetPlatform}`),!1}}return U?this.s.warn(`Overwriting user extension ${B.location.path} with ${N.location.path}.`):this.s.debug(`Overwriting user extension ${B.location.path} with ${N.location.path}.`),!0},ne=new Map;return H?.forEach(B=>{const N=R.ExtensionIdentifier.toKey(B.identifier.id),U=ne.get(N);(!U||me(U,B,!1))&&ne.set(N,B)}),q?.forEach(B=>{const N=R.ExtensionIdentifier.toKey(B.identifier.id),U=ne.get(N);if(!U&&H&&B.type===0){this.s.debug(`Skipping obsolete system extension ${B.location.path}.`);return}(!U||me(U,B,!1))&&ne.set(N,B)}),M?.forEach(B=>{const N=R.ExtensionIdentifier.toKey(B.identifier.id),U=ne.get(N);(!U||me(U,B,!0))&&ne.set(N,B),ne.set(N,B)}),[...ne.values()]}async G(H,q){this.s.trace("Started scanning system extensions");const M=await this.J(this.systemExtensionsLocation,!1,0,!0,q,!0,void 0),ie=await(H&&!M.devMode?this.i:this.k).scanExtensions(M);return this.s.trace("Scanned system extensions:",ie.length),ie}async H(H,q){const M=this.t.isBuilt?[]:this.u.builtInExtensions;if(!M?.length)return[];this.s.trace("Started scanning dev system extensions");const ee=q?await this.I():{},ie=[],me=h.URI.file(I.normalize(I.join(k.FileAccess.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const B of M){const N=ee[B.name]||"marketplace";switch(N){case"disabled":break;case"marketplace":ie.push((0,d.joinPath)(me,B.name));break;default:ie.push(h.URI.file(N));break}}const ne=await Promise.all(ie.map(async B=>this.k.scanExtension(await this.J(B,!1,0,!0,H,!0,void 0))));return this.s.trace("Scanned dev system extensions:",ne.length),(0,E.coalesce)(ne)}async I(){try{const H=await this.r.readFile(this.l);return JSON.parse(H.value.toString())}catch{return{}}}async J(H,q,M,ee,ie,me,ne){const B=await this.f(ie??v.language),N=await this.L(H),U=q&&!this.v.extUri.isEqual(H,this.n.defaultProfile.extensionsResource)?this.n.defaultProfile.extensionsResource:void 0,G=U?await this.L(U):void 0;return new fe(H,N,U,G,q,ne,M,ee,me,this.u.version,this.u.date,this.u.commit,!this.t.isBuilt,ie,B)}async L(H){try{const q=await this.r.stat(H);if(typeof q.mtime=="number")return q.mtime}catch{}}};se=Te([Ae(4,C.IUserDataProfilesService),Ae(5,s.IExtensionsProfileScannerService),Ae(6,r.IFileService),Ae(7,n.ILogService),Ae(8,f.IEnvironmentService),Ae(9,o.IProductService),Ae(10,L.IUriIdentityService),Ae(11,i.IInstantiationService)],se),e.AbstractExtensionsScannerService=se;class fe{constructor(H,q,M,ee,ie,me,ne,B,N,U,G,te,le,j,K){this.location=H,this.mtime=q,this.applicationExtensionslocation=M,this.applicationExtensionslocationMtime=ee,this.profile=ie,this.profileScanOptions=me,this.type=ne,this.excludeObsolete=B,this.validate=N,this.productVersion=U,this.productDate=G,this.productCommit=te,this.devMode=le,this.language=j,this.translations=K}static createNlsConfiguration(H){return{language:H.language,pseudo:H.language==="pseudo",devMode:H.devMode,translations:H.translations}}static equals(H,q){return(0,d.isEqual)(H.location,q.location)&&H.mtime===q.mtime&&(0,d.isEqual)(H.applicationExtensionslocation,q.applicationExtensionslocation)&&H.applicationExtensionslocationMtime===q.applicationExtensionslocationMtime&&H.profile===q.profile&&l.equals(H.profileScanOptions,q.profileScanOptions)&&H.type===q.type&&H.excludeObsolete===q.excludeObsolete&&H.validate===q.validate&&H.productVersion===q.productVersion&&H.productDate===q.productDate&&H.productCommit===q.productCommit&&H.devMode===q.devMode&&H.language===q.language&&X.equals(H.translations,q.translations)}}e.ExtensionScannerInput=fe;let ce=class extends b.Disposable{constructor(H,q,M,ee,ie){super(),this.f=H,this.g=q,this.h=M,this.i=ee,this.j=ie}async scanExtensions(H){const q=H.profile?await this.l(H):await this.k(H);let M={};if(H.excludeObsolete&&H.type===1)try{const ee=(await this.i.readFile(this.f)).value.toString();M=JSON.parse(ee)}catch{}return(0,c.isEmptyObject)(M)?q:q.filter(ee=>!M[D.ExtensionKey.create(ee).toString()])}async k(H){const q=await this.i.resolve(H.location);if(!q.children?.length)return[];const M=await Promise.all(q.children.map(async ee=>{if(!ee.isDirectory||H.type===1&&(0,d.basename)(ee.resource).indexOf(".")===0)return null;const ie=new fe(ee.resource,H.mtime,H.applicationExtensionslocation,H.applicationExtensionslocationMtime,H.profile,H.profileScanOptions,H.type,H.excludeObsolete,H.validate,H.productVersion,H.productDate,H.productCommit,H.devMode,H.language,H.translations);return this.scanExtension(ie)}));return(0,E.coalesce)(M).sort((ee,ie)=>ee.location.path<ie.location.path?-1:1)}async l(H){let q=await this.m(H.location,()=>!0,H);if(H.applicationExtensionslocation&&!this.h.extUri.isEqual(H.location,H.applicationExtensionslocation)){q=q.filter(ee=>!ee.metadata?.isApplicationScoped);const M=await this.m(H.applicationExtensionslocation,ee=>!!ee.metadata?.isApplicationScoped,H);q.push(...M)}return q}async m(H,q,M){const ee=await this.g.scanProfileExtensions(H,M.profileScanOptions);if(!ee.length)return[];const ie=await Promise.all(ee.map(async me=>{if(q(me)){const ne=new fe(me.location,M.mtime,M.applicationExtensionslocation,M.applicationExtensionslocationMtime,M.profile,M.profileScanOptions,M.type,M.excludeObsolete,M.validate,M.productVersion,M.productDate,M.productCommit,M.devMode,M.language,M.translations);return this.scanExtension(ne,me.metadata)}return null}));return(0,E.coalesce)(ie)}async scanOneOrMultipleExtensions(H){try{if(await this.i.exists((0,d.joinPath)(H.location,"package.json"))){const q=await this.scanExtension(H);return q?[q]:[]}else return await this.scanExtensions(H)}catch(q){return this.j.error(`Error scanning extensions at ${H.location.path}:`,(0,S.getErrorMessage)(q)),[]}}async scanExtension(H,q){try{let M=await this.scanExtensionManifest(H.location);if(M){M.publisher||(M.publisher=R.UNDEFINED_PUBLISHER),q=q??M.__metadata,delete M.__metadata;const ee=(0,D.getGalleryExtensionId)(M.publisher,M.name),ie=q?.id?{id:ee,uuid:q.id}:{id:ee},me=q?.isSystem?0:H.type,ne=me===0||!!q?.isBuiltin;W.ImplicitActivationEvents.updateManifest(M),M=await this.n(H.location,M,fe.createNlsConfiguration(H));const B={type:me,identifier:ie,manifest:M,location:H.location,isBuiltin:ne,targetPlatform:q?.targetPlatform??"undefined",metadata:q,isValid:!0,validations:[]};return H.validate?this.validate(B,H):B}}catch(M){H.type!==0&&this.j.error(M)}return null}validate(H,q){let M=!0;const ee=(0,t.validateExtensionManifest)(q.productVersion,q.productDate,q.location,H.manifest,H.isBuiltin);for(const[ie,me]of ee)ie===p.default.Error&&(M=!1,this.j.error(this.t(q.location,me)));return H.isValid=M,H.validations=ee,H}async scanExtensionManifest(H){const q=(0,d.joinPath)(H,"package.json");let M;try{M=(await this.i.readFile(q)).value.toString()}catch(ie){return(0,r.toFileOperationResult)(ie)!==1&&this.j.error(this.t(H,(0,g.localize)(0,null,q.path,ie.message))),null}let ee;try{ee=JSON.parse(M)}catch{const me=[];(0,P.parse)(M,me);for(const ne of me)this.j.error(this.t(H,(0,g.localize)(1,null,q.path,ne.offset,ne.length,(0,y.getParseErrorMessage)(ne.error))));return null}return(0,P.getNodeType)(ee)!=="object"?(this.j.error(this.t(H,(0,g.localize)(2,null,q.path))),null):ee}async n(H,q,M){const ee=await this.p(H,q,M);if(ee)try{const ie=[],me=await this.r(ee.default,ie);if(ie.length>0)return ie.forEach(B=>{this.j.error(this.t(H,(0,g.localize)(3,null,ee.default?.path,(0,y.getParseErrorMessage)(B.error))))}),q;if((0,P.getNodeType)(ee)!=="object")return this.j.error(this.t(H,(0,g.localize)(4,null,ee.default?.path))),q;const ne=ee.values||Object.create(null);return(0,O.localizeManifest)(q,ne,me)}catch{}return q}async p(H,q,M){const ee=(0,d.joinPath)(H,"package.nls.json"),ie=(N,U)=>{U.forEach(G=>{this.j.error(this.t(H,(0,g.localize)(5,null,N?.path,(0,y.getParseErrorMessage)(G.error))))})},me=N=>{this.j.error(this.t(H,(0,g.localize)(6,null,N?.path)))},ne=`${q.publisher}.${q.name}`,B=M.translations[ne];if(B)try{const N=h.URI.file(B),U=(await this.i.readFile(N)).value.toString(),G=[],te=(0,P.parse)(U,G);return G.length>0?(ie(N,G),{values:void 0,default:ee}):(0,P.getNodeType)(te)!=="object"?(me(N),{values:void 0,default:ee}):{values:te.contents?te.contents.package:void 0,default:ee}}catch{return{values:void 0,default:ee}}else{if(!await this.i.exists(ee))return;let U;try{U=await this.s(H,M)}catch{return}if(!U.localized)return{values:void 0,default:U.original};try{const G=(await this.i.readFile(U.localized)).value.toString(),te=[],le=(0,P.parse)(G,te);return te.length>0?(ie(U.localized,te),{values:void 0,default:U.original}):(0,P.getNodeType)(le)!=="object"?(me(U.localized),{values:void 0,default:U.original}):{values:le,default:U.original}}catch{return{values:void 0,default:U.original}}}}async r(H,q){if(H)try{const M=(await this.i.readFile(H)).value.toString();return(0,P.parse)(M,q)}catch{}}s(H,q){return new Promise((M,ee)=>{const ie=me=>{const ne=(0,d.joinPath)(H,`package.nls.${me}.json`);this.i.exists(ne).then(B=>{B&&M({localized:ne,original:(0,d.joinPath)(H,"package.nls.json")});const N=me.lastIndexOf("-");N===-1?M({localized:(0,d.joinPath)(H,"package.nls.json"),original:null}):(me=me.substring(0,N),ie(me))})};if(q.devMode||q.pseudo||!q.language)return M({localized:(0,d.joinPath)(H,"package.nls.json"),original:null});ie(q.language)})}t(H,q){return`[${H.path}]: ${q}`}};ce=Te([Ae(1,s.IExtensionsProfileScannerService),Ae(2,L.IUriIdentityService),Ae(3,r.IFileService),Ae(4,n.ILogService)],ce);let V=class extends ce{constructor(H,q,M,ee,ie,me){super(q,M,ee,ie,me),this.y=H,this.v=this.B(new A.ThrottledDelayer(3e3)),this.w=this.B(new u.Emitter),this.onDidChangeCache=this.w.event}async scanExtensions(H){const q=await this.z();if(this.u=H,q&&q.input&&fe.equals(q.input,this.u))return this.j.debug("Using cached extensions scan result",H.location.toString()),this.v.trigger(()=>this.D()),q.result.map(ee=>(ee.location=h.URI.revive(ee.location),ee));const M=await super.scanExtensions(H);return await this.C({input:H,result:M}),M}async z(){try{const H=await this.i.readFile(this.y),q=JSON.parse(H.value.toString());return{result:q.result,input:(0,a.revive)(q.input)}}catch(H){this.j.debug("Error while reading the extension cache file:",this.y.path,(0,S.getErrorMessage)(H))}return null}async C(H){try{await this.i.writeFile(this.y,w.VSBuffer.fromString(JSON.stringify(H)))}catch(q){this.j.debug("Error while writing the extension cache file:",this.y.path,(0,S.getErrorMessage)(q))}}async D(){if(!this.u)return;const H=await this.z();if(!H)return;const q=H.result,M=JSON.parse(JSON.stringify(await super.scanExtensions(this.u)));if(!l.equals(M,q))try{await this.i.del(this.y),this.w.fire()}catch(ee){this.j.error(ee)}}};V=Te([Ae(2,s.IExtensionsProfileScannerService),Ae(3,L.IUriIdentityService),Ae(4,r.IFileService),Ae(5,n.ILogService)],V);function T(he,H){const q=(0,D.getExtensionId)(he.manifest.publisher,he.manifest.name);return{id:q,identifier:new R.ExtensionIdentifier(q),isBuiltin:he.type===0,isUserBuiltin:he.type===1&&he.isBuiltin,isUnderDevelopment:H,extensionLocation:he.location,uuid:he.identifier.uuid,targetPlatform:he.targetPlatform,...he.manifest}}e.toExtensionDescription=T;class z extends se{constructor(H,q,M,ee,ie,me,ne,B,N,U,G,te){super(H,q,(0,d.joinPath)(M,".vscode-oss-dev","extensions","control.json"),(0,d.joinPath)(ee,R.MANIFEST_CACHE_FOLDER),ie,me,ne,B,N,U,G,te),this.M=(async()=>{if(v.translationsConfigFile)try{const le=await this.r.readFile(h.URI.file(v.translationsConfigFile));return JSON.parse(le.value.toString())}catch{}return Object.create(null)})()}f(H){return this.M}}e.NativeExtensionsScannerService=z}),define(be[252],Ee([1,0,48,14,39,6,2,13,7,22,10,32]),function(oe,e,E,A,l,w,S,P,y,b,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let v=class extends S.Disposable{constructor(m,p){super(),this.b=m,this.f=p,this.a=new A.Limiter(5)}async postUninstall(m){const p=this.g(m,"uninstall");p&&(this.f.info(m.identifier.id,m.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(p.script,"uninstall",p.args,!0,m),this.f.info("Finished running post uninstall script",m.identifier.id,m.manifest.version)}catch(c){this.f.error("Failed to run post uninstall script",m.identifier.id,m.manifest.version),this.f.error(c)}}));try{await b.Promises.rm(this.j(m))}catch(c){this.f.error("Error while removing extension storage path",m.identifier.id),this.f.error(c)}}g(m,p){const c=`vscode:${p}`;if(m.location.scheme===P.Schemas.file&&m.manifest&&m.manifest.scripts&&typeof m.manifest.scripts[c]=="string"){const h=m.manifest.scripts[c].split(" ");return h.length<2||h[0]!=="node"||!h[1]?(this.f.warn(m.identifier.id,m.manifest.version,`${c} should be a node script`),null):{script:(0,y.join)(m.location.fsPath,h[1]),args:h.slice(2)||[]}}return null}h(m,p,c,h,g){return new Promise((f,D)=>{const R=this.i(m,p,c,g);let t;const r=i=>{t&&(clearTimeout(t),t=null),i?D(i):f(void 0)};R.on("error",i=>{r((0,l.toErrorMessage)(i)||"Unknown")}),R.on("exit",(i,n)=>{r(i?`post-${p} process exited with code ${i}`:void 0)}),h&&(t=setTimeout(()=>{t=null,R.kill(),D("timed out")},5e3))})}i(m,p,c,h){const g={silent:!0,execArgv:void 0},f=(0,E.fork)(m,[`--type=extension-post-${p}`,...c],g);f.stdout.setEncoding("utf8"),f.stderr.setEncoding("utf8");const D=w.Event.fromNodeEventEmitter(f.stdout,"data"),R=w.Event.fromNodeEventEmitter(f.stderr,"data");D(i=>this.f.info(h.identifier.id,h.manifest.version,`post-${p}`,i)),R(i=>this.f.error(h.identifier.id,h.manifest.version,`post-${p}`,i));const t=w.Event.any(w.Event.map(D,i=>({data:`%c${i}`,format:[""]})),w.Event.map(R,i=>({data:`%c${i}`,format:["color: red"]})));return w.Event.debounce(t,(i,n)=>i?{data:i.data+n.data,format:[...i.format,...n.format]}:{data:n.data,format:n.format},100)(i=>{console.group(h.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),f}j(m){return(0,y.join)(this.b.defaultProfile.globalStorageHome.fsPath,m.identifier.id.toLowerCase())}};v=Te([Ae(0,I.IUserDataProfilesService),Ae(1,k.ILogService)],v),e.ExtensionsLifecycle=v}),define(be[123],Ee([1,0,10,32,36,31,44,16,25,4]),function(oe,e,E,A,l,w,S,P,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=void 0;let k=class extends S.AbstractExtensionsProfileScannerService{constructor(v,d,m,p,c,h){super(b.URI.file(v.extensionsPath),d,m,p,c,h)}};k=Te([Ae(0,y.INativeEnvironmentService),Ae(1,P.IFileService),Ae(2,A.IUserDataProfilesService),Ae(3,l.IUriIdentityService),Ae(4,w.ITelemetryService),Ae(5,E.ILogService)],k),e.ExtensionsProfileScannerService=k}),define(be[253],Ee([1,0,14,6,2,42,8,157,5,32]),function(oe,e,E,A,l,w,S,P,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.loadKeyTargets=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.TARGET_KEY=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker",e.TARGET_KEY="__$__targetStorageMarker",e.IStorageService=(0,y.createDecorator)("storageService");var k;(function(g){g[g.NONE=0]="NONE",g[g.SHUTDOWN=1]="SHUTDOWN"})(k=e.WillSaveStateReason||(e.WillSaveStateReason={}));var I;(function(g){g[g.APPLICATION=-1]="APPLICATION",g[g.PROFILE=0]="PROFILE",g[g.WORKSPACE=1]="WORKSPACE"})(I=e.StorageScope||(e.StorageScope={}));var v;(function(g){g[g.USER=0]="USER",g[g.MACHINE=1]="MACHINE"})(v=e.StorageTarget||(e.StorageTarget={}));function d(g){const f=g.get(e.TARGET_KEY);if(f)try{return JSON.parse(f)}catch{}return Object.create(null)}e.loadKeyTargets=d;class m extends l.Disposable{constructor(f={flushInterval:m.a}){super(),this.j=f,this.b=this.B(new A.PauseableEmitter),this.onDidChangeValue=this.b.event,this.c=this.B(new A.PauseableEmitter),this.onDidChangeTarget=this.c.event,this.f=this.B(new A.Emitter),this.onWillSaveState=this.f.event,this.h=this.B(new E.RunOnceScheduler(()=>this.k(),this.j.flushInterval)),this.i=this.B(new l.MutableDisposable),this.v=void 0,this.y=void 0,this.C=void 0}k(){this.i.value=(0,E.runWhenIdle)(()=>{this.l()&&this.flush(),this.h.schedule()})}l(){return!0}m(){(0,l.dispose)([this.i,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,w.mark)("code/willInitStorage");try{await this.J()}finally{(0,w.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}n(f,D){if(D===e.TARGET_KEY){switch(f){case-1:this.C=void 0;break;case 0:this.y=void 0;break;case 1:this.v=void 0;break}this.c.fire({scope:f})}else this.b.fire({scope:f,key:D,target:this.F(f)[D]})}r(f){this.f.fire({reason:f})}get(f,D,R){return this.L(D)?.get(f,R)}getBoolean(f,D,R){return this.L(D)?.getBoolean(f,R)}getNumber(f,D,R){return this.L(D)?.getNumber(f,R)}store(f,D,R,t){if((0,S.isUndefinedOrNull)(D)){this.remove(f,R);return}this.t(()=>{this.u(f,R,t),this.L(R)?.set(f,D)})}remove(f,D){this.t(()=>{this.u(f,D,void 0),this.L(D)?.delete(f)})}t(f){this.b.pause(),this.c.pause();try{f()}finally{this.b.resume(),this.c.resume()}}keys(f,D){const R=[],t=this.F(f);for(const r of Object.keys(t))t[r]===D&&R.push(r);return R}u(f,D,R){const t=this.F(D);typeof R=="number"?t[f]!==R&&(t[f]=R,this.L(D)?.set(e.TARGET_KEY,JSON.stringify(t))):typeof t[f]=="number"&&(delete t[f],this.L(D)?.set(e.TARGET_KEY,JSON.stringify(t)))}get w(){return this.v||(this.v=this.G(1)),this.v}get z(){return this.y||(this.y=this.G(0)),this.y}get D(){return this.C||(this.C=this.G(-1)),this.C}F(f){switch(f){case-1:return this.D;case 0:return this.z;default:return this.w}}G(f){const D=this.L(f);return D?d(D):Object.create(null)}isNew(f){return this.getBoolean(e.IS_NEW_KEY,f)===!0}async flush(f=k.NONE){this.f.fire({reason:f});const D=this.L(-1),R=this.L(0),t=this.L(1);switch(f){case k.NONE:await E.Promises.settled([D?.whenFlushed()??Promise.resolve(),R?.whenFlushed()??Promise.resolve(),t?.whenFlushed()??Promise.resolve()]);break;case k.SHUTDOWN:await E.Promises.settled([D?.flush(0)??Promise.resolve(),R?.flush(0)??Promise.resolve(),t?.flush(0)??Promise.resolve()]);break}}async log(){const f=this.L(-1)?.items??new Map,D=this.L(0)?.items??new Map,R=this.L(1)?.items??new Map;return h(f,D,R,this.M(-1)??"",this.M(0)??"",this.M(1)??"")}async switch(f,D){return this.r(k.NONE),(0,b.isUserDataProfile)(f)?this.N(f,D):this.O(f,D)}H(f,D){return!(f.id===D.id||p(D)&&p(f))}I(f,D,R,t){this.t(()=>{if(t)for(const[r,i]of f)D.set(r,i);else{const r=new Set;for(const[i,n]of f)r.add(i),D.get(i)!==n&&this.n(R,i);for(const[i]of D.items)r.has(i)||this.n(R,i)}})}}m.a=60*1e3,e.AbstractStorageService=m;function p(g){return g.isDefault||!!g.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=p;class c extends m{constructor(){super(),this.p=this.B(new P.Storage(new P.InMemoryStorageDatabase,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.P=this.B(new P.Storage(new P.InMemoryStorageDatabase,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.Q=this.B(new P.Storage(new P.InMemoryStorageDatabase,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.B(this.Q.onDidChangeStorage(f=>this.n(1,f))),this.B(this.P.onDidChangeStorage(f=>this.n(0,f))),this.B(this.p.onDidChangeStorage(f=>this.n(-1,f)))}L(f){switch(f){case-1:return this.p;case 0:return this.P;default:return this.Q}}M(f){switch(f){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async J(){}async N(){}async O(){}hasScope(f){return!1}}e.InMemoryStorageService=c;async function h(g,f,D,R,t,r){const i=W=>{try{return JSON.parse(W)}catch{return W}},n=new Map,o=new Map;g.forEach((W,X)=>{n.set(X,W),o.set(X,i(W))});const u=new Map,a=new Map;f.forEach((W,X)=>{u.set(X,W),a.set(X,i(W))});const s=new Map,C=new Map;D.forEach((W,X)=>{s.set(X,W),C.set(X,i(W))}),console.group(R!==t?`Storage: Application (path: ${R})`:`Storage: Application & Profile (path: ${R}, default profile)`);const L=[];if(n.forEach((W,X)=>{L.push({key:X,value:W})}),console.table(L),console.groupEnd(),console.log(o),R!==t){console.group(`Storage: Profile (path: ${t}, profile specific)`);const W=[];u.forEach((X,se)=>{W.push({key:se,value:X})}),console.table(W),console.groupEnd(),console.log(a)}console.group(`Storage: Workspace (path: ${r})`);const O=[];s.forEach((W,X)=>{O.push({key:X,value:W})}),console.table(O),console.groupEnd(),console.log(C)}e.logStorage=h}),define(be[124],Ee([1,0,18,19,9,3,28,8,4,24,25,30,35,73,16,10,26,54,237,253,31]),function(oe,e,E,A,l,w,S,P,y,b,k,I,v,d,m,p,c,h,g,f,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const R=w.isWeb?"web":(0,I.getTargetPlatform)(w.platform,S.arch),t="X-Market-Search-Activity-Id";var r;(function(N){N[N.None=0]="None",N[N.IncludeVersions=1]="IncludeVersions",N[N.IncludeFiles=2]="IncludeFiles",N[N.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",N[N.IncludeSharedAccounts=8]="IncludeSharedAccounts",N[N.IncludeVersionProperties=16]="IncludeVersionProperties",N[N.ExcludeNonValidated=32]="ExcludeNonValidated",N[N.IncludeInstallationTargets=64]="IncludeInstallationTargets",N[N.IncludeAssetUri=128]="IncludeAssetUri",N[N.IncludeStatistics=256]="IncludeStatistics",N[N.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",N[N.Unpublished=4096]="Unpublished",N[N.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(r||(r={}));function i(...N){return String(N.reduce((U,G)=>U|G,0))}var n;(function(N){N[N.Tag=1]="Tag",N[N.ExtensionId=4]="ExtensionId",N[N.Category=5]="Category",N[N.ExtensionName=7]="ExtensionName",N[N.Target=8]="Target",N[N.Featured=9]="Featured",N[N.SearchText=10]="SearchText",N[N.ExcludeWithFlags=12]="ExcludeWithFlags"})(n||(n={}));const o={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},u={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},s={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:r.None,criteria:[],assetTypes:[]};class C{constructor(U=s){this.d=U}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(U,G=this.d.pageSize){return new C({...this.d,pageNumber:U,pageSize:G})}withFilter(U,...G){const te=[...this.d.criteria,...G.length?G.map(le=>({filterType:U,value:le})):[{filterType:U}]];return new C({...this.d,criteria:te})}withSortBy(U){return new C({...this.d,sortBy:U})}withSortOrder(U){return new C({...this.d,sortOrder:U})}withFlags(...U){return new C({...this.d,flags:U.reduce((G,te)=>G|te,0)})}withAssetTypes(...U){return new C({...this.d,assetTypes:U})}withSource(U){return new C({...this.d,source:U})}get raw(){const{criteria:U,pageNumber:G,pageSize:te,sortBy:le,sortOrder:j,flags:K,assetTypes:Q}=this.d;return{filters:[{criteria:U,pageNumber:G,pageSize:te,sortBy:le,sortOrder:j}],assetTypes:Q,flags:K}}get searchText(){const U=this.d.criteria.filter(G=>G.filterType===n.SearchText)[0];return U&&U.value?U.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(U=>String(U.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function L(N,U){const G=(N||[]).filter(te=>te.statisticName===U)[0];return G?G.value:0}function O(N){const U="Microsoft.VisualStudio.Code.Translation.";return N.files.filter(te=>te.assetType.indexOf(U)===0).reduce((te,le)=>{const j=se(N,le.assetType);return j&&te.push([le.assetType.substring(U.length),j]),te},[])}function W(N){if(N.properties){const U=N.properties.filter(le=>le.key===o.Repository),G=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),te=U.filter(le=>G.test(le.value))[0];return te?{uri:te.value,fallbackUri:te.value}:null}return se(N,o.Repository)}function X(N){return{uri:`${N.fallbackAssetUri}/${o.VSIX}?redirect=true${N.targetPlatform?`&targetPlatform=${N.targetPlatform}`:""}`,fallbackUri:`${N.fallbackAssetUri}/${o.VSIX}${N.targetPlatform?`?targetPlatform=${N.targetPlatform}`:""}`}}function se(N,U){return N.files.filter(te=>te.assetType===U)[0]?{uri:`${N.assetUri}/${U}${N.targetPlatform?`?targetPlatform=${N.targetPlatform}`:""}`,fallbackUri:`${N.fallbackAssetUri}/${U}${N.targetPlatform?`?targetPlatform=${N.targetPlatform}`:""}`}:null}function fe(N,U){const G=N.properties?N.properties.filter(le=>le.key===U):[],te=G.length>0&&G[0].value;return te?te.split(",").map(le=>(0,v.adoptToGalleryExtensionId)(le)):[]}function ce(N){const U=N.properties?N.properties.filter(G=>G.key===u.Engine):[];return U.length>0&&U[0].value||""}function V(N){const U=N.properties?N.properties.filter(G=>G.key===u.PreRelease):[];return U.length>0&&U[0].value==="true"}function T(N){const U=N.properties?N.properties.filter(te=>te.key===u.LocalizedLanguages):[],G=U.length>0&&U[0].value||"";return G?G.split(","):[]}function z(N){return N.properties?.find(U=>U.key===u.SponsorLink)?.value}function he(N){return N.indexOf("preview")!==-1}function H(N){return N.targetPlatform?(0,I.toTargetPlatform)(N.targetPlatform):"undefined"}function q(N){const U=(0,E.distinct)(N.versions.map(H)),G=!!N.tags?.includes(I.WEB_EXTENSION_TAG),te=U.indexOf("web");return G?te===-1&&U.push("web"):te!==-1&&U.splice(te,1),U}function M(N,U){const G=(0,I.getFallbackTargetPlarforms)(U);for(let te=0;te<N.length;te++){const le=N[te];if(le.version===N[te-1]?.version){let j=te;const K=H(le);if(K===U)for(;j>0&&N[j-1].version===le.version;)j--;else if(G.includes(K))for(;j>0&&N[j-1].version===le.version&&H(N[j-1])!==U;)j--;j!==te&&(N.splice(te,1),N.splice(j,0,le))}}return N}e.sortExtensionVersions=M;function ee(N,U,G){N.telemetryData={index:U,querySource:G,queryActivityId:N.queryContext?.[t]}}function ie(N,U,G,te){const le=N.versions[0],j={manifest:se(U,o.Manifest),readme:se(U,o.Details),changelog:se(U,o.Changelog),license:se(U,o.License),repository:W(U),download:X(U),icon:se(U,o.Icon),signature:se(U,o.Signature),coreTranslations:O(U)};return{identifier:{id:(0,v.getGalleryExtensionId)(N.publisher.publisherName,N.extensionName),uuid:N.extensionId},name:N.extensionName,version:U.version,displayName:N.displayName,publisherId:N.publisher.publisherId,publisher:N.publisher.publisherName,publisherDisplayName:N.publisher.displayName,publisherDomain:N.publisher.domain?{link:N.publisher.domain,verified:!!N.publisher.isDomainVerified}:void 0,publisherSponsorLink:z(le),description:N.shortDescription||"",installCount:L(N.statistics,"install"),rating:L(N.statistics,"averagerating"),ratingCount:L(N.statistics,"ratingcount"),categories:N.categories||[],tags:N.tags||[],releaseDate:Date.parse(N.releaseDate),lastUpdated:Date.parse(N.lastUpdated),allTargetPlatforms:G,assets:j,properties:{dependencies:fe(U,u.Dependency),extensionPack:fe(U,u.ExtensionPack),engine:ce(U),localizedLanguages:T(U),targetPlatform:H(U),isPreReleaseVersion:V(U)},hasPreReleaseVersion:V(le),hasReleaseVersion:!0,preview:he(N.flags),isSigned:!!j.signature,queryContext:te}}let me=class{constructor(U,G,te,le,j,K,Q,x){this.k=G,this.l=te,this.n=le,this.o=j,this.q=K,this.u=Q,this.w=x;const _=Q.extensionsGallery,Y=_?.servicePPEUrl&&x.getValue("_extensionsGallery.enablePPE");this.d=Y?_.servicePPEUrl:_?.serviceUrl,this.g=Y?void 0:_?.searchUrl,this.h=_?.controlUrl,this.j=(0,g.resolveMarketplaceHeaders)(Q.version,Q,this.n,this.w,this.q,U,this.o)}x(U=""){return`${this.d}${U}`}isEnabled(){return!!this.d}async getExtensions(U,G,te){const le=A.CancellationToken.isCancellationToken(G)?{}:G,j=A.CancellationToken.isCancellationToken(G)?G:te,K=[],Q=[],x=[],_=[];let Y=!0;for(const ve of U){ve.uuid?Q.push(ve.uuid):K.push(ve.id);const Pe=!!(ve.version||ve.preRelease);x.push({id:ve.id,uuid:ve.uuid,includePreRelease:Pe}),ve.version&&_.push({id:ve.id,uuid:ve.uuid,version:ve.version}),Y=Y&&!!ve.hasPreRelease&&!Pe}if(!Q.length&&!K.length)return[];let Z=new C().withPage(1,U.length);Q.length&&(Z=Z.withFilter(n.ExtensionId,...Q)),K.length&&(Z=Z.withFilter(n.ExtensionName,...K)),(le.queryAllVersions||Y)&&(Z=Z.withFlags(Z.flags,r.IncludeVersions)),le.source&&(Z=Z.withSource(le.source));const{extensions:ae}=await this.z(Z,{targetPlatform:le.targetPlatform??R,includePreRelease:x,versions:_,compatible:!!le.compatible},j);return le.source&&ae.forEach((ve,Pe)=>ee(ve,Pe,le.source)),ae}async getCompatibleExtension(U,G,te){if((0,I.isNotWebExtensionInWebTargetPlatform)(U.allTargetPlatforms,te))return null;if(await this.isExtensionCompatible(U,G,te))return U;const le=new C().withFlags(r.IncludeVersions).withPage(1,1).withFilter(n.ExtensionId,U.identifier.uuid),{extensions:j}=await this.z(le,{targetPlatform:te,compatible:!0,includePreRelease:G},A.CancellationToken.None);return j[0]||null}async isExtensionCompatible(U,G,te){if(!(0,I.isTargetPlatformCompatible)(U.properties.targetPlatform,U.allTargetPlatforms,te)||!G&&U.properties.isPreReleaseVersion)return!1;let le=U.properties.engine;if(!le){const j=await this.getManifest(U,A.CancellationToken.None);if(!j)throw new Error("Manifest was not found");le=j.engines.vscode}return(0,d.isEngineValid)(le,this.u.version,this.u.date)}async y(U,G,te,le,j){if(!(0,I.isTargetPlatformCompatible)(H(U),le,j)||G!=="any"&&V(U)!==(G==="prerelease"))return!1;if(te)try{const K=await this.E(U);if(!(0,d.isEngineValid)(K,this.u.version,this.u.date))return!1}catch(K){return this.l.error(`Error while getting the engine for the version ${U.version}.`,(0,l.getErrorMessage)(K)),!1}return!0}async query(U,G){let te=U.text||"";const le=U.pageSize??50;let j=new C().withPage(1,le);te?(te=te.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Y,Z,ae)=>(j=j.withFilter(n.Category,ae||Z),"")),te=te.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(Y,Z,ae)=>(j=j.withFilter(n.Tag,ae||Z),"")),te=te.replace(/\bfeatured(\s+|\b|$)/g,()=>(j=j.withFilter(n.Featured),"")),te=te.trim(),te&&(te=te.length<200?te:te.substring(0,200),j=j.withFilter(n.SearchText,te)),j=j.withSortBy(0)):U.ids?j=j.withFilter(n.ExtensionId,...U.ids):U.names?j=j.withFilter(n.ExtensionName,...U.names):j=j.withSortBy(4),typeof U.sortBy=="number"&&(j=j.withSortBy(U.sortBy)),typeof U.sortOrder=="number"&&(j=j.withSortOrder(U.sortOrder)),U.source&&(j=j.withSource(U.source));const K=async(Y,Z)=>{const{extensions:ae,total:ve}=await this.z(Y,{targetPlatform:R,compatible:!1,includePreRelease:!!U.includePreRelease},Z);return ae.forEach((Pe,ke)=>ee(Pe,(Y.pageNumber-1)*Y.pageSize+ke,U.source)),{extensions:ae,total:ve}},{extensions:Q,total:x}=await K(j,G),_=async(Y,Z)=>{if(Z.isCancellationRequested)throw new l.CancellationError;const{extensions:ae}=await K(j.withPage(Y+1),Z);return ae};return{firstPage:Q,total:x,pageSize:j.pageSize,getPage:_}}async z(U,G,te){const le=U.flags;!!(U.flags&r.IncludeLatestVersionOnly)&&!!(U.flags&r.IncludeVersions)&&(U=U.withFlags(U.flags&~r.IncludeVersions,r.IncludeLatestVersionOnly)),!(U.flags&r.IncludeLatestVersionOnly)&&!(U.flags&r.IncludeVersions)&&(U=U.withFlags(U.flags,r.IncludeLatestVersionOnly)),G.versions?.length&&(U=U.withFlags(U.flags&~r.IncludeLatestVersionOnly,r.IncludeVersions)),U=U.withFlags(U.flags,r.IncludeAssetUri,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeStatistics,r.IncludeVersionProperties);const{galleryExtensions:j,total:K,context:Q}=await this.B(U,te);if(!(U.flags&r.IncludeLatestVersionOnly)){const Z=[];for(const ae of j){const ve=await this.A(ae,G,Q);ve&&Z.push(ve)}return{extensions:Z,total:K}}const _=[],Y=new Map;for(let Z=0;Z<j.length;Z++){const ae=j[Z],ve={id:(0,v.getGalleryExtensionId)(ae.publisher.publisherName,ae.extensionName),uuid:ae.extensionId},Pe=(0,P.isBoolean)(G.includePreRelease)?G.includePreRelease:!!G.includePreRelease.find(Me=>(0,v.areSameExtensions)(Me,ve))?.includePreRelease;if(G.compatible&&(0,I.isNotWebExtensionInWebTargetPlatform)(q(ae),G.targetPlatform))continue;const ke=await this.A(ae,G,Q);!ke||ke.properties.isPreReleaseVersion&&(!Pe||!ke.hasReleaseVersion)||!ke.properties.isPreReleaseVersion&&ke.properties.targetPlatform!==G.targetPlatform&&ke.hasPreReleaseVersion?Y.set(ae.extensionId,Z):_.push([Z,ke])}if(Y.size){const Z=new Date().getTime(),ae=new C().withFlags(le&~r.IncludeLatestVersionOnly,r.IncludeVersions).withPage(1,Y.size).withFilter(n.ExtensionId,...Y.keys()),{extensions:ve}=await this.z(ae,G,te);this.o.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-Z,count:Y.size});for(const Pe of ve){const ke=Y.get(Pe.identifier.uuid);_.push([ke,Pe])}}return{extensions:_.sort((Z,ae)=>Z[0]-ae[0]).map(([,Z])=>Z),total:K}}async A(U,G,te){const le={id:(0,v.getGalleryExtensionId)(U.publisher.publisherName,U.extensionName),uuid:U.extensionId},j=G.versions?.find(_=>(0,v.areSameExtensions)(_,le))?.version,K=(0,P.isBoolean)(G.includePreRelease)?G.includePreRelease:!!G.includePreRelease.find(_=>(0,v.areSameExtensions)(_,le))?.includePreRelease,Q=q(U),x=M(U.versions,G.targetPlatform);if(G.compatible&&(0,I.isNotWebExtensionInWebTargetPlatform)(Q,G.targetPlatform))return null;for(let _=0;_<x.length;_++){const Y=x[_];if(!(j&&Y.version!==j)){if(await this.y(Y,K?"any":"release",G.compatible,Q,G.targetPlatform))return ie(U,Y,Q,te);if(j&&Y.version===j)return null}}return j||G.compatible?null:ie(U,U.versions[0],Q)}async B(U,G){if(!this.isEnabled())throw new Error("No extension gallery service configured.");U=U.withFlags(U.flags,r.ExcludeNonValidated).withFilter(n.Target,"Microsoft.VisualStudio.Code").withFilter(n.ExcludeWithFlags,i(r.Unpublished));const te=await this.j,le=JSON.stringify(U.raw),j={...te,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(le.length)},K=new Date().getTime();let Q,x,_=0;try{if(Q=await this.k.request({type:"POST",url:this.g&&U.criteria.some(Z=>Z.filterType===n.SearchText)?this.g:this.x("/extensionquery"),data:le,headers:j},G),Q.res.statusCode&&Q.res.statusCode>=400&&Q.res.statusCode<500)return{galleryExtensions:[],total:_};const Y=await(0,h.asJson)(Q);if(Y){const Z=Y.results[0],ae=Z.extensions,ve=Z.resultMetadata&&Z.resultMetadata.filter(Pe=>Pe.metadataType==="ResultCount")[0];return _=ve&&ve.metadataItems.filter(Pe=>Pe.name==="TotalCount")[0].count||0,{galleryExtensions:ae,total:_,context:{[t]:Q.res.headers.activityid}}}return{galleryExtensions:[],total:_}}catch(Y){throw x=Y,Y}finally{this.o.publicLog2("galleryService:query",{...U.telemetryData,requestBodySize:String(le.length),duration:new Date().getTime()-K,success:!!Q&&(0,h.isSuccess)(Q),responseBodySize:Q?.res.headers["Content-Length"],statusCode:Q?String(Q.res.statusCode):void 0,errorCode:x?(0,l.isCancellationError)(x)?"canceled":(0,l.getErrorMessage)(x).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(_)})}}async reportStatistic(U,G,te,le){if(!this.isEnabled())return;const j=w.isWeb?this.x(`/itemName/${U}.${G}/version/${te}/statType/${le==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${U}/extensions/${G}/${te}/stats?statType=${le}`),K=w.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",x={...await this.j,Accept:K};try{await this.k.request({type:"POST",url:j,headers:x},A.CancellationToken.None)}catch{}}async download(U,G,te){this.l.trace("ExtensionGalleryService#download",U.identifier.id);const le=(0,v.getGalleryExtensionTelemetryData)(U),j=new Date().getTime(),K=Z=>this.o.publicLog("galleryService:downloadVSIX",{...le,duration:Z}),Q=te===2?"install":te===3?"update":"",x=Q?{uri:`${U.assets.download.uri}${y.URI.parse(U.assets.download.uri).query?"&":"?"}${Q}=true`,fallbackUri:`${U.assets.download.fallbackUri}${y.URI.parse(U.assets.download.fallbackUri).query?"&":"?"}${Q}=true`}:U.assets.download,_=U.queryContext?.[t]?{[t]:U.queryContext[t]}:void 0,Y=await this.D(x,_?{headers:_}:void 0);await this.q.writeFile(G,Y.stream),K(new Date().getTime()-j)}async downloadSignatureArchive(U,G){if(!U.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",U.identifier.id);const te=await this.D(U.assets.signature);await this.q.writeFile(G,te.stream)}async getReadme(U,G){if(U.assets.readme){const te=await this.D(U.assets.readme,{},G);return await(0,h.asTextOrError)(te)||""}return""}async getManifest(U,G){if(U.assets.manifest){const te=await this.D(U.assets.manifest,{},G),le=await(0,h.asTextOrError)(te);return le?JSON.parse(le):null}return null}async C(U,G){const te=se(U,o.Manifest);if(!te)throw new Error("Manifest was not found");const le={"Accept-Encoding":"gzip"},j=await this.D(te,{headers:le});return await(0,h.asJson)(j)}async getCoreTranslation(U,G){const te=U.assets.coreTranslations.filter(le=>le[0]===G.toUpperCase())[0];if(te){const le=await this.D(te[1]),j=await(0,h.asTextOrError)(le);return j?JSON.parse(j):null}return null}async getChangelog(U,G){if(U.assets.changelog){const te=await this.D(U.assets.changelog,{},G);return await(0,h.asTextOrError)(te)||""}return""}async getAllCompatibleVersions(U,G,te){let le=new C().withFlags(r.IncludeVersions,r.IncludeCategoryAndTags,r.IncludeFiles,r.IncludeVersionProperties).withPage(1,1);U.identifier.uuid?le=le.withFilter(n.ExtensionId,U.identifier.uuid):le=le.withFilter(n.ExtensionName,U.identifier.id);const{galleryExtensions:j}=await this.B(le,A.CancellationToken.None);if(!j.length)return[];const K=q(j[0]);if((0,I.isNotWebExtensionInWebTargetPlatform)(K,te))return[];const Q=[];await Promise.all(j[0].versions.map(async Y=>{try{await this.y(Y,G?"any":"release",!0,K,te)&&Q.push(Y)}catch{}}));const x=[],_=new Set;for(const Y of M(Q,te))_.has(Y.version)||(_.add(Y.version),x.push({version:Y.version,date:Y.lastUpdated,isPreReleaseVersion:V(Y)}));return x}async D(U,G={},te=A.CancellationToken.None){const le=await this.j,j={type:"GET"},K={...le,...G.headers||{}};G={...G,...j,headers:K};const Q=U.uri,x=U.fallbackUri,_={...G,url:Q};try{const Y=await this.k.request(_,te);if(Y.res.statusCode===200)return Y;const Z=await(0,h.asTextOrError)(Y);throw new Error(`Expected 200, got back ${Y.res.statusCode} instead.

${Z}`)}catch(Y){if((0,l.isCancellationError)(Y))throw Y;const Z=(0,l.getErrorMessage)(Y);this.o.publicLog2("galleryService:cdnFallback",{url:Q,message:Z});const ae={...G,url:x};return this.k.request(ae,te)}}async E(U){let G=ce(U);if(!G){const te=await this.C(U,A.CancellationToken.None);if(!te)throw new Error("Manifest was not found");G=te.engines.vscode}return G}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{}};const U=await this.k.request({type:"GET",url:this.h},A.CancellationToken.None);if(U.res.statusCode!==200)throw new Error("Could not get extensions report.");const G=await(0,h.asJson)(U),te=[],le={};if(G){for(const j of G.malicious)te.push({id:j});if(G.migrateToPreRelease)for(const[j,K]of Object.entries(G.migrateToPreRelease))(!K.engine||(0,d.isEngineValid)(K.engine,this.u.version,this.u.date))&&(le[j.toLowerCase()]={disallowInstall:!0,extension:{id:K.id,displayName:K.displayName,autoMigrate:{storage:!!K.migrateStorage},preRelease:!0}});if(G.deprecated)for(const[j,K]of Object.entries(G.deprecated))K&&(le[j.toLowerCase()]=(0,P.isBoolean)(K)?{}:K)}return{malicious:te,deprecated:le}}};me=Te([Ae(1,h.IRequestService),Ae(2,p.ILogService),Ae(3,k.IEnvironmentService),Ae(4,D.ITelemetryService),Ae(5,m.IFileService),Ae(6,c.IProductService),Ae(7,b.IConfigurationService)],me);let ne=class extends me{constructor(U,G,te,le,j,K,Q,x){super(U,G,te,le,j,K,Q,x)}};ne=Te([Ae(0,f.IStorageService),Ae(1,h.IRequestService),Ae(2,p.ILogService),Ae(3,k.IEnvironmentService),Ae(4,D.ITelemetryService),Ae(5,m.IFileService),Ae(6,c.IProductService),Ae(7,b.IConfigurationService)],ne),e.ExtensionGalleryService=ne;let B=class extends me{constructor(U,G,te,le,j,K,Q){super(void 0,U,G,te,le,j,K,Q)}};B=Te([Ae(0,h.IRequestService),Ae(1,p.ILogService),Ae(2,k.IEnvironmentService),Ae(3,D.ITelemetryService),Ae(4,m.IFileService),Ae(5,c.IProductService),Ae(6,b.IConfigurationService)],B),e.ExtensionGalleryServiceWithNoStorageService=B}),define(be[254],Ee([1,0,6,2,32,47]),function(oe,e,E,A,l,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.RemoteUserDataProfilesServiceChannel=void 0;class S{constructor(b,k){this.a=b,this.b=k}listen(b,k){const I=this.b(b);switch(k){case"onDidChangeProfiles":return E.Event.map(this.a.onDidChangeProfiles,v=>({all:v.all.map(d=>(0,w.transformOutgoingURIs)({...d},I)),added:v.added.map(d=>(0,w.transformOutgoingURIs)({...d},I)),removed:v.removed.map(d=>(0,w.transformOutgoingURIs)({...d},I)),updated:v.updated.map(d=>(0,w.transformOutgoingURIs)({...d},I))}))}throw new Error(`Invalid listen ${k}`)}async call(b,k,I){const v=this.b(b);switch(k){case"createProfile":{const d=await this.a.createProfile(I[0],I[1],I[2]);return(0,w.transformOutgoingURIs)({...d},v)}case"updateProfile":{let d=(0,l.reviveProfile)((0,w.transformIncomingURIs)(I[0],v),this.a.profilesHome.scheme);return d=await this.a.updateProfile(d,I[1]),(0,w.transformOutgoingURIs)({...d},v)}case"removeProfile":{const d=(0,l.reviveProfile)((0,w.transformIncomingURIs)(I[0],v),this.a.profilesHome.scheme);return this.a.removeProfile(d)}}throw new Error(`Invalid call ${k}`)}}e.RemoteUserDataProfilesServiceChannel=S;class P extends A.Disposable{get defaultProfile(){return this.profiles[0]}get profiles(){return this.a}constructor(b,k,I){super(),this.profilesHome=k,this.f=I,this.a=[],this.b=this.B(new E.Emitter),this.onDidChangeProfiles=this.b.event,this.c=!0,this.a=b.map(v=>(0,l.reviveProfile)(v,this.profilesHome.scheme)),this.B(this.f.listen("onDidChangeProfiles")(v=>{const d=v.added.map(c=>(0,l.reviveProfile)(c,this.profilesHome.scheme)),m=v.removed.map(c=>(0,l.reviveProfile)(c,this.profilesHome.scheme)),p=v.updated.map(c=>(0,l.reviveProfile)(c,this.profilesHome.scheme));this.a=v.all.map(c=>(0,l.reviveProfile)(c,this.profilesHome.scheme)),this.b.fire({added:d,removed:m,updated:p,all:this.profiles})})),this.onDidResetWorkspaces=this.f.listen("onDidResetWorkspaces")}setEnablement(b){this.c=b}isEnabled(){return this.c}async createNamedProfile(b,k,I){const v=await this.f.call("createNamedProfile",[b,k,I]);return(0,l.reviveProfile)(v,this.profilesHome.scheme)}async createProfile(b,k,I,v){const d=await this.f.call("createProfile",[b,k,I,v]);return(0,l.reviveProfile)(d,this.profilesHome.scheme)}async createTransientProfile(b){const k=await this.f.call("createTransientProfile",[b]);return(0,l.reviveProfile)(k,this.profilesHome.scheme)}async setProfileForWorkspace(b,k){await this.f.call("setProfileForWorkspace",[b,k])}removeProfile(b){return this.f.call("removeProfile",[b])}async updateProfile(b,k){const I=await this.f.call("updateProfile",[b,k]);return(0,l.reviveProfile)(I,this.profilesHome.scheme)}resetWorkspaces(){return this.f.call("resetWorkspaces")}cleanUp(){return this.f.call("cleanUp")}cleanUpTransientProfiles(){return this.f.call("cleanUpTransientProfiles")}}e.UserDataProfilesService=P}),define(be[125],Ee([1,0,4,25,16,10,231,36,32,8,232]),function(oe,e,E,A,l,w,S,P,y,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerUserDataProfilesService=e.UserDataProfilesService=e.UserDataProfilesReadonlyService=void 0;let I=class Kt extends y.UserDataProfilesService{constructor(p,c,h,g,f){super(h,g,c,f),this.O=p,this.P=h}I(){return this.O.getItem(Kt.b,[]).map(c=>({...c,location:(0,b.isString)(c.location)?this.r.extUri.joinPath(this.profilesHome,c.location):E.URI.revive(c.location)}))}L(){const p=this.O.getItem(Kt.c,{});return this.O.getItem(Kt.a,!1)?p:this.H(p)}N(){return this.r.extUri.joinPath(E.URI.file(this.P.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};I.a="profileAssociationsMigration",I=Te([Ae(0,S.IStateReadService),Ae(1,P.IUriIdentityService),Ae(2,A.INativeEnvironmentService),Ae(3,l.IFileService),Ae(4,w.ILogService)],I),e.UserDataProfilesReadonlyService=I;let v=class Rt extends I{constructor(p,c,h,g,f){super(p,c,h,g,f),this.U=p}J(p){p.length?this.U.setItem(Rt.b,p.map(c=>({...c,location:this.r.extUri.basename(c.location)}))):this.U.removeItem(Rt.b)}I(){const p=super.I();return this.U.getItem("userDataProfilesMigration",!1)||(this.J(p),this.U.setItem("userDataProfilesMigration",!0)),p}M(p){p.emptyWindows||p.workspaces?this.U.setItem(Rt.c,p):this.U.removeItem(Rt.c)}L(){const p="workspaceAndProfileInfo",c=this.U.getItem(p,void 0);if(c){this.U.removeItem(p);const g=c.reduce((f,{workspace:D,profile:R})=>(f[E.URI.revive(D).toString()]=E.URI.revive(R).toString(),f),{});this.U.setItem(Rt.c,{workspaces:g})}const h=super.L();return this.U.getItem(Rt.a,!1)||(this.M(h),this.U.setItem(Rt.a,!0)),h}};v=Te([Ae(0,S.IStateService),Ae(1,P.IUriIdentityService),Ae(2,A.INativeEnvironmentService),Ae(3,l.IFileService),Ae(4,w.ILogService)],v),e.UserDataProfilesService=v;let d=class extends v{constructor(p,c,h,g){super(new k.StateService(0,c,g,h),p,c,h,g)}async init(){return await this.U.init(),super.init()}};d=Te([Ae(0,P.IUriIdentityService),Ae(1,A.INativeEnvironmentService),Ae(2,l.IFileService),Ae(3,w.ILogService)],d),e.ServerUserDataProfilesService=d}),define(be[126],Ee([1,0,5]),function(oe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostStatusService=e.IExtensionHostStatusService=void 0,e.IExtensionHostStatusService=(0,E.createDecorator)("extensionHostStatusService");class A{constructor(){this.a=new Map}setExitInfo(w,S){this.a.set(w,S)}getExitInfo(w){return this.a.get(w)||null}}e.ExtensionHostStatusService=A}),define(be[255],Ee([1,0,6,14]),function(oe,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ManagementConnection=void 0;function l(S){let P=0,y=0,b=0;S>=1e3&&(b=Math.floor(S/1e3),S-=b*1e3),b>=60&&(y=Math.floor(b/60),b-=y*60),y>=60&&(P=Math.floor(y/60),y-=P*60);const k=P?`${P}h`:"",I=y?`${y}m`:"",v=b?`${b}s`:"",d=S?`${S}ms`:"";return`${k}${I}${v}${d}`}class w{constructor(P,y,b,k){this.i=P,this.j=y,this.a=new E.Emitter,this.onClose=this.a.event,this.b=108e5,this.c=3e5,this.d=b,this.protocol=k,this.e=!1,this.f=new A.ProcessTimeRunOnceScheduler(()=>{this.k(`The reconnection grace time of ${l(this.b)} has expired, so the connection will be disposed.`),this.l()},this.b),this.g=new A.ProcessTimeRunOnceScheduler(()=>{this.k(`The reconnection short grace time of ${l(this.c)} has expired, so the connection will be disposed.`),this.l()},this.c),this.protocol.onDidDispose(()=>{this.k("The client has disconnected gracefully, so the connection will be disposed."),this.l()}),this.protocol.onSocketClose(()=>{this.k(`The client has disconnected, will wait for reconnection ${l(this.b)} before disposing...`),this.f.schedule()}),this.k("New connection established.")}k(P){this.i.info(`[${this.d}][${this.j.substr(0,8)}][ManagementConnection] ${P}`)}shortenReconnectionGraceTimeIfNecessary(){this.g.isScheduled()||this.f.isScheduled()&&(this.k(`Another client has connected, will shorten the wait for reconnection ${l(this.c)} before disposing...`),this.g.schedule())}l(){if(this.e)return;this.e=!0,this.f.dispose(),this.g.dispose();const P=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),P.end(),this.a.fire(void 0)}acceptReconnection(P,y,b){this.d=P,this.k("The client has reconnected."),this.f.cancel(),this.g.cancel(),this.protocol.beginAcceptReconnection(y,b),this.protocol.endAcceptReconnection()}}e.ManagementConnection=w}),define(be[83],Ee([1,0,33,13,7,152,51]),function(oe,e,E,A,l,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLocaleFromConfig=e.InternalNLSConfiguration=e.getNLSConfiguration=void 0;const P=l.join(A.FileAccess.asFileUri("").fsPath,"nls.metadata.json"),y=new Map;function b(m){return new Promise(p=>E.exists(m,p))}function k(m,p){return b(P).then(c=>{if(!c||!S.default.commit)return Promise.resolve({locale:"en",availableLanguages:{}});const h=`${m}||${p}`;let g=y.get(h);return g||(g=w.getNLSConfiguration(S.default.commit,p,P,m,m).then(f=>(I.is(f)&&(f._languagePackSupport=!0),f.locale!=="en"&&f.locale!=="en-us"&&Object.keys(f.availableLanguages).length===0&&y.delete(h),f)),y.set(h,g)),g})}e.getNLSConfiguration=k;var I;(function(m){function p(c){const h=c;return h&&typeof h._languagePackId=="string"}m.is=p})(I=e.InternalNLSConfiguration||(e.InternalNLSConfiguration={}));const v=async m=>{try{const p=d(await E.promises.readFile(m,"utf8"));return JSON.parse(p).locale}catch(p){return p.code!=="ENOENT"&&console.warn(p),"en"}};e.getLocaleFromConfig=v;const d=m=>{const p=/('(?:[^\\']*(?:\\.)?)*')|('(?:[^\\']*(?:\\.)?)*')|(\/\*(?:\r?\n|.)*?\*\/)|(\/{2,}.*?(?:(?:\r?\n)|$))/g;return m.replace(p,(c,h,g,f,D)=>{if(f)return"";if(D){const R=D.length;return R>2&&D[R-1]===`
`?D[R-2]==="\r"?`\r
`:`
`:""}else return c})}}),define(be[127],Ee([1,0,20,4,25,44,55,34,16,5,10,26,36,32,83]),function(oe,e,E,A,l,w,S,P,y,b,k,I,v,d,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let p=class extends S.AbstractExtensionsScannerService{constructor(h,g,f,D,R,t,r,i){super(A.URI.file(R.builtinExtensionsPath),A.URI.file(R.extensionsPath),(0,E.joinPath)(R.userHome,".vscode-oss-dev","extensions","control.json"),(0,E.joinPath)(A.URI.file(R.userDataPath),P.MANIFEST_CACHE_FOLDER),h,g,f,D,R,t,r,i),this.M=R}async f(h){const g=await(0,m.getNLSConfiguration)(h,this.M.userDataPath);if(m.InternalNLSConfiguration.is(g))try{const f=await this.r.readFile(A.URI.file(g._translationsConfigFile));return JSON.parse(f.value.toString())}catch{}return Object.create(null)}};p=Te([Ae(0,d.IUserDataProfilesService),Ae(1,w.IExtensionsProfileScannerService),Ae(2,y.IFileService),Ae(3,k.ILogService),Ae(4,l.INativeEnvironmentService),Ae(5,I.IProductService),Ae(6,v.IUriIdentityService),Ae(7,b.IInstantiationService)],p),e.ExtensionsScannerService=p}),define(be[256],Ee([1,0,257,33,7,21,13,22]),function(oe,e,E,A,l,w,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.requestHasValidConnectionToken=e.determineServerConnectionToken=e.parseServerConnectionToken=e.ServerConnectionTokenParseError=e.MandatoryServerConnectionToken=e.OptionalServerConnectionToken=e.NoneServerConnectionToken=e.ServerConnectionTokenType=void 0;const y=/^[0-9A-Za-z_-]+$/;var b;(function(h){h[h.None=0]="None",h[h.Optional=1]="Optional",h[h.Mandatory=2]="Mandatory"})(b=e.ServerConnectionTokenType||(e.ServerConnectionTokenType={}));class k{constructor(){this.type=0}validate(g){return!0}}e.NoneServerConnectionToken=k;class I{constructor(g){this.value=g,this.type=1}validate(g){return g===this.value}}e.OptionalServerConnectionToken=I;class v{constructor(g){this.value=g,this.type=2}validate(g){return g===this.value}}e.MandatoryServerConnectionToken=v;class d{constructor(g){this.message=g}}e.ServerConnectionTokenParseError=d;async function m(h,g){const f=h["without-connection-token"],D=h["connection-token"],R=h["connection-token-file"],t=h.compatibility==="1.63";if(f)return typeof D<"u"||typeof R<"u"?new d("Please do not use the argument '--connection-token' or '--connection-token-file' at the same time as '--without-connection-token'."):new k;if(typeof R<"u"){if(typeof D<"u")return new d("Please do not use the argument '--connection-token' at the same time as '--connection-token-file'.");let r;try{r=A.readFileSync(R).toString().replace(/\r?\n$/,"")}catch{return new d(`Unable to read the connection token file at '${R}'.`)}return y.test(r)?new v(r):new d(`The connection token defined in '${R} does not adhere to the characters 0-9, a-z, A-Z, _, or -.`)}return typeof D<"u"?y.test(D)?t?new I(D):new v(D):new d(`The connection token '${D} does not adhere to the characters 0-9, a-z, A-Z or -.`):t?(console.log("Breaking change in the next release: Please use one of the following arguments: '--connection-token', '--connection-token-file' or '--without-connection-token'."),new I(await g())):new v(await g())}e.parseServerConnectionToken=m;async function p(h){return m(h,async()=>{if(!h["user-data-dir"])return(0,w.generateUuid)();const f=l.join(h["user-data-dir"],"token");try{const t=(await P.Promises.readFile(f)).toString().replace(/\r?\n$/,"");if(y.test(t))return t}catch{}const D=(0,w.generateUuid)();try{await P.Promises.writeFile(f,D,{mode:384})}catch{}return D})}e.determineServerConnectionToken=p;function c(h,g,f){if(h.validate(f.query[S.connectionTokenQueryName]))return!0;const D=E.parse(g.headers.cookie||"");return h.validate(D[S.connectionTokenCookieName])}e.requestHasValidConnectionToken=c}),define(be[41],Ee([1,0,192,104,63,5,25]),function(oe,e,E,A,l,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerEnvironmentService=e.IServerEnvironmentService=e.serverOptions=void 0,e.serverOptions={"disable-update-check":{type:"boolean"},auth:{type:"string"},"disable-file-downloads":{type:"boolean"},locale:{type:"string"},"disable-getting-started-override":{type:"boolean"},host:{type:"string",cat:"o",args:"ip-address",description:E.localize(0,null)},port:{type:"string",cat:"o",args:"port | port range",description:E.localize(1,null)},"socket-path":{type:"string",cat:"o",args:"path",description:E.localize(2,null)},"connection-token":{type:"string",cat:"o",args:"token",deprecates:["connectionToken"],description:E.localize(3,null)},"connection-token-file":{type:"string",cat:"o",args:"path",deprecates:["connection-secret","connectionTokenFile"],description:E.localize(4,null)},"without-connection-token":{type:"boolean",cat:"o",description:E.localize(5,null)},"disable-websocket-compression":{type:"boolean"},"print-startup-performance":{type:"boolean"},"print-ip-address":{type:"boolean"},"accept-server-license-terms":{type:"boolean",cat:"o",description:E.localize(6,null)},"server-data-dir":{type:"string",cat:"o",description:E.localize(7,null)},"telemetry-level":{type:"string",cat:"o",args:"level",description:E.localize(8,null)},"user-data-dir":l.OPTIONS["user-data-dir"],"enable-smoke-test-driver":l.OPTIONS["enable-smoke-test-driver"],"disable-telemetry":l.OPTIONS["disable-telemetry"],"disable-workspace-trust":l.OPTIONS["disable-workspace-trust"],"file-watcher-polling":{type:"string",deprecates:["fileWatcherPolling"]},log:l.OPTIONS.log,logsPath:l.OPTIONS.logsPath,"force-disable-user-env":l.OPTIONS["force-disable-user-env"],folder:{type:"string",deprecationMessage:"No longer supported. Folder needs to be provided in the browser URL or with `default-folder`."},workspace:{type:"string",deprecationMessage:"No longer supported. Workspace needs to be provided in the browser URL or with `default-workspace`."},"default-folder":{type:"string",description:E.localize(9,null)},"default-workspace":{type:"string",description:E.localize(10,null)},"enable-sync":{type:"boolean"},"github-auth":{type:"string"},"extensions-dir":l.OPTIONS["extensions-dir"],"extensions-download-dir":l.OPTIONS["extensions-download-dir"],"builtin-extensions-dir":l.OPTIONS["builtin-extensions-dir"],"install-extension":l.OPTIONS["install-extension"],"install-builtin-extension":l.OPTIONS["install-builtin-extension"],"uninstall-extension":l.OPTIONS["uninstall-extension"],"list-extensions":l.OPTIONS["list-extensions"],"locate-extension":l.OPTIONS["locate-extension"],"show-versions":l.OPTIONS["show-versions"],category:l.OPTIONS.category,force:l.OPTIONS.force,"do-not-sync":l.OPTIONS["do-not-sync"],"pre-release":l.OPTIONS["pre-release"],"start-server":{type:"boolean",cat:"e",description:E.localize(11,null)},"enable-remote-auto-shutdown":{type:"boolean"},"remote-auto-shutdown-without-delay":{type:"boolean"},"use-host-proxy":{type:"boolean"},"without-browser-env-var":{type:"boolean"},help:l.OPTIONS.help,version:l.OPTIONS.version,"locate-shell-integration-path":l.OPTIONS["locate-shell-integration-path"],compatibility:{type:"string"},_:l.OPTIONS._},e.IServerEnvironmentService=(0,w.refineServiceDecorator)(S.IEnvironmentService);class P extends A.NativeEnvironmentService{get args(){return super.args}}e.ServerEnvironmentService=P}),define(be[258],Ee([1,0,74,10,41,26,218,21,18]),function(oe,e,E,A,l,w,S,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CredentialsWebMainService=void 0;let b=class extends S.BaseCredentialsMainService{constructor(I,v,d){super(I),this.k=v,this.l=d,this.k.args["github-auth"]&&this.n(this.k.args["github-auth"]).catch(m=>{this.g.error("Failed to store provided GitHub token",m)})}async getSecretStoragePrefix(){return Promise.resolve(`${this.l.urlProtocol}-server`)}async h(){if(this.f)return this.f;if(this.k.disableKeytar)return this.g.info("Keytar is disabled. Using in-memory credential store instead."),this.f=new E.InMemoryCredentialsProvider,this.f;try{this.f=await new Promise((I,v)=>{oe(["keytar"],I,v)}),await this.f.findCredentials("test-keytar-loads")}catch(I){this.g.warn(`Using the in-memory credential store as the operating system's credential store could not be accessed. Please see https://aka.ms/vscode-server-keyring on how to set this up. Details: ${I.message??I}`),this.f=new E.InMemoryCredentialsProvider}return this.f}async n(I){const v="vscode.github-authentication",d=`${await this.getSecretStoragePrefix()}${v}`,m="github.auth",c=[["read:user","user:email","repo"]].map(f=>({id:(0,P.generateUuid)(),scopes:f.sort(),accessToken:I})),h=await this.getPassword(d,m);let g;if(h)try{const f=JSON.parse(h);f.content=JSON.parse(f.content),g=f}catch(f){this.g.error("Failed to parse existing GitHub credentials",f)}return g?.content&&(g.content=g.content.filter(f=>{const D=f.scopes.sort();return!c.find(R=>(0,y.equals)(D,R.scopes)&&R.account?.label===f.account?.label)})),this.setPassword(d,m,JSON.stringify({extensionId:v,...g||{},content:JSON.stringify([...c,...g?.content||[]])}))}};b=Te([Ae(0,A.ILogService),Ae(1,l.IServerEnvironmentService),Ae(2,w.IProductService)],b),e.CredentialsWebMainService=b}),define(be[259],Ee([1,0,294,242,260,29]),function(oe,e,E,A,l,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryClient=void 0;class S extends E.AppInsightsCore{constructor(y){super(),this.a=y}track(y){const b=y.baseData||{};b.properties||(b.properties={}),b.measurements||(b.measurements={});try{const k=w.cpus();b.measurements.cores=k.length,b.properties["common.cpuModel"]=k[0].model}catch{}try{b.measurements.memoryFree=w.freemem(),b.measurements.memoryTotal=w.totalmem()}catch{}try{b.properties["common.shell"]=w.userInfo().shell,b.properties["common.release"]=w.release(),b.properties["common.arch"]=w.arch()}catch{}try{const k=(/^http:/.test(this.a)?l:A).request(this.a,{method:"POST",headers:{"Content-Type":"application/json"}});k.on("error",()=>{}),k.write(JSON.stringify(b)),k.end()}catch{}}}e.TelemetryClient=S}),define(be[261],Ee([1,0,33,95,79,257,118,38,57,3,10,41,7,13,21,26,54,19,4,15,8,83,53]),function(oe,e,E,A,l,w,S,P,y,b,k,I,v,d,m,p,c,h,g,f,D,R,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getOriginalUrl=e.relativePath=e.relativeRoot=e.normalizeUrlPath=e.WebClientServer=e.serveFile=e.CacheControl=e.serveError=void 0;const r={".html":"text/html",".js":"text/javascript",".json":"application/json",".css":"text/css",".svg":"image/svg+xml"};async function i(W,X,se,fe){X.writeHead(se,{"Content-Type":"text/plain"}),X.end(fe)}e.serveError=i;var n;(function(W){W[W.NO_CACHING=0]="NO_CACHING",W[W.ETAG=1]="ETAG",W[W.NO_EXPIRY=2]="NO_EXPIRY"})(n=e.CacheControl||(e.CacheControl={}));async function o(W,X,se,fe,ce,V){try{const T=await E.promises.stat(W);if(X===1){const z=`W/"${[T.ino,T.size,T.mtime.getTime()].join("-")}"`;if(fe.headers["if-none-match"]===z)return ce.writeHead(304),void ce.end();V.Etag=z}else X===2?V["Cache-Control"]="public, max-age=31536000":X===0&&(V["Cache-Control"]="no-store");V["Content-Type"]=r[(0,v.extname)(W)]||(0,y.getMediaMime)(W)||"text/plain",ce.writeHead(200,V),(0,E.createReadStream)(W).pipe(ce)}catch(T){return T.code!=="ENOENT"?(se.error(T),console.error(T.toString())):console.error(`File not found: ${W}`),ce.writeHead(404,{"Content-Type":"text/plain"}),void ce.end("Not found")}}e.serveFile=o;const u=(0,v.dirname)(d.FileAccess.asFileUri("").fsPath);let a=class{constructor(X,se,fe,ce,V){this.f=X,this.g=se,this.h=fe,this.i=ce,this.j=V,this.a=this.j.extensionsGallery?.resourceUrlTemplate?g.URI.parse(this.j.extensionsGallery.resourceUrlTemplate):void 0;const T=(0,t.getRemoteServerRootPath)(V);this.b=`${T}/static`,this.c=`${T}/callback`,this.d="/web-extension-resource"}async handle(X,se,fe){try{const ce=fe.pathname;return ce.startsWith(this.b)&&ce.charCodeAt(this.b.length)===47?this.k(X,se,fe):ce==="/"?this.n(X,se,fe):ce===this.c?this.p(se):ce.startsWith(this.d)&&ce.charCodeAt(this.d.length)===47?this.m(X,se,fe):i(X,se,404,"Not found.")}catch(ce){return this.h.error(ce),console.error(ce.toString()),i(X,se,500,"Internal Server Error.")}}async k(X,se,fe){const ce=Object.create(null),T=decodeURIComponent(fe.pathname).substring(this.b.length+1),z=(0,v.join)(u,T);return(0,P.isEqualOrParent)(z,u,!b.isLinux)?o(z,this.g.isBuilt?2:1,this.h,X,se,ce):i(X,se,400,"Bad request.")}l(X){const se=X.authority.indexOf(".");return se!==-1?X.authority.substring(se+1):void 0}async m(X,se,fe){if(!this.a)return i(X,se,500,"No extension gallery service configured.");const ce=decodeURIComponent(fe.pathname),V=(0,v.normalize)(ce.substring(this.d.length+1)),T=g.URI.parse(V).with({scheme:this.a.scheme,authority:V.substring(0,V.indexOf("/")),path:V.substring(V.indexOf("/")+1)});if(this.l(this.a)!==this.l(T))return i(X,se,403,"Request Forbidden");const z={},he=me=>{const ne=X.headers[me];ne&&((0,D.isString)(ne)||ne[0])?z[me]=(0,D.isString)(ne)?ne:ne[0]:me!==me.toLowerCase()&&he(me.toLowerCase())};he("X-Client-Name"),he("X-Client-Version"),he("X-Machine-Id"),he("X-Client-Commit");const H=await this.i.request({type:"GET",url:T.toString(!0),headers:z},h.CancellationToken.None),q=H.res.statusCode||500;if(q!==200){let me=null;try{me=await(0,c.asTextOrError)(H)}catch{}return i(X,se,q,me||`Request failed with status ${q}`)}const M=Object.create(null),ee=me=>{const ne=H.res.headers[me];ne?M[me]=ne:me!==me.toLowerCase()&&ee(me.toLowerCase())};ee("Cache-Control"),ee("Content-Type"),se.writeHead(200,M);const ie=await(0,f.streamToBuffer)(H.stream);return void se.end(ie.buffer)}async n(X,se,fe){const ce=fe.query[d.connectionTokenQueryName];if(typeof ce=="string"){const le=Object.create(null);le["Set-Cookie"]=w.serialize(d.connectionTokenCookieName,ce,{sameSite:"lax",maxAge:60*60*24*7});const j=Object.create(null);for(const Q in fe.query)Q!==d.connectionTokenQueryName&&(j[Q]=fe.query[Q]);const K=l.format({pathname:"/",query:j});return le.Location=K,se.writeHead(302,le),void se.end()}const V="remote";if(!V)return i(X,se,400,"Bad request.");function T(le){return JSON.stringify(le).replace(/"/g,"&quot;")}let z;this.g.args["enable-smoke-test-driver"]&&(z=!1);const he=le=>le&&g.URI.file(A.resolve(le)).with({scheme:d.Schemas.vscodeRemote,authority:V}),H=d.FileAccess.asFileUri(this.g.isBuilt?"vs/code/browser/workbench/workbench.html":"vs/code/browser/workbench/workbench-dev.html").fsPath,q=!this.g.isBuilt&&this.g.args["github-auth"]?{id:(0,m.generateUuid)(),providerId:"github",accessToken:this.g.args["github-auth"],scopes:[["user:email"],["repo"]]}:void 0,M=(0,e.relativeRoot)((0,e.getOriginalUrl)(X)),ee=(0,e.relativePath)((0,e.getOriginalUrl)(X)),ie=this.g.args.locale||await(0,R.getLocaleFromConfig)(this.g.argvResource.fsPath),me=await(0,R.getNLSConfiguration)(ie,this.g.userDataPath),ne={remoteAuthority:V,webviewEndpoint:ee+this.b+"/out/vs/workbench/contrib/webview/browser/pre",userDataPath:this.g.userDataPath,isEnabledFileDownloads:!this.g.args["disable-file-downloads"],isEnabledCoderGettingStarted:!this.g.args["disable-getting-started-override"],_wrapWebWorkerExtHostInIframe:z,developmentOptions:{enableSmokeTestDriver:this.g.args["enable-smoke-test-driver"]?!0:void 0,logLevel:this.h.getLevel()},settingsSyncOptions:!this.g.isBuilt&&this.g.args["enable-sync"]?{enabled:!0}:void 0,enableWorkspaceTrust:!this.g.args["disable-workspace-trust"],folderUri:he(this.g.args["default-folder"]),workspaceUri:he(this.g.args["default-workspace"]),productConfiguration:{codeServerVersion:this.j.codeServerVersion,rootEndpoint:M,updateEndpoint:this.g.args["disable-update-check"]?void 0:M+"/update/check",logoutEndpoint:this.g.args.auth&&this.g.args.auth!=="none"?M+"/logout":void 0,proxyEndpointTemplate:process.env.VSCODE_PROXY_URI??M+"/proxy/{{port}}/",serviceWorker:{scope:ee+"/",path:M+"/_static/out/browser/serviceWorker.js"},enableTelemetry:this.j.enableTelemetry,embedderIdentifier:"server-distro",extensionsGallery:this.j.extensionsGallery},callbackRoute:this.c},B=this.j.extensionsGallery?.nlsBaseUrl,N={WORKBENCH_WEB_CONFIGURATION:T(ne),WORKBENCH_AUTH_SESSION:q?T(q):"",WORKBENCH_WEB_BASE_URL:ee+this.b,WORKBENCH_NLS_BASE_URL:ee+(B?`${B}${B.endsWith("/")?"":"/"}${this.j.commit}/${this.j.version}/`:""),BASE:M,VS_BASE:ee,NLS_CONFIGURATION:T(me)};let U;try{U=(await E.promises.readFile(H)).toString().replace(/\{\{([^}]+)\}\}/g,(j,K)=>N[K]??"undefined")}catch{return se.writeHead(404,{"Content-Type":"text/plain"}),void se.end("Not found")}const G=["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'self';",`script-src 'self' 'unsafe-eval' ${this.o(U).join(" ")} 'sha256-fh3TwPMflhsEIpR8g1OYTIMVWhXTLcjQ9kh2tIpmv54=';`,"child-src 'self';","frame-src 'self' https://*.vscode-cdn.net data:;","worker-src 'self' data: blob:;","style-src 'self' 'unsafe-inline';","connect-src 'self' ws: wss: https:;","font-src 'self' blob:;","manifest-src 'self';"].join(" "),te={"Content-Type":"text/html","Content-Security-Policy":G};return this.f.type!==0&&(te["Set-Cookie"]=w.serialize(d.connectionTokenCookieName,this.f.value,{sameSite:"lax",maxAge:60*60*24*7})),se.writeHead(200,te),void se.end(U)}o(X){const se=/<script>([\s\S]+?)<\/script>/img,fe=[];let ce;for(;ce=se.exec(X);){const V=S.createHash("sha256"),T=ce[1].replace(/\r\n/g,`
`),z=V.update(Buffer.from(T)).digest().toString("base64");fe.push(`'sha256-${z}'`)}return fe}async p(X){const se=d.FileAccess.asFileUri("vs/code/browser/workbench/callback.html").fsPath,fe=(await E.promises.readFile(se)).toString(),ce=["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'none';",`script-src 'self' ${this.o(fe).join(" ")};`,"style-src 'self' 'unsafe-inline';","font-src 'self' blob:;"].join(" ");return X.writeHead(200,{"Content-Type":"text/html","Content-Security-Policy":ce}),void X.end(fe)}};a=Te([Ae(1,I.IServerEnvironmentService),Ae(2,k.ILogService),Ae(3,c.IRequestService),Ae(4,p.IProductService)],a),e.WebClientServer=a;const s=(W,X=!1)=>W.replace(/\/\/+/g,"/").replace(/\/+$/,X?"/":"");e.normalizeUrlPath=s;const C=W=>{const X=(W.split("?",1)[0].match(/\//g)||[]).length;return(0,e.normalizeUrlPath)("./"+(X>1?"../".repeat(X-1):""))};e.relativeRoot=C;const L=W=>{const X=W.split("?",1)[0].split("/");return(0,e.normalizeUrlPath)("./"+X[X.length-1])};e.relativePath=L;const O=W=>W.originalUrl||W.url;e.getOriginalUrl=O}),define(be[262],Ee([1,0,5]),function(oe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,E.createDecorator)("IExtHostInitDataService")}),define(be[263],Ee([1,0,5]),function(oe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,E.createDecorator)("IExtHostRpcService");class A{constructor(w){this.getProxy=w.getProxy.bind(w),this.set=w.set.bind(w),this.dispose=w.dispose.bind(w),this.assertRegistered=w.assertRegistered.bind(w),this.drain=w.drain.bind(w)}}e.ExtHostRpcService=A}),define(be[68],Ee([1,0,47]),function(oe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function A(w){return{transformIncoming:S=>S.scheme==="vscode-remote"?{scheme:"file",path:S.path,query:S.query,fragment:S.fragment}:S.scheme==="file"?{scheme:"vscode-local",path:S.path,query:S.query,fragment:S.fragment}:S,transformOutgoing:S=>S.scheme==="file"?{scheme:"vscode-remote",authority:w,path:S.path,query:S.query,fragment:S.fragment}:S.scheme==="vscode-local"?{scheme:"file",path:S.path,query:S.query,fragment:S.fragment}:S,transformOutgoingScheme:S=>S==="file"?"vscode-remote":S==="vscode-local"?"file":S}}function l(w){return new E.URITransformer(A(w))}e.createURITransformer=l}),define(be[264],Ee([1,0,3,42,4,68,47,100,235,7]),function(oe,e,E,A,l,w,S,P,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAgentEnvironmentChannel=void 0;class k{constructor(v,d,m,p){this.b=v,this.c=d,this.d=m,this.e=p}async call(v,d,m){switch(d){case"getEnvironmentData":{const p=m,c=(0,w.createURITransformer)(p.remoteAuthority);let h=await this.f(p.profile);return h=(0,S.transformOutgoingURIs)(h,c),h}case"getExtensionHostExitInfo":{const p=m;return this.e.getExitInfo(p.reconnectionToken)}case"getDiagnosticInfo":{const p=m,c={machineInfo:(0,y.getMachineInfo)()},h=p.includeProcesses?(0,P.listProcesses)(process.pid):Promise.resolve();let g=[];const f={};if(p.folders){const D=(0,w.createURITransformer)("");g=p.folders.map(t=>l.URI.revive(D.transformIncoming(t))).filter(t=>t.scheme==="file").map(t=>(0,y.collectWorkspaceStats)(t.fsPath,["node_modules",".git"]).then(r=>{f[(0,b.basename)(t.fsPath)]=r}))}return Promise.all([h,...g]).then(([D,R])=>(c.processes=D||void 0,c.workspaceMetadata=p.folders?f:void 0,c))}}throw new Error(`IPC Command ${d} not found`)}listen(v,d,m){throw new Error("Not supported")}async f(v){return v&&!this.d.profiles.some(d=>d.id===v)&&await this.d.createProfile(v,v),{pid:process.pid,connectionToken:this.b.type!==0?this.b.value:"",appRoot:l.URI.file(this.c.appRoot),settingsPath:this.c.machineSettingsResource,logsPath:l.URI.file(this.c.logsPath),extensionHostLogsPath:l.URI.file((0,b.join)(this.c.logsPath,`exthost${k.a++}`)),globalStorageHome:this.d.defaultProfile.globalStorageHome,workspaceStorageHome:this.c.workspaceStorageHome,localHistoryHome:this.c.localHistoryHome,userHome:this.c.userHome,os:E.OS,arch:process.arch,marks:A.getMarks(),useHostProxy:!!this.c.args["use-host-proxy"],profiles:{home:this.d.profilesHome,all:[...this.d.profiles].map(d=>({...d}))}}}}k.a=1,e.RemoteAgentEnvironmentChannel=k}),define(be[265],Ee([1,0,4,68,66,7,221]),function(oe,e,E,A,l,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAgentFileSystemProviderChannel=void 0;class P extends S.AbstractDiskFileSystemProviderChannel{constructor(k,I){super(new l.DiskFileSystemProvider(k),k),this.H=I,this.G=new Map,this.B(this.a)}c(k){let I=this.G.get(k.remoteAuthority);return I||(I=(0,A.createURITransformer)(k.remoteAuthority),this.G.set(k.remoteAuthority,I)),I}f(k,I,v=!1){if(v&&I.path==="/vscode-resource"&&I.query){const d=JSON.parse(I.query).requestResourcePath;return E.URI.from({scheme:"file",path:d})}return E.URI.revive(k.transformIncoming(I))}F(k,I){return new y(k,I,this.b,this.H)}}e.RemoteAgentFileSystemProviderChannel=P;class y extends S.AbstractSessionFileWatcher{constructor(k,I,v,d){super(k,I,v,d)}i(k){const I=k.args["file-watcher-polling"];if(I){const v=I.split(w.delimiter),d=Number(v[0]);if(d>0)return{usePolling:v.length>1?v.slice(1):!0,pollingInterval:d}}}j(k){if(k.extensionsPath)return[w.posix.join(k.extensionsPath,"**")]}}}),define(be[84],Ee([1,0,195,8,4,2,5,40,16,13,39,161,59]),function(oe,e,E,A,l,w,S,P,y,b,k,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEditorOpenError=e.isEditorOpenError=e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.createTooLargeFileError=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,E.localize)(0,null),providerDisplayName:(0,E.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var d;(function(ne){ne[ne.PROGRAMMATIC=1]="PROGRAMMATIC",ne[ne.USER=2]="USER",ne[ne.EDIT=3]="EDIT",ne[ne.NAVIGATION=4]="NAVIGATION",ne[ne.JUMP=5]="JUMP"})(d=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var m;(function(ne){ne[ne.IDENTICAL=1]="IDENTICAL",ne[ne.SIMILAR=2]="SIMILAR",ne[ne.DIFFERENT=3]="DIFFERENT"})(m=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function p(ne){const B=ne;return!!B&&typeof B.getSelection=="function"&&!!B.onDidChangeSelection}e.isEditorPaneWithSelection=p;function c(ne,B,N){for(const U of N.visibleEditorPanes)if(U.group.id===B&&ne.matches(U.input))return U.getViewState()}e.findViewStateForEditor=c;function h(ne){if(s(ne))return!1;const B=ne;return l.URI.isUri(B?.resource)}e.isResourceEditorInput=h;function g(ne){if(s(ne))return!1;const B=ne;return B?.original!==void 0&&B.modified!==void 0}e.isResourceDiffEditorInput=g;function f(ne){if(s(ne)||g(ne))return!1;const B=ne;return B?.primary!==void 0&&B.secondary!==void 0}e.isResourceSideBySideEditorInput=f;function D(ne){if(s(ne))return!1;const B=ne;return B?B.resource===void 0||B.resource.scheme===b.Schemas.untitled||B.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=D;const R=/Untitled-\d+/;function t(ne){return ne.scheme===b.Schemas.untitled&&ne.path.length>1&&!R.test(ne.path)}e.isUntitledWithAssociatedResource=t;function r(ne){if(s(ne))return!1;const B=ne;return l.URI.isUri(B?.base?.resource)&&l.URI.isUri(B?.input1?.resource)&&l.URI.isUri(B?.input2?.resource)&&l.URI.isUri(B?.result?.resource)}e.isResourceMergeEditorInput=r;var i;(function(ne){ne[ne.SHORT=0]="SHORT",ne[ne.MEDIUM=1]="MEDIUM",ne[ne.LONG=2]="LONG"})(i=e.Verbosity||(e.Verbosity={}));var n;(function(ne){ne[ne.EXPLICIT=1]="EXPLICIT",ne[ne.AUTO=2]="AUTO",ne[ne.FOCUS_CHANGE=3]="FOCUS_CHANGE",ne[ne.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(n=e.SaveReason||(e.SaveReason={}));class o{constructor(){this.a=new Map}registerSource(B,N){let U=this.a.get(B);return U||(U={source:B,label:N},this.a.set(B,U)),U.source}getSourceLabel(B){return this.a.get(B)?.label??B}}e.SaveSourceRegistry=new o;var u;(function(ne){ne[ne.None=0]="None",ne[ne.Readonly=2]="Readonly",ne[ne.Untitled=4]="Untitled",ne[ne.Singleton=8]="Singleton",ne[ne.RequiresTrust=16]="RequiresTrust",ne[ne.CanSplitInGroup=32]="CanSplitInGroup",ne[ne.ForceDescription=64]="ForceDescription",ne[ne.CanDropIntoEditor=128]="CanDropIntoEditor",ne[ne.MultipleEditors=256]="MultipleEditors"})(u=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class a extends w.Disposable{}e.AbstractEditorInput=a;function s(ne){return ne instanceof a}e.isEditorInput=s;function C(ne){const B=ne;return l.URI.isUri(B?.preferredResource)}function L(ne){const B=ne;return s(B?.primary)&&s(B?.secondary)}e.isSideBySideEditorInput=L;function O(ne){const B=ne;return s(B?.modified)&&s(B?.original)}e.isDiffEditorInput=O;function W(ne,B,N,U,G){return me(U,[(0,I.toAction)({id:"workbench.action.openLargeFile",label:(0,E.localize)(2,null),run:()=>{const te={...N,limits:{size:Number.MAX_VALUE}};ne.openEditor(B,te)}}),(0,I.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,E.localize)(3,null),run:()=>G.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:v.default.Warning})}e.createTooLargeFileError=W;function X(ne){return s(ne?.editor)}e.isEditorInputWithOptions=X;function se(ne){const B=ne;return X(ne)&&B?.group!==void 0}e.isEditorInputWithOptionsAndGroup=se;function fe(ne){const B=ne;return typeof B?.groupId=="number"&&s(B.editor)}e.isEditorIdentifier=fe;var ce;(function(ne){ne[ne.UNKNOWN=0]="UNKNOWN",ne[ne.REPLACE=1]="REPLACE",ne[ne.MOVE=2]="MOVE",ne[ne.UNPIN=3]="UNPIN"})(ce=e.EditorCloseContext||(e.EditorCloseContext={}));var V;(function(ne){ne[ne.GROUP_ACTIVE=0]="GROUP_ACTIVE",ne[ne.GROUP_INDEX=1]="GROUP_INDEX",ne[ne.GROUP_LOCKED=2]="GROUP_LOCKED",ne[ne.EDITOR_OPEN=3]="EDITOR_OPEN",ne[ne.EDITOR_CLOSE=4]="EDITOR_CLOSE",ne[ne.EDITOR_MOVE=5]="EDITOR_MOVE",ne[ne.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",ne[ne.EDITOR_LABEL=7]="EDITOR_LABEL",ne[ne.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",ne[ne.EDITOR_PIN=9]="EDITOR_PIN",ne[ne.EDITOR_STICKY=10]="EDITOR_STICKY",ne[ne.EDITOR_DIRTY=11]="EDITOR_DIRTY",ne[ne.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(V=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var T;(function(ne){ne[ne.PRIMARY=1]="PRIMARY",ne[ne.SECONDARY=2]="SECONDARY",ne[ne.BOTH=3]="BOTH",ne[ne.ANY=4]="ANY"})(T=e.SideBySideEditor||(e.SideBySideEditor={}));class z{getOriginalUri(B,N){if(!B)return;if(r(B))return e.EditorResourceAccessor.getOriginalUri(B.result,N);if(N?.supportSideBySide){const{primary:G,secondary:te}=this.a(B);if(G&&te){if(N?.supportSideBySide===T.BOTH)return{primary:this.getOriginalUri(G,{filterByScheme:N.filterByScheme}),secondary:this.getOriginalUri(te,{filterByScheme:N.filterByScheme})};if(N?.supportSideBySide===T.ANY)return this.getOriginalUri(G,{filterByScheme:N.filterByScheme})??this.getOriginalUri(te,{filterByScheme:N.filterByScheme});B=N.supportSideBySide===T.PRIMARY?G:te}}if(g(B)||f(B)||r(B))return;const U=C(B)?B.preferredResource:B.resource;return!U||!N||!N.filterByScheme?U:this.b(U,N.filterByScheme)}a(B){return L(B)||f(B)?{primary:B.primary,secondary:B.secondary}:O(B)||g(B)?{primary:B.modified,secondary:B.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(B,N){if(!B)return;if(r(B))return e.EditorResourceAccessor.getCanonicalUri(B.result,N);if(N?.supportSideBySide){const{primary:G,secondary:te}=this.a(B);if(G&&te){if(N?.supportSideBySide===T.BOTH)return{primary:this.getCanonicalUri(G,{filterByScheme:N.filterByScheme}),secondary:this.getCanonicalUri(te,{filterByScheme:N.filterByScheme})};if(N?.supportSideBySide===T.ANY)return this.getCanonicalUri(G,{filterByScheme:N.filterByScheme})??this.getCanonicalUri(te,{filterByScheme:N.filterByScheme});B=N.supportSideBySide===T.PRIMARY?G:te}}if(g(B)||f(B)||r(B))return;const U=B.resource;return!U||!N||!N.filterByScheme?U:this.b(U,N.filterByScheme)}b(B,N){if(Array.isArray(N)){if(N.some(U=>B.scheme===U))return B}else if(N===B.scheme)return B}}e.EditorResourceAccessor=new z;var he;(function(ne){ne[ne.LEFT=0]="LEFT",ne[ne.RIGHT=1]="RIGHT"})(he=e.CloseDirection||(e.CloseDirection={}));class H{constructor(){this.c=new Map,this.d=new Map}start(B){const N=this.a=B.get(S.IInstantiationService);for(const[U,G]of this.c)this.e(U,G,N);this.c.clear()}e(B,N,U){const G=U.createInstance(N);this.d.set(B,G)}registerFileEditorFactory(B){if(this.b)throw new Error("Can only register one file editor factory.");this.b=B}getFileEditorFactory(){return(0,A.assertIsDefined)(this.b)}registerEditorSerializer(B,N){if(this.c.has(B)||this.d.has(B))throw new Error(`A editor serializer with type ID '${B}' was already registered.`);return this.a?this.e(B,N,this.a):this.c.set(B,N),(0,w.toDisposable)(()=>{this.c.delete(B),this.d.delete(B)})}getEditorSerializer(B){return this.d.get(typeof B=="string"?B:B.typeId)}}P.Registry.add(e.EditorExtensions.EditorFactory,new H);async function q(ne,B,N){return!ne||!ne.length?[]:await Promise.all(ne.map(async U=>{const G=l.URI.revive(U.fileUri);if(!G){N.info("Cannot resolve the path because it is not valid.",U);return}if(!await B.canHandleResource(G)){N.info("Cannot resolve the path because it cannot be handled",U);return}let le=U.exists,j=U.type;if(typeof le!="boolean"||typeof j!="number")try{j=(await B.stat(G)).isDirectory?y.FileType.Directory:y.FileType.Unknown,le=!0}catch(Q){N.error(Q),le=!1}if(!le&&U.openOnlyIfExists){N.info("Cannot resolve the path because it does not exist",U);return}if(j===y.FileType.Directory){N.info("Cannot resolve the path because it is a directory",U);return}const K={...U.options,pinned:!0};return le?{resource:G,options:K}:{resource:G,options:K,forceUntitled:!0}}))}e.pathsToEditors=q;var M;(function(ne){ne[ne.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ne[ne.SEQUENTIAL=1]="SEQUENTIAL"})(M=e.EditorsOrder||(e.EditorsOrder={}));function ee(ne){const B=ne;if(!B)return!1;const N=B;if(N.modified)return ee(N.modified);const U=B;return!!(U.contributionsState&&U.viewState&&Array.isArray(U.cursorState))}e.isTextEditorViewState=ee;function ie(ne){return(0,k.isErrorWithActions)(ne)}e.isEditorOpenError=ie;function me(ne,B,N){const U=(0,k.createErrorWithActions)(ne,B);return U.forceMessage=N?.forceMessage,U.forceSeverity=N?.forceSeverity,U.allowDialog=N?.allowDialog,U}e.createEditorOpenError=me}),define(be[128],Ee([1,0,15,72,56,57,13,7,3,105]),function(oe,e,E,A,l,w,S,P,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var k;(function(T){T[T.Markup=1]="Markup",T[T.Code=2]="Code"})(k=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",w.Mimes.latex,w.Mimes.markdown,"image/png","image/jpeg",w.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[w.Mimes.latex,w.Mimes.markdown,"application/json",w.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var I;(function(T){T[T.Running=1]="Running",T[T.Idle=2]="Idle"})(I=e.NotebookRunState||(e.NotebookRunState={}));var v;(function(T){T[T.Unconfirmed=1]="Unconfirmed",T[T.Pending=2]="Pending",T[T.Executing=3]="Executing"})(v=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var d;(function(T){T[T.WithHardKernelDependency=0]="WithHardKernelDependency",T[T.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",T[T.Pure=2]="Pure",T[T.Never=3]="Never"})(d=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var m;(function(T){T.Always="always",T.Never="never",T.Optional="optional"})(m=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var p;(function(T){T[T.ModelChange=1]="ModelChange",T[T.Move=2]="Move",T[T.ChangeCellLanguage=5]="ChangeCellLanguage",T[T.Initialize=6]="Initialize",T[T.ChangeCellMetadata=7]="ChangeCellMetadata",T[T.Output=8]="Output",T[T.OutputItem=9]="OutputItem",T[T.ChangeCellContent=10]="ChangeCellContent",T[T.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",T[T.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",T[T.ChangeCellMime=13]="ChangeCellMime",T[T.Unknown=100]="Unknown"})(p=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var c;(function(T){T[T.Handle=0]="Handle",T[T.Index=1]="Index"})(c=e.SelectionStateType||(e.SelectionStateType={}));var h;(function(T){T[T.Replace=1]="Replace",T[T.Output=2]="Output",T[T.Metadata=3]="Metadata",T[T.CellLanguage=4]="CellLanguage",T[T.DocumentMetadata=5]="DocumentMetadata",T[T.Move=6]="Move",T[T.OutputItems=7]="OutputItems",T[T.PartialMetadata=8]="PartialMetadata",T[T.PartialInternalMetadata=9]="PartialInternalMetadata"})(h=e.CellEditType||(e.CellEditType={}));var g;(function(T){T.scheme=S.Schemas.vscodeNotebookCell;const z=["W","X","Y","Z","a","b","c","d","e","f"],he=new RegExp(`^[${z.join("")}]+`),H=7;function q(B,N){const U=N.toString(H),te=`${U.length<z.length?z[U.length-1]:"z"}${U}s${(0,E.encodeBase64)(E.VSBuffer.fromString(B.scheme),!0,!0)}`;return B.with({scheme:T.scheme,fragment:te})}T.generate=q;function M(B){if(B.scheme!==T.scheme)return;const N=B.fragment.indexOf("s");if(N<0)return;const U=parseInt(B.fragment.substring(0,N).replace(he,""),H),G=(0,E.decodeBase64)(B.fragment.substring(N+1)).toString();if(!isNaN(U))return{handle:U,notebook:B.with({scheme:G,fragment:null})}}T.parse=M;function ee(B,N){return B.with({scheme:S.Schemas.vscodeNotebookCellOutput,fragment:`op${N??""},${B.scheme!==S.Schemas.file?B.scheme:""}`})}T.generateCellOutputUri=ee;function ie(B){if(B.scheme!==S.Schemas.vscodeNotebookCellOutput)return;const N=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(B.fragment);if(!N)return;const U=N[1]&&N[1]!==""?N[1]:void 0,G=N[2];return{outputId:U,notebook:B.with({scheme:G||S.Schemas.file,fragment:null})}}T.parseCellOutputUri=ie;function me(B,N,U){return T.generate(B,N).with({scheme:U})}T.generateCellPropertyUri=me;function ne(B,N){if(B.scheme===N)return T.parse(B.with({scheme:T.scheme}))}T.parseCellPropertyUri=ne})(g=e.CellUri||(e.CellUri={}));const f=T=>y.isWindows?T.replace(/\//g,"\\"):T;class D{constructor(z=[],he=e.NOTEBOOK_DISPLAY_ORDER){this.e=he,this.d=[...new Set(z)].map(H=>({pattern:H,matches:A.parse(f(H))}))}sort(z){const he=new Map(l.Iterable.map(z,q=>[q,f(q)]));let H=[];for(const{matches:q}of this.d)for(const[M,ee]of he)if(q(ee)){H.push(M),he.delete(M);break}return he.size&&(H=H.concat([...he.keys()].sort((q,M)=>this.e.indexOf(q)-this.e.indexOf(M)))),H}prioritize(z,he){const H=this.f(z);if(H===-1){this.d.unshift({pattern:z,matches:A.parse(f(z))});return}const q=new Set(he.map(ee=>this.f(ee,H)));q.delete(-1);const M=Array.from(q).sort();this.d.splice(H+1,0,...M.map(ee=>this.d[ee]));for(let ee=M.length-1;ee>=0;ee--)this.d.splice(M[ee],1)}toArray(){return this.d.map(z=>z.pattern)}f(z,he=this.d.length){const H=f(z);for(let q=0;q<he;q++)if(this.d[q].matches(H))return q;return-1}}e.MimeTypeDisplayOrder=D;function R(T,z,he,H=(q,M)=>q===M){const q=[];function M(me,ne,B){if(ne===0&&B.length===0)return;const N=q[q.length-1];N&&N.start+N.deleteCount===me?(N.deleteCount+=ne,N.toInsert.push(...B)):q.push({start:me,deleteCount:ne,toInsert:B})}let ee=0,ie=0;for(;;){if(ee===T.length){M(ee,0,z.slice(ie));break}if(ie===z.length){M(ee,T.length-ee,[]);break}const me=T[ee],ne=z[ie];if(H(me,ne)){ee+=1,ie+=1;continue}he(ne)?(M(ee,1,[]),ee+=1):(M(ee,0,[ne]),ie+=1)}return q}e.diff=R,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new b.RawContextKey("notebookEditorCursorAtBoundary","none");var t;(function(T){T.default="default",T.option="option"})(t=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function r(T){const z=T;return!!((typeof z.include=="string"||A.isRelativePattern(z.include))&&(typeof z.exclude=="string"||A.isRelativePattern(z.exclude)))}e.isDocumentExcludePattern=r;function i(T,z,he){if(Array.isArray(T.viewType)&&T.viewType.indexOf(z)>=0||T.viewType===z)return!0;if(T.filenamePattern){const H=r(T.filenamePattern)?T.filenamePattern.include:T.filenamePattern,q=r(T.filenamePattern)?T.filenamePattern.exclude:void 0;if(A.match(H,(0,P.basename)(he.fsPath).toLowerCase()))return!(q&&A.match(q,(0,P.basename)(he.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=i,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily",kernelPickerType:"notebook.kernelPicker.type",outputScrolling:"notebook.experimental.outputScrolling",outputWordWrap:"notebook.output.wordWrap",logging:"notebook.logging"};var n;(function(T){T[T.Left=1]="Left",T[T.Right=2]="Right"})(n=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class o{static create(z){return`${o.d}${z}`}static parse(z){if(z.startsWith(o.d))return z.substring(o.d.length)}}o.d="notebook/",e.NotebookWorkingCopyTypeIdentifier=o;function u(T){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(T)}e.isTextStreamMime=u;const a=new TextDecoder;function s(T){const z=[];let he=!1;for(const H of T)(z.length===0||he)&&(z.push(H),he=!0);return W(z),V(E.VSBuffer.concat(z.map(H=>E.VSBuffer.wrap(H))))}e.compressOutputItemStreams=s;const C=`${String.fromCharCode(27)}[A`,L=C.split("").map(T=>T.charCodeAt(0)),O=10;function W(T){T.forEach((z,he)=>{if(he===0||z.length<C.length)return;const H=T[he-1],q=z.subarray(0,C.length);if(q[0]===L[0]&&q[1]===L[1]&&q[2]===L[2]){const M=H.lastIndexOf(O);if(M===-1)return;T[he-1]=H.subarray(0,M),T[he]=z.subarray(C.length)}})}function X(T){let z=T;do T=z,z=T.replace(/[^\n]\x08/gm,"");while(z.length<T.length);return T}function se(T){for(T=T.replace(/\r+\n/gm,`
`);T.search(/\r[^$]/g)>-1;){const z=T.match(/^(.*)\r+/m)[1];let he=T.match(/\r+(.*)$/m)[1];he=he+z.slice(he.length,z.length),T=T.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,he)}return T}const fe="\b".charCodeAt(0),ce="\r".charCodeAt(0);function V(T){return!T.buffer.includes(fe)&&!T.buffer.includes(ce)?T:E.VSBuffer.fromString(se(X(a.decode(T.buffer))))}}),define(be[266],Ee([1,0,5]),function(oe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEnvironmentVariableService=void 0,e.IEnvironmentVariableService=(0,E.createDecorator)("environmentVariableService")}),define(be[267],Ee([1,0,7,58,3,245,8]),function(oe,e,E,A,l,w,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preparePathForShell=e.createTerminalEnvironment=e.getDefaultShellArgs=e.getDefaultShell=e.createVariableResolver=e.getCwd=e.getLangEnvVariable=e.shouldSetLangEnvVariable=e.addTerminalEnvironmentKeys=e.mergeEnvironments=void 0;function P(t,r){if(!!r)if(l.isWindows)for(const i in r){let n=i;for(const u in t)if(i.toLowerCase()===u.toLowerCase()){n=u;break}const o=r[i];o!==void 0&&y(t,n,o)}else Object.keys(r).forEach(i=>{const n=r[i];n!==void 0&&y(t,i,n)})}e.mergeEnvironments=P;function y(t,r,i){typeof i=="string"?t[r]=i:delete t[r]}function b(t,r,i,n){t.TERM_PROGRAM="vscode",r&&(t.TERM_PROGRAM_VERSION=r),v(t,n)&&(t.LANG=d(i)),t.COLORTERM="truecolor"}e.addTerminalEnvironmentKeys=b;function k(t,r){if(!!r)for(const i of Object.keys(r)){const n=r[i];n&&(t[i]=n)}}async function I(t,r){return await Promise.all(Object.entries(r).map(async([i,n])=>{if(typeof n=="string")try{r[i]=await t(n)}catch{r[i]=n}})),r}function v(t,r){if(r==="on")return!0;if(r==="auto"){const i=t.LANG;return!i||i.search(/\.UTF\-8$/)===-1&&i.search(/\.utf8$/)===-1&&i.search(/\.euc.+/)===-1}return!1}e.shouldSetLangEnvVariable=v;function d(t){const r=t?t.split("-"):[],i=r.length;if(i===0)return"en_US.UTF-8";if(i===1){const n={af:"ZA",am:"ET",be:"BY",bg:"BG",ca:"ES",cs:"CZ",da:"DK",de:"DE",el:"GR",en:"US",es:"ES",et:"EE",eu:"ES",fi:"FI",fr:"FR",he:"IL",hr:"HR",hu:"HU",hy:"AM",is:"IS",it:"IT",ja:"JP",kk:"KZ",ko:"KR",lt:"LT",nl:"NL",no:"NO",pl:"PL",pt:"BR",ro:"RO",ru:"RU",sk:"SK",sl:"SI",sr:"YU",sv:"SE",tr:"TR",uk:"UA",zh:"CN"};r[0]in n&&r.push(n[r[0]])}else r[1]=r[1].toUpperCase();return r.join("_")+".UTF-8"}e.getLangEnvVariable=d;async function m(t,r,i,n,o,u){if(t.cwd){const s=typeof t.cwd=="object"?t.cwd.fsPath:t.cwd,C=await p(s,i);return(0,w.sanitizeCwd)(C||s)}let a;return!t.ignoreConfigurationCwd&&o&&(i&&(o=await p(o,i,u)),o&&(E.isAbsolute(o)?a=o:n&&(a=E.join(n.fsPath,o)))),a||(a=n?n.fsPath:r||""),(0,w.sanitizeCwd)(a)}e.getCwd=m;async function p(t,r,i){if(r)try{return await r(t)}catch(n){i?.error("Could not resolve terminal cwd",n);return}return t}function c(t,r,i){if(!!i)return n=>i.resolveWithEnvironment(r,t,n)}e.createVariableResolver=c;async function h(t,r,i,n,o,u,a,s=l.platform){let C;a&&(C=f(t,"automationShell",s)),C||(C=f(t,"shell",s));let L=C||r;if(s===3&&!i&&n){const O=E.join(n,"Sysnative").replace(/\//g,"\\").toLowerCase();L&&L.toLowerCase().indexOf(O)===0&&(L=E.join(n,"System32",L.substr(O.length+1)))}if(L&&s===3&&(L=L.replace(/\//g,"\\")),o)try{L=await o(L)}catch(O){u.error("Could not resolve shell",O)}return L}e.getDefaultShell=h;async function g(t,r,i,n,o=l.platform){if(r&&f(t,"automationShell",o))return[];const u=o===3?"windows":o===1?"osx":"linux";let a=t(`terminal.integrated.shellArgs.${u}`);if(!a)return[];if(typeof a=="string"&&o===3)return i?await i(a):a;if(i){const s=[];for(const C of a)try{s.push(await i(C))}catch(L){n.error(`Could not resolve terminal.integrated.shellArgs.${u}`,L),s.push(C)}a=s}return a}e.getDefaultShellArgs=g;function f(t,r,i=l.platform){return t(`terminal.integrated.${r}.${i===3?"windows":i===1?"osx":"linux"}`)}async function D(t,r,i,n,o,u){const a={};if(t.strictEnv)k(a,t.env);else{k(a,u);const s={...r};i&&(s&&await I(i,s),t.env&&await I(i,t.env)),(0,A.sanitizeProcessEnvironment)(a,"VSCODE_IPC_HOOK_CLI","VSCODE_PROXY_URI"),P(a,s),P(a,t.env),b(a,n,l.language,o)}return a}e.createTerminalEnvironment=D;async function R(t,r,i,n,o,u,a=l.isWindows){let s;if((0,S.isString)(t)?s=t:(s=t.fsPath,a&&u!==1?s=s.replace(/\\/g,"/"):!a&&u===1&&(s=s.replace(/\//g,"\\"))),!r)return s;const C=s.includes(" "),L=s.includes("(")||s.includes(")"),O=E.basename(r,".exe"),W=O==="pwsh"||i==="pwsh"||O==="powershell"||i==="powershell";if(W&&(C||s.includes("'")))return`& '${s.replace(/'/g,"''")}'`;if(L&&W)return`& '${s}'`;if(u===1){if(n!==void 0)return n==="gitbash"?(0,w.escapeNonWindowsPath)(s.replace(/\\/g,"/")):n==="wsl"?o?.getWslPath(s,"win-to-unix")||s:C?`"${s}"`:s;const X=r.toLowerCase();return X.includes("wsl")||X.includes("bash.exe")&&!X.toLowerCase().includes("git")?o?.getWslPath(s,"win-to-unix")||s:C?`"${s}"`:s}return(0,w.escapeNonWindowsPath)(s)}e.preparePathForShell=R}),define(be[69],Ee([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var E;(function(w){w.Delimiter="\0"})(E=e.TestIdPathParts||(e.TestIdPathParts={}));var A;(function(w){w[w.IsSame=0]="IsSame",w[w.Disconnected=1]="Disconnected",w[w.IsChild=2]="IsChild",w[w.IsParent=3]="IsParent"})(A=e.TestPosition||(e.TestPosition={}));class l{static fromExtHostTestItem(S,P,y=S.parent){if(S._isRoot)return new l([P]);const b=[S.id];for(let k=y;k&&k.id!==P;k=k.parent)b.push(k.id);return b.push(P),new l(b.reverse())}static isRoot(S){return!S.includes("\0")}static root(S){const P=S.indexOf("\0");return P===-1?S:S.slice(0,P)}static fromString(S){return new l(S.split("\0"))}static join(S,P){return new l([...S.path,P])}static joinToString(S,P){return S.toString()+"\0"+P}static parentId(S){const P=S.lastIndexOf("\0");return P===-1?void 0:S.slice(0,P)}static localId(S){const P=S.lastIndexOf("\0");return P===-1?S:S.slice(P+1)}static compare(S,P){return S===P?0:P.startsWith(S+"\0")?2:S.startsWith(P+"\0")?3:1}constructor(S,P=S.length){if(this.path=S,this.d=P,S.length===0||P<1)throw new Error("cannot create test with empty path")}get parentId(){return this.d>1?new l(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let S=1;S<=this.d;S++)yield new l(this.path,S)}*idsToRoot(){for(let S=this.d;S>0;S--)yield new l(this.path,S)}compare(S){if(typeof S=="string")return l.compare(this.toString(),S);for(let P=0;P<S.d&&P<this.d;P++)if(S.path[P]!==this.path[P])return 1;return S.d>this.d?2:S.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let S=1;S<this.d;S++)this.c+="\0",this.c+=this.path[S]}return this.c}}e.TestId=l}),define(be[85],Ee([1,0,4,49,69]),function(oe,e,E,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.isStartControllerTests=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var w;(function(a){a[a.Unset=0]="Unset",a[a.Queued=1]="Queued",a[a.Running=2]="Running",a[a.Passed=3]="Passed",a[a.Failed=4]="Failed",a[a.Skipped=5]="Skipped",a[a.Errored=6]="Errored"})(w=e.TestResultState||(e.TestResultState={}));var S;(function(a){a[a.Run=2]="Run",a[a.Debug=4]="Debug",a[a.Coverage=8]="Coverage",a[a.HasNonDefaultProfile=16]="HasNonDefaultProfile",a[a.HasConfigurable=32]="HasConfigurable",a[a.SupportsContinuousRun=64]="SupportsContinuousRun"})(S=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16,32,64];const P=a=>"runId"in a;e.isStartControllerTests=P;var y;(function(a){a.serialize=s=>({range:s.range.toJSON(),uri:s.uri.toJSON()}),a.deserialize=s=>({range:A.Range.lift(s.range),uri:E.URI.revive(s.uri)})})(y=e.IRichLocation||(e.IRichLocation={}));var b;(function(a){a[a.Error=0]="Error",a[a.Output=1]="Output"})(b=e.TestMessageType||(e.TestMessageType={}));var k;(function(a){a.serialize=s=>({message:s.message,type:0,expected:s.expected,actual:s.actual,location:s.location&&y.serialize(s.location)}),a.deserialize=s=>({message:s.message,type:0,expected:s.expected,actual:s.actual,location:s.location&&y.deserialize(s.location)})})(k=e.ITestErrorMessage||(e.ITestErrorMessage={}));const I=(a,s)=>`${s?"s":"e"}${a}`;e.getMarkId=I;var v;(function(a){a.serialize=s=>({message:s.message,type:1,offset:s.offset,length:s.length,location:s.location&&y.serialize(s.location)}),a.deserialize=s=>({message:s.message,type:1,offset:s.offset,length:s.length,location:s.location&&y.deserialize(s.location)})})(v=e.ITestOutputMessage||(e.ITestOutputMessage={}));var d;(function(a){a.serialize=s=>s.type===0?k.serialize(s):v.serialize(s),a.deserialize=s=>s.type===0?k.deserialize(s):v.deserialize(s)})(d=e.ITestMessage||(e.ITestMessage={}));var m;(function(a){a.serializeWithoutMessages=s=>({state:s.state,duration:s.duration,messages:[]}),a.serialize=s=>({state:s.state,duration:s.duration,messages:s.messages.map(d.serialize)}),a.deserialize=s=>({state:s.state,duration:s.duration,messages:s.messages.map(d.deserialize)})})(m=e.ITestTaskState||(e.ITestTaskState={}));const p="\0",c=(a,s)=>a+p+s;e.namespaceTestTag=c;const h=a=>{const s=a.indexOf(p);return{ctrlId:a.slice(0,s),tagId:a.slice(s+1)}};e.denamespaceTestTag=h;var g;(function(a){a.serialize=s=>({extId:s.extId,label:s.label,tags:s.tags,busy:s.busy,children:void 0,uri:s.uri?.toJSON(),range:s.range?.toJSON()||null,description:s.description,error:s.error,sortText:s.sortText}),a.deserialize=s=>({extId:s.extId,label:s.label,tags:s.tags,busy:s.busy,children:void 0,uri:s.uri?E.URI.revive(s.uri):void 0,range:s.range?A.Range.lift(s.range):null,description:s.description,error:s.error,sortText:s.sortText})})(g=e.ITestItem||(e.ITestItem={}));var f;(function(a){a[a.NotExpandable=0]="NotExpandable",a[a.Expandable=1]="Expandable",a[a.BusyExpanding=2]="BusyExpanding",a[a.Expanded=3]="Expanded"})(f=e.TestItemExpandState||(e.TestItemExpandState={}));var D;(function(a){a.serialize=s=>({expand:s.expand,item:g.serialize(s.item)}),a.deserialize=s=>({controllerId:l.TestId.root(s.item.extId),expand:s.expand,item:g.deserialize(s.item)})})(D=e.InternalTestItem||(e.InternalTestItem={}));var R;(function(a){a.serialize=s=>{let C;return s.item&&(C={},s.item.label!==void 0&&(C.label=s.item.label),s.item.tags!==void 0&&(C.tags=s.item.tags),s.item.busy!==void 0&&(C.busy=s.item.busy),s.item.uri!==void 0&&(C.uri=s.item.uri?.toJSON()),s.item.range!==void 0&&(C.range=s.item.range?.toJSON()),s.item.description!==void 0&&(C.description=s.item.description),s.item.error!==void 0&&(C.error=s.item.error),s.item.sortText!==void 0&&(C.sortText=s.item.sortText)),{extId:s.extId,expand:s.expand,item:C}},a.deserialize=s=>{let C;return s.item&&(C={},s.item.label!==void 0&&(C.label=s.item.label),s.item.tags!==void 0&&(C.tags=s.item.tags),s.item.busy!==void 0&&(C.busy=s.item.busy),s.item.range!==void 0&&(C.range=s.item.range?A.Range.lift(s.item.range):null),s.item.description!==void 0&&(C.description=s.item.description),s.item.error!==void 0&&(C.error=s.item.error),s.item.sortText!==void 0&&(C.sortText=s.item.sortText)),{extId:s.extId,expand:s.expand,item:C}}})(R=e.ITestItemUpdate||(e.ITestItemUpdate={}));const t=(a,s)=>{s.expand!==void 0&&(a.expand=s.expand),s.item!==void 0&&(a.item=a.item?Object.assign(a.item,s.item):s.item)};e.applyTestItemUpdate=t;var r;(function(a){a.serializeWithoutMessages=s=>({...D.serialize(s),ownComputedState:s.ownComputedState,computedState:s.computedState,tasks:s.tasks.map(m.serializeWithoutMessages),retired:s.retired}),a.serialize=s=>({...D.serialize(s),ownComputedState:s.ownComputedState,computedState:s.computedState,tasks:s.tasks.map(m.serialize),retired:s.retired}),a.deserialize=s=>({...D.deserialize(s),ownComputedState:s.ownComputedState,computedState:s.computedState,tasks:s.tasks.map(m.deserialize),retired:!0})})(r=e.TestResultItem||(e.TestResultItem={}));var i;(function(a){a[a.Function=0]="Function",a[a.Statement=1]="Statement"})(i=e.DetailType||(e.DetailType={}));var n;(function(a){a[a.Add=0]="Add",a[a.Update=1]="Update",a[a.DocumentSynced=2]="DocumentSynced",a[a.Remove=3]="Remove",a[a.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",a[a.Retire=5]="Retire",a[a.AddTag=6]="AddTag",a[a.RemoveTag=7]="RemoveTag"})(n=e.TestDiffOpType||(e.TestDiffOpType={}));var o;(function(a){a.deserialize=s=>s.op===0?{op:s.op,item:D.deserialize(s.item)}:s.op===1?{op:s.op,item:R.deserialize(s.item)}:s.op===2?{op:s.op,uri:E.URI.revive(s.uri),docv:s.docv}:s,a.serialize=s=>s.op===0?{op:s.op,item:D.serialize(s.item)}:s.op===1?{op:s.op,item:R.serialize(s.item)}:s})(o=e.TestsDiffOp||(e.TestsDiffOp={}));class u{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(s){const C=this.o();for(const L of s)switch(L.op){case 0:this.j(D.deserialize(L.item),C);break;case 1:this.k(R.deserialize(L.item),C);break;case 3:this.l(L.itemId,C);break;case 5:this.m(L.itemId);break;case 4:this.updatePendingRoots(L.amount);break;case 6:this.c.set(L.tag.id,L.tag);break;case 7:this.c.delete(L.id);break}C.complete?.()}j(s,C){const L=l.TestId.parentId(s.item.extId)?.toString();let O;if(!L)O=this.p(s),this.f.add(O),this.d.set(s.item.extId,O);else if(this.d.has(L)){const W=this.d.get(L);W.children.add(s.item.extId),O=this.p(s,W),this.d.set(s.item.extId,O)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(s)}`);return}return C.add?.(O),s.expand===2&&this.g++,O}k(s,C){const L=this.d.get(s.extId);if(!!L)return s.expand!==void 0&&(L.expand===2&&this.g--,s.expand===2&&this.g++),(0,e.applyTestItemUpdate)(L,s),C.update?.(L),L}l(s,C){const L=this.d.get(s);if(!L)return;const O=l.TestId.parentId(L.item.extId)?.toString();O?this.d.get(O).children.delete(L.item.extId):this.f.delete(L);const W=[[s]];for(;W.length;)for(const X of W.pop()){const se=this.d.get(X);se&&(W.push(se.children),this.d.delete(X),C.remove?.(se,se!==L),se.expand===2&&this.g--)}}m(s){}updatePendingRoots(s){this.h+=s}o(){return{}}}e.AbstractIncrementalTestCollection=u}),define(be[129],Ee([1,0,14,6,2,88,85,69]),function(oe,e,E,A,l,w,S,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var y;(function(g){g[g.Upsert=0]="Upsert",g[g.SetTags=1]="SetTags",g[g.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",g[g.RemoveChild=3]="RemoveChild",g[g.SetProp=4]="SetProp",g[g.Bulk=5]="Bulk",g[g.DocumentSynced=6]="DocumentSynced"})(y=e.TestItemEventOp||(e.TestItemEventOp={}));const b=(g,f)=>g===f,I=Object.entries({range:(g,f)=>g===f?!0:!g||!f?!1:g.equalsRange(f),busy:b,label:b,description:b,error:b,sortText:b,tags:(g,f)=>!(g.length!==f.length||g.some(D=>!f.includes(D)))}),v=(g,f)=>{let D;for(const[R,t]of I)t(g[R],f[R])||(D?D[R]=f[R]:D={[R]:f[R]});return D};class d extends l.Disposable{get root(){return this.m.root}constructor(f){super(),this.m=f,this.f=this.B(new E.RunOnceScheduler(()=>this.flushDiff(),200)),this.g=this.B(new A.Emitter),this.tree=new Map,this.j=new Map,this.k=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.u(this.root,void 0)}set resolveHandler(f){this.h=f;for(const D of this.tree.values())this.G(D)}get resolveHandler(){return this.h}collectDiff(){const f=this.k;return this.k=[],f}pushDiff(f){switch(f.op){case 2:{for(const D of this.k)if(D.op===2&&D.uri===f.uri){D.docv=f.docv;return}break}case 1:{const D=this.k[this.k.length-1];if(D){if(D.op===1&&D.item.extId===f.item.extId){(0,S.applyTestItemUpdate)(D.item,f.item);return}if(D.op===0&&D.item.item.extId===f.item.extId){(0,S.applyTestItemUpdate)(D.item,f.item);return}}break}}this.k.push(f),this.f.isScheduled()||this.f.schedule()}expand(f,D){const R=this.tree.get(f);if(!!R){if((R.expandLevels===void 0||D>R.expandLevels)&&(R.expandLevels=D),R.expand===1){const t=this.I(R);return t.isOpen()?this.H(R,D-1):t.wait().then(()=>this.H(R,D-1))}else if(R.expand===3)return R.resolveBarrier?.isOpen()===!1?R.resolveBarrier.wait().then(()=>this.H(R,D-1)):this.H(R,D-1)}}dispose(){for(const f of this.tree.values())this.m.getApiFor(f.actual).listener=void 0;this.tree.clear(),this.k=[],super.dispose()}p(f,D){switch(D.op){case 3:this.L(P.TestId.joinToString(f.fullId,D.id));break;case 0:this.u(D.item,f);break;case 5:for(const R of D.ops)this.p(f,R);break;case 1:this.w(D.new,D.old,f.fullId.toString());break;case 2:this.G(f);break;case 4:this.pushDiff({op:1,item:{extId:f.fullId.toString(),item:D.update}});break;case 6:this.s(f.actual.uri);break;default:(0,w.assertNever)(D)}}s(f){f&&this.pushDiff({op:2,uri:f,docv:this.m.getDocumentVersion(f)})}u(f,D){const R=P.TestId.fromExtHostTestItem(f,this.root.id,D?.actual),t=this.m.getApiFor(f);t.parent&&t.parent!==D?.actual&&this.m.getChildren(t.parent).delete(f.id);let r=this.tree.get(R.toString());if(!r){r={fullId:R,actual:f,expandLevels:D?.expandLevels?D.expandLevels-1:void 0,expand:0},f.tags.forEach(this.y,this),this.tree.set(r.fullId.toString(),r),this.C(f,D),this.pushDiff({op:0,item:{controllerId:this.m.controllerId,expand:r.expand,item:this.m.toITestItem(f)}}),this.F(f,r,D);return}if(r.actual===f){this.D(f,r,D);return}if(r.actual.uri?.toString()!==f.uri?.toString())return this.L(R.toString()),this.u(f,D);const i=this.m.getChildren(r.actual),n=r.actual,o=v(this.m.toITestItem(n),this.m.toITestItem(f));this.m.getApiFor(n).listener=void 0,r.actual=f,r.expand=0,o&&(o.hasOwnProperty("tags")&&(this.w(f.tags,n.tags,R.toString()),delete o.tags),this.p(r,{op:4,update:o})),this.F(f,r,D);for(const[u,a]of i)this.m.getChildren(f).get(a.id)||this.L(P.TestId.joinToString(R,a.id));this.s(r.actual.uri)}w(f,D,R){const t=new Set(D.map(r=>r.id));for(const r of f)t.delete(r.id)||this.y(r);this.pushDiff({op:1,item:{extId:R,item:{tags:f.map(r=>(0,S.namespaceTestTag)(this.m.controllerId,r.id))}}}),t.forEach(this.z,this)}y(f){const D=this.j.get(f.id);D?D.refCount++:(this.j.set(f.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,S.namespaceTestTag)(this.m.controllerId,f.id)}}))}z(f){const D=this.j.get(f);D&&!--D.refCount&&(this.j.delete(f),this.pushDiff({op:7,id:(0,S.namespaceTestTag)(this.m.controllerId,f)}))}C(f,D){this.m.getApiFor(f).parent=D&&D.actual!==this.root?D.actual:void 0}D(f,D,R){this.C(f,R);const t=this.m.getApiFor(f);t.parent=R?.actual,t.listener=r=>this.p(D,r),this.G(D)}F(f,D,R){this.D(f,D,R);for(const[t,r]of this.m.getChildren(f))this.u(r,D)}G(f){let D;this.h?f.resolveBarrier?D=f.resolveBarrier.isOpen()?3:2:D=f.actual.canResolveChildren?1:0:D=0,D!==f.expand&&(f.expand=D,this.pushDiff({op:1,item:{extId:f.fullId.toString(),expand:D}}),D===1&&f.expandLevels!==void 0&&this.I(f))}H(f,D){if(D<0)return;const R=[];for(const[t,r]of this.m.getChildren(f.actual)){const i=this.expand(P.TestId.joinToString(f.fullId,r.id),D);(0,E.isThenable)(i)&&R.push(i)}if(R.length)return Promise.all(R).then(()=>{})}I(f){if(f.resolveBarrier)return f.resolveBarrier;if(!this.h){const r=new E.Barrier;return r.open(),r}f.expand=2,this.J(f);const D=f.resolveBarrier=new E.Barrier,R=r=>{console.error(`Unhandled error in resolveHandler of test controller "${this.m.controllerId}"`,r)};let t;try{t=this.h(f.actual===this.root?void 0:f.actual)}catch(r){R(r)}return(0,E.isThenable)(t)?t.catch(R).then(()=>{D.open(),this.G(f)}):(D.open(),this.G(f)),f.resolveBarrier}J(f){this.pushDiff({op:1,item:{extId:f.fullId.toString(),expand:f.expand}})}L(f){const D=this.tree.get(f);if(!D)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:f});const R=[D];for(;R.length;){const t=R.pop();if(!!t){this.m.getApiFor(t.actual).listener=void 0;for(const r of t.actual.tags)this.z(r.id);this.tree.delete(t.fullId.toString());for(const[r,i]of this.m.getChildren(t.actual))R.push(this.tree.get(P.TestId.joinToString(t.fullId,i.id)))}}}flushDiff(){const f=this.collectDiff();f.length&&this.g.fire(f)}}e.TestItemCollection=d;class m extends Error{constructor(f){super(`Attempted to insert a duplicate test item ID ${f}`)}}e.DuplicateTestItemError=m;class p extends Error{constructor(f){super(`TestItem with ID "${f}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=p;class c extends Error{constructor(f,D,R){super(`TestItem with ID "${f}" is from controller "${D}" and cannot be added as a child of an item from controller "${R}".`)}}e.MixedTestItemController=c;const h=(g,f,D)=>{let R=new Map;return{get size(){return R.size},forEach(t,r){for(const i of R.values())t.call(r,i,this)},[Symbol.iterator](){return R.entries()},replace(t){const r=new Map,i=new Set(R.keys()),n={op:5,ops:[]};for(const o of t){if(!(o instanceof D))throw new p(o.id);const u=f(o).controllerId;if(u!==g.controllerId)throw new c(o.id,u,g.controllerId);if(r.has(o.id))throw new m(o.id);r.set(o.id,o),i.delete(o.id),n.ops.push({op:0,item:o})}for(const o of i.keys())n.ops.push({op:3,id:o});g.listener?.(n),R=r},add(t){if(!(t instanceof D))throw new p(t.id);R.set(t.id,t),g.listener?.({op:0,item:t})},delete(t){R.delete(t)&&g.listener?.({op:3,id:t})},get(t){return R.get(t)},toJSON(){return Array.from(R.values())}}};e.createTestItemChildren=h}),define(be[130],Ee([1,0,129]),function(oe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const A=new WeakMap,l=(S,P)=>{const y={controllerId:P};return A.set(S,y),y};e.createPrivateApiFor=l;const w=S=>{const P=A.get(S);if(!P)throw new E.InvalidTestItemError(S?.id||"<unknown>");return P};e.getPrivateApiFor=w}),define(be[268],Ee([1,0,24,5]),function(oe,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TASKS_DEFAULT=e.IWorkbenchConfigurationService=e.USER_STANDALONE_CONFIGURATIONS=e.WORKSPACE_STANDALONE_CONFIGURATIONS=e.LAUNCH_CONFIGURATION_KEY=e.TASKS_CONFIGURATION_KEY=e.FOLDER_SCOPES=e.WORKSPACE_SCOPES=e.REMOTE_MACHINE_SCOPES=e.LOCAL_MACHINE_SCOPES=e.LOCAL_MACHINE_PROFILE_SCOPES=e.PROFILE_SCOPES=e.APPLICATION_SCOPES=e.tasksSchemaId=e.launchSchemaId=e.folderSettingsSchemaId=e.workspaceSettingsSchemaId=e.machineSettingsSchemaId=e.profileSettingsSchemaId=e.userSettingsSchemaId=e.defaultSettingsSchemaId=e.FOLDER_SETTINGS_PATH=e.FOLDER_SETTINGS_NAME=e.FOLDER_CONFIG_FOLDER_NAME=void 0,e.FOLDER_CONFIG_FOLDER_NAME=".vscode",e.FOLDER_SETTINGS_NAME="settings",e.FOLDER_SETTINGS_PATH=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.FOLDER_SETTINGS_NAME}.json`,e.defaultSettingsSchemaId="vscode://schemas/settings/default",e.userSettingsSchemaId="vscode://schemas/settings/user",e.profileSettingsSchemaId="vscode://schemas/settings/profile",e.machineSettingsSchemaId="vscode://schemas/settings/machine",e.workspaceSettingsSchemaId="vscode://schemas/settings/workspace",e.folderSettingsSchemaId="vscode://schemas/settings/folder",e.launchSchemaId="vscode://schemas/launch",e.tasksSchemaId="vscode://schemas/tasks",e.APPLICATION_SCOPES=[1],e.PROFILE_SCOPES=[2,3,4,5,6],e.LOCAL_MACHINE_PROFILE_SCOPES=[3,4,5],e.LOCAL_MACHINE_SCOPES=[1,...e.LOCAL_MACHINE_PROFILE_SCOPES],e.REMOTE_MACHINE_SCOPES=[2,3,4,5,6],e.WORKSPACE_SCOPES=[3,4,5,6],e.FOLDER_SCOPES=[4,5,6],e.TASKS_CONFIGURATION_KEY="tasks",e.LAUNCH_CONFIGURATION_KEY="launch",e.WORKSPACE_STANDALONE_CONFIGURATIONS=Object.create(null),e.WORKSPACE_STANDALONE_CONFIGURATIONS[e.TASKS_CONFIGURATION_KEY]=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.TASKS_CONFIGURATION_KEY}.json`,e.WORKSPACE_STANDALONE_CONFIGURATIONS[e.LAUNCH_CONFIGURATION_KEY]=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.LAUNCH_CONFIGURATION_KEY}.json`,e.USER_STANDALONE_CONFIGURATIONS=Object.create(null),e.USER_STANDALONE_CONFIGURATIONS[e.TASKS_CONFIGURATION_KEY]=`${e.TASKS_CONFIGURATION_KEY}.json`,e.IWorkbenchConfigurationService=(0,A.refineServiceDecorator)(E.IConfigurationService),e.TASKS_DEFAULT=`{
	"version": "2.0.0",
	"tasks": []
}`}),define(be[131],Ee([1,0,5]),function(oe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,E.createDecorator)("configurationResolverService");var A;(function(w){w.Unknown="unknown",w.Env="env",w.Config="config",w.Command="command",w.Input="input",w.ExtensionInstallFolder="extensionInstallFolder",w.WorkspaceFolder="workspaceFolder",w.Cwd="cwd",w.WorkspaceFolderBasename="workspaceFolderBasename",w.UserHome="userHome",w.LineNumber="lineNumber",w.SelectedText="selectedText",w.File="file",w.FileWorkspaceFolder="fileWorkspaceFolder",w.RelativeFile="relativeFile",w.RelativeFileDirname="relativeFileDirname",w.FileDirname="fileDirname",w.FileExtname="fileExtname",w.FileBasename="fileBasename",w.FileBasenameNoExtension="fileBasenameNoExtension",w.FileDirnameBasename="fileDirnameBasename",w.ExecPath="execPath",w.ExecInstallFolder="execInstallFolder",w.PathSeparator="pathSeparator"})(A=e.VariableKind||(e.VariableKind={}));class l extends Error{constructor(S,P){super(P),this.variable=S}}e.VariableError=l}),define(be[269],Ee([1,0,7,28,8,23,3,150,196,131,17]),function(oe,e,E,A,l,w,S,P,y,b,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class I{constructor(d,m,p,c){this.g=new Map,this.a=d,this.b=m,this.d=p,c&&(this.c=c.then(h=>this.h(h)))}h(d){if(S.isWindows){const m=Object.create(null);return Object.keys(d).forEach(p=>{m[p.toLowerCase()]=d[p]}),m}return d}resolveWithEnvironment(d,m,p){return this.j({env:this.h(d),userHome:void 0},m?m.uri:void 0,p)}async resolveAsync(d,m){const p={env:await this.c,userHome:await this.d};return this.j(p,d?d.uri:void 0,m)}async i(d,m,p,c){const h=w.deepClone(m);S.isWindows&&h.windows?Object.keys(h.windows).forEach(f=>h[f]=h.windows[f]):S.isMacintosh&&h.osx?Object.keys(h.osx).forEach(f=>h[f]=h.osx[f]):S.isLinux&&h.linux&&Object.keys(h.linux).forEach(f=>h[f]=h.linux[f]),delete h.windows,delete h.osx,delete h.linux;const g={env:await this.c,userHome:await this.d};return this.j(g,d?d.uri:void 0,h,p,c)}async resolveAnyAsync(d,m,p){return this.i(d,m,p)}async resolveAnyMap(d,m,p){const c=new Map;return{newConfig:await this.i(d,m,p,c),resolvedVariables:c}}resolveWithInteractionReplace(d,m,p,c){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(d,m,p,c){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(d,m){if(this.g.has(d))throw new Error("Variable "+d+" is contributed twice.");this.g.set(d,m)}async j(d,m,p,c,h){if(l.isString(p))return this.l(d,m,p,c,h);if(Array.isArray(p))return Promise.all(p.map(g=>this.j(d,m,g,c,h)));if(l.isObject(p)){const g=Object.create(null),f=await Promise.all(Object.keys(p).map(async D=>[await this.l(d,m,D,c,h),await this.j(d,m,p[D],c,h)]));for(const[D,R]of f)g[D]=R;return g}return p}l(d,m,p,c,h){return(0,k.replaceAsync)(p,I.VARIABLE_REGEXP,async(g,f)=>{if(f.includes(I.VARIABLE_LHS))return g;let D=await this.n(d,g,f,m,c);return h?.set(f,D),D!==g&&l.isString(D)&&D.match(I.VARIABLE_REGEXP)&&(D=await this.l(d,m,D,c,h)),D})}m(d){return this.b?this.b.getUriLabel(d,{noPrefix:!0}):d.fsPath}async n(d,m,p,c,h){let g;const f=p.split(":");f.length>1&&(p=f[0],g=f[1]);const D=r=>{const i=this.a.getFilePath();if(i)return(0,P.normalizeDriveLetter)(i);throw new b.VariableError(r,(0,y.localize)(0,null,m))},R=r=>{const i=D(r);if(this.a.getWorkspaceFolderPathForFile){const n=this.a.getWorkspaceFolderPathForFile();if(n)return(0,P.normalizeDriveLetter)(n)}throw new b.VariableError(r,(0,y.localize)(1,null,m,E.basename(i)))},t=r=>{if(g){const i=this.a.getFolderUri(g);if(i)return i;throw new b.VariableError(r,(0,y.localize)(2,null,m,g))}if(c)return c;throw this.a.getWorkspaceFolderCount()>1?new b.VariableError(r,(0,y.localize)(3,null,m)):new b.VariableError(r,(0,y.localize)(4,null,m))};switch(p){case"env":if(g){if(d.env){const r=d.env[S.isWindows?g.toLowerCase():g];if(l.isString(r))return r}return""}throw new b.VariableError(b.VariableKind.Env,(0,y.localize)(5,null,m));case"config":if(g){const r=this.a.getConfigurationValue(c,g);if(l.isUndefinedOrNull(r))throw new b.VariableError(b.VariableKind.Config,(0,y.localize)(6,null,m,g));if(l.isObject(r))throw new b.VariableError(b.VariableKind.Config,(0,y.localize)(7,null,m,g));return r}throw new b.VariableError(b.VariableKind.Config,(0,y.localize)(8,null,m));case"command":return this.o(b.VariableKind.Command,m,g,h,"command");case"input":return this.o(b.VariableKind.Input,m,g,h,"input");case"extensionInstallFolder":if(g){const r=await this.a.getExtension(g);if(!r)throw new b.VariableError(b.VariableKind.ExtensionInstallFolder,(0,y.localize)(9,null,m,g));return this.m(r.extensionLocation)}throw new b.VariableError(b.VariableKind.ExtensionInstallFolder,(0,y.localize)(10,null,m));default:switch(p){case"workspaceRoot":case"workspaceFolder":return(0,P.normalizeDriveLetter)(this.m(t(b.VariableKind.WorkspaceFolder)));case"cwd":return c||g?(0,P.normalizeDriveLetter)(this.m(t(b.VariableKind.Cwd))):A.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,P.normalizeDriveLetter)(E.basename(this.m(t(b.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(d.userHome)return d.userHome;throw new b.VariableError(b.VariableKind.UserHome,(0,y.localize)(11,null,m))}case"lineNumber":{const r=this.a.getLineNumber();if(r)return r;throw new b.VariableError(b.VariableKind.LineNumber,(0,y.localize)(12,null,m))}case"selectedText":{const r=this.a.getSelectedText();if(r)return r;throw new b.VariableError(b.VariableKind.SelectedText,(0,y.localize)(13,null,m))}case"file":return D(b.VariableKind.File);case"fileWorkspaceFolder":return R(b.VariableKind.FileWorkspaceFolder);case"relativeFile":return c||g?E.relative(this.m(t(b.VariableKind.RelativeFile)),D(b.VariableKind.RelativeFile)):D(b.VariableKind.RelativeFile);case"relativeFileDirname":{const r=E.dirname(D(b.VariableKind.RelativeFileDirname));if(c||g){const i=E.relative(this.m(t(b.VariableKind.RelativeFileDirname)),r);return i.length===0?".":i}return r}case"fileDirname":return E.dirname(D(b.VariableKind.FileDirname));case"fileExtname":return E.extname(D(b.VariableKind.FileExtname));case"fileBasename":return E.basename(D(b.VariableKind.FileBasename));case"fileBasenameNoExtension":{const r=E.basename(D(b.VariableKind.FileBasenameNoExtension));return r.slice(0,r.length-E.extname(r).length)}case"fileDirnameBasename":return E.basename(E.dirname(D(b.VariableKind.FileDirnameBasename)));case"execPath":{const r=this.a.getExecPath();return r||m}case"execInstallFolder":{const r=this.a.getAppRoot();return r||m}case"pathSeparator":return E.sep;default:try{const r=g?`${p}:${g}`:p;return this.o(b.VariableKind.Unknown,m,r,h,void 0)}catch{return m}}}}o(d,m,p,c,h){if(p&&c){const g=h===void 0?c[p]:c[h+":"+p];if(typeof g=="string")return g;throw new b.VariableError(d,(0,y.localize)(14,null,m))}return m}}I.VARIABLE_LHS="${",I.VARIABLE_REGEXP=/\$\{(.*?)\}/g,e.AbstractVariableResolverService=I}),define(be[270],Ee([1,0,5,84]),function(oe,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,E.createDecorator)("editorGroupsService");var l;(function(m){m[m.UP=0]="UP",m[m.DOWN=1]="DOWN",m[m.LEFT=2]="LEFT",m[m.RIGHT=3]="RIGHT"})(l=e.GroupDirection||(e.GroupDirection={}));var w;(function(m){m[m.HORIZONTAL=0]="HORIZONTAL",m[m.VERTICAL=1]="VERTICAL"})(w=e.GroupOrientation||(e.GroupOrientation={}));var S;(function(m){m[m.FIRST=0]="FIRST",m[m.LAST=1]="LAST",m[m.NEXT=2]="NEXT",m[m.PREVIOUS=3]="PREVIOUS"})(S=e.GroupLocation||(e.GroupLocation={}));var P;(function(m){m[m.MAXIMIZE=0]="MAXIMIZE",m[m.EVEN=1]="EVEN",m[m.TOGGLE=2]="TOGGLE"})(P=e.GroupsArrangement||(e.GroupsArrangement={}));var y;(function(m){m[m.COPY_EDITORS=0]="COPY_EDITORS",m[m.MOVE_EDITORS=1]="MOVE_EDITORS"})(y=e.MergeGroupMode||(e.MergeGroupMode={}));function b(m){const p=m;return(0,A.isEditorInput)(p?.editor)&&(0,A.isEditorInput)(p?.replacement)}e.isEditorReplacement=b;var k;(function(m){m[m.CREATION_TIME=0]="CREATION_TIME",m[m.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",m[m.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(k=e.GroupsOrder||(e.GroupsOrder={}));var I;(function(m){m[m.NEW_EDITOR=1]="NEW_EDITOR",m[m.MOVE_EDITOR=2]="MOVE_EDITOR",m[m.COPY_EDITOR=3]="COPY_EDITOR"})(I=e.OpenEditorContext||(e.OpenEditorContext={}));function v(m){const p=m;return!!p&&typeof p.id=="number"&&Array.isArray(p.editors)}e.isEditorGroup=v;function d(m){return m.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=d}),define(be[132],Ee([1,0,5,270]),function(oe,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,E.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function l(w){const S=w;return typeof w=="number"||(0,A.isEditorGroup)(S)}e.isPreferredGroup=l}),define(be[271],Ee([1,0,8,268,10,114,82,81,131,84,132,13,217,266]),function(oe,e,E,A,l,w,S,P,y,b,k,I,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTerminalChannelClient=e.REMOTE_TERMINAL_CHANNEL_NAME=void 0,e.REMOTE_TERMINAL_CHANNEL_NAME="remoteterminal";let m=class{get onPtyHostExit(){return this.b.listen("$onPtyHostExitEvent")}get onPtyHostStart(){return this.b.listen("$onPtyHostStartEvent")}get onPtyHostUnresponsive(){return this.b.listen("$onPtyHostUnresponsiveEvent")}get onPtyHostResponsive(){return this.b.listen("$onPtyHostResponsiveEvent")}get onPtyHostRequestResolveVariables(){return this.b.listen("$onPtyHostRequestResolveVariablesEvent")}get onProcessData(){return this.b.listen("$onProcessDataEvent")}get onProcessExit(){return this.b.listen("$onProcessExitEvent")}get onProcessReady(){return this.b.listen("$onProcessReadyEvent")}get onProcessReplay(){return this.b.listen("$onProcessReplayEvent")}get onProcessOrphanQuestion(){return this.b.listen("$onProcessOrphanQuestion")}get onExecuteCommand(){return this.b.listen("$onExecuteCommand")}get onDidRequestDetach(){return this.b.listen("$onDidRequestDetach")}get onDidChangeProperty(){return this.b.listen("$onDidChangeProperty")}constructor(c,h,g,f,D,R,t,r,i,n){this.a=c,this.b=h,this.c=g,this.d=f,this.e=D,this.f=R,this.g=t,this.h=r,this.i=i,this.j=n}restartPtyHost(){return this.b.call("$restartPtyHost",[])}async createProcess(c,h,g,f,D,R,t,r){await this.c.whenRemoteConfigurationLoaded();const i=Object.create(null),n=g?(0,E.withNullAsUndefined)(this.d.getWorkspaceFolder(g)):void 0;let o;try{o=(await this.e.resolveAnyMap(n,{shellLaunchConfig:c,configuration:h})).resolvedVariables}catch(se){this.h.error(se)}if(o)for(const[se,fe]of o.entries())(/^config:/.test(se)||se==="selectedText"||se==="lineNumber")&&(i[se]=fe);const u=[];for(const[se,fe]of this.f.collections.entries())u.push([se,(0,P.serializeEnvironmentVariableCollection)(fe.map)]);const a=await this.g.resolveAuthority(this.a),s=a.options&&a.options.extensionHostEnv,C=this.d.getWorkspace(),L=C.folders,O=g?this.d.getWorkspaceFolder(g):null,W=b.EditorResourceAccessor.getOriginalUri(this.i.activeEditor,{supportSideBySide:b.SideBySideEditor.PRIMARY,filterByScheme:[I.Schemas.file,I.Schemas.vscodeUserData,I.Schemas.vscodeRemote]}),X={configuration:h,resolvedVariables:i,envVariableCollections:u,shellLaunchConfig:c,workspaceId:C.id,workspaceName:this.j.getWorkspaceLabel(C),workspaceFolders:L,activeWorkspaceFolder:O,activeFileResource:W,shouldPersistTerminal:D,options:f,cols:R,rows:t,unicodeVersion:r,resolverEnv:s};return await this.b.call("$createProcess",X)}requestDetachInstance(c,h){return this.b.call("$requestDetachInstance",[c,h])}acceptDetachInstanceReply(c,h){return this.b.call("$acceptDetachInstanceReply",[c,h])}attachToProcess(c){return this.b.call("$attachToProcess",[c])}detachFromProcess(c,h){return this.b.call("$detachFromProcess",[c,h])}listProcesses(){return this.b.call("$listProcesses")}reduceConnectionGraceTime(){return this.b.call("$reduceConnectionGraceTime")}processBinary(c,h){return this.b.call("$processBinary",[c,h])}start(c){return this.b.call("$start",[c])}input(c,h){return this.b.call("$input",[c,h])}acknowledgeDataEvent(c,h){return this.b.call("$acknowledgeDataEvent",[c,h])}setUnicodeVersion(c,h){return this.b.call("$setUnicodeVersion",[c,h])}shutdown(c,h){return this.b.call("$shutdown",[c,h])}resize(c,h,g){return this.b.call("$resize",[c,h,g])}getInitialCwd(c){return this.b.call("$getInitialCwd",[c])}getCwd(c){return this.b.call("$getCwd",[c])}orphanQuestionReply(c){return this.b.call("$orphanQuestionReply",[c])}sendCommandResult(c,h,g){return this.b.call("$sendCommandResult",[c,h,g])}freePortKillProcess(c){return this.b.call("$freePortKillProcess",[c])}installAutoReply(c,h){return this.b.call("$installAutoReply",[c,h])}uninstallAllAutoReplies(){return this.b.call("$uninstallAllAutoReplies",[])}getDefaultSystemShell(c){return this.b.call("$getDefaultSystemShell",[c])}getProfiles(c,h,g){return this.b.call("$getProfiles",[this.d.getWorkspace().id,c,h,g])}acceptPtyHostResolvedVariables(c,h){return this.b.call("$acceptPtyHostResolvedVariables",[c,h])}getEnvironment(){return this.b.call("$getEnvironment")}getWslPath(c,h){return this.b.call("$getWslPath",[c,h])}setTerminalLayoutInfo(c){const g={workspaceId:this.d.getWorkspace().id,tabs:c?c.tabs:[]};return this.b.call("$setTerminalLayoutInfo",g)}updateTitle(c,h,g){return this.b.call("$updateTitle",[c,h,g])}updateIcon(c,h,g,f){return this.b.call("$updateIcon",[c,h,g,f])}refreshProperty(c,h){return this.b.call("$refreshProperty",[c,h])}updateProperty(c,h,g){return this.b.call("$updateProperty",[c,h,g])}getTerminalLayoutInfo(){const h={workspaceId:this.d.getWorkspace().id};return this.b.call("$getTerminalLayoutInfo",h)}reviveTerminalProcesses(c,h){return this.b.call("$reviveTerminalProcesses",[c,h])}getRevivedPtyNewId(c){return this.b.call("$getRevivedPtyNewId",[c])}serializeTerminalState(c){return this.b.call("$serializeTerminalState",[c])}};m=Te([Ae(2,A.IWorkbenchConfigurationService),Ae(3,S.IWorkspaceContextService),Ae(4,y.IConfigurationResolverService),Ae(5,d.IEnvironmentVariableService),Ae(6,w.IRemoteAuthorityResolverService),Ae(7,l.ILogService),Ae(8,k.IEditorService),Ae(9,v.ILabelService)],m),e.RemoteTerminalChannelClient=m}),define(be[272],Ee([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readExtHostConnection=e.writeExtHostConnection=e.MessagePortExtHostConnection=e.SocketExtHostConnection=e.IPCExtHostConnection=e.ExtHostConnectionType=void 0;var E;(function(k){k[k.IPC=1]="IPC",k[k.Socket=2]="Socket",k[k.MessagePort=3]="MessagePort"})(E=e.ExtHostConnectionType||(e.ExtHostConnectionType={}));class A{constructor(I){this.pipeName=I,this.type=1}serialize(I){I[A.ENV_KEY]=this.pipeName}}A.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK",e.IPCExtHostConnection=A;class l{constructor(){this.type=2}serialize(I){I[l.ENV_KEY]="1"}}l.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET",e.SocketExtHostConnection=l;class w{constructor(){this.type=3}serialize(I){I[w.ENV_KEY]="1"}}w.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT",e.MessagePortExtHostConnection=w;function S(k){delete k[A.ENV_KEY],delete k[l.ENV_KEY],delete k[w.ENV_KEY]}function P(k,I){S(I),k.serialize(I)}e.writeExtHostConnection=P;function y(k){if(k[A.ENV_KEY])return b(k,new A(k[A.ENV_KEY]));if(k[l.ENV_KEY])return b(k,new l);if(k[w.ENV_KEY])return b(k,new w);throw new Error("No connection information defined in environment!")}e.readExtHostConnection=y;function b(k,I){return S(k),I}}),define(be[133],Ee([1,0,48,97,83,13,7,15,6,62,80,10,41,3,58,126,2,272,24]),function(oe,e,E,A,l,w,S,P,y,b,k,I,v,d,m,p,c,h,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostConnection=e.buildUserEnvironment=void 0;async function f(n={},o,u,a,s,C){const L=await(0,l.getNLSConfiguration)(u,a.userDataPath);let O={};if(o)try{O=await(0,k.getResolvedShellEnv)(C,s,a.args,process.env)}catch(V){s.error("ExtensionHostConnection#buildUserEnvironment resolving shell environment failed",V)}const X={...process.env,...O,VSCODE_AMD_ENTRYPOINT:"vs/workbench/api/node/extensionHostProcess",VSCODE_HANDLES_UNCAUGHT_ERRORS:"true",VSCODE_NLS_CONFIG:JSON.stringify(L,void 0,0),...n},se=a.isBuilt?(0,S.join)(a.appRoot,"bin"):(0,S.join)(a.appRoot,"resources","server","bin-dev"),fe=(0,S.join)(se,"remote-cli");let ce=t(X,"PATH");return ce?ce=fe+S.delimiter+ce:ce=fe,r(X,"PATH",ce),a.args["without-browser-env-var"]||(X.BROWSER=(0,S.join)(se,"helpers",d.isWindows?"browser.cmd":"browser.sh")),i(X),X}e.buildUserEnvironment=f;class D{constructor(o,u){this.socket=o,this.initialDataChunk=u}socketDrain(){return this.socket.drain()}toIExtHostSocketMessage(){let o,u,a;return this.socket instanceof b.NodeSocket?(o=!0,u=!1,a=P.VSBuffer.alloc(0)):(o=!1,u=this.socket.permessageDeflate,a=this.socket.recordedInflateBytes),{type:"VSCODE_EXTHOST_IPC_SOCKET",initialDataChunk:this.initialDataChunk.buffer.toString("base64"),skipWebSocketFrames:o,permessageDeflate:u,inflateBytes:a.buffer.toString("base64")}}}let R=class{constructor(o,u,a,s,C,L,O,W){this.i=o,this.j=C,this.l=L,this.m=O,this.n=W,this.b=new y.Emitter,this.onClose=this.b.event,this.c=!d.isWindows||!this.j.args["socket-path"],this.d=!1,this.f=u,this.g=null,this.h=new D(a,s),this.p("New connection established.")}get o(){return`[${this.f}][${this.i.substr(0,8)}][ExtensionHostConnection] `}p(o){this.l.info(`${this.o}${o}`)}q(o){this.l.error(`${this.o}${o}`)}async r(o,u){const a=new c.DisposableStore;a.add(u.socket),a.add((0,c.toDisposable)(()=>{o.destroy()}));const s=()=>{a.dispose()};a.add(u.socket.onEnd(s)),a.add(u.socket.onClose(s)),a.add(y.Event.fromNodeEventEmitter(o,"end")(s)),a.add(y.Event.fromNodeEventEmitter(o,"close")(s)),a.add(y.Event.fromNodeEventEmitter(o,"error")(s)),a.add(u.socket.onData(C=>o.write(C.buffer))),a.add(y.Event.fromNodeEventEmitter(o,"data")(C=>{u.socket.write(P.VSBuffer.wrap(C))})),u.initialDataChunk.byteLength>0&&o.write(u.initialDataChunk.buffer)}async s(o,u){await u.socketDrain();const a=u.toIExtHostSocketMessage();let s;u.socket instanceof b.NodeSocket?s=u.socket.socket:s=u.socket.socket.socket,o.send(a,s)}shortenReconnectionGraceTimeIfNecessary(){if(!this.g)return;const o={type:"VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"};this.g.send(o)}acceptReconnection(o,u,a){this.f=o,this.p("The client has reconnected.");const s=new D(u,a);if(!this.g){this.h=s;return}this.s(this.g,s)}t(){this.d||(this.d=!0,this.h&&(this.h.socket.end(),this.h=null),this.g&&(this.g.kill(),this.g=null),this.b.fire(void 0))}async start(o){try{let u=process.execArgv?process.execArgv.filter(fe=>!/^--inspect(-brk)?=/.test(fe)):[];o.port&&!process.pkg&&(u=[`--inspect${o.break?"-brk":""}=${o.port}`]);const a=await f(o.env,!0,o.language,this.j,this.l,this.n);(0,m.removeDangerousEnvVariables)(a);let s;if(this.c)(0,h.writeExtHostConnection)(new h.SocketExtHostConnection,a),s=null;else{const{namedPipeServer:fe,pipeName:ce}=await this.u();(0,h.writeExtHostConnection)(new h.IPCExtHostConnection(ce),a),s=fe}const C={env:a,execArgv:u,silent:!0},L=["--type=extensionHost","--transformURIs"],O=this.j.args["use-host-proxy"];L.push(`--useHostProxy=${O?"true":"false"}`),this.g=E.fork(w.FileAccess.asFileUri("bootstrap-fork").fsPath,L,C);const W=this.g.pid;this.p(`<${W}> Launched Extension Host Process.`),this.g.stdout.setEncoding("utf8"),this.g.stderr.setEncoding("utf8");const X=y.Event.fromNodeEventEmitter(this.g.stdout,"data"),se=y.Event.fromNodeEventEmitter(this.g.stderr,"data");if(X(fe=>this.p(`<${W}> ${fe}`)),se(fe=>this.p(`<${W}><stderr> ${fe}`)),this.g.on("error",fe=>{this.q(`<${W}> Extension Host Process had an error`),this.l.error(fe),this.t()}),this.g.on("exit",(fe,ce)=>{this.m.setExitInfo(this.i,{code:fe,signal:ce}),this.p(`<${W}> Extension Host Process exited with code: ${fe}, signal: ${ce}.`),this.t()}),s)s.on("connection",fe=>{s.close(),this.r(fe,this.h)});else{const fe=ce=>{ce.type==="VSCODE_EXTHOST_IPC_READY"&&(this.g.removeListener("message",fe),this.s(this.g,this.h),this.h=null)};this.g.on("message",fe)}}catch(u){console.error("ExtensionHostConnection errored"),u&&console.error(u)}}u(){return new Promise((o,u)=>{const a=(0,b.createRandomIPCHandle)(),s=A.createServer();s.on("error",u),s.listen(a,()=>{s?.removeListener("error",u),o({pipeName:a,namedPipeServer:s})})})}};R=Te([Ae(4,v.IServerEnvironmentService),Ae(5,I.ILogService),Ae(6,p.IExtensionHostStatusService),Ae(7,g.IConfigurationService)],R),e.ExtensionHostConnection=R;function t(n,o){const u=Object.keys(n).filter(s=>s.toLowerCase()===o.toLowerCase()),a=u.length>0?u[0]:o;return n[a]}function r(n,o,u){const a=Object.keys(n).filter(C=>C.toLowerCase()===o.toLowerCase()),s=a.length>0?a[0]:o;n[s]=u}function i(n){for(const o of Object.keys(n))n[o]===null&&delete n[o]}}),define(be[273],Ee([1,0,15]),function(oe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var A;(function(b){b[b.Desktop=1]="Desktop",b[b.Web=2]="Web"})(A=e.UIKind||(e.UIKind={}));var l;(function(b){b[b.VersionMismatch=55]="VersionMismatch",b[b.UnexpectedError=81]="UnexpectedError"})(l=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var w;(function(b){b[b.Initialized=0]="Initialized",b[b.Ready=1]="Ready",b[b.Terminate=2]="Terminate"})(w=e.MessageType||(e.MessageType={}));function S(b){const k=E.VSBuffer.alloc(1);switch(b){case 0:k.writeUInt8(1,0);break;case 1:k.writeUInt8(2,0);break;case 2:k.writeUInt8(3,0);break}return k}e.createMessageOfType=S;function P(b,k){if(b.byteLength!==1)return!1;switch(b.readUInt8(0)){case 1:return k===0;case 2:return k===1;case 3:return k===2;default:return!1}}e.isMessageOfType=P;var y;(function(b){b.Start="START_NATIVE_LOG",b.End="END_NATIVE_LOG"})(y=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(be[274],Ee([1,0,5,6,10,262,273,53,37,23,4,2,194]),function(oe,e,E,A,l,w,S,P,y,b,k,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let d=class extends I.Disposable{constructor(h,g){super(),this.m=h,this.n=g,this.a=this.B(new A.Emitter),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new A.Emitter),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.i=!1,this.l=new Map,this.j=k.URI.revive(this.m.environment.extensionTelemetryLogResource),this.i=this.m.environment.isExtensionTelemetryLoggingOnly,this.k=g.createLogger(this.j,{id:y.extensionTelemetryLogChannelId,name:(0,v.localize)(0,null,this.i?" (Not Sent)":""),hidden:!0}),this.B(g.onDidChangeLogLevel(f=>{(0,l.isLogLevel)(f)&&this.p()})),this.k.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.k.info("===========================================================")}p(){this.n.setVisibility(this.j,this.g&&this.n.getLogLevel()===l.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(h,g,f){const D=this.getTelemetryDetails(),R=new m(g,f,h,this.k,this.i,this.getBuiltInCommonProperties(h),{isUsageEnabled:D.isUsageEnabled,isErrorsEnabled:D.isErrorsEnabled});return this.l.set(h.identifier.value,R),R.apiTelemetryLogger}$initializeTelemetryLevel(h,g,f){this.f=h,this.g=g,this.c=f??{usage:!0,error:!0},this.p()}getBuiltInCommonProperties(h){const g={};switch(g["common.extname"]=`${h.publisher}.${h.name}`,g["common.extversion"]=h.version,g["common.vscodemachineid"]=this.m.telemetryInfo.machineId,g["common.vscodesessionid"]=this.m.telemetryInfo.sessionId,g["common.vscodeversion"]=this.m.version,g["common.isnewappinstall"]=p(this.m.telemetryInfo.firstSessionDate),g["common.product"]=this.m.environment.appHost,this.m.uiKind){case S.UIKind.Web:g["common.uikind"]="web";break;case S.UIKind.Desktop:g["common.uikind"]="desktop";break;default:g["common.uikind"]="unknown"}return g["common.remotename"]=(0,P.getRemoteName)((0,y.cleanRemoteAuthority)(this.m.remote.authority)),g}$onDidChangeTelemetryLevel(h){this.h=this.getTelemetryConfiguration(),this.f=h;const g=this.getTelemetryDetails();this.l.forEach(f=>{f.updateTelemetryEnablements(g.isUsageEnabled,g.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.p()}onExtensionError(h,g){const f=this.l.get(h.value);return!f||f.ignoreUnhandledExtHostErrors?!1:(f.logError(g),!0)}};d=Te([Ae(0,w.IExtHostInitDataService),Ae(1,l.ILoggerService)],d),e.ExtHostTelemetry=d;class m{static validateSender(h){if(typeof h!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof h.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof h.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof h.flush<"u"&&typeof h.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(h,g,f,D,R,t,r){this.g=f,this.h=D,this.i=R,this.j=t,this.a=new A.Emitter,this.ignoreUnhandledExtHostErrors=g?.ignoreUnhandledErrors??!1,this.b=g?.ignoreBuiltInCommonProperties??!1,this.c=g?.additionalCommonProperties,this.f=h,this.d={isUsageEnabled:r.isUsageEnabled,isErrorsEnabled:r.isErrorsEnabled}}updateTelemetryEnablements(h,g){this.e&&(this.d={isUsageEnabled:h,isErrorsEnabled:g},this.a.fire(this.e))}mixInCommonPropsAndCleanData(h){let g=h.properties??h;return g=(0,y.cleanData)(g,[]),this.c&&(g=(0,b.mixin)(g,this.c)),this.b||(g=(0,b.mixin)(g,this.j)),h.properties?h.properties=g:h=g,h}k(h,g){!this.f||(this.g.publisher==="vscode"?h=this.g.name+"/"+h:h=this.g.identifier.value+"/"+h,g=this.mixInCommonPropsAndCleanData(g||{}),this.i||this.f?.sendEventData(h,g),this.h.trace(h,g))}logUsage(h,g){!this.d.isUsageEnabled||this.k(h,g)}logError(h,g){!this.d.isErrorsEnabled||!this.f||(typeof h=="string"?this.k(h,g):this.f.sendErrorData(h,g))}get apiTelemetryLogger(){if(!this.e){const h=this,g={logUsage:h.logUsage.bind(h),get isUsageEnabled(){return h.d.isUsageEnabled},get isErrorsEnabled(){return h.d.isErrorsEnabled},logError:h.logError.bind(h),dispose:h.dispose.bind(h),onDidChangeEnableStates:h.a.event.bind(h)};this.e=Object.freeze(g)}return this.e}dispose(){this.f?.flush&&(Promise.resolve(this.f.flush()).then(this.f=void 0),this.e=void 0)}}e.ExtHostTelemetryLogger=m;function p(c){const h=Date.now()-new Date(c).getTime();return isNaN(h)?!1:h<1e3*60*60*24}e.isNewAppInstall=p,e.IExtHostTelemetry=(0,E.createDecorator)("IExtHostTelemetry")}),define(be[275],Ee([1,0,6,4,5,34,35]),function(oe,e,E,A,l,w,S){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new w.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:A.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,l.createDecorator)("extensionService");class y{constructor(u){this.affinity=u,this.kind=1}equals(u){return this.kind===u.kind&&this.affinity===u.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=y;class b{constructor(u){this.affinity=u,this.kind=2}equals(u){return this.kind===u.kind&&this.affinity===u.affinity}asString(){return this.affinity===0?"LocalWebWorker":`LocalWebWorker${this.affinity}`}}e.LocalWebWorkerRunningLocation=b;class k{constructor(){this.kind=3,this.affinity=0}equals(u){return this.kind===u.kind}asString(){return"Remote"}}e.RemoteRunningLocation=k;class I{constructor(u){this.dependency=u}}e.MissingExtensionDependency=I;var v;(function(o){o[o.LocalProcess=1]="LocalProcess",o[o.LocalWebWorker=2]="LocalWebWorker",o[o.Remote=3]="Remote"})(v=e.ExtensionHostKind||(e.ExtensionHostKind={}));function d(o){if(o===null)return"None";switch(o){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=d;class m{constructor(){this.c=[],this.d=[]}toDelta(){return{toRemove:[],toAdd:this.c,myToRemove:[],myToAdd:this.d}}set(u,a){const s=[],C=[],L=[],O=[],W=h(this.c),X=h(u),se=(T,z)=>T.extensionLocation.toString()===z.extensionLocation.toString()||T.isBuiltin===z.isBuiltin||T.isUserBuiltin===z.isUserBuiltin||T.isUnderDevelopment===z.isUnderDevelopment;for(const T of this.c){const z=X.get(w.ExtensionIdentifier.toKey(T.identifier));if(!z){s.push(T.identifier),W.delete(w.ExtensionIdentifier.toKey(T.identifier));continue}if(!se(T,z)){s.push(T.identifier),W.delete(w.ExtensionIdentifier.toKey(T.identifier));continue}}for(const T of u){const z=W.get(w.ExtensionIdentifier.toKey(T.identifier));if(!z){C.push(T);continue}if(!se(z,T)){s.push(z.identifier),W.delete(w.ExtensionIdentifier.toKey(z.identifier));continue}}const fe=c(this.d),ce=c(a);for(const T of this.d)ce.has(w.ExtensionIdentifier.toKey(T))||L.push(T);for(const T of a)fe.has(w.ExtensionIdentifier.toKey(T))||O.push(T);const V={toRemove:s,toAdd:C,myToRemove:L,myToAdd:O};return this.delta(V),V}delta(u){const{toRemove:a,toAdd:s,myToRemove:C,myToAdd:L}=u,O=c(a),W=c(C);for(let X=0;X<this.c.length;X++)O.has(w.ExtensionIdentifier.toKey(this.c[X].identifier))&&(this.c.splice(X,1),X--);for(let X=0;X<this.d.length;X++)W.has(w.ExtensionIdentifier.toKey(this.d[X]))&&(this.d.splice(X,1),X--);for(const X of s)this.c.push(X);for(const X of L)this.d.push(X)}containsExtension(u){for(const a of this.d)if(w.ExtensionIdentifier.equals(a,u))return!0;return!1}}e.ExtensionHostExtensions=m;class p{constructor(u){if(this[P]="ExtensionIdentifierSet",this.c=new Map,this.d=w.ExtensionIdentifier.toKey,u)for(const a of u)this.add(a)}get size(){return this.c.size}add(u){return this.c.set(this.d(u),u),this}clear(){this.c.clear()}delete(u){return this.c.delete(this.d(u))}has(u){return this.c.has(this.d(u))}forEach(u,a){this.c.forEach(s=>u.call(a,s,s,this))}*entries(){for(const[u,a]of this.c)yield[a,a]}keys(){return this.c.values()}values(){return this.c.values()}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.c.values()}}e.ExtensionIdentifierSet=p;function c(o){const u=new Set;for(const a of o)u.add(w.ExtensionIdentifier.toKey(a));return u}e.extensionIdentifiersArrayToSet=c;function h(o){const u=new Map;for(const a of o)u.set(w.ExtensionIdentifier.toKey(a.identifier),a);return u}function g(o,u){return!0}e.isProposedApiEnabled=g;function f(o,u){if(!g(o,u))throw new Error(`Extension '${o.identifier.value}' CANNOT use API proposal: ${u}.
Its package.json#enabledApiProposals-property declares: ${o.enabledApiProposals?.join(", ")??"[]"} but NOT ${u}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${o.identifier.value}`)}e.checkProposedApiEnabled=f;class D{constructor(u,a,s,C){this.codeLoadingTime=u,this.activateCallTime=a,this.activateResolvedTime=s,this.activationReason=C}}e.ActivationTimes=D;class R{constructor(u,a){this.description=u,this.value=a}}e.ExtensionPointContribution=R,e.ExtensionHostLogFileName="exthost";var t;(function(o){o[o.Normal=0]="Normal",o[o.Immediate=1]="Immediate"})(t=e.ActivationKind||(e.ActivationKind={}));function r(o){return{type:o.isBuiltin?0:1,isBuiltin:o.isBuiltin||o.isUserBuiltin,identifier:{id:(0,S.getGalleryExtensionId)(o.publisher,o.name),uuid:o.uuid},manifest:o,location:o.extensionLocation,targetPlatform:o.targetPlatform,validations:[],isValid:!0}}e.toExtension=r;function i(o,u){return{identifier:new w.ExtensionIdentifier((0,S.getExtensionId)(o.manifest.publisher,o.manifest.name)),isBuiltin:o.type===0,isUserBuiltin:o.type===1&&o.isBuiltin,isUnderDevelopment:!!u,extensionLocation:o.location,...o.manifest,uuid:o.identifier.uuid,targetPlatform:o.targetPlatform,browserNlsBundleUris:o.browserNlsBundleUris}}e.toExtensionDescription=i;class n{constructor(){this.onDidRegisterExtensions=E.Event.None,this.onDidChangeExtensionsStatus=E.Event.None,this.onDidChangeExtensions=E.Event.None,this.onWillActivateByEvent=E.Event.None,this.onDidChangeResponsiveChange=E.Event.None,this.extensions=[]}activateByEvent(u){return Promise.resolve(void 0)}activationEventIsDone(u){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(u){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(u,a){return Promise.resolve(0)}getInspectPorts(u,a){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(u){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=n});var Tt=this&&this.__classPrivateFieldSet||function(oe,e,E,A,l){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!l:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?l.call(oe,E):l?l.value=E:e.set(oe,E),E},st=this&&this.__classPrivateFieldGet||function(oe,e,E,A){if(E==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!A:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return E==="m"?A:E==="a"?A.call(oe):A?A.value:e.get(oe)};define(be[134],Ee([1,0,18,9,94,27,57,17,8,4,21,16,114,128,275]),function(oe,e,E,A,l,w,S,P,y,b,k,I,v,d,m){"use strict";var p,c,h,g,f,D,R,t,r,i,n,o,u,a,s,C,L,O,W,X,se,fe,ce;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest2=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.setBreakpointId=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function V($){return Object.assign($,{apply:function(){const re=arguments.length===1?[]:arguments[1];return Reflect.construct($,re,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct($,[]);{const[re,...pe]=arguments;return Reflect.construct($,pe,re.constructor)}}})}var T;(function($){$[$.Top=0]="Top",$[$.Bottom=1]="Bottom"})(T=e.TerminalOutputAnchor||(e.TerminalOutputAnchor={}));var z;(function($){$[$.Command=0]="Command",$[$.Opener=1]="Opener"})(z=e.TerminalQuickFixType||(e.TerminalQuickFixType={}));let he=D=class{static from(...F){let re=F;return new D(function(){if(re){for(const pe of re)pe&&typeof pe.dispose=="function"&&pe.dispose();re=void 0}})}constructor(F){p.set(this,void 0),Tt(this,p,F,"f")}dispose(){typeof st(this,p,"f")=="function"&&(st(this,p,"f").call(this),Tt(this,p,void 0,"f"))}};p=new WeakMap,he=D=Te([V],he),e.Disposable=he;let H=R=class{static Min(...F){if(F.length===0)throw new TypeError;let re=F[0];for(let pe=1;pe<F.length;pe++){const Ue=F[pe];Ue.isBefore(re)&&(re=Ue)}return re}static Max(...F){if(F.length===0)throw new TypeError;let re=F[0];for(let pe=1;pe<F.length;pe++){const Ue=F[pe];Ue.isAfter(re)&&(re=Ue)}return re}static isPosition(F){if(!F)return!1;if(F instanceof R)return!0;const{line:re,character:pe}=F;return typeof re=="number"&&typeof pe=="number"}static of(F){if(F instanceof R)return F;if(this.isPosition(F))return new R(F.line,F.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(F,re){if(F<0)throw(0,A.illegalArgument)("line must be non-negative");if(re<0)throw(0,A.illegalArgument)("character must be non-negative");this.c=F,this.e=re}isBefore(F){return this.c<F.c?!0:F.c<this.c?!1:this.e<F.e}isBeforeOrEqual(F){return this.c<F.c?!0:F.c<this.c?!1:this.e<=F.e}isAfter(F){return!this.isBeforeOrEqual(F)}isAfterOrEqual(F){return!this.isBefore(F)}isEqual(F){return this.c===F.c&&this.e===F.e}compareTo(F){return this.c<F.c?-1:this.c>F.line?1:this.e<F.e?-1:this.e>F.e?1:0}translate(F,re=0){if(F===null||re===null)throw(0,A.illegalArgument)();let pe;return typeof F>"u"?pe=0:typeof F=="number"?pe=F:(pe=typeof F.lineDelta=="number"?F.lineDelta:0,re=typeof F.characterDelta=="number"?F.characterDelta:0),pe===0&&re===0?this:new R(this.line+pe,this.character+re)}with(F,re=this.character){if(F===null||re===null)throw(0,A.illegalArgument)();let pe;return typeof F>"u"?pe=this.line:typeof F=="number"?pe=F:(pe=typeof F.line=="number"?F.line:this.line,re=typeof F.character=="number"?F.character:this.character),pe===this.line&&re===this.character?this:new R(pe,re)}toJSON(){return{line:this.line,character:this.character}}};H=R=Te([V],H),e.Position=H;let q=t=class{static isRange(F){return F instanceof t?!0:F?H.isPosition(F.start)&&H.isPosition(F.end):!1}static of(F){if(F instanceof t)return F;if(this.isRange(F))return new t(F.start,F.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(F,re,pe,Ue){let He,Ze;if(typeof F=="number"&&typeof re=="number"&&typeof pe=="number"&&typeof Ue=="number"?(He=new H(F,re),Ze=new H(pe,Ue)):H.isPosition(F)&&H.isPosition(re)&&(He=H.of(F),Ze=H.of(re)),!He||!Ze)throw new Error("Invalid arguments");He.isBefore(Ze)?(this.c=He,this.e=Ze):(this.c=Ze,this.e=He)}contains(F){return t.isRange(F)?this.contains(F.start)&&this.contains(F.end):H.isPosition(F)?!(H.of(F).isBefore(this.c)||this.e.isBefore(F)):!1}isEqual(F){return this.c.isEqual(F.c)&&this.e.isEqual(F.e)}intersection(F){const re=H.Max(F.start,this.c),pe=H.Min(F.end,this.e);if(!re.isAfter(pe))return new t(re,pe)}union(F){if(this.contains(F))return this;if(F.contains(this))return F;const re=H.Min(F.start,this.c),pe=H.Max(F.end,this.end);return new t(re,pe)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(F,re=this.end){if(F===null||re===null)throw(0,A.illegalArgument)();let pe;return F?H.isPosition(F)?pe=F:(pe=F.start||this.start,re=F.end||this.end):pe=this.start,pe.isEqual(this.c)&&re.isEqual(this.end)?this:new t(pe,re)}toJSON(){return[this.start,this.end]}};q=t=Te([V],q),e.Range=q;let M=r=class extends q{static isSelection(F){return F instanceof r?!0:F?q.isRange(F)&&H.isPosition(F.anchor)&&H.isPosition(F.active)&&typeof F.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(F,re,pe,Ue){let He,Ze;if(typeof F=="number"&&typeof re=="number"&&typeof pe=="number"&&typeof Ue=="number"?(He=new H(F,re),Ze=new H(pe,Ue)):H.isPosition(F)&&H.isPosition(re)&&(He=H.of(F),Ze=H.of(re)),!He||!Ze)throw new Error("Invalid arguments");super(He,Ze),this.f=He,this.g=Ze}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};M=r=Te([V],M),e.Selection=M;class ee{constructor(F,re,pe){if(typeof F!="string"||F.length===0)throw(0,A.illegalArgument)("host");if(typeof re!="number"||re===0||Math.round(re)!==re)throw(0,A.illegalArgument)("port");if(typeof pe<"u"&&(typeof pe!="string"||pe.length===0||!/^[0-9A-Za-z_\-]+$/.test(pe)))throw(0,A.illegalArgument)("connectionToken");this.host=F,this.port=Math.round(re),this.connectionToken=pe}}e.ResolvedAuthority=ee;class ie extends Error{static NotAvailable(F,re){return new ie(F,v.RemoteAuthorityResolverErrorCode.NotAvailable,re)}static TemporarilyNotAvailable(F){return new ie(F,v.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(F,re=v.RemoteAuthorityResolverErrorCode.Unknown,pe){super(F),this._message=F,this._code=re,this._detail=pe,Object.setPrototypeOf(this,ie.prototype)}}e.RemoteAuthorityResolverError=ie;var me;(function($){$[$.LF=1]="LF",$[$.CRLF=2]="CRLF"})(me=e.EndOfLine||(e.EndOfLine={}));var ne;(function($){$[$.Replace=1]="Replace",$[$.Append=2]="Append",$[$.Prepend=3]="Prepend"})(ne=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let B=i=class{static isTextEdit(F){return F instanceof i?!0:F?q.isRange(F)&&typeof F.newText=="string":!1}static replace(F,re){return new i(F,re)}static insert(F,re){return i.replace(new q(F,F),re)}static delete(F){return i.replace(F,"")}static setEndOfLine(F){const re=new i(new q(new H(0,0),new H(0,0)),"");return re.newEol=F,re}get range(){return this.c}set range(F){if(F&&!q.isRange(F))throw(0,A.illegalArgument)("range");this.c=F}get newText(){return this.e||""}set newText(F){if(F&&typeof F!="string")throw(0,A.illegalArgument)("newText");this.e=F}get newEol(){return this.f}set newEol(F){if(F&&typeof F!="number")throw(0,A.illegalArgument)("newEol");this.f=F}constructor(F,re){this.c=F,this.e=re}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};B=i=Te([V],B),e.TextEdit=B;let N=n=class{static isNotebookCellEdit(F){return F instanceof n?!0:F?At.isNotebookRange(F)&&Array.isArray(F.newCells):!1}static replaceCells(F,re){return new n(F,re)}static insertCells(F,re){return new n(new At(F,F),re)}static deleteCells(F){return new n(F,[])}static updateCellMetadata(F,re){const pe=new n(new At(F,F),[]);return pe.newCellMetadata=re,pe}static updateNotebookMetadata(F){const re=new n(new At(0,0),[]);return re.newNotebookMetadata=F,re}constructor(F,re){this.range=F,this.newCells=re}};N=n=Te([V],N),e.NotebookEdit=N;class U{static isSnippetTextEdit(F){return F instanceof U?!0:F?q.isRange(F.range)&&le.isSnippetString(F.snippet):!1}static replace(F,re){return new U(F,re)}static insert(F,re){return U.replace(new q(F,F),re)}constructor(F,re){this.range=F,this.snippet=re}}e.SnippetTextEdit=U;var G;(function($){$[$.File=1]="File",$[$.Text=2]="Text",$[$.Cell=3]="Cell",$[$.CellReplace=5]="CellReplace",$[$.Snippet=6]="Snippet"})(G=e.FileEditType||(e.FileEditType={}));let te=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(F,re,pe,Ue){this.c.push({_type:1,from:F,to:re,options:pe,metadata:Ue})}createFile(F,re,pe){this.c.push({_type:1,from:void 0,to:F,options:re,metadata:pe})}deleteFile(F,re,pe){this.c.push({_type:1,from:F,to:void 0,options:re,metadata:pe})}e(F,re,pe){this.c.push({_type:3,metadata:pe,uri:F,edit:{editType:5,metadata:re},notebookMetadata:re})}f(F,re,pe,Ue){const He=re.start,Ze=re.end;(He!==Ze||pe.length>0)&&this.c.push({_type:5,uri:F,index:He,count:Ze-He,cells:pe,metadata:Ue})}g(F,re,pe,Ue){this.c.push({_type:3,metadata:Ue,uri:F,edit:{editType:8,index:re,metadata:pe}})}replace(F,re,pe,Ue){this.c.push({_type:2,uri:F,edit:new B(re,pe),metadata:Ue})}insert(F,re,pe,Ue){this.replace(F,new q(re,re),pe,Ue)}delete(F,re,pe){this.replace(F,re,"",pe)}has(F){return this.c.some(re=>re._type===2&&re.uri.toString()===F.toString())}set(F,re){if(re)for(const pe of re){if(!pe)continue;let Ue,He;Array.isArray(pe)?(Ue=pe[0],He=pe[1]):Ue=pe,N.isNotebookCellEdit(Ue)?Ue.newCellMetadata?this.g(F,Ue.range.start,Ue.newCellMetadata,He):Ue.newNotebookMetadata?this.e(F,Ue.newNotebookMetadata,He):this.f(F,Ue.range,Ue.newCells,He):U.isSnippetTextEdit(Ue)?this.c.push({_type:6,uri:F,range:Ue.range,edit:Ue.snippet,metadata:He}):this.c.push({_type:2,uri:F,edit:Ue,metadata:He})}else{for(let pe=0;pe<this.c.length;pe++){const Ue=this.c[pe];switch(Ue._type){case 2:case 6:case 3:case 5:Ue.uri.toString()===F.toString()&&(this.c[pe]=void 0);break}}(0,E.coalesceInPlace)(this.c)}}get(F){const re=[];for(const pe of this.c)pe._type===2&&pe.uri.toString()===F.toString()&&re.push(pe.edit);return re}entries(){const F=new w.ResourceMap;for(const re of this.c)if(re._type===2){let pe=F.get(re.uri);pe||(pe=[re.uri,[]],F.set(re.uri,pe)),pe[1].push(re.edit)}return[...F.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};te=Te([V],te),e.WorkspaceEdit=te;let le=o=class{static isSnippetString(F){return F instanceof o?!0:F?typeof F.value=="string":!1}static c(F){return F.replace(/\$|}|\\/g,"\\$&")}constructor(F){this.e=1,this.value=F||""}appendText(F){return this.value+=o.c(F),this}appendTabstop(F=this.e++){return this.value+="$",this.value+=F,this}appendPlaceholder(F,re=this.e++){if(typeof F=="function"){const pe=new o;pe.e=this.e,F(pe),this.e=pe.e,F=pe.value}else F=o.c(F);return this.value+="${",this.value+=re,this.value+=":",this.value+=F,this.value+="}",this}appendChoice(F,re=this.e++){const pe=F.map(Ue=>Ue.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=re,this.value+="|",this.value+=pe,this.value+="|}",this}appendVariable(F,re){if(typeof re=="function"){const pe=new o;pe.e=this.e,re(pe),this.e=pe.e,re=pe.value}else typeof re=="string"&&(re=re.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=F,re&&(this.value+=":",this.value+=re),this.value+="}",this}};le=o=Te([V],le),e.SnippetString=le;var j;(function($){$[$.Unnecessary=1]="Unnecessary",$[$.Deprecated=2]="Deprecated"})(j=e.DiagnosticTag||(e.DiagnosticTag={}));var K;(function($){$[$.Hint=3]="Hint",$[$.Information=2]="Information",$[$.Warning=1]="Warning",$[$.Error=0]="Error"})(K=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let Q=u=class{static isLocation(F){return F instanceof u?!0:F?q.isRange(F.range)&&b.URI.isUri(F.uri):!1}constructor(F,re){if(this.uri=F,re)if(q.isRange(re))this.range=q.of(re);else if(H.isPosition(re))this.range=new q(re,re);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};Q=u=Te([V],Q),e.Location=Q;let x=class{static is(F){return F?typeof F.message=="string"&&F.location&&q.isRange(F.location.range)&&b.URI.isUri(F.location.uri):!1}constructor(F,re){this.location=F,this.message=re}static isEqual(F,re){return F===re?!0:!F||!re?!1:F.message===re.message&&F.location.range.isEqual(re.location.range)&&F.location.uri.toString()===re.location.uri.toString()}};x=Te([V],x),e.DiagnosticRelatedInformation=x;let _=class{constructor(F,re,pe=K.Error){if(!q.isRange(F))throw new TypeError("range must be set");if(!re)throw new TypeError("message must be set");this.range=F,this.message=re,this.severity=pe}toJSON(){return{severity:K[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(F,re){return F===re?!0:!F||!re?!1:F.message===re.message&&F.severity===re.severity&&F.code===re.code&&F.severity===re.severity&&F.source===re.source&&F.range.isEqual(re.range)&&(0,E.equals)(F.tags,re.tags)&&(0,E.equals)(F.relatedInformation,re.relatedInformation,x.isEqual)}};_=Te([V],_),e.Diagnostic=_;let Y=class{constructor(F,re){if(!F)throw new Error("Illegal argument, contents must be defined");Array.isArray(F)?this.contents=F:this.contents=[F],this.range=re}};Y=Te([V],Y),e.Hover=Y;var Z;(function($){$[$.Text=0]="Text",$[$.Read=1]="Read",$[$.Write=2]="Write"})(Z=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let ae=class{constructor(F,re=Z.Text){this.range=F,this.kind=re}toJSON(){return{range:this.range,kind:Z[this.kind]}}};ae=Te([V],ae),e.DocumentHighlight=ae;var ve;(function($){$[$.File=0]="File",$[$.Module=1]="Module",$[$.Namespace=2]="Namespace",$[$.Package=3]="Package",$[$.Class=4]="Class",$[$.Method=5]="Method",$[$.Property=6]="Property",$[$.Field=7]="Field",$[$.Constructor=8]="Constructor",$[$.Enum=9]="Enum",$[$.Interface=10]="Interface",$[$.Function=11]="Function",$[$.Variable=12]="Variable",$[$.Constant=13]="Constant",$[$.String=14]="String",$[$.Number=15]="Number",$[$.Boolean=16]="Boolean",$[$.Array=17]="Array",$[$.Object=18]="Object",$[$.Key=19]="Key",$[$.Null=20]="Null",$[$.EnumMember=21]="EnumMember",$[$.Struct=22]="Struct",$[$.Event=23]="Event",$[$.Operator=24]="Operator",$[$.TypeParameter=25]="TypeParameter"})(ve=e.SymbolKind||(e.SymbolKind={}));var Pe;(function($){$[$.Deprecated=1]="Deprecated"})(Pe=e.SymbolTag||(e.SymbolTag={}));let ke=a=class{static validate(F){if(!F.name)throw new Error("name must not be falsy")}constructor(F,re,pe,Ue,He){this.name=F,this.kind=re,this.containerName=He,typeof pe=="string"&&(this.containerName=pe),Ue instanceof Q?this.location=Ue:pe instanceof q&&(this.location=new Q(Ue,pe)),a.validate(this)}toJSON(){return{name:this.name,kind:ve[this.kind],location:this.location,containerName:this.containerName}}};ke=a=Te([V],ke),e.SymbolInformation=ke;let Me=s=class{static validate(F){if(!F.name)throw new Error("name must not be falsy");if(!F.range.contains(F.selectionRange))throw new Error("selectionRange must be contained in fullRange");F.children?.forEach(s.validate)}constructor(F,re,pe,Ue,He){this.name=F,this.detail=re,this.kind=pe,this.range=Ue,this.selectionRange=He,this.children=[],s.validate(this)}};Me=s=Te([V],Me),e.DocumentSymbol=Me;var je;(function($){$[$.Invoke=1]="Invoke",$[$.Automatic=2]="Automatic"})(je=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let ge=class{constructor(F,re){this.title=F,this.kind=re}};ge=Te([V],ge),e.CodeAction=ge;let we=C=class{constructor(F){this.value=F}append(F){return new C(this.value?this.value+C.c+F:F)}intersects(F){return this.contains(F)||F.contains(this)}contains(F){return this.value===F.value||F.value.startsWith(this.value+C.c)}};we.c=".",we=C=Te([V],we),e.CodeActionKind=we,we.Empty=new we(""),we.QuickFix=we.Empty.append("quickfix"),we.Refactor=we.Empty.append("refactor"),we.RefactorExtract=we.Refactor.append("extract"),we.RefactorInline=we.Refactor.append("inline"),we.RefactorMove=we.Refactor.append("move"),we.RefactorRewrite=we.Refactor.append("rewrite"),we.Source=we.Empty.append("source"),we.SourceOrganizeImports=we.Source.append("organizeImports"),we.SourceFixAll=we.Source.append("fixAll");let ye=class{constructor(F,re){if(this.range=F,this.parent=re,re&&!re.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};ye=Te([V],ye),e.SelectionRange=ye;class Fe{constructor(F,re,pe,Ue,He,Ze){this.kind=F,this.name=re,this.detail=pe,this.uri=Ue,this.range=He,this.selectionRange=Ze}}e.CallHierarchyItem=Fe;class $e{constructor(F,re){this.fromRanges=re,this.from=F}}e.CallHierarchyIncomingCall=$e;class tt{constructor(F,re){this.fromRanges=re,this.to=F}}e.CallHierarchyOutgoingCall=tt;var Ve;(function($){$[$.Information=0]="Information",$[$.Warning=1]="Warning",$[$.Error=2]="Error"})(Ve=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let Je=class{constructor(F,re){this.range=F,this.command=re}get isResolved(){return!!this.command}};Je=Te([V],Je),e.CodeLens=Je;let Xe=L=class{static isMarkdownString(F){return F instanceof L?!0:F&&F.appendCodeblock&&F.appendMarkdown&&F.appendText&&F.value!==void 0}constructor(F,re=!1){c.set(this,void 0),Tt(this,c,new l.MarkdownString(F,{supportThemeIcons:re}),"f")}get value(){return st(this,c,"f").value}set value(F){st(this,c,"f").value=F}get isTrusted(){return st(this,c,"f").isTrusted}set isTrusted(F){st(this,c,"f").isTrusted=F}get supportThemeIcons(){return st(this,c,"f").supportThemeIcons}set supportThemeIcons(F){st(this,c,"f").supportThemeIcons=F}get supportHtml(){return st(this,c,"f").supportHtml}set supportHtml(F){st(this,c,"f").supportHtml=F}get baseUri(){return st(this,c,"f").baseUri}set baseUri(F){st(this,c,"f").baseUri=F}appendText(F){return st(this,c,"f").appendText(F),this}appendMarkdown(F){return st(this,c,"f").appendMarkdown(F),this}appendCodeblock(F,re){return st(this,c,"f").appendCodeblock(re??"",F),this}};c=new WeakMap,Xe=L=Te([V],Xe),e.MarkdownString=Xe;let _e=class{constructor(F,re){this.label=F,this.documentation=re}};_e=Te([V],_e),e.ParameterInformation=_e;let Ke=class{constructor(F,re){this.label=F,this.documentation=re,this.parameters=[]}};Ke=Te([V],Ke),e.SignatureInformation=Ke;let ue=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};ue=Te([V],ue),e.SignatureHelp=ue;var De;(function($){$[$.Invoke=1]="Invoke",$[$.TriggerCharacter=2]="TriggerCharacter",$[$.ContentChange=3]="ContentChange"})(De=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Re;(function($){$[$.Type=1]="Type",$[$.Parameter=2]="Parameter"})(Re=e.InlayHintKind||(e.InlayHintKind={}));let Ne=class{constructor(F){this.value=F}};Ne=Te([V],Ne),e.InlayHintLabelPart=Ne;let Oe=class{constructor(F,re,pe){this.position=F,this.label=re,this.kind=pe}};Oe=Te([V],Oe),e.InlayHint=Oe;var ze;(function($){$[$.Invoke=0]="Invoke",$[$.TriggerCharacter=1]="TriggerCharacter",$[$.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(ze=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var We;(function($){$[$.Text=0]="Text",$[$.Method=1]="Method",$[$.Function=2]="Function",$[$.Constructor=3]="Constructor",$[$.Field=4]="Field",$[$.Variable=5]="Variable",$[$.Class=6]="Class",$[$.Interface=7]="Interface",$[$.Module=8]="Module",$[$.Property=9]="Property",$[$.Unit=10]="Unit",$[$.Value=11]="Value",$[$.Enum=12]="Enum",$[$.Keyword=13]="Keyword",$[$.Snippet=14]="Snippet",$[$.Color=15]="Color",$[$.File=16]="File",$[$.Reference=17]="Reference",$[$.Folder=18]="Folder",$[$.EnumMember=19]="EnumMember",$[$.Constant=20]="Constant",$[$.Struct=21]="Struct",$[$.Event=22]="Event",$[$.Operator=23]="Operator",$[$.TypeParameter=24]="TypeParameter",$[$.User=25]="User",$[$.Issue=26]="Issue"})(We=e.CompletionItemKind||(e.CompletionItemKind={}));var qe;(function($){$[$.Deprecated=1]="Deprecated"})(qe=e.CompletionItemTag||(e.CompletionItemTag={}));let Ge=class{constructor(F,re){this.label=F,this.kind=re}toJSON(){return{label:this.label,kind:this.kind&&We[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Ge=Te([V],Ge),e.CompletionItem=Ge;let et=class{constructor(F=[],re=!1){this.items=F,this.isIncomplete=re}};et=Te([V],et),e.CompletionList=et;let Ye=class{constructor(F,re,pe){this.insertText=F,this.range=re,this.command=pe}};Ye=Te([V],Ye),e.InlineSuggestion=Ye;let Qe=class{constructor(F){this.commands=void 0,this.items=F}};Qe=Te([V],Qe),e.InlineSuggestionList=Qe;var ot;(function($){$[$.Active=-1]="Active",$[$.Beside=-2]="Beside",$[$.One=1]="One",$[$.Two=2]="Two",$[$.Three=3]="Three",$[$.Four=4]="Four",$[$.Five=5]="Five",$[$.Six=6]="Six",$[$.Seven=7]="Seven",$[$.Eight=8]="Eight",$[$.Nine=9]="Nine"})(ot=e.ViewColumn||(e.ViewColumn={}));var rt;(function($){$[$.Left=1]="Left",$[$.Right=2]="Right"})(rt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Lt;(function($){$[$.Off=0]="Off",$[$.On=1]="On",$[$.Relative=2]="Relative"})(Lt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ut;(function($){$[$.Manual=1]="Manual",$[$.AfterDelay=2]="AfterDelay",$[$.FocusOut=3]="FocusOut"})(Ut=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var lt;(function($){$[$.Default=0]="Default",$[$.InCenter=1]="InCenter",$[$.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",$[$.AtTop=3]="AtTop"})(lt=e.TextEditorRevealType||(e.TextEditorRevealType={}));var Ot;(function($){$[$.Keyboard=1]="Keyboard",$[$.Mouse=2]="Mouse",$[$.Command=3]="Command"})(Ot=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var ht;(function($){$[$.Undo=1]="Undo",$[$.Redo=2]="Redo"})(ht=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var Nt;(function($){$[$.OpenOpen=0]="OpenOpen",$[$.ClosedClosed=1]="ClosedClosed",$[$.OpenClosed=2]="OpenClosed",$[$.ClosedOpen=3]="ClosedOpen"})(Nt=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function($){function F(re){switch(re){case"keyboard":return $.Keyboard;case"mouse":return $.Mouse;case"api":return $.Command}}$.fromValue=F}(Ot=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let pt=class{constructor(F,re){if(re&&!b.URI.isUri(re))throw(0,A.illegalArgument)("target");if(!q.isRange(F)||F.isEmpty)throw(0,A.illegalArgument)("range");this.range=F,this.target=re}};pt=Te([V],pt),e.DocumentLink=pt;let ft=class{constructor(F,re,pe,Ue){this.red=F,this.green=re,this.blue=pe,this.alpha=Ue}};ft=Te([V],ft),e.Color=ft;let Dt=class{constructor(F,re){if(re&&!(re instanceof ft))throw(0,A.illegalArgument)("color");if(!q.isRange(F)||F.isEmpty)throw(0,A.illegalArgument)("range");this.range=F,this.color=re}};Dt=Te([V],Dt),e.ColorInformation=Dt;let Pt=class{constructor(F){if(!F||typeof F!="string")throw(0,A.illegalArgument)("label");this.label=F}};Pt=Te([V],Pt),e.ColorPresentation=Pt;var wt;(function($){$[$.RGB=0]="RGB",$[$.HEX=1]="HEX",$[$.HSL=2]="HSL"})(wt=e.ColorFormat||(e.ColorFormat={}));var kt;(function($){$[$.Error=0]="Error",$[$.Warning=1]="Warning",$[$.Information=2]="Information"})(kt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var Bt;(function($){$[$.Unknown=0]="Unknown",$[$.Shutdown=1]="Shutdown",$[$.Process=2]="Process",$[$.User=3]="User",$[$.Extension=4]="Extension"})(Bt=e.TerminalExitReason||(e.TerminalExitReason={}));class Se{constructor(F,re,pe){if(this.startIndex=F,this.length=re,this.tooltip=pe,typeof F!="number"||F<0)throw(0,A.illegalArgument)("startIndex");if(typeof re!="number"||re<1)throw(0,A.illegalArgument)("length");if(pe!==void 0&&typeof pe!="string")throw(0,A.illegalArgument)("tooltip")}}e.TerminalLink=Se;class Ie{constructor(F){this.uri=F}}e.TerminalQuickFixOpener=Ie;class de{constructor(F){this.terminalCommand=F}}e.TerminalQuickFixCommand=de;var J;(function($){$[$.Panel=1]="Panel",$[$.Editor=2]="Editor"})(J=e.TerminalLocation||(e.TerminalLocation={}));class Ce{constructor(F){if(this.options=F,typeof F!="object")throw(0,A.illegalArgument)("options")}}e.TerminalProfile=Ce;var Le;(function($){$[$.Always=1]="Always",$[$.Silent=2]="Silent",$[$.Never=3]="Never"})(Le=e.TaskRevealKind||(e.TaskRevealKind={}));var xe;(function($){$[$.Shared=1]="Shared",$[$.Dedicated=2]="Dedicated",$[$.New=3]="New"})(xe=e.TaskPanelKind||(e.TaskPanelKind={}));let Be=O=class{static from(F){switch(F){case"clean":return O.Clean;case"build":return O.Build;case"rebuild":return O.Rebuild;case"test":return O.Test;default:return}}constructor(F,re){if(this.label=re,typeof F!="string"||typeof re!="string")throw(0,A.illegalArgument)("name");this.c=F}get id(){return this.c}};Be.Clean=new O("clean","Clean"),Be.Build=new O("build","Build"),Be.Rebuild=new O("rebuild","Rebuild"),Be.Test=new O("test","Test"),Be=O=Te([V],Be),e.TaskGroup=Be;function nt($){let F="";for(let re=0;re<$.length;re++)F+=$[re].replace(/,/g,",,")+",";return F}let at=class{constructor(F,re,pe){if(typeof F!="string")throw(0,A.illegalArgument)("process");this.e=[],this.c=F,re!==void 0&&(Array.isArray(re)?(this.e=re,this.f=pe):this.f=re)}get process(){return this.c}set process(F){if(typeof F!="string")throw(0,A.illegalArgument)("process");this.c=F}get args(){return this.e}set args(F){Array.isArray(F)||(F=[]),this.e=F}get options(){return this.f}set options(F){this.f=F}computeId(){const F=[];if(F.push("process"),this.c!==void 0&&F.push(this.c),this.e&&this.e.length>0)for(const re of this.e)F.push(re);return nt(F)}};at=Te([V],at),e.ProcessExecution=at;let dt=class{constructor(F,re,pe){if(this.f=[],Array.isArray(re)){if(!F)throw(0,A.illegalArgument)("command can't be undefined or null");if(typeof F!="string"&&typeof F.value!="string")throw(0,A.illegalArgument)("command");this.e=F,this.f=re,this.g=pe}else{if(typeof F!="string")throw(0,A.illegalArgument)("commandLine");this.c=F,this.g=re}}get commandLine(){return this.c}set commandLine(F){if(typeof F!="string")throw(0,A.illegalArgument)("commandLine");this.c=F}get command(){return this.e?this.e:""}set command(F){if(typeof F!="string"&&typeof F.value!="string")throw(0,A.illegalArgument)("command");this.e=F}get args(){return this.f}set args(F){this.f=F||[]}get options(){return this.g}set options(F){this.g=F}computeId(){const F=[];if(F.push("shell"),this.c!==void 0&&F.push(this.c),this.e!==void 0&&F.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const re of this.f)F.push(typeof re=="string"?re:re.value);return nt(F)}};dt=Te([V],dt),e.ShellExecution=dt;var bt;(function($){$[$.Escape=1]="Escape",$[$.Strong=2]="Strong",$[$.Weak=3]="Weak"})(bt=e.ShellQuoting||(e.ShellQuoting={}));var ct;(function($){$[$.Global=1]="Global",$[$.Workspace=2]="Workspace"})(ct=e.TaskScope||(e.TaskScope={}));class mt{constructor(F){this.c=F}computeId(){return"customExecution"+(0,k.generateUuid)()}set callback(F){this.c=F}get callback(){return this.c}}e.CustomExecution=mt;let St=W=class{constructor(F,re,pe,Ue,He,Ze){this.j=!1,this.k=this.definition=F;let it;typeof re=="string"?(this.m=this.name=re,this.t=this.source=pe,this.execution=Ue,it=He,this.j=!0):re===ct.Global||re===ct.Workspace?(this.target=re,this.m=this.name=pe,this.t=this.source=Ue,this.execution=He,it=Ze):(this.target=re,this.m=this.name=pe,this.t=this.source=Ue,this.execution=He,it=Ze),typeof it=="string"?(this.o=[it],this.q=!0):Array.isArray(it)?(this.o=it,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.v=Object.create(null),this.w=Object.create(null)}get _id(){return this.h}set _id(F){this.h=F}get _deprecated(){return this.j}y(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.z())}z(){this.n instanceof at?this.k={type:W.e,id:this.n.computeId()}:this.n instanceof dt?this.k={type:W.f,id:this.n.computeId()}:this.n instanceof mt?this.k={type:W.c,id:this.n.computeId()}:this.k={type:W.g,id:(0,k.generateUuid)()}}get definition(){return this.k}set definition(F){if(F==null)throw(0,A.illegalArgument)("Kind can't be undefined or null");this.y(),this.k=F}get scope(){return this.l}set target(F){this.y(),this.l=F}get name(){return this.m}set name(F){if(typeof F!="string")throw(0,A.illegalArgument)("name");this.y(),this.m=F}get execution(){return this.n}set execution(F){F===null&&(F=void 0),this.y(),this.n=F;const re=this.k.type;(W.g===re||W.e===re||W.f===re||W.c===re)&&this.z()}get problemMatchers(){return this.o}set problemMatchers(F){if(Array.isArray(F))this.y(),this.o=F,this.q=!0;else{this.y(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(F){F!==!0&&F!==!1&&(F=!1),this.y(),this.r=F}get source(){return this.t}set source(F){if(typeof F!="string"||F.length===0)throw(0,A.illegalArgument)("source must be a string of length > 0");this.y(),this.t=F}get group(){return this.u}set group(F){F===null&&(F=void 0),this.y(),this.u=F}get detail(){return this.x}set detail(F){F===null&&(F=void 0),this.x=F}get presentationOptions(){return this.v}set presentationOptions(F){F==null&&(F=Object.create(null)),this.y(),this.v=F}get runOptions(){return this.w}set runOptions(F){F==null&&(F=Object.create(null)),this.y(),this.w=F}};St.c="customExecution",St.e="process",St.f="shell",St.g="$empty",St=W=Te([V],St),e.Task=St;var $t;(function($){$[$.SourceControl=1]="SourceControl",$[$.Window=10]="Window",$[$.Notification=15]="Notification"})($t=e.ProgressLocation||(e.ProgressLocation={}));var Ti;(function($){function F(re){const pe=re;return(0,y.isNumber)(pe.value)?pe.tooltip&&!(0,y.isString)(pe.tooltip)?(console.log("INVALID view badge, invalid tooltip",pe.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",pe.value),!1)}$.isViewBadge=F})(Ti=e.ViewBadge||(e.ViewBadge={}));let Yt=X=class{static isTreeItem(F,re){const pe=F;if(pe.checkboxState!==void 0){(0,m.checkProposedApiEnabled)(re,"treeItemCheckbox");const Ue=(0,y.isNumber)(pe.checkboxState)?pe.checkboxState:(0,y.isObject)(pe.checkboxState)&&(0,y.isNumber)(pe.checkboxState.state)?pe.checkboxState.state:void 0,He=!(0,y.isNumber)(pe.checkboxState)&&(0,y.isObject)(pe.checkboxState)?pe.checkboxState.tooltip:void 0;if(Ue===void 0||Ue!==Jt.Checked&&Ue!==Jt.Unchecked||He!==void 0&&!(0,y.isString)(He))return console.log("INVALID tree item, invalid checkboxState",pe.checkboxState),!1}if(F instanceof X)return!0;if(pe.label!==void 0&&!(0,y.isString)(pe.label)&&!pe.label?.label)return console.log("INVALID tree item, invalid label",pe.label),!1;if(pe.id!==void 0&&!(0,y.isString)(pe.id))return console.log("INVALID tree item, invalid id",pe.id),!1;if(pe.iconPath!==void 0&&!(0,y.isString)(pe.iconPath)&&!b.URI.isUri(pe.iconPath)&&(!pe.iconPath||!(0,y.isString)(pe.iconPath.id))){const Ue=pe.iconPath;if(!Ue||!(0,y.isString)(Ue.light)&&!b.URI.isUri(Ue.light)&&!(0,y.isString)(Ue.dark)&&!b.URI.isUri(Ue.dark))return console.log("INVALID tree item, invalid iconPath",pe.iconPath),!1}return pe.description!==void 0&&!(0,y.isString)(pe.description)&&typeof pe.description!="boolean"?(console.log("INVALID tree item, invalid description",pe.description),!1):pe.resourceUri!==void 0&&!b.URI.isUri(pe.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",pe.resourceUri),!1):pe.tooltip!==void 0&&!(0,y.isString)(pe.tooltip)&&!(pe.tooltip instanceof Xe)?(console.log("INVALID tree item, invalid tooltip",pe.tooltip),!1):pe.command!==void 0&&!pe.command.command?(console.log("INVALID tree item, invalid command",pe.command),!1):pe.collapsibleState!==void 0&&pe.collapsibleState<Wt.None&&pe.collapsibleState>Wt.Expanded?(console.log("INVALID tree item, invalid collapsibleState",pe.collapsibleState),!1):pe.contextValue!==void 0&&!(0,y.isString)(pe.contextValue)?(console.log("INVALID tree item, invalid contextValue",pe.contextValue),!1):pe.accessibilityInformation!==void 0&&!pe.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",pe.accessibilityInformation),!1):!0}constructor(F,re=Wt.None){this.collapsibleState=re,b.URI.isUri(F)?this.resourceUri=F:this.label=F}};Yt=X=Te([V],Yt),e.TreeItem=Yt;var Wt;(function($){$[$.None=0]="None",$[$.Collapsed=1]="Collapsed",$[$.Expanded=2]="Expanded"})(Wt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var Jt;(function($){$[$.Unchecked=0]="Unchecked",$[$.Checked=1]="Checked"})(Jt=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let Xt=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(F,re){this.value=F,this.id=re??(0,k.generateUuid)()}};Xt=Te([V],Xt),e.DataTransferItem=Xt;let Qt=class{constructor(F){h.set(this,new Map);for(const[re,pe]of F??[]){const Ue=st(this,h,"f").get(re);Ue?Ue.push(pe):st(this,h,"f").set(re,[pe])}}get(F){return st(this,h,"f").get(F)?.[0]}set(F,re){st(this,h,"f").set(F,[re])}forEach(F,re){for(const[pe,Ue]of st(this,h,"f"))for(const He of Ue)F.call(re,He,pe,this)}*[(h=new WeakMap,Symbol.iterator)](){for(const[F,re]of st(this,h,"f"))for(const pe of re)yield[F,pe]}};Qt=Te([V],Qt),e.DataTransfer=Qt;let Zt=class{constructor(F){this.insertText=F}};Zt=Te([V],Zt),e.DocumentDropEdit=Zt;let _t=class{constructor(F){this.insertText=F}};_t=Te([V],_t),e.DocumentPasteEdit=_t;let It=class{constructor(F,re){this.id=F,this.color=re}static isThemeIcon(F){return typeof F.id!="string"?(console.log("INVALID ThemeIcon, invalid id",F.id),!1):!0}};It=Te([V],It),e.ThemeIcon=It,It.File=new It("file"),It.Folder=new It("folder");let ei=class{constructor(F){this.id=F}};ei=Te([V],ei),e.ThemeColor=ei;var Li;(function($){$[$.Global=1]="Global",$[$.Workspace=2]="Workspace",$[$.WorkspaceFolder=3]="WorkspaceFolder"})(Li=e.ConfigurationTarget||(e.ConfigurationTarget={}));let ti=class{get base(){return this.c}set base(F){this.c=F,this.e=b.URI.file(F)}get baseUri(){return this.e}set baseUri(F){this.e=F,this.c=F.fsPath}constructor(F,re){if(typeof F!="string"&&(!F||!b.URI.isUri(F)&&!b.URI.isUri(F.uri)))throw(0,A.illegalArgument)("base");if(typeof re!="string")throw(0,A.illegalArgument)("pattern");typeof F=="string"?this.baseUri=b.URI.file(F):b.URI.isUri(F)?this.baseUri=F:this.baseUri=F.uri,this.pattern=re}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};ti=Te([V],ti),e.RelativePattern=ti;const Ai=new WeakMap;function Oi($,F){Ai.set($,F)}e.setBreakpointId=Oi;let Ft=class{constructor(F,re,pe,Ue){this.enabled=typeof F=="boolean"?F:!0,typeof re=="string"&&(this.condition=re),typeof pe=="string"&&(this.hitCondition=pe),typeof Ue=="string"&&(this.logMessage=Ue)}get id(){return this.c||(this.c=Ai.get(this)??(0,k.generateUuid)()),this.c}};Ft=Te([V],Ft),e.Breakpoint=Ft;let ii=class extends Ft{constructor(F,re,pe,Ue,He){if(super(re,pe,Ue,He),F===null)throw(0,A.illegalArgument)("location");this.location=F}};ii=Te([V],ii),e.SourceBreakpoint=ii;let ni=class extends Ft{constructor(F,re,pe,Ue,He){super(re,pe,Ue,He),this.functionName=F}};ni=Te([V],ni),e.FunctionBreakpoint=ni;let ri=class extends Ft{constructor(F,re,pe,Ue,He,Ze,it){if(super(Ue,He,Ze,it),!re)throw(0,A.illegalArgument)("dataId");this.label=F,this.dataId=re,this.canPersist=pe}};ri=Te([V],ri),e.DataBreakpoint=ri;let si=class{constructor(F,re,pe){this.command=F,this.args=re||[],this.options=pe}};si=Te([V],si),e.DebugAdapterExecutable=si;let oi=class{constructor(F,re){this.port=F,this.host=re}};oi=Te([V],oi),e.DebugAdapterServer=oi;let ai=class{constructor(F){this.path=F}};ai=Te([V],ai),e.DebugAdapterNamedPipeServer=ai;let li=class{constructor(F){this.implementation=F}};li=Te([V],li),e.DebugAdapterInlineImplementation=li;let ci=class{constructor(F,re){this.range=F,this.expression=re}};ci=Te([V],ci),e.EvaluatableExpression=ci;var Ni;(function($){$[$.Invoke=0]="Invoke",$[$.Automatic=1]="Automatic"})(Ni=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let ui=class{constructor(F,re){this.range=F,this.text=re}};ui=Te([V],ui),e.InlineValueText=ui;let hi=class{constructor(F,re,pe=!0){this.range=F,this.variableName=re,this.caseSensitiveLookup=pe}};hi=Te([V],hi),e.InlineValueVariableLookup=hi;let fi=class{constructor(F,re){this.range=F,this.expression=re}};fi=Te([V],fi),e.InlineValueEvaluatableExpression=fi;let di=class{constructor(F,re){this.frameId=F,this.stoppedLocation=re}};di=Te([V],di),e.InlineValueContext=di;var Fi;(function($){$[$.Changed=1]="Changed",$[$.Created=2]="Created",$[$.Deleted=3]="Deleted"})(Fi=e.FileChangeType||(e.FileChangeType={}));let mi=se=class extends Error{static FileExists(F){return new se(F,I.FileSystemProviderErrorCode.FileExists,se.FileExists)}static FileNotFound(F){return new se(F,I.FileSystemProviderErrorCode.FileNotFound,se.FileNotFound)}static FileNotADirectory(F){return new se(F,I.FileSystemProviderErrorCode.FileNotADirectory,se.FileNotADirectory)}static FileIsADirectory(F){return new se(F,I.FileSystemProviderErrorCode.FileIsADirectory,se.FileIsADirectory)}static NoPermissions(F){return new se(F,I.FileSystemProviderErrorCode.NoPermissions,se.NoPermissions)}static Unavailable(F){return new se(F,I.FileSystemProviderErrorCode.Unavailable,se.Unavailable)}constructor(F,re=I.FileSystemProviderErrorCode.Unknown,pe){super(b.URI.isUri(F)?F.toString(!0):F),this.code=pe?.name??"Unknown",(0,I.markAsFileSystemProviderError)(this,re),Object.setPrototypeOf(this,se.prototype),typeof Error.captureStackTrace=="function"&&typeof pe=="function"&&Error.captureStackTrace(this,pe)}};mi=se=Te([V],mi),e.FileSystemError=mi;let gi=class{constructor(F,re,pe){this.start=F,this.end=re,this.kind=pe}};gi=Te([V],gi),e.FoldingRange=gi;var Mi;(function($){$[$.Comment=1]="Comment",$[$.Imports=2]="Imports",$[$.Region=3]="Region"})(Mi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Ui;(function($){$[$.Collapsed=0]="Collapsed",$[$.Expanded=1]="Expanded"})(Ui=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Bi;(function($){$[$.Editing=0]="Editing",$[$.Preview=1]="Preview"})(Bi=e.CommentMode||(e.CommentMode={}));var $i;(function($){$[$.Unresolved=0]="Unresolved",$[$.Resolved=1]="Resolved"})($i=e.CommentThreadState||(e.CommentThreadState={}));class ji{constructor(F,re=[]){this.tokenTypes=F,this.tokenModifiers=re}}e.SemanticTokensLegend=ji;function zi($){return typeof $>"u"||(0,y.isStringArray)($)}class pi{constructor(F){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,F){this.l=!0;for(let re=0,pe=F.tokenTypes.length;re<pe;re++)this.j.set(F.tokenTypes[re],re);for(let re=0,pe=F.tokenModifiers.length;re<pe;re++)this.k.set(F.tokenModifiers[re],re)}}push(F,re,pe,Ue,He){if(typeof F=="number"&&typeof re=="number"&&typeof pe=="number"&&typeof Ue=="number"&&(typeof He=="number"||typeof He>"u"))return typeof He>"u"&&(He=0),this.n(F,re,pe,Ue,He);if(q.isRange(F)&&typeof re=="string"&&zi(pe))return this.m(F,re,pe);throw(0,A.illegalArgument)()}m(F,re,pe){if(!this.l)throw new Error("Legend must be provided in constructor");if(F.start.line!==F.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(re))throw new Error("`tokenType` is not in the provided legend");const Ue=F.start.line,He=F.start.character,Ze=F.end.character-F.start.character,it=this.j.get(re);let ut=0;if(pe)for(const gt of pe){if(!this.k.has(gt))throw new Error("`tokenModifier` is not in the provided legend");const Et=this.k.get(gt);ut|=1<<Et>>>0}this.n(Ue,He,Ze,it,ut)}n(F,re,pe,Ue,He){if(this.f&&(F<this.c||F===this.c&&re<this.e)){this.f=!1;const ut=this.g.length/5|0;let gt=0,Et=0;for(let yt=0;yt<ut;yt++){let Ct=this.g[5*yt],jt=this.g[5*yt+1];Ct===0?(Ct=gt,jt+=Et):Ct+=gt,this.g[5*yt]=Ct,this.g[5*yt+1]=jt,gt=Ct,Et=jt}}let Ze=F,it=re;this.f&&this.h>0&&(Ze-=this.c,Ze===0&&(it-=this.e)),this.g[this.h++]=Ze,this.g[this.h++]=it,this.g[this.h++]=pe,this.g[this.h++]=Ue,this.g[this.h++]=He,this.c=F,this.e=re}static o(F){const re=[],pe=F.length/5|0;for(let it=0;it<pe;it++)re[it]=it;re.sort((it,ut)=>{const gt=F[5*it],Et=F[5*ut];if(gt===Et){const yt=F[5*it+1],Ct=F[5*ut+1];return yt-Ct}return gt-Et});const Ue=new Uint32Array(F.length);let He=0,Ze=0;for(let it=0;it<pe;it++){const ut=5*re[it],gt=F[ut+0],Et=F[ut+1],yt=F[ut+2],Ct=F[ut+3],jt=F[ut+4],Ri=gt-He,Pn=Ri===0?Et-Ze:Et,zt=5*it;Ue[zt+0]=Ri,Ue[zt+1]=Pn,Ue[zt+2]=yt,Ue[zt+3]=Ct,Ue[zt+4]=jt,He=gt,Ze=Et}return Ue}build(F){return this.f?new bi(new Uint32Array(this.g),F):new bi(pi.o(this.g),F)}}e.SemanticTokensBuilder=pi;class bi{constructor(F,re){this.resultId=re,this.data=F}}e.SemanticTokens=bi;class Wi{constructor(F,re,pe){this.start=F,this.deleteCount=re,this.data=pe}}e.SemanticTokensEdit=Wi;class Hi{constructor(F,re){this.resultId=re,this.edits=F}}e.SemanticTokensEdits=Hi;var Vi;(function($){$[$.Separate=0]="Separate",$[$.MergeWithParent=1]="MergeWithParent"})(Vi=e.DebugConsoleMode||(e.DebugConsoleMode={}));let Ht=class{constructor(){}};Ht.Back={iconPath:new It("arrow-left")},Ht=Te([V],Ht),e.QuickInputButtons=Ht;var qi;(function($){$[$.Separator=-1]="Separator",$[$.Default=0]="Default"})(qi=e.QuickPickItemKind||(e.QuickPickItemKind={}));var xi;(function($){$[$.Info=1]="Info",$[$.Warning=2]="Warning",$[$.Error=3]="Error"})(xi=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var Gi;(function($){$[$.UI=1]="UI",$[$.Workspace=2]="Workspace"})(Gi=e.ExtensionKind||(e.ExtensionKind={}));class Ki{static validate(F){if(typeof F.badge=="string"){let re=(0,P.nextCharLength)(F.badge,0);if(re<F.badge.length&&(re+=(0,P.nextCharLength)(F.badge,re)),F.badge.length>re)throw new Error("The 'badge'-property must be undefined or a short character")}else if(F.badge&&!It.isThemeIcon(F.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!F.color&&!F.badge&&!F.tooltip)throw new Error("The decoration is empty");return!0}constructor(F,re,pe){this.badge=F,this.tooltip=re,this.color=pe}}e.FileDecoration=Ki;let vi=class{constructor(F){this.kind=F}};vi=Te([V],vi),e.ColorTheme=vi;var Yi;(function($){$[$.Light=1]="Light",$[$.Dark=2]="Dark",$[$.HighContrast=3]="HighContrast",$[$.HighContrastLight=4]="HighContrastLight"})(Yi=e.ColorThemeKind||(e.ColorThemeKind={}));class At{static isNotebookRange(F){return F instanceof At?!0:F?typeof F.start=="number"&&typeof F.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(F,re){if(F<0)throw(0,A.illegalArgument)("start must be positive");if(re<0)throw(0,A.illegalArgument)("end must be positive");F<=re?(this.c=F,this.e=re):(this.c=re,this.e=F)}with(F){let re=this.c,pe=this.e;return F.start!==void 0&&(re=F.start),F.end!==void 0&&(pe=F.end),re===this.c&&pe===this.e?this:new At(re,pe)}}e.NotebookRange=At;class Vt{static validate(F){if(typeof F.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof F.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof F.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(F){return Array.isArray(F)&&F.every(re=>Vt.isNotebookCellData(re))}static isNotebookCellData(F){return!0}constructor(F,re,pe,Ue,He,Ze,it){this.kind=F,this.value=re,this.languageId=pe,this.mime=Ue,this.outputs=He??[],this.metadata=Ze,this.executionSummary=it,Vt.validate(this)}}e.NotebookCellData=Vt;class Ji{constructor(F){this.cells=F}}e.NotebookData=Ji;class vt{static isNotebookCellOutputItem(F){return F instanceof vt?!0:F?typeof F.mime=="string"&&F.data instanceof Uint8Array:!1}static error(F){const re={name:F.name,message:F.message,stack:F.stack};return vt.json(re,"application/vnd.code.notebook.error")}static stdout(F){return vt.text(F,"application/vnd.code.notebook.stdout")}static stderr(F){return vt.text(F,"application/vnd.code.notebook.stderr")}static bytes(F,re="application/octet-stream"){return new vt(F,re)}static text(F,re=S.Mimes.text){const pe=st(vt,g,"f",f).encode(String(F));return new vt(pe,re)}static json(F,re="text/x-json"){const pe=JSON.stringify(F,void 0,"	");return vt.text(pe,re)}constructor(F,re){this.data=F,this.mime=re;const pe=(0,S.normalizeMimeType)(re,!0);if(!pe)throw new Error(`INVALID mime type: ${re}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=pe}}g=vt,f={value:new TextEncoder},e.NotebookCellOutputItem=vt;class qt{static isNotebookCellOutput(F){return F instanceof qt?!0:!F||typeof F!="object"?!1:typeof F.id=="string"&&Array.isArray(F.items)}static ensureUniqueMimeTypes(F,re=!1){const pe=new Set,Ue=new Set;for(let He=0;He<F.length;He++){const Ze=F[He],it=(0,S.normalizeMimeType)(Ze.mime);if(!pe.has(it)||(0,d.isTextStreamMime)(it)){pe.add(it);continue}Ue.add(He),re&&console.warn(`DUPLICATED mime type '${Ze.mime}' will be dropped`)}return Ue.size===0?F:F.filter((He,Ze)=>!Ue.has(Ze))}constructor(F,re,pe){this.items=qt.ensureUniqueMimeTypes(F,!0),typeof re=="string"?(this.id=re,this.metadata=pe):(this.id=(0,k.generateUuid)(),this.metadata=re??pe)}}e.NotebookCellOutput=qt;var Xi;(function($){$[$.Markup=1]="Markup",$[$.Code=2]="Code"})(Xi=e.NotebookCellKind||(e.NotebookCellKind={}));var Qi;(function($){$[$.Idle=1]="Idle",$[$.Pending=2]="Pending",$[$.Executing=3]="Executing"})(Qi=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Zi;(function($){$[$.Left=1]="Left",$[$.Right=2]="Right"})(Zi=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var _i;(function($){$[$.Default=0]="Default",$[$.InCenter=1]="InCenter",$[$.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",$[$.AtTop=3]="AtTop"})(_i=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class en{constructor(F,re){this.text=F,this.alignment=re}}e.NotebookCellStatusBarItem=en;var tn;(function($){$[$.Default=1]="Default",$[$.Preferred=2]="Preferred"})(tn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));var nn;(function($){$[$.Default=1]="Default",$[$.Preferred=2]="Preferred",$[$.Hidden=-1]="Hidden"})(nn=e.NotebookControllerAffinity2||(e.NotebookControllerAffinity2={}));class rn{constructor(F,re=[]){this.uri=F,this.provides=(0,E.asArray)(re)}}e.NotebookRendererScript=rn;class sn{constructor(F){this.label=F}}e.NotebookKernelSourceAction=sn;let Ei=class{constructor(F,re){this.label=F,this.timestamp=re}};Ei=Te([V],Ei),e.TimelineItem=Ei;var on;(function($){$[$.Production=1]="Production",$[$.Development=2]="Development",$[$.Test=3]="Test"})(on=e.ExtensionMode||(e.ExtensionMode={}));var an;(function($){$[$.Node=1]="Node",$[$.Webworker=2]="Webworker"})(an=e.ExtensionRuntime||(e.ExtensionRuntime={}));var ln;(function($){$[$.Other=0]="Other",$[$.Comment=1]="Comment",$[$.String=2]="String",$[$.RegEx=3]="RegEx"})(ln=e.StandardTokenType||(e.StandardTokenType={}));class cn{constructor(F,re){this.ranges=F,this.wordPattern=re}}e.LinkedEditingRanges=cn;class un{constructor(F,re){this.c=F,this.e=re}get port(){return this.c}get autoForwardAction(){return this.e}}e.PortAttributes=un;var hn;(function($){$[$.Queued=1]="Queued",$[$.Running=2]="Running",$[$.Passed=3]="Passed",$[$.Failed=4]="Failed",$[$.Skipped=5]="Skipped",$[$.Errored=6]="Errored"})(hn=e.TestResultState||(e.TestResultState={}));var fn;(function($){$[$.Run=1]="Run",$[$.Debug=2]="Debug",$[$.Coverage=3]="Coverage"})(fn=e.TestRunProfileKind||(e.TestRunProfileKind={}));let xt=class{constructor(F=void 0,re=void 0,pe=void 0){this.include=F,this.exclude=re,this.profile=pe}};xt=Te([V],xt),e.TestRunRequest=xt;let yi=class extends xt{constructor(F=void 0,re=void 0,pe=void 0,Ue=!1){super(F,re,pe),this.continuous=Ue}};yi=Te([V],yi),e.TestRunRequest2=yi;let wi=fe=class{static diff(F,re,pe){const Ue=new fe(F);return Ue.expectedOutput=re,Ue.actualOutput=pe,Ue}constructor(F){this.message=F}};wi=fe=Te([V],wi),e.TestMessage=wi;let Si=class{constructor(F){this.id=F}};Si=Te([V],Si),e.TestTag=Si;let Mt=class{constructor(F,re){this.covered=F,this.total=re}};Mt=Te([V],Mt),e.CoveredCount=Mt;let Ii=ce=class{static fromDetails(F,re){const pe=new Mt(0,0),Ue=new Mt(0,0),He=new Mt(0,0);for(const it of re)if("branches"in it){pe.total+=1,pe.covered+=it.executionCount>0?1:0;for(const ut of it.branches)Ue.total+=1,Ue.covered+=ut.executionCount>0?1:0}else He.total+=1,He.covered+=it.executionCount>0?1:0;const Ze=new ce(F,pe,Ue.total>0?Ue:void 0,He.total>0?He:void 0);return Ze.detailedCoverage=re,Ze}constructor(F,re,pe,Ue){this.uri=F,this.statementCoverage=re,this.branchCoverage=pe,this.functionCoverage=Ue}};Ii=ce=Te([V],Ii),e.FileCoverage=Ii;let Ci=class{constructor(F,re,pe=[]){this.executionCount=F,this.location=re,this.branches=pe}};Ci=Te([V],Ci),e.StatementCoverage=Ci;let Di=class{constructor(F,re){this.executionCount=F,this.location=re}};Di=Te([V],Di),e.BranchCoverage=Di;let Pi=class{constructor(F,re){this.executionCount=F,this.location=re}};Pi=Te([V],Pi),e.FunctionCoverage=Pi;var dn;(function($){$[$.None=0]="None",$[$.Option=1]="Option",$[$.Default=2]="Default",$[$.Preferred=3]="Preferred"})(dn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var mn;(function($){$[$.Untrusted=0]="Untrusted",$[$.Trusted=1]="Trusted",$[$.Unspecified=2]="Unspecified"})(mn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var gn;(function($){$[$.Notify=1]="Notify",$[$.OpenBrowser=2]="OpenBrowser",$[$.OpenPreview=3]="OpenPreview",$[$.Silent=4]="Silent",$[$.Ignore=5]="Ignore",$[$.OpenBrowserOnce=6]="OpenBrowserOnce"})(gn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class pn{constructor(F,re,pe,Ue,He,Ze){this.kind=F,this.name=re,this.detail=pe,this.uri=Ue,this.range=He,this.selectionRange=Ze}}e.TypeHierarchyItem=pn;class bn{constructor(F){this.uri=F}}e.TextTabInput=bn;class vn{constructor(F,re){this.original=F,this.modified=re}}e.TextDiffTabInput=vn;class En{constructor(F,re,pe,Ue){this.base=F,this.input1=re,this.input2=pe,this.result=Ue}}e.TextMergeTabInput=En;class yn{constructor(F,re){this.uri=F,this.viewType=re}}e.CustomEditorTabInput=yn;class wn{constructor(F){this.viewType=F}}e.WebviewEditorTabInput=wn;class Sn{constructor(F,re){this.uri=F,this.notebookType=re}}e.NotebookEditorTabInput=Sn;class In{constructor(F,re,pe){this.original=F,this.modified=re,this.notebookType=pe}}e.NotebookDiffEditorTabInput=In;class Cn{constructor(){}}e.TerminalEditorTabInput=Cn;class Dn{constructor(F,re){this.uri=F,this.inputBoxUri=re}}e.InteractiveWindowInput=Dn}),define(be[135],Ee([1,0,18,15,151,70,94,27,142,61,57,23,8,4,49,159,223,130,84,128,69,85,132,134]),function(oe,e,E,A,l,w,S,P,y,b,k,I,v,d,m,p,c,h,g,f,D,R,t,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var i;(function(Se){function Ie(J){const{selectionStartLineNumber:Ce,selectionStartColumn:Le,positionLineNumber:xe,positionColumn:Be}=J,nt=new r.Position(Ce-1,Le-1),at=new r.Position(xe-1,Be-1);return new r.Selection(nt,at)}Se.to=Ie;function de(J){const{anchor:Ce,active:Le}=J;return{selectionStartLineNumber:Ce.line+1,selectionStartColumn:Ce.character+1,positionLineNumber:Le.line+1,positionColumn:Le.character+1}}Se.from=de})(i=e.Selection||(e.Selection={}));var n;(function(Se){function Ie(J){if(!J)return;const{start:Ce,end:Le}=J;return{startLineNumber:Ce.line+1,startColumn:Ce.character+1,endLineNumber:Le.line+1,endColumn:Le.character+1}}Se.from=Ie;function de(J){if(!J)return;const{startLineNumber:Ce,startColumn:Le,endLineNumber:xe,endColumn:Be}=J;return new r.Range(Ce-1,Le-1,xe-1,Be-1)}Se.to=de})(n=e.Range||(e.Range={}));var o;(function(Se){function Ie(de){switch(de){case 1:return r.StandardTokenType.Comment;case 0:return r.StandardTokenType.Other;case 3:return r.StandardTokenType.RegEx;case 2:return r.StandardTokenType.String}}Se.to=Ie})(o=e.TokenType||(e.TokenType={}));var u;(function(Se){function Ie(J){return new r.Position(J.lineNumber-1,J.column-1)}Se.to=Ie;function de(J){return{lineNumber:J.line+1,column:J.character+1}}Se.from=de})(u=e.Position||(e.Position={}));var a;(function(Se){function Ie(Ce,Le){return(0,E.coalesce)((0,E.asArray)(Ce).map(xe=>de(xe,Le)))}Se.from=Ie;function de(Ce,Le){if(typeof Ce=="string")return{$serialized:!0,language:Ce};if(Ce)return{$serialized:!0,language:Ce.language,scheme:J(Ce.scheme,Le),pattern:Re.from(Ce.pattern)??void 0,exclusive:Ce.exclusive,notebookType:Ce.notebookType}}function J(Ce,Le){return Le&&typeof Ce=="string"?Le.transformOutgoingScheme(Ce):Ce}})(a=e.DocumentSelector||(e.DocumentSelector={}));var s;(function(Se){function Ie(J){switch(J){case r.DiagnosticTag.Unnecessary:return 1;case r.DiagnosticTag.Deprecated:return 2}}Se.from=Ie;function de(J){switch(J){case 1:return r.DiagnosticTag.Unnecessary;case 2:return r.DiagnosticTag.Deprecated;default:return}}Se.to=de})(s=e.DiagnosticTag||(e.DiagnosticTag={}));var C;(function(Se){function Ie(J){let Ce;return J.code&&((0,v.isString)(J.code)||(0,v.isNumber)(J.code)?Ce=String(J.code):Ce={value:String(J.code.value),target:J.code.target}),{...n.from(J.range),message:J.message,source:J.source,code:Ce,severity:O.from(J.severity),relatedInformation:J.relatedInformation&&J.relatedInformation.map(L.from),tags:Array.isArray(J.tags)?(0,E.coalesce)(J.tags.map(s.from)):void 0}}Se.from=Ie;function de(J){const Ce=new r.Diagnostic(n.to(J),J.message,O.to(J.severity));return Ce.source=J.source,Ce.code=(0,v.isString)(J.code)?J.code:J.code?.value,Ce.relatedInformation=J.relatedInformation&&J.relatedInformation.map(L.to),Ce.tags=J.tags&&(0,E.coalesce)(J.tags.map(s.to)),Ce}Se.to=de})(C=e.Diagnostic||(e.Diagnostic={}));var L;(function(Se){function Ie(J){return{...n.from(J.location.range),message:J.message,resource:J.location.uri}}Se.from=Ie;function de(J){return new r.DiagnosticRelatedInformation(new r.Location(J.resource,n.to(J)),J.message)}Se.to=de})(L=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var O;(function(Se){function Ie(J){switch(J){case r.DiagnosticSeverity.Error:return c.MarkerSeverity.Error;case r.DiagnosticSeverity.Warning:return c.MarkerSeverity.Warning;case r.DiagnosticSeverity.Information:return c.MarkerSeverity.Info;case r.DiagnosticSeverity.Hint:return c.MarkerSeverity.Hint}return c.MarkerSeverity.Error}Se.from=Ie;function de(J){switch(J){case c.MarkerSeverity.Info:return r.DiagnosticSeverity.Information;case c.MarkerSeverity.Warning:return r.DiagnosticSeverity.Warning;case c.MarkerSeverity.Error:return r.DiagnosticSeverity.Error;case c.MarkerSeverity.Hint:return r.DiagnosticSeverity.Hint;default:return r.DiagnosticSeverity.Error}}Se.to=de})(O=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var W;(function(Se){function Ie(J){return typeof J=="number"&&J>=r.ViewColumn.One?J-1:J===r.ViewColumn.Beside?t.SIDE_GROUP:t.ACTIVE_GROUP}Se.from=Ie;function de(J){if(typeof J=="number"&&J>=0)return J+1;throw new Error("invalid 'EditorGroupColumn'")}Se.to=de})(W=e.ViewColumn||(e.ViewColumn={}));function X(Se){return typeof Se.range<"u"}function se(Se){return Se.length===0?!0:!!X(Se[0])}e.isDecorationOptionsArr=se;var fe;(function(Se){function Ie(Be){return Be.map(Se.from)}Se.fromMany=Ie;function de(Be){return Be&&typeof Be=="object"&&typeof Be.language=="string"&&typeof Be.value=="string"}function J(Be){let nt;if(de(Be)){const{language:ct,value:mt}=Be;nt={value:"```"+ct+`
`+mt+"\n```\n"}}else r.MarkdownString.isMarkdownString(Be)?nt={value:Be.value,isTrusted:Be.isTrusted,supportThemeIcons:Be.supportThemeIcons,supportHtml:Be.supportHtml,baseUri:Be.baseUri}:typeof Be=="string"?nt={value:Be}:nt={value:""};const at=Object.create(null);nt.uris=at;const dt=ct=>{try{let mt=d.URI.parse(ct,!0);mt=mt.with({query:Ce(mt.query,at)}),at[ct]=mt}catch{}return""},bt=new y.marked.Renderer;return bt.link=dt,bt.image=ct=>typeof ct=="string"?dt(S.parseHrefAndDimensions(ct).href):"",(0,y.marked)(nt.value,{renderer:bt}),nt}Se.from=J;function Ce(Be,nt){if(!Be)return Be;let at;try{at=(0,b.parse)(Be)}catch{}if(!at)return Be;let dt=!1;return at=(0,I.cloneAndChange)(at,bt=>{if(d.URI.isUri(bt)){const ct=`__uri_${Math.random().toString(16).slice(2,8)}`;return nt[ct]=bt,dt=!0,ct}else return}),dt?JSON.stringify(at):Be}function Le(Be){const nt=new r.MarkdownString(Be.value,Be.supportThemeIcons);return nt.isTrusted=Be.isTrusted,nt.supportHtml=Be.supportHtml,nt.baseUri=Be.baseUri?d.URI.from(Be.baseUri):void 0,nt}Se.to=Le;function xe(Be){if(!!Be)return typeof Be=="string"?Be:Se.from(Be)}Se.fromStrict=xe})(fe=e.MarkdownString||(e.MarkdownString={}));function ce(Se){return se(Se)?Se.map(Ie=>({range:n.from(Ie.range),hoverMessage:Array.isArray(Ie.hoverMessage)?fe.fromMany(Ie.hoverMessage):Ie.hoverMessage?fe.from(Ie.hoverMessage):void 0,renderOptions:Ie.renderOptions})):Se.map(Ie=>({range:n.from(Ie)}))}e.fromRangeOrRangeWithMessage=ce;function V(Se){return typeof Se>"u"?Se:typeof Se=="string"?d.URI.file(Se):Se}e.pathOrURIToURI=V;var T;(function(Se){function Ie(de){return typeof de>"u"?de:{contentText:de.contentText,contentIconPath:de.contentIconPath?V(de.contentIconPath):void 0,border:de.border,borderColor:de.borderColor,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,color:de.color,backgroundColor:de.backgroundColor,margin:de.margin,width:de.width,height:de.height}}Se.from=Ie})(T=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var z;(function(Se){function Ie(de){return typeof de>"u"?de:{backgroundColor:de.backgroundColor,outline:de.outline,outlineColor:de.outlineColor,outlineStyle:de.outlineStyle,outlineWidth:de.outlineWidth,border:de.border,borderColor:de.borderColor,borderRadius:de.borderRadius,borderSpacing:de.borderSpacing,borderStyle:de.borderStyle,borderWidth:de.borderWidth,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,cursor:de.cursor,color:de.color,opacity:de.opacity,letterSpacing:de.letterSpacing,gutterIconPath:de.gutterIconPath?V(de.gutterIconPath):void 0,gutterIconSize:de.gutterIconSize,overviewRulerColor:de.overviewRulerColor,before:de.before?T.from(de.before):void 0,after:de.after?T.from(de.after):void 0}}Se.from=Ie})(z=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var he;(function(Se){function Ie(de){if(typeof de>"u")return de;switch(de){case r.DecorationRangeBehavior.OpenOpen:return 0;case r.DecorationRangeBehavior.ClosedClosed:return 1;case r.DecorationRangeBehavior.OpenClosed:return 2;case r.DecorationRangeBehavior.ClosedOpen:return 3}}Se.from=Ie})(he=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var H;(function(Se){function Ie(de){return{isWholeLine:de.isWholeLine,rangeBehavior:de.rangeBehavior?he.from(de.rangeBehavior):void 0,overviewRulerLane:de.overviewRulerLane,light:de.light?z.from(de.light):void 0,dark:de.dark?z.from(de.dark):void 0,backgroundColor:de.backgroundColor,outline:de.outline,outlineColor:de.outlineColor,outlineStyle:de.outlineStyle,outlineWidth:de.outlineWidth,border:de.border,borderColor:de.borderColor,borderRadius:de.borderRadius,borderSpacing:de.borderSpacing,borderStyle:de.borderStyle,borderWidth:de.borderWidth,fontStyle:de.fontStyle,fontWeight:de.fontWeight,textDecoration:de.textDecoration,cursor:de.cursor,color:de.color,opacity:de.opacity,letterSpacing:de.letterSpacing,gutterIconPath:de.gutterIconPath?V(de.gutterIconPath):void 0,gutterIconSize:de.gutterIconSize,overviewRulerColor:de.overviewRulerColor,before:de.before?T.from(de.before):void 0,after:de.after?T.from(de.after):void 0}}Se.from=Ie})(H=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var q;(function(Se){function Ie(J){return{text:J.newText,eol:J.newEol&&Xe.from(J.newEol),range:n.from(J.range)}}Se.from=Ie;function de(J){const Ce=new r.TextEdit(n.to(J.range),J.text);return Ce.newEol=typeof J.eol>"u"?void 0:Xe.to(J.eol),Ce}Se.to=de})(q=e.TextEdit||(e.TextEdit={}));var M;(function(Se){function Ie(J,Ce){const Le={edits:[]};if(J instanceof r.WorkspaceEdit){const xe=new P.ResourceSet;for(const Be of J._allEntries())Be._type===1&&d.URI.isUri(Be.to)&&Be.from===void 0&&xe.add(Be.to);for(const Be of J._allEntries())Be._type===1?Le.edits.push({oldResource:Be.from,newResource:Be.to,options:{...Be.options,contentsBase64:Be.options?.contents&&(0,A.encodeBase64)(A.VSBuffer.wrap(Be.options.contents))},metadata:Be.metadata}):Be._type===2?Le.edits.push({resource:Be.uri,textEdit:q.from(Be.edit),versionId:xe.has(Be.uri)?void 0:Ce?.getTextDocumentVersion(Be.uri),metadata:Be.metadata}):Be._type===6?Le.edits.push({resource:Be.uri,textEdit:{range:n.from(Be.range),text:Be.edit.value,insertAsSnippet:!0},versionId:xe.has(Be.uri)?void 0:Ce?.getTextDocumentVersion(Be.uri),metadata:Be.metadata}):Be._type===3?Le.edits.push({metadata:Be.metadata,resource:Be.uri,cellEdit:Be.edit,notebookMetadata:Be.notebookMetadata,notebookVersionId:Ce?.getNotebookDocumentVersion(Be.uri)}):Be._type===5&&Le.edits.push({metadata:Be.metadata,resource:Be.uri,notebookVersionId:Ce?.getNotebookDocumentVersion(Be.uri),cellEdit:{editType:1,index:Be.index,count:Be.count,cells:Be.cells.map(et.from)}})}return Le}Se.from=Ie;function de(J){const Ce=new r.WorkspaceEdit;for(const Le of J.edits)Le.textEdit?Ce.replace(d.URI.revive(Le.resource),n.to(Le.textEdit.range),Le.textEdit.text):Ce.renameFile(d.URI.revive(Le.oldResource),d.URI.revive(Le.newResource),Le.options);return Ce}Se.to=de})(M=e.WorkspaceEdit||(e.WorkspaceEdit={}));var ee;(function(Se){const Ie=Object.create(null);Ie[r.SymbolKind.File]=0,Ie[r.SymbolKind.Module]=1,Ie[r.SymbolKind.Namespace]=2,Ie[r.SymbolKind.Package]=3,Ie[r.SymbolKind.Class]=4,Ie[r.SymbolKind.Method]=5,Ie[r.SymbolKind.Property]=6,Ie[r.SymbolKind.Field]=7,Ie[r.SymbolKind.Constructor]=8,Ie[r.SymbolKind.Enum]=9,Ie[r.SymbolKind.Interface]=10,Ie[r.SymbolKind.Function]=11,Ie[r.SymbolKind.Variable]=12,Ie[r.SymbolKind.Constant]=13,Ie[r.SymbolKind.String]=14,Ie[r.SymbolKind.Number]=15,Ie[r.SymbolKind.Boolean]=16,Ie[r.SymbolKind.Array]=17,Ie[r.SymbolKind.Object]=18,Ie[r.SymbolKind.Key]=19,Ie[r.SymbolKind.Null]=20,Ie[r.SymbolKind.EnumMember]=21,Ie[r.SymbolKind.Struct]=22,Ie[r.SymbolKind.Event]=23,Ie[r.SymbolKind.Operator]=24,Ie[r.SymbolKind.TypeParameter]=25;function de(Ce){return typeof Ie[Ce]=="number"?Ie[Ce]:6}Se.from=de;function J(Ce){for(const Le in Ie)if(Ie[Le]===Ce)return Number(Le);return r.SymbolKind.Property}Se.to=J})(ee=e.SymbolKind||(e.SymbolKind={}));var ie;(function(Se){function Ie(J){switch(J){case r.SymbolTag.Deprecated:return 1}}Se.from=Ie;function de(J){switch(J){case 1:return r.SymbolTag.Deprecated}}Se.to=de})(ie=e.SymbolTag||(e.SymbolTag={}));var me;(function(Se){function Ie(J){return{name:J.name,kind:ee.from(J.kind),tags:J.tags&&J.tags.map(ie.from),containerName:J.containerName,location:G.from(J.location)}}Se.from=Ie;function de(J){const Ce=new r.SymbolInformation(J.name,ee.to(J.kind),J.containerName,G.to(J.location));return Ce.tags=J.tags&&J.tags.map(ie.to),Ce}Se.to=de})(me=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var ne;(function(Se){function Ie(J){const Ce={name:J.name||"!!MISSING: name!!",detail:J.detail,range:n.from(J.range),selectionRange:n.from(J.selectionRange),kind:ee.from(J.kind),tags:J.tags?.map(ie.from)??[]};return J.children&&(Ce.children=J.children.map(Ie)),Ce}Se.from=Ie;function de(J){const Ce=new r.DocumentSymbol(J.name,J.detail,ee.to(J.kind),n.to(J.range),n.to(J.selectionRange));return(0,E.isNonEmptyArray)(J.tags)&&(Ce.tags=J.tags.map(ie.to)),J.children&&(Ce.children=J.children.map(de)),Ce}Se.to=de})(ne=e.DocumentSymbol||(e.DocumentSymbol={}));var B;(function(Se){function Ie(J){const Ce=new r.CallHierarchyItem(ee.to(J.kind),J.name,J.detail||"",d.URI.revive(J.uri),n.to(J.range),n.to(J.selectionRange));return Ce._sessionId=J._sessionId,Ce._itemId=J._itemId,Ce}Se.to=Ie;function de(J,Ce,Le){if(Ce=Ce??J._sessionId,Le=Le??J._itemId,Ce===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:Ce,_itemId:Le,name:J.name,detail:J.detail,kind:ee.from(J.kind),uri:J.uri,range:n.from(J.range),selectionRange:n.from(J.selectionRange),tags:J.tags?.map(ie.from)}}Se.from=de})(B=e.CallHierarchyItem||(e.CallHierarchyItem={}));var N;(function(Se){function Ie(de){return new r.CallHierarchyIncomingCall(B.to(de.from),de.fromRanges.map(J=>n.to(J)))}Se.to=Ie})(N=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var U;(function(Se){function Ie(de){return new r.CallHierarchyOutgoingCall(B.to(de.to),de.fromRanges.map(J=>n.to(J)))}Se.to=Ie})(U=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var G;(function(Se){function Ie(J){return{range:J.range&&n.from(J.range),uri:J.uri}}Se.from=Ie;function de(J){return new r.Location(d.URI.revive(J.uri),n.to(J.range))}Se.to=de})(G=e.location||(e.location={}));var te;(function(Se){function Ie(J){const Ce=J,Le=J;return{originSelectionRange:Ce.originSelectionRange?n.from(Ce.originSelectionRange):void 0,uri:Ce.targetUri?Ce.targetUri:Le.uri,range:n.from(Ce.targetRange?Ce.targetRange:Le.range),targetSelectionRange:Ce.targetSelectionRange?n.from(Ce.targetSelectionRange):void 0}}Se.from=Ie;function de(J){return{targetUri:d.URI.revive(J.uri),targetRange:n.to(J.range),targetSelectionRange:J.targetSelectionRange?n.to(J.targetSelectionRange):void 0,originSelectionRange:J.originSelectionRange?n.to(J.originSelectionRange):void 0}}Se.to=de})(te=e.DefinitionLink||(e.DefinitionLink={}));var le;(function(Se){function Ie(J){return{range:n.from(J.range),contents:fe.fromMany(J.contents)}}Se.from=Ie;function de(J){return new r.Hover(J.contents.map(fe.to),n.to(J.range))}Se.to=de})(le=e.Hover||(e.Hover={}));var j;(function(Se){function Ie(J){return{range:n.from(J.range),expression:J.expression}}Se.from=Ie;function de(J){return new r.EvaluatableExpression(n.to(J.range),J.expression)}Se.to=de})(j=e.EvaluatableExpression||(e.EvaluatableExpression={}));var K;(function(Se){function Ie(J){if(J instanceof r.InlineValueText)return{type:"text",range:n.from(J.range),text:J.text};if(J instanceof r.InlineValueVariableLookup)return{type:"variable",range:n.from(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};if(J instanceof r.InlineValueEvaluatableExpression)return{type:"expression",range:n.from(J.range),expression:J.expression};throw new Error("Unknown 'InlineValue' type")}Se.from=Ie;function de(J){switch(J.type){case"text":return{range:n.to(J.range),text:J.text};case"variable":return{range:n.to(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};case"expression":return{range:n.to(J.range),expression:J.expression}}}Se.to=de})(K=e.InlineValue||(e.InlineValue={}));var Q;(function(Se){function Ie(J){return{frameId:J.frameId,stoppedLocation:n.from(J.stoppedLocation)}}Se.from=Ie;function de(J){return new r.InlineValueContext(J.frameId,n.to(J.stoppedLocation))}Se.to=de})(Q=e.InlineValueContext||(e.InlineValueContext={}));var x;(function(Se){function Ie(J){return{range:n.from(J.range),kind:J.kind}}Se.from=Ie;function de(J){return new r.DocumentHighlight(n.to(J.range),J.kind)}Se.to=de})(x=e.DocumentHighlight||(e.DocumentHighlight={}));var _;(function(Se){function Ie(de){switch(de){case 1:return r.CompletionTriggerKind.TriggerCharacter;case 2:return r.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return r.CompletionTriggerKind.Invoke}}Se.to=Ie})(_=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Y;(function(Se){function Ie(de){return{triggerKind:_.to(de.triggerKind),triggerCharacter:de.triggerCharacter}}Se.to=Ie})(Y=e.CompletionContext||(e.CompletionContext={}));var Z;(function(Se){function Ie(J){switch(J){case r.CompletionItemTag.Deprecated:return 1}}Se.from=Ie;function de(J){switch(J){case 1:return r.CompletionItemTag.Deprecated}}Se.to=de})(Z=e.CompletionItemTag||(e.CompletionItemTag={}));var ae;(function(Se){const Ie=new Map([[r.CompletionItemKind.Method,0],[r.CompletionItemKind.Function,1],[r.CompletionItemKind.Constructor,2],[r.CompletionItemKind.Field,3],[r.CompletionItemKind.Variable,4],[r.CompletionItemKind.Class,5],[r.CompletionItemKind.Interface,7],[r.CompletionItemKind.Struct,6],[r.CompletionItemKind.Module,8],[r.CompletionItemKind.Property,9],[r.CompletionItemKind.Unit,12],[r.CompletionItemKind.Value,13],[r.CompletionItemKind.Constant,14],[r.CompletionItemKind.Enum,15],[r.CompletionItemKind.EnumMember,16],[r.CompletionItemKind.Keyword,17],[r.CompletionItemKind.Snippet,27],[r.CompletionItemKind.Text,18],[r.CompletionItemKind.Color,19],[r.CompletionItemKind.File,20],[r.CompletionItemKind.Reference,21],[r.CompletionItemKind.Folder,23],[r.CompletionItemKind.Event,10],[r.CompletionItemKind.Operator,11],[r.CompletionItemKind.TypeParameter,24],[r.CompletionItemKind.Issue,26],[r.CompletionItemKind.User,25]]);function de(Le){return Ie.get(Le)??9}Se.from=de;const J=new Map([[0,r.CompletionItemKind.Method],[1,r.CompletionItemKind.Function],[2,r.CompletionItemKind.Constructor],[3,r.CompletionItemKind.Field],[4,r.CompletionItemKind.Variable],[5,r.CompletionItemKind.Class],[7,r.CompletionItemKind.Interface],[6,r.CompletionItemKind.Struct],[8,r.CompletionItemKind.Module],[9,r.CompletionItemKind.Property],[12,r.CompletionItemKind.Unit],[13,r.CompletionItemKind.Value],[14,r.CompletionItemKind.Constant],[15,r.CompletionItemKind.Enum],[16,r.CompletionItemKind.EnumMember],[17,r.CompletionItemKind.Keyword],[27,r.CompletionItemKind.Snippet],[18,r.CompletionItemKind.Text],[19,r.CompletionItemKind.Color],[20,r.CompletionItemKind.File],[21,r.CompletionItemKind.Reference],[23,r.CompletionItemKind.Folder],[10,r.CompletionItemKind.Event],[11,r.CompletionItemKind.Operator],[24,r.CompletionItemKind.TypeParameter],[25,r.CompletionItemKind.User],[26,r.CompletionItemKind.Issue]]);function Ce(Le){return J.get(Le)??r.CompletionItemKind.Property}Se.to=Ce})(ae=e.CompletionItemKind||(e.CompletionItemKind={}));var ve;(function(Se){function Ie(de,J){const Ce=new r.CompletionItem(de.label);return Ce.insertText=de.insertText,Ce.kind=ae.to(de.kind),Ce.tags=de.tags?.map(Z.to),Ce.detail=de.detail,Ce.documentation=S.isMarkdownString(de.documentation)?fe.to(de.documentation):de.documentation,Ce.sortText=de.sortText,Ce.filterText=de.filterText,Ce.preselect=de.preselect,Ce.commitCharacters=de.commitCharacters,m.Range.isIRange(de.range)?Ce.range=n.to(de.range):typeof de.range=="object"&&(Ce.range={inserting:n.to(de.range.insert),replacing:n.to(de.range.replace)}),Ce.keepWhitespace=typeof de.insertTextRules>"u"?!1:Boolean(de.insertTextRules&1),typeof de.insertTextRules<"u"&&de.insertTextRules&4?Ce.insertText=new r.SnippetString(de.insertText):(Ce.insertText=de.insertText,Ce.textEdit=Ce.range instanceof r.Range?new r.TextEdit(Ce.range,Ce.insertText):void 0),de.additionalTextEdits&&de.additionalTextEdits.length>0&&(Ce.additionalTextEdits=de.additionalTextEdits.map(Le=>q.to(Le))),Ce.command=J&&de.command?J.fromInternal(de.command):void 0,Ce}Se.to=Ie})(ve=e.CompletionItem||(e.CompletionItem={}));var Pe;(function(Se){function Ie(J){if(typeof J.label!="string"&&!Array.isArray(J.label))throw new TypeError("Invalid label");return{label:J.label,documentation:fe.fromStrict(J.documentation)}}Se.from=Ie;function de(J){return{label:J.label,documentation:S.isMarkdownString(J.documentation)?fe.to(J.documentation):J.documentation}}Se.to=de})(Pe=e.ParameterInformation||(e.ParameterInformation={}));var ke;(function(Se){function Ie(J){return{label:J.label,documentation:fe.fromStrict(J.documentation),parameters:Array.isArray(J.parameters)?J.parameters.map(Pe.from):[],activeParameter:J.activeParameter}}Se.from=Ie;function de(J){return{label:J.label,documentation:S.isMarkdownString(J.documentation)?fe.to(J.documentation):J.documentation,parameters:Array.isArray(J.parameters)?J.parameters.map(Pe.to):[],activeParameter:J.activeParameter}}Se.to=de})(ke=e.SignatureInformation||(e.SignatureInformation={}));var Me;(function(Se){function Ie(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(ke.from):[]}}Se.from=Ie;function de(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(ke.to):[]}}Se.to=de})(Me=e.SignatureHelp||(e.SignatureHelp={}));var je;(function(Se){function Ie(de,J){const Ce=new r.InlayHint(u.to(J.position),typeof J.label=="string"?J.label:J.label.map(ge.to.bind(void 0,de)),J.kind&&we.to(J.kind));return Ce.textEdits=J.textEdits&&J.textEdits.map(q.to),Ce.tooltip=S.isMarkdownString(J.tooltip)?fe.to(J.tooltip):J.tooltip,Ce.paddingLeft=J.paddingLeft,Ce.paddingRight=J.paddingRight,Ce}Se.to=Ie})(je=e.InlayHint||(e.InlayHint={}));var ge;(function(Se){function Ie(de,J){const Ce=new r.InlayHintLabelPart(J.label);return Ce.tooltip=S.isMarkdownString(J.tooltip)?fe.to(J.tooltip):J.tooltip,p.Command.is(J.command)&&(Ce.command=de.fromInternal(J.command)),J.location&&(Ce.location=G.to(J.location)),Ce}Se.to=Ie})(ge=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var we;(function(Se){function Ie(J){return J}Se.from=Ie;function de(J){return J}Se.to=de})(we=e.InlayHintKind||(e.InlayHintKind={}));var ye;(function(Se){function Ie(J){return{range:n.from(J.range),url:J.target,tooltip:J.tooltip}}Se.from=Ie;function de(J){let Ce;if(J.url)try{Ce=typeof J.url=="string"?d.URI.parse(J.url,!0):d.URI.revive(J.url)}catch{}return new r.DocumentLink(n.to(J.range),Ce)}Se.to=de})(ye=e.DocumentLink||(e.DocumentLink={}));var Fe;(function(Se){function Ie(J){const Ce=new r.ColorPresentation(J.label);return J.textEdit&&(Ce.textEdit=q.to(J.textEdit)),J.additionalTextEdits&&(Ce.additionalTextEdits=J.additionalTextEdits.map(Le=>q.to(Le))),Ce}Se.to=Ie;function de(J){return{label:J.label,textEdit:J.textEdit?q.from(J.textEdit):void 0,additionalTextEdits:J.additionalTextEdits?J.additionalTextEdits.map(Ce=>q.from(Ce)):void 0}}Se.from=de})(Fe=e.ColorPresentation||(e.ColorPresentation={}));var $e;(function(Se){function Ie(J){return new r.Color(J[0],J[1],J[2],J[3])}Se.to=Ie;function de(J){return[J.red,J.green,J.blue,J.alpha]}Se.from=de})($e=e.Color||(e.Color={}));var tt;(function(Se){function Ie(J){return{range:n.from(J.range)}}Se.from=Ie;function de(J){return new r.SelectionRange(n.to(J.range))}Se.to=de})(tt=e.SelectionRange||(e.SelectionRange={}));var Ve;(function(Se){function Ie(de){switch(de){case 2:return r.TextDocumentSaveReason.AfterDelay;case 1:return r.TextDocumentSaveReason.Manual;case 3:case 4:return r.TextDocumentSaveReason.FocusOut}}Se.to=Ie})(Ve=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Je;(function(Se){function Ie(J){switch(J){case r.TextEditorLineNumbersStyle.Off:return 0;case r.TextEditorLineNumbersStyle.Relative:return 2;case r.TextEditorLineNumbersStyle.On:default:return 1}}Se.from=Ie;function de(J){switch(J){case 0:return r.TextEditorLineNumbersStyle.Off;case 2:return r.TextEditorLineNumbersStyle.Relative;case 1:default:return r.TextEditorLineNumbersStyle.On}}Se.to=de})(Je=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Xe;(function(Se){function Ie(J){if(J===r.EndOfLine.CRLF)return 1;if(J===r.EndOfLine.LF)return 0}Se.from=Ie;function de(J){if(J===1)return r.EndOfLine.CRLF;if(J===0)return r.EndOfLine.LF}Se.to=de})(Xe=e.EndOfLine||(e.EndOfLine={}));var _e;(function(Se){function Ie(de){if(typeof de=="object")return de.viewId;switch(de){case r.ProgressLocation.SourceControl:return 3;case r.ProgressLocation.Window:return 10;case r.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Se.from=Ie})(_e=e.ProgressLocation||(e.ProgressLocation={}));var Ke;(function(Se){function Ie(J){const Ce={start:J.start+1,end:J.end+1};return J.kind&&(Ce.kind=ue.from(J.kind)),Ce}Se.from=Ie;function de(J){const Ce={start:J.start-1,end:J.end-1};return J.kind&&(Ce.kind=ue.to(J.kind)),Ce}Se.to=de})(Ke=e.FoldingRange||(e.FoldingRange={}));var ue;(function(Se){function Ie(J){if(J)switch(J){case r.FoldingRangeKind.Comment:return p.FoldingRangeKind.Comment;case r.FoldingRangeKind.Imports:return p.FoldingRangeKind.Imports;case r.FoldingRangeKind.Region:return p.FoldingRangeKind.Region}}Se.from=Ie;function de(J){if(J)switch(J.value){case p.FoldingRangeKind.Comment.value:return r.FoldingRangeKind.Comment;case p.FoldingRangeKind.Imports.value:return r.FoldingRangeKind.Imports;case p.FoldingRangeKind.Region.value:return r.FoldingRangeKind.Region}}Se.to=de})(ue=e.FoldingRangeKind||(e.FoldingRangeKind={}));var De;(function(Se){function Ie(de){if(de)return{pinned:typeof de.preview=="boolean"?!de.preview:void 0,inactive:de.background,preserveFocus:de.preserveFocus,selection:typeof de.selection=="object"?n.from(de.selection):void 0,override:typeof de.override=="boolean"?g.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Se.from=Ie})(De=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Re;(function(Se){function Ie(Le){return Le instanceof r.RelativePattern?Le.toJSON():typeof Le=="string"?Le:de(Le)||J(Le)?new r.RelativePattern(Le.baseUri??Le.base,Le.pattern).toJSON():Le}Se.from=Ie;function de(Le){const xe=Le;return xe?d.URI.isUri(xe.baseUri)&&typeof xe.pattern=="string":!1}function J(Le){const xe=Le;return xe?typeof xe.base=="string"&&typeof xe.pattern=="string":!1}function Ce(Le){return typeof Le=="string"?Le:new r.RelativePattern(d.URI.revive(Le.baseUri),Le.pattern)}Se.to=Ce})(Re=e.GlobPattern||(e.GlobPattern={}));var Ne;(function(Se){function Ie(de){if(de){if(Array.isArray(de))return de.map(Ie);if(typeof de=="string")return de;{const J=de;return{language:J.language,scheme:J.scheme,pattern:Re.from(J.pattern),exclusive:J.exclusive,notebookType:J.notebookType}}}else return}Se.from=Ie})(Ne=e.LanguageSelector||(e.LanguageSelector={}));var Oe;(function(Se){function Ie(J){return{start:J.start,end:J.end}}Se.from=Ie;function de(J){return new r.NotebookRange(J.start,J.end)}Se.to=de})(Oe=e.NotebookRange||(e.NotebookRange={}));var ze;(function(Se){function Ie(J){return{timing:typeof J.runStartTime=="number"&&typeof J.runEndTime=="number"?{startTime:J.runStartTime,endTime:J.runEndTime}:void 0,executionOrder:J.executionOrder,success:J.lastRunSuccess}}Se.to=Ie;function de(J){return{lastRunSuccess:J.success,runStartTime:J.timing?.startTime,runEndTime:J.timing?.endTime,executionOrder:J.executionOrder}}Se.from=de})(ze=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var We;(function(Se){function Ie(de){if(de===f.NotebookCellExecutionState.Unconfirmed)return r.NotebookCellExecutionState.Pending;if(de===f.NotebookCellExecutionState.Pending)return;if(de===f.NotebookCellExecutionState.Executing)return r.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${de}`)}Se.to=Ie})(We=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var qe;(function(Se){function Ie(J){switch(J){case r.NotebookCellKind.Markup:return f.CellKind.Markup;case r.NotebookCellKind.Code:default:return f.CellKind.Code}}Se.from=Ie;function de(J){switch(J){case f.CellKind.Markup:return r.NotebookCellKind.Markup;case f.CellKind.Code:default:return r.NotebookCellKind.Code}}Se.to=de})(qe=e.NotebookCellKind||(e.NotebookCellKind={}));var Ge;(function(Se){function Ie(J){const Ce={metadata:J.metadata??Object.create(null),cells:[]};for(const Le of J.cells)r.NotebookCellData.validate(Le),Ce.cells.push(et.from(Le));return Ce}Se.from=Ie;function de(J){const Ce=new r.NotebookData(J.cells.map(et.to));return(0,v.isEmptyObject)(J.metadata)||(Ce.metadata=J.metadata),Ce}Se.to=de})(Ge=e.NotebookData||(e.NotebookData={}));var et;(function(Se){function Ie(J){return{cellKind:qe.from(J.kind),language:J.languageId,mime:J.mime,source:J.value,metadata:J.metadata,internalMetadata:ze.from(J.executionSummary??{}),outputs:J.outputs?J.outputs.map(Qe.from):[]}}Se.from=Ie;function de(J){return new r.NotebookCellData(qe.to(J.cellKind),J.source,J.language,J.mime,J.outputs?J.outputs.map(Qe.to):void 0,J.metadata,J.internalMetadata?ze.to(J.internalMetadata):void 0)}Se.to=de})(et=e.NotebookCellData||(e.NotebookCellData={}));var Ye;(function(Se){function Ie(J){return{mime:J.mime,valueBytes:A.VSBuffer.wrap(J.data)}}Se.from=Ie;function de(J){return new r.NotebookCellOutputItem(J.valueBytes.buffer,J.mime)}Se.to=de})(Ye=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Qe;(function(Se){function Ie(J){return{outputId:J.id,items:J.items.map(Ye.from),metadata:J.metadata}}Se.from=Ie;function de(J){const Ce=J.items.map(Ye.to);return new r.NotebookCellOutput(Ce,J.outputId,J.metadata)}Se.to=de})(Qe=e.NotebookCellOutput||(e.NotebookCellOutput={}));var ot;(function(Se){function Ie(Ce){return J(Ce)?{include:(0,v.withNullAsUndefined)(Re.from(Ce.include)),exclude:(0,v.withNullAsUndefined)(Re.from(Ce.exclude))}:(0,v.withNullAsUndefined)(Re.from(Ce))}Se.from=Ie;function de(Ce){return J(Ce)?{include:Re.to(Ce.include),exclude:Re.to(Ce.exclude)}:Re.to(Ce)}Se.to=de;function J(Ce){const Le=Ce;return Le?!(0,v.isUndefinedOrNull)(Le.include)&&!(0,v.isUndefinedOrNull)(Le.exclude):!1}})(ot=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var rt;(function(Se){function Ie(de,J,Ce){const Le=typeof de.command=="string"?{title:"",command:de.command}:de.command;return{alignment:de.alignment===r.NotebookCellStatusBarAlignment.Left?1:2,command:J.toInternal(Le,Ce),text:de.text,tooltip:de.tooltip,accessibilityInformation:de.accessibilityInformation,priority:de.priority}}Se.from=Ie})(rt=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Lt;(function(Se){function Ie(de,J,Ce){const Le=typeof de.command=="string"?{title:"",command:de.command}:de.command;return{command:J.toInternal(Le,Ce),label:de.label,description:de.description,detail:de.detail,documentation:de.documentation}}Se.from=Ie})(Lt=e.NotebookKernelSourceAction||(e.NotebookKernelSourceAction={}));var Ut;(function(Se){function Ie(de){return{transientOutputs:de?.transientOutputs??!1,transientCellMetadata:de?.transientCellMetadata??{},transientDocumentMetadata:de?.transientDocumentMetadata??{},cellContentMetadata:de?.cellContentMetadata??{}}}Se.from=Ie})(Ut=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var lt;(function(Se){function Ie(J){return{uri:J.uri,provides:J.provides}}Se.from=Ie;function de(J){return new r.NotebookRendererScript(d.URI.revive(J.uri),J.provides)}Se.to=de})(lt=e.NotebookRendererScript||(e.NotebookRendererScript={}));var Ot;(function(Se){function Ie(J){return{message:fe.fromStrict(J.message)||"",type:0,expected:J.expectedOutput,actual:J.actualOutput,location:J.location&&{range:n.from(J.location.range),uri:J.location.uri}}}Se.from=Ie;function de(J){const Ce=new r.TestMessage(typeof J.message=="string"?J.message:fe.to(J.message));return Ce.actualOutput=J.actual,Ce.expectedOutput=J.expected,Ce.location=J.location?G.to(J.location):void 0,Ce}Se.to=de})(Ot=e.TestMessage||(e.TestMessage={}));var ht;(function(Se){Se.namespace=R.namespaceTestTag,Se.denamespace=R.denamespaceTestTag})(ht=e.TestTag||(e.TestTag={}));var Nt;(function(Se){function Ie(J){const Ce=(0,h.getPrivateApiFor)(J).controllerId;return{extId:D.TestId.fromExtHostTestItem(J,Ce).toString(),label:J.label,uri:d.URI.revive(J.uri),busy:J.busy,tags:J.tags.map(Le=>ht.namespace(Ce,Le.id)),range:m.Range.lift(n.from(J.range)),description:J.description||null,sortText:J.sortText||null,error:J.error&&fe.fromStrict(J.error)||null}}Se.from=Ie;function de(J){return{parent:void 0,error:void 0,id:D.TestId.fromString(J.extId).localId,label:J.label,uri:d.URI.revive(J.uri),tags:(J.tags||[]).map(Ce=>{const{tagId:Le}=ht.denamespace(Ce);return new r.TestTag(Le)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:n.to(J.range||void 0),canResolveChildren:!1,busy:J.busy,description:J.description||void 0,sortText:J.sortText||void 0}}Se.toPlain=de})(Nt=e.TestItem||(e.TestItem={})),function(Se){function Ie(J){return{id:J.id}}Se.from=Ie;function de(J){return new r.TestTag(J.id)}Se.to=de}(ht=e.TestTag||(e.TestTag={}));var pt;(function(Se){const Ie=(J,Ce)=>{const Le=[];for(const[Be,nt]of Ce)D.TestId.compare(nt.item.extId,Be)===2&&(Ce.delete(Be),Le.push(nt));const xe={...Nt.toPlain(J.item),parent:void 0,taskStates:J.tasks.map(Be=>({state:Be.state,duration:Be.duration,messages:Be.messages.filter(nt=>nt.type===0).map(Ot.to)})),children:Le.map(Be=>Ie(Be,Ce))};for(const Be of xe.children)Be.parent=xe;return xe};function de(J){const Ce=[],Le=new Map;for(const xe of J.items){Le.set(xe.item.extId,xe);const Be=D.TestId.root(xe.item.extId);J.request.targets.some(nt=>nt.controllerId===Be&&nt.testIds.includes(xe.item.extId))&&Ce.push(xe)}return{completedAt:J.completedAt,results:Ce.map(xe=>Ie(xe,Le))}}Se.to=de})(pt=e.TestResults||(e.TestResults={}));var ft;(function(Se){function Ie(Le){return{covered:Le.covered,total:Le.covered}}function de(Le){return"line"in Le?u.from(Le):n.from(Le)}function J(Le){return"branches"in Le?{count:Le.executionCount,location:de(Le.location),type:1,branches:Le.branches.length?Le.branches.map(xe=>({count:xe.executionCount,location:xe.location&&de(xe.location)})):void 0}:{type:0,count:Le.executionCount,location:de(Le.location)}}Se.fromDetailed=J;function Ce(Le){return{uri:Le.uri,statement:Ie(Le.statementCoverage),branch:Le.branchCoverage&&Ie(Le.branchCoverage),function:Le.functionCoverage&&Ie(Le.functionCoverage),details:Le.detailedCoverage?.map(J)}}Se.fromFile=Ce})(ft=e.TestCoverage||(e.TestCoverage={}));var Dt;(function(Se){function Ie(de){switch(de){case 1:return r.CodeActionTriggerKind.Invoke;case 2:return r.CodeActionTriggerKind.Automatic}}Se.to=Ie})(Dt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Pt;(function(Se){function Ie(J){const Ce=new r.TypeHierarchyItem(ee.to(J.kind),J.name,J.detail||"",d.URI.revive(J.uri),n.to(J.range),n.to(J.selectionRange));return Ce._sessionId=J._sessionId,Ce._itemId=J._itemId,Ce}Se.to=Ie;function de(J,Ce,Le){if(Ce=Ce??J._sessionId,Le=Le??J._itemId,Ce===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:Ce,_itemId:Le,kind:ee.from(J.kind),name:J.name,detail:J.detail??"",uri:J.uri,range:n.from(J.range),selectionRange:n.from(J.selectionRange),tags:J.tags?.map(ie.from)}}Se.from=de})(Pt=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var wt;(function(Se){function Ie(de){if(!!de)return{value:de.value,tooltip:de.tooltip}}Se.from=Ie})(wt=e.ViewBadge||(e.ViewBadge={}));var kt;(function(Se){function Ie(Le,xe,Be){const nt=xe.fileData;return nt?new class extends r.DataTransferItem{asFile(){return{name:nt.name,uri:d.URI.revive(nt.uri),data:(0,w.once)(()=>Be())}}}("",xe.id):Le===k.Mimes.uriList&&xe.uriListData?new r.DataTransferItem(Ce(xe.uriListData)):new r.DataTransferItem(xe.asString)}Se.to=Ie;async function de(Le,xe){const Be=await xe.asString();if(Le===k.Mimes.uriList)return{id:xe.id,asString:Be,fileData:void 0,uriListData:J(Be)};const nt=xe.asFile();return{id:xe.id,asString:Be,fileData:nt?{name:nt.name,uri:nt.uri}:void 0}}Se.from=de;function J(Le){return l.UriList.split(Le).map(xe=>{if(xe.startsWith("#"))return xe;try{return d.URI.parse(xe)}catch{}return xe})}function Ce(Le){return l.UriList.create(Le.map(xe=>typeof xe=="string"?xe:d.URI.revive(xe)))}})(kt=e.DataTransferItem||(e.DataTransferItem={}));var Bt;(function(Se){function Ie(J,Ce){const Le=J.items.map(([xe,Be])=>[xe,kt.to(xe,Be,()=>Ce(Be.id))]);return new r.DataTransfer(Le)}Se.toDataTransfer=Ie;async function de(J){const Ce={items:[]},Le=[];return J.forEach((xe,Be)=>{Le.push((async()=>{Ce.items.push([Be,await kt.from(Be,xe)])})())}),await Promise.all(Le),Ce}Se.toDataTransferDTO=de})(Bt=e.DataTransfer||(e.DataTransfer={}))}),define(be[276],Ee([1,0,49,130,69,129,85,135,4]),function(oe,e,E,A,l,w,S,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const b=(f,D,R,t)=>{let r=D;return{enumerable:!0,configurable:!1,get(){return r},set(i){if(!R(r,i)){const n=r;r=i,f.listener?.(t(i,n))}}}},k=(f,D)=>f===D,I={range:(f,D)=>f===D?!0:!f||!D?!1:f.isEqual(D),label:k,description:k,sortText:k,busy:k,error:k,canResolveChildren:k,tags:(f,D)=>!(f.length!==D.length||f.some(R=>!D.find(t=>R.id===t.id)))},v=f=>D=>({op:4,update:f(D)}),d=(f,D)=>({range:(()=>{let R;const t=v(r=>({range:E.Range.lift(P.Range.from(r))}));return{enumerable:!0,configurable:!1,get(){return R},set(r){f.listener?.({op:6}),I.range(R,r)||(R=r,f.listener?.(t(r)))}}})(),label:b(f,D,I.label,v(R=>({label:R}))),description:b(f,void 0,I.description,v(R=>({description:R}))),sortText:b(f,void 0,I.sortText,v(R=>({sortText:R}))),canResolveChildren:b(f,!1,I.canResolveChildren,R=>({op:2,state:R})),busy:b(f,!1,I.busy,v(R=>({busy:R}))),error:b(f,void 0,I.error,v(R=>({error:P.MarkdownString.fromStrict(R)||null}))),tags:b(f,[],I.tags,(R,t)=>({op:1,new:R.map(P.TestTag.from),old:t.map(P.TestTag.from)}))}),m=f=>{const D=l.TestId.fromString(f.extId),R=new c(D.controllerId,D.localId,f.label,y.URI.revive(f.uri)||void 0);return R.range=P.Range.to(f.range||void 0),R.description=f.description||void 0,R.sortText=f.sortText||void 0,R.tags=f.tags.map(t=>P.TestTag.to({id:(0,S.denamespaceTestTag)(t).tagId})),R},p=f=>{let D;for(const R of f.tests){const t=m(R.item);(0,A.getPrivateApiFor)(t).parent=D,D=t}return D};e.toItemFromContext=p;class c{constructor(D,R,t,r){if(R.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(R)} symbol`);const i=(0,A.createPrivateApiFor)(this,D);Object.defineProperties(this,{id:{value:R,enumerable:!0,writable:!1},uri:{value:r,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return i.parent instanceof h?void 0:i.parent}},children:{value:(0,w.createTestItemChildren)(i,A.getPrivateApiFor,c),enumerable:!0,writable:!1},...d(i,t)})}}e.TestItemImpl=c;class h extends c{constructor(D,R){super(D,D,R,void 0),this._isRoot=!0}}e.TestItemRootImpl=h;class g extends w.TestItemCollection{constructor(D,R,t){super({controllerId:D,getDocumentVersion:r=>r&&t.getDocument(r)?.version,getApiFor:A.getPrivateApiFor,getChildren:r=>r.children,root:new h(D,R),toITestItem:P.TestItem.from})}}e.ExtHostTestItemCollection=g}),define(be[277],Ee([1,0,34,197,50]),function(oe,e,E,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.dedupExtensions=void 0;function w(S,P,y,b){const k=new Map;S.forEach(v=>{const d=E.ExtensionIdentifier.toKey(v.identifier),m=k.get(d);m&&b.warn((0,A.localize)(0,null,m.extensionLocation.fsPath,v.extensionLocation.fsPath)),k.set(d,v)}),P.forEach(v=>{const d=E.ExtensionIdentifier.toKey(v.identifier),m=k.get(d);if(m)if(m.isBuiltin){if(l.gte(m.version,v.version)){b.warn(`Skipping extension ${v.extensionLocation.path} in favour of the builtin extension ${m.extensionLocation.path}.`);return}v.isBuiltin=!0}else b.warn((0,A.localize)(1,null,m.extensionLocation.fsPath,v.extensionLocation.fsPath));else if(v.isBuiltin){b.warn(`Skipping obsolete builtin extension ${v.extensionLocation.path}`);return}k.set(d,v)}),y.forEach(v=>{b.info((0,A.localize)(2,null,v.extensionLocation.fsPath));const d=E.ExtensionIdentifier.toKey(v.identifier),m=k.get(d);m&&m.isBuiltin&&(v.isBuiltin=!0),k.set(d,v)});const I=[];return k.forEach(v=>I.push(v)),I}e.dedupExtensions=w}),define(be[278],Ee([1,0,7,3,28,4,42,47,105,55,277,13]),function(oe,e,E,A,l,w,S,P,y,b,k,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteExtensionsScannerChannel=e.RemoteExtensionsScannerService=void 0;class v{constructor(p,c,h,g,f,D,R){if(this.b=p,this.c=h,this.d=g,this.f=f,this.g=D,this.h=R,c.args["install-builtin-extension"]){const r={isMachineScoped:!!c.args["do-not-sync"],installPreReleaseVersion:!!c.args["pre-release"]};S.mark("code/server/willInstallBuiltinExtensions"),this.a=p.installExtensions([],c.args["install-builtin-extension"],r,!!c.args.force).then(()=>S.mark("code/server/didInstallBuiltinExtensions"),i=>{f.error(i)})}else this.a=Promise.resolve();const t=c.args["install-extension"];if(t){const r=t.map(i=>/\.vsix$/i.test(i)?w.URI.file((0,E.isAbsolute)(i)?i:(0,E.join)((0,l.cwd)(),i)):i);this.a.then(()=>p.installExtensions(r,[],{isMachineScoped:!!c.args["do-not-sync"],installPreReleaseVersion:!!c.args["pre-release"]},!!c.args.force)).then(null,i=>{f.error(i)})}}whenExtensionsReady(){return this.a}async scanExtensions(p,c,h,g){await this.whenExtensionsReady(),S.mark("code/server/willScanExtensions"),this.f.trace(`Scanning extensions using UI language: ${p}`);const f=h?h.filter(R=>R.scheme===I.Schemas.file).map(R=>R.fsPath):void 0;c=c??this.c.defaultProfile.extensionsResource;const D=await this.i(c,p??A.language,f,g);return this.f.trace("Scanned Extensions",D),this.o(D),S.mark("code/server/didScanExtensions"),D}async scanSingleExtension(p,c,h){await this.whenExtensionsReady();const g=p.scheme===I.Schemas.file?p.fsPath:null;if(!g)return null;const f=await this.m(g,c,h??A.language);return f?(this.o([f]),f):null}async i(p,c,h,g){await this.n(c,g);const[f,D,R]=await Promise.all([this.k(c),this.l(p,c),this.j(c,h)]);return(0,k.dedupExtensions)(f,D,R,this.f)}async j(p,c){return c?(await Promise.all(c.map(h=>this.d.scanOneOrMultipleExtensions(w.URI.file((0,E.resolve)(h)),1,{language:p})))).flat().map(h=>(0,b.toExtensionDescription)(h,!0)):[]}async k(p){return(await this.d.scanSystemExtensions({language:p,useCache:!0})).map(h=>(0,b.toExtensionDescription)(h,!1))}async l(p,c){return(await this.d.scanUserExtensions({profileLocation:p,language:c,useCache:!0})).map(g=>(0,b.toExtensionDescription)(g,!1))}async m(p,c,h){const g=w.URI.file((0,E.resolve)(p)),f=c?0:1,D=await this.d.scanExistingExtension(g,f,{language:h});return D?(0,b.toExtensionDescription)(D,!1):null}async n(p,c){if(!(p===A.LANGUAGE_DEFAULT||!this.g.isEnabled())){try{if((await this.h.getInstalledLanguages()).find(g=>g.id===p)){this.f.trace(`Language Pack ${p} is already installed. Skipping language pack installation.`);return}}catch(h){this.f.error(h)}if(!c){this.f.trace(`No language pack id provided for language ${p}. Skipping language pack installation.`);return}this.f.trace(`Language Pack ${c} for language ${p} is not installed. It will be installed now.`);try{await this.b.installExtensions([c],[],{isMachineScoped:!0},!0,{log:h=>this.f.info(h),error:h=>this.f.error(h)})}catch(h){this.f.error(h)}}}o(p){const c=(t,r)=>t.replace(/file/g,"vscode-remote"),h=t=>{let r="";return r+=t.global?"g":"",r+=t.ignoreCase?"i":"",r+=t.multiline?"m":"",new RegExp(c(t.source,!0),r)},g=new class{mapDefined(t){return y.ContextKeyDefinedExpr.create(t)}mapNot(t){return y.ContextKeyNotExpr.create(t)}mapEquals(t,r){return t==="resourceScheme"&&typeof r=="string"?y.ContextKeyEqualsExpr.create(t,c(r,!1)):y.ContextKeyEqualsExpr.create(t,r)}mapNotEquals(t,r){return t==="resourceScheme"&&typeof r=="string"?y.ContextKeyNotEqualsExpr.create(t,c(r,!1)):y.ContextKeyNotEqualsExpr.create(t,r)}mapGreater(t,r){return y.ContextKeyGreaterExpr.create(t,r)}mapGreaterEquals(t,r){return y.ContextKeyGreaterEqualsExpr.create(t,r)}mapSmaller(t,r){return y.ContextKeySmallerExpr.create(t,r)}mapSmallerEquals(t,r){return y.ContextKeySmallerEqualsExpr.create(t,r)}mapRegex(t,r){return t==="resourceScheme"&&r?y.ContextKeyRegexExpr.create(t,h(r)):y.ContextKeyRegexExpr.create(t,r)}mapIn(t,r){return y.ContextKeyInExpr.create(t,r)}mapNotIn(t,r){return y.ContextKeyNotInExpr.create(t,r)}},f=t=>{if(!t||!t.when||!/resourceScheme/.test(t.when))return;const r=y.ContextKeyExpr.deserialize(t.when);if(!r)return;const i=r.map(g);t.when=i.serialize()},D=t=>{if(Array.isArray(t))for(const r of t)f(r);else f(t)},R=t=>{for(const r in t)D(t[r])};p.forEach(t=>{t.contributes&&(t.contributes.menus&&R(t.contributes.menus),t.contributes.keybindings&&D(t.contributes.keybindings),t.contributes.views&&R(t.contributes.views))})}}e.RemoteExtensionsScannerService=v;class d{constructor(p,c){this.a=p,this.b=c}listen(p,c){throw new Error("Invalid listen")}async call(p,c,h){const g=this.b(p);switch(c){case"whenExtensionsReady":return this.a.whenExtensionsReady();case"scanExtensions":{const f=h[0],D=h[1]?w.URI.revive(g.transformIncoming(h[1])):void 0,R=Array.isArray(h[2])?h[2].map(i=>w.URI.revive(g.transformIncoming(i))):void 0,t=h[3];return(await this.a.scanExtensions(f,D,R,t)).map(i=>(0,P.transformOutgoingURIs)(i,g))}case"scanSingleExtension":{const f=await this.a.scanSingleExtension(w.URI.revive(g.transformIncoming(h[0])),h[1],h[2]);return f?(0,P.transformOutgoingURIs)(f,g):null}}throw new Error("Invalid call")}}e.RemoteExtensionsScannerChannel=d}),define(be[136],Ee([1,0]),function(oe,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class E{constructor(y){this._proxyIdentifierBrand=void 0,this.sid=y,this.nid=++E.count}}E.count=0,e.ProxyIdentifier=E;const A=[];function l(P){const y=new E(P);return A[y.nid]=y,y}e.createProxyIdentifier=l;function w(P){return A[P].sid}e.getStringIdentifierForProxy=w;class S{constructor(y){this.value=y}}e.SerializableObjectWithBuffers=S}),define(be[279],Ee([1,0,136]),function(oe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var A;(function(p){p[p.Default=0]="Default",p[p.InCenter=1]="InCenter",p[p.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",p[p.AtTop=3]="AtTop"})(A=e.TextEditorRevealType||(e.TextEditorRevealType={}));var l;(function(p){p[p.UnknownInput=0]="UnknownInput",p[p.TextInput=1]="TextInput",p[p.TextDiffInput=2]="TextDiffInput",p[p.TextMergeInput=3]="TextMergeInput",p[p.NotebookInput=4]="NotebookInput",p[p.NotebookDiffInput=5]="NotebookDiffInput",p[p.CustomEditorInput=6]="CustomEditorInput",p[p.WebviewEditorInput=7]="WebviewEditorInput",p[p.TerminalEditorInput=8]="TerminalEditorInput",p[p.InteractiveEditorInput=9]="InteractiveEditorInput"})(l=e.TabInputKind||(e.TabInputKind={}));var w;(function(p){p[p.TAB_OPEN=0]="TAB_OPEN",p[p.TAB_CLOSE=1]="TAB_CLOSE",p[p.TAB_UPDATE=2]="TAB_UPDATE",p[p.TAB_MOVE=3]="TAB_MOVE"})(w=e.TabModelOperationKind||(e.TabModelOperationKind={}));var S;(function(p){p[p.Editable=0]="Editable",p[p.SupportsHotExit=1]="SupportsHotExit"})(S=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var P;(function(p){p[p.Int8Array=1]="Int8Array",p[p.Uint8Array=2]="Uint8Array",p[p.Uint8ClampedArray=3]="Uint8ClampedArray",p[p.Int16Array=4]="Int16Array",p[p.Uint16Array=5]="Uint16Array",p[p.Int32Array=6]="Int32Array",p[p.Uint32Array=7]="Uint32Array",p[p.Float32Array=8]="Float32Array",p[p.Float64Array=9]="Float64Array",p[p.BigInt64Array=10]="BigInt64Array",p[p.BigUint64Array=11]="BigUint64Array"})(P=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var y;(function(p){p[p.Text=1]="Text",p[p.Error=2]="Error",p[p.Rich=3]="Rich"})(y=e.CellOutputKind||(e.CellOutputKind={}));var b;(function(p){p[p.Default=0]="Default",p[p.InCenter=1]="InCenter",p[p.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",p[p.AtTop=3]="AtTop"})(b=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var k;(function(p){p[p.None=0]="None",p[p.Process=1]="Process",p[p.Output=2]="Output"})(k=e.CandidatePortSource||(e.CandidatePortSource={}));class I{static mixin(c){return c._id=I.a++,c}}I.a=0,e.IdObject=I;var v;(function(p){p.label="a",p.kind="b",p.detail="c",p.documentation="d",p.sortText="e",p.filterText="f",p.preselect="g",p.insertText="h",p.insertTextRules="i",p.range="j",p.commitCharacters="k",p.additionalTextEdits="l",p.kindModifier="m",p.commandIdent="n",p.commandId="o",p.commandArguments="p"})(v=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var d;(function(p){p.defaultRanges="a",p.completions="b",p.isIncomplete="c",p.duration="d"})(d=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var m;(function(p){p[p.Workspace=0]="Workspace",p[p.TextDocument=1]="TextDocument"})(m=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,E.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,E.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,E.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,E.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,E.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,E.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,E.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,E.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,E.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,E.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,E.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,E.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,E.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,E.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,E.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,E.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,E.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,E.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,E.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,E.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,E.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,E.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,E.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,E.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,E.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,E.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickDiff:(0,E.createProxyIdentifier)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,E.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,E.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,E.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,E.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,E.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,E.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,E.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,E.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,E.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,E.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,E.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,E.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,E.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,E.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,E.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,E.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,E.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,E.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,E.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,E.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,E.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,E.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,E.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,E.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,E.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,E.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,E.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,E.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,E.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,E.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,E.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,E.createProxyIdentifier)("MainThreadLocalizationShape")},e.ExtHostContext={ExtHostCommands:(0,E.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,E.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,E.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,E.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,E.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,E.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,E.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,E.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,E.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,E.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,E.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,E.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,E.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,E.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,E.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,E.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,E.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,E.createProxyIdentifier)("ExtHostQuickDiff"),ExtHostExtensionService:(0,E.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,E.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,E.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,E.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,E.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,E.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,E.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,E.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,E.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,E.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,E.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,E.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,E.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,E.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,E.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,E.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,E.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,E.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,E.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,E.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,E.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,E.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,E.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,E.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,E.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,E.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,E.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,E.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,E.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,E.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,E.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,E.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,E.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,E.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,E.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,E.createProxyIdentifier)("ExtHostLocalization")}});var Tt=this&&this.__classPrivateFieldSet||function(oe,e,E,A,l){if(A==="m")throw new TypeError("Private method is not writable");if(A==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?oe!==e||!l:!e.has(oe))throw new TypeError("Cannot write private member to an object whose class did not declare it");return A==="a"?l.call(oe,E):l?l.value=E:e.set(oe,E),E},st=this&&this.__classPrivateFieldGet||function(oe,e,E,A){if(E==="a"&&!A)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?oe!==e||!A:!e.has(oe))throw new TypeError("Cannot read private member from an object whose class did not declare it");return E==="m"?A:E==="a"?A.call(oe):A?A.value:e.get(oe)};define(be[280],Ee([1,0,8,134,135,23,279,18,10,61,49,103,4,2,5,263,276,15,136,39,91,37,274]),function(oe,e,E,A,l,w,S,P,y,b,k,I,v,d,m,p,c,h,g,f,D,R,t){"use strict";var r,i,n;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let o=class{constructor(O,W,X){r.set(this,void 0),this.b=new Map,this.c=new Map,i.set(this,void 0),n.set(this,void 0),Tt(this,r,O.getProxy(S.MainContext.MainThreadCommands),"f"),this.d=W,Tt(this,n,X,"f"),Tt(this,i,O.getProxy(S.MainContext.MainThreadTelemetry),"f"),this.converter=new u(this,se=>{const fe=this.c.get(se);return fe?.result===s.Void?fe:void 0},W),this.f=[{processArgument(se){return(0,b.revive)(se)}},{processArgument(se){return(0,w.cloneAndChange)(se,function(fe){if(k.Range.isIRange(fe))return l.Range.to(fe);if(I.Position.isIPosition(fe))return l.Position.to(fe);if(k.Range.isIRange(fe.range)&&v.URI.isUri(fe.uri))return l.location.to(fe);if(fe instanceof h.VSBuffer)return fe.buffer.buffer;if(!Array.isArray(fe))return fe})}}]}registerArgumentProcessor(O){this.f.push(O)}registerApiCommand(O){const W=this.registerCommand(!1,O.id,async(...X)=>{const se=O.args.map((ce,V)=>{if(!ce.validate(X[V]))throw new Error(`Invalid argument '${ce.name}' when running '${O.id}', received: ${X[V]}`);return ce.convert(X[V])}),fe=await this.executeCommand(O.internalId,...se);return O.result.convert(fe,X,this.converter)},void 0,{description:O.description,args:O.args,returns:O.result.description});return this.c.set(O.id,O),new A.Disposable(()=>{W.dispose(),this.c.delete(O.id)})}registerCommand(O,W,X,se,fe,ce){if(this.d.trace("ExtHostCommands#registerCommand",W),!W.trim().length)throw new Error("invalid id");if(this.b.has(W))throw new Error(`command '${W}' already exists`);return this.b.set(W,{callback:X,thisArg:se,description:fe,extension:ce}),O&&st(this,r,"f").$registerCommand(W),new A.Disposable(()=>{this.b.delete(W)&&O&&st(this,r,"f").$unregisterCommand(W)})}executeCommand(O,...W){return this.d.trace("ExtHostCommands#executeCommand",O),this.g(O,W,!0)}async g(O,W,X){if(this.b.has(O))return st(this,r,"f").$fireCommandActivationEvent(O),this.h(O,W,!1);{let se=!1;const fe=(0,w.cloneAndChange)(W,function(ce){if(ce instanceof A.Position)return l.Position.from(ce);if(ce instanceof A.Range)return l.Range.from(ce);if(ce instanceof A.Location)return l.location.from(ce);if(A.NotebookRange.isNotebookRange(ce))return l.NotebookRange.from(ce);if(ce instanceof ArrayBuffer)return se=!0,h.VSBuffer.wrap(new Uint8Array(ce));if(ce instanceof Uint8Array)return se=!0,h.VSBuffer.wrap(ce);if(ce instanceof h.VSBuffer)return se=!0,ce;if(!Array.isArray(ce))return ce});try{const ce=await st(this,r,"f").$executeCommand(O,se?new g.SerializableObjectWithBuffers(fe):fe,X);return(0,b.revive)(ce)}catch(ce){if(ce instanceof Error&&ce.message==="$executeCommand:retry")return this.g(O,W,!1);throw ce}}}async h(O,W,X){const se=this.b.get(O);if(!se)throw new Error("Unknown command");const{callback:fe,thisArg:ce,description:V}=se;if(V)for(let z=0;z<V.args.length;z++)try{(0,E.validateConstraint)(W[z],V.args[z].constraint)}catch{throw new Error(`Running the contributed command: '${O}' failed. Illegal argument '${V.args[z].name}' - ${V.args[z].description}`)}const T=D.StopWatch.create();try{return await fe.apply(ce,W)}catch(z){if(O===this.converter.delegatingCommandId){const he=this.converter.getActualCommand(...W);he&&(O=he.command)}if(this.d.error(z,O,se.extension?.identifier),!X)throw z;if(se.extension?.identifier){const he=st(this,n,"f").onExtensionError(se.extension.identifier,z);this.d.trace("forwarded error to extension?",he,se.extension?.identifier)}throw new class extends Error{constructor(){super((0,f.toErrorMessage)(z)),this.id=O,this.source=se.extension?.displayName??se.extension?.name}}}finally{this.j(se,O,T.elapsed())}}j(O,W,X){!O.extension||st(this,i,"f").$publicLog2("Extension:ActionExecuted",{extensionId:O.extension.identifier.value,id:new R.TelemetryTrustedValue(W),duration:X})}$executeContributedCommand(O,...W){this.d.trace("ExtHostCommands#$executeContributedCommand",O);const X=this.b.get(O);return X?(W=W.map(se=>this.f.reduce((fe,ce)=>ce.processArgument(fe,X.extension?.identifier),se)),this.h(O,W,!0)):Promise.reject(new Error(`Contributed command '${O}' does not exist.`))}getCommands(O=!1){return this.d.trace("ExtHostCommands#getCommands",O),st(this,r,"f").$getCommands().then(W=>(O&&(W=W.filter(X=>X[0]!=="_")),W))}$getContributedCommandHandlerDescriptions(){const O=Object.create(null);for(const[W,X]of this.b){const{description:se}=X;se&&(O[W]=se)}return Promise.resolve(O)}};r=new WeakMap,i=new WeakMap,n=new WeakMap,o=Te([Ae(0,p.IExtHostRpcService),Ae(1,y.ILogService),Ae(2,t.IExtHostTelemetry)],o),e.ExtHostCommands=o,e.IExtHostCommands=(0,m.createDecorator)("IExtHostCommands");class u{constructor(O,W,X){this.d=O,this.f=W,this.g=X,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(O,W){if(!O)return;const X={$ident:void 0,id:O.command,title:O.title,tooltip:O.tooltip};if(!O.command)return X;const se=this.f(O.command);if(se)X.id=se.internalId,X.arguments=se.args.map((fe,ce)=>fe.convert(O.arguments&&O.arguments[ce]));else if((0,P.isNonEmptyArray)(O.arguments)){const fe=`${O.command}/${++this.c}`;this.b.set(fe,O),W.add((0,d.toDisposable)(()=>{this.b.delete(fe),this.g.trace("CommandsConverter#DISPOSE",fe)})),X.$ident=fe,X.id=this.delegatingCommandId,X.arguments=[fe],this.g.trace("CommandsConverter#CREATE",O.command,fe)}return X}fromInternal(O){return typeof O.$ident=="string"?this.b.get(O.$ident):{command:O.id,title:O.title,arguments:O.arguments}}getActualCommand(...O){return this.b.get(O[0])}h(...O){const W=this.getActualCommand(...O);return this.g.trace("CommandsConverter#EXECUTE",O[0],W?W.command:"MISSING"),W?this.d.executeCommand(W.command,...W.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${O[0]}`)}}e.CommandsConverter=u;class a{constructor(O,W,X,se){this.name=O,this.description=W,this.validate=X,this.convert=se}optional(){return new a(this.name,`(optional) ${this.description}`,O=>O==null||this.validate(O),O=>O===void 0?void 0:O===null?null:this.convert(O))}with(O,W){return new a(O??this.name,W??this.description,this.validate,this.convert)}}a.Uri=new a("uri","Uri of a text document",L=>v.URI.isUri(L),L=>L),a.Position=new a("position","A position in a text document",L=>A.Position.isPosition(L),l.Position.from),a.Range=new a("range","A range in a text document",L=>A.Range.isRange(L),l.Range.from),a.Selection=new a("selection","A selection in a text document",L=>A.Selection.isSelection(L),l.Selection.from),a.Number=new a("number","",L=>typeof L=="number",L=>L),a.String=new a("string","",L=>typeof L=="string",L=>L),a.CallHierarchyItem=new a("item","A call hierarchy item",L=>L instanceof A.CallHierarchyItem,l.CallHierarchyItem.from),a.TypeHierarchyItem=new a("item","A type hierarchy item",L=>L instanceof A.TypeHierarchyItem,l.TypeHierarchyItem.from),a.TestItem=new a("testItem","A VS Code TestItem",L=>L instanceof c.TestItemImpl,l.TestItem.from),e.ApiCommandArgument=a;class s{constructor(O,W){this.description=O,this.convert=W}}s.Void=new s("no result",L=>L),e.ApiCommandResult=s;class C{constructor(O,W,X,se,fe){this.id=O,this.internalId=W,this.description=X,this.args=se,this.result=fe}}e.ApiCommand=C}),define(be[281],Ee([1,0,62,260,33,280,4,10,82]),function(oe,e,E,A,l,w,S,P,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class b{constructor(v,d,m){this.b=v,this.c=d,this.f=m,this.a=A.createServer((p,c)=>this.h(p,c)),this.g().catch(p=>(d.error(p),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",v=>this.c.error(v))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(v,d){const m=(c,h)=>{d.writeHead(c,{"content-type":"application/json"}),d.end(JSON.stringify(h||null),g=>g&&this.c.error(g))},p=[];v.setEncoding("utf8"),v.on("data",c=>p.push(c)),v.on("end",async()=>{try{const c=JSON.parse(p.join(""));let h;switch(c.type){case"open":h=await this.i(c);break;case"openExternal":h=await this.j(c);break;case"status":h=await this.l(c);break;case"extensionManagement":h=await this.k(c);break;default:m(404,`Unknown message type: ${c.type}`);break}m(200,h)}catch(c){const h=c instanceof Error?c.message:JSON.stringify(c);m(500,h),this.c.error("Error while processing pipe request",c)}})}async i(v){const{fileURIs:d,folderURIs:m,forceNewWindow:p,diffMode:c,mergeMode:h,addMode:g,forceReuseWindow:f,gotoLineMode:D,waitMarkerFilePath:R,remoteAuthority:t}=v,r=[];if(Array.isArray(m))for(const u of m)try{r.push({folderUri:S.URI.parse(u)})}catch{}if(Array.isArray(d))for(const u of d)try{(0,y.hasWorkspaceFileExtension)(u)?r.push({workspaceUri:S.URI.parse(u)}):r.push({fileUri:S.URI.parse(u)})}catch{}const i=R?S.URI.file(R):void 0,o={forceNewWindow:p,diffMode:c,mergeMode:h,addMode:g,gotoLineMode:D,forceReuseWindow:f,preferNewWindow:!f&&!i&&!g,waitMarkerFileURI:i,remoteAuthority:t};return this.b.executeCommand("_remoteCLI.windowOpen",r,o),""}async j(v){for(const d of v.uris){const m=S.URI.parse(d),p=m.scheme==="file"?m:d;await this.b.executeCommand("_remoteCLI.openExternal",p)}}async k(v){const d=p=>p?.map(c=>/\.vsix$/i.test(c)?S.URI.parse(c):c),m={list:v.list,install:d(v.install),uninstall:d(v.uninstall),force:v.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",m)}async l(v){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&l.existsSync(this.f)&&l.unlinkSync(this.f)}}e.CLIServerBase=b;let k=class extends b{constructor(v,d){super(v,d,(0,E.createRandomIPCHandle)())}};k=Te([Ae(0,w.IExtHostCommands),Ae(1,P.ILogService)],k),e.CLIServer=k}),define(be[282],Ee([1,0,29,6,23,2,7,3,4,62,68,281,120,81,267,269,133]),function(oe,e,E,A,l,w,S,P,y,b,k,I,v,d,m,p,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTerminalChannel=void 0;class h extends p.AbstractVariableResolverService{constructor(D,R,t,r,i){super({getFolderUri:n=>{const o=R.filter(u=>u.name===n);if(o&&o.length>0)return o[0].uri},getWorkspaceFolderCount:()=>R.length,getConfigurationValue:(n,o)=>r[`config:${o}`],getExecPath:()=>D.VSCODE_EXEC_PATH,getAppRoot:()=>D.VSCODE_CWD,getFilePath:()=>{if(t)return S.normalize(t.fsPath)},getSelectedText:()=>r.selectedText,getLineNumber:()=>r.lineNumber,getExtension:async n=>{const u=(await i.getInstalled()).find(a=>a.identifier.id===n);return u&&{extensionLocation:u.location}}},void 0,Promise.resolve(E.homedir()),Promise.resolve(D))}}class g extends w.Disposable{constructor(D,R,t,r,i,n){super(),this.g=D,this.h=R,this.i=t,this.j=r,this.l=i,this.m=n,this.a=0,this.b=new Map,this.c=this.B(new A.Emitter),this.onExecuteCommand=this.c.event}async call(D,R,t){switch(R){case"$restartPtyHost":return this.i.restartPtyHost?.apply(this.i,t);case"$createProcess":{const r=(0,k.createURITransformer)(D.remoteAuthority);return this.n(r,t)}case"$attachToProcess":return this.i.attachToProcess.apply(this.i,t);case"$detachFromProcess":return this.i.detachFromProcess.apply(this.i,t);case"$listProcesses":return this.i.listProcesses.apply(this.i,t);case"$orphanQuestionReply":return this.i.orphanQuestionReply.apply(this.i,t);case"$acceptPtyHostResolvedVariables":return this.i.acceptPtyHostResolvedVariables?.apply(this.i,t);case"$start":return this.i.start.apply(this.i,t);case"$input":return this.i.input.apply(this.i,t);case"$acknowledgeDataEvent":return this.i.acknowledgeDataEvent.apply(this.i,t);case"$shutdown":return this.i.shutdown.apply(this.i,t);case"$resize":return this.i.resize.apply(this.i,t);case"$getInitialCwd":return this.i.getInitialCwd.apply(this.i,t);case"$getCwd":return this.i.getCwd.apply(this.i,t);case"$processBinary":return this.i.processBinary.apply(this.i,t);case"$sendCommandResult":return this.r(t[0],t[1],t[2]);case"$installAutoReply":return this.i.installAutoReply.apply(this.i,t);case"$uninstallAllAutoReplies":return this.i.uninstallAllAutoReplies.apply(this.i,t);case"$getDefaultSystemShell":return this.s.apply(this,t);case"$getProfiles":return this.t.apply(this,t);case"$getEnvironment":return this.u();case"$getWslPath":return this.w(t[0],t[1]);case"$getTerminalLayoutInfo":return this.i.getTerminalLayoutInfo(t);case"$setTerminalLayoutInfo":return this.i.setTerminalLayoutInfo(t);case"$serializeTerminalState":return this.i.serializeTerminalState.apply(this.i,t);case"$reviveTerminalProcesses":return this.i.reviveTerminalProcesses.apply(this.i,t);case"$getRevivedPtyNewId":return this.i.getRevivedPtyNewId.apply(this.i,t);case"$setUnicodeVersion":return this.i.setUnicodeVersion.apply(this.i,t);case"$reduceConnectionGraceTime":return this.y();case"$updateIcon":return this.i.updateIcon.apply(this.i,t);case"$updateTitle":return this.i.updateTitle.apply(this.i,t);case"$updateProperty":return this.i.updateProperty.apply(this.i,t);case"$refreshProperty":return this.i.refreshProperty.apply(this.i,t);case"$requestDetachInstance":return this.i.requestDetachInstance(t[0],t[1]);case"$acceptDetachedInstance":return this.i.acceptDetachInstanceReply(t[0],t[1]);case"$freePortKillProcess":return this.i.freePortKillProcess?.apply(this.i,t)}throw new Error(`IPC Command ${R} not found`)}listen(D,R,t){switch(R){case"$onPtyHostExitEvent":return this.i.onPtyHostExit||A.Event.None;case"$onPtyHostStartEvent":return this.i.onPtyHostStart||A.Event.None;case"$onPtyHostUnresponsiveEvent":return this.i.onPtyHostUnresponsive||A.Event.None;case"$onPtyHostResponsiveEvent":return this.i.onPtyHostResponsive||A.Event.None;case"$onPtyHostRequestResolveVariablesEvent":return this.i.onPtyHostRequestResolveVariables||A.Event.None;case"$onProcessDataEvent":return this.i.onProcessData;case"$onProcessReadyEvent":return this.i.onProcessReady;case"$onProcessExitEvent":return this.i.onProcessExit;case"$onProcessReplayEvent":return this.i.onProcessReplay;case"$onProcessOrphanQuestion":return this.i.onProcessOrphanQuestion;case"$onExecuteCommand":return this.onExecuteCommand;case"$onDidRequestDetach":return this.i.onDidRequestDetach||A.Event.None;case"$onDidChangeProperty":return this.i.onDidChangeProperty;default:break}throw new Error("Not supported")}async n(D,R){const t={name:R.shellLaunchConfig.name,executable:R.shellLaunchConfig.executable,args:R.shellLaunchConfig.args,cwd:typeof R.shellLaunchConfig.cwd=="string"||typeof R.shellLaunchConfig.cwd>"u"?R.shellLaunchConfig.cwd:y.URI.revive(D.transformIncoming(R.shellLaunchConfig.cwd)),env:R.shellLaunchConfig.env,useShellEnvironment:R.shellLaunchConfig.useShellEnvironment,reconnectionProperties:R.shellLaunchConfig.reconnectionProperties,type:R.shellLaunchConfig.type,isFeatureTerminal:R.shellLaunchConfig.isFeatureTerminal},r=await(0,c.buildUserEnvironment)(R.resolverEnv,!!R.shellLaunchConfig.useShellEnvironment,P.language,this.g,this.h,this.m);this.h.trace("baseEnv",r);const i=V=>({uri:y.URI.revive(D.transformIncoming(V.uri)),name:V.name,index:V.index,toResource:()=>{throw new Error("Not implemented")}}),n=R.workspaceFolders.map(i),o=R.activeWorkspaceFolder?i(R.activeWorkspaceFolder):void 0,u=R.activeFileResource?y.URI.revive(D.transformIncoming(R.activeFileResource)):void 0,a=new h(r,n,u,R.resolvedVariables,this.l),s=m.createVariableResolver(o,process.env,a),C=await m.getCwd(t,E.homedir(),s,o?.uri,R.configuration["terminal.integrated.cwd"],this.h);t.cwd=C;const L=P.isWindows?"terminal.integrated.env.windows":P.isMacintosh?"terminal.integrated.env.osx":"terminal.integrated.env.linux",O=R.configuration[L],W=await m.createTerminalEnvironment(t,O,s,this.j.version,R.configuration["terminal.integrated.detectLocale"],r);if(!t.strictEnv){const V=[];for(const[he,H]of R.envVariableCollections)V.push([he,{map:(0,d.deserializeEnvironmentVariableCollection)(H)}]);const T=new Map(V);await new v.MergedEnvironmentVariableCollection(T).applyToProcessEnvironment(W,s)}this.h.debug("Terminal process launching on remote agent",{shellLaunchConfig:t,initialCwd:C,cols:R.cols,rows:R.rows,env:W});const X=(0,b.createRandomIPCHandle)();W.VSCODE_IPC_HOOK_CLI=X;const se=await this.i.createProcess(t,C,R.cols,R.rows,R.unicodeVersion,W,r,R.options,R.shouldPersistTerminal,R.workspaceId,R.workspaceName),fe={executeCommand:(V,...T)=>this.p(se,V,T,D)},ce=new I.CLIServerBase(fe,this.h,X);return this.i.onProcessExit(V=>V.id===se&&ce.dispose()),{persistentTerminalId:se,resolvedShellLaunchConfig:t}}p(D,R,t,r){let i,n;const o=new Promise((s,C)=>{i=s,n=C}),u=++this.a;this.b.set(u,{resolve:i,reject:n,uriTransformer:r});const a=(0,l.cloneAndChange)(t,s=>{if(s&&s.$mid===1)return r.transformOutgoing(s);if(s&&s instanceof y.URI)return r.transformOutgoingURI(s)});return this.c.fire({reqId:u,persistentProcessId:D,commandId:R,commandArgs:a}),o}r(D,R,t){const r=this.b.get(D);if(!r)return;this.b.delete(D);const i=(0,l.cloneAndChange)(t,n=>{if(n&&n.$mid===1)return r.uriTransformer.transformIncoming(n)});R?r.reject(i):r.resolve(i)}s(D){return this.i.getDefaultSystemShell(D)}async t(D,R,t,r){return this.i.getProfiles?.(D,R,t,r)||[]}u(){return{...process.env}}w(D,R){return this.i.getWslPath(D,R)}y(){return this.i.reduceConnectionGraceTime()}}e.RemoteTerminalChannel=g}),define(be[137],Ee([1,0,5]),function(oe,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,E.createDecorator)("remoteAgentService")}),define(be[283],Ee([1,0,9,2,13,212]),function(oe,e,E,A,l,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteFileSystemProviderClient=e.REMOTE_FILE_SYSTEM_CHANNEL_NAME=void 0,e.REMOTE_FILE_SYSTEM_CHANNEL_NAME="remoteFilesystem";class S extends w.DiskFileSystemProviderClient{static register(y,b,k){const I=y.getConnection();if(!I)return A.Disposable.None;const v=new A.DisposableStore,d=(async()=>{try{const m=await y.getRawEnvironment();m?b.registerProvider(l.Schemas.vscodeRemote,v.add(new S(m,I))):k.error("Cannot register remote filesystem provider. Remote environment doesnot exist.")}catch(m){k.error("Cannot register remote filesystem provider. Error while fetching remote environment.",(0,E.getErrorMessage)(m))}})();return v.add(b.onWillActivateFileSystemProvider(m=>{m.scheme===l.Schemas.vscodeRemote&&m.join(d)})),v}constructor(y,b){super(b.getChannel(e.REMOTE_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:y.os===3})}}e.RemoteFileSystemProviderClient=S}),define(be[86],Ee([1,0,33,14,7,8,22,167,295,296]),function(oe,e,E,A,l,w,S,P,y,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=e.CorruptZipMessage=void 0,e.CorruptZipMessage="end of central directory record signature not found";const k=new RegExp(e.CorruptZipMessage);class I extends Error{constructor(r,i){let n=i.message;switch(r){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n),this.type=r,this.cause=i}}e.ExtractError=I;function v(t){const r=t.externalFileAttributes>>16||33188;return[448,56,7].map(i=>r&i).reduce((i,n)=>i+n,r&61440)}function d(t){if(t instanceof I)return t;let r;return k.test(t.message)&&(r="CorruptZip"),new I(r,t)}function m(t,r,i,n,o,u){const a=l.dirname(r),s=l.join(n,a);if(!s.startsWith(n))return Promise.reject(new Error(P.localize(0,null,r)));const C=l.join(n,r);let L;return u.onCancellationRequested(()=>{L?.destroy()}),Promise.resolve(S.Promises.mkdir(s,{recursive:!0})).then(()=>new Promise((O,W)=>{if(!u.isCancellationRequested)try{L=(0,E.createWriteStream)(C,{mode:i}),L.once("close",()=>O()),L.once("error",W),t.once("error",W),t.pipe(L)}catch(X){W(X)}}))}function p(t,r,i,n){let o=(0,A.createCancelablePromise)(()=>Promise.resolve()),u=0;return n.onCancellationRequested(()=>{o.cancel(),t.close()}),new Promise((a,s)=>{const C=new A.Sequencer,L=O=>{O.isCancellationRequested||(u++,t.readEntry())};t.once("error",s),t.once("close",()=>o.then(()=>{n.isCancellationRequested||t.entryCount===u?a():s(new I("Incomplete",new Error(P.localize(1,null,u,t.entryCount))))},s)),t.readEntry(),t.on("entry",O=>{if(n.isCancellationRequested)return;if(!i.sourcePathRegex.test(O.fileName)){L(n);return}const W=O.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(W)){const fe=l.join(r,W);o=(0,A.createCancelablePromise)(ce=>S.Promises.mkdir(fe,{recursive:!0}).then(()=>L(ce)).then(void 0,s));return}const X=h(t,O),se=v(O);o=(0,A.createCancelablePromise)(fe=>C.queue(()=>X.then(ce=>m(ce,W,se,r,i,fe).then(()=>L(fe)))).then(null,s))})})}function c(t,r=!1){return new Promise((i,n)=>{(0,y.open)(t,r?{lazyEntries:!0}:void 0,(o,u)=>{o?n(d(o)):i((0,w.assertIsDefined)(u))})})}function h(t,r){return new Promise((i,n)=>{t.openReadStream(r,(o,u)=>{o?n(d(o)):i((0,w.assertIsDefined)(u))})})}function g(t,r){return new Promise((i,n)=>{const o=new b.ZipFile;r.forEach(a=>{a.contents?o.addBuffer(typeof a.contents=="string"?Buffer.from(a.contents,"utf8"):a.contents,a.path):a.localPath&&o.addFile(a.localPath,a.path)}),o.end();const u=(0,E.createWriteStream)(t);o.outputStream.pipe(u),o.outputStream.once("error",n),u.once("error",n),u.once("finish",()=>i(t))})}e.zip=g;function f(t,r,i={},n){const o=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let u=c(t,!0);return i.overwrite&&(u=u.then(a=>S.Promises.rm(r).then(()=>a))),u.then(a=>p(a,r,{sourcePathRegex:o},n))}e.extract=f;function D(t,r){return c(t).then(i=>new Promise((n,o)=>{i.on("entry",u=>{u.fileName===r&&h(i,u).then(a=>n(a),a=>o(a))}),i.once("close",()=>o(new Error(P.localize(2,null,r))))}))}function R(t,r){return D(t,r).then(i=>new Promise((n,o)=>{const u=[];i.once("error",o),i.on("data",a=>u.push(a)),i.on("end",()=>n(Buffer.concat(u)))}))}e.buffer=R}),define(be[284],Ee([1,0,14,9,2,13,3,20,50,8,21,22,86,24,25,30,35,76,16,10]),function(oe,e,E,A,l,w,S,P,y,b,k,I,v,d,m,p,c,h,g,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let D=class ki extends l.Disposable{constructor(t,r,i,n,o,u){super(),this.h=r,this.i=i,this.j=n,this.k=o,this.l=u,this.extensionsDownloadDir=t.extensionsDownloadLocation,this.f=20,this.g=this.u()}async download(t,r){await this.g;const i=(0,P.joinPath)(this.extensionsDownloadDir,this.v(t));try{await this.r(t,i,o=>this.i.download(t,o,r))}catch(o){throw new p.ExtensionManagementError(o.message,p.ExtensionManagementErrorCode.Download)}let n="Unverified";if(this.m(t)){const o=await this.n(t);try{await this.k.verify(i.fsPath,o.fsPath,this.l.getLevel()===f.LogLevel.Trace)&&(n="Verified"),this.l.info(`Extension signature verification: ${t.identifier.id}. Verification status: ${n}.`)}catch(u){const a=u,s=a.code;if(a.output&&this.l.trace(`Extension signature verification details for ${t.identifier.id} ${t.version}:
${a.output}`),s==="UnknownError")n="UnknownError",this.l.warn(`Extension signature verification: ${t.identifier.id}. Verification status: ${n}.`);else{if(s==="PackageIsInvalidZip"||s==="SignatureArchiveIsInvalidZip")throw new p.ExtensionManagementError(v.CorruptZipMessage,p.ExtensionManagementErrorCode.CorruptZip);if(!a.didExecute)this.l.warn(`Extension signature verification: ${t.identifier.id}. Verification status: ${n} (${s})`);else throw await this.delete(i),new p.ExtensionManagementError(s,p.ExtensionManagementErrorCode.Signature)}}finally{try{await this.delete(o)}catch(u){this.l.error(u)}}}return{location:i,verificationStatus:n}}m(t){if(!t.isSigned)return!1;const r=this.j.getValue("extensions.verifySignature");return(0,b.isBoolean)(r)?r:!0}async n(t){await this.g;const r=(0,P.joinPath)(this.extensionsDownloadDir,`${this.v(t)}${ki.c}`);return await this.r(t,r,i=>this.i.downloadSignatureArchive(t,i)),r}async r(t,r,i){if(await this.h.exists(r))return;if(r.scheme!==w.Schemas.file){await i(r);return}const n=(0,P.joinPath)(this.extensionsDownloadDir,`.${(0,k.generateUuid)()}`);await this.h.exists(n)||await i(n);try{await this.t(n,r,Date.now()+2*60*1e3)}catch(o){try{await this.h.del(n)}catch{}if(o.code==="ENOTEMPTY")this.l.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",t.identifier.id,r.path);else throw this.l.info(`Rename failed because of ${(0,A.getErrorMessage)(o)}. Deleted the file from downloaded location`,n.path),o}}async delete(t){await this.g,await this.h.del(t)}async t(t,r,i){try{await I.Promises.rename(t.fsPath,r.fsPath)}catch(n){if(S.isWindows&&n&&n.code==="EPERM"&&Date.now()<i)return this.l.info(`Failed renaming ${t} to ${r} with 'EPERM' error. Trying again...`),this.t(t,r,i);throw n}}async u(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.l.trace("Extension VSIX downloads cache dir does not exist");return}const t=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(t.children){const r=[],i=[],n=[];for(const a of t.children)if(a.name.endsWith(ki.c))n.push(a.resource);else{const s=c.ExtensionKey.parse(a.name);s&&i.push([s,a])}const o=(0,c.groupByExtension)(i,([a])=>a),u=[];for(const a of o)a.sort((s,C)=>y.rcompare(s[0].version,C[0].version)),r.push(...a.slice(1).map(s=>s[1].resource)),u.push(a[0][1]);u.sort((a,s)=>a.mtime-s.mtime),r.push(...u.slice(0,Math.max(0,u.length-this.f)).map(a=>a.resource)),r.push(...n),await E.Promises.settled(r.map(a=>(this.l.trace("Deleting from cache",a.path),this.h.del(a))))}}catch(t){this.l.error(t)}}v(t){return this.f?c.ExtensionKey.create(t).toString().toLowerCase():(0,k.generateUuid)()}};D.c=".sigzip",D=Te([Ae(0,m.INativeEnvironmentService),Ae(1,g.IFileService),Ae(2,p.IExtensionGalleryService),Ae(3,d.IConfigurationService),Ae(4,h.IExtensionSignatureVerificationService),Ae(5,f.ILogService)],D),e.ExtensionsDownloader=D}),define(be[285],Ee([1,0,86,177]),function(oe,e,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function l(w){return(0,E.buffer)(w,"extension/package.json").then(S=>{try{return JSON.parse(S.toString("utf8"))}catch{throw new Error((0,A.localize)(0,null))}})}e.getManifest=l}),define(be[138],Ee([1,0,14,15,19,39,9,6,2,27,13,7,3,20,50,8,4,21,22,86,176,75,25,251,30,35,44,55,284,252,285,227,236,34,73,16,5,10,26,31,36,32]),function(oe,e,E,A,l,w,S,P,y,b,k,I,v,d,m,p,c,h,g,f,D,R,t,r,i,n,o,u,a,s,C,L,O,W,X,se,fe,ce,V,T,z,he){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstallGalleryExtensionTask=e.ExtensionsScanner=e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,fe.refineServiceDecorator)(i.IExtensionManagementService);let H=class extends r.AbstractExtensionManagementService{constructor(B,N,U,G,te,le,j,K,Q,x,_,Y){super(B,N,U,x,Y),this.Z=te,this.ab=le,this.bb=j,this.cb=Q,this.db=_,this.X=this.B(new P.Emitter),this.onDidUpdateExtensionMetadata=this.X.event,this.Y=new Map,this.lb=new b.ResourceSet;const Z=this.B(K.createInstance(s.ExtensionsLifecycle));this.S=this.B(K.createInstance(q,ve=>Z.postUninstall(ve))),this.U=this.B(new L.ExtensionsManifestCache(G,this)),this.W=this.B(K.createInstance(a.ExtensionsDownloader));const ae=this.B(new O.ExtensionsWatcher(this,this.Z,Y,le,_,Q,U));this.B(ae.onDidChangeExtensionsByAnotherSource(ve=>this.kb(ve))),this.mb()}getTargetPlatform(){return this.eb||(this.eb=(0,n.computeTargetPlatform)(this.cb,this.v)),this.eb}async zip(B){this.v.trace("ExtensionManagementService#zip",B.identifier.id);const N=await this.jb(B),U=await(0,f.zip)((0,d.joinPath)(this.W.extensionsDownloadDir,(0,h.generateUuid)()).fsPath,N);return c.URI.file(U)}async unzip(B){return this.v.trace("ExtensionManagementService#unzip",B.toString()),(await this.install(B)).identifier}async getManifest(B){const{location:N,cleanup:U}=await this.fb(B),G=I.resolve(N.fsPath);try{return await(0,C.getManifest)(G)}finally{await U()}}getInstalled(B,N=this.y.defaultProfile.extensionsResource){return this.S.scanExtensions(B??null,N)}scanAllUserInstalledExtensions(){return this.S.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(B){return this.S.scanUserExtensionAtLocation(B)}async install(B,N={}){this.v.trace("ExtensionManagementService#install",B.toString());const{location:U,cleanup:G}=await this.fb(B);try{const te=await(0,C.getManifest)(I.resolve(U.fsPath));if(te.engines&&te.engines.vscode&&!(0,X.isEngineValid)(te.engines.vscode,this.w.version,this.w.date))throw new Error(D.localize(0,null,(0,n.getGalleryExtensionId)(te.publisher,te.name),this.w.version));return await this.z(te,U,N)}finally{await G()}}async installFromLocation(B,N){this.v.trace("ExtensionManagementService#installFromLocation",B.toString());const U=await this.S.scanUserExtensionAtLocation(B);if(!U)throw new Error(`Cannot find a valid extension from the location ${B.toString()}`);return await this.ob([[U,void 0]],N),this.v.info("Successfully installed extension",U.identifier.id,N.toString()),U}async installExtensionsFromProfile(B,N,U){this.v.trace("ExtensionManagementService#installExtensionsFromProfile",B,N.toString(),U.toString());const G=(await this.S.scanExtensions(1,N)).filter(te=>B.some(le=>(0,n.areSameExtensions)(le,te.identifier)));if(G.length){const te=await Promise.all(G.map(le=>this.S.scanMetadata(le,N)));await this.ob(G.map((le,j)=>[le,te[j]]),U),this.v.info("Successfully installed extensions",G.map(le=>le.identifier.id),U.toString())}return G}async updateMetadata(B,N,U=this.y.defaultProfile.extensionsResource){return this.v.trace("ExtensionManagementService#updateMetadata",B.identifier.id),N.isPreReleaseVersion&&(N.preRelease=!0),N.isMachineScoped=N.isMachineScoped||void 0,N.isBuiltin=N.isBuiltin||void 0,N.pinned=N.pinned||void 0,B=await this.S.updateMetadata(B,N,U),this.U.invalidate(),this.X.fire(B),B}async reinstallFromGallery(B){if(this.v.trace("ExtensionManagementService#reinstallFromGallery",B.identifier.id),!this.t.isEnabled())throw new Error(D.localize(1,null));const N=await this.getTargetPlatform(),[U]=await this.t.getExtensions([{...B.identifier,preRelease:B.preRelease}],{targetPlatform:N,compatible:!0},l.CancellationToken.None);if(!U)throw new Error(D.localize(2,null));await this.S.setUninstalled(B);try{await this.S.removeUninstalledExtension(B)}catch(G){throw new Error(D.localize(3,null,(0,w.toErrorMessage)(G)))}return this.installFromGallery(U)}copyExtensions(B,N){return this.S.copyExtensions(B,N)}markAsUninstalled(...B){return this.S.setUninstalled(...B)}async cleanUp(){this.v.trace("ExtensionManagementService#cleanUp");try{await this.S.cleanUp()}catch(B){this.v.error(B)}}async download(B,N){const{location:U}=await this.W.download(B,N);return U}async fb(B){if(B.scheme===k.Schemas.file)return{location:B,async cleanup(){}};this.v.trace("Downloading extension from",B.toString());const N=(0,d.joinPath)(this.W.extensionsDownloadDir,(0,h.generateUuid)());return await this.bb.download(B,N),this.v.info("Downloaded extension to",N.toString()),{location:N,cleanup:async()=>{try{await this.cb.del(N)}catch(G){this.v.error(G)}}}}P(){return this.y.defaultProfile.extensionsResource}Q(B,N,U){if(c.URI.isUri(N))return new ie(B,N,U,this.t,this.S,this.db,this.y,this.Z,this.ab,this.v);const G=n.ExtensionKey.create(N).toString();let te=this.Y.get(G);return te||(this.Y.set(G,te=new ee(B,N,U,this.W,this.S,this.db,this.y,this.Z,this.ab,this.v)),te.waitUntilTaskIsFinished().then(()=>this.Y.delete(G))),te}R(B,N){return new me(B,N.profileLocation,this.ab)}async jb(B){const N=async G=>{let te=await g.Promises.readdir(G);te=te.map(K=>I.join(G,K));const le=await Promise.all(te.map(K=>g.Promises.stat(K)));let j=Promise.resolve([]);return le.forEach((K,Q)=>{const x=te[Q];K.isFile()&&(j=j.then(_=>[..._,x])),K.isDirectory()&&(j=j.then(_=>N(x).then(Y=>[..._,...Y])))}),j};return(await N(B.location.fsPath)).map(G=>({path:`extension/${I.relative(B.location.fsPath,G)}`,localPath:G}))}async kb({added:B,removed:N}){if(N)for(const U of N.extensions)this.v.info("Extensions removed from another source",U.id,N.profileLocation.toString()),this.p.fire({identifier:U,profileLocation:N.profileLocation});if(B){const G=(await this.S.scanExtensions(1,B.profileLocation)).filter(te=>B.extensions.some(le=>(0,n.areSameExtensions)(le,te.identifier)));this.m.fire(G.map(te=>(this.v.info("Extensions added from another source",te.identifier.id,B.profileLocation.toString()),{identifier:te.identifier,local:te,profileLocation:B.profileLocation,operation:1})))}}async mb(){this.B(this.S.onExtract(N=>this.lb.add(N)));const B=await this.cb.resolve(this.Z.userExtensionsLocation);for(const N of B.children??[])N.isDirectory&&this.lb.add(N.resource);this.B(this.cb.watch(this.Z.userExtensionsLocation)),this.B(this.cb.onDidFilesChange(N=>this.nb(N)))}async nb(B){if(!B.affects(this.Z.userExtensionsLocation,1))return;const N=[];for(const U of B.rawAdded){if(this.lb.has(U)||!this.db.extUri.isEqual(this.db.extUri.dirname(U),this.Z.userExtensionsLocation)||this.db.extUri.isEqual(U,this.db.extUri.joinPath(this.Z.userExtensionsLocation,".obsolete"))||this.db.extUri.basename(U).startsWith(".")||!(await this.cb.stat(U)).isDirectory)continue;const G=await this.S.scanUserExtensionAtLocation(U);G&&G.installedTimestamp===void 0&&(this.lb.add(U),N.push(G))}N.length&&(await this.ob(N.map(U=>[U,void 0]),this.y.defaultProfile.extensionsResource),this.v.info("Added extensions to default profile from external source",N.map(U=>U.identifier.id)))}async ob(B,N){const U=B.map(G=>G[0]);await this.pb(U),await this.ab.addExtensionsToProfile(B,N),this.m.fire(U.map(G=>({local:G,identifier:G.identifier,operation:1,profileLocation:N})))}async pb(B){const N=await this.S.getUninstalledExtensions();for(const U of B){const G=n.ExtensionKey.create(U);!N[G.toString()]||(this.v.trace("Removing the extension from uninstalled list:",G.id),await this.S.setInstalled(G),this.v.info("Removed the extension from uninstalled list:",G.id))}}};H=Te([Ae(0,i.IExtensionGalleryService),Ae(1,T.ITelemetryService),Ae(2,ce.ILogService),Ae(3,t.INativeEnvironmentService),Ae(4,u.IExtensionsScannerService),Ae(5,o.IExtensionsProfileScannerService),Ae(6,R.IDownloadService),Ae(7,fe.IInstantiationService),Ae(8,se.IFileService),Ae(9,V.IProductService),Ae(10,z.IUriIdentityService),Ae(11,he.IUserDataProfilesService)],H),e.ExtensionManagementService=H;let q=class extends y.Disposable{constructor(B,N,U,G,te,le){super(),this.k=B,this.l=N,this.m=U,this.n=G,this.p=te,this.s=le,this.h=this.B(new P.Emitter),this.onExtract=this.h.event,this.j=Promise.resolve(),this.c=(0,d.joinPath)(this.m.userExtensionsLocation,".obsolete"),this.g=new E.Queue}async cleanUp(){await this.z(),this.j=this.j.then(()=>this.C()),await this.j}async scanExtensions(B,N){const U={includeInvalid:!0,profileLocation:N};let G=[];return B===null||B===0?G.push(...await this.m.scanAllExtensions({includeInvalid:!0},U,!1)):B===1&&G.push(...await this.m.scanUserExtensions(U)),G=B!==null?G.filter(te=>te.type===B):G,Promise.all(G.map(te=>this.y(te)))}async scanAllUserExtensions(B){const N=await this.m.scanUserExtensions({includeAllVersions:!B,includeInvalid:!0});return Promise.all(N.map(U=>this.y(U)))}async scanUserExtensionAtLocation(B){try{const N=await this.m.scanExistingExtension(B,1,{includeInvalid:!0});if(N)return await this.y(N)}catch(N){this.s.error(N)}return null}async extractUserExtension(B,N,U,G){await this.j.catch(()=>{});const te=B.toString(),le=I.join(this.m.userExtensionsLocation.fsPath,`.${(0,h.generateUuid)()}`),j=I.join(this.m.userExtensionsLocation.fsPath,te);try{await g.Promises.rm(j)}catch{throw new i.ExtensionManagementError(D.localize(4,null,j,B.id),i.ExtensionManagementErrorCode.Delete)}await this.u(B,N,le,G),await this.m.updateMetadata(c.URI.file(le),U);try{this.h.fire(c.URI.file(j)),await this.v(B,le,j,Date.now()+2*60*1e3),this.s.info("Renamed to",j)}catch(K){try{await g.Promises.rm(le)}catch{}if(K.code==="ENOTEMPTY")this.s.info("Rename failed because extension was installed by another source. So ignoring renaming.",B.id);else throw this.s.info(`Rename failed because of ${(0,S.getErrorMessage)(K)}. Deleted from extracted location`,le),K}return this.w(c.URI.file(j),1)}async scanMetadata(B,N){return N?(await this.n.scanProfileExtensions(N)).find(G=>(0,n.areSameExtensions)(G.identifier,B.identifier))?.metadata:this.m.scanMetadata(B.location)}async updateMetadata(B,N,U){return U?await this.n.updateMetadata([[B,N]],U):await this.m.updateMetadata(B.location,N),this.w(B.location,B.type)}getUninstalledExtensions(){return this.t()}async setUninstalled(...B){const N=B.map(U=>n.ExtensionKey.create(U));await this.t(U=>N.forEach(G=>{U[G.toString()]=!0,this.s.info("Marked extension as uninstalled",G.toString())}))}async setInstalled(B){await this.t(N=>delete N[B.toString()])}async removeExtension(B,N){this.s.trace(`Deleting ${N} extension from disk`,B.identifier.id,B.location.fsPath);const U=this.p.extUri.joinPath(this.p.extUri.dirname(B.location),`.${(0,h.generateUuid)()}`);await this.v(B.identifier,B.location.fsPath,U.fsPath,Date.now()+2*60*1e3),await this.l.del(U,{recursive:!0}),this.s.info("Deleted from disk",B.identifier.id,B.location.fsPath)}async removeUninstalledExtension(B){await this.removeExtension(B,"uninstalled"),await this.t(N=>delete N[n.ExtensionKey.create(B).toString()])}async copyExtensions(B,N){const U=await this.scanExtensions(1,B),G=await Promise.all(U.filter(te=>!te.isApplicationScoped).map(async te=>[te,await this.scanMetadata(te,B)]));await this.n.addExtensionsToProfile(G,N)}async t(B){return this.g.queue(async()=>{let N;try{N=(await this.l.readFile(this.c,"utf8")).value.toString()}catch(G){if((0,se.toFileOperationResult)(G)!==1)throw G}let U={};if(N)try{U=JSON.parse(N)}catch{}return B&&(B(U),Object.keys(U).length?await this.l.writeFile(this.c,A.VSBuffer.fromString(JSON.stringify(U))):await this.l.del(this.c)),U})}async u(B,N,U,G){this.s.trace(`Started extracting the extension from ${N} to ${U}`);try{await g.Promises.rm(U)}catch(te){throw new i.ExtensionManagementError(this.D(te).message,i.ExtensionManagementErrorCode.Delete)}try{await(0,f.extract)(N,U,{sourcePath:"extension",overwrite:!0},G),this.s.info(`Extracted extension to ${U}:`,B.id)}catch(te){try{await g.Promises.rm(U)}catch{}let le=i.ExtensionManagementErrorCode.Extract;throw te instanceof f.ExtractError&&(te.type==="CorruptZip"?le=i.ExtensionManagementErrorCode.CorruptZip:te.type==="Incomplete"&&(le=i.ExtensionManagementErrorCode.IncompleteZip)),new i.ExtensionManagementError(te.message,le)}}async v(B,N,U,G){try{await g.Promises.rename(N,U)}catch(te){if(v.isWindows&&te&&te.code==="EPERM"&&Date.now()<G)return this.s.info(`Failed renaming ${N} to ${U} with 'EPERM' error. Trying again...`,B.id),this.v(B,N,U,G);throw new i.ExtensionManagementError(te.message||D.localize(5,null,N,U),te.code||i.ExtensionManagementErrorCode.Rename)}}async w(B,N){const U=await this.m.scanExistingExtension(B,N,{includeInvalid:!0});if(U)return this.y(U);throw new Error(D.localize(6,null,B.path))}async y(B){const N=await this.l.resolve(B.location);let U,G;return N.children&&(U=N.children.find(({name:te})=>/^readme(\.txt|\.md|)$/i.test(te))?.resource,G=N.children.find(({name:te})=>/^changelog(\.txt|\.md|)$/i.test(te))?.resource),{identifier:B.identifier,type:B.type,isBuiltin:B.isBuiltin||!!B.metadata?.isBuiltin,location:B.location,manifest:B.manifest,targetPlatform:B.targetPlatform,validations:B.validations,isValid:B.isValid,readmeUrl:U,changelogUrl:G,publisherDisplayName:B.metadata?.publisherDisplayName||null,publisherId:B.metadata?.publisherId||null,isApplicationScoped:!!B.metadata?.isApplicationScoped,isMachineScoped:!!B.metadata?.isMachineScoped,isPreReleaseVersion:!!B.metadata?.isPreReleaseVersion,preRelease:!!B.metadata?.preRelease,installedTimestamp:B.metadata?.installedTimestamp,updated:!!B.metadata?.updated,pinned:!!B.metadata?.pinned}}async z(){const B=await this.getUninstalledExtensions();this.s.debug("Removing uninstalled extensions:",Object.keys(B));const N=await this.m.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),U=new Set;for(const te of N)B[n.ExtensionKey.create(te).toString()]||U.add(te.identifier.id.toLowerCase());try{const te=(0,n.groupByExtension)(N,le=>le.identifier);await E.Promises.settled(te.map(async le=>{const j=le.sort((K,Q)=>m.rcompare(K.manifest.version,Q.manifest.version))[0];U.has(j.identifier.id.toLowerCase())||await this.k(await this.y(j))}))}catch(te){this.s.error(te)}const G=N.filter(te=>te.metadata&&B[n.ExtensionKey.create(te).toString()]);await Promise.allSettled(G.map(te=>this.removeUninstalledExtension(te)))}async C(){this.s.trace("ExtensionManagementService#removeGeneratedFolders");const B=[];let N;try{N=await this.l.resolve(this.m.userExtensionsLocation)}catch(U){(0,se.toFileOperationResult)(U)!==1&&this.s.error(U)}for(const U of N?.children??[])U.isDirectory&&U.name.startsWith(".")&&(0,h.isUUID)(U.name.substring(1))&&B.push((async()=>{this.s.trace("Deleting the generated extension folder",U.resource.toString());try{await this.l.del(U.resource,{recursive:!0}),this.s.info("Deleted the generated extension folder",U.resource.toString())}catch(G){this.s.error(G)}})());await Promise.allSettled(B)}D(B){const N=Array.isArray(B)?B:[B];return N.length===1?N[0]instanceof Error?N[0]:new Error(N[0]):N.reduce((U,G)=>new Error(`${U.message}${U.message?",":""}${G instanceof Error?G.message:G}`),new Error(""))}};q=Te([Ae(1,se.IFileService),Ae(2,u.IExtensionsScannerService),Ae(3,o.IExtensionsProfileScannerService),Ae(4,z.IUriIdentityService),Ae(5,ce.ILogService)],q),e.ExtensionsScanner=q;class M extends r.AbstractExtensionTask{get verificationStatus(){return this.j}get operation(){return(0,p.isUndefined)(this.l.operation)?this.k:this.l.operation}constructor(B,N,U,G,te,le,j,K,Q){super(),this.identifier=B,this.source=N,this.l=U,this.m=G,this.n=te,this.o=le,this.p=j,this.q=K,this.s=Q,this.j="Unverified",this.k=2}async h(B){const[N,U]=await this.x(B);return this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.l.profileLocation)&&await this.p.initializeDefaultProfileExtensions(),await this.q.addExtensionsToProfile([[N,U]],this.l.profileLocation),N}async u({zipPath:B,key:N,metadata:U},G){let te=await this.v(N);return te||(this.s.trace("Extracting extension...",N.id),te=await this.m.extractUserExtension(N,B,U,G),this.s.info("Extracting extension completed.",N.id)),te}async v(B){return await this.w(B)?(this.s.trace("Removing the extension from uninstalled list:",B.id),await this.m.setInstalled(B),this.s.info("Removed the extension from uninstalled list:",B.id),(await this.m.scanAllUserExtensions(!0)).find(G=>n.ExtensionKey.create(G).equals(B))):void 0}async w(B){return!!(await this.m.getUninstalledExtensions())[B.toString()]}}class ee extends M{constructor(B,N,U,G,te,le,j,K,Q,x){super(N.identifier,N,U,te,le,j,K,Q,x),this.y=B,this.z=N,this.A=G}async x(B){const U=(await this.m.scanExtensions(null,this.l.profileLocation)).find(j=>(0,n.areSameExtensions)(j.identifier,this.z.identifier));U&&(this.k=3);const G={id:this.z.identifier.uuid,publisherId:this.z.publisherId,publisherDisplayName:this.z.publisherDisplayName,targetPlatform:this.z.properties.targetPlatform,isApplicationScoped:(0,W.isApplicationScopedExtension)(this.y),isMachineScoped:this.l.isMachineScoped||U?.isMachineScoped,isBuiltin:this.l.isBuiltin||U?.isBuiltin,isSystem:U?.type===0?!0:void 0,updated:!!U,isPreReleaseVersion:this.z.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.l.installGivenVersion?!0:void 0,preRelease:this.z.properties.isPreReleaseVersion||((0,p.isBoolean)(this.l.installPreReleaseVersion)?this.l.installPreReleaseVersion:U?.preRelease)};if(U?.manifest.version===this.z.version)return[await this.m.updateMetadata(U,G),G];const{location:te,verificationStatus:le}=await this.A.download(this.z,this.k);try{return this.j=le,this.C(te.fsPath),[await this.u({zipPath:te.fsPath,key:n.ExtensionKey.create(this.z),metadata:G},B),G]}catch(j){try{await this.A.delete(te)}catch(K){this.s.warn("Error while deleting the downloaded file",te.toString(),(0,S.getErrorMessage)(K))}throw j}}async C(B){try{await(0,C.getManifest)(B)}catch(N){throw new i.ExtensionManagementError((0,r.joinErrors)(N).message,i.ExtensionManagementErrorCode.Invalid)}}}e.InstallGalleryExtensionTask=ee;class ie extends M{constructor(B,N,U,G,te,le,j,K,Q,x){super({id:(0,n.getGalleryExtensionId)(B.publisher,B.name)},N,U,te,le,j,K,Q,x),this.y=B,this.z=N,this.A=G}async x(B){const N=new n.ExtensionKey(this.identifier,this.y.version),G=(await this.m.scanExtensions(1,this.l.profileLocation)).find(j=>(0,n.areSameExtensions)(this.identifier,j.identifier)),te=await this.C(this.identifier.id,this.y.version,B);if(te.isApplicationScoped=(0,W.isApplicationScopedExtension)(this.y),te.isMachineScoped=this.l.isMachineScoped||G?.isMachineScoped,te.isBuiltin=this.l.isBuiltin||G?.isBuiltin,te.installedTimestamp=Date.now(),te.pinned=this.l.installGivenVersion?!0:void 0,G)if(this.k=3,N.equals(new n.ExtensionKey(G.identifier,G.manifest.version)))try{await this.m.removeExtension(G,"existing")}catch{throw new Error(D.localize(7,null,this.y.displayName||this.y.name))}else!this.l.profileLocation&&m.gt(G.manifest.version,this.y.version)&&await this.m.setUninstalled(G);else{const j=await this.v(N);if(j)try{await this.m.removeExtension(j,"existing")}catch{throw new Error(D.localize(8,null,this.y.displayName||this.y.name))}}return[await this.u({zipPath:I.resolve(this.z.fsPath),key:N,metadata:te},B),te]}async C(B,N,U){try{let[G]=await this.A.getExtensions([{id:B,version:N}],U);if(G||([G]=await this.A.getExtensions([{id:B}],U)),G)return{id:G.identifier.uuid,publisherDisplayName:G.publisherDisplayName,publisherId:G.publisherId,isPreReleaseVersion:G.properties.isPreReleaseVersion,preRelease:G.properties.isPreReleaseVersion||this.l.installPreReleaseVersion}}catch{}return{}}}class me extends r.AbstractExtensionTask{constructor(B,N,U){super(),this.extension=B,this.j=N,this.k=U}async h(B){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(be[139],Ee([1,0,79,14,15,9,2,8,24,25,80,10,230,297]),function(oe,e,E,A,l,w,S,P,y,b,k,I,v,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let m=class extends S.Disposable{constructor(c,h,g){super(),this.h=c,this.i=h,this.j=g,this.k(),this.B(c.onDidChangeConfiguration(f=>{f.affectsConfiguration("http")&&this.k()}))}k(){const c=this.h.getValue("http");this.a=c?.proxy,this.b=!!c?.proxyStrictSSL,this.f=c?.proxyAuthorization}async request(c,h){this.j.trace("RequestService#request (node) - begin",c.url);const{a:g,b:f}=this;let D;try{D=await(0,k.getResolvedShellEnv)(this.h,this.j,this.i.args,process.env)}catch(r){this.g||(this.g=!0,this.j.error("RequestService#request (node) resolving shell environment failed",r))}const R={...process.env,...D},t=c.agent?c.agent:await(0,v.getProxyAgent)(c.url||"",R,{proxyUrl:g,strictSSL:f});c.agent=t,c.strictSSL=f,this.f&&(c.headers={...c.headers||{},"Proxy-Authorization":this.f});try{const r=await this.m(c,h);return this.j.trace("RequestService#request (node) - success",c.url),r}catch(r){throw this.j.trace("RequestService#request (node) - error",c.url,r),r}}async l(c){return((0,E.parse)(c.url).protocol==="https:"?await new Promise((f,D)=>{oe(["https"],f,D)}):await new Promise((f,D)=>{oe(["http"],f,D)})).request}m(c,h){return A.Promises.withAsyncBody(async(g,f)=>{const D=(0,E.parse)(c.url),R=c.getRawRequest?c.getRawRequest(c):await this.l(c),t={hostname:D.hostname,port:D.port?parseInt(D.port):D.protocol==="https:"?443:80,protocol:D.protocol,path:D.path,method:c.type||"GET",headers:c.headers,agent:c.agent,rejectUnauthorized:(0,P.isBoolean)(c.strictSSL)?c.strictSSL:!0};c.user&&c.password&&(t.auth=c.user+":"+c.password);const r=R(t,i=>{const n=(0,P.isNumber)(c.followRedirects)?c.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)this.m({...c,url:i.headers.location,followRedirects:n-1},h).then(g,f);else{let o=i;!c.isChromiumNetwork&&i.headers["content-encoding"]==="gzip"&&(o=i.pipe((0,d.createGunzip)())),g({res:i,stream:(0,l.streamToBufferReadableStream)(o)})}});r.on("error",f),c.timeout&&r.setTimeout(c.timeout),c.isChromiumNetwork&&r.removeHeader("Content-Length"),c.data&&typeof c.data=="string"&&r.write(c.data),r.end(),h.onCancellationRequested(()=>{r.abort(),f(new w.CancellationError)})})}async resolveProxy(c){}};m=Te([Ae(0,y.IConfigurationService),Ae(1,b.INativeEnvironmentService),Ae(2,I.ILogService)],m),e.RequestService=m}),define(be[286],Ee([1,0,77,10,64,113,24,54,139,37,31,30,124,138,76,107,51,2,108,66,13,16,26,111,137,41,116,78,117,9,4,7,28,228,75,36,122,63,3,55,127,32,44,67,125,123,110]),function(oe,e,E,A,l,w,S,P,y,b,k,I,v,d,m,p,c,h,g,f,D,R,t,r,i,n,o,u,a,s,C,L,O,W,X,se,fe,ce,V,T,z,he,H,q,M,ee,ie){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.run=void 0;class me extends h.Disposable{constructor(U,G){super(),this.a=U,this.b=G,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const U=await this.f();await U.invokeFunction(async G=>{const te=G.get(A.ILogService);try{await this.g(U.createInstance(o.ExtensionManagementCLI))}catch(le){throw te.error(le),console.error((0,s.getErrorMessage)(le)),le}})}async f(){const U=new E.ServiceCollection,G={_serviceBrand:void 0,...c.default};U.set(t.IProductService,G);const te=new n.ServerEnvironmentService(this.a,G);U.set(n.IServerEnvironmentService,te);const le=new ie.LogService(new r.SpdLogLogger(i.RemoteExtensionLogFileName,(0,L.join)(te.logsPath,`${i.RemoteExtensionLogFileName}.log`),!0,!1,(0,A.getLogLevel)(te)));U.set(A.ILogService,le),le.trace(`Remote configuration data at ${this.b}`),le.trace("process arguments:",this.a);const j=this.B(new g.FileService(le));U.set(R.IFileService,j),j.registerProvider(D.Schemas.file,this.B(new f.DiskFileSystemProvider(le)));const K=new fe.UriIdentityService(j);U.set(se.IUriIdentityService,K);const Q=this.B(new M.ServerUserDataProfilesService(K,te,j,le));U.set(he.IUserDataProfilesService,Q);const x=this.B(new w.ConfigurationService(Q.defaultProfile.settingsResource,j,new q.NullPolicyService,le));return U.set(S.IConfigurationService,x),await Promise.all([x.initialize(),Q.init()]),U.set(P.IRequestService,new l.SyncDescriptor(y.RequestService)),U.set(X.IDownloadService,new l.SyncDescriptor(W.DownloadService)),U.set(k.ITelemetryService,b.NullTelemetryService),U.set(I.IExtensionGalleryService,new l.SyncDescriptor(v.ExtensionGalleryServiceWithNoStorageService)),U.set(H.IExtensionsProfileScannerService,new l.SyncDescriptor(ee.ExtensionsProfileScannerService)),U.set(T.IExtensionsScannerService,new l.SyncDescriptor(z.ExtensionsScannerService)),U.set(m.IExtensionSignatureVerificationService,new l.SyncDescriptor(m.ExtensionSignatureVerificationService)),U.set(d.INativeServerExtensionManagementService,new l.SyncDescriptor(d.ExtensionManagementService)),U.set(u.ILanguagePackService,new l.SyncDescriptor(a.NativeLanguagePackService)),new p.InstantiationService(U)}async g(U){if(this.a["list-extensions"])return U.listExtensions(!!this.a["show-versions"],this.a.category);if(this.a["install-extension"]||this.a["install-builtin-extension"]){const G={isMachineScoped:!!this.a["do-not-sync"],installPreReleaseVersion:!!this.a["pre-release"]};return U.installExtensions(this.h(this.a["install-extension"]||[]),this.a["install-builtin-extension"]||[],G,!!this.a.force)}else{if(this.a["uninstall-extension"])return U.uninstallExtensions(this.h(this.a["uninstall-extension"]),!!this.a.force);if(this.a["locate-extension"])return U.locateExtension(this.a["locate-extension"])}}h(U){return U.map(G=>/\.vsix$/i.test(G)?C.URI.file((0,L.isAbsolute)(G)?G:(0,L.join)((0,O.cwd)(),G)):G)}}function ne(N){setTimeout(()=>process.exit(N),0)}async function B(N,U,G){if(N.help){const le=c.default.serverApplicationName+(V.isWindows?".cmd":"");console.log((0,ce.buildHelpMessage)(c.default.nameLong,le,c.default.version,G,{noInputFiles:!0,noPipe:!0}));return}if(N.version){console.log((0,ce.buildVersionMessage)(c.default.version,c.default.commit));return}const te=new me(N,U);try{await te.run(),ne(0)}catch{ne(1)}finally{te.dispose()}}e.run=B}),define(be[287],Ee([1,0,29,6,2,13,7,96,22,43,24,113,74,258,199,75,200,210,219,25,124,30,76,116,211,138,16,108,66,64,107,77,78,117,10,51,26,54,229,139,115,31,37,243,121,250,36,122,264,265,234,240,282,68,41,271,137,283,126,55,127,44,32,259,67,241,222,4,125,123,110,109,193,278,226,254]),function(oe,e,E,A,l,w,S,P,y,b,k,I,v,d,m,p,c,h,g,f,D,R,t,r,i,n,o,u,a,s,C,L,O,W,X,se,fe,ce,V,T,z,he,H,q,M,ee,ie,me,ne,B,N,U,G,te,le,j,K,Q,x,_,Y,Z,ae,ve,Pe,ke,Me,je,ge,we,ye,Fe,$e,tt,Ve,Je){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SocketServer=e.setupServerServices=void 0;const Xe="monacoworkbench";async function _e(We,qe,Ge,et){const Ye=new L.ServiceCollection,Qe=new De,ot={_serviceBrand:void 0,...se.default};Ye.set(fe.IProductService,ot);const rt=new le.ServerEnvironmentService(qe,ot);Ye.set(f.IEnvironmentService,rt),Ye.set(f.INativeEnvironmentService,rt);const Lt=new Me.LoggerService((0,X.getLogLevel)(rt));Ye.set(X.ILoggerService,Lt),Qe.registerChannel("logger",new Fe.LoggerChannel(Lt,de=>ue(de.remoteAuthority)));const Ut=Lt.createLogger(je.URI.file(S.join(rt.logsPath,`${K.RemoteExtensionLogFileName}.log`)),{id:"remoteServerLog",name:(0,$e.localize)(0,null)}),lt=new ye.LogService(Ut,[new Re((0,X.getLogLevel)(rt))]);Ye.set(X.ILogService,lt),setTimeout(()=>ze(rt.logsPath).then(null,de=>lt.error(de)),1e4),lt.trace(`Remote configuration data at ${Ge}`),lt.trace("process arguments:",rt.args),Array.isArray(ot.serverGreeting)&&lt.info(`

${ot.serverGreeting.join(`
`)}

`),Qe.registerChannel(m.ExtensionHostDebugBroadcastChannel.ChannelName,new m.ExtensionHostDebugBroadcastChannel);const Ot=new b.StaticRouter(de=>de.clientId==="renderer"),ht=et.add(new u.FileService(lt));Ye.set(o.IFileService,ht),ht.registerProvider(w.Schemas.file,et.add(new a.DiskFileSystemProvider(lt)));const Nt=new me.UriIdentityService(ht);Ye.set(ie.IUriIdentityService,Nt);const pt=new I.ConfigurationService(rt.machineSettingsResource,ht,new Pe.NullPolicyService,lt);Ye.set(k.IConfigurationService,pt);const ft=new ge.ServerUserDataProfilesService(Nt,rt,ht,lt);Ye.set(ae.IUserDataProfilesService,ft),Qe.registerChannel("userDataProfiles",new Je.RemoteUserDataProfilesServiceChannel(ft,de=>ue(de.remoteAuthority)));const[,,Dt]=await Promise.all([pt.initialize(),ft.init(),(0,P.getMachineId)()]),Pt=new x.ExtensionHostStatusService;Ye.set(x.IExtensionHostStatusService,Pt),Ye.set(ce.IRequestService,new s.SyncDescriptor(T.RequestService));let wt=H.NullAppender;const kt=(0,H.isInternalTelemetry)(ot,pt);if((0,H.supportsTelemetry)(ot,rt)){const de=process.env.CS_TELEMETRY_URL||"https://v1.telemetry.coder.com/track";de?wt=new ke.OneDataSystemAppender(!1,Xe,null,()=>new ve.TelemetryClient(de)):ot.aiConfig&&ot.aiConfig.ariaKey&&(wt=new ke.OneDataSystemAppender(kt,Xe,null,ot.aiConfig.ariaKey)),et.add((0,l.toDisposable)(()=>wt?.flush()));const J={appenders:[wt],commonProperties:(0,z.resolveCommonProperties)(ht,(0,E.release)(),(0,E.hostname)(),process.arch,ot.commit,ot.version+"-remote",Dt,kt,rt.installSourcePath,"remoteAgent"),piiPaths:(0,H.getPiiPathsFromEnvironment)(rt)},Ce=rt.args["telemetry-level"];let Le=3;Ce==="all"?Le=3:Ce==="error"?Le=2:Ce==="crash"?Le=1:Ce!==void 0&&(Le=0),Ye.set(U.IServerTelemetryService,new s.SyncDescriptor(U.ServerTelemetryService,[J,Le]))}else Ye.set(U.IServerTelemetryService,U.ServerNullTelemetryService);Ye.set(R.IExtensionGalleryService,new s.SyncDescriptor(D.ExtensionGalleryServiceWithNoStorageService));const Bt=Qe.getChannel("download",Ot);Ye.set(p.IDownloadService,new c.DownloadServiceChannelClient(Bt,()=>ue("renderer"))),Ye.set(Z.IExtensionsProfileScannerService,new s.SyncDescriptor(we.ExtensionsProfileScannerService)),Ye.set(_.IExtensionsScannerService,new s.SyncDescriptor(Y.ExtensionsScannerService)),Ye.set(t.IExtensionSignatureVerificationService,new s.SyncDescriptor(t.ExtensionSignatureVerificationService)),Ye.set(n.INativeServerExtensionManagementService,new s.SyncDescriptor(n.ExtensionManagementService));const Se=new C.InstantiationService(Ye);Ye.set(O.ILanguagePackService,Se.createInstance(W.NativeLanguagePackService));const Ie=Se.createInstance(ee.PtyHostService,{graceTime:108e5,shortGraceTime:3e5,scrollback:pt.getValue("terminal.integrated.persistentSessionScrollback")??100},(0,$e.localize)(1,null));return Ye.set(M.IPtyService,Ie),Ye.set(h.IEncryptionMainService,new s.SyncDescriptor(g.EncryptionMainService,[Dt])),Ye.set(v.ICredentialsMainService,new s.SyncDescriptor(d.CredentialsWebMainService)),Se.invokeFunction(de=>{const J=de.get(n.INativeServerExtensionManagementService),Ce=de.get(_.IExtensionsScannerService),Le=de.get(R.IExtensionGalleryService),xe=de.get(O.ILanguagePackService),Be=new ne.RemoteAgentEnvironmentChannel(We,rt,ft,Pt);Qe.registerChannel("remoteextensionsenvironment",Be);const nt=new N.ServerTelemetryChannel(de.get(U.IServerTelemetryService),wt);Qe.registerChannel("telemetry",nt),Qe.registerChannel(j.REMOTE_TERMINAL_CHANNEL_NAME,new G.RemoteTerminalChannel(rt,lt,Ie,ot,J,pt));const at=new tt.RemoteExtensionsScannerService(Se.createInstance(r.ExtensionManagementCLI),rt,ft,Ce,lt,Le,xe);Qe.registerChannel(Ve.RemoteExtensionsScannerChannelName,new tt.RemoteExtensionsScannerChannel(at,$t=>ue($t.remoteAuthority)));const dt=new B.RemoteAgentFileSystemProviderChannel(lt,rt);Qe.registerChannel(Q.REMOTE_FILE_SYSTEM_CHANNEL_NAME,dt),Qe.registerChannel("request",new V.RequestChannel(de.get(ce.IRequestService)));const bt=new i.ExtensionManagementChannel(J,$t=>ue($t.remoteAuthority));Qe.registerChannel("extensions",bt);const ct=b.ProxyChannel.fromService(de.get(O.ILanguagePackService));Qe.registerChannel("languagePacks",ct);const mt=b.ProxyChannel.fromService(de.get(h.IEncryptionMainService));Qe.registerChannel("encryption",mt);const St=b.ProxyChannel.fromService(de.get(v.ICredentialsMainService));return Qe.registerChannel("credentials",St),J.cleanUp(),et.add(new q.default(de.get(he.ITelemetryService))),{telemetryService:de.get(he.ITelemetryService)}}),{socketServer:Qe,instantiationService:Se}}e.setupServerServices=_e;const Ke=Object.create(null);function ue(We){return Ke[We]||(Ke[We]=(0,te.createURITransformer)(We)),Ke[We]}class De extends b.IPCServer{constructor(){const qe=new A.Emitter;super(qe.event),this.b=qe}acceptConnection(qe,Ge){this.b.fire({protocol:qe,onDidClientDisconnect:Ge})}}e.SocketServer=De;class Re extends X.AbstractLogger{constructor(qe=X.DEFAULT_LOG_LEVEL){super(),this.setLevel(qe),this.g=Boolean(process.stdout.isTTY)}trace(qe,...Ge){this.f(X.LogLevel.Trace)&&(this.g?console.log(`\x1B[90m[${Ne()}]\x1B[0m`,qe,...Ge):console.log(`[${Ne()}]`,qe,...Ge))}debug(qe,...Ge){this.f(X.LogLevel.Debug)&&(this.g?console.log(`\x1B[90m[${Ne()}]\x1B[0m`,qe,...Ge):console.log(`[${Ne()}]`,qe,...Ge))}info(qe,...Ge){this.f(X.LogLevel.Info)&&(this.g?console.log(`\x1B[90m[${Ne()}]\x1B[0m`,qe,...Ge):console.log(`[${Ne()}]`,qe,...Ge))}warn(qe,...Ge){this.f(X.LogLevel.Warning)&&(this.g?console.warn(`\x1B[93m[${Ne()}]\x1B[0m`,qe,...Ge):console.warn(`[${Ne()}]`,qe,...Ge))}error(qe,...Ge){this.f(X.LogLevel.Error)&&(this.g?console.error(`\x1B[91m[${Ne()}]\x1B[0m`,qe,...Ge):console.error(`[${Ne()}]`,qe,...Ge))}dispose(){}flush(){}}function Ne(){const We=new Date;return`${Oe(We.getHours())}:${Oe(We.getMinutes())}:${Oe(We.getSeconds())}`}function Oe(We){return We<10?`0${We}`:String(We)}async function ze(We){const qe=S.basename(We),Ge=S.dirname(We),Qe=(await y.Promises.readdir(Ge)).filter(rt=>/^\d{8}T\d{6}$/.test(rt)).sort().filter(rt=>rt!==qe),ot=Qe.slice(0,Math.max(0,Qe.length-9));await Promise.all(ot.map(rt=>y.Promises.rm(S.join(Ge,rt))))}}),define(be[288],Ee([1,0,118,33,97,289,79,140,15,9,38,2,13,7,42,3,17,4,21,155,101,62,5,10,26,53,31,133,255,256,41,287,261]),function(oe,e,E,A,l,w,S,P,y,b,k,I,v,d,m,p,c,h,g,f,D,R,t,r,i,n,o,u,a,s,C,L,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createServer=void 0;const W=5*60*1e3;let X=class extends I.Disposable{constructor(V,T,z,he,H,q,M,ee){super(),this.k=V,this.l=T,this.m=z,this.n=H,this.p=q,this.r=M,this.s=ee,this.h=fe.create(this.p),this.i=(0,n.getRemoteServerRootPath)(q),this.a=Object.create(null),this.b=Object.create(null),this.f=new Set,this.g=he?this.s.createInstance(O.WebClientServer,this.l):null,this.r.info("Extension host agent started."),this.F(!0)}async handleRequest(V,T){if(V.method!=="GET")return(0,O.serveError)(V,T,405,`Unsupported method ${V.method}`);if(!V.url)return(0,O.serveError)(V,T,400,"Bad request.");const z=S.parse(V.url,!0);let he=z.pathname;if(!he)return(0,O.serveError)(V,T,400,"Bad request.");if(he.startsWith(this.i)&&he.charCodeAt(this.i.length)===47&&(he=he.substring(this.i.length)),he==="/version")return T.writeHead(200,{"Content-Type":"text/plain"}),void T.end(this.p.commit||"");if(he==="/delay-shutdown")return this.H(),T.writeHead(200),void T.end("OK");if(!(0,s.requestHasValidConnectionToken)(this.l,V,z))return(0,O.serveError)(V,T,403,"Forbidden.");if(he==="/vscode-remote-resource"){const H=z.query.path;if(typeof H!="string")return(0,O.serveError)(V,T,400,"Bad request.");let q;try{q=h.URI.from({scheme:v.Schemas.file,path:H}).fsPath}catch{return(0,O.serveError)(V,T,400,"Bad request.")}const M=Object.create(null);this.n.isBuilt&&((0,k.isEqualOrParent)(q,this.n.builtinExtensionsPath,!p.isLinux)||(0,k.isEqualOrParent)(q,this.n.extensionsPath,!p.isLinux))&&(M["Cache-Control"]="public, max-age=31536000"),M.Vary="Origin";const ee=V.headers.origin;return ee&&this.h.matches(ee)&&(M["Access-Control-Allow-Origin"]=ee),(0,O.serveFile)(q,1,this.r,V,T,M)}if(this.g){this.g.handle(V,T,z);return}return T.writeHead(404,{"Content-Type":"text/plain"}),void T.end("Not found")}handleUpgrade(V,T){let z=(0,g.generateUuid)(),he=!1,H=!1;if(V.url){const ne=S.parse(V.url,!0).query;typeof ne.reconnectionToken=="string"&&(z=ne.reconnectionToken),ne.reconnection==="true"&&(he=!0),ne.skipWebSocketFrames==="true"&&(H=!0)}if(V.headers.upgrade===void 0||V.headers.upgrade.toLowerCase()!=="websocket"){T.end("HTTP/1.1 400 Bad Request");return}const q=V.headers["sec-websocket-key"],M=E.createHash("sha1");M.update(q+"258EAFA5-E914-47DA-95CA-C5AB0DC85B11");const ee=M.digest("base64"),ie=["HTTP/1.1 101 Switching Protocols","Upgrade: websocket","Connection: Upgrade",`Sec-WebSocket-Accept: ${ee}`];let me=!1;if(!H&&!this.n.args["disable-websocket-compression"]&&V.headers["sec-websocket-extensions"]){const ne=Array.isArray(V.headers["sec-websocket-extensions"])?V.headers["sec-websocket-extensions"]:[V.headers["sec-websocket-extensions"]];for(const B of ne)if(!/\b((server_max_window_bits)|(server_no_context_takeover)|(client_no_context_takeover))\b/.test(B)){if(/\b(permessage-deflate)\b/.test(B)){me=!0,ie.push("Sec-WebSocket-Extensions: permessage-deflate");break}if(/\b(x-webkit-deflate-frame)\b/.test(B)){me=!0,ie.push("Sec-WebSocket-Extensions: x-webkit-deflate-frame");break}}}T.write(ie.join(`\r
`)+`\r
\r
`),T.setTimeout(0),T.setNoDelay(!0),H?this.v(new R.NodeSocket(T,`server-connection-${z}`),he,z):this.v(new R.WebSocketNodeSocket(new R.NodeSocket(T,`server-connection-${z}`),me,null,!0),he,z)}handleServerError(V){this.r.error("Error occurred in server"),this.r.error(V)}t(V){let T;return V instanceof R.NodeSocket?T=V.socket:T=V.socket.socket,T.remoteAddress||"<unknown>"}async u(V,T,z){const he=T.getSocket();this.r.error(`${V} ${z}.`);const H={type:"error",reason:z};T.sendControl(y.VSBuffer.fromString(JSON.stringify(H))),T.dispose(),await he.drain(),he.dispose()}v(V,T,z){const he=this.t(V),H=`[${he}][${z.substr(0,8)}]`,q=new D.PersistentProtocol({socket:V}),M=this.m?new this.m.validator:null,ee=this.m?new this.m.signer:null;let ie;(function(N){N[N.WaitingForAuth=0]="WaitingForAuth",N[N.WaitingForConnectionType=1]="WaitingForConnectionType",N[N.Done=2]="Done",N[N.Error=3]="Error"})(ie||(ie={}));let me=0;const ne=N=>{me=3,B.dispose(),this.u(H,q,N)},B=q.onControlMessage(N=>{if(me===0){let U;try{U=JSON.parse(N.toString())}catch{return ne("Malformed first message")}if(U.type!=="auth")return ne("Invalid first message");if(this.l.type===2&&!this.l.validate(U.auth))return ne("Unauthorized client refused: auth mismatch");let G=(0,g.generateUuid)();if(ee)try{G=ee.sign(U.data)}catch{}let te=(0,g.generateUuid)();if(M)try{te=M.createNewMessage(te)}catch{}const le={type:"sign",data:te,signedData:G};q.sendControl(y.VSBuffer.fromString(JSON.stringify(le))),me=1}else if(me===1){let U;try{U=JSON.parse(N.toString())}catch{return ne("Malformed second message")}if(U.type!=="connectionType")return ne("Invalid second message");if(typeof U.signedData!="string")return ne("Invalid second message field type");const G=U.commit,te=this.p.commit;if(G&&te&&G!==te)return ne("Client refused: version mismatch");let le=!1;if(!M)le=!0;else if(this.l.validate(U.signedData))le=!0;else try{le=M.validate(U.signedData)==="ok"}catch{}if(!le){if(this.n.isBuilt)return ne("Unauthorized client refused");this.r.error(`${H} Unauthorized client handshake failed but we proceed because of dev mode.`)}for(const j in this.b)this.b[j].shortenReconnectionGraceTimeIfNecessary();for(const j in this.a)this.a[j].shortenReconnectionGraceTimeIfNecessary();me=2,B.dispose(),this.w(he,H,q,V,T,z,U)}})}async w(V,T,z,he,H,q,M){const ee=M.desiredConnectionType===1?`${T}[ManagementConnection]`:M.desiredConnectionType===2?`${T}[ExtensionHostConnection]`:T;if(M.desiredConnectionType===1)if(H){if(!this.b[q])return this.f.has(q)?this.u(ee,z,"Unknown reconnection token (seen before)"):this.u(ee,z,"Unknown reconnection token (never seen)");z.sendControl(y.VSBuffer.fromString(JSON.stringify({type:"ok"})));const ie=z.readEntireBuffer();z.dispose(),this.b[q].acceptReconnection(V,he,ie)}else{if(this.b[q])return this.u(ee,z,"Duplicate reconnection token");z.sendControl(y.VSBuffer.fromString(JSON.stringify({type:"ok"})));const ie=new a.ManagementConnection(this.r,q,V,z);this.k.acceptConnection(ie.protocol,ie.onClose),this.b[q]=ie,this.f.add(q),ie.onClose(()=>{delete this.b[q]})}else if(M.desiredConnectionType===2){const ie=M.args||{language:"en"},me=await this.C(ie);if(me.port&&this.r.trace(`${ee} - startParams debug port ${me.port}`),this.r.trace(`${ee} - startParams language: ${me.language}`),this.r.trace(`${ee} - startParams env: ${JSON.stringify(me.env)}`),H){if(!this.a[q])return this.f.has(q)?this.u(ee,z,"Unknown reconnection token (seen before)"):this.u(ee,z,"Unknown reconnection token (never seen)");z.sendPause(),z.sendControl(y.VSBuffer.fromString(JSON.stringify(me.port?{debugPort:me.port}:{})));const ne=z.readEntireBuffer();z.dispose(),this.a[q].acceptReconnection(V,he,ne)}else{if(this.a[q])return this.u(ee,z,"Duplicate reconnection token");z.sendPause(),z.sendControl(y.VSBuffer.fromString(JSON.stringify(me.port?{debugPort:me.port}:{})));const ne=z.readEntireBuffer();z.dispose();const B=this.s.createInstance(u.ExtensionHostConnection,q,V,he,ne);this.a[q]=B,this.f.add(q),B.onClose(()=>{delete this.a[q],this.D()}),B.start(me)}}else if(M.desiredConnectionType===3){const ie=M.args;this.y(z,ie)}else return this.u(ee,z,"Unknown initial data received")}async y(V,T){const z=V.getSocket().socket,he=V.readEntireBuffer();V.dispose(),z.pause();const H=await this.z(T.host,T.port);he.byteLength>0&&H.write(he.buffer),H.on("end",()=>z.end()),H.on("close",()=>z.end()),H.on("error",()=>z.destroy()),z.on("end",()=>H.end()),z.on("close",()=>H.end()),z.on("error",()=>H.destroy()),H.pipe(z),z.pipe(H)}z(V,T){return new Promise((z,he)=>{const H=l.createConnection({host:V,port:T},()=>{H.removeListener("error",he),H.pause(),z(H)});H.once("error",he)})}C(V){return typeof V.port=="number"?(0,f.findFreePort)(V.port,10,5e3).then(T=>(V.port=T,V)):(V.debugId=void 0,V.port=void 0,V.break=void 0,Promise.resolve(V))}async D(){if(!this.n.args["enable-remote-auto-shutdown"])return;this.I(),!!Object.keys(this.a).length||(console.log("Last EH closed, waiting before shutting down"),this.r.info("Last EH closed, waiting before shutting down"),this.F())}F(V=!1){!this.n.args["enable-remote-auto-shutdown"]||(this.n.args["remote-auto-shutdown-without-delay"]&&!V?this.G():this.j=setTimeout(()=>{this.j=void 0,this.G()},W))}G(){if(!!Object.keys(this.a).length){console.log("New EH opened, aborting shutdown"),this.r.info("New EH opened, aborting shutdown");return}else console.log("Last EH closed, shutting down"),this.r.info("Last EH closed, shutting down"),this.dispose(),process.exit(0)}H(){this.j&&(console.log("Got delay-shutdown request while in shutdown timeout, delaying"),this.r.info("Got delay-shutdown request while in shutdown timeout, delaying"),this.I(),this.F())}I(){this.j&&(console.log("Cancelling previous shutdown timeout"),this.r.info("Cancelling previous shutdown timeout"),clearTimeout(this.j),this.j=void 0)}};X=Te([Ae(4,C.IServerEnvironmentService),Ae(5,i.IProductService),Ae(6,r.ILogService),Ae(7,t.IInstantiationService)],X);async function se(ce,V,T){const z=await(0,s.determineServerConnectionToken)(V);z instanceof s.ServerConnectionTokenParseError&&(console.warn(z.message),process.exit(1));function he(le){(0,b.setUnexpectedErrorHandler)(j=>{(0,b.isSigPipeError)(j)&&j.stack&&/unexpectedErrorHandler/.test(j.stack)||le(j)})}const H=[];he(le=>{H.push(le),console.error(le)});let q=!1;process.on("SIGPIPE",()=>{q||(q=!0,(0,b.onUnexpectedError)(new Error("Unexpected SIGPIPE")))});const M=new I.DisposableStore,{socketServer:ee,instantiationService:ie}=await(0,L.setupServerServices)(z,V,T,M);ie.invokeFunction(le=>{const j=le.get(r.ILogService);H.forEach(K=>j.error(K)),H.length=0,he(K=>j.error(K))}),ie.invokeFunction(le=>{const j=le.get(r.ILogService);if(process.platform==="win32"&&process.env.HOMEDRIVE&&process.env.HOMEPATH){const K=(0,d.join)(process.env.HOMEDRIVE,"node_modules"),Q=(0,d.dirname)((0,d.join)(process.env.HOMEDRIVE,process.env.HOMEPATH)),x=(0,d.join)(Q,"node_modules");if(A.existsSync(K)||A.existsSync(x)){const _=`

*
* !!!! Server terminated due to presence of CVE-2020-1416 !!!!
*
* Please remove the following directories and re-try
* ${K}
* ${x}
*
* For more information on the vulnerability https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2020-1416
*

`;j.warn(_),console.warn(_),process.exit(0)}}});const me=ie.invokeFunction(le=>{const j=le.get(r.ILogService);if(A.existsSync((0,d.join)(v.FileAccess.asFileUri("").fsPath,"../node_modules/vsda")))try{return globalThis._VSCODE_NODE_MODULES.vsda}catch(Q){j.error(Q)}return null}),ne=A.existsSync(v.FileAccess.asFileUri("vs/code/browser/workbench/workbench.html").fsPath);if(ne&&ce&&typeof ce!="string"){const le=z.type!==0?`?${v.connectionTokenQueryName}=${z.value}`:"";console.log(`Web UI available at http://localhost${ce.port===80?"":`:${ce.port}`}/${le}`)}const B=ie.createInstance(X,ee,z,me,ne);m.mark("code/server/ready");const N=w.performance.now(),U=global.vscodeServerStartTime,G=global.vscodeServerListenTime,te=global.vscodeServerCodeLoadedTime;if(ie.invokeFunction(le=>{le.get(o.ITelemetryService).publicLog2("serverStart",{startTime:U,startedTime:G,codeLoadedTime:te,readyTime:N})}),V["print-startup-performance"]){const le=P.LoaderStats.get();let j="";j+=`

### Load AMD-module
`,j+=P.LoaderStats.toMarkdownTable(["Module","Duration"],le.amdLoad),j+=`

### Load commonjs-module
`,j+=P.LoaderStats.toMarkdownTable(["Module","Duration"],le.nodeRequire),j+=`

### Invoke AMD-module factory
`,j+=P.LoaderStats.toMarkdownTable(["Module","Duration"],le.amdInvoke),j+=`

### Invoke commonjs-module
`,j+=P.LoaderStats.toMarkdownTable(["Module","Duration"],le.nodeEval),j+=`Start-up time: ${G-U}
`,j+=`Code loading time: ${te-U}
`,j+=`Initialized time: ${N-U}
`,j+=`
`,console.log(j)}return B}e.createServer=se;class fe{static create(V){const T=V.webEndpointUrlTemplate,z=V.commit,he=V.quality;if(!T||!z||!he)return new fe(null);const H=(0,g.generateUuid)(),M=new URL(T.replace("{{uuid}}",H).replace("{{commit}}",z).replace("{{quality}}",he)).origin,ee=(0,c.escapeRegExpCharacters)(M).replace(H,"[a-zA-Z0-9\\-]+");try{const ie=(0,c.createRegExp)(`^${ee}$`,!0,{matchCase:!1});return new fe(ie)}catch{return new fe(null)}}constructor(V){this.a=V}matches(V){return this.a?this.a.test(V):!1}}}),define(be[298],Ee([1,0,29,33,13,286,288,63,7,289,41,51,42]),function(oe,e,E,A,l,w,S,P,y,b,k,I,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createServer=e.spawnCli=void 0,v.mark("code/server/codeLoaded"),global.vscodeServerCodeLoadedTime=b.performance.now();const d={onMultipleValues:(g,f)=>{console.error(`Option '${g}' can only be defined once. Using value ${f}.`)},onEmptyValue:g=>{console.error(`Ignoring option '${g}': Value must not be empty.`)},onUnknownOption:g=>{console.error(`Ignoring option '${g}': not supported for server.`)},onDeprecatedOption:(g,f)=>{console.warn(`Option '${g}' is deprecated: ${f}`)}};function m(){return(0,P.parseArgs)(process.argv.slice(2),k.serverOptions,d)}function p(g){const f=g["server-data-dir"]||g["user-data-dir"]||process.env.VSCODE_AGENT_FOLDER||(0,y.join)(E.homedir(),I.default.serverDataFolderName||".vscode-remote"),D=g["user-data-dir"]||(0,y.join)(f,"data"),R=(0,y.join)(D,"User"),t=(0,y.join)(R,"globalStorage"),r=(0,y.join)(R,"History"),i=(0,y.join)(D,"Machine");g["user-data-dir"]=D;const n=(0,y.dirname)(l.FileAccess.asFileUri("").fsPath),o=g["builtin-extensions-dir"]||(0,y.join)(n,"extensions");return g["builtin-extensions-dir"]=o,g["extensions-dir"]=g["extensions-dir"]||(0,y.join)(f,"extensions"),[f,g["extensions-dir"],D,R,i,t,r].forEach(u=>{try{A.existsSync(u)||A.mkdirSync(u,{mode:448})}catch(a){console.error(a)}}),f}function c(g=m()){return(0,w.run)(g,p(g),k.serverOptions)}e.spawnCli=c;function h(g,f=m()){return(0,S.createServer)(g,f,p(f))}e.createServer=h})}).call(this);

//# sourceMappingURL=server.main.js.map
