"use strict";/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var ye=["exports","require","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/base/common/strings","vs/base/common/path","vs/base/common/types","vs/base/common/errors","vs/base/common/platform","vs/platform/log/common/log","vs/workbench/api/common/extHostTypeConverters","vs/base/common/arrays","vs/base/common/network","vs/base/common/async","vs/workbench/api/common/extHostRpcService","vs/nls","vs/nls!vs/workbench/api/node/extensionHostProcess","vs/base/common/cancellation","vs/base/common/buffer","vs/base/common/objects","vs/base/common/resources","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/platform/extensions/common/extensions","vs/base/common/map","vs/base/node/pfs","vs/base/common/uuid","vs/workbench/services/search/common/search","vs/base/common/extpath","vs/editor/common/core/range","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/base/common/process","vs/base/common/severity","vs/base/common/glob","vs/platform/registry/common/platform","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostExtensionService","vs/base/common/stopwatch","vs/platform/files/common/files","vs/base/common/errorMessage","child_process","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostVariableResolverService","vs/base/common/assert","vs/base/common/themables","fs","vs/editor/common/core/position","vs/platform/configuration/common/configuration","vs/platform/contextkey/common/contextkey","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testId","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/base/common/collections","vs/base/common/decorators","vs/base/common/functional","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/ternarySearchTree","vs/base/common/codicons","vs/base/common/marshalling","os","vs/editor/common/languages","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostWebview","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/base/common/performance","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/normalization","vs/base/common/mime","vs/base/common/hash","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/serviceCollection","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/services/search/node/ripgrepSearchUtils","vs/base/common/idGenerator","vs/base/common/numbers","vs/base/common/comparers","vs/base/common/processes","vs/base/common/stream","vs/base/common/filters","vs/base/common/fuzzyScorer","vs/base/common/uint","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/uriIpc","vs/base/node/extpath","vs/base/node/processes","vs/base/parts/ipc/common/ipc","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/node/ipc.net","vs/editor/common/core/characterClassifier","vs/editor/common/core/wordHelper","vs/editor/common/model","vs/editor/common/services/semanticTokensDto","vs/editor/common/config/editorOptions","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/tunnel/common/tunnel","vs/workbench/common/editor","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/textSearchManager","vs/workbench/services/search/node/textSearchManager","vs/workbench/services/search/node/ripgrepTextSearchEngine","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/cache","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/selection","vs/editor/common/core/textModelDefaults","vs/editor/common/core/wordCharacterClassifier","vs/editor/common/languageSelector","vs/editor/common/languages/languageConfiguration","vs/editor/common/languages/linkComputer","vs/editor/common/model/prefixSumComputer","vs/editor/common/model/mirrorTextModel","vs/editor/common/model/textModelSearch","vs/editor/common/tokenizationRegistry","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/api/node/extHostDebugService","vs/nls!vs/workbench/api/node/extHostTunnelService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/debug/node/debugAdapter","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensionManagement/common/implicitActivationEvents","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/externalTerminal/common/externalTerminal","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/instantiation/common/instantiationService","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/notification/common/notification","vs/platform/product/common/product","vs/platform/product/common/productService","vs/platform/configuration/common/configurationModels","vs/platform/sign/node/signService","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/node/uriTransformer","vs/workbench/common/views","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/debug/node/debugAdapter","net","vs/workbench/contrib/debug/node/terminals","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionHostEnv","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/node/extHostCLIServer","http","vs/workbench/api/node/extHostConsoleForwarder","vs/workbench/api/node/extHostDownloadService","vs/workbench/api/node/extHostLoggerService","vs/workbench/api/node/extHostStoragePaths","vs/workbench/api/node/extHostTerminalService","vs/workbench/api/node/extHostTunnelService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/api/node/extHostDebugService","vs/workbench/api/node/extHostTask","vs/workbench/api/node/extHostVariableResolverService","vs/workbench/api/common/extHost.common.services","vs/workbench/services/search/node/ripgrepFileSearch","@vscode/ripgrep","vs/workbench/services/search/node/fileSearch","string_decoder","vs/workbench/services/textfile/common/encoding","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/node/proxyResolver","vs/workbench/api/node/extHostExtensionService","vs/workbench/services/search/node/ripgrepSearchProvider","vs/workbench/services/search/node/textSearchAdapter","vs/workbench/services/search/node/rawSearchService","vs/workbench/api/node/extHostSearch","vs/workbench/api/node/extHost.node.services","util","vs/base/common/semver/semver","https","tls","vscode-proxy-agent","events","vscode-regexpp","vs/workbench/api/node/extensionHostProcess","minimist"],De=function(re){for(var e=[],a=0,L=re.length;a<L;a++)e[a]=ye[re[a]];return e};define(ye[62],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function a(S,A){const y=Object.create(null);for(const I of S){const O=A(I);let P=y[O];P||(P=y[O]=[]),P.push(I)}return y}e.groupBy=a;function L(S,A){const y=[],I=[];for(const O of S)A.has(O)||y.push(O);for(const O of A)S.has(O)||I.push(O);return{removed:y,added:I}}e.diffSets=L;function l(S,A){const y=[],I=[];for(const[O,P]of S)A.has(O)||y.push(P);for(const[O,P]of A)S.has(O)||I.push(P);return{removed:y,added:I}}e.diffMaps=l;class R{constructor(){this.a=new Map}add(A,y){let I=this.a.get(A);I||(I=new Set,this.a.set(A,I)),I.add(y)}delete(A,y){const I=this.a.get(A);!I||(I.delete(y),I.size===0&&this.a.delete(A))}forEach(A,y){const I=this.a.get(A);!I||I.forEach(y)}}e.SetMap=R}),define(ye[63],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=void 0;function a(S){return(A,y,I)=>{let O=null,P=null;if(typeof I.value=="function"?(O="value",P=I.value):typeof I.get=="function"&&(O="get",P=I.get),!P)throw new Error("not supported");I[O]=S(P,y)}}function L(S,A,y){let I=null,O=null;if(typeof y.value=="function"?(I="value",O=y.value,O.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof y.get=="function"&&(I="get",O=y.get),!O)throw new Error("not supported");const P=`$memoize$${A}`;y[I]=function(...v){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:O.apply(this,v)}),this[P]}}e.memoize=L;function l(S,A,y){return a((I,O)=>{const P=`$debounce$${O}`,v=`$debounce$result$${O}`;return function(...k){this[v]||(this[v]=y?y():void 0),clearTimeout(this[P]),A&&(this[v]=A(this[v],...k),k=[this[v]]),this[P]=setTimeout(()=>{I.apply(this,k),this[v]=y?y():void 0},S)}})}e.debounce=l;function R(S,A,y){return a((I,O)=>{const P=`$throttle$timer$${O}`,v=`$throttle$result$${O}`,k=`$throttle$lastRun$${O}`,D=`$throttle$pending$${O}`;return function(...f){if(this[v]||(this[v]=y?y():void 0),(this[k]===null||this[k]===void 0)&&(this[k]=-Number.MAX_VALUE),A&&(this[v]=A(this[v],...f)),this[D])return;const u=this[k]+S;u<=Date.now()?(this[k]=Date.now(),I.apply(this,[this[v]]),this[v]=y?y():void 0):(this[D]=!0,this[P]=setTimeout(()=>{this[D]=!1,this[k]=Date.now(),I.apply(this,[this[v]]),this[v]=y?y():void 0},u-Date.now()))}})}e.throttle=R}),define(ye[11],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.isSigPipeError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class a{constructor(){this.b=[],this.a=function(s){setTimeout(()=>{throw s.stack?C.isErrorNoTelemetry(s)?new C(s.message+`

`+s.stack):new Error(s.message+`

`+s.stack):s},0)}}addListener(s){return this.b.push(s),()=>{this.d(s)}}c(s){this.b.forEach(r=>{r(s)})}d(s){this.b.splice(this.b.indexOf(s),1)}setUnexpectedErrorHandler(s){this.a=s}getUnexpectedErrorHandler(){return this.a}onUnexpectedError(s){this.a(s),this.c(s)}onUnexpectedExternalError(s){this.a(s)}}e.ErrorHandler=a,e.errorHandler=new a;function L(i){e.errorHandler.setUnexpectedErrorHandler(i)}e.setUnexpectedErrorHandler=L;function l(i){if(!i||typeof i!="object")return!1;const s=i;return s.code==="EPIPE"&&s.syscall?.toUpperCase()==="WRITE"}e.isSigPipeError=l;function R(i){I(i)||e.errorHandler.onUnexpectedError(i)}e.onUnexpectedError=R;function S(i){I(i)||e.errorHandler.onUnexpectedExternalError(i)}e.onUnexpectedExternalError=S;function A(i){if(i instanceof Error){const{name:s,message:r}=i,o=i.stacktrace||i.stack;return{$isError:!0,name:s,message:r,stack:o,noTelemetry:C.isErrorNoTelemetry(i)}}return i}e.transformErrorForSerialization=A;const y="Canceled";function I(i){return i instanceof O?!0:i instanceof Error&&i.name===y&&i.message===y}e.isCancellationError=I;class O extends Error{constructor(){super(y),this.name=this.message}}e.CancellationError=O;function P(){const i=new Error(y);return i.name=i.message,i}e.canceled=P;function v(i){return i?new Error(`Illegal argument: ${i}`):new Error("Illegal argument")}e.illegalArgument=v;function k(i){return i?new Error(`Illegal state: ${i}`):new Error("Illegal state")}e.illegalState=k;function D(i){return i?new Error(`readonly property '${i} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=D;function f(i){const s=new Error(`${i} has been disposed`);return s.name="DISPOSED",s}e.disposed=f;function u(i){return i?i.message?i.message:i.stack?i.stack.split(`
`)[0]:String(i):"Error"}e.getErrorMessage=u;class h extends Error{constructor(s){super("NotImplemented"),s&&(this.message=s)}}e.NotImplementedError=h;class p extends Error{constructor(s){super("NotSupported"),s&&(this.message=s)}}e.NotSupportedError=p;class b extends Error{constructor(){super(...arguments),this.isExpected=!0}}e.ExpectedError=b;class C extends Error{constructor(s){super(s),this.name="CodeExpectedError"}static fromError(s){if(s instanceof C)return s;const r=new C;return r.message=s.message,r.stack=s.stack,r}static isErrorNoTelemetry(s){return s.name==="CodeExpectedError"}}e.ErrorNoTelemetry=C;class g extends Error{constructor(s){super(s||"An unexpected bug occurred."),Object.setPrototypeOf(this,g.prototype);debugger}}e.BugIndicatingError=g}),define(ye[15],De([1,0,11]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function L(ae,le=0){return ae[ae.length-(1+le)]}e.tail=L;function l(ae){if(ae.length===0)throw new Error("Invalid tail call");return[ae.slice(0,ae.length-1),ae[ae.length-1]]}e.tail2=l;function R(ae,le,ue=(ne,ce)=>ne===ce){if(ae===le)return!0;if(!ae||!le||ae.length!==le.length)return!1;for(let ne=0,ce=ae.length;ne<ce;ne++)if(!ue(ae[ne],le[ne]))return!1;return!0}e.equals=R;function S(ae,le){const ue=ae.length-1;le<ue&&(ae[le]=ae[ue]),ae.pop()}e.removeFastWithoutKeepingOrder=S;function A(ae,le,ue){return y(ae.length,ne=>ue(ae[ne],le))}e.binarySearch=A;function y(ae,le){let ue=0,ne=ae-1;for(;ue<=ne;){const ce=(ue+ne)/2|0,oe=le(ce);if(oe<0)ue=ce+1;else if(oe>0)ne=ce-1;else return ce}return-(ue+1)}e.binarySearch2=y;function I(ae,le){let ue=0,ne=ae.length;if(ne===0)return 0;for(;ue<ne;){const ce=Math.floor((ue+ne)/2);le(ae[ce])?ne=ce:ue=ce+1}return ue}e.findFirstInSorted=I;function O(ae,le,ue){if(ae=ae|0,ae>=le.length)throw new TypeError("invalid index");const ne=le[Math.floor(le.length*Math.random())],ce=[],oe=[],M=[];for(const z of le){const G=ue(z,ne);G<0?ce.push(z):G>0?oe.push(z):M.push(z)}return ae<ce.length?O(ae,ce,ue):ae<ce.length+M.length?M[0]:O(ae-(ce.length+M.length),oe,ue)}e.quickSelect=O;function P(ae,le){const ue=[];let ne;for(const ce of ae.slice(0).sort(le))!ne||le(ne[0],ce)!==0?(ne=[ce],ue.push(ne)):ne.push(ce);return ue}e.groupBy=P;function v(ae,le,ue){const ne=[];function ce(z,G,te){if(G===0&&te.length===0)return;const de=ne[ne.length-1];de&&de.start+de.deleteCount===z?(de.deleteCount+=G,de.toInsert.push(...te)):ne.push({start:z,deleteCount:G,toInsert:te})}let oe=0,M=0;for(;;){if(oe===ae.length){ce(oe,0,le.slice(M));break}if(M===le.length){ce(oe,ae.length-oe,[]);break}const z=ae[oe],G=le[M],te=ue(z,G);te===0?(oe+=1,M+=1):te<0?(ce(oe,1,[]),oe+=1):te>0&&(ce(oe,0,[G]),M+=1)}return ne}e.sortedDiff=v;function k(ae,le,ue){const ne=v(ae,le,ue),ce=[],oe=[];for(const M of ne)ce.push(...ae.slice(M.start,M.start+M.deleteCount)),oe.push(...M.toInsert);return{removed:ce,added:oe}}e.delta=k;function D(ae,le,ue){if(ue===0)return[];const ne=ae.slice(0,ue).sort(le);return u(ae,le,ne,ue,ae.length),ne}e.top=D;function f(ae,le,ue,ne,ce){return ue===0?Promise.resolve([]):new Promise((oe,M)=>{(async()=>{const z=ae.length,G=ae.slice(0,ue).sort(le);for(let te=ue,de=Math.min(ue+ne,z);te<z;te=de,de=Math.min(de+ne,z)){if(te>ue&&await new Promise(we=>setTimeout(we)),ce&&ce.isCancellationRequested)throw new a.CancellationError;u(ae,le,G,te,de)}return G})().then(oe,M)})}e.topAsync=f;function u(ae,le,ue,ne,ce){for(const oe=ue.length;ne<ce;ne++){const M=ae[ne];if(le(M,ue[oe-1])<0){ue.pop();const z=I(ue,G=>le(M,G)<0);ue.splice(z,0,M)}}}function h(ae){return ae.filter(le=>!!le)}e.coalesce=h;function p(ae){let le=0;for(let ue=0;ue<ae.length;ue++)ae[ue]&&(ae[le]=ae[ue],le+=1);ae.length=le}e.coalesceInPlace=p;function b(ae,le,ue){ae.splice(ue,0,ae.splice(le,1)[0])}e.move=b;function C(ae){return!Array.isArray(ae)||ae.length===0}e.isFalsyOrEmpty=C;function g(ae){return Array.isArray(ae)&&ae.length>0}e.isNonEmptyArray=g;function i(ae,le=ue=>ue){const ue=new Set;return ae.filter(ne=>{const ce=le(ne);return ue.has(ce)?!1:(ue.add(ce),!0)})}e.distinct=i;function s(ae){const le=new Set;return ue=>{const ne=ae(ue);return le.has(ne)?!1:(le.add(ne),!0)}}e.uniqueFilter=s;function r(ae,le){const ue=o(ae,le);if(ue!==-1)return ae[ue]}e.findLast=r;function o(ae,le){for(let ue=ae.length-1;ue>=0;ue--){const ne=ae[ue];if(le(ne))return ue}return-1}e.lastIndex=o;function c(ae,le){return ae.length>0?ae[0]:le}e.firstOrDefault=c;function m(ae,le){return ae.length>0?ae[ae.length-1]:le}e.lastOrDefault=m;function n(ae,le,ue=(ne,ce)=>ne===ce){let ne=0;for(let ce=0,oe=Math.min(ae.length,le.length);ce<oe&&ue(ae[ce],le[ce]);ce++)ne++;return ne}e.commonPrefixLength=n;function t(ae){return[].concat(...ae)}e.flatten=t;function d(ae,le){let ue=typeof le=="number"?ae:0;typeof le=="number"?ue=ae:(ue=0,le=ae);const ne=[];if(ue<=le)for(let ce=ue;ce<le;ce++)ne.push(ce);else for(let ce=ue;ce>le;ce--)ne.push(ce);return ne}e.range=d;function E(ae,le,ue){return ae.reduce((ne,ce)=>(ne[le(ce)]=ue?ue(ce):ce,ne),Object.create(null))}e.index=E;function w(ae,le){return ae.push(le),()=>N(ae,le)}e.insert=w;function N(ae,le){const ue=ae.indexOf(le);if(ue>-1)return ae.splice(ue,1),le}e.remove=N;function j(ae,le,ue){const ne=ae.slice(0,le),ce=ae.slice(le);return ne.concat(ue,ce)}e.arrayInsert=j;function V(ae,le){let ue;if(typeof le=="number"){let ne=le;ue=()=>{const ce=Math.sin(ne++)*179426549;return ce-Math.floor(ce)}}else ue=Math.random;for(let ne=ae.length-1;ne>0;ne-=1){const ce=Math.floor(ue()*(ne+1)),oe=ae[ne];ae[ne]=ae[ce],ae[ce]=oe}}e.shuffle=V;function Q(ae,le){const ue=ae.indexOf(le);ue>-1&&(ae.splice(ue,1),ae.unshift(le))}e.pushToStart=Q;function x(ae,le){const ue=ae.indexOf(le);ue>-1&&(ae.splice(ue,1),ae.push(le))}e.pushToEnd=x;function U(ae,le){for(const ue of le)ae.push(ue)}e.pushMany=U;function T(ae,le){return Array.isArray(ae)?ae.map(le):le(ae)}e.mapArrayOrNot=T;function F(ae){return Array.isArray(ae)?ae:[ae]}e.asArray=F;function B(ae){return ae[Math.floor(Math.random()*ae.length)]}e.getRandomElement=B;function Z(ae,le){for(const ue of ae){const ne=le(ue);if(ne!==void 0)return ne}}e.mapFind=Z;function _(ae,le,ue){const ne=Y(ae,le),ce=ae.length,oe=ue.length;ae.length=ce+oe;for(let M=ce-1;M>=ne;M--)ae[M+oe]=ae[M];for(let M=0;M<oe;M++)ae[M+ne]=ue[M]}e.insertInto=_;function H(ae,le,ue,ne){const ce=Y(ae,le),oe=ae.splice(ce,ue);return _(ae,ce,ne),oe}e.splice=H;function Y(ae,le){return le<0?Math.max(le+ae.length,0):Math.min(le,ae.length)}var ie;(function(ae){function le(ce){return ce<0}ae.isLessThan=le;function ue(ce){return ce>0}ae.isGreaterThan=ue;function ne(ce){return ce===0}ae.isNeitherLessOrGreaterThan=ne,ae.greaterThan=1,ae.lessThan=-1,ae.neitherLessOrGreaterThan=0})(ie=e.CompareResult||(e.CompareResult={}));function ge(ae,le){return(ue,ne)=>le(ae(ue),ae(ne))}e.compareBy=ge;function X(...ae){return(le,ue)=>{for(const ne of ae){const ce=ne(le,ue);if(!ie.isNeitherLessOrGreaterThan(ce))return ce}return ie.neitherLessOrGreaterThan}}e.tieBreakComparators=X;const J=(ae,le)=>ae-le;e.numberComparator=J;function ee(ae,le){if(ae.length===0)return;let ue=ae[0];for(let ne=1;ne<ae.length;ne++){const ce=ae[ne];le(ce,ue)>0&&(ue=ce)}return ue}e.findMaxBy=ee;function me(ae,le){if(ae.length===0)return;let ue=ae[0];for(let ne=1;ne<ae.length;ne++){const ce=ae[ne];le(ce,ue)>=0&&(ue=ce)}return ue}e.findLastMaxBy=me;function ve(ae,le){return ee(ae,(ue,ne)=>-le(ue,ne))}e.findMinBy=ve;class Ie{constructor(le){this.f=le,this.c=0,this.d=this.f.length-1}get length(){return this.d-this.c+1}takeWhile(le){let ue=this.c;for(;ue<this.f.length&&le(this.f[ue]);)ue++;const ne=ue===this.c?null:this.f.slice(this.c,ue);return this.c=ue,ne}takeFromEndWhile(le){let ue=this.d;for(;ue>=0&&le(this.f[ue]);)ue--;const ne=ue===this.d?null:this.f.slice(ue+1,this.d+1);return this.d=ue,ne}peek(){if(this.length!==0)return this.f[this.c]}peekLast(){if(this.length!==0)return this.f[this.d]}dequeue(){const le=this.f[this.c];return this.c++,le}removeLast(){const le=this.f[this.d];return this.d--,le}takeCount(le){const ue=this.f.slice(this.c,this.c+le);return this.c+=le,ue}}e.ArrayQueue=Ie;class Re{constructor(le){this.iterate=le}forEach(le){this.iterate(ue=>(le(ue),!0))}toArray(){const le=[];return this.iterate(ue=>(le.push(ue),!0)),le}filter(le){return new Re(ue=>this.iterate(ne=>le(ne)?ue(ne):!0))}map(le){return new Re(ue=>this.iterate(ne=>ue(le(ne))))}some(le){let ue=!1;return this.iterate(ne=>(ue=le(ne),!ue)),ue}findFirst(le){let ue;return this.iterate(ne=>le(ne)?(ue=ne,!1):!0),ue}findLast(le){let ue;return this.iterate(ne=>(le(ne)&&(ue=ne),!0)),ue}findLastMaxBy(le){let ue,ne=!0;return this.iterate(ce=>((ne||ie.isGreaterThan(le(ce,ue)))&&(ne=!1,ue=ce),!0)),ue}}Re.empty=new Re(ae=>{}),e.CallbackIterable=Re}),define(ye[50],De([1,0,11]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkAdjacentItems=e.assertFn=e.assert=e.assertNever=e.ok=void 0;function L(y,I){if(!y)throw new Error(I?`Assertion failed (${I})`:"Assertion Failed")}e.ok=L;function l(y,I="Unreachable"){throw new Error(I)}e.assertNever=l;function R(y){if(!y)throw new a.BugIndicatingError("Assertion Failed")}e.assert=R;function S(y){if(!y()){debugger;y(),(0,a.onUnexpectedError)(new a.BugIndicatingError("Assertion Failed"))}}e.assertFn=S;function A(y,I){let O=0;for(;O<y.length-1;){const P=y[O],v=y[O+1];if(!I(P,v))return!1;O++}return!0}e.checkAdjacentItems=A}),define(ye[64],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function a(L){const l=this;let R=!1,S;return function(){return R||(R=!0,S=L.apply(l,arguments)),S}}e.once=a}),define(ye[101],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class a{constructor(l){this.a=l,this.b=0}nextId(){return this.a+ ++this.b}}e.IdGenerator=a,e.defaultGenerator=new a("id#")}),define(ye[65],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var a;(function(L){function l(C){return C&&typeof C=="object"&&typeof C[Symbol.iterator]=="function"}L.is=l;const R=Object.freeze([]);function S(){return R}L.empty=S;function*A(C){yield C}L.single=A;function y(C){return l(C)?C:A(C)}L.wrap=y;function I(C){return C||R}L.from=I;function O(C){return!C||C[Symbol.iterator]().next().done===!0}L.isEmpty=O;function P(C){return C[Symbol.iterator]().next().value}L.first=P;function v(C,g){for(const i of C)if(g(i))return!0;return!1}L.some=v;function k(C,g){for(const i of C)if(g(i))return i}L.find=k;function*D(C,g){for(const i of C)g(i)&&(yield i)}L.filter=D;function*f(C,g){let i=0;for(const s of C)yield g(s,i++)}L.map=f;function*u(...C){for(const g of C)for(const i of g)yield i}L.concat=u;function h(C,g,i){let s=i;for(const r of C)s=g(s,r);return s}L.reduce=h;function*p(C,g,i=C.length){for(g<0&&(g+=C.length),i<0?i+=C.length:i>C.length&&(i=C.length);g<i;g++)yield C[g]}L.slice=p;function b(C,g=Number.POSITIVE_INFINITY){const i=[];if(g===0)return[i,C];const s=C[Symbol.iterator]();for(let r=0;r<g;r++){const o=s.next();if(o.done)return[i,L.empty()];i.push(o.value)}return[i,{[Symbol.iterator](){return s}}]}L.consume=b})(a=e.Iterable||(e.Iterable={}))}),define(ye[146],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var a;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(a=e.ScanError||(e.ScanError={}));var L;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(L=e.SyntaxKind||(e.SyntaxKind={}));var l;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(l=e.ParseErrorCode||(e.ParseErrorCode={}));var R;(function(i){i.DEFAULT={allowTrailingComma:!0}})(R=e.ParseOptions||(e.ParseOptions={}));function S(i,s=!1){let r=0;const o=i.length;let c="",m=0,n=16,t=0;function d(x){let U=0,T=0;for(;U<x;){const F=i.charCodeAt(r);if(F>=48&&F<=57)T=T*16+F-48;else if(F>=65&&F<=70)T=T*16+F-65+10;else if(F>=97&&F<=102)T=T*16+F-97+10;else break;r++,U++}return U<x&&(T=-1),T}function E(x){r=x,c="",m=0,n=16,t=0}function w(){const x=r;if(i.charCodeAt(r)===48)r++;else for(r++;r<i.length&&I(i.charCodeAt(r));)r++;if(r<i.length&&i.charCodeAt(r)===46)if(r++,r<i.length&&I(i.charCodeAt(r)))for(r++;r<i.length&&I(i.charCodeAt(r));)r++;else return t=3,i.substring(x,r);let U=r;if(r<i.length&&(i.charCodeAt(r)===69||i.charCodeAt(r)===101))if(r++,(r<i.length&&i.charCodeAt(r)===43||i.charCodeAt(r)===45)&&r++,r<i.length&&I(i.charCodeAt(r))){for(r++;r<i.length&&I(i.charCodeAt(r));)r++;U=r}else t=3;return i.substring(x,U)}function N(){let x="",U=r;for(;;){if(r>=o){x+=i.substring(U,r),t=2;break}const T=i.charCodeAt(r);if(T===34){x+=i.substring(U,r),r++;break}if(T===92){if(x+=i.substring(U,r),r++,r>=o){t=2;break}switch(i.charCodeAt(r++)){case 34:x+='"';break;case 92:x+="\\";break;case 47:x+="/";break;case 98:x+="\b";break;case 102:x+="\f";break;case 110:x+=`
`;break;case 114:x+="\r";break;case 116:x+="	";break;case 117:{const B=d(4);B>=0?x+=String.fromCharCode(B):t=4;break}default:t=5}U=r;continue}if(T>=0&&T<=31)if(y(T)){x+=i.substring(U,r),t=2;break}else t=6;r++}return x}function j(){if(c="",t=0,m=r,r>=o)return m=o,n=17;let x=i.charCodeAt(r);if(A(x)){do r++,c+=String.fromCharCode(x),x=i.charCodeAt(r);while(A(x));return n=15}if(y(x))return r++,c+=String.fromCharCode(x),x===13&&i.charCodeAt(r)===10&&(r++,c+=`
`),n=14;switch(x){case 123:return r++,n=1;case 125:return r++,n=2;case 91:return r++,n=3;case 93:return r++,n=4;case 58:return r++,n=6;case 44:return r++,n=5;case 34:return r++,c=N(),n=10;case 47:{const U=r-1;if(i.charCodeAt(r+1)===47){for(r+=2;r<o&&!y(i.charCodeAt(r));)r++;return c=i.substring(U,r),n=12}if(i.charCodeAt(r+1)===42){r+=2;const T=o-1;let F=!1;for(;r<T;){if(i.charCodeAt(r)===42&&i.charCodeAt(r+1)===47){r+=2,F=!0;break}r++}return F||(r++,t=1),c=i.substring(U,r),n=13}return c+=String.fromCharCode(x),r++,n=16}case 45:if(c+=String.fromCharCode(x),r++,r===o||!I(i.charCodeAt(r)))return n=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return c+=w(),n=11;default:for(;r<o&&V(x);)r++,x=i.charCodeAt(r);if(m!==r){switch(c=i.substring(m,r),c){case"true":return n=8;case"false":return n=9;case"null":return n=7}return n=16}return c+=String.fromCharCode(x),r++,n=16}}function V(x){if(A(x)||y(x))return!1;switch(x){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function Q(){let x;do x=j();while(x>=12&&x<=15);return x}return{setPosition:E,getPosition:()=>r,scan:s?Q:j,getToken:()=>n,getTokenValue:()=>c,getTokenOffset:()=>m,getTokenLength:()=>r-m,getTokenError:()=>t}}e.createScanner=S;function A(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function y(i){return i===10||i===13||i===8232||i===8233}function I(i){return i>=48&&i<=57}var O;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(O||(O={}));function P(i,s){const r=[],o=new Object;let c;const m={value:{},offset:0,length:0,type:"object",parent:void 0};let n=!1;function t(d,E,w,N){m.value=d,m.offset=E,m.length=w,m.type=N,m.colonOffset=void 0,c=m}try{b(i,{onObjectBegin:(d,E)=>{if(s<=d)throw o;c=void 0,n=s>d,r.push("")},onObjectProperty:(d,E,w)=>{if(s<E||(t(d,E,w,"property"),r[r.length-1]=d,s<=E+w))throw o},onObjectEnd:(d,E)=>{if(s<=d)throw o;c=void 0,r.pop()},onArrayBegin:(d,E)=>{if(s<=d)throw o;c=void 0,r.push(0)},onArrayEnd:(d,E)=>{if(s<=d)throw o;c=void 0,r.pop()},onLiteralValue:(d,E,w)=>{if(s<E||(t(d,E,w,g(d)),s<=E+w))throw o},onSeparator:(d,E,w)=>{if(s<=E)throw o;if(d===":"&&c&&c.type==="property")c.colonOffset=E,n=!1,c=void 0;else if(d===","){const N=r[r.length-1];typeof N=="number"?r[r.length-1]=N+1:(n=!0,r[r.length-1]=""),c=void 0}}})}catch(d){if(d!==o)throw d}return{path:r,previousNode:c,isAtPropertyKey:n,matches:d=>{let E=0;for(let w=0;E<d.length&&w<r.length;w++)if(d[E]===r[w]||d[E]==="*")E++;else if(d[E]!=="**")return!1;return E===d.length}}}e.getLocation=P;function v(i,s=[],r=R.DEFAULT){let o=null,c=[];const m=[];function n(d){Array.isArray(c)?c.push(d):o!==null&&(c[o]=d)}return b(i,{onObjectBegin:()=>{const d={};n(d),m.push(c),c=d,o=null},onObjectProperty:d=>{o=d},onObjectEnd:()=>{c=m.pop()},onArrayBegin:()=>{const d=[];n(d),m.push(c),c=d,o=null},onArrayEnd:()=>{c=m.pop()},onLiteralValue:n,onError:(d,E,w)=>{s.push({error:d,offset:E,length:w})}},r),c[0]}e.parse=v;function k(i,s=[],r=R.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function c(d){o.type==="property"&&(o.length=d-o.offset,o=o.parent)}function m(d){return o.children.push(d),d}b(i,{onObjectBegin:d=>{o=m({type:"object",offset:d,length:-1,parent:o,children:[]})},onObjectProperty:(d,E,w)=>{o=m({type:"property",offset:E,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:d,offset:E,length:w,parent:o})},onObjectEnd:(d,E)=>{o.length=d+E-o.offset,o=o.parent,c(d+E)},onArrayBegin:(d,E)=>{o=m({type:"array",offset:d,length:-1,parent:o,children:[]})},onArrayEnd:(d,E)=>{o.length=d+E-o.offset,o=o.parent,c(d+E)},onLiteralValue:(d,E,w)=>{m({type:g(d),offset:E,length:w,parent:o,value:d}),c(E+w)},onSeparator:(d,E,w)=>{o.type==="property"&&(d===":"?o.colonOffset=E:d===","&&c(E))},onError:(d,E,w)=>{s.push({error:d,offset:E,length:w})}},r);const t=o.children[0];return t&&delete t.parent,t}e.parseTree=k;function D(i,s){if(!i)return;let r=i;for(const o of s)if(typeof o=="string"){if(r.type!=="object"||!Array.isArray(r.children))return;let c=!1;for(const m of r.children)if(Array.isArray(m.children)&&m.children[0].value===o){r=m.children[1],c=!0;break}if(!c)return}else{const c=o;if(r.type!=="array"||c<0||!Array.isArray(r.children)||c>=r.children.length)return;r=r.children[c]}return r}e.findNodeAtLocation=D;function f(i){if(!i.parent||!i.parent.children)return[];const s=f(i.parent);if(i.parent.type==="property"){const r=i.parent.children[0].value;s.push(r)}else if(i.parent.type==="array"){const r=i.parent.children.indexOf(i);r!==-1&&s.push(r)}return s}e.getNodePath=f;function u(i){switch(i.type){case"array":return i.children.map(u);case"object":{const s=Object.create(null);for(const r of i.children){const o=r.children[1];o&&(s[r.children[0].value]=u(o))}return s}case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=u;function h(i,s,r=!1){return s>=i.offset&&s<i.offset+i.length||r&&s===i.offset+i.length}e.contains=h;function p(i,s,r=!1){if(h(i,s,r)){const o=i.children;if(Array.isArray(o))for(let c=0;c<o.length&&o[c].offset<=s;c++){const m=p(o[c],s,r);if(m)return m}return i}}e.findNodeAtOffset=p;function b(i,s,r=R.DEFAULT){const o=S(i,!1);function c(ge){return ge?()=>ge(o.getTokenOffset(),o.getTokenLength()):()=>!0}function m(ge){return ge?X=>ge(X,o.getTokenOffset(),o.getTokenLength()):()=>!0}const n=c(s.onObjectBegin),t=m(s.onObjectProperty),d=c(s.onObjectEnd),E=c(s.onArrayBegin),w=c(s.onArrayEnd),N=m(s.onLiteralValue),j=m(s.onSeparator),V=c(s.onComment),Q=m(s.onError),x=r&&r.disallowComments,U=r&&r.allowTrailingComma;function T(){for(;;){const ge=o.scan();switch(o.getTokenError()){case 4:F(14);break;case 5:F(15);break;case 3:F(13);break;case 1:x||F(11);break;case 2:F(12);break;case 6:F(16);break}switch(ge){case 12:case 13:x?F(10):V();break;case 16:F(1);break;case 15:case 14:break;default:return ge}}}function F(ge,X=[],J=[]){if(Q(ge),X.length+J.length>0){let ee=o.getToken();for(;ee!==17;){if(X.indexOf(ee)!==-1){T();break}else if(J.indexOf(ee)!==-1)break;ee=T()}}}function B(ge){const X=o.getTokenValue();return ge?N(X):t(X),T(),!0}function Z(){switch(o.getToken()){case 11:{let ge=0;try{ge=JSON.parse(o.getTokenValue()),typeof ge!="number"&&(F(2),ge=0)}catch{F(2)}N(ge);break}case 7:N(null);break;case 8:N(!0);break;case 9:N(!1);break;default:return!1}return T(),!0}function _(){return o.getToken()!==10?(F(3,[],[2,5]),!1):(B(!1),o.getToken()===6?(j(":"),T(),ie()||F(4,[],[2,5])):F(5,[],[2,5]),!0)}function H(){n(),T();let ge=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(ge||F(4,[],[]),j(","),T(),o.getToken()===2&&U)break}else ge&&F(6,[],[]);_()||F(4,[],[2,5]),ge=!0}return d(),o.getToken()!==2?F(7,[2],[]):T(),!0}function Y(){E(),T();let ge=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(ge||F(4,[],[]),j(","),T(),o.getToken()===4&&U)break}else ge&&F(6,[],[]);ie()||F(4,[],[4,5]),ge=!0}return w(),o.getToken()!==4?F(8,[4],[]):T(),!0}function ie(){switch(o.getToken()){case 3:return Y();case 1:return H();case 10:return B(!0);default:return Z()}}return T(),o.getToken()===17?r.allowEmptyContent?!0:(F(4,[],[]),!1):ie()?(o.getToken()!==17&&F(9,[],[]),!0):(F(4,[],[]),!1)}e.visit=b;function C(i,s){const r=S(i),o=[];let c,m=0,n;do switch(n=r.getPosition(),c=r.scan(),c){case 12:case 13:case 17:m!==n&&o.push(i.substring(m,n)),s!==void 0&&o.push(r.getTokenValue().replace(/[^\r\n]/g,s)),m=r.getPosition();break}while(c!==17);return o.join("")}e.stripComments=C;function g(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=g}),define(ye[66],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class a{constructor(l){this.d=l,this.a=!1}get hasValue(){return this.a}get value(){if(!this.a)try{this.b=this.d()}catch(l){this.c=l}finally{this.a=!0}if(this.c)throw this.c;return this.b}get rawValue(){return this.b}}e.Lazy=a}),define(ye[6],De([1,0,64,65]),function(re,e,a,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DisposableMap=e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.disposeIfDisposable=e.dispose=e.isDisposable=e.markAsSingleton=e.setDisposableTracker=void 0;const l=!1;let R=null;function S(m){R=m}if(e.setDisposableTracker=S,l){const m="__is_disposable_tracked__";S(new class{trackDisposable(n){const t=new Error("Potentially leaked disposable").stack;setTimeout(()=>{n[m]||console.log(t)},3e3)}setParent(n,t){if(n&&n!==p.None)try{n[m]=!0}catch{}}markAsDisposed(n){if(n&&n!==p.None)try{n[m]=!0}catch{}}markAsSingleton(n){}})}function A(m){return R?.trackDisposable(m),m}function y(m){R?.markAsDisposed(m)}function I(m,n){R?.setParent(m,n)}function O(m,n){if(!!R)for(const t of m)R.setParent(t,n)}function P(m){return R?.markAsSingleton(m),m}e.markAsSingleton=P;function v(m){return typeof m.dispose=="function"&&m.dispose.length===0}e.isDisposable=v;function k(m){if(L.Iterable.is(m)){const n=[];for(const t of m)if(t)try{t.dispose()}catch(d){n.push(d)}if(n.length===1)throw n[0];if(n.length>1)throw new AggregateError(n,"Encountered errors while disposing of store");return Array.isArray(m)?[]:m}else if(m)return m.dispose(),m}e.dispose=k;function D(m){for(const n of m)v(n)&&n.dispose();return[]}e.disposeIfDisposable=D;function f(...m){const n=u(()=>k(m));return O(m,n),n}e.combinedDisposable=f;function u(m){const n=A({dispose:(0,a.once)(()=>{y(n),m()})});return n}e.toDisposable=u;class h{constructor(){this.c=new Set,this.f=!1,A(this)}dispose(){this.f||(y(this),this.f=!0,this.clear())}get isDisposed(){return this.f}clear(){if(this.c.size!==0)try{k(this.c)}finally{this.c.clear()}}add(n){if(!n)return n;if(n===this)throw new Error("Cannot register a disposable on itself!");return I(n,this),this.f?h.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this.c.add(n),n}}h.DISABLE_DISPOSED_WARNING=!1,e.DisposableStore=h;class p{constructor(){this.q=new h,A(this),I(this.q,this)}dispose(){y(this),this.q.dispose()}B(n){if(n===this)throw new Error("Cannot register a disposable on itself!");return this.q.add(n)}}p.None=Object.freeze({dispose(){}}),e.Disposable=p;class b{constructor(){this.b=!1,A(this)}get value(){return this.b?void 0:this.a}set value(n){this.b||n===this.a||(this.a?.dispose(),n&&I(n,this),this.a=n)}clear(){this.value=void 0}dispose(){this.b=!0,y(this),this.a?.dispose(),this.a=void 0}clearAndLeak(){const n=this.a;return this.a=void 0,n&&I(n,null),n}}e.MutableDisposable=b;class C{constructor(n){this.b=n,this.a=1}acquire(){return this.a++,this}release(){return--this.a===0&&this.b.dispose(),this}}e.RefCountedDisposable=C;class g{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,A(this)}set(n){let t=n;return this.unset=()=>t=void 0,this.isset=()=>t!==void 0,this.dispose=()=>{t&&(t(),t=void 0,y(this))},this}}e.SafeDisposable=g;class i{constructor(){this.a=new Map}acquire(n,...t){let d=this.a.get(n);d||(d={counter:0,object:this.b(n,...t)},this.a.set(n,d));const{object:E}=d,w=(0,a.once)(()=>{--d.counter===0&&(this.c(n,d.object),this.a.delete(n))});return d.counter++,{object:E,dispose:w}}}e.ReferenceCollection=i;class s{constructor(n){this.a=n}async acquire(n,...t){const d=this.a.acquire(n,...t);try{return{object:await d.object,dispose:()=>d.dispose()}}catch(E){throw d.dispose(),E}}}e.AsyncReferenceCollection=s;class r{constructor(n){this.object=n}dispose(){}}e.ImmortalReference=r;function o(m){const n=new h;try{m(n)}finally{n.dispose()}}e.disposeOnReturn=o;class c{constructor(){this.a=new Map,this.b=!1,A(this)}dispose(){y(this),this.b=!0,this.clearAndDisposeAll()}clearAndDisposeAll(){if(!!this.a.size)try{k(this.a.values())}finally{this.a.clear()}}has(n){return this.a.has(n)}get(n){return this.a.get(n)}set(n,t,d=!1){this.b&&console.warn(new Error("Trying to add a disposable to a DisposableMap that has already been disposed of. The added object will be leaked!").stack),d||this.a.get(n)?.dispose(),this.a.set(n,t)}deleteAndDispose(n){this.a.get(n)?.dispose(),this.a.delete(n)}[Symbol.iterator](){return this.a[Symbol.iterator]()}}e.DisposableMap=c}),define(ye[67],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class a{constructor(R){this.element=R,this.next=a.Undefined,this.prev=a.Undefined}}a.Undefined=new a(void 0);class L{constructor(){this.a=a.Undefined,this.b=a.Undefined,this.c=0}get size(){return this.c}isEmpty(){return this.a===a.Undefined}clear(){let R=this.a;for(;R!==a.Undefined;){const S=R.next;R.prev=a.Undefined,R.next=a.Undefined,R=S}this.a=a.Undefined,this.b=a.Undefined,this.c=0}unshift(R){return this.d(R,!1)}push(R){return this.d(R,!0)}d(R,S){const A=new a(R);if(this.a===a.Undefined)this.a=A,this.b=A;else if(S){const I=this.b;this.b=A,A.prev=I,I.next=A}else{const I=this.a;this.a=A,A.next=I,I.prev=A}this.c+=1;let y=!1;return()=>{y||(y=!0,this.e(A))}}shift(){if(this.a!==a.Undefined){const R=this.a.element;return this.e(this.a),R}}pop(){if(this.b!==a.Undefined){const R=this.b.element;return this.e(this.b),R}}e(R){if(R.prev!==a.Undefined&&R.next!==a.Undefined){const S=R.prev;S.next=R.next,R.next.prev=S}else R.prev===a.Undefined&&R.next===a.Undefined?(this.a=a.Undefined,this.b=a.Undefined):R.next===a.Undefined?(this.b=this.b.prev,this.b.next=a.Undefined):R.prev===a.Undefined&&(this.a=this.a.next,this.a.prev=a.Undefined);this.c-=1}*[Symbol.iterator](){let R=this.a;for(;R!==a.Undefined;)yield R.element,R=R.next}}e.LinkedList=L}),define(ye[28],De([1,0]),function(re,e){"use strict";var a,L,l;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.setToString=e.mapToString=e.getOrSet=void 0;function R(D,f,u){let h=D.get(f);return h===void 0&&(h=u,D.set(f,h)),h}e.getOrSet=R;function S(D){const f=[];return D.forEach((u,h)=>{f.push(`${h} => ${u}`)}),`Map(${D.size}) {${f.join(", ")}}`}e.mapToString=S;function A(D){const f=[];return D.forEach(u=>{f.push(u)}),`Set(${D.size}) {${f.join(", ")}}`}e.setToString=A;class y{constructor(f,u){this.uri=f,this.value=u}}class I{constructor(f,u){this[a]="ResourceMap",f instanceof I?(this.b=new Map(f.b),this.c=u??I.a):(this.b=new Map,this.c=f??I.a)}set(f,u){return this.b.set(this.c(f),new y(f,u)),this}get(f){return this.b.get(this.c(f))?.value}has(f){return this.b.has(this.c(f))}get size(){return this.b.size}clear(){this.b.clear()}delete(f){return this.b.delete(this.c(f))}forEach(f,u){typeof u<"u"&&(f=f.bind(u));for(const[h,p]of this.b)f(p.value,p.uri,this)}*values(){for(const f of this.b.values())yield f.value}*keys(){for(const f of this.b.values())yield f.uri}*entries(){for(const f of this.b.values())yield[f.uri,f.value]}*[(a=Symbol.toStringTag,Symbol.iterator)](){for(const[,f]of this.b)yield[f.uri,f.value]}}I.a=D=>D.toString(),e.ResourceMap=I;class O{constructor(f,u){this[L]="ResourceSet",!f||typeof f=="function"?this.a=new I(f):(this.a=new I(u),f.forEach(this.add,this))}get size(){return this.a.size}add(f){return this.a.set(f,f),this}clear(){this.a.clear()}delete(f){return this.a.delete(f)}forEach(f,u){this.a.forEach((h,p)=>f.call(u,p,p,this))}has(f){return this.a.has(f)}entries(){return this.a.entries()}keys(){return this.a.keys()}values(){return this.a.keys()}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=O;var P;(function(D){D[D.None=0]="None",D[D.AsOld=1]="AsOld",D[D.AsNew=2]="AsNew"})(P=e.Touch||(e.Touch={}));class v{constructor(){this[l]="LinkedMap",this.a=new Map,this.b=void 0,this.c=void 0,this.d=0,this.e=0}clear(){this.a.clear(),this.b=void 0,this.c=void 0,this.d=0,this.e++}isEmpty(){return!this.b&&!this.c}get size(){return this.d}get first(){return this.b?.value}get last(){return this.c?.value}has(f){return this.a.has(f)}get(f,u=0){const h=this.a.get(f);if(!!h)return u!==0&&this.j(h,u),h.value}set(f,u,h=0){let p=this.a.get(f);if(p)p.value=u,h!==0&&this.j(p,h);else{switch(p={key:f,value:u,next:void 0,previous:void 0},h){case 0:this.h(p);break;case 1:this.g(p);break;case 2:this.h(p);break;default:this.h(p);break}this.a.set(f,p),this.d++}return this}delete(f){return!!this.remove(f)}remove(f){const u=this.a.get(f);if(!!u)return this.a.delete(f),this.i(u),this.d--,u.value}shift(){if(!this.b&&!this.c)return;if(!this.b||!this.c)throw new Error("Invalid list");const f=this.b;return this.a.delete(f.key),this.i(f),this.d--,f.value}forEach(f,u){const h=this.e;let p=this.b;for(;p;){if(u?f.bind(u)(p.value,p.key,this):f(p.value,p.key,this),this.e!==h)throw new Error("LinkedMap got modified during iteration.");p=p.next}}keys(){const f=this,u=this.e;let h=this.b;const p={[Symbol.iterator](){return p},next(){if(f.e!==u)throw new Error("LinkedMap got modified during iteration.");if(h){const b={value:h.key,done:!1};return h=h.next,b}else return{value:void 0,done:!0}}};return p}values(){const f=this,u=this.e;let h=this.b;const p={[Symbol.iterator](){return p},next(){if(f.e!==u)throw new Error("LinkedMap got modified during iteration.");if(h){const b={value:h.value,done:!1};return h=h.next,b}else return{value:void 0,done:!0}}};return p}entries(){const f=this,u=this.e;let h=this.b;const p={[Symbol.iterator](){return p},next(){if(f.e!==u)throw new Error("LinkedMap got modified during iteration.");if(h){const b={value:[h.key,h.value],done:!1};return h=h.next,b}else return{value:void 0,done:!0}}};return p}[(l=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}f(f){if(f>=this.size)return;if(f===0){this.clear();return}let u=this.b,h=this.size;for(;u&&h>f;)this.a.delete(u.key),u=u.next,h--;this.b=u,this.d=h,u&&(u.previous=void 0),this.e++}g(f){if(!this.b&&!this.c)this.c=f;else if(this.b)f.next=this.b,this.b.previous=f;else throw new Error("Invalid list");this.b=f,this.e++}h(f){if(!this.b&&!this.c)this.b=f;else if(this.c)f.previous=this.c,this.c.next=f;else throw new Error("Invalid list");this.c=f,this.e++}i(f){if(f===this.b&&f===this.c)this.b=void 0,this.c=void 0;else if(f===this.b){if(!f.next)throw new Error("Invalid list");f.next.previous=void 0,this.b=f.next}else if(f===this.c){if(!f.previous)throw new Error("Invalid list");f.previous.next=void 0,this.c=f.previous}else{const u=f.next,h=f.previous;if(!u||!h)throw new Error("Invalid list");u.previous=h,h.next=u}f.next=void 0,f.previous=void 0,this.e++}j(f,u){if(!this.b||!this.c)throw new Error("Invalid list");if(!(u!==1&&u!==2)){if(u===1){if(f===this.b)return;const h=f.next,p=f.previous;f===this.c?(p.next=void 0,this.c=p):(h.previous=p,p.next=h),f.previous=void 0,f.next=this.b,this.b.previous=f,this.b=f,this.e++}else if(u===2){if(f===this.c)return;const h=f.next,p=f.previous;f===this.b?(h.previous=void 0,this.b=h):(h.previous=p,p.next=h),f.next=void 0,f.previous=this.c,this.c.next=f,this.c=f,this.e++}}}toJSON(){const f=[];return this.forEach((u,h)=>{f.push([h,u])}),f}fromJSON(f){this.clear();for(const[u,h]of f)this.set(u,h)}}e.LinkedMap=v;class k extends v{constructor(f,u=1){super(),this.k=f,this.l=Math.min(Math.max(0,u),1)}get limit(){return this.k}set limit(f){this.k=f,this.m()}get ratio(){return this.l}set ratio(f){this.l=Math.min(Math.max(0,f),1),this.m()}get(f,u=2){return super.get(f,u)}peek(f){return super.get(f,0)}set(f,u){return super.set(f,u,2),this.m(),this}m(){this.size>this.k&&this.f(Math.round(this.k*this.l))}}e.LRUCache=k}),function(re,e){typeof exports=="object"&&typeof module<"u"?e(exports):typeof define=="function"&&define.amd?define(ye[147],De([0]),e):(re=typeof globalThis<"u"?globalThis:re||self,e(re.marked={}))}(this,function(re){"use strict";function e(ae,le){for(var ue=0;ue<le.length;ue++){var ne=le[ue];ne.enumerable=ne.enumerable||!1,ne.configurable=!0,"value"in ne&&(ne.writable=!0),Object.defineProperty(ae,ne.key,ne)}}function a(ae,le,ue){return le&&e(ae.prototype,le),ue&&e(ae,ue),Object.defineProperty(ae,"prototype",{writable:!1}),ae}function L(ae,le){if(!!ae){if(typeof ae=="string")return l(ae,le);var ue=Object.prototype.toString.call(ae).slice(8,-1);if(ue==="Object"&&ae.constructor&&(ue=ae.constructor.name),ue==="Map"||ue==="Set")return Array.from(ae);if(ue==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ue))return l(ae,le)}}function l(ae,le){(le==null||le>ae.length)&&(le=ae.length);for(var ue=0,ne=new Array(le);ue<le;ue++)ne[ue]=ae[ue];return ne}function R(ae,le){var ue=typeof Symbol<"u"&&ae[Symbol.iterator]||ae["@@iterator"];if(ue)return(ue=ue.call(ae)).next.bind(ue);if(Array.isArray(ae)||(ue=L(ae))||le&&ae&&typeof ae.length=="number"){ue&&(ae=ue);var ne=0;return function(){return ne>=ae.length?{done:!0}:{done:!1,value:ae[ne++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function S(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}re.defaults=S();function A(ae){re.defaults=ae}var y=/[&<>"']/,I=/[&<>"']/g,O=/[<>"']|&(?!#?\w+;)/,P=/[<>"']|&(?!#?\w+;)/g,v={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},k=function(le){return v[le]};function D(ae,le){if(le){if(y.test(ae))return ae.replace(I,k)}else if(O.test(ae))return ae.replace(P,k);return ae}var f=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function u(ae){return ae.replace(f,function(le,ue){return ue=ue.toLowerCase(),ue==="colon"?":":ue.charAt(0)==="#"?ue.charAt(1)==="x"?String.fromCharCode(parseInt(ue.substring(2),16)):String.fromCharCode(+ue.substring(1)):""})}var h=/(^|[^\[])\^/g;function p(ae,le){ae=typeof ae=="string"?ae:ae.source,le=le||"";var ue={replace:function(ce,oe){return oe=oe.source||oe,oe=oe.replace(h,"$1"),ae=ae.replace(ce,oe),ue},getRegex:function(){return new RegExp(ae,le)}};return ue}var b=/[^\w:]/g,C=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function g(ae,le,ue){if(ae){var ne;try{ne=decodeURIComponent(u(ue)).replace(b,"").toLowerCase()}catch{return null}if(ne.indexOf("javascript:")===0||ne.indexOf("vbscript:")===0||ne.indexOf("data:")===0)return null}le&&!C.test(ue)&&(ue=c(le,ue));try{ue=encodeURI(ue).replace(/%25/g,"%")}catch{return null}return ue}var i={},s=/^[^:]+:\/*[^/]*$/,r=/^([^:]+:)[\s\S]*$/,o=/^([^:]+:\/*[^/]*)[\s\S]*$/;function c(ae,le){i[" "+ae]||(s.test(ae)?i[" "+ae]=ae+"/":i[" "+ae]=d(ae,"/",!0)),ae=i[" "+ae];var ue=ae.indexOf(":")===-1;return le.substring(0,2)==="//"?ue?le:ae.replace(r,"$1")+le:le.charAt(0)==="/"?ue?le:ae.replace(o,"$1")+le:ae+le}var m={exec:function(){}};function n(ae){for(var le=1,ue,ne;le<arguments.length;le++){ue=arguments[le];for(ne in ue)Object.prototype.hasOwnProperty.call(ue,ne)&&(ae[ne]=ue[ne])}return ae}function t(ae,le){var ue=ae.replace(/\|/g,function(oe,M,z){for(var G=!1,te=M;--te>=0&&z[te]==="\\";)G=!G;return G?"|":" |"}),ne=ue.split(/ \|/),ce=0;if(ne[0].trim()||ne.shift(),ne.length>0&&!ne[ne.length-1].trim()&&ne.pop(),ne.length>le)ne.splice(le);else for(;ne.length<le;)ne.push("");for(;ce<ne.length;ce++)ne[ce]=ne[ce].trim().replace(/\\\|/g,"|");return ne}function d(ae,le,ue){var ne=ae.length;if(ne===0)return"";for(var ce=0;ce<ne;){var oe=ae.charAt(ne-ce-1);if(oe===le&&!ue)ce++;else if(oe!==le&&ue)ce++;else break}return ae.slice(0,ne-ce)}function E(ae,le){if(ae.indexOf(le[1])===-1)return-1;for(var ue=ae.length,ne=0,ce=0;ce<ue;ce++)if(ae[ce]==="\\")ce++;else if(ae[ce]===le[0])ne++;else if(ae[ce]===le[1]&&(ne--,ne<0))return ce;return-1}function w(ae){ae&&ae.sanitize&&!ae.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function N(ae,le){if(le<1)return"";for(var ue="";le>1;)le&1&&(ue+=ae),le>>=1,ae+=ae;return ue+ae}function j(ae,le,ue,ne){var ce=le.href,oe=le.title?D(le.title):null,M=ae[1].replace(/\\([\[\]])/g,"$1");if(ae[0].charAt(0)!=="!"){ne.state.inLink=!0;var z={type:"link",raw:ue,href:ce,title:oe,text:M,tokens:ne.inlineTokens(M)};return ne.state.inLink=!1,z}return{type:"image",raw:ue,href:ce,title:oe,text:D(M)}}function V(ae,le){var ue=ae.match(/^(\s+)(?:```)/);if(ue===null)return le;var ne=ue[1];return le.split(`
`).map(function(ce){var oe=ce.match(/^\s+/);if(oe===null)return ce;var M=oe[0];return M.length>=ne.length?ce.slice(ne.length):ce}).join(`
`)}var Q=function(){function ae(ue){this.options=ue||re.defaults}var le=ae.prototype;return le.space=function(ne){var ce=this.rules.block.newline.exec(ne);if(ce&&ce[0].length>0)return{type:"space",raw:ce[0]}},le.code=function(ne){var ce=this.rules.block.code.exec(ne);if(ce){var oe=ce[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ce[0],codeBlockStyle:"indented",text:this.options.pedantic?oe:d(oe,`
`)}}},le.fences=function(ne){var ce=this.rules.block.fences.exec(ne);if(ce){var oe=ce[0],M=V(oe,ce[3]||"");return{type:"code",raw:oe,lang:ce[2]?ce[2].trim():ce[2],text:M}}},le.heading=function(ne){var ce=this.rules.block.heading.exec(ne);if(ce){var oe=ce[2].trim();if(/#$/.test(oe)){var M=d(oe,"#");(this.options.pedantic||!M||/ $/.test(M))&&(oe=M.trim())}return{type:"heading",raw:ce[0],depth:ce[1].length,text:oe,tokens:this.lexer.inline(oe)}}},le.hr=function(ne){var ce=this.rules.block.hr.exec(ne);if(ce)return{type:"hr",raw:ce[0]}},le.blockquote=function(ne){var ce=this.rules.block.blockquote.exec(ne);if(ce){var oe=ce[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:ce[0],tokens:this.lexer.blockTokens(oe,[]),text:oe}}},le.list=function(ne){var ce=this.rules.block.list.exec(ne);if(ce){var oe,M,z,G,te,de,we,Pe,be,Ce,ke,He,Ge=ce[1].trim(),nt=Ge.length>1,Qe={type:"list",raw:"",ordered:nt,start:nt?+Ge.slice(0,-1):"",loose:!1,items:[]};Ge=nt?"\\d{1,9}\\"+Ge.slice(-1):"\\"+Ge,this.options.pedantic&&(Ge=nt?Ge:"[*+-]");for(var tt=new RegExp("^( {0,3}"+Ge+")((?:[	 ][^\\n]*)?(?:\\n|$))");ne&&(He=!1,!(!(ce=tt.exec(ne))||this.rules.block.hr.test(ne)));){if(oe=ce[0],ne=ne.substring(oe.length),Pe=ce[2].split(`
`,1)[0],be=ne.split(`
`,1)[0],this.options.pedantic?(G=2,ke=Pe.trimLeft()):(G=ce[2].search(/[^ ]/),G=G>4?1:G,ke=Pe.slice(G),G+=ce[1].length),de=!1,!Pe&&/^ *$/.test(be)&&(oe+=be+`
`,ne=ne.substring(be.length+1),He=!0),!He)for(var rt=new RegExp("^ {0,"+Math.min(3,G-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),Be=new RegExp("^ {0,"+Math.min(3,G-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),it=new RegExp("^ {0,"+Math.min(3,G-1)+"}(?:```|~~~)"),$=new RegExp("^ {0,"+Math.min(3,G-1)+"}#");ne&&(Ce=ne.split(`
`,1)[0],Pe=Ce,this.options.pedantic&&(Pe=Pe.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(it.test(Pe)||$.test(Pe)||rt.test(Pe)||Be.test(ne)));){if(Pe.search(/[^ ]/)>=G||!Pe.trim())ke+=`
`+Pe.slice(G);else if(!de)ke+=`
`+Pe;else break;!de&&!Pe.trim()&&(de=!0),oe+=Ce+`
`,ne=ne.substring(Ce.length+1)}Qe.loose||(we?Qe.loose=!0:/\n *\n *$/.test(oe)&&(we=!0)),this.options.gfm&&(M=/^\[[ xX]\] /.exec(ke),M&&(z=M[0]!=="[ ] ",ke=ke.replace(/^\[[ xX]\] +/,""))),Qe.items.push({type:"list_item",raw:oe,task:!!M,checked:z,loose:!1,text:ke}),Qe.raw+=oe}Qe.items[Qe.items.length-1].raw=oe.trimRight(),Qe.items[Qe.items.length-1].text=ke.trimRight(),Qe.raw=Qe.raw.trimRight();var K=Qe.items.length;for(te=0;te<K;te++){this.lexer.state.top=!1,Qe.items[te].tokens=this.lexer.blockTokens(Qe.items[te].text,[]);var he=Qe.items[te].tokens.filter(function(Ne){return Ne.type==="space"}),Le=he.every(function(Ne){for(var xe=Ne.raw.split(""),je=0,Ze=R(xe),st;!(st=Ze()).done;){var at=st.value;if(at===`
`&&(je+=1),je>1)return!0}return!1});!Qe.loose&&he.length&&Le&&(Qe.loose=!0,Qe.items[te].loose=!0)}return Qe}},le.html=function(ne){var ce=this.rules.block.html.exec(ne);if(ce){var oe={type:"html",raw:ce[0],pre:!this.options.sanitizer&&(ce[1]==="pre"||ce[1]==="script"||ce[1]==="style"),text:ce[0]};if(this.options.sanitize){var M=this.options.sanitizer?this.options.sanitizer(ce[0]):D(ce[0]);oe.type="paragraph",oe.text=M,oe.tokens=this.lexer.inline(M)}return oe}},le.def=function(ne){var ce=this.rules.block.def.exec(ne);if(ce){ce[3]&&(ce[3]=ce[3].substring(1,ce[3].length-1));var oe=ce[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:oe,raw:ce[0],href:ce[2],title:ce[3]}}},le.table=function(ne){var ce=this.rules.block.table.exec(ne);if(ce){var oe={type:"table",header:t(ce[1]).map(function(we){return{text:we}}),align:ce[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ce[3]&&ce[3].trim()?ce[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(oe.header.length===oe.align.length){oe.raw=ce[0];var M=oe.align.length,z,G,te,de;for(z=0;z<M;z++)/^ *-+: *$/.test(oe.align[z])?oe.align[z]="right":/^ *:-+: *$/.test(oe.align[z])?oe.align[z]="center":/^ *:-+ *$/.test(oe.align[z])?oe.align[z]="left":oe.align[z]=null;for(M=oe.rows.length,z=0;z<M;z++)oe.rows[z]=t(oe.rows[z],oe.header.length).map(function(we){return{text:we}});for(M=oe.header.length,G=0;G<M;G++)oe.header[G].tokens=this.lexer.inline(oe.header[G].text);for(M=oe.rows.length,G=0;G<M;G++)for(de=oe.rows[G],te=0;te<de.length;te++)de[te].tokens=this.lexer.inline(de[te].text);return oe}}},le.lheading=function(ne){var ce=this.rules.block.lheading.exec(ne);if(ce)return{type:"heading",raw:ce[0],depth:ce[2].charAt(0)==="="?1:2,text:ce[1],tokens:this.lexer.inline(ce[1])}},le.paragraph=function(ne){var ce=this.rules.block.paragraph.exec(ne);if(ce){var oe=ce[1].charAt(ce[1].length-1)===`
`?ce[1].slice(0,-1):ce[1];return{type:"paragraph",raw:ce[0],text:oe,tokens:this.lexer.inline(oe)}}},le.text=function(ne){var ce=this.rules.block.text.exec(ne);if(ce)return{type:"text",raw:ce[0],text:ce[0],tokens:this.lexer.inline(ce[0])}},le.escape=function(ne){var ce=this.rules.inline.escape.exec(ne);if(ce)return{type:"escape",raw:ce[0],text:D(ce[1])}},le.tag=function(ne){var ce=this.rules.inline.tag.exec(ne);if(ce)return!this.lexer.state.inLink&&/^<a /i.test(ce[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ce[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ce[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ce[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ce[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ce[0]):D(ce[0]):ce[0]}},le.link=function(ne){var ce=this.rules.inline.link.exec(ne);if(ce){var oe=ce[2].trim();if(!this.options.pedantic&&/^</.test(oe)){if(!/>$/.test(oe))return;var M=d(oe.slice(0,-1),"\\");if((oe.length-M.length)%2===0)return}else{var z=E(ce[2],"()");if(z>-1){var G=ce[0].indexOf("!")===0?5:4,te=G+ce[1].length+z;ce[2]=ce[2].substring(0,z),ce[0]=ce[0].substring(0,te).trim(),ce[3]=""}}var de=ce[2],we="";if(this.options.pedantic){var Pe=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(de);Pe&&(de=Pe[1],we=Pe[3])}else we=ce[3]?ce[3].slice(1,-1):"";return de=de.trim(),/^</.test(de)&&(this.options.pedantic&&!/>$/.test(oe)?de=de.slice(1):de=de.slice(1,-1)),j(ce,{href:de&&de.replace(this.rules.inline._escapes,"$1"),title:we&&we.replace(this.rules.inline._escapes,"$1")},ce[0],this.lexer)}},le.reflink=function(ne,ce){var oe;if((oe=this.rules.inline.reflink.exec(ne))||(oe=this.rules.inline.nolink.exec(ne))){var M=(oe[2]||oe[1]).replace(/\s+/g," ");if(M=ce[M.toLowerCase()],!M||!M.href){var z=oe[0].charAt(0);return{type:"text",raw:z,text:z}}return j(oe,M,oe[0],this.lexer)}},le.emStrong=function(ne,ce,oe){oe===void 0&&(oe="");var M=this.rules.inline.emStrong.lDelim.exec(ne);if(!!M&&!(M[3]&&oe.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var z=M[1]||M[2]||"";if(!z||z&&(oe===""||this.rules.inline.punctuation.exec(oe))){var G=M[0].length-1,te,de,we=G,Pe=0,be=M[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(be.lastIndex=0,ce=ce.slice(-1*ne.length+G);(M=be.exec(ce))!=null;)if(te=M[1]||M[2]||M[3]||M[4]||M[5]||M[6],!!te){if(de=te.length,M[3]||M[4]){we+=de;continue}else if((M[5]||M[6])&&G%3&&!((G+de)%3)){Pe+=de;continue}if(we-=de,!(we>0)){if(de=Math.min(de,de+we+Pe),Math.min(G,de)%2){var Ce=ne.slice(1,G+M.index+de);return{type:"em",raw:ne.slice(0,G+M.index+de+1),text:Ce,tokens:this.lexer.inlineTokens(Ce)}}var ke=ne.slice(2,G+M.index+de-1);return{type:"strong",raw:ne.slice(0,G+M.index+de+1),text:ke,tokens:this.lexer.inlineTokens(ke)}}}}}},le.codespan=function(ne){var ce=this.rules.inline.code.exec(ne);if(ce){var oe=ce[2].replace(/\n/g," "),M=/[^ ]/.test(oe),z=/^ /.test(oe)&&/ $/.test(oe);return M&&z&&(oe=oe.substring(1,oe.length-1)),oe=D(oe,!0),{type:"codespan",raw:ce[0],text:oe}}},le.br=function(ne){var ce=this.rules.inline.br.exec(ne);if(ce)return{type:"br",raw:ce[0]}},le.del=function(ne){var ce=this.rules.inline.del.exec(ne);if(ce)return{type:"del",raw:ce[0],text:ce[2],tokens:this.lexer.inlineTokens(ce[2])}},le.autolink=function(ne,ce){var oe=this.rules.inline.autolink.exec(ne);if(oe){var M,z;return oe[2]==="@"?(M=D(this.options.mangle?ce(oe[1]):oe[1]),z="mailto:"+M):(M=D(oe[1]),z=M),{type:"link",raw:oe[0],text:M,href:z,tokens:[{type:"text",raw:M,text:M}]}}},le.url=function(ne,ce){var oe;if(oe=this.rules.inline.url.exec(ne)){var M,z;if(oe[2]==="@")M=D(this.options.mangle?ce(oe[0]):oe[0]),z="mailto:"+M;else{var G;do G=oe[0],oe[0]=this.rules.inline._backpedal.exec(oe[0])[0];while(G!==oe[0]);M=D(oe[0]),oe[1]==="www."?z="http://"+M:z=M}return{type:"link",raw:oe[0],text:M,href:z,tokens:[{type:"text",raw:M,text:M}]}}},le.inlineText=function(ne,ce){var oe=this.rules.inline.text.exec(ne);if(oe){var M;return this.lexer.state.inRawBlock?M=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(oe[0]):D(oe[0]):oe[0]:M=D(this.options.smartypants?ce(oe[0]):oe[0]),{type:"text",raw:oe[0],text:M}}},ae}(),x={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:m,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};x._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,x._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,x.def=p(x.def).replace("label",x._label).replace("title",x._title).getRegex(),x.bullet=/(?:[*+-]|\d{1,9}[.)])/,x.listItemStart=p(/^( *)(bull) */).replace("bull",x.bullet).getRegex(),x.list=p(x.list).replace(/bull/g,x.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+x.def.source+")").getRegex(),x._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",x._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,x.html=p(x.html,"i").replace("comment",x._comment).replace("tag",x._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),x.paragraph=p(x._paragraph).replace("hr",x.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",x._tag).getRegex(),x.blockquote=p(x.blockquote).replace("paragraph",x.paragraph).getRegex(),x.normal=n({},x),x.gfm=n({},x.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),x.gfm.table=p(x.gfm.table).replace("hr",x.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",x._tag).getRegex(),x.gfm.paragraph=p(x._paragraph).replace("hr",x.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",x.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",x._tag).getRegex(),x.pedantic=n({},x.normal,{html:p(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",x._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:m,paragraph:p(x.normal._paragraph).replace("hr",x.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",x.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var U={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:m,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:m,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};U._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",U.punctuation=p(U.punctuation).replace(/punctuation/g,U._punctuation).getRegex(),U.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,U.escapedEmSt=/\\\*|\\_/g,U._comment=p(x._comment).replace("(?:-->|$)","-->").getRegex(),U.emStrong.lDelim=p(U.emStrong.lDelim).replace(/punct/g,U._punctuation).getRegex(),U.emStrong.rDelimAst=p(U.emStrong.rDelimAst,"g").replace(/punct/g,U._punctuation).getRegex(),U.emStrong.rDelimUnd=p(U.emStrong.rDelimUnd,"g").replace(/punct/g,U._punctuation).getRegex(),U._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,U._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,U._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,U.autolink=p(U.autolink).replace("scheme",U._scheme).replace("email",U._email).getRegex(),U._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,U.tag=p(U.tag).replace("comment",U._comment).replace("attribute",U._attribute).getRegex(),U._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,U._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,U._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,U.link=p(U.link).replace("label",U._label).replace("href",U._href).replace("title",U._title).getRegex(),U.reflink=p(U.reflink).replace("label",U._label).replace("ref",x._label).getRegex(),U.nolink=p(U.nolink).replace("ref",x._label).getRegex(),U.reflinkSearch=p(U.reflinkSearch,"g").replace("reflink",U.reflink).replace("nolink",U.nolink).getRegex(),U.normal=n({},U),U.pedantic=n({},U.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:p(/^!?\[(label)\]\((.*?)\)/).replace("label",U._label).getRegex(),reflink:p(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",U._label).getRegex()}),U.gfm=n({},U.normal,{escape:p(U.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),U.gfm.url=p(U.gfm.url,"i").replace("email",U.gfm._extended_email).getRegex(),U.breaks=n({},U.gfm,{br:p(U.br).replace("{2,}","*").getRegex(),text:p(U.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function T(ae){return ae.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function F(ae){var le="",ue,ne,ce=ae.length;for(ue=0;ue<ce;ue++)ne=ae.charCodeAt(ue),Math.random()>.5&&(ne="x"+ne.toString(16)),le+="&#"+ne+";";return le}var B=function(){function ae(ue){this.tokens=[],this.tokens.links=Object.create(null),this.options=ue||re.defaults,this.options.tokenizer=this.options.tokenizer||new Q,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ne={block:x.normal,inline:U.normal};this.options.pedantic?(ne.block=x.pedantic,ne.inline=U.pedantic):this.options.gfm&&(ne.block=x.gfm,this.options.breaks?ne.inline=U.breaks:ne.inline=U.gfm),this.tokenizer.rules=ne}ae.lex=function(ne,ce){var oe=new ae(ce);return oe.lex(ne)},ae.lexInline=function(ne,ce){var oe=new ae(ce);return oe.inlineTokens(ne)};var le=ae.prototype;return le.lex=function(ne){ne=ne.replace(/\r\n|\r/g,`
`),this.blockTokens(ne,this.tokens);for(var ce;ce=this.inlineQueue.shift();)this.inlineTokens(ce.src,ce.tokens);return this.tokens},le.blockTokens=function(ne,ce){var oe=this;ce===void 0&&(ce=[]),this.options.pedantic?ne=ne.replace(/\t/g,"    ").replace(/^ +$/gm,""):ne=ne.replace(/^( *)(\t+)/gm,function(we,Pe,be){return Pe+"    ".repeat(be.length)});for(var M,z,G,te;ne;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(we){return(M=we.call({lexer:oe},ne,ce))?(ne=ne.substring(M.raw.length),ce.push(M),!0):!1}))){if(M=this.tokenizer.space(ne)){ne=ne.substring(M.raw.length),M.raw.length===1&&ce.length>0?ce[ce.length-1].raw+=`
`:ce.push(M);continue}if(M=this.tokenizer.code(ne)){ne=ne.substring(M.raw.length),z=ce[ce.length-1],z&&(z.type==="paragraph"||z.type==="text")?(z.raw+=`
`+M.raw,z.text+=`
`+M.text,this.inlineQueue[this.inlineQueue.length-1].src=z.text):ce.push(M);continue}if(M=this.tokenizer.fences(ne)){ne=ne.substring(M.raw.length),ce.push(M);continue}if(M=this.tokenizer.heading(ne)){ne=ne.substring(M.raw.length),ce.push(M);continue}if(M=this.tokenizer.hr(ne)){ne=ne.substring(M.raw.length),ce.push(M);continue}if(M=this.tokenizer.blockquote(ne)){ne=ne.substring(M.raw.length),ce.push(M);continue}if(M=this.tokenizer.list(ne)){ne=ne.substring(M.raw.length),ce.push(M);continue}if(M=this.tokenizer.html(ne)){ne=ne.substring(M.raw.length),ce.push(M);continue}if(M=this.tokenizer.def(ne)){ne=ne.substring(M.raw.length),z=ce[ce.length-1],z&&(z.type==="paragraph"||z.type==="text")?(z.raw+=`
`+M.raw,z.text+=`
`+M.raw,this.inlineQueue[this.inlineQueue.length-1].src=z.text):this.tokens.links[M.tag]||(this.tokens.links[M.tag]={href:M.href,title:M.title});continue}if(M=this.tokenizer.table(ne)){ne=ne.substring(M.raw.length),ce.push(M);continue}if(M=this.tokenizer.lheading(ne)){ne=ne.substring(M.raw.length),ce.push(M);continue}if(G=ne,this.options.extensions&&this.options.extensions.startBlock&&function(){var we=1/0,Pe=ne.slice(1),be=void 0;oe.options.extensions.startBlock.forEach(function(Ce){be=Ce.call({lexer:this},Pe),typeof be=="number"&&be>=0&&(we=Math.min(we,be))}),we<1/0&&we>=0&&(G=ne.substring(0,we+1))}(),this.state.top&&(M=this.tokenizer.paragraph(G))){z=ce[ce.length-1],te&&z.type==="paragraph"?(z.raw+=`
`+M.raw,z.text+=`
`+M.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=z.text):ce.push(M),te=G.length!==ne.length,ne=ne.substring(M.raw.length);continue}if(M=this.tokenizer.text(ne)){ne=ne.substring(M.raw.length),z=ce[ce.length-1],z&&z.type==="text"?(z.raw+=`
`+M.raw,z.text+=`
`+M.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=z.text):ce.push(M);continue}if(ne){var de="Infinite loop on byte: "+ne.charCodeAt(0);if(this.options.silent){console.error(de);break}else throw new Error(de)}}return this.state.top=!0,ce},le.inline=function(ne,ce){return ce===void 0&&(ce=[]),this.inlineQueue.push({src:ne,tokens:ce}),ce},le.inlineTokens=function(ne,ce){var oe=this;ce===void 0&&(ce=[]);var M,z,G,te=ne,de,we,Pe;if(this.tokens.links){var be=Object.keys(this.tokens.links);if(be.length>0)for(;(de=this.tokenizer.rules.inline.reflinkSearch.exec(te))!=null;)be.includes(de[0].slice(de[0].lastIndexOf("[")+1,-1))&&(te=te.slice(0,de.index)+"["+N("a",de[0].length-2)+"]"+te.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(de=this.tokenizer.rules.inline.blockSkip.exec(te))!=null;)te=te.slice(0,de.index)+"["+N("a",de[0].length-2)+"]"+te.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(de=this.tokenizer.rules.inline.escapedEmSt.exec(te))!=null;)te=te.slice(0,de.index)+"++"+te.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ne;)if(we||(Pe=""),we=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ke){return(M=ke.call({lexer:oe},ne,ce))?(ne=ne.substring(M.raw.length),ce.push(M),!0):!1}))){if(M=this.tokenizer.escape(ne)){ne=ne.substring(M.raw.length),ce.push(M);continue}if(M=this.tokenizer.tag(ne)){ne=ne.substring(M.raw.length),z=ce[ce.length-1],z&&M.type==="text"&&z.type==="text"?(z.raw+=M.raw,z.text+=M.text):ce.push(M);continue}if(M=this.tokenizer.link(ne)){ne=ne.substring(M.raw.length),ce.push(M);continue}if(M=this.tokenizer.reflink(ne,this.tokens.links)){ne=ne.substring(M.raw.length),z=ce[ce.length-1],z&&M.type==="text"&&z.type==="text"?(z.raw+=M.raw,z.text+=M.text):ce.push(M);continue}if(M=this.tokenizer.emStrong(ne,te,Pe)){ne=ne.substring(M.raw.length),ce.push(M);continue}if(M=this.tokenizer.codespan(ne)){ne=ne.substring(M.raw.length),ce.push(M);continue}if(M=this.tokenizer.br(ne)){ne=ne.substring(M.raw.length),ce.push(M);continue}if(M=this.tokenizer.del(ne)){ne=ne.substring(M.raw.length),ce.push(M);continue}if(M=this.tokenizer.autolink(ne,F)){ne=ne.substring(M.raw.length),ce.push(M);continue}if(!this.state.inLink&&(M=this.tokenizer.url(ne,F))){ne=ne.substring(M.raw.length),ce.push(M);continue}if(G=ne,this.options.extensions&&this.options.extensions.startInline&&function(){var ke=1/0,He=ne.slice(1),Ge=void 0;oe.options.extensions.startInline.forEach(function(nt){Ge=nt.call({lexer:this},He),typeof Ge=="number"&&Ge>=0&&(ke=Math.min(ke,Ge))}),ke<1/0&&ke>=0&&(G=ne.substring(0,ke+1))}(),M=this.tokenizer.inlineText(G,T)){ne=ne.substring(M.raw.length),M.raw.slice(-1)!=="_"&&(Pe=M.raw.slice(-1)),we=!0,z=ce[ce.length-1],z&&z.type==="text"?(z.raw+=M.raw,z.text+=M.text):ce.push(M);continue}if(ne){var Ce="Infinite loop on byte: "+ne.charCodeAt(0);if(this.options.silent){console.error(Ce);break}else throw new Error(Ce)}}return ce},a(ae,null,[{key:"rules",get:function(){return{block:x,inline:U}}}]),ae}(),Z=function(){function ae(ue){this.options=ue||re.defaults}var le=ae.prototype;return le.code=function(ne,ce,oe){var M=(ce||"").match(/\S*/)[0];if(this.options.highlight){var z=this.options.highlight(ne,M);z!=null&&z!==ne&&(oe=!0,ne=z)}return ne=ne.replace(/\n$/,"")+`
`,M?'<pre><code class="'+this.options.langPrefix+D(M,!0)+'">'+(oe?ne:D(ne,!0))+`</code></pre>
`:"<pre><code>"+(oe?ne:D(ne,!0))+`</code></pre>
`},le.blockquote=function(ne){return`<blockquote>
`+ne+`</blockquote>
`},le.html=function(ne){return ne},le.heading=function(ne,ce,oe,M){if(this.options.headerIds){var z=this.options.headerPrefix+M.slug(oe);return"<h"+ce+' id="'+z+'">'+ne+"</h"+ce+`>
`}return"<h"+ce+">"+ne+"</h"+ce+`>
`},le.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},le.list=function(ne,ce,oe){var M=ce?"ol":"ul",z=ce&&oe!==1?' start="'+oe+'"':"";return"<"+M+z+`>
`+ne+"</"+M+`>
`},le.listitem=function(ne){return"<li>"+ne+`</li>
`},le.checkbox=function(ne){return"<input "+(ne?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},le.paragraph=function(ne){return"<p>"+ne+`</p>
`},le.table=function(ne,ce){return ce&&(ce="<tbody>"+ce+"</tbody>"),`<table>
<thead>
`+ne+`</thead>
`+ce+`</table>
`},le.tablerow=function(ne){return`<tr>
`+ne+`</tr>
`},le.tablecell=function(ne,ce){var oe=ce.header?"th":"td",M=ce.align?"<"+oe+' align="'+ce.align+'">':"<"+oe+">";return M+ne+("</"+oe+`>
`)},le.strong=function(ne){return"<strong>"+ne+"</strong>"},le.em=function(ne){return"<em>"+ne+"</em>"},le.codespan=function(ne){return"<code>"+ne+"</code>"},le.br=function(){return this.options.xhtml?"<br/>":"<br>"},le.del=function(ne){return"<del>"+ne+"</del>"},le.link=function(ne,ce,oe){if(ne=g(this.options.sanitize,this.options.baseUrl,ne),ne===null)return oe;var M='<a href="'+D(ne)+'"';return ce&&(M+=' title="'+ce+'"'),M+=">"+oe+"</a>",M},le.image=function(ne,ce,oe){if(ne=g(this.options.sanitize,this.options.baseUrl,ne),ne===null)return oe;var M='<img src="'+ne+'" alt="'+oe+'"';return ce&&(M+=' title="'+ce+'"'),M+=this.options.xhtml?"/>":">",M},le.text=function(ne){return ne},ae}(),_=function(){function ae(){}var le=ae.prototype;return le.strong=function(ne){return ne},le.em=function(ne){return ne},le.codespan=function(ne){return ne},le.del=function(ne){return ne},le.html=function(ne){return ne},le.text=function(ne){return ne},le.link=function(ne,ce,oe){return""+oe},le.image=function(ne,ce,oe){return""+oe},le.br=function(){return""},ae}(),H=function(){function ae(){this.seen={}}var le=ae.prototype;return le.serialize=function(ne){return ne.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},le.getNextSafeSlug=function(ne,ce){var oe=ne,M=0;if(this.seen.hasOwnProperty(oe)){M=this.seen[ne];do M++,oe=ne+"-"+M;while(this.seen.hasOwnProperty(oe))}return ce||(this.seen[ne]=M,this.seen[oe]=0),oe},le.slug=function(ne,ce){ce===void 0&&(ce={});var oe=this.serialize(ne);return this.getNextSafeSlug(oe,ce.dryrun)},ae}(),Y=function(){function ae(ue){this.options=ue||re.defaults,this.options.renderer=this.options.renderer||new Z,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new _,this.slugger=new H}ae.parse=function(ne,ce){var oe=new ae(ce);return oe.parse(ne)},ae.parseInline=function(ne,ce){var oe=new ae(ce);return oe.parseInline(ne)};var le=ae.prototype;return le.parse=function(ne,ce){ce===void 0&&(ce=!0);var oe="",M,z,G,te,de,we,Pe,be,Ce,ke,He,Ge,nt,Qe,tt,rt,Be,it,$,K=ne.length;for(M=0;M<K;M++){if(ke=ne[M],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ke.type]&&($=this.options.extensions.renderers[ke.type].call({parser:this},ke),$!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ke.type))){oe+=$||"";continue}switch(ke.type){case"space":continue;case"hr":{oe+=this.renderer.hr();continue}case"heading":{oe+=this.renderer.heading(this.parseInline(ke.tokens),ke.depth,u(this.parseInline(ke.tokens,this.textRenderer)),this.slugger);continue}case"code":{oe+=this.renderer.code(ke.text,ke.lang,ke.escaped);continue}case"table":{for(be="",Pe="",te=ke.header.length,z=0;z<te;z++)Pe+=this.renderer.tablecell(this.parseInline(ke.header[z].tokens),{header:!0,align:ke.align[z]});for(be+=this.renderer.tablerow(Pe),Ce="",te=ke.rows.length,z=0;z<te;z++){for(we=ke.rows[z],Pe="",de=we.length,G=0;G<de;G++)Pe+=this.renderer.tablecell(this.parseInline(we[G].tokens),{header:!1,align:ke.align[G]});Ce+=this.renderer.tablerow(Pe)}oe+=this.renderer.table(be,Ce);continue}case"blockquote":{Ce=this.parse(ke.tokens),oe+=this.renderer.blockquote(Ce);continue}case"list":{for(He=ke.ordered,Ge=ke.start,nt=ke.loose,te=ke.items.length,Ce="",z=0;z<te;z++)tt=ke.items[z],rt=tt.checked,Be=tt.task,Qe="",tt.task&&(it=this.renderer.checkbox(rt),nt?tt.tokens.length>0&&tt.tokens[0].type==="paragraph"?(tt.tokens[0].text=it+" "+tt.tokens[0].text,tt.tokens[0].tokens&&tt.tokens[0].tokens.length>0&&tt.tokens[0].tokens[0].type==="text"&&(tt.tokens[0].tokens[0].text=it+" "+tt.tokens[0].tokens[0].text)):tt.tokens.unshift({type:"text",text:it}):Qe+=it),Qe+=this.parse(tt.tokens,nt),Ce+=this.renderer.listitem(Qe,Be,rt);oe+=this.renderer.list(Ce,He,Ge);continue}case"html":{oe+=this.renderer.html(ke.text);continue}case"paragraph":{oe+=this.renderer.paragraph(this.parseInline(ke.tokens));continue}case"text":{for(Ce=ke.tokens?this.parseInline(ke.tokens):ke.text;M+1<K&&ne[M+1].type==="text";)ke=ne[++M],Ce+=`
`+(ke.tokens?this.parseInline(ke.tokens):ke.text);oe+=ce?this.renderer.paragraph(Ce):Ce;continue}default:{var he='Token with "'+ke.type+'" type was not found.';if(this.options.silent){console.error(he);return}else throw new Error(he)}}}return oe},le.parseInline=function(ne,ce){ce=ce||this.renderer;var oe="",M,z,G,te=ne.length;for(M=0;M<te;M++){if(z=ne[M],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[z.type]&&(G=this.options.extensions.renderers[z.type].call({parser:this},z),G!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(z.type))){oe+=G||"";continue}switch(z.type){case"escape":{oe+=ce.text(z.text);break}case"html":{oe+=ce.html(z.text);break}case"link":{oe+=ce.link(z.href,z.title,this.parseInline(z.tokens,ce));break}case"image":{oe+=ce.image(z.href,z.title,z.text);break}case"strong":{oe+=ce.strong(this.parseInline(z.tokens,ce));break}case"em":{oe+=ce.em(this.parseInline(z.tokens,ce));break}case"codespan":{oe+=ce.codespan(z.text);break}case"br":{oe+=ce.br();break}case"del":{oe+=ce.del(this.parseInline(z.tokens,ce));break}case"text":{oe+=ce.text(z.text);break}default:{var de='Token with "'+z.type+'" type was not found.';if(this.options.silent){console.error(de);return}else throw new Error(de)}}}return oe},ae}();function ie(ae,le,ue){if(typeof ae>"u"||ae===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ae!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ae)+", string expected");if(typeof le=="function"&&(ue=le,le=null),le=n({},ie.defaults,le||{}),w(le),ue){var ne=le.highlight,ce;try{ce=B.lex(ae,le)}catch(te){return ue(te)}var oe=function(de){var we;if(!de)try{le.walkTokens&&ie.walkTokens(ce,le.walkTokens),we=Y.parse(ce,le)}catch(Pe){de=Pe}return le.highlight=ne,de?ue(de):ue(null,we)};if(!ne||ne.length<3||(delete le.highlight,!ce.length))return oe();var M=0;ie.walkTokens(ce,function(te){te.type==="code"&&(M++,setTimeout(function(){ne(te.text,te.lang,function(de,we){if(de)return oe(de);we!=null&&we!==te.text&&(te.text=we,te.escaped=!0),M--,M===0&&oe()})},0))}),M===0&&oe();return}function z(te){if(te.message+=`
Please report this to https://github.com/markedjs/marked.`,le.silent)return"<p>An error occurred:</p><pre>"+D(te.message+"",!0)+"</pre>";throw te}try{var G=B.lex(ae,le);if(le.walkTokens){if(le.async)return Promise.all(ie.walkTokens(G,le.walkTokens)).then(function(){return Y.parse(G,le)}).catch(z);ie.walkTokens(G,le.walkTokens)}return Y.parse(G,le)}catch(te){z(te)}}ie.options=ie.setOptions=function(ae){return n(ie.defaults,ae),A(ie.defaults),ie},ie.getDefaults=S,ie.defaults=re.defaults,ie.use=function(){for(var ae=arguments.length,le=new Array(ae),ue=0;ue<ae;ue++)le[ue]=arguments[ue];var ne=n.apply(void 0,[{}].concat(le)),ce=ie.defaults.extensions||{renderers:{},childTokens:{}},oe;le.forEach(function(M){if(M.extensions&&(oe=!0,M.extensions.forEach(function(G){if(!G.name)throw new Error("extension name required");if(G.renderer){var te=ce.renderers?ce.renderers[G.name]:null;te?ce.renderers[G.name]=function(){for(var de=arguments.length,we=new Array(de),Pe=0;Pe<de;Pe++)we[Pe]=arguments[Pe];var be=G.renderer.apply(this,we);return be===!1&&(be=te.apply(this,we)),be}:ce.renderers[G.name]=G.renderer}if(G.tokenizer){if(!G.level||G.level!=="block"&&G.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ce[G.level]?ce[G.level].unshift(G.tokenizer):ce[G.level]=[G.tokenizer],G.start&&(G.level==="block"?ce.startBlock?ce.startBlock.push(G.start):ce.startBlock=[G.start]:G.level==="inline"&&(ce.startInline?ce.startInline.push(G.start):ce.startInline=[G.start]))}G.childTokens&&(ce.childTokens[G.name]=G.childTokens)})),M.renderer&&function(){var G=ie.defaults.renderer||new Z,te=function(Pe){var be=G[Pe];G[Pe]=function(){for(var Ce=arguments.length,ke=new Array(Ce),He=0;He<Ce;He++)ke[He]=arguments[He];var Ge=M.renderer[Pe].apply(G,ke);return Ge===!1&&(Ge=be.apply(G,ke)),Ge}};for(var de in M.renderer)te(de);ne.renderer=G}(),M.tokenizer&&function(){var G=ie.defaults.tokenizer||new Q,te=function(Pe){var be=G[Pe];G[Pe]=function(){for(var Ce=arguments.length,ke=new Array(Ce),He=0;He<Ce;He++)ke[He]=arguments[He];var Ge=M.tokenizer[Pe].apply(G,ke);return Ge===!1&&(Ge=be.apply(G,ke)),Ge}};for(var de in M.tokenizer)te(de);ne.tokenizer=G}(),M.walkTokens){var z=ie.defaults.walkTokens;ne.walkTokens=function(G){var te=[];return te.push(M.walkTokens.call(this,G)),z&&(te=te.concat(z.call(this,G))),te}}oe&&(ne.extensions=ce),ie.setOptions(ne)})},ie.walkTokens=function(ae,le){for(var ue=[],ne=function(){var z=oe.value;switch(ue=ue.concat(le.call(ie,z)),z.type){case"table":{for(var G=R(z.header),te;!(te=G()).done;){var de=te.value;ue=ue.concat(ie.walkTokens(de.tokens,le))}for(var we=R(z.rows),Pe;!(Pe=we()).done;)for(var be=Pe.value,Ce=R(be),ke;!(ke=Ce()).done;){var He=ke.value;ue=ue.concat(ie.walkTokens(He.tokens,le))}break}case"list":{ue=ue.concat(ie.walkTokens(z.items,le));break}default:ie.defaults.extensions&&ie.defaults.extensions.childTokens&&ie.defaults.extensions.childTokens[z.type]?ie.defaults.extensions.childTokens[z.type].forEach(function(Ge){ue=ue.concat(ie.walkTokens(z[Ge],le))}):z.tokens&&(ue=ue.concat(ie.walkTokens(z.tokens,le)))}},ce=R(ae),oe;!(oe=ce()).done;)ne();return ue},ie.parseInline=function(ae,le){if(typeof ae>"u"||ae===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ae!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ae)+", string expected");le=n({},ie.defaults,le||{}),w(le);try{var ue=B.lexInline(ae,le);return le.walkTokens&&ie.walkTokens(ue,le.walkTokens),Y.parseInline(ue,le)}catch(ne){if(ne.message+=`
Please report this to https://github.com/markedjs/marked.`,le.silent)return"<p>An error occurred:</p><pre>"+D(ne.message+"",!0)+"</pre>";throw ne}},ie.Parser=Y,ie.parser=Y.parse,ie.Renderer=Z,ie.TextRenderer=_,ie.Lexer=B,ie.lexer=B.lex,ie.Tokenizer=Q,ie.Slugger=H,ie.parse=ie;var ge=ie.options,X=ie.setOptions,J=ie.use,ee=ie.walkTokens,me=ie.parseInline,ve=ie,Ie=Y.parse,Re=B.lex;re.Lexer=B,re.Parser=Y,re.Renderer=Z,re.Slugger=H,re.TextRenderer=_,re.Tokenizer=Q,re.getDefaults=S,re.lexer=Re,re.marked=ie,re.options=ge,re.parse=ve,re.parseInline=me,re.parser=Ie,re.setOptions=X,re.use=J,re.walkTokens=ee,Object.defineProperty(re,"__esModule",{value:!0})}),define(ye[87],De([1,0,28]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new a.LRUCache(1e4);function l(I){return y(I,"NFC",L)}e.normalizeNFC=l;const R=new a.LRUCache(1e4);function S(I){return y(I,"NFD",R)}e.normalizeNFD=S;const A=/[^\u0000-\u0080]/;function y(I,O,P){if(!I)return I;const v=P.get(I);if(v)return v;let k;return A.test(I)?k=I.normalize(O):k=I,P.set(I,k),k}e.removeAccents=function(){const I=/[\u0300-\u036f]/g;return function(O){return S(O).replace(I,"")}}()}),define(ye[102],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function a(A,y,I){return Math.min(Math.max(A,y),I)}e.clamp=a;function L(A,y){return(y+A%y)%y}e.rot=L;class l{constructor(){this.a=0}getNext(){return this.a++}}e.Counter=l;class R{constructor(){this.a=1,this.b=0}update(y){return this.b=this.b+(y-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.MovingAverage=R;class S{constructor(y){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(y),this.c.fill(0,0,y)}update(y){const I=this.c[this.d];return this.c[this.d]=y,this.d=(this.d+1)%this.c.length,this.e-=I,this.e+=y,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.SlidingWindowAverage=S}),function(){function re(l){const R=[];typeof l=="number"&&R.push("code/timeOrigin",l);function S(y){R.push(y,Date.now())}function A(){const y=[];for(let I=0;I<R.length;I+=2)y.push({name:R[I],startTime:R[I+1]});return y}return{mark:S,getMarks:A}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?re():{mark(l){performance.mark(l)},getMarks(){let l=performance.timeOrigin;typeof l!="number"&&(l=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const R=[{name:"code/timeOrigin",startTime:Math.round(l)}];for(const S of performance.getEntriesByType("mark"))R.push({name:S.name,startTime:Math.round(l+S.startTime)});return R}};if(typeof process=="object"){const l=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return re(l)}else return console.trace("perf-util loaded in UNKNOWN environment"),re()}function a(l){return l.MonacoPerformanceMarks||(l.MonacoPerformanceMarks=e()),l.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return a(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=a(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=a(L))}(),define(ye[12],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isMobile=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=e.LANGUAGE_DEFAULT=void 0,e.LANGUAGE_DEFAULT="en";let a=!1,L=!1,l=!1,R=!1,S=!1,A=!1,y=!1,I=!1,O=!1,P=!1,v,k=e.LANGUAGE_DEFAULT,D,f;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let u;typeof e.globals.vscode<"u"&&typeof e.globals.vscode.process<"u"?u=e.globals.vscode.process:typeof process<"u"&&(u=process);const h=typeof u?.versions?.electron=="string",p=h&&u?.type==="renderer";if(typeof navigator=="object"&&!p){f=navigator.userAgent,a=f.indexOf("Windows")>=0,L=f.indexOf("Macintosh")>=0,I=(f.indexOf("Macintosh")>=0||f.indexOf("iPad")>=0||f.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,l=f.indexOf("Linux")>=0,P=f?.indexOf("Mobi")>=0,A=!0,v=e.LANGUAGE_DEFAULT,k=v;const m=typeof document<"u"&&document.getElementById("vscode-remote-nls-configuration"),n=m&&m.getAttribute("data-settings");if(n)try{const t=JSON.parse(n);v=t.locale,D=t._translationsConfigFile,k=t.availableLanguages["*"]||e.LANGUAGE_DEFAULT}catch{}}else if(typeof u=="object"){a=u.platform==="win32",L=u.platform==="darwin",l=u.platform==="linux",R=l&&!!u.env.SNAP&&!!u.env.SNAP_REVISION,y=h,O=!!u.env.CI||!!u.env.BUILD_ARTIFACTSTAGINGDIRECTORY,v=e.LANGUAGE_DEFAULT,k=e.LANGUAGE_DEFAULT;const m=u.env.VSCODE_NLS_CONFIG;if(m)try{const n=JSON.parse(m),t=n.availableLanguages["*"];v=n.locale,k=t||e.LANGUAGE_DEFAULT,D=n._translationsConfigFile}catch{}S=!0}else console.error("Unable to resolve platform.");var b;(function(m){m[m.Web=0]="Web",m[m.Mac=1]="Mac",m[m.Linux=2]="Linux",m[m.Windows=3]="Windows"})(b=e.Platform||(e.Platform={}));function C(m){switch(m){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=C;let g=0;L?g=1:a?g=3:l&&(g=2),e.isWindows=a,e.isMacintosh=L,e.isLinux=l,e.isLinuxSnap=R,e.isNative=S,e.isElectron=y,e.isWeb=A,e.isWebWorker=A&&typeof e.globals.importScripts=="function",e.isIOS=I,e.isMobile=P,e.isCI=O,e.platform=g,e.userAgent=f,e.language=k;var i;(function(m){function n(){return e.language}m.value=n;function t(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}m.isDefaultVariant=t;function d(){return e.language==="en"}m.isDefault=d})(i=e.Language||(e.Language={})),e.locale=v,e.translationsConfigFile=D,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const m=[];e.globals.addEventListener("message",t=>{if(t.data&&t.data.vscodeScheduleAsyncWork)for(let d=0,E=m.length;d<E;d++){const w=m[d];if(w.id===t.data.vscodeScheduleAsyncWork){m.splice(d,1),w.callback();return}}});let n=0;return t=>{const d=++n;m.push({id:d,callback:t}),e.globals.postMessage({vscodeScheduleAsyncWork:d},"*")}}return m=>setTimeout(m)})();var s;(function(m){m[m.Windows=1]="Windows",m[m.Macintosh=2]="Macintosh",m[m.Linux=3]="Linux"})(s=e.OperatingSystem||(e.OperatingSystem={})),e.OS=L||I?2:a?1:3;let r=!0,o=!1;function c(){if(!o){o=!0;const m=new Uint8Array(2);m[0]=1,m[1]=2,r=new Uint16Array(m.buffer)[0]===(2<<8)+1}return r}e.isLittleEndian=c,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(ye[36],De([1,0,12]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let L;if(typeof a.globals.vscode<"u"&&typeof a.globals.vscode.process<"u"){const l=a.globals.vscode.process;L={get platform(){return l.platform},get arch(){return l.arch},get env(){return l.env},cwd(){return l.cwd()}}}else typeof process<"u"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:L={get platform(){return a.isWindows?"win32":a.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.arch=L.arch}),define(ye[9],De([1,0,36]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,l=97,R=90,S=122,A=46,y=47,I=92,O=58,P=63;class v extends Error{constructor(s,r,o){let c;typeof r=="string"&&r.indexOf("not ")===0?(c="must not be",r=r.replace(/^not /,"")):c="must be";const m=s.indexOf(".")!==-1?"property":"argument";let n=`The "${s}" ${m} ${c} of type ${r}`;n+=`. Received type ${typeof o}`,super(n),this.code="ERR_INVALID_ARG_TYPE"}}function k(i,s){if(i===null||typeof i!="object")throw new v(s,"Object",i)}function D(i,s){if(typeof i!="string")throw new v(s,"string",i)}const f=a.platform==="win32";function u(i){return i===y||i===I}function h(i){return i===y}function p(i){return i>=L&&i<=R||i>=l&&i<=S}function b(i,s,r,o){let c="",m=0,n=-1,t=0,d=0;for(let E=0;E<=i.length;++E){if(E<i.length)d=i.charCodeAt(E);else{if(o(d))break;d=y}if(o(d)){if(!(n===E-1||t===1))if(t===2){if(c.length<2||m!==2||c.charCodeAt(c.length-1)!==A||c.charCodeAt(c.length-2)!==A){if(c.length>2){const w=c.lastIndexOf(r);w===-1?(c="",m=0):(c=c.slice(0,w),m=c.length-1-c.lastIndexOf(r)),n=E,t=0;continue}else if(c.length!==0){c="",m=0,n=E,t=0;continue}}s&&(c+=c.length>0?`${r}..`:"..",m=2)}else c.length>0?c+=`${r}${i.slice(n+1,E)}`:c=i.slice(n+1,E),m=E-n-1;n=E,t=0}else d===A&&t!==-1?++t:t=-1}return c}function C(i,s){k(s,"pathObject");const r=s.dir||s.root,o=s.base||`${s.name||""}${s.ext||""}`;return r?r===s.root?`${r}${o}`:`${r}${i}${o}`:o}e.win32={resolve(...i){let s="",r="",o=!1;for(let c=i.length-1;c>=-1;c--){let m;if(c>=0){if(m=i[c],D(m,"path"),m.length===0)continue}else s.length===0?m=a.cwd():(m=a.env[`=${s}`]||a.cwd(),(m===void 0||m.slice(0,2).toLowerCase()!==s.toLowerCase()&&m.charCodeAt(2)===I)&&(m=`${s}\\`));const n=m.length;let t=0,d="",E=!1;const w=m.charCodeAt(0);if(n===1)u(w)&&(t=1,E=!0);else if(u(w))if(E=!0,u(m.charCodeAt(1))){let N=2,j=N;for(;N<n&&!u(m.charCodeAt(N));)N++;if(N<n&&N!==j){const V=m.slice(j,N);for(j=N;N<n&&u(m.charCodeAt(N));)N++;if(N<n&&N!==j){for(j=N;N<n&&!u(m.charCodeAt(N));)N++;(N===n||N!==j)&&(d=`\\\\${V}\\${m.slice(j,N)}`,t=N)}}}else t=1;else p(w)&&m.charCodeAt(1)===O&&(d=m.slice(0,2),t=2,n>2&&u(m.charCodeAt(2))&&(E=!0,t=3));if(d.length>0)if(s.length>0){if(d.toLowerCase()!==s.toLowerCase())continue}else s=d;if(o){if(s.length>0)break}else if(r=`${m.slice(t)}\\${r}`,o=E,E&&s.length>0)break}return r=b(r,!o,"\\",u),o?`${s}\\${r}`:`${s}${r}`||"."},normalize(i){D(i,"path");const s=i.length;if(s===0)return".";let r=0,o,c=!1;const m=i.charCodeAt(0);if(s===1)return h(m)?"\\":i;if(u(m))if(c=!0,u(i.charCodeAt(1))){let t=2,d=t;for(;t<s&&!u(i.charCodeAt(t));)t++;if(t<s&&t!==d){const E=i.slice(d,t);for(d=t;t<s&&u(i.charCodeAt(t));)t++;if(t<s&&t!==d){for(d=t;t<s&&!u(i.charCodeAt(t));)t++;if(t===s)return`\\\\${E}\\${i.slice(d)}\\`;t!==d&&(o=`\\\\${E}\\${i.slice(d,t)}`,r=t)}}}else r=1;else p(m)&&i.charCodeAt(1)===O&&(o=i.slice(0,2),r=2,s>2&&u(i.charCodeAt(2))&&(c=!0,r=3));let n=r<s?b(i.slice(r),!c,"\\",u):"";return n.length===0&&!c&&(n="."),n.length>0&&u(i.charCodeAt(s-1))&&(n+="\\"),o===void 0?c?`\\${n}`:n:c?`${o}\\${n}`:`${o}${n}`},isAbsolute(i){D(i,"path");const s=i.length;if(s===0)return!1;const r=i.charCodeAt(0);return u(r)||s>2&&p(r)&&i.charCodeAt(1)===O&&u(i.charCodeAt(2))},join(...i){if(i.length===0)return".";let s,r;for(let m=0;m<i.length;++m){const n=i[m];D(n,"path"),n.length>0&&(s===void 0?s=r=n:s+=`\\${n}`)}if(s===void 0)return".";let o=!0,c=0;if(typeof r=="string"&&u(r.charCodeAt(0))){++c;const m=r.length;m>1&&u(r.charCodeAt(1))&&(++c,m>2&&(u(r.charCodeAt(2))?++c:o=!1))}if(o){for(;c<s.length&&u(s.charCodeAt(c));)c++;c>=2&&(s=`\\${s.slice(c)}`)}return e.win32.normalize(s)},relative(i,s){if(D(i,"from"),D(s,"to"),i===s)return"";const r=e.win32.resolve(i),o=e.win32.resolve(s);if(r===o||(i=r.toLowerCase(),s=o.toLowerCase(),i===s))return"";let c=0;for(;c<i.length&&i.charCodeAt(c)===I;)c++;let m=i.length;for(;m-1>c&&i.charCodeAt(m-1)===I;)m--;const n=m-c;let t=0;for(;t<s.length&&s.charCodeAt(t)===I;)t++;let d=s.length;for(;d-1>t&&s.charCodeAt(d-1)===I;)d--;const E=d-t,w=n<E?n:E;let N=-1,j=0;for(;j<w;j++){const Q=i.charCodeAt(c+j);if(Q!==s.charCodeAt(t+j))break;Q===I&&(N=j)}if(j!==w){if(N===-1)return o}else{if(E>w){if(s.charCodeAt(t+j)===I)return o.slice(t+j+1);if(j===2)return o.slice(t+j)}n>w&&(i.charCodeAt(c+j)===I?N=j:j===2&&(N=3)),N===-1&&(N=0)}let V="";for(j=c+N+1;j<=m;++j)(j===m||i.charCodeAt(j)===I)&&(V+=V.length===0?"..":"\\..");return t+=N,V.length>0?`${V}${o.slice(t,d)}`:(o.charCodeAt(t)===I&&++t,o.slice(t,d))},toNamespacedPath(i){if(typeof i!="string"||i.length===0)return i;const s=e.win32.resolve(i);if(s.length<=2)return i;if(s.charCodeAt(0)===I){if(s.charCodeAt(1)===I){const r=s.charCodeAt(2);if(r!==P&&r!==A)return`\\\\?\\UNC\\${s.slice(2)}`}}else if(p(s.charCodeAt(0))&&s.charCodeAt(1)===O&&s.charCodeAt(2)===I)return`\\\\?\\${s}`;return i},dirname(i){D(i,"path");const s=i.length;if(s===0)return".";let r=-1,o=0;const c=i.charCodeAt(0);if(s===1)return u(c)?i:".";if(u(c)){if(r=o=1,u(i.charCodeAt(1))){let t=2,d=t;for(;t<s&&!u(i.charCodeAt(t));)t++;if(t<s&&t!==d){for(d=t;t<s&&u(i.charCodeAt(t));)t++;if(t<s&&t!==d){for(d=t;t<s&&!u(i.charCodeAt(t));)t++;if(t===s)return i;t!==d&&(r=o=t+1)}}}}else p(c)&&i.charCodeAt(1)===O&&(r=s>2&&u(i.charCodeAt(2))?3:2,o=r);let m=-1,n=!0;for(let t=s-1;t>=o;--t)if(u(i.charCodeAt(t))){if(!n){m=t;break}}else n=!1;if(m===-1){if(r===-1)return".";m=r}return i.slice(0,m)},basename(i,s){s!==void 0&&D(s,"ext"),D(i,"path");let r=0,o=-1,c=!0,m;if(i.length>=2&&p(i.charCodeAt(0))&&i.charCodeAt(1)===O&&(r=2),s!==void 0&&s.length>0&&s.length<=i.length){if(s===i)return"";let n=s.length-1,t=-1;for(m=i.length-1;m>=r;--m){const d=i.charCodeAt(m);if(u(d)){if(!c){r=m+1;break}}else t===-1&&(c=!1,t=m+1),n>=0&&(d===s.charCodeAt(n)?--n===-1&&(o=m):(n=-1,o=t))}return r===o?o=t:o===-1&&(o=i.length),i.slice(r,o)}for(m=i.length-1;m>=r;--m)if(u(i.charCodeAt(m))){if(!c){r=m+1;break}}else o===-1&&(c=!1,o=m+1);return o===-1?"":i.slice(r,o)},extname(i){D(i,"path");let s=0,r=-1,o=0,c=-1,m=!0,n=0;i.length>=2&&i.charCodeAt(1)===O&&p(i.charCodeAt(0))&&(s=o=2);for(let t=i.length-1;t>=s;--t){const d=i.charCodeAt(t);if(u(d)){if(!m){o=t+1;break}continue}c===-1&&(m=!1,c=t+1),d===A?r===-1?r=t:n!==1&&(n=1):r!==-1&&(n=-1)}return r===-1||c===-1||n===0||n===1&&r===c-1&&r===o+1?"":i.slice(r,c)},format:C.bind(null,"\\"),parse(i){D(i,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return s;const r=i.length;let o=0,c=i.charCodeAt(0);if(r===1)return u(c)?(s.root=s.dir=i,s):(s.base=s.name=i,s);if(u(c)){if(o=1,u(i.charCodeAt(1))){let N=2,j=N;for(;N<r&&!u(i.charCodeAt(N));)N++;if(N<r&&N!==j){for(j=N;N<r&&u(i.charCodeAt(N));)N++;if(N<r&&N!==j){for(j=N;N<r&&!u(i.charCodeAt(N));)N++;N===r?o=N:N!==j&&(o=N+1)}}}}else if(p(c)&&i.charCodeAt(1)===O){if(r<=2)return s.root=s.dir=i,s;if(o=2,u(i.charCodeAt(2))){if(r===3)return s.root=s.dir=i,s;o=3}}o>0&&(s.root=i.slice(0,o));let m=-1,n=o,t=-1,d=!0,E=i.length-1,w=0;for(;E>=o;--E){if(c=i.charCodeAt(E),u(c)){if(!d){n=E+1;break}continue}t===-1&&(d=!1,t=E+1),c===A?m===-1?m=E:w!==1&&(w=1):m!==-1&&(w=-1)}return t!==-1&&(m===-1||w===0||w===1&&m===t-1&&m===n+1?s.base=s.name=i.slice(n,t):(s.name=i.slice(n,m),s.base=i.slice(n,t),s.ext=i.slice(m,t))),n>0&&n!==o?s.dir=i.slice(0,n-1):s.dir=s.root,s},sep:"\\",delimiter:";",win32:null,posix:null};const g=(()=>{if(f){const i=/\\/g;return()=>{const s=a.cwd().replace(i,"/");return s.slice(s.indexOf("/"))}}return()=>a.cwd()})();e.posix={resolve(...i){let s="",r=!1;for(let o=i.length-1;o>=-1&&!r;o--){const c=o>=0?i[o]:g();D(c,"path"),c.length!==0&&(s=`${c}/${s}`,r=c.charCodeAt(0)===y)}return s=b(s,!r,"/",h),r?`/${s}`:s.length>0?s:"."},normalize(i){if(D(i,"path"),i.length===0)return".";const s=i.charCodeAt(0)===y,r=i.charCodeAt(i.length-1)===y;return i=b(i,!s,"/",h),i.length===0?s?"/":r?"./":".":(r&&(i+="/"),s?`/${i}`:i)},isAbsolute(i){return D(i,"path"),i.length>0&&i.charCodeAt(0)===y},join(...i){if(i.length===0)return".";let s;for(let r=0;r<i.length;++r){const o=i[r];D(o,"path"),o.length>0&&(s===void 0?s=o:s+=`/${o}`)}return s===void 0?".":e.posix.normalize(s)},relative(i,s){if(D(i,"from"),D(s,"to"),i===s||(i=e.posix.resolve(i),s=e.posix.resolve(s),i===s))return"";const r=1,o=i.length,c=o-r,m=1,n=s.length-m,t=c<n?c:n;let d=-1,E=0;for(;E<t;E++){const N=i.charCodeAt(r+E);if(N!==s.charCodeAt(m+E))break;N===y&&(d=E)}if(E===t)if(n>t){if(s.charCodeAt(m+E)===y)return s.slice(m+E+1);if(E===0)return s.slice(m+E)}else c>t&&(i.charCodeAt(r+E)===y?d=E:E===0&&(d=0));let w="";for(E=r+d+1;E<=o;++E)(E===o||i.charCodeAt(E)===y)&&(w+=w.length===0?"..":"/..");return`${w}${s.slice(m+d)}`},toNamespacedPath(i){return i},dirname(i){if(D(i,"path"),i.length===0)return".";const s=i.charCodeAt(0)===y;let r=-1,o=!0;for(let c=i.length-1;c>=1;--c)if(i.charCodeAt(c)===y){if(!o){r=c;break}}else o=!1;return r===-1?s?"/":".":s&&r===1?"//":i.slice(0,r)},basename(i,s){s!==void 0&&D(s,"ext"),D(i,"path");let r=0,o=-1,c=!0,m;if(s!==void 0&&s.length>0&&s.length<=i.length){if(s===i)return"";let n=s.length-1,t=-1;for(m=i.length-1;m>=0;--m){const d=i.charCodeAt(m);if(d===y){if(!c){r=m+1;break}}else t===-1&&(c=!1,t=m+1),n>=0&&(d===s.charCodeAt(n)?--n===-1&&(o=m):(n=-1,o=t))}return r===o?o=t:o===-1&&(o=i.length),i.slice(r,o)}for(m=i.length-1;m>=0;--m)if(i.charCodeAt(m)===y){if(!c){r=m+1;break}}else o===-1&&(c=!1,o=m+1);return o===-1?"":i.slice(r,o)},extname(i){D(i,"path");let s=-1,r=0,o=-1,c=!0,m=0;for(let n=i.length-1;n>=0;--n){const t=i.charCodeAt(n);if(t===y){if(!c){r=n+1;break}continue}o===-1&&(c=!1,o=n+1),t===A?s===-1?s=n:m!==1&&(m=1):s!==-1&&(m=-1)}return s===-1||o===-1||m===0||m===1&&s===o-1&&s===r+1?"":i.slice(s,o)},format:C.bind(null,"/"),parse(i){D(i,"path");const s={root:"",dir:"",base:"",ext:"",name:""};if(i.length===0)return s;const r=i.charCodeAt(0)===y;let o;r?(s.root="/",o=1):o=0;let c=-1,m=0,n=-1,t=!0,d=i.length-1,E=0;for(;d>=o;--d){const w=i.charCodeAt(d);if(w===y){if(!t){m=d+1;break}continue}n===-1&&(t=!1,n=d+1),w===A?c===-1?c=d:E!==1&&(E=1):c!==-1&&(E=-1)}if(n!==-1){const w=m===0&&r?1:m;c===-1||E===0||E===1&&c===n-1&&c===m+1?s.base=s.name=i.slice(w,n):(s.name=i.slice(w,c),s.base=i.slice(w,n),s.ext=i.slice(c,n))}return m>0?s.dir=i.slice(0,m-1):r&&(s.dir="/"),s},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=f?e.win32.normalize:e.posix.normalize,e.isAbsolute=f?e.win32.isAbsolute:e.posix.isAbsolute,e.join=f?e.win32.join:e.posix.join,e.resolve=f?e.win32.resolve:e.posix.resolve,e.relative=f?e.win32.relative:e.posix.relative,e.dirname=f?e.win32.dirname:e.posix.dirname,e.basename=f?e.win32.basename:e.posix.basename,e.extname=f?e.win32.extname:e.posix.extname,e.format=f?e.win32.format:e.posix.format,e.parse=f?e.win32.parse:e.posix.parse,e.toNamespacedPath=f?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=f?e.win32.sep:e.posix.sep,e.delimiter=f?e.win32.delimiter:e.posix.delimiter}),define(ye[103],De([1,0,66,9]),function(re,e,a,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const l=new a.Lazy(()=>{const t=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:t,collatorIsNumeric:t.resolvedOptions().numeric}}),R=new a.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),S=new a.Lazy(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function A(t,d,E=!1){const w=t||"",N=d||"",j=l.value.collator.compare(w,N);return l.value.collatorIsNumeric&&j===0&&w!==N?w<N?-1:1:j}e.compareFileNames=A;function y(t,d){const E=R.value.collator;return t=t||"",d=d||"",C(E,t,d)}e.compareFileNamesDefault=y;function I(t,d){const E=R.value.collator;return t=t||"",d=d||"",r(t,d)||C(E,t,d)}e.compareFileNamesUpper=I;function O(t,d){const E=R.value.collator;return t=t||"",d=d||"",s(t,d)||C(E,t,d)}e.compareFileNamesLower=O;function P(t,d){return t=t||"",d=d||"",t===d?0:t<d?-1:1}e.compareFileNamesUnicode=P;function v(t,d){const[E,w]=p(t),[N,j]=p(d);let V=l.value.collator.compare(w,j);if(V===0){if(l.value.collatorIsNumeric&&w!==j)return w<j?-1:1;if(V=l.value.collator.compare(E,N),l.value.collatorIsNumeric&&V===0&&E!==N)return E<N?-1:1}return V}e.compareFileExtensions=v;function k(t,d){t=t||"",d=d||"";const E=b(t),w=b(d),N=R.value.collator,j=S.value.collator;return C(j,E,w)||C(N,t,d)}e.compareFileExtensionsDefault=k;function D(t,d){t=t||"",d=d||"";const E=b(t),w=b(d),N=R.value.collator,j=S.value.collator;return C(j,E,w)||r(t,d)||C(N,t,d)}e.compareFileExtensionsUpper=D;function f(t,d){t=t||"",d=d||"";const E=b(t),w=b(d),N=R.value.collator,j=S.value.collator;return C(j,E,w)||s(t,d)||C(N,t,d)}e.compareFileExtensionsLower=f;function u(t,d){t=t||"",d=d||"";const E=b(t).toLowerCase(),w=b(d).toLowerCase();return E!==w?E<w?-1:1:t!==d?t<d?-1:1:0}e.compareFileExtensionsUnicode=u;const h=/^(.*?)(\.([^.]*))?$/;function p(t,d=!1){const E=t?h.exec(t):[];let w=[E&&E[1]||"",E&&E[3]||""];return d&&(!w[0]&&w[1]||w[0]&&w[0].charAt(0)===".")&&(w=[w[0]+"."+w[1],""]),w}function b(t){const d=t?h.exec(t):[];return d&&d[1]&&d[1].charAt(0)!=="."&&d[3]||""}function C(t,d,E){const w=t.compare(d,E);return w!==0?w:d.length!==E.length?d.length<E.length?-1:1:0}function g(t){const d=t.charAt(0);return d.toLocaleUpperCase()!==d}function i(t){const d=t.charAt(0);return d.toLocaleLowerCase()!==d}function s(t,d){return g(t)&&i(d)?-1:i(t)&&g(d)?1:0}function r(t,d){return i(t)&&g(d)?-1:g(t)&&i(d)?1:0}function o(t,d,E=!1){return E||(t=t&&t.toLowerCase(),d=d&&d.toLowerCase()),t===d?0:t<d?-1:1}function c(t,d,E=!1){const w=t.split(L.sep),N=d.split(L.sep),j=w.length-1,V=N.length-1;let Q,x;for(let U=0;;U++){if(Q=j===U,x=V===U,Q&&x)return A(w[U],N[U],E);if(Q)return-1;if(x)return 1;const T=o(w[U],N[U],E);if(T!==0)return T}}e.comparePaths=c;function m(t,d,E){const w=t.toLowerCase(),N=d.toLowerCase(),j=n(t,d,E);if(j)return j;const V=w.endsWith(E),Q=N.endsWith(E);if(V!==Q)return V?-1:1;const x=A(w,N);return x!==0?x:w.localeCompare(N)}e.compareAnything=m;function n(t,d,E){const w=t.toLowerCase(),N=d.toLowerCase(),j=w.startsWith(E),V=N.startsWith(E);if(j!==V)return j?-1:1;if(j&&V){if(w.length<N.length)return-1;if(w.length>N.length)return 1}return 0}e.compareByPrefix=n}),define(ye[88],De([1,0,9]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const L={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},l={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function R(O){const P=(0,a.extname)(O),v=L[P.toLowerCase()];return v!==void 0?v:S(O)}e.getMediaOrTextMime=R;function S(O){const P=(0,a.extname)(O);return l[P.toLowerCase()]}e.getMediaMime=S;function A(O){for(const P in l)if(l[P]===O)return P}e.getExtensionForMimeType=A;const y=/^(.+)\/(.+?)(;.+)?$/;function I(O,P){const v=y.exec(O);return v?`${v[1].toLowerCase()}/${v[2].toLowerCase()}${v[3]??""}`:P?void 0:O}e.normalizeMimeType=I}),define(ye[104],De([1,0,12]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var L;(function(A){A[A.stdout=0]="stdout",A[A.stderr=1]="stderr"})(L=e.Source||(e.Source={}));var l;(function(A){A[A.Success=0]="Success",A[A.Unknown=1]="Unknown",A[A.AccessDenied=2]="AccessDenied",A[A.ProcessNotFound=3]="ProcessNotFound"})(l=e.TerminateResponseCode||(e.TerminateResponseCode={}));function R(A,...y){const I=y.reduce((v,k)=>(v[k]=!0,v),{}),O=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/,/^CODE_SERVER_.+$/,/^CS_.+$/];Object.keys(A).filter(v=>!I[v]).forEach(v=>{for(let k=0;k<O.length;k++)if(v.search(O[k])!==-1){delete A[v];break}})}e.sanitizeProcessEnvironment=R;function S(A){!A||(delete A.DEBUG,a.isMacintosh&&delete A.DYLD_LIBRARY_PATH,a.isLinux&&delete A.LD_PRELOAD)}e.removeDangerousEnvVariables=S}),function(re,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var a=e();for(var L in a)(typeof exports=="object"?exports:re)[L]=a[L]}}(typeof self<"u"?self:this,function(){return function(re){var e={};function a(L){if(e[L])return e[L].exports;var l=e[L]={i:L,l:!1,exports:{}};return re[L].call(l.exports,l,l.exports,a),l.l=!0,l.exports}return a.m=re,a.c=e,a.d=function(L,l,R){a.o(L,l)||Object.defineProperty(L,l,{enumerable:!0,get:R})},a.r=function(L){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(L,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(L,"__esModule",{value:!0})},a.t=function(L,l){if(1&l&&(L=a(L)),8&l||4&l&&typeof L=="object"&&L&&L.__esModule)return L;var R=Object.create(null);if(a.r(R),Object.defineProperty(R,"default",{enumerable:!0,value:L}),2&l&&typeof L!="string")for(var S in L)a.d(R,S,function(A){return L[A]}.bind(null,S));return R},a.n=function(L){var l=L&&L.__esModule?function(){return L.default}:function(){return L};return a.d(l,"a",l),l},a.o=function(L,l){return Object.prototype.hasOwnProperty.call(L,l)},a.p="",a(a.s=0)}([function(re,e,a){(function(L){var l;e=re.exports=J,l=typeof L=="object"&&L.env&&L.env.NODE_DEBUG&&/\bsemver\b/i.test(L.env.NODE_DEBUG)?function(){var be=Array.prototype.slice.call(arguments,0);be.unshift("SEMVER"),console.log.apply(console,be)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var R=256,S=Number.MAX_SAFE_INTEGER||9007199254740991,A=e.re=[],y=e.src=[],I=0,O=I++;y[O]="0|[1-9]\\d*";var P=I++;y[P]="[0-9]+";var v=I++;y[v]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var k=I++;y[k]="("+y[O]+")\\.("+y[O]+")\\.("+y[O]+")";var D=I++;y[D]="("+y[P]+")\\.("+y[P]+")\\.("+y[P]+")";var f=I++;y[f]="(?:"+y[O]+"|"+y[v]+")";var u=I++;y[u]="(?:"+y[P]+"|"+y[v]+")";var h=I++;y[h]="(?:-("+y[f]+"(?:\\."+y[f]+")*))";var p=I++;y[p]="(?:-?("+y[u]+"(?:\\."+y[u]+")*))";var b=I++;y[b]="[0-9A-Za-z-]+";var C=I++;y[C]="(?:\\+("+y[b]+"(?:\\."+y[b]+")*))";var g=I++,i="v?"+y[k]+y[h]+"?"+y[C]+"?";y[g]="^"+i+"$";var s="[v=\\s]*"+y[D]+y[p]+"?"+y[C]+"?",r=I++;y[r]="^"+s+"$";var o=I++;y[o]="((?:<|>)?=?)";var c=I++;y[c]=y[P]+"|x|X|\\*";var m=I++;y[m]=y[O]+"|x|X|\\*";var n=I++;y[n]="[v=\\s]*("+y[m]+")(?:\\.("+y[m]+")(?:\\.("+y[m]+")(?:"+y[h]+")?"+y[C]+"?)?)?";var t=I++;y[t]="[v=\\s]*("+y[c]+")(?:\\.("+y[c]+")(?:\\.("+y[c]+")(?:"+y[p]+")?"+y[C]+"?)?)?";var d=I++;y[d]="^"+y[o]+"\\s*"+y[n]+"$";var E=I++;y[E]="^"+y[o]+"\\s*"+y[t]+"$";var w=I++;y[w]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var N=I++;y[N]="(?:~>?)";var j=I++;y[j]="(\\s*)"+y[N]+"\\s+",A[j]=new RegExp(y[j],"g");var V=I++;y[V]="^"+y[N]+y[n]+"$";var Q=I++;y[Q]="^"+y[N]+y[t]+"$";var x=I++;y[x]="(?:\\^)";var U=I++;y[U]="(\\s*)"+y[x]+"\\s+",A[U]=new RegExp(y[U],"g");var T=I++;y[T]="^"+y[x]+y[n]+"$";var F=I++;y[F]="^"+y[x]+y[t]+"$";var B=I++;y[B]="^"+y[o]+"\\s*("+s+")$|^$";var Z=I++;y[Z]="^"+y[o]+"\\s*("+i+")$|^$";var _=I++;y[_]="(\\s*)"+y[o]+"\\s*("+s+"|"+y[n]+")",A[_]=new RegExp(y[_],"g");var H=I++;y[H]="^\\s*("+y[n]+")\\s+-\\s+("+y[n]+")\\s*$";var Y=I++;y[Y]="^\\s*("+y[t]+")\\s+-\\s+("+y[t]+")\\s*$";var ie=I++;y[ie]="(<|>)?=?\\s*\\*";for(var ge=0;ge<35;ge++)l(ge,y[ge]),A[ge]||(A[ge]=new RegExp(y[ge]));function X(be,Ce){if(be instanceof J)return be;if(typeof be!="string"||be.length>R||!(Ce?A[r]:A[g]).test(be))return null;try{return new J(be,Ce)}catch{return null}}function J(be,Ce){if(be instanceof J){if(be.loose===Ce)return be;be=be.version}else if(typeof be!="string")throw new TypeError("Invalid Version: "+be);if(be.length>R)throw new TypeError("version is longer than "+R+" characters");if(!(this instanceof J))return new J(be,Ce);l("SemVer",be,Ce),this.loose=Ce;var ke=be.trim().match(Ce?A[r]:A[g]);if(!ke)throw new TypeError("Invalid Version: "+be);if(this.raw=be,this.major=+ke[1],this.minor=+ke[2],this.patch=+ke[3],this.major>S||this.major<0)throw new TypeError("Invalid major version");if(this.minor>S||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>S||this.patch<0)throw new TypeError("Invalid patch version");ke[4]?this.prerelease=ke[4].split(".").map(function(He){if(/^[0-9]+$/.test(He)){var Ge=+He;if(Ge>=0&&Ge<S)return Ge}return He}):this.prerelease=[],this.build=ke[5]?ke[5].split("."):[],this.format()}e.parse=X,e.valid=function(be,Ce){var ke=X(be,Ce);return ke?ke.version:null},e.clean=function(be,Ce){var ke=X(be.trim().replace(/^[=v]+/,""),Ce);return ke?ke.version:null},e.SemVer=J,J.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},J.prototype.toString=function(){return this.version},J.prototype.compare=function(be){return l("SemVer.compare",this.version,this.loose,be),be instanceof J||(be=new J(be,this.loose)),this.compareMain(be)||this.comparePre(be)},J.prototype.compareMain=function(be){return be instanceof J||(be=new J(be,this.loose)),me(this.major,be.major)||me(this.minor,be.minor)||me(this.patch,be.patch)},J.prototype.comparePre=function(be){if(be instanceof J||(be=new J(be,this.loose)),this.prerelease.length&&!be.prerelease.length)return-1;if(!this.prerelease.length&&be.prerelease.length)return 1;if(!this.prerelease.length&&!be.prerelease.length)return 0;var Ce=0;do{var ke=this.prerelease[Ce],He=be.prerelease[Ce];if(l("prerelease compare",Ce,ke,He),ke===void 0&&He===void 0)return 0;if(He===void 0)return 1;if(ke===void 0)return-1;if(ke!==He)return me(ke,He)}while(++Ce)},J.prototype.inc=function(be,Ce){switch(be){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",Ce);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",Ce);break;case"prepatch":this.prerelease.length=0,this.inc("patch",Ce),this.inc("pre",Ce);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",Ce),this.inc("pre",Ce);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ke=this.prerelease.length;--ke>=0;)typeof this.prerelease[ke]=="number"&&(this.prerelease[ke]++,ke=-2);ke===-1&&this.prerelease.push(0)}Ce&&(this.prerelease[0]===Ce?isNaN(this.prerelease[1])&&(this.prerelease=[Ce,0]):this.prerelease=[Ce,0]);break;default:throw new Error("invalid increment argument: "+be)}return this.format(),this.raw=this.version,this},e.inc=function(be,Ce,ke,He){typeof ke=="string"&&(He=ke,ke=void 0);try{return new J(be,ke).inc(Ce,He).version}catch{return null}},e.diff=function(be,Ce){if(ae(be,Ce))return null;var ke=X(be),He=X(Ce);if(ke.prerelease.length||He.prerelease.length){for(var Ge in ke)if((Ge==="major"||Ge==="minor"||Ge==="patch")&&ke[Ge]!==He[Ge])return"pre"+Ge;return"prerelease"}for(var Ge in ke)if((Ge==="major"||Ge==="minor"||Ge==="patch")&&ke[Ge]!==He[Ge])return Ge},e.compareIdentifiers=me;var ee=/^[0-9]+$/;function me(be,Ce){var ke=ee.test(be),He=ee.test(Ce);return ke&&He&&(be=+be,Ce=+Ce),ke&&!He?-1:He&&!ke?1:be<Ce?-1:be>Ce?1:0}function ve(be,Ce,ke){return new J(be,ke).compare(new J(Ce,ke))}function Ie(be,Ce,ke){return ve(be,Ce,ke)>0}function Re(be,Ce,ke){return ve(be,Ce,ke)<0}function ae(be,Ce,ke){return ve(be,Ce,ke)===0}function le(be,Ce,ke){return ve(be,Ce,ke)!==0}function ue(be,Ce,ke){return ve(be,Ce,ke)>=0}function ne(be,Ce,ke){return ve(be,Ce,ke)<=0}function ce(be,Ce,ke,He){var Ge;switch(Ce){case"===":typeof be=="object"&&(be=be.version),typeof ke=="object"&&(ke=ke.version),Ge=be===ke;break;case"!==":typeof be=="object"&&(be=be.version),typeof ke=="object"&&(ke=ke.version),Ge=be!==ke;break;case"":case"=":case"==":Ge=ae(be,ke,He);break;case"!=":Ge=le(be,ke,He);break;case">":Ge=Ie(be,ke,He);break;case">=":Ge=ue(be,ke,He);break;case"<":Ge=Re(be,ke,He);break;case"<=":Ge=ne(be,ke,He);break;default:throw new TypeError("Invalid operator: "+Ce)}return Ge}function oe(be,Ce){if(be instanceof oe){if(be.loose===Ce)return be;be=be.value}if(!(this instanceof oe))return new oe(be,Ce);l("comparator",be,Ce),this.loose=Ce,this.parse(be),this.semver===M?this.value="":this.value=this.operator+this.semver.version,l("comp",this)}e.rcompareIdentifiers=function(be,Ce){return me(Ce,be)},e.major=function(be,Ce){return new J(be,Ce).major},e.minor=function(be,Ce){return new J(be,Ce).minor},e.patch=function(be,Ce){return new J(be,Ce).patch},e.compare=ve,e.compareLoose=function(be,Ce){return ve(be,Ce,!0)},e.rcompare=function(be,Ce,ke){return ve(Ce,be,ke)},e.sort=function(be,Ce){return be.sort(function(ke,He){return e.compare(ke,He,Ce)})},e.rsort=function(be,Ce){return be.sort(function(ke,He){return e.rcompare(ke,He,Ce)})},e.gt=Ie,e.lt=Re,e.eq=ae,e.neq=le,e.gte=ue,e.lte=ne,e.cmp=ce,e.Comparator=oe;var M={};function z(be,Ce){if(be instanceof z)return be.loose===Ce?be:new z(be.raw,Ce);if(be instanceof oe)return new z(be.value,Ce);if(!(this instanceof z))return new z(be,Ce);if(this.loose=Ce,this.raw=be,this.set=be.split(/\s*\|\|\s*/).map(function(ke){return this.parseRange(ke.trim())},this).filter(function(ke){return ke.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+be);this.format()}function G(be){return!be||be.toLowerCase()==="x"||be==="*"}function te(be,Ce,ke,He,Ge,nt,Qe,tt,rt,Be,it,$,K){return((Ce=G(ke)?"":G(He)?">="+ke+".0.0":G(Ge)?">="+ke+"."+He+".0":">="+Ce)+" "+(tt=G(rt)?"":G(Be)?"<"+(+rt+1)+".0.0":G(it)?"<"+rt+"."+(+Be+1)+".0":$?"<="+rt+"."+Be+"."+it+"-"+$:"<="+tt)).trim()}function de(be,Ce){for(var ke=0;ke<be.length;ke++)if(!be[ke].test(Ce))return!1;if(Ce.prerelease.length){for(ke=0;ke<be.length;ke++)if(l(be[ke].semver),be[ke].semver!==M&&be[ke].semver.prerelease.length>0){var He=be[ke].semver;if(He.major===Ce.major&&He.minor===Ce.minor&&He.patch===Ce.patch)return!0}return!1}return!0}function we(be,Ce,ke){try{Ce=new z(Ce,ke)}catch{return!1}return Ce.test(be)}function Pe(be,Ce,ke,He){var Ge,nt,Qe,tt,rt;switch(be=new J(be,He),Ce=new z(Ce,He),ke){case">":Ge=Ie,nt=ne,Qe=Re,tt=">",rt=">=";break;case"<":Ge=Re,nt=ue,Qe=Ie,tt="<",rt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(we(be,Ce,He))return!1;for(var Be=0;Be<Ce.set.length;++Be){var it=Ce.set[Be],$=null,K=null;if(it.forEach(function(he){he.semver===M&&(he=new oe(">=0.0.0")),$=$||he,K=K||he,Ge(he.semver,$.semver,He)?$=he:Qe(he.semver,K.semver,He)&&(K=he)}),$.operator===tt||$.operator===rt||(!K.operator||K.operator===tt)&&nt(be,K.semver)||K.operator===rt&&Qe(be,K.semver))return!1}return!0}oe.prototype.parse=function(be){var Ce=this.loose?A[B]:A[Z],ke=be.match(Ce);if(!ke)throw new TypeError("Invalid comparator: "+be);this.operator=ke[1],this.operator==="="&&(this.operator=""),ke[2]?this.semver=new J(ke[2],this.loose):this.semver=M},oe.prototype.toString=function(){return this.value},oe.prototype.test=function(be){return l("Comparator.test",be,this.loose),this.semver===M||(typeof be=="string"&&(be=new J(be,this.loose)),ce(be,this.operator,this.semver,this.loose))},oe.prototype.intersects=function(be,Ce){if(!(be instanceof oe))throw new TypeError("a Comparator is required");var ke;if(this.operator==="")return ke=new z(be.value,Ce),we(this.value,ke,Ce);if(be.operator==="")return ke=new z(this.value,Ce),we(be.semver,ke,Ce);var He=!(this.operator!==">="&&this.operator!==">"||be.operator!==">="&&be.operator!==">"),Ge=!(this.operator!=="<="&&this.operator!=="<"||be.operator!=="<="&&be.operator!=="<"),nt=this.semver.version===be.semver.version,Qe=!(this.operator!==">="&&this.operator!=="<="||be.operator!==">="&&be.operator!=="<="),tt=ce(this.semver,"<",be.semver,Ce)&&(this.operator===">="||this.operator===">")&&(be.operator==="<="||be.operator==="<"),rt=ce(this.semver,">",be.semver,Ce)&&(this.operator==="<="||this.operator==="<")&&(be.operator===">="||be.operator===">");return He||Ge||nt&&Qe||tt||rt},e.Range=z,z.prototype.format=function(){return this.range=this.set.map(function(be){return be.join(" ").trim()}).join("||").trim(),this.range},z.prototype.toString=function(){return this.range},z.prototype.parseRange=function(be){var Ce=this.loose;be=be.trim(),l("range",be,Ce);var ke=Ce?A[Y]:A[H];be=be.replace(ke,te),l("hyphen replace",be),be=be.replace(A[_],"$1$2$3"),l("comparator trim",be,A[_]),be=(be=(be=be.replace(A[j],"$1~")).replace(A[U],"$1^")).split(/\s+/).join(" ");var He=Ce?A[B]:A[Z],Ge=be.split(" ").map(function(nt){return function(Qe,tt){return l("comp",Qe),Qe=function(rt,Be){return rt.trim().split(/\s+/).map(function(it){return function($,K){l("caret",$,K);var he=K?A[F]:A[T];return $.replace(he,function(Le,Ne,xe,je,Ze){var st;return l("caret",$,Le,Ne,xe,je,Ze),G(Ne)?st="":G(xe)?st=">="+Ne+".0.0 <"+(+Ne+1)+".0.0":G(je)?st=Ne==="0"?">="+Ne+"."+xe+".0 <"+Ne+"."+(+xe+1)+".0":">="+Ne+"."+xe+".0 <"+(+Ne+1)+".0.0":Ze?(l("replaceCaret pr",Ze),Ze.charAt(0)!=="-"&&(Ze="-"+Ze),st=Ne==="0"?xe==="0"?">="+Ne+"."+xe+"."+je+Ze+" <"+Ne+"."+xe+"."+(+je+1):">="+Ne+"."+xe+"."+je+Ze+" <"+Ne+"."+(+xe+1)+".0":">="+Ne+"."+xe+"."+je+Ze+" <"+(+Ne+1)+".0.0"):(l("no pr"),st=Ne==="0"?xe==="0"?">="+Ne+"."+xe+"."+je+" <"+Ne+"."+xe+"."+(+je+1):">="+Ne+"."+xe+"."+je+" <"+Ne+"."+(+xe+1)+".0":">="+Ne+"."+xe+"."+je+" <"+(+Ne+1)+".0.0"),l("caret return",st),st})}(it,Be)}).join(" ")}(Qe,tt),l("caret",Qe),Qe=function(rt,Be){return rt.trim().split(/\s+/).map(function(it){return function($,K){var he=K?A[Q]:A[V];return $.replace(he,function(Le,Ne,xe,je,Ze){var st;return l("tilde",$,Le,Ne,xe,je,Ze),G(Ne)?st="":G(xe)?st=">="+Ne+".0.0 <"+(+Ne+1)+".0.0":G(je)?st=">="+Ne+"."+xe+".0 <"+Ne+"."+(+xe+1)+".0":Ze?(l("replaceTilde pr",Ze),Ze.charAt(0)!=="-"&&(Ze="-"+Ze),st=">="+Ne+"."+xe+"."+je+Ze+" <"+Ne+"."+(+xe+1)+".0"):st=">="+Ne+"."+xe+"."+je+" <"+Ne+"."+(+xe+1)+".0",l("tilde return",st),st})}(it,Be)}).join(" ")}(Qe,tt),l("tildes",Qe),Qe=function(rt,Be){return l("replaceXRanges",rt,Be),rt.split(/\s+/).map(function(it){return function($,K){$=$.trim();var he=K?A[E]:A[d];return $.replace(he,function(Le,Ne,xe,je,Ze,st){l("xRange",$,Le,Ne,xe,je,Ze,st);var at=G(xe),mt=at||G(je),gt=mt||G(Ze);return Ne==="="&&gt&&(Ne=""),at?Le=Ne===">"||Ne==="<"?"<0.0.0":"*":Ne&&gt?(mt&&(je=0),gt&&(Ze=0),Ne===">"?(Ne=">=",mt?(xe=+xe+1,je=0,Ze=0):gt&&(je=+je+1,Ze=0)):Ne==="<="&&(Ne="<",mt?xe=+xe+1:je=+je+1),Le=Ne+xe+"."+je+"."+Ze):mt?Le=">="+xe+".0.0 <"+(+xe+1)+".0.0":gt&&(Le=">="+xe+"."+je+".0 <"+xe+"."+(+je+1)+".0"),l("xRange return",Le),Le})}(it,Be)}).join(" ")}(Qe,tt),l("xrange",Qe),Qe=function(rt,Be){return l("replaceStars",rt,Be),rt.trim().replace(A[ie],"")}(Qe,tt),l("stars",Qe),Qe}(nt,Ce)}).join(" ").split(/\s+/);return this.loose&&(Ge=Ge.filter(function(nt){return!!nt.match(He)})),Ge=Ge.map(function(nt){return new oe(nt,Ce)})},z.prototype.intersects=function(be,Ce){if(!(be instanceof z))throw new TypeError("a Range is required");return this.set.some(function(ke){return ke.every(function(He){return be.set.some(function(Ge){return Ge.every(function(nt){return He.intersects(nt,Ce)})})})})},e.toComparators=function(be,Ce){return new z(be,Ce).set.map(function(ke){return ke.map(function(He){return He.value}).join(" ").trim().split(" ")})},z.prototype.test=function(be){if(!be)return!1;typeof be=="string"&&(be=new J(be,this.loose));for(var Ce=0;Ce<this.set.length;Ce++)if(de(this.set[Ce],be))return!0;return!1},e.satisfies=we,e.maxSatisfying=function(be,Ce,ke){var He=null,Ge=null;try{var nt=new z(Ce,ke)}catch{return null}return be.forEach(function(Qe){nt.test(Qe)&&(He&&Ge.compare(Qe)!==-1||(Ge=new J(He=Qe,ke)))}),He},e.minSatisfying=function(be,Ce,ke){var He=null,Ge=null;try{var nt=new z(Ce,ke)}catch{return null}return be.forEach(function(Qe){nt.test(Qe)&&(He&&Ge.compare(Qe)!==1||(Ge=new J(He=Qe,ke)))}),He},e.validRange=function(be,Ce){try{return new z(be,Ce).range||"*"}catch{return null}},e.ltr=function(be,Ce,ke){return Pe(be,Ce,"<",ke)},e.gtr=function(be,Ce,ke){return Pe(be,Ce,">",ke)},e.outside=Pe,e.prerelease=function(be,Ce){var ke=X(be,Ce);return ke&&ke.prerelease.length?ke.prerelease:null},e.intersects=function(be,Ce,ke){return be=new z(be,ke),Ce=new z(Ce,ke),be.intersects(Ce)},e.coerce=function(be){if(be instanceof J)return be;if(typeof be!="string")return null;var Ce=be.match(A[w]);return Ce==null?null:X((Ce[1]||"0")+"."+(Ce[2]||"0")+"."+(Ce[3]||"0"))}}).call(this,a(1))},function(re,e){var a,L,l=re.exports={};function R(){throw new Error("setTimeout has not been defined")}function S(){throw new Error("clearTimeout has not been defined")}function A(u){if(a===setTimeout)return setTimeout(u,0);if((a===R||!a)&&setTimeout)return a=setTimeout,setTimeout(u,0);try{return a(u,0)}catch{try{return a.call(null,u,0)}catch{return a.call(this,u,0)}}}(function(){try{a=typeof setTimeout=="function"?setTimeout:R}catch{a=R}try{L=typeof clearTimeout=="function"?clearTimeout:S}catch{L=S}})();var y,I=[],O=!1,P=-1;function v(){O&&y&&(O=!1,y.length?I=y.concat(I):P=-1,I.length&&k())}function k(){if(!O){var u=A(v);O=!0;for(var h=I.length;h;){for(y=I,I=[];++P<h;)y&&y[P].run();P=-1,h=I.length}y=null,O=!1,function(p){if(L===clearTimeout)return clearTimeout(p);if((L===S||!L)&&clearTimeout)return L=clearTimeout,clearTimeout(p);try{L(p)}catch{try{return L.call(null,p)}catch{return L.call(this,p)}}}(u)}}function D(u,h){this.fun=u,this.array=h}function f(){}l.nextTick=function(u){var h=new Array(arguments.length-1);if(arguments.length>1)for(var p=1;p<arguments.length;p++)h[p-1]=arguments[p];I.push(new D(u,h)),I.length!==1||O||A(k)},D.prototype.run=function(){this.fun.apply(null,this.array)},l.title="browser",l.browser=!0,l.env={},l.argv=[],l.version="",l.versions={},l.on=f,l.addListener=f,l.once=f,l.off=f,l.removeListener=f,l.removeAllListeners=f,l.emit=f,l.prependListener=f,l.prependOnceListener=f,l.listeners=function(u){return[]},l.binding=function(u){throw new Error("process.binding is not supported")},l.cwd=function(){return"/"},l.chdir=function(u){throw new Error("process.chdir is not supported")},l.umask=function(){return 0}}])}),define(ye[43],De([1,0,12]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=a.globals.performance&&typeof a.globals.performance.now=="function";class l{static create(S=!0){return new l(S)}constructor(S){this.a=L&&S,this.b=this.d(),this.c=-1}stop(){this.c=this.d()}reset(){this.b=this.d(),this.c=-1}elapsed(){return this.c!==-1?this.c-this.b:this.d()-this.b}d(){return this.a?a.globals.performance.now():Date.now()}}e.StopWatch=l}),define(ye[3],De([1,0,11,64,6,67,43]),function(re,e,a,L,l,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.EventProfiling=e.Event=void 0;const A=!1,y=!1;var I;(function(m){m.None=()=>l.Disposable.None;function n(ve){if(y){const{onDidAddListener:Ie}=ve,Re=D.create();let ae=0;ve.onDidAddListener=()=>{++ae===2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),Re.print()),Ie?.()}}}function t(ve,Ie){return U(ve,()=>{},0,void 0,!0,void 0,Ie)}m.defer=t;function d(ve){return(Ie,Re=null,ae)=>{let le=!1,ue;return ue=ve(ne=>{if(!le)return ue?ue.dispose():le=!0,Ie.call(Re,ne)},null,ae),le&&ue.dispose(),ue}}m.once=d;function E(ve,Ie,Re){return x((ae,le=null,ue)=>ve(ne=>ae.call(le,Ie(ne)),null,ue),Re)}m.map=E;function w(ve,Ie,Re){return x((ae,le=null,ue)=>ve(ne=>{Ie(ne),ae.call(le,ne)},null,ue),Re)}m.forEach=w;function N(ve,Ie,Re){return x((ae,le=null,ue)=>ve(ne=>Ie(ne)&&ae.call(le,ne),null,ue),Re)}m.filter=N;function j(ve){return ve}m.signal=j;function V(...ve){return(Ie,Re=null,ae)=>(0,l.combinedDisposable)(...ve.map(le=>le(ue=>Ie.call(Re,ue),null,ae)))}m.any=V;function Q(ve,Ie,Re,ae){let le=Re;return E(ve,ue=>(le=Ie(le,ue),le),ae)}m.reduce=Q;function x(ve,Ie){let Re;const ae={onWillAddFirstListener(){Re=ve(le.fire,le)},onDidRemoveLastListener(){Re?.dispose()}};Ie||n(ae);const le=new u(ae);return Ie?.add(le),le.event}function U(ve,Ie,Re=100,ae=!1,le=!1,ue,ne){let ce,oe,M,z=0,G;const te={leakWarningThreshold:ue,onWillAddFirstListener(){ce=ve(we=>{z++,oe=Ie(oe,we),ae&&!M&&(de.fire(oe),oe=void 0),G=()=>{const Pe=oe;oe=void 0,M=void 0,(!ae||z>1)&&de.fire(Pe),z=0},typeof Re=="number"?(clearTimeout(M),M=setTimeout(G,Re)):M===void 0&&(M=0,queueMicrotask(G))})},onWillRemoveListener(){le&&z>0&&G?.()},onDidRemoveLastListener(){G=void 0,ce.dispose()}};ne||n(te);const de=new u(te);return ne?.add(de),de.event}m.debounce=U;function T(ve,Ie=0,Re){return m.debounce(ve,(ae,le)=>ae?(ae.push(le),ae):[le],Ie,void 0,!0,void 0,Re)}m.accumulate=T;function F(ve,Ie=(ae,le)=>ae===le,Re){let ae=!0,le;return N(ve,ue=>{const ne=ae||!Ie(ue,le);return ae=!1,le=ue,ne},Re)}m.latch=F;function B(ve,Ie,Re){return[m.filter(ve,Ie,Re),m.filter(ve,ae=>!Ie(ae),Re)]}m.split=B;function Z(ve,Ie=!1,Re=[]){let ae=Re.slice(),le=ve(ce=>{ae?ae.push(ce):ne.fire(ce)});const ue=()=>{ae?.forEach(ce=>ne.fire(ce)),ae=null},ne=new u({onWillAddFirstListener(){le||(le=ve(ce=>ne.fire(ce)))},onDidAddFirstListener(){ae&&(Ie?setTimeout(ue):ue())},onDidRemoveLastListener(){le&&le.dispose(),le=null}});return ne.event}m.buffer=Z;class _{constructor(Ie){this.event=Ie,this.c=new l.DisposableStore}map(Ie){return new _(E(this.event,Ie,this.c))}forEach(Ie){return new _(w(this.event,Ie,this.c))}filter(Ie){return new _(N(this.event,Ie,this.c))}reduce(Ie,Re){return new _(Q(this.event,Ie,Re,this.c))}latch(){return new _(F(this.event,void 0,this.c))}debounce(Ie,Re=100,ae=!1,le=!1,ue){return new _(U(this.event,Ie,Re,ae,le,ue,this.c))}on(Ie,Re,ae){return this.event(Ie,Re,ae)}once(Ie,Re,ae){return d(this.event)(Ie,Re,ae)}dispose(){this.c.dispose()}}function H(ve){return new _(ve)}m.chain=H;function Y(ve,Ie,Re=ae=>ae){const ae=(...ce)=>ne.fire(Re(...ce)),le=()=>ve.on(Ie,ae),ue=()=>ve.removeListener(Ie,ae),ne=new u({onWillAddFirstListener:le,onDidRemoveLastListener:ue});return ne.event}m.fromNodeEventEmitter=Y;function ie(ve,Ie,Re=ae=>ae){const ae=(...ce)=>ne.fire(Re(...ce)),le=()=>ve.addEventListener(Ie,ae),ue=()=>ve.removeEventListener(Ie,ae),ne=new u({onWillAddFirstListener:le,onDidRemoveLastListener:ue});return ne.event}m.fromDOMEventEmitter=ie;function ge(ve){return new Promise(Ie=>d(ve)(Ie))}m.toPromise=ge;function X(ve,Ie){return Ie(void 0),ve(Re=>Ie(Re))}m.runAndSubscribe=X;function J(ve,Ie){let Re=null;function ae(ue){Re?.dispose(),Re=new l.DisposableStore,Ie(ue,Re)}ae(void 0);const le=ve(ue=>ae(ue));return(0,l.toDisposable)(()=>{le.dispose(),Re?.dispose()})}m.runAndSubscribeWithStore=J;class ee{constructor(Ie,Re){this.obs=Ie,this.c=0,this.d=!1;const ae={onWillAddFirstListener:()=>{Ie.addObserver(this)},onDidRemoveLastListener:()=>{Ie.removeObserver(this)}};Re||n(ae),this.emitter=new u(ae),Re&&Re.add(this.emitter)}beginUpdate(Ie){this.c++}handleChange(Ie,Re){this.d=!0}endUpdate(Ie){--this.c===0&&this.d&&(this.d=!1,this.emitter.fire(this.obs.get()))}}function me(ve,Ie){return new ee(ve,Ie).emitter.event}m.fromObservable=me})(I=e.Event||(e.Event={}));class O{constructor(n){this.listenerCount=0,this.invocationCount=0,this.elapsedOverall=0,this.durations=[],this.name=`${n}_${O.c++}`,O.all.add(this)}start(n){this.d=new S.StopWatch(!0),this.listenerCount=n}stop(){if(this.d){const n=this.d.elapsed();this.durations.push(n),this.elapsedOverall+=n,this.invocationCount+=1,this.d=void 0}}}O.all=new Set,O.c=0,e.EventProfiling=O;let P=-1;function v(m){const n=P;return P=m,{dispose(){P=n}}}e.setGlobalLeakWarningThreshold=v;class k{constructor(n,t=Math.random().toString(18).slice(2,5)){this.threshold=n,this.name=t,this.d=0}dispose(){this.c?.clear()}check(n,t){const d=this.threshold;if(d<=0||t<d)return;this.c||(this.c=new Map);const E=this.c.get(n.value)||0;if(this.c.set(n.value,E+1),this.d-=1,this.d<=0){this.d=d*.5;let w,N=0;for(const[j,V]of this.c)(!w||N<V)&&(w=j,N=V);console.warn(`[${this.name}] potential listener LEAK detected, having ${t} listeners already. MOST frequent listener (${N}):`),console.warn(w)}return()=>{const w=this.c.get(n.value)||0;this.c.set(n.value,w-1)}}}class D{static create(){return new D(new Error().stack??"")}constructor(n){this.value=n}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class f{constructor(n,t,d){this.callback=n,this.callbackThis=t,this.stack=d,this.subscription=new l.SafeDisposable}invoke(n){this.callback.call(this.callbackThis,n)}}class u{constructor(n){this.j=!1,this.d=n,this.f=P>0||this.d?.leakWarningThreshold?new k(this.d?.leakWarningThreshold??P):void 0,this.g=this.d?._profName?new O(this.d._profName):void 0,this.m=this.d?.deliveryQueue}dispose(){if(!this.j){if(this.j=!0,this.q){if(A){const n=Array.from(this.q);queueMicrotask(()=>{for(const t of n)t.subscription.isset()&&(t.subscription.unset(),t.stack?.print())})}this.q.clear()}this.m?.clear(this),this.d?.onDidRemoveLastListener?.(),this.f?.dispose()}}get event(){return this.l||(this.l=(n,t,d)=>{if(this.q||(this.q=new R.LinkedList),this.f&&this.q.size>this.f.threshold*3)return console.warn(`[${this.f.name}] REFUSES to accept new listeners because it exceeded its threshold by far`),l.Disposable.None;const E=this.q.isEmpty();E&&this.d?.onWillAddFirstListener&&this.d.onWillAddFirstListener(this);let w,N;this.f&&this.q.size>=Math.ceil(this.f.threshold*.2)&&(N=D.create(),w=this.f.check(N,this.q.size+1)),A&&(N=N??D.create());const j=new f(n,t,N),V=this.q.push(j);E&&this.d?.onDidAddFirstListener&&this.d.onDidAddFirstListener(this),this.d?.onDidAddListener&&this.d.onDidAddListener(this,n,t);const Q=j.subscription.set(()=>{w?.(),this.j||(this.d?.onWillRemoveListener?.(this),V(),this.d&&this.d.onDidRemoveLastListener&&(this.q&&!this.q.isEmpty()||this.d.onDidRemoveLastListener(this)))});return d instanceof l.DisposableStore?d.add(Q):Array.isArray(d)&&d.push(Q),Q}),this.l}fire(n){if(this.q){this.m||(this.m=new p);for(const t of this.q)this.m.push(this,t,n);this.g?.start(this.m.size),this.m.deliver(),this.g?.stop()}}hasListeners(){return this.q?!this.q.isEmpty():!1}}e.Emitter=u;class h{constructor(){this.c=new R.LinkedList}get size(){return this.c.size}push(n,t,d){this.c.push(new b(n,t,d))}clear(n){const t=new R.LinkedList;for(const d of this.c)d.emitter!==n&&t.push(d);this.c=t}deliver(){for(;this.c.size>0;){const n=this.c.shift();try{n.listener.invoke(n.event)}catch(t){(0,a.onUnexpectedError)(t)}}}}e.EventDeliveryQueue=h;class p extends h{clear(n){this.c.clear()}}class b{constructor(n,t,d){this.emitter=n,this.listener=t,this.event=d}}class C extends u{async fireAsync(n,t,d){if(!!this.q){this.c||(this.c=new R.LinkedList);for(const E of this.q)this.c.push([E,n]);for(;this.c.size>0&&!t.isCancellationRequested;){const[E,w]=this.c.shift(),N=[],j={...w,token:t,waitUntil:V=>{if(Object.isFrozen(N))throw new Error("waitUntil can NOT be called asynchronous");d&&(V=d(V,E.callback)),N.push(V)}};try{E.invoke(j)}catch(V){(0,a.onUnexpectedError)(V);continue}Object.freeze(N),await Promise.allSettled(N).then(V=>{for(const Q of V)Q.status==="rejected"&&(0,a.onUnexpectedError)(Q.reason)})}}}}e.AsyncEmitter=C;class g extends u{constructor(n){super(n),this.h=0,this.s=new R.LinkedList,this.t=n?.merge}pause(){this.h++}resume(){if(this.h!==0&&--this.h===0)if(this.t){if(this.s.size>0){const n=Array.from(this.s);this.s.clear(),super.fire(this.t(n))}}else for(;!this.h&&this.s.size!==0;)super.fire(this.s.shift())}fire(n){this.q&&(this.h!==0?this.s.push(n):super.fire(n))}}e.PauseableEmitter=g;class i extends g{constructor(n){super(n),this.c=n.delay??100}fire(n){this.k||(this.pause(),this.k=setTimeout(()=>{this.k=void 0,this.resume()},this.c)),super.fire(n)}}e.DebounceEmitter=i;class s extends u{constructor(n){super(n),this.c=[],this.h=n?.merge}fire(n){!this.hasListeners()||(this.c.push(n),this.c.length===1&&queueMicrotask(()=>{this.h?super.fire(this.h(this.c)):this.c.forEach(t=>super.fire(t)),this.c=[]}))}}e.MicrotaskEmitter=s;class r{constructor(){this.d=!1,this.f=[],this.c=new u({onWillAddFirstListener:()=>this.g(),onDidRemoveLastListener:()=>this.h()})}get event(){return this.c.event}add(n){const t={event:n,listener:null};this.f.push(t),this.d&&this.j(t);const d=()=>{this.d&&this.k(t);const E=this.f.indexOf(t);this.f.splice(E,1)};return(0,l.toDisposable)((0,L.once)(d))}g(){this.d=!0,this.f.forEach(n=>this.j(n))}h(){this.d=!1,this.f.forEach(n=>this.k(n))}j(n){n.listener=n.event(t=>this.c.fire(t))}k(n){n.listener&&n.listener.dispose(),n.listener=null}dispose(){this.c.dispose()}}e.EventMultiplexer=r;class o{constructor(){this.c=[]}wrapEvent(n){return(t,d,E)=>n(w=>{const N=this.c[this.c.length-1];N?N.push(()=>t.call(d,w)):t.call(d,w)},void 0,E)}bufferEvents(n){const t=[];this.c.push(t);const d=n();return this.c.pop(),t.forEach(E=>E()),d}}e.EventBufferer=o;class c{constructor(){this.c=!1,this.d=I.None,this.f=l.Disposable.None,this.g=new u({onDidAddFirstListener:()=>{this.c=!0,this.f=this.d(this.g.fire,this.g)},onDidRemoveLastListener:()=>{this.c=!1,this.f.dispose()}}),this.event=this.g.event}set input(n){this.d=n,this.c&&(this.f.dispose(),this.f=n(this.g.fire,this.g))}dispose(){this.f.dispose(),this.g.dispose()}}e.Relay=c}),define(ye[21],De([1,0,3]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(A,y){const I=setTimeout(A.bind(y),0);return{dispose(){clearTimeout(I)}}});var l;(function(A){function y(I){return I===A.None||I===A.Cancelled||I instanceof R?!0:!I||typeof I!="object"?!1:typeof I.isCancellationRequested=="boolean"&&typeof I.onCancellationRequested=="function"}A.isCancellationToken=y,A.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:a.Event.None}),A.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(l=e.CancellationToken||(e.CancellationToken={}));class R{constructor(){this.a=!1,this.b=null}cancel(){this.a||(this.a=!0,this.b&&(this.b.fire(void 0),this.dispose()))}get isCancellationRequested(){return this.a}get onCancellationRequested(){return this.a?L:(this.b||(this.b=new a.Emitter),this.b.event)}dispose(){this.b&&(this.b.dispose(),this.b=null)}}class S{constructor(y){this.a=void 0,this.b=void 0,this.b=y&&y.onCancellationRequested(this.cancel,this)}get token(){return this.a||(this.a=new R),this.a}cancel(){this.a?this.a instanceof R&&this.a.cancel():this.a=l.Cancelled}dispose(y=!1){y&&this.cancel(),this.b?.dispose(),this.a?this.a instanceof R&&this.a.dispose():this.a=l.None}}e.CancellationTokenSource=S}),define(ye[148],De([1,0,21]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class L{constructor(A){this.b=A,this.a=null}get(){if(this.a)return this.a;const A=new a.CancellationTokenSource,y=this.b(A.token);return this.a={promise:y,dispose:()=>{this.a=null,A.cancel(),A.dispose()}},this.a}}e.Cache=L;class l{constructor(A){this.c=A,this.a=void 0,this.b=void 0}get(A){const y=JSON.stringify(A);return this.b!==y&&(this.b=y,this.a=this.c(A)),this.a}}e.LRUCachedFunction=l;class R{get cachedValues(){return this.a}constructor(A){this.b=A,this.a=new Map}get(A){if(this.a.has(A))return this.a.get(A);const y=this.b(A);return this.a.set(A,y),y}}e.CachedFunction=R}),define(ye[105],De([1,0,11,6]),function(re,e,a,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function l(C){const g=C;return g?typeof g.read=="function":!1}e.isReadable=l;function R(C){const g=C;return g?[g.on,g.pause,g.resume,g.destroy].every(i=>typeof i=="function"):!1}e.isReadableStream=R;function S(C){const g=C;return g?R(g.stream)&&Array.isArray(g.buffer)&&typeof g.ended=="boolean":!1}e.isReadableBufferedStream=S;function A(C,g){return new y(C,g)}e.newWriteableStream=A;class y{constructor(g,i){this.e=g,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(g){if(!this.a.destroyed){if(this.a.flowing)this.g(g);else if(this.b.data.push(g),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(g){this.a.destroyed||(this.a.flowing?this.h(g):this.b.error.push(g))}end(g){this.a.destroyed||(typeof g<"u"&&this.write(g),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(g){this.c.data.slice(0).forEach(i=>i(g))}h(g){this.c.error.length===0?(0,a.onUnexpectedError)(g):this.c.error.slice(0).forEach(i=>i(g))}i(){this.c.end.slice(0).forEach(g=>g())}on(g,i){if(!this.a.destroyed)switch(g){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(g,i){if(this.a.destroyed)return;let s;switch(g){case"data":s=this.c.data;break;case"end":s=this.c.end;break;case"error":s=this.c.error;break}if(s){const r=s.indexOf(i);r>=0&&s.splice(r,1)}}j(){if(this.b.data.length>0){const g=this.e(this.b.data);this.g(g),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(s=>s())}}k(){if(this.c.error.length>0){for(const g of this.b.error)this.h(g);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function I(C,g){const i=[];let s;for(;(s=C.read())!==null;)i.push(s);return g(i)}e.consumeReadable=I;function O(C,g,i){const s=[];let r;for(;(r=C.read())!==null&&s.length<i;)s.push(r);return r===null&&s.length>0?g(s):{read:()=>{if(s.length>0)return s.shift();if(typeof r<"u"){const o=r;return r=void 0,o}return C.read()}}}e.peekReadable=O;function P(C,g){return new Promise((i,s)=>{const r=[];v(C,{onData:o=>{g&&r.push(o)},onError:o=>{g?s(o):i(void 0)},onEnd:()=>{i(g?g(r):void 0)}})})}e.consumeStream=P;function v(C,g){let i=!1;return C.on("error",s=>{i||g.onError(s)}),C.on("end",()=>{i||g.onEnd()}),C.on("data",s=>{i||g.onData(s)}),(0,L.toDisposable)(()=>i=!0)}e.listenStream=v;function k(C,g){return new Promise((i,s)=>{const r=new L.DisposableStore,o=[],c=t=>{if(o.push(t),o.length>g)return r.dispose(),C.pause(),i({stream:C,buffer:o,ended:!1})},m=t=>s(t),n=()=>i({stream:C,buffer:o,ended:!0});r.add((0,L.toDisposable)(()=>C.removeListener("error",m))),C.on("error",m),r.add((0,L.toDisposable)(()=>C.removeListener("end",n))),C.on("end",n),r.add((0,L.toDisposable)(()=>C.removeListener("data",c))),C.on("data",c)})}e.peekStream=k;function D(C,g){const i=A(g);return i.end(C),i}e.toStream=D;function f(){const C=A(()=>{throw new Error("not supported")});return C.end(),C}e.emptyStream=f;function u(C){let g=!1;return{read:()=>g?null:(g=!0,C)}}e.toReadable=u;function h(C,g,i){const s=A(i);return v(C,{onData:r=>s.write(g.data(r)),onError:r=>s.error(g.error?g.error(r):r),onEnd:()=>s.end()}),s}e.transform=h;function p(C,g,i){let s=!1;return{read:()=>{const r=g.read();return s?r:(s=!0,r!==null?i([C,r]):C)}}}e.prefixedReadable=p;function b(C,g,i){let s=!1;const r=A(i);return v(g,{onData:o=>s?r.write(o):(s=!0,r.write(i([C,o]))),onError:o=>r.error(o),onEnd:()=>{s||(s=!0,r.write(C)),r.end()}}),r}e.prefixedStream=b}),define(ye[22],De([1,0,105]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const L=typeof Buffer<"u";let l,R;class S{static alloc(t){return L?new S(Buffer.allocUnsafe(t)):new S(new Uint8Array(t))}static wrap(t){return L&&!Buffer.isBuffer(t)&&(t=Buffer.from(t.buffer,t.byteOffset,t.byteLength)),new S(t)}static fromString(t,d){return!(d?.dontUseNodeBuffer||!1)&&L?new S(Buffer.from(t)):(l||(l=new TextEncoder),new S(l.encode(t)))}static fromByteArray(t){const d=S.alloc(t.length);for(let E=0,w=t.length;E<w;E++)d.buffer[E]=t[E];return d}static concat(t,d){if(typeof d>"u"){d=0;for(let N=0,j=t.length;N<j;N++)d+=t[N].byteLength}const E=S.alloc(d);let w=0;for(let N=0,j=t.length;N<j;N++){const V=t[N];E.set(V,w),w+=V.byteLength}return E}constructor(t){this.buffer=t,this.byteLength=this.buffer.byteLength}clone(){const t=S.alloc(this.byteLength);return t.set(this),t}toString(){return L?this.buffer.toString():(R||(R=new TextDecoder),R.decode(this.buffer))}slice(t,d){return new S(this.buffer.subarray(t,d))}set(t,d){if(t instanceof S)this.buffer.set(t.buffer,d);else if(t instanceof Uint8Array)this.buffer.set(t,d);else if(t instanceof ArrayBuffer)this.buffer.set(new Uint8Array(t),d);else if(ArrayBuffer.isView(t))this.buffer.set(new Uint8Array(t.buffer,t.byteOffset,t.byteLength),d);else throw new Error("Unknown argument 'array'")}readUInt32BE(t){return I(this.buffer,t)}writeUInt32BE(t,d){O(this.buffer,t,d)}readUInt32LE(t){return P(this.buffer,t)}writeUInt32LE(t,d){v(this.buffer,t,d)}readUInt8(t){return k(this.buffer,t)}writeUInt8(t,d){D(this.buffer,t,d)}}e.VSBuffer=S;function A(n,t){return n[t+0]<<0>>>0|n[t+1]<<8>>>0}e.readUInt16LE=A;function y(n,t,d){n[d+0]=t&255,t=t>>>8,n[d+1]=t&255}e.writeUInt16LE=y;function I(n,t){return n[t]*2**24+n[t+1]*2**16+n[t+2]*2**8+n[t+3]}e.readUInt32BE=I;function O(n,t,d){n[d+3]=t,t=t>>>8,n[d+2]=t,t=t>>>8,n[d+1]=t,t=t>>>8,n[d]=t}e.writeUInt32BE=O;function P(n,t){return n[t+0]<<0>>>0|n[t+1]<<8>>>0|n[t+2]<<16>>>0|n[t+3]<<24>>>0}e.readUInt32LE=P;function v(n,t,d){n[d+0]=t&255,t=t>>>8,n[d+1]=t&255,t=t>>>8,n[d+2]=t&255,t=t>>>8,n[d+3]=t&255}e.writeUInt32LE=v;function k(n,t){return n[t]}e.readUInt8=k;function D(n,t,d){n[d]=t}e.writeUInt8=D;function f(n){return a.consumeReadable(n,t=>S.concat(t))}e.readableToBuffer=f;function u(n){return a.toReadable(n)}e.bufferToReadable=u;function h(n){return a.consumeStream(n,t=>S.concat(t))}e.streamToBuffer=h;async function p(n){return n.ended?S.concat(n.buffer):S.concat([...n.buffer,await h(n.stream)])}e.bufferedStreamToBuffer=p;function b(n){return a.toStream(n,t=>S.concat(t))}e.bufferToStream=b;function C(n){return a.transform(n,{data:t=>typeof t=="string"?S.fromString(t):S.wrap(t)},t=>S.concat(t))}e.streamToBufferReadableStream=C;function g(n){return a.newWriteableStream(t=>S.concat(t),n)}e.newWriteableBufferStream=g;function i(n,t){return a.prefixedReadable(n,t,d=>S.concat(d))}e.prefixedBufferReadable=i;function s(n,t){return a.prefixedStream(n,t,d=>S.concat(d))}e.prefixedBufferStream=s;function r(n){let t=0,d=0,E=0;const w=new Uint8Array(Math.floor(n.length/4*3)),N=V=>{switch(d){case 3:w[E++]=t|V,d=0;break;case 2:w[E++]=t|V>>>2,t=V<<6,d=3;break;case 1:w[E++]=t|V>>>4,t=V<<4,d=2;break;default:t=V<<2,d=1}};for(let V=0;V<n.length;V++){const Q=n.charCodeAt(V);if(Q>=65&&Q<=90)N(Q-65);else if(Q>=97&&Q<=122)N(Q-97+26);else if(Q>=48&&Q<=57)N(Q-48+52);else if(Q===43||Q===45)N(62);else if(Q===47||Q===95)N(63);else{if(Q===61)break;throw new SyntaxError(`Unexpected base64 character ${n[V]}`)}}const j=E;for(;d>0;)N(0);return S.wrap(w).slice(0,j)}e.decodeBase64=r;const o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",c="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function m({buffer:n},t=!0,d=!1){const E=d?c:o;let w="";const N=n.byteLength%3;let j=0;for(;j<n.byteLength-N;j+=3){const V=n[j+0],Q=n[j+1],x=n[j+2];w+=E[V>>>2],w+=E[(V<<4|Q>>>4)&63],w+=E[(Q<<2|x>>>6)&63],w+=E[x&63]}if(N===1){const V=n[j+0];w+=E[V>>>2],w+=E[V<<4&63],t&&(w+="==")}else if(N===2){const V=n[j+0],Q=n[j+1];w+=E[V>>>2],w+=E[(V<<4|Q>>>4)&63],w+=E[Q<<2&63],t&&(w+="=")}return w}e.encodeBase64=m}),define(ye[8],De([1,0,148,66]),function(re,e,a,L){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.charCount=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function R($){return!$||typeof $!="string"?!0:$.trim().length===0}e.isFalsyOrWhitespace=R;const S=/{(\d+)}/g;function A($,...K){return K.length===0?$:$.replace(S,function(he,Le){const Ne=parseInt(Le,10);return isNaN(Ne)||Ne<0||Ne>=K.length?he:K[Ne]})}e.format=A;const y=/{([^}]+)}/g;function I($,K){return $.replace(y,(he,Le)=>K[Le]??he)}e.format2=I;function O($){return $.replace(/[<>&]/g,function(K){switch(K){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return K}})}e.escape=O;function P($){return $.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=P;function v($,K){let he=0;const Le=K.charCodeAt(0);for(let Ne=$.length-1;Ne>=0;Ne--)$.charCodeAt(Ne)===Le&&he++;return he}e.count=v;function k($,K,he="\u2026"){return $.length<=K?$:`${$.substr(0,K)}${he}`}e.truncate=k;function D($,K=" "){const he=f($,K);return u(he,K)}e.trim=D;function f($,K){if(!$||!K)return $;const he=K.length;if(he===0||$.length===0)return $;let Le=0;for(;$.indexOf(K,Le)===Le;)Le=Le+he;return $.substring(Le)}e.ltrim=f;function u($,K){if(!$||!K)return $;const he=K.length,Le=$.length;if(he===0||Le===0)return $;let Ne=Le,xe=-1;for(;xe=$.lastIndexOf(K,Ne-1),!(xe===-1||xe+he!==Ne);){if(xe===0)return"";Ne=xe}return $.substring(0,Ne)}e.rtrim=u;function h($){return $.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=h;function p($){return $.replace(/\*/g,"")}e.stripWildcards=p;function b($,K,he={}){if(!$)throw new Error("Cannot create regex from empty string");K||($=P($)),he.wholeWord&&(/\B/.test($.charAt(0))||($="\\b"+$),/\B/.test($.charAt($.length-1))||($=$+"\\b"));let Le="";return he.global&&(Le+="g"),he.matchCase||(Le+="i"),he.multiline&&(Le+="m"),he.unicode&&(Le+="u"),new RegExp($,Le)}e.createRegExp=b;function C($){return $.source==="^"||$.source==="^$"||$.source==="$"||$.source==="^\\s*$"?!1:!!($.exec("")&&$.lastIndex===0)}e.regExpLeadsToEndlessLoop=C;function g($){return!!$.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=g;function i($){return($.global?"g":"")+($.ignoreCase?"i":"")+($.multiline?"m":"")+($.unicode?"u":"")}e.regExpFlags=i;function s($){return $.split(/\r\n|\r|\n/)}e.splitLines=s;function r($){for(let K=0,he=$.length;K<he;K++){const Le=$.charCodeAt(K);if(Le!==32&&Le!==9)return K}return-1}e.firstNonWhitespaceIndex=r;function o($,K=0,he=$.length){for(let Le=K;Le<he;Le++){const Ne=$.charCodeAt(Le);if(Ne!==32&&Ne!==9)return $.substring(K,Le)}return $.substring(K,he)}e.getLeadingWhitespace=o;function c($,K=$.length-1){for(let he=K;he>=0;he--){const Le=$.charCodeAt(he);if(Le!==32&&Le!==9)return he}return-1}e.lastNonWhitespaceIndex=c;function m($,K,he){const Le=[];let Ne=0;for(const xe of $.matchAll(K)){if(Le.push($.slice(Ne,xe.index)),xe.index===void 0)throw new Error("match.index should be defined");Ne=xe.index+xe[0].length,Le.push(he(xe[0],...xe.slice(1),xe.index,$,xe.groups))}return Le.push($.slice(Ne)),Promise.all(Le).then(xe=>xe.join(""))}e.replaceAsync=m;function n($,K){return $<K?-1:$>K?1:0}e.compare=n;function t($,K,he=0,Le=$.length,Ne=0,xe=K.length){for(;he<Le&&Ne<xe;he++,Ne++){const st=$.charCodeAt(he),at=K.charCodeAt(Ne);if(st<at)return-1;if(st>at)return 1}const je=Le-he,Ze=xe-Ne;return je<Ze?-1:je>Ze?1:0}e.compareSubstring=t;function d($,K){return E($,K,0,$.length,0,K.length)}e.compareIgnoreCase=d;function E($,K,he=0,Le=$.length,Ne=0,xe=K.length){for(;he<Le&&Ne<xe;he++,Ne++){let st=$.charCodeAt(he),at=K.charCodeAt(Ne);if(st===at)continue;if(st>=128||at>=128)return t($.toLowerCase(),K.toLowerCase(),he,Le,Ne,xe);N(st)&&(st-=32),N(at)&&(at-=32);const mt=st-at;if(mt!==0)return mt}const je=Le-he,Ze=xe-Ne;return je<Ze?-1:je>Ze?1:0}e.compareSubstringIgnoreCase=E;function w($){return $>=48&&$<=57}e.isAsciiDigit=w;function N($){return $>=97&&$<=122}e.isLowerAsciiLetter=N;function j($){return $>=65&&$<=90}e.isUpperAsciiLetter=j;function V($,K){return $.length===K.length&&E($,K)===0}e.equalsIgnoreCase=V;function Q($,K){const he=K.length;return K.length>$.length?!1:E($,K,0,he)===0}e.startsWithIgnoreCase=Q;function x($,K){const he=Math.min($.length,K.length);let Le;for(Le=0;Le<he;Le++)if($.charCodeAt(Le)!==K.charCodeAt(Le))return Le;return he}e.commonPrefixLength=x;function U($,K){const he=Math.min($.length,K.length);let Le;const Ne=$.length-1,xe=K.length-1;for(Le=0;Le<he;Le++)if($.charCodeAt(Ne-Le)!==K.charCodeAt(xe-Le))return Le;return he}e.commonSuffixLength=U;function T($){return 55296<=$&&$<=56319}e.isHighSurrogate=T;function F($){return 56320<=$&&$<=57343}e.isLowSurrogate=F;function B($,K){return($-55296<<10)+(K-56320)+65536}e.computeCodePoint=B;function Z($,K,he){const Le=$.charCodeAt(he);if(T(Le)&&he+1<K){const Ne=$.charCodeAt(he+1);if(F(Ne))return B(Le,Ne)}return Le}e.getNextCodePoint=Z;function _($,K){const he=$.charCodeAt(K-1);if(F(he)&&K>1){const Le=$.charCodeAt(K-2);if(T(Le))return B(Le,he)}return he}class H{get offset(){return this.e}constructor(K,he=0){this.c=K,this.d=K.length,this.e=he}setOffset(K){this.e=K}prevCodePoint(){const K=_(this.c,this.e);return this.e-=K>=65536?2:1,K}nextCodePoint(){const K=Z(this.c,this.d,this.e);return this.e+=K>=65536?2:1,K}eol(){return this.e>=this.d}}e.CodePointIterator=H;class Y{get offset(){return this.c.offset}constructor(K,he=0){this.c=new H(K,he)}nextGraphemeLength(){const K=He.getInstance(),he=this.c,Le=he.offset;let Ne=K.getGraphemeBreakType(he.nextCodePoint());for(;!he.eol();){const xe=he.offset,je=K.getGraphemeBreakType(he.nextCodePoint());if(Ce(Ne,je)){he.setOffset(xe);break}Ne=je}return he.offset-Le}prevGraphemeLength(){const K=He.getInstance(),he=this.c,Le=he.offset;let Ne=K.getGraphemeBreakType(he.prevCodePoint());for(;he.offset>0;){const xe=he.offset,je=K.getGraphemeBreakType(he.prevCodePoint());if(Ce(je,Ne)){he.setOffset(xe);break}Ne=je}return Le-he.offset}eol(){return this.c.eol()}}e.GraphemeIterator=Y;function ie($,K){return new Y($,K).nextGraphemeLength()}e.nextCharLength=ie;function ge($,K){return new Y($,K).prevGraphemeLength()}e.prevCharLength=ge;function X($,K){K>0&&F($.charCodeAt(K))&&K--;const he=K+ie($,K);return[he-ge($,he),he]}e.getCharContainingOffset=X;function J($){const K=new Y($);let he=0;for(;!K.eol();)he++,K.nextGraphemeLength();return he}e.charCount=J;let ee;function me(){return/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/}function ve($){return ee||(ee=me()),ee.test($)}e.containsRTL=ve;const Ie=/^[\t\n\r\x20-\x7E]*$/;function Re($){return Ie.test($)}e.isBasicASCII=Re,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function ae($){return e.UNUSUAL_LINE_TERMINATORS.test($)}e.containsUnusualLineTerminators=ae;function le($){return $>=11904&&$<=55215||$>=63744&&$<=64255||$>=65281&&$<=65374}e.isFullWidthCharacter=le;function ue($){return $>=127462&&$<=127487||$===8986||$===8987||$===9200||$===9203||$>=9728&&$<=10175||$===11088||$===11093||$>=127744&&$<=128591||$>=128640&&$<=128764||$>=128992&&$<=129008||$>=129280&&$<=129535||$>=129648&&$<=129782}e.isEmojiImprecise=ue;function ne($,K){if($.length<K)return $;const he=/\b/g;let Le=0;for(;he.test($)&&!($.length-he.lastIndex<K);)Le=he.lastIndex,he.lastIndex+=1;return $.substring(Le).replace(/^\s/,"")}e.lcut=ne;const ce=/(:?\x1b\[|\x9B)[=?>!]?[\d;:]*["$#'* ]?[a-zA-Z@^`{}|~]/g;function oe($){return $&&($=$.replace(ce,"")),$}e.removeAnsiEscapeCodes=oe,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function M($){return!!($&&$.length>0&&$.charCodeAt(0)===65279)}e.startsWithUTF8BOM=M;function z($){return M($)?$.substr(1):$}e.stripUTF8BOM=z;function G($,K){if(!$||!K||$.length<K.length)return!1;const he=K.length,Le=$.toLowerCase();let Ne=0,xe=-1;for(;Ne<he;){const je=Le.indexOf(K[Ne],xe+1);if(je<0)return!1;xe=je,Ne++}return!0}e.fuzzyContains=G;function te($,K=!1){return $?(K&&($=$.replace(/\\./g,"")),$.toLowerCase()!==$):!1}e.containsUppercaseCharacter=te;function de($){return $.charAt(0).toUpperCase()+$.slice(1)}e.uppercaseFirstLetter=de;function we($,K=1){if(K===0)return"";let he=-1;do he=$.indexOf(`
`,he+1),K--;while(K>0&&he>=0);return he===-1?$:($[he-1]==="\r"&&he--,$.substr(0,he))}e.getNLines=we;function Pe($){return $=$%(2*26),$<26?String.fromCharCode(97+$):String.fromCharCode(65+$-26)}e.singleLetterHash=Pe;function be($){return He.getInstance().getGraphemeBreakType($)}e.getGraphemeBreakType=be;function Ce($,K){return $===0?K!==5&&K!==7:$===2&&K===3?!1:$===4||$===2||$===3||K===4||K===2||K===3?!0:!($===8&&(K===8||K===9||K===11||K===12)||($===11||$===9)&&(K===9||K===10)||($===12||$===10)&&K===10||K===5||K===13||K===7||$===1||$===13&&K===14||$===6&&K===6)}var ke;(function($){$[$.Other=0]="Other",$[$.Prepend=1]="Prepend",$[$.CR=2]="CR",$[$.LF=3]="LF",$[$.Control=4]="Control",$[$.Extend=5]="Extend",$[$.Regional_Indicator=6]="Regional_Indicator",$[$.SpacingMark=7]="SpacingMark",$[$.L=8]="L",$[$.V=9]="V",$[$.T=10]="T",$[$.LV=11]="LV",$[$.LVT=12]="LVT",$[$.ZWJ=13]="ZWJ",$[$.Extended_Pictographic=14]="Extended_Pictographic"})(ke=e.GraphemeBreakType||(e.GraphemeBreakType={}));class He{static getInstance(){return He.c||(He.c=new He),He.c}constructor(){this.d=Ge()}getGraphemeBreakType(K){if(K<32)return K===10?3:K===13?2:4;if(K<127)return 0;const he=this.d,Le=he.length/3;let Ne=1;for(;Ne<=Le;)if(K<he[3*Ne])Ne=2*Ne;else if(K>he[3*Ne+1])Ne=2*Ne+1;else return he[3*Ne+2];return 0}}He.c=null;function Ge(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function nt($,K){if($===0)return 0;const he=Qe($,K);if(he!==void 0)return he;const Le=new H(K,$);return Le.prevCodePoint(),Le.offset}e.getLeftDeleteOffset=nt;function Qe($,K){const he=new H(K,$);let Le=he.prevCodePoint();for(;tt(Le)||Le===65039||Le===8419;){if(he.offset===0)return;Le=he.prevCodePoint()}if(!ue(Le))return;let Ne=he.offset;return Ne>0&&he.prevCodePoint()===8205&&(Ne=he.offset),Ne}function tt($){return 127995<=$&&$<=127999}var rt;(function($){$[$.zwj=8205]="zwj",$[$.emojiVariantSelector=65039]="emojiVariantSelector",$[$.enclosingKeyCap=8419]="enclosingKeyCap"})(rt||(rt={})),e.noBreakWhitespace="\xA0";class Be{static getInstance(K){return Be.d.get(Array.from(K))}static getLocales(){return Be.e.value}constructor(K){this.f=K}isAmbiguous(K){return this.f.has(K)}getPrimaryConfusable(K){return this.f.get(K)}getConfusableCodePoints(){return new Set(this.f.keys())}}l=Be,Be.c=new L.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Be.d=new a.LRUCachedFunction($=>{function K(at){const mt=new Map;for(let gt=0;gt<at.length;gt+=2)mt.set(at[gt],at[gt+1]);return mt}function he(at,mt){const gt=new Map(at);for(const[Et,lt]of mt)gt.set(Et,lt);return gt}function Le(at,mt){if(!at)return mt;const gt=new Map;for(const[Et,lt]of at)mt.has(Et)&&gt.set(Et,lt);return gt}const Ne=l.c.value;let xe=$.filter(at=>!at.startsWith("_")&&at in Ne);xe.length===0&&(xe=["_default"]);let je;for(const at of xe){const mt=K(Ne[at]);je=Le(je,mt)}const Ze=K(Ne._common),st=he(Ze,je);return new Be(st)}),Be.e=new L.Lazy(()=>Object.keys(Be.c.value).filter($=>!$.startsWith("_"))),e.AmbiguousCharacters=Be;class it{static c(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static e(){return this.d||(this.d=new Set(it.c())),this.d}static isInvisibleCharacter(K){return it.e().has(K)}static get codePoints(){return it.e()}}it.d=void 0,e.InvisibleCharacters=it}),define(ye[106],De([1,0,28,8]),function(re,e,a,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function l(...oe){return function(M,z){for(let G=0,te=oe.length;G<te;G++){const de=oe[G](M,z);if(de)return de}return null}}e.or=l,e.matchesStrictPrefix=R.bind(void 0,!1),e.matchesPrefix=R.bind(void 0,!0);function R(oe,M,z){if(!z||z.length<M.length)return null;let G;return oe?G=L.startsWithIgnoreCase(z,M):G=z.indexOf(M)===0,G?M.length>0?[{start:0,end:M.length}]:[]:null}function S(oe,M){const z=M.toLowerCase().indexOf(oe.toLowerCase());return z===-1?null:[{start:z,end:z+oe.length}]}e.matchesContiguousSubString=S;function A(oe,M){return y(oe.toLowerCase(),M.toLowerCase(),0,0)}e.matchesSubString=A;function y(oe,M,z,G){if(z===oe.length)return[];if(G===M.length)return null;if(oe[z]===M[G]){let te=null;return(te=y(oe,M,z+1,G+1))?h({start:G,end:G+1},te):null}return y(oe,M,z,G+1)}function I(oe){return 97<=oe&&oe<=122}function O(oe){return 65<=oe&&oe<=90}e.isUpper=O;function P(oe){return 48<=oe&&oe<=57}function v(oe){return oe===32||oe===9||oe===10||oe===13}const k=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(oe=>k.add(oe.charCodeAt(0)));function D(oe){return v(oe)||k.has(oe)}function f(oe,M){return oe===M||D(oe)&&D(M)}function u(oe){return I(oe)||O(oe)||P(oe)}function h(oe,M){return M.length===0?M=[oe]:oe.end===M[0].start?M[0].start=oe.start:M.unshift(oe),M}function p(oe,M){for(let z=M;z<oe.length;z++){const G=oe.charCodeAt(z);if(O(G)||P(G)||z>0&&!u(oe.charCodeAt(z-1)))return z}return oe.length}function b(oe,M,z,G){if(z===oe.length)return[];if(G===M.length)return null;if(oe[z]!==M[G].toLowerCase())return null;{let te=null,de=G+1;for(te=b(oe,M,z+1,G+1);!te&&(de=p(M,de))<M.length;)te=b(oe,M,z+1,de),de++;return te===null?null:h({start:G,end:G+1},te)}}function C(oe){let M=0,z=0,G=0,te=0,de=0;for(let ke=0;ke<oe.length;ke++)de=oe.charCodeAt(ke),O(de)&&M++,I(de)&&z++,u(de)&&G++,P(de)&&te++;const we=M/oe.length,Pe=z/oe.length,be=G/oe.length,Ce=te/oe.length;return{upperPercent:we,lowerPercent:Pe,alphaPercent:be,numericPercent:Ce}}function g(oe){const{upperPercent:M,lowerPercent:z}=oe;return z===0&&M>.6}function i(oe){const{upperPercent:M,lowerPercent:z,alphaPercent:G,numericPercent:te}=oe;return z>.2&&M<.8&&G>.6&&te<.2}function s(oe){let M=0,z=0,G=0,te=0;for(let de=0;de<oe.length;de++)G=oe.charCodeAt(de),O(G)&&M++,I(G)&&z++,v(G)&&te++;return(M===0||z===0)&&te===0?oe.length<=30:M<=5}function r(oe,M){if(!M||(M=M.trim(),M.length===0)||!s(oe)||M.length>60)return null;const z=C(M);if(!i(z)){if(!g(z))return null;M=M.toLowerCase()}let G=null,te=0;for(oe=oe.toLowerCase();te<M.length&&(G=b(oe,M,0,te))===null;)te=p(M,te+1);return G}e.matchesCamelCase=r;function o(oe,M,z=!1){if(!M||M.length===0)return null;let G=null,te=0;for(oe=oe.toLowerCase(),M=M.toLowerCase();te<M.length&&(G=c(oe,M,0,te,z))===null;)te=m(M,te+1);return G}e.matchesWords=o;function c(oe,M,z,G,te){if(z===oe.length)return[];if(G===M.length)return null;if(f(oe.charCodeAt(z),M.charCodeAt(G))){let de=null,we=G+1;if(de=c(oe,M,z+1,G+1,te),!te)for(;!de&&(we=m(M,we))<M.length;)de=c(oe,M,z+1,we,te),we++;return de?oe.charCodeAt(z)!==M.charCodeAt(G)?de:h({start:G,end:G+1},de):null}else return null}function m(oe,M){for(let z=M;z<oe.length;z++)if(D(oe.charCodeAt(z))||z>0&&D(oe.charCodeAt(z-1)))return z;return oe.length}const n=l(e.matchesPrefix,r,S),t=l(e.matchesPrefix,r,A),d=new a.LRUCache(1e4);function E(oe,M,z=!1){if(typeof oe!="string"||typeof M!="string")return null;let G=d.get(oe);G||(G=new RegExp(L.convertSimple2RegExpPattern(oe),"i"),d.set(oe,G));const te=G.exec(M);return te?[{start:te.index,end:te.index+te[0].length}]:z?t(oe,M):n(oe,M)}e.matchesFuzzy=E;function w(oe,M){const z=Ie(oe,oe.toLowerCase(),0,M,M.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return z?j(z):null}e.matchesFuzzy2=w;function N(oe,M,z,G,te,de){const we=Math.min(13,oe.length);for(;z<we;z++){const Pe=Ie(oe,M,z,G,te,de,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(Pe)return Pe}return[0,de]}e.anyScore=N;function j(oe){if(typeof oe>"u")return[];const M=[],z=oe[1];for(let G=oe.length-1;G>1;G--){const te=oe[G]+z,de=M[M.length-1];de&&de.end===te?de.end=te+1:M.push({start:te,end:te+1})}return M}e.createMatches=j;const V=128;function Q(){const oe=[],M=[];for(let z=0;z<=V;z++)M[z]=0;for(let z=0;z<=V;z++)oe.push(M.slice(0));return oe}function x(oe){const M=[];for(let z=0;z<=oe;z++)M[z]=0;return M}const U=x(2*V),T=x(2*V),F=Q(),B=Q(),Z=Q(),_=!1;function H(oe,M,z,G,te){function de(Pe,be,Ce=" "){for(;Pe.length<be;)Pe=Ce+Pe;return Pe}let we=` |   |${G.split("").map(Pe=>de(Pe,3)).join("|")}
`;for(let Pe=0;Pe<=z;Pe++)Pe===0?we+=" |":we+=`${M[Pe-1]}|`,we+=oe[Pe].slice(0,te+1).map(be=>de(be.toString(),3)).join("|")+`
`;return we}function Y(oe,M,z,G){oe=oe.substr(M),z=z.substr(G),console.log(H(B,oe,oe.length,z,z.length)),console.log(H(Z,oe,oe.length,z,z.length)),console.log(H(F,oe,oe.length,z,z.length))}function ie(oe,M){if(M<0||M>=oe.length)return!1;const z=oe.codePointAt(M);switch(z){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!L.isEmojiImprecise(z)}}function ge(oe,M){if(M<0||M>=oe.length)return!1;switch(oe.charCodeAt(M)){case 32:case 9:return!0;default:return!1}}function X(oe,M,z){return M[oe]!==z[oe]}function J(oe,M,z,G,te,de,we=!1){for(;M<z&&te<de;)oe[M]===G[te]&&(we&&(U[M]=te),M+=1),te+=1;return M===z}e.isPatternInWord=J;var ee;(function(oe){oe[oe.Diag=1]="Diag",oe[oe.Left=2]="Left",oe[oe.LeftLeft=3]="LeftLeft"})(ee||(ee={}));var me;(function(oe){oe.Default=[-100,0];function M(z){return!z||z.length===2&&z[0]===-100&&z[1]===0}oe.isDefault=M})(me=e.FuzzyScore||(e.FuzzyScore={}));class ve{constructor(M,z){this.firstMatchCanBeWeak=M,this.boostFullMatch=z}}ve.default={boostFullMatch:!0,firstMatchCanBeWeak:!1},e.FuzzyScoreOptions=ve;function Ie(oe,M,z,G,te,de,we=ve.default){const Pe=oe.length>V?V:oe.length,be=G.length>V?V:G.length;if(z>=Pe||de>=be||Pe-z>be-de||!J(M,z,Pe,te,de,be,!0))return;Re(Pe,be,z,de,M,te);let Ce=1,ke=1,He=z,Ge=de;const nt=[!1];for(Ce=1,He=z;He<Pe;Ce++,He++){const it=U[He],$=T[He],K=He+1<Pe?T[He+1]:be;for(ke=it-de+1,Ge=it;Ge<K;ke++,Ge++){let he=Number.MIN_SAFE_INTEGER,Le=!1;Ge<=$&&(he=ae(oe,M,He,z,G,te,Ge,be,de,F[Ce-1][ke-1]===0,nt));let Ne=0;he!==Number.MAX_SAFE_INTEGER&&(Le=!0,Ne=he+B[Ce-1][ke-1]);const xe=Ge>it,je=xe?B[Ce][ke-1]+(F[Ce][ke-1]>0?-5:0):0,Ze=Ge>it+1&&F[Ce][ke-1]>0,st=Ze?B[Ce][ke-2]+(F[Ce][ke-2]>0?-5:0):0;if(Ze&&(!xe||st>=je)&&(!Le||st>=Ne))B[Ce][ke]=st,Z[Ce][ke]=3,F[Ce][ke]=0;else if(xe&&(!Le||je>=Ne))B[Ce][ke]=je,Z[Ce][ke]=2,F[Ce][ke]=0;else if(Le)B[Ce][ke]=Ne,Z[Ce][ke]=1,F[Ce][ke]=F[Ce-1][ke-1]+1;else throw new Error("not possible")}}if(_&&Y(oe,z,G,de),!nt[0]&&!we.firstMatchCanBeWeak)return;Ce--,ke--;const Qe=[B[Ce][ke],de];let tt=0,rt=0;for(;Ce>=1;){let it=ke;do{const $=Z[Ce][it];if($===3)it=it-2;else if($===2)it=it-1;else break}while(it>=1);tt>1&&M[z+Ce-1]===te[de+ke-1]&&!X(it+de-1,G,te)&&tt+1>F[Ce][it]&&(it=ke),it===ke?tt++:tt=1,rt||(rt=it),Ce--,ke=it-1,Qe.push(ke)}be===Pe&&we.boostFullMatch&&(Qe[0]+=2);const Be=rt-Pe;return Qe[0]-=Be,Qe}e.fuzzyScore=Ie;function Re(oe,M,z,G,te,de){let we=oe-1,Pe=M-1;for(;we>=z&&Pe>=G;)te[we]===de[Pe]&&(T[we]=Pe,we--),Pe--}function ae(oe,M,z,G,te,de,we,Pe,be,Ce,ke){if(M[z]!==de[we])return Number.MIN_SAFE_INTEGER;let He=1,Ge=!1;return we===z-G?He=oe[z]===te[we]?7:5:X(we,te,de)&&(we===0||!X(we-1,te,de))?(He=oe[z]===te[we]?7:5,Ge=!0):ie(de,we)&&(we===0||!ie(de,we-1))?He=5:(ie(de,we-1)||ge(de,we-1))&&(He=5,Ge=!0),He>1&&z===G&&(ke[0]=!0),Ge||(Ge=X(we,te,de)||ie(de,we-1)||ge(de,we-1)),z===G?we>be&&(He-=Ge?3:5):Ce?He+=Ge?2:0:He+=Ge?0:1,we+1===Pe&&(He-=Ge?3:5),He}function le(oe,M,z,G,te,de,we){return ne(oe,M,z,G,te,de,!0,we)}e.fuzzyScoreGracefulAggressive=le;function ue(oe,M,z,G,te,de,we){return ne(oe,M,z,G,te,de,!1,we)}e.fuzzyScoreGraceful=ue;function ne(oe,M,z,G,te,de,we,Pe){let be=Ie(oe,M,z,G,te,de,Pe);if(be&&!we)return be;if(oe.length>=3){const Ce=Math.min(7,oe.length-1);for(let ke=z+1;ke<Ce;ke++){const He=ce(oe,ke);if(He){const Ge=Ie(He,He.toLowerCase(),z,G,te,de,Pe);Ge&&(Ge[0]-=3,(!be||Ge[0]>be[0])&&(be=Ge))}}}return be}function ce(oe,M){if(M+1>=oe.length)return;const z=oe[M],G=oe[M+1];if(z!==G)return oe.slice(0,M)+G+z+oe.slice(M+2)}}),define(ye[89],De([1,0,8]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function L(h){return l(h,0)}e.hash=L;function l(h,p){switch(typeof h){case"object":return h===null?R(349,p):Array.isArray(h)?y(h,p):I(h,p);case"string":return A(h,p);case"boolean":return S(h,p);case"number":return R(h,p);case"undefined":return R(937,p);default:return R(617,p)}}e.doHash=l;function R(h,p){return(p<<5)-p+h|0}e.numberHash=R;function S(h,p){return R(h?433:863,p)}function A(h,p){p=R(149417,p);for(let b=0,C=h.length;b<C;b++)p=R(h.charCodeAt(b),p);return p}e.stringHash=A;function y(h,p){return p=R(104579,p),h.reduce((b,C)=>l(C,b),p)}function I(h,p){return p=R(181387,p),Object.keys(h).sort().reduce((b,C)=>(b=A(C,b),l(h[C],b)),p)}class O{constructor(){this.g=0}get value(){return this.g}hash(p){return this.g=l(p,this.g),this.g}}e.Hasher=O;var P;(function(h){h[h.BLOCK_SIZE=64]="BLOCK_SIZE",h[h.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function v(h,p,b=32){const C=b-p,g=~((1<<C)-1);return(h<<p|(g&h)>>>C)>>>0}function k(h,p=0,b=h.byteLength,C=0){for(let g=0;g<b;g++)h[p+g]=C}function D(h,p,b="0"){for(;h.length<p;)h=b+h;return h}function f(h,p=32){return h instanceof ArrayBuffer?Array.from(new Uint8Array(h)).map(b=>b.toString(16).padStart(2,"0")).join(""):D((h>>>0).toString(16),p/4)}e.toHexString=f;class u{constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(64+3),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(p){const b=p.length;if(b===0)return;const C=this.p;let g=this.r,i=this.u,s,r;for(i!==0?(s=i,r=-1,i=0):(s=p.charCodeAt(0),r=0);;){let o=s;if(a.isHighSurrogate(s))if(r+1<b){const c=p.charCodeAt(r+1);a.isLowSurrogate(c)?(r++,o=a.computeCodePoint(s,c)):o=65533}else{i=s;break}else a.isLowSurrogate(s)&&(o=65533);if(g=this.w(C,g,o),r++,r<b)s=p.charCodeAt(r);else break}this.r=g,this.u=i}w(p,b,C){return C<128?p[b++]=C:C<2048?(p[b++]=192|(C&1984)>>>6,p[b++]=128|(C&63)>>>0):C<65536?(p[b++]=224|(C&61440)>>>12,p[b++]=128|(C&4032)>>>6,p[b++]=128|(C&63)>>>0):(p[b++]=240|(C&1835008)>>>18,p[b++]=128|(C&258048)>>>12,p[b++]=128|(C&4032)>>>6,p[b++]=128|(C&63)>>>0),b>=64&&(this.y(),b-=64,this.t+=64,p[0]=p[64+0],p[1]=p[64+1],p[2]=p[64+2]),b}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),f(this.h)+f(this.l)+f(this.m)+f(this.n)+f(this.o)}x(){this.p[this.r++]=128,k(this.p,this.r),this.r>56&&(this.y(),k(this.p));const p=8*this.t;this.q.setUint32(56,Math.floor(p/4294967296),!1),this.q.setUint32(60,p%4294967296,!1),this.y()}y(){const p=u.g,b=this.q;for(let n=0;n<64;n+=4)p.setUint32(n,b.getUint32(n,!1),!1);for(let n=64;n<320;n+=4)p.setUint32(n,v(p.getUint32(n-12,!1)^p.getUint32(n-32,!1)^p.getUint32(n-56,!1)^p.getUint32(n-64,!1),1),!1);let C=this.h,g=this.l,i=this.m,s=this.n,r=this.o,o,c,m;for(let n=0;n<80;n++)n<20?(o=g&i|~g&s,c=1518500249):n<40?(o=g^i^s,c=1859775393):n<60?(o=g&i|g&s|i&s,c=2400959708):(o=g^i^s,c=3395469782),m=v(C,5)+o+r+c+p.getUint32(n*4,!1)&4294967295,r=s,s=i,i=v(g,30),g=C,C=m;this.h=this.h+C&4294967295,this.l=this.l+g&4294967295,this.m=this.m+i&4294967295,this.n=this.n+s&4294967295,this.o=this.o+r&4294967295}}u.g=new DataView(new ArrayBuffer(320)),e.StringSHA1=u}),define(ye[107],De([1,0,103,106,89,9,12,8]),function(re,e,a,L,l,R,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.pieceToQuery=e.prepareQuery=e.compareItemsByFuzzyScore=e.scoreItemFuzzy=e.scoreFuzzy2=e.scoreFuzzy=void 0;const y=0,I=[y,[]];function O(F,B,Z,_){if(!F||!B)return I;const H=F.length,Y=B.length;if(H<Y)return I;const ie=F.toLowerCase();return P(B,Z,Y,F,ie,H,_)}e.scoreFuzzy=O;function P(F,B,Z,_,H,Y,ie){const ge=[],X=[];for(let ve=0;ve<Z;ve++){const Ie=ve*Y,Re=Ie-Y,ae=ve>0,le=F[ve],ue=B[ve];for(let ne=0;ne<Y;ne++){const ce=ne>0,oe=Ie+ne,M=oe-1,z=Re+ne-1,G=ce?ge[M]:0,te=ae&&ce?ge[z]:0,de=ae&&ce?X[z]:0;let we;!te&&ae?we=0:we=v(le,ue,_,H,ne,de),we&&te+we>=G&&(ie||ae||H.startsWith(B,ne))?(X[oe]=de+1,ge[oe]=te+we):(X[oe]=y,ge[oe]=G)}}const J=[];let ee=Z-1,me=Y-1;for(;ee>=0&&me>=0;){const ve=ee*Y+me;X[ve]===y||(J.push(me),ee--),me--}return[ge[Z*Y-1],J.reverse()]}function v(F,B,Z,_,H,Y){let ie=0;if(!k(B,_[H]))return ie;if(ie+=1,Y>0&&(ie+=Y*5),F===Z[H]&&(ie+=1),H===0)ie+=8;else{const ge=D(Z.charCodeAt(H-1));ge?ie+=ge:(0,L.isUpper)(Z.charCodeAt(H))&&Y===0&&(ie+=2)}return ie}function k(F,B){return F===B?!0:F==="/"||F==="\\"?B==="/"||B==="\\":!1}function D(F){switch(F){case 47:case 92:return 5;case 95:case 45:case 46:case 32:case 39:case 34:case 58:return 4;default:return 0}}const f=[void 0,[]];function u(F,B,Z=0,_=0){const H=B;return H.values&&H.values.length>1?h(F,H.values,Z,_):p(F,B,Z,_)}e.scoreFuzzy2=u;function h(F,B,Z,_){let H=0;const Y=[];for(const ie of B){const[ge,X]=p(F,ie,Z,_);if(typeof ge!="number")return f;H+=ge,Y.push(...X)}return[H,t(Y)]}function p(F,B,Z,_){const H=(0,L.fuzzyScore)(B.original,B.originalLowercase,Z,F,F.toLowerCase(),_,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return H?[H[0],(0,L.createMatches)(H)]:f}const b=Object.freeze({score:0}),C=1<<18,g=1<<17,i=1<<16;function s(F,B,Z,_){const H=_.values?_.values:[_];return(0,l.hash)({[_.normalized]:{values:H.map(ie=>({value:ie.normalized,expectContiguousMatch:ie.expectContiguousMatch})),label:F,description:B,allowNonContiguousMatches:Z}})}function r(F,B,Z,_,H){if(!F||!B.normalized)return b;const Y=_.getItemLabel(F);if(!Y)return b;const ie=_.getItemDescription(F),ge=s(Y,ie,Z,B),X=H[ge];if(X)return X;const J=o(Y,ie,_.getItemPath(F),B,Z);return H[ge]=J,J}e.scoreItemFuzzy=r;function o(F,B,Z,_,H){const Y=!Z||!_.containsPathSeparator;return Z&&(S.isLinux?_.pathNormalized===Z:(0,A.equalsIgnoreCase)(_.pathNormalized,Z))?{score:C,labelMatch:[{start:0,end:F.length}],descriptionMatch:B?[{start:0,end:B.length}]:void 0}:_.values&&_.values.length>1?c(F,B,Z,_.values,Y,H):m(F,B,Z,_,Y,H)}function c(F,B,Z,_,H,Y){let ie=0;const ge=[],X=[];for(const J of _){const{score:ee,labelMatch:me,descriptionMatch:ve}=m(F,B,Z,J,H,Y);if(ee===y)return b;ie+=ee,me&&ge.push(...me),ve&&X.push(...ve)}return{score:ie,labelMatch:t(ge),descriptionMatch:t(X)}}function m(F,B,Z,_,H,Y){if(H||!B){const[ie,ge]=O(F,_.normalized,_.normalizedLowercase,Y&&!_.expectContiguousMatch);if(ie){const X=(0,L.matchesPrefix)(_.normalized,F);let J;return X?(J=g,J+=Math.round(_.normalized.length/F.length*100)):J=i,{score:J+ie,labelMatch:X||n(ge)}}}if(B){let ie=B;Z&&(ie=`${B}${R.sep}`);const ge=ie.length,X=`${ie}${F}`,[J,ee]=O(X,_.normalized,_.normalizedLowercase,Y&&!_.expectContiguousMatch);if(J){const me=n(ee),ve=[],Ie=[];return me.forEach(Re=>{Re.start<ge&&Re.end>ge?(ve.push({start:0,end:Re.end-ge}),Ie.push({start:Re.start,end:ge})):Re.start>=ge?ve.push({start:Re.start-ge,end:Re.end-ge}):Ie.push(Re)}),{score:J,labelMatch:ve,descriptionMatch:Ie}}}return b}function n(F){const B=[];if(!F)return B;let Z;for(const _ of F)Z&&Z.end===_?Z.end+=1:(Z={start:_,end:_+1},B.push(Z));return B}function t(F){const B=F.sort((H,Y)=>H.start-Y.start),Z=[];let _;for(const H of B)!_||!d(_,H)?(_=H,Z.push(H)):(_.start=Math.min(_.start,H.start),_.end=Math.max(_.end,H.end));return Z}function d(F,B){return!(F.end<B.start||B.end<F.start)}function E(F,B,Z,_,H,Y){const ie=r(F,Z,_,H,Y),ge=r(B,Z,_,H,Y),X=ie.score,J=ge.score;if((X===C||J===C)&&X!==J)return X===C?-1:1;if(X>i||J>i){if(X!==J)return X>J?-1:1;if(X<g&&J<g){const le=N(ie.labelMatch,ge.labelMatch);if(le!==0)return le}const Re=H.getItemLabel(F)||"",ae=H.getItemLabel(B)||"";if(Re.length!==ae.length)return Re.length-ae.length}if(X!==J)return X>J?-1:1;const ee=Array.isArray(ie.labelMatch)&&ie.labelMatch.length>0,me=Array.isArray(ge.labelMatch)&&ge.labelMatch.length>0;if(ee&&!me)return-1;if(me&&!ee)return 1;const ve=w(F,ie,H),Ie=w(B,ge,H);return ve&&Ie&&ve!==Ie?Ie>ve?-1:1:j(F,B,Z,H)}e.compareItemsByFuzzyScore=E;function w(F,B,Z){let _=-1,H=-1;if(B.descriptionMatch&&B.descriptionMatch.length?_=B.descriptionMatch[0].start:B.labelMatch&&B.labelMatch.length&&(_=B.labelMatch[0].start),B.labelMatch&&B.labelMatch.length){if(H=B.labelMatch[B.labelMatch.length-1].end,B.descriptionMatch&&B.descriptionMatch.length){const Y=Z.getItemDescription(F);Y&&(H+=Y.length)}}else B.descriptionMatch&&B.descriptionMatch.length&&(H=B.descriptionMatch[B.descriptionMatch.length-1].end);return H-_}function N(F,B){if(!F&&!B||(!F||!F.length)&&(!B||!B.length))return 0;if(!B||!B.length)return-1;if(!F||!F.length)return 1;const Z=F[0].start,H=F[F.length-1].end-Z,Y=B[0].start,ge=B[B.length-1].end-Y;return H===ge?0:ge<H?1:-1}function j(F,B,Z,_){const H=_.getItemLabel(F)||"",Y=_.getItemLabel(B)||"",ie=_.getItemDescription(F),ge=_.getItemDescription(B),X=H.length+(ie?ie.length:0),J=Y.length+(ge?ge.length:0);if(X!==J)return X-J;const ee=_.getItemPath(F),me=_.getItemPath(B);return ee&&me&&ee.length!==me.length?ee.length-me.length:H!==Y?(0,a.compareAnything)(H,Y,Z.normalized):ie&&ge&&ie!==ge?(0,a.compareAnything)(ie,ge,Z.normalized):ee&&me&&ee!==me?(0,a.compareAnything)(ee,me,Z.normalized):0}function V(F){return F.startsWith('"')&&F.endsWith('"')}const Q=" ";function x(F){typeof F!="string"&&(F="");const B=F.toLowerCase(),{pathNormalized:Z,normalized:_,normalizedLowercase:H}=U(F),Y=Z.indexOf(R.sep)>=0,ie=V(F);let ge;const X=F.split(Q);if(X.length>1)for(const J of X){const ee=V(J),{pathNormalized:me,normalized:ve,normalizedLowercase:Ie}=U(J);ve&&(ge||(ge=[]),ge.push({original:J,originalLowercase:J.toLowerCase(),pathNormalized:me,normalized:ve,normalizedLowercase:Ie,expectContiguousMatch:ee}))}return{original:F,originalLowercase:B,pathNormalized:Z,normalized:_,normalizedLowercase:H,values:ge,containsPathSeparator:Y,expectContiguousMatch:ie}}e.prepareQuery=x;function U(F){let B;S.isWindows?B=F.replace(/\//g,R.sep):B=F.replace(/\\/g,R.sep);const Z=(0,A.stripWildcards)(B).replace(/\s|"/g,"");return{pathNormalized:B,normalized:Z,normalizedLowercase:Z.toLowerCase()}}function T(F){return Array.isArray(F)?x(F.map(B=>B.original).join(Q)):x(F.original)}e.pieceToQuery=T}),define(ye[37],De([1,0,8]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var L;(function(l){l[l.Ignore=0]="Ignore",l[l.Info=1]="Info",l[l.Warning=2]="Warning",l[l.Error=3]="Error"})(L||(L={})),function(l){const R="error",S="warning",A="warn",y="info",I="ignore";function O(v){return v?a.equalsIgnoreCase(R,v)?l.Error:a.equalsIgnoreCase(S,v)||a.equalsIgnoreCase(A,v)?l.Warning:a.equalsIgnoreCase(y,v)?l.Info:l.Ignore:l.Ignore}l.fromValue=O;function P(v){switch(v){case l.Error:return R;case l.Warning:return S;case l.Info:return y;default:return I}}l.toString=P}(L||(L={})),e.default=L}),define(ye[149],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MicrotaskDelay=void 0,e.MicrotaskDelay=Symbol("MicrotaskDelay")}),define(ye[68],De([1,0,15,8]),function(re,e,a,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=void 0;class l{constructor(){this.b="",this.c=0}reset(k){return this.b=k,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(k){const D=k.charCodeAt(0),f=this.b.charCodeAt(this.c);return D-f}value(){return this.b[this.c]}}e.StringIterator=l;class R{constructor(k=!0){this.e=k}reset(k){return this.b=k,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let k=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(k)this.c++;else break;else k=!1;return this}cmp(k){return this.e?(0,L.compareSubstring)(k,this.b,0,k.length,this.c,this.d):(0,L.compareSubstringIgnoreCase)(k,this.b,0,k.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.ConfigKeysIterator=R;class S{constructor(k=!0,D=!0){this.f=k,this.g=D}reset(k){this.d=0,this.e=0,this.b=k,this.c=k.length;for(let D=k.length-1;D>=0;D--,this.c--){const f=this.b.charCodeAt(D);if(!(f===47||this.f&&f===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let k=!0;for(;this.e<this.c;this.e++){const D=this.b.charCodeAt(this.e);if(D===47||this.f&&D===92)if(k)this.d++;else break;else k=!1}return this}cmp(k){return this.g?(0,L.compareSubstring)(k,this.b,0,k.length,this.d,this.e):(0,L.compareSubstringIgnoreCase)(k,this.b,0,k.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.PathIterator=S;var A;(function(v){v[v.Scheme=1]="Scheme",v[v.Authority=2]="Authority",v[v.Path=3]="Path",v[v.Query=4]="Query",v[v.Fragment=5]="Fragment"})(A||(A={}));class y{constructor(k,D){this.f=k,this.g=D,this.d=[],this.e=0}reset(k){return this.c=k,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new S(!1,!this.f(k)),this.b.reset(k.path),this.b.value()&&this.d.push(3)),this.g(k)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(k){if(this.d[this.e]===1)return(0,L.compareIgnoreCase)(k,this.c.scheme);if(this.d[this.e]===2)return(0,L.compareIgnoreCase)(k,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(k);if(this.d[this.e]===4)return(0,L.compare)(k,this.c.query);if(this.d[this.e]===5)return(0,L.compare)(k,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.UriIterator=y;class I{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const k=this.right;return this.right=k.left,k.left=this,this.updateHeight(),k.updateHeight(),k}rotateRight(){const k=this.left;return this.left=k.right,k.right=this,this.updateHeight(),k.updateHeight(),k}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var O;(function(v){v[v.Left=-1]="Left",v[v.Mid=0]="Mid",v[v.Right=1]="Right"})(O||(O={}));class P{static forUris(k=()=>!1,D=()=>!1){return new P(new y(k,D))}static forPaths(k=!1){return new P(new S(void 0,!k))}static forStrings(){return new P(new l)}static forConfigKeys(){return new P(new R)}constructor(k){this.b=k}clear(){this.c=void 0}fill(k,D){if(D){const f=D.slice(0);(0,a.shuffle)(f);for(const u of f)this.set(u,k)}else{const f=k.slice(0);(0,a.shuffle)(f);for(const u of f)this.set(u[0],u[1])}}set(k,D){const f=this.b.reset(k);let u;this.c||(this.c=new I,this.c.segment=f.value());const h=[];for(u=this.c;;){const b=f.cmp(u.segment);if(b>0)u.left||(u.left=new I,u.left.segment=f.value()),h.push([-1,u]),u=u.left;else if(b<0)u.right||(u.right=new I,u.right.segment=f.value()),h.push([1,u]),u=u.right;else if(f.hasNext())f.next(),u.mid||(u.mid=new I,u.mid.segment=f.value()),h.push([0,u]),u=u.mid;else break}const p=u.value;u.value=D,u.key=k;for(let b=h.length-1;b>=0;b--){const C=h[b][1];C.updateHeight();const g=C.balanceFactor();if(g<-1||g>1){const i=h[b][0],s=h[b+1][0];if(i===1&&s===1)h[b][1]=C.rotateLeft();else if(i===-1&&s===-1)h[b][1]=C.rotateRight();else if(i===1&&s===-1)C.right=h[b+1][1]=h[b+1][1].rotateRight(),h[b][1]=C.rotateLeft();else if(i===-1&&s===1)C.left=h[b+1][1]=h[b+1][1].rotateLeft(),h[b][1]=C.rotateRight();else throw new Error;if(b>0)switch(h[b-1][0]){case-1:h[b-1][1].left=h[b][1];break;case 1:h[b-1][1].right=h[b][1];break;case 0:h[b-1][1].mid=h[b][1];break}else this.c=h[0][1]}}return p}get(k){return this.d(k)?.value}d(k){const D=this.b.reset(k);let f=this.c;for(;f;){const u=D.cmp(f.segment);if(u>0)f=f.left;else if(u<0)f=f.right;else if(D.hasNext())D.next(),f=f.mid;else break}return f}has(k){const D=this.d(k);return!(D?.value===void 0&&D?.mid===void 0)}delete(k){return this.e(k,!1)}deleteSuperstr(k){return this.e(k,!0)}e(k,D){const f=this.b.reset(k),u=[];let h=this.c;for(;h;){const p=f.cmp(h.segment);if(p>0)u.push([-1,h]),h=h.left;else if(p<0)u.push([1,h]),h=h.right;else if(f.hasNext())f.next(),u.push([0,h]),h=h.mid;else break}if(!!h){if(D?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const p=this.f(h.right);if(p.key){const{key:b,value:C,segment:g}=p;this.e(p.key,!1),h.key=b,h.value=C,h.segment=g}}else{const p=h.left??h.right;if(u.length>0){const[b,C]=u[u.length-1];switch(b){case-1:C.left=p;break;case 0:C.mid=p;break;case 1:C.right=p;break}}else this.c=p}for(let p=u.length-1;p>=0;p--){const b=u[p][1];b.updateHeight();const C=b.balanceFactor();if(C>1?(b.right.balanceFactor()>=0||(b.right=b.right.rotateRight()),u[p][1]=b.rotateLeft()):C<-1&&(b.left.balanceFactor()<=0||(b.left=b.left.rotateLeft()),u[p][1]=b.rotateRight()),p>0)switch(u[p-1][0]){case-1:u[p-1][1].left=u[p][1];break;case 1:u[p-1][1].right=u[p][1];break;case 0:u[p-1][1].mid=u[p][1];break}else this.c=u[0][1]}}}f(k){for(;k.left;)k=k.left;return k}findSubstr(k){const D=this.b.reset(k);let f=this.c,u;for(;f;){const h=D.cmp(f.segment);if(h>0)f=f.left;else if(h<0)f=f.right;else if(D.hasNext())D.next(),u=f.value||u,f=f.mid;else break}return f&&f.value||u}findSuperstr(k){return this.g(k,!1)}g(k,D){const f=this.b.reset(k);let u=this.c;for(;u;){const h=f.cmp(u.segment);if(h>0)u=u.left;else if(h<0)u=u.right;else if(f.hasNext())f.next(),u=u.mid;else return u.mid?this.h(u.mid):D?u.value:void 0}}hasElementOrSubtree(k){return this.g(k,!0)!==void 0}forEach(k){for(const[D,f]of this)k(f,D)}*[Symbol.iterator](){yield*this.h(this.c)}h(k){const D=[];return this.j(k,D),D[Symbol.iterator]()}j(k,D){!k||(k.left&&this.j(k.left,D),k.value&&D.push([k.key,k.value]),k.mid&&this.j(k.mid,D),k.right&&this.j(k.right,D))}_isBalanced(){const k=D=>{if(!D)return!0;const f=D.balanceFactor();return f<-1||f>1?!1:k(D.left)&&k(D.right)};return k(this.c)}}e.TernarySearchTree=P}),define(ye[10],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function a(s){return typeof s=="string"}e.isString=a;function L(s){return Array.isArray(s)&&s.every(r=>a(r))}e.isStringArray=L;function l(s){return typeof s=="object"&&s!==null&&!Array.isArray(s)&&!(s instanceof RegExp)&&!(s instanceof Date)}e.isObject=l;function R(s){const r=Object.getPrototypeOf(Uint8Array);return typeof s=="object"&&s instanceof r}e.isTypedArray=R;function S(s){return typeof s=="number"&&!isNaN(s)}e.isNumber=S;function A(s){return!!s&&typeof s[Symbol.iterator]=="function"}e.isIterable=A;function y(s){return s===!0||s===!1}e.isBoolean=y;function I(s){return typeof s>"u"}e.isUndefined=I;function O(s){return!P(s)}e.isDefined=O;function P(s){return I(s)||s===null}e.isUndefinedOrNull=P;function v(s,r){if(!s)throw new Error(r?`Unexpected type, expected '${r}'`:"Unexpected type")}e.assertType=v;function k(s){if(P(s))throw new Error("Assertion Failed: argument is undefined or null");return s}e.assertIsDefined=k;function D(...s){const r=[];for(let o=0;o<s.length;o++){const c=s[o];if(P(c))throw new Error(`Assertion Failed: argument at index ${o} is undefined or null`);r.push(c)}return r}e.assertAllDefined=D;const f=Object.prototype.hasOwnProperty;function u(s){if(!l(s))return!1;for(const r in s)if(f.call(s,r))return!1;return!0}e.isEmptyObject=u;function h(s){return typeof s=="function"}e.isFunction=h;function p(...s){return s.length>0&&s.every(h)}e.areFunctions=p;function b(s,r){const o=Math.min(s.length,r.length);for(let c=0;c<o;c++)C(s[c],r[c])}e.validateConstraints=b;function C(s,r){if(a(r)){if(typeof s!==r)throw new Error(`argument does not match constraint: typeof ${r}`)}else if(h(r)){try{if(s instanceof r)return}catch{}if(!P(s)&&s.constructor===r||r.length===1&&r.call(void 0,s)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=C;function g(s){return s===null?void 0:s}e.withNullAsUndefined=g;function i(s){return typeof s>"u"?null:s}e.withUndefinedAsNull=i}),define(ye[69],De([1,0,10]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Codicon=e.getAllCodicons=e.getCodiconFontCharacters=void 0;const L=Object.create(null);function l(A,y){if((0,a.isString)(y)){const I=L[y];if(I===void 0)throw new Error(`${A} references an unknown codicon: ${y}`);y=I}return L[A]=y,{id:A}}function R(){return L}e.getCodiconFontCharacters=R;function S(){return Object.values(e.Codicon)}e.getAllCodicons=S,e.Codicon={add:l("add",6e4),plus:l("plus",6e4),gistNew:l("gist-new",6e4),repoCreate:l("repo-create",6e4),lightbulb:l("lightbulb",60001),lightBulb:l("light-bulb",60001),repo:l("repo",60002),repoDelete:l("repo-delete",60002),gistFork:l("gist-fork",60003),repoForked:l("repo-forked",60003),gitPullRequest:l("git-pull-request",60004),gitPullRequestAbandoned:l("git-pull-request-abandoned",60004),recordKeys:l("record-keys",60005),keyboard:l("keyboard",60005),tag:l("tag",60006),tagAdd:l("tag-add",60006),tagRemove:l("tag-remove",60006),person:l("person",60007),personFollow:l("person-follow",60007),personOutline:l("person-outline",60007),personFilled:l("person-filled",60007),gitBranch:l("git-branch",60008),gitBranchCreate:l("git-branch-create",60008),gitBranchDelete:l("git-branch-delete",60008),sourceControl:l("source-control",60008),mirror:l("mirror",60009),mirrorPublic:l("mirror-public",60009),star:l("star",60010),starAdd:l("star-add",60010),starDelete:l("star-delete",60010),starEmpty:l("star-empty",60010),comment:l("comment",60011),commentAdd:l("comment-add",60011),alert:l("alert",60012),warning:l("warning",60012),search:l("search",60013),searchSave:l("search-save",60013),logOut:l("log-out",60014),signOut:l("sign-out",60014),logIn:l("log-in",60015),signIn:l("sign-in",60015),eye:l("eye",60016),eyeUnwatch:l("eye-unwatch",60016),eyeWatch:l("eye-watch",60016),circleFilled:l("circle-filled",60017),primitiveDot:l("primitive-dot",60017),closeDirty:l("close-dirty",60017),debugBreakpoint:l("debug-breakpoint",60017),debugBreakpointDisabled:l("debug-breakpoint-disabled",60017),debugHint:l("debug-hint",60017),primitiveSquare:l("primitive-square",60018),edit:l("edit",60019),pencil:l("pencil",60019),info:l("info",60020),issueOpened:l("issue-opened",60020),gistPrivate:l("gist-private",60021),gitForkPrivate:l("git-fork-private",60021),lock:l("lock",60021),mirrorPrivate:l("mirror-private",60021),close:l("close",60022),removeClose:l("remove-close",60022),x:l("x",60022),repoSync:l("repo-sync",60023),sync:l("sync",60023),clone:l("clone",60024),desktopDownload:l("desktop-download",60024),beaker:l("beaker",60025),microscope:l("microscope",60025),vm:l("vm",60026),deviceDesktop:l("device-desktop",60026),file:l("file",60027),fileText:l("file-text",60027),more:l("more",60028),ellipsis:l("ellipsis",60028),kebabHorizontal:l("kebab-horizontal",60028),mailReply:l("mail-reply",60029),reply:l("reply",60029),organization:l("organization",60030),organizationFilled:l("organization-filled",60030),organizationOutline:l("organization-outline",60030),newFile:l("new-file",60031),fileAdd:l("file-add",60031),newFolder:l("new-folder",60032),fileDirectoryCreate:l("file-directory-create",60032),trash:l("trash",60033),trashcan:l("trashcan",60033),history:l("history",60034),clock:l("clock",60034),folder:l("folder",60035),fileDirectory:l("file-directory",60035),symbolFolder:l("symbol-folder",60035),logoGithub:l("logo-github",60036),markGithub:l("mark-github",60036),github:l("github",60036),terminal:l("terminal",60037),console:l("console",60037),repl:l("repl",60037),zap:l("zap",60038),symbolEvent:l("symbol-event",60038),error:l("error",60039),stop:l("stop",60039),variable:l("variable",60040),symbolVariable:l("symbol-variable",60040),array:l("array",60042),symbolArray:l("symbol-array",60042),symbolModule:l("symbol-module",60043),symbolPackage:l("symbol-package",60043),symbolNamespace:l("symbol-namespace",60043),symbolObject:l("symbol-object",60043),symbolMethod:l("symbol-method",60044),symbolFunction:l("symbol-function",60044),symbolConstructor:l("symbol-constructor",60044),symbolBoolean:l("symbol-boolean",60047),symbolNull:l("symbol-null",60047),symbolNumeric:l("symbol-numeric",60048),symbolNumber:l("symbol-number",60048),symbolStructure:l("symbol-structure",60049),symbolStruct:l("symbol-struct",60049),symbolParameter:l("symbol-parameter",60050),symbolTypeParameter:l("symbol-type-parameter",60050),symbolKey:l("symbol-key",60051),symbolText:l("symbol-text",60051),symbolReference:l("symbol-reference",60052),goToFile:l("go-to-file",60052),symbolEnum:l("symbol-enum",60053),symbolValue:l("symbol-value",60053),symbolRuler:l("symbol-ruler",60054),symbolUnit:l("symbol-unit",60054),activateBreakpoints:l("activate-breakpoints",60055),archive:l("archive",60056),arrowBoth:l("arrow-both",60057),arrowDown:l("arrow-down",60058),arrowLeft:l("arrow-left",60059),arrowRight:l("arrow-right",60060),arrowSmallDown:l("arrow-small-down",60061),arrowSmallLeft:l("arrow-small-left",60062),arrowSmallRight:l("arrow-small-right",60063),arrowSmallUp:l("arrow-small-up",60064),arrowUp:l("arrow-up",60065),bell:l("bell",60066),bold:l("bold",60067),book:l("book",60068),bookmark:l("bookmark",60069),debugBreakpointConditionalUnverified:l("debug-breakpoint-conditional-unverified",60070),debugBreakpointConditional:l("debug-breakpoint-conditional",60071),debugBreakpointConditionalDisabled:l("debug-breakpoint-conditional-disabled",60071),debugBreakpointDataUnverified:l("debug-breakpoint-data-unverified",60072),debugBreakpointData:l("debug-breakpoint-data",60073),debugBreakpointDataDisabled:l("debug-breakpoint-data-disabled",60073),debugBreakpointLogUnverified:l("debug-breakpoint-log-unverified",60074),debugBreakpointLog:l("debug-breakpoint-log",60075),debugBreakpointLogDisabled:l("debug-breakpoint-log-disabled",60075),briefcase:l("briefcase",60076),broadcast:l("broadcast",60077),browser:l("browser",60078),bug:l("bug",60079),calendar:l("calendar",60080),caseSensitive:l("case-sensitive",60081),check:l("check",60082),checklist:l("checklist",60083),chevronDown:l("chevron-down",60084),dropDownButton:l("drop-down-button",60084),chevronLeft:l("chevron-left",60085),chevronRight:l("chevron-right",60086),chevronUp:l("chevron-up",60087),chromeClose:l("chrome-close",60088),chromeMaximize:l("chrome-maximize",60089),chromeMinimize:l("chrome-minimize",60090),chromeRestore:l("chrome-restore",60091),circle:l("circle",60092),circleOutline:l("circle-outline",60092),debugBreakpointUnverified:l("debug-breakpoint-unverified",60092),circleSlash:l("circle-slash",60093),circuitBoard:l("circuit-board",60094),clearAll:l("clear-all",60095),clippy:l("clippy",60096),closeAll:l("close-all",60097),cloudDownload:l("cloud-download",60098),cloudUpload:l("cloud-upload",60099),code:l("code",60100),collapseAll:l("collapse-all",60101),colorMode:l("color-mode",60102),commentDiscussion:l("comment-discussion",60103),compareChanges:l("compare-changes",60157),creditCard:l("credit-card",60105),dash:l("dash",60108),dashboard:l("dashboard",60109),database:l("database",60110),debugContinue:l("debug-continue",60111),debugDisconnect:l("debug-disconnect",60112),debugPause:l("debug-pause",60113),debugRestart:l("debug-restart",60114),debugStart:l("debug-start",60115),debugStepInto:l("debug-step-into",60116),debugStepOut:l("debug-step-out",60117),debugStepOver:l("debug-step-over",60118),debugStop:l("debug-stop",60119),debug:l("debug",60120),deviceCameraVideo:l("device-camera-video",60121),deviceCamera:l("device-camera",60122),deviceMobile:l("device-mobile",60123),diffAdded:l("diff-added",60124),diffIgnored:l("diff-ignored",60125),diffModified:l("diff-modified",60126),diffRemoved:l("diff-removed",60127),diffRenamed:l("diff-renamed",60128),diff:l("diff",60129),discard:l("discard",60130),editorLayout:l("editor-layout",60131),emptyWindow:l("empty-window",60132),exclude:l("exclude",60133),extensions:l("extensions",60134),eyeClosed:l("eye-closed",60135),fileBinary:l("file-binary",60136),fileCode:l("file-code",60137),fileMedia:l("file-media",60138),filePdf:l("file-pdf",60139),fileSubmodule:l("file-submodule",60140),fileSymlinkDirectory:l("file-symlink-directory",60141),fileSymlinkFile:l("file-symlink-file",60142),fileZip:l("file-zip",60143),files:l("files",60144),filter:l("filter",60145),flame:l("flame",60146),foldDown:l("fold-down",60147),foldUp:l("fold-up",60148),fold:l("fold",60149),folderActive:l("folder-active",60150),folderOpened:l("folder-opened",60151),gear:l("gear",60152),gift:l("gift",60153),gistSecret:l("gist-secret",60154),gist:l("gist",60155),gitCommit:l("git-commit",60156),gitCompare:l("git-compare",60157),gitMerge:l("git-merge",60158),githubAction:l("github-action",60159),githubAlt:l("github-alt",60160),globe:l("globe",60161),grabber:l("grabber",60162),graph:l("graph",60163),gripper:l("gripper",60164),heart:l("heart",60165),home:l("home",60166),horizontalRule:l("horizontal-rule",60167),hubot:l("hubot",60168),inbox:l("inbox",60169),issueClosed:l("issue-closed",60324),issueReopened:l("issue-reopened",60171),issues:l("issues",60172),italic:l("italic",60173),jersey:l("jersey",60174),json:l("json",60175),bracket:l("bracket",60175),kebabVertical:l("kebab-vertical",60176),key:l("key",60177),law:l("law",60178),lightbulbAutofix:l("lightbulb-autofix",60179),linkExternal:l("link-external",60180),link:l("link",60181),listOrdered:l("list-ordered",60182),listUnordered:l("list-unordered",60183),liveShare:l("live-share",60184),loading:l("loading",60185),location:l("location",60186),mailRead:l("mail-read",60187),mail:l("mail",60188),markdown:l("markdown",60189),megaphone:l("megaphone",60190),mention:l("mention",60191),milestone:l("milestone",60192),mortarBoard:l("mortar-board",60193),move:l("move",60194),multipleWindows:l("multiple-windows",60195),mute:l("mute",60196),noNewline:l("no-newline",60197),note:l("note",60198),octoface:l("octoface",60199),openPreview:l("open-preview",60200),package_:l("package",60201),paintcan:l("paintcan",60202),pin:l("pin",60203),play:l("play",60204),run:l("run",60204),plug:l("plug",60205),preserveCase:l("preserve-case",60206),preview:l("preview",60207),project:l("project",60208),pulse:l("pulse",60209),question:l("question",60210),quote:l("quote",60211),radioTower:l("radio-tower",60212),reactions:l("reactions",60213),references:l("references",60214),refresh:l("refresh",60215),regex:l("regex",60216),remoteExplorer:l("remote-explorer",60217),remote:l("remote",60218),remove:l("remove",60219),replaceAll:l("replace-all",60220),replace:l("replace",60221),repoClone:l("repo-clone",60222),repoForcePush:l("repo-force-push",60223),repoPull:l("repo-pull",60224),repoPush:l("repo-push",60225),report:l("report",60226),requestChanges:l("request-changes",60227),rocket:l("rocket",60228),rootFolderOpened:l("root-folder-opened",60229),rootFolder:l("root-folder",60230),rss:l("rss",60231),ruby:l("ruby",60232),saveAll:l("save-all",60233),saveAs:l("save-as",60234),save:l("save",60235),screenFull:l("screen-full",60236),screenNormal:l("screen-normal",60237),searchStop:l("search-stop",60238),server:l("server",60240),settingsGear:l("settings-gear",60241),settings:l("settings",60242),shield:l("shield",60243),smiley:l("smiley",60244),sortPrecedence:l("sort-precedence",60245),splitHorizontal:l("split-horizontal",60246),splitVertical:l("split-vertical",60247),squirrel:l("squirrel",60248),starFull:l("star-full",60249),starHalf:l("star-half",60250),symbolClass:l("symbol-class",60251),symbolColor:l("symbol-color",60252),symbolCustomColor:l("symbol-customcolor",60252),symbolConstant:l("symbol-constant",60253),symbolEnumMember:l("symbol-enum-member",60254),symbolField:l("symbol-field",60255),symbolFile:l("symbol-file",60256),symbolInterface:l("symbol-interface",60257),symbolKeyword:l("symbol-keyword",60258),symbolMisc:l("symbol-misc",60259),symbolOperator:l("symbol-operator",60260),symbolProperty:l("symbol-property",60261),wrench:l("wrench",60261),wrenchSubaction:l("wrench-subaction",60261),symbolSnippet:l("symbol-snippet",60262),tasklist:l("tasklist",60263),telescope:l("telescope",60264),textSize:l("text-size",60265),threeBars:l("three-bars",60266),thumbsdown:l("thumbsdown",60267),thumbsup:l("thumbsup",60268),tools:l("tools",60269),triangleDown:l("triangle-down",60270),triangleLeft:l("triangle-left",60271),triangleRight:l("triangle-right",60272),triangleUp:l("triangle-up",60273),twitter:l("twitter",60274),unfold:l("unfold",60275),unlock:l("unlock",60276),unmute:l("unmute",60277),unverified:l("unverified",60278),verified:l("verified",60279),versions:l("versions",60280),vmActive:l("vm-active",60281),vmOutline:l("vm-outline",60282),vmRunning:l("vm-running",60283),watch:l("watch",60284),whitespace:l("whitespace",60285),wholeWord:l("whole-word",60286),window:l("window",60287),wordWrap:l("word-wrap",60288),zoomIn:l("zoom-in",60289),zoomOut:l("zoom-out",60290),listFilter:l("list-filter",60291),listFlat:l("list-flat",60292),listSelection:l("list-selection",60293),selection:l("selection",60293),listTree:l("list-tree",60294),debugBreakpointFunctionUnverified:l("debug-breakpoint-function-unverified",60295),debugBreakpointFunction:l("debug-breakpoint-function",60296),debugBreakpointFunctionDisabled:l("debug-breakpoint-function-disabled",60296),debugStackframeActive:l("debug-stackframe-active",60297),circleSmallFilled:l("circle-small-filled",60298),debugStackframeDot:l("debug-stackframe-dot",60298),debugStackframe:l("debug-stackframe",60299),debugStackframeFocused:l("debug-stackframe-focused",60299),debugBreakpointUnsupported:l("debug-breakpoint-unsupported",60300),symbolString:l("symbol-string",60301),debugReverseContinue:l("debug-reverse-continue",60302),debugStepBack:l("debug-step-back",60303),debugRestartFrame:l("debug-restart-frame",60304),callIncoming:l("call-incoming",60306),callOutgoing:l("call-outgoing",60307),menu:l("menu",60308),expandAll:l("expand-all",60309),feedback:l("feedback",60310),groupByRefType:l("group-by-ref-type",60311),ungroupByRefType:l("ungroup-by-ref-type",60312),account:l("account",60313),bellDot:l("bell-dot",60314),debugConsole:l("debug-console",60315),library:l("library",60316),output:l("output",60317),runAll:l("run-all",60318),syncIgnored:l("sync-ignored",60319),pinned:l("pinned",60320),githubInverted:l("github-inverted",60321),debugAlt:l("debug-alt",60305),serverProcess:l("server-process",60322),serverEnvironment:l("server-environment",60323),pass:l("pass",60324),stopCircle:l("stop-circle",60325),playCircle:l("play-circle",60326),record:l("record",60327),debugAltSmall:l("debug-alt-small",60328),vmConnect:l("vm-connect",60329),cloud:l("cloud",60330),merge:l("merge",60331),exportIcon:l("export",60332),graphLeft:l("graph-left",60333),magnet:l("magnet",60334),notebook:l("notebook",60335),redo:l("redo",60336),checkAll:l("check-all",60337),pinnedDirty:l("pinned-dirty",60338),passFilled:l("pass-filled",60339),circleLargeFilled:l("circle-large-filled",60340),circleLarge:l("circle-large",60341),circleLargeOutline:l("circle-large-outline",60341),combine:l("combine",60342),gather:l("gather",60342),table:l("table",60343),variableGroup:l("variable-group",60344),typeHierarchy:l("type-hierarchy",60345),typeHierarchySub:l("type-hierarchy-sub",60346),typeHierarchySuper:l("type-hierarchy-super",60347),gitPullRequestCreate:l("git-pull-request-create",60348),runAbove:l("run-above",60349),runBelow:l("run-below",60350),notebookTemplate:l("notebook-template",60351),debugRerun:l("debug-rerun",60352),workspaceTrusted:l("workspace-trusted",60353),workspaceUntrusted:l("workspace-untrusted",60354),workspaceUnspecified:l("workspace-unspecified",60355),terminalCmd:l("terminal-cmd",60356),terminalDebian:l("terminal-debian",60357),terminalLinux:l("terminal-linux",60358),terminalPowershell:l("terminal-powershell",60359),terminalTmux:l("terminal-tmux",60360),terminalUbuntu:l("terminal-ubuntu",60361),terminalBash:l("terminal-bash",60362),arrowSwap:l("arrow-swap",60363),copy:l("copy",60364),personAdd:l("person-add",60365),filterFilled:l("filter-filled",60366),wand:l("wand",60367),debugLineByLine:l("debug-line-by-line",60368),inspect:l("inspect",60369),layers:l("layers",60370),layersDot:l("layers-dot",60371),layersActive:l("layers-active",60372),compass:l("compass",60373),compassDot:l("compass-dot",60374),compassActive:l("compass-active",60375),azure:l("azure",60376),issueDraft:l("issue-draft",60377),gitPullRequestClosed:l("git-pull-request-closed",60378),gitPullRequestDraft:l("git-pull-request-draft",60379),debugAll:l("debug-all",60380),debugCoverage:l("debug-coverage",60381),runErrors:l("run-errors",60382),folderLibrary:l("folder-library",60383),debugContinueSmall:l("debug-continue-small",60384),beakerStop:l("beaker-stop",60385),graphLine:l("graph-line",60386),graphScatter:l("graph-scatter",60387),pieChart:l("pie-chart",60388),bracketDot:l("bracket-dot",60389),bracketError:l("bracket-error",60390),lockSmall:l("lock-small",60391),azureDevops:l("azure-devops",60392),verifiedFilled:l("verified-filled",60393),newLine:l("newline",60394),layout:l("layout",60395),layoutActivitybarLeft:l("layout-activitybar-left",60396),layoutActivitybarRight:l("layout-activitybar-right",60397),layoutPanelLeft:l("layout-panel-left",60398),layoutPanelCenter:l("layout-panel-center",60399),layoutPanelJustify:l("layout-panel-justify",60400),layoutPanelRight:l("layout-panel-right",60401),layoutPanel:l("layout-panel",60402),layoutSidebarLeft:l("layout-sidebar-left",60403),layoutSidebarRight:l("layout-sidebar-right",60404),layoutStatusbar:l("layout-statusbar",60405),layoutMenubar:l("layout-menubar",60406),layoutCentered:l("layout-centered",60407),layoutSidebarRightOff:l("layout-sidebar-right-off",60416),layoutPanelOff:l("layout-panel-off",60417),layoutSidebarLeftOff:l("layout-sidebar-left-off",60418),target:l("target",60408),indent:l("indent",60409),recordSmall:l("record-small",60410),errorSmall:l("error-small",60411),arrowCircleDown:l("arrow-circle-down",60412),arrowCircleLeft:l("arrow-circle-left",60413),arrowCircleRight:l("arrow-circle-right",60414),arrowCircleUp:l("arrow-circle-up",60415),heartFilled:l("heart-filled",60420),map:l("map",60421),mapFilled:l("map-filled",60422),circleSmall:l("circle-small",60423),bellSlash:l("bell-slash",60424),bellSlashDot:l("bell-slash-dot",60425),commentUnresolved:l("comment-unresolved",60426),gitPullRequestGoToChanges:l("git-pull-request-go-to-changes",60427),gitPullRequestNewChanges:l("git-pull-request-new-changes",60428),searchFuzzy:l("search-fuzzy",60429),commentDraft:l("comment-draft",60430),dialogError:l("dialog-error","error"),dialogWarning:l("dialog-warning","warning"),dialogInfo:l("dialog-info","info"),dialogClose:l("dialog-close","close"),treeItemExpanded:l("tree-item-expanded","chevron-down"),treeFilterOnTypeOn:l("tree-filter-on-type-on","list-filter"),treeFilterOnTypeOff:l("tree-filter-on-type-off","list-selection"),treeFilterClear:l("tree-filter-clear","close"),treeItemLoading:l("tree-item-loading","loading"),menuSelection:l("menu-selection","check"),menuSubmenu:l("menu-submenu","chevron-right"),menuBarMore:l("menubar-more","more"),scrollbarButtonLeft:l("scrollbar-button-left","triangle-left"),scrollbarButtonRight:l("scrollbar-button-right","triangle-right"),scrollbarButtonUp:l("scrollbar-button-up","triangle-up"),scrollbarButtonDown:l("scrollbar-button-down","triangle-down"),toolBarMore:l("toolbar-more","more"),quickInputBack:l("quick-input-back","arrow-left")}}),define(ye[32],De([1,0,9,12,8,10]),function(re,e,a,L,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function S(c){return c===47||c===92}e.isPathSeparator=S;function A(c){return c.replace(/[\\/]/g,a.posix.sep)}e.toSlashes=A;function y(c){return c.indexOf("/")===-1&&(c=A(c)),/^[a-zA-Z]:(\/|$)/.test(c)&&(c="/"+c),c}e.toPosixPath=y;function I(c,m=a.posix.sep){if(!c)return"";const n=c.length,t=c.charCodeAt(0);if(S(t)){if(S(c.charCodeAt(1))&&!S(c.charCodeAt(2))){let E=3;const w=E;for(;E<n&&!S(c.charCodeAt(E));E++);if(w!==E&&!S(c.charCodeAt(E+1))){for(E+=1;E<n;E++)if(S(c.charCodeAt(E)))return c.slice(0,E+1).replace(/[\\/]/g,m)}}return m}else if(h(t)&&c.charCodeAt(1)===58)return S(c.charCodeAt(2))?c.slice(0,2)+m:c.slice(0,2);let d=c.indexOf("://");if(d!==-1){for(d+=3;d<n;d++)if(S(c.charCodeAt(d)))return c.slice(0,d+1)}return""}e.getRoot=I;function O(c){if(!L.isWindows||!c||c.length<5)return!1;let m=c.charCodeAt(0);if(m!==92||(m=c.charCodeAt(1),m!==92))return!1;let n=2;const t=n;for(;n<c.length&&(m=c.charCodeAt(n),m!==92);n++);return!(t===n||(m=c.charCodeAt(n+1),isNaN(m)||m===92))}e.isUNC=O;const P=/[\\/:\*\?"<>\|]/g,v=/[\\/]/g,k=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function D(c,m=L.isWindows){const n=m?P:v;return!(!c||c.length===0||/^\s+$/.test(c)||(n.lastIndex=0,n.test(c))||m&&k.test(c)||c==="."||c===".."||m&&c[c.length-1]==="."||m&&c.length!==c.trim().length||c.length>255)}e.isValidBasename=D;function f(c,m,n){const t=c===m;return!n||t?t:!c||!m?!1:(0,l.equalsIgnoreCase)(c,m)}e.isEqual=f;function u(c,m,n,t=a.sep){if(c===m)return!0;if(!c||!m||m.length>c.length)return!1;if(n){if(!(0,l.startsWithIgnoreCase)(c,m))return!1;if(m.length===c.length)return!0;let E=m.length;return m.charAt(m.length-1)===t&&E--,c.charAt(E)===t}return m.charAt(m.length-1)!==t&&(m+=t),c.indexOf(m)===0}e.isEqualOrParent=u;function h(c){return c>=65&&c<=90||c>=97&&c<=122}e.isWindowsDriveLetter=h;function p(c,m){return L.isWindows&&c.endsWith(":")&&(c+=a.sep),(0,a.isAbsolute)(c)||(c=(0,a.join)(m,c)),c=(0,a.normalize)(c),L.isWindows?(c=(0,l.rtrim)(c,a.sep),c.endsWith(":")&&(c+=a.sep)):(c=(0,l.rtrim)(c,a.sep),c||(c=a.sep)),c}e.sanitizeFilePath=p;function b(c){const m=(0,a.normalize)(c);return L.isWindows?c.length>3?!1:C(m)&&(c.length===2||m.charCodeAt(2)===92):m===a.posix.sep}e.isRootOrDriveLetter=b;function C(c,m=L.isWindows){return m?h(c.charCodeAt(0))&&c.charCodeAt(1)===58:!1}e.hasDriveLetter=C;function g(c){return C(c)?c[0]:void 0}e.getDriveLetter=g;function i(c,m,n){return m.length>c.length?-1:c===m?0:(n&&(c=c.toLowerCase(),m=m.toLowerCase()),c.indexOf(m))}e.indexOfPath=i;function s(c){const m=c.split(":");let n,t,d;for(const E of m){const w=Number(E);(0,R.isNumber)(w)?t===void 0?t=w:d===void 0&&(d=w):n=n?[n,E].join(":"):E}if(!n)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:n,line:t!==void 0?t:void 0,column:d!==void 0?d:t!==void 0?1:void 0}}e.parseLineAndColumnAware=s;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function o(c,m,n=8){let t="";for(let E=0;E<n;E++)t+=r.charAt(Math.floor(Math.random()*r.length));let d;return m?d=`${m}-${t}`:d=t,c?(0,a.join)(c,d):d}e.randomPath=o}),define(ye[23],De([1,0,10]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const p=Array.isArray(h)?[]:{};return Object.entries(h).forEach(([b,C])=>{p[b]=C&&typeof C=="object"?L(C):C}),p}e.deepClone=L;function l(h){if(!h||typeof h!="object")return h;const p=[h];for(;p.length>0;){const b=p.shift();Object.freeze(b);for(const C in b)if(R.call(b,C)){const g=b[C];typeof g=="object"&&!Object.isFrozen(g)&&!(0,a.isTypedArray)(g)&&p.push(g)}}return h}e.deepFreeze=l;const R=Object.prototype.hasOwnProperty;function S(h,p){return A(h,p,new Set)}e.cloneAndChange=S;function A(h,p,b){if((0,a.isUndefinedOrNull)(h))return h;const C=p(h);if(typeof C<"u")return C;if(Array.isArray(h)){const g=[];for(const i of h)g.push(A(i,p,b));return g}if((0,a.isObject)(h)){if(b.has(h))throw new Error("Cannot clone recursive data-structure");b.add(h);const g={};for(const i in h)R.call(h,i)&&(g[i]=A(h[i],p,b));return b.delete(h),g}return h}function y(h,p,b=!0){return(0,a.isObject)(h)?((0,a.isObject)(p)&&Object.keys(p).forEach(C=>{C in h?b&&((0,a.isObject)(h[C])&&(0,a.isObject)(p[C])?y(h[C],p[C],b):h[C]=p[C]):h[C]=p[C]}),h):p}e.mixin=y;function I(h,p){if(h===p)return!0;if(h==null||p===null||p===void 0||typeof h!=typeof p||typeof h!="object"||Array.isArray(h)!==Array.isArray(p))return!1;let b,C;if(Array.isArray(h)){if(h.length!==p.length)return!1;for(b=0;b<h.length;b++)if(!I(h[b],p[b]))return!1}else{const g=[];for(C in h)g.push(C);g.sort();const i=[];for(C in p)i.push(C);if(i.sort(),!I(g,i))return!1;for(b=0;b<g.length;b++)if(!I(h[g[b]],p[g[b]]))return!1}return!0}e.equals=I;function O(h){const p=new Set;return JSON.stringify(h,(b,C)=>{if((0,a.isObject)(C)||Array.isArray(C)){if(p.has(C))return"[Circular]";p.add(C)}return C})}e.safeStringify=O;function P(h,p){const b=Object.create(null);return!h||!p||Object.keys(p).forEach(g=>{const i=h[g],s=p[g];I(i,s)||(b[g]=s)}),b}e.distinct=P;function v(h,p){const b=p.toLowerCase(),C=Object.keys(h).find(g=>g.toLowerCase()===b);return C?h[C]:h[p]}e.getCaseInsensitive=v;function k(h,p){const b=Object.create(null);for(const[C,g]of Object.entries(h))p(C,g)&&(b[C]=g);return b}e.filter=k;function D(h){let p=[],b=Object.getPrototypeOf(h);for(;Object.prototype!==b;)p=p.concat(Object.getOwnPropertyNames(b)),b=Object.getPrototypeOf(b);return p}e.getAllPropertyNames=D;function f(h){const p=[];for(const b of D(h))typeof h[b]=="function"&&p.push(b);return p}e.getAllMethodNames=f;function u(h,p){const b=g=>function(){const i=Array.prototype.slice.call(arguments,0);return p(g,i)},C={};for(const g of h)C[g]=b(g);return C}e.createProxyObject=u}),define(ye[51],De([1,0,69]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.themeColorFromId=e.ThemeColor=void 0;var L;(function(S){function A(y){return y&&typeof y=="object"&&typeof y.id=="string"}S.isThemeColor=A})(L=e.ThemeColor||(e.ThemeColor={}));function l(S){return{id:S}}e.themeColorFromId=l;var R;(function(S){S.iconNameSegment="[A-Za-z0-9]+",S.iconNameExpression="[A-Za-z0-9-]+",S.iconModifierExpression="~[A-Za-z]+",S.iconNameCharacter="[A-Za-z0-9~-]";const A=new RegExp(`^(${S.iconNameExpression})(${S.iconModifierExpression})?$`);function y(p){const b=A.exec(p.id);if(!b)return y(a.Codicon.error);const[,C,g]=b,i=["codicon","codicon-"+C];return g&&i.push("codicon-modifier-"+g.substring(1)),i}S.asClassNameArray=y;function I(p){return y(p).join(" ")}S.asClassName=I;function O(p){return"."+y(p).join(".")}S.asCSSSelector=O;function P(p){return p&&typeof p=="object"&&typeof p.id=="string"&&(typeof p.color>"u"||L.isThemeColor(p.color))}S.isThemeIcon=P;const v=new RegExp(`^\\$\\((${S.iconNameExpression}(?:${S.iconModifierExpression})?)\\)$`);function k(p){const b=v.exec(p);if(!b)return;const[,C]=b;return{id:C}}S.fromString=k;function D(p){return{id:p}}S.fromId=D;function f(p,b){let C=p.id;const g=C.lastIndexOf("~");return g!==-1&&(C=C.substring(0,g)),b&&(C=`${C}~${b}`),{id:C}}S.modify=f;function u(p){const b=p.id.lastIndexOf("~");if(b!==-1)return p.id.substring(b+1)}S.getModifier=u;function h(p,b){return p.id===b.id&&p.color?.id===b.color?.id}S.isEqual=h})(R=e.ThemeIcon||(e.ThemeIcon={}))}),define(ye[150],De([1,0,106,8,51]),function(re,e,a,L,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.getCodiconAriaLabel=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=void 0;const R="$(",S=new RegExp(`\\$\\(${l.ThemeIcon.iconNameExpression}(?:${l.ThemeIcon.iconModifierExpression})?\\)`,"g"),A=new RegExp(`(\\\\)?${S.source}`,"g");function y(h){return h.replace(A,(p,b)=>b?p:`\\${p}`)}e.escapeIcons=y;const I=new RegExp(`\\\\${S.source}`,"g");function O(h){return h.replace(I,p=>`\\${p}`)}e.markdownEscapeEscapedIcons=O;const P=new RegExp(`(\\s)?(\\\\)?${S.source}(\\s)?`,"g");function v(h){return h.indexOf(R)===-1?h:h.replace(P,(p,b,C,g)=>C?p:b||g||"")}e.stripIcons=v;function k(h){return h?h.replace(/\$\((.*?)\)/g,(p,b)=>` ${b} `).trim():""}e.getCodiconAriaLabel=k;const D=new RegExp(`\\$\\(${l.ThemeIcon.iconNameCharacter}+\\)`,"g");function f(h){D.lastIndex=0;let p="";const b=[];let C=0;for(;;){const g=D.lastIndex,i=D.exec(h),s=h.substring(g,i?.index);if(s.length>0){p+=s;for(let r=0;r<s.length;r++)b.push(C)}if(!i)break;C+=i[0].length}return{text:p,iconOffsets:b}}e.parseLabelWithIcons=f;function u(h,p,b=!1){const{text:C,iconOffsets:g}=p;if(!g||g.length===0)return(0,a.matchesFuzzy)(h,C,b);const i=(0,L.ltrim)(C," "),s=C.length-i.length,r=(0,a.matchesFuzzy)(h,i,b);if(r)for(const o of r){const c=g[o.start+s]+s;o.start+=c,o.end+=c}return r}e.matchesFuzzyIconAware=u}),define(ye[108],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toUint32=e.toUint8=e.Constants=void 0;var a;(function(R){R[R.MAX_SAFE_SMALL_INTEGER=1073741824]="MAX_SAFE_SMALL_INTEGER",R[R.MIN_SAFE_SMALL_INTEGER=-1073741824]="MIN_SAFE_SMALL_INTEGER",R[R.MAX_UINT_8=255]="MAX_UINT_8",R[R.MAX_UINT_16=65535]="MAX_UINT_16",R[R.MAX_UINT_32=4294967295]="MAX_UINT_32",R[R.UNICODE_SUPPLEMENTARY_PLANE_BEGIN=65536]="UNICODE_SUPPLEMENTARY_PLANE_BEGIN"})(a=e.Constants||(e.Constants={}));function L(R){return R<0?0:R>255?255:R|0}e.toUint8=L;function l(R){return R<0?0:R>4294967295?4294967295:R|0}e.toUint32=l}),define(ye[2],De([1,0,9,12]),function(re,e,a,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const l=/^\w[\w\d+.-]*$/,R=/^\//,S=/^\/\//;function A(r,o){if(!r.scheme&&o)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${r.authority}", path: "${r.path}", query: "${r.query}", fragment: "${r.fragment}"}`);if(r.scheme&&!l.test(r.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(r.path){if(r.authority){if(!R.test(r.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(S.test(r.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function y(r,o){return!r&&!o?"file":r}function I(r,o){switch(r){case"https":case"http":case"file":o?o[0]!==P&&(o=P+o):o=P;break}return o}const O="",P="/",v=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class k{static isUri(o){return o instanceof k?!0:o?typeof o.authority=="string"&&typeof o.fragment=="string"&&typeof o.path=="string"&&typeof o.query=="string"&&typeof o.scheme=="string"&&typeof o.fsPath=="string"&&typeof o.with=="function"&&typeof o.toString=="function":!1}constructor(o,c,m,n,t,d=!1){typeof o=="object"?(this.scheme=o.scheme||O,this.authority=o.authority||O,this.path=o.path||O,this.query=o.query||O,this.fragment=o.fragment||O):(this.scheme=y(o,d),this.authority=c||O,this.path=I(this.scheme,m||O),this.query=n||O,this.fragment=t||O,A(this,d))}get fsPath(){return b(this,!1)}with(o){if(!o)return this;let{scheme:c,authority:m,path:n,query:t,fragment:d}=o;return c===void 0?c=this.scheme:c===null&&(c=O),m===void 0?m=this.authority:m===null&&(m=O),n===void 0?n=this.path:n===null&&(n=O),t===void 0?t=this.query:t===null&&(t=O),d===void 0?d=this.fragment:d===null&&(d=O),c===this.scheme&&m===this.authority&&n===this.path&&t===this.query&&d===this.fragment?this:new f(c,m,n,t,d)}static parse(o,c=!1){const m=v.exec(o);return m?new f(m[2]||O,s(m[4]||O),s(m[5]||O),s(m[7]||O),s(m[9]||O),c):new f(O,O,O,O,O)}static file(o){let c=O;if(L.isWindows&&(o=o.replace(/\\/g,P)),o[0]===P&&o[1]===P){const m=o.indexOf(P,2);m===-1?(c=o.substring(2),o=P):(c=o.substring(2,m),o=o.substring(m)||P)}return new f("file",c,o,O,O)}static from(o){const c=new f(o.scheme,o.authority,o.path,o.query,o.fragment);return A(c,!0),c}static joinPath(o,...c){if(!o.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let m;return L.isWindows&&o.scheme==="file"?m=k.file(a.win32.join(b(o,!0),...c)).path:m=a.posix.join(o.path,...c),o.with({path:m})}toString(o=!1){return C(this,o)}toJSON(){return this}static revive(o){if(o){if(o instanceof k)return o;{const c=new f(o);return c._formatted=o.external,c._fsPath=o._sep===D?o.fsPath:null,c}}else return o}}e.URI=k;const D=L.isWindows?1:void 0;class f extends k{constructor(){super(...arguments),this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=b(this,!1)),this._fsPath}toString(o=!1){return o?C(this,!0):(this._formatted||(this._formatted=C(this,!1)),this._formatted)}toJSON(){const o={$mid:1};return this._fsPath&&(o.fsPath=this._fsPath,o._sep=D),this._formatted&&(o.external=this._formatted),this.path&&(o.path=this.path),this.scheme&&(o.scheme=this.scheme),this.authority&&(o.authority=this.authority),this.query&&(o.query=this.query),this.fragment&&(o.fragment=this.fragment),o}}const u={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function h(r,o,c){let m,n=-1;for(let t=0;t<r.length;t++){const d=r.charCodeAt(t);if(d>=97&&d<=122||d>=65&&d<=90||d>=48&&d<=57||d===45||d===46||d===95||d===126||o&&d===47||c&&d===91||c&&d===93||c&&d===58)n!==-1&&(m+=encodeURIComponent(r.substring(n,t)),n=-1),m!==void 0&&(m+=r.charAt(t));else{m===void 0&&(m=r.substr(0,t));const E=u[d];E!==void 0?(n!==-1&&(m+=encodeURIComponent(r.substring(n,t)),n=-1),m+=E):n===-1&&(n=t)}}return n!==-1&&(m+=encodeURIComponent(r.substring(n))),m!==void 0?m:r}function p(r){let o;for(let c=0;c<r.length;c++){const m=r.charCodeAt(c);m===35||m===63?(o===void 0&&(o=r.substr(0,c)),o+=u[m]):o!==void 0&&(o+=r[c])}return o!==void 0?o:r}function b(r,o){let c;return r.authority&&r.path.length>1&&r.scheme==="file"?c=`//${r.authority}${r.path}`:r.path.charCodeAt(0)===47&&(r.path.charCodeAt(1)>=65&&r.path.charCodeAt(1)<=90||r.path.charCodeAt(1)>=97&&r.path.charCodeAt(1)<=122)&&r.path.charCodeAt(2)===58?o?c=r.path.substr(1):c=r.path[1].toLowerCase()+r.path.substr(2):c=r.path,L.isWindows&&(c=c.replace(/\//g,"\\")),c}e.uriToFsPath=b;function C(r,o){const c=o?p:h;let m="",{scheme:n,authority:t,path:d,query:E,fragment:w}=r;if(n&&(m+=n,m+=":"),(t||n==="file")&&(m+=P,m+=P),t){let N=t.indexOf("@");if(N!==-1){const j=t.substr(0,N);t=t.substr(N+1),N=j.lastIndexOf(":"),N===-1?m+=c(j,!1,!1):(m+=c(j.substr(0,N),!1,!1),m+=":",m+=c(j.substr(N+1),!1,!0)),m+="@"}t=t.toLowerCase(),N=t.lastIndexOf(":"),N===-1?m+=c(t,!1,!0):(m+=c(t.substr(0,N),!1,!0),m+=t.substr(N))}if(d){if(d.length>=3&&d.charCodeAt(0)===47&&d.charCodeAt(2)===58){const N=d.charCodeAt(1);N>=65&&N<=90&&(d=`/${String.fromCharCode(N+32)}:${d.substr(3)}`)}else if(d.length>=2&&d.charCodeAt(1)===58){const N=d.charCodeAt(0);N>=65&&N<=90&&(d=`${String.fromCharCode(N+32)}:${d.substr(2)}`)}m+=c(d,!0,!1)}return E&&(m+="?",m+=c(E,!1,!1)),w&&(m+="#",m+=o?w:h(w,!1,!1)),m}function g(r){try{return decodeURIComponent(r)}catch{return r.length>3?r.substr(0,3)+g(r.substr(3)):r}}const i=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function s(r){return r.match(i)?r.replace(i,o=>g(o)):r}}),define(ye[70],De([1,0,22,8,2]),function(re,e,a,L,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function R(I){return JSON.stringify(I,A)}e.stringify=R;function S(I){let O=JSON.parse(I);return O=y(O),O}e.parse=S;function A(I,O){return O instanceof RegExp?{$mid:2,source:O.source,flags:(0,L.regExpFlags)(O)}:O}function y(I,O=0){if(!I||O>200)return I;if(typeof I=="object"){switch(I.$mid){case 1:return l.URI.revive(I);case 2:return new RegExp(I.source,I.flags);case 16:return new Date(I.source)}if(I instanceof a.VSBuffer||I instanceof Uint8Array)return I;if(Array.isArray(I))for(let P=0;P<I.length;++P)I[P]=y(I[P],O+1);else for(const P in I)Object.hasOwnProperty.call(I,P)&&(I[P]=y(I[P],O+1))}return I}e.revive=y}),define(ye[16],De([1,0,11,12,2]),function(re,e,a,L,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.FileAccess=e.nodeModulesAsarUnpackedPath=e.nodeModulesAsarPath=e.nodeModulesPath=e.builtinExtensionsPath=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var R;(function(I){I.inMemory="inmemory",I.vscode="vscode",I.internal="private",I.walkThrough="walkThrough",I.walkThroughSnippet="walkThroughSnippet",I.http="http",I.https="https",I.file="file",I.mailto="mailto",I.untitled="untitled",I.data="data",I.command="command",I.vscodeRemote="vscode-remote",I.vscodeRemoteResource="vscode-remote-resource",I.vscodeUserData="vscode-userdata",I.vscodeCustomEditor="vscode-custom-editor",I.vscodeNotebookCell="vscode-notebook-cell",I.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",I.vscodeNotebookCellOutput="vscode-notebook-cell-output",I.vscodeInteractive="vscode-interactive",I.vscodeInteractiveInput="vscode-interactive-input",I.vscodeSettings="vscode-settings",I.vscodeWorkspaceTrust="vscode-workspace-trust",I.vscodeTerminal="vscode-terminal",I.webviewPanel="webview-panel",I.vscodeWebview="vscode-webview",I.extension="extension",I.vscodeFileResource="vscode-file",I.tmp="tmp",I.vsls="vsls",I.vscodeSourceControl="vscode-scm"})(R=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class S{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f=`/${R.vscodeRemoteResource}`}setPreferredWebSchema(O){this.d=O}setDelegate(O){this.e=O}setServerRootPath(O){this.f=`${O}/${R.vscodeRemoteResource}`}set(O,P,v){this.a[O]=P,this.b[O]=v}setConnectionToken(O,P){this.c[O]=P}getPreferredWebSchema(){return this.d}rewrite(O){if(this.e)try{return this.e(O)}catch(u){return a.onUnexpectedError(u),O}const P=O.authority;let v=this.a[P];v&&v.indexOf(":")!==-1&&v.indexOf("[")===-1&&(v=`[${v}]`);const k=this.b[P],D=this.c[P];let f=`path=${encodeURIComponent(O.path)}`;return typeof D=="string"&&(f+=`&${e.connectionTokenQueryName}=${encodeURIComponent(D)}`),l.URI.from({scheme:L.isWeb?this.d:R.vscodeRemoteResource,authority:`${v}:${k}`,path:L.isWeb?(window.location.pathname+"/"+this.f).replace(/\/\/+/g,"/"):this.f,query:f})}}e.RemoteAuthorities=new S,e.builtinExtensionsPath="vs/../../extensions",e.nodeModulesPath="vs/../../node_modules",e.nodeModulesAsarPath="vs/../../node_modules.asar",e.nodeModulesAsarUnpackedPath="vs/../../node_modules.asar.unpacked";class A{asBrowserUri(O){const P=this.b(O,re);return this.uriToBrowserUri(P)}uriToBrowserUri(O){return O.scheme===R.vscodeRemote?e.RemoteAuthorities.rewrite(O):O.scheme===R.file&&(L.isNative||L.isWebWorker&&L.globals.origin===`${R.vscodeFileResource}://${A.a}`)?O.with({scheme:R.vscodeFileResource,authority:O.authority||A.a,query:null,fragment:null}):O}asFileUri(O){const P=this.b(O,re);return this.uriToFileUri(P)}uriToFileUri(O){return O.scheme===R.vscodeFileResource?O.with({scheme:R.file,authority:O.authority!==A.a?O.authority:null,query:null,fragment:null}):O}b(O,P){return l.URI.isUri(O)?O:l.URI.parse(P.toUrl(O))}}A.a="vscode-app",e.FileAccess=new A;var y;(function(I){const O=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);I.CoopAndCoep=Object.freeze(O.get("3"));const P="vscode-coi";function v(D){let f;typeof D=="string"?f=new URL(D).searchParams:D instanceof URL?f=D.searchParams:l.URI.isUri(D)&&(f=new URL(D.toString(!0)).searchParams);const u=f?.get(P);if(!!u)return O.get(u)}I.getHeadersFromQuery=v;function k(D,f,u){if(!globalThis.crossOriginIsolated)return;const h=f&&u?"3":u?"2":"1";D instanceof URLSearchParams?D.set(P,h):D[P]=h}I.addSearchParam=k})(y=e.COI||(e.COI={}))}),define(ye[24],De([1,0,32,16,9,12,8,2]),function(re,e,a,L,l,R,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(k){return(0,A.uriToFsPath)(k,!0)}e.originalFSPath=y;class I{constructor(D){this.a=D}compare(D,f,u=!1){return D===f?0:(0,S.compare)(this.getComparisonKey(D,u),this.getComparisonKey(f,u))}isEqual(D,f,u=!1){return D===f?!0:!D||!f?!1:this.getComparisonKey(D,u)===this.getComparisonKey(f,u)}getComparisonKey(D,f=!1){return D.with({path:this.a(D)?D.path.toLowerCase():void 0,fragment:f?null:void 0}).toString()}ignorePathCasing(D){return this.a(D)}isEqualOrParent(D,f,u=!1){if(D.scheme===f.scheme){if(D.scheme===L.Schemas.file)return a.isEqualOrParent(y(D),y(f),this.a(D))&&D.query===f.query&&(u||D.fragment===f.fragment);if((0,e.isEqualAuthority)(D.authority,f.authority))return a.isEqualOrParent(D.path,f.path,this.a(D),"/")&&D.query===f.query&&(u||D.fragment===f.fragment)}return!1}joinPath(D,...f){return A.URI.joinPath(D,...f)}basenameOrAuthority(D){return(0,e.basename)(D)||D.authority}basename(D){return l.posix.basename(D.path)}extname(D){return l.posix.extname(D.path)}dirname(D){if(D.path.length===0)return D;let f;return D.scheme===L.Schemas.file?f=A.URI.file(l.dirname(y(D))).path:(f=l.posix.dirname(D.path),D.authority&&f.length&&f.charCodeAt(0)!==47&&(console.error(`dirname("${D.toString})) resulted in a relative path`),f="/")),D.with({path:f})}normalizePath(D){if(!D.path.length)return D;let f;return D.scheme===L.Schemas.file?f=A.URI.file(l.normalize(y(D))).path:f=l.posix.normalize(D.path),D.with({path:f})}relativePath(D,f){if(D.scheme!==f.scheme||!(0,e.isEqualAuthority)(D.authority,f.authority))return;if(D.scheme===L.Schemas.file){const p=l.relative(y(D),y(f));return R.isWindows?a.toSlashes(p):p}let u=D.path||"/";const h=f.path||"/";if(this.a(D)){let p=0;for(const b=Math.min(u.length,h.length);p<b&&!(u.charCodeAt(p)!==h.charCodeAt(p)&&u.charAt(p).toLowerCase()!==h.charAt(p).toLowerCase());p++);u=h.substr(0,p)+u.substr(p)}return l.posix.relative(u,h)}resolvePath(D,f){if(D.scheme===L.Schemas.file){const u=A.URI.file(l.resolve(y(D),f));return D.with({authority:u.authority,path:u.path})}return f=a.toPosixPath(f),D.with({path:l.posix.resolve(D.path,f)})}isAbsolutePath(D){return!!D.path&&D.path[0]==="/"}isEqualAuthority(D,f){return D===f||D!==void 0&&f!==void 0&&(0,S.equalsIgnoreCase)(D,f)}hasTrailingPathSeparator(D,f=l.sep){if(D.scheme===L.Schemas.file){const u=y(D);return u.length>a.getRoot(u).length&&u[u.length-1]===f}else{const u=D.path;return u.length>1&&u.charCodeAt(u.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(D.fsPath)}}removeTrailingPathSeparator(D,f=l.sep){return(0,e.hasTrailingPathSeparator)(D,f)?D.with({path:D.path.substr(0,D.path.length-1)}):D}addTrailingPathSeparator(D,f=l.sep){let u=!1;if(D.scheme===L.Schemas.file){const h=y(D);u=h!==void 0&&h.length===a.getRoot(h).length&&h[h.length-1]===f}else{f="/";const h=D.path;u=h.length===1&&h.charCodeAt(h.length-1)===47}return!u&&!(0,e.hasTrailingPathSeparator)(D,f)?D.with({path:D.path+"/"}):D}}e.ExtUri=I,e.extUri=new I(()=>!1),e.extUriBiasedIgnorePathCase=new I(k=>k.scheme===L.Schemas.file?!R.isLinux:!0),e.extUriIgnorePathCase=new I(k=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function O(k,D){const f=[];for(let u=0;u<k.length;u++){const h=D(k[u]);k.some((p,b)=>b===u?!1:(0,e.isEqualOrParent)(h,D(p)))||f.push(k[u])}return f}e.distinctParents=O;var P;(function(k){k.META_DATA_LABEL="label",k.META_DATA_DESCRIPTION="description",k.META_DATA_SIZE="size",k.META_DATA_MIME="mime";function D(f){const u=new Map;f.path.substring(f.path.indexOf(";")+1,f.path.lastIndexOf(";")).split(";").forEach(b=>{const[C,g]=b.split(":");C&&g&&u.set(C,g)});const p=f.path.substring(0,f.path.indexOf(";"));return p&&u.set(k.META_DATA_MIME,p),u}k.parseMetaData=D})(P=e.DataUri||(e.DataUri={}));function v(k,D,f){if(D){let u=k.path;return u&&u[0]!==l.posix.sep&&(u=l.posix.sep+u),k.with({scheme:f,authority:D,path:u})}return k.with({scheme:f})}e.toLocalResource=v}),define(ye[17],De([1,0,21,11,3,6,24,12,149]),function(re,e,a,L,l,R,S,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function I(J){return!!J&&typeof J.then=="function"}e.isThenable=I;function O(J){const ee=new a.CancellationTokenSource,me=J(ee.token),ve=new Promise((Ie,Re)=>{const ae=ee.token.onCancellationRequested(()=>{ae.dispose(),ee.dispose(),Re(new L.CancellationError)});Promise.resolve(me).then(le=>{ae.dispose(),ee.dispose(),Ie(le)},le=>{ae.dispose(),ee.dispose(),Re(le)})});return new class{cancel(){ee.cancel()}then(Ie,Re){return ve.then(Ie,Re)}catch(Ie){return this.then(void 0,Ie)}finally(Ie){return ve.finally(Ie)}}}e.createCancelablePromise=O;function P(J,ee,me){return new Promise((ve,Ie)=>{const Re=ee.onCancellationRequested(()=>{Re.dispose(),ve(me)});J.then(ve,Ie).finally(()=>Re.dispose())})}e.raceCancellation=P;function v(J,ee){return new Promise((me,ve)=>{const Ie=ee.onCancellationRequested(()=>{Ie.dispose(),ve(new L.CancellationError)});J.then(me,ve).finally(()=>Ie.dispose())})}e.raceCancellationError=v;async function k(J){let ee=-1;const me=J.map((Ie,Re)=>Ie.then(ae=>(ee=Re,ae))),ve=await Promise.race(me);return J.forEach((Ie,Re)=>{Re!==ee&&Ie.cancel()}),ve}e.raceCancellablePromises=k;function D(J,ee,me){let ve;const Ie=setTimeout(()=>{ve?.(void 0),me?.()},ee);return Promise.race([J.finally(()=>clearTimeout(Ie)),new Promise(Re=>ve=Re)])}e.raceTimeout=D;function f(J){return new Promise((ee,me)=>{const ve=J();I(ve)?ve.then(ee,me):ee(ve)})}e.asPromise=f;class u{constructor(){this.a=null,this.b=null,this.d=null}queue(ee){if(this.a){if(this.d=ee,!this.b){const me=()=>{this.b=null;const ve=this.queue(this.d);return this.d=null,ve};this.b=new Promise(ve=>{this.a.then(me,me).then(ve)})}return new Promise((me,ve)=>{this.b.then(me,ve)})}return this.a=ee(),new Promise((me,ve)=>{this.a.then(Ie=>{this.a=null,me(Ie)},Ie=>{this.a=null,ve(Ie)})})}}e.Throttler=u;class h{constructor(){this.a=Promise.resolve(null)}queue(ee){return this.a=this.a.then(()=>ee(),()=>ee())}}e.Sequencer=h;class p{constructor(){this.a=new Map}queue(ee,me){const Ie=(this.a.get(ee)??Promise.resolve()).catch(()=>{}).then(me).finally(()=>{this.a.get(ee)===Ie&&this.a.delete(ee)});return this.a.set(ee,Ie),Ie}}e.SequencerByKey=p;const b=(J,ee)=>{let me=!0;const ve=setTimeout(()=>{me=!1,ee()},J);return{isTriggered:()=>me,dispose:()=>{clearTimeout(ve),me=!1}}},C=J=>{let ee=!0;return queueMicrotask(()=>{ee&&(ee=!1,J())}),{isTriggered:()=>ee,dispose:()=>{ee=!1}}};class g{constructor(ee){this.defaultDelay=ee,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(ee,me=this.defaultDelay){this.g=ee,this.h(),this.b||(this.b=new Promise((Ie,Re)=>{this.d=Ie,this.f=Re}).then(()=>{if(this.b=null,this.d=null,this.g){const Ie=this.g;return this.g=null,Ie()}}));const ve=()=>{this.a=null,this.d?.(null)};return this.a=me===y.MicrotaskDelay?C(ve):b(me,ve),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new L.CancellationError),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.Delayer=g;class i{constructor(ee){this.a=new g(ee),this.b=new u}trigger(ee,me){return this.a.trigger(()=>this.b.queue(ee),me)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose()}}e.ThrottledDelayer=i;class s{constructor(){this.a=!1,this.b=new Promise((ee,me)=>{this.d=ee})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.Barrier=s;class r extends s{constructor(ee){super(),this.f=setTimeout(()=>this.open(),ee)}open(){clearTimeout(this.f),super.open()}}e.AutoOpenBarrier=r;function o(J,ee){return ee?new Promise((me,ve)=>{const Ie=setTimeout(()=>{Re.dispose(),me()},J),Re=ee.onCancellationRequested(()=>{clearTimeout(Ie),Re.dispose(),ve(new L.CancellationError)})}):O(me=>o(J,me))}e.timeout=o;function c(J,ee=0){const me=setTimeout(J,ee);return(0,R.toDisposable)(()=>clearTimeout(me))}e.disposableTimeout=c;function m(J){const ee=[];let me=0;const ve=J.length;function Ie(){return me<ve?J[me++]():null}function Re(ae){ae!=null&&ee.push(ae);const le=Ie();return le?le.then(Re):Promise.resolve(ee)}return Promise.resolve(null).then(Re)}e.sequence=m;function n(J,ee=ve=>!!ve,me=null){let ve=0;const Ie=J.length,Re=()=>{if(ve>=Ie)return Promise.resolve(me);const ae=J[ve++];return Promise.resolve(ae()).then(ue=>ee(ue)?Promise.resolve(ue):Re())};return Re()}e.first=n;function t(J,ee=ve=>!!ve,me=null){if(J.length===0)return Promise.resolve(me);let ve=J.length;const Ie=()=>{ve=-1;for(const Re of J)Re.cancel?.()};return new Promise((Re,ae)=>{for(const le of J)le.then(ue=>{--ve>=0&&ee(ue)?(Ie(),Re(ue)):ve===0&&Re(me)}).catch(ue=>{--ve>=0&&(Ie(),ae(ue))})})}e.firstParallel=t;class d{constructor(ee){this.a=0,this.d=ee,this.f=[],this.b=0,this.g=new l.Emitter}get onDrained(){return this.g.event}get size(){return this.a}queue(ee){return this.a++,new Promise((me,ve)=>{this.f.push({factory:ee,c:me,e:ve}),this.h()})}h(){for(;this.f.length&&this.b<this.d;){const ee=this.f.shift();this.b++;const me=ee.factory();me.then(ee.c,ee.e),me.then(()=>this.j(),()=>this.j())}}j(){this.a--,this.b--,this.f.length>0?this.h():this.g.fire()}dispose(){this.g.dispose()}}e.Limiter=d;class E extends d{constructor(){super(1)}}e.Queue=E;class w{constructor(){this.a=new Map,this.b=new Set}async whenDrained(){if(this.d())return;const ee=new _;return this.b.add(ee),ee.p}d(){for(const[,ee]of this.a)if(ee.size>0)return!1;return!0}queueFor(ee,me=S.extUri){const ve=me.getComparisonKey(ee);let Ie=this.a.get(ve);return Ie||(Ie=new E,l.Event.once(Ie.onDrained)(()=>{Ie?.dispose(),this.a.delete(ve),this.f()}),this.a.set(ve,Ie)),Ie}f(){!this.d()||this.g()}g(){for(const ee of this.b)ee.complete();this.b.clear()}dispose(){for(const[,ee]of this.a)ee.dispose();this.a.clear(),this.g()}}e.ResourceQueue=w;class N{constructor(ee,me){this.a=-1,typeof ee=="function"&&typeof me=="number"&&this.setIfNotSet(ee,me)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(ee,me){this.cancel(),this.a=setTimeout(()=>{this.a=-1,ee()},me)}setIfNotSet(ee,me){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,ee()},me))}}e.TimeoutTimer=N;class j{constructor(){this.a=-1}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearInterval(this.a),this.a=-1)}cancelAndSet(ee,me){this.cancel(),this.a=setInterval(()=>{ee()},me)}}e.IntervalTimer=j;class V{constructor(ee,me){this.b=-1,this.a=ee,this.d=me,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(ee=this.d){this.cancel(),this.b=setTimeout(this.f,ee)}get delay(){return this.d}set delay(ee){this.d=ee}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.RunOnceScheduler=V;class Q{constructor(ee,me){me%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${me}ms is not a multiple of 1000ms.`),this.a=ee,this.b=me,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(ee=this.b){ee%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ee}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(ee/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.ProcessTimeRunOnceScheduler=Q;class x extends V{constructor(ee,me){super(ee,me),this.j=[]}work(ee){this.j.push(ee),this.isScheduled()||this.schedule()}h(){const ee=this.j;this.j=[],this.a?.(ee)}dispose(){this.j=[],super.dispose()}}e.RunOnceWorker=x;class U extends R.Disposable{constructor(ee,me){super(),this.g=ee,this.h=me,this.a=[],this.b=this.B(new R.MutableDisposable),this.f=!1}get pending(){return this.a.length}work(ee){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+ee.length>this.g.maxBufferedWork)return!1}else if(this.pending+ee.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const me of ee)this.a.push(me);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new V(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.ThrottledWorker=U,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=J=>{(0,A.setTimeout0)(()=>{if(ee)return;const me=Date.now()+15;J(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,me-Date.now())}}))});let ee=!1;return{dispose(){ee||(ee=!0)}}}:e.runWhenIdle=(J,ee)=>{const me=requestIdleCallback(J,typeof ee=="number"?{timeout:ee}:void 0);let ve=!1;return{dispose(){ve||(ve=!0,cancelIdleCallback(me))}}}}();class T{constructor(ee){this.d=!1,this.a=()=>{try{this.f=ee()}catch(me){this.g=me}finally{this.d=!0}},this.b=(0,e.runWhenIdle)(()=>this.a())}dispose(){this.b.dispose()}get value(){if(this.d||(this.b.dispose(),this.a()),this.g)throw this.g;return this.f}get isInitialized(){return this.d}}e.IdleValue=T;async function F(J,ee,me){let ve;for(let Ie=0;Ie<me;Ie++)try{return await J()}catch(Re){ve=Re,await o(ee)}throw ve}e.retry=F;class B{hasPending(ee){return this.a?typeof ee=="number"?this.a.taskId===ee:!!this.a:!1}get pending(){return this.a?.promise}cancelPending(){this.a?.cancel()}setPending(ee,me,ve){return this.a={taskId:ee,cancel:()=>ve?.(),promise:me},me.then(()=>this.d(ee),()=>this.d(ee)),me}d(ee){this.a&&ee===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const ee=this.b;this.b=void 0,ee.run().then(ee.promiseResolve,ee.promiseReject)}}setNext(ee){if(this.b)this.b.run=ee;else{let me,ve;const Ie=new Promise((Re,ae)=>{me=Re,ve=ae});this.b={run:ee,promise:Ie,promiseResolve:me,promiseReject:ve}}return this.b.promise}hasNext(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.TaskSequentializer=B;class Z{constructor(ee,me=()=>Date.now()){this.d=ee,this.f=me,this.a=0,this.b=0}increment(){const ee=this.f();return ee-this.a>this.d&&(this.a=ee,this.b=0),this.b++,this.b}}e.IntervalCounter=Z;class _{get isRejected(){return this.d}get isResolved(){return this.f}get isSettled(){return this.d||this.f}constructor(){this.d=!1,this.f=!1,this.p=new Promise((ee,me)=>{this.a=ee,this.b=me})}complete(ee){return new Promise(me=>{this.a(ee),this.f=!0,me()})}error(ee){return new Promise(me=>{this.b(ee),this.d=!0,me()})}cancel(){new Promise(ee=>{this.b(new L.CancellationError),this.d=!0,ee()})}}e.DeferredPromise=_;var H;(function(J){async function ee(ve){let Ie;const Re=await Promise.all(ve.map(ae=>ae.then(le=>le,le=>{Ie||(Ie=le)})));if(typeof Ie<"u")throw Ie;return Re}J.settled=ee;function me(ve){return new Promise(async(Ie,Re)=>{try{await ve(Ie,Re)}catch(ae){Re(ae)}})}J.withAsyncBody=me})(H=e.Promises||(e.Promises={}));var Y;(function(J){J[J.Initial=0]="Initial",J[J.DoneOK=1]="DoneOK",J[J.DoneError=2]="DoneError"})(Y||(Y={}));class ie{static fromArray(ee){return new ie(me=>{me.emitMany(ee)})}static fromPromise(ee){return new ie(async me=>{me.emitMany(await ee)})}static fromPromises(ee){return new ie(async me=>{await Promise.all(ee.map(async ve=>me.emitOne(await ve)))})}static merge(ee){return new ie(async me=>{await Promise.all(ee.map(async ve=>{for await(const Ie of ve)me.emitOne(Ie)}))})}constructor(ee){this.a=0,this.b=[],this.d=null,this.f=new l.Emitter,queueMicrotask(async()=>{const me={emitOne:ve=>this.g(ve),emitMany:ve=>this.h(ve),reject:ve=>this.k(ve)};try{await Promise.resolve(ee(me)),this.j()}catch(ve){this.k(ve)}finally{me.emitOne=void 0,me.emitMany=void 0,me.reject=void 0}})}[Symbol.asyncIterator](){let ee=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(ee<this.b.length)return{done:!1,value:this.b[ee++]};if(this.a===1)return{done:!0,value:void 0};await l.Event.toPromise(this.f.event)}while(!0)}}}static map(ee,me){return new ie(async ve=>{for await(const Ie of ee)ve.emitOne(me(Ie))})}map(ee){return ie.map(this,ee)}static filter(ee,me){return new ie(async ve=>{for await(const Ie of ee)me(Ie)&&ve.emitOne(Ie)})}filter(ee){return ie.filter(this,ee)}static coalesce(ee){return ie.filter(ee,me=>!!me)}coalesce(){return ie.coalesce(this)}static async toPromise(ee){const me=[];for await(const ve of ee)me.push(ve);return me}toPromise(){return ie.toPromise(this)}g(ee){this.a===0&&(this.b.push(ee),this.f.fire())}h(ee){this.a===0&&(this.b=this.b.concat(ee),this.f.fire())}j(){this.a===0&&(this.a=1,this.f.fire())}k(ee){this.a===0&&(this.a=2,this.d=ee,this.f.fire())}}ie.EMPTY=ie.fromArray([]),e.AsyncIterableObject=ie;class ge extends ie{constructor(ee,me){super(me),this.l=ee}cancel(){this.l.cancel()}}e.CancelableAsyncIterableObject=ge;function X(J){const ee=new a.CancellationTokenSource,me=J(ee.token);return new ge(ee,async ve=>{const Ie=ee.token.onCancellationRequested(()=>{Ie.dispose(),ee.dispose(),ve.reject(new L.CancellationError)});try{for await(const Re of me){if(ee.token.isCancellationRequested)return;ve.emitOne(Re)}Ie.dispose(),ee.dispose()}catch(Re){Ie.dispose(),ee.dispose(),ve.reject(Re)}})}e.createCancelableAsyncIterable=X}),define(ye[38],De([1,0,15,17,32,28,9,12,8]),function(re,e,a,L,l,R,S,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function I(){return Object.create(null)}e.getEmptyExpression=I,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const O="[/\\\\]",P="[^/\\\\]",v=/\//g;function k(Z,_){switch(Z){case 0:return"";case 1:return`${P}*?`;default:return`(?:${O}|${P}+${O}${_?`|${O}${P}+`:""})*?`}}function D(Z,_){if(!Z)return[];const H=[];let Y=!1,ie=!1,ge="";for(const X of Z){switch(X){case _:if(!Y&&!ie){H.push(ge),ge="";continue}break;case"{":Y=!0;break;case"}":Y=!1;break;case"[":ie=!0;break;case"]":ie=!1;break}ge+=X}return ge&&H.push(ge),H}e.splitGlobAware=D;function f(Z){if(!Z)return"";let _="";const H=D(Z,e.GLOB_SPLIT);if(H.every(Y=>Y===e.GLOBSTAR))_=".*";else{let Y=!1;H.forEach((ie,ge)=>{if(ie===e.GLOBSTAR){if(Y)return;_+=k(2,ge===H.length-1)}else{let X=!1,J="",ee=!1,me="";for(const ve of ie){if(ve!=="}"&&X){J+=ve;continue}if(ee&&(ve!=="]"||!me)){let Ie;ve==="-"?Ie=ve:(ve==="^"||ve==="!")&&!me?Ie="^":ve===e.GLOB_SPLIT?Ie="":Ie=(0,y.escapeRegExpCharacters)(ve),me+=Ie;continue}switch(ve){case"{":X=!0;continue;case"[":ee=!0;continue;case"}":{_+=`(?:${D(J,",").map(ae=>f(ae)).join("|")})`,X=!1,J="";break}case"]":{_+="["+me+"]",ee=!1,me="";break}case"?":_+=P;continue;case"*":_+=k(1);continue;default:_+=(0,y.escapeRegExpCharacters)(ve)}}ge<H.length-1&&(H[ge+1]!==e.GLOBSTAR||ge+2<H.length)&&(_+=O)}Y=ie===e.GLOBSTAR})}return _}const u=/^\*\*\/\*\.[\w\.-]+$/,h=/^\*\*\/([\w\.-]+)\/?$/,p=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,b=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,C=/^\*\*((\/[\w\.-]+)+)\/?$/,g=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new R.LRUCache(1e4),s=function(){return!1},r=function(){return null};function o(Z,_){if(!Z)return r;let H;typeof Z!="string"?H=Z.pattern:H=Z,H=H.trim();const Y=`${H}_${!!_.trimForExclusions}`;let ie=i.get(Y);if(ie)return c(ie,Z);let ge;return u.test(H)?ie=n(H.substr(4),H):(ge=h.exec(m(H,_)))?ie=t(ge[1],H):(_.trimForExclusions?b:p).test(H)?ie=d(H,_):(ge=C.exec(m(H,_)))?ie=E(ge[1].substr(1),H,!0):(ge=g.exec(m(H,_)))?ie=E(ge[1],H,!1):ie=w(H),i.set(Y,ie),c(ie,Z)}function c(Z,_){if(typeof _=="string")return Z;const H=function(Y,ie){return(0,l.isEqualOrParent)(Y,_.base,!A.isLinux)?Z((0,y.ltrim)(Y.substr(_.base.length),S.sep),ie):null};return H.allBasenames=Z.allBasenames,H.allPaths=Z.allPaths,H.basenames=Z.basenames,H.patterns=Z.patterns,H}function m(Z,_){return _.trimForExclusions&&Z.endsWith("/**")?Z.substr(0,Z.length-2):Z}function n(Z,_){return function(H,Y){return typeof H=="string"&&H.endsWith(Z)?_:null}}function t(Z,_){const H=`/${Z}`,Y=`\\${Z}`,ie=function(X,J){return typeof X!="string"?null:J?J===Z?_:null:X===Z||X.endsWith(H)||X.endsWith(Y)?_:null},ge=[Z];return ie.basenames=ge,ie.patterns=[_],ie.allBasenames=ge,ie}function d(Z,_){const H=F(Z.slice(1,-1).split(",").map(J=>o(J,_)).filter(J=>J!==r),Z),Y=H.length;if(!Y)return r;if(Y===1)return H[0];const ie=function(J,ee){for(let me=0,ve=H.length;me<ve;me++)if(H[me](J,ee))return Z;return null},ge=H.find(J=>!!J.allBasenames);ge&&(ie.allBasenames=ge.allBasenames);const X=H.reduce((J,ee)=>ee.allPaths?J.concat(ee.allPaths):J,[]);return X.length&&(ie.allPaths=X),ie}function E(Z,_,H){const Y=S.sep===S.posix.sep,ie=Y?Z:Z.replace(v,S.sep),ge=S.sep+ie,X=S.posix.sep+Z;let J;return H?J=function(ee,me){return typeof ee=="string"&&(ee===ie||ee.endsWith(ge)||!Y&&(ee===Z||ee.endsWith(X)))?_:null}:J=function(ee,me){return typeof ee=="string"&&(ee===ie||!Y&&ee===Z)?_:null},J.allPaths=[(H?"*/":"./")+Z],J}function w(Z){try{const _=new RegExp(`^${f(Z)}$`);return function(H){return _.lastIndex=0,typeof H=="string"&&_.test(H)?Z:null}}catch{return r}}function N(Z,_,H){return!Z||typeof _!="string"?!1:j(Z)(_,void 0,H)}e.match=N;function j(Z,_={}){if(!Z)return s;if(typeof Z=="string"||V(Z)){const H=o(Z,_);if(H===r)return s;const Y=function(ie,ge){return!!H(ie,ge)};return H.allBasenames&&(Y.allBasenames=H.allBasenames),H.allPaths&&(Y.allPaths=H.allPaths),Y}return U(Z,_)}e.parse=j;function V(Z){const _=Z;return _?typeof _.base=="string"&&typeof _.pattern=="string":!1}e.isRelativePattern=V;function Q(Z){return Z.allBasenames||[]}e.getBasenameTerms=Q;function x(Z){return Z.allPaths||[]}e.getPathTerms=x;function U(Z,_){const H=F(Object.getOwnPropertyNames(Z).map(J=>T(J,Z[J],_)).filter(J=>J!==r)),Y=H.length;if(!Y)return r;if(!H.some(J=>!!J.requiresSiblings)){if(Y===1)return H[0];const J=function(ve,Ie){let Re;for(let ae=0,le=H.length;ae<le;ae++){const ue=H[ae](ve,Ie);if(typeof ue=="string")return ue;(0,L.isThenable)(ue)&&(Re||(Re=[]),Re.push(ue))}return Re?(async()=>{for(const ae of Re){const le=await ae;if(typeof le=="string")return le}return null})():null},ee=H.find(ve=>!!ve.allBasenames);ee&&(J.allBasenames=ee.allBasenames);const me=H.reduce((ve,Ie)=>Ie.allPaths?ve.concat(Ie.allPaths):ve,[]);return me.length&&(J.allPaths=me),J}const ie=function(J,ee,me){let ve,Ie;for(let Re=0,ae=H.length;Re<ae;Re++){const le=H[Re];le.requiresSiblings&&me&&(ee||(ee=(0,S.basename)(J)),ve||(ve=ee.substr(0,ee.length-(0,S.extname)(J).length)));const ue=le(J,ee,ve,me);if(typeof ue=="string")return ue;(0,L.isThenable)(ue)&&(Ie||(Ie=[]),Ie.push(ue))}return Ie?(async()=>{for(const Re of Ie){const ae=await Re;if(typeof ae=="string")return ae}return null})():null},ge=H.find(J=>!!J.allBasenames);ge&&(ie.allBasenames=ge.allBasenames);const X=H.reduce((J,ee)=>ee.allPaths?J.concat(ee.allPaths):J,[]);return X.length&&(ie.allPaths=X),ie}function T(Z,_,H){if(_===!1)return r;const Y=o(Z,H);if(Y===r)return r;if(typeof _=="boolean")return Y;if(_){const ie=_.when;if(typeof ie=="string"){const ge=(X,J,ee,me)=>{if(!me||!Y(X,J))return null;const ve=ie.replace("$(basename)",()=>ee),Ie=me(ve);return(0,L.isThenable)(Ie)?Ie.then(Re=>Re?Z:null):Ie?Z:null};return ge.requiresSiblings=!0,ge}}return Y}function F(Z,_){const H=Z.filter(J=>!!J.basenames);if(H.length<2)return Z;const Y=H.reduce((J,ee)=>{const me=ee.basenames;return me?J.concat(me):J},[]);let ie;if(_){ie=[];for(let J=0,ee=Y.length;J<ee;J++)ie.push(_)}else ie=H.reduce((J,ee)=>{const me=ee.patterns;return me?J.concat(me):J},[]);const ge=function(J,ee){if(typeof J!="string")return null;if(!ee){let ve;for(ve=J.length;ve>0;ve--){const Ie=J.charCodeAt(ve-1);if(Ie===47||Ie===92)break}ee=J.substr(ve)}const me=Y.indexOf(ee);return me!==-1?ie[me]:null};ge.basenames=Y,ge.patterns=ie,ge.allBasenames=Y;const X=Z.filter(J=>!J.basenames);return X.push(ge),X}function B(Z,_){return(0,a.equals)(Z,_,(H,Y)=>typeof H=="string"&&typeof Y=="string"?H===Y:typeof H!="string"&&typeof Y!="string"?H.base===Y.base&&H.pattern===Y.pattern:!1)}e.patternsEquals=B}),define(ye[109],De([1,0,11,150,24,8,2]),function(re,e,a,L,l,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var A;(function(u){u[u.Paragraph=0]="Paragraph",u[u.Break=1]="Break"})(A=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class y{constructor(h="",p=!1){if(this.value=h,typeof this.value!="string")throw(0,a.illegalArgument)("value");typeof p=="boolean"?(this.isTrusted=p,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=p.isTrusted??void 0,this.supportThemeIcons=p.supportThemeIcons??!1,this.supportHtml=p.supportHtml??!1)}appendText(h,p=0){return this.value+=v(this.supportThemeIcons?(0,L.escapeIcons)(h):h).replace(/([ \t]+)/g,(b,C)=>"&nbsp;".repeat(C.length)).replace(/\>/gm,"\\>").replace(/\n/g,p===1?`\\
`:`

`),this}appendMarkdown(h){return this.value+=h,this}appendCodeblock(h,p){return this.value+="\n```",this.value+=h,this.value+=`
`,this.value+=p,this.value+="\n```\n",this}appendLink(h,p,b){return this.value+="[",this.value+=this.c(p,"]"),this.value+="](",this.value+=this.c(String(h),")"),b&&(this.value+=` "${this.c(this.c(b,'"'),")")}"`),this.value+=")",this}c(h,p){const b=new RegExp((0,R.escapeRegExpCharacters)(p),"g");return h.replace(b,(C,g)=>h.charAt(g-1)!=="\\"?`\\${C}`:C)}}e.MarkdownString=y;function I(u){return O(u)?!u.value:Array.isArray(u)?u.every(I):!0}e.isEmptyMarkdownString=I;function O(u){return u instanceof y?!0:u&&typeof u=="object"?typeof u.value=="string"&&(typeof u.isTrusted=="boolean"||u.isTrusted===void 0)&&(typeof u.supportThemeIcons=="boolean"||u.supportThemeIcons===void 0):!1}e.isMarkdownString=O;function P(u,h){return u===h?!0:!u||!h?!1:u.value===h.value&&u.isTrusted===h.isTrusted&&u.supportThemeIcons===h.supportThemeIcons&&u.supportHtml===h.supportHtml&&(u.baseUri===h.baseUri||!!u.baseUri&&!!h.baseUri&&(0,l.isEqual)(S.URI.from(u.baseUri),S.URI.from(h.baseUri)))}e.markdownStringEqual=P;function v(u){return u.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=v;function k(u){return u.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=k;function D(u){return u&&u.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}e.removeMarkdownEscapes=D;function f(u){const h=[],p=u.split("|").map(C=>C.trim());u=p[0];const b=p[1];if(b){const C=/height=(\d+)/.exec(b),g=/width=(\d+)/.exec(b),i=C?C[1]:"",s=g?g[1]:"",r=isFinite(parseInt(s)),o=isFinite(parseInt(i));r&&h.push(`width="${s}"`),o&&h.push(`height="${i}"`)}return{href:u,dimensions:h}}e.parseHrefAndDimensions=f}),define(ye[110],De([1,0,15,32,9,12,24,8]),function(re,e,a,L,l,R,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function y(r,o){const{os:c,tildify:m,relative:n}=o;if(n){const E=I(r,n,c);if(typeof E=="string")return E}let t=r.fsPath;if(c===1&&!R.isWindows?t=t.replace(/\//g,"\\"):c!==1&&R.isWindows&&(t=t.replace(/\\/g,"/")),c!==1&&m?.userHome){const E=m.userHome.fsPath;let w;r.scheme!==m.userHome.scheme&&r.path.startsWith(l.posix.sep)?w=m.userHome.with({path:r.path}).fsPath:w=r.fsPath,t=v(w,E,c)}return(c===1?l.win32:l.posix).normalize(O(t,c===1))}e.getPathLabel=y;function I(r,o,c){const m=c===1?l.win32:l.posix,n=c===3?S.extUri:S.extUriIgnorePathCase,t=o.getWorkspace(),d=(0,a.firstOrDefault)(t.folders);if(!d)return;r.scheme!==d.uri.scheme&&r.path.startsWith(l.posix.sep)&&(r=d.uri.with({path:r.path}));const E=o.getWorkspaceFolder(r);if(!E)return;let w;if(n.isEqual(E.uri,r)?w="":w=n.relativePath(E.uri,r)??"",w&&(w=m.normalize(w)),t.folders.length>1&&!o.noPrefix){const N=E.name?E.name:n.basenameOrAuthority(E.uri);w=w?`${N} \u2022 ${w}`:N}return w}function O(r,o=R.isWindows){return(0,L.hasDriveLetter)(r,o)?r.charAt(0).toUpperCase()+r.slice(1):r}e.normalizeDriveLetter=O;let P=Object.create(null);function v(r,o,c=R.OS){if(c===1||!r||!o)return r;let m=P.original===o?P.normalized:void 0;m||(m=o,R.isWindows&&(m=(0,L.toSlashes)(m)),m=`${(0,A.rtrim)(m,l.posix.sep)}${l.posix.sep}`,P={original:o,normalized:m});let n=r;return R.isWindows&&(n=(0,L.toSlashes)(n)),(c===3?n.startsWith(m):(0,A.startsWithIgnoreCase)(n,m))?`~/${n.substr(m.length)}`:r}e.tildify=v;function k(r,o){return r.replace(/^~($|\/|\\)/,`${o}$1`)}e.untildify=k;const D="\u2026",f="\\\\",u="~";function h(r,o=l.sep){const c=new Array(r.length);let m=!1;for(let n=0;n<r.length;n++){const t=r[n];if(t===""){c[n]=`.${o}`;continue}if(!t){c[n]=t;continue}m=!0;let d="",E=t;E.indexOf(f)===0?(d=E.substr(0,E.indexOf(f)+f.length),E=E.substr(E.indexOf(f)+f.length)):E.indexOf(o)===0?(d=E.substr(0,E.indexOf(o)+o.length),E=E.substr(E.indexOf(o)+o.length)):E.indexOf(u)===0&&(d=E.substr(0,E.indexOf(u)+u.length),E=E.substr(E.indexOf(u)+u.length));const w=E.split(o);for(let N=1;m&&N<=w.length;N++)for(let j=w.length-N;m&&j>=0;j--){m=!1;let V=w.slice(j,j+N).join(o);for(let Q=0;!m&&Q<r.length;Q++)if(Q!==n&&r[Q]&&r[Q].indexOf(V)>-1){const x=j+N===w.length,U=j>0&&r[Q].indexOf(o)>-1?o+V:V,T=r[Q].endsWith(U);m=!x||T}if(!m){let Q="";(w[0].endsWith(":")||d!=="")&&(j===1&&(j=0,N++,V=w[0]+o+V),j>0&&(Q=w[0]+o),Q=d+Q),j>0&&(Q=Q+D+o),Q=Q+V,j+N<w.length&&(Q=Q+o+D),c[n]=Q}}m&&(c[n]=t)}return c}e.shorten=h;var p;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(p||(p={}));function b(r,o=Object.create(null)){const c=[];let m=!1,n="";for(const t of r)if(t==="$"||m&&t==="{")n&&c.push({value:n,type:p.TEXT}),n="",m=!0;else if(t==="}"&&m){const d=o[n];if(typeof d=="string")d.length&&c.push({value:d,type:p.VARIABLE});else if(d){const E=c[c.length-1];(!E||E.type!==p.SEPARATOR)&&c.push({value:d.label,type:p.SEPARATOR})}n="",m=!1}else n+=t;return n&&!m&&c.push({value:n,type:p.TEXT}),c.filter((t,d)=>{if(t.type===p.SEPARATOR){const E=c[d-1],w=c[d+1];return[E,w].every(N=>N&&(N.type===p.VARIABLE||N.type===p.TEXT)&&N.value.length>0)}return!0}).map(t=>t.value).join("")}e.template=b;function C(r,o){return R.isMacintosh||o?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,R.isMacintosh?"&":"&&"):r.replace(/&&|&/g,c=>c==="&"?"&&":"&")}e.mnemonicMenuLabel=C;function g(r,o){return R.isMacintosh||o?r.replace(/\(&&\w\)|&&/g,""):R.isWindows?r.replace(/&&|&/g,c=>c==="&"?"&&":"&"):r.replace(/&&/g,"_")}e.mnemonicButtonLabel=g;function i(r){return r.replace(/&/g,"&&")}e.unmnemonicLabel=i;function s(r){const o=r.indexOf("/")!==-1?l.posix:l.win32,c=o.basename(r),m=o.dirname(r);return c.length?{name:c,parentPath:m}:{name:m,parentPath:""}}e.splitName=s}),define(ye[111],De([1,0,22,2]),function(re,e,a,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function l(P){return P.toJSON()}class R{constructor(v){this.a=v}transformIncoming(v){const k=this.a.transformIncoming(v);return k===v?v:l(L.URI.from(k))}transformOutgoing(v){const k=this.a.transformOutgoing(v);return k===v?v:l(L.URI.from(k))}transformOutgoingURI(v){const k=this.a.transformOutgoing(v);return k===v?v:L.URI.from(k)}transformOutgoingScheme(v){return this.a.transformOutgoingScheme(v)}}e.URITransformer=R,e.DefaultURITransformer=new class{transformIncoming(P){return P}transformOutgoing(P){return P}transformOutgoingURI(P){return P}transformOutgoingScheme(P){return P}};function S(P,v,k){if(!P||k>200)return null;if(typeof P=="object"){if(P instanceof L.URI)return v.transformOutgoing(P);for(const D in P)if(Object.hasOwnProperty.call(P,D)){const f=S(P[D],v,k+1);f!==null&&(P[D]=f)}}return null}function A(P,v){const k=S(P,v,0);return k===null?P:k}e.transformOutgoingURIs=A;function y(P,v,k,D){if(!P||D>200)return null;if(typeof P=="object"){if(P.$mid===1)return k?L.URI.revive(v.transformIncoming(P)):v.transformIncoming(P);if(P instanceof a.VSBuffer)return null;for(const f in P)if(Object.hasOwnProperty.call(P,f)){const u=y(P[f],v,k,D+1);u!==null&&(P[f]=u)}}return null}function I(P,v){const k=y(P,v,!1,0);return k===null?P:k}e.transformIncomingURIs=I;function O(P,v){const k=y(P,v,!0,0);return k===null?P:k}e.transformAndReviveIncomingURIs=O}),define(ye[30],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const a=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(l){return a.test(l)}e.isUUID=L,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let l;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?l=crypto.getRandomValues.bind(crypto):l=function(A){for(let y=0;y<A.length;y++)A[y]=Math.floor(Math.random()*256);return A};const R=new Uint8Array(16),S=[];for(let A=0;A<256;A++)S.push(A.toString(16).padStart(2,"0"));return function(){l(R),R[6]=R[6]&15|64,R[8]=R[8]&63|128;let y=0,I="";return I+=S[R[y++]],I+=S[R[y++]],I+=S[R[y++]],I+=S[R[y++]],I+="-",I+=S[R[y++]],I+=S[R[y++]],I+="-",I+=S[R[y++]],I+=S[R[y++]],I+="-",I+=S[R[y++]],I+=S[R[y++]],I+="-",I+=S[R[y++]],I+=S[R[y++]],I+=S[R[y++]],I+=S[R[y++]],I+=S[R[y++]],I+=S[R[y++]],I}}()}),define(ye[151],De([1,0,15,30]),function(re,e,a,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriList=e.VSDataTransfer=e.createFileDataTransferItem=e.createStringDataTransferItem=void 0;function l(A){return{id:(0,L.generateUuid)(),asString:async()=>A,asFile:()=>{},value:typeof A=="string"?A:void 0}}e.createStringDataTransferItem=l;function R(A,y,I){return{id:(0,L.generateUuid)(),asString:async()=>"",asFile:()=>({name:A,uri:y,data:I}),value:void 0}}e.createFileDataTransferItem=R;class S{constructor(){this.a=new Map}get size(){return this.a.size}has(y){return this.a.has(this.b(y))}get(y){return this.a.get(this.b(y))?.[0]}append(y,I){const O=this.a.get(y);O?O.push(I):this.a.set(this.b(y),[I])}replace(y,I){this.a.set(this.b(y),[I])}delete(y){this.a.delete(this.b(y))}*entries(){for(const[y,I]of this.a.entries())for(const O of I)yield[y,O]}values(){return Array.from(this.a.values()).flat()}forEach(y){for(const[I,O]of this.entries())y(O,I)}b(y){return y.toLowerCase()}}e.VSDataTransfer=S,e.UriList=Object.freeze({create:A=>(0,a.distinct)(A.map(y=>y.toString())).join(`\r
`),split:A=>A.split(`\r
`),parse:A=>e.UriList.split(A).filter(y=>!y.startsWith("#"))})}),define(ye[29],De([1,0,52,71,318,17,32,87,9,12,24,2]),function(re,e,a,L,l,R,S,A,y,I,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var v;(function(U){U[U.UNLINK=0]="UNLINK",U[U.MOVE=1]="MOVE"})(v=e.RimRafMode||(e.RimRafMode={}));async function k(U,T=v.UNLINK){if((0,S.isRootOrDriveLetter)(U))throw new Error("rimraf - will refuse to recursively delete root");return T===v.UNLINK?f(U):D(U)}async function D(U){try{const T=(0,S.randomPath)((0,L.tmpdir)());try{await a.promises.rename(U,T)}catch(F){return F.code==="ENOENT"?void 0:f(U)}f(T).catch(F=>{})}catch(T){if(T.code!=="ENOENT")throw T}}async function f(U){return(0,l.promisify)(a.rm)(U,{recursive:!0,force:!0,maxRetries:3})}function u(U){if((0,S.isRootOrDriveLetter)(U))throw new Error("rimraf - will refuse to recursively delete root");a.rmSync(U,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=u;async function h(U,T){return C(await(T?p(U):(0,l.promisify)(a.readdir)(U)))}async function p(U){try{return await(0,l.promisify)(a.readdir)(U,{withFileTypes:!0})}catch(B){console.warn("[node.js fs] readdir with filetypes failed with error: ",B)}const T=[],F=await h(U);for(const B of F){let Z=!1,_=!1,H=!1;try{const Y=await e.Promises.lstat((0,y.join)(U,B));Z=Y.isFile(),_=Y.isDirectory(),H=Y.isSymbolicLink()}catch(Y){console.warn("[node.js fs] unexpected error from lstat after readdir: ",Y)}T.push({name:B,isFile:()=>Z,isDirectory:()=>_,isSymbolicLink:()=>H})}return T}function b(U){return C(a.readdirSync(U))}e.readdirSync=b;function C(U){return U.map(T=>typeof T=="string"?I.isMacintosh?(0,A.normalizeNFC)(T):T:(T.name=I.isMacintosh?(0,A.normalizeNFC)(T.name):T.name,T))}async function g(U){const T=await h(U),F=[];for(const B of T)await s.existsDirectory((0,y.join)(U,B))&&F.push(B);return F}function i(U,T=1e3){return new Promise(F=>{let B=!1;const Z=setInterval(()=>{B||(B=!0,a.access(U,_=>{B=!1,_&&(clearInterval(Z),F(void 0))}))},T)})}e.whenDeleted=i;var s;(function(U){async function T(Z){let _;try{if(_=await e.Promises.lstat(Z),!_.isSymbolicLink())return{stat:_}}catch{}try{return{stat:await e.Promises.stat(Z),symbolicLink:_?.isSymbolicLink()?{dangling:!1}:void 0}}catch(H){if(H.code==="ENOENT"&&_)return{stat:_,symbolicLink:{dangling:!0}};if(I.isWindows&&H.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(Z)),symbolicLink:{dangling:!1}}}catch(Y){if(Y.code==="ENOENT"&&_)return{stat:_,symbolicLink:{dangling:!0}};throw Y}throw H}}U.stat=T;async function F(Z){try{const{stat:_,symbolicLink:H}=await U.stat(Z);return _.isFile()&&H?.dangling!==!0}catch{}return!1}U.existsFile=F;async function B(Z){try{const{stat:_,symbolicLink:H}=await U.stat(Z);return _.isDirectory()&&H?.dangling!==!0}catch{}return!1}U.existsDirectory=B})(s=e.SymlinkSupport||(e.SymlinkSupport={}));const r=new R.ResourceQueue;function o(U,T,F){return r.queueFor(P.URI.file(U),O.extUriBiasedIgnorePathCase).queue(()=>{const B=d(F);return new Promise((Z,_)=>n(U,T,B,H=>H?_(H):Z()))})}let c=!0;function m(U){c=U}e.configureFlushOnWrite=m;function n(U,T,F,B){if(!c)return a.writeFile(U,T,{mode:F.mode,flag:F.flag},B);a.open(U,F.flag,F.mode,(Z,_)=>{if(Z)return B(Z);a.writeFile(_,T,H=>{if(H)return a.close(_,()=>B(H));a.fdatasync(_,Y=>(Y&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",Y),m(!1)),a.close(_,ie=>B(ie))))})})}function t(U,T,F){const B=d(F);if(!c)return a.writeFileSync(U,T,{mode:B.mode,flag:B.flag});const Z=a.openSync(U,B.flag,B.mode);try{a.writeFileSync(Z,T);try{a.fdatasyncSync(Z)}catch(_){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",_),m(!1)}}finally{a.closeSync(Z)}}e.writeFileSync=t;function d(U){return U?{mode:typeof U.mode=="number"?U.mode:438,flag:typeof U.flag=="string"?U.flag:"w"}:{mode:438,flag:"w"}}async function E(U,T){if(U!==T)try{await e.Promises.rename(U,T)}catch(F){if(U.toLowerCase()!==T.toLowerCase()&&F.code==="EXDEV"||U.endsWith("."))await w(U,T,{preserveSymlinks:!1}),await k(U,v.MOVE);else throw F}}async function w(U,T,F){return j(U,T,{root:{source:U,target:T},options:F,handledSourcePaths:new Set})}const N=511;async function j(U,T,F){if(F.handledSourcePaths.has(U))return;F.handledSourcePaths.add(U);const{stat:B,symbolicLink:Z}=await s.stat(U);if(Z){if(F.options.preserveSymlinks)try{return await x(U,T,F)}catch(_){console.warn("[node.js fs] copy of symlink failed: ",_)}if(Z.dangling)return}return B.isDirectory()?V(U,T,B.mode&N,F):Q(U,T,B.mode&N)}async function V(U,T,F,B){await e.Promises.mkdir(T,{recursive:!0,mode:F});const Z=await h(U);for(const _ of Z)await j((0,y.join)(U,_),(0,y.join)(T,_),B)}async function Q(U,T,F){await e.Promises.copyFile(U,T),await e.Promises.chmod(T,F)}async function x(U,T,F){let B=await e.Promises.readlink(U);(0,S.isEqualOrParent)(B,F.root.source,!I.isLinux)&&(B=(0,y.join)(F.root.target,B.substr(F.root.source.length+1))),await e.Promises.symlink(B,T)}e.Promises=new class{get access(){return(0,l.promisify)(a.access)}get stat(){return(0,l.promisify)(a.stat)}get lstat(){return(0,l.promisify)(a.lstat)}get utimes(){return(0,l.promisify)(a.utimes)}get read(){return(U,T,F,B,Z)=>new Promise((_,H)=>{a.read(U,T,F,B,Z,(Y,ie,ge)=>Y?H(Y):_({bytesRead:ie,buffer:ge}))})}get readFile(){return(0,l.promisify)(a.readFile)}get write(){return(U,T,F,B,Z)=>new Promise((_,H)=>{a.write(U,T,F,B,Z,(Y,ie,ge)=>Y?H(Y):_({bytesWritten:ie,buffer:ge}))})}get appendFile(){return(0,l.promisify)(a.appendFile)}get fdatasync(){return(0,l.promisify)(a.fdatasync)}get truncate(){return(0,l.promisify)(a.truncate)}get rename(){return(0,l.promisify)(a.rename)}get copyFile(){return(0,l.promisify)(a.copyFile)}get open(){return(0,l.promisify)(a.open)}get close(){return(0,l.promisify)(a.close)}get symlink(){return(0,l.promisify)(a.symlink)}get readlink(){return(0,l.promisify)(a.readlink)}get chmod(){return(0,l.promisify)(a.chmod)}get mkdir(){return(0,l.promisify)(a.mkdir)}get unlink(){return(0,l.promisify)(a.unlink)}get rmdir(){return(0,l.promisify)(a.rmdir)}get realpath(){return(0,l.promisify)(a.realpath)}async exists(U){try{return await e.Promises.access(U),!0}catch{return!1}}get readdir(){return h}get readDirsInDir(){return g}get writeFile(){return o}get rm(){return k}get move(){return E}get copy(){return w}}}),define(ye[112],De([1,0,52,9,12,8,29]),function(re,e,a,L,l,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function A(v){if(l.isLinux)return v;const k=(0,L.dirname)(v);if(v===k)return v;const D=((0,L.basename)(v)||v).toLowerCase();try{const u=(0,S.readdirSync)(k).filter(h=>h.toLowerCase()===D);if(u.length===1){const h=A(k);if(h)return(0,L.join)(h,u[0])}else if(u.length>1){const h=u.indexOf(D);if(h>=0){const p=A(k);if(p)return(0,L.join)(p,u[h])}}}catch{}return null}e.realcaseSync=A;async function y(v){if(l.isLinux)return v;const k=(0,L.dirname)(v);if(v===k)return v;const D=((0,L.basename)(v)||v).toLowerCase();try{const u=(await S.Promises.readdir(k)).filter(h=>h.toLowerCase()===D);if(u.length===1){const h=await y(k);if(h)return(0,L.join)(h,u[0])}else if(u.length>1){const h=u.indexOf(D);if(h>=0){const p=await y(k);if(p)return(0,L.join)(p,u[h])}}}catch{}return null}e.realcase=y;async function I(v){try{return await S.Promises.realpath(v)}catch{const D=P(v);return await S.Promises.access(D,a.constants.R_OK),D}}e.realpath=I;function O(v){try{return a.realpathSync(v)}catch{const D=P(v);return a.accessSync(D,a.constants.R_OK),D}}e.realpathSync=O;function P(v){return(0,R.rtrim)((0,L.normalize)(v),L.sep)}}),define(ye[113],De([1,0,9,12,36,104,10,29]),function(re,e,a,L,l,R,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return R.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return R.TerminateResponseCode}});function y(P=l.env){return P.comspec||"cmd.exe"}e.getWindowsShell=y;function I(P){let v=[],k=!1;const D=function(f){if(k){v.push(f);return}(!P.send(f,h=>{if(h&&console.error(h),k=!1,v.length>0){const p=v.slice(0);v=[],p.forEach(b=>D(b))}})||L.isWindows)&&(k=!0)};return{send:D}}e.createQueuedSender=I;var O;(function(P){async function v(k,D,f){if(a.isAbsolute(k))return k;if(D===void 0&&(D=l.cwd()),a.dirname(k)!=="."||(f===void 0&&S.isString(l.env.PATH)&&(f=l.env.PATH.split(a.delimiter)),f===void 0||f.length===0))return a.join(D,k);async function h(p){if(await A.Promises.exists(p)){let b;try{b=await A.Promises.stat(p)}catch(C){C.message.startsWith("EACCES")&&(b=await A.Promises.lstat(p))}return b?!b.isDirectory():!1}return!1}for(const p of f){let b;if(a.isAbsolute(p)?b=a.join(p,k):b=a.join(D,p,k),await h(b))return b;let C=b+".com";if(await h(C)||(C=b+".exe",await h(C)))return C}return a.join(D,k)}P.findExecutable=v})(O=e.win32||(e.win32={}))});var qe=this&&this.__decorate||function(re,e,a,L){var l=arguments.length,R=l<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,a):L,S;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")R=Reflect.decorate(re,e,a,L);else for(var A=re.length-1;A>=0;A--)(S=re[A])&&(R=(l<3?S(R):l>3?S(e,a,R):S(e,a))||R);return l>3&&R&&Object.defineProperty(e,a,R),R};define(ye[114],De([1,0,15,17,22,21,63,11,3,6,70,8,10]),function(re,e,a,L,l,R,S,A,y,I,O,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.deserialize=e.serialize=e.BufferWriter=e.BufferReader=void 0;var k;(function(_){_[_.Promise=100]="Promise",_[_.PromiseCancel=101]="PromiseCancel",_[_.EventListen=102]="EventListen",_[_.EventDispose=103]="EventDispose"})(k||(k={}));function D(_){switch(_){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var f;(function(_){_[_.Initialize=200]="Initialize",_[_.PromiseSuccess=201]="PromiseSuccess",_[_.PromiseError=202]="PromiseError",_[_.PromiseErrorObj=203]="PromiseErrorObj",_[_.EventFire=204]="EventFire"})(f||(f={}));function u(_){switch(_){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var h;(function(_){_[_.Uninitialized=0]="Uninitialized",_[_.Idle=1]="Idle"})(h||(h={}));function p(_){let H=0;for(let Y=0;;Y+=7){const ie=_.read(1);if(H|=(ie.buffer[0]&127)<<Y,!(ie.buffer[0]&128))return H}}const b=r(0);function C(_,H){if(H===0){_.write(b);return}let Y=0;for(let ge=H;ge!==0;ge=ge>>>7)Y++;const ie=l.VSBuffer.alloc(Y);for(let ge=0;H!==0;ge++)ie.buffer[ge]=H&127,H=H>>>7,H>0&&(ie.buffer[ge]|=128);_.write(ie)}class g{constructor(H){this.b=H,this.a=0}read(H){const Y=this.b.slice(this.a,this.a+H);return this.a+=Y.byteLength,Y}}e.BufferReader=g;class i{constructor(){this.a=[]}get buffer(){return l.VSBuffer.concat(this.a)}write(H){this.a.push(H)}}e.BufferWriter=i;var s;(function(_){_[_.Undefined=0]="Undefined",_[_.String=1]="String",_[_.Buffer=2]="Buffer",_[_.VSBuffer=3]="VSBuffer",_[_.Array=4]="Array",_[_.Object=5]="Object",_[_.Int=6]="Int"})(s||(s={}));function r(_){const H=l.VSBuffer.alloc(1);return H.writeUInt8(_,0),H}const o={Undefined:r(s.Undefined),String:r(s.String),Buffer:r(s.Buffer),VSBuffer:r(s.VSBuffer),Array:r(s.Array),Object:r(s.Object),Uint:r(s.Int)},c=typeof Buffer<"u";function m(_,H){if(typeof H>"u")_.write(o.Undefined);else if(typeof H=="string"){const Y=l.VSBuffer.fromString(H);_.write(o.String),C(_,Y.byteLength),_.write(Y)}else if(c&&Buffer.isBuffer(H)){const Y=l.VSBuffer.wrap(H);_.write(o.Buffer),C(_,Y.byteLength),_.write(Y)}else if(H instanceof l.VSBuffer)_.write(o.VSBuffer),C(_,H.byteLength),_.write(H);else if(Array.isArray(H)){_.write(o.Array),C(_,H.length);for(const Y of H)m(_,Y)}else if(typeof H=="number"&&(H|0)===H)_.write(o.Uint),C(_,H);else{const Y=l.VSBuffer.fromString(JSON.stringify(H));_.write(o.Object),C(_,Y.byteLength),_.write(Y)}}e.serialize=m;function n(_){switch(_.read(1).readUInt8(0)){case s.Undefined:return;case s.String:return _.read(p(_)).toString();case s.Buffer:return _.read(p(_)).buffer;case s.VSBuffer:return _.read(p(_));case s.Array:{const Y=p(_),ie=[];for(let ge=0;ge<Y;ge++)ie.push(n(_));return ie}case s.Object:return JSON.parse(_.read(p(_)).toString());case s.Int:return p(_)}}e.deserialize=n;class t{constructor(H,Y,ie=null,ge=1e3){this.h=H,this.j=Y,this.k=ie,this.l=ge,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(X=>this.q(X)),this.m({type:200})}registerChannel(H,Y){this.b.set(H,Y),setTimeout(()=>this.w(H),0)}m(H){switch(H.type){case 200:{const Y=this.o([H.type]);this.k?.logOutgoing(Y,0,1,u(H.type));return}case 201:case 202:case 204:case 203:{const Y=this.o([H.type,H.id],H.data);this.k?.logOutgoing(Y,H.id,1,u(H.type),H.data);return}}}o(H,Y=void 0){const ie=new i;return m(ie,H),m(ie,Y),this.p(ie.buffer)}p(H){try{return this.h.send(H),H.byteLength}catch{return 0}}q(H){const Y=new g(H),ie=n(Y),ge=n(Y),X=ie[0];switch(X){case 100:return this.k?.logIncoming(H.byteLength,ie[1],1,`${D(X)}: ${ie[2]}.${ie[3]}`,ge),this.s({type:X,id:ie[1],channelName:ie[2],name:ie[3],arg:ge});case 102:return this.k?.logIncoming(H.byteLength,ie[1],1,`${D(X)}: ${ie[2]}.${ie[3]}`,ge),this.t({type:X,id:ie[1],channelName:ie[2],name:ie[3],arg:ge});case 101:return this.k?.logIncoming(H.byteLength,ie[1],1,`${D(X)}`),this.u({type:X,id:ie[1]});case 103:return this.k?.logIncoming(H.byteLength,ie[1],1,`${D(X)}`),this.u({type:X,id:ie[1]})}}s(H){const Y=this.b.get(H.channelName);if(!Y){this.v(H);return}const ie=new R.CancellationTokenSource;let ge;try{ge=Y.call(this.j,H.name,H.arg,ie.token)}catch(ee){ge=Promise.reject(ee)}const X=H.id;ge.then(ee=>{this.m({id:X,data:ee,type:201}),this.d.delete(H.id)},ee=>{ee instanceof Error?this.m({id:X,data:{message:ee.message,name:ee.name,stack:ee.stack?ee.stack.split?ee.stack.split(`
`):ee.stack:void 0},type:202}):this.m({id:X,data:ee,type:203}),this.d.delete(H.id)});const J=(0,I.toDisposable)(()=>ie.cancel());this.d.set(H.id,J)}t(H){const Y=this.b.get(H.channelName);if(!Y){this.v(H);return}const ie=H.id,X=Y.listen(this.j,H.name,H.arg)(J=>this.m({id:ie,data:J,type:204}));this.d.set(H.id,X)}u(H){const Y=this.d.get(H.id);Y&&(Y.dispose(),this.d.delete(H.id))}v(H){let Y=this.g.get(H.channelName);Y||(Y=[],this.g.set(H.channelName,Y));const ie=setTimeout(()=>{console.error(`Unknown channel: ${H.channelName}`),H.type===100&&this.m({id:H.id,data:{name:"Unknown channel",message:`Channel name '${H.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);Y.push({request:H,timeoutTimer:ie})}w(H){const Y=this.g.get(H);if(Y){for(const ie of Y)switch(clearTimeout(ie.timeoutTimer),ie.request.type){case 100:this.s(ie.request);break;case 102:this.t(ie.request);break}this.g.delete(H)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,I.dispose)(this.d.values()),this.d.clear()}}e.ChannelServer=t;var d;(function(_){_[_.LocalSide=0]="LocalSide",_[_.OtherSide=1]="OtherSide"})(d=e.RequestInitiator||(e.RequestInitiator={}));class E{constructor(H,Y=null){this.l=H,this.a=!1,this.b=h.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new y.Emitter,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(ie=>this.s(ie)),this.j=Y}getChannel(H){const Y=this;return{call(ie,ge,X){return Y.a?Promise.reject(new A.CancellationError):Y.m(H,ie,ge,X)},listen(ie,ge){return Y.a?y.Event.None:Y.o(H,ie,ge)}}}m(H,Y,ie,ge=R.CancellationToken.None){const X=this.g++,ee={id:X,type:100,channelName:H,name:Y,arg:ie};if(ge.isCancellationRequested)return Promise.reject(new A.CancellationError);let me;return new Promise((Ie,Re)=>{if(ge.isCancellationRequested)return Re(new A.CancellationError);const ae=()=>{const ce=oe=>{switch(oe.type){case 201:this.f.delete(X),Ie(oe.data);break;case 202:{this.f.delete(X);const M=new Error(oe.data.message);M.stack=Array.isArray(oe.data.stack)?oe.data.stack.join(`
`):oe.data.stack,M.name=oe.data.name,Re(M);break}case 203:this.f.delete(X),Re(oe.data);break}};this.f.set(X,ce),this.p(ee)};let le=null;this.b===h.Idle?ae():(le=(0,L.createCancelablePromise)(ce=>this.u()),le.then(()=>{le=null,ae()}));const ue=()=>{le?(le.cancel(),le=null):this.p({id:X,type:101}),Re(new A.CancellationError)},ne=ge.onCancellationRequested(ue);me=(0,I.combinedDisposable)((0,I.toDisposable)(ue),ne),this.d.add(me)}).finally(()=>{this.d.delete(me)})}o(H,Y,ie){const ge=this.g++,J={id:ge,type:102,channelName:H,name:Y,arg:ie};let ee=null;const me=new y.Emitter({onWillAddFirstListener:()=>{ee=(0,L.createCancelablePromise)(Ie=>this.u()),ee.then(()=>{ee=null,this.d.add(me),this.p(J)})},onDidRemoveLastListener:()=>{ee?(ee.cancel(),ee=null):(this.d.delete(me),this.p({id:ge,type:103}))}}),ve=Ie=>me.fire(Ie.data);return this.f.set(ge,ve),me.event}p(H){switch(H.type){case 100:case 102:{const Y=this.q([H.type,H.id,H.channelName,H.name],H.arg);this.j?.logOutgoing(Y,H.id,0,`${D(H.type)}: ${H.channelName}.${H.name}`,H.arg);return}case 101:case 103:{const Y=this.q([H.type,H.id]);this.j?.logOutgoing(Y,H.id,0,D(H.type));return}}}q(H,Y=void 0){const ie=new i;return m(ie,H),m(ie,Y),this.r(ie.buffer)}r(H){try{return this.l.send(H),H.byteLength}catch{return 0}}s(H){const Y=new g(H),ie=n(Y),ge=n(Y),X=ie[0];switch(X){case 200:return this.j?.logIncoming(H.byteLength,0,0,u(X)),this.t({type:ie[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(H.byteLength,ie[1],0,u(X),ge),this.t({type:ie[0],id:ie[1],data:ge})}}t(H){if(H.type===200){this.b=h.Idle,this.k.fire();return}this.f.get(H.id)?.(H)}get onDidInitializePromise(){return y.Event.toPromise(this.onDidInitialize)}u(){return this.b===h.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,I.dispose)(this.d.values()),this.d.clear()}}qe([S.memoize],E.prototype,"onDidInitializePromise",null),e.ChannelClient=E;class w{get connections(){const H=[];return this.f.forEach(Y=>H.push(Y)),H}constructor(H){this.a=new Map,this.f=new Set,this.g=new y.Emitter,this.onDidAddConnection=this.g.event,this.h=new y.Emitter,this.onDidRemoveConnection=this.h.event,H(({protocol:Y,onDidClientDisconnect:ie})=>{y.Event.once(Y.onMessage)(X=>{const J=new g(X),ee=n(J),me=new t(Y,ee),ve=new E(Y);this.a.forEach((Re,ae)=>me.registerChannel(ae,Re));const Ie={channelServer:me,channelClient:ve,ctx:ee};this.f.add(Ie),this.g.fire(Ie),ie(()=>{me.dispose(),ve.dispose(),this.f.delete(Ie),this.h.fire(Ie)})})})}getChannel(H,Y){const ie=this;return{call(ge,X,J){let ee;if((0,v.isFunction)(Y)){const ve=(0,a.getRandomElement)(ie.connections.filter(Y));ee=ve?Promise.resolve(ve):y.Event.toPromise(y.Event.filter(ie.onDidAddConnection,Y))}else ee=Y.routeCall(ie,ge,X);const me=ee.then(ve=>ve.channelClient.getChannel(H));return j(me).call(ge,X,J)},listen(ge,X){if((0,v.isFunction)(Y))return ie.j(H,Y,ge,X);const J=Y.routeEvent(ie,ge,X).then(ee=>ee.channelClient.getChannel(H));return j(J).listen(ge,X)}}}j(H,Y,ie,ge){const X=this;let J=new I.DisposableStore;const ee=new y.Emitter({onWillAddFirstListener:()=>{J=new I.DisposableStore;const me=new y.EventMultiplexer,ve=new Map,Ie=ae=>{const ue=ae.channelClient.getChannel(H).listen(ie,ge),ne=me.add(ue);ve.set(ae,ne)},Re=ae=>{const le=ve.get(ae);!le||(le.dispose(),ve.delete(ae))};X.connections.filter(Y).forEach(Ie),y.Event.filter(X.onDidAddConnection,Y)(Ie,void 0,J),X.onDidRemoveConnection(Re,void 0,J),me.event(ee.fire,ee,J),J.add(me)},onDidRemoveLastListener:()=>{J.dispose()}});return ee.event}registerChannel(H,Y){this.a.set(H,Y),this.f.forEach(ie=>{ie.channelServer.registerChannel(H,Y)})}dispose(){this.a.clear(),this.f.clear(),this.g.dispose(),this.h.dispose()}}e.IPCServer=w;class N{constructor(H,Y,ie=null){const ge=new i;m(ge,Y),H.send(ge.buffer),this.a=new E(H,ie),this.d=new t(H,Y,ie)}getChannel(H){return this.a.getChannel(H)}registerChannel(H,Y){this.d.registerChannel(H,Y)}dispose(){this.a.dispose(),this.d.dispose()}}e.IPCClient=N;function j(_){return{call(H,Y,ie){return _.then(ge=>ge.call(H,Y,ie))},listen(H,Y){const ie=new y.Relay;return _.then(ge=>ie.input=ge.listen(H,Y)),ie.event}}}e.getDelayedChannel=j;function V(_){let H=!1;return{call(Y,ie,ge){return H?_.call(Y,ie,ge):(0,L.timeout)(0).then(()=>H=!0).then(()=>_.call(Y,ie,ge))},listen(Y,ie){if(H)return _.listen(Y,ie);const ge=new y.Relay;return(0,L.timeout)(0).then(()=>H=!0).then(()=>ge.input=_.listen(Y,ie)),ge.event}}}e.getNextTickChannel=V;class Q{constructor(H){this.a=H}routeCall(H){return this.b(H)}routeEvent(H){return this.b(H)}async b(H){for(const Y of H.connections)if(await Promise.resolve(this.a(Y.ctx)))return Promise.resolve(Y);return await y.Event.toPromise(H.onDidAddConnection),await this.b(H)}}e.StaticRouter=Q;var x;(function(_){function H(X,J){const ee=X,me=J&&J.disableMarshalling,ve=new Map;for(const Ie in ee)ie(Ie)&&ve.set(Ie,y.Event.buffer(ee[Ie],!0));return new class{listen(Ie,Re,ae){const le=ve.get(Re);if(le)return le;if(ge(Re)){const ue=ee[Re];if(typeof ue=="function")return ue.call(ee,ae)}throw new Error(`Event not found: ${Re}`)}call(Ie,Re,ae){const le=ee[Re];if(typeof le=="function"){if(!me&&Array.isArray(ae))for(let ue=0;ue<ae.length;ue++)ae[ue]=(0,O.revive)(ae[ue]);return le.apply(ee,ae)}throw new Error(`Method not found: ${Re}`)}}}_.fromService=H;function Y(X,J){const ee=J&&J.disableMarshalling;return new Proxy({},{get(me,ve){if(typeof ve=="string")return J?.properties?.has(ve)?J.properties.get(ve):ge(ve)?function(Ie){return X.listen(ve,Ie)}:ie(ve)?X.listen(ve):async function(...Ie){let Re;J&&!(0,v.isUndefinedOrNull)(J.context)?Re=[J.context,...Ie]:Re=Ie;const ae=await X.call(ve,Re);return ee?ae:(0,O.revive)(ae)};throw new Error(`Property not found: ${String(ve)}`)}})}_.toService=Y;function ie(X){return X[0]==="o"&&X[1]==="n"&&P.isUpperAsciiLetter(X.charCodeAt(2))}function ge(X){return/^onDynamic/.test(X)&&P.isUpperAsciiLetter(X.charCodeAt(9))}})(x=e.ProxyChannel||(e.ProxyChannel={}));const U=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function T(_){if(Array.isArray(_))return _;if(_&&typeof _=="object"&&typeof _.toString=="function"){const H=_.toString();if(H!=="[object Object]")return H}return _}function F(_){return Array.isArray(_)?_.map(T):T(_)}function B(_,H,Y,ie,ge,X,J){J=F(J);const ee=U[ge],me=ee[ie%ee.length];let ve=[`%c[${_}]%c[${String(H).padStart(7," ")}]%c[len: ${String(Y).padStart(5," ")}]%c${String(ie).padStart(5," ")} - ${X}`,"color: darkgreen","color: grey","color: grey",`color: ${me}`];/\($/.test(X)?(ve=ve.concat(J),ve.push(")")):ve.push(J),console.log.apply(console,ve)}class Z{constructor(H,Y){this.d=H,this.f=Y,this.a=0,this.b=0}logOutgoing(H,Y,ie,ge,X){this.b+=H,B(this.d,this.b,H,Y,ie,ge,X)}logIncoming(H,Y,ie,ge,X){this.a+=H,B(this.f,this.a,H,Y,ie,ge,X)}}e.IPCLogger=Z}),define(ye[115],De([1,0,17,22,3,6,114]),function(re,e,a,L,l,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.HighRoundTripTimeEvent=e.ConnectionHealthChangedEvent=e.connectionHealthToString=e.ConnectionHealth=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var A;(function(E){E.Created="created",E.Read="read",E.Write="write",E.Open="open",E.Error="error",E.Close="close",E.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",E.NodeEndReceived="nodeEndReceived",E.NodeEndSent="nodeEndSent",E.NodeDrainBegin="nodeDrainBegin",E.NodeDrainEnd="nodeDrainEnd",E.zlibInflateError="zlibInflateError",E.zlibInflateData="zlibInflateData",E.zlibInflateInitialWrite="zlibInflateInitialWrite",E.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",E.zlibInflateWrite="zlibInflateWrite",E.zlibInflateFlushFired="zlibInflateFlushFired",E.zlibDeflateError="zlibDeflateError",E.zlibDeflateData="zlibDeflateData",E.zlibDeflateWrite="zlibDeflateWrite",E.zlibDeflateFlushFired="zlibDeflateFlushFired",E.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",E.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",E.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",E.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",E.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",E.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",E.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",E.ProtocolHeaderRead="protocolHeaderRead",E.ProtocolMessageRead="protocolMessageRead",E.ProtocolHeaderWrite="protocolHeaderWrite",E.ProtocolMessageWrite="protocolMessageWrite",E.ProtocolWrite="protocolWrite"})(A=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var y;(function(E){E.enableDiagnostics=!1,E.records=[];const w=new WeakMap;let N=0;function j(Q,x){if(!w.has(Q)){const U=String(++N);w.set(Q,U)}return w.get(Q)}function V(Q,x,U,T){if(!E.enableDiagnostics)return;const F=j(Q,x);if(T instanceof L.VSBuffer||T instanceof Uint8Array||T instanceof ArrayBuffer||ArrayBuffer.isView(T)){const B=L.VSBuffer.alloc(T.byteLength);B.set(T),E.records.push({timestamp:Date.now(),id:F,label:x,type:U,buff:B})}else E.records.push({timestamp:Date.now(),id:F,label:x,type:U,data:T})}E.traceSocketEvent=V})(y=e.SocketDiagnostics||(e.SocketDiagnostics={}));var I;(function(E){E[E.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",E[E.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(I=e.SocketCloseEventType||(e.SocketCloseEventType={}));let O=null;function P(){return O||(O=L.VSBuffer.alloc(0)),O}class v{get byteLength(){return this.b}constructor(){this.a=[],this.b=0}acceptChunk(w){this.a.push(w),this.b+=w.byteLength}read(w){return this.c(w,!0)}peek(w){return this.c(w,!1)}c(w,N){if(w===0)return P();if(w>this.b)throw new Error("Cannot read so many bytes!");if(this.a[0].byteLength===w){const x=this.a[0];return N&&(this.a.shift(),this.b-=w),x}if(this.a[0].byteLength>w){const x=this.a[0].slice(0,w);return N&&(this.a[0]=this.a[0].slice(w),this.b-=w),x}const j=L.VSBuffer.alloc(w);let V=0,Q=0;for(;w>0;){const x=this.a[Q];if(x.byteLength>w){const U=x.slice(0,w);j.set(U,V),V+=w,N&&(this.a[Q]=x.slice(w),this.b-=w),w-=w}else j.set(x,V),V+=x.byteLength,N?(this.a.shift(),this.b-=x.byteLength):Q++,w-=x.byteLength}return j}}e.ChunkStream=v;var k;(function(E){E[E.None=0]="None",E[E.Regular=1]="Regular",E[E.Control=2]="Control",E[E.Ack=3]="Ack",E[E.Disconnect=5]="Disconnect",E[E.ReplayRequest=6]="ReplayRequest",E[E.Pause=7]="Pause",E[E.Resume=8]="Resume",E[E.KeepAlive=9]="KeepAlive",E[E.LatencyMeasurementRequest=10]="LatencyMeasurementRequest",E[E.LatencyMeasurementResponse=11]="LatencyMeasurementResponse"})(k||(k={}));function D(E){switch(E){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting";case 9:return"KeepAlive";case 10:return"LatencyMeasurementRequest";case 11:return"LatencyMeasurementResponse"}}var f;(function(E){E[E.HeaderLength=13]="HeaderLength",E[E.AcknowledgeTime=2e3]="AcknowledgeTime",E[E.TimeoutTime=2e4]="TimeoutTime",E[E.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",E[E.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime",E[E.KeepAliveSendTime=5e3]="KeepAliveSendTime",E[E.LatencySampleTime=6e4]="LatencySampleTime",E[E.LatencySampleCount=5]="LatencySampleCount",E[E.HighLatencyTimeThreshold=1e3]="HighLatencyTimeThreshold",E[E.HighLatencySampleThreshold=3]="HighLatencySampleThreshold"})(f=e.ProtocolConstants||(e.ProtocolConstants={}));class u{constructor(w,N,j,V){this.type=w,this.id=N,this.ack=j,this.data=V,this.writtenTime=0}get size(){return this.data.byteLength}}class h extends R.Disposable{constructor(w){super(),this.f=this.B(new l.Emitter),this.onMessage=this.f.event,this.g={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this.a=w,this.b=!1,this.c=new v,this.B(this.a.onData(N=>this.acceptChunk(N))),this.lastReadTime=Date.now()}acceptChunk(w){if(!(!w||w.byteLength===0))for(this.lastReadTime=Date.now(),this.c.acceptChunk(w);this.c.byteLength>=this.g.readLen;){const N=this.c.read(this.g.readLen);if(this.g.readHead)this.g.readHead=!1,this.g.readLen=N.readUInt32BE(9),this.g.messageType=N.readUInt8(0),this.g.id=N.readUInt32BE(1),this.g.ack=N.readUInt32BE(5),this.a.traceSocketEvent("protocolHeaderRead",{messageType:D(this.g.messageType),id:this.g.id,ack:this.g.ack,messageSize:this.g.readLen});else{const j=this.g.messageType,V=this.g.id,Q=this.g.ack;if(this.g.readHead=!0,this.g.readLen=13,this.g.messageType=0,this.g.id=0,this.g.ack=0,this.a.traceSocketEvent("protocolMessageRead",N),this.f.fire(new u(j,V,Q,N)),this.b)break}}}readEntireBuffer(){return this.c.read(this.c.byteLength)}dispose(){this.b=!0,super.dispose()}}class p{constructor(w){this.k=null,this.a=!1,this.b=!1,this.c=w,this.d=[],this.f=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this.a=!0}drain(){return this.flush(),this.c.drain()}flush(){this.m()}pause(){this.b=!0}resume(){this.b=!1,this.l()}write(w){if(this.a)return;w.writtenTime=Date.now(),this.lastWriteTime=Date.now();const N=L.VSBuffer.alloc(13);N.writeUInt8(w.type,0),N.writeUInt32BE(w.id,1),N.writeUInt32BE(w.ack,5),N.writeUInt32BE(w.data.byteLength,9),this.c.traceSocketEvent("protocolHeaderWrite",{messageType:D(w.type),id:w.id,ack:w.ack,messageSize:w.data.byteLength}),this.c.traceSocketEvent("protocolMessageWrite",w.data),this.j(N,w.data)}g(w,N){const j=this.f===0;return this.d.push(w,N),this.f+=w.byteLength+N.byteLength,j}h(){const w=L.VSBuffer.concat(this.d,this.f);return this.d.length=0,this.f=0,w}j(w,N){this.g(w,N)&&this.l()}l(){this.k||(this.k=setTimeout(()=>{this.k=null,this.m()}))}m(){if(this.f===0||this.b)return;const w=this.h();this.c.traceSocketEvent("protocolWrite",{byteLength:w.byteLength}),this.c.write(w)}}class b extends R.Disposable{constructor(w){super(),this.f=new l.Emitter,this.onMessage=this.f.event,this.g=new l.Emitter,this.onDidDispose=this.g.event,this.a=w,this.b=this.B(new p(this.a)),this.c=this.B(new h(this.a)),this.B(this.c.onMessage(N=>{N.type===1&&this.f.fire(N.data)})),this.B(this.a.onClose(()=>this.g.fire()))}drain(){return this.b.drain()}getSocket(){return this.a}sendDisconnect(){}send(w){this.b.write(new u(1,0,0,w))}}e.Protocol=b;class C extends S.IPCClient{static fromSocket(w,N){return new C(new b(w),N)}get onDidDispose(){return this.b.onDidDispose}constructor(w,N,j=null){super(w,N,j),this.b=w}dispose(){super.dispose();const w=this.b.getSocket();this.b.sendDisconnect(),this.b.dispose(),w.end()}}e.Client=C;class g{constructor(){this.b=!1,this.c=!1,this.d=[],this.a=new l.Emitter({onWillAddFirstListener:()=>{this.b=!0,queueMicrotask(()=>this.f())},onDidRemoveLastListener:()=>{this.b=!1}}),this.event=this.a.event}f(){if(!this.c){for(this.c=!0;this.b&&this.d.length>0;)this.a.fire(this.d.shift());this.c=!1}}fire(w){this.b?this.d.length>0?this.d.push(w):this.a.fire(w):this.d.push(w)}flushBuffer(){this.d=[]}}e.BufferedEmitter=g;class i{constructor(w){this.data=w,this.next=null}}class s{constructor(){this.a=null,this.b=null}length(){let w=0,N=this.a;for(;N;)N=N.next,w++;return w}peek(){return this.a?this.a.data:null}toArray(){const w=[];let N=0,j=this.a;for(;j;)w[N++]=j.data,j=j.next;return w}pop(){if(!!this.a){if(this.a===this.b){this.a=null,this.b=null;return}this.a=this.a.next}}push(w){const N=new i(w);if(!this.a){this.a=N,this.b=N;return}this.b.next=N,this.b=N}}class r{static getInstance(){return r.b||(r.b=new r),r.b}constructor(){this.c=[];const w=Date.now();for(let N=0;N<r.a;N++)this.c[N]=w-1e3*N;setInterval(()=>{for(let N=r.a;N>=1;N--)this.c[N]=this.c[N-1];this.c[0]=Date.now()},1e3)}d(){const w=Date.now(),N=(1+r.a)*1e3;let j=0;for(let V=0;V<r.a;V++)w-this.c[V]<=N&&j++;return 1-j/r.a}hasHighLoad(){return this.d()>=.5}}r.a=10,r.b=null;var o;(function(E){E[E.Good=0]="Good",E[E.Poor=1]="Poor"})(o=e.ConnectionHealth||(e.ConnectionHealth={}));function c(E){switch(E){case 0:return"good";case 1:return"poor"}}e.connectionHealthToString=c;class m{constructor(w){this.connectionHealth=w}}e.ConnectionHealthChangedEvent=m;class n{constructor(w,N){this.roundTripTime=w,this.recentHighRoundTripCount=N}}e.HighRoundTripTimeEvent=n;class t{get unacknowledgedCount(){return this.c-this.d}constructor(w){this.x=new g,this.onControlMessage=this.x.event,this.y=new g,this.onMessage=this.y.event,this.z=new g,this.onDidDispose=this.z.event,this.A=new g,this.onSocketClose=this.A.event,this.B=new g,this.onSocketTimeout=this.B.event,this.C=new g,this.onHighRoundTripTime=this.C.event,this.D=new g,this.onDidChangeConnectionHealth=this.D.event,this.u=w.loadEstimator??r.getInstance(),this.v=w.measureRoundTripTime??!1,this.w=w.sendKeepAlive??!0,this.a=!1,this.b=new s,this.c=0,this.d=0,this.f=null,this.g=0,this.h=0,this.j=0,this.k=null,this.m=0,this.n=Date.now(),this.t=new R.DisposableStore,this.o=w.socket,this.p=this.t.add(new p(this.o)),this.q=this.t.add(new h(this.o)),this.t.add(this.q.onMessage(N=>this.E(N))),this.t.add(this.o.onClose(N=>this.A.fire(N))),this.r=this.t.add(new d),this.t.add(this.r.onSendLatencyRequest(N=>this.J(N))),this.t.add(this.r.onHighRoundTripTime(N=>this.C.fire(N))),this.t.add(this.r.onDidChangeConnectionHealth(N=>this.D.fire(N))),this.v&&this.r.start(),w.initialChunk&&this.q.acceptChunk(w.initialChunk),this.w?this.l=setInterval(()=>{this.I()},5e3):this.l=null}dispose(){this.f&&(clearTimeout(this.f),this.f=null),this.k&&(clearTimeout(this.k),this.k=null),this.l&&(clearInterval(this.l),this.l=null),this.t.dispose()}drain(){return this.p.drain()}sendDisconnect(){const w=new u(5,0,0,P());this.p.write(w),this.p.flush()}sendPause(){const w=new u(7,0,0,P());this.p.write(w)}sendResume(){const w=new u(8,0,0,P());this.p.write(w)}pauseSocketWriting(){this.p.pause()}getSocket(){return this.o}getMillisSinceLastIncomingData(){return Date.now()-this.q.lastReadTime}beginAcceptReconnection(w,N){this.a=!0,this.t.dispose(),this.t=new R.DisposableStore,this.x.flushBuffer(),this.A.flushBuffer(),this.B.flushBuffer(),this.o.dispose(),this.m=0,this.n=Date.now(),this.o=w,this.p=this.t.add(new p(this.o)),this.q=this.t.add(new h(this.o)),this.t.add(this.q.onMessage(j=>this.E(j))),this.t.add(this.o.onClose(j=>this.A.fire(j))),this.r=this.t.add(new d),this.t.add(this.r.onSendLatencyRequest(j=>this.J(j))),this.t.add(this.r.onHighRoundTripTime(j=>this.C.fire(j))),this.t.add(this.r.onDidChangeConnectionHealth(j=>this.D.fire(j))),this.q.acceptChunk(N)}endAcceptReconnection(){this.a=!1,this.v&&this.r.start(),this.h=this.g;const w=new u(3,0,this.h,P());this.p.write(w);const N=this.b.toArray();for(let j=0,V=N.length;j<V;j++)this.p.write(N[j]);this.G()}acceptDisconnect(){this.z.fire()}E(w){if(w.ack>this.d){this.d=w.ack;do{const N=this.b.peek();if(N&&N.id<=w.ack)this.b.pop();else break}while(!0)}switch(w.type){case 0:break;case 1:{if(w.id>this.g)if(w.id!==this.g+1){const N=Date.now();N-this.m>1e4&&(this.m=N,this.p.write(new u(6,0,0,P())))}else this.g=w.id,this.j=Date.now(),this.F(),this.y.fire(w.data);break}case 2:{this.x.fire(w.data);break}case 3:break;case 5:{this.z.fire();break}case 6:{const N=this.b.toArray();for(let j=0,V=N.length;j<V;j++)this.p.write(N[j]);this.G();break}case 7:{this.p.pause();break}case 8:{this.p.resume();break}case 9:break;case 10:{this.K(w.data);break}case 11:{this.r.handleResponse(w.data);break}}}readEntireBuffer(){return this.q.readEntireBuffer()}flush(){this.p.flush()}send(w){const N=++this.c;this.h=this.g;const j=new u(1,N,this.h,w);this.b.push(j),this.a||(this.p.write(j),this.G())}sendControl(w){const N=new u(2,0,0,w);this.p.write(N)}F(){if(this.g<=this.h||this.k)return;const w=Date.now()-this.j;if(w>=2e3){this.H();return}this.k=setTimeout(()=>{this.k=null,this.F()},2e3-w+5)}G(){if(this.c<=this.d||this.f||this.a)return;const w=this.b.peek(),N=Date.now()-w.writtenTime,j=Date.now()-this.q.lastReadTime,V=Date.now()-this.n;if(N>=2e4&&j>=2e4&&V>=2e4&&!this.u.hasHighLoad()){this.n=Date.now(),this.B.fire({unacknowledgedMsgCount:this.b.length(),timeSinceOldestUnacknowledgedMsg:N,timeSinceLastReceivedSomeData:j});return}const Q=Math.max(2e4-N,2e4-j,2e4-V,500);this.f=setTimeout(()=>{this.f=null,this.G()},Q)}H(){if(this.g<=this.h)return;this.h=this.g;const w=new u(3,0,this.h,P());this.p.write(w)}I(){this.h=this.g;const w=new u(9,0,this.h,P());this.p.write(w)}J(w){this.h=this.g;const N=new u(10,0,this.h,w);this.p.write(N)}K(w){this.h=this.g;const N=new u(11,0,this.h,w);this.p.write(N)}}e.PersistentProtocol=t;class d extends R.Disposable{constructor(){super(),this.a=this.B(new l.Emitter),this.onSendLatencyRequest=this.a.event,this.b=this.B(new l.Emitter),this.onHighRoundTripTime=this.b.event,this.c=this.B(new l.Emitter),this.onDidChangeConnectionHealth=this.c.event,this.f=this.B(new a.IntervalTimer),this.g=-1,this.h=0,this.j=Array.from({length:5},w=>0),this.k=0,this.l=0}start(){this.f.cancelAndSet(()=>{this.g=Date.now();const w=++this.h,N=L.VSBuffer.alloc(4);N.writeUInt32BE(w,0),this.a.fire(N)},6e4)}handleResponse(w){if(w.byteLength!==4)return;const N=w.readUInt32BE(0);if(this.g<=0||N!==this.h)return;const j=Date.now()-this.g,V=this.k++;this.j[V%this.j.length]=j;const Q=this.l,x=this.j.filter(U=>U>=1e3).length;this.l=x>=3?1:0,j>1e3&&this.b.fire(new n(j,x)),Q!==this.l&&this.c.fire(this.l)}}}),define(ye[116],De([1,0,22,11,3,6,9,12,30,114,115]),function(re,e,a,L,l,R,S,A,y,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function P(){return{crypto:globalThis._VSCODE_NODE_MODULES.crypto,zlib:globalThis._VSCODE_NODE_MODULES.zlib,net:globalThis._VSCODE_NODE_MODULES.net,os:globalThis._VSCODE_NODE_MODULES.os}}class v{traceSocketEvent(n,t){O.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,n,t)}constructor(n,t=""){this.f=!0,this.debugLabel=t,this.socket=n,this.traceSocketEvent("created",{type:"NodeSocket"}),this.a=d=>{if(this.traceSocketEvent("error",{code:d?.code,message:d?.message}),d){if(d.code==="EPIPE")return;(0,L.onUnexpectedError)(d)}},this.socket.on("error",this.a),this.b=d=>{this.traceSocketEvent("close",{hadError:d}),this.f=!1},this.socket.on("close",this.b),this.d=()=>{this.traceSocketEvent("nodeEndReceived"),this.f=!1},this.socket.on("end",this.d)}dispose(){this.socket.off("error",this.a),this.socket.off("close",this.b),this.socket.off("end",this.d),this.socket.destroy()}onData(n){const t=d=>{this.traceSocketEvent("read",d),n(a.VSBuffer.wrap(d))};return this.socket.on("data",t),{dispose:()=>this.socket.off("data",t)}}onClose(n){const t=d=>{n({type:0,hadError:d,error:void 0})};return this.socket.on("close",t),{dispose:()=>this.socket.off("close",t)}}onEnd(n){const t=()=>{n()};return this.socket.on("end",t),{dispose:()=>this.socket.off("end",t)}}write(n){if(!(this.socket.destroyed||!this.f))try{this.traceSocketEvent("write",n),this.socket.write(n.buffer,t=>{if(t){if(t.code==="EPIPE")return;(0,L.onUnexpectedError)(t)}})}catch(t){if(t.code==="EPIPE")return;(0,L.onUnexpectedError)(t)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((n,t)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),n();return}const d=()=>{this.socket.off("close",d),this.socket.off("end",d),this.socket.off("error",d),this.socket.off("timeout",d),this.socket.off("drain",d),this.traceSocketEvent("nodeDrainEnd"),n()};this.socket.on("close",d),this.socket.on("end",d),this.socket.on("error",d),this.socket.on("timeout",d),this.socket.on("drain",d)})}}e.NodeSocket=v;var k;(function(m){m[m.MinHeaderByteSize=2]="MinHeaderByteSize",m[m.MaxWebSocketMessageLength=262144]="MaxWebSocketMessageLength"})(k||(k={}));var D;(function(m){m[m.PeekHeader=1]="PeekHeader",m[m.ReadHeader=2]="ReadHeader",m[m.ReadBody=3]="ReadBody",m[m.Fin=4]="Fin"})(D||(D={}));class f extends R.Disposable{get permessageDeflate(){return this.a.permessageDeflate}get recordedInflateBytes(){return this.a.recordedInflateBytes}traceSocketEvent(n,t){this.socket.traceSocketEvent(n,t)}constructor(n,t,d,E){super(),this.f=this.B(new l.Emitter),this.g=this.B(new l.Emitter),this.h=!1,this.j={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=n,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:t,inflateBytesLength:d?.byteLength||0,recordInflateBytes:E}),this.a=this.B(new u(this,t,d,E,this.f,(w,N)=>this.k(w,N))),this.B(this.a.onError(w=>{console.error(w),(0,L.onUnexpectedError)(w),this.g.fire({type:0,hadError:!0,error:w})})),this.b=new O.ChunkStream,this.B(this.socket.onData(w=>this.l(w))),this.B(this.socket.onClose(async w=>{this.a.isProcessingReadQueue()&&await l.Event.toPromise(this.a.onDidFinishProcessingReadQueue),this.g.fire(w)}))}dispose(){this.a.isProcessingWriteQueue()?this.B(this.a.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(n){return this.f.event(n)}onClose(n){return this.g.event(n)}onEnd(n){return this.socket.onEnd(n)}write(n){let t=0;for(;t<n.byteLength;)this.a.writeMessage(n.slice(t,Math.min(t+262144,n.byteLength))),t+=262144}k(n,t){if(this.h)return;this.traceSocketEvent("webSocketNodeSocketWrite",n);let d=2;n.byteLength<126?d+=0:n.byteLength<2**16?d+=2:d+=8;const E=a.VSBuffer.alloc(d);if(t?E.writeUInt8(194,0):E.writeUInt8(130,0),n.byteLength<126)E.writeUInt8(n.byteLength,1);else if(n.byteLength<2**16){E.writeUInt8(126,1);let w=1;E.writeUInt8(n.byteLength>>>8&255,++w),E.writeUInt8(n.byteLength>>>0&255,++w)}else{E.writeUInt8(127,1);let w=1;E.writeUInt8(0,++w),E.writeUInt8(0,++w),E.writeUInt8(0,++w),E.writeUInt8(0,++w),E.writeUInt8(n.byteLength>>>24&255,++w),E.writeUInt8(n.byteLength>>>16&255,++w),E.writeUInt8(n.byteLength>>>8&255,++w),E.writeUInt8(n.byteLength>>>0&255,++w)}this.socket.write(a.VSBuffer.concat([E,n]))}end(){this.h=!0,this.socket.end()}l(n){if(n.byteLength!==0){for(this.b.acceptChunk(n);this.b.byteLength>=this.j.readLen;)if(this.j.state===1){const t=this.b.peek(this.j.readLen),d=t.readUInt8(0),E=(d&128)>>>7,w=(d&64)>>>6,N=t.readUInt8(1),j=(N&128)>>>7,V=N&127;this.j.state=2,this.j.readLen=2+(j?4:0)+(V===126?2:0)+(V===127?8:0),this.j.fin=E,this.j.firstFrameOfMessage&&(this.j.compressed=Boolean(w)),this.j.firstFrameOfMessage=Boolean(E),this.j.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin})}else if(this.j.state===2){const t=this.b.read(this.j.readLen),d=t.readUInt8(1),E=(d&128)>>>7;let w=d&127,N=1;w===126?w=t.readUInt8(++N)*2**8+t.readUInt8(++N):w===127&&(w=t.readUInt8(++N)*0+t.readUInt8(++N)*0+t.readUInt8(++N)*0+t.readUInt8(++N)*0+t.readUInt8(++N)*2**24+t.readUInt8(++N)*2**16+t.readUInt8(++N)*2**8+t.readUInt8(++N));let j=0;E&&(j=t.readUInt8(++N)*2**24+t.readUInt8(++N)*2**16+t.readUInt8(++N)*2**8+t.readUInt8(++N)),this.j.state=3,this.j.readLen=w,this.j.mask=j,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this.j.readLen,compressed:this.j.compressed,fin:this.j.fin,mask:this.j.mask})}else if(this.j.state===3){const t=this.b.read(this.j.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",t),b(t,this.j.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",t),this.j.state=1,this.j.readLen=2,this.j.mask=0,this.a.acceptFrame(t,this.j.compressed,!!this.j.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this.a.isProcessingWriteQueue()&&await l.Event.toPromise(this.a.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=f;class u extends R.Disposable{get permessageDeflate(){return Boolean(this.b&&this.f)}get recordedInflateBytes(){return this.b?this.b.recordedInflateBytes:a.VSBuffer.alloc(0)}constructor(n,t,d,E,w,N){super(),this.l=n,this.m=w,this.n=N,this.a=this.B(new l.Emitter),this.onError=this.a.event,this.g=[],this.h=[],this.j=this.B(new l.Emitter),this.onDidFinishProcessingReadQueue=this.j.event,this.k=this.B(new l.Emitter),this.onDidFinishProcessingWriteQueue=this.k.event,this.p=!1,this.t=!1,t?(this.b=this.B(new h(this.l,E,d,{windowBits:15})),this.f=this.B(new p(this.l,{windowBits:15})),this.B(this.b.onError(j=>this.a.fire(j))),this.B(this.f.onError(j=>this.a.fire(j)))):(this.b=null,this.f=null)}writeMessage(n){this.g.push(n),this.r()}async r(){if(!this.p){for(this.p=!0;this.g.length>0;){const n=this.g.shift();if(this.f){const t=await this.s(this.f,n);this.n(t,!0)}else this.n(n,!1)}this.p=!1,this.k.fire()}}isProcessingWriteQueue(){return this.p}s(n,t){return new Promise((d,E)=>{n.write(t),n.flush(w=>d(w))})}acceptFrame(n,t,d){this.h.push({data:n,isCompressed:t,isLastFrameOfMessage:d}),this.u()}async u(){if(!this.t){for(this.t=!0;this.h.length>0;){const n=this.h.shift();if(this.b&&n.isCompressed){const t=await this.w(this.b,n.data,n.isLastFrameOfMessage);this.m.fire(t)}else this.m.fire(n.data)}this.t=!1,this.j.fire()}}isProcessingReadQueue(){return this.t}w(n,t,d){return new Promise((E,w)=>{n.write(t),d&&n.write(a.VSBuffer.fromByteArray([0,0,255,255])),n.flush(N=>E(N))})}}class h extends R.Disposable{get recordedInflateBytes(){return this.j?a.VSBuffer.concat(this.f):a.VSBuffer.alloc(0)}constructor(n,t,d,E){super(),this.h=n,this.j=t,this.a=this.B(new l.Emitter),this.onError=this.a.event,this.f=[],this.g=[],this.b=P().zlib.createInflateRaw(E),this.b.on("error",w=>{this.h.traceSocketEvent("zlibInflateError",{message:w?.message,code:w?.code}),this.a.fire(w)}),this.b.on("data",w=>{this.h.traceSocketEvent("zlibInflateData",w),this.g.push(a.VSBuffer.wrap(w))}),d&&(this.h.traceSocketEvent("zlibInflateInitialWrite",d.buffer),this.b.write(d.buffer),this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateInitialFlushFired"),this.g.length=0}))}write(n){this.j&&this.f.push(n.clone()),this.h.traceSocketEvent("zlibInflateWrite",n),this.b.write(n.buffer)}flush(n){this.b.flush(()=>{this.h.traceSocketEvent("zlibInflateFlushFired");const t=a.VSBuffer.concat(this.g);this.g.length=0,n(t)})}}class p extends R.Disposable{constructor(n,t){super(),this.g=n,this.a=this.B(new l.Emitter),this.onError=this.a.event,this.f=[],this.b=P().zlib.createDeflateRaw({windowBits:15}),this.b.on("error",d=>{this.g.traceSocketEvent("zlibDeflateError",{message:d?.message,code:d?.code}),this.a.fire(d)}),this.b.on("data",d=>{this.g.traceSocketEvent("zlibDeflateData",d),this.f.push(a.VSBuffer.wrap(d))})}write(n){this.g.traceSocketEvent("zlibDeflateWrite",n.buffer),this.b.write(n.buffer)}flush(n){this.b.flush(2,()=>{this.g.traceSocketEvent("zlibDeflateFlushFired");let t=a.VSBuffer.concat(this.f);this.f.length=0,t=t.slice(0,t.byteLength-4),n(t)})}}function b(m,n){if(n===0)return;const t=m.byteLength>>>2;for(let V=0;V<t;V++){const Q=m.readUInt32BE(V*4);m.writeUInt32BE(Q^n,V*4)}const d=t*4,E=m.byteLength-d,w=n>>>24&255,N=n>>>16&255,j=n>>>8&255;E>=1&&m.writeUInt8(m.readUInt8(d)^w,d),E>=2&&m.writeUInt8(m.readUInt8(d+1)^N,d+1),E>=3&&m.writeUInt8(m.readUInt8(d+2)^j,d+2)}e.XDG_RUNTIME_DIR=typeof process<"u"?process.env.XDG_RUNTIME_DIR:void 0;const C={[2]:107,[1]:103};function g(){const m=(0,y.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${m}-sock`;let n;return e.XDG_RUNTIME_DIR?n=(0,S.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${m}.sock`):n=(0,S.join)(P().os.tmpdir(),`vscode-ipc-${m}.sock`),s(n),n}e.createRandomIPCHandle=g;function i(m,n,t){const d=P().crypto.createHash("md5").update(m).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${d}-${t}-${n}-sock`;const E=t.substr(0,4),w=n.substr(0,6),N=d.substr(0,8);let j;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?j=(0,S.join)(e.XDG_RUNTIME_DIR,`vscode-${N}-${E}-${w}.sock`):j=(0,S.join)(m,`${E}-${w}.sock`),s(j),j}e.createStaticIPCHandle=i;function s(m){const n=C[A.platform];typeof n=="number"&&m.length>=n&&console.warn(`WARNING: IPC handle "${m}" is longer than ${n} chars, try a shorter --user-data-dir`)}class r extends I.IPCServer{static b(n){const t=l.Event.fromNodeEventEmitter(n,"connection");return l.Event.map(t,d=>({protocol:new O.Protocol(new v(d,"ipc-server-connection")),onDidClientDisconnect:l.Event.once(l.Event.fromNodeEventEmitter(d,"close"))}))}constructor(n){super(r.b(n)),this.d=n}dispose(){super.dispose(),this.d&&(this.d.close(),this.d=null)}}e.Server=r;function o(m){return new Promise((n,t)=>{const d=P().net.createServer();d.on("error",t),d.listen(m,()=>{d.removeListener("error",t),n(new r(d))})})}e.serve=o;function c(m,n){return new Promise((t,d)=>{const E=P().net.createConnection(m,()=>{E.removeListener("error",d),t(O.Client.fromSocket(new v(E,`ipc-client${n}`),n))});E.once("error",d)})}e.connect=c}),define(ye[117],De([1,0,108]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CharacterSet=e.CharacterClassifier=void 0;class L{constructor(A){const y=(0,a.toUint8)(A);this.c=y,this.a=L.d(y),this.b=new Map}static d(A){const y=new Uint8Array(256);return y.fill(A),y}set(A,y){const I=(0,a.toUint8)(y);A>=0&&A<256?this.a[A]=I:this.b.set(A,I)}get(A){return A>=0&&A<256?this.a[A]:this.b.get(A)||this.c}clear(){this.a.fill(this.c),this.b.clear()}}e.CharacterClassifier=L;var l;(function(S){S[S.False=0]="False",S[S.True=1]="True"})(l||(l={}));class R{constructor(){this.a=new L(0)}add(A){this.a.set(A,1)}has(A){return this.a.get(A)===1}clear(){return this.a.clear()}}e.CharacterSet=R}),define(ye[53],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class a{constructor(l,R){this.lineNumber=l,this.column=R}with(l=this.lineNumber,R=this.column){return l===this.lineNumber&&R===this.column?this:new a(l,R)}delta(l=0,R=0){return this.with(this.lineNumber+l,this.column+R)}equals(l){return a.equals(this,l)}static equals(l,R){return!l&&!R?!0:!!l&&!!R&&l.lineNumber===R.lineNumber&&l.column===R.column}isBefore(l){return a.isBefore(this,l)}static isBefore(l,R){return l.lineNumber<R.lineNumber?!0:R.lineNumber<l.lineNumber?!1:l.column<R.column}isBeforeOrEqual(l){return a.isBeforeOrEqual(this,l)}static isBeforeOrEqual(l,R){return l.lineNumber<R.lineNumber?!0:R.lineNumber<l.lineNumber?!1:l.column<=R.column}static compare(l,R){const S=l.lineNumber|0,A=R.lineNumber|0;if(S===A){const y=l.column|0,I=R.column|0;return y-I}return S-A}clone(){return new a(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(l){return new a(l.lineNumber,l.column)}static isIPosition(l){return l&&typeof l.lineNumber=="number"&&typeof l.column=="number"}}e.Position=a}),define(ye[33],De([1,0,53]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class L{constructor(R,S,A,y){R>A||R===A&&S>y?(this.startLineNumber=A,this.startColumn=y,this.endLineNumber=R,this.endColumn=S):(this.startLineNumber=R,this.startColumn=S,this.endLineNumber=A,this.endColumn=y)}isEmpty(){return L.isEmpty(this)}static isEmpty(R){return R.startLineNumber===R.endLineNumber&&R.startColumn===R.endColumn}containsPosition(R){return L.containsPosition(this,R)}static containsPosition(R,S){return!(S.lineNumber<R.startLineNumber||S.lineNumber>R.endLineNumber||S.lineNumber===R.startLineNumber&&S.column<R.startColumn||S.lineNumber===R.endLineNumber&&S.column>R.endColumn)}static strictContainsPosition(R,S){return!(S.lineNumber<R.startLineNumber||S.lineNumber>R.endLineNumber||S.lineNumber===R.startLineNumber&&S.column<=R.startColumn||S.lineNumber===R.endLineNumber&&S.column>=R.endColumn)}containsRange(R){return L.containsRange(this,R)}static containsRange(R,S){return!(S.startLineNumber<R.startLineNumber||S.endLineNumber<R.startLineNumber||S.startLineNumber>R.endLineNumber||S.endLineNumber>R.endLineNumber||S.startLineNumber===R.startLineNumber&&S.startColumn<R.startColumn||S.endLineNumber===R.endLineNumber&&S.endColumn>R.endColumn)}strictContainsRange(R){return L.strictContainsRange(this,R)}static strictContainsRange(R,S){return!(S.startLineNumber<R.startLineNumber||S.endLineNumber<R.startLineNumber||S.startLineNumber>R.endLineNumber||S.endLineNumber>R.endLineNumber||S.startLineNumber===R.startLineNumber&&S.startColumn<=R.startColumn||S.endLineNumber===R.endLineNumber&&S.endColumn>=R.endColumn)}plusRange(R){return L.plusRange(this,R)}static plusRange(R,S){let A,y,I,O;return S.startLineNumber<R.startLineNumber?(A=S.startLineNumber,y=S.startColumn):S.startLineNumber===R.startLineNumber?(A=S.startLineNumber,y=Math.min(S.startColumn,R.startColumn)):(A=R.startLineNumber,y=R.startColumn),S.endLineNumber>R.endLineNumber?(I=S.endLineNumber,O=S.endColumn):S.endLineNumber===R.endLineNumber?(I=S.endLineNumber,O=Math.max(S.endColumn,R.endColumn)):(I=R.endLineNumber,O=R.endColumn),new L(A,y,I,O)}intersectRanges(R){return L.intersectRanges(this,R)}static intersectRanges(R,S){let A=R.startLineNumber,y=R.startColumn,I=R.endLineNumber,O=R.endColumn;const P=S.startLineNumber,v=S.startColumn,k=S.endLineNumber,D=S.endColumn;return A<P?(A=P,y=v):A===P&&(y=Math.max(y,v)),I>k?(I=k,O=D):I===k&&(O=Math.min(O,D)),A>I||A===I&&y>O?null:new L(A,y,I,O)}equalsRange(R){return L.equalsRange(this,R)}static equalsRange(R,S){return!R&&!S?!0:!!R&&!!S&&R.startLineNumber===S.startLineNumber&&R.startColumn===S.startColumn&&R.endLineNumber===S.endLineNumber&&R.endColumn===S.endColumn}getEndPosition(){return L.getEndPosition(this)}static getEndPosition(R){return new a.Position(R.endLineNumber,R.endColumn)}getStartPosition(){return L.getStartPosition(this)}static getStartPosition(R){return new a.Position(R.startLineNumber,R.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(R,S){return new L(this.startLineNumber,this.startColumn,R,S)}setStartPosition(R,S){return new L(R,S,this.endLineNumber,this.endColumn)}collapseToStart(){return L.collapseToStart(this)}static collapseToStart(R){return new L(R.startLineNumber,R.startColumn,R.startLineNumber,R.startColumn)}collapseToEnd(){return L.collapseToEnd(this)}static collapseToEnd(R){return new L(R.endLineNumber,R.endColumn,R.endLineNumber,R.endColumn)}delta(R){return new L(this.startLineNumber+R,this.startColumn,this.endLineNumber+R,this.endColumn)}static fromPositions(R,S=R){return new L(R.lineNumber,R.column,S.lineNumber,S.column)}static lift(R){return R?new L(R.startLineNumber,R.startColumn,R.endLineNumber,R.endColumn):null}static isIRange(R){return R&&typeof R.startLineNumber=="number"&&typeof R.startColumn=="number"&&typeof R.endLineNumber=="number"&&typeof R.endColumn=="number"}static areIntersectingOrTouching(R,S){return!(R.endLineNumber<S.startLineNumber||R.endLineNumber===S.startLineNumber&&R.endColumn<S.startColumn||S.endLineNumber<R.startLineNumber||S.endLineNumber===R.startLineNumber&&S.endColumn<R.startColumn)}static areIntersecting(R,S){return!(R.endLineNumber<S.startLineNumber||R.endLineNumber===S.startLineNumber&&R.endColumn<=S.startColumn||S.endLineNumber<R.startLineNumber||S.endLineNumber===R.startLineNumber&&S.endColumn<=R.startColumn)}static compareRangesUsingStarts(R,S){if(R&&S){const I=R.startLineNumber|0,O=S.startLineNumber|0;if(I===O){const P=R.startColumn|0,v=S.startColumn|0;if(P===v){const k=R.endLineNumber|0,D=S.endLineNumber|0;if(k===D){const f=R.endColumn|0,u=S.endColumn|0;return f-u}return k-D}return P-v}return I-O}return(R?1:0)-(S?1:0)}static compareRangesUsingEnds(R,S){return R.endLineNumber===S.endLineNumber?R.endColumn===S.endColumn?R.startLineNumber===S.startLineNumber?R.startColumn-S.startColumn:R.startLineNumber-S.startLineNumber:R.endColumn-S.endColumn:R.endLineNumber-S.endLineNumber}static spansMultipleLines(R){return R.endLineNumber>R.startLineNumber}toJSON(){return this}}e.Range=L}),define(ye[152],De([1,0,53,33]),function(re,e,a,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Selection=e.SelectionDirection=void 0;var l;(function(S){S[S.LTR=0]="LTR",S[S.RTL=1]="RTL"})(l=e.SelectionDirection||(e.SelectionDirection={}));class R extends L.Range{constructor(A,y,I,O){super(A,y,I,O),this.selectionStartLineNumber=A,this.selectionStartColumn=y,this.positionLineNumber=I,this.positionColumn=O}toString(){return"["+this.selectionStartLineNumber+","+this.selectionStartColumn+" -> "+this.positionLineNumber+","+this.positionColumn+"]"}equalsSelection(A){return R.selectionsEqual(this,A)}static selectionsEqual(A,y){return A.selectionStartLineNumber===y.selectionStartLineNumber&&A.selectionStartColumn===y.selectionStartColumn&&A.positionLineNumber===y.positionLineNumber&&A.positionColumn===y.positionColumn}getDirection(){return this.selectionStartLineNumber===this.startLineNumber&&this.selectionStartColumn===this.startColumn?0:1}setEndPosition(A,y){return this.getDirection()===0?new R(this.startLineNumber,this.startColumn,A,y):new R(A,y,this.startLineNumber,this.startColumn)}getPosition(){return new a.Position(this.positionLineNumber,this.positionColumn)}getSelectionStart(){return new a.Position(this.selectionStartLineNumber,this.selectionStartColumn)}setStartPosition(A,y){return this.getDirection()===0?new R(A,y,this.endLineNumber,this.endColumn):new R(this.endLineNumber,this.endColumn,A,y)}static fromPositions(A,y=A){return new R(A.lineNumber,A.column,y.lineNumber,y.column)}static fromRange(A,y){return y===0?new R(A.startLineNumber,A.startColumn,A.endLineNumber,A.endColumn):new R(A.endLineNumber,A.endColumn,A.startLineNumber,A.startColumn)}static liftSelection(A){return new R(A.selectionStartLineNumber,A.selectionStartColumn,A.positionLineNumber,A.positionColumn)}static selectionsArrEqual(A,y){if(A&&!y||!A&&y)return!1;if(!A&&!y)return!0;if(A.length!==y.length)return!1;for(let I=0,O=A.length;I<O;I++)if(!this.selectionsEqual(A[I],y[I]))return!1;return!0}static isISelection(A){return A&&typeof A.selectionStartLineNumber=="number"&&typeof A.selectionStartColumn=="number"&&typeof A.positionLineNumber=="number"&&typeof A.positionColumn=="number"}static createWithDirection(A,y,I,O,P){return P===0?new R(A,y,I,O):new R(I,O,A,y)}}e.Selection=R}),define(ye[153],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(ye[154],De([1,0,117]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var L;(function(S){S[S.Regular=0]="Regular",S[S.Whitespace=1]="Whitespace",S[S.WordSeparator=2]="WordSeparator"})(L=e.WordCharacterClass||(e.WordCharacterClass={}));class l extends a.CharacterClassifier{constructor(A){super(0);for(let y=0,I=A.length;y<I;y++)this.set(A.charCodeAt(y),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=l;function R(S){const A={};return y=>(A.hasOwnProperty(y)||(A[y]=S(y)),A[y])}e.getMapForWordSeparators=R(S=>new l(S))}),define(ye[118],De([1,0,65,6,67]),function(re,e,a,L,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWordAtText=e.setDefaultGetWordAtTextConfig=e.ensureValidWordDefinition=e.DEFAULT_WORD_REGEXP=e.USUAL_WORD_SEPARATORS=void 0,e.USUAL_WORD_SEPARATORS="`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?";function R(P=""){let v="(-?\\d*\\.\\d\\w*)|([^";for(const k of e.USUAL_WORD_SEPARATORS)P.indexOf(k)>=0||(v+="\\"+k);return v+="\\s]+)",new RegExp(v,"g")}e.DEFAULT_WORD_REGEXP=R();function S(P){let v=e.DEFAULT_WORD_REGEXP;if(P&&P instanceof RegExp)if(P.global)v=P;else{let k="g";P.ignoreCase&&(k+="i"),P.multiline&&(k+="m"),P.unicode&&(k+="u"),v=new RegExp(P.source,k)}return v.lastIndex=0,v}e.ensureValidWordDefinition=S;const A=new l.LinkedList;A.unshift({maxLen:1e3,windowSize:15,timeBudget:150});function y(P){const v=A.unshift(P);return(0,L.toDisposable)(v)}e.setDefaultGetWordAtTextConfig=y;function I(P,v,k,D,f){if(f||(f=a.Iterable.first(A)),k.length>f.maxLen){let C=P-f.maxLen/2;return C<0?C=0:D+=C,k=k.substring(C,P+f.maxLen/2),I(P,v,k,D,f)}const u=Date.now(),h=P-1-D;let p=-1,b=null;for(let C=1;!(Date.now()-u>=f.timeBudget);C++){const g=h-f.windowSize*C;v.lastIndex=Math.max(0,g);const i=O(v,k,h,p);if(!i&&b||(b=i,g<=0))break;p=g}if(b){const C={word:b[0],startColumn:D+1+b.index,endColumn:D+1+b.index+b[0].length};return v.lastIndex=0,C}return null}e.getWordAtText=I;function O(P,v,k,D){let f;for(;f=P.exec(v);){const u=f.index||0;if(u<=k&&P.lastIndex>=k)return f;if(D>0&&u>D)return null}return null}}),define(ye[155],De([1,0,38,9]),function(re,e,a,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function l(R,S,A,y,I,O){if(Array.isArray(R)){let P=0;for(const v of R){const k=l(v,S,A,y,I,O);if(k===10)return k;k>P&&(P=k)}return P}else{if(typeof R=="string")return y?R==="*"?5:R===A?10:0:0;if(R){const{language:P,pattern:v,scheme:k,hasAccessToAllModels:D,notebookType:f}=R;if(!y&&!D)return 0;f&&I&&(S=I);let u=0;if(k)if(k===S.scheme)u=10;else if(k==="*")u=5;else return 0;if(P)if(P===A)u=10;else if(P==="*")u=Math.max(u,5);else return 0;if(f)if(f===O)u=10;else if(f==="*"&&O!==void 0)u=Math.max(u,5);else return 0;if(v){let h;if(typeof v=="string"?h=v:h={...v,base:(0,L.normalize)(v.base)},h===S.fsPath||(0,a.match)(h,S.fsPath))u=10;else return 0}return u}else return 0}}e.score=l}),define(ye[156],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var a;(function(S){S[S.None=0]="None",S[S.Indent=1]="Indent",S[S.IndentOutdent=2]="IndentOutdent",S[S.Outdent=3]="Outdent"})(a=e.IndentAction||(e.IndentAction={}));class L{constructor(A){if(this.e=null,this.f=!1,this.open=A.open,this.close=A.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(A.notIn))for(let y=0,I=A.notIn.length;y<I;y++)switch(A.notIn[y]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(A){switch(A){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(A,y){if(A.getTokenCount()===0)return!0;const I=A.findTokenIndexAtOffset(y-2),O=A.getStandardTokenType(I);return this.isOK(O)}g(A,y){for(let I=A;I<=y;I++){const O=String.fromCharCode(I);if(!this.open.includes(O)&&!this.close.includes(O))return O}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.StandardAutoClosingPairConditional=L;class l{constructor(A){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const y of A)R(this.autoClosingPairsOpenByStart,y.open.charAt(0),y),R(this.autoClosingPairsOpenByEnd,y.open.charAt(y.open.length-1),y),R(this.autoClosingPairsCloseByStart,y.close.charAt(0),y),R(this.autoClosingPairsCloseByEnd,y.close.charAt(y.close.length-1),y),y.close.length===1&&y.open.length===1&&R(this.autoClosingPairsCloseSingleChar,y.close,y)}}e.AutoClosingPairs=l;function R(S,A,y){S.has(A)?S.get(A).push(y):S.set(A,[y])}}),define(ye[157],De([1,0,117]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeLinks=e.LinkComputer=e.StateMachine=e.State=void 0;var L;(function(k){k[k.Invalid=0]="Invalid",k[k.Start=1]="Start",k[k.H=2]="H",k[k.HT=3]="HT",k[k.HTT=4]="HTT",k[k.HTTP=5]="HTTP",k[k.F=6]="F",k[k.FI=7]="FI",k[k.FIL=8]="FIL",k[k.BeforeColon=9]="BeforeColon",k[k.AfterColon=10]="AfterColon",k[k.AlmostThere=11]="AlmostThere",k[k.End=12]="End",k[k.Accept=13]="Accept",k[k.LastKnownState=14]="LastKnownState"})(L=e.State||(e.State={}));class l{constructor(D,f,u){const h=new Uint8Array(D*f);for(let p=0,b=D*f;p<b;p++)h[p]=u;this.a=h,this.rows=D,this.cols=f}get(D,f){return this.a[D*this.cols+f]}set(D,f,u){this.a[D*this.cols+f]=u}}class R{constructor(D){let f=0,u=0;for(let p=0,b=D.length;p<b;p++){const[C,g,i]=D[p];g>f&&(f=g),C>u&&(u=C),i>u&&(u=i)}f++,u++;const h=new l(u,f,0);for(let p=0,b=D.length;p<b;p++){const[C,g,i]=D[p];h.set(C,g,i)}this.a=h,this.b=f}nextState(D,f){return f<0||f>=this.b?0:this.a.get(D,f)}}e.StateMachine=R;let S=null;function A(){return S===null&&(S=new R([[1,104,2],[1,72,2],[1,102,6],[1,70,6],[2,116,3],[2,84,3],[3,116,4],[3,84,4],[4,112,5],[4,80,5],[5,115,9],[5,83,9],[5,58,10],[6,105,7],[6,73,7],[7,108,8],[7,76,8],[8,101,9],[8,69,9],[9,58,10],[10,47,11],[11,47,12]])),S}var y;(function(k){k[k.None=0]="None",k[k.ForceTermination=1]="ForceTermination",k[k.CannotEndIn=2]="CannotEndIn"})(y||(y={}));let I=null;function O(){if(I===null){I=new a.CharacterClassifier(0);const k=` 	<>'"\u3001\u3002\uFF61\uFF64\uFF0C\uFF0E\uFF1A\uFF1B\u2018\u3008\u300C\u300E\u3014\uFF08\uFF3B\uFF5B\uFF62\uFF63\uFF5D\uFF3D\uFF09\u3015\u300F\u300D\u3009\u2019\uFF40\uFF5E\u2026`;for(let f=0;f<k.length;f++)I.set(k.charCodeAt(f),1);const D=".,;:";for(let f=0;f<D.length;f++)I.set(D.charCodeAt(f),2)}return I}class P{static a(D,f,u,h,p){let b=p-1;do{const C=f.charCodeAt(b);if(D.get(C)!==2)break;b--}while(b>h);if(h>0){const C=f.charCodeAt(h-1),g=f.charCodeAt(b);(C===40&&g===41||C===91&&g===93||C===123&&g===125)&&b--}return{range:{startLineNumber:u,startColumn:h+1,endLineNumber:u,endColumn:b+2},url:f.substring(h,b+1)}}static computeLinks(D,f=A()){const u=O(),h=[];for(let p=1,b=D.getLineCount();p<=b;p++){const C=D.getLineContent(p),g=C.length;let i=0,s=0,r=0,o=1,c=!1,m=!1,n=!1,t=!1;for(;i<g;){let d=!1;const E=C.charCodeAt(i);if(o===13){let w;switch(E){case 40:c=!0,w=0;break;case 41:w=c?0:1;break;case 91:n=!0,m=!0,w=0;break;case 93:n=!1,w=m?0:1;break;case 123:t=!0,w=0;break;case 125:w=t?0:1;break;case 39:case 34:case 96:r===E?w=1:r===39||r===34||r===96?w=0:w=1;break;case 42:w=r===42?1:0;break;case 124:w=r===124?1:0;break;case 32:w=n?0:1;break;default:w=u.get(E)}w===1&&(h.push(P.a(u,C,p,s,i)),d=!0)}else if(o===12){let w;E===91?(m=!0,w=0):w=u.get(E),w===1?d=!0:o=13}else o=f.nextState(o,E),o===0&&(d=!0);d&&(o=1,c=!1,m=!1,t=!1,s=i+1,r=E),i++}o===13&&h.push(P.a(u,C,p,s,g))}return h}}e.LinkComputer=P;function v(k){return!k||typeof k.getLineCount!="function"||typeof k.getLineContent!="function"?[]:P.computeLinks(k)}e.computeLinks=v}),define(ye[119],De([1,0,23]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.ApplyEditsResult=e.SearchData=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.isITextSnapshot=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.InjectedTextCursorStops=e.MinimapPosition=e.OverviewRulerLane=void 0;var L;(function(b){b[b.Left=1]="Left",b[b.Center=2]="Center",b[b.Right=4]="Right",b[b.Full=7]="Full"})(L=e.OverviewRulerLane||(e.OverviewRulerLane={}));var l;(function(b){b[b.Inline=1]="Inline",b[b.Gutter=2]="Gutter"})(l=e.MinimapPosition||(e.MinimapPosition={}));var R;(function(b){b[b.Both=0]="Both",b[b.Right=1]="Right",b[b.Left=2]="Left",b[b.None=3]="None"})(R=e.InjectedTextCursorStops||(e.InjectedTextCursorStops={}));var S;(function(b){b[b.TextDefined=0]="TextDefined",b[b.LF=1]="LF",b[b.CRLF=2]="CRLF"})(S=e.EndOfLinePreference||(e.EndOfLinePreference={}));var A;(function(b){b[b.LF=1]="LF",b[b.CRLF=2]="CRLF"})(A=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var y;(function(b){b[b.LF=0]="LF",b[b.CRLF=1]="CRLF"})(y=e.EndOfLineSequence||(e.EndOfLineSequence={}));class I{get originalIndentSize(){return this.a?"tabSize":this.indentSize}constructor(C){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,C.tabSize|0),C.indentSize==="tabSize"?(this.indentSize=this.tabSize,this.a=!0):(this.indentSize=Math.max(1,C.indentSize|0),this.a=!1),this.insertSpaces=Boolean(C.insertSpaces),this.defaultEOL=C.defaultEOL|0,this.trimAutoWhitespace=Boolean(C.trimAutoWhitespace),this.bracketPairColorizationOptions=C.bracketPairColorizationOptions}equals(C){return this.tabSize===C.tabSize&&this.a===C.a&&this.indentSize===C.indentSize&&this.insertSpaces===C.insertSpaces&&this.defaultEOL===C.defaultEOL&&this.trimAutoWhitespace===C.trimAutoWhitespace&&(0,a.equals)(this.bracketPairColorizationOptions,C.bracketPairColorizationOptions)}createChangeEvent(C){return{tabSize:this.tabSize!==C.tabSize,indentSize:this.indentSize!==C.indentSize,insertSpaces:this.insertSpaces!==C.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==C.trimAutoWhitespace}}}e.TextModelResolvedOptions=I;class O{constructor(C,g){this._findMatchBrand=void 0,this.range=C,this.matches=g}}e.FindMatch=O;var P;(function(b){b[b.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",b[b.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",b[b.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",b[b.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(P=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));function v(b){return b&&typeof b.read=="function"}e.isITextSnapshot=v;var k;(function(b){b[b.Left=0]="Left",b[b.Right=1]="Right",b[b.None=2]="None",b[b.LeftOfInjectedText=3]="LeftOfInjectedText",b[b.RightOfInjectedText=4]="RightOfInjectedText"})(k=e.PositionAffinity||(e.PositionAffinity={}));var D;(function(b){b[b.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(D=e.ModelConstants||(e.ModelConstants={}));class f{constructor(C,g,i,s,r,o){this.identifier=C,this.range=g,this.text=i,this.forceMoveMarkers=s,this.isAutoWhitespaceEdit=r,this._isTracked=o}}e.ValidAnnotatedEditOperation=f;class u{constructor(C,g,i){this.regex=C,this.wordSeparators=g,this.simpleSearch=i}}e.SearchData=u;class h{constructor(C,g,i){this.reverseEdits=C,this.changes=g,this.trimAutoWhitespaceLineNumbers=i}}e.ApplyEditsResult=h;function p(b){return!b.isTooLargeForSyncing()&&!b.isForSimpleWidget}e.shouldSynchronizeModel=p}),define(ye[158],De([1,0,15,108]),function(re,e,a,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PrefixSumIndexOfResult=e.ConstantTimePrefixSumComputer=e.PrefixSumComputer=void 0;class l{constructor(y){this.a=y,this.b=new Uint32Array(y.length),this.c=new Int32Array(1),this.c[0]=-1}getCount(){return this.a.length}insertValues(y,I){y=(0,L.toUint32)(y);const O=this.a,P=this.b,v=I.length;return v===0?!1:(this.a=new Uint32Array(O.length+v),this.a.set(O.subarray(0,y),0),this.a.set(O.subarray(y),y+v),this.a.set(I,y),y-1<this.c[0]&&(this.c[0]=y-1),this.b=new Uint32Array(this.a.length),this.c[0]>=0&&this.b.set(P.subarray(0,this.c[0]+1)),!0)}setValue(y,I){return y=(0,L.toUint32)(y),I=(0,L.toUint32)(I),this.a[y]===I?!1:(this.a[y]=I,y-1<this.c[0]&&(this.c[0]=y-1),!0)}removeValues(y,I){y=(0,L.toUint32)(y),I=(0,L.toUint32)(I);const O=this.a,P=this.b;if(y>=O.length)return!1;const v=O.length-y;return I>=v&&(I=v),I===0?!1:(this.a=new Uint32Array(O.length-I),this.a.set(O.subarray(0,y),0),this.a.set(O.subarray(y+I),y),this.b=new Uint32Array(this.a.length),y-1<this.c[0]&&(this.c[0]=y-1),this.c[0]>=0&&this.b.set(P.subarray(0,this.c[0]+1)),!0)}getTotalSum(){return this.a.length===0?0:this.d(this.a.length-1)}getPrefixSum(y){return y<0?0:(y=(0,L.toUint32)(y),this.d(y))}d(y){if(y<=this.c[0])return this.b[y];let I=this.c[0]+1;I===0&&(this.b[0]=this.a[0],I++),y>=this.a.length&&(y=this.a.length-1);for(let O=I;O<=y;O++)this.b[O]=this.b[O-1]+this.a[O];return this.c[0]=Math.max(this.c[0],y),this.b[y]}getIndexOf(y){y=Math.floor(y),this.getTotalSum();let I=0,O=this.a.length-1,P=0,v=0,k=0;for(;I<=O;)if(P=I+(O-I)/2|0,v=this.b[P],k=v-this.a[P],y<k)O=P-1;else if(y>=v)I=P+1;else break;return new S(P,y-k)}}e.PrefixSumComputer=l;class R{constructor(y){this.a=y,this.b=!1,this.c=-1,this.d=[],this.e=[]}getTotalSum(){return this.g(),this.e.length}getPrefixSum(y){return this.g(),y===0?0:this.d[y-1]}getIndexOf(y){this.g();const I=this.e[y],O=I>0?this.d[I-1]:0;return new S(I,y-O)}removeValues(y,I){this.a.splice(y,I),this.f(y)}insertValues(y,I){this.a=(0,a.arrayInsert)(this.a,y,I),this.f(y)}f(y){this.b=!1,this.c=Math.min(this.c,y-1)}g(){if(!this.b){for(let y=this.c+1,I=this.a.length;y<I;y++){const O=this.a[y],P=y>0?this.d[y-1]:0;this.d[y]=P+O;for(let v=0;v<O;v++)this.e[P+v]=y}this.d.length=this.a.length,this.e.length=this.d[this.d.length-1],this.b=!0,this.c=this.a.length-1}}setValue(y,I){this.a[y]!==I&&(this.a[y]=I,this.f(y))}}e.ConstantTimePrefixSumComputer=R;class S{constructor(y,I){this.index=y,this.remainder=I,this._prefixSumIndexOfResultBrand=void 0,this.index=y,this.remainder=I}}e.PrefixSumIndexOfResult=S}),define(ye[159],De([1,0,8,53,158]),function(re,e,a,L,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MirrorTextModel=void 0;class R{constructor(A,y,I,O){this.c=A,this.d=y,this.f=I,this.g=O,this.h=null,this.j=null}dispose(){this.d.length=0}get version(){return this.g}getText(){return this.j===null&&(this.j=this.d.join(this.f)),this.j}onEvents(A){A.eol&&A.eol!==this.f&&(this.f=A.eol,this.h=null);const y=A.changes;for(const I of y)this.n(I.range),this.o(new L.Position(I.range.startLineNumber,I.range.startColumn),I.text);this.g=A.versionId,this.j=null}k(){if(!this.h){const A=this.f.length,y=this.d.length,I=new Uint32Array(y);for(let O=0;O<y;O++)I[O]=this.d[O].length+A;this.h=new l.PrefixSumComputer(I)}}l(A,y){this.d[A]=y,this.h&&this.h.setValue(A,this.d[A].length+this.f.length)}n(A){if(A.startLineNumber===A.endLineNumber){if(A.startColumn===A.endColumn)return;this.l(A.startLineNumber-1,this.d[A.startLineNumber-1].substring(0,A.startColumn-1)+this.d[A.startLineNumber-1].substring(A.endColumn-1));return}this.l(A.startLineNumber-1,this.d[A.startLineNumber-1].substring(0,A.startColumn-1)+this.d[A.endLineNumber-1].substring(A.endColumn-1)),this.d.splice(A.startLineNumber,A.endLineNumber-A.startLineNumber),this.h&&this.h.removeValues(A.startLineNumber,A.endLineNumber-A.startLineNumber)}o(A,y){if(y.length===0)return;const I=(0,a.splitLines)(y);if(I.length===1){this.l(A.lineNumber-1,this.d[A.lineNumber-1].substring(0,A.column-1)+I[0]+this.d[A.lineNumber-1].substring(A.column-1));return}I[I.length-1]+=this.d[A.lineNumber-1].substring(A.column-1),this.l(A.lineNumber-1,this.d[A.lineNumber-1].substring(0,A.column-1)+I[0]);const O=new Uint32Array(I.length-1);for(let P=1;P<I.length;P++)this.d.splice(A.lineNumber+P-1,0,I[P]),O[P-1]=I[P].length+this.f.length;this.h&&this.h.insertValues(A.lineNumber,O)}}e.MirrorTextModel=R}),define(ye[160],De([1,0,8,154,53,33,119]),function(re,e,a,L,l,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.isMultilineRegexSource=e.SearchParams=void 0;const A=999;class y{constructor(p,b,C,g){this.searchString=p,this.isRegex=b,this.matchCase=C,this.wordSeparators=g}parseSearchRequest(){if(this.searchString==="")return null;let p;this.isRegex?p=I(this.searchString):p=this.searchString.indexOf(`
`)>=0;let b=null;try{b=a.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:p,global:!0,unicode:!0})}catch{return null}if(!b)return null;let C=!this.isRegex&&!p;return C&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(C=this.matchCase),new S.SearchData(b,this.wordSeparators?(0,L.getMapForWordSeparators)(this.wordSeparators):null,C?this.searchString:null)}}e.SearchParams=y;function I(h){if(!h||h.length===0)return!1;for(let p=0,b=h.length;p<b;p++){const C=h.charCodeAt(p);if(C===10)return!0;if(C===92){if(p++,p>=b)break;const g=h.charCodeAt(p);if(g===110||g===114||g===87)return!0}}return!1}e.isMultilineRegexSource=I;function O(h,p,b){if(!b)return new S.FindMatch(h,null);const C=[];for(let g=0,i=p.length;g<i;g++)C[g]=p[g];return new S.FindMatch(h,C)}e.createFindMatch=O;class P{constructor(p){const b=[];let C=0;for(let g=0,i=p.length;g<i;g++)p.charCodeAt(g)===10&&(b[C++]=g);this.a=b}findLineFeedCountBeforeOffset(p){const b=this.a;let C=0,g=b.length-1;if(g===-1||p<=b[0])return 0;for(;C<g;){const i=C+((g-C)/2>>0);b[i]>=p?g=i-1:b[i+1]>=p?(C=i,g=i):C=i+1}return C+1}}class v{static findMatches(p,b,C,g,i){const s=b.parseSearchRequest();return s?s.regex.multiline?this.b(p,C,new u(s.wordSeparators,s.regex),g,i):this.c(p,C,s,g,i):[]}static a(p,b,C,g,i,s){let r,o=0;g?(o=g.findLineFeedCountBeforeOffset(i),r=b+i+o):r=b+i;let c;if(g){const d=g.findLineFeedCountBeforeOffset(i+s.length)-o;c=r+s.length+d}else c=r+s.length;const m=p.getPositionAt(r),n=p.getPositionAt(c);return new R.Range(m.lineNumber,m.column,n.lineNumber,n.column)}static b(p,b,C,g,i){const s=p.getOffsetAt(b.getStartPosition()),r=p.getValueInRange(b,1),o=p.getEOL()===`\r
`?new P(r):null,c=[];let m=0,n;for(C.reset(0);n=C.next(r);)if(c[m++]=O(this.a(p,s,r,o,n.index,n[0]),n,g),m>=i)return c;return c}static c(p,b,C,g,i){const s=[];let r=0;if(b.startLineNumber===b.endLineNumber){const c=p.getLineContent(b.startLineNumber).substring(b.startColumn-1,b.endColumn-1);return r=this.d(C,c,b.startLineNumber,b.startColumn-1,r,s,g,i),s}const o=p.getLineContent(b.startLineNumber).substring(b.startColumn-1);r=this.d(C,o,b.startLineNumber,b.startColumn-1,r,s,g,i);for(let c=b.startLineNumber+1;c<b.endLineNumber&&r<i;c++)r=this.d(C,p.getLineContent(c),c,0,r,s,g,i);if(r<i){const c=p.getLineContent(b.endLineNumber).substring(0,b.endColumn-1);r=this.d(C,c,b.endLineNumber,0,r,s,g,i)}return s}static d(p,b,C,g,i,s,r,o){const c=p.wordSeparators;if(!r&&p.simpleSearch){const t=p.simpleSearch,d=t.length,E=b.length;let w=-d;for(;(w=b.indexOf(t,w+d))!==-1;)if((!c||f(c,b,E,w,d))&&(s[i++]=new S.FindMatch(new R.Range(C,w+1+g,C,w+1+d+g),null),i>=o))return i;return i}const m=new u(p.wordSeparators,p.regex);let n;m.reset(0);do if(n=m.next(b),n&&(s[i++]=O(new R.Range(C,n.index+1+g,C,n.index+1+n[0].length+g),n,r),i>=o))return i;while(n);return i}static findNextMatch(p,b,C,g){const i=b.parseSearchRequest();if(!i)return null;const s=new u(i.wordSeparators,i.regex);return i.regex.multiline?this.e(p,C,s,g):this.f(p,C,s,g)}static e(p,b,C,g){const i=new l.Position(b.lineNumber,1),s=p.getOffsetAt(i),r=p.getLineCount(),o=p.getValueInRange(new R.Range(i.lineNumber,i.column,r,p.getLineMaxColumn(r)),1),c=p.getEOL()===`\r
`?new P(o):null;C.reset(b.column-1);const m=C.next(o);return m?O(this.a(p,s,o,c,m.index,m[0]),m,g):b.lineNumber!==1||b.column!==1?this.e(p,new l.Position(1,1),C,g):null}static f(p,b,C,g){const i=p.getLineCount(),s=b.lineNumber,r=p.getLineContent(s),o=this.g(C,r,s,b.column,g);if(o)return o;for(let c=1;c<=i;c++){const m=(s+c-1)%i,n=p.getLineContent(m+1),t=this.g(C,n,m+1,1,g);if(t)return t}return null}static g(p,b,C,g,i){p.reset(g-1);const s=p.next(b);return s?O(new R.Range(C,s.index+1,C,s.index+1+s[0].length),s,i):null}static findPreviousMatch(p,b,C,g){const i=b.parseSearchRequest();if(!i)return null;const s=new u(i.wordSeparators,i.regex);return i.regex.multiline?this.h(p,C,s,g):this.j(p,C,s,g)}static h(p,b,C,g){const i=this.b(p,new R.Range(1,1,b.lineNumber,b.column),C,g,10*A);if(i.length>0)return i[i.length-1];const s=p.getLineCount();return b.lineNumber!==s||b.column!==p.getLineMaxColumn(s)?this.h(p,new l.Position(s,p.getLineMaxColumn(s)),C,g):null}static j(p,b,C,g){const i=p.getLineCount(),s=b.lineNumber,r=p.getLineContent(s).substring(0,b.column-1),o=this.k(C,r,s,g);if(o)return o;for(let c=1;c<=i;c++){const m=(i+s-c-1)%i,n=p.getLineContent(m+1),t=this.k(C,n,m+1,g);if(t)return t}return null}static k(p,b,C,g){let i=null,s;for(p.reset(0);s=p.next(b);)i=O(new R.Range(C,s.index+1,C,s.index+1+s[0].length),s,g);return i}}e.TextModelSearch=v;function k(h,p,b,C,g){if(C===0)return!0;const i=p.charCodeAt(C-1);if(h.get(i)!==0||i===13||i===10)return!0;if(g>0){const s=p.charCodeAt(C);if(h.get(s)!==0)return!0}return!1}function D(h,p,b,C,g){if(C+g===b)return!0;const i=p.charCodeAt(C+g);if(h.get(i)!==0||i===13||i===10)return!0;if(g>0){const s=p.charCodeAt(C+g-1);if(h.get(s)!==0)return!0}return!1}function f(h,p,b,C,g){return k(h,p,b,C,g)&&D(h,p,b,C,g)}e.isValidMatch=f;class u{constructor(p,b){this._wordSeparators=p,this.a=b,this.b=-1,this.c=0}reset(p){this.a.lastIndex=p,this.b=-1,this.c=0}next(p){const b=p.length;let C;do{if(this.b+this.c===b||(C=this.a.exec(p),!C))return null;const g=C.index,i=C[0].length;if(g===this.b&&i===this.c){if(i===0){a.getNextCodePoint(p,b,this.a.lastIndex)>65535?this.a.lastIndex+=2:this.a.lastIndex+=1;continue}return null}if(this.b=g,this.c=i,!this._wordSeparators||f(this._wordSeparators,p,b,g,i))return C}while(C);return null}}e.Searcher=u}),define(ye[120],De([1,0,22,12]),function(re,e,a,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var l;(function(P){P[P.Full=1]="Full",P[P.Delta=2]="Delta"})(l||(l={}));function R(P){for(let v=0,k=P.length;v<k;v+=4){const D=P[v+0],f=P[v+1],u=P[v+2],h=P[v+3];P[v+0]=h,P[v+1]=u,P[v+2]=f,P[v+3]=D}}function S(P){const v=new Uint8Array(P.buffer,P.byteOffset,P.length*4);return L.isLittleEndian()||R(v),a.VSBuffer.wrap(v)}function A(P){const v=P.buffer;if(L.isLittleEndian()||R(v),v.byteOffset%4===0)return new Uint32Array(v.buffer,v.byteOffset,v.length/4);{const k=new Uint8Array(v.byteLength);return k.set(v),new Uint32Array(k.buffer,k.byteOffset,k.length/4)}}function y(P){const v=new Uint32Array(I(P));let k=0;if(v[k++]=P.id,P.type==="full")v[k++]=1,v[k++]=P.data.length,v.set(P.data,k),k+=P.data.length;else{v[k++]=2,v[k++]=P.deltas.length;for(const D of P.deltas)v[k++]=D.start,v[k++]=D.deleteCount,D.data?(v[k++]=D.data.length,v.set(D.data,k),k+=D.data.length):v[k++]=0}return S(v)}e.encodeSemanticTokensDto=y;function I(P){let v=0;if(v+=1+1,P.type==="full")v+=1+P.data.length;else{v+=1,v+=(1+1+1)*P.deltas.length;for(const k of P.deltas)k.data&&(v+=k.data.length)}return v}function O(P){const v=A(P);let k=0;const D=v[k++];if(v[k++]===1){const p=v[k++],b=v.subarray(k,k+p);return k+=p,{id:D,type:"full",data:b}}const u=v[k++],h=[];for(let p=0;p<u;p++){const b=v[k++],C=v[k++],g=v[k++];let i;g>0&&(i=v.subarray(k,k+g),k+=g),h[p]={start:b,deleteCount:C,data:i}}return{id:D,type:"delta",deltas:h}}e.decodeSemanticTokensDto=O}),define(ye[161],De([1,0,3,6]),function(re,e,a,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistry=void 0;class l{constructor(){this.a=new Map,this.b=new Map,this.c=new a.Emitter,this.onDidChange=this.c.event,this.d=null}fire(A){this.c.fire({changedLanguages:A,changedColorMap:!1})}register(A,y){return this.a.set(A,y),this.fire([A]),(0,L.toDisposable)(()=>{this.a.get(A)===y&&(this.a.delete(A),this.fire([A]))})}registerFactory(A,y){this.b.get(A)?.dispose();const I=new R(this,A,y);return this.b.set(A,I),(0,L.toDisposable)(()=>{const O=this.b.get(A);!O||O!==I||(this.b.delete(A),O.dispose())})}async getOrCreate(A){const y=this.get(A);if(y)return y;const I=this.b.get(A);return!I||I.isResolved?null:(await I.resolve(),this.get(A))}get(A){return this.a.get(A)||null}isResolved(A){if(this.get(A))return!0;const I=this.b.get(A);return!!(!I||I.isResolved)}setColorMap(A){this.d=A,this.c.fire({changedLanguages:Array.from(this.a.keys()),changedColorMap:!0})}getColorMap(){return this.d}getDefaultBackground(){return this.d&&this.d.length>2?this.d[2]:null}}e.TokenizationRegistry=l;class R extends L.Disposable{get isResolved(){return this.c}constructor(A,y,I){super(),this.f=A,this.g=y,this.h=I,this.a=!1,this.b=null,this.c=!1}dispose(){this.a=!0,super.dispose()}async resolve(){return this.b||(this.b=this.i()),this.b}async i(){const A=await Promise.resolve(this.h.createTokenizationSupport());this.c=!0,A&&!this.a&&this.B(this.f.register(this.g,A))}}}),define(ye[72],De([1,0,69,2,33,161]),function(re,e,a,L,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadState=e.CommentThreadCollapsibleState=e.Command=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.CompletionItemKinds=e.CompletionItemKind=e.EncodedTokenizationResult=e.TokenizationResult=e.Token=void 0;class S{constructor(d,E,w){this.offset=d,this.type=E,this.language=w,this._tokenBrand=void 0}toString(){return"("+this.offset+", "+this.type+")"}}e.Token=S;class A{constructor(d,E){this.tokens=d,this.endState=E,this._tokenizationResultBrand=void 0}}e.TokenizationResult=A;class y{constructor(d,E){this.tokens=d,this.endState=E,this._encodedTokenizationResultBrand=void 0}}e.EncodedTokenizationResult=y;var I;(function(t){t[t.Method=0]="Method",t[t.Function=1]="Function",t[t.Constructor=2]="Constructor",t[t.Field=3]="Field",t[t.Variable=4]="Variable",t[t.Class=5]="Class",t[t.Struct=6]="Struct",t[t.Interface=7]="Interface",t[t.Module=8]="Module",t[t.Property=9]="Property",t[t.Event=10]="Event",t[t.Operator=11]="Operator",t[t.Unit=12]="Unit",t[t.Value=13]="Value",t[t.Constant=14]="Constant",t[t.Enum=15]="Enum",t[t.EnumMember=16]="EnumMember",t[t.Keyword=17]="Keyword",t[t.Text=18]="Text",t[t.Color=19]="Color",t[t.File=20]="File",t[t.Reference=21]="Reference",t[t.Customcolor=22]="Customcolor",t[t.Folder=23]="Folder",t[t.TypeParameter=24]="TypeParameter",t[t.User=25]="User",t[t.Issue=26]="Issue",t[t.Snippet=27]="Snippet"})(I=e.CompletionItemKind||(e.CompletionItemKind={}));var O;(function(t){const d=new Map;d.set(0,a.Codicon.symbolMethod),d.set(1,a.Codicon.symbolFunction),d.set(2,a.Codicon.symbolConstructor),d.set(3,a.Codicon.symbolField),d.set(4,a.Codicon.symbolVariable),d.set(5,a.Codicon.symbolClass),d.set(6,a.Codicon.symbolStruct),d.set(7,a.Codicon.symbolInterface),d.set(8,a.Codicon.symbolModule),d.set(9,a.Codicon.symbolProperty),d.set(10,a.Codicon.symbolEvent),d.set(11,a.Codicon.symbolOperator),d.set(12,a.Codicon.symbolUnit),d.set(13,a.Codicon.symbolValue),d.set(15,a.Codicon.symbolEnum),d.set(14,a.Codicon.symbolConstant),d.set(15,a.Codicon.symbolEnum),d.set(16,a.Codicon.symbolEnumMember),d.set(17,a.Codicon.symbolKeyword),d.set(27,a.Codicon.symbolSnippet),d.set(18,a.Codicon.symbolText),d.set(19,a.Codicon.symbolColor),d.set(20,a.Codicon.symbolFile),d.set(21,a.Codicon.symbolReference),d.set(22,a.Codicon.symbolCustomColor),d.set(23,a.Codicon.symbolFolder),d.set(24,a.Codicon.symbolTypeParameter),d.set(25,a.Codicon.account),d.set(26,a.Codicon.issues);function E(j){let V=d.get(j);return V||(console.info("No codicon found for CompletionItemKind "+j),V=a.Codicon.symbolProperty),V}t.toIcon=E;const w=new Map;w.set("method",0),w.set("function",1),w.set("constructor",2),w.set("field",3),w.set("variable",4),w.set("class",5),w.set("struct",6),w.set("interface",7),w.set("module",8),w.set("property",9),w.set("event",10),w.set("operator",11),w.set("unit",12),w.set("value",13),w.set("constant",14),w.set("enum",15),w.set("enum-member",16),w.set("enumMember",16),w.set("keyword",17),w.set("snippet",27),w.set("text",18),w.set("color",19),w.set("file",20),w.set("reference",21),w.set("customcolor",22),w.set("folder",23),w.set("type-parameter",24),w.set("typeParameter",24),w.set("account",25),w.set("issue",26);function N(j,V){let Q=w.get(j);return typeof Q>"u"&&!V&&(Q=9),Q}t.fromString=N})(O=e.CompletionItemKinds||(e.CompletionItemKinds={}));var P;(function(t){t[t.Deprecated=1]="Deprecated"})(P=e.CompletionItemTag||(e.CompletionItemTag={}));var v;(function(t){t[t.None=0]="None",t[t.KeepWhitespace=1]="KeepWhitespace",t[t.InsertAsSnippet=4]="InsertAsSnippet"})(v=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var k;(function(t){t[t.Invoke=0]="Invoke",t[t.TriggerCharacter=1]="TriggerCharacter",t[t.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(k=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var D;(function(t){t[t.Automatic=0]="Automatic",t[t.Explicit=1]="Explicit"})(D=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var f;(function(t){t[t.Invoke=1]="Invoke",t[t.Auto=2]="Auto"})(f=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var u;(function(t){t[t.Invoke=1]="Invoke",t[t.TriggerCharacter=2]="TriggerCharacter",t[t.ContentChange=3]="ContentChange"})(u=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var h;(function(t){t[t.Text=0]="Text",t[t.Read=1]="Read",t[t.Write=2]="Write"})(h=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function p(t){return t&&L.URI.isUri(t.uri)&&l.Range.isIRange(t.range)&&(l.Range.isIRange(t.originSelectionRange)||l.Range.isIRange(t.targetSelectionRange))}e.isLocationLink=p;var b;(function(t){t[t.File=0]="File",t[t.Module=1]="Module",t[t.Namespace=2]="Namespace",t[t.Package=3]="Package",t[t.Class=4]="Class",t[t.Method=5]="Method",t[t.Property=6]="Property",t[t.Field=7]="Field",t[t.Constructor=8]="Constructor",t[t.Enum=9]="Enum",t[t.Interface=10]="Interface",t[t.Function=11]="Function",t[t.Variable=12]="Variable",t[t.Constant=13]="Constant",t[t.String=14]="String",t[t.Number=15]="Number",t[t.Boolean=16]="Boolean",t[t.Array=17]="Array",t[t.Object=18]="Object",t[t.Key=19]="Key",t[t.Null=20]="Null",t[t.EnumMember=21]="EnumMember",t[t.Struct=22]="Struct",t[t.Event=23]="Event",t[t.Operator=24]="Operator",t[t.TypeParameter=25]="TypeParameter"})(b=e.SymbolKind||(e.SymbolKind={}));var C;(function(t){t[t.Deprecated=1]="Deprecated"})(C=e.SymbolTag||(e.SymbolTag={}));var g;(function(t){const d=new Map;d.set(0,a.Codicon.symbolFile),d.set(1,a.Codicon.symbolModule),d.set(2,a.Codicon.symbolNamespace),d.set(3,a.Codicon.symbolPackage),d.set(4,a.Codicon.symbolClass),d.set(5,a.Codicon.symbolMethod),d.set(6,a.Codicon.symbolProperty),d.set(7,a.Codicon.symbolField),d.set(8,a.Codicon.symbolConstructor),d.set(9,a.Codicon.symbolEnum),d.set(10,a.Codicon.symbolInterface),d.set(11,a.Codicon.symbolFunction),d.set(12,a.Codicon.symbolVariable),d.set(13,a.Codicon.symbolConstant),d.set(14,a.Codicon.symbolString),d.set(15,a.Codicon.symbolNumber),d.set(16,a.Codicon.symbolBoolean),d.set(17,a.Codicon.symbolArray),d.set(18,a.Codicon.symbolObject),d.set(19,a.Codicon.symbolKey),d.set(20,a.Codicon.symbolNull),d.set(21,a.Codicon.symbolEnumMember),d.set(22,a.Codicon.symbolStruct),d.set(23,a.Codicon.symbolEvent),d.set(24,a.Codicon.symbolOperator),d.set(25,a.Codicon.symbolTypeParameter);function E(w){let N=d.get(w);return N||(console.info("No codicon found for SymbolKind "+w),N=a.Codicon.symbolProperty),N}t.toIcon=E})(g=e.SymbolKinds||(e.SymbolKinds={}));class i{static fromValue(d){switch(d){case"comment":return i.Comment;case"imports":return i.Imports;case"region":return i.Region}return new i(d)}constructor(d){this.value=d}}i.Comment=new i("comment"),i.Imports=new i("imports"),i.Region=new i("region"),e.FoldingRangeKind=i;var s;(function(t){function d(E){return!E||typeof E!="object"?!1:typeof E.id=="string"&&typeof E.title=="string"}t.is=d})(s=e.Command||(e.Command={}));var r;(function(t){t[t.Collapsed=0]="Collapsed",t[t.Expanded=1]="Expanded"})(r=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var o;(function(t){t[t.Unresolved=0]="Unresolved",t[t.Resolved=1]="Resolved"})(o=e.CommentThreadState||(e.CommentThreadState={}));var c;(function(t){t[t.Editing=0]="Editing",t[t.Preview=1]="Preview"})(c=e.CommentMode||(e.CommentMode={}));var m;(function(t){t[t.Type=1]="Type",t[t.Parameter=2]="Parameter"})(m=e.InlayHintKind||(e.InlayHintKind={})),e.TokenizationRegistry=new R.TokenizationRegistry;var n;(function(t){t[t.None=0]="None",t[t.Option=1]="Option",t[t.Default=2]="Default",t[t.Preferred=3]="Preferred"})(n=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(ye[162],De([19,20]),function(re,e){return re.create("vs/base/common/actions",e)}),define(ye[163],De([1,0,3,6,162]),function(re,e,a,L,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toAction=e.EmptySubmenuAction=e.SubmenuAction=e.Separator=e.ActionRunner=e.Action=void 0;class R extends L.Disposable{constructor(v,k="",D="",f=!0,u){super(),this.h=this.B(new a.Emitter),this.onDidChange=this.h.event,this.w=!0,this.j=v,this.m=k,this.u=D,this.w=f,this.C=u}get id(){return this.j}get label(){return this.m}set label(v){this.D(v)}D(v){this.m!==v&&(this.m=v,this.h.fire({label:v}))}get tooltip(){return this.n||""}set tooltip(v){this.F(v)}F(v){this.n!==v&&(this.n=v,this.h.fire({tooltip:v}))}get class(){return this.u}set class(v){this.G(v)}G(v){this.u!==v&&(this.u=v,this.h.fire({class:v}))}get enabled(){return this.w}set enabled(v){this.H(v)}H(v){this.w!==v&&(this.w=v,this.h.fire({enabled:v}))}get checked(){return this.z}set checked(v){this.I(v)}I(v){this.z!==v&&(this.z=v,this.h.fire({checked:v}))}async run(v,k){this.C&&await this.C(v)}}e.Action=R;class S extends L.Disposable{constructor(){super(...arguments),this.f=this.B(new a.Emitter),this.onWillRun=this.f.event,this.h=this.B(new a.Emitter),this.onDidRun=this.h.event}async run(v,k){if(!v.enabled)return;this.f.fire({action:v});let D;try{await this.runAction(v,k)}catch(f){D=f}this.h.fire({action:v,error:D})}async runAction(v,k){await v.run(k)}}e.ActionRunner=S;class A{constructor(){this.id=A.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...v){let k=[];for(const D of v)D.length&&(k.length?k=[...k,new A,...D]:k=D);return k}async run(){}}A.ID="vs.actions.separator",e.Separator=A;class y{get actions(){return this.a}constructor(v,k,D,f){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=v,this.label=k,this.class=f,this.a=D}async run(){}}e.SubmenuAction=y;class I extends R{constructor(){super(I.ID,l.localize(0,null),void 0,!1)}}I.ID="vs.actions.empty",e.EmptySubmenuAction=I;function O(P){return{id:P.id,label:P.label,class:void 0,enabled:P.enabled??!0,checked:P.checked??!1,run:async()=>P.run(),tooltip:P.label}}e.toAction=O}),define(ye[164],De([19,20]),function(re,e){return re.create("vs/base/common/date",e)}),define(ye[165],De([1,0,164]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,l=L*60,R=l*24,S=R*7,A=R*30,y=R*365;function I(P,v,k,D){typeof P!="number"&&(P=P.getTime());const f=Math.round((new Date().getTime()-P)/1e3);if(f<-30)return(0,a.localize)(0,null,I(new Date().getTime()+f*1e3,!1));if(!D&&f<30)return(0,a.localize)(1,null);let u;return f<L?(u=f,v?u===1?k?(0,a.localize)(2,null,u):(0,a.localize)(3,null,u):k?(0,a.localize)(4,null,u):(0,a.localize)(5,null,u):u===1?k?(0,a.localize)(6,null,u):(0,a.localize)(7,null,u):k?(0,a.localize)(8,null,u):(0,a.localize)(9,null,u)):f<l?(u=Math.floor(f/L),v?u===1?k?(0,a.localize)(10,null,u):(0,a.localize)(11,null,u):k?(0,a.localize)(12,null,u):(0,a.localize)(13,null,u):u===1?k?(0,a.localize)(14,null,u):(0,a.localize)(15,null,u):k?(0,a.localize)(16,null,u):(0,a.localize)(17,null,u)):f<R?(u=Math.floor(f/l),v?u===1?k?(0,a.localize)(18,null,u):(0,a.localize)(19,null,u):k?(0,a.localize)(20,null,u):(0,a.localize)(21,null,u):u===1?k?(0,a.localize)(22,null,u):(0,a.localize)(23,null,u):k?(0,a.localize)(24,null,u):(0,a.localize)(25,null,u)):f<S?(u=Math.floor(f/R),v?u===1?(0,a.localize)(26,null,u):(0,a.localize)(27,null,u):u===1?(0,a.localize)(28,null,u):(0,a.localize)(29,null,u)):f<A?(u=Math.floor(f/S),v?u===1?k?(0,a.localize)(30,null,u):(0,a.localize)(31,null,u):k?(0,a.localize)(32,null,u):(0,a.localize)(33,null,u):u===1?k?(0,a.localize)(34,null,u):(0,a.localize)(35,null,u):k?(0,a.localize)(36,null,u):(0,a.localize)(37,null,u)):f<y?(u=Math.floor(f/A),v?u===1?k?(0,a.localize)(38,null,u):(0,a.localize)(39,null,u):k?(0,a.localize)(40,null,u):(0,a.localize)(41,null,u):u===1?k?(0,a.localize)(42,null,u):(0,a.localize)(43,null,u):k?(0,a.localize)(44,null,u):(0,a.localize)(45,null,u)):(u=Math.floor(f/y),v?u===1?k?(0,a.localize)(46,null,u):(0,a.localize)(47,null,u):k?(0,a.localize)(48,null,u):(0,a.localize)(49,null,u):u===1?k?(0,a.localize)(50,null,u):(0,a.localize)(51,null,u):k?(0,a.localize)(52,null,u):(0,a.localize)(53,null,u))}e.fromNow=I;function O(P){return P.getFullYear()+"-"+String(P.getMonth()+1).padStart(2,"0")+"-"+String(P.getDate()).padStart(2,"0")+"T"+String(P.getHours()).padStart(2,"0")+":"+String(P.getMinutes()).padStart(2,"0")+":"+String(P.getSeconds()).padStart(2,"0")+"."+(P.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=O}),define(ye[166],De([19,20]),function(re,e){return re.create("vs/base/common/errorMessage",e)}),define(ye[45],De([1,0,15,10,166]),function(re,e,a,L,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function R(P,v){return v&&(P.stack||P.stacktrace)?l.localize(0,null,A(P),S(P.stack)||S(P.stacktrace)):A(P)}function S(P){return Array.isArray(P)?P.join(`
`):P}function A(P){return typeof P.code=="string"&&typeof P.errno=="number"&&typeof P.syscall=="string"?l.localize(1,null,P.message):P.message||l.localize(2,null)}function y(P=null,v=!1){if(!P)return l.localize(3,null);if(Array.isArray(P)){const k=a.coalesce(P),D=y(k[0],v);return k.length>1?l.localize(4,null,D,k.length):D}if(L.isString(P))return P;if(P.detail){const k=P.detail;if(k.error)return R(k.error,v);if(k.exception)return R(k.exception,v)}return P.stack?R(P,v):P.message?P.message:l.localize(5,null)}e.toErrorMessage=y;function I(P){const v=P;return v instanceof Error&&Array.isArray(v.actions)}e.isErrorWithActions=I;function O(P,v){let k;return typeof P=="string"?k=new Error(P):k=P,k.actions=v,k}e.createErrorWithActions=O}),define(ye[167],De([19,20]),function(re,e){return re.create("vs/editor/common/config/editorOptions",e)}),define(ye[121],De([1,0,167,12,118,15,23,153]),function(re,e,a,L,l,R,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var y;(function($){$[$.None=0]="None",$[$.Keep=1]="Keep",$[$.Brackets=2]="Brackets",$[$.Advanced=3]="Advanced",$[$.Full=4]="Full"})(y=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class I{constructor(K){this.c=K}hasChanged(K){return this.c[K]}}e.ConfigurationChangedEvent=I;class O{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=O;class P{constructor(K,he,Le,Ne){this.id=K,this.name=he,this.defaultValue=Le,this.schema=Ne}applyUpdate(K,he){return k(K,he)}compute(K,he,Le){return Le}}class v{constructor(K,he){this.newValue=K,this.didChange=he}}e.ApplyUpdateResult=v;function k($,K){if(typeof $!="object"||typeof K!="object"||!$||!K)return new v(K,$!==K);if(Array.isArray($)||Array.isArray(K)){const Le=Array.isArray($)&&Array.isArray(K)&&R.equals($,K);return new v(K,!Le)}let he=!1;for(const Le in K)if(K.hasOwnProperty(Le)){const Ne=k($[Le],K[Le]);Ne.didChange&&($[Le]=Ne.newValue,he=!0)}return new v($,he)}class D{constructor(K){this.schema=void 0,this.id=K,this.name="_never_",this.defaultValue=void 0}applyUpdate(K,he){return k(K,he)}validate(K){return this.defaultValue}}class f{constructor(K,he,Le,Ne){this.id=K,this.name=he,this.defaultValue=Le,this.schema=Ne}applyUpdate(K,he){return k(K,he)}validate(K){return typeof K>"u"?this.defaultValue:K}compute(K,he,Le){return Le}}function u($,K){return typeof $>"u"?K:$==="false"?!1:Boolean($)}e.boolean=u;class h extends f{constructor(K,he,Le,Ne=void 0){typeof Ne<"u"&&(Ne.type="boolean",Ne.default=Le),super(K,he,Le,Ne)}validate(K){return u(K,this.defaultValue)}}function p($,K,he,Le){if(typeof $>"u")return K;let Ne=parseInt($,10);return isNaN(Ne)?K:(Ne=Math.max(he,Ne),Ne=Math.min(Le,Ne),Ne|0)}e.clampedInt=p;class b extends f{static clampedInt(K,he,Le,Ne){return p(K,he,Le,Ne)}constructor(K,he,Le,Ne,xe,je=void 0){typeof je<"u"&&(je.type="integer",je.default=Le,je.minimum=Ne,je.maximum=xe),super(K,he,Le,je),this.minimum=Ne,this.maximum=xe}validate(K){return b.clampedInt(K,this.defaultValue,this.minimum,this.maximum)}}class C extends f{static clamp(K,he,Le){return K<he?he:K>Le?Le:K}static float(K,he){if(typeof K=="number")return K;if(typeof K>"u")return he;const Le=parseFloat(K);return isNaN(Le)?he:Le}constructor(K,he,Le,Ne,xe){typeof xe<"u"&&(xe.type="number",xe.default=Le),super(K,he,Le,xe),this.validationFn=Ne}validate(K){return this.validationFn(C.float(K,this.defaultValue))}}class g extends f{static string(K,he){return typeof K!="string"?he:K}constructor(K,he,Le,Ne=void 0){typeof Ne<"u"&&(Ne.type="string",Ne.default=Le),super(K,he,Le,Ne)}validate(K){return g.string(K,this.defaultValue)}}function i($,K,he){return typeof $!="string"||he.indexOf($)===-1?K:$}e.stringSet=i;class s extends f{constructor(K,he,Le,Ne,xe=void 0){typeof xe<"u"&&(xe.type="string",xe.enum=Ne,xe.default=Le),super(K,he,Le,xe),this.c=Ne}validate(K){return i(K,this.defaultValue,this.c)}}class r extends P{constructor(K,he,Le,Ne,xe,je,Ze=void 0){typeof Ze<"u"&&(Ze.type="string",Ze.enum=xe,Ze.default=Ne),super(K,he,Le,Ze),this.c=xe,this.d=je}validate(K){return typeof K!="string"?this.defaultValue:this.c.indexOf(K)===-1?this.defaultValue:this.d(K)}}function o($){switch($){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class c extends P{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[a.localize(0,null),a.localize(1,null),a.localize(2,null)],default:"auto",tags:["accessibility"],description:a.localize(3,null)})}validate(K){switch(K){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(K,he,Le){return Le===0?K.accessibilitySupport:Le}}class m extends P{constructor(){const K={insertSpace:!0,ignoreEmptyLines:!0};super(20,"comments",K,{"editor.comments.insertSpace":{type:"boolean",default:K.insertSpace,description:a.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:K.ignoreEmptyLines,description:a.localize(5,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const he=K;return{insertSpace:u(he.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:u(he.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var n;(function($){$[$.Hidden=0]="Hidden",$[$.Blink=1]="Blink",$[$.Smooth=2]="Smooth",$[$.Phase=3]="Phase",$[$.Expand=4]="Expand",$[$.Solid=5]="Solid"})(n=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function t($){switch($){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var d;(function($){$[$.Line=1]="Line",$[$.Block=2]="Block",$[$.Underline=3]="Underline",$[$.LineThin=4]="LineThin",$[$.BlockOutline=5]="BlockOutline",$[$.UnderlineThin=6]="UnderlineThin"})(d=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function E($){switch($){case d.Line:return"line";case d.Block:return"block";case d.Underline:return"underline";case d.LineThin:return"line-thin";case d.BlockOutline:return"block-outline";case d.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=E;function w($){switch($){case"line":return d.Line;case"block":return d.Block;case"underline":return d.Underline;case"line-thin":return d.LineThin;case"block-outline":return d.BlockOutline;case"underline-thin":return d.UnderlineThin}}class N extends D{constructor(){super(135)}compute(K,he,Le){const Ne=["monaco-editor"];return he.get(36)&&Ne.push(he.get(36)),K.extraEditorClassName&&Ne.push(K.extraEditorClassName),he.get(70)==="default"?Ne.push("mouse-default"):he.get(70)==="copy"&&Ne.push("mouse-copy"),he.get(105)&&Ne.push("showUnused"),he.get(133)&&Ne.push("showDeprecated"),Ne.join(" ")}}class j extends h{constructor(){super(34,"emptySelectionClipboard",!0,{description:a.localize(6,null)})}compute(K,he,Le){return Le&&K.emptySelectionClipboard}}class V extends P{constructor(){const K={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(38,"find",K,{"editor.find.cursorMoveOnType":{type:"boolean",default:K.cursorMoveOnType,description:a.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:K.seedSearchStringFromSelection,enumDescriptions:[a.localize(8,null),a.localize(9,null),a.localize(10,null)],description:a.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:K.autoFindInSelection,enumDescriptions:[a.localize(12,null),a.localize(13,null),a.localize(14,null)],description:a.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:K.globalFindClipboard,description:a.localize(16,null),included:L.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:K.addExtraSpaceOnTop,description:a.localize(17,null)},"editor.find.loop":{type:"boolean",default:K.loop,description:a.localize(18,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const he=K;return{cursorMoveOnType:u(he.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof K.seedSearchStringFromSelection=="boolean"?K.seedSearchStringFromSelection?"always":"never":i(he.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof K.autoFindInSelection=="boolean"?K.autoFindInSelection?"always":"never":i(he.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:u(he.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:u(he.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:u(he.loop,this.defaultValue.loop)}}}class Q extends P{constructor(){super(48,"fontLigatures",Q.OFF,{anyOf:[{type:"boolean",description:a.localize(19,null)},{type:"string",description:a.localize(20,null)}],description:a.localize(21,null),default:!1})}validate(K){return typeof K>"u"?this.defaultValue:typeof K=="string"?K==="false"?Q.OFF:K==="true"?Q.ON:K:Boolean(K)?Q.ON:Q.OFF}}Q.OFF='"liga" off, "calt" off',Q.ON='"liga" on, "calt" on',e.EditorFontLigatures=Q;class x extends P{constructor(){super(51,"fontVariations",x.OFF,{anyOf:[{type:"boolean",description:a.localize(22,null)},{type:"string",description:a.localize(23,null)}],description:a.localize(24,null),default:!1})}validate(K){return typeof K>"u"?this.defaultValue:typeof K=="string"?K==="false"?x.OFF:K==="true"?x.TRANSLATE:K:Boolean(K)?x.TRANSLATE:x.OFF}compute(K,he,Le){return K.fontInfo.fontVariationSettings}}x.OFF="normal",x.TRANSLATE="translate",e.EditorFontVariations=x;class U extends D{constructor(){super(47)}compute(K,he,Le){return K.fontInfo}}class T extends f{constructor(){super(49,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:a.localize(25,null)})}validate(K){const he=C.float(K,this.defaultValue);return he===0?e.EDITOR_FONT_DEFAULTS.fontSize:C.clamp(he,6,100)}compute(K,he,Le){return K.fontInfo.fontSize}}class F extends P{constructor(){super(50,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:F.d,maximum:F.e,errorMessage:a.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:F.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:a.localize(27,null)})}validate(K){return K==="normal"||K==="bold"?K:String(b.clampedInt(K,e.EDITOR_FONT_DEFAULTS.fontWeight,F.d,F.e))}}F.c=["normal","bold","100","200","300","400","500","600","700","800","900"],F.d=1,F.e=1e3;class B extends P{constructor(){const K={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},he={type:"string",enum:["peek","gotoAndPeek","goto"],default:K.multiple,enumDescriptions:[a.localize(28,null),a.localize(29,null),a.localize(30,null)]},Le=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(55,"gotoLocation",K,{"editor.gotoLocation.multiple":{deprecationMessage:a.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:a.localize(32,null),...he},"editor.gotoLocation.multipleTypeDefinitions":{description:a.localize(33,null),...he},"editor.gotoLocation.multipleDeclarations":{description:a.localize(34,null),...he},"editor.gotoLocation.multipleImplementations":{description:a.localize(35,null),...he},"editor.gotoLocation.multipleReferences":{description:a.localize(36,null),...he},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:K.alternativeDefinitionCommand,enum:Le,description:a.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:K.alternativeTypeDefinitionCommand,enum:Le,description:a.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:K.alternativeDeclarationCommand,enum:Le,description:a.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:K.alternativeImplementationCommand,enum:Le,description:a.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:K.alternativeReferenceCommand,enum:Le,description:a.localize(41,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const he=K;return{multiple:i(he.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:he.multipleDefinitions??i(he.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:he.multipleTypeDefinitions??i(he.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:he.multipleDeclarations??i(he.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:he.multipleImplementations??i(he.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:he.multipleReferences??i(he.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:g.string(he.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:g.string(he.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:g.string(he.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:g.string(he.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:g.string(he.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class Z extends P{constructor(){const K={enabled:!0,delay:300,sticky:!0,above:!0};super(57,"hover",K,{"editor.hover.enabled":{type:"boolean",default:K.enabled,description:a.localize(42,null)},"editor.hover.delay":{type:"number",default:K.delay,minimum:0,maximum:1e4,description:a.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:K.sticky,description:a.localize(44,null)},"editor.hover.above":{type:"boolean",default:K.above,description:a.localize(45,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const he=K;return{enabled:u(he.enabled,this.defaultValue.enabled),delay:b.clampedInt(he.delay,this.defaultValue.delay,0,1e4),sticky:u(he.sticky,this.defaultValue.sticky),above:u(he.above,this.defaultValue.above)}}}var _;(function($){$[$.None=0]="None",$[$.Text=1]="Text",$[$.Blocks=2]="Blocks"})(_=e.RenderMinimap||(e.RenderMinimap={}));class H extends D{constructor(){super(138)}compute(K,he,Le){return H.computeLayout(he,{memory:K.memory,outerWidth:K.outerWidth,outerHeight:K.outerHeight,isDominatedByLongLines:K.isDominatedByLongLines,lineHeight:K.fontInfo.lineHeight,viewLineCount:K.viewLineCount,lineNumbersDigitCount:K.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:K.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:K.fontInfo.maxDigitWidth,pixelRatio:K.pixelRatio})}static computeContainedMinimapLineCount(K){const he=K.height/K.lineHeight,Le=Math.floor(K.paddingTop/K.lineHeight);let Ne=Math.floor(K.paddingBottom/K.lineHeight);K.scrollBeyondLastLine&&(Ne=Math.max(Ne,he-1));const xe=(Le+K.viewLineCount+Ne)/(K.pixelRatio*K.height),je=Math.floor(K.viewLineCount/xe);return{typicalViewportLineCount:he,extraLinesBeforeFirstLine:Le,extraLinesBeyondLastLine:Ne,desiredRatio:xe,minimapLineCount:je}}static c(K,he){const Le=K.outerWidth,Ne=K.outerHeight,xe=K.pixelRatio;if(!K.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(xe*Ne),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ne};const je=he.stableMinimapLayoutInput,Ze=je&&K.outerHeight===je.outerHeight&&K.lineHeight===je.lineHeight&&K.typicalHalfwidthCharacterWidth===je.typicalHalfwidthCharacterWidth&&K.pixelRatio===je.pixelRatio&&K.scrollBeyondLastLine===je.scrollBeyondLastLine&&K.paddingTop===je.paddingTop&&K.paddingBottom===je.paddingBottom&&K.minimap.enabled===je.minimap.enabled&&K.minimap.side===je.minimap.side&&K.minimap.size===je.minimap.size&&K.minimap.showSlider===je.minimap.showSlider&&K.minimap.renderCharacters===je.minimap.renderCharacters&&K.minimap.maxColumn===je.minimap.maxColumn&&K.minimap.scale===je.minimap.scale&&K.verticalScrollbarWidth===je.verticalScrollbarWidth&&K.isViewportWrapping===je.isViewportWrapping,st=K.lineHeight,at=K.typicalHalfwidthCharacterWidth,mt=K.scrollBeyondLastLine,gt=K.minimap.renderCharacters;let Et=xe>=2?Math.round(K.minimap.scale*2):K.minimap.scale;const lt=K.minimap.maxColumn,pt=K.minimap.size,qt=K.minimap.side,jt=K.verticalScrollbarWidth,kt=K.viewLineCount,ft=K.remainingWidth,Tt=K.isViewportWrapping,Bt=gt?2:3;let At=Math.floor(xe*Ne);const Xe=At/xe;let Nt=!1,Gt=!1,Ft=Bt*Et,bt=Et/xe,Ae=1;if(pt==="fill"||pt==="fit"){const{typicalViewportLineCount:Ve,extraLinesBeforeFirstLine:et,extraLinesBeyondLastLine:ut,desiredRatio:Pt,minimapLineCount:St}=H.computeContainedMinimapLineCount({viewLineCount:kt,scrollBeyondLastLine:mt,paddingTop:K.paddingTop,paddingBottom:K.paddingBottom,height:Ne,lineHeight:st,pixelRatio:xe});if(kt/St>1)Nt=!0,Gt=!0,Et=1,Ft=1,bt=Et/xe;else{let wt=!1,Rt=Et+1;if(pt==="fit"){const yt=Math.ceil((et+kt+ut)*Ft);Tt&&Ze&&ft<=he.stableFitRemainingWidth?(wt=!0,Rt=he.stableFitMaxMinimapScale):wt=yt>At}if(pt==="fill"||wt){Nt=!0;const yt=Et;Ft=Math.min(st*xe,Math.max(1,Math.floor(1/Pt))),Tt&&Ze&&ft<=he.stableFitRemainingWidth&&(Rt=he.stableFitMaxMinimapScale),Et=Math.min(Rt,Math.max(1,Math.floor(Ft/Bt))),Et>yt&&(Ae=Math.min(2,Et/yt)),bt=Et/xe/Ae,At=Math.ceil(Math.max(Ve,et+kt+ut)*Ft),Tt?(he.stableMinimapLayoutInput=K,he.stableFitRemainingWidth=ft,he.stableFitMaxMinimapScale=Et):(he.stableMinimapLayoutInput=null,he.stableFitRemainingWidth=0)}}}const Oe=Math.floor(lt*bt),Se=Math.min(Oe,Math.max(0,Math.floor((ft-jt-2)*bt/(at+bt)))+e.MINIMAP_GUTTER_WIDTH);let se=Math.floor(xe*Se);const Fe=se/xe;se=Math.floor(se*Ae);const We=gt?1:2,Ye=qt==="left"?0:Le-Se-jt;return{renderMinimap:We,minimapLeft:Ye,minimapWidth:Se,minimapHeightIsEditorHeight:Nt,minimapIsSampling:Gt,minimapScale:Et,minimapLineHeight:Ft,minimapCanvasInnerWidth:se,minimapCanvasInnerHeight:At,minimapCanvasOuterWidth:Fe,minimapCanvasOuterHeight:Xe}}static computeLayout(K,he){const Le=he.outerWidth|0,Ne=he.outerHeight|0,xe=he.lineHeight|0,je=he.lineNumbersDigitCount|0,Ze=he.typicalHalfwidthCharacterWidth,st=he.maxDigitWidth,at=he.pixelRatio,mt=he.viewLineCount,gt=K.get(130),Et=gt==="inherit"?K.get(129):gt,lt=Et==="inherit"?K.get(125):Et,pt=K.get(128),qt=he.isDominatedByLongLines,jt=K.get(54),kt=K.get(64).renderType!==0,ft=K.get(65),Tt=K.get(99),Bt=K.get(80),At=K.get(69),Xe=K.get(97),Nt=Xe.verticalScrollbarSize,Gt=Xe.verticalHasArrows,Ft=Xe.arrowSize,bt=Xe.horizontalScrollbarSize,Ae=K.get(40),Oe=K.get(104)!=="never";let Se=K.get(62);Ae&&Oe&&(Se+=16);let se=0;if(kt){const ei=Math.max(je,ft);se=Math.round(ei*st)}let Fe=0;jt&&(Fe=xe);let We=0,Ye=We+Fe,Ve=Ye+se,et=Ve+Se;const ut=Le-Fe-se-Se;let Pt=!1,St=!1,Dt=-1;Et==="inherit"&&qt?(Pt=!0,St=!0):lt==="on"||lt==="bounded"?St=!0:lt==="wordWrapColumn"&&(Dt=pt);const wt=H.c({outerWidth:Le,outerHeight:Ne,lineHeight:xe,typicalHalfwidthCharacterWidth:Ze,pixelRatio:at,scrollBeyondLastLine:Tt,paddingTop:Bt.top,paddingBottom:Bt.bottom,minimap:At,verticalScrollbarWidth:Nt,viewLineCount:mt,remainingWidth:ut,isViewportWrapping:St},he.memory||new O);wt.renderMinimap!==0&&wt.minimapLeft===0&&(We+=wt.minimapWidth,Ye+=wt.minimapWidth,Ve+=wt.minimapWidth,et+=wt.minimapWidth);const Rt=ut-wt.minimapWidth,yt=Math.max(1,Math.floor((Rt-Nt-2)/Ze)),ri=Gt?Ft:0;return St&&(Dt=Math.max(1,yt),lt==="bounded"&&(Dt=Math.min(Dt,pt))),{width:Le,height:Ne,glyphMarginLeft:We,glyphMarginWidth:Fe,lineNumbersLeft:Ye,lineNumbersWidth:se,decorationsLeft:Ve,decorationsWidth:Se,contentLeft:et,contentWidth:Rt,minimap:wt,viewportColumn:yt,isWordWrapMinified:Pt,isViewportWrapping:St,wrappingColumn:Dt,verticalScrollbarWidth:Nt,horizontalScrollbarHeight:bt,overviewRuler:{top:ri,width:Nt,height:Ne-2*ri,right:0}}}}e.EditorLayoutInfoComputer=H;class Y extends P{constructor(){super(132,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[a.localize(46,null),a.localize(47,null)],type:"string",enum:["simple","advanced"],default:"simple",description:a.localize(48,null)}})}validate(K){return i(K,"simple",["simple","advanced"])}compute(K,he,Le){return he.get(2)===2?"advanced":Le}}class ie extends P{constructor(){const K={enabled:!0};super(61,"lightbulb",K,{"editor.lightbulb.enabled":{type:"boolean",default:K.enabled,description:a.localize(49,null)}})}validate(K){return!K||typeof K!="object"?this.defaultValue:{enabled:u(K.enabled,this.defaultValue.enabled)}}}class ge extends P{constructor(){const K={enabled:!1,maxLineCount:5};super(109,"stickyScroll",K,{"editor.stickyScroll.enabled":{type:"boolean",default:K.enabled,description:a.localize(50,null)},"editor.stickyScroll.maxLineCount":{type:"number",default:K.maxLineCount,minimum:1,maximum:10,description:a.localize(51,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const he=K;return{enabled:u(he.enabled,this.defaultValue.enabled),maxLineCount:b.clampedInt(he.maxLineCount,this.defaultValue.maxLineCount,1,10)}}}class X extends P{constructor(){const K={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(134,"inlayHints",K,{"editor.inlayHints.enabled":{type:"string",default:K.enabled,description:a.localize(52,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[a.localize(53,null),a.localize(54,null,L.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),a.localize(55,null,L.isMacintosh?"Ctrl+Option":"Ctrl+Alt"),a.localize(56,null)]},"editor.inlayHints.fontSize":{type:"number",default:K.fontSize,markdownDescription:a.localize(57,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:K.fontFamily,markdownDescription:a.localize(58,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:K.padding,description:a.localize(59,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const he=K;return typeof he.enabled=="boolean"&&(he.enabled=he.enabled?"on":"off"),{enabled:i(he.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:b.clampedInt(he.fontSize,this.defaultValue.fontSize,0,100),fontFamily:g.string(he.fontFamily,this.defaultValue.fontFamily),padding:u(he.padding,this.defaultValue.padding)}}}class J extends P{constructor(){super(62,"lineDecorationsWidth",10)}validate(K){return typeof K=="string"&&/^\d+(\.\d+)?ch$/.test(K)?-parseFloat(K.substring(0,K.length-2)):b.clampedInt(K,this.defaultValue,0,1e3)}compute(K,he,Le){return Le<0?b.clampedInt(-Le*K.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):Le}}class ee extends C{constructor(){super(63,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,K=>C.clamp(K,0,150),{markdownDescription:a.localize(60,null)})}compute(K,he,Le){return K.fontInfo.lineHeight}}class me extends P{constructor(){const K={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(69,"minimap",K,{"editor.minimap.enabled":{type:"boolean",default:K.enabled,description:a.localize(61,null)},"editor.minimap.autohide":{type:"boolean",default:K.autohide,description:a.localize(62,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[a.localize(63,null),a.localize(64,null),a.localize(65,null)],default:K.size,description:a.localize(66,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:K.side,description:a.localize(67,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:K.showSlider,description:a.localize(68,null)},"editor.minimap.scale":{type:"number",default:K.scale,minimum:1,maximum:3,enum:[1,2,3],description:a.localize(69,null)},"editor.minimap.renderCharacters":{type:"boolean",default:K.renderCharacters,description:a.localize(70,null)},"editor.minimap.maxColumn":{type:"number",default:K.maxColumn,description:a.localize(71,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const he=K;return{enabled:u(he.enabled,this.defaultValue.enabled),autohide:u(he.autohide,this.defaultValue.autohide),size:i(he.size,this.defaultValue.size,["proportional","fill","fit"]),side:i(he.side,this.defaultValue.side,["right","left"]),showSlider:i(he.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:u(he.renderCharacters,this.defaultValue.renderCharacters),scale:b.clampedInt(he.scale,1,1,3),maxColumn:b.clampedInt(he.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function ve($){return $==="ctrlCmd"?L.isMacintosh?"metaKey":"ctrlKey":"altKey"}class Ie extends P{constructor(){super(80,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:a.localize(72,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:a.localize(73,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const he=K;return{top:b.clampedInt(he.top,0,0,1e3),bottom:b.clampedInt(he.bottom,0,0,1e3)}}}class Re extends P{constructor(){const K={enabled:!0,cycle:!0};super(81,"parameterHints",K,{"editor.parameterHints.enabled":{type:"boolean",default:K.enabled,description:a.localize(74,null)},"editor.parameterHints.cycle":{type:"boolean",default:K.cycle,description:a.localize(75,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const he=K;return{enabled:u(he.enabled,this.defaultValue.enabled),cycle:u(he.cycle,this.defaultValue.cycle)}}}class ae extends D{constructor(){super(136)}compute(K,he,Le){return K.pixelRatio}}class le extends P{constructor(){const K={other:"on",comments:"off",strings:"off"},he=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[a.localize(76,null),a.localize(77,null),a.localize(78,null)]}];super(84,"quickSuggestions",K,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:he,default:K.strings,description:a.localize(79,null)},comments:{anyOf:he,default:K.comments,description:a.localize(80,null)},other:{anyOf:he,default:K.other,description:a.localize(81,null)}},default:K,markdownDescription:a.localize(82,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=K}validate(K){if(typeof K=="boolean"){const at=K?"on":"off";return{comments:at,strings:at,other:at}}if(!K||typeof K!="object")return this.defaultValue;const{other:he,comments:Le,strings:Ne}=K,xe=["on","inline","off"];let je,Ze,st;return typeof he=="boolean"?je=he?"on":"off":je=i(he,this.defaultValue.other,xe),typeof Le=="boolean"?Ze=Le?"on":"off":Ze=i(Le,this.defaultValue.comments,xe),typeof Ne=="boolean"?st=Ne?"on":"off":st=i(Ne,this.defaultValue.strings,xe),{other:je,comments:Ze,strings:st}}}var ue;(function($){$[$.Off=0]="Off",$[$.On=1]="On",$[$.Relative=2]="Relative",$[$.Interval=3]="Interval",$[$.Custom=4]="Custom"})(ue=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class ne extends P{constructor(){super(64,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[a.localize(83,null),a.localize(84,null),a.localize(85,null),a.localize(86,null)],default:"on",description:a.localize(87,null)})}validate(K){let he=this.defaultValue.renderType,Le=this.defaultValue.renderFn;return typeof K<"u"&&(typeof K=="function"?(he=4,Le=K):K==="interval"?he=3:K==="relative"?he=2:K==="on"?he=1:he=0),{renderType:he,renderFn:Le}}}function ce($){const K=$.get(92);return K==="editable"?$.get(86):K!=="on"}e.filterValidationDecorations=ce;class oe extends P{constructor(){const K=[],he={type:"number",description:a.localize(88,null)};super(96,"rulers",K,{type:"array",items:{anyOf:[he,{type:["object"],properties:{column:he,color:{type:"string",description:a.localize(89,null),format:"color-hex"}}}]},default:K,description:a.localize(90,null)})}validate(K){if(Array.isArray(K)){const he=[];for(const Le of K)if(typeof Le=="number")he.push({column:b.clampedInt(Le,0,0,1e4),color:null});else if(Le&&typeof Le=="object"){const Ne=Le;he.push({column:b.clampedInt(Ne.column,0,0,1e4),color:Ne.color})}return he.sort((Le,Ne)=>Le.column-Ne.column),he}return this.defaultValue}}function M($,K){if(typeof $!="string")return K;switch($){case"hidden":return 2;case"visible":return 3;default:return 1}}class z extends P{constructor(){const K={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(97,"scrollbar",K,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[a.localize(91,null),a.localize(92,null),a.localize(93,null)],default:"auto",description:a.localize(94,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[a.localize(95,null),a.localize(96,null),a.localize(97,null)],default:"auto",description:a.localize(98,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:K.verticalScrollbarSize,description:a.localize(99,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:K.horizontalScrollbarSize,description:a.localize(100,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:K.scrollByPage,description:a.localize(101,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const he=K,Le=b.clampedInt(he.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ne=b.clampedInt(he.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:b.clampedInt(he.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:M(he.vertical,this.defaultValue.vertical),horizontal:M(he.horizontal,this.defaultValue.horizontal),useShadows:u(he.useShadows,this.defaultValue.useShadows),verticalHasArrows:u(he.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:u(he.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:u(he.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:u(he.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Le,horizontalSliderSize:b.clampedInt(he.horizontalSliderSize,Le,0,1e3),verticalScrollbarSize:Ne,verticalSliderSize:b.clampedInt(he.verticalSliderSize,Ne,0,1e3),scrollByPage:u(he.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class G extends P{constructor(){const K={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(119,"unicodeHighlight",K,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:K.nonBasicASCII,description:a.localize(102,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:K.invisibleCharacters,description:a.localize(103,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:K.ambiguousCharacters,description:a.localize(104,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:K.includeComments,description:a.localize(105,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:K.includeStrings,description:a.localize(106,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:K.allowedCharacters,description:a.localize(107,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:K.allowedLocales,description:a.localize(108,null)}})}applyUpdate(K,he){let Le=!1;he.allowedCharacters&&K&&(S.equals(K.allowedCharacters,he.allowedCharacters)||(K={...K,allowedCharacters:he.allowedCharacters},Le=!0)),he.allowedLocales&&K&&(S.equals(K.allowedLocales,he.allowedLocales)||(K={...K,allowedLocales:he.allowedLocales},Le=!0));const Ne=super.applyUpdate(K,he);return Le?new v(Ne.newValue,!0):Ne}validate(K){if(!K||typeof K!="object")return this.defaultValue;const he=K;return{nonBasicASCII:Pe(he.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:u(he.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:u(he.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:Pe(he.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:Pe(he.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(K.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(K.allowedLocales,this.defaultValue.allowedLocales)}}c(K,he){if(typeof K!="object"||!K)return he;const Le={};for(const[Ne,xe]of Object.entries(K))xe===!0&&(Le[Ne]=!0);return Le}}class te extends P{constructor(){const K={enabled:!0,mode:"subwordSmart",showToolbar:"onHover"};super(59,"inlineSuggest",K,{"editor.inlineSuggest.enabled":{type:"boolean",default:K.enabled,description:a.localize(109,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:K.showToolbar,enum:["always","onHover"],enumDescriptions:[a.localize(110,null),a.localize(111,null)],description:a.localize(112,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const he=K;return{enabled:u(he.enabled,this.defaultValue.enabled),mode:i(he.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:i(he.showToolbar,this.defaultValue.showToolbar,["always","onHover"])}}}class de extends P{constructor(){const K={enabled:A.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:A.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",K,{"editor.bracketPairColorization.enabled":{type:"boolean",default:K.enabled,markdownDescription:a.localize(113,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:K.independentColorPoolPerBracketType,description:a.localize(114,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const he=K;return{enabled:u(he.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:u(he.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class we extends P{constructor(){const K={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",K,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[a.localize(115,null),a.localize(116,null),a.localize(117,null)],default:K.bracketPairs,description:a.localize(118,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[a.localize(119,null),a.localize(120,null),a.localize(121,null)],default:K.bracketPairsHorizontal,description:a.localize(122,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:K.highlightActiveBracketPair,description:a.localize(123,null)},"editor.guides.indentation":{type:"boolean",default:K.indentation,description:a.localize(124,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[a.localize(125,null),a.localize(126,null),a.localize(127,null)],default:K.highlightActiveIndentation,description:a.localize(128,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const he=K;return{bracketPairs:Pe(he.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:Pe(he.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:u(he.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:u(he.indentation,this.defaultValue.indentation),highlightActiveIndentation:Pe(he.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function Pe($,K,he){const Le=he.indexOf($);return Le===-1?K:he[Le]}class be extends P{constructor(){const K={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(112,"suggest",K,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[a.localize(129,null),a.localize(130,null)],default:K.insertMode,description:a.localize(131,null)},"editor.suggest.filterGraceful":{type:"boolean",default:K.filterGraceful,description:a.localize(132,null)},"editor.suggest.localityBonus":{type:"boolean",default:K.localityBonus,description:a.localize(133,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:K.shareSuggestSelections,markdownDescription:a.localize(134,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[a.localize(135,null),a.localize(136,null),a.localize(137,null),a.localize(138,null)],default:K.selectionMode,markdownDescription:a.localize(139,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:K.snippetsPreventQuickSuggestions,description:a.localize(140,null)},"editor.suggest.showIcons":{type:"boolean",default:K.showIcons,description:a.localize(141,null)},"editor.suggest.showStatusBar":{type:"boolean",default:K.showStatusBar,description:a.localize(142,null)},"editor.suggest.preview":{type:"boolean",default:K.preview,description:a.localize(143,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:K.showInlineDetails,description:a.localize(144,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:a.localize(145,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:a.localize(146,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:a.localize(147,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:a.localize(148,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:a.localize(149,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:a.localize(150,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:a.localize(151,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:a.localize(152,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:a.localize(153,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:a.localize(154,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:a.localize(155,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:a.localize(156,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:a.localize(157,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:a.localize(158,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:a.localize(159,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:a.localize(160,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:a.localize(161,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:a.localize(162,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:a.localize(163,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:a.localize(164,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:a.localize(165,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:a.localize(166,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:a.localize(167,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:a.localize(168,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:a.localize(169,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:a.localize(170,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:a.localize(171,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:a.localize(172,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:a.localize(173,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:a.localize(174,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:a.localize(175,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:a.localize(176,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const he=K;return{insertMode:i(he.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:u(he.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:u(he.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:u(he.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:u(he.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:i(he.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:u(he.showIcons,this.defaultValue.showIcons),showStatusBar:u(he.showStatusBar,this.defaultValue.showStatusBar),preview:u(he.preview,this.defaultValue.preview),previewMode:i(he.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:u(he.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:u(he.showMethods,this.defaultValue.showMethods),showFunctions:u(he.showFunctions,this.defaultValue.showFunctions),showConstructors:u(he.showConstructors,this.defaultValue.showConstructors),showDeprecated:u(he.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:u(he.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:u(he.showFields,this.defaultValue.showFields),showVariables:u(he.showVariables,this.defaultValue.showVariables),showClasses:u(he.showClasses,this.defaultValue.showClasses),showStructs:u(he.showStructs,this.defaultValue.showStructs),showInterfaces:u(he.showInterfaces,this.defaultValue.showInterfaces),showModules:u(he.showModules,this.defaultValue.showModules),showProperties:u(he.showProperties,this.defaultValue.showProperties),showEvents:u(he.showEvents,this.defaultValue.showEvents),showOperators:u(he.showOperators,this.defaultValue.showOperators),showUnits:u(he.showUnits,this.defaultValue.showUnits),showValues:u(he.showValues,this.defaultValue.showValues),showConstants:u(he.showConstants,this.defaultValue.showConstants),showEnums:u(he.showEnums,this.defaultValue.showEnums),showEnumMembers:u(he.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:u(he.showKeywords,this.defaultValue.showKeywords),showWords:u(he.showWords,this.defaultValue.showWords),showColors:u(he.showColors,this.defaultValue.showColors),showFiles:u(he.showFiles,this.defaultValue.showFiles),showReferences:u(he.showReferences,this.defaultValue.showReferences),showFolders:u(he.showFolders,this.defaultValue.showFolders),showTypeParameters:u(he.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:u(he.showSnippets,this.defaultValue.showSnippets),showUsers:u(he.showUsers,this.defaultValue.showUsers),showIssues:u(he.showIssues,this.defaultValue.showIssues)}}}class Ce extends P{constructor(){super(107,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:a.localize(177,null),default:!0,type:"boolean"}})}validate(K){return!K||typeof K!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:u(K.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}var ke;(function($){$[$.None=0]="None",$[$.Same=1]="Same",$[$.Indent=2]="Indent",$[$.DeepIndent=3]="DeepIndent"})(ke=e.WrappingIndent||(e.WrappingIndent={}));class He extends P{constructor(){super(131,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[a.localize(178,null),a.localize(179,null),a.localize(180,null),a.localize(181,null)],description:a.localize(182,null),default:"same"}})}validate(K){switch(K){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(K,he,Le){return he.get(2)===2?0:Le}}class Ge extends D{constructor(){super(139)}compute(K,he,Le){const Ne=he.get(138);return{isDominatedByLongLines:K.isDominatedByLongLines,isWordWrapMinified:Ne.isWordWrapMinified,isViewportWrapping:Ne.isViewportWrapping,wrappingColumn:Ne.wrappingColumn}}}class nt extends P{constructor(){const K={enabled:!0};super(33,"dropIntoEditor",K,{"editor.dropIntoEditor.enabled":{type:"boolean",default:K.enabled,markdownDescription:a.localize(183,null)}})}validate(K){return!K||typeof K!="object"?this.defaultValue:{enabled:u(K.enabled,this.defaultValue.enabled)}}}const Qe="Consolas, 'Courier New', monospace",tt="Menlo, Monaco, 'Courier New', monospace",rt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:L.isMacintosh?tt:L.isLinux?rt:Qe,fontWeight:"normal",fontSize:L.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Be($){return e.editorOptionsRegistry[$.id]=$,$}var it;(function($){$[$.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",$[$.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",$[$.accessibilitySupport=2]="accessibilitySupport",$[$.accessibilityPageSize=3]="accessibilityPageSize",$[$.ariaLabel=4]="ariaLabel",$[$.autoClosingBrackets=5]="autoClosingBrackets",$[$.autoClosingDelete=6]="autoClosingDelete",$[$.autoClosingOvertype=7]="autoClosingOvertype",$[$.autoClosingQuotes=8]="autoClosingQuotes",$[$.autoIndent=9]="autoIndent",$[$.automaticLayout=10]="automaticLayout",$[$.autoSurround=11]="autoSurround",$[$.bracketPairColorization=12]="bracketPairColorization",$[$.guides=13]="guides",$[$.codeLens=14]="codeLens",$[$.codeLensFontFamily=15]="codeLensFontFamily",$[$.codeLensFontSize=16]="codeLensFontSize",$[$.colorDecorators=17]="colorDecorators",$[$.colorDecoratorsLimit=18]="colorDecoratorsLimit",$[$.columnSelection=19]="columnSelection",$[$.comments=20]="comments",$[$.contextmenu=21]="contextmenu",$[$.copyWithSyntaxHighlighting=22]="copyWithSyntaxHighlighting",$[$.cursorBlinking=23]="cursorBlinking",$[$.cursorSmoothCaretAnimation=24]="cursorSmoothCaretAnimation",$[$.cursorStyle=25]="cursorStyle",$[$.cursorSurroundingLines=26]="cursorSurroundingLines",$[$.cursorSurroundingLinesStyle=27]="cursorSurroundingLinesStyle",$[$.cursorWidth=28]="cursorWidth",$[$.disableLayerHinting=29]="disableLayerHinting",$[$.disableMonospaceOptimizations=30]="disableMonospaceOptimizations",$[$.domReadOnly=31]="domReadOnly",$[$.dragAndDrop=32]="dragAndDrop",$[$.dropIntoEditor=33]="dropIntoEditor",$[$.emptySelectionClipboard=34]="emptySelectionClipboard",$[$.experimentalWhitespaceRendering=35]="experimentalWhitespaceRendering",$[$.extraEditorClassName=36]="extraEditorClassName",$[$.fastScrollSensitivity=37]="fastScrollSensitivity",$[$.find=38]="find",$[$.fixedOverflowWidgets=39]="fixedOverflowWidgets",$[$.folding=40]="folding",$[$.foldingStrategy=41]="foldingStrategy",$[$.foldingHighlight=42]="foldingHighlight",$[$.foldingImportsByDefault=43]="foldingImportsByDefault",$[$.foldingMaximumRegions=44]="foldingMaximumRegions",$[$.unfoldOnClickAfterEndOfLine=45]="unfoldOnClickAfterEndOfLine",$[$.fontFamily=46]="fontFamily",$[$.fontInfo=47]="fontInfo",$[$.fontLigatures=48]="fontLigatures",$[$.fontSize=49]="fontSize",$[$.fontWeight=50]="fontWeight",$[$.fontVariations=51]="fontVariations",$[$.formatOnPaste=52]="formatOnPaste",$[$.formatOnType=53]="formatOnType",$[$.glyphMargin=54]="glyphMargin",$[$.gotoLocation=55]="gotoLocation",$[$.hideCursorInOverviewRuler=56]="hideCursorInOverviewRuler",$[$.hover=57]="hover",$[$.inDiffEditor=58]="inDiffEditor",$[$.inlineSuggest=59]="inlineSuggest",$[$.letterSpacing=60]="letterSpacing",$[$.lightbulb=61]="lightbulb",$[$.lineDecorationsWidth=62]="lineDecorationsWidth",$[$.lineHeight=63]="lineHeight",$[$.lineNumbers=64]="lineNumbers",$[$.lineNumbersMinChars=65]="lineNumbersMinChars",$[$.linkedEditing=66]="linkedEditing",$[$.links=67]="links",$[$.matchBrackets=68]="matchBrackets",$[$.minimap=69]="minimap",$[$.mouseStyle=70]="mouseStyle",$[$.mouseWheelScrollSensitivity=71]="mouseWheelScrollSensitivity",$[$.mouseWheelZoom=72]="mouseWheelZoom",$[$.multiCursorMergeOverlapping=73]="multiCursorMergeOverlapping",$[$.multiCursorModifier=74]="multiCursorModifier",$[$.multiCursorPaste=75]="multiCursorPaste",$[$.multiCursorLimit=76]="multiCursorLimit",$[$.occurrencesHighlight=77]="occurrencesHighlight",$[$.overviewRulerBorder=78]="overviewRulerBorder",$[$.overviewRulerLanes=79]="overviewRulerLanes",$[$.padding=80]="padding",$[$.parameterHints=81]="parameterHints",$[$.peekWidgetDefaultFocus=82]="peekWidgetDefaultFocus",$[$.definitionLinkOpensInPeek=83]="definitionLinkOpensInPeek",$[$.quickSuggestions=84]="quickSuggestions",$[$.quickSuggestionsDelay=85]="quickSuggestionsDelay",$[$.readOnly=86]="readOnly",$[$.renameOnType=87]="renameOnType",$[$.renderControlCharacters=88]="renderControlCharacters",$[$.renderFinalNewline=89]="renderFinalNewline",$[$.renderLineHighlight=90]="renderLineHighlight",$[$.renderLineHighlightOnlyWhenFocus=91]="renderLineHighlightOnlyWhenFocus",$[$.renderValidationDecorations=92]="renderValidationDecorations",$[$.renderWhitespace=93]="renderWhitespace",$[$.revealHorizontalRightPadding=94]="revealHorizontalRightPadding",$[$.roundedSelection=95]="roundedSelection",$[$.rulers=96]="rulers",$[$.scrollbar=97]="scrollbar",$[$.scrollBeyondLastColumn=98]="scrollBeyondLastColumn",$[$.scrollBeyondLastLine=99]="scrollBeyondLastLine",$[$.scrollPredominantAxis=100]="scrollPredominantAxis",$[$.selectionClipboard=101]="selectionClipboard",$[$.selectionHighlight=102]="selectionHighlight",$[$.selectOnLineNumbers=103]="selectOnLineNumbers",$[$.showFoldingControls=104]="showFoldingControls",$[$.showUnused=105]="showUnused",$[$.snippetSuggestions=106]="snippetSuggestions",$[$.smartSelect=107]="smartSelect",$[$.smoothScrolling=108]="smoothScrolling",$[$.stickyScroll=109]="stickyScroll",$[$.stickyTabStops=110]="stickyTabStops",$[$.stopRenderingLineAfter=111]="stopRenderingLineAfter",$[$.suggest=112]="suggest",$[$.suggestFontSize=113]="suggestFontSize",$[$.suggestLineHeight=114]="suggestLineHeight",$[$.suggestOnTriggerCharacters=115]="suggestOnTriggerCharacters",$[$.suggestSelection=116]="suggestSelection",$[$.tabCompletion=117]="tabCompletion",$[$.tabIndex=118]="tabIndex",$[$.unicodeHighlighting=119]="unicodeHighlighting",$[$.unusualLineTerminators=120]="unusualLineTerminators",$[$.useShadowDOM=121]="useShadowDOM",$[$.useTabStops=122]="useTabStops",$[$.wordBreak=123]="wordBreak",$[$.wordSeparators=124]="wordSeparators",$[$.wordWrap=125]="wordWrap",$[$.wordWrapBreakAfterCharacters=126]="wordWrapBreakAfterCharacters",$[$.wordWrapBreakBeforeCharacters=127]="wordWrapBreakBeforeCharacters",$[$.wordWrapColumn=128]="wordWrapColumn",$[$.wordWrapOverride1=129]="wordWrapOverride1",$[$.wordWrapOverride2=130]="wordWrapOverride2",$[$.wrappingIndent=131]="wrappingIndent",$[$.wrappingStrategy=132]="wrappingStrategy",$[$.showDeprecated=133]="showDeprecated",$[$.inlayHints=134]="inlayHints",$[$.editorClassName=135]="editorClassName",$[$.pixelRatio=136]="pixelRatio",$[$.tabFocusMode=137]="tabFocusMode",$[$.layoutInfo=138]="layoutInfo",$[$.wrappingInfo=139]="wrappingInfo"})(it=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Be(new h(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:a.localize(184,null)})),acceptSuggestionOnEnter:Be(new s(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",a.localize(185,null),""],markdownDescription:a.localize(186,null)})),accessibilitySupport:Be(new c),accessibilityPageSize:Be(new b(3,"accessibilityPageSize",10,1,1073741824,{description:a.localize(187,null),tags:["accessibility"]})),ariaLabel:Be(new g(4,"ariaLabel",a.localize(188,null))),autoClosingBrackets:Be(new s(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",a.localize(189,null),a.localize(190,null),""],description:a.localize(191,null)})),autoClosingDelete:Be(new s(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",a.localize(192,null),""],description:a.localize(193,null)})),autoClosingOvertype:Be(new s(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",a.localize(194,null),""],description:a.localize(195,null)})),autoClosingQuotes:Be(new s(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",a.localize(196,null),a.localize(197,null),""],description:a.localize(198,null)})),autoIndent:Be(new r(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],o,{enumDescriptions:[a.localize(199,null),a.localize(200,null),a.localize(201,null),a.localize(202,null),a.localize(203,null)],description:a.localize(204,null)})),automaticLayout:Be(new h(10,"automaticLayout",!1)),autoSurround:Be(new s(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[a.localize(205,null),a.localize(206,null),a.localize(207,null),""],description:a.localize(208,null)})),bracketPairColorization:Be(new de),bracketPairGuides:Be(new we),stickyTabStops:Be(new h(110,"stickyTabStops",!1,{description:a.localize(209,null)})),codeLens:Be(new h(14,"codeLens",!0,{description:a.localize(210,null)})),codeLensFontFamily:Be(new g(15,"codeLensFontFamily","",{description:a.localize(211,null)})),codeLensFontSize:Be(new b(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:a.localize(212,null)})),colorDecorators:Be(new h(17,"colorDecorators",!0,{description:a.localize(213,null)})),colorDecoratorsLimit:Be(new b(18,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:a.localize(214,null)})),columnSelection:Be(new h(19,"columnSelection",!1,{description:a.localize(215,null)})),comments:Be(new m),contextmenu:Be(new h(21,"contextmenu",!0)),copyWithSyntaxHighlighting:Be(new h(22,"copyWithSyntaxHighlighting",!0,{description:a.localize(216,null)})),cursorBlinking:Be(new r(23,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],t,{description:a.localize(217,null)})),cursorSmoothCaretAnimation:Be(new s(24,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[a.localize(218,null),a.localize(219,null),a.localize(220,null)],description:a.localize(221,null)})),cursorStyle:Be(new r(25,"cursorStyle",d.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],w,{description:a.localize(222,null)})),cursorSurroundingLines:Be(new b(26,"cursorSurroundingLines",0,0,1073741824,{description:a.localize(223,null)})),cursorSurroundingLinesStyle:Be(new s(27,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[a.localize(224,null),a.localize(225,null)],description:a.localize(226,null)})),cursorWidth:Be(new b(28,"cursorWidth",0,0,1073741824,{markdownDescription:a.localize(227,null)})),disableLayerHinting:Be(new h(29,"disableLayerHinting",!1)),disableMonospaceOptimizations:Be(new h(30,"disableMonospaceOptimizations",!1)),domReadOnly:Be(new h(31,"domReadOnly",!1)),dragAndDrop:Be(new h(32,"dragAndDrop",!0,{description:a.localize(228,null)})),emptySelectionClipboard:Be(new j),dropIntoEditor:Be(new nt),stickyScroll:Be(new ge),experimentalWhitespaceRendering:Be(new s(35,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[a.localize(229,null),a.localize(230,null),a.localize(231,null)],description:a.localize(232,null)})),extraEditorClassName:Be(new g(36,"extraEditorClassName","")),fastScrollSensitivity:Be(new C(37,"fastScrollSensitivity",5,$=>$<=0?5:$,{markdownDescription:a.localize(233,null)})),find:Be(new V),fixedOverflowWidgets:Be(new h(39,"fixedOverflowWidgets",!1)),folding:Be(new h(40,"folding",!0,{description:a.localize(234,null)})),foldingStrategy:Be(new s(41,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[a.localize(235,null),a.localize(236,null)],description:a.localize(237,null)})),foldingHighlight:Be(new h(42,"foldingHighlight",!0,{description:a.localize(238,null)})),foldingImportsByDefault:Be(new h(43,"foldingImportsByDefault",!1,{description:a.localize(239,null)})),foldingMaximumRegions:Be(new b(44,"foldingMaximumRegions",5e3,10,65e3,{description:a.localize(240,null)})),unfoldOnClickAfterEndOfLine:Be(new h(45,"unfoldOnClickAfterEndOfLine",!1,{description:a.localize(241,null)})),fontFamily:Be(new g(46,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:a.localize(242,null)})),fontInfo:Be(new U),fontLigatures2:Be(new Q),fontSize:Be(new T),fontWeight:Be(new F),fontVariations:Be(new x),formatOnPaste:Be(new h(52,"formatOnPaste",!1,{description:a.localize(243,null)})),formatOnType:Be(new h(53,"formatOnType",!1,{description:a.localize(244,null)})),glyphMargin:Be(new h(54,"glyphMargin",!0,{description:a.localize(245,null)})),gotoLocation:Be(new B),hideCursorInOverviewRuler:Be(new h(56,"hideCursorInOverviewRuler",!1,{description:a.localize(246,null)})),hover:Be(new Z),inDiffEditor:Be(new h(58,"inDiffEditor",!1)),letterSpacing:Be(new C(60,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,$=>C.clamp($,-5,20),{description:a.localize(247,null)})),lightbulb:Be(new ie),lineDecorationsWidth:Be(new J),lineHeight:Be(new ee),lineNumbers:Be(new ne),lineNumbersMinChars:Be(new b(65,"lineNumbersMinChars",5,1,300)),linkedEditing:Be(new h(66,"linkedEditing",!1,{description:a.localize(248,null)})),links:Be(new h(67,"links",!0,{description:a.localize(249,null)})),matchBrackets:Be(new s(68,"matchBrackets","always",["always","near","never"],{description:a.localize(250,null)})),minimap:Be(new me),mouseStyle:Be(new s(70,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Be(new C(71,"mouseWheelScrollSensitivity",1,$=>$===0?1:$,{markdownDescription:a.localize(251,null)})),mouseWheelZoom:Be(new h(72,"mouseWheelZoom",!1,{markdownDescription:a.localize(252,null)})),multiCursorMergeOverlapping:Be(new h(73,"multiCursorMergeOverlapping",!0,{description:a.localize(253,null)})),multiCursorModifier:Be(new r(74,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ve,{markdownEnumDescriptions:[a.localize(254,null),a.localize(255,null)],markdownDescription:a.localize(256,null)})),multiCursorPaste:Be(new s(75,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[a.localize(257,null),a.localize(258,null)],markdownDescription:a.localize(259,null)})),multiCursorLimit:Be(new b(76,"multiCursorLimit",1e4,1,1e5,{markdownDescription:a.localize(260,null)})),occurrencesHighlight:Be(new h(77,"occurrencesHighlight",!0,{description:a.localize(261,null)})),overviewRulerBorder:Be(new h(78,"overviewRulerBorder",!0,{description:a.localize(262,null)})),overviewRulerLanes:Be(new b(79,"overviewRulerLanes",3,0,3)),padding:Be(new Ie),parameterHints:Be(new Re),peekWidgetDefaultFocus:Be(new s(82,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[a.localize(263,null),a.localize(264,null)],description:a.localize(265,null)})),definitionLinkOpensInPeek:Be(new h(83,"definitionLinkOpensInPeek",!1,{description:a.localize(266,null)})),quickSuggestions:Be(new le),quickSuggestionsDelay:Be(new b(85,"quickSuggestionsDelay",10,0,1073741824,{description:a.localize(267,null)})),readOnly:Be(new h(86,"readOnly",!1)),renameOnType:Be(new h(87,"renameOnType",!1,{description:a.localize(268,null),markdownDeprecationMessage:a.localize(269,null)})),renderControlCharacters:Be(new h(88,"renderControlCharacters",!0,{description:a.localize(270,null),restricted:!0})),renderFinalNewline:Be(new s(89,"renderFinalNewline",L.isLinux?"dimmed":"on",["off","on","dimmed"],{description:a.localize(271,null)})),renderLineHighlight:Be(new s(90,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",a.localize(272,null)],description:a.localize(273,null)})),renderLineHighlightOnlyWhenFocus:Be(new h(91,"renderLineHighlightOnlyWhenFocus",!1,{description:a.localize(274,null)})),renderValidationDecorations:Be(new s(92,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Be(new s(93,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",a.localize(275,null),a.localize(276,null),a.localize(277,null),""],description:a.localize(278,null)})),revealHorizontalRightPadding:Be(new b(94,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Be(new h(95,"roundedSelection",!0,{description:a.localize(279,null)})),rulers:Be(new oe),scrollbar:Be(new z),scrollBeyondLastColumn:Be(new b(98,"scrollBeyondLastColumn",4,0,1073741824,{description:a.localize(280,null)})),scrollBeyondLastLine:Be(new h(99,"scrollBeyondLastLine",!0,{description:a.localize(281,null)})),scrollPredominantAxis:Be(new h(100,"scrollPredominantAxis",!0,{description:a.localize(282,null)})),selectionClipboard:Be(new h(101,"selectionClipboard",!0,{description:a.localize(283,null),included:L.isLinux})),selectionHighlight:Be(new h(102,"selectionHighlight",!0,{description:a.localize(284,null)})),selectOnLineNumbers:Be(new h(103,"selectOnLineNumbers",!0)),showFoldingControls:Be(new s(104,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[a.localize(285,null),a.localize(286,null),a.localize(287,null)],description:a.localize(288,null)})),showUnused:Be(new h(105,"showUnused",!0,{description:a.localize(289,null)})),showDeprecated:Be(new h(133,"showDeprecated",!0,{description:a.localize(290,null)})),inlayHints:Be(new X),snippetSuggestions:Be(new s(106,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[a.localize(291,null),a.localize(292,null),a.localize(293,null),a.localize(294,null)],description:a.localize(295,null)})),smartSelect:Be(new Ce),smoothScrolling:Be(new h(108,"smoothScrolling",!1,{description:a.localize(296,null)})),stopRenderingLineAfter:Be(new b(111,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Be(new be),inlineSuggest:Be(new te),suggestFontSize:Be(new b(113,"suggestFontSize",0,0,1e3,{markdownDescription:a.localize(297,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Be(new b(114,"suggestLineHeight",0,0,1e3,{markdownDescription:a.localize(298,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Be(new h(115,"suggestOnTriggerCharacters",!0,{description:a.localize(299,null)})),suggestSelection:Be(new s(116,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[a.localize(300,null),a.localize(301,null),a.localize(302,null)],description:a.localize(303,null)})),tabCompletion:Be(new s(117,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[a.localize(304,null),a.localize(305,null),a.localize(306,null)],description:a.localize(307,null)})),tabIndex:Be(new b(118,"tabIndex",0,-1,1073741824)),unicodeHighlight:Be(new G),unusualLineTerminators:Be(new s(120,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[a.localize(308,null),a.localize(309,null),a.localize(310,null)],description:a.localize(311,null)})),useShadowDOM:Be(new h(121,"useShadowDOM",!0)),useTabStops:Be(new h(122,"useTabStops",!0,{description:a.localize(312,null)})),wordBreak:Be(new s(123,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[a.localize(313,null),a.localize(314,null)],description:a.localize(315,null)})),wordSeparators:Be(new g(124,"wordSeparators",l.USUAL_WORD_SEPARATORS,{description:a.localize(316,null)})),wordWrap:Be(new s(125,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[a.localize(317,null),a.localize(318,null),a.localize(319,null),a.localize(320,null)],description:a.localize(321,null)})),wordWrapBreakAfterCharacters:Be(new g(126,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Be(new g(127,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Be(new b(128,"wordWrapColumn",80,1,1073741824,{markdownDescription:a.localize(322,null)})),wordWrapOverride1:Be(new s(129,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Be(new s(130,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Be(new N),pixelRatio:Be(new ae),tabFocusMode:Be(new h(137,"tabFocusMode",!1,{markdownDescription:a.localize(323,null)})),layoutInfo:Be(new H),wrappingInfo:Be(new Ge),wrappingIndent:Be(new He),wrappingStrategy:Be(new Y)}}),define(ye[168],De([19,20]),function(re,e){return re.create("vs/platform/configuration/common/configurationRegistry",e)}),define(ye[169],De([19,20]),function(re,e){return re.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(ye[170],De([19,20]),function(re,e){return re.create("vs/platform/extensions/common/extensionValidator",e)}),define(ye[171],De([19,20]),function(re,e){return re.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(ye[172],De([19,20]),function(re,e){return re.create("vs/platform/files/common/files",e)}),define(ye[173],De([19,20]),function(re,e){return re.create("vs/platform/markers/common/markers",e)}),define(ye[174],De([19,20]),function(re,e){return re.create("vs/platform/theme/common/iconRegistry",e)}),define(ye[175],De([19,20]),function(re,e){return re.create("vs/platform/workspace/common/workspace",e)}),define(ye[176],De([19,20]),function(re,e){return re.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(ye[177],De([19,20]),function(re,e){return re.create("vs/workbench/api/common/extHostExtensionService",e)}),define(ye[178],De([19,20]),function(re,e){return re.create("vs/workbench/api/common/extHostProgress",e)}),define(ye[179],De([19,20]),function(re,e){return re.create("vs/workbench/api/common/extHostStatusBar",e)}),define(ye[180],De([19,20]),function(re,e){return re.create("vs/workbench/api/common/extHostTelemetry",e)}),define(ye[181],De([19,20]),function(re,e){return re.create("vs/workbench/api/common/extHostTerminalService",e)}),define(ye[182],De([19,20]),function(re,e){return re.create("vs/workbench/api/common/extHostTreeViews",e)}),define(ye[183],De([19,20]),function(re,e){return re.create("vs/workbench/api/common/extHostWorkspace",e)}),define(ye[184],De([19,20]),function(re,e){return re.create("vs/workbench/api/node/extHostDebugService",e)}),define(ye[185],De([19,20]),function(re,e){return re.create("vs/workbench/api/node/extHostTunnelService",e)}),define(ye[186],De([19,20]),function(re,e){return re.create("vs/workbench/common/editor",e)}),define(ye[187],De([19,20]),function(re,e){return re.create("vs/workbench/common/views",e)}),define(ye[188],De([19,20]),function(re,e){return re.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(ye[189],De([19,20]),function(re,e){return re.create("vs/workbench/contrib/debug/common/debug",e)}),define(ye[190],De([19,20]),function(re,e){return re.create("vs/workbench/contrib/debug/node/debugAdapter",e)}),define(ye[191],De([19,20]),function(re,e){return re.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(ye[192],De([19,20]),function(re,e){return re.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(ye[193],De([19,20]),function(re,e){return re.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(ye[194],De([19,20]),function(re,e){return re.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(ye[195],De([19,20]),function(re,e){return re.create("vs/workbench/services/search/common/queryBuilder",e)}),define(ye[196],De([1,0,11]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Scanner=e.TokenType=void 0;var L;(function(R){R[R.LParen=0]="LParen",R[R.RParen=1]="RParen",R[R.Neg=2]="Neg",R[R.Eq=3]="Eq",R[R.NotEq=4]="NotEq",R[R.Lt=5]="Lt",R[R.LtEq=6]="LtEq",R[R.Gt=7]="Gt",R[R.GtEq=8]="GtEq",R[R.RegexOp=9]="RegexOp",R[R.RegexStr=10]="RegexStr",R[R.True=11]="True",R[R.False=12]="False",R[R.In=13]="In",R[R.Not=14]="Not",R[R.And=15]="And",R[R.Or=16]="Or",R[R.Str=17]="Str",R[R.QuotedStr=18]="QuotedStr",R[R.Error=19]="Error",R[R.EOF=20]="EOF"})(L=e.TokenType||(e.TokenType={}));class l{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static reportError(S){if(S.type!==19)throw(0,a.illegalArgument)(`expected an error token but got ${JSON.stringify(S)}`);switch(S.lexeme){case"=":return`Unexpected token '${S.lexeme}' at offset ${S.offset}. Did you mean '==' or '=~'?`;case"&":return`Unexpected token '${S.lexeme}' at offset ${S.offset}. Did you mean '&&'?`;case"|":return`Unexpected token '${S.lexeme}' at offset ${S.offset}. Did you mean '||'?`;default:{const A=S.lexeme;return A&&A.length>1&&A.startsWith("'")?`Unexpected token '${S.lexeme}' at offset ${S.offset}. Did you forget to close the string?`:A&&A.length>1&&A.endsWith("'")?`Unexpected token '${S.lexeme}' at offset ${S.offset}. Did you forget to open the string?`:`Unexpected token '${S.lexeme}' at offset ${S.offset}`}}}static getLexeme(S){switch(S.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return"==";case 4:return"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return S.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return S.lexeme;case 18:return S.lexeme;case 19:return S.lexeme;case 20:return"EOF";default:throw(0,a.illegalState)(`unhandled token type: ${JSON.stringify(S)}; have you forgotten to add a case?`)}}get errorTokens(){return this.g}reset(S){return this.c=S,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:this.k(this.h(61)?4:2);break;case 39:this.o();break;case 47:this.q();break;case 61:this.h(61)?this.k(3):this.h(126)?this.k(9):this.l();break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l();break;case 124:this.h(124)?this.k(16):this.l();break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(S){return this.r()||this.c.charCodeAt(this.e)!==S?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(S){this.f.push({type:S,offset:this.d})}l(){const S={type:19,offset:this.d,lexeme:this.c.substring(this.d,this.e)};this.g.push(S),this.f.push(S)}n(){this.m.lastIndex=this.d;const S=this.m.exec(this.c);if(S){this.e=this.d+S[0].length;const A=this.c.substring(this.d,this.e),y=l.b.get(A);y?this.k(y):this.f.push({type:17,lexeme:A,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l();return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let S=this.e,A=!1,y=!1;for(;;){if(S>=this.c.length){this.e=S,this.l();return}const O=this.c.charCodeAt(S);if(A)A=!1;else if(O===47&&!y){S++;break}else O===91?y=!0:O===92?A=!0:O===93&&(y=!1);S++}for(;S<this.c.length&&l.a.has(this.c.charCodeAt(S));)S++;this.e=S;const I=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:I,offset:this.d})}r(){return this.e>=this.c.length}}l.a=new Set(["i","g","s","m","y","u"].map(R=>R.charCodeAt(0))),l.b=new Map([["not",14],["in",13],["false",12],["true",11]]),e.Scanner=l}),define(ye[197],De([1,0,11]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImplicitActivationEvents=e.ImplicitActivationEventsImpl=void 0;class L{constructor(){this.a=new Map}register(R,S){this.a.set(R,S)}updateManifest(R){if(!(typeof R.main>"u"&&typeof R.browser>"u")&&(R.activationEvents===void 0&&Object.assign(R,{activationEvents:[]}),!(!Array.isArray(R.activationEvents)||!R.contributes)))for(const S in R.contributes){const A=this.a.get(S);if(!A)continue;const y=R.contributes[S],I=Array.isArray(y)?y:[y];try{A(I,R.activationEvents)}catch(O){(0,a.onUnexpectedError)(O)}}}}e.ImplicitActivationEventsImpl=L,e.ImplicitActivationEvents=new L}),define(ye[198],De([1,0,24,37,170,319]),function(re,e,a,L,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const S=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,A=/^-(\d{4})(\d{2})(\d{2})$/;function y(h){return h=h.trim(),h==="*"||S.test(h)}e.isValidVersionStr=y;function I(h){if(!y(h))return null;if(h=h.trim(),h==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const p=h.match(S);return p?{hasCaret:p[1]==="^",hasGreaterEquals:p[1]===">=",majorBase:p[2]==="x"?0:parseInt(p[2],10),majorMustEqual:p[2]!=="x",minorBase:p[4]==="x"?0:parseInt(p[4],10),minorMustEqual:p[4]!=="x",patchBase:p[6]==="x"?0:parseInt(p[6],10),patchMustEqual:p[6]!=="x",preRelease:p[8]||null}:null}e.parseVersion=I;function O(h){if(!h)return null;const p=h.majorBase,b=h.majorMustEqual,C=h.minorBase;let g=h.minorMustEqual;const i=h.patchBase;let s=h.patchMustEqual;h.hasCaret&&(p===0||(g=!1),s=!1);let r=0;if(h.preRelease){const o=A.exec(h.preRelease);if(o){const[,c,m,n]=o;r=Date.UTC(Number(c),Number(m)-1,Number(n))}}return{majorBase:p,majorMustEqual:b,minorBase:C,minorMustEqual:g,patchBase:i,patchMustEqual:s,isMinimum:h.hasGreaterEquals,notBefore:r}}e.normalizeVersion=O;function P(h,p,b){let C;typeof h=="string"?C=O(I(h)):C=h;let g;p instanceof Date?g=p.getTime():typeof p=="string"&&(g=new Date(p).getTime());let i;if(typeof b=="string"?i=O(I(b)):i=b,!C||!i)return!1;const s=C.majorBase,r=C.minorBase,o=C.patchBase;let c=i.majorBase,m=i.minorBase,n=i.patchBase;const t=i.notBefore;let d=i.majorMustEqual,E=i.minorMustEqual,w=i.patchMustEqual;return i.isMinimum?s>c?!0:s<c?!1:r>m?!0:r<m||g&&g<t?!1:o>=n:(s===1&&c===0&&(!d||!E||!w)&&(c=1,m=0,n=0,d=!0,E=!1,w=!1),s<c?!1:s>c?!d:r<m?!1:r>m?!E:o<n?!1:o>n?!w:!(g&&g<t))}e.isValidVersion=P;function v(h,p,b,C,g){const i=[];if(typeof C.publisher<"u"&&typeof C.publisher!="string")return i.push([L.default.Error,l.localize(0,null)]),i;if(typeof C.name!="string")return i.push([L.default.Error,l.localize(1,null,"name")]),i;if(typeof C.version!="string")return i.push([L.default.Error,l.localize(2,null,"version")]),i;if(!C.engines)return i.push([L.default.Error,l.localize(3,null,"engines")]),i;if(typeof C.engines.vscode!="string")return i.push([L.default.Error,l.localize(4,null,"engines.vscode")]),i;if(typeof C.extensionDependencies<"u"&&!u(C.extensionDependencies))return i.push([L.default.Error,l.localize(5,null,"extensionDependencies")]),i;if(typeof C.activationEvents<"u"){if(!u(C.activationEvents))return i.push([L.default.Error,l.localize(6,null,"activationEvents")]),i;if(typeof C.main>"u"&&typeof C.browser>"u")return i.push([L.default.Error,l.localize(7,null,"activationEvents","main")]),i}if(typeof C.extensionKind<"u"&&typeof C.main>"u"&&i.push([L.default.Warning,l.localize(8,null,"extensionKind")]),typeof C.main<"u"){if(typeof C.main!="string")return i.push([L.default.Error,l.localize(9,null,"main")]),i;{const o=(0,a.joinPath)(b,C.main);(0,a.isEqualOrParent)(o,b)||i.push([L.default.Warning,l.localize(10,null,o.path,b.path)])}if(typeof C.activationEvents>"u")return i.push([L.default.Error,l.localize(11,null,"activationEvents","main")]),i}if(typeof C.browser<"u"){if(typeof C.browser!="string")return i.push([L.default.Error,l.localize(12,null,"browser")]),i;{const o=(0,a.joinPath)(b,C.browser);(0,a.isEqualOrParent)(o,b)||i.push([L.default.Warning,l.localize(13,null,o.path,b.path)])}if(typeof C.activationEvents>"u")return i.push([L.default.Error,l.localize(14,null,"activationEvents","browser")]),i}if(!R.valid(C.version))return i.push([L.default.Error,l.localize(15,null)]),i;const s=[];if(!k(h,p,C,g,s))for(const o of s)i.push([L.default.Error,o]);return i}e.validateExtensionManifest=v;function k(h,p,b,C,g){return C||typeof b.main>"u"&&typeof b.browser>"u"?!0:f(h,p,b.engines.vscode,g)}e.isValidExtensionVersion=k;function D(h,p,b){return h==="*"||f(p,b,h)}e.isEngineValid=D;function f(h,p,b,C=[]){const g=O(I(b));if(!g)return C.push(l.localize(16,null,b)),!1;if(g.majorBase===0){if(!g.majorMustEqual||!g.minorMustEqual)return C.push(l.localize(17,null,b)),!1}else if(!g.majorMustEqual)return C.push(l.localize(18,null,b)),!1;return P(h,p,g)?!0:(C.push(l.localize(19,null,h,b)),!1)}function u(h){if(!Array.isArray(h))return!1;for(let p=0,b=h.length;p<b;p++)if(typeof h[p]!="string")return!1;return!0}}),define(ye[122],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class a{constructor(l,R=[],S=!1){this.ctor=l,this.staticArguments=R,this.supportsDelayedInstantiation=S}}e.SyncDescriptor=a}),define(ye[90],De([1,0,122]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=e.InstantiationType=void 0;const L=[];var l;(function(A){A[A.Eager=0]="Eager",A[A.Delayed=1]="Delayed"})(l=e.InstantiationType||(e.InstantiationType={}));function R(A,y,I){y instanceof a.SyncDescriptor||(y=new a.SyncDescriptor(y,[],Boolean(I))),L.push([A,y])}e.registerSingleton=R;function S(){return L}e.getSingletonServiceDescriptors=S}),define(ye[199],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class a{constructor(R,S){this.key=R,this.data=S,this.incoming=new Map,this.outgoing=new Map}}e.Node=a;class L{constructor(R){this.b=R,this.a=new Map}roots(){const R=[];for(const S of this.a.values())S.outgoing.size===0&&R.push(S);return R}insertEdge(R,S){const A=this.lookupOrInsertNode(R),y=this.lookupOrInsertNode(S);A.outgoing.set(y.key,y),y.incoming.set(A.key,A)}removeNode(R){const S=this.b(R);this.a.delete(S);for(const A of this.a.values())A.outgoing.delete(S),A.incoming.delete(S)}lookupOrInsertNode(R){const S=this.b(R);let A=this.a.get(S);return A||(A=new a(S,R),this.a.set(S,A)),A}lookup(R){return this.a.get(this.b(R))}isEmpty(){return this.a.size===0}toString(){const R=[];for(const[S,A]of this.a)R.push(`${S}
	(-> incoming)[${[...A.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...A.outgoing.keys()].join(",")}]
`);return R.join(`
`)}findCycleSlow(){for(const[R,S]of this.a){const A=new Set([R]),y=this.c(S,A);if(y)return y}}c(R,S){for(const[A,y]of R.outgoing){if(S.has(A))return[...S,A].join(" -> ");S.add(A);const I=this.c(y,S);if(I)return I;S.delete(A)}}}e.Graph=L}),define(ye[4],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var a;(function(S){S.serviceIds=new Map,S.DI_TARGET="$di$target",S.DI_DEPENDENCIES="$di$dependencies";function A(y){return y[S.DI_DEPENDENCIES]||[]}S.getServiceDependencies=A})(a=e._util||(e._util={})),e.IInstantiationService=l("instantiationService");function L(S,A,y){A[a.DI_TARGET]===A?A[a.DI_DEPENDENCIES].push({id:S,index:y}):(A[a.DI_DEPENDENCIES]=[{id:S,index:y}],A[a.DI_TARGET]=A)}function l(S){if(a.serviceIds.has(S))return a.serviceIds.get(S);const A=function(y,I,O){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(A,y,O)};return A.toString=()=>S,a.serviceIds.set(S,A),A}e.createDecorator=l;function R(S){return S}e.refineServiceDecorator=R}),define(ye[54],De([1,0,10,2,4]),function(re,e,a,L,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,l.createDecorator)("configurationService");function R(u){return u&&typeof u=="object"&&(!u.overrideIdentifier||typeof u.overrideIdentifier=="string")&&(!u.resource||u.resource instanceof L.URI)}e.isConfigurationOverrides=R;function S(u){return u&&typeof u=="object"&&(!u.overrideIdentifiers||Array.isArray(u.overrideIdentifiers))&&!u.overrideIdentifier&&(!u.resource||u.resource instanceof L.URI)}e.isConfigurationUpdateOverrides=S;var A;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.USER=2]="USER",u[u.USER_LOCAL=3]="USER_LOCAL",u[u.USER_REMOTE=4]="USER_REMOTE",u[u.WORKSPACE=5]="WORKSPACE",u[u.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",u[u.DEFAULT=7]="DEFAULT",u[u.MEMORY=8]="MEMORY"})(A=e.ConfigurationTarget||(e.ConfigurationTarget={}));function y(u){switch(u){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=y;function I(u,h){const p=Object.create(null);for(const b in u)O(p,b,u[b],h);return p}e.toValuesTree=I;function O(u,h,p,b){const C=h.split("."),g=C.pop();let i=u;for(let s=0;s<C.length;s++){const r=C[s];let o=i[r];switch(typeof o){case"undefined":o=i[r]=Object.create(null);break;case"object":break;default:b(`Ignoring ${h} as ${C.slice(0,s+1).join(".")} is ${JSON.stringify(o)}`);return}i=o}if(typeof i=="object"&&i!==null)try{i[g]=p}catch{b(`Ignoring ${h} as ${C.join(".")} is ${JSON.stringify(i)}`)}else b(`Ignoring ${h} as ${C.join(".")} is ${JSON.stringify(i)}`)}e.addToValueTree=O;function P(u,h){const p=h.split(".");v(u,p)}e.removeFromValueTree=P;function v(u,h){const p=h.shift();if(h.length===0){delete u[p];return}if(Object.keys(u).indexOf(p)!==-1){const b=u[p];typeof b=="object"&&!Array.isArray(b)&&(v(b,h),Object.keys(b).length===0&&delete u[p])}}function k(u,h,p){function b(i,s){let r=i;for(const o of s){if(typeof r!="object"||r===null)return;r=r[o]}return r}const C=h.split("."),g=b(u,C);return typeof g>"u"?p:g}e.getConfigurationValue=k;function D(u,h,p){Object.keys(h).forEach(b=>{b!=="__proto__"&&(b in u?a.isObject(u[b])&&a.isObject(h[b])?D(u[b],h[b],p):p&&(u[b]=h[b]):u[b]=h[b])})}e.merge=D;function f(u){return u.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=f}),define(ye[55],De([1,0,12,8,196,4]),function(re,e,a,L,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.Parser=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const S=new Map;S.set("false",!1),S.set("true",!0),S.set("isMac",a.isMacintosh),S.set("isLinux",a.isLinux),S.set("isWindows",a.isWindows),S.set("isWeb",a.isWeb),S.set("isMacNative",a.isMacintosh&&!a.isWeb),S.set("isEdge",a.isEdge),S.set("isFirefox",a.isFirefox),S.set("isChrome",a.isChrome),S.set("isSafari",a.isSafari);const A=Object.prototype.hasOwnProperty;var y;(function(U){U[U.False=0]="False",U[U.True=1]="True",U[U.Defined=2]="Defined",U[U.Not=3]="Not",U[U.Equals=4]="Equals",U[U.NotEquals=5]="NotEquals",U[U.And=6]="And",U[U.Regex=7]="Regex",U[U.NotRegex=8]="NotRegex",U[U.Or=9]="Or",U[U.In=10]="In",U[U.NotIn=11]="NotIn",U[U.Greater=12]="Greater",U[U.GreaterEquals=13]="GreaterEquals",U[U.Smaller=14]="Smaller",U[U.SmallerEquals=15]="SmallerEquals"})(y=e.ContextKeyExprType||(e.ContextKeyExprType={}));class I{static false(){return D.INSTANCE}static true(){return f.INSTANCE}static has(T){return u.create(T)}static equals(T,F){return h.create(T,F)}static notEquals(T,F){return C.create(T,F)}static regex(T,F){return m.create(T,F)}static in(T,F){return p.create(T,F)}static notIn(T,F){return b.create(T,F)}static not(T){return g.create(T)}static and(...T){return d.create(T,null,!0)}static or(...T){return E.create(T,null,!0)}static greater(T,F){return s.create(T,F)}static greaterEquals(T,F){return r.create(T,F)}static smaller(T,F){return o.create(T,F)}static smallerEquals(T,F){return c.create(T,F)}static deserializeOrErrorNew(T){if(!T)return{type:"error",lexingErrors:[],parsingErrors:[]};const F=new P,B=F.parse(T);return B===void 0?{type:"error",lexingErrors:F.lexingErrors.map(Z=>l.Scanner.reportError(Z)),parsingErrors:F.parsingErrors}:{type:"ok",expr:B}}static deserialize(T){if(!!T)return this.c(T)}static c(T){const F=T.split("||");return E.create(F.map(B=>this.d(B)),null,!0)}static d(T){const F=T.split("&&");return d.create(F.map(B=>this.f(B)),null,!0)}static f(T){if(T=T.trim(),T.indexOf("!=")>=0){const F=T.split("!=");return C.create(F[0].trim(),this.g(F[1]))}if(T.indexOf("==")>=0){const F=T.split("==");return h.create(F[0].trim(),this.g(F[1]))}if(T.indexOf("=~")>=0){const F=T.split("=~");return m.create(F[0].trim(),this.h(F[1]))}if(T.indexOf(" not in ")>=0){const F=T.split(" not in ");return b.create(F[0].trim(),this.g(F[1]))}if(T.indexOf(" in ")>=0){const F=T.split(" in ");return p.create(F[0].trim(),this.g(F[1]))}if(/^[^<=>]+>=[^<=>]+$/.test(T)){const F=T.split(">=");return r.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(T)){const F=T.split(">");return s.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(T)){const F=T.split("<=");return c.create(F[0].trim(),F[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(T)){const F=T.split("<");return o.create(F[0].trim(),F[1].trim())}return/^\!\s*/.test(T)?g.create(T.substr(1).trim()):u.create(T)}static g(T){if(T=T.trim(),T==="true")return!0;if(T==="false")return!1;const F=/^'([^']*)'$/.exec(T);return F?F[1].trim():T}static h(T){if((0,L.isFalsyOrWhitespace)(T))return null;const F=T.indexOf("/"),B=T.lastIndexOf("/");if(F===B||F<0)return null;const Z=T.slice(F+1,B),_=T[B+1]==="i"?"i":"";try{return new RegExp(Z,_)}catch{return null}}}e.ContextKeyExpr=I;class O extends Error{}class P{constructor(){this.c=new l.Scanner,this.d=[],this.f=0,this.g=[]}get lexingErrors(){return this.c.errorTokens}get parsingErrors(){return this.g}parse(T){if(T===""){this.g.push("Expected an expression but got an empty string");return}this.d=this.c.reset(T).scan(),this.f=0,this.g=[];try{const F=this.h();if(!this.D())throw this.z(this.C());return F}catch(F){if(!(F instanceof O)){const B=this.C();this.g.push(`Unexpected error: ${F} for token ${l.Scanner.getLexeme(B)} at offset ${B.offset}.`)}return}}h(){return this.k()}k(){const T=[this.l()];for(;this.v(16);){const F=this.l();T.push(F)}return T.length===1?T[0]:I.or(...T)}l(){const T=[this.o()];for(;this.v(15);){const F=this.o();T.push(F)}return T.length===1?T[0]:I.and(...T)}o(){if(this.v(2)){const T=this.C();switch(T.type){case 17:return this.w(),I.not(T.lexeme);case 11:return this.w(),I.false();case 12:return this.w(),I.true();default:throw this.y("KEY, 'true', or 'false'",T)}}return this.s()}s(){const T=this.C();switch(T.type){case 11:return this.w(),I.true();case 12:return this.w(),I.false();case 0:{this.w();const F=this.h();return this.x(1,"')'"),F}case 17:{const F=T.lexeme;if(this.w(),this.v(9)){const Z=this.C();switch(Z.type){case 10:case 19:{const _=[Z.lexeme];this.w();let H=this.C(),Y=0;for(let ee=0;ee<Z.lexeme.length;ee++)Z.lexeme.charCodeAt(ee)===40?Y++:Z.lexeme.charCodeAt(ee)===41&&Y--;for(;!this.D()&&H.type!==15&&H.type!==16;){switch(H.type){case 0:Y++;break;case 1:Y--;break;case 10:case 18:for(let ee=0;ee<H.lexeme.length;ee++)H.lexeme.charCodeAt(ee)===40?Y++:Z.lexeme.charCodeAt(ee)===41&&Y--}if(Y<0)break;_.push(l.Scanner.getLexeme(H)),this.w(),H=this.C()}const ie=_.join(""),ge=ie.lastIndexOf("/"),X=ge===ie.length-1?void 0:ie.substring(ge+1),J=new RegExp(ie.substring(1,ge),X);return I.regex(F,J)}case 18:{const _=Z.lexeme;this.w();let H=null;if(!(0,L.isFalsyOrWhitespace)(_)){const Y=_.indexOf("/"),ie=_.lastIndexOf("/");if(Y!==ie&&Y>=0){const ge=_.slice(Y+1,ie),X=_[ie+1]==="i"?"i":"";try{H=new RegExp(ge,X)}catch{}}}if(H===null)throw this.y("REGEX",Z);return m.create(F,H)}default:throw this.y("REGEX",this.C())}}if(this.v(14)){this.x(13,"'in' after 'not'");const Z=this.t();return I.notIn(F,Z)}switch(this.C().type){case 3:{this.w();const Z=this.t();switch(Z){case"true":return I.has(F);case"false":return I.not(F);default:return I.equals(F,Z)}}case 4:{this.w();const Z=this.t();switch(Z){case"true":return I.not(F);case"false":return I.has(F);default:return I.notEquals(F,Z)}}case 5:return this.w(),o.create(F,this.t());case 6:return this.w(),c.create(F,this.t());case 7:return this.w(),s.create(F,this.t());case 8:return this.w(),r.create(F,this.t());case 13:return this.w(),I.in(F,this.t());default:return I.has(F)}}default:throw this.y("'true', 'false', '(', KEY, KEY '=~' regex, KEY [ ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value ]",this.C())}}t(){const T=this.C();switch(T.type){case 17:case 18:return this.w(),T.lexeme;case 11:return this.w(),"true";case 12:return this.w(),"false";case 13:return this.w(),"in";default:return""}}u(){return this.d[this.f-1]}v(T){return this.B(T)?(this.w(),!0):!1}w(){return this.D()||this.f++,this.u()}x(T,F){if(this.B(T))return this.w();throw this.y(F,this.C())}y(T,F){return this.A(`Expected ${T} but got '${l.Scanner.getLexeme(F)}' at offset ${F.offset}.`)}z(T){return this.A(`Unexpected '${l.Scanner.getLexeme(T)}' at offset ${T.offset}.`)}A(T){return this.g.push(T),new O}B(T){return this.C().type===T}C(){return this.d[this.f]}D(){return this.C().type===20}}e.Parser=P;function v(U,T){const F=U?U.substituteConstants():void 0,B=T?T.substituteConstants():void 0;return!F&&!B?!0:!F||!B?!1:F.equals(B)}e.expressionsAreEqualWithConstantSubstitution=v;function k(U,T){return U.cmp(T)}class D{constructor(){this.type=0}cmp(T){return this.type-T.type}equals(T){return T.type===this.type}substituteConstants(){return this}evaluate(T){return!1}serialize(){return"false"}keys(){return[]}map(T){return this}negate(){return f.INSTANCE}}D.INSTANCE=new D,e.ContextKeyFalseExpr=D;class f{constructor(){this.type=1}cmp(T){return this.type-T.type}equals(T){return T.type===this.type}substituteConstants(){return this}evaluate(T){return!0}serialize(){return"true"}keys(){return[]}map(T){return this}negate(){return D.INSTANCE}}f.INSTANCE=new f,e.ContextKeyTrueExpr=f;class u{static create(T,F=null){const B=S.get(T);return typeof B=="boolean"?B?f.INSTANCE:D.INSTANCE:new u(T,F)}constructor(T,F){this.key=T,this.c=F,this.type=2}cmp(T){return T.type!==this.type?this.type-T.type:N(this.key,T.key)}equals(T){return T.type===this.type?this.key===T.key:!1}substituteConstants(){const T=S.get(this.key);return typeof T=="boolean"?T?f.INSTANCE:D.INSTANCE:this}evaluate(T){return!!T.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(T){return T.mapDefined(this.key)}negate(){return this.c||(this.c=g.create(this.key,this)),this.c}}e.ContextKeyDefinedExpr=u;class h{static create(T,F,B=null){if(typeof F=="boolean")return F?u.create(T,B):g.create(T,B);const Z=S.get(T);return typeof Z=="boolean"?F===(Z?"true":"false")?f.INSTANCE:D.INSTANCE:new h(T,F,B)}constructor(T,F,B){this.c=T,this.d=F,this.f=B,this.type=4}cmp(T){return T.type!==this.type?this.type-T.type:j(this.c,this.d,T.c,T.d)}equals(T){return T.type===this.type?this.c===T.c&&this.d===T.d:!1}substituteConstants(){const T=S.get(this.c);if(typeof T=="boolean"){const F=T?"true":"false";return this.d===F?f.INSTANCE:D.INSTANCE}return this}evaluate(T){return T.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(T){return T.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=C.create(this.c,this.d,this)),this.f}}e.ContextKeyEqualsExpr=h;class p{static create(T,F){return new p(T,F)}constructor(T,F){this.d=T,this.f=F,this.type=10,this.c=null}cmp(T){return T.type!==this.type?this.type-T.type:j(this.d,this.f,T.d,T.f)}equals(T){return T.type===this.type?this.d===T.d&&this.f===T.f:!1}substituteConstants(){return this}evaluate(T){const F=T.getValue(this.f),B=T.getValue(this.d);return Array.isArray(F)?F.includes(B):typeof B=="string"&&typeof F=="object"&&F!==null?A.call(F,B):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(T){return T.mapIn(this.d,this.f)}negate(){return this.c||(this.c=b.create(this.d,this.f)),this.c}}e.ContextKeyInExpr=p;class b{static create(T,F){return new b(T,F)}constructor(T,F){this.d=T,this.f=F,this.type=11,this.c=p.create(T,F)}cmp(T){return T.type!==this.type?this.type-T.type:this.c.cmp(T.c)}equals(T){return T.type===this.type?this.c.equals(T.c):!1}substituteConstants(){return this}evaluate(T){return!this.c.evaluate(T)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(T){return T.mapNotIn(this.d,this.f)}negate(){return this.c}}e.ContextKeyNotInExpr=b;class C{static create(T,F,B=null){if(typeof F=="boolean")return F?g.create(T,B):u.create(T,B);const Z=S.get(T);return typeof Z=="boolean"?F===(Z?"true":"false")?D.INSTANCE:f.INSTANCE:new C(T,F,B)}constructor(T,F,B){this.c=T,this.d=F,this.f=B,this.type=5}cmp(T){return T.type!==this.type?this.type-T.type:j(this.c,this.d,T.c,T.d)}equals(T){return T.type===this.type?this.c===T.c&&this.d===T.d:!1}substituteConstants(){const T=S.get(this.c);if(typeof T=="boolean"){const F=T?"true":"false";return this.d===F?D.INSTANCE:f.INSTANCE}return this}evaluate(T){return T.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(T){return T.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=h.create(this.c,this.d,this)),this.f}}e.ContextKeyNotEqualsExpr=C;class g{static create(T,F=null){const B=S.get(T);return typeof B=="boolean"?B?D.INSTANCE:f.INSTANCE:new g(T,F)}constructor(T,F){this.c=T,this.d=F,this.type=3}cmp(T){return T.type!==this.type?this.type-T.type:N(this.c,T.c)}equals(T){return T.type===this.type?this.c===T.c:!1}substituteConstants(){const T=S.get(this.c);return typeof T=="boolean"?T?D.INSTANCE:f.INSTANCE:this}evaluate(T){return!T.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(T){return T.mapNot(this.c)}negate(){return this.d||(this.d=u.create(this.c,this)),this.d}}e.ContextKeyNotExpr=g;function i(U,T){if(typeof U=="string"){const F=parseFloat(U);isNaN(F)||(U=F)}return typeof U=="string"||typeof U=="number"?T(U):D.INSTANCE}class s{static create(T,F,B=null){return i(F,Z=>new s(T,Z,B))}constructor(T,F,B){this.c=T,this.d=F,this.f=B,this.type=12}cmp(T){return T.type!==this.type?this.type-T.type:j(this.c,this.d,T.c,T.d)}equals(T){return T.type===this.type?this.c===T.c&&this.d===T.d:!1}substituteConstants(){return this}evaluate(T){return typeof this.d=="string"?!1:parseFloat(T.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(T){return T.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=c.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterExpr=s;class r{static create(T,F,B=null){return i(F,Z=>new r(T,Z,B))}constructor(T,F,B){this.c=T,this.d=F,this.f=B,this.type=13}cmp(T){return T.type!==this.type?this.type-T.type:j(this.c,this.d,T.c,T.d)}equals(T){return T.type===this.type?this.c===T.c&&this.d===T.d:!1}substituteConstants(){return this}evaluate(T){return typeof this.d=="string"?!1:parseFloat(T.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(T){return T.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=o.create(this.c,this.d,this)),this.f}}e.ContextKeyGreaterEqualsExpr=r;class o{static create(T,F,B=null){return i(F,Z=>new o(T,Z,B))}constructor(T,F,B){this.c=T,this.d=F,this.f=B,this.type=14}cmp(T){return T.type!==this.type?this.type-T.type:j(this.c,this.d,T.c,T.d)}equals(T){return T.type===this.type?this.c===T.c&&this.d===T.d:!1}substituteConstants(){return this}evaluate(T){return typeof this.d=="string"?!1:parseFloat(T.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(T){return T.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=r.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerExpr=o;class c{static create(T,F,B=null){return i(F,Z=>new c(T,Z,B))}constructor(T,F,B){this.c=T,this.d=F,this.f=B,this.type=15}cmp(T){return T.type!==this.type?this.type-T.type:j(this.c,this.d,T.c,T.d)}equals(T){return T.type===this.type?this.c===T.c&&this.d===T.d:!1}substituteConstants(){return this}evaluate(T){return typeof this.d=="string"?!1:parseFloat(T.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(T){return T.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=s.create(this.c,this.d,this)),this.f}}e.ContextKeySmallerEqualsExpr=c;class m{static create(T,F){return new m(T,F)}constructor(T,F){this.d=T,this.f=F,this.type=7,this.c=null}cmp(T){if(T.type!==this.type)return this.type-T.type;if(this.d<T.d)return-1;if(this.d>T.d)return 1;const F=this.f?this.f.source:"",B=T.f?T.f.source:"";return F<B?-1:F>B?1:0}equals(T){if(T.type===this.type){const F=this.f?this.f.source:"",B=T.f?T.f.source:"";return this.d===T.d&&F===B}return!1}substituteConstants(){return this}evaluate(T){const F=T.getValue(this.d);return this.f?this.f.test(F):!1}serialize(){const T=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${T}`}keys(){return[this.d]}map(T){return T.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=n.create(this)),this.c}}e.ContextKeyRegexExpr=m;class n{static create(T){return new n(T)}constructor(T){this.c=T,this.type=8}cmp(T){return T.type!==this.type?this.type-T.type:this.c.cmp(T.c)}equals(T){return T.type===this.type?this.c.equals(T.c):!1}substituteConstants(){return this}evaluate(T){return!this.c.evaluate(T)}serialize(){throw new Error("Method not implemented.")}keys(){return this.c.keys()}map(T){return new n(this.c.map(T))}negate(){return this.c}}e.ContextKeyNotRegexExpr=n;function t(U){let T=null;for(let F=0,B=U.length;F<B;F++){const Z=U[F].substituteConstants();if(U[F]!==Z&&T===null){T=[];for(let _=0;_<F;_++)T[_]=U[_]}T!==null&&(T[F]=Z)}return T===null?U:T}class d{static create(T,F,B){return d.d(T,F,B)}constructor(T,F){this.expr=T,this.c=F,this.type=6}cmp(T){if(T.type!==this.type)return this.type-T.type;if(this.expr.length<T.expr.length)return-1;if(this.expr.length>T.expr.length)return 1;for(let F=0,B=this.expr.length;F<B;F++){const Z=k(this.expr[F],T.expr[F]);if(Z!==0)return Z}return 0}equals(T){if(T.type===this.type){if(this.expr.length!==T.expr.length)return!1;for(let F=0,B=this.expr.length;F<B;F++)if(!this.expr[F].equals(T.expr[F]))return!1;return!0}return!1}substituteConstants(){const T=t(this.expr);return T===this.expr?this:d.create(T,this.c,!1)}evaluate(T){for(let F=0,B=this.expr.length;F<B;F++)if(!this.expr[F].evaluate(T))return!1;return!0}static d(T,F,B){const Z=[];let _=!1;for(const H of T)if(!!H){if(H.type===1){_=!0;continue}if(H.type===0)return D.INSTANCE;if(H.type===6){Z.push(...H.expr);continue}Z.push(H)}if(Z.length===0&&_)return f.INSTANCE;if(Z.length!==0){if(Z.length===1)return Z[0];Z.sort(k);for(let H=1;H<Z.length;H++)Z[H-1].equals(Z[H])&&(Z.splice(H,1),H--);if(Z.length===1)return Z[0];for(;Z.length>1;){const H=Z[Z.length-1];if(H.type!==9)break;Z.pop();const Y=Z.pop(),ie=Z.length===0,ge=E.create(H.expr.map(X=>d.create([X,Y],null,B)),null,ie);ge&&(Z.push(ge),Z.sort(k))}if(Z.length===1)return Z[0];if(B){for(let H=0;H<Z.length;H++)for(let Y=H+1;Y<Z.length;Y++)if(Z[H].negate().equals(Z[Y]))return D.INSTANCE;if(Z.length===1)return Z[0]}return new d(Z,F)}}serialize(){return this.expr.map(T=>T.serialize()).join(" && ")}keys(){const T=[];for(const F of this.expr)T.push(...F.keys());return T}map(T){return new d(this.expr.map(F=>F.map(T)),null)}negate(){if(!this.c){const T=[];for(const F of this.expr)T.push(F.negate());this.c=E.create(T,this,!0)}return this.c}}class E{static create(T,F,B){return E.d(T,F,B)}constructor(T,F){this.expr=T,this.c=F,this.type=9}cmp(T){if(T.type!==this.type)return this.type-T.type;if(this.expr.length<T.expr.length)return-1;if(this.expr.length>T.expr.length)return 1;for(let F=0,B=this.expr.length;F<B;F++){const Z=k(this.expr[F],T.expr[F]);if(Z!==0)return Z}return 0}equals(T){if(T.type===this.type){if(this.expr.length!==T.expr.length)return!1;for(let F=0,B=this.expr.length;F<B;F++)if(!this.expr[F].equals(T.expr[F]))return!1;return!0}return!1}substituteConstants(){const T=t(this.expr);return T===this.expr?this:E.create(T,this.c,!1)}evaluate(T){for(let F=0,B=this.expr.length;F<B;F++)if(this.expr[F].evaluate(T))return!0;return!1}static d(T,F,B){let Z=[],_=!1;if(T){for(let H=0,Y=T.length;H<Y;H++){const ie=T[H];if(!!ie){if(ie.type===0){_=!0;continue}if(ie.type===1)return f.INSTANCE;if(ie.type===9){Z=Z.concat(ie.expr);continue}Z.push(ie)}}if(Z.length===0&&_)return D.INSTANCE;Z.sort(k)}if(Z.length!==0){if(Z.length===1)return Z[0];for(let H=1;H<Z.length;H++)Z[H-1].equals(Z[H])&&(Z.splice(H,1),H--);if(Z.length===1)return Z[0];if(B){for(let H=0;H<Z.length;H++)for(let Y=H+1;Y<Z.length;Y++)if(Z[H].negate().equals(Z[Y]))return f.INSTANCE;if(Z.length===1)return Z[0]}return new E(Z,F)}}serialize(){return this.expr.map(T=>T.serialize()).join(" || ")}keys(){const T=[];for(const F of this.expr)T.push(...F.keys());return T}map(T){return new E(this.expr.map(F=>F.map(T)),null)}negate(){if(!this.c){const T=[];for(const F of this.expr)T.push(F.negate());for(;T.length>1;){const F=T.shift(),B=T.shift(),Z=[];for(const _ of x(F))for(const H of x(B))Z.push(d.create([_,H],null,!1));T.unshift(E.create(Z,null,!1))}this.c=E.create(T,this,!0)}return this.c}}class w extends u{static all(){return w.d.values()}constructor(T,F,B){super(T,null),this.f=F,typeof B=="object"?w.d.push({...B,key:T}):B!==!0&&w.d.push({key:T,description:B,type:F!=null?typeof F:void 0})}bindTo(T){return T.createKey(this.key,this.f)}getValue(T){return T.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(T){return h.create(this.key,T)}notEqualsTo(T){return C.create(this.key,T)}}w.d=[],e.RawContextKey=w,e.IContextKeyService=(0,R.createDecorator)("contextKeyService");function N(U,T){return U<T?-1:U>T?1:0}function j(U,T,F,B){return U<F?-1:U>F?1:T<B?-1:T>B?1:0}function V(U,T){if(U.type===0||T.type===1)return!0;if(U.type===9)return T.type===9?Q(U.expr,T.expr):!1;if(T.type===9){for(const F of T.expr)if(V(U,F))return!0;return!1}if(U.type===6){if(T.type===6)return Q(T.expr,U.expr);for(const F of U.expr)if(V(F,T))return!0;return!1}return U.equals(T)}e.implies=V;function Q(U,T){let F=0,B=0;for(;F<U.length&&B<T.length;){const Z=U[F].cmp(T[B]);if(Z<0)return!1;Z===0&&F++,B++}return F===U.length}function x(U){return U.type===9?U.expr:[U]}}),define(ye[200],De([1,0,4]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,a.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,a.refineServiceDecorator)(e.IEnvironmentService)}),define(ye[123],De([1,0,169,4]),function(re,e,a,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PreferencesLocalizedLabel=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.EXTENSION_INSTALL_SYNC_CONTEXT=e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension",e.EXTENSION_INSTALL_SKIP_WALKTHROUGH_CONTEXT="skipWalkthrough",e.EXTENSION_INSTALL_SYNC_CONTEXT="extensionsSync";function l(h){switch(h){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=l;function R(h){switch(h){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=R;function S(h,p){switch(h){case 3:return p==="x64"?"win32-x64":p==="ia32"?"win32-ia32":p==="arm64"?"win32-arm64":"unknown";case 2:return p==="x64"?"linux-x64":p==="arm64"?"linux-arm64":p==="arm"?"linux-armhf":"unknown";case"alpine":return p==="x64"?"alpine-x64":p==="arm64"?"alpine-arm64":"unknown";case 1:return p==="x64"?"darwin-x64":p==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=S;function A(h,p){return p==="web"&&!h.includes("web")}e.isNotWebExtensionInWebTargetPlatform=A;function y(h,p,b){return A(p,b)?!1:h==="undefined"||h==="universal"?!0:h==="unknown"?!1:h===b?!0:I(b).includes(h)}e.isTargetPlatformCompatible=y;function I(h){switch(h){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=I;function O(h){return h&&typeof h=="object"&&typeof h.id=="string"&&(!h.uuid||typeof h.uuid=="string")}e.isIExtensionIdentifier=O;var P;(function(h){h[h.NoneOrRelevance=0]="NoneOrRelevance",h[h.LastUpdatedDate=1]="LastUpdatedDate",h[h.Title=2]="Title",h[h.PublisherName=3]="PublisherName",h[h.InstallCount=4]="InstallCount",h[h.PublishedDate=10]="PublishedDate",h[h.AverageRating=6]="AverageRating",h[h.WeightedRating=12]="WeightedRating"})(P=e.SortBy||(e.SortBy={}));var v;(function(h){h[h.Default=0]="Default",h[h.Ascending=1]="Ascending",h[h.Descending=2]="Descending"})(v=e.SortOrder||(e.SortOrder={}));var k;(function(h){h.Install="install",h.Uninstall="uninstall"})(k=e.StatisticType||(e.StatisticType={}));var D;(function(h){h[h.None=1]="None",h[h.Install=2]="Install",h[h.Update=3]="Update",h[h.Migrate=4]="Migrate"})(D=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,L.createDecorator)("extensionGalleryService");var f;(function(h){h.Unsupported="Unsupported",h.Deprecated="Deprecated",h.Malicious="Malicious",h.Incompatible="Incompatible",h.IncompatiblePreRelease="IncompatiblePreRelease",h.IncompatibleTargetPlatform="IncompatibleTargetPlatform",h.ReleaseVersionNotFound="ReleaseVersionNotFound",h.Invalid="Invalid",h.Download="Download",h.Extract="Extract",h.Delete="Delete",h.Rename="Rename",h.CorruptZip="CorruptZip",h.IncompleteZip="IncompleteZip",h.Internal="Internal",h.Signature="Signature"})(f=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class u extends Error{constructor(p,b){super(p),this.code=b,this.name=b}}e.ExtensionManagementError=u,e.IExtensionManagementService=(0,L.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,L.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,L.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,a.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.PreferencesLocalizedLabel={value:(0,a.localize)(1,null),original:"Preferences"}}),define(ye[201],De([1,0,4]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,a.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,a.createDecorator)("externalTerminal")}),define(ye[202],De([1,0,46,16,9,12,104,29,113,171,201]),function(re,e,a,L,l,R,S,A,y,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const P=I.localize(0,null);class v{async getDefaultTerminalForPlatforms(){return{windows:k.getDefaultTerminalWindows(),linux:await f.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class k extends v{openTerminal(C,g){return this.spawnTerminal(a,C,y.getWindowsShell(),g)}spawnTerminal(C,g,i,s){const r=g.windowsExec||k.getDefaultTerminalWindows();s&&s[1]===":"&&(s=s[0].toUpperCase()+s.substr(1));const o=l.basename(r,".exe").toLowerCase();if(o==="cmder")return C.spawn(r,s?[s]:void 0),Promise.resolve(void 0);const c=["/c","start","/wait"];return r.indexOf(" ")>=0&&c.push('""'),c.push(r),o==="wt"&&c.push("-d ."),new Promise((m,n)=>{const t=u(process),d=C.spawn(i,c,{cwd:s,env:t});d.on("error",n),d.on("exit",()=>m())})}runInTerminal(C,g,i,s,r){const o="windowsExec"in r&&r.windowsExec?r.windowsExec:k.getDefaultTerminalWindows();return new Promise((c,m)=>{const n=`"${g} - ${P}"`,t=`""${i.join('" "')}" & pause"`,d=Object.assign({},u(process),s);Object.keys(d).filter(V=>d[V]===null).forEach(V=>delete d[V]);const E={cwd:g,env:d,windowsVerbatimArguments:!0};let w,N;l.basename(o,".exe")==="wt"?(w=o,N=["-d",".",k.b,"/c",t]):(w=k.b,N=["/c","start",n,"/wait",o,"/c",t]),a.spawn(w,N,E).on("error",V=>{m(h(V))}),c(void 0)})}static getDefaultTerminalWindows(){if(!k.d){const C=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");k.d=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${C?"Sysnative":"System32"}\\cmd.exe`}return k.d}}k.b="cmd.exe",e.WindowsExternalTerminalService=k;class D extends v{openTerminal(C,g){return this.spawnTerminal(a,C,g)}runInTerminal(C,g,i,s,r){const o=r.osxExec||O.DEFAULT_TERMINAL_OSX;return new Promise((c,m)=>{if(o===O.DEFAULT_TERMINAL_OSX||o==="iTerm.app"){const n=o===O.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",d=[L.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${n}.scpt`).fsPath,"-t",C||P,"-w",g];for(const N of i)d.push("-a"),d.push(N);if(s){const N=Object.assign({},u(process),s);for(const j in N){const V=N[j];V===null?(d.push("-u"),d.push(j)):(d.push("-e"),d.push(`${j}=${V}`))}}let E="";const w=a.spawn(D.b,d);w.on("error",N=>{m(h(N))}),w.stderr.on("data",N=>{E+=N.toString()}),w.on("exit",N=>{if(N===0)c(void 0);else if(E){const j=E.split(`
`,1);m(new Error(j[0]))}else m(new Error(I.localize(1,null,n,N)))})}else m(new Error(I.localize(2,null,o)))})}spawnTerminal(C,g,i){const s=g.osxExec||O.DEFAULT_TERMINAL_OSX;return new Promise((r,o)=>{const c=["-a",s];i&&c.push(i);const m=u(process),n=C.spawn("/usr/bin/open",c,{cwd:i,env:m});n.on("error",o),n.on("exit",()=>r())})}}D.b="/usr/bin/osascript",e.MacExternalTerminalService=D;class f extends v{openTerminal(C,g){return this.spawnTerminal(a,C,g)}runInTerminal(C,g,i,s,r){const o=r.linuxExec?Promise.resolve(r.linuxExec):f.getDefaultTerminalLinuxReady();return new Promise((c,m)=>{const n=[];o.then(t=>{t.indexOf("gnome-terminal")>=0?n.push("-x"):n.push("-e"),n.push("bash"),n.push("-c");const d=`${p(i)}; echo; read -p "${f.b}" -n1;`;n.push(`''${d}''`);const E=Object.assign({},u(process),s);Object.keys(E).filter(V=>E[V]===null).forEach(V=>delete E[V]);const w={cwd:g,env:E};let N="";const j=a.spawn(t,n,w);j.on("error",V=>{m(h(V))}),j.stderr.on("data",V=>{N+=V.toString()}),j.on("exit",V=>{if(V===0)c(void 0);else if(N){const Q=N.split(`
`,1);m(new Error(Q[0]))}else m(new Error(I.localize(4,null,t,V)))})})})}static async getDefaultTerminalLinuxReady(){if(!f.d)if(!R.isLinux)f.d=Promise.resolve("xterm");else{const C=await A.Promises.exists("/etc/debian_version");f.d=new Promise(g=>{C?g("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?g("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?g("konsole"):process.env.COLORTERM?g(process.env.COLORTERM):process.env.TERM?g(process.env.TERM):g("xterm")})}return f.d}spawnTerminal(C,g,i){const s=g.linuxExec?Promise.resolve(g.linuxExec):f.getDefaultTerminalLinuxReady();return new Promise((r,o)=>{s.then(c=>{const m=u(process),n=C.spawn(c,[],{cwd:i,env:m});n.on("error",o),n.on("exit",()=>r())})})}}f.b=I.localize(3,null),e.LinuxExternalTerminalService=f;function u(b){const C={...b.env};return(0,S.sanitizeProcessEnvironment)(C),C}function h(b){return"errno"in b&&b.errno==="ENOENT"&&"path"in b&&typeof b.path=="string"?new Error(I.localize(5,null,b.path)):b}function p(b){let C="";for(const g of b)g.indexOf(" ")>=0?C+='"'+g+'"':C+=g,C+=" ";return C}}),define(ye[44],De([1,0,68,9,8,10,2,172,4,12,16]),function(re,e,a,L,l,R,S,A,y,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLargeFileConfirmationLimit=e.getPlatformFileLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.TooLargeFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,y.createDecorator)("fileService");function P(H){return H.create===!0}e.isFileOpenForWriteOptions=P;var v;(function(H){H[H.Unknown=0]="Unknown",H[H.File=1]="File",H[H.Directory=2]="Directory",H[H.SymbolicLink=64]="SymbolicLink"})(v=e.FileType||(e.FileType={}));var k;(function(H){H[H.Readonly=1]="Readonly"})(k=e.FilePermission||(e.FilePermission={}));var D;(function(H){H[H.None=0]="None",H[H.FileReadWrite=2]="FileReadWrite",H[H.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",H[H.FileReadStream=16]="FileReadStream",H[H.FileFolderCopy=8]="FileFolderCopy",H[H.PathCaseSensitive=1024]="PathCaseSensitive",H[H.Readonly=2048]="Readonly",H[H.Trash=4096]="Trash",H[H.FileWriteUnlock=8192]="FileWriteUnlock",H[H.FileAtomicRead=16384]="FileAtomicRead",H[H.FileClone=32768]="FileClone"})(D=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function f(H){return!!(H.capabilities&2)}e.hasReadWriteCapability=f;function u(H){return!!(H.capabilities&8)}e.hasFileFolderCopyCapability=u;function h(H){return!!(H.capabilities&32768)}e.hasFileCloneCapability=h;function p(H){return!!(H.capabilities&4)}e.hasOpenReadWriteCloseCapability=p;function b(H){return!!(H.capabilities&16)}e.hasFileReadStreamCapability=b;function C(H){return f(H)?!!(H.capabilities&16384):!1}e.hasFileAtomicReadCapability=C;var g;(function(H){H.FileExists="EntryExists",H.FileNotFound="EntryNotFound",H.FileNotADirectory="EntryNotADirectory",H.FileIsADirectory="EntryIsADirectory",H.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",H.FileTooLarge="EntryTooLarge",H.FileWriteLocked="EntryWriteLocked",H.NoPermissions="NoPermissions",H.Unavailable="Unavailable",H.Unknown="Unknown"})(g=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class i extends Error{static create(Y,ie){const ge=new i(Y.toString(),ie);return o(ge,ie),ge}constructor(Y,ie){super(Y),this.code=ie}}e.FileSystemProviderError=i;function s(H,Y){return i.create(H,Y)}e.createFileSystemProviderError=s;function r(H){return H||s((0,A.localize)(0,null),g.Unknown)}e.ensureFileSystemProviderError=r;function o(H,Y){return H.name=Y?`${Y} (FileSystemError)`:"FileSystemError",H}e.markAsFileSystemProviderError=o;function c(H){if(!H)return g.Unknown;if(H instanceof i)return H.code;const Y=/^(.+) \(FileSystemError\)$/.exec(H.name);if(!Y)return g.Unknown;switch(Y[1]){case g.FileExists:return g.FileExists;case g.FileIsADirectory:return g.FileIsADirectory;case g.FileNotADirectory:return g.FileNotADirectory;case g.FileNotFound:return g.FileNotFound;case g.FileExceedsMemoryLimit:return g.FileExceedsMemoryLimit;case g.FileTooLarge:return g.FileTooLarge;case g.FileWriteLocked:return g.FileWriteLocked;case g.NoPermissions:return g.NoPermissions;case g.Unavailable:return g.Unavailable}return g.Unknown}e.toFileSystemProviderErrorCode=c;function m(H){if(H instanceof N)return H.fileOperationResult;switch(c(H)){case g.FileNotFound:return 1;case g.FileIsADirectory:return 0;case g.FileNotADirectory:return 10;case g.FileWriteLocked:return 5;case g.NoPermissions:return 6;case g.FileExists:return 4;case g.FileExceedsMemoryLimit:return 9;case g.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=m;var n;(function(H){H[H.CREATE=0]="CREATE",H[H.DELETE=1]="DELETE",H[H.MOVE=2]="MOVE",H[H.COPY=3]="COPY",H[H.WRITE=4]="WRITE"})(n=e.FileOperation||(e.FileOperation={}));class t{constructor(Y,ie,ge){this.resource=Y,this.operation=ie,this.target=ge}isOperation(Y){return this.operation===Y}}e.FileOperationEvent=t;var d;(function(H){H[H.UPDATED=0]="UPDATED",H[H.ADDED=1]="ADDED",H[H.DELETED=2]="DELETED"})(d=e.FileChangeType||(e.FileChangeType={}));class E{constructor(Y,ie){this.a=void 0,this.b=void 0,this.c=void 0,this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];const ge=new Map;for(const X of Y){const J=ge.get(X.type);switch(J?J.push([X.resource,X]):ge.set(X.type,[[X.resource,X]]),X.type){case 1:this.rawAdded.push(X.resource);break;case 0:this.rawUpdated.push(X.resource);break;case 2:this.rawDeleted.push(X.resource);break}}for(const[X,J]of ge)switch(X){case 1:this.a=a.TernarySearchTree.forUris(()=>ie),this.a.fill(J);break;case 0:this.b=a.TernarySearchTree.forUris(()=>ie),this.b.fill(J);break;case 2:this.c=a.TernarySearchTree.forUris(()=>ie),this.c.fill(J);break}}contains(Y,...ie){return this.d(Y,{includeChildren:!1},...ie)}affects(Y,...ie){return this.d(Y,{includeChildren:!0},...ie)}d(Y,ie,...ge){if(!Y)return!1;const X=ge.length>0;return!!((!X||ge.includes(1))&&(this.a?.get(Y)||ie.includeChildren&&this.a?.findSuperstr(Y))||(!X||ge.includes(0))&&(this.b?.get(Y)||ie.includeChildren&&this.b?.findSuperstr(Y))||(!X||ge.includes(2))&&(this.c?.findSubstr(Y)||ie.includeChildren&&this.c?.findSuperstr(Y)))}gotAdded(){return!!this.a}gotDeleted(){return!!this.c}gotUpdated(){return!!this.b}}e.FileChangesEvent=E;function w(H,Y,ie){return!H||!Y||H===Y||Y.length>H.length?!1:(Y.charAt(Y.length-1)!==L.sep&&(Y+=L.sep),ie?(0,l.startsWithIgnoreCase)(H,Y):H.indexOf(Y)===0)}e.isParent=w;class N extends Error{constructor(Y,ie,ge){super(Y),this.fileOperationResult=ie,this.options=ge}}e.FileOperationError=N;class j extends N{constructor(Y,ie,ge,X){super(Y,ie,X),this.fileOperationResult=ie,this.size=ge}}e.TooLargeFileOperationError=j;class V extends N{constructor(Y,ie,ge){super(Y,2,ge),this.stat=ie}}e.NotModifiedSinceFileOperationError=V;var Q;(function(H){H[H.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",H[H.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",H[H.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",H[H.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",H[H.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",H[H.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",H[H.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",H[H.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",H[H.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",H[H.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",H[H.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",H[H.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(Q=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var x;(function(H){H[H.FILE=0]="FILE",H[H.FOLDER=1]="FOLDER",H[H.ROOT_FOLDER=2]="ROOT_FOLDER"})(x=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function U(H){if(!(typeof H.size!="number"||typeof H.mtime!="number"))return H.mtime.toString(29)+H.size.toString(31)}e.etag=U;async function T(H,Y){if(!Y.hasProvider(S.URI.from({scheme:H.scheme})))return new Promise(ie=>{const ge=Y.onDidChangeFileSystemProviderRegistrations(X=>{X.scheme===H.scheme&&X.added&&(ge.dispose(),ie())})})}e.whenProviderRegistered=T,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class F{static formatSize(Y){return(0,R.isNumber)(Y)||(Y=0),Y<F.KB?(0,A.localize)(1,null,Y.toFixed(0)):Y<F.MB?(0,A.localize)(2,null,(Y/F.KB).toFixed(2)):Y<F.GB?(0,A.localize)(3,null,(Y/F.MB).toFixed(2)):Y<F.TB?(0,A.localize)(4,null,(Y/F.GB).toFixed(2)):(0,A.localize)(5,null,(Y/F.TB).toFixed(2))}}F.KB=1024,F.MB=F.KB*F.KB,F.GB=F.MB*F.KB,F.TB=F.GB*F.KB,e.ByteSize=F;var B;(function(H){H[H.IA32=0]="IA32",H[H.OTHER=1]="OTHER"})(B=e.Arch||(e.Arch={}));function Z(H){return{maxFileSize:H===0?300*F.MB:16*F.GB,maxHeapSize:H===0?700*F.MB:2*700*F.MB}}e.getPlatformFileLimits=Z;function _(H){const Y=typeof H=="string"||H?.scheme===O.Schemas.vscodeRemote;return typeof H!="string"&&H?.scheme===O.Schemas.file?1024*F.MB:Y?10*F.MB:I.isWeb?50*F.MB:1024*F.MB}e.getLargeFileConfirmationLimit=_}),define(ye[91],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class a{constructor(...l){this.a=new Map;for(const[R,S]of l)this.set(R,S)}set(l,R){const S=this.a.get(l);return this.a.set(l,R),S}has(l){return this.a.has(l)}get(l){return this.a.get(l)}}e.ServiceCollection=a}),define(ye[203],De([1,0,17,11,6,122,199,4,91,67]),function(re,e,a,L,l,R,S,A,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const O=!1;class P extends Error{constructor(u){super("cyclic dependency between services"),this.message=u.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${u.toString()}`}}class v{constructor(u=new y.ServiceCollection,h=!1,p,b=O){this.f=u,this.g=h,this.h=p,this.i=b,this.o=new Set,this.f.set(A.IInstantiationService,this),this._globalGraph=b?p?._globalGraph??new S.Graph(C=>C):void 0}createChild(u){return new v(u,this.g,this,this.i)}invokeFunction(u,...h){const p=D.traceInvocation(this.i,u);let b=!1;try{return u({get:g=>{if(b)throw(0,L.illegalState)("service accessor is only valid during the invocation of its target method");const i=this.m(g,p);if(!i)throw new Error(`[invokeFunction] unknown service '${g}'`);return i}},...h)}finally{b=!0,p.stop()}}createInstance(u,...h){let p,b;return u instanceof R.SyncDescriptor?(p=D.traceCreation(this.i,u.ctor),b=this.j(u.ctor,u.staticArguments.concat(h),p)):(p=D.traceCreation(this.i,u),b=this.j(u,h,p)),p.stop(),b}j(u,h=[],p){const b=A._util.getServiceDependencies(u).sort((i,s)=>i.index-s.index),C=[];for(const i of b){const s=this.m(i.id,p);s||this.u(`[createInstance] ${u.name} depends on UNKNOWN service ${i.id}.`,!1),C.push(s)}const g=b.length>0?b[0].index:h.length;if(h.length!==g){console.trace(`[createInstance] First service dependency of ${u.name} at position ${g+1} conflicts with ${h.length} static arguments`);const i=g-h.length;i>0?h=h.concat(new Array(i)):h=h.slice(0,g)}return Reflect.construct(u,h.concat(C))}k(u,h){if(this.f.get(u)instanceof R.SyncDescriptor)this.f.set(u,h);else if(this.h)this.h.k(u,h);else throw new Error("illegalState - setting UNKNOWN service instance")}l(u){const h=this.f.get(u);return!h&&this.h?this.h.l(u):h}m(u,h){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(u));const p=this.l(u);return p instanceof R.SyncDescriptor?this.q(u,p,h.branch(u,!0)):(h.branch(u,!1),p)}q(u,h,p){if(this.o.has(u))throw new Error(`illegal state - RECURSIVELY instantiating service '${u}'`);this.o.add(u);try{return this.r(u,h,p)}finally{this.o.delete(u)}}r(u,h,p){const b=new S.Graph(i=>i.id.toString());let C=0;const g=[{id:u,desc:h,_trace:p}];for(;g.length;){const i=g.pop();if(b.lookupOrInsertNode(i),C++>1e3)throw new P(b);for(const s of A._util.getServiceDependencies(i.desc.ctor)){const r=this.l(s.id);if(r||this.u(`[createInstance] ${u} depends on ${s.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(s.id)),r instanceof R.SyncDescriptor){const o={id:s.id,desc:r,_trace:i._trace.branch(s.id,!0)};b.insertEdge(i,o),g.push(o)}}}for(;;){const i=b.roots();if(i.length===0){if(!b.isEmpty())throw new P(b);break}for(const{data:s}of i){if(this.l(s.id)instanceof R.SyncDescriptor){const o=this.s(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this.k(s.id,o)}b.removeNode(s)}}return this.l(u)}s(u,h,p=[],b,C){if(this.f.get(u)instanceof R.SyncDescriptor)return this.t(u,h,p,b,C);if(this.h)return this.h.s(u,h,p,b,C);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}t(u,h,p=[],b,C){if(b){const g=new v(void 0,this.g,this,this.i);g.c=String(u);const i=new Map,s=new a.IdleValue(()=>{const r=g.j(h,p,C);for(const[o,c]of i){const m=r[o];if(typeof m=="function")for(const n of c)m.apply(r,n)}return i.clear(),r});return new Proxy(Object.create(null),{get(r,o){if(!s.isInitialized&&typeof o=="string"&&(o.startsWith("onDid")||o.startsWith("onWill"))){let n=i.get(o);return n||(n=new I.LinkedList,i.set(o,n)),(d,E,w)=>{const N=n.push([d,E,w]);return(0,l.toDisposable)(N)}}if(o in r)return r[o];const c=s.value;let m=c[o];return typeof m!="function"||(m=m.bind(c),r[o]=m),m},set(r,o,c){return s.value[o]=c,!0},getPrototypeOf(r){return h.prototype}})}else return this.j(h,p,C)}u(u,h){if(h&&console.warn(u),this.g)throw new Error(u)}}e.InstantiationService=v;var k;(function(f){f[f.None=0]="None",f[f.Creation=1]="Creation",f[f.Invocation=2]="Invocation",f[f.Branch=3]="Branch"})(k||(k={}));class D{static traceInvocation(u,h){return u?new D(2,h.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):D.c}static traceCreation(u,h){return u?new D(1,h.name):D.c}constructor(u,h){this.type=u,this.name=h,this.g=Date.now(),this.h=[]}branch(u,h){const p=new D(3,u.toString());return this.h.push([u,h,p]),p}stop(){const u=Date.now()-this.g;D.f+=u;let h=!1;function p(C,g){const i=[],s=new Array(C+1).join("	");for(const[r,o,c]of g.h)if(o&&c){h=!0,i.push(`${s}CREATES -> ${r}`);const m=p(C+1,c);m&&i.push(m)}else i.push(`${s}uses -> ${r}`);return i.join(`
`)}const b=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${p(1,this)}`,`DONE, took ${u.toFixed(2)}ms (grand total ${D.f.toFixed(2)}ms)`];(u>2||h)&&D.all.add(b.join(`
`))}}D.all=new Set,D.c=new class extends D{constructor(){super(0,null)}stop(){}branch(){return this}},D.f=0,e.Trace=D}),define(ye[13],De([1,0,45,3,6,28,12,10,2,4]),function(re,e,a,L,l,R,S,A,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLogLevel=e.LogLevelToString=e.getLogLevel=e.NullLoggerService=e.NullLogService=e.NullLogger=e.AbstractLoggerService=e.MultiplexLogger=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.isLogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,I.createDecorator)("logService"),e.ILoggerService=(0,I.createDecorator)("loggerService");function O(){return new Date().toISOString()}function P(n){return(0,A.isNumber)(n)}e.isLogLevel=P;var v;(function(n){n[n.Off=0]="Off",n[n.Trace=1]="Trace",n[n.Debug=2]="Debug",n[n.Info=3]="Info",n[n.Warning=4]="Warning",n[n.Error=5]="Error"})(v=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=v.Info;function k(n,t,d){switch(t){case v.Trace:n.trace(d);break;case v.Debug:n.debug(d);break;case v.Info:n.info(d);break;case v.Warning:n.warn(d);break;case v.Error:n.error(d);break;case v.Off:break;default:throw new Error(`Invalid log level ${t}`)}}e.log=k;function D(n){let t="";for(let d=0;d<n.length;d++){let E=n[d];if(typeof E=="object")try{E=JSON.stringify(E)}catch{}t+=(d>0?" ":"")+E}return t}e.format=D;class f extends l.Disposable{constructor(){super(...arguments),this.b=e.DEFAULT_LOG_LEVEL,this.c=this.B(new L.Emitter),this.onDidChangeLogLevel=this.c.event}setLevel(t){this.b!==t&&(this.b=t,this.c.fire(this.b))}getLevel(){return this.b}f(t){return this.b!==v.Off&&this.b<=t}}e.AbstractLogger=f;class u extends f{constructor(t){super(),this.h=t}f(t){return this.h||super.f(t)}trace(t,...d){this.f(v.Trace)&&this.g(v.Trace,D([t,...d]))}debug(t,...d){this.f(v.Debug)&&this.g(v.Debug,D([t,...d]))}info(t,...d){this.f(v.Info)&&this.g(v.Info,D([t,...d]))}warn(t,...d){this.f(v.Warning)&&this.g(v.Warning,D([t,...d]))}error(t,...d){if(this.f(v.Error))if(t instanceof Error){const E=Array.prototype.slice.call(arguments);E[0]=t.stack,this.g(v.Error,D(E))}else this.g(v.Error,D([t,...d]))}flush(){}}e.AbstractMessageLogger=u;class h extends f{constructor(t=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(t),this.g=!S.isWindows}trace(t,...d){this.f(v.Trace)&&(this.g?console.log(`\x1B[90m[main ${O()}]\x1B[0m`,t,...d):console.log(`[main ${O()}]`,t,...d))}debug(t,...d){this.f(v.Debug)&&(this.g?console.log(`\x1B[90m[main ${O()}]\x1B[0m`,t,...d):console.log(`[main ${O()}]`,t,...d))}info(t,...d){this.f(v.Info)&&(this.g?console.log(`\x1B[90m[main ${O()}]\x1B[0m`,t,...d):console.log(`[main ${O()}]`,t,...d))}warn(t,...d){this.f(v.Warning)&&(this.g?console.warn(`\x1B[93m[main ${O()}]\x1B[0m`,t,...d):console.warn(`[main ${O()}]`,t,...d))}error(t,...d){this.f(v.Error)&&(this.g?console.error(`\x1B[91m[main ${O()}]\x1B[0m`,t,...d):console.error(`[main ${O()}]`,t,...d))}dispose(){}flush(){}}e.ConsoleMainLogger=h;class p extends f{constructor(t=e.DEFAULT_LOG_LEVEL){super(),this.setLevel(t)}trace(t,...d){this.f(v.Trace)&&console.log("%cTRACE","color: #888",t,...d)}debug(t,...d){this.f(v.Debug)&&console.log("%cDEBUG","background: #eee; color: #888",t,...d)}info(t,...d){this.f(v.Info)&&console.log("%c INFO","color: #33f",t,...d)}warn(t,...d){this.f(v.Warning)&&console.log("%c WARN","color: #993",t,...d)}error(t,...d){this.f(v.Error)&&console.log("%c  ERR","color: #f33",t,...d)}dispose(){}flush(){}}e.ConsoleLogger=p;class b extends f{constructor(t,d=e.DEFAULT_LOG_LEVEL){super(),this.g=t,this.setLevel(d)}trace(t,...d){this.f(v.Trace)&&this.g.log(v.Trace,[this.h(t),...d])}debug(t,...d){this.f(v.Debug)&&this.g.log(v.Debug,[this.h(t),...d])}info(t,...d){this.f(v.Info)&&this.g.log(v.Info,[this.h(t),...d])}warn(t,...d){this.f(v.Warning)&&this.g.log(v.Warning,[this.h(t),...d])}error(t,...d){this.f(v.Error)&&this.g.log(v.Error,[this.h(t),...d])}h(t){return typeof t=="string"?t:(0,a.toErrorMessage)(t,this.f(v.Trace))}dispose(){}flush(){}}e.AdapterLogger=b;class C extends f{constructor(t){super(),this.g=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const d of this.g)d.setLevel(t);super.setLevel(t)}trace(t,...d){for(const E of this.g)E.trace(t,...d)}debug(t,...d){for(const E of this.g)E.debug(t,...d)}info(t,...d){for(const E of this.g)E.info(t,...d)}warn(t,...d){for(const E of this.g)E.warn(t,...d)}error(t,...d){for(const E of this.g)E.error(t,...d)}flush(){for(const t of this.g)t.flush()}dispose(){for(const t of this.g)t.dispose()}}e.MultiplexLogger=C;class g extends l.Disposable{constructor(t,d){if(super(),this.j=t,this.b=new R.ResourceMap,this.c=new R.ResourceMap,this.f=this.B(new L.Emitter),this.onDidChangeLoggers=this.f.event,this.g=this.B(new L.Emitter),this.onDidChangeLogLevel=this.g.event,this.h=this.B(new L.Emitter),this.onDidChangeVisibility=this.h.event,d)for(const E of d)this.c.set(E.resource,E)}getLogger(t){return this.b.get(t)}createLogger(t,d){let E=this.b.get(t);const w=d?.logLevel==="always"?v.Trace:d?.logLevel;return E||(E=this.k(t,w??this.getLogLevel(t)??this.j,d),this.b.set(t,E)),this.registerLogger({resource:t,id:d?.id??t.toString(),logLevel:w,name:d?.name,hidden:d?.hidden,extensionId:d?.extensionId}),E}setLogLevel(t,d){if(y.URI.isUri(t)){const E=t,w=d,N=this.c.get(E);N&&w!==N.logLevel&&(N.logLevel=w===this.j?void 0:w,this.b.get(E)?.setLevel(w),this.c.set(N.resource,N),this.g.fire([E,w]))}else{this.j=t;for(const[E,w]of this.b.entries())this.c.get(E)?.logLevel===void 0&&w.setLevel(this.j);this.g.fire(this.j)}}setVisibility(t,d){const E=this.c.get(t);E&&d!==!E.hidden&&(E.hidden=!d,this.c.set(E.resource,E),this.h.fire([t,d]))}getLogLevel(t){let d;return t&&(d=this.c.get(t)?.logLevel),d??this.j}registerLogger(t){const d=this.c.get(t.resource);d?d.hidden!==t.hidden&&this.setVisibility(t.resource,!t.hidden):(this.c.set(t.resource,t),this.f.fire({added:[t],removed:[]}))}deregisterLogger(t){const d=this.c.get(t);if(d){this.c.delete(t);const E=this.b.get(t);E&&(this.b.delete(t),E.dispose()),this.f.fire({added:[],removed:[d]})}}getRegisteredLoggers(){return this.c.values()}getRegisteredLogger(t){return this.c.get(t)}dispose(){this.b.forEach(t=>t.dispose()),this.b.clear(),this.c.clear(),super.dispose()}}e.AbstractLoggerService=g;class i{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(t){}getLevel(){return v.Info}trace(t,...d){}debug(t,...d){}info(t,...d){}warn(t,...d){}error(t,...d){}critical(t,...d){}dispose(){}flush(){}}e.NullLogger=i;class s extends i{}e.NullLogService=s;class r extends g{constructor(){super(v.Info)}k(t,d,E){return new i}}e.NullLoggerService=r;function o(n){if(n.verbose)return v.Trace;if(typeof n.logLevel=="string"){const t=m(n.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=o;function c(n){switch(n){case v.Trace:return"trace";case v.Debug:return"debug";case v.Info:return"info";case v.Warning:return"warn";case v.Error:return"error";case v.Off:return"off"}}e.LogLevelToString=c;function m(n){switch(n){case"trace":return v.Trace;case"debug":return v.Debug;case"info":return v.Info;case"warn":return v.Warning;case"error":return v.Error;case"critical":return v.Error;case"off":return v.Off}}e.parseLogLevel=m}),define(ye[204],De([1,0,6,13]),function(re,e,a,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogService=void 0;class l extends a.Disposable{constructor(S,A=[]){super(),this.a=new L.MultiplexLogger([S,...A]),this.B(S.onDidChangeLogLevel(y=>this.setLevel(y)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(S){this.a.setLevel(S)}getLevel(){return this.a.getLevel()}trace(S,...A){this.a.trace(S,...A)}debug(S,...A){this.a.debug(S,...A)}info(S,...A){this.a.info(S,...A)}warn(S,...A){this.a.warn(S,...A)}error(S,...A){this.a.error(S,...A)}flush(){this.a.flush()}}e.LogService=l}),define(ye[205],De([1,0,44,13]),function(re,e,a,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=void 0;var l;(function(I){I[I.Trace=0]="Trace",I[I.Debug=1]="Debug",I[I.Info=2]="Info",I[I.Warning=3]="Warning",I[I.Error=4]="Error",I[I.Critical=5]="Critical",I[I.Off=6]="Off"})(l||(l={}));async function R(I,O,P,v,k){try{const D=await new Promise((u,h)=>{re(["spdlog"],u,h)});D.setFlushOn(l.Trace);const f=await D.createAsyncRotatingLogger(I,O,P,v);return k?f.clearFormatters():f.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),f}catch(D){console.error(D)}return null}function S(I,O,P){switch(O){case L.LogLevel.Trace:I.trace(P);break;case L.LogLevel.Debug:I.debug(P);break;case L.LogLevel.Info:I.info(P);break;case L.LogLevel.Warning:I.warn(P);break;case L.LogLevel.Error:I.error(P);break;case L.LogLevel.Off:break;default:throw new Error(`Invalid log level ${O}`)}}function A(I,O){switch(O){case L.LogLevel.Trace:I.setLevel(l.Trace);break;case L.LogLevel.Debug:I.setLevel(l.Debug);break;case L.LogLevel.Info:I.setLevel(l.Info);break;case L.LogLevel.Warning:I.setLevel(l.Warning);break;case L.LogLevel.Error:I.setLevel(l.Error);break;case L.LogLevel.Off:I.setLevel(l.Off);break;default:throw new Error(`Invalid log level ${O}`)}}class y extends L.AbstractMessageLogger{constructor(O,P,v,k,D){super(),this.k=[],this.setLevel(D),this.l=this.n(O,P,v,k),this.B(this.onDidChangeLogLevel(f=>{this.m&&A(this.m,f)}))}async n(O,P,v,k){const D=v?6:1,f=30/D*a.ByteSize.MB,u=await R(O,P,f,D,k);if(u){this.m=u,A(this.m,this.getLevel());for(const{level:h,message:p}of this.k)S(this.m,h,p);this.k=[]}}g(O,P){this.m?S(this.m,O,P):this.getLevel()<=O&&this.k.push({level:O,message:P})}flush(){this.m?this.m.flush():this.l.then(()=>this.flush())}dispose(){this.m?this.r():this.l.then(()=>this.r())}r(){this.m&&(this.m.drop(),this.m=void 0)}}e.SpdLogLogger=y}),define(ye[124],De([1,0,37,173,4]),function(re,e,a,L,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var R;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(R=e.MarkerTag||(e.MarkerTag={}));var S;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(S=e.MarkerSeverity||(e.MarkerSeverity={})),function(y){function I(D,f){return f-D}y.compare=I;const O=Object.create(null);O[y.Error]=(0,L.localize)(0,null),O[y.Warning]=(0,L.localize)(1,null),O[y.Info]=(0,L.localize)(2,null);function P(D){return O[D]||""}y.toString=P;function v(D){switch(D){case a.default.Error:return y.Error;case a.default.Warning:return y.Warning;case a.default.Info:return y.Info;case a.default.Ignore:return y.Hint}}y.fromSeverity=v;function k(D){switch(D){case y.Error:return a.default.Error;case y.Warning:return a.default.Warning;case y.Info:return a.default.Info;case y.Hint:return a.default.Ignore}}y.toSeverity=k}(S=e.MarkerSeverity||(e.MarkerSeverity={}));var A;(function(y){const I="";function O(v){return P(v,!0)}y.makeKey=O;function P(v,k){const D=[I];return v.source?D.push(v.source.replace("\xA6","\\\xA6")):D.push(I),v.code?typeof v.code=="string"?D.push(v.code.replace("\xA6","\\\xA6")):D.push(v.code.value.replace("\xA6","\\\xA6")):D.push(I),v.severity!==void 0&&v.severity!==null?D.push(S.toString(v.severity)):D.push(I),v.message&&k?D.push(v.message.replace("\xA6","\\\xA6")):D.push(I),v.startLineNumber!==void 0&&v.startLineNumber!==null?D.push(v.startLineNumber.toString()):D.push(I),v.startColumn!==void 0&&v.startColumn!==null?D.push(v.startColumn.toString()):D.push(I),v.endLineNumber!==void 0&&v.endLineNumber!==null?D.push(v.endLineNumber.toString()):D.push(I),v.endColumn!==void 0&&v.endColumn!==null?D.push(v.endColumn.toString()):D.push(I),D.push(I),D.join("\xA6")}y.makeKeyOptionalMessage=P})(A=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,l.createDecorator)("markerService")}),define(ye[206],De([1,0,3,37,4]),function(re,e,a,L,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=L.default,e.INotificationService=(0,l.createDecorator)("notificationService");var R;(function(I){I[I.WORKSPACE=0]="WORKSPACE",I[I.PROFILE=1]="PROFILE",I[I.APPLICATION=2]="APPLICATION"})(R=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var S;(function(I){I[I.OFF=0]="OFF",I[I.SILENT=1]="SILENT",I[I.ERROR=2]="ERROR"})(S=e.NotificationsFilter||(e.NotificationsFilter={}));class A{constructor(){this.progress=new y,this.onDidClose=a.Event.None,this.onDidChangeVisibility=a.Event.None}updateSeverity(O){}updateMessage(O){}updateActions(O){}close(){}}e.NoOpNotification=A;class y{infinite(){}done(){}total(O){}worked(O){}}e.NoOpProgress=y}),define(ye[125],De([1,0,8,2,4]),function(re,e,a,L,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.IOpenerService=void 0,e.IOpenerService=(0,l.createDecorator)("openerService");function R(I,O){return L.URI.isUri(I)?(0,a.equalsIgnoreCase)(I.scheme,O):(0,a.startsWithIgnoreCase)(I,O+":")}e.matchesScheme=R;function S(I,...O){return O.some(P=>R(I,P))}e.matchesSomeScheme=S;function A(I,O){return I.with({fragment:`${O.startLineNumber},${O.startColumn}${O.endLineNumber?`-${O.endLineNumber}${O.endColumn?`,${O.endColumn}`:""}`:""}`})}e.withSelection=A;function y(I){let O;const P=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(I.fragment);return P&&(O={startLineNumber:parseInt(P[1]),startColumn:P[2]?parseInt(P[2]):1,endLineNumber:P[4]?parseInt(P[4]):void 0,endColumn:P[4]?P[5]?parseInt(P[5]):1:void 0},I=I.with({fragment:""})),{selection:O,uri:I}}e.extractSelection=y}),define(ye[207],De([1,0,12,36]),function(re,e,a,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let l;if(typeof a.globals.vscode<"u"&&typeof a.globals.vscode.context<"u"){const R=a.globals.vscode.context.configuration();if(R)l=R.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(globalThis._VSCODE_PRODUCT_JSON&&globalThis._VSCODE_PACKAGE_JSON){if(l=globalThis._VSCODE_PRODUCT_JSON,L.env.VSCODE_DEV&&Object.assign(l,{nameShort:`${l.nameShort} Dev`,nameLong:`${l.nameLong} Dev`,dataFolderName:`${l.dataFolderName}-dev`,serverDataFolderName:l.serverDataFolderName?`${l.serverDataFolderName}-dev`:void 0}),!l.version){const R=globalThis._VSCODE_PACKAGE_JSON;Object.assign(l,{version:R.version})}Object.assign(l,{extensionsGallery:L.env.EXTENSIONS_GALLERY?JSON.parse(L.env.EXTENSIONS_GALLERY):l.extensionsGallery||{serviceUrl:"https://open-vsx.org/vscode/gallery",itemUrl:"https://open-vsx.org/vscode/item",resourceUrlTemplate:"https://open-vsx.org/vscode/asset/{publisher}/{name}/{version}/Microsoft.VisualStudio.Code.WebResources/{path}",controlUrl:"",recommendationsUrl:""}})}else l={nameShort:"code-server",nameLong:"code-server",applicationName:"code-server",dataFolderName:".code-server",win32MutexName:"codeserver",licenseName:"MIT",licenseUrl:"https://github.com/coder/code-server/blob/main/LICENSE",serverGreeting:[],serverLicense:[],serverLicensePrompt:"",serverApplicationName:"code-server-oss",serverDataFolderName:".vscode-server-oss",tunnelApplicationName:"code-tunnel-oss",win32DirName:"code-server",win32NameVersion:"code-server",win32RegValueName:"CodeOSS",win32AppId:"{{E34003BB-9E10-4501-8C11-BE3FAA83F23F}",win32x64AppId:"{{D77B7E06-80BA-4137-BCF4-654B95CCEBC5}",win32arm64AppId:"{{D1ACE434-89C5-48D1-88D3-E2991DF85475}",win32UserAppId:"{{C6065F05-9603-4FC4-8101-B9781A25D88E}",win32x64UserAppId:"{{CC6B787D-37A0-49E8-AE24-8559A032BE0C}",win32arm64UserAppId:"{{3AEBF0C8-F733-4AD4-BADE-FDB816D53D7B}",win32AppUserModelId:"coder.code-server",win32ShellNameShort:"c&ode-server",darwinBundleIdentifier:"com.coder.code.server",linuxIconName:"com.coder.code.server",licenseFileName:"LICENSE.txt",reportIssueUrl:"https://github.com/coder/code-server/issues/new",urlProtocol:"code-oss",webviewContentExternalBaseUrlTemplate:"https://{{uuid}}.vscode-cdn.net/insider/ef65ac1ba57f57f2a3961bfe94aa20481caca4c6/out/vs/workbench/contrib/webview/browser/pre/",builtInExtensions:[{name:"ms-vscode.js-debug-companion",version:"1.0.18",repo:"https://github.com/microsoft/vscode-js-debug-companion",metadata:{id:"99cb0b7f-7354-4278-b8da-6cc79972169d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug",version:"1.76.0",repo:"https://github.com/microsoft/vscode-js-debug",metadata:{id:"25629058-ddac-4e17-abba-74678e126c5d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.vscode-js-profile-table",version:"1.0.3",repo:"https://github.com/microsoft/vscode-js-profile-visualizer",metadata:{id:"7e52b41b-71ad-457b-ab7e-0620f1fc4feb",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}}],enableTelemetry:!0,quality:"stable",codeServerVersion:"0.0.0",documentationUrl:"https://go.microsoft.com/fwlink/?LinkID=533484#vscode",keyboardShortcutsUrlMac:"https://go.microsoft.com/fwlink/?linkid=832143",keyboardShortcutsUrlLinux:"https://go.microsoft.com/fwlink/?linkid=832144",keyboardShortcutsUrlWin:"https://go.microsoft.com/fwlink/?linkid=832145",introductoryVideosUrl:"https://go.microsoft.com/fwlink/?linkid=832146",tipsAndTricksUrl:"https://go.microsoft.com/fwlink/?linkid=852118",newsletterSignupUrl:"https://www.research.net/r/vsc-newsletter",linkProtectionTrustedDomains:["https://open-vsx.org"],aiConfig:{ariaKey:"code-server"},version:"1.76.1",commit:"5e805b79fcb6ba4c2d23712967df89a089da575b",date:"2023-03-14T20:11:32.198Z"},Object.keys(l).length===0&&Object.assign(l,{version:"1.72.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=l}),define(ye[208],De([1,0,4]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,a.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var ze=this&&this.__param||function(re,e){return function(a,L){e(a,L,re)}};define(ye[126],De([1,0,17,21,6,4]),function(re,e,a,L,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,R.createDecorator)("progressService");var S;(function(O){O[O.Explorer=1]="Explorer",O[O.Scm=3]="Scm",O[O.Extensions=5]="Extensions",O[O.Window=10]="Window",O[O.Notification=15]="Notification",O[O.Dialog=20]="Dialog"})(S=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class A{get value(){return this.a}constructor(P){this.b=P}report(P){this.a=P,this.b(this.a)}}A.None=Object.freeze({report(){}}),e.Progress=A;let y=class extends l.Disposable{constructor(P,v){super(),this.a=new a.DeferredPromise,v.withProgress(P,k=>(this.b=k,this.c&&k.report(this.c),this.a.p)),this.B((0,l.toDisposable)(()=>this.a.complete()))}report(P){this.b?this.b.report(P):this.c=P}};y=qe([ze(1,e.IProgressService)],y),e.UnmanagedProgress=y;class I extends l.Disposable{constructor(P){super(),this.g=P,this.a=0,this.b=this.B(new l.DisposableStore)}start(P){this.stop();const v=++this.a,k=new L.CancellationTokenSource;return this.f=setTimeout(()=>{v===this.a&&(this.c=this.g.show(!0))},P),this.b.add((0,l.toDisposable)(()=>clearTimeout(this.f))),this.b.add((0,l.toDisposable)(()=>k.cancel())),this.b.add((0,l.toDisposable)(()=>this.c?this.c.done():void 0)),{id:v,token:k.token,stop:()=>this.h(v),isCurrent:()=>this.a===v}}stop(){this.h(this.a)}h(P){this.a===P&&this.b.clear()}}e.LongRunningOperation=I,e.IEditorProgressService=(0,R.createDecorator)("editorProgressService")}),define(ye[39],De([1,0,50,10]),function(re,e,a,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class l{constructor(){this.a=new Map}add(S,A){a.ok(L.isString(S)),a.ok(L.isObject(A)),a.ok(!this.a.has(S),"There is already an extension with this id"),this.a.set(S,A)}knows(S){return this.a.has(S)}as(S){return this.a.get(S)||null}}e.Registry=new l}),define(ye[92],De([1,0,3,39]),function(re,e,a,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function l(A){return A.length>0&&A.charAt(A.length-1)==="#"?A.substring(0,A.length-1):A}class R{constructor(){this.b=new a.Emitter,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(y,I){this.a[l(y)]=I,this.b.fire(y)}notifySchemaChanged(y){this.b.fire(y)}getSchemaContributions(){return{schemas:this.a}}}const S=new R;L.Registry.add(e.Extensions.JSONContribution,S)}),define(ye[127],De([1,0,15,3,10,168,54,92,39]),function(re,e,a,L,l,R,S,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var I;(function(g){g.Multiline="multilineText",g.Singleline="singlelineText"})(I=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var O;(function(g){g[g.APPLICATION=1]="APPLICATION",g[g.MACHINE=2]="MACHINE",g[g.WINDOW=3]="WINDOW",g[g.RESOURCE=4]="RESOURCE",g[g.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",g[g.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(O=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const P=y.Registry.as(A.Extensions.JSONContribution);class v{constructor(){this.h=new Set,this.i=new L.Emitter,this.onDidSchemaChange=this.i.event,this.j=new L.Emitter,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:R.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},P.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.v()}registerConfiguration(i,s=!0){this.registerConfigurations([i],s)}registerConfigurations(i,s=!0){const r=new Set;this.n(i,s,r),P.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:r})}deregisterConfigurations(i){const s=new Set;this.o(i,s),P.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:s})}updateConfigurations({add:i,remove:s}){const r=new Set;this.o(s,r),this.n(i,!1,r),P.registerSchema(e.resourceLanguageSettingsSchemaId,this.g),this.i.fire(),this.j.fire({properties:r})}registerDefaultConfigurations(i){const s=new Set;this.k(i,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}k(i,s){const r=[];for(const{overrides:o,source:c}of i)for(const m in o)if(s.add(m),e.OVERRIDE_PROPERTY_REGEX.test(m)){const n=this.a.get(m),t=n?.valuesSources??new Map;if(c)for(const N of Object.keys(o[m]))t.set(N,c);const d={...n?.value||{},...o[m]};this.a.set(m,{source:c,value:d,valuesSources:t});const E=(0,S.getLanguageTagSettingPlainKey)(m),w={type:"object",default:d,description:R.localize(1,null,E),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:d,source:l.isString(c)?void 0:c,defaultValueSource:c};r.push(...f(m)),this.d[m]=w,this.b.properties[m]=w}else{this.a.set(m,{value:o[m],source:c});const n=this.d[m];n&&(this.w(m,n),this.r(m,n))}this.m(r)}deregisterDefaultConfigurations(i){const s=new Set;this.l(i,s),this.i.fire(),this.j.fire({properties:s,defaultsOverrides:!0})}l(i,s){for(const{overrides:r,source:o}of i)for(const c in r){const m=this.a.get(c),n=l.isString(o)?o:o?.id,t=l.isString(m?.source)?m?.source:m?.source?.id;if(n===t)if(s.add(c),this.a.delete(c),e.OVERRIDE_PROPERTY_REGEX.test(c))delete this.d[c],delete this.b.properties[c];else{const d=this.d[c];d&&(this.w(c,d),this.r(c,d))}}this.u()}deltaConfiguration(i){let s=!1;const r=new Set;i.removedDefaults&&(this.l(i.removedDefaults,r),s=!0),i.addedDefaults&&(this.k(i.addedDefaults,r),s=!0),i.removedConfigurations&&this.o(i.removedConfigurations,r),i.addedConfigurations&&this.n(i.addedConfigurations,!1,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:s})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const s of i)this.h.add(s);this.u()}n(i,s,r){i.forEach(o=>{this.p(o,s,o.extensionInfo,o.restrictedProperties,void 0,r),this.c.push(o),this.q(o)})}o(i,s){const r=o=>{if(o.properties)for(const c in o.properties){s.add(c);const m=this.d[c];m?.policy?.name&&this.e.delete(m.policy.name),delete this.d[c],this.s(c,o.properties[c])}o.allOf?.forEach(c=>r(c))};for(const o of i){r(o);const c=this.c.indexOf(o);c!==-1&&this.c.splice(c,1)}}p(i,s=!0,r,o,c=3,m){c=l.isUndefinedOrNull(i.scope)?c:i.scope;const n=i.properties;if(n)for(const d in n){const E=n[d];if(s&&b(d,E)){delete n[d];continue}if(E.source=r,E.defaultDefaultValue=n[d].default,this.w(d,E),e.OVERRIDE_PROPERTY_REGEX.test(d)?E.scope=void 0:(E.scope=l.isUndefinedOrNull(E.scope)?c:E.scope,E.restricted=l.isUndefinedOrNull(E.restricted)?!!o?.includes(d):E.restricted),n[d].hasOwnProperty("included")&&!n[d].included){this.f[d]=n[d],delete n[d];continue}else this.d[d]=n[d],n[d].policy?.name&&this.e.set(n[d].policy.name,d);!n[d].deprecationMessage&&n[d].markdownDeprecationMessage&&(n[d].deprecationMessage=n[d].markdownDeprecationMessage),m.add(d)}const t=i.allOf;if(t)for(const d of t)this.p(d,s,r,o,c,m)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const s=r=>{const o=r.properties;if(o)for(const m in o)this.r(m,o[m]);r.allOf?.forEach(s)};s(i)}r(i,s){switch(e.allSettings.properties[i]=s,s.scope){case 1:e.applicationSettings.properties[i]=s;break;case 2:e.machineSettings.properties[i]=s;break;case 6:e.machineOverridableSettings.properties[i]=s;break;case 3:e.windowSettings.properties[i]=s;break;case 4:e.resourceSettings.properties[i]=s;break;case 5:e.resourceSettings.properties[i]=s,this.g.properties[i]=s;break}}s(i,s){switch(delete e.allSettings.properties[i],s.scope){case 1:delete e.applicationSettings.properties[i];break;case 2:delete e.machineSettings.properties[i];break;case 6:delete e.machineOverridableSettings.properties[i];break;case 3:delete e.windowSettings.properties[i];break;case 4:case 5:delete e.resourceSettings.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const s=`[${i}]`,r={type:"object",description:R.localize(2,null),errorMessage:R.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.w(s,r),e.allSettings.properties[s]=r,e.applicationSettings.properties[s]=r,e.machineSettings.properties[s]=r,e.machineOverridableSettings.properties[s]=r,e.windowSettings.properties[s]=r,e.resourceSettings.properties[s]=r}}v(){const i={type:"object",description:R.localize(4,null),errorMessage:R.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=i,this.i.fire()}w(i,s){const r=this.a.get(i);let o=r?.value,c=r?.source;l.isUndefined(o)&&(o=s.defaultDefaultValue,c=void 0),l.isUndefined(o)&&(o=h(s.type)),s.default=o,s.defaultValueSource=c}}const k="\\[([^\\]]+)\\]",D=new RegExp(k,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${k})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function f(g){const i=[];if(e.OVERRIDE_PROPERTY_REGEX.test(g)){let s=D.exec(g);for(;s?.length;){const r=s[1].trim();r&&i.push(r),s=D.exec(g)}}return(0,a.distinct)(i)}e.overrideIdentifiersFromKey=f;function u(g){return g.reduce((i,s)=>`${i}[${s}]`,"")}e.keyFromOverrideIdentifiers=u;function h(g){switch(Array.isArray(g)?g[0]:g){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=h;const p=new v;y.Registry.add(e.Extensions.Configuration,p);function b(g,i){return g.trim()?e.OVERRIDE_PROPERTY_REGEX.test(g)?R.localize(7,null,g):p.getConfigurationProperties()[g]!==void 0?R.localize(8,null,g):i.policy?.name&&p.getPolicyConfigurations().get(i.policy?.name)!==void 0?R.localize(9,null,g,i.policy?.name,p.getPolicyConfigurations().get(i.policy?.name)):null:R.localize(6,null)}e.validateProperty=b;function C(){const g=[],i=p.getConfigurationProperties();for(const s of Object.keys(i))g.push([s,i[s].scope]);return g.push(["launch",4]),g.push(["task",4]),g}e.getScopes=C}),define(ye[209],De([1,0,15,3,146,6,28,23,10,2,54,127,39]),function(re,e,a,L,l,R,S,A,y,I,O,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;function k(s){return Object.isFrozen(s)?s:A.deepFreeze(s)}class D{constructor(r={},o=[],c=[],m){this.b=r,this.c=o,this.d=c,this.raw=m,this.a=new Map}get rawConfiguration(){if(!this.f)if(this.raw?.length){const r=this.raw.map(o=>{if(o instanceof D)return o;const c=new f("");return c.parseRaw(o),c.configurationModel});this.f=r.reduce((o,c)=>c===o?c:o.merge(c),r[0])}else this.f=this;return this.f}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(r){return r?(0,O.getConfigurationValue)(this.contents,r):this.contents}inspect(r,o){const c=this.rawConfiguration.getValue(r),m=o?this.rawConfiguration.getOverrideValue(r,o):void 0,n=o?this.rawConfiguration.override(o).getValue(r):c;return{value:c,override:m,merged:n}}getOverrideValue(r,o){const c=this.i(o);return c?r?(0,O.getConfigurationValue)(c,r):c:void 0}getKeysForOverrideIdentifier(r){const o=[];for(const c of this.overrides)c.identifiers.includes(r)&&o.push(...c.keys);return a.distinct(o)}getAllOverrideIdentifiers(){const r=[];for(const o of this.overrides)r.push(...o.identifiers);return a.distinct(r)}override(r){let o=this.a.get(r);return o||(o=this.g(r),this.a.set(r,o)),o}merge(...r){const o=A.deepClone(this.contents),c=A.deepClone(this.overrides),m=[...this.keys],n=this.raw?.length?[...this.raw]:[this];for(const t of r)if(n.push(...t.raw?.length?t.raw:[t]),!t.isEmpty()){this.h(o,t.contents);for(const d of t.overrides){const[E]=c.filter(w=>a.equals(w.identifiers,d.identifiers));E?(this.h(E.contents,d.contents),E.keys.push(...d.keys),E.keys=a.distinct(E.keys)):c.push(A.deepClone(d))}for(const d of t.keys)m.indexOf(d)===-1&&m.push(d)}return new D(o,m,c,n.every(t=>t instanceof D)?void 0:n)}g(r){const o=this.i(r);if(!o||typeof o!="object"||!Object.keys(o).length)return this;const c={};for(const m of a.distinct([...Object.keys(this.contents),...Object.keys(o)])){let n=this.contents[m];const t=o[m];t&&(typeof n=="object"&&typeof t=="object"?(n=A.deepClone(n),this.h(n,t)):n=t),c[m]=n}return new D(c,this.keys,this.overrides)}h(r,o){for(const c of Object.keys(o)){if(c in r&&y.isObject(r[c])&&y.isObject(o[c])){this.h(r[c],o[c]);continue}r[c]=A.deepClone(o[c])}}i(r){let o=null,c=null;const m=n=>{n&&(c?this.h(c,n):c=A.deepClone(n))};for(const n of this.overrides)a.equals(n.identifiers,[r])?o=n.contents:n.identifiers.includes(r)&&m(n.contents);return m(o),c}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(r,o){this.j(r,o,!0)}setValue(r,o){this.j(r,o,!1)}removeValue(r){const o=this.keys.indexOf(r);o!==-1&&(this.keys.splice(o,1),(0,O.removeFromValueTree)(this.contents,r),P.OVERRIDE_PROPERTY_REGEX.test(r)&&this.overrides.splice(this.overrides.findIndex(c=>a.equals(c.identifiers,(0,P.overrideIdentifiersFromKey)(r))),1))}j(r,o,c){(0,O.addToValueTree)(this.contents,r,o,m=>console.error(m)),c=c||this.keys.indexOf(r)===-1,c&&this.keys.push(r),P.OVERRIDE_PROPERTY_REGEX.test(r)&&this.overrides.push({identifiers:(0,P.overrideIdentifiersFromKey)(r),keys:Object.keys(this.contents[r]),contents:(0,O.toValuesTree)(this.contents[r],m=>console.error(m))})}}e.ConfigurationModel=D;class f{constructor(r){this.f=r,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||new D}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(r,o){if(!y.isUndefinedOrNull(r)){const c=this.g(r);this.parseRaw(c,o)}}reparse(r){this.a&&this.parseRaw(this.a,r)}parseRaw(r,o){this.a=r;const{contents:c,keys:m,overrides:n,restricted:t,hasExcludedProperties:d}=this.h(r,o);this.b=new D(c,m,n,d?[r]:void 0),this.c=t||[]}g(r){let o={},c=null,m=[];const n=[],t=[];function d(w){Array.isArray(m)?m.push(w):c!==null&&(m[c]=w)}const E={onObjectBegin:()=>{const w={};d(w),n.push(m),m=w,c=null},onObjectProperty:w=>{c=w},onObjectEnd:()=>{m=n.pop()},onArrayBegin:()=>{const w=[];d(w),n.push(m),m=w,c=null},onArrayEnd:()=>{m=n.pop()},onLiteralValue:d,onError:(w,N,j)=>{t.push({error:w,offset:N,length:j})}};if(r)try{l.visit(r,E),o=m[0]||{}}catch(w){console.error(`Error while parsing settings file ${this.f}: ${w}`),this.d=[w]}return o}h(r,o){const c=v.Registry.as(P.Extensions.Configuration).getConfigurationProperties(),m=this.i(r,c,!0,o);r=m.raw;const n=(0,O.toValuesTree)(r,E=>console.error(`Conflict in settings file ${this.f}: ${E}`)),t=Object.keys(r),d=this.j(r,E=>console.error(`Conflict in settings file ${this.f}: ${E}`));return{contents:n,keys:t,overrides:d,restricted:m.restricted,hasExcludedProperties:m.hasExcludedProperties}}i(r,o,c,m){let n=!1;if(!m?.scopes&&!m?.skipRestricted)return{raw:r,restricted:[],hasExcludedProperties:n};const t={},d=[];for(const E in r)if(P.OVERRIDE_PROPERTY_REGEX.test(E)&&c){const w=this.i(r[E],o,!1,m);t[E]=w.raw,n=n||w.hasExcludedProperties,d.push(...w.restricted)}else{const w=o[E],N=w?typeof w.scope<"u"?w.scope:3:void 0;w?.restricted&&d.push(E),(N===void 0||m.scopes===void 0||m.scopes.includes(N))&&!(m.skipRestricted&&w?.restricted)?t[E]=r[E]:n=!0}return{raw:t,restricted:d,hasExcludedProperties:n}}j(r,o){const c=[];for(const m of Object.keys(r))if(P.OVERRIDE_PROPERTY_REGEX.test(m)){const n={};for(const t in r[m])n[t]=r[m][t];c.push({identifiers:(0,P.overrideIdentifiersFromKey)(m),keys:Object.keys(n),contents:(0,O.toValuesTree)(n,o)})}return c}}e.ConfigurationModelParser=f;class u extends R.Disposable{constructor(r,o,c,m){super(),this.f=r,this.g=o,this.h=m,this.c=this.B(new L.Emitter),this.onDidChange=this.c.event,this.a=new f(this.f.toString()),this.b={scopes:this.g},this.B(this.h.watch(c.dirname(this.f))),this.B(this.h.watch(this.f)),this.B(L.Event.any(L.Event.filter(this.h.onDidFilesChange,n=>n.contains(this.f)),L.Event.filter(this.h.onDidRunOperation,n=>(n.isOperation(0)||n.isOperation(3)||n.isOperation(1)||n.isOperation(4))&&c.isEqual(n.resource,r)))(()=>this.c.fire()))}async loadConfiguration(){try{const r=await this.h.readFile(this.f);return this.a.parse(r.value.toString()||"{}",this.b),this.a.configurationModel}catch{return new D}}reparse(){return this.a.reparse(this.b),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.UserSettings=u;class h{constructor(r,o,c,m,n,t,d,E,w,N,j,V,Q){this.a=r,this.b=o,this.c=c,this.overrideIdentifiers=m,this.d=n,this.f=t,this.g=d,this.h=E,this.i=w,this.j=N,this.k=j,this.l=V,this.m=Q}get value(){return k(this.c)}n(r,o,c){const m=r.inspect(o,c);return{get value(){return k(m.value)},get override(){return k(m.override)},get merged(){return k(m.merged)}}}get q(){return this.p||(this.p=this.n(this.d,this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.q.value!==void 0||this.q.override!==void 0?{value:this.q.value,override:this.q.override}:void 0}get s(){return this.r===void 0&&(this.r=this.f?this.n(this.f,this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.n(this.g,this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.u?.value!==void 0||this.u?.override!==void 0?{value:this.u.value,override:this.u.override}:void 0}get w(){return this.v||(this.v=this.n(this.h,this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.w.value!==void 0||this.w.override!==void 0?{value:this.w.value,override:this.w.override}:void 0}get y(){return this.x||(this.x=this.n(this.i,this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.y.value!==void 0||this.y.override!==void 0?{value:this.y.value,override:this.y.override}:void 0}get A(){return this.z||(this.z=this.n(this.j,this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.A.value!==void 0||this.A.override!==void 0?{value:this.A.value,override:this.A.override}:void 0}get D(){return this.B===void 0&&(this.B=this.k?this.n(this.k,this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.D?.value!==void 0||this.D?.override!==void 0?{value:this.D.value,override:this.D.override}:void 0}get F(){return this.E===void 0&&(this.E=this.l?this.n(this.l,this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.F?.value!==void 0||this.F?.override!==void 0?{value:this.F.value,override:this.F.override}:void 0}get H(){return this.G===void 0&&(this.G=this.n(this.m,this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.H.value!==void 0||this.H.override!==void 0?{value:this.H.value,override:this.H.override}:void 0}}class p{constructor(r,o,c,m,n=new D,t=new D,d=new S.ResourceMap,E=new D,w=new S.ResourceMap){this.c=r,this.d=o,this.f=c,this.g=m,this.h=n,this.i=t,this.j=d,this.l=E,this.m=w,this.a=null,this.b=new S.ResourceMap,this.n=null}getValue(r,o,c){return this.q(r,o,c).getValue(r)}updateValue(r,o,c={}){let m;c.resource?(m=this.m.get(c.resource),m||(m=new D,this.m.set(c.resource,m))):m=this.l,o===void 0?m.removeValue(r):m.setValue(r,o),c.resource||(this.a=null)}inspect(r,o,c){const m=this.q(r,o,c),n=this.u(o.resource,c),t=o.resource?this.m.get(o.resource)||this.l:this.l,d=new Set;for(const E of m.overrides)for(const w of E.identifiers)m.getOverrideValue(r,w)!==void 0&&d.add(w);return new h(r,o,m.getValue(r),d.size?[...d]:void 0,this.c,this.d.isEmpty()?void 0:this.d,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,c?this.i:void 0,n||void 0,t)}keys(r){const o=this.u(void 0,r);return{default:this.c.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.i.keys.slice(0),workspaceFolder:o?o.keys.slice(0):[]}}updateDefaultConfiguration(r){this.c=r,this.a=null,this.b.clear()}updatePolicyConfiguration(r){this.d=r}updateApplicationConfiguration(r){this.f=r,this.a=null,this.b.clear()}updateLocalUserConfiguration(r){this.g=r,this.n=null,this.a=null,this.b.clear()}updateRemoteUserConfiguration(r){this.h=r,this.n=null,this.a=null,this.b.clear()}updateWorkspaceConfiguration(r){this.i=r,this.a=null,this.b.clear()}updateFolderConfiguration(r,o){this.j.set(r,o),this.b.delete(r)}deleteFolderConfiguration(r){this.p.delete(r),this.b.delete(r)}compareAndUpdateDefaultConfiguration(r,o){const c=[];if(!o){const{added:m,updated:n,removed:t}=g(this.c,r);o=[...m,...n,...t]}for(const m of o)for(const n of(0,P.overrideIdentifiersFromKey)(m)){const t=this.c.getKeysForOverrideIdentifier(n),d=r.getKeysForOverrideIdentifier(n),E=[...d.filter(w=>t.indexOf(w)===-1),...t.filter(w=>d.indexOf(w)===-1),...t.filter(w=>!A.equals(this.c.override(n).getValue(w),r.override(n).getValue(w)))];c.push([n,E])}return this.updateDefaultConfiguration(r),{keys:o,overrides:c}}compareAndUpdatePolicyConfiguration(r){const{added:o,updated:c,removed:m}=g(this.d,r),n=[...o,...c,...m];return n.length&&this.updatePolicyConfiguration(r),{keys:n,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:o,updated:c,removed:m,overrides:n}=g(this.applicationConfiguration,r),t=[...o,...c,...m];return t.length&&this.updateApplicationConfiguration(r),{keys:t,overrides:n}}compareAndUpdateLocalUserConfiguration(r){const{added:o,updated:c,removed:m,overrides:n}=g(this.localUserConfiguration,r),t=[...o,...c,...m];return t.length&&this.updateLocalUserConfiguration(r),{keys:t,overrides:n}}compareAndUpdateRemoteUserConfiguration(r){const{added:o,updated:c,removed:m,overrides:n}=g(this.remoteUserConfiguration,r),t=[...o,...c,...m];return t.length&&this.updateRemoteUserConfiguration(r),{keys:t,overrides:n}}compareAndUpdateWorkspaceConfiguration(r){const{added:o,updated:c,removed:m,overrides:n}=g(this.workspaceConfiguration,r),t=[...o,...c,...m];return t.length&&this.updateWorkspaceConfiguration(r),{keys:t,overrides:n}}compareAndUpdateFolderConfiguration(r,o){const c=this.p.get(r),{added:m,updated:n,removed:t,overrides:d}=g(c,o),E=[...m,...n,...t];return(E.length||!c)&&this.updateFolderConfiguration(r,o),{keys:E,overrides:d}}compareAndDeleteFolderConfiguration(r){const o=this.p.get(r);if(!o)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:c,updated:m,removed:n,overrides:t}=g(o,void 0);return{keys:[...c,...m,...n],overrides:t}}get defaults(){return this.c}get applicationConfiguration(){return this.f}get userConfiguration(){return this.n||(this.n=this.h.isEmpty()?this.g:this.g.merge(this.h)),this.n}get localUserConfiguration(){return this.g}get remoteUserConfiguration(){return this.h}get workspaceConfiguration(){return this.i}get p(){return this.j}q(r,o,c){let m=this.r(o,c);return o.overrideIdentifier&&(m=m.override(o.overrideIdentifier)),!this.d.isEmpty()&&this.d.getValue(r)!==void 0&&(m=m.merge(this.d)),m}r({resource:r},o){let c=this.s();if(o&&r){const m=o.getFolder(r);m&&(c=this.t(m.uri)||c);const n=this.m.get(r);n&&(c=c.merge(n))}return c}s(){return this.a||(this.a=this.c.merge(this.applicationConfiguration,this.userConfiguration,this.i,this.l)),this.a}t(r){let o=this.b.get(r);if(!o){const c=this.s(),m=this.j.get(r);m?(o=c.merge(m),this.b.set(r,o)):o=c}return o}u(r,o){if(o&&r){const c=o.getFolder(r);if(c)return this.j.get(c.uri)}}toData(){return{defaults:{contents:this.c.contents,overrides:this.c.overrides,keys:this.c.keys},policy:{contents:this.d.contents,overrides:this.d.overrides,keys:this.d.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.i.contents,overrides:this.i.overrides,keys:this.i.keys},folders:[...this.j.keys()].reduce((r,o)=>{const{contents:c,overrides:m,keys:n}=this.j.get(o);return r.push([o,{contents:c,overrides:m,keys:n}]),r},[])}}allKeys(){const r=new Set;return this.c.keys.forEach(o=>r.add(o)),this.userConfiguration.keys.forEach(o=>r.add(o)),this.i.keys.forEach(o=>r.add(o)),this.j.forEach(o=>o.keys.forEach(c=>r.add(c))),[...r.values()]}v(){const r=new Set;return this.c.getAllOverrideIdentifiers().forEach(o=>r.add(o)),this.userConfiguration.getAllOverrideIdentifiers().forEach(o=>r.add(o)),this.i.getAllOverrideIdentifiers().forEach(o=>r.add(o)),this.j.forEach(o=>o.getAllOverrideIdentifiers().forEach(c=>r.add(c))),[...r.values()]}w(r){const o=new Set;return this.c.getKeysForOverrideIdentifier(r).forEach(c=>o.add(c)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(c=>o.add(c)),this.i.getKeysForOverrideIdentifier(r).forEach(c=>o.add(c)),this.j.forEach(c=>c.getKeysForOverrideIdentifier(r).forEach(m=>o.add(m))),[...o.values()]}static parse(r){const o=this.x(r.defaults),c=this.x(r.policy),m=this.x(r.application),n=this.x(r.user),t=this.x(r.workspace),d=r.folders.reduce((E,w)=>(E.set(I.URI.revive(w[0]),this.x(w[1])),E),new S.ResourceMap);return new p(o,c,m,n,new D,t,d,new D,new S.ResourceMap)}static x(r){return new D(r.contents,r.keys,r.overrides)}}e.Configuration=p;function b(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const r=new Set,o=new Map;for(const m of s)m.keys.forEach(n=>r.add(n)),m.overrides.forEach(([n,t])=>{const d=(0,S.getOrSet)(o,n,new Set);t.forEach(E=>d.add(E))});const c=[];return o.forEach((m,n)=>c.push([n,[...m.values()]])),{keys:[...r.values()],overrides:c}}e.mergeChanges=b;class C{constructor(r,o,c,m){this.change=r,this.f=o,this.g=c,this.h=m,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=".".charCodeAt(0),this.affectedKeys=new Set,this.i=void 0;for(const n of r.keys)this.affectedKeys.add(n);for(const[,n]of r.overrides)for(const t of n)this.affectedKeys.add(t);this.d=this.a;for(const n of this.affectedKeys)this.d+=n+this.a}get previousConfiguration(){return!this.i&&this.f&&(this.i=p.parse(this.f.data)),this.i}affectsConfiguration(r,o){const c=this.a+r,m=this.d.indexOf(c);if(m<0)return!1;const n=m+c.length;if(n>=this.d.length)return!1;const t=this.d.charCodeAt(n);if(t!==this.b&&t!==this.c)return!1;if(o){const d=this.previousConfiguration?this.previousConfiguration.getValue(r,o,this.f?.workspace):void 0,E=this.g.getValue(r,o,this.h);return!A.equals(d,E)}return!0}}e.ConfigurationChangeEvent=C;function g(s,r){const{added:o,removed:c,updated:m}=i(r?.rawConfiguration,s?.rawConfiguration),n=[],t=s?.getAllOverrideIdentifiers()||[],d=r?.getAllOverrideIdentifiers()||[];if(r){const E=d.filter(w=>!t.includes(w));for(const w of E)n.push([w,r.getKeysForOverrideIdentifier(w)])}if(s){const E=t.filter(w=>!d.includes(w));for(const w of E)n.push([w,s.getKeysForOverrideIdentifier(w)])}if(r&&s){for(const E of t)if(d.includes(E)){const w=i({contents:s.getOverrideValue(void 0,E)||{},keys:s.getKeysForOverrideIdentifier(E)},{contents:r.getOverrideValue(void 0,E)||{},keys:r.getKeysForOverrideIdentifier(E)});n.push([E,[...w.added,...w.removed,...w.updated]])}}return{added:o,removed:c,updated:m,overrides:n}}function i(s,r){const o=s?r?s.keys.filter(n=>r.keys.indexOf(n)===-1):[...s.keys]:[],c=r?s?r.keys.filter(n=>s.keys.indexOf(n)===-1):[...r.keys]:[],m=[];if(s&&r){for(const n of r.keys)if(s.keys.indexOf(n)!==-1){const t=(0,O.getConfigurationValue)(r.contents,n),d=(0,O.getConfigurationValue)(s.contents,n);A.equals(t,d)||m.push(n)}}return{added:o,removed:c,updated:m}}}),define(ye[128],De([1,0,11,4]),function(re,e,a,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemoteAuthorityPrefix=e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,L.createDecorator)("remoteAuthorityResolverService");var l;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound"})(l=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class R extends a.ErrorNoTelemetry{static isNotAvailable(y){return y instanceof R&&y._code===l.NotAvailable}static isTemporarilyNotAvailable(y){return y instanceof R&&y._code===l.TemporarilyNotAvailable}static isNoResolverFound(y){return y instanceof R&&y._code===l.NoResolverFound}static isHandled(y){return y instanceof R&&y.isHandled}constructor(y,I=l.Unknown,O){super(y),this._message=y,this._code=I,this._detail=O,this.isHandled=I===l.NotAvailable&&O===!0,Object.setPrototypeOf(this,R.prototype)}}e.RemoteAuthorityResolverError=R;function S(A){const y=A.indexOf("+");return y===-1?A:A.substring(0,y)}e.getRemoteAuthorityPrefix=S}),define(ye[73],De([1,0,16]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function L(I){return I.scheme===a.Schemas.vscodeRemote?I.authority:void 0}e.getRemoteAuthority=L;function l(I){if(!I)return;const O=I.indexOf("+");return O<0?I:I.substr(0,O)}e.getRemoteName=l;function R(I){return`/${I.quality??"oss"}-${I.commit??"dev"}`}e.getRemoteServerRootPath=R;function S(I){const{host:O,port:P}=y(I);if(typeof P>"u")throw new Error("Remote authority doesn't contain a port!");return{host:O,port:P}}e.parseAuthorityWithPort=S;function A(I,O){let{host:P,port:v}=y(I);return typeof v>"u"&&(v=O),{host:P,port:v}}e.parseAuthorityWithOptionalPort=A;function y(I){const O=I.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(O)return{host:O[1],port:parseInt(O[2],10)};const P=I.match(/^(\[[0-9a-z:]+\])$/);if(P)return{host:P[1],port:void 0};const v=I.match(/(.*):(\d+)$/);return v?{host:v[1],port:parseInt(v[2],10)}:{host:I,port:void 0}}}),define(ye[27],De([1,0,8,4,73]),function(re,e,a,L,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function R(k){if(typeof k=="object"&&k!==null&&k.supported!==!0)return k.description}e.getWorkspaceSupportTypeMessage=R,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var S;(function(k){k[k.System=0]="System",k[k.User=1]="User"})(S=e.ExtensionType||(e.ExtensionType={}));var A;(function(k){k.WIN32_X64="win32-x64",k.WIN32_IA32="win32-ia32",k.WIN32_ARM64="win32-arm64",k.LINUX_X64="linux-x64",k.LINUX_ARM64="linux-arm64",k.LINUX_ARMHF="linux-armhf",k.ALPINE_X64="alpine-x64",k.ALPINE_ARM64="alpine-arm64",k.DARWIN_X64="darwin-x64",k.DARWIN_ARM64="darwin-arm64",k.WEB="web",k.UNIVERSAL="universal",k.UNKNOWN="unknown",k.UNDEFINED="undefined"})(A=e.TargetPlatform||(e.TargetPlatform={}));class y{constructor(D){this.value=D,this.c=D.toLowerCase()}static equals(D,f){if(typeof D>"u"||D===null)return typeof f>"u"||f===null;if(typeof f>"u"||f===null)return!1;if(typeof D=="string"||typeof f=="string"){const u=typeof D=="string"?D:D.value,h=typeof f=="string"?f:f.value;return a.equalsIgnoreCase(u,h)}return D.c===f.c}static toKey(D){return typeof D=="string"?D.toLowerCase():D.c}}e.ExtensionIdentifier=y;function I(k){return O(k)}e.isApplicationScopedExtension=I;function O(k){return k.contributes&&k.contributes.localizations?k.contributes.localizations.length>0:!1}e.isLanguagePackExtension=O;function P(k){return k.contributes&&k.contributes.authentication?k.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=P;function v(k,D){if(D){const f=`onResolveRemoteAuthority:${(0,l.getRemoteName)(D)}`;return!!k.activationEvents?.includes(f)}return!1}e.isResolverExtension=v,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(ye[210],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class a{constructor(){this.b=new Map}c(){return new Promise((l,R)=>re(["vsda"],l,R))}async createNewMessage(l){try{const R=await this.c(),S=new R.validator;if(S){const A=String(a.a++);return this.b.set(A,S),{id:A,data:S.createNewMessage(l)}}}catch{}return{id:"",data:l}}async validate(l,R){if(!l.id)return!0;const S=this.b.get(l.id);if(!S)return!1;this.b.delete(l.id);try{return S.validate(R)==="ok"}catch{return!1}}async sign(l){try{const R=await this.c(),S=new R.signer;if(S)return S.sign(l)}catch{}return l}}a.a=1,e.SignService=a}),define(ye[211],De([1,0,12,36,2,30]),function(re,e,a,L,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function S(I){if(a.platform===2&&/^penguin(\.|$)/i.test(I))return"chromebook"}async function A(I,O,P,v,k,D,f,u,h,p){const b=Object.create(null);b["common.machineId"]=f,b.sessionID=(0,R.generateUuid)()+Date.now(),b.commitHash=k,b.version=D,b["common.platformVersion"]=(O||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),b["common.platform"]=(0,a.PlatformToString)(a.platform),b["common.nodePlatform"]=L.platform,b["common.nodeArch"]=v,b["common.product"]=p||"desktop",u&&(b["common.msftInternal"]=u);let C=0;const g=Date.now();Object.defineProperties(b,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-g,enumerable:!0},"common.sequence":{get:()=>C++,enumerable:!0}}),a.isLinuxSnap&&(b["common.snap"]="true");const i=S(P);i&&(b["common.platformDetail"]=i);try{const s=await I.readFile(l.URI.file(h));b["common.source"]=s.value.toString().slice(0,30)}catch{}return b}e.resolveCommonProperties=A;function y(I){const O=L.env.USERDNSDOMAIN;if(!O)return!1;const P=O.toLowerCase();return I.some(v=>P===v)}e.verifyMicrosoftInternalDomain=y}),define(ye[212],De([1,0,4]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_CRASH_REPORTER_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,a.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,a.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_CRASH_REPORTER_SETTING_ID="telemetry.enableCrashReporter",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var L;(function(R){R[R.NONE=0]="NONE",R[R.CRASH=1]="CRASH",R[R.ERROR=2]="ERROR",R[R.USAGE=3]="USAGE"})(L=e.TelemetryLevel||(e.TelemetryLevel={}));var l;(function(R){R.OFF="off",R.CRASH="crash",R.ERROR="error",R.ON="all"})(l=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(ye[74],De([1,0,23,10,3,54,73,211,212]),function(re,e,a,L,l,R,S,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanData=e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.isLoggingOnly=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.extensionTelemetryLogChannelId=e.telemetryLogChannelId=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=e.TelemetryTrustedValue=void 0;class I{constructor(c){this.value=c}}e.TelemetryTrustedValue=I;class O{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(c,m){return Promise.resolve(void 0)}publicLog2(c,m){return this.publicLog(c,m)}publicLogError(c,m){return Promise.resolve(void 0)}publicLogError2(c,m){return this.publicLogError(c,m)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=O,e.NullTelemetryService=new O;class P{async publicLog(c,m,n){}async publicLogError(c,m,n){}}e.NullEndpointTelemetryService=P,e.telemetryLogChannelId="telemetryLog",e.extensionTelemetryLogChannelId="extensionTelemetryLog",e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function v(o,c){return l.Event.debounce(c.onDidChangeConfiguration,(n,t)=>{const d=n?new Set([...n.affectedKeys,...t.affectedKeys]):t.affectedKeys;return{...t,affectedKeys:d}},1e3,!0)(n=>{n.source!==7&&o.publicLog2("updateConfiguration",{configurationSource:(0,R.ConfigurationTargetToString)(n.source),configurationKeys:Array.from(n.affectedKeys)})})}e.configurationTelemetry=v;function k(o,c){return!c.isBuilt&&!c.disableTelemetry?!0:!(c.disableTelemetry||!o.enableTelemetry||c.extensionTestsLocationURI)}e.supportsTelemetry=k;function D(o,c){return!(c.isBuilt||c.disableTelemetry||o.enableTelemetry&&o.aiConfig?.ariaKey)}e.isLoggingOnly=D;function f(o){const c=o.getValue(y.TELEMETRY_SETTING_ID),m=o.getValue(y.TELEMETRY_CRASH_REPORTER_SETTING_ID);if(o.getValue(y.TELEMETRY_OLD_SETTING_ID)===!1||m===!1)return 0;switch(c??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=f;function u(o){const c={},m={},n={};b(o,n);for(let t in n){t=t.length>150?t.substr(t.length-149):t;const d=n[t];typeof d=="number"?m[t]=d:typeof d=="boolean"?m[t]=d?1:0:typeof d=="string"?(d.length>8192&&console.warn(`Telemetry property: ${t} has been trimmed to 8192, the original length is ${d.length}`),c[t]=d.substring(0,8191)):typeof d<"u"&&d!==null&&(c[t]=d)}return{properties:c,measurements:m}}e.validateTelemetryData=u;const h=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function p(o){if(!o)return"none";const c=(0,S.getRemoteName)(o);return h.has(c)?c:"other"}e.cleanRemoteAuthority=p;function b(o,c,m=0,n){if(!!o)for(const t of Object.getOwnPropertyNames(o)){const d=o[t],E=n?n+t:t;Array.isArray(d)?c[E]=(0,a.safeStringify)(d):d instanceof Date?c[E]=d.toISOString():(0,L.isObject)(d)?m<2?b(d,c,m+1,E+"."):c[E]=(0,a.safeStringify)(d):c[E]=d}}function C(o,c){const m=o.msftInternalDomains||[],n=c.getValue("telemetry.internalTesting");return(0,A.verifyMicrosoftInternalDomain)(m)||n}e.isInternalTelemetry=C;function g(o){return[o.appRoot,o.extensionsPath,o.userHome.fsPath,o.tmpDir.fsPath,o.userDataPath]}e.getPiiPathsFromEnvironment=g;function i(o,c){if(!o||!o.includes("/")&&!o.includes("\\"))return o;let m=o;const n=[];for(const w of c)for(;;){const N=w.exec(o);if(!N)break;n.push([N.index,w.lastIndex])}const t=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,d=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let E=0;for(m="";;){const w=d.exec(o);if(!w)break;const N=n.some(([j,V])=>w.index<V&&j<d.lastIndex);!t.test(w[0])&&!N&&(m+=o.substring(E,w.index)+"<REDACTED: user-file-path>",E=d.lastIndex)}return E<o.length&&(m+=o.substr(E)),m}function s(o){if(!o)return o;const c=o.toLowerCase(),m=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const n of m)if(n.regex.test(c))return`<REDACTED: ${n.label}>`;return o}function r(o,c){return(0,a.cloneAndChange)(o,m=>{if(m instanceof I)return m.value;if(typeof m=="string"){let n=m.replaceAll("%20"," ");n=i(n,c);for(const t of c)n=n.replace(t,"");return n=s(n),n}})}e.cleanData=r}),define(ye[213],De([1,0,8,123,27,12,2,11,36,74]),function(re,e,a,L,l,R,S,A,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function O(r,o){return r.uuid&&o.uuid?r.uuid===o.uuid:r.id===o.id?!0:(0,a.compareIgnoreCase)(r.id,o.id)===0}e.areSameExtensions=O;const P=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class v{static create(o){const c=o.manifest?o.manifest.version:o.version,m=o.manifest?o.targetPlatform:o.properties.targetPlatform;return new v(o.identifier,c,m)}static parse(o){const c=P.exec(o);return c&&c[1]&&c[2]?new v({id:c[1]},c[2],c[4]||void 0):null}constructor(o,c,m="undefined"){this.version=c,this.targetPlatform=m,this.id=o.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(o){return o instanceof v?O(this,o)&&this.version===o.version&&this.targetPlatform===o.targetPlatform:!1}}e.ExtensionKey=v;const k=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function D(r){const o=k.exec(r);return o&&o[1]?[u(o[1]),o[2]]:[u(r),void 0]}e.getIdAndVersion=D;function f(r,o){return`${r}.${o}`}e.getExtensionId=f;function u(r){return r.toLocaleLowerCase()}e.adoptToGalleryExtensionId=u;function h(r,o){return u(f(r,o))}e.getGalleryExtensionId=h;function p(r,o){const c=[],m=n=>{for(const t of c)if(t.some(d=>O(o(d),o(n))))return t;return null};for(const n of r){const t=m(n);t?t.push(n):c.push([n])}return c}e.groupByExtension=p;function b(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=b;function C(r){return{id:new I.TelemetryTrustedValue(r.identifier.id),name:new I.TelemetryTrustedValue(r.name),galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),isSigned:r.isSigned,...r.telemetryData}}e.getGalleryExtensionTelemetryData=C,e.BetterMergeId=new l.ExtensionIdentifier("pprice.better-merge");function g(r,o){const c=[],m=o.manifest.extensionDependencies?.slice(0)??[];for(;m.length;){const n=m.shift();if(n&&c.every(t=>!O(t.identifier,{id:n}))){const t=r.filter(d=>O(d.identifier,{id:n}));t.length===1&&(c.push(t[0]),m.push(...t[0].manifest.extensionDependencies?.slice(0)??[]))}}return c}e.getExtensionDependencies=g;async function i(r,o){if(!R.isLinux)return!1;let c;try{c=(await r.readFile(S.URI.file("/etc/os-release"))).value.toString()}catch{try{c=(await r.readFile(S.URI.file("/usr/lib/os-release"))).value.toString()}catch(n){o.debug("Error while getting the os-release file.",(0,A.getErrorMessage)(n))}}return!!c&&(c.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function s(r,o){const c=await i(r,o),m=(0,L.getTargetPlatform)(c?"alpine":R.platform,y.arch);return o.debug("ComputeTargetPlatform:",m),m}e.computeTargetPlatform=s}),define(ye[214],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function a(S){return[...S.entries()]}e.serializeEnvironmentVariableCollection=a;function L(S){return new Map(S)}e.deserializeEnvironmentVariableCollection=L;function l(S){return Array.from(S.entries()).map(A=>[A[0],a(A[1].map)])}e.serializeEnvironmentVariableCollections=l;function R(S){return new Map(S.map(A=>[A[0],{map:L(A[1])}]))}e.deserializeEnvironmentVariableCollections=R}),define(ye[215],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class a{constructor(l){this.b=l,this.a=new Map}dispose(){for(const l of this.a.values())l.dispose()}startBuffering(l,R,S=5){const A=R(y=>{const I=typeof y=="string"?y:y.data;let O=this.a.get(l);if(O){O.data.push(I);return}const P=setTimeout(()=>this.flushBuffer(l),S);O={data:[I],timeoutId:P,dispose:()=>{clearTimeout(P),this.flushBuffer(l),A.dispose()}},this.a.set(l,O)});return A}stopBuffering(l){this.a.get(l)?.dispose()}flushBuffer(l){const R=this.a.get(l);R&&(this.a.delete(l),this.b(l,R.data.join("")))}}e.TerminalDataBufferer=a}),define(ye[216],De([1,0,17,69,51,3,10,2,174,92,39]),function(re,e,a,L,l,R,S,A,y,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.spinningLoading=e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.IconFontDefinition=e.IconContribution=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};var P;(function(C){function g(i,s){let r=i.defaults;for(;l.ThemeIcon.isThemeIcon(r);){const o=D.getIcon(r.id);if(!o)return;r=o.defaults}return r}C.getDefinition=g})(P=e.IconContribution||(e.IconContribution={}));var v;(function(C){function g(s){return{weight:s.weight,style:s.style,src:s.src.map(r=>({format:r.format,location:r.location.toString()}))}}C.toJSONObject=g;function i(s){const r=o=>(0,S.isString)(o)?o:void 0;if(s&&Array.isArray(s.src)&&s.src.every(o=>(0,S.isString)(o.format)&&(0,S.isString)(o.location)))return{weight:r(s.weight),style:r(s.style),src:s.src.map(o=>({format:o.format,location:A.URI.parse(o.location)}))}}C.fromJSONObject=i})(v=e.IconFontDefinition||(e.IconFontDefinition={}));class k{constructor(){this.a=new R.Emitter,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,y.localize)(0,null)},fontCharacter:{type:"string",description:(0,y.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${l.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(g,i,s,r){const o=this.b[g];if(o){if(s&&!o.description){o.description=s,this.d.properties[g].markdownDescription=`${s} $(${g})`;const n=this.e.enum.indexOf(g);n!==-1&&(this.e.enumDescriptions[n]=s),this.a.fire()}return o}const c={id:g,description:s,defaults:i,deprecationMessage:r};this.b[g]=c;const m={$ref:"#/definitions/icons"};return r&&(m.deprecationMessage=r),s&&(m.markdownDescription=`${s}: $(${g})`),this.d.properties[g]=m,this.e.enum.push(g),this.e.enumDescriptions.push(s||""),this.a.fire(),{id:g}}deregisterIcon(g){delete this.b[g],delete this.d.properties[g];const i=this.e.enum.indexOf(g);i!==-1&&(this.e.enum.splice(i,1),this.e.enumDescriptions.splice(i,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(g=>this.b[g])}getIcon(g){return this.b[g]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(g,i){const s=this.f[g];return s||(this.f[g]=i,this.a.fire(),i)}deregisterIconFont(g){delete this.f[g]}getIconFont(g){return this.f[g]}toString(){const g=(o,c)=>o.id.localeCompare(c.id),i=o=>{for(;l.ThemeIcon.isThemeIcon(o.defaults);)o=this.b[o.defaults.id];return`codicon codicon-${o?o.id:""}`},s=[];s.push("| preview     | identifier                        | default codicon ID                | description"),s.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const r=Object.keys(this.b).map(o=>this.b[o]);for(const o of r.filter(c=>!!c.description).sort(g))s.push(`|<i class="${i(o)}"></i>|${o.id}|${l.ThemeIcon.isThemeIcon(o.defaults)?o.defaults.id:o.id}|${o.description||""}|`);s.push("| preview     | identifier                        "),s.push("| ----------- | --------------------------------- |");for(const o of r.filter(c=>!l.ThemeIcon.isThemeIcon(c.defaults)).sort(g))s.push(`|<i class="${i(o)}"></i>|${o.id}|`);return s.join(`
`)}}const D=new k;O.Registry.add(e.Extensions.IconContribution,D);function f(C,g,i,s){return D.registerIcon(C,g,i,s)}e.registerIcon=f;function u(){return D}e.getIconRegistry=u;function h(){const C=(0,L.getCodiconFontCharacters)();for(const g in C){const i="\\"+C[g].toString(16);D.registerIcon(g,{fontCharacter:i})}}h(),e.iconsSchemaId="vscode://schemas/icons";const p=O.Registry.as(I.Extensions.JSONContribution);p.registerSchema(e.iconsSchemaId,D.getIconSchema());const b=new a.RunOnceScheduler(()=>p.notifySchemaChanged(e.iconsSchemaId),200);D.onDidChange(()=>{b.isScheduled()||b.schedule()}),e.widgetClose=f("widget-close",L.Codicon.close,(0,y.localize)(2,null)),e.gotoPreviousLocation=f("goto-previous-location",L.Codicon.arrowUp,(0,y.localize)(3,null)),e.gotoNextLocation=f("goto-next-location",L.Codicon.arrowDown,(0,y.localize)(4,null)),e.syncing=l.ThemeIcon.modify(L.Codicon.sync,"spin"),e.spinningLoading=l.ThemeIcon.modify(L.Codicon.loading,"spin")}),define(ye[129],De([1,0,3,54,4,13]),function(re,e,a,L,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,l.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,l.createDecorator)("sharedTunnelsService");var S;(function(f){f.Http="http",f.Https="https"})(S=e.TunnelProtocol||(e.TunnelProtocol={}));var A;(function(f){f.ConstantPrivate="constantPrivate",f.Private="private",f.Public="public"})(A=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var y;(function(f){f[f.Notify=1]="Notify",f[f.OpenBrowser=2]="OpenBrowser",f[f.OpenPreview=3]="OpenPreview",f[f.Silent=4]="Silent",f[f.Ignore=5]="Ignore",f[f.OpenBrowserOnce=6]="OpenBrowserOnce"})(y=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function I(f){if(f.scheme!=="http"&&f.scheme!=="https")return;const u=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(f.authority);if(!!u)return{address:u[1],port:+u[2]}}e.extractLocalHostUriMetaDataForPortMapping=I,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function O(f){return e.LOCALHOST_ADDRESSES.indexOf(f)>=0}e.isLocalhost=O,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function P(f){return e.ALL_INTERFACES_ADDRESSES.indexOf(f)>=0}e.isAllInterfaces=P;function v(f,u,h,p){if(h===1)return!1;if(h===2&&P(u)){const b=/(\d+)\.(\d+)\.(\d+)/g.exec(p);if(b?.length===4&&parseInt(b[1])>=18)return!1}return f<1024}e.isPortPrivileged=v;class k{constructor(u,h,p){this.remoteAddress=u,this.localAddress=h,this.b=p,this.a=new a.Emitter,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.DisposableTunnel=k;let D=class{constructor(u,h){this.i=u,this.j=h,this.a=new a.Emitter,this.onTunnelOpened=this.a.event,this.b=new a.Emitter,this.onTunnelClosed=this.b.event,this.c=new a.Emitter,this.onAddedTunnelProvider=this.c.event,this.d=new Map,this.f=!1,this.g=[],this.h=new Set}get hasTunnelProvider(){return!!this.e}get k(){const u=this.j.getValue("remote.localPortHost");return!u||u==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(u){return this.e=u,u?(this.c.fire(),{dispose:()=>{this.e=void 0,this.f=!1,this.g=[]}}):(this.f=!1,this.g=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(u){this.f=u.elevation,this.g=u.privacyOptions}get canElevate(){return this.f}get canChangePrivacy(){return this.g.length>0}get privacyOptions(){return this.g}get tunnels(){return this.l()}async l(){const u=[],h=Array.from(this.d.values());for(const p of h){const b=Array.from(p.values());for(const C of b){const g=await C.value;g&&u.push(g)}}return u}async dispose(){for(const u of this.d.values()){for(const{value:h}of u.values())await h.then(p=>p?.dispose());u.clear()}this.d.clear()}setEnvironmentTunnel(u,h,p,b,C){this.o(u,h,Promise.resolve({tunnelRemoteHost:u,tunnelRemotePort:h,localAddress:p,privacy:b,protocol:C,dispose:()=>Promise.resolve()}))}async getExistingTunnel(u,h){(P(u)||O(u))&&(u=e.LOCALHOST_ADDRESSES[0]);const p=this.q(u,h);if(p)return++p.refcount,p.value}openTunnel(u,h,p,b,C,g=!1,i,s){if(this.i.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${h}:${p} on local port ${C}.`),!u)return;if(h||(h="localhost"),b||(b=this.k),this.e&&this.h.has(p)){this.i.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const r=this.r(u,h,p,b,C,g,i,s);return r?r.then(o=>{if(!o){this.i.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.p(h,p);return}this.i.trace("ForwardedPorts: (TunnelService) New tunnel established.");const c=this.m(o);return(o.tunnelRemoteHost!==h||o.tunnelRemotePort!==p)&&this.i.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this.a.fire(c),c}):(this.i.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}m(u){return{tunnelRemotePort:u.tunnelRemotePort,tunnelRemoteHost:u.tunnelRemoteHost,tunnelLocalPort:u.tunnelLocalPort,localAddress:u.localAddress,privacy:u.privacy,protocol:u.protocol,dispose:async()=>{this.i.trace(`ForwardedPorts: (TunnelService) dispose request for ${u.tunnelRemoteHost}:${u.tunnelRemotePort} `);const h=this.d.get(u.tunnelRemoteHost);if(h){const p=h.get(u.tunnelRemotePort);p&&(p.refcount--,await this.n(u.tunnelRemoteHost,u.tunnelRemotePort,p))}}}}async n(u,h,p){if(p.refcount<=0){this.i.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${u}:${h}.`);const b=p.value.then(async C=>{C&&(await C.dispose(!0),this.b.fire({host:C.tunnelRemoteHost,port:C.tunnelRemotePort}))});return this.d.has(u)&&this.d.get(u).delete(h),b}}async closeTunnel(u,h){this.i.trace(`ForwardedPorts: (TunnelService) close request for ${u}:${h} `);const p=this.d.get(u);if(p&&p.has(h)){const b=p.get(h);b.refcount=0,await this.n(u,h,b)}}o(u,h,p){this.d.has(u)||this.d.set(u,new Map),this.d.get(u).set(h,{refcount:1,value:p})}async p(u,h){const p=this.d.get(u);p&&(await p.get(h)||p.delete(h),p.size===0&&this.d.delete(u))}q(u,h){const p=[u];O(u)?(p.push(...e.LOCALHOST_ADDRESSES),p.push(...e.ALL_INTERFACES_ADDRESSES)):P(u)&&p.push(...e.ALL_INTERFACES_ADDRESSES);const b=p.map(C=>this.d.get(C));for(const C of b){const g=C?.get(h);if(g)return g}}canTunnel(u){return!!I(u)}s(u,h,p,b,C,g,i){this.i.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${h}:${p} on local port ${b}.`);const s=p;this.h.add(s);const r=b===void 0?p:b,o={elevationRequired:C?this.isPortPrivileged(r):!1},c={remoteAddress:{host:h,port:p},localAddressPort:b,privacy:g,public:g?g!==A.Private:void 0,protocol:i},m=u.forwardPort(c,o);return m?(this.o(h,p,m),m.finally(()=>{this.i.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.h.delete(s)})):this.h.delete(s),m}};D=qe([ze(0,R.ILogService),ze(1,L.IConfigurationService)],D),e.AbstractTunnelService=D}),define(ye[217],De([1,0,4]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.IEditSessionIdentityService=void 0,e.IEditSessionIdentityService=(0,a.createDecorator)("editSessionIdentityService");var L;(function(l){l[l.Complete=100]="Complete",l[l.Partial=50]="Partial",l[l.None=0]="None"})(L=e.EditSessionIdentityMatch||(e.EditSessionIdentityMatch={}))}),define(ye[218],De([1,0,16]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function L(y){return y.scheme!==a.Schemas.file&&y.scheme!==a.Schemas.vscodeRemote}e.isVirtualResource=L;function l(y){if(y.folders.length)return y.folders.every(I=>L(I.uri))?y.folders[0].uri:void 0;if(y.configuration&&L(y.configuration))return y.configuration}e.getVirtualWorkspaceLocation=l;function R(y){return l(y)?.scheme}e.getVirtualWorkspaceScheme=R;function S(y){return l(y)?.authority}e.getVirtualWorkspaceAuthority=S;function A(y){return l(y)!==void 0}e.isVirtualWorkspace=A}),define(ye[47],De([1,0,175,9,68,24,2,4,16]),function(re,e,a,L,l,R,S,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_SUFFIX=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.UNKNOWN_EMPTY_WINDOW_WORKSPACE=e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE=e.isEmptyWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,A.createDecorator)("contextService");function I(r){const o=r;return typeof o?.id=="string"&&S.URI.isUri(o.uri)}e.isSingleFolderWorkspaceIdentifier=I;function O(r){return typeof r?.id=="string"&&!I(r)&&!v(r)}e.isEmptyWorkspaceIdentifier=O,e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE={id:"ext-dev"},e.UNKNOWN_EMPTY_WINDOW_WORKSPACE={id:"empty-window"};function P(r,o){if(typeof r=="string"||typeof r>"u")return typeof r=="string"?{id:(0,L.basename)(r)}:o?e.EXTENSION_DEVELOPMENT_EMPTY_WINDOW_WORKSPACE:e.UNKNOWN_EMPTY_WINDOW_WORKSPACE;const c=r;return c.configuration?{id:c.id,configPath:c.configuration}:c.folders.length===1?{id:c.id,uri:c.folders[0].uri}:{id:c.id}}e.toWorkspaceIdentifier=P;function v(r){const o=r;return typeof o?.id=="string"&&S.URI.isUri(o.configPath)}e.isWorkspaceIdentifier=v;function k(r){const o=r;if(o?.uri)return{id:o.id,uri:S.URI.revive(o.uri)};const c=r;if(c?.configPath)return{id:c.id,configPath:S.URI.revive(c.configPath)};if(r?.id)return{id:r.id}}e.reviveIdentifier=k;var D;(function(r){r[r.EMPTY=1]="EMPTY",r[r.FOLDER=2]="FOLDER",r[r.WORKSPACE=3]="WORKSPACE"})(D=e.WorkbenchState||(e.WorkbenchState={}));function f(r){const o=r;return!!(o&&typeof o=="object"&&typeof o.id=="string"&&Array.isArray(o.folders))}e.isWorkspace=f;function u(r){const o=r;return!!(o&&typeof o=="object"&&S.URI.isUri(o.uri)&&typeof o.name=="string"&&typeof o.toResource=="function")}e.isWorkspaceFolder=u;class h{constructor(o,c,m,n,t){this.h=o,this.j=m,this.k=n,this.l=t,this.c=l.TernarySearchTree.forUris(this.l,()=>!0),this.folders=c}update(o){this.h=o.id,this.k=o.configuration,this.j=o.transient,this.l=o.l,this.folders=o.folders}get folders(){return this.g}set folders(o){this.g=o,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(o){this.k=o}getFolder(o){return o&&this.c.findSubstr(o)||null}n(){this.c=l.TernarySearchTree.forUris(this.l,()=>!0);for(const o of this.folders)this.c.set(o.uri,o)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=h;class p{constructor(o,c){this.raw=c,this.uri=o.uri,this.index=o.index,this.name=o.name}toResource(o){return(0,R.joinPath)(this.uri,o)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=p;function b(r){return new p({uri:r,index:0,name:(0,R.basenameOrAuthority)(r)},{uri:r.toString()})}e.toWorkspaceFolder=b,e.WORKSPACE_EXTENSION="code-workspace",e.WORKSPACE_SUFFIX=`.${e.WORKSPACE_EXTENSION}`,e.WORKSPACE_FILTER=[{name:(0,a.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function C(r,o){return R.extUriBiasedIgnorePathCase.isEqualOrParent(r,o.untitledWorkspacesHome)}e.isUntitledWorkspace=C;function g(r){let o;return S.URI.isUri(r)?o=r:o=r.configuration,o?.scheme===y.Schemas.tmp}e.isTemporaryWorkspace=g;function i(r,o){return!C(r,o)&&!g(r)}e.isSavedWorkspace=i;function s(r){return(typeof r=="string"?(0,L.extname)(r):(0,R.extname)(r))===e.WORKSPACE_SUFFIX}e.hasWorkspaceFileExtension=s}),define(ye[75],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class a{constructor(l){this.d=l,this.b=new Map,this.c=1}add(l){const R=this.c++;return this.b.set(R,l),this.e(),R}get(l,R){return this.b.has(l)?this.b.get(l)[R]:void 0}delete(l){this.b.delete(l),this.e()}e(){!a.a||console.log(`${this.d} cache size - ${this.b.size}`)}}a.a=!1,e.Cache=a}),define(ye[48],De([1,0,16,24,4]),function(re,e,a,L,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class R{constructor(){this.a=new Set(Object.keys(a.Schemas)),this.b=new Map,this.extUri=new L.ExtUri(A=>{const y=this.b.get(A.scheme);return!(y===void 0||y&1024)})}$acceptProviderInfos(A,y){y===null?this.b.delete(A.scheme):this.b.set(A.scheme,y)}isFreeScheme(A){return!this.b.has(A)&&!this.a.has(A)}getCapabilities(A){return this.b.get(A)}}e.ExtHostFileSystemInfo=R,e.IExtHostFileSystemInfo=(0,l.createDecorator)("IExtHostFileSystemInfo")}),define(ye[25],De([1,0,4]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,a.createDecorator)("IExtHostInitDataService")}),define(ye[219],De([1,0,13,204,25]),function(re,e,a,L,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let R=class extends L.LogService{constructor(A,y){super(A.createLogger(y.logFile,{name:y.logName}))}};R=qe([ze(0,a.ILoggerService),ze(1,l.IExtHostInitDataService)],R),e.ExtHostLogService=R}),define(ye[220],De([1,0,17]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class L{constructor(S,A,y){this.h=new Map,this.a=S,this.b=A,this.c=y,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(I=>(this.f=I,this)),this.g=this.c.onDidChangeStorage(I=>{I.shared===this.b&&I.key===this.a&&(this.f=I.value)}),this.i=new a.RunOnceScheduler(()=>{const I=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const O of I.values())O.complete()}catch(O){for(const P of I.values())P.error(O)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,S])=>S!==void 0).map(([S])=>S)}get whenReady(){return this.d}get(S,A){let y=this.f[S];return typeof y>"u"&&(y=A),y}update(S,A){this.f[S]=A;const y=this.h.get(S);if(y!==void 0)return y.p;const I=new a.DeferredPromise;return this.h.set(S,I),this.i.isScheduled()||this.i.schedule(),I.p}dispose(){this.g.dispose()}}e.ExtensionMemento=L;class l extends L{setKeysForSync(S){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},S)}constructor(S,A){super(S.identifier.value,!0,A),this.j=S}}e.ExtensionGlobalMemento=l}),define(ye[221],De([1,0,3,2]),function(re,e,a,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class l{constructor(S){this.c=S,this.a=new a.Emitter,this.onDidSaveNotebookDocument=this.a.event,this.b=new a.Emitter,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(S,A,y,I){const P=this.c.getNotebookDocument(L.URI.revive(S)).acceptModelChanged(A.value,y,I);this.b.fire(P)}$acceptDirtyStateChanged(S,A){this.c.getNotebookDocument(L.URI.revive(S)).acceptDirty(A)}$acceptModelSaved(S){const A=this.c.getNotebookDocument(L.URI.revive(S));this.a.fire(A.apiNotebook)}}e.ExtHostNotebookDocuments=l}),define(ye[18],De([1,0,4]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,a.createDecorator)("IExtHostRpcService");class L{constructor(R){this.getProxy=R.getProxy.bind(R),this.set=R.set.bind(R),this.dispose=R.dispose.bind(R),this.assertRegistered=R.assertRegistered.bind(R),this.drain=R.drain.bind(R)}}e.ExtHostRpcService=L});var _e=this&&this.__classPrivateFieldSet||function(re,e,a,L,l){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!l:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?l.call(re,a):l?l.value=a:e.set(re,a),a},Ue=this&&this.__classPrivateFieldGet||function(re,e,a,L){if(a==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!L:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?L:a==="a"?L.call(re):L?L.value:e.get(re)};define(ye[222],De([1,0,27,3]),function(re,e,a,L){"use strict";var l;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class R{constructor(A,y){l.set(this,void 0),this.b=new L.Emitter,this.onDidChange=this.b.event,this.a=a.ExtensionIdentifier.toKey(A.identifier),_e(this,l,y,"f"),Ue(this,l,"f").onDidChangePassword(I=>{I.extensionId===this.a&&this.b.fire({key:I.key})})}get(A){return Ue(this,l,"f").get(this.a,A)}store(A,y){return Ue(this,l,"f").store(this.a,A,y)}delete(A){return Ue(this,l,"f").delete(this.a,A)}}e.ExtensionSecrets=R,l=new WeakMap}),define(ye[56],De([1,0,4,129,3,18]),function(re,e,a,L,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var S;(function(y){function I(P){return{remoteAddress:P.remoteAddress,localAddress:P.localAddress,public:!!P.public,privacy:P.privacy??(P.public?L.TunnelPrivacyId.Public:L.TunnelPrivacyId.Private),protocol:P.protocol}}y.fromApiTunnel=I;function O(P){return{remoteAddress:{host:P.tunnelRemoteHost,port:P.tunnelRemotePort},localAddress:P.localAddress,public:P.privacy!==L.TunnelPrivacyId.ConstantPrivate&&P.privacy!==L.TunnelPrivacyId.ConstantPrivate,privacy:P.privacy,protocol:P.protocol}}y.fromServiceTunnel=O})(S=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,a.createDecorator)("IExtHostTunnelService");let A=class{constructor(I){this.onDidChangeTunnels=new l.Emitter().event}async $applyCandidateFilter(I){return I}async openTunnel(I,O){}async getTunnels(){return[]}async setTunnelFactory(I){return{dispose:()=>{}}}registerPortsAttributesProvider(I,O){return{dispose:()=>{}}}async $providePortAttributes(I,O,P,v,k){return[]}async $forwardPort(I,O){}async $closeTunnel(I){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};A=qe([ze(0,R.IExtHostRpcService)],A),e.ExtHostTunnelService=A}),define(ye[57],De([1,0,4]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,a.createDecorator)("IURITransformerService");class L{constructor(R){R?(this.transformIncoming=R.transformIncoming.bind(R),this.transformOutgoing=R.transformOutgoing.bind(R),this.transformOutgoingURI=R.transformOutgoingURI.bind(R),this.transformOutgoingScheme=R.transformOutgoingScheme.bind(R)):(this.transformIncoming=S=>S,this.transformOutgoing=S=>S,this.transformOutgoingURI=S=>S,this.transformOutgoingScheme=S=>S)}}e.URITransformerService=L}),define(ye[223],De([1,0,22]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class L{constructor(){this.buffers=[]}add(y){let I=this.buffers.indexOf(y);return I<0&&(I=this.buffers.length,this.buffers.push(y)),I}}function l(A,y){if(y.serializeBuffersForPostMessage){const I=new L,O=(k,D)=>{if(D instanceof ArrayBuffer){const f=I.add(D);return{$$vscode_array_buffer_reference$$:!0,index:f}}else if(ArrayBuffer.isView(D)){const f=R(D);if(f){const u=I.add(D.buffer);return{$$vscode_array_buffer_reference$$:!0,index:u,view:{type:f,byteLength:D.byteLength,byteOffset:D.byteOffset}}}}return D},P=JSON.stringify(A,O),v=I.buffers.map(k=>{const D=new Uint8Array(k);return a.VSBuffer.wrap(D)});return{message:P,buffers:v}}else return{message:JSON.stringify(A),buffers:[]}}e.serializeWebviewMessage=l;function R(A){switch(A.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function S(A,y){const I=y.map(v=>{const k=new ArrayBuffer(v.byteLength);return new Uint8Array(k).set(v.buffer),k}),O=y.length?(v,k)=>{if(k&&typeof k=="object"&&k.$$vscode_array_buffer_reference$$){const D=k,{index:f}=D,u=I[f];if(D.view)switch(D.view.type){case 1:return new Int8Array(u,D.view.byteOffset,D.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(u,D.view.byteOffset,D.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(u,D.view.byteOffset,D.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(u,D.view.byteOffset,D.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(u,D.view.byteOffset,D.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(u,D.view.byteOffset,D.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(u,D.view.byteOffset,D.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(u,D.view.byteOffset,D.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(u,D.view.byteOffset,D.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(u,D.view.byteOffset,D.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(u,D.view.byteOffset,D.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return u}return k}:void 0;return{message:JSON.parse(A,O),arrayBuffers:I}}e.deserializeWebviewMessage=S}),define(ye[224],De([1,0,111]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createURITransformer=void 0;function L(R){return{transformIncoming:S=>S.scheme==="vscode-remote"?{scheme:"file",path:S.path,query:S.query,fragment:S.fragment}:S.scheme==="file"?{scheme:"vscode-local",path:S.path,query:S.query,fragment:S.fragment}:S,transformOutgoing:S=>S.scheme==="file"?{scheme:"vscode-remote",authority:R,path:S.path,query:S.query,fragment:S.fragment}:S.scheme==="vscode-local"?{scheme:"file",path:S.path,query:S.query,fragment:S.fragment}:S,transformOutgoingScheme:S=>S==="file"?"vscode-remote":S==="vscode-local"?"file":S}}function l(R){return new a.URITransformer(L(R))}e.createURITransformer=l}),define(ye[130],De([1,0,186,10,2,6,4,39,44,16,45,163,37]),function(re,e,a,L,l,R,S,A,y,I,O,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createEditorOpenError=e.isEditorOpenError=e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.createTooLargeFileError=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledWithAssociatedResource=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,a.localize)(0,null),providerDisplayName:(0,a.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var k;(function(X){X[X.PROGRAMMATIC=1]="PROGRAMMATIC",X[X.USER=2]="USER",X[X.EDIT=3]="EDIT",X[X.NAVIGATION=4]="NAVIGATION",X[X.JUMP=5]="JUMP"})(k=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var D;(function(X){X[X.IDENTICAL=1]="IDENTICAL",X[X.SIMILAR=2]="SIMILAR",X[X.DIFFERENT=3]="DIFFERENT"})(D=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function f(X){const J=X;return!!J&&typeof J.getSelection=="function"&&!!J.onDidChangeSelection}e.isEditorPaneWithSelection=f;function u(X,J,ee){for(const me of ee.visibleEditorPanes)if(me.group.id===J&&X.matches(me.input))return me.getViewState()}e.findViewStateForEditor=u;function h(X){if(t(X))return!1;const J=X;return l.URI.isUri(J?.resource)}e.isResourceEditorInput=h;function p(X){if(t(X))return!1;const J=X;return J?.original!==void 0&&J.modified!==void 0}e.isResourceDiffEditorInput=p;function b(X){if(t(X)||p(X))return!1;const J=X;return J?.primary!==void 0&&J.secondary!==void 0}e.isResourceSideBySideEditorInput=b;function C(X){if(t(X))return!1;const J=X;return J?J.resource===void 0||J.resource.scheme===I.Schemas.untitled||J.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=C;const g=/Untitled-\d+/;function i(X){return X.scheme===I.Schemas.untitled&&X.path.length>1&&!g.test(X.path)}e.isUntitledWithAssociatedResource=i;function s(X){if(t(X))return!1;const J=X;return l.URI.isUri(J?.base?.resource)&&l.URI.isUri(J?.input1?.resource)&&l.URI.isUri(J?.input2?.resource)&&l.URI.isUri(J?.result?.resource)}e.isResourceMergeEditorInput=s;var r;(function(X){X[X.SHORT=0]="SHORT",X[X.MEDIUM=1]="MEDIUM",X[X.LONG=2]="LONG"})(r=e.Verbosity||(e.Verbosity={}));var o;(function(X){X[X.EXPLICIT=1]="EXPLICIT",X[X.AUTO=2]="AUTO",X[X.FOCUS_CHANGE=3]="FOCUS_CHANGE",X[X.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(o=e.SaveReason||(e.SaveReason={}));class c{constructor(){this.a=new Map}registerSource(J,ee){let me=this.a.get(J);return me||(me={source:J,label:ee},this.a.set(J,me)),me.source}getSourceLabel(J){return this.a.get(J)?.label??J}}e.SaveSourceRegistry=new c;var m;(function(X){X[X.None=0]="None",X[X.Readonly=2]="Readonly",X[X.Untitled=4]="Untitled",X[X.Singleton=8]="Singleton",X[X.RequiresTrust=16]="RequiresTrust",X[X.CanSplitInGroup=32]="CanSplitInGroup",X[X.ForceDescription=64]="ForceDescription",X[X.CanDropIntoEditor=128]="CanDropIntoEditor",X[X.MultipleEditors=256]="MultipleEditors"})(m=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class n extends R.Disposable{}e.AbstractEditorInput=n;function t(X){return X instanceof n}e.isEditorInput=t;function d(X){const J=X;return l.URI.isUri(J?.preferredResource)}function E(X){const J=X;return t(J?.primary)&&t(J?.secondary)}e.isSideBySideEditorInput=E;function w(X){const J=X;return t(J?.modified)&&t(J?.original)}e.isDiffEditorInput=w;function N(X,J,ee,me,ve){return ge(me,[(0,P.toAction)({id:"workbench.action.openLargeFile",label:(0,a.localize)(2,null),run:()=>{const Ie={...ee,limits:{size:Number.MAX_VALUE}};X.openEditor(J,Ie)}}),(0,P.toAction)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,a.localize)(3,null),run:()=>ve.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:v.default.Warning})}e.createTooLargeFileError=N;function j(X){return t(X?.editor)}e.isEditorInputWithOptions=j;function V(X){const J=X;return j(X)&&J?.group!==void 0}e.isEditorInputWithOptionsAndGroup=V;function Q(X){const J=X;return typeof J?.groupId=="number"&&t(J.editor)}e.isEditorIdentifier=Q;var x;(function(X){X[X.UNKNOWN=0]="UNKNOWN",X[X.REPLACE=1]="REPLACE",X[X.MOVE=2]="MOVE",X[X.UNPIN=3]="UNPIN"})(x=e.EditorCloseContext||(e.EditorCloseContext={}));var U;(function(X){X[X.GROUP_ACTIVE=0]="GROUP_ACTIVE",X[X.GROUP_INDEX=1]="GROUP_INDEX",X[X.GROUP_LOCKED=2]="GROUP_LOCKED",X[X.EDITOR_OPEN=3]="EDITOR_OPEN",X[X.EDITOR_CLOSE=4]="EDITOR_CLOSE",X[X.EDITOR_MOVE=5]="EDITOR_MOVE",X[X.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",X[X.EDITOR_LABEL=7]="EDITOR_LABEL",X[X.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",X[X.EDITOR_PIN=9]="EDITOR_PIN",X[X.EDITOR_STICKY=10]="EDITOR_STICKY",X[X.EDITOR_DIRTY=11]="EDITOR_DIRTY",X[X.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(U=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var T;(function(X){X[X.PRIMARY=1]="PRIMARY",X[X.SECONDARY=2]="SECONDARY",X[X.BOTH=3]="BOTH",X[X.ANY=4]="ANY"})(T=e.SideBySideEditor||(e.SideBySideEditor={}));class F{getOriginalUri(J,ee){if(!J)return;if(s(J))return e.EditorResourceAccessor.getOriginalUri(J.result,ee);if(ee?.supportSideBySide){const{primary:ve,secondary:Ie}=this.a(J);if(ve&&Ie){if(ee?.supportSideBySide===T.BOTH)return{primary:this.getOriginalUri(ve,{filterByScheme:ee.filterByScheme}),secondary:this.getOriginalUri(Ie,{filterByScheme:ee.filterByScheme})};if(ee?.supportSideBySide===T.ANY)return this.getOriginalUri(ve,{filterByScheme:ee.filterByScheme})??this.getOriginalUri(Ie,{filterByScheme:ee.filterByScheme});J=ee.supportSideBySide===T.PRIMARY?ve:Ie}}if(p(J)||b(J)||s(J))return;const me=d(J)?J.preferredResource:J.resource;return!me||!ee||!ee.filterByScheme?me:this.b(me,ee.filterByScheme)}a(J){return E(J)||b(J)?{primary:J.primary,secondary:J.secondary}:w(J)||p(J)?{primary:J.modified,secondary:J.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(J,ee){if(!J)return;if(s(J))return e.EditorResourceAccessor.getCanonicalUri(J.result,ee);if(ee?.supportSideBySide){const{primary:ve,secondary:Ie}=this.a(J);if(ve&&Ie){if(ee?.supportSideBySide===T.BOTH)return{primary:this.getCanonicalUri(ve,{filterByScheme:ee.filterByScheme}),secondary:this.getCanonicalUri(Ie,{filterByScheme:ee.filterByScheme})};if(ee?.supportSideBySide===T.ANY)return this.getCanonicalUri(ve,{filterByScheme:ee.filterByScheme})??this.getCanonicalUri(Ie,{filterByScheme:ee.filterByScheme});J=ee.supportSideBySide===T.PRIMARY?ve:Ie}}if(p(J)||b(J)||s(J))return;const me=J.resource;return!me||!ee||!ee.filterByScheme?me:this.b(me,ee.filterByScheme)}b(J,ee){if(Array.isArray(ee)){if(ee.some(me=>J.scheme===me))return J}else if(ee===J.scheme)return J}}e.EditorResourceAccessor=new F;var B;(function(X){X[X.LEFT=0]="LEFT",X[X.RIGHT=1]="RIGHT"})(B=e.CloseDirection||(e.CloseDirection={}));class Z{constructor(){this.c=new Map,this.d=new Map}start(J){const ee=this.a=J.get(S.IInstantiationService);for(const[me,ve]of this.c)this.e(me,ve,ee);this.c.clear()}e(J,ee,me){const ve=me.createInstance(ee);this.d.set(J,ve)}registerFileEditorFactory(J){if(this.b)throw new Error("Can only register one file editor factory.");this.b=J}getFileEditorFactory(){return(0,L.assertIsDefined)(this.b)}registerEditorSerializer(J,ee){if(this.c.has(J)||this.d.has(J))throw new Error(`A editor serializer with type ID '${J}' was already registered.`);return this.a?this.e(J,ee,this.a):this.c.set(J,ee),(0,R.toDisposable)(()=>{this.c.delete(J),this.d.delete(J)})}getEditorSerializer(J){return this.d.get(typeof J=="string"?J:J.typeId)}}A.Registry.add(e.EditorExtensions.EditorFactory,new Z);async function _(X,J,ee){return!X||!X.length?[]:await Promise.all(X.map(async me=>{const ve=l.URI.revive(me.fileUri);if(!ve){ee.info("Cannot resolve the path because it is not valid.",me);return}if(!await J.canHandleResource(ve)){ee.info("Cannot resolve the path because it cannot be handled",me);return}let Re=me.exists,ae=me.type;if(typeof Re!="boolean"||typeof ae!="number")try{ae=(await J.stat(ve)).isDirectory?y.FileType.Directory:y.FileType.Unknown,Re=!0}catch(ue){ee.error(ue),Re=!1}if(!Re&&me.openOnlyIfExists){ee.info("Cannot resolve the path because it does not exist",me);return}if(ae===y.FileType.Directory){ee.info("Cannot resolve the path because it is a directory",me);return}const le={...me.options,pinned:!0};return Re?{resource:ve,options:le}:{resource:ve,options:le,forceUntitled:!0}}))}e.pathsToEditors=_;var H;(function(X){X[X.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",X[X.SEQUENTIAL=1]="SEQUENTIAL"})(H=e.EditorsOrder||(e.EditorsOrder={}));function Y(X){const J=X;if(!J)return!1;const ee=J;if(ee.modified)return Y(ee.modified);const me=J;return!!(me.contributionsState&&me.viewState&&Array.isArray(me.cursorState))}e.isTextEditorViewState=Y;function ie(X){return(0,O.isErrorWithActions)(X)}e.isEditorOpenError=ie;function ge(X,J,ee){const me=(0,O.createErrorWithActions)(X,J);return me.forceMessage=ee?.forceMessage,me.forceSeverity=ee?.forceSeverity,me.allowDialog=ee?.allowDialog,me}e.createEditorOpenError=ge}),define(ye[225],De([1,0,3,187,4,6,28,39,15,62,23,69,216]),function(re,e,a,L,l,R,S,A,y,I,O,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoTreeViewError=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.IViewsService=e.ViewContentGroups=e.ViewContainerLocationToString=e.ViewContainerLocations=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,v.registerIcon)("default-view-icon",P.Codicon.window,(0,L.localize)(0,null));var k;(function(r){r.ViewContainersRegistry="workbench.registry.view.containers",r.ViewsRegistry="workbench.registry.view"})(k=e.Extensions||(e.Extensions={}));var D;(function(r){r[r.Sidebar=0]="Sidebar",r[r.Panel=1]="Panel",r[r.AuxiliaryBar=2]="AuxiliaryBar"})(D=e.ViewContainerLocation||(e.ViewContainerLocation={})),e.ViewContainerLocations=[0,1,2];function f(r){switch(r){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}e.ViewContainerLocationToString=f;class u extends R.Disposable{constructor(){super(...arguments),this.c=this.B(new a.Emitter),this.onDidRegister=this.c.event,this.f=this.B(new a.Emitter),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return(0,y.flatten)([...this.g.values()])}registerViewContainer(o,c,m){const n=this.get(o.id);if(n)return n;const t=o;return t.openCommandActionDescriptor=m?.doNotRegisterOpenCommand?void 0:t.openCommandActionDescriptor??{id:t.id},(0,S.getOrSet)(this.g,c,[]).push(t),m?.isDefault&&this.h.push(t),this.c.fire({viewContainer:t,viewContainerLocation:c}),t}deregisterViewContainer(o){for(const c of this.g.keys()){const m=this.g.get(c),n=m?.indexOf(o);if(n!==-1){m?.splice(n,1),m.length===0&&this.g.delete(c),this.f.fire({viewContainer:o,viewContainerLocation:c});return}}}get(o){return this.all.filter(c=>c.id===o)[0]}getViewContainers(o){return[...this.g.get(o)||[]]}getViewContainerLocation(o){return[...this.g.keys()].filter(c=>this.getViewContainers(c).filter(m=>m?.id===o.id).length>0)[0]}getDefaultViewContainer(o){return this.h.find(c=>this.getViewContainerLocation(c)===o)}}A.Registry.add(k.ViewContainersRegistry,new u);var h;(function(r){r.Open="2_open",r.Debug="4_debug",r.SCM="5_scm",r.More="9_more"})(h=e.ViewContentGroups||(e.ViewContentGroups={}));function p(r,o){const c=r.group??h.More,m=o.group??h.More;return c!==m?c.localeCompare(m):(r.order??5)-(o.order??5)}class b extends R.Disposable{constructor(){super(...arguments),this.c=this.B(new a.Emitter),this.onViewsRegistered=this.c.event,this.f=this.B(new a.Emitter),this.onViewsDeregistered=this.f.event,this.g=this.B(new a.Emitter),this.onDidChangeContainer=this.g.event,this.h=this.B(new a.Emitter),this.onDidChangeViewWelcomeContent=this.h.event,this.i=[],this.j=new Map,this.k=new I.SetMap}registerViews(o,c){this.registerViews2([{views:o,viewContainer:c}])}registerViews2(o){o.forEach(({views:c,viewContainer:m})=>this.l(c,m)),this.c.fire(o)}deregisterViews(o,c){const m=this.m(o,c);m.length&&this.f.fire({views:m,viewContainer:c})}moveViews(o,c){for(const m of this.j.keys())if(m!==c){const n=this.m(o,m);n.length&&(this.l(n,c),this.g.fire({views:n,from:m,to:c}))}}getViews(o){return this.j.get(o)||[]}getView(o){for(const c of this.i){const m=(this.j.get(c)||[]).filter(n=>n.id===o)[0];if(m)return m}return null}getViewContainer(o){for(const c of this.i)if((this.j.get(c)||[]).filter(n=>n.id===o)[0])return c;return null}registerViewWelcomeContent(o,c){return this.k.add(o,c),this.h.fire(o),(0,R.toDisposable)(()=>{this.k.delete(o,c),this.h.fire(o)})}registerViewWelcomeContent2(o,c){const m=new Map;for(const[n,t]of c)this.k.add(o,t),m.set(n,(0,R.toDisposable)(()=>{this.k.delete(o,t),this.h.fire(o)}));return this.h.fire(o),m}getViewWelcomeContent(o){const c=[];return this.k.forEach(o,m=>c.push(m)),c.sort(p)}l(o,c){let m=this.j.get(c);m||(m=[],this.j.set(c,m),this.i.push(c));for(const n of o){if(this.getView(n.id)!==null)throw new Error((0,L.localize)(1,null,n.id));m.push(n)}}m(o,c){const m=this.j.get(c);if(!m)return[];const n=[],t=[];for(const d of m)o.includes(d)?n.push(d):t.push(d);return n.length&&(t.length?this.j.set(c,t):(this.j.delete(c),this.i.splice(this.i.indexOf(c),1))),n}}A.Registry.add(k.ViewsRegistry,new b),e.IViewsService=(0,l.createDecorator)("viewsService"),e.IViewDescriptorService=(0,l.createDecorator)("viewDescriptorService");var C;(function(r){r[r.Default=0]="Default",r[r.Expand=1]="Expand"})(C=e.ViewVisibilityState||(e.ViewVisibilityState={}));var g;(function(r){r[r.None=0]="None",r[r.Collapsed=1]="Collapsed",r[r.Expanded=2]="Expanded"})(g=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class i{constructor(o,c){this.c=!1,this.d=!1,(0,O.mixin)(this,o),this.d=!!c,this.resolve=async m=>{if(c&&!this.c){const n=await c(m);n&&(this.tooltip=this.tooltip??n.tooltip,this.command=this.command??n.command)}m.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=i;class s extends Error{constructor(o){super((0,L.localize)(2,null,o))}}e.NoTreeViewError=s}),define(ye[131],De([1,0,3,17,188]),function(re,e,a,L,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class R{constructor(){this.f=new Map,this.k=[],this.m=new a.Emitter,this.n=new a.Emitter,this.d=1}get onError(){return this.m.event}get onExit(){return this.n.event}onMessage(A){this.j&&this.m.fire(new Error("attempt to set more than one 'Message' callback")),this.j=A}onEvent(A){this.i&&this.m.fire(new Error("attempt to set more than one 'Event' callback")),this.i=A}onRequest(A){this.g&&this.m.fire(new Error("attempt to set more than one 'Request' callback")),this.g=A}sendResponse(A){A.seq>0?this.m.fire(new Error(`attempt to send more than one response for command ${A.command}`)):this.s("response",A)}sendRequest(A,y,I,O){const P={command:A};if(y&&Object.keys(y).length>0&&(P.arguments=y),this.s("request",P),typeof O=="number"){const v=setTimeout(()=>{clearTimeout(v);const k=this.f.get(P.seq);if(k){this.f.delete(P.seq);const D={type:"response",seq:0,request_seq:P.seq,success:!1,command:A,message:(0,l.localize)(0,null,O,A)};k(D)}},O)}return I&&this.f.set(P.seq,I),P.seq}acceptMessage(A){this.j?this.j(A):(this.k.push(A),this.k.length===1&&this.q())}o(A,y){return A.type!=="event"||y.type!=="event"}async q(){let A;for(;this.k.length;){if((!A||this.o(this.k[0],A))&&await(0,L.timeout)(0),A=this.k.shift(),!A)return;switch(A.type){case"event":this.i?.(A);break;case"request":this.g?.(A);break;case"response":{const y=A,I=this.f.get(y.request_seq);I&&(this.f.delete(y.request_seq),I(y));break}}}}s(A,y){y.type=A,y.seq=this.d++,this.sendMessage(y)}async u(){if(this.f.size===0)return Promise.resolve();const A=new Map;this.f.forEach((y,I)=>A.set(I,y)),await(0,L.timeout)(500),A.forEach((y,I)=>{y({type:"response",seq:0,request_seq:I,success:!1,command:"canceled",message:"canceled"}),this.f.delete(I)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.k=[]}}e.AbstractDebugAdapter=R}),define(ye[226],De([1,0,189,55,4]),function(re,e,a,L,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_HAS_DEBUGGED=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.CONTEXT_DEBUG_TYPE=new L.RawContextKey("debugType",void 0,{type:"string",description:a.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new L.RawContextKey("debugConfigurationType",void 0,{type:"string",description:a.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new L.RawContextKey("debugState","inactive",{type:"string",description:a.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new L.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:a.localize(3,null)}),e.CONTEXT_HAS_DEBUGGED=new L.RawContextKey("hasDebugged",!1,{type:"boolean",description:a.localize(4,null)}),e.CONTEXT_IN_DEBUG_MODE=new L.RawContextKey("inDebugMode",!1,{type:"boolean",description:a.localize(5,null)}),e.CONTEXT_IN_DEBUG_REPL=new L.RawContextKey("inDebugRepl",!1,{type:"boolean",description:a.localize(6,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new L.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:a.localize(7,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new L.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:a.localize(8,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new L.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:a.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new L.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:a.localize(10,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new L.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:a.localize(11,null)}),e.CONTEXT_VARIABLES_FOCUSED=new L.RawContextKey("variablesFocused",!0,{type:"boolean",description:a.localize(12,null)}),e.CONTEXT_EXPRESSION_SELECTED=new L.RawContextKey("expressionSelected",!1,{type:"boolean",description:a.localize(13,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new L.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:a.localize(14,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new L.RawContextKey("callStackItemType",void 0,{type:"string",description:a.localize(15,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new L.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:a.localize(16,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new L.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:a.localize(17,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new L.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:a.localize(18,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new L.RawContextKey("watchItemType",void 0,{type:"string",description:a.localize(19,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new L.RawContextKey("canViewMemory",void 0,{type:"boolean",description:a.localize(20,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new L.RawContextKey("breakpointItemType",void 0,{type:"string",description:a.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new L.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:a.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new L.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:a.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new L.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:a.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new L.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:a.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new L.RawContextKey("stepBackSupported",!1,{type:"boolean",description:a.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new L.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:a.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new L.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:a.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new L.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:a.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new L.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:a.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new L.RawContextKey("breakpointsExist",!1,{type:"boolean",description:a.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new L.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:a.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new L.RawContextKey("debugExtensionAvailable",!0,{type:"boolean",description:a.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new L.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:a.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new L.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:a.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new L.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:a.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new L.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:a.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new L.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:a.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new L.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:a.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new L.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:a.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new L.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:a.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new L.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:a.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new L.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:a.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new L.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:a.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new L.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:a.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new L.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:a.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new L.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:a.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new L.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:a.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new L.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:a.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new L.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:a.localize(50,null)});const R=v=>a.localize(51,null,v);e.debuggerDisabledMessage=R,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:a.localize(52,null)};var S;(function(v){v[v.Inactive=0]="Inactive",v[v.Initializing=1]="Initializing",v[v.Stopped=2]="Stopped",v[v.Running=3]="Running"})(S=e.State||(e.State={}));function A(v){switch(v){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=A;var y;(function(v){v[v.Valid=0]="Valid",v[v.Unreadable=1]="Unreadable",v[v.Error=2]="Error"})(y=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var I;(function(v){v[v.Initial=1]="Initial",v[v.Dynamic=2]="Dynamic"})(I=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var O;(function(v){v.UnverifiedBreakpoints="unverifiedBreakpoints"})(O=e.DebuggerString||(e.DebuggerString={})),e.IDebugService=(0,l.createDecorator)("debugService");var P;(function(v){v[v.CONDITION=0]="CONDITION",v[v.HIT_COUNT=1]="HIT_COUNT",v[v.LOG_MESSAGE=2]="LOG_MESSAGE"})(P=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(ye[227],De([1,0,8,2,9,23,16,33,21,15]),function(re,e,a,L,l,R,S,A,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getEvaluatableExpressionAtPosition=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const O=/{([^}]+)}/g;function P(n,t,d){return n.replace(O,function(E,w){return t&&w.length>0&&w[0]!=="_"?E:d&&d.hasOwnProperty(w)?d[w]:E})}e.formatPII=P;function v(n){const t={};for(const d of Object.keys(n))d.startsWith("!")||(t[d]=n[d]);return t}e.filterExceptionsFromTelemetry=v;function k(n){return n.configuration.request==="attach"&&!D(n)&&(!n.parentSession||k(n.parentSession))}e.isSessionAttach=k;function D(n){let t=n.configuration.type;if(!!t)return t==="vslsShare"&&(t=n.configuration.adapterProxy.configuration.type),(0,a.equalsIgnoreCase)(t,"extensionhost")||(0,a.equalsIgnoreCase)(t,"pwa-extensionhost")?n:n.parentSession?D(n.parentSession):void 0}e.getExtensionHostDebugSession=D;function f(n){return n.type&&(n.label||n.program||n.runtime)}e.isDebuggerMainContribution=f;function u(n,t,d){let E,w=0;const N=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let j=null;for(;j=N.exec(n);){const V=j.index+1,Q=V+j[0].length;if(V<=t&&Q>=d){E=j[0],w=V;break}}if(E){const V=/\w+/g;let Q=null;for(;(Q=V.exec(E))&&!(Q.index+1+w+Q[0].length>=d););Q&&(E=E.substring(0,V.lastIndex))}return E?{start:w,end:w+E.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=u;async function h(n,t,d,E){if(n.evaluatableExpressionProvider.has(t)){const w=n.evaluatableExpressionProvider.ordered(t),N=(0,I.coalesce)(await Promise.all(w.map(async j=>{try{return await j.provideEvaluatableExpression(t,d,E??y.CancellationToken.None)}catch{return}})));if(N.length>0){let j=N[0].expression;const V=N[0].range;return j||(j=t.getLineContent(d.lineNumber).substring(V.startColumn-1,V.endColumn-1)),{range:V,matchingExpression:j}}}else{const w=t.getLineContent(d.lineNumber),{start:N,end:j}=u(w,d.column,d.column),V=w.substring(N-1,j);return{matchingExpression:V,range:new A.Range(d.lineNumber,N,d.lineNumber,N+V.length)}}return null}e.getEvaluatableExpressionAtPosition=h;const p=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function b(n){return!!(n&&n.match(p))}e.isUri=b;function C(n){if(typeof n.path=="string"&&!(typeof n.sourceReference=="number"&&n.sourceReference>0)){if(b(n.path))return L.URI.parse(n.path);if((0,l.isAbsolute)(n.path))return L.URI.file(n.path)}return n.path}function g(n){if(typeof n.path=="object"){const t=L.URI.revive(n.path);if(t)return t.scheme===S.Schemas.file?t.fsPath:t.toString()}return n.path}function i(n,t){const d=t?C:g,E=(0,R.deepClone)(n);return r(E,(w,N)=>{w&&N&&(N.path=d(N))}),E}e.convertToDAPaths=i;function s(n,t){const d=t?C:g,E=(0,R.deepClone)(n);return r(E,(w,N)=>{!w&&N&&(N.path=d(N))}),E}e.convertToVSCPaths=s;function r(n,t){switch(n.type){case"event":{const d=n;switch(d.event){case"output":t(!1,d.body.source);break;case"loadedSource":t(!1,d.body.source);break;case"breakpoint":t(!1,d.body.breakpoint.source);break;default:break}break}case"request":{const d=n;switch(d.command){case"setBreakpoints":t(!0,d.arguments.source);break;case"breakpointLocations":t(!0,d.arguments.source);break;case"source":t(!0,d.arguments.source);break;case"gotoTargets":t(!0,d.arguments.source);break;case"launchVSCode":d.arguments.args.forEach(E=>t(!1,E));break;default:break}break}case"response":{const d=n;if(d.success&&d.body)switch(d.command){case"stackTrace":d.body.stackFrames.forEach(E=>t(!1,E.source));break;case"loadedSources":d.body.sources.forEach(E=>t(!1,E));break;case"scopes":d.body.scopes.forEach(E=>t(!1,E.source));break;case"setFunctionBreakpoints":d.body.breakpoints.forEach(E=>t(!1,E.source));break;case"setBreakpoints":d.body.breakpoints.forEach(E=>t(!1,E.source));break;case"disassemble":d.body?.instructions.forEach(w=>t(!1,w.location));break;default:break}break}}}function o(n){return n.filter(t=>!t.presentation?.hidden).sort((t,d)=>t.presentation?d.presentation?t.presentation.group?d.presentation.group?t.presentation.group!==d.presentation.group?t.presentation.group.localeCompare(d.presentation.group):c(t.presentation.order,d.presentation.order):-1:d.presentation.group?1:c(t.presentation.order,d.presentation.order):-1:d.presentation?1:0)}e.getVisibleAndSorted=o;function c(n,t){return typeof n!="number"?typeof t!="number"?0:1:typeof t!="number"?-1:n-t}async function m(n,t){const d=n.getValue("debug.saveBeforeStart",{overrideIdentifier:t.activeTextEditorLanguageId});if(d!=="none"&&(await t.saveAll(),d==="allEditorsInActiveGroup")){const E=t.activeEditorPane;E&&E.input.resource?.scheme===S.Schemas.untitled&&await t.save({editor:E.input,groupId:E.group.id})}await n.reloadConfiguration()}e.saveAllBeforeDebugStart=m}),define(ye[228],De([1,0,46,229,23,9,12,8,29,190,131]),function(re,e,a,L,l,R,S,A,y,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExecutableDebugAdapter=e.NamedPipeDebugAdapter=e.SocketDebugAdapter=e.NetworkDebugAdapter=e.StreamDebugAdapter=void 0;class P extends O.AbstractDebugAdapter{constructor(){super(),this.r=Buffer.allocUnsafe(0),this.t=-1}v(h,p){this.p=p,this.r=Buffer.allocUnsafe(0),this.t=-1,h.on("data",b=>this.w(b))}sendMessage(h){if(this.p){const p=JSON.stringify(h);this.p.write(`Content-Length: ${Buffer.byteLength(p,"utf8")}${P.a}${p}`,"utf8")}}w(h){for(this.r=Buffer.concat([this.r,h]);;){if(this.t>=0){if(this.r.length>=this.t){const p=this.r.toString("utf8",0,this.t);if(this.r=this.r.slice(this.t),this.t=-1,p.length>0)try{this.acceptMessage(JSON.parse(p))}catch(b){this.m.fire(new Error((b.message||b)+`
`+p))}continue}}else{const p=this.r.indexOf(P.a);if(p!==-1){const C=this.r.toString("utf8",0,p).split(P.b);for(const g of C){const i=g.split(P.l);i[0]==="Content-Length"&&(this.t=Number(i[1]))}this.r=this.r.slice(p+P.a.length);continue}}break}}}P.a=`\r
\r
`,P.b=/\r?\n/,P.l=/: */,e.StreamDebugAdapter=P;class v extends P{startSession(){return new Promise((h,p)=>{let b=!1;this.x=this.y(()=>{this.v(this.x,this.x),h(),b=!0}),this.x.on("close",()=>{b?this.m.fire(new Error("connection closed")):p(new Error("connection closed"))}),this.x.on("error",C=>{b?this.m.fire(C):p(C)})})}async stopSession(){await this.u(),this.x&&(this.x.end(),this.x=void 0)}}e.NetworkDebugAdapter=v;class k extends v{constructor(h){super(),this.z=h}y(h){return L.createConnection(this.z.port,this.z.host||"127.0.0.1",h)}}e.SocketDebugAdapter=k;class D extends v{constructor(h){super(),this.z=h}y(h){return L.createConnection(this.z.path,h)}}e.NamedPipeDebugAdapter=D;class f extends P{constructor(h,p){super(),this.y=h,this.z=p}async startSession(){const h=this.y.command,p=this.y.args,b=this.y.options||{};try{if(h)if(R.isAbsolute(h)){if(!await y.Promises.exists(h))throw new Error(I.localize(0,null,h))}else h.indexOf("/")<0&&h.indexOf("\\")<0;else throw new Error(I.localize(1,null,this.z));let C=process.env;if(b.env&&Object.keys(b.env).length>0&&(C=l.mixin(l.deepClone(process.env),b.env)),h==="node")if(Array.isArray(p)&&p.length>0){const g=!!process.env.ELECTRON_RUN_AS_NODE||!!process.versions.electron,i={env:C,execArgv:g?["-e","delete process.env.ELECTRON_RUN_AS_NODE;require(process.argv[1])"]:[],silent:!0};b.cwd&&(i.cwd=b.cwd);const s=a.fork(p[0],p.slice(1),i);if(!s.pid)throw new Error(I.localize(2,null,p[0]));this.x=s}else throw new Error(I.localize(3,null));else{const g={env:C};b.cwd&&(g.cwd=b.cwd),this.x=a.spawn(h,p,g)}this.x.on("error",g=>{this.m.fire(g)}),this.x.on("exit",(g,i)=>{this.n.fire(g)}),this.x.stdout.on("close",()=>{this.m.fire(new Error("read error"))}),this.x.stdout.on("error",g=>{this.m.fire(g)}),this.x.stdin.on("error",g=>{this.m.fire(g)}),this.x.stderr.resume(),this.v(this.x.stdout,this.x.stdin)}catch(C){this.m.fire(C)}}async stopSession(){return this.x?(await this.u(),S.isWindows?new Promise((h,p)=>{const b=a.exec(`taskkill /F /T /PID ${this.x.pid}`,function(C,g,i){if(C)return p(C)});b.on("exit",h),b.on("error",p)}):(this.x.kill("SIGTERM"),Promise.resolve(void 0))):Promise.resolve(void 0)}static A(h,p){if(!h)return;const b=Object.create(null);h.runtime&&(h.runtime.indexOf("./")===0?b.runtime=R.join(p,h.runtime):b.runtime=h.runtime),h.runtimeArgs&&(b.runtimeArgs=h.runtimeArgs),h.program&&(R.isAbsolute(h.program)?b.program=h.program:b.program=R.join(p,h.program)),h.args&&(b.args=h.args);const C=h;return C.win&&(b.win=f.A(C.win,p)),C.winx86&&(b.winx86=f.A(C.winx86,p)),C.windows&&(b.windows=f.A(C.windows,p)),C.osx&&(b.osx=f.A(C.osx,p)),C.linux&&(b.linux=f.A(C.linux,p)),b}static platformAdapterExecutable(h,p){let b=Object.create(null);p=p.toLowerCase();for(const o of h)if(o.contributes){const c=o.contributes.debuggers;c&&c.length>0&&c.filter(m=>typeof m.type=="string"&&A.equalsIgnoreCase(m.type,p)).forEach(m=>{const n=f.A(m,o.extensionLocation.fsPath);b=l.mixin(b,n,o.isBuiltin)})}let C;S.isWindows&&!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432")?C=b.winx86||b.win||b.windows:S.isWindows?C=b.win||b.windows:S.isMacintosh?C=b.osx:S.isLinux&&(C=b.linux),C=C||b;const g=C.program||b.program,i=C.args||b.args,s=C.runtime||b.runtime,r=C.runtimeArgs||b.runtimeArgs;if(s)return{type:"executable",command:s,args:(r||[]).concat(typeof g=="string"?[g]:[]).concat(i||[])};if(g)return{type:"executable",command:g,args:i||[]}}}e.ExecutableDebugAdapter=f}),define(ye[230],De([1,0,46,32,12]),function(re,e,a,L,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prepareCommand=e.hasChildProcesses=void 0;function R(I,O){return new Promise((P,v)=>{let k="";const D=a.spawn(I,O);D.pid&&D.stdout.on("data",f=>{k+=f.toString()}),D.on("error",f=>{v(f)}),D.on("close",f=>{P(k)})})}async function S(I){if(I)if(l.isWindows){const O=await new Promise((P,v)=>{re(["windows-process-tree"],P,v)});return new Promise(P=>{O.getProcessTree(I,v=>{P(!!v&&v.children.length>0)})})}else return R("/usr/bin/pgrep",["-lP",String(I)]).then(O=>{const P=O.trim();return!(P.length===0||P.indexOf(" tmux")>=0)},O=>!0);return Promise.resolve(!0)}e.hasChildProcesses=S;var A;(function(I){I[I.cmd=0]="cmd",I[I.powershell=1]="powershell",I[I.bash=2]="bash"})(A||(A={}));function y(I,O,P,v,k){I=I.trim().toLowerCase();let D;I.indexOf("powershell")>=0||I.indexOf("pwsh")>=0?D=1:I.indexOf("cmd.exe")>=0?D=0:I.indexOf("bash")>=0?D=2:l.isWindows?D=0:D=2;let f,u=" ";switch(D){case 1:if(f=h=>(h=h.replace(/\'/g,"''"),h.length>0&&h.charAt(h.length-1)==="\\"?`'${h}\\'`:`'${h}'`),v){const h=(0,L.getDriveLetter)(v);h&&(u+=`${h}:; `),u+=`cd ${f(v)}; `}if(k)for(const h in k){const p=k[h];p===null?u+=`Remove-Item env:${h}; `:u+=`\${env:${h}}='${p}'; `}if(O.length>0){const h=O.shift(),p=P?h:f(h);u+=p[0]==="'"?`& ${p} `:`${p} `;for(const b of O)u+=b==="<"||b===">"||P?b:f(b),u+=" "}break;case 0:if(f=h=>(h=h.replace(/\"/g,'""'),h=h.replace(/([><!^&|])/g,"^$1"),' "'.split("").some(p=>h.includes(p))||h.length===0?`"${h}"`:h),v){const h=(0,L.getDriveLetter)(v);h&&(u+=`${h}: && `),u+=`cd ${f(v)} && `}if(k){u+='cmd /C "';for(const h in k){let p=k[h];p===null?u+=`set "${h}=" && `:(p=p.replace(/[&^|<>]/g,b=>`^${b}`),u+=`set "${h}=${p}" && `)}}for(const h of O)u+=h==="<"||h===">"||P?h:f(h),u+=" ";k&&(u+='"');break;case 2:{f=p=>(p=p.replace(/(["'\\\$!><#()\[\]*&^| ;{}`])/g,"\\$1"),p.length===0?'""':p);const h=p=>/[^\w@%\/+=,.:^-]/.test(p)?`'${p.replace(/'/g,"'\\''")}'`:p;if(v&&(u+=`cd ${f(v)} ; `),k){u+="/usr/bin/env";for(const p in k){const b=k[p];b===null?u+=` -u ${h(p)}`:u+=` ${h(`${p}=${b}`)}`}u+=" "}for(const p of O)u+=p==="<"||p===">"||P?p:f(p),u+=" ";break}}return u}e.prepareCommand=y}),define(ye[93],De([1,0,22,38,65,88,16,9,12,55]),function(re,e,a,L,l,R,S,A,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compressOutputItemStreams=e.isTextStreamMime=e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.INTERACTIVE_WINDOW_EDITOR_ID=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor",e.INTERACTIVE_WINDOW_EDITOR_ID="workbench.editor.interactive";var O;(function(T){T[T.Markup=1]="Markup",T[T.Code=2]="Code"})(O=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",R.Mimes.latex,R.Mimes.markdown,"image/png","image/jpeg",R.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[R.Mimes.latex,R.Mimes.markdown,"application/json",R.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var P;(function(T){T[T.Running=1]="Running",T[T.Idle=2]="Idle"})(P=e.NotebookRunState||(e.NotebookRunState={}));var v;(function(T){T[T.Unconfirmed=1]="Unconfirmed",T[T.Pending=2]="Pending",T[T.Executing=3]="Executing"})(v=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var k;(function(T){T[T.WithHardKernelDependency=0]="WithHardKernelDependency",T[T.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",T[T.Pure=2]="Pure",T[T.Never=3]="Never"})(k=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var D;(function(T){T.Always="always",T.Never="never",T.Optional="optional"})(D=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var f;(function(T){T[T.ModelChange=1]="ModelChange",T[T.Move=2]="Move",T[T.ChangeCellLanguage=5]="ChangeCellLanguage",T[T.Initialize=6]="Initialize",T[T.ChangeCellMetadata=7]="ChangeCellMetadata",T[T.Output=8]="Output",T[T.OutputItem=9]="OutputItem",T[T.ChangeCellContent=10]="ChangeCellContent",T[T.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",T[T.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",T[T.ChangeCellMime=13]="ChangeCellMime",T[T.Unknown=100]="Unknown"})(f=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var u;(function(T){T[T.Handle=0]="Handle",T[T.Index=1]="Index"})(u=e.SelectionStateType||(e.SelectionStateType={}));var h;(function(T){T[T.Replace=1]="Replace",T[T.Output=2]="Output",T[T.Metadata=3]="Metadata",T[T.CellLanguage=4]="CellLanguage",T[T.DocumentMetadata=5]="DocumentMetadata",T[T.Move=6]="Move",T[T.OutputItems=7]="OutputItems",T[T.PartialMetadata=8]="PartialMetadata",T[T.PartialInternalMetadata=9]="PartialInternalMetadata"})(h=e.CellEditType||(e.CellEditType={}));var p;(function(T){T.scheme=S.Schemas.vscodeNotebookCell;const F=["W","X","Y","Z","a","b","c","d","e","f"],B=new RegExp(`^[${F.join("")}]+`),Z=7;function _(J,ee){const me=ee.toString(Z),Ie=`${me.length<F.length?F[me.length-1]:"z"}${me}s${(0,a.encodeBase64)(a.VSBuffer.fromString(J.scheme),!0,!0)}`;return J.with({scheme:T.scheme,fragment:Ie})}T.generate=_;function H(J){if(J.scheme!==T.scheme)return;const ee=J.fragment.indexOf("s");if(ee<0)return;const me=parseInt(J.fragment.substring(0,ee).replace(B,""),Z),ve=(0,a.decodeBase64)(J.fragment.substring(ee+1)).toString();if(!isNaN(me))return{handle:me,notebook:J.with({scheme:ve,fragment:null})}}T.parse=H;function Y(J,ee){return J.with({scheme:S.Schemas.vscodeNotebookCellOutput,fragment:`op${ee??""},${J.scheme!==S.Schemas.file?J.scheme:""}`})}T.generateCellOutputUri=Y;function ie(J){if(J.scheme!==S.Schemas.vscodeNotebookCellOutput)return;const ee=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(J.fragment);if(!ee)return;const me=ee[1]&&ee[1]!==""?ee[1]:void 0,ve=ee[2];return{outputId:me,notebook:J.with({scheme:ve||S.Schemas.file,fragment:null})}}T.parseCellOutputUri=ie;function ge(J,ee,me){return T.generate(J,ee).with({scheme:me})}T.generateCellPropertyUri=ge;function X(J,ee){if(J.scheme===ee)return T.parse(J.with({scheme:T.scheme}))}T.parseCellPropertyUri=X})(p=e.CellUri||(e.CellUri={}));const b=T=>y.isWindows?T.replace(/\//g,"\\"):T;class C{constructor(F=[],B=e.NOTEBOOK_DISPLAY_ORDER){this.e=B,this.d=[...new Set(F)].map(Z=>({pattern:Z,matches:L.parse(b(Z))}))}sort(F){const B=new Map(l.Iterable.map(F,_=>[_,b(_)]));let Z=[];for(const{matches:_}of this.d)for(const[H,Y]of B)if(_(Y)){Z.push(H),B.delete(H);break}return B.size&&(Z=Z.concat([...B.keys()].sort((_,H)=>this.e.indexOf(_)-this.e.indexOf(H)))),Z}prioritize(F,B){const Z=this.f(F);if(Z===-1){this.d.unshift({pattern:F,matches:L.parse(b(F))});return}const _=new Set(B.map(Y=>this.f(Y,Z)));_.delete(-1);const H=Array.from(_).sort();this.d.splice(Z+1,0,...H.map(Y=>this.d[Y]));for(let Y=H.length-1;Y>=0;Y--)this.d.splice(H[Y],1)}toArray(){return this.d.map(F=>F.pattern)}f(F,B=this.d.length){const Z=b(F);for(let _=0;_<B;_++)if(this.d[_].matches(Z))return _;return-1}}e.MimeTypeDisplayOrder=C;function g(T,F,B,Z=(_,H)=>_===H){const _=[];function H(ge,X,J){if(X===0&&J.length===0)return;const ee=_[_.length-1];ee&&ee.start+ee.deleteCount===ge?(ee.deleteCount+=X,ee.toInsert.push(...J)):_.push({start:ge,deleteCount:X,toInsert:J})}let Y=0,ie=0;for(;;){if(Y===T.length){H(Y,0,F.slice(ie));break}if(ie===F.length){H(Y,T.length-Y,[]);break}const ge=T[Y],X=F[ie];if(Z(ge,X)){Y+=1,ie+=1;continue}B(X)?(H(Y,1,[]),Y+=1):(H(Y,0,[X]),ie+=1)}return _}e.diff=g,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new I.RawContextKey("notebookEditorCursorAtBoundary","none");var i;(function(T){T.default="default",T.option="option"})(i=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function s(T){const F=T;return!!((typeof F.include=="string"||L.isRelativePattern(F.include))&&(typeof F.exclude=="string"||L.isRelativePattern(F.exclude)))}e.isDocumentExcludePattern=s;function r(T,F,B){if(Array.isArray(T.viewType)&&T.viewType.indexOf(F)>=0||T.viewType===F)return!0;if(T.filenamePattern){const Z=s(T.filenamePattern)?T.filenamePattern.include:T.filenamePattern,_=s(T.filenamePattern)?T.filenamePattern.exclude:void 0;if(L.match(Z,(0,A.basename)(B.fsPath).toLowerCase()))return!(_&&L.match(_,(0,A.basename)(B.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=r,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily",kernelPickerType:"notebook.kernelPicker.type",outputScrolling:"notebook.experimental.outputScrolling",outputWordWrap:"notebook.output.wordWrap",logging:"notebook.logging"};var o;(function(T){T[T.Left=1]="Left",T[T.Right=2]="Right"})(o=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class c{static create(F){return`${c.d}${F}`}static parse(F){if(F.startsWith(c.d))return F.substring(c.d.length)}}c.d="notebook/",e.NotebookWorkingCopyTypeIdentifier=c;function m(T){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(T)}e.isTextStreamMime=m;const n=new TextDecoder;function t(T){const F=[];let B=!1;for(const Z of T)(F.length===0||B)&&(F.push(Z),B=!0);return N(F),U(a.VSBuffer.concat(F.map(Z=>a.VSBuffer.wrap(Z))))}e.compressOutputItemStreams=t;const d=`${String.fromCharCode(27)}[A`,E=d.split("").map(T=>T.charCodeAt(0)),w=10;function N(T){T.forEach((F,B)=>{if(B===0||F.length<d.length)return;const Z=T[B-1],_=F.subarray(0,d.length);if(_[0]===E[0]&&_[1]===E[1]&&_[2]===E[2]){const H=Z.lastIndexOf(w);if(H===-1)return;T[B-1]=Z.subarray(0,H),T[B]=F.subarray(d.length)}})}function j(T){let F=T;do T=F,F=T.replace(/[^\n]\x08/gm,"");while(F.length<T.length);return T}function V(T){for(T=T.replace(/\r+\n/gm,`
`);T.search(/\r[^$]/g)>-1;){const F=T.match(/^(.*)\r+/m)[1];let B=T.match(/\r+(.*)$/m)[1];B=B+F.slice(B.length,F.length),T=T.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,B)}return T}const Q="\b".charCodeAt(0),x="\r".charCodeAt(0);function U(T){return!T.buffer.includes(Q)&&!T.buffer.includes(x)?T:a.VSBuffer.fromString(V(j(n.decode(T.buffer))))}}),define(ye[231],De([1,0,4]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var L;(function(l){l[l.Output=1]="Output",l[l.OutputItems=2]="OutputItems",l[l.ExecutionState=3]="ExecutionState"})(L=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,a.createDecorator)("INotebookExecutionService")}),define(ye[58],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var a;(function(R){R.Delimiter="\0"})(a=e.TestIdPathParts||(e.TestIdPathParts={}));var L;(function(R){R[R.IsSame=0]="IsSame",R[R.Disconnected=1]="Disconnected",R[R.IsChild=2]="IsChild",R[R.IsParent=3]="IsParent"})(L=e.TestPosition||(e.TestPosition={}));class l{static fromExtHostTestItem(S,A,y=S.parent){if(S._isRoot)return new l([A]);const I=[S.id];for(let O=y;O&&O.id!==A;O=O.parent)I.push(O.id);return I.push(A),new l(I.reverse())}static isRoot(S){return!S.includes("\0")}static root(S){const A=S.indexOf("\0");return A===-1?S:S.slice(0,A)}static fromString(S){return new l(S.split("\0"))}static join(S,A){return new l([...S.path,A])}static joinToString(S,A){return S.toString()+"\0"+A}static parentId(S){const A=S.lastIndexOf("\0");return A===-1?void 0:S.slice(0,A)}static localId(S){const A=S.lastIndexOf("\0");return A===-1?S:S.slice(A+1)}static compare(S,A){return S===A?0:A.startsWith(S+"\0")?2:S.startsWith(A+"\0")?3:1}constructor(S,A=S.length){if(this.path=S,this.d=A,S.length===0||A<1)throw new Error("cannot create test with empty path")}get parentId(){return this.d>1?new l(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let S=1;S<=this.d;S++)yield new l(this.path,S)}*idsToRoot(){for(let S=this.d;S>0;S--)yield new l(this.path,S)}compare(S){if(typeof S=="string")return l.compare(this.toString(),S);for(let A=0;A<S.d&&A<this.d;A++)if(S.path[A]!==this.path[A])return 1;return S.d>this.d?2:S.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let S=1;S<this.d;S++)this.c+="\0",this.c+=this.path[S]}return this.c}}e.TestId=l}),define(ye[76],De([1,0,2,33,58]),function(re,e,a,L,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.getMarkId=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.isStartControllerTests=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var R;(function(n){n[n.Unset=0]="Unset",n[n.Queued=1]="Queued",n[n.Running=2]="Running",n[n.Passed=3]="Passed",n[n.Failed=4]="Failed",n[n.Skipped=5]="Skipped",n[n.Errored=6]="Errored"})(R=e.TestResultState||(e.TestResultState={}));var S;(function(n){n[n.Run=2]="Run",n[n.Debug=4]="Debug",n[n.Coverage=8]="Coverage",n[n.HasNonDefaultProfile=16]="HasNonDefaultProfile",n[n.HasConfigurable=32]="HasConfigurable",n[n.SupportsContinuousRun=64]="SupportsContinuousRun"})(S=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16,32,64];const A=n=>"runId"in n;e.isStartControllerTests=A;var y;(function(n){n.serialize=t=>({range:t.range.toJSON(),uri:t.uri.toJSON()}),n.deserialize=t=>({range:L.Range.lift(t.range),uri:a.URI.revive(t.uri)})})(y=e.IRichLocation||(e.IRichLocation={}));var I;(function(n){n[n.Error=0]="Error",n[n.Output=1]="Output"})(I=e.TestMessageType||(e.TestMessageType={}));var O;(function(n){n.serialize=t=>({message:t.message,type:0,expected:t.expected,actual:t.actual,location:t.location&&y.serialize(t.location)}),n.deserialize=t=>({message:t.message,type:0,expected:t.expected,actual:t.actual,location:t.location&&y.deserialize(t.location)})})(O=e.ITestErrorMessage||(e.ITestErrorMessage={}));const P=(n,t)=>`${t?"s":"e"}${n}`;e.getMarkId=P;var v;(function(n){n.serialize=t=>({message:t.message,type:1,offset:t.offset,length:t.length,location:t.location&&y.serialize(t.location)}),n.deserialize=t=>({message:t.message,type:1,offset:t.offset,length:t.length,location:t.location&&y.deserialize(t.location)})})(v=e.ITestOutputMessage||(e.ITestOutputMessage={}));var k;(function(n){n.serialize=t=>t.type===0?O.serialize(t):v.serialize(t),n.deserialize=t=>t.type===0?O.deserialize(t):v.deserialize(t)})(k=e.ITestMessage||(e.ITestMessage={}));var D;(function(n){n.serializeWithoutMessages=t=>({state:t.state,duration:t.duration,messages:[]}),n.serialize=t=>({state:t.state,duration:t.duration,messages:t.messages.map(k.serialize)}),n.deserialize=t=>({state:t.state,duration:t.duration,messages:t.messages.map(k.deserialize)})})(D=e.ITestTaskState||(e.ITestTaskState={}));const f="\0",u=(n,t)=>n+f+t;e.namespaceTestTag=u;const h=n=>{const t=n.indexOf(f);return{ctrlId:n.slice(0,t),tagId:n.slice(t+1)}};e.denamespaceTestTag=h;var p;(function(n){n.serialize=t=>({extId:t.extId,label:t.label,tags:t.tags,busy:t.busy,children:void 0,uri:t.uri?.toJSON(),range:t.range?.toJSON()||null,description:t.description,error:t.error,sortText:t.sortText}),n.deserialize=t=>({extId:t.extId,label:t.label,tags:t.tags,busy:t.busy,children:void 0,uri:t.uri?a.URI.revive(t.uri):void 0,range:t.range?L.Range.lift(t.range):null,description:t.description,error:t.error,sortText:t.sortText})})(p=e.ITestItem||(e.ITestItem={}));var b;(function(n){n[n.NotExpandable=0]="NotExpandable",n[n.Expandable=1]="Expandable",n[n.BusyExpanding=2]="BusyExpanding",n[n.Expanded=3]="Expanded"})(b=e.TestItemExpandState||(e.TestItemExpandState={}));var C;(function(n){n.serialize=t=>({expand:t.expand,item:p.serialize(t.item)}),n.deserialize=t=>({controllerId:l.TestId.root(t.item.extId),expand:t.expand,item:p.deserialize(t.item)})})(C=e.InternalTestItem||(e.InternalTestItem={}));var g;(function(n){n.serialize=t=>{let d;return t.item&&(d={},t.item.label!==void 0&&(d.label=t.item.label),t.item.tags!==void 0&&(d.tags=t.item.tags),t.item.busy!==void 0&&(d.busy=t.item.busy),t.item.uri!==void 0&&(d.uri=t.item.uri?.toJSON()),t.item.range!==void 0&&(d.range=t.item.range?.toJSON()),t.item.description!==void 0&&(d.description=t.item.description),t.item.error!==void 0&&(d.error=t.item.error),t.item.sortText!==void 0&&(d.sortText=t.item.sortText)),{extId:t.extId,expand:t.expand,item:d}},n.deserialize=t=>{let d;return t.item&&(d={},t.item.label!==void 0&&(d.label=t.item.label),t.item.tags!==void 0&&(d.tags=t.item.tags),t.item.busy!==void 0&&(d.busy=t.item.busy),t.item.range!==void 0&&(d.range=t.item.range?L.Range.lift(t.item.range):null),t.item.description!==void 0&&(d.description=t.item.description),t.item.error!==void 0&&(d.error=t.item.error),t.item.sortText!==void 0&&(d.sortText=t.item.sortText)),{extId:t.extId,expand:t.expand,item:d}}})(g=e.ITestItemUpdate||(e.ITestItemUpdate={}));const i=(n,t)=>{t.expand!==void 0&&(n.expand=t.expand),t.item!==void 0&&(n.item=n.item?Object.assign(n.item,t.item):t.item)};e.applyTestItemUpdate=i;var s;(function(n){n.serializeWithoutMessages=t=>({...C.serialize(t),ownComputedState:t.ownComputedState,computedState:t.computedState,tasks:t.tasks.map(D.serializeWithoutMessages),retired:t.retired}),n.serialize=t=>({...C.serialize(t),ownComputedState:t.ownComputedState,computedState:t.computedState,tasks:t.tasks.map(D.serialize),retired:t.retired}),n.deserialize=t=>({...C.deserialize(t),ownComputedState:t.ownComputedState,computedState:t.computedState,tasks:t.tasks.map(D.deserialize),retired:!0})})(s=e.TestResultItem||(e.TestResultItem={}));var r;(function(n){n[n.Function=0]="Function",n[n.Statement=1]="Statement"})(r=e.DetailType||(e.DetailType={}));var o;(function(n){n[n.Add=0]="Add",n[n.Update=1]="Update",n[n.DocumentSynced=2]="DocumentSynced",n[n.Remove=3]="Remove",n[n.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",n[n.Retire=5]="Retire",n[n.AddTag=6]="AddTag",n[n.RemoveTag=7]="RemoveTag"})(o=e.TestDiffOpType||(e.TestDiffOpType={}));var c;(function(n){n.deserialize=t=>t.op===0?{op:t.op,item:C.deserialize(t.item)}:t.op===1?{op:t.op,item:g.deserialize(t.item)}:t.op===2?{op:t.op,uri:a.URI.revive(t.uri),docv:t.docv}:t,n.serialize=t=>t.op===0?{op:t.op,item:C.serialize(t.item)}:t.op===1?{op:t.op,item:g.serialize(t.item)}:t})(c=e.TestsDiffOp||(e.TestsDiffOp={}));class m{constructor(){this.c=new Map,this.d=new Map,this.f=new Set,this.g=0,this.h=0,this.tags=this.c}apply(t){const d=this.o();for(const E of t)switch(E.op){case 0:this.j(C.deserialize(E.item),d);break;case 1:this.k(g.deserialize(E.item),d);break;case 3:this.l(E.itemId,d);break;case 5:this.m(E.itemId);break;case 4:this.updatePendingRoots(E.amount);break;case 6:this.c.set(E.tag.id,E.tag);break;case 7:this.c.delete(E.id);break}d.complete?.()}j(t,d){const E=l.TestId.parentId(t.item.extId)?.toString();let w;if(!E)w=this.p(t),this.f.add(w),this.d.set(t.item.extId,w);else if(this.d.has(E)){const N=this.d.get(E);N.children.add(t.item.extId),w=this.p(t,N),this.d.set(t.item.extId,w)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(t)}`);return}return d.add?.(w),t.expand===2&&this.g++,w}k(t,d){const E=this.d.get(t.extId);if(!!E)return t.expand!==void 0&&(E.expand===2&&this.g--,t.expand===2&&this.g++),(0,e.applyTestItemUpdate)(E,t),d.update?.(E),E}l(t,d){const E=this.d.get(t);if(!E)return;const w=l.TestId.parentId(E.item.extId)?.toString();w?this.d.get(w).children.delete(E.item.extId):this.f.delete(E);const N=[[t]];for(;N.length;)for(const j of N.pop()){const V=this.d.get(j);V&&(N.push(V.children),this.d.delete(j),d.remove?.(V,V!==E),V.expand===2&&this.g--)}}m(t){}updatePendingRoots(t){this.h+=t}o(){return{}}}e.AbstractIncrementalTestCollection=m}),define(ye[94],De([1,0,17,3,6,50,76,58]),function(re,e,a,L,l,R,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var y;(function(p){p[p.Upsert=0]="Upsert",p[p.SetTags=1]="SetTags",p[p.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",p[p.RemoveChild=3]="RemoveChild",p[p.SetProp=4]="SetProp",p[p.Bulk=5]="Bulk",p[p.DocumentSynced=6]="DocumentSynced"})(y=e.TestItemEventOp||(e.TestItemEventOp={}));const I=(p,b)=>p===b,P=Object.entries({range:(p,b)=>p===b?!0:!p||!b?!1:p.equalsRange(b),busy:I,label:I,description:I,error:I,sortText:I,tags:(p,b)=>!(p.length!==b.length||p.some(C=>!b.includes(C)))}),v=(p,b)=>{let C;for(const[g,i]of P)i(p[g],b[g])||(C?C[g]=b[g]:C={[g]:b[g]});return C};class k extends l.Disposable{get root(){return this.m.root}constructor(b){super(),this.m=b,this.f=this.B(new a.RunOnceScheduler(()=>this.flushDiff(),200)),this.g=this.B(new L.Emitter),this.tree=new Map,this.j=new Map,this.k=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.u(this.root,void 0)}set resolveHandler(b){this.h=b;for(const C of this.tree.values())this.G(C)}get resolveHandler(){return this.h}collectDiff(){const b=this.k;return this.k=[],b}pushDiff(b){switch(b.op){case 2:{for(const C of this.k)if(C.op===2&&C.uri===b.uri){C.docv=b.docv;return}break}case 1:{const C=this.k[this.k.length-1];if(C){if(C.op===1&&C.item.extId===b.item.extId){(0,S.applyTestItemUpdate)(C.item,b.item);return}if(C.op===0&&C.item.item.extId===b.item.extId){(0,S.applyTestItemUpdate)(C.item,b.item);return}}break}}this.k.push(b),this.f.isScheduled()||this.f.schedule()}expand(b,C){const g=this.tree.get(b);if(!!g){if((g.expandLevels===void 0||C>g.expandLevels)&&(g.expandLevels=C),g.expand===1){const i=this.I(g);return i.isOpen()?this.H(g,C-1):i.wait().then(()=>this.H(g,C-1))}else if(g.expand===3)return g.resolveBarrier?.isOpen()===!1?g.resolveBarrier.wait().then(()=>this.H(g,C-1)):this.H(g,C-1)}}dispose(){for(const b of this.tree.values())this.m.getApiFor(b.actual).listener=void 0;this.tree.clear(),this.k=[],super.dispose()}p(b,C){switch(C.op){case 3:this.L(A.TestId.joinToString(b.fullId,C.id));break;case 0:this.u(C.item,b);break;case 5:for(const g of C.ops)this.p(b,g);break;case 1:this.w(C.new,C.old,b.fullId.toString());break;case 2:this.G(b);break;case 4:this.pushDiff({op:1,item:{extId:b.fullId.toString(),item:C.update}});break;case 6:this.s(b.actual.uri);break;default:(0,R.assertNever)(C)}}s(b){b&&this.pushDiff({op:2,uri:b,docv:this.m.getDocumentVersion(b)})}u(b,C){const g=A.TestId.fromExtHostTestItem(b,this.root.id,C?.actual),i=this.m.getApiFor(b);i.parent&&i.parent!==C?.actual&&this.m.getChildren(i.parent).delete(b.id);let s=this.tree.get(g.toString());if(!s){s={fullId:g,actual:b,expandLevels:C?.expandLevels?C.expandLevels-1:void 0,expand:0},b.tags.forEach(this.y,this),this.tree.set(s.fullId.toString(),s),this.C(b,C),this.pushDiff({op:0,item:{controllerId:this.m.controllerId,expand:s.expand,item:this.m.toITestItem(b)}}),this.F(b,s,C);return}if(s.actual===b){this.D(b,s,C);return}if(s.actual.uri?.toString()!==b.uri?.toString())return this.L(g.toString()),this.u(b,C);const r=this.m.getChildren(s.actual),o=s.actual,c=v(this.m.toITestItem(o),this.m.toITestItem(b));this.m.getApiFor(o).listener=void 0,s.actual=b,s.expand=0,c&&(c.hasOwnProperty("tags")&&(this.w(b.tags,o.tags,g.toString()),delete c.tags),this.p(s,{op:4,update:c})),this.F(b,s,C);for(const[m,n]of r)this.m.getChildren(b).get(n.id)||this.L(A.TestId.joinToString(g,n.id));this.s(s.actual.uri)}w(b,C,g){const i=new Set(C.map(s=>s.id));for(const s of b)i.delete(s.id)||this.y(s);this.pushDiff({op:1,item:{extId:g,item:{tags:b.map(s=>(0,S.namespaceTestTag)(this.m.controllerId,s.id))}}}),i.forEach(this.z,this)}y(b){const C=this.j.get(b.id);C?C.refCount++:(this.j.set(b.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,S.namespaceTestTag)(this.m.controllerId,b.id)}}))}z(b){const C=this.j.get(b);C&&!--C.refCount&&(this.j.delete(b),this.pushDiff({op:7,id:(0,S.namespaceTestTag)(this.m.controllerId,b)}))}C(b,C){this.m.getApiFor(b).parent=C&&C.actual!==this.root?C.actual:void 0}D(b,C,g){this.C(b,g);const i=this.m.getApiFor(b);i.parent=g?.actual,i.listener=s=>this.p(C,s),this.G(C)}F(b,C,g){this.D(b,C,g);for(const[i,s]of this.m.getChildren(b))this.u(s,C)}G(b){let C;this.h?b.resolveBarrier?C=b.resolveBarrier.isOpen()?3:2:C=b.actual.canResolveChildren?1:0:C=0,C!==b.expand&&(b.expand=C,this.pushDiff({op:1,item:{extId:b.fullId.toString(),expand:C}}),C===1&&b.expandLevels!==void 0&&this.I(b))}H(b,C){if(C<0)return;const g=[];for(const[i,s]of this.m.getChildren(b.actual)){const r=this.expand(A.TestId.joinToString(b.fullId,s.id),C);(0,a.isThenable)(r)&&g.push(r)}if(g.length)return Promise.all(g).then(()=>{})}I(b){if(b.resolveBarrier)return b.resolveBarrier;if(!this.h){const s=new a.Barrier;return s.open(),s}b.expand=2,this.J(b);const C=b.resolveBarrier=new a.Barrier,g=s=>{console.error(`Unhandled error in resolveHandler of test controller "${this.m.controllerId}"`,s)};let i;try{i=this.h(b.actual===this.root?void 0:b.actual)}catch(s){g(s)}return(0,a.isThenable)(i)?i.catch(g).then(()=>{C.open(),this.G(b)}):(C.open(),this.G(b)),b.resolveBarrier}J(b){this.pushDiff({op:1,item:{extId:b.fullId.toString(),expand:b.expand}})}L(b){const C=this.tree.get(b);if(!C)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:b});const g=[C];for(;g.length;){const i=g.pop();if(!!i){this.m.getApiFor(i.actual).listener=void 0;for(const s of i.actual.tags)this.z(s.id);this.tree.delete(i.fullId.toString());for(const[s,r]of this.m.getChildren(i.actual))g.push(this.tree.get(A.TestId.joinToString(i.fullId,r.id)))}}}flushDiff(){const b=this.collectDiff();b.length&&this.g.fire(b)}}e.TestItemCollection=k;class D extends Error{constructor(b){super(`Attempted to insert a duplicate test item ID ${b}`)}}e.DuplicateTestItemError=D;class f extends Error{constructor(b){super(`TestItem with ID "${b}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=f;class u extends Error{constructor(b,C,g){super(`TestItem with ID "${b}" is from controller "${C}" and cannot be added as a child of an item from controller "${g}".`)}}e.MixedTestItemController=u;const h=(p,b,C)=>{let g=new Map;return{get size(){return g.size},forEach(i,s){for(const r of g.values())i.call(s,r,this)},[Symbol.iterator](){return g.entries()},replace(i){const s=new Map,r=new Set(g.keys()),o={op:5,ops:[]};for(const c of i){if(!(c instanceof C))throw new f(c.id);const m=b(c).controllerId;if(m!==p.controllerId)throw new u(c.id,m,p.controllerId);if(s.has(c.id))throw new D(c.id);s.set(c.id,c),r.delete(c.id),o.ops.push({op:0,item:c})}for(const c of r.keys())o.ops.push({op:3,id:c});p.listener?.(o),g=s},add(i){if(!(i instanceof C))throw new f(i.id);g.set(i.id,i),p.listener?.({op:0,item:i})},delete(i){g.delete(i)&&p.listener?.({op:3,id:i})},get(i){return g.get(i)},toJSON(){return Array.from(g.values())}}};e.createTestItemChildren=h}),define(ye[132],De([1,0,94]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const L=new WeakMap,l=(S,A)=>{const y={controllerId:A};return L.set(S,y),y};e.createPrivateApiFor=l;const R=S=>{const A=L.get(S);if(!A)throw new a.InvalidTestItemError(S?.id||"<unknown>");return A};e.getPrivateApiFor=R}),define(ye[95],De([1,0,16,2]),function(re,e,a,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function l(A,y){return A.scheme===a.Schemas.http||A.scheme===a.Schemas.https?A:(y&&y.authority&&y.isRemote&&A.scheme===a.Schemas.file&&(A=L.URI.from({scheme:a.Schemas.vscodeRemote,authority:y.authority,path:A.path})),L.URI.from({scheme:a.Schemas.https,authority:`${A.scheme}+${R(A.authority)}.${e.webviewRootResourceAuthority}`,path:A.path,fragment:A.fragment,query:A.query}))}e.asWebviewUri=l;function R(A){return A.replace(/./g,y=>{const I=y.charCodeAt(0);return I>=97&&I<=122||I>=65&&I<=90||I>=48&&I<=57?y:"-"+I.toString(16).padStart(4,"0")})}function S(A){return A.replace(/-([0-9a-f]{4})/g,(y,I)=>String.fromCharCode(parseInt(I,16)))}e.decodeAuthority=S}),define(ye[232],De([1,0,3,6,95]),function(re,e,a,L,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class R{constructor(A,y,I){this.d=A,this.e=y,this.f=I,this.a=0,this.b=new L.DisposableStore,this.c=new Map,this.b.add(y.onDidChangeVisibleTextEditors(()=>{const O=y.getVisibleTextEditors();for(const P of this.c.values())O.indexOf(P.editor)<0&&P.inset.dispose()}))}dispose(){this.c.forEach(A=>A.inset.dispose()),this.b.dispose()}createWebviewEditorInset(A,y,I,O,P){let v;for(const b of this.e.getVisibleTextEditors(!0))if(b.value===A){v=b;break}if(!v)throw new Error("not a visible editor");const k=this,D=this.a++,f=new a.Emitter,u=new a.Emitter,h=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(b){return(0,l.asWebviewUri)(b,k.f)}get cspSource(){return l.webviewGenericCspSource}set options(b){this.b=b,k.d.$setOptions(D,b)}get options(){return this.b}set html(b){this.a=b,k.d.$setHtml(D,b)}get html(){return this.a}get onDidReceiveMessage(){return f.event}postMessage(b){return k.d.$postMessage(D,b)}},p=new class{constructor(){this.editor=A,this.line=y,this.height=I,this.webview=h,this.onDidDispose=u.event}dispose(){k.c.has(D)&&(k.c.delete(D),k.d.$disposeEditorInset(D),u.fire(),u.dispose(),f.dispose())}};return this.d.$createEditorInset(D,v.id,v.value.document.uri,y+1,I,O||{},P.identifier,P.extensionLocation),this.c.set(D,{editor:A,inset:p,onDidReceiveMessage:f}),p}$onDidDispose(A){const y=this.c.get(A);y&&y.inset.dispose()}$onDidReceiveMessage(A,y){this.c.get(A)?.onDidReceiveMessage.fire(y)}}e.ExtHostEditorInsets=R}),define(ye[233],De([1,0,4]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.VariableError=e.VariableKind=e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=(0,a.createDecorator)("configurationResolverService");var L;(function(R){R.Unknown="unknown",R.Env="env",R.Config="config",R.Command="command",R.Input="input",R.ExtensionInstallFolder="extensionInstallFolder",R.WorkspaceFolder="workspaceFolder",R.Cwd="cwd",R.WorkspaceFolderBasename="workspaceFolderBasename",R.UserHome="userHome",R.LineNumber="lineNumber",R.SelectedText="selectedText",R.File="file",R.FileWorkspaceFolder="fileWorkspaceFolder",R.RelativeFile="relativeFile",R.RelativeFileDirname="relativeFileDirname",R.FileDirname="fileDirname",R.FileExtname="fileExtname",R.FileBasename="fileBasename",R.FileBasenameNoExtension="fileBasenameNoExtension",R.FileDirnameBasename="fileDirnameBasename",R.ExecPath="execPath",R.ExecInstallFolder="execInstallFolder",R.PathSeparator="pathSeparator"})(L=e.VariableKind||(e.VariableKind={}));class l extends Error{constructor(S,A){super(A),this.variable=S}}e.VariableError=l}),define(ye[234],De([1,0,9,36,10,23,12,110,193,233,8]),function(re,e,a,L,l,R,S,A,y,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class P{constructor(k,D,f,u){this.g=new Map,this.a=k,this.b=D,this.d=f,u&&(this.c=u.then(h=>this.h(h)))}h(k){if(S.isWindows){const D=Object.create(null);return Object.keys(k).forEach(f=>{D[f.toLowerCase()]=k[f]}),D}return k}resolveWithEnvironment(k,D,f){return this.j({env:this.h(k),userHome:void 0},D?D.uri:void 0,f)}async resolveAsync(k,D){const f={env:await this.c,userHome:await this.d};return this.j(f,k?k.uri:void 0,D)}async i(k,D,f,u){const h=R.deepClone(D);S.isWindows&&h.windows?Object.keys(h.windows).forEach(b=>h[b]=h.windows[b]):S.isMacintosh&&h.osx?Object.keys(h.osx).forEach(b=>h[b]=h.osx[b]):S.isLinux&&h.linux&&Object.keys(h.linux).forEach(b=>h[b]=h.linux[b]),delete h.windows,delete h.osx,delete h.linux;const p={env:await this.c,userHome:await this.d};return this.j(p,k?k.uri:void 0,h,f,u)}async resolveAnyAsync(k,D,f){return this.i(k,D,f)}async resolveAnyMap(k,D,f){const u=new Map;return{newConfig:await this.i(k,D,f,u),resolvedVariables:u}}resolveWithInteractionReplace(k,D,f,u){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(k,D,f,u){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(k,D){if(this.g.has(k))throw new Error("Variable "+k+" is contributed twice.");this.g.set(k,D)}async j(k,D,f,u,h){if(l.isString(f))return this.l(k,D,f,u,h);if(Array.isArray(f))return Promise.all(f.map(p=>this.j(k,D,p,u,h)));if(l.isObject(f)){const p=Object.create(null),b=await Promise.all(Object.keys(f).map(async C=>[await this.l(k,D,C,u,h),await this.j(k,D,f[C],u,h)]));for(const[C,g]of b)p[C]=g;return p}return f}l(k,D,f,u,h){return(0,O.replaceAsync)(f,P.VARIABLE_REGEXP,async(p,b)=>{if(b.includes(P.VARIABLE_LHS))return p;let C=await this.n(k,p,b,D,u);return h?.set(b,C),C!==p&&l.isString(C)&&C.match(P.VARIABLE_REGEXP)&&(C=await this.l(k,D,C,u,h)),C})}m(k){return this.b?this.b.getUriLabel(k,{noPrefix:!0}):k.fsPath}async n(k,D,f,u,h){let p;const b=f.split(":");b.length>1&&(f=b[0],p=b[1]);const C=s=>{const r=this.a.getFilePath();if(r)return(0,A.normalizeDriveLetter)(r);throw new I.VariableError(s,(0,y.localize)(0,null,D))},g=s=>{const r=C(s);if(this.a.getWorkspaceFolderPathForFile){const o=this.a.getWorkspaceFolderPathForFile();if(o)return(0,A.normalizeDriveLetter)(o)}throw new I.VariableError(s,(0,y.localize)(1,null,D,a.basename(r)))},i=s=>{if(p){const r=this.a.getFolderUri(p);if(r)return r;throw new I.VariableError(s,(0,y.localize)(2,null,D,p))}if(u)return u;throw this.a.getWorkspaceFolderCount()>1?new I.VariableError(s,(0,y.localize)(3,null,D)):new I.VariableError(s,(0,y.localize)(4,null,D))};switch(f){case"env":if(p){if(k.env){const s=k.env[S.isWindows?p.toLowerCase():p];if(l.isString(s))return s}return""}throw new I.VariableError(I.VariableKind.Env,(0,y.localize)(5,null,D));case"config":if(p){const s=this.a.getConfigurationValue(u,p);if(l.isUndefinedOrNull(s))throw new I.VariableError(I.VariableKind.Config,(0,y.localize)(6,null,D,p));if(l.isObject(s))throw new I.VariableError(I.VariableKind.Config,(0,y.localize)(7,null,D,p));return s}throw new I.VariableError(I.VariableKind.Config,(0,y.localize)(8,null,D));case"command":return this.o(I.VariableKind.Command,D,p,h,"command");case"input":return this.o(I.VariableKind.Input,D,p,h,"input");case"extensionInstallFolder":if(p){const s=await this.a.getExtension(p);if(!s)throw new I.VariableError(I.VariableKind.ExtensionInstallFolder,(0,y.localize)(9,null,D,p));return this.m(s.extensionLocation)}throw new I.VariableError(I.VariableKind.ExtensionInstallFolder,(0,y.localize)(10,null,D));default:switch(f){case"workspaceRoot":case"workspaceFolder":return(0,A.normalizeDriveLetter)(this.m(i(I.VariableKind.WorkspaceFolder)));case"cwd":return u||p?(0,A.normalizeDriveLetter)(this.m(i(I.VariableKind.Cwd))):L.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,A.normalizeDriveLetter)(a.basename(this.m(i(I.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(k.userHome)return k.userHome;throw new I.VariableError(I.VariableKind.UserHome,(0,y.localize)(11,null,D))}case"lineNumber":{const s=this.a.getLineNumber();if(s)return s;throw new I.VariableError(I.VariableKind.LineNumber,(0,y.localize)(12,null,D))}case"selectedText":{const s=this.a.getSelectedText();if(s)return s;throw new I.VariableError(I.VariableKind.SelectedText,(0,y.localize)(13,null,D))}case"file":return C(I.VariableKind.File);case"fileWorkspaceFolder":return g(I.VariableKind.FileWorkspaceFolder);case"relativeFile":return u||p?a.relative(this.m(i(I.VariableKind.RelativeFile)),C(I.VariableKind.RelativeFile)):C(I.VariableKind.RelativeFile);case"relativeFileDirname":{const s=a.dirname(C(I.VariableKind.RelativeFileDirname));if(u||p){const r=a.relative(this.m(i(I.VariableKind.RelativeFileDirname)),s);return r.length===0?".":r}return s}case"fileDirname":return a.dirname(C(I.VariableKind.FileDirname));case"fileExtname":return a.extname(C(I.VariableKind.FileExtname));case"fileBasename":return a.basename(C(I.VariableKind.FileBasename));case"fileBasenameNoExtension":{const s=a.basename(C(I.VariableKind.FileBasenameNoExtension));return s.slice(0,s.length-a.extname(s).length)}case"fileDirnameBasename":return a.basename(a.dirname(C(I.VariableKind.FileDirnameBasename)));case"execPath":{const s=this.a.getExecPath();return s||D}case"execInstallFolder":{const s=this.a.getAppRoot();return s||D}case"pathSeparator":return a.sep;default:try{const s=p?`${f}:${p}`:f;return this.o(I.VariableKind.Unknown,D,s,h,void 0)}catch{return D}}}}o(k,D,f,u,h){if(f&&u){const p=h===void 0?u[f]:u[h+":"+f];if(typeof p=="string")return p;throw new I.VariableError(k,(0,y.localize)(14,null,D))}return D}}P.VARIABLE_LHS="${",P.VARIABLE_REGEXP=/\$\{(.*?)\}/g,e.AbstractVariableResolverService=P}),define(ye[133],De([1,0,4,130]),function(re,e,a,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,a.createDecorator)("editorGroupsService");var l;(function(D){D[D.UP=0]="UP",D[D.DOWN=1]="DOWN",D[D.LEFT=2]="LEFT",D[D.RIGHT=3]="RIGHT"})(l=e.GroupDirection||(e.GroupDirection={}));var R;(function(D){D[D.HORIZONTAL=0]="HORIZONTAL",D[D.VERTICAL=1]="VERTICAL"})(R=e.GroupOrientation||(e.GroupOrientation={}));var S;(function(D){D[D.FIRST=0]="FIRST",D[D.LAST=1]="LAST",D[D.NEXT=2]="NEXT",D[D.PREVIOUS=3]="PREVIOUS"})(S=e.GroupLocation||(e.GroupLocation={}));var A;(function(D){D[D.MAXIMIZE=0]="MAXIMIZE",D[D.EVEN=1]="EVEN",D[D.TOGGLE=2]="TOGGLE"})(A=e.GroupsArrangement||(e.GroupsArrangement={}));var y;(function(D){D[D.COPY_EDITORS=0]="COPY_EDITORS",D[D.MOVE_EDITORS=1]="MOVE_EDITORS"})(y=e.MergeGroupMode||(e.MergeGroupMode={}));function I(D){const f=D;return(0,L.isEditorInput)(f?.editor)&&(0,L.isEditorInput)(f?.replacement)}e.isEditorReplacement=I;var O;(function(D){D[D.CREATION_TIME=0]="CREATION_TIME",D[D.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",D[D.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(O=e.GroupsOrder||(e.GroupsOrder={}));var P;(function(D){D[D.NEW_EDITOR=1]="NEW_EDITOR",D[D.MOVE_EDITOR=2]="MOVE_EDITOR",D[D.COPY_EDITOR=3]="COPY_EDITOR"})(P=e.OpenEditorContext||(e.OpenEditorContext={}));function v(D){const f=D;return!!f&&typeof f.id=="number"&&Array.isArray(f.editors)}e.isEditorGroup=v;function k(D){return D.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=k}),define(ye[235],De([1,0,4,133]),function(re,e,a,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,a.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function l(R){const S=R;return typeof R=="number"||(0,L.isEditorGroup)(S)}e.isPreferredGroup=l}),define(ye[236],De([1,0,4,200]),function(re,e,a,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,a.refineServiceDecorator)(L.IEnvironmentService)}),define(ye[134],De([1,0,27,3,9]),function(re,e,a,L,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class R{constructor(P){this.removedDueToLooping=P}}e.DeltaExtensionsResult=R;class S{static isHostExtension(P,v,k){if(v.getExtensionDescription(P))return!1;const D=k.getExtensionDescription(P);return D?!!((D.main||D.browser)&&D.api==="none"):!1}constructor(P){this.c=new L.Emitter,this.onDidChange=this.c.event,this.d=P,this.h()}h(){this.d.sort(y),this.e=new Map,this.f=[],this.g=new Map;for(const P of this.d){if(this.e.has(a.ExtensionIdentifier.toKey(P.identifier))){console.error("Extension `"+P.identifier.value+"` is already registered");continue}if(this.e.set(a.ExtensionIdentifier.toKey(P.identifier),P),this.f.push(P),Array.isArray(P.activationEvents))for(let v of P.activationEvents)v==="onUri"&&(v=`onUri:${a.ExtensionIdentifier.toKey(P.identifier)}`),this.g.has(v)||this.g.set(v,[]),this.g.get(v).push(P)}}set(P){this.d=P,this.h(),this.c.fire(void 0)}deltaExtensions(P,v){this.d=I(this.d,v),this.d=this.d.concat(P);const k=S.j(this.d);return this.d=I(this.d,k.map(D=>D.identifier)),this.h(),this.c.fire(void 0),new R(k)}static j(P){const v=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(h){this.d.has(h)||(this.d.add(h),this.e.push(h))}addArc(h,p){this.addNode(h),this.addNode(p),this.c.has(h)?this.c.get(h).push(p):this.c.set(h,[p])}getArcs(h){return this.c.has(h)?this.c.get(h):[]}hasOnlyGoodArcs(h,p){const b=v.getArcs(h);for(let C=0;C<b.length;C++)if(!p.has(b[C]))return!1;return!0}getNodes(){return this.e}},k=new Map;for(const h of P){const p=a.ExtensionIdentifier.toKey(h.identifier);if(k.set(p,h),h.extensionDependencies)for(const b of h.extensionDependencies){const C=a.ExtensionIdentifier.toKey(b);v.addArc(p,C)}}const D=new Set;v.getNodes().filter(h=>v.getArcs(h).length===0).forEach(h=>D.add(h));const f=v.getNodes().filter(h=>!D.has(h));let u;do{u=!1;for(let h=0;h<f.length;h++){const p=f[h];v.hasOnlyGoodArcs(p,D)&&(f.splice(h,1),h--,D.add(p),u=!0)}}while(u);return f.map(h=>k.get(h))}containsActivationEvent(P){return this.g.has(P)}containsExtension(P){return this.e.has(a.ExtensionIdentifier.toKey(P))}getExtensionDescriptionsForActivationEvent(P){const v=this.g.get(P);return v?v.slice(0):[]}getAllExtensionDescriptions(){return this.f.slice(0)}getExtensionDescription(P){const v=this.e.get(a.ExtensionIdentifier.toKey(P));return v||void 0}getExtensionDescriptionByUUID(P){for(const v of this.f)if(v.uuid===P)return v}getExtensionDescriptionByIdOrUUID(P,v){return this.getExtensionDescription(P)??(v?this.getExtensionDescriptionByUUID(v):void 0)}}e.ExtensionDescriptionRegistry=S;var A;(function(O){O[O.Builtin=0]="Builtin",O[O.User=1]="User",O[O.Dev=2]="Dev"})(A||(A={}));function y(O,P){const v=O.isBuiltin?0:O.isUnderDevelopment?2:1,k=P.isBuiltin?0:P.isUnderDevelopment?2:1;if(v!==k)return v-k;const D=l.posix.basename(O.extensionLocation.path),f=l.posix.basename(P.extensionLocation.path);return D<f?-1:D>f?1:0}function I(O,P){const v=new Set;return P.forEach(k=>v.add(a.ExtensionIdentifier.toKey(k))),O.filter(k=>!v.has(a.ExtensionIdentifier.toKey(k.identifier)))}}),define(ye[237],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readExtHostConnection=e.writeExtHostConnection=e.MessagePortExtHostConnection=e.SocketExtHostConnection=e.IPCExtHostConnection=e.ExtHostConnectionType=void 0;var a;(function(O){O[O.IPC=1]="IPC",O[O.Socket=2]="Socket",O[O.MessagePort=3]="MessagePort"})(a=e.ExtHostConnectionType||(e.ExtHostConnectionType={}));class L{constructor(P){this.pipeName=P,this.type=1}serialize(P){P[L.ENV_KEY]=this.pipeName}}L.ENV_KEY="VSCODE_EXTHOST_IPC_HOOK",e.IPCExtHostConnection=L;class l{constructor(){this.type=2}serialize(P){P[l.ENV_KEY]="1"}}l.ENV_KEY="VSCODE_EXTHOST_WILL_SEND_SOCKET",e.SocketExtHostConnection=l;class R{constructor(){this.type=3}serialize(P){P[R.ENV_KEY]="1"}}R.ENV_KEY="VSCODE_WILL_SEND_MESSAGE_PORT",e.MessagePortExtHostConnection=R;function S(O){delete O[L.ENV_KEY],delete O[l.ENV_KEY],delete O[R.ENV_KEY]}function A(O,P){S(P),O.serialize(P)}e.writeExtHostConnection=A;function y(O){if(O[L.ENV_KEY])return I(O,new L(O[L.ENV_KEY]));if(O[l.ENV_KEY])return I(O,new l);if(O[R.ENV_KEY])return I(O,new R);throw new Error("No connection information defined in environment!")}e.readExtHostConnection=y;function I(O,P){return S(O),P}}),define(ye[96],De([1,0,22]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var L;(function(I){I[I.Desktop=1]="Desktop",I[I.Web=2]="Web"})(L=e.UIKind||(e.UIKind={}));var l;(function(I){I[I.VersionMismatch=55]="VersionMismatch",I[I.UnexpectedError=81]="UnexpectedError"})(l=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var R;(function(I){I[I.Initialized=0]="Initialized",I[I.Ready=1]="Ready",I[I.Terminate=2]="Terminate"})(R=e.MessageType||(e.MessageType={}));function S(I){const O=a.VSBuffer.alloc(1);switch(I){case 0:O.writeUInt8(1,0);break;case 1:O.writeUInt8(2,0);break;case 2:O.writeUInt8(3,0);break}return O}e.createMessageOfType=S;function A(I,O){if(I.byteLength!==1)return!1;switch(I.readUInt8(0)){case 1:return O===0;case 2:return O===1;case 3:return O===2;default:return!1}}e.isMessageOfType=A;var y;(function(I){I.Start="START_NATIVE_LOG",I.End="END_NATIVE_LOG"})(y=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(ye[77],De([1,0,4,3,13,25,96,73,74,23,2,6,180]),function(re,e,a,L,l,R,S,A,y,I,O,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.isNewAppInstall=e.ExtHostTelemetryLogger=e.ExtHostTelemetry=void 0;let k=class extends P.Disposable{constructor(h,p){super(),this.m=h,this.n=p,this.a=this.B(new L.Emitter),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new L.Emitter),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.i=!1,this.l=new Map,this.j=O.URI.revive(this.m.environment.extensionTelemetryLogResource),this.i=this.m.environment.isExtensionTelemetryLoggingOnly,this.k=p.createLogger(this.j,{id:y.extensionTelemetryLogChannelId,name:(0,v.localize)(0,null,this.i?" (Not Sent)":""),hidden:!0}),this.B(p.onDidChangeLogLevel(b=>{(0,l.isLogLevel)(b)&&this.p()})),this.k.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.k.info("===========================================================")}p(){this.n.setVisibility(this.j,this.g&&this.n.getLogLevel()===l.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(h,p,b){const C=this.getTelemetryDetails(),g=new D(p,b,h,this.k,this.i,this.getBuiltInCommonProperties(h),{isUsageEnabled:C.isUsageEnabled,isErrorsEnabled:C.isErrorsEnabled});return this.l.set(h.identifier.value,g),g.apiTelemetryLogger}$initializeTelemetryLevel(h,p,b){this.f=h,this.g=p,this.c=b??{usage:!0,error:!0},this.p()}getBuiltInCommonProperties(h){const p={};switch(p["common.extname"]=`${h.publisher}.${h.name}`,p["common.extversion"]=h.version,p["common.vscodemachineid"]=this.m.telemetryInfo.machineId,p["common.vscodesessionid"]=this.m.telemetryInfo.sessionId,p["common.vscodeversion"]=this.m.version,p["common.isnewappinstall"]=f(this.m.telemetryInfo.firstSessionDate),p["common.product"]=this.m.environment.appHost,this.m.uiKind){case S.UIKind.Web:p["common.uikind"]="web";break;case S.UIKind.Desktop:p["common.uikind"]="desktop";break;default:p["common.uikind"]="unknown"}return p["common.remotename"]=(0,A.getRemoteName)((0,y.cleanRemoteAuthority)(this.m.remote.authority)),p}$onDidChangeTelemetryLevel(h){this.h=this.getTelemetryConfiguration(),this.f=h;const p=this.getTelemetryDetails();this.l.forEach(b=>{b.updateTelemetryEnablements(p.isUsageEnabled,p.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.p()}onExtensionError(h,p){const b=this.l.get(h.value);return!b||b.ignoreUnhandledExtHostErrors?!1:(b.logError(p),!0)}};k=qe([ze(0,R.IExtHostInitDataService),ze(1,l.ILoggerService)],k),e.ExtHostTelemetry=k;class D{static validateSender(h){if(typeof h!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof h.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof h.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof h.flush<"u"&&typeof h.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(h,p,b,C,g,i,s){this.g=b,this.h=C,this.i=g,this.j=i,this.a=new L.Emitter,this.ignoreUnhandledExtHostErrors=p?.ignoreUnhandledErrors??!1,this.b=p?.ignoreBuiltInCommonProperties??!1,this.c=p?.additionalCommonProperties,this.f=h,this.d={isUsageEnabled:s.isUsageEnabled,isErrorsEnabled:s.isErrorsEnabled}}updateTelemetryEnablements(h,p){this.e&&(this.d={isUsageEnabled:h,isErrorsEnabled:p},this.a.fire(this.e))}mixInCommonPropsAndCleanData(h){let p=h.properties??h;return p=(0,y.cleanData)(p,[]),this.c&&(p=(0,I.mixin)(p,this.c)),this.b||(p=(0,I.mixin)(p,this.j)),h.properties?h.properties=p:h=p,h}k(h,p){!this.f||(this.g.publisher==="vscode"?h=this.g.name+"/"+h:h=this.g.identifier.value+"/"+h,p=this.mixInCommonPropsAndCleanData(p||{}),this.i||this.f?.sendEventData(h,p),this.h.trace(h,p))}logUsage(h,p){!this.d.isUsageEnabled||this.k(h,p)}logError(h,p){!this.d.isErrorsEnabled||!this.f||(typeof h=="string"?this.k(h,p):this.f.sendErrorData(h,p))}get apiTelemetryLogger(){if(!this.e){const h=this,p={logUsage:h.logUsage.bind(h),get isUsageEnabled(){return h.d.isUsageEnabled},get isErrorsEnabled(){return h.d.isErrorsEnabled},logError:h.logError.bind(h),dispose:h.dispose.bind(h),onDidChangeEnableStates:h.a.event.bind(h)};this.e=Object.freeze(p)}return this.e}dispose(){this.f?.flush&&(Promise.resolve(this.f.flush()).then(this.f=void 0),this.e=void 0)}}e.ExtHostTelemetryLogger=D;function f(u){const h=Date.now()-new Date(u).getTime();return isNaN(h)?!1:h<1e3*60*60*24}e.isNewAppInstall=f,e.IExtHostTelemetry=(0,a.createDecorator)("IExtHostTelemetry")}),define(ye[26],De([1,0,3,2,4,27,213]),function(re,e,a,L,l,R,S){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new R.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:L.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,l.createDecorator)("extensionService");class y{constructor(m){this.affinity=m,this.kind=1}equals(m){return this.kind===m.kind&&this.affinity===m.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=y;class I{constructor(m){this.affinity=m,this.kind=2}equals(m){return this.kind===m.kind&&this.affinity===m.affinity}asString(){return this.affinity===0?"LocalWebWorker":`LocalWebWorker${this.affinity}`}}e.LocalWebWorkerRunningLocation=I;class O{constructor(){this.kind=3,this.affinity=0}equals(m){return this.kind===m.kind}asString(){return"Remote"}}e.RemoteRunningLocation=O;class P{constructor(m){this.dependency=m}}e.MissingExtensionDependency=P;var v;(function(c){c[c.LocalProcess=1]="LocalProcess",c[c.LocalWebWorker=2]="LocalWebWorker",c[c.Remote=3]="Remote"})(v=e.ExtensionHostKind||(e.ExtensionHostKind={}));function k(c){if(c===null)return"None";switch(c){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=k;class D{constructor(){this.c=[],this.d=[]}toDelta(){return{toRemove:[],toAdd:this.c,myToRemove:[],myToAdd:this.d}}set(m,n){const t=[],d=[],E=[],w=[],N=h(this.c),j=h(m),V=(T,F)=>T.extensionLocation.toString()===F.extensionLocation.toString()||T.isBuiltin===F.isBuiltin||T.isUserBuiltin===F.isUserBuiltin||T.isUnderDevelopment===F.isUnderDevelopment;for(const T of this.c){const F=j.get(R.ExtensionIdentifier.toKey(T.identifier));if(!F){t.push(T.identifier),N.delete(R.ExtensionIdentifier.toKey(T.identifier));continue}if(!V(T,F)){t.push(T.identifier),N.delete(R.ExtensionIdentifier.toKey(T.identifier));continue}}for(const T of m){const F=N.get(R.ExtensionIdentifier.toKey(T.identifier));if(!F){d.push(T);continue}if(!V(F,T)){t.push(F.identifier),N.delete(R.ExtensionIdentifier.toKey(F.identifier));continue}}const Q=u(this.d),x=u(n);for(const T of this.d)x.has(R.ExtensionIdentifier.toKey(T))||E.push(T);for(const T of n)Q.has(R.ExtensionIdentifier.toKey(T))||w.push(T);const U={toRemove:t,toAdd:d,myToRemove:E,myToAdd:w};return this.delta(U),U}delta(m){const{toRemove:n,toAdd:t,myToRemove:d,myToAdd:E}=m,w=u(n),N=u(d);for(let j=0;j<this.c.length;j++)w.has(R.ExtensionIdentifier.toKey(this.c[j].identifier))&&(this.c.splice(j,1),j--);for(let j=0;j<this.d.length;j++)N.has(R.ExtensionIdentifier.toKey(this.d[j]))&&(this.d.splice(j,1),j--);for(const j of t)this.c.push(j);for(const j of E)this.d.push(j)}containsExtension(m){for(const n of this.d)if(R.ExtensionIdentifier.equals(n,m))return!0;return!1}}e.ExtensionHostExtensions=D;class f{constructor(m){if(this[A]="ExtensionIdentifierSet",this.c=new Map,this.d=R.ExtensionIdentifier.toKey,m)for(const n of m)this.add(n)}get size(){return this.c.size}add(m){return this.c.set(this.d(m),m),this}clear(){this.c.clear()}delete(m){return this.c.delete(this.d(m))}has(m){return this.c.has(this.d(m))}forEach(m,n){this.c.forEach(t=>m.call(n,t,t,this))}*entries(){for(const[m,n]of this.c)yield[n,n]}keys(){return this.c.values()}values(){return this.c.values()}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.c.values()}}e.ExtensionIdentifierSet=f;function u(c){const m=new Set;for(const n of c)m.add(R.ExtensionIdentifier.toKey(n));return m}e.extensionIdentifiersArrayToSet=u;function h(c){const m=new Map;for(const n of c)m.set(R.ExtensionIdentifier.toKey(n.identifier),n);return m}function p(c,m){return!0}e.isProposedApiEnabled=p;function b(c,m){if(!p(c,m))throw new Error(`Extension '${c.identifier.value}' CANNOT use API proposal: ${m}.
Its package.json#enabledApiProposals-property declares: ${c.enabledApiProposals?.join(", ")??"[]"} but NOT ${m}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${c.identifier.value}`)}e.checkProposedApiEnabled=b;class C{constructor(m,n,t,d){this.codeLoadingTime=m,this.activateCallTime=n,this.activateResolvedTime=t,this.activationReason=d}}e.ActivationTimes=C;class g{constructor(m,n){this.description=m,this.value=n}}e.ExtensionPointContribution=g,e.ExtensionHostLogFileName="exthost";var i;(function(c){c[c.Normal=0]="Normal",c[c.Immediate=1]="Immediate"})(i=e.ActivationKind||(e.ActivationKind={}));function s(c){return{type:c.isBuiltin?0:1,isBuiltin:c.isBuiltin||c.isUserBuiltin,identifier:{id:(0,S.getGalleryExtensionId)(c.publisher,c.name),uuid:c.uuid},manifest:c,location:c.extensionLocation,targetPlatform:c.targetPlatform,validations:[],isValid:!0}}e.toExtension=s;function r(c,m){return{identifier:new R.ExtensionIdentifier((0,S.getExtensionId)(c.manifest.publisher,c.manifest.name)),isBuiltin:c.type===0,isUserBuiltin:c.type===1&&c.isBuiltin,isUnderDevelopment:!!m,extensionLocation:c.location,...c.manifest,uuid:c.identifier.uuid,targetPlatform:c.targetPlatform,browserNlsBundleUris:c.browserNlsBundleUris}}e.toExtensionDescription=r;class o{constructor(){this.onDidRegisterExtensions=a.Event.None,this.onDidChangeExtensionsStatus=a.Event.None,this.onDidChangeExtensions=a.Event.None,this.onWillActivateByEvent=a.Event.None,this.onDidChangeResponsiveChange=a.Event.None,this.extensions=[]}activateByEvent(m){return Promise.resolve(void 0)}activationEventIsDone(m){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(m){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(m,n){return Promise.resolve(0)}getInspectPorts(m,n){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(m){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.NullExtensionService=o}),define(ye[238],De([1,0,11,134,27,26,13,17]),function(re,e,a,L,l,R,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class y{constructor(h,p,b,C){this.startup=h,this.codeLoadingTime=p,this.activateCallTime=b,this.activateResolvedTime=C}}y.NONE=new y(!1,-1,-1,-1),e.ExtensionActivationTimes=y;class I{constructor(h){this.a=h,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(h,p){return h===-1||p===-1?-1:p-h}build(){return new y(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.ExtensionActivationTimesBuilder=I;class O{constructor(h,p,b,C,g,i){this.activationFailed=h,this.activationFailedError=p,this.activationTimes=b,this.module=C,this.exports=g,this.subscriptions=i}}e.ActivatedExtension=O;class P extends O{constructor(h){super(!1,null,h,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=P;class v extends O{constructor(){super(!1,null,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=v;class k extends O{constructor(h){super(!0,h,y.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let D=class{constructor(h,p,b,C){this.g=C,this.a=h,this.b=p,this.c=b,this.d=new Map,this.f=Object.create(null)}dispose(){for(const[h,p]of this.d)p.dispose()}isActivated(h){const p=this.d.get(l.ExtensionIdentifier.toKey(h));return Boolean(p&&p.value)}getActivatedExtension(h){const p=this.d.get(l.ExtensionIdentifier.toKey(h));if(!p||!p.value)throw new Error(`Extension '${h.value}' is not known or not activated`);return p.value}async activateByEvent(h,p){if(this.f[h])return;const b=this.a.getExtensionDescriptionsForActivationEvent(h);await this.h(b.map(C=>({id:C.identifier,reason:{startup:p,extensionId:C.identifier,activationEvent:h}}))),this.f[h]=!0}activateById(h,p){const b=this.a.getExtensionDescription(h);if(!b)throw new Error(`Extension '${h}' is not known`);return this.h([{id:b.identifier,reason:p}])}async h(h){const p=h.filter(b=>!this.isActivated(b.id)).map(b=>this.j(b));await Promise.all(p.map(b=>b.wait()))}j(h){if(this.d.has(l.ExtensionIdentifier.toKey(h.id)))return this.d.get(l.ExtensionIdentifier.toKey(h.id));if(this.l(h.id))return this.k(h,null,[],null);const p=this.a.getExtensionDescription(h.id);if(!p){const g=new Error(`Cannot activate unknown extension '${h.id.value}'`),i=this.k(h,null,[],new k(g));return this.c.onExtensionActivationError(h.id,g,new R.MissingExtensionDependency(h.id.value)),i}const b=[],C=typeof p.extensionDependencies>"u"?[]:p.extensionDependencies;for(const g of C){if(this.m(g))continue;const i=this.d.get(l.ExtensionIdentifier.toKey(g));if(i){b.push(i);continue}if(this.l(g)){b.push(this.j({id:this.b.getExtensionDescription(g).identifier,reason:h.reason}));continue}const s=this.a.getExtensionDescription(g);if(s){if(!s.main&&!s.browser)continue;b.push(this.j({id:s.identifier,reason:h.reason}));continue}const r=p.displayName||p.identifier.value,o=new Error(`Cannot activate the '${r}' extension because it depends on unknown extension '${g}'`),c=this.k(h,p.displayName,[],new k(o));return this.c.onExtensionActivationError(p.identifier,o,new R.MissingExtensionDependency(g)),c}return this.k(h,p.displayName,b,null)}k(h,p,b,C){const g=new f(h.id,p,h.reason,b,C,this.c,this.g);return this.d.set(l.ExtensionIdentifier.toKey(h.id),g),g}l(h){return L.ExtensionDescriptionRegistry.isHostExtension(h,this.a,this.b)}m(h){const p=this.b.getExtensionDescription(h);return p?!p.main&&!p.browser:!1}};D=qe([ze(3,S.ILogService)],D),e.ExtensionsActivator=D;let f=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(h,p,b,C,g,i,s){this.c=h,this.d=p,this.f=b,this.g=C,this.h=g,this.j=i,this.k=s,this.a=new A.Barrier,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let h=0;h<this.g.length;h++){const p=this.g[h];if(p.value&&!p.value.activationFailed){this.g.splice(h,1),h--;continue}if(p.value&&p.value.activationFailed){const b=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${p.friendlyName}' failed to activate`);b.detail=p.value.activationFailedError,this.h=new k(b),this.j.onExtensionActivationError(this.c,b,null);return}}this.g.length>0&&await Promise.race(this.g.map(h=>h.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(h){const p=new Error;if(h&&h.name&&(p.name=h.name),h&&h.message?p.message=`Activating extension '${this.c.value}' failed: ${h.message}.`:p.message=`Activating extension '${this.c.value}' failed: ${h}.`,h&&h.stack&&(p.stack=h.stack),this.h=new k(p),this.b&&a.isCancellationError(h))return;this.j.onExtensionActivationError(this.c,p,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(h)}}};f=qe([ze(6,S.ILogService)],f)});var _e=this&&this.__classPrivateFieldSet||function(re,e,a,L,l){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!l:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?l.call(re,a):l?l.value=a:e.set(re,a),a},Ue=this&&this.__classPrivateFieldGet||function(re,e,a,L){if(a==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!L:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?L:a==="a"?L.call(re):L?L.value:e.get(re)};define(ye[7],De([1,0,15,11,109,28,88,8,10,2,30,44,128,93,26]),function(re,e,a,L,l,R,S,A,y,I,O,P,v,k,D){"use strict";var f,u,h,p,b,C,g,i,s,r,o,c,m,n,t,d,E,w,N,j,V,Q,x;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest2=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookKernelSourceAction=e.NotebookRendererScript=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.setBreakpointId=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.TreeItem=e.ViewBadge=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalQuickFixCommand=e.TerminalQuickFixOpener=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.SnippetTextEdit=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0;function U(q){return Object.assign(q,{apply:function(){const fe=arguments.length===1?[]:arguments[1];return Reflect.construct(q,fe,arguments[0].constructor)},call:function(){if(arguments.length===0)return Reflect.construct(q,[]);{const[fe,...Te]=arguments;return Reflect.construct(q,Te,fe.constructor)}}})}var T;(function(q){q[q.Top=0]="Top",q[q.Bottom=1]="Bottom"})(T=e.TerminalOutputAnchor||(e.TerminalOutputAnchor={}));var F;(function(q){q[q.Command=0]="Command",q[q.Opener=1]="Opener"})(F=e.TerminalQuickFixType||(e.TerminalQuickFixType={}));let B=C=class{static from(...W){let fe=W;return new C(function(){if(fe){for(const Te of fe)Te&&typeof Te.dispose=="function"&&Te.dispose();fe=void 0}})}constructor(W){f.set(this,void 0),_e(this,f,W,"f")}dispose(){typeof Ue(this,f,"f")=="function"&&(Ue(this,f,"f").call(this),_e(this,f,void 0,"f"))}};f=new WeakMap,B=C=qe([U],B),e.Disposable=B;let Z=g=class{static Min(...W){if(W.length===0)throw new TypeError;let fe=W[0];for(let Te=1;Te<W.length;Te++){const Ke=W[Te];Ke.isBefore(fe)&&(fe=Ke)}return fe}static Max(...W){if(W.length===0)throw new TypeError;let fe=W[0];for(let Te=1;Te<W.length;Te++){const Ke=W[Te];Ke.isAfter(fe)&&(fe=Ke)}return fe}static isPosition(W){if(!W)return!1;if(W instanceof g)return!0;const{line:fe,character:Te}=W;return typeof fe=="number"&&typeof Te=="number"}static of(W){if(W instanceof g)return W;if(this.isPosition(W))return new g(W.line,W.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(W,fe){if(W<0)throw(0,L.illegalArgument)("line must be non-negative");if(fe<0)throw(0,L.illegalArgument)("character must be non-negative");this.c=W,this.e=fe}isBefore(W){return this.c<W.c?!0:W.c<this.c?!1:this.e<W.e}isBeforeOrEqual(W){return this.c<W.c?!0:W.c<this.c?!1:this.e<=W.e}isAfter(W){return!this.isBeforeOrEqual(W)}isAfterOrEqual(W){return!this.isBefore(W)}isEqual(W){return this.c===W.c&&this.e===W.e}compareTo(W){return this.c<W.c?-1:this.c>W.line?1:this.e<W.e?-1:this.e>W.e?1:0}translate(W,fe=0){if(W===null||fe===null)throw(0,L.illegalArgument)();let Te;return typeof W>"u"?Te=0:typeof W=="number"?Te=W:(Te=typeof W.lineDelta=="number"?W.lineDelta:0,fe=typeof W.characterDelta=="number"?W.characterDelta:0),Te===0&&fe===0?this:new g(this.line+Te,this.character+fe)}with(W,fe=this.character){if(W===null||fe===null)throw(0,L.illegalArgument)();let Te;return typeof W>"u"?Te=this.line:typeof W=="number"?Te=W:(Te=typeof W.line=="number"?W.line:this.line,fe=typeof W.character=="number"?W.character:this.character),Te===this.line&&fe===this.character?this:new g(Te,fe)}toJSON(){return{line:this.line,character:this.character}}};Z=g=qe([U],Z),e.Position=Z;let _=i=class{static isRange(W){return W instanceof i?!0:W?Z.isPosition(W.start)&&Z.isPosition(W.end):!1}static of(W){if(W instanceof i)return W;if(this.isRange(W))return new i(W.start,W.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(W,fe,Te,Ke){let Je,ct;if(typeof W=="number"&&typeof fe=="number"&&typeof Te=="number"&&typeof Ke=="number"?(Je=new Z(W,fe),ct=new Z(Te,Ke)):Z.isPosition(W)&&Z.isPosition(fe)&&(Je=Z.of(W),ct=Z.of(fe)),!Je||!ct)throw new Error("Invalid arguments");Je.isBefore(ct)?(this.c=Je,this.e=ct):(this.c=ct,this.e=Je)}contains(W){return i.isRange(W)?this.contains(W.start)&&this.contains(W.end):Z.isPosition(W)?!(Z.of(W).isBefore(this.c)||this.e.isBefore(W)):!1}isEqual(W){return this.c.isEqual(W.c)&&this.e.isEqual(W.e)}intersection(W){const fe=Z.Max(W.start,this.c),Te=Z.Min(W.end,this.e);if(!fe.isAfter(Te))return new i(fe,Te)}union(W){if(this.contains(W))return this;if(W.contains(this))return W;const fe=Z.Min(W.start,this.c),Te=Z.Max(W.end,this.end);return new i(fe,Te)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(W,fe=this.end){if(W===null||fe===null)throw(0,L.illegalArgument)();let Te;return W?Z.isPosition(W)?Te=W:(Te=W.start||this.start,fe=W.end||this.end):Te=this.start,Te.isEqual(this.c)&&fe.isEqual(this.end)?this:new i(Te,fe)}toJSON(){return[this.start,this.end]}};_=i=qe([U],_),e.Range=_;let H=s=class extends _{static isSelection(W){return W instanceof s?!0:W?_.isRange(W)&&Z.isPosition(W.anchor)&&Z.isPosition(W.active)&&typeof W.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(W,fe,Te,Ke){let Je,ct;if(typeof W=="number"&&typeof fe=="number"&&typeof Te=="number"&&typeof Ke=="number"?(Je=new Z(W,fe),ct=new Z(Te,Ke)):Z.isPosition(W)&&Z.isPosition(fe)&&(Je=Z.of(W),ct=Z.of(fe)),!Je||!ct)throw new Error("Invalid arguments");super(Je,ct),this.f=Je,this.g=ct}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};H=s=qe([U],H),e.Selection=H;class Y{constructor(W,fe,Te){if(typeof W!="string"||W.length===0)throw(0,L.illegalArgument)("host");if(typeof fe!="number"||fe===0||Math.round(fe)!==fe)throw(0,L.illegalArgument)("port");if(typeof Te<"u"&&(typeof Te!="string"||Te.length===0||!/^[0-9A-Za-z_\-]+$/.test(Te)))throw(0,L.illegalArgument)("connectionToken");this.host=W,this.port=Math.round(fe),this.connectionToken=Te}}e.ResolvedAuthority=Y;class ie extends Error{static NotAvailable(W,fe){return new ie(W,v.RemoteAuthorityResolverErrorCode.NotAvailable,fe)}static TemporarilyNotAvailable(W){return new ie(W,v.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(W,fe=v.RemoteAuthorityResolverErrorCode.Unknown,Te){super(W),this._message=W,this._code=fe,this._detail=Te,Object.setPrototypeOf(this,ie.prototype)}}e.RemoteAuthorityResolverError=ie;var ge;(function(q){q[q.LF=1]="LF",q[q.CRLF=2]="CRLF"})(ge=e.EndOfLine||(e.EndOfLine={}));var X;(function(q){q[q.Replace=1]="Replace",q[q.Append=2]="Append",q[q.Prepend=3]="Prepend"})(X=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let J=r=class{static isTextEdit(W){return W instanceof r?!0:W?_.isRange(W)&&typeof W.newText=="string":!1}static replace(W,fe){return new r(W,fe)}static insert(W,fe){return r.replace(new _(W,W),fe)}static delete(W){return r.replace(W,"")}static setEndOfLine(W){const fe=new r(new _(new Z(0,0),new Z(0,0)),"");return fe.newEol=W,fe}get range(){return this.c}set range(W){if(W&&!_.isRange(W))throw(0,L.illegalArgument)("range");this.c=W}get newText(){return this.e||""}set newText(W){if(W&&typeof W!="string")throw(0,L.illegalArgument)("newText");this.e=W}get newEol(){return this.f}set newEol(W){if(W&&typeof W!="number")throw(0,L.illegalArgument)("newEol");this.f=W}constructor(W,fe){this.c=W,this.e=fe}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};J=r=qe([U],J),e.TextEdit=J;let ee=o=class{static isNotebookCellEdit(W){return W instanceof o?!0:W?Vt.isNotebookRange(W)&&Array.isArray(W.newCells):!1}static replaceCells(W,fe){return new o(W,fe)}static insertCells(W,fe){return new o(new Vt(W,W),fe)}static deleteCells(W){return new o(W,[])}static updateCellMetadata(W,fe){const Te=new o(new Vt(W,W),[]);return Te.newCellMetadata=fe,Te}static updateNotebookMetadata(W){const fe=new o(new Vt(0,0),[]);return fe.newNotebookMetadata=W,fe}constructor(W,fe){this.range=W,this.newCells=fe}};ee=o=qe([U],ee),e.NotebookEdit=ee;class me{static isSnippetTextEdit(W){return W instanceof me?!0:W?_.isRange(W.range)&&Re.isSnippetString(W.snippet):!1}static replace(W,fe){return new me(W,fe)}static insert(W,fe){return me.replace(new _(W,W),fe)}constructor(W,fe){this.range=W,this.snippet=fe}}e.SnippetTextEdit=me;var ve;(function(q){q[q.File=1]="File",q[q.Text=2]="Text",q[q.Cell=3]="Cell",q[q.CellReplace=5]="CellReplace",q[q.Snippet=6]="Snippet"})(ve=e.FileEditType||(e.FileEditType={}));let Ie=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(W,fe,Te,Ke){this.c.push({_type:1,from:W,to:fe,options:Te,metadata:Ke})}createFile(W,fe,Te){this.c.push({_type:1,from:void 0,to:W,options:fe,metadata:Te})}deleteFile(W,fe,Te){this.c.push({_type:1,from:W,to:void 0,options:fe,metadata:Te})}e(W,fe,Te){this.c.push({_type:3,metadata:Te,uri:W,edit:{editType:5,metadata:fe},notebookMetadata:fe})}f(W,fe,Te,Ke){const Je=fe.start,ct=fe.end;(Je!==ct||Te.length>0)&&this.c.push({_type:5,uri:W,index:Je,count:ct-Je,cells:Te,metadata:Ke})}g(W,fe,Te,Ke){this.c.push({_type:3,metadata:Ke,uri:W,edit:{editType:8,index:fe,metadata:Te}})}replace(W,fe,Te,Ke){this.c.push({_type:2,uri:W,edit:new J(fe,Te),metadata:Ke})}insert(W,fe,Te,Ke){this.replace(W,new _(fe,fe),Te,Ke)}delete(W,fe,Te){this.replace(W,fe,"",Te)}has(W){return this.c.some(fe=>fe._type===2&&fe.uri.toString()===W.toString())}set(W,fe){if(fe)for(const Te of fe){if(!Te)continue;let Ke,Je;Array.isArray(Te)?(Ke=Te[0],Je=Te[1]):Ke=Te,ee.isNotebookCellEdit(Ke)?Ke.newCellMetadata?this.g(W,Ke.range.start,Ke.newCellMetadata,Je):Ke.newNotebookMetadata?this.e(W,Ke.newNotebookMetadata,Je):this.f(W,Ke.range,Ke.newCells,Je):me.isSnippetTextEdit(Ke)?this.c.push({_type:6,uri:W,range:Ke.range,edit:Ke.snippet,metadata:Je}):this.c.push({_type:2,uri:W,edit:Ke,metadata:Je})}else{for(let Te=0;Te<this.c.length;Te++){const Ke=this.c[Te];switch(Ke._type){case 2:case 6:case 3:case 5:Ke.uri.toString()===W.toString()&&(this.c[Te]=void 0);break}}(0,a.coalesceInPlace)(this.c)}}get(W){const fe=[];for(const Te of this.c)Te._type===2&&Te.uri.toString()===W.toString()&&fe.push(Te.edit);return fe}entries(){const W=new R.ResourceMap;for(const fe of this.c)if(fe._type===2){let Te=W.get(fe.uri);Te||(Te=[fe.uri,[]],W.set(fe.uri,Te)),Te[1].push(fe.edit)}return[...W.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};Ie=qe([U],Ie),e.WorkspaceEdit=Ie;let Re=c=class{static isSnippetString(W){return W instanceof c?!0:W?typeof W.value=="string":!1}static c(W){return W.replace(/\$|}|\\/g,"\\$&")}constructor(W){this.e=1,this.value=W||""}appendText(W){return this.value+=c.c(W),this}appendTabstop(W=this.e++){return this.value+="$",this.value+=W,this}appendPlaceholder(W,fe=this.e++){if(typeof W=="function"){const Te=new c;Te.e=this.e,W(Te),this.e=Te.e,W=Te.value}else W=c.c(W);return this.value+="${",this.value+=fe,this.value+=":",this.value+=W,this.value+="}",this}appendChoice(W,fe=this.e++){const Te=W.map(Ke=>Ke.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=fe,this.value+="|",this.value+=Te,this.value+="|}",this}appendVariable(W,fe){if(typeof fe=="function"){const Te=new c;Te.e=this.e,fe(Te),this.e=Te.e,fe=Te.value}else typeof fe=="string"&&(fe=fe.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=W,fe&&(this.value+=":",this.value+=fe),this.value+="}",this}};Re=c=qe([U],Re),e.SnippetString=Re;var ae;(function(q){q[q.Unnecessary=1]="Unnecessary",q[q.Deprecated=2]="Deprecated"})(ae=e.DiagnosticTag||(e.DiagnosticTag={}));var le;(function(q){q[q.Hint=3]="Hint",q[q.Information=2]="Information",q[q.Warning=1]="Warning",q[q.Error=0]="Error"})(le=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let ue=m=class{static isLocation(W){return W instanceof m?!0:W?_.isRange(W.range)&&I.URI.isUri(W.uri):!1}constructor(W,fe){if(this.uri=W,fe)if(_.isRange(fe))this.range=_.of(fe);else if(Z.isPosition(fe))this.range=new _(fe,fe);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};ue=m=qe([U],ue),e.Location=ue;let ne=class{static is(W){return W?typeof W.message=="string"&&W.location&&_.isRange(W.location.range)&&I.URI.isUri(W.location.uri):!1}constructor(W,fe){this.location=W,this.message=fe}static isEqual(W,fe){return W===fe?!0:!W||!fe?!1:W.message===fe.message&&W.location.range.isEqual(fe.location.range)&&W.location.uri.toString()===fe.location.uri.toString()}};ne=qe([U],ne),e.DiagnosticRelatedInformation=ne;let ce=class{constructor(W,fe,Te=le.Error){if(!_.isRange(W))throw new TypeError("range must be set");if(!fe)throw new TypeError("message must be set");this.range=W,this.message=fe,this.severity=Te}toJSON(){return{severity:le[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(W,fe){return W===fe?!0:!W||!fe?!1:W.message===fe.message&&W.severity===fe.severity&&W.code===fe.code&&W.severity===fe.severity&&W.source===fe.source&&W.range.isEqual(fe.range)&&(0,a.equals)(W.tags,fe.tags)&&(0,a.equals)(W.relatedInformation,fe.relatedInformation,ne.isEqual)}};ce=qe([U],ce),e.Diagnostic=ce;let oe=class{constructor(W,fe){if(!W)throw new Error("Illegal argument, contents must be defined");Array.isArray(W)?this.contents=W:this.contents=[W],this.range=fe}};oe=qe([U],oe),e.Hover=oe;var M;(function(q){q[q.Text=0]="Text",q[q.Read=1]="Read",q[q.Write=2]="Write"})(M=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let z=class{constructor(W,fe=M.Text){this.range=W,this.kind=fe}toJSON(){return{range:this.range,kind:M[this.kind]}}};z=qe([U],z),e.DocumentHighlight=z;var G;(function(q){q[q.File=0]="File",q[q.Module=1]="Module",q[q.Namespace=2]="Namespace",q[q.Package=3]="Package",q[q.Class=4]="Class",q[q.Method=5]="Method",q[q.Property=6]="Property",q[q.Field=7]="Field",q[q.Constructor=8]="Constructor",q[q.Enum=9]="Enum",q[q.Interface=10]="Interface",q[q.Function=11]="Function",q[q.Variable=12]="Variable",q[q.Constant=13]="Constant",q[q.String=14]="String",q[q.Number=15]="Number",q[q.Boolean=16]="Boolean",q[q.Array=17]="Array",q[q.Object=18]="Object",q[q.Key=19]="Key",q[q.Null=20]="Null",q[q.EnumMember=21]="EnumMember",q[q.Struct=22]="Struct",q[q.Event=23]="Event",q[q.Operator=24]="Operator",q[q.TypeParameter=25]="TypeParameter"})(G=e.SymbolKind||(e.SymbolKind={}));var te;(function(q){q[q.Deprecated=1]="Deprecated"})(te=e.SymbolTag||(e.SymbolTag={}));let de=n=class{static validate(W){if(!W.name)throw new Error("name must not be falsy")}constructor(W,fe,Te,Ke,Je){this.name=W,this.kind=fe,this.containerName=Je,typeof Te=="string"&&(this.containerName=Te),Ke instanceof ue?this.location=Ke:Te instanceof _&&(this.location=new ue(Ke,Te)),n.validate(this)}toJSON(){return{name:this.name,kind:G[this.kind],location:this.location,containerName:this.containerName}}};de=n=qe([U],de),e.SymbolInformation=de;let we=t=class{static validate(W){if(!W.name)throw new Error("name must not be falsy");if(!W.range.contains(W.selectionRange))throw new Error("selectionRange must be contained in fullRange");W.children?.forEach(t.validate)}constructor(W,fe,Te,Ke,Je){this.name=W,this.detail=fe,this.kind=Te,this.range=Ke,this.selectionRange=Je,this.children=[],t.validate(this)}};we=t=qe([U],we),e.DocumentSymbol=we;var Pe;(function(q){q[q.Invoke=1]="Invoke",q[q.Automatic=2]="Automatic"})(Pe=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let be=class{constructor(W,fe){this.title=W,this.kind=fe}};be=qe([U],be),e.CodeAction=be;let Ce=d=class{constructor(W){this.value=W}append(W){return new d(this.value?this.value+d.c+W:W)}intersects(W){return this.contains(W)||W.contains(this)}contains(W){return this.value===W.value||W.value.startsWith(this.value+d.c)}};Ce.c=".",Ce=d=qe([U],Ce),e.CodeActionKind=Ce,Ce.Empty=new Ce(""),Ce.QuickFix=Ce.Empty.append("quickfix"),Ce.Refactor=Ce.Empty.append("refactor"),Ce.RefactorExtract=Ce.Refactor.append("extract"),Ce.RefactorInline=Ce.Refactor.append("inline"),Ce.RefactorMove=Ce.Refactor.append("move"),Ce.RefactorRewrite=Ce.Refactor.append("rewrite"),Ce.Source=Ce.Empty.append("source"),Ce.SourceOrganizeImports=Ce.Source.append("organizeImports"),Ce.SourceFixAll=Ce.Source.append("fixAll");let ke=class{constructor(W,fe){if(this.range=W,this.parent=fe,fe&&!fe.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};ke=qe([U],ke),e.SelectionRange=ke;class He{constructor(W,fe,Te,Ke,Je,ct){this.kind=W,this.name=fe,this.detail=Te,this.uri=Ke,this.range=Je,this.selectionRange=ct}}e.CallHierarchyItem=He;class Ge{constructor(W,fe){this.fromRanges=fe,this.from=W}}e.CallHierarchyIncomingCall=Ge;class nt{constructor(W,fe){this.fromRanges=fe,this.to=W}}e.CallHierarchyOutgoingCall=nt;var Qe;(function(q){q[q.Information=0]="Information",q[q.Warning=1]="Warning",q[q.Error=2]="Error"})(Qe=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let tt=class{constructor(W,fe){this.range=W,this.command=fe}get isResolved(){return!!this.command}};tt=qe([U],tt),e.CodeLens=tt;let rt=E=class{static isMarkdownString(W){return W instanceof E?!0:W&&W.appendCodeblock&&W.appendMarkdown&&W.appendText&&W.value!==void 0}constructor(W,fe=!1){u.set(this,void 0),_e(this,u,new l.MarkdownString(W,{supportThemeIcons:fe}),"f")}get value(){return Ue(this,u,"f").value}set value(W){Ue(this,u,"f").value=W}get isTrusted(){return Ue(this,u,"f").isTrusted}set isTrusted(W){Ue(this,u,"f").isTrusted=W}get supportThemeIcons(){return Ue(this,u,"f").supportThemeIcons}set supportThemeIcons(W){Ue(this,u,"f").supportThemeIcons=W}get supportHtml(){return Ue(this,u,"f").supportHtml}set supportHtml(W){Ue(this,u,"f").supportHtml=W}get baseUri(){return Ue(this,u,"f").baseUri}set baseUri(W){Ue(this,u,"f").baseUri=W}appendText(W){return Ue(this,u,"f").appendText(W),this}appendMarkdown(W){return Ue(this,u,"f").appendMarkdown(W),this}appendCodeblock(W,fe){return Ue(this,u,"f").appendCodeblock(fe??"",W),this}};u=new WeakMap,rt=E=qe([U],rt),e.MarkdownString=rt;let Be=class{constructor(W,fe){this.label=W,this.documentation=fe}};Be=qe([U],Be),e.ParameterInformation=Be;let it=class{constructor(W,fe){this.label=W,this.documentation=fe,this.parameters=[]}};it=qe([U],it),e.SignatureInformation=it;let $=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};$=qe([U],$),e.SignatureHelp=$;var K;(function(q){q[q.Invoke=1]="Invoke",q[q.TriggerCharacter=2]="TriggerCharacter",q[q.ContentChange=3]="ContentChange"})(K=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var he;(function(q){q[q.Type=1]="Type",q[q.Parameter=2]="Parameter"})(he=e.InlayHintKind||(e.InlayHintKind={}));let Le=class{constructor(W){this.value=W}};Le=qe([U],Le),e.InlayHintLabelPart=Le;let Ne=class{constructor(W,fe,Te){this.position=W,this.label=fe,this.kind=Te}};Ne=qe([U],Ne),e.InlayHint=Ne;var xe;(function(q){q[q.Invoke=0]="Invoke",q[q.TriggerCharacter=1]="TriggerCharacter",q[q.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(xe=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var je;(function(q){q[q.Text=0]="Text",q[q.Method=1]="Method",q[q.Function=2]="Function",q[q.Constructor=3]="Constructor",q[q.Field=4]="Field",q[q.Variable=5]="Variable",q[q.Class=6]="Class",q[q.Interface=7]="Interface",q[q.Module=8]="Module",q[q.Property=9]="Property",q[q.Unit=10]="Unit",q[q.Value=11]="Value",q[q.Enum=12]="Enum",q[q.Keyword=13]="Keyword",q[q.Snippet=14]="Snippet",q[q.Color=15]="Color",q[q.File=16]="File",q[q.Reference=17]="Reference",q[q.Folder=18]="Folder",q[q.EnumMember=19]="EnumMember",q[q.Constant=20]="Constant",q[q.Struct=21]="Struct",q[q.Event=22]="Event",q[q.Operator=23]="Operator",q[q.TypeParameter=24]="TypeParameter",q[q.User=25]="User",q[q.Issue=26]="Issue"})(je=e.CompletionItemKind||(e.CompletionItemKind={}));var Ze;(function(q){q[q.Deprecated=1]="Deprecated"})(Ze=e.CompletionItemTag||(e.CompletionItemTag={}));let st=class{constructor(W,fe){this.label=W,this.kind=fe}toJSON(){return{label:this.label,kind:this.kind&&je[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};st=qe([U],st),e.CompletionItem=st;let at=class{constructor(W=[],fe=!1){this.items=W,this.isIncomplete=fe}};at=qe([U],at),e.CompletionList=at;let mt=class{constructor(W,fe,Te){this.insertText=W,this.range=fe,this.command=Te}};mt=qe([U],mt),e.InlineSuggestion=mt;let gt=class{constructor(W){this.commands=void 0,this.items=W}};gt=qe([U],gt),e.InlineSuggestionList=gt;var Et;(function(q){q[q.Active=-1]="Active",q[q.Beside=-2]="Beside",q[q.One=1]="One",q[q.Two=2]="Two",q[q.Three=3]="Three",q[q.Four=4]="Four",q[q.Five=5]="Five",q[q.Six=6]="Six",q[q.Seven=7]="Seven",q[q.Eight=8]="Eight",q[q.Nine=9]="Nine"})(Et=e.ViewColumn||(e.ViewColumn={}));var lt;(function(q){q[q.Left=1]="Left",q[q.Right=2]="Right"})(lt=e.StatusBarAlignment||(e.StatusBarAlignment={}));var pt;(function(q){q[q.Off=0]="Off",q[q.On=1]="On",q[q.Relative=2]="Relative"})(pt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var qt;(function(q){q[q.Manual=1]="Manual",q[q.AfterDelay=2]="AfterDelay",q[q.FocusOut=3]="FocusOut"})(qt=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var jt;(function(q){q[q.Default=0]="Default",q[q.InCenter=1]="InCenter",q[q.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",q[q.AtTop=3]="AtTop"})(jt=e.TextEditorRevealType||(e.TextEditorRevealType={}));var kt;(function(q){q[q.Keyboard=1]="Keyboard",q[q.Mouse=2]="Mouse",q[q.Command=3]="Command"})(kt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var ft;(function(q){q[q.Undo=1]="Undo",q[q.Redo=2]="Redo"})(ft=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var Tt;(function(q){q[q.OpenOpen=0]="OpenOpen",q[q.ClosedClosed=1]="ClosedClosed",q[q.OpenClosed=2]="OpenClosed",q[q.ClosedOpen=3]="ClosedOpen"})(Tt=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(q){function W(fe){switch(fe){case"keyboard":return q.Keyboard;case"mouse":return q.Mouse;case"api":return q.Command}}q.fromValue=W}(kt=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Bt=class{constructor(W,fe){if(fe&&!I.URI.isUri(fe))throw(0,L.illegalArgument)("target");if(!_.isRange(W)||W.isEmpty)throw(0,L.illegalArgument)("range");this.range=W,this.target=fe}};Bt=qe([U],Bt),e.DocumentLink=Bt;let At=class{constructor(W,fe,Te,Ke){this.red=W,this.green=fe,this.blue=Te,this.alpha=Ke}};At=qe([U],At),e.Color=At;let Xe=class{constructor(W,fe){if(fe&&!(fe instanceof At))throw(0,L.illegalArgument)("color");if(!_.isRange(W)||W.isEmpty)throw(0,L.illegalArgument)("range");this.range=W,this.color=fe}};Xe=qe([U],Xe),e.ColorInformation=Xe;let Nt=class{constructor(W){if(!W||typeof W!="string")throw(0,L.illegalArgument)("label");this.label=W}};Nt=qe([U],Nt),e.ColorPresentation=Nt;var Gt;(function(q){q[q.RGB=0]="RGB",q[q.HEX=1]="HEX",q[q.HSL=2]="HSL"})(Gt=e.ColorFormat||(e.ColorFormat={}));var Ft;(function(q){q[q.Error=0]="Error",q[q.Warning=1]="Warning",q[q.Information=2]="Information"})(Ft=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var bt;(function(q){q[q.Unknown=0]="Unknown",q[q.Shutdown=1]="Shutdown",q[q.Process=2]="Process",q[q.User=3]="User",q[q.Extension=4]="Extension"})(bt=e.TerminalExitReason||(e.TerminalExitReason={}));class Ae{constructor(W,fe,Te){if(this.startIndex=W,this.length=fe,this.tooltip=Te,typeof W!="number"||W<0)throw(0,L.illegalArgument)("startIndex");if(typeof fe!="number"||fe<1)throw(0,L.illegalArgument)("length");if(Te!==void 0&&typeof Te!="string")throw(0,L.illegalArgument)("tooltip")}}e.TerminalLink=Ae;class Oe{constructor(W){this.uri=W}}e.TerminalQuickFixOpener=Oe;class Se{constructor(W){this.terminalCommand=W}}e.TerminalQuickFixCommand=Se;var se;(function(q){q[q.Panel=1]="Panel",q[q.Editor=2]="Editor"})(se=e.TerminalLocation||(e.TerminalLocation={}));class Fe{constructor(W){if(this.options=W,typeof W!="object")throw(0,L.illegalArgument)("options")}}e.TerminalProfile=Fe;var We;(function(q){q[q.Always=1]="Always",q[q.Silent=2]="Silent",q[q.Never=3]="Never"})(We=e.TaskRevealKind||(e.TaskRevealKind={}));var Ye;(function(q){q[q.Shared=1]="Shared",q[q.Dedicated=2]="Dedicated",q[q.New=3]="New"})(Ye=e.TaskPanelKind||(e.TaskPanelKind={}));let Ve=w=class{static from(W){switch(W){case"clean":return w.Clean;case"build":return w.Build;case"rebuild":return w.Rebuild;case"test":return w.Test;default:return}}constructor(W,fe){if(this.label=fe,typeof W!="string"||typeof fe!="string")throw(0,L.illegalArgument)("name");this.c=W}get id(){return this.c}};Ve.Clean=new w("clean","Clean"),Ve.Build=new w("build","Build"),Ve.Rebuild=new w("rebuild","Rebuild"),Ve.Test=new w("test","Test"),Ve=w=qe([U],Ve),e.TaskGroup=Ve;function et(q){let W="";for(let fe=0;fe<q.length;fe++)W+=q[fe].replace(/,/g,",,")+",";return W}let ut=class{constructor(W,fe,Te){if(typeof W!="string")throw(0,L.illegalArgument)("process");this.e=[],this.c=W,fe!==void 0&&(Array.isArray(fe)?(this.e=fe,this.f=Te):this.f=fe)}get process(){return this.c}set process(W){if(typeof W!="string")throw(0,L.illegalArgument)("process");this.c=W}get args(){return this.e}set args(W){Array.isArray(W)||(W=[]),this.e=W}get options(){return this.f}set options(W){this.f=W}computeId(){const W=[];if(W.push("process"),this.c!==void 0&&W.push(this.c),this.e&&this.e.length>0)for(const fe of this.e)W.push(fe);return et(W)}};ut=qe([U],ut),e.ProcessExecution=ut;let Pt=class{constructor(W,fe,Te){if(this.f=[],Array.isArray(fe)){if(!W)throw(0,L.illegalArgument)("command can't be undefined or null");if(typeof W!="string"&&typeof W.value!="string")throw(0,L.illegalArgument)("command");this.e=W,this.f=fe,this.g=Te}else{if(typeof W!="string")throw(0,L.illegalArgument)("commandLine");this.c=W,this.g=fe}}get commandLine(){return this.c}set commandLine(W){if(typeof W!="string")throw(0,L.illegalArgument)("commandLine");this.c=W}get command(){return this.e?this.e:""}set command(W){if(typeof W!="string"&&typeof W.value!="string")throw(0,L.illegalArgument)("command");this.e=W}get args(){return this.f}set args(W){this.f=W||[]}get options(){return this.g}set options(W){this.g=W}computeId(){const W=[];if(W.push("shell"),this.c!==void 0&&W.push(this.c),this.e!==void 0&&W.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const fe of this.f)W.push(typeof fe=="string"?fe:fe.value);return et(W)}};Pt=qe([U],Pt),e.ShellExecution=Pt;var St;(function(q){q[q.Escape=1]="Escape",q[q.Strong=2]="Strong",q[q.Weak=3]="Weak"})(St=e.ShellQuoting||(e.ShellQuoting={}));var Dt;(function(q){q[q.Global=1]="Global",q[q.Workspace=2]="Workspace"})(Dt=e.TaskScope||(e.TaskScope={}));class wt{constructor(W){this.c=W}computeId(){return"customExecution"+(0,O.generateUuid)()}set callback(W){this.c=W}get callback(){return this.c}}e.CustomExecution=wt;let Rt=N=class{constructor(W,fe,Te,Ke,Je,ct){this.j=!1,this.k=this.definition=W;let ht;typeof fe=="string"?(this.m=this.name=fe,this.t=this.source=Te,this.execution=Ke,ht=Je,this.j=!0):fe===Dt.Global||fe===Dt.Workspace?(this.target=fe,this.m=this.name=Te,this.t=this.source=Ke,this.execution=Je,ht=ct):(this.target=fe,this.m=this.name=Te,this.t=this.source=Ke,this.execution=Je,ht=ct),typeof ht=="string"?(this.o=[ht],this.q=!0):Array.isArray(ht)?(this.o=ht,this.q=!0):(this.o=[],this.q=!1),this.r=!1,this.v=Object.create(null),this.w=Object.create(null)}get _id(){return this.h}set _id(W){this.h=W}get _deprecated(){return this.j}y(){this.h!==void 0&&(this.h=void 0,this.l=void 0,this.z())}z(){this.n instanceof ut?this.k={type:N.e,id:this.n.computeId()}:this.n instanceof Pt?this.k={type:N.f,id:this.n.computeId()}:this.n instanceof wt?this.k={type:N.c,id:this.n.computeId()}:this.k={type:N.g,id:(0,O.generateUuid)()}}get definition(){return this.k}set definition(W){if(W==null)throw(0,L.illegalArgument)("Kind can't be undefined or null");this.y(),this.k=W}get scope(){return this.l}set target(W){this.y(),this.l=W}get name(){return this.m}set name(W){if(typeof W!="string")throw(0,L.illegalArgument)("name");this.y(),this.m=W}get execution(){return this.n}set execution(W){W===null&&(W=void 0),this.y(),this.n=W;const fe=this.k.type;(N.g===fe||N.e===fe||N.f===fe||N.c===fe)&&this.z()}get problemMatchers(){return this.o}set problemMatchers(W){if(Array.isArray(W))this.y(),this.o=W,this.q=!0;else{this.y(),this.o=[],this.q=!1;return}}get hasDefinedMatchers(){return this.q}get isBackground(){return this.r}set isBackground(W){W!==!0&&W!==!1&&(W=!1),this.y(),this.r=W}get source(){return this.t}set source(W){if(typeof W!="string"||W.length===0)throw(0,L.illegalArgument)("source must be a string of length > 0");this.y(),this.t=W}get group(){return this.u}set group(W){W===null&&(W=void 0),this.y(),this.u=W}get detail(){return this.x}set detail(W){W===null&&(W=void 0),this.x=W}get presentationOptions(){return this.v}set presentationOptions(W){W==null&&(W=Object.create(null)),this.y(),this.v=W}get runOptions(){return this.w}set runOptions(W){W==null&&(W=Object.create(null)),this.y(),this.w=W}};Rt.c="customExecution",Rt.e="process",Rt.f="shell",Rt.g="$empty",Rt=N=qe([U],Rt),e.Task=Rt;var yt;(function(q){q[q.SourceControl=1]="SourceControl",q[q.Window=10]="Window",q[q.Notification=15]="Notification"})(yt=e.ProgressLocation||(e.ProgressLocation={}));var ri;(function(q){function W(fe){const Te=fe;return(0,y.isNumber)(Te.value)?Te.tooltip&&!(0,y.isString)(Te.tooltip)?(console.log("INVALID view badge, invalid tooltip",Te.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Te.value),!1)}q.isViewBadge=W})(ri=e.ViewBadge||(e.ViewBadge={}));let ei=j=class{static isTreeItem(W,fe){const Te=W;if(Te.checkboxState!==void 0){(0,D.checkProposedApiEnabled)(fe,"treeItemCheckbox");const Ke=(0,y.isNumber)(Te.checkboxState)?Te.checkboxState:(0,y.isObject)(Te.checkboxState)&&(0,y.isNumber)(Te.checkboxState.state)?Te.checkboxState.state:void 0,Je=!(0,y.isNumber)(Te.checkboxState)&&(0,y.isObject)(Te.checkboxState)?Te.checkboxState.tooltip:void 0;if(Ke===void 0||Ke!==si.Checked&&Ke!==si.Unchecked||Je!==void 0&&!(0,y.isString)(Je))return console.log("INVALID tree item, invalid checkboxState",Te.checkboxState),!1}if(W instanceof j)return!0;if(Te.label!==void 0&&!(0,y.isString)(Te.label)&&!Te.label?.label)return console.log("INVALID tree item, invalid label",Te.label),!1;if(Te.id!==void 0&&!(0,y.isString)(Te.id))return console.log("INVALID tree item, invalid id",Te.id),!1;if(Te.iconPath!==void 0&&!(0,y.isString)(Te.iconPath)&&!I.URI.isUri(Te.iconPath)&&(!Te.iconPath||!(0,y.isString)(Te.iconPath.id))){const Ke=Te.iconPath;if(!Ke||!(0,y.isString)(Ke.light)&&!I.URI.isUri(Ke.light)&&!(0,y.isString)(Ke.dark)&&!I.URI.isUri(Ke.dark))return console.log("INVALID tree item, invalid iconPath",Te.iconPath),!1}return Te.description!==void 0&&!(0,y.isString)(Te.description)&&typeof Te.description!="boolean"?(console.log("INVALID tree item, invalid description",Te.description),!1):Te.resourceUri!==void 0&&!I.URI.isUri(Te.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Te.resourceUri),!1):Te.tooltip!==void 0&&!(0,y.isString)(Te.tooltip)&&!(Te.tooltip instanceof rt)?(console.log("INVALID tree item, invalid tooltip",Te.tooltip),!1):Te.command!==void 0&&!Te.command.command?(console.log("INVALID tree item, invalid command",Te.command),!1):Te.collapsibleState!==void 0&&Te.collapsibleState<Ct.None&&Te.collapsibleState>Ct.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Te.collapsibleState),!1):Te.contextValue!==void 0&&!(0,y.isString)(Te.contextValue)?(console.log("INVALID tree item, invalid contextValue",Te.contextValue),!1):Te.accessibilityInformation!==void 0&&!Te.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Te.accessibilityInformation),!1):!0}constructor(W,fe=Ct.None){this.collapsibleState=fe,I.URI.isUri(W)?this.resourceUri=W:this.label=W}};ei=j=qe([U],ei),e.TreeItem=ei;var Ct;(function(q){q[q.None=0]="None",q[q.Collapsed=1]="Collapsed",q[q.Expanded=2]="Expanded"})(Ct=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));var si;(function(q){q[q.Unchecked=0]="Unchecked",q[q.Checked=1]="Checked"})(si=e.TreeItemCheckboxState||(e.TreeItemCheckboxState={}));let oi=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(W,fe){this.value=W,this.id=fe??(0,O.generateUuid)()}};oi=qe([U],oi),e.DataTransferItem=oi;let Jt=class{constructor(W){h.set(this,new Map);for(const[fe,Te]of W??[]){const Ke=Ue(this,h,"f").get(fe);Ke?Ke.push(Te):Ue(this,h,"f").set(fe,[Te])}}get(W){return Ue(this,h,"f").get(W)?.[0]}set(W,fe){Ue(this,h,"f").set(W,[fe])}forEach(W,fe){for(const[Te,Ke]of Ue(this,h,"f"))for(const Je of Ke)W.call(fe,Je,Te,this)}*[(h=new WeakMap,Symbol.iterator)](){for(const[W,fe]of Ue(this,h,"f"))for(const Te of fe)yield[W,Te]}};Jt=qe([U],Jt),e.DataTransfer=Jt;let bi=class{constructor(W){this.insertText=W}};bi=qe([U],bi),e.DocumentDropEdit=bi;let Lt=class{constructor(W){this.insertText=W}};Lt=qe([U],Lt),e.DocumentPasteEdit=Lt;let zt=class{constructor(W,fe){this.id=W,this.color=fe}static isThemeIcon(W){return typeof W.id!="string"?(console.log("INVALID ThemeIcon, invalid id",W.id),!1):!0}};zt=qe([U],zt),e.ThemeIcon=zt,zt.File=new zt("file"),zt.Folder=new zt("folder");let vi=class{constructor(W){this.id=W}};vi=qe([U],vi),e.ThemeColor=vi;var ai;(function(q){q[q.Global=1]="Global",q[q.Workspace=2]="Workspace",q[q.WorkspaceFolder=3]="WorkspaceFolder"})(ai=e.ConfigurationTarget||(e.ConfigurationTarget={}));let _t=class{get base(){return this.c}set base(W){this.c=W,this.e=I.URI.file(W)}get baseUri(){return this.e}set baseUri(W){this.e=W,this.c=W.fsPath}constructor(W,fe){if(typeof W!="string"&&(!W||!I.URI.isUri(W)&&!I.URI.isUri(W.uri)))throw(0,L.illegalArgument)("base");if(typeof fe!="string")throw(0,L.illegalArgument)("pattern");typeof W=="string"?this.baseUri=I.URI.file(W):I.URI.isUri(W)?this.baseUri=W:this.baseUri=W.uri,this.pattern=fe}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};_t=qe([U],_t),e.RelativePattern=_t;const dt=new WeakMap;function Bi(q,W){dt.set(q,W)}e.setBreakpointId=Bi;let Ut=class{constructor(W,fe,Te,Ke){this.enabled=typeof W=="boolean"?W:!0,typeof fe=="string"&&(this.condition=fe),typeof Te=="string"&&(this.hitCondition=Te),typeof Ke=="string"&&(this.logMessage=Ke)}get id(){return this.c||(this.c=dt.get(this)??(0,O.generateUuid)()),this.c}};Ut=qe([U],Ut),e.Breakpoint=Ut;let Xt=class extends Ut{constructor(W,fe,Te,Ke,Je){if(super(fe,Te,Ke,Je),W===null)throw(0,L.illegalArgument)("location");this.location=W}};Xt=qe([U],Xt),e.SourceBreakpoint=Xt;let ci=class extends Ut{constructor(W,fe,Te,Ke,Je){super(fe,Te,Ke,Je),this.functionName=W}};ci=qe([U],ci),e.FunctionBreakpoint=ci;let wi=class extends Ut{constructor(W,fe,Te,Ke,Je,ct,ht){if(super(Ke,Je,ct,ht),!fe)throw(0,L.illegalArgument)("dataId");this.label=W,this.dataId=fe,this.canPersist=Te}};wi=qe([U],wi),e.DataBreakpoint=wi;let Ei=class{constructor(W,fe,Te){this.command=W,this.args=fe||[],this.options=Te}};Ei=qe([U],Ei),e.DebugAdapterExecutable=Ei;let li=class{constructor(W,fe){this.port=W,this.host=fe}};li=qe([U],li),e.DebugAdapterServer=li;let Si=class{constructor(W){this.path=W}};Si=qe([U],Si),e.DebugAdapterNamedPipeServer=Si;let ui=class{constructor(W){this.implementation=W}};ui=qe([U],ui),e.DebugAdapterInlineImplementation=ui;let Zt=class{constructor(W,fe){this.range=W,this.expression=fe}};Zt=qe([U],Zt),e.EvaluatableExpression=Zt;var $i;(function(q){q[q.Invoke=0]="Invoke",q[q.Automatic=1]="Automatic"})($i=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let ti=class{constructor(W,fe){this.range=W,this.text=fe}};ti=qe([U],ti),e.InlineValueText=ti;let ii=class{constructor(W,fe,Te=!0){this.range=W,this.variableName=fe,this.caseSensitiveLookup=Te}};ii=qe([U],ii),e.InlineValueVariableLookup=ii;let yi=class{constructor(W,fe){this.range=W,this.expression=fe}};yi=qe([U],yi),e.InlineValueEvaluatableExpression=yi;let Di=class{constructor(W,fe){this.frameId=W,this.stoppedLocation=fe}};Di=qe([U],Di),e.InlineValueContext=Di;var ni;(function(q){q[q.Changed=1]="Changed",q[q.Created=2]="Created",q[q.Deleted=3]="Deleted"})(ni=e.FileChangeType||(e.FileChangeType={}));let Ci=V=class extends Error{static FileExists(W){return new V(W,P.FileSystemProviderErrorCode.FileExists,V.FileExists)}static FileNotFound(W){return new V(W,P.FileSystemProviderErrorCode.FileNotFound,V.FileNotFound)}static FileNotADirectory(W){return new V(W,P.FileSystemProviderErrorCode.FileNotADirectory,V.FileNotADirectory)}static FileIsADirectory(W){return new V(W,P.FileSystemProviderErrorCode.FileIsADirectory,V.FileIsADirectory)}static NoPermissions(W){return new V(W,P.FileSystemProviderErrorCode.NoPermissions,V.NoPermissions)}static Unavailable(W){return new V(W,P.FileSystemProviderErrorCode.Unavailable,V.Unavailable)}constructor(W,fe=P.FileSystemProviderErrorCode.Unknown,Te){super(I.URI.isUri(W)?W.toString(!0):W),this.code=Te?.name??"Unknown",(0,P.markAsFileSystemProviderError)(this,fe),Object.setPrototypeOf(this,V.prototype),typeof Error.captureStackTrace=="function"&&typeof Te=="function"&&Error.captureStackTrace(this,Te)}};Ci=V=qe([U],Ci),e.FileSystemError=Ci;let Ii=class{constructor(W,fe,Te){this.start=W,this.end=fe,this.kind=Te}};Ii=qe([U],Ii),e.FoldingRange=Ii;var zi;(function(q){q[q.Comment=1]="Comment",q[q.Imports=2]="Imports",q[q.Region=3]="Region"})(zi=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Wi;(function(q){q[q.Collapsed=0]="Collapsed",q[q.Expanded=1]="Expanded"})(Wi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Hi;(function(q){q[q.Editing=0]="Editing",q[q.Preview=1]="Preview"})(Hi=e.CommentMode||(e.CommentMode={}));var ki;(function(q){q[q.Unresolved=0]="Unresolved",q[q.Resolved=1]="Resolved"})(ki=e.CommentThreadState||(e.CommentThreadState={}));class Ri{constructor(W,fe=[]){this.tokenTypes=W,this.tokenModifiers=fe}}e.SemanticTokensLegend=Ri;function Li(q){return typeof q>"u"||(0,y.isStringArray)(q)}class $e{constructor(W){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.h=0,this.j=new Map,this.k=new Map,this.l=!1,W){this.l=!0;for(let fe=0,Te=W.tokenTypes.length;fe<Te;fe++)this.j.set(W.tokenTypes[fe],fe);for(let fe=0,Te=W.tokenModifiers.length;fe<Te;fe++)this.k.set(W.tokenModifiers[fe],fe)}}push(W,fe,Te,Ke,Je){if(typeof W=="number"&&typeof fe=="number"&&typeof Te=="number"&&typeof Ke=="number"&&(typeof Je=="number"||typeof Je>"u"))return typeof Je>"u"&&(Je=0),this.n(W,fe,Te,Ke,Je);if(_.isRange(W)&&typeof fe=="string"&&Li(Te))return this.m(W,fe,Te);throw(0,L.illegalArgument)()}m(W,fe,Te){if(!this.l)throw new Error("Legend must be provided in constructor");if(W.start.line!==W.end.line)throw new Error("`range` cannot span multiple lines");if(!this.j.has(fe))throw new Error("`tokenType` is not in the provided legend");const Ke=W.start.line,Je=W.start.character,ct=W.end.character-W.start.character,ht=this.j.get(fe);let Mt=0;if(Te)for(const Ht of Te){if(!this.k.has(Ht))throw new Error("`tokenModifier` is not in the provided legend");const xt=this.k.get(Ht);Mt|=1<<xt>>>0}this.n(Ke,Je,ct,ht,Mt)}n(W,fe,Te,Ke,Je){if(this.f&&(W<this.c||W===this.c&&fe<this.e)){this.f=!1;const Mt=this.g.length/5|0;let Ht=0,xt=0;for(let Kt=0;Kt<Mt;Kt++){let Qt=this.g[5*Kt],Pi=this.g[5*Kt+1];Qt===0?(Qt=Ht,Pi+=xt):Qt+=Ht,this.g[5*Kt]=Qt,this.g[5*Kt+1]=Pi,Ht=Qt,xt=Pi}}let ct=W,ht=fe;this.f&&this.h>0&&(ct-=this.c,ct===0&&(ht-=this.e)),this.g[this.h++]=ct,this.g[this.h++]=ht,this.g[this.h++]=Te,this.g[this.h++]=Ke,this.g[this.h++]=Je,this.c=W,this.e=fe}static o(W){const fe=[],Te=W.length/5|0;for(let ht=0;ht<Te;ht++)fe[ht]=ht;fe.sort((ht,Mt)=>{const Ht=W[5*ht],xt=W[5*Mt];if(Ht===xt){const Kt=W[5*ht+1],Qt=W[5*Mt+1];return Kt-Qt}return Ht-xt});const Ke=new Uint32Array(W.length);let Je=0,ct=0;for(let ht=0;ht<Te;ht++){const Mt=5*fe[ht],Ht=W[Mt+0],xt=W[Mt+1],Kt=W[Mt+2],Qt=W[Mt+3],Pi=W[Mt+4],sn=Ht-Je,Rn=sn===0?xt-ct:xt,Ai=5*ht;Ke[Ai+0]=sn,Ke[Ai+1]=Rn,Ke[Ai+2]=Kt,Ke[Ai+3]=Qt,Ke[Ai+4]=Pi,Je=Ht,ct=xt}return Ke}build(W){return this.f?new Wt(new Uint32Array(this.g),W):new Wt($e.o(this.g),W)}}e.SemanticTokensBuilder=$e;class Wt{constructor(W,fe){this.resultId=fe,this.data=W}}e.SemanticTokens=Wt;class Oi{constructor(W,fe,Te){this.start=W,this.deleteCount=fe,this.data=Te}}e.SemanticTokensEdit=Oi;class vt{constructor(W,fe){this.resultId=fe,this.edits=W}}e.SemanticTokensEdits=vt;var ji;(function(q){q[q.Separate=0]="Separate",q[q.MergeWithParent=1]="MergeWithParent"})(ji=e.DebugConsoleMode||(e.DebugConsoleMode={}));let di=class{constructor(){}};di.Back={iconPath:new zt("arrow-left")},di=qe([U],di),e.QuickInputButtons=di;var Ni;(function(q){q[q.Separator=-1]="Separator",q[q.Default=0]="Default"})(Ni=e.QuickPickItemKind||(e.QuickPickItemKind={}));var Vi;(function(q){q[q.Info=1]="Info",q[q.Warning=2]="Warning",q[q.Error=3]="Error"})(Vi=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var hi;(function(q){q[q.UI=1]="UI",q[q.Workspace=2]="Workspace"})(hi=e.ExtensionKind||(e.ExtensionKind={}));class xi{static validate(W){if(typeof W.badge=="string"){let fe=(0,A.nextCharLength)(W.badge,0);if(fe<W.badge.length&&(fe+=(0,A.nextCharLength)(W.badge,fe)),W.badge.length>fe)throw new Error("The 'badge'-property must be undefined or a short character")}else if(W.badge&&!zt.isThemeIcon(W.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!W.color&&!W.badge&&!W.tooltip)throw new Error("The decoration is empty");return!0}constructor(W,fe,Te){this.badge=W,this.tooltip=fe,this.color=Te}}e.FileDecoration=xi;let Ti=class{constructor(W){this.kind=W}};Ti=qe([U],Ti),e.ColorTheme=Ti;var qi;(function(q){q[q.Light=1]="Light",q[q.Dark=2]="Dark",q[q.HighContrast=3]="HighContrast",q[q.HighContrastLight=4]="HighContrastLight"})(qi=e.ColorThemeKind||(e.ColorThemeKind={}));class Vt{static isNotebookRange(W){return W instanceof Vt?!0:W?typeof W.start=="number"&&typeof W.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(W,fe){if(W<0)throw(0,L.illegalArgument)("start must be positive");if(fe<0)throw(0,L.illegalArgument)("end must be positive");W<=fe?(this.c=W,this.e=fe):(this.c=fe,this.e=W)}with(W){let fe=this.c,Te=this.e;return W.start!==void 0&&(fe=W.start),W.end!==void 0&&(Te=W.end),fe===this.c&&Te===this.e?this:new Vt(fe,Te)}}e.NotebookRange=Vt;class fi{static validate(W){if(typeof W.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof W.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof W.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(W){return Array.isArray(W)&&W.every(fe=>fi.isNotebookCellData(fe))}static isNotebookCellData(W){return!0}constructor(W,fe,Te,Ke,Je,ct,ht){this.kind=W,this.value=fe,this.languageId=Te,this.mime=Ke,this.outputs=Je??[],this.metadata=ct,this.executionSummary=ht,fi.validate(this)}}e.NotebookCellData=fi;class Gi{constructor(W){this.cells=W}}e.NotebookData=Gi;class $t{static isNotebookCellOutputItem(W){return W instanceof $t?!0:W?typeof W.mime=="string"&&W.data instanceof Uint8Array:!1}static error(W){const fe={name:W.name,message:W.message,stack:W.stack};return $t.json(fe,"application/vnd.code.notebook.error")}static stdout(W){return $t.text(W,"application/vnd.code.notebook.stdout")}static stderr(W){return $t.text(W,"application/vnd.code.notebook.stderr")}static bytes(W,fe="application/octet-stream"){return new $t(W,fe)}static text(W,fe=S.Mimes.text){const Te=Ue($t,p,"f",b).encode(String(W));return new $t(Te,fe)}static json(W,fe="text/x-json"){const Te=JSON.stringify(W,void 0,"	");return $t.text(Te,fe)}constructor(W,fe){this.data=W,this.mime=fe;const Te=(0,S.normalizeMimeType)(fe,!0);if(!Te)throw new Error(`INVALID mime type: ${fe}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Te}}p=$t,b={value:new TextEncoder},e.NotebookCellOutputItem=$t;class mi{static isNotebookCellOutput(W){return W instanceof mi?!0:!W||typeof W!="object"?!1:typeof W.id=="string"&&Array.isArray(W.items)}static ensureUniqueMimeTypes(W,fe=!1){const Te=new Set,Ke=new Set;for(let Je=0;Je<W.length;Je++){const ct=W[Je],ht=(0,S.normalizeMimeType)(ct.mime);if(!Te.has(ht)||(0,k.isTextStreamMime)(ht)){Te.add(ht);continue}Ke.add(Je),fe&&console.warn(`DUPLICATED mime type '${ct.mime}' will be dropped`)}return Ke.size===0?W:W.filter((Je,ct)=>!Ke.has(ct))}constructor(W,fe,Te){this.items=mi.ensureUniqueMimeTypes(W,!0),typeof fe=="string"?(this.id=fe,this.metadata=Te):(this.id=(0,O.generateUuid)(),this.metadata=fe??Te)}}e.NotebookCellOutput=mi;var Ki;(function(q){q[q.Markup=1]="Markup",q[q.Code=2]="Code"})(Ki=e.NotebookCellKind||(e.NotebookCellKind={}));var Xi;(function(q){q[q.Idle=1]="Idle",q[q.Pending=2]="Pending",q[q.Executing=3]="Executing"})(Xi=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var pe;(function(q){q[q.Left=1]="Left",q[q.Right=2]="Right"})(pe=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Ee;(function(q){q[q.Default=0]="Default",q[q.InCenter=1]="InCenter",q[q.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",q[q.AtTop=3]="AtTop"})(Ee=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Me{constructor(W,fe){this.text=W,this.alignment=fe}}e.NotebookCellStatusBarItem=Me;var ot;(function(q){q[q.Default=1]="Default",q[q.Preferred=2]="Preferred"})(ot=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));var It;(function(q){q[q.Default=1]="Default",q[q.Preferred=2]="Preferred",q[q.Hidden=-1]="Hidden"})(It=e.NotebookControllerAffinity2||(e.NotebookControllerAffinity2={}));class Ot{constructor(W,fe=[]){this.uri=W,this.provides=(0,a.asArray)(fe)}}e.NotebookRendererScript=Ot;class ln{constructor(W){this.label=W}}e.NotebookKernelSourceAction=ln;let Qi=class{constructor(W,fe){this.label=W,this.timestamp=fe}};Qi=qe([U],Qi),e.TimelineItem=Qi;var un;(function(q){q[q.Production=1]="Production",q[q.Development=2]="Development",q[q.Test=3]="Test"})(un=e.ExtensionMode||(e.ExtensionMode={}));var dn;(function(q){q[q.Node=1]="Node",q[q.Webworker=2]="Webworker"})(dn=e.ExtensionRuntime||(e.ExtensionRuntime={}));var hn;(function(q){q[q.Other=0]="Other",q[q.Comment=1]="Comment",q[q.String=2]="String",q[q.RegEx=3]="RegEx"})(hn=e.StandardTokenType||(e.StandardTokenType={}));class fn{constructor(W,fe){this.ranges=W,this.wordPattern=fe}}e.LinkedEditingRanges=fn;class mn{constructor(W,fe){this.c=W,this.e=fe}get port(){return this.c}get autoForwardAction(){return this.e}}e.PortAttributes=mn;var gn;(function(q){q[q.Queued=1]="Queued",q[q.Running=2]="Running",q[q.Passed=3]="Passed",q[q.Failed=4]="Failed",q[q.Skipped=5]="Skipped",q[q.Errored=6]="Errored"})(gn=e.TestResultState||(e.TestResultState={}));var pn;(function(q){q[q.Run=1]="Run",q[q.Debug=2]="Debug",q[q.Coverage=3]="Coverage"})(pn=e.TestRunProfileKind||(e.TestRunProfileKind={}));let Fi=class{constructor(W=void 0,fe=void 0,Te=void 0){this.include=W,this.exclude=fe,this.profile=Te}};Fi=qe([U],Fi),e.TestRunRequest=Fi;let Yi=class extends Fi{constructor(W=void 0,fe=void 0,Te=void 0,Ke=!1){super(W,fe,Te),this.continuous=Ke}};Yi=qe([U],Yi),e.TestRunRequest2=Yi;let Ji=Q=class{static diff(W,fe,Te){const Ke=new Q(W);return Ke.expectedOutput=fe,Ke.actualOutput=Te,Ke}constructor(W){this.message=W}};Ji=Q=qe([U],Ji),e.TestMessage=Ji;let _i=class{constructor(W){this.id=W}};_i=qe([U],_i),e.TestTag=_i;let gi=class{constructor(W,fe){this.covered=W,this.total=fe}};gi=qe([U],gi),e.CoveredCount=gi;let Zi=x=class{static fromDetails(W,fe){const Te=new gi(0,0),Ke=new gi(0,0),Je=new gi(0,0);for(const ht of fe)if("branches"in ht){Te.total+=1,Te.covered+=ht.executionCount>0?1:0;for(const Mt of ht.branches)Ke.total+=1,Ke.covered+=Mt.executionCount>0?1:0}else Je.total+=1,Je.covered+=ht.executionCount>0?1:0;const ct=new x(W,Te,Ke.total>0?Ke:void 0,Je.total>0?Je:void 0);return ct.detailedCoverage=fe,ct}constructor(W,fe,Te,Ke){this.uri=W,this.statementCoverage=fe,this.branchCoverage=Te,this.functionCoverage=Ke}};Zi=x=qe([U],Zi),e.FileCoverage=Zi;let en=class{constructor(W,fe,Te=[]){this.executionCount=W,this.location=fe,this.branches=Te}};en=qe([U],en),e.StatementCoverage=en;let tn=class{constructor(W,fe){this.executionCount=W,this.location=fe}};tn=qe([U],tn),e.BranchCoverage=tn;let nn=class{constructor(W,fe){this.executionCount=W,this.location=fe}};nn=qe([U],nn),e.FunctionCoverage=nn;var bn;(function(q){q[q.None=0]="None",q[q.Option=1]="Option",q[q.Default=2]="Default",q[q.Preferred=3]="Preferred"})(bn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var vn;(function(q){q[q.Untrusted=0]="Untrusted",q[q.Trusted=1]="Trusted",q[q.Unspecified=2]="Unspecified"})(vn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var wn;(function(q){q[q.Notify=1]="Notify",q[q.OpenBrowser=2]="OpenBrowser",q[q.OpenPreview=3]="OpenPreview",q[q.Silent=4]="Silent",q[q.Ignore=5]="Ignore",q[q.OpenBrowserOnce=6]="OpenBrowserOnce"})(wn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class En{constructor(W,fe,Te,Ke,Je,ct){this.kind=W,this.name=fe,this.detail=Te,this.uri=Ke,this.range=Je,this.selectionRange=ct}}e.TypeHierarchyItem=En;class Sn{constructor(W){this.uri=W}}e.TextTabInput=Sn;class yn{constructor(W,fe){this.original=W,this.modified=fe}}e.TextDiffTabInput=yn;class Dn{constructor(W,fe,Te,Ke){this.base=W,this.input1=fe,this.input2=Te,this.result=Ke}}e.TextMergeTabInput=Dn;class Cn{constructor(W,fe){this.uri=W,this.viewType=fe}}e.CustomEditorTabInput=Cn;class In{constructor(W){this.viewType=W}}e.WebviewEditorTabInput=In;class kn{constructor(W,fe){this.uri=W,this.notebookType=fe}}e.NotebookEditorTabInput=kn;class Tn{constructor(W,fe,Te){this.original=W,this.modified=fe,this.notebookType=Te}}e.NotebookDiffEditorTabInput=Tn;class Pn{constructor(){}}e.TerminalEditorTabInput=Pn;class An{constructor(W,fe){this.uri=W,this.inputBoxUri=fe}}e.InteractiveWindowInput=An}),define(ye[135],De([1,0,50,16,8,159,118,7,15]),function(re,e,a,L,l,R,S,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.setWordDefinitionFor=void 0;const I=new Map;function O(D,f){f?I.set(D,f):I.delete(D)}e.setWordDefinitionFor=O;function P(D){return I.get(D)}class v extends R.MirrorTextModel{constructor(f,u,h,p,b,C,g,i){super(u,h,p,b),this.m=f,this.p=C,this.q=g,this.notebook=i,this.b=!1}dispose(){(0,a.ok)(!this.b),this.b=!0,this.q=!1}equalLines(f){return(0,y.equals)(this.d,f)}get document(){if(!this.a){const f=this;this.a={get uri(){return f.c},get fileName(){return f.c.fsPath},get isUntitled(){return f.c.scheme===L.Schemas.untitled},get languageId(){return f.p},get version(){return f.g},get isClosed(){return f.b},get isDirty(){return f.q},save(){return f.r()},getText(u){return u?f.s(u):f.getText()},get eol(){return f.f===`
`?A.EndOfLine.LF:A.EndOfLine.CRLF},get lineCount(){return f.d.length},lineAt(u){return f.t(u)},offsetAt(u){return f.u(u)},positionAt(u){return f.v(u)},validateRange(u){return f.w(u)},validatePosition(u){return f.x(u)},getWordRangeAtPosition(u,h){return f.y(u,h)}}}return Object.freeze(this.a)}_acceptLanguageId(f){(0,a.ok)(!this.b),this.p=f}_acceptIsDirty(f){(0,a.ok)(!this.b),this.q=f}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.m.$trySaveDocument(this.c)}s(f){const u=this.w(f);if(u.isEmpty)return"";if(u.isSingleLine)return this.d[u.start.line].substring(u.start.character,u.end.character);const h=this.f,p=u.start.line,b=u.end.line,C=[];C.push(this.d[p].substring(u.start.character));for(let g=p+1;g<b;g++)C.push(this.d[g]);return C.push(this.d[b].substring(0,u.end.character)),C.join(h)}t(f){let u;if(f instanceof A.Position?u=f.line:typeof f=="number"&&(u=f),typeof u!="number"||u<0||u>=this.d.length||Math.floor(u)!==u)throw new Error("Illegal value for `line`");return new k(u,this.d[u],u===this.d.length-1)}u(f){return f=this.x(f),this.k(),this.h.getPrefixSum(f.line-1)+f.character}v(f){f=Math.floor(f),f=Math.max(0,f),this.k();const u=this.h.getIndexOf(f),h=this.d[u.index].length;return new A.Position(u.index,Math.min(u.remainder,h))}w(f){if(!(f instanceof A.Range))throw new Error("Invalid argument");const u=this.x(f.start),h=this.x(f.end);return u===f.start&&h===f.end?f:new A.Range(u.line,u.character,h.line,h.character)}x(f){if(!(f instanceof A.Position))throw new Error("Invalid argument");if(this.d.length===0)return f.with(0,0);let{line:u,character:h}=f,p=!1;if(u<0)u=0,h=0,p=!0;else if(u>=this.d.length)u=this.d.length-1,h=this.d[u].length,p=!0;else{const b=this.d[u].length;h<0?(h=0,p=!0):h>b&&(h=b,p=!0)}return p?new A.Position(u,h):f}y(f,u){const h=this.x(f);if(!u)u=P(this.p);else if((0,l.regExpLeadsToEndlessLoop)(u))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${u.source}' because it matches the empty string.`);const p=(0,S.getWordAtText)(h.character+1,(0,S.ensureValidWordDefinition)(u),this.d[h.line],0);if(p)return new A.Range(h.line,p.startColumn-1,h.line,p.endColumn-1)}}e.ExtHostDocumentData=v;class k{constructor(f,u,h){this.a=f,this.b=u,this.c=h}get lineNumber(){return this.a}get text(){return this.b}get range(){return new A.Range(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new A.Range(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.ExtHostDocumentLine=k}),define(ye[239],De([1,0,7,18,3]),function(re,e,a,L,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let R=class{constructor(A){this.a=new a.ColorTheme(a.ColorThemeKind.Dark),this.b=new l.Emitter}get activeColorTheme(){return this.a}$onColorThemeChange(A){let y;switch(A){case"light":y=a.ColorThemeKind.Light;break;case"hcDark":y=a.ColorThemeKind.HighContrast;break;case"hcLight":y=a.ColorThemeKind.HighContrastLight;break;default:y=a.ColorThemeKind.Dark}this.a=new a.ColorTheme(y),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};R=qe([ze(0,L.IExtHostRpcService)],R),e.ExtHostTheming=R}),define(ye[14],De([1,0,15,22,151,64,109,28,147,70,88,23,10,2,33,72,124,132,130,93,58,76,235,7]),function(re,e,a,L,l,R,S,A,y,I,O,P,v,k,D,f,u,h,p,b,C,g,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var r;(function(Ae){function Oe(se){const{selectionStartLineNumber:Fe,selectionStartColumn:We,positionLineNumber:Ye,positionColumn:Ve}=se,et=new s.Position(Fe-1,We-1),ut=new s.Position(Ye-1,Ve-1);return new s.Selection(et,ut)}Ae.to=Oe;function Se(se){const{anchor:Fe,active:We}=se;return{selectionStartLineNumber:Fe.line+1,selectionStartColumn:Fe.character+1,positionLineNumber:We.line+1,positionColumn:We.character+1}}Ae.from=Se})(r=e.Selection||(e.Selection={}));var o;(function(Ae){function Oe(se){if(!se)return;const{start:Fe,end:We}=se;return{startLineNumber:Fe.line+1,startColumn:Fe.character+1,endLineNumber:We.line+1,endColumn:We.character+1}}Ae.from=Oe;function Se(se){if(!se)return;const{startLineNumber:Fe,startColumn:We,endLineNumber:Ye,endColumn:Ve}=se;return new s.Range(Fe-1,We-1,Ye-1,Ve-1)}Ae.to=Se})(o=e.Range||(e.Range={}));var c;(function(Ae){function Oe(Se){switch(Se){case 1:return s.StandardTokenType.Comment;case 0:return s.StandardTokenType.Other;case 3:return s.StandardTokenType.RegEx;case 2:return s.StandardTokenType.String}}Ae.to=Oe})(c=e.TokenType||(e.TokenType={}));var m;(function(Ae){function Oe(se){return new s.Position(se.lineNumber-1,se.column-1)}Ae.to=Oe;function Se(se){return{lineNumber:se.line+1,column:se.character+1}}Ae.from=Se})(m=e.Position||(e.Position={}));var n;(function(Ae){function Oe(Fe,We){return(0,a.coalesce)((0,a.asArray)(Fe).map(Ye=>Se(Ye,We)))}Ae.from=Oe;function Se(Fe,We){if(typeof Fe=="string")return{$serialized:!0,language:Fe};if(Fe)return{$serialized:!0,language:Fe.language,scheme:se(Fe.scheme,We),pattern:he.from(Fe.pattern)??void 0,exclusive:Fe.exclusive,notebookType:Fe.notebookType}}function se(Fe,We){return We&&typeof Fe=="string"?We.transformOutgoingScheme(Fe):Fe}})(n=e.DocumentSelector||(e.DocumentSelector={}));var t;(function(Ae){function Oe(se){switch(se){case s.DiagnosticTag.Unnecessary:return 1;case s.DiagnosticTag.Deprecated:return 2}}Ae.from=Oe;function Se(se){switch(se){case 1:return s.DiagnosticTag.Unnecessary;case 2:return s.DiagnosticTag.Deprecated;default:return}}Ae.to=Se})(t=e.DiagnosticTag||(e.DiagnosticTag={}));var d;(function(Ae){function Oe(se){let Fe;return se.code&&((0,v.isString)(se.code)||(0,v.isNumber)(se.code)?Fe=String(se.code):Fe={value:String(se.code.value),target:se.code.target}),{...o.from(se.range),message:se.message,source:se.source,code:Fe,severity:w.from(se.severity),relatedInformation:se.relatedInformation&&se.relatedInformation.map(E.from),tags:Array.isArray(se.tags)?(0,a.coalesce)(se.tags.map(t.from)):void 0}}Ae.from=Oe;function Se(se){const Fe=new s.Diagnostic(o.to(se),se.message,w.to(se.severity));return Fe.source=se.source,Fe.code=(0,v.isString)(se.code)?se.code:se.code?.value,Fe.relatedInformation=se.relatedInformation&&se.relatedInformation.map(E.to),Fe.tags=se.tags&&(0,a.coalesce)(se.tags.map(t.to)),Fe}Ae.to=Se})(d=e.Diagnostic||(e.Diagnostic={}));var E;(function(Ae){function Oe(se){return{...o.from(se.location.range),message:se.message,resource:se.location.uri}}Ae.from=Oe;function Se(se){return new s.DiagnosticRelatedInformation(new s.Location(se.resource,o.to(se)),se.message)}Ae.to=Se})(E=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var w;(function(Ae){function Oe(se){switch(se){case s.DiagnosticSeverity.Error:return u.MarkerSeverity.Error;case s.DiagnosticSeverity.Warning:return u.MarkerSeverity.Warning;case s.DiagnosticSeverity.Information:return u.MarkerSeverity.Info;case s.DiagnosticSeverity.Hint:return u.MarkerSeverity.Hint}return u.MarkerSeverity.Error}Ae.from=Oe;function Se(se){switch(se){case u.MarkerSeverity.Info:return s.DiagnosticSeverity.Information;case u.MarkerSeverity.Warning:return s.DiagnosticSeverity.Warning;case u.MarkerSeverity.Error:return s.DiagnosticSeverity.Error;case u.MarkerSeverity.Hint:return s.DiagnosticSeverity.Hint;default:return s.DiagnosticSeverity.Error}}Ae.to=Se})(w=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var N;(function(Ae){function Oe(se){return typeof se=="number"&&se>=s.ViewColumn.One?se-1:se===s.ViewColumn.Beside?i.SIDE_GROUP:i.ACTIVE_GROUP}Ae.from=Oe;function Se(se){if(typeof se=="number"&&se>=0)return se+1;throw new Error("invalid 'EditorGroupColumn'")}Ae.to=Se})(N=e.ViewColumn||(e.ViewColumn={}));function j(Ae){return typeof Ae.range<"u"}function V(Ae){return Ae.length===0?!0:!!j(Ae[0])}e.isDecorationOptionsArr=V;var Q;(function(Ae){function Oe(Ve){return Ve.map(Ae.from)}Ae.fromMany=Oe;function Se(Ve){return Ve&&typeof Ve=="object"&&typeof Ve.language=="string"&&typeof Ve.value=="string"}function se(Ve){let et;if(Se(Ve)){const{language:Dt,value:wt}=Ve;et={value:"```"+Dt+`
`+wt+"\n```\n"}}else s.MarkdownString.isMarkdownString(Ve)?et={value:Ve.value,isTrusted:Ve.isTrusted,supportThemeIcons:Ve.supportThemeIcons,supportHtml:Ve.supportHtml,baseUri:Ve.baseUri}:typeof Ve=="string"?et={value:Ve}:et={value:""};const ut=Object.create(null);et.uris=ut;const Pt=Dt=>{try{let wt=k.URI.parse(Dt,!0);wt=wt.with({query:Fe(wt.query,ut)}),ut[Dt]=wt}catch{}return""},St=new y.marked.Renderer;return St.link=Pt,St.image=Dt=>typeof Dt=="string"?Pt(S.parseHrefAndDimensions(Dt).href):"",(0,y.marked)(et.value,{renderer:St}),et}Ae.from=se;function Fe(Ve,et){if(!Ve)return Ve;let ut;try{ut=(0,I.parse)(Ve)}catch{}if(!ut)return Ve;let Pt=!1;return ut=(0,P.cloneAndChange)(ut,St=>{if(k.URI.isUri(St)){const Dt=`__uri_${Math.random().toString(16).slice(2,8)}`;return et[Dt]=St,Pt=!0,Dt}else return}),Pt?JSON.stringify(ut):Ve}function We(Ve){const et=new s.MarkdownString(Ve.value,Ve.supportThemeIcons);return et.isTrusted=Ve.isTrusted,et.supportHtml=Ve.supportHtml,et.baseUri=Ve.baseUri?k.URI.from(Ve.baseUri):void 0,et}Ae.to=We;function Ye(Ve){if(!!Ve)return typeof Ve=="string"?Ve:Ae.from(Ve)}Ae.fromStrict=Ye})(Q=e.MarkdownString||(e.MarkdownString={}));function x(Ae){return V(Ae)?Ae.map(Oe=>({range:o.from(Oe.range),hoverMessage:Array.isArray(Oe.hoverMessage)?Q.fromMany(Oe.hoverMessage):Oe.hoverMessage?Q.from(Oe.hoverMessage):void 0,renderOptions:Oe.renderOptions})):Ae.map(Oe=>({range:o.from(Oe)}))}e.fromRangeOrRangeWithMessage=x;function U(Ae){return typeof Ae>"u"?Ae:typeof Ae=="string"?k.URI.file(Ae):Ae}e.pathOrURIToURI=U;var T;(function(Ae){function Oe(Se){return typeof Se>"u"?Se:{contentText:Se.contentText,contentIconPath:Se.contentIconPath?U(Se.contentIconPath):void 0,border:Se.border,borderColor:Se.borderColor,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,color:Se.color,backgroundColor:Se.backgroundColor,margin:Se.margin,width:Se.width,height:Se.height}}Ae.from=Oe})(T=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var F;(function(Ae){function Oe(Se){return typeof Se>"u"?Se:{backgroundColor:Se.backgroundColor,outline:Se.outline,outlineColor:Se.outlineColor,outlineStyle:Se.outlineStyle,outlineWidth:Se.outlineWidth,border:Se.border,borderColor:Se.borderColor,borderRadius:Se.borderRadius,borderSpacing:Se.borderSpacing,borderStyle:Se.borderStyle,borderWidth:Se.borderWidth,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,cursor:Se.cursor,color:Se.color,opacity:Se.opacity,letterSpacing:Se.letterSpacing,gutterIconPath:Se.gutterIconPath?U(Se.gutterIconPath):void 0,gutterIconSize:Se.gutterIconSize,overviewRulerColor:Se.overviewRulerColor,before:Se.before?T.from(Se.before):void 0,after:Se.after?T.from(Se.after):void 0}}Ae.from=Oe})(F=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var B;(function(Ae){function Oe(Se){if(typeof Se>"u")return Se;switch(Se){case s.DecorationRangeBehavior.OpenOpen:return 0;case s.DecorationRangeBehavior.ClosedClosed:return 1;case s.DecorationRangeBehavior.OpenClosed:return 2;case s.DecorationRangeBehavior.ClosedOpen:return 3}}Ae.from=Oe})(B=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var Z;(function(Ae){function Oe(Se){return{isWholeLine:Se.isWholeLine,rangeBehavior:Se.rangeBehavior?B.from(Se.rangeBehavior):void 0,overviewRulerLane:Se.overviewRulerLane,light:Se.light?F.from(Se.light):void 0,dark:Se.dark?F.from(Se.dark):void 0,backgroundColor:Se.backgroundColor,outline:Se.outline,outlineColor:Se.outlineColor,outlineStyle:Se.outlineStyle,outlineWidth:Se.outlineWidth,border:Se.border,borderColor:Se.borderColor,borderRadius:Se.borderRadius,borderSpacing:Se.borderSpacing,borderStyle:Se.borderStyle,borderWidth:Se.borderWidth,fontStyle:Se.fontStyle,fontWeight:Se.fontWeight,textDecoration:Se.textDecoration,cursor:Se.cursor,color:Se.color,opacity:Se.opacity,letterSpacing:Se.letterSpacing,gutterIconPath:Se.gutterIconPath?U(Se.gutterIconPath):void 0,gutterIconSize:Se.gutterIconSize,overviewRulerColor:Se.overviewRulerColor,before:Se.before?T.from(Se.before):void 0,after:Se.after?T.from(Se.after):void 0}}Ae.from=Oe})(Z=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var _;(function(Ae){function Oe(se){return{text:se.newText,eol:se.newEol&&rt.from(se.newEol),range:o.from(se.range)}}Ae.from=Oe;function Se(se){const Fe=new s.TextEdit(o.to(se.range),se.text);return Fe.newEol=typeof se.eol>"u"?void 0:rt.to(se.eol),Fe}Ae.to=Se})(_=e.TextEdit||(e.TextEdit={}));var H;(function(Ae){function Oe(se,Fe){const We={edits:[]};if(se instanceof s.WorkspaceEdit){const Ye=new A.ResourceSet;for(const Ve of se._allEntries())Ve._type===1&&k.URI.isUri(Ve.to)&&Ve.from===void 0&&Ye.add(Ve.to);for(const Ve of se._allEntries())Ve._type===1?We.edits.push({oldResource:Ve.from,newResource:Ve.to,options:{...Ve.options,contentsBase64:Ve.options?.contents&&(0,L.encodeBase64)(L.VSBuffer.wrap(Ve.options.contents))},metadata:Ve.metadata}):Ve._type===2?We.edits.push({resource:Ve.uri,textEdit:_.from(Ve.edit),versionId:Ye.has(Ve.uri)?void 0:Fe?.getTextDocumentVersion(Ve.uri),metadata:Ve.metadata}):Ve._type===6?We.edits.push({resource:Ve.uri,textEdit:{range:o.from(Ve.range),text:Ve.edit.value,insertAsSnippet:!0},versionId:Ye.has(Ve.uri)?void 0:Fe?.getTextDocumentVersion(Ve.uri),metadata:Ve.metadata}):Ve._type===3?We.edits.push({metadata:Ve.metadata,resource:Ve.uri,cellEdit:Ve.edit,notebookMetadata:Ve.notebookMetadata,notebookVersionId:Fe?.getNotebookDocumentVersion(Ve.uri)}):Ve._type===5&&We.edits.push({metadata:Ve.metadata,resource:Ve.uri,notebookVersionId:Fe?.getNotebookDocumentVersion(Ve.uri),cellEdit:{editType:1,index:Ve.index,count:Ve.count,cells:Ve.cells.map(at.from)}})}return We}Ae.from=Oe;function Se(se){const Fe=new s.WorkspaceEdit;for(const We of se.edits)We.textEdit?Fe.replace(k.URI.revive(We.resource),o.to(We.textEdit.range),We.textEdit.text):Fe.renameFile(k.URI.revive(We.oldResource),k.URI.revive(We.newResource),We.options);return Fe}Ae.to=Se})(H=e.WorkspaceEdit||(e.WorkspaceEdit={}));var Y;(function(Ae){const Oe=Object.create(null);Oe[s.SymbolKind.File]=0,Oe[s.SymbolKind.Module]=1,Oe[s.SymbolKind.Namespace]=2,Oe[s.SymbolKind.Package]=3,Oe[s.SymbolKind.Class]=4,Oe[s.SymbolKind.Method]=5,Oe[s.SymbolKind.Property]=6,Oe[s.SymbolKind.Field]=7,Oe[s.SymbolKind.Constructor]=8,Oe[s.SymbolKind.Enum]=9,Oe[s.SymbolKind.Interface]=10,Oe[s.SymbolKind.Function]=11,Oe[s.SymbolKind.Variable]=12,Oe[s.SymbolKind.Constant]=13,Oe[s.SymbolKind.String]=14,Oe[s.SymbolKind.Number]=15,Oe[s.SymbolKind.Boolean]=16,Oe[s.SymbolKind.Array]=17,Oe[s.SymbolKind.Object]=18,Oe[s.SymbolKind.Key]=19,Oe[s.SymbolKind.Null]=20,Oe[s.SymbolKind.EnumMember]=21,Oe[s.SymbolKind.Struct]=22,Oe[s.SymbolKind.Event]=23,Oe[s.SymbolKind.Operator]=24,Oe[s.SymbolKind.TypeParameter]=25;function Se(Fe){return typeof Oe[Fe]=="number"?Oe[Fe]:6}Ae.from=Se;function se(Fe){for(const We in Oe)if(Oe[We]===Fe)return Number(We);return s.SymbolKind.Property}Ae.to=se})(Y=e.SymbolKind||(e.SymbolKind={}));var ie;(function(Ae){function Oe(se){switch(se){case s.SymbolTag.Deprecated:return 1}}Ae.from=Oe;function Se(se){switch(se){case 1:return s.SymbolTag.Deprecated}}Ae.to=Se})(ie=e.SymbolTag||(e.SymbolTag={}));var ge;(function(Ae){function Oe(se){return{name:se.name,kind:Y.from(se.kind),tags:se.tags&&se.tags.map(ie.from),containerName:se.containerName,location:ve.from(se.location)}}Ae.from=Oe;function Se(se){const Fe=new s.SymbolInformation(se.name,Y.to(se.kind),se.containerName,ve.to(se.location));return Fe.tags=se.tags&&se.tags.map(ie.to),Fe}Ae.to=Se})(ge=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var X;(function(Ae){function Oe(se){const Fe={name:se.name||"!!MISSING: name!!",detail:se.detail,range:o.from(se.range),selectionRange:o.from(se.selectionRange),kind:Y.from(se.kind),tags:se.tags?.map(ie.from)??[]};return se.children&&(Fe.children=se.children.map(Oe)),Fe}Ae.from=Oe;function Se(se){const Fe=new s.DocumentSymbol(se.name,se.detail,Y.to(se.kind),o.to(se.range),o.to(se.selectionRange));return(0,a.isNonEmptyArray)(se.tags)&&(Fe.tags=se.tags.map(ie.to)),se.children&&(Fe.children=se.children.map(Se)),Fe}Ae.to=Se})(X=e.DocumentSymbol||(e.DocumentSymbol={}));var J;(function(Ae){function Oe(se){const Fe=new s.CallHierarchyItem(Y.to(se.kind),se.name,se.detail||"",k.URI.revive(se.uri),o.to(se.range),o.to(se.selectionRange));return Fe._sessionId=se._sessionId,Fe._itemId=se._itemId,Fe}Ae.to=Oe;function Se(se,Fe,We){if(Fe=Fe??se._sessionId,We=We??se._itemId,Fe===void 0||We===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:We,name:se.name,detail:se.detail,kind:Y.from(se.kind),uri:se.uri,range:o.from(se.range),selectionRange:o.from(se.selectionRange),tags:se.tags?.map(ie.from)}}Ae.from=Se})(J=e.CallHierarchyItem||(e.CallHierarchyItem={}));var ee;(function(Ae){function Oe(Se){return new s.CallHierarchyIncomingCall(J.to(Se.from),Se.fromRanges.map(se=>o.to(se)))}Ae.to=Oe})(ee=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var me;(function(Ae){function Oe(Se){return new s.CallHierarchyOutgoingCall(J.to(Se.to),Se.fromRanges.map(se=>o.to(se)))}Ae.to=Oe})(me=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var ve;(function(Ae){function Oe(se){return{range:se.range&&o.from(se.range),uri:se.uri}}Ae.from=Oe;function Se(se){return new s.Location(k.URI.revive(se.uri),o.to(se.range))}Ae.to=Se})(ve=e.location||(e.location={}));var Ie;(function(Ae){function Oe(se){const Fe=se,We=se;return{originSelectionRange:Fe.originSelectionRange?o.from(Fe.originSelectionRange):void 0,uri:Fe.targetUri?Fe.targetUri:We.uri,range:o.from(Fe.targetRange?Fe.targetRange:We.range),targetSelectionRange:Fe.targetSelectionRange?o.from(Fe.targetSelectionRange):void 0}}Ae.from=Oe;function Se(se){return{targetUri:k.URI.revive(se.uri),targetRange:o.to(se.range),targetSelectionRange:se.targetSelectionRange?o.to(se.targetSelectionRange):void 0,originSelectionRange:se.originSelectionRange?o.to(se.originSelectionRange):void 0}}Ae.to=Se})(Ie=e.DefinitionLink||(e.DefinitionLink={}));var Re;(function(Ae){function Oe(se){return{range:o.from(se.range),contents:Q.fromMany(se.contents)}}Ae.from=Oe;function Se(se){return new s.Hover(se.contents.map(Q.to),o.to(se.range))}Ae.to=Se})(Re=e.Hover||(e.Hover={}));var ae;(function(Ae){function Oe(se){return{range:o.from(se.range),expression:se.expression}}Ae.from=Oe;function Se(se){return new s.EvaluatableExpression(o.to(se.range),se.expression)}Ae.to=Se})(ae=e.EvaluatableExpression||(e.EvaluatableExpression={}));var le;(function(Ae){function Oe(se){if(se instanceof s.InlineValueText)return{type:"text",range:o.from(se.range),text:se.text};if(se instanceof s.InlineValueVariableLookup)return{type:"variable",range:o.from(se.range),variableName:se.variableName,caseSensitiveLookup:se.caseSensitiveLookup};if(se instanceof s.InlineValueEvaluatableExpression)return{type:"expression",range:o.from(se.range),expression:se.expression};throw new Error("Unknown 'InlineValue' type")}Ae.from=Oe;function Se(se){switch(se.type){case"text":return{range:o.to(se.range),text:se.text};case"variable":return{range:o.to(se.range),variableName:se.variableName,caseSensitiveLookup:se.caseSensitiveLookup};case"expression":return{range:o.to(se.range),expression:se.expression}}}Ae.to=Se})(le=e.InlineValue||(e.InlineValue={}));var ue;(function(Ae){function Oe(se){return{frameId:se.frameId,stoppedLocation:o.from(se.stoppedLocation)}}Ae.from=Oe;function Se(se){return new s.InlineValueContext(se.frameId,o.to(se.stoppedLocation))}Ae.to=Se})(ue=e.InlineValueContext||(e.InlineValueContext={}));var ne;(function(Ae){function Oe(se){return{range:o.from(se.range),kind:se.kind}}Ae.from=Oe;function Se(se){return new s.DocumentHighlight(o.to(se.range),se.kind)}Ae.to=Se})(ne=e.DocumentHighlight||(e.DocumentHighlight={}));var ce;(function(Ae){function Oe(Se){switch(Se){case 1:return s.CompletionTriggerKind.TriggerCharacter;case 2:return s.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return s.CompletionTriggerKind.Invoke}}Ae.to=Oe})(ce=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var oe;(function(Ae){function Oe(Se){return{triggerKind:ce.to(Se.triggerKind),triggerCharacter:Se.triggerCharacter}}Ae.to=Oe})(oe=e.CompletionContext||(e.CompletionContext={}));var M;(function(Ae){function Oe(se){switch(se){case s.CompletionItemTag.Deprecated:return 1}}Ae.from=Oe;function Se(se){switch(se){case 1:return s.CompletionItemTag.Deprecated}}Ae.to=Se})(M=e.CompletionItemTag||(e.CompletionItemTag={}));var z;(function(Ae){const Oe=new Map([[s.CompletionItemKind.Method,0],[s.CompletionItemKind.Function,1],[s.CompletionItemKind.Constructor,2],[s.CompletionItemKind.Field,3],[s.CompletionItemKind.Variable,4],[s.CompletionItemKind.Class,5],[s.CompletionItemKind.Interface,7],[s.CompletionItemKind.Struct,6],[s.CompletionItemKind.Module,8],[s.CompletionItemKind.Property,9],[s.CompletionItemKind.Unit,12],[s.CompletionItemKind.Value,13],[s.CompletionItemKind.Constant,14],[s.CompletionItemKind.Enum,15],[s.CompletionItemKind.EnumMember,16],[s.CompletionItemKind.Keyword,17],[s.CompletionItemKind.Snippet,27],[s.CompletionItemKind.Text,18],[s.CompletionItemKind.Color,19],[s.CompletionItemKind.File,20],[s.CompletionItemKind.Reference,21],[s.CompletionItemKind.Folder,23],[s.CompletionItemKind.Event,10],[s.CompletionItemKind.Operator,11],[s.CompletionItemKind.TypeParameter,24],[s.CompletionItemKind.Issue,26],[s.CompletionItemKind.User,25]]);function Se(We){return Oe.get(We)??9}Ae.from=Se;const se=new Map([[0,s.CompletionItemKind.Method],[1,s.CompletionItemKind.Function],[2,s.CompletionItemKind.Constructor],[3,s.CompletionItemKind.Field],[4,s.CompletionItemKind.Variable],[5,s.CompletionItemKind.Class],[7,s.CompletionItemKind.Interface],[6,s.CompletionItemKind.Struct],[8,s.CompletionItemKind.Module],[9,s.CompletionItemKind.Property],[12,s.CompletionItemKind.Unit],[13,s.CompletionItemKind.Value],[14,s.CompletionItemKind.Constant],[15,s.CompletionItemKind.Enum],[16,s.CompletionItemKind.EnumMember],[17,s.CompletionItemKind.Keyword],[27,s.CompletionItemKind.Snippet],[18,s.CompletionItemKind.Text],[19,s.CompletionItemKind.Color],[20,s.CompletionItemKind.File],[21,s.CompletionItemKind.Reference],[23,s.CompletionItemKind.Folder],[10,s.CompletionItemKind.Event],[11,s.CompletionItemKind.Operator],[24,s.CompletionItemKind.TypeParameter],[25,s.CompletionItemKind.User],[26,s.CompletionItemKind.Issue]]);function Fe(We){return se.get(We)??s.CompletionItemKind.Property}Ae.to=Fe})(z=e.CompletionItemKind||(e.CompletionItemKind={}));var G;(function(Ae){function Oe(Se,se){const Fe=new s.CompletionItem(Se.label);return Fe.insertText=Se.insertText,Fe.kind=z.to(Se.kind),Fe.tags=Se.tags?.map(M.to),Fe.detail=Se.detail,Fe.documentation=S.isMarkdownString(Se.documentation)?Q.to(Se.documentation):Se.documentation,Fe.sortText=Se.sortText,Fe.filterText=Se.filterText,Fe.preselect=Se.preselect,Fe.commitCharacters=Se.commitCharacters,D.Range.isIRange(Se.range)?Fe.range=o.to(Se.range):typeof Se.range=="object"&&(Fe.range={inserting:o.to(Se.range.insert),replacing:o.to(Se.range.replace)}),Fe.keepWhitespace=typeof Se.insertTextRules>"u"?!1:Boolean(Se.insertTextRules&1),typeof Se.insertTextRules<"u"&&Se.insertTextRules&4?Fe.insertText=new s.SnippetString(Se.insertText):(Fe.insertText=Se.insertText,Fe.textEdit=Fe.range instanceof s.Range?new s.TextEdit(Fe.range,Fe.insertText):void 0),Se.additionalTextEdits&&Se.additionalTextEdits.length>0&&(Fe.additionalTextEdits=Se.additionalTextEdits.map(We=>_.to(We))),Fe.command=se&&Se.command?se.fromInternal(Se.command):void 0,Fe}Ae.to=Oe})(G=e.CompletionItem||(e.CompletionItem={}));var te;(function(Ae){function Oe(se){if(typeof se.label!="string"&&!Array.isArray(se.label))throw new TypeError("Invalid label");return{label:se.label,documentation:Q.fromStrict(se.documentation)}}Ae.from=Oe;function Se(se){return{label:se.label,documentation:S.isMarkdownString(se.documentation)?Q.to(se.documentation):se.documentation}}Ae.to=Se})(te=e.ParameterInformation||(e.ParameterInformation={}));var de;(function(Ae){function Oe(se){return{label:se.label,documentation:Q.fromStrict(se.documentation),parameters:Array.isArray(se.parameters)?se.parameters.map(te.from):[],activeParameter:se.activeParameter}}Ae.from=Oe;function Se(se){return{label:se.label,documentation:S.isMarkdownString(se.documentation)?Q.to(se.documentation):se.documentation,parameters:Array.isArray(se.parameters)?se.parameters.map(te.to):[],activeParameter:se.activeParameter}}Ae.to=Se})(de=e.SignatureInformation||(e.SignatureInformation={}));var we;(function(Ae){function Oe(se){return{activeSignature:se.activeSignature,activeParameter:se.activeParameter,signatures:Array.isArray(se.signatures)?se.signatures.map(de.from):[]}}Ae.from=Oe;function Se(se){return{activeSignature:se.activeSignature,activeParameter:se.activeParameter,signatures:Array.isArray(se.signatures)?se.signatures.map(de.to):[]}}Ae.to=Se})(we=e.SignatureHelp||(e.SignatureHelp={}));var Pe;(function(Ae){function Oe(Se,se){const Fe=new s.InlayHint(m.to(se.position),typeof se.label=="string"?se.label:se.label.map(be.to.bind(void 0,Se)),se.kind&&Ce.to(se.kind));return Fe.textEdits=se.textEdits&&se.textEdits.map(_.to),Fe.tooltip=S.isMarkdownString(se.tooltip)?Q.to(se.tooltip):se.tooltip,Fe.paddingLeft=se.paddingLeft,Fe.paddingRight=se.paddingRight,Fe}Ae.to=Oe})(Pe=e.InlayHint||(e.InlayHint={}));var be;(function(Ae){function Oe(Se,se){const Fe=new s.InlayHintLabelPart(se.label);return Fe.tooltip=S.isMarkdownString(se.tooltip)?Q.to(se.tooltip):se.tooltip,f.Command.is(se.command)&&(Fe.command=Se.fromInternal(se.command)),se.location&&(Fe.location=ve.to(se.location)),Fe}Ae.to=Oe})(be=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var Ce;(function(Ae){function Oe(se){return se}Ae.from=Oe;function Se(se){return se}Ae.to=Se})(Ce=e.InlayHintKind||(e.InlayHintKind={}));var ke;(function(Ae){function Oe(se){return{range:o.from(se.range),url:se.target,tooltip:se.tooltip}}Ae.from=Oe;function Se(se){let Fe;if(se.url)try{Fe=typeof se.url=="string"?k.URI.parse(se.url,!0):k.URI.revive(se.url)}catch{}return new s.DocumentLink(o.to(se.range),Fe)}Ae.to=Se})(ke=e.DocumentLink||(e.DocumentLink={}));var He;(function(Ae){function Oe(se){const Fe=new s.ColorPresentation(se.label);return se.textEdit&&(Fe.textEdit=_.to(se.textEdit)),se.additionalTextEdits&&(Fe.additionalTextEdits=se.additionalTextEdits.map(We=>_.to(We))),Fe}Ae.to=Oe;function Se(se){return{label:se.label,textEdit:se.textEdit?_.from(se.textEdit):void 0,additionalTextEdits:se.additionalTextEdits?se.additionalTextEdits.map(Fe=>_.from(Fe)):void 0}}Ae.from=Se})(He=e.ColorPresentation||(e.ColorPresentation={}));var Ge;(function(Ae){function Oe(se){return new s.Color(se[0],se[1],se[2],se[3])}Ae.to=Oe;function Se(se){return[se.red,se.green,se.blue,se.alpha]}Ae.from=Se})(Ge=e.Color||(e.Color={}));var nt;(function(Ae){function Oe(se){return{range:o.from(se.range)}}Ae.from=Oe;function Se(se){return new s.SelectionRange(o.to(se.range))}Ae.to=Se})(nt=e.SelectionRange||(e.SelectionRange={}));var Qe;(function(Ae){function Oe(Se){switch(Se){case 2:return s.TextDocumentSaveReason.AfterDelay;case 1:return s.TextDocumentSaveReason.Manual;case 3:case 4:return s.TextDocumentSaveReason.FocusOut}}Ae.to=Oe})(Qe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var tt;(function(Ae){function Oe(se){switch(se){case s.TextEditorLineNumbersStyle.Off:return 0;case s.TextEditorLineNumbersStyle.Relative:return 2;case s.TextEditorLineNumbersStyle.On:default:return 1}}Ae.from=Oe;function Se(se){switch(se){case 0:return s.TextEditorLineNumbersStyle.Off;case 2:return s.TextEditorLineNumbersStyle.Relative;case 1:default:return s.TextEditorLineNumbersStyle.On}}Ae.to=Se})(tt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var rt;(function(Ae){function Oe(se){if(se===s.EndOfLine.CRLF)return 1;if(se===s.EndOfLine.LF)return 0}Ae.from=Oe;function Se(se){if(se===1)return s.EndOfLine.CRLF;if(se===0)return s.EndOfLine.LF}Ae.to=Se})(rt=e.EndOfLine||(e.EndOfLine={}));var Be;(function(Ae){function Oe(Se){if(typeof Se=="object")return Se.viewId;switch(Se){case s.ProgressLocation.SourceControl:return 3;case s.ProgressLocation.Window:return 10;case s.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}Ae.from=Oe})(Be=e.ProgressLocation||(e.ProgressLocation={}));var it;(function(Ae){function Oe(se){const Fe={start:se.start+1,end:se.end+1};return se.kind&&(Fe.kind=$.from(se.kind)),Fe}Ae.from=Oe;function Se(se){const Fe={start:se.start-1,end:se.end-1};return se.kind&&(Fe.kind=$.to(se.kind)),Fe}Ae.to=Se})(it=e.FoldingRange||(e.FoldingRange={}));var $;(function(Ae){function Oe(se){if(se)switch(se){case s.FoldingRangeKind.Comment:return f.FoldingRangeKind.Comment;case s.FoldingRangeKind.Imports:return f.FoldingRangeKind.Imports;case s.FoldingRangeKind.Region:return f.FoldingRangeKind.Region}}Ae.from=Oe;function Se(se){if(se)switch(se.value){case f.FoldingRangeKind.Comment.value:return s.FoldingRangeKind.Comment;case f.FoldingRangeKind.Imports.value:return s.FoldingRangeKind.Imports;case f.FoldingRangeKind.Region.value:return s.FoldingRangeKind.Region}}Ae.to=Se})($=e.FoldingRangeKind||(e.FoldingRangeKind={}));var K;(function(Ae){function Oe(Se){if(Se)return{pinned:typeof Se.preview=="boolean"?!Se.preview:void 0,inactive:Se.background,preserveFocus:Se.preserveFocus,selection:typeof Se.selection=="object"?o.from(Se.selection):void 0,override:typeof Se.override=="boolean"?p.DEFAULT_EDITOR_ASSOCIATION.id:void 0}}Ae.from=Oe})(K=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var he;(function(Ae){function Oe(We){return We instanceof s.RelativePattern?We.toJSON():typeof We=="string"?We:Se(We)||se(We)?new s.RelativePattern(We.baseUri??We.base,We.pattern).toJSON():We}Ae.from=Oe;function Se(We){const Ye=We;return Ye?k.URI.isUri(Ye.baseUri)&&typeof Ye.pattern=="string":!1}function se(We){const Ye=We;return Ye?typeof Ye.base=="string"&&typeof Ye.pattern=="string":!1}function Fe(We){return typeof We=="string"?We:new s.RelativePattern(k.URI.revive(We.baseUri),We.pattern)}Ae.to=Fe})(he=e.GlobPattern||(e.GlobPattern={}));var Le;(function(Ae){function Oe(Se){if(Se){if(Array.isArray(Se))return Se.map(Oe);if(typeof Se=="string")return Se;{const se=Se;return{language:se.language,scheme:se.scheme,pattern:he.from(se.pattern),exclusive:se.exclusive,notebookType:se.notebookType}}}else return}Ae.from=Oe})(Le=e.LanguageSelector||(e.LanguageSelector={}));var Ne;(function(Ae){function Oe(se){return{start:se.start,end:se.end}}Ae.from=Oe;function Se(se){return new s.NotebookRange(se.start,se.end)}Ae.to=Se})(Ne=e.NotebookRange||(e.NotebookRange={}));var xe;(function(Ae){function Oe(se){return{timing:typeof se.runStartTime=="number"&&typeof se.runEndTime=="number"?{startTime:se.runStartTime,endTime:se.runEndTime}:void 0,executionOrder:se.executionOrder,success:se.lastRunSuccess}}Ae.to=Oe;function Se(se){return{lastRunSuccess:se.success,runStartTime:se.timing?.startTime,runEndTime:se.timing?.endTime,executionOrder:se.executionOrder}}Ae.from=Se})(xe=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var je;(function(Ae){function Oe(Se){if(Se===b.NotebookCellExecutionState.Unconfirmed)return s.NotebookCellExecutionState.Pending;if(Se===b.NotebookCellExecutionState.Pending)return;if(Se===b.NotebookCellExecutionState.Executing)return s.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${Se}`)}Ae.to=Oe})(je=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var Ze;(function(Ae){function Oe(se){switch(se){case s.NotebookCellKind.Markup:return b.CellKind.Markup;case s.NotebookCellKind.Code:default:return b.CellKind.Code}}Ae.from=Oe;function Se(se){switch(se){case b.CellKind.Markup:return s.NotebookCellKind.Markup;case b.CellKind.Code:default:return s.NotebookCellKind.Code}}Ae.to=Se})(Ze=e.NotebookCellKind||(e.NotebookCellKind={}));var st;(function(Ae){function Oe(se){const Fe={metadata:se.metadata??Object.create(null),cells:[]};for(const We of se.cells)s.NotebookCellData.validate(We),Fe.cells.push(at.from(We));return Fe}Ae.from=Oe;function Se(se){const Fe=new s.NotebookData(se.cells.map(at.to));return(0,v.isEmptyObject)(se.metadata)||(Fe.metadata=se.metadata),Fe}Ae.to=Se})(st=e.NotebookData||(e.NotebookData={}));var at;(function(Ae){function Oe(se){return{cellKind:Ze.from(se.kind),language:se.languageId,mime:se.mime,source:se.value,metadata:se.metadata,internalMetadata:xe.from(se.executionSummary??{}),outputs:se.outputs?se.outputs.map(gt.from):[]}}Ae.from=Oe;function Se(se){return new s.NotebookCellData(Ze.to(se.cellKind),se.source,se.language,se.mime,se.outputs?se.outputs.map(gt.to):void 0,se.metadata,se.internalMetadata?xe.to(se.internalMetadata):void 0)}Ae.to=Se})(at=e.NotebookCellData||(e.NotebookCellData={}));var mt;(function(Ae){function Oe(se){return{mime:se.mime,valueBytes:L.VSBuffer.wrap(se.data)}}Ae.from=Oe;function Se(se){return new s.NotebookCellOutputItem(se.valueBytes.buffer,se.mime)}Ae.to=Se})(mt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var gt;(function(Ae){function Oe(se){return{outputId:se.id,items:se.items.map(mt.from),metadata:se.metadata}}Ae.from=Oe;function Se(se){const Fe=se.items.map(mt.to);return new s.NotebookCellOutput(Fe,se.outputId,se.metadata)}Ae.to=Se})(gt=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Et;(function(Ae){function Oe(Fe){return se(Fe)?{include:(0,v.withNullAsUndefined)(he.from(Fe.include)),exclude:(0,v.withNullAsUndefined)(he.from(Fe.exclude))}:(0,v.withNullAsUndefined)(he.from(Fe))}Ae.from=Oe;function Se(Fe){return se(Fe)?{include:he.to(Fe.include),exclude:he.to(Fe.exclude)}:he.to(Fe)}Ae.to=Se;function se(Fe){const We=Fe;return We?!(0,v.isUndefinedOrNull)(We.include)&&!(0,v.isUndefinedOrNull)(We.exclude):!1}})(Et=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var lt;(function(Ae){function Oe(Se,se,Fe){const We=typeof Se.command=="string"?{title:"",command:Se.command}:Se.command;return{alignment:Se.alignment===s.NotebookCellStatusBarAlignment.Left?1:2,command:se.toInternal(We,Fe),text:Se.text,tooltip:Se.tooltip,accessibilityInformation:Se.accessibilityInformation,priority:Se.priority}}Ae.from=Oe})(lt=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var pt;(function(Ae){function Oe(Se,se,Fe){const We=typeof Se.command=="string"?{title:"",command:Se.command}:Se.command;return{command:se.toInternal(We,Fe),label:Se.label,description:Se.description,detail:Se.detail,documentation:Se.documentation}}Ae.from=Oe})(pt=e.NotebookKernelSourceAction||(e.NotebookKernelSourceAction={}));var qt;(function(Ae){function Oe(Se){return{transientOutputs:Se?.transientOutputs??!1,transientCellMetadata:Se?.transientCellMetadata??{},transientDocumentMetadata:Se?.transientDocumentMetadata??{},cellContentMetadata:Se?.cellContentMetadata??{}}}Ae.from=Oe})(qt=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var jt;(function(Ae){function Oe(se){return{uri:se.uri,provides:se.provides}}Ae.from=Oe;function Se(se){return new s.NotebookRendererScript(k.URI.revive(se.uri),se.provides)}Ae.to=Se})(jt=e.NotebookRendererScript||(e.NotebookRendererScript={}));var kt;(function(Ae){function Oe(se){return{message:Q.fromStrict(se.message)||"",type:0,expected:se.expectedOutput,actual:se.actualOutput,location:se.location&&{range:o.from(se.location.range),uri:se.location.uri}}}Ae.from=Oe;function Se(se){const Fe=new s.TestMessage(typeof se.message=="string"?se.message:Q.to(se.message));return Fe.actualOutput=se.actual,Fe.expectedOutput=se.expected,Fe.location=se.location?ve.to(se.location):void 0,Fe}Ae.to=Se})(kt=e.TestMessage||(e.TestMessage={}));var ft;(function(Ae){Ae.namespace=g.namespaceTestTag,Ae.denamespace=g.denamespaceTestTag})(ft=e.TestTag||(e.TestTag={}));var Tt;(function(Ae){function Oe(se){const Fe=(0,h.getPrivateApiFor)(se).controllerId;return{extId:C.TestId.fromExtHostTestItem(se,Fe).toString(),label:se.label,uri:k.URI.revive(se.uri),busy:se.busy,tags:se.tags.map(We=>ft.namespace(Fe,We.id)),range:D.Range.lift(o.from(se.range)),description:se.description||null,sortText:se.sortText||null,error:se.error&&Q.fromStrict(se.error)||null}}Ae.from=Oe;function Se(se){return{parent:void 0,error:void 0,id:C.TestId.fromString(se.extId).localId,label:se.label,uri:k.URI.revive(se.uri),tags:(se.tags||[]).map(Fe=>{const{tagId:We}=ft.denamespace(Fe);return new s.TestTag(We)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:o.to(se.range||void 0),canResolveChildren:!1,busy:se.busy,description:se.description||void 0,sortText:se.sortText||void 0}}Ae.toPlain=Se})(Tt=e.TestItem||(e.TestItem={})),function(Ae){function Oe(se){return{id:se.id}}Ae.from=Oe;function Se(se){return new s.TestTag(se.id)}Ae.to=Se}(ft=e.TestTag||(e.TestTag={}));var Bt;(function(Ae){const Oe=(se,Fe)=>{const We=[];for(const[Ve,et]of Fe)C.TestId.compare(et.item.extId,Ve)===2&&(Fe.delete(Ve),We.push(et));const Ye={...Tt.toPlain(se.item),parent:void 0,taskStates:se.tasks.map(Ve=>({state:Ve.state,duration:Ve.duration,messages:Ve.messages.filter(et=>et.type===0).map(kt.to)})),children:We.map(Ve=>Oe(Ve,Fe))};for(const Ve of Ye.children)Ve.parent=Ye;return Ye};function Se(se){const Fe=[],We=new Map;for(const Ye of se.items){We.set(Ye.item.extId,Ye);const Ve=C.TestId.root(Ye.item.extId);se.request.targets.some(et=>et.controllerId===Ve&&et.testIds.includes(Ye.item.extId))&&Fe.push(Ye)}return{completedAt:se.completedAt,results:Fe.map(Ye=>Oe(Ye,We))}}Ae.to=Se})(Bt=e.TestResults||(e.TestResults={}));var At;(function(Ae){function Oe(We){return{covered:We.covered,total:We.covered}}function Se(We){return"line"in We?m.from(We):o.from(We)}function se(We){return"branches"in We?{count:We.executionCount,location:Se(We.location),type:1,branches:We.branches.length?We.branches.map(Ye=>({count:Ye.executionCount,location:Ye.location&&Se(Ye.location)})):void 0}:{type:0,count:We.executionCount,location:Se(We.location)}}Ae.fromDetailed=se;function Fe(We){return{uri:We.uri,statement:Oe(We.statementCoverage),branch:We.branchCoverage&&Oe(We.branchCoverage),function:We.functionCoverage&&Oe(We.functionCoverage),details:We.detailedCoverage?.map(se)}}Ae.fromFile=Fe})(At=e.TestCoverage||(e.TestCoverage={}));var Xe;(function(Ae){function Oe(Se){switch(Se){case 1:return s.CodeActionTriggerKind.Invoke;case 2:return s.CodeActionTriggerKind.Automatic}}Ae.to=Oe})(Xe=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Nt;(function(Ae){function Oe(se){const Fe=new s.TypeHierarchyItem(Y.to(se.kind),se.name,se.detail||"",k.URI.revive(se.uri),o.to(se.range),o.to(se.selectionRange));return Fe._sessionId=se._sessionId,Fe._itemId=se._itemId,Fe}Ae.to=Oe;function Se(se,Fe,We){if(Fe=Fe??se._sessionId,We=We??se._itemId,Fe===void 0||We===void 0)throw new Error("invalid item");return{_sessionId:Fe,_itemId:We,kind:Y.from(se.kind),name:se.name,detail:se.detail??"",uri:se.uri,range:o.from(se.range),selectionRange:o.from(se.selectionRange),tags:se.tags?.map(ie.from)}}Ae.from=Se})(Nt=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var Gt;(function(Ae){function Oe(Se){if(!!Se)return{value:Se.value,tooltip:Se.tooltip}}Ae.from=Oe})(Gt=e.ViewBadge||(e.ViewBadge={}));var Ft;(function(Ae){function Oe(We,Ye,Ve){const et=Ye.fileData;return et?new class extends s.DataTransferItem{asFile(){return{name:et.name,uri:k.URI.revive(et.uri),data:(0,R.once)(()=>Ve())}}}("",Ye.id):We===O.Mimes.uriList&&Ye.uriListData?new s.DataTransferItem(Fe(Ye.uriListData)):new s.DataTransferItem(Ye.asString)}Ae.to=Oe;async function Se(We,Ye){const Ve=await Ye.asString();if(We===O.Mimes.uriList)return{id:Ye.id,asString:Ve,fileData:void 0,uriListData:se(Ve)};const et=Ye.asFile();return{id:Ye.id,asString:Ve,fileData:et?{name:et.name,uri:et.uri}:void 0}}Ae.from=Se;function se(We){return l.UriList.split(We).map(Ye=>{if(Ye.startsWith("#"))return Ye;try{return k.URI.parse(Ye)}catch{}return Ye})}function Fe(We){return l.UriList.create(We.map(Ye=>typeof Ye=="string"?Ye:k.URI.revive(Ye)))}})(Ft=e.DataTransferItem||(e.DataTransferItem={}));var bt;(function(Ae){function Oe(se,Fe){const We=se.items.map(([Ye,Ve])=>[Ye,Ft.to(Ye,Ve,()=>Fe(Ve.id))]);return new s.DataTransfer(We)}Ae.toDataTransfer=Oe;async function Se(se){const Fe={items:[]},We=[];return se.forEach((Ye,Ve)=>{We.push((async()=>{Fe.items.push([Ve,await Ft.from(Ve,Ye)])})())}),await Promise.all(We),Fe}Ae.toDataTransferDTO=Se})(bt=e.DataTransfer||(e.DataTransfer={}))}),define(ye[240],De([1,0,2,11,7,14,67]),function(re,e,a,L,l,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class A{constructor(I,O,P,v={timeout:1500,errors:3}){this.c=I,this.d=O,this.f=P,this.g=v,this.a=new S.LinkedList,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(I){return(O,P,v)=>{const D={dispose:this.a.push([O,P,I])};return Array.isArray(v)&&v.push(D),D}}async $participateInSave(I,O){const P=a.URI.revive(I);let v=!1;const k=setTimeout(()=>v=!0,this.g.timeout),D=[];try{for(const f of[...this.a]){if(v)break;const u=this.d.getDocument(P),h=await this.h(f,{document:u,reason:R.TextDocumentSaveReason.to(O)});D.push(h)}}finally{clearTimeout(k)}return D}h([I,O,P],v){const k=this.b.get(I);return typeof k=="number"&&k>this.g.errors?Promise.resolve(!1):this.i(P,I,O,v).then(()=>!0,D=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' threw ERROR`),this.c.error(D),!(D instanceof Error)||D.message!=="concurrent_edits"){const f=this.b.get(I);this.b.set(I,f?f+1:1),typeof f=="number"&&f>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(I,O,P,v){const k=[],D=Date.now(),{document:f,reason:u}=v,{version:h}=f,p=Object.freeze({document:f,reason:u,waitUntil(b){if(Object.isFrozen(k))throw(0,L.illegalState)("waitUntil can not be called async");k.push(Promise.resolve(b))}});try{O.apply(P,[p])}catch(b){return Promise.reject(b)}return Object.freeze(k),new Promise((b,C)=>{const g=setTimeout(()=>C(new Error("timeout")),this.g.timeout);return Promise.all(k).then(i=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${I.identifier.value}' finished after ${Date.now()-D}ms`),clearTimeout(g),b(i)}).catch(i=>{clearTimeout(g),C(i)})}).then(b=>{const C={edits:[]};for(const g of b)if(Array.isArray(g)&&g.every(i=>i instanceof l.TextEdit))for(const{newText:i,newEol:s,range:r}of g)C.edits.push({resource:f.uri,versionId:void 0,textEdit:{range:r&&R.Range.from(r),text:i,eol:s&&R.EndOfLine.from(s)}});if(C.edits.length!==0)return h===f.version?this.f.$tryApplyWorkspaceEdit(C):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=A}),define(ye[241],De([1,0,16,2,14,7,93]),function(re,e,a,L,l,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class A{constructor(P,v,k,D){this.start=P,this.deletedCount=v,this.deletedItems=k,this.items=D}asApiEvent(){return{range:new R.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(P=>P.apiCell),removedCells:this.deletedItems}}}class y{static asModelAddData(P,v){return{EOL:v.eol,lines:v.source,languageId:v.language,uri:v.uri,isDirty:!1,versionId:1,notebook:P}}constructor(P,v,k){this.notebook=P,this.h=v,this.j=k,this.handle=k.handle,this.uri=L.URI.revive(k.uri),this.cellKind=k.cellKind,this.a=k.outputs.map(l.NotebookCellOutput.to),this.e=k.internalMetadata??{},this.b=Object.freeze(k.metadata??{}),this.d=Object.freeze(l.NotebookCellExecutionSummary.to(k.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const P=this,v=this.h.getDocument(this.uri);if(!v)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const k={get index(){return P.notebook.getCellIndex(P)},notebook:P.notebook.apiNotebook,kind:l.NotebookCellKind.to(this.j.cellKind),document:v.document,get mime(){return P.g},set mime(D){P.g=D},get outputs(){return P.a.slice(0)},get metadata(){return P.b},get executionSummary(){return P.d}};this.f=Object.freeze(k)}return this.f}setOutputs(P){this.a=P.map(l.NotebookCellOutput.to)}setOutputItems(P,v,k){const D=k.map(l.NotebookCellOutputItem.to),f=this.a.find(u=>u.id===P);if(f&&(v||(f.items.length=0),f.items.push(...D),f.items.length>1&&f.items.every(u=>S.isTextStreamMime(u.mime)))){const u=new Map,h=[];f.items.forEach(p=>{let b;u.has(p.mime)?b=u.get(p.mime):(b=[],u.set(p.mime,b),h.push(p.mime)),b.push(p.data)}),f.items.length=0,h.forEach(p=>{const b=S.compressOutputItemStreams(u.get(p));f.items.push({mime:p,data:b.buffer})})}}setMetadata(P){this.b=Object.freeze(P)}setInternalMetadata(P){this.e=P,this.d=Object.freeze(l.NotebookCellExecutionSummary.to(P))}setMime(P){}}e.ExtHostCell=y;class I{constructor(P,v,k,D,f){this.k=P,this.l=v,this.m=k,this.uri=D,this.handle=I.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=f.viewType,this.f=Object.freeze(f.metadata??Object.create(null)),this.r([[0,0,f.cells]],!0,void 0),this.g=f.versionId}dispose(){this.j=!0}get apiNotebook(){if(!this.e){const P=this,v={get uri(){return P.uri},get version(){return P.g},get notebookType(){return P.d},get isDirty(){return P.h},get isUntitled(){return P.uri.scheme===a.Schemas.untitled},get isClosed(){return P.j},get metadata(){return P.f},get cellCount(){return P.b.length},cellAt(k){return k=P.n(k),P.b[k].apiCell},getCells(k){return(k?P.p(k):P.b).map(f=>f.apiCell)},save(){return P.q()}};this.e=Object.freeze(v)}return this.e}acceptDocumentPropertiesChanged(P){P.metadata&&(this.f=Object.freeze({...this.f,...P.metadata}))}acceptDirty(P){this.h=P}acceptModelChanged(P,v,k){this.g=P.versionId,this.h=v,this.acceptDocumentPropertiesChanged({metadata:k});const D={notebook:this.apiNotebook,metadata:k,cellChanges:[],contentChanges:[]},f=[];for(const h of P.rawEvents)h.kind===S.NotebookCellsChangeType.ModelChange?this.r(h.changes,!1,D.contentChanges):h.kind===S.NotebookCellsChangeType.Move?this.s(h.index,h.length,h.newIdx,D.contentChanges):h.kind===S.NotebookCellsChangeType.Output?(this.t(h.index,h.outputs),f.push({cell:this.b[h.index].apiCell,outputs:this.b[h.index].apiCell.outputs})):h.kind===S.NotebookCellsChangeType.OutputItem?(this.u(h.index,h.outputId,h.append,h.outputItems),f.push({cell:this.b[h.index].apiCell,outputs:this.b[h.index].apiCell.outputs})):h.kind===S.NotebookCellsChangeType.ChangeCellLanguage?(this.v(h.index,h.language),f.push({cell:this.b[h.index].apiCell,document:this.b[h.index].apiCell.document})):h.kind===S.NotebookCellsChangeType.ChangeCellContent?f.push({cell:this.b[h.index].apiCell,document:this.b[h.index].apiCell.document}):h.kind===S.NotebookCellsChangeType.ChangeCellMime?this.w(h.index,h.mime):h.kind===S.NotebookCellsChangeType.ChangeCellMetadata?(this.x(h.index,h.metadata),f.push({cell:this.b[h.index].apiCell,metadata:this.b[h.index].apiCell.metadata})):h.kind===S.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(h.index,h.internalMetadata),f.push({cell:this.b[h.index].apiCell,executionSummary:this.b[h.index].apiCell.executionSummary}));const u=new Map;for(let h=0;h<f.length;h++){const p=f[h],b=u.get(p.cell);if(b===void 0){const C=D.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...p});u.set(p.cell,C-1)}else D.cellChanges[b]={...D.cellChanges[b],...p}}return Object.freeze(D),Object.freeze(D.cellChanges),Object.freeze(D.contentChanges),D}n(P){return P=P|0,P<0?0:P>=this.b.length?this.b.length-1:P}o(P){let v=P.start|0,k=P.end|0;return v<0&&(v=0),k>this.b.length&&(k=this.b.length),P.with({start:v,end:k})}p(P){P=this.o(P);const v=[];for(let k=P.start;k<P.end;k++)v.push(this.b[k]);return v}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(P,v,k){if(this.j)return;const D=[],f=[],u=[];if(P.reverse().forEach(h=>{const b=h[2].map(i=>{const s=new y(this,this.l,i);return v||f.push(y.asModelAddData(this.apiNotebook,i)),s}),C=new A(h[0],h[1],[],b),g=this.b.splice(h[0],h[1],...b);for(const i of g)u.push(i.uri),C.deletedItems.push(i.apiCell);D.push(C)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:f,removedDocuments:u}),k)for(const h of D)k.push(h.asApiEvent())}s(P,v,k,D){const f=this.b.splice(P,v);this.b.splice(k,0,...f);const u=[new A(P,v,f.map(h=>h.apiCell),[]),new A(k,0,[],f)];for(const h of u)D.push(h.asApiEvent())}t(P,v){this.b[P].setOutputs(v)}u(P,v,k,D){this.b[P].setOutputItems(v,k,D)}v(P,v){const k=this.b[P];k.apiCell.document.languageId!==v&&this.m.$acceptModelLanguageChanged(k.uri,v)}w(P,v){const k=this.b[P];k.apiCell.mime=v}x(P,v){this.b[P].setMetadata(v)}y(P,v){this.b[P].setInternalMetadata(v)}getCellFromApiCell(P){return this.b.find(v=>v.apiCell===P)}getCellFromIndex(P){return this.b[P]}getCell(P){return this.b.find(v=>v.handle===P)}getCellIndex(P){return this.b.indexOf(P)}}I.a=0,e.ExtHostNotebookDocument=I}),define(ye[136],De([1,0,11,14,7]),function(re,e,a,L,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class R{constructor(A,y,I,O,P,v){this.id=A,this.f=y,this.notebookData=I,this.a=[],this.b=[],this.d=!1,this.a=P,this.b=O,this.c=v}get apiEditor(){if(!this.e){const A=this;this.e={get notebook(){return A.notebookData.apiNotebook},get selection(){return A.a[0]},set selection(y){this.selections=[y]},get selections(){return A.a},set selections(y){if(!Array.isArray(y)||!y.every(l.NotebookRange.isNotebookRange))throw(0,a.illegalArgument)("selections");A.a=y,A.g(y)},get visibleRanges(){return A.b},revealRange(y,I){A.f.$tryRevealRange(A.id,L.NotebookRange.from(y),I??l.NotebookEditorRevealType.Default)},get viewColumn(){return A.c}},R.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(A){this.d=A}_acceptVisibleRanges(A){this.b=A}_acceptSelections(A){this.a=A}g(A){this.f.$trySetSelections(this.id,A.map(L.NotebookRange.from))}_acceptViewColumn(A){this.c=A}}R.apiEditorsToExtHost=new WeakMap,e.ExtHostNotebookEditor=R}),define(ye[242],De([1,0,3,13,14]),function(re,e,a,L,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let R=class{constructor(A,y){this.c=A,this.d=y,this.a=new a.Emitter,this.b=new a.Emitter,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(A,y){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",A,y);const I=this.d.getEditorById(A);y.visibleRanges&&I._acceptVisibleRanges(y.visibleRanges.ranges.map(l.NotebookRange.to)),y.selections&&I._acceptSelections(y.selections.selections.map(l.NotebookRange.to)),y.visibleRanges&&this.b.fire({notebookEditor:I.apiEditor,visibleRanges:I.apiEditor.visibleRanges}),y.selections&&this.a.fire(Object.freeze({notebookEditor:I.apiEditor,selections:I.apiEditor.selections}))}$acceptEditorViewColumns(A){for(const y in A)this.d.getEditorById(y)._acceptViewColumn(l.ViewColumn.to(A[y]))}};R=qe([ze(0,L.ILogService)],R),e.ExtHostNotebookEditors=R}),define(ye[243],De([1,0,14,126,178,21,63,11]),function(re,e,a,L,l,R,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class y{constructor(v){this.b=0,this.c=new Map,this.a=v}async withProgress(v,k,D){const f=this.b++,{title:u,location:h,cancellable:p}=k,b={label:(0,l.localize)(0,null,v.displayName||v.name),id:v.identifier.value};return this.a.$startProgress(f,{location:a.ProgressLocation.from(h),title:u,source:b,cancellable:p},v.isUnderDevelopment?void 0:v.identifier.value).catch(A.onUnexpectedExternalError),this.d(f,D,!!p)}d(v,k,D){let f;D&&(f=new R.CancellationTokenSource,this.c.set(v,f));const u=p=>{this.a.$progressEnd(p),this.c.delete(p),f?.dispose()};let h;try{h=k(new O(this.a,v),D&&f?f.token:R.CancellationToken.None)}catch(p){throw u(v),p}return h.then(p=>u(v),p=>u(v)),h}$acceptProgressCanceled(v){const k=this.c.get(v);k&&(k.cancel(),this.c.delete(v))}}e.ExtHostProgress=y;function I(P,v){return P.message=v.message,typeof v.increment=="number"&&(typeof P.increment=="number"?P.increment+=v.increment:P.increment=v.increment),P}class O extends L.Progress{constructor(v,k){super(D=>this.throttledReport(D)),this.c=v,this.d=k}throttledReport(v){this.c.$progressReport(this.d,v)}}qe([(0,S.throttle)(100,(P,v)=>I(P,v),()=>Object.create(null))],O.prototype,"throttledReport",null)}),define(ye[137],De([1,0,33,132,58,94,76,14,2]),function(re,e,a,L,l,R,S,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const I=(b,C,g,i)=>{let s=C;return{enumerable:!0,configurable:!1,get(){return s},set(r){if(!g(s,r)){const o=s;s=r,b.listener?.(i(r,o))}}}},O=(b,C)=>b===C,P={range:(b,C)=>b===C?!0:!b||!C?!1:b.isEqual(C),label:O,description:O,sortText:O,busy:O,error:O,canResolveChildren:O,tags:(b,C)=>!(b.length!==C.length||b.some(g=>!C.find(i=>g.id===i.id)))},v=b=>C=>({op:4,update:b(C)}),k=(b,C)=>({range:(()=>{let g;const i=v(s=>({range:a.Range.lift(A.Range.from(s))}));return{enumerable:!0,configurable:!1,get(){return g},set(s){b.listener?.({op:6}),P.range(g,s)||(g=s,b.listener?.(i(s)))}}})(),label:I(b,C,P.label,v(g=>({label:g}))),description:I(b,void 0,P.description,v(g=>({description:g}))),sortText:I(b,void 0,P.sortText,v(g=>({sortText:g}))),canResolveChildren:I(b,!1,P.canResolveChildren,g=>({op:2,state:g})),busy:I(b,!1,P.busy,v(g=>({busy:g}))),error:I(b,void 0,P.error,v(g=>({error:A.MarkdownString.fromStrict(g)||null}))),tags:I(b,[],P.tags,(g,i)=>({op:1,new:g.map(A.TestTag.from),old:i.map(A.TestTag.from)}))}),D=b=>{const C=l.TestId.fromString(b.extId),g=new u(C.controllerId,C.localId,b.label,y.URI.revive(b.uri)||void 0);return g.range=A.Range.to(b.range||void 0),g.description=b.description||void 0,g.sortText=b.sortText||void 0,g.tags=b.tags.map(i=>A.TestTag.to({id:(0,S.denamespaceTestTag)(i).tagId})),g},f=b=>{let C;for(const g of b.tests){const i=D(g.item);(0,L.getPrivateApiFor)(i).parent=C,C=i}return C};e.toItemFromContext=f;class u{constructor(C,g,i,s){if(g.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(g)} symbol`);const r=(0,L.createPrivateApiFor)(this,C);Object.defineProperties(this,{id:{value:g,enumerable:!0,writable:!1},uri:{value:s,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return r.parent instanceof h?void 0:r.parent}},children:{value:(0,R.createTestItemChildren)(r,L.getPrivateApiFor,u),enumerable:!0,writable:!1},...k(r,i)})}}e.TestItemImpl=u;class h extends u{constructor(C,g){super(C,C,g,void 0),this._isRoot=!0}}e.TestItemRootImpl=h;class p extends R.TestItemCollection{constructor(C,g,i){super({controllerId:C,getDocumentVersion:s=>s&&i.getDocument(s)?.version,getApiFor:L.getPrivateApiFor,getChildren:s=>s.children,root:new h(C,g),toITestItem:A.TestItem.from})}}e.ExtHostTestItemCollection=p}),define(ye[138],De([1,0,50,11,101,14,7]),function(re,e,a,L,l,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorDecorationType=void 0;class A{constructor(v,k,D){const f=A.c.nextId();v.$registerTextEditorDecorationType(k.identifier,f,R.DecorationRenderOptions.from(D)),this.value=Object.freeze({key:f,dispose(){v.$removeTextEditorDecorationType(f)}})}}A.c=new l.IdGenerator("TextEditorDecorationType"),e.TextEditorDecorationType=A;class y{constructor(v,k){this.g=[],this.h=void 0,this.j=!1,this.c=v,this.d=v.version,this.e=k.undoStopBefore,this.f=k.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(v,k){this.k();let D=null;if(v instanceof S.Position)D=new S.Range(v,v);else if(v instanceof S.Range)D=v;else throw new Error("Unrecognized location");this.l(D,k,!1)}insert(v,k){this.k(),this.l(new S.Range(v,v),k,!0)}delete(v){this.k();let k=null;if(v instanceof S.Range)k=v;else throw new Error("Unrecognized location");this.l(k,null,!0)}l(v,k,D){const f=this.c.validateRange(v);this.g.push({range:f,text:k,forceMoveMarkers:D})}setEndOfLine(v){if(this.k(),v!==S.EndOfLine.LF&&v!==S.EndOfLine.CRLF)throw(0,L.illegalArgument)("endOfLine");this.h=v}}class I{constructor(v,k,D,f){this.c=v,this.d=k,this._accept(D),this.e=f;const u=this;this.value={get tabSize(){return u.f},set tabSize(h){u.m(h)},get indentSize(){return u.g},set indentSize(h){u.o(h)},get insertSpaces(){return u.h},set insertSpaces(h){u.q(h)},get cursorStyle(){return u.j},set cursorStyle(h){u.s(h)},get lineNumbers(){return u.k},set lineNumbers(h){u.t(h)}}}_accept(v){this.f=v.tabSize,this.g=v.indentSize,this.h=v.insertSpaces,this.j=v.cursorStyle,this.k=R.TextEditorLineNumbersStyle.to(v.lineNumbers)}l(v){if(v==="auto")return"auto";if(typeof v=="number"){const k=Math.floor(v);return k>0?k:null}if(typeof v=="string"){const k=parseInt(v,10);return isNaN(k)?null:k>0?k:null}return null}m(v){const k=this.l(v);if(k!==null){if(typeof k=="number"){if(this.f===k)return;this.f=k}this.u("setTabSize",this.c.$trySetOptions(this.d,{tabSize:k}))}}n(v){if(v==="tabSize")return"tabSize";if(typeof v=="number"){const k=Math.floor(v);return k>0?k:null}if(typeof v=="string"){const k=parseInt(v,10);return isNaN(k)?null:k>0?k:null}return null}o(v){const k=this.n(v);if(k!==null){if(typeof k=="number"){if(this.g===k)return;this.g=k}this.u("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:k}))}}p(v){return v==="auto"?"auto":v==="false"?!1:Boolean(v)}q(v){const k=this.p(v);if(typeof k=="boolean"){if(this.h===k)return;this.h=k}this.u("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:k}))}s(v){this.j!==v&&(this.j=v,this.u("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:v})))}t(v){this.k!==v&&(this.k=v,this.u("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:R.TextEditorLineNumbersStyle.from(v)})))}assign(v){const k={};let D=!1;if(typeof v.tabSize<"u"){const f=this.l(v.tabSize);f==="auto"?(D=!0,k.tabSize=f):typeof f=="number"&&this.f!==f&&(this.f=f,D=!0,k.tabSize=f)}if(typeof v.indentSize<"u"){const f=this.n(v.indentSize);f==="tabSize"?(D=!0,k.indentSize=f):typeof f=="number"&&this.g!==f&&(this.g=f,D=!0,k.indentSize=f)}if(typeof v.insertSpaces<"u"){const f=this.p(v.insertSpaces);f==="auto"?(D=!0,k.insertSpaces=f):this.h!==f&&(this.h=f,D=!0,k.insertSpaces=f)}typeof v.cursorStyle<"u"&&this.j!==v.cursorStyle&&(this.j=v.cursorStyle,D=!0,k.cursorStyle=v.cursorStyle),typeof v.lineNumbers<"u"&&this.k!==v.lineNumbers&&(this.k=v.lineNumbers,D=!0,k.lineNumbers=R.TextEditorLineNumbersStyle.from(v.lineNumbers)),D&&this.u("setOptions",this.c.$trySetOptions(this.d,k))}u(v,k){k.catch(D=>{this.e.warn(`ExtHostTextEditorOptions '${v}' failed:'`),this.e.warn(D)})}}e.ExtHostTextEditorOptions=I;class O{constructor(v,k,D,f,u,h,p,b){this.id=v,this.j=k,this.k=D,this.g=!1,this.h=new Set,this.c=u,this.d=new I(this.j,this.id,h,D),this.e=p,this.f=b;const C=this;this.value=Object.freeze({get document(){return f.value},set document(g){throw(0,L.readonly)("document")},get selection(){return C.c&&C.c[0]},set selection(g){if(!(g instanceof S.Selection))throw(0,L.illegalArgument)("selection");C.c=[g],C.l()},get selections(){return C.c},set selections(g){if(!Array.isArray(g)||g.some(i=>!(i instanceof S.Selection)))throw(0,L.illegalArgument)("selections");C.c=g,C.l()},get visibleRanges(){return C.e},set visibleRanges(g){throw(0,L.readonly)("visibleRanges")},get options(){return C.d.value},set options(g){C.g||C.d.assign(g)},get viewColumn(){return C.f},set viewColumn(g){throw(0,L.readonly)("viewColumn")},edit(g,i={undoStopBefore:!0,undoStopAfter:!0}){if(C.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const s=new y(f.value,i);return g(s),C.m(s)},insertSnippet(g,i,s={undoStopBefore:!0,undoStopAfter:!0}){if(C.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let r;if(!i||Array.isArray(i)&&i.length===0)r=C.c.map(o=>R.Range.from(o));else if(i instanceof S.Position){const{lineNumber:o,column:c}=R.Position.from(i);r=[{startLineNumber:o,startColumn:c,endLineNumber:o,endColumn:c}]}else if(i instanceof S.Range)r=[R.Range.from(i)];else{r=[];for(const o of i)if(o instanceof S.Range)r.push(R.Range.from(o));else{const{lineNumber:c,column:m}=R.Position.from(o);r.push({startLineNumber:c,startColumn:m,endLineNumber:c,endColumn:m})}}return k.$tryInsertSnippet(v,f.value.version,g.value,r,s)},setDecorations(g,i){const s=i.length===0;s&&!C.h.has(g.key)||(s?C.h.delete(g.key):C.h.add(g.key),C.n(()=>{if(R.isDecorationOptionsArr(i))return k.$trySetDecorations(v,g.key,R.fromRangeOrRangeWithMessage(i));{const r=new Array(4*i.length);for(let o=0,c=i.length;o<c;o++){const m=i[o];r[4*o]=m.start.line+1,r[4*o+1]=m.start.character+1,r[4*o+2]=m.end.line+1,r[4*o+3]=m.end.character+1}return k.$trySetDecorationsFast(v,g.key,r)}}))},revealRange(g,i){C.n(()=>k.$tryRevealRange(v,R.Range.from(g),i||S.TextEditorRevealType.Default))},show(g){k.$tryShowEditor(v,R.ViewColumn.from(g))},hide(){k.$tryHideEditor(v)}})}dispose(){(0,a.ok)(!this.g),this.g=!0}_acceptOptions(v){(0,a.ok)(!this.g),this.d._accept(v)}_acceptVisibleRanges(v){(0,a.ok)(!this.g),this.e=v}_acceptViewColumn(v){(0,a.ok)(!this.g),this.f=v}_acceptSelections(v){(0,a.ok)(!this.g),this.c=v}async l(){const v=this.c.map(R.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,v)),this.value}m(v){const k=v.finalize();if(k.edits.length===0&&!k.setEndOfLine)return Promise.resolve(!0);const D=k.edits.map(u=>u.range);D.sort((u,h)=>u.end.line===h.end.line?u.end.character===h.end.character?u.start.line===h.start.line?u.start.character-h.start.character:u.start.line-h.start.line:u.end.character-h.end.character:u.end.line-h.end.line);for(let u=0,h=D.length-1;u<h;u++){const p=D[u].end;if(D[u+1].start.isBefore(p))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const f=k.edits.map(u=>({range:R.Range.from(u.range),text:u.text,forceMoveMarkers:u.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,k.documentVersionId,f,{setEndOfLine:typeof k.setEndOfLine=="number"?R.EndOfLine.from(k.setEndOfLine):void 0,undoStopBefore:k.undoStopBefore,undoStopAfter:k.undoStopAfter})}n(v){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):v().then(()=>this,k=>(k instanceof Error&&k.name==="DISPOSED"||this.k.warn(k),null))}}e.ExtHostTextEditor=O}),define(ye[244],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",envShellEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.envShellEvent.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",indentSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.indentSize.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",testContinuousRun:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testContinuousRun.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeItemCheckbox:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeItemCheckbox.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(ye[245],De([1,0,194,11,37,123,92,39,27,244,208,197]),function(re,e,a,L,l,R,S,A,y,I,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const v=A.Registry.as(S.Extensions.JSONContribution);class k{constructor(g,i,s){this.a=g,this.b=i,this.c=s}d(g,i){this.a({type:g,message:i,extensionId:this.b.identifier,extensionPointId:this.c})}error(g){this.d(l.default.Error,g)}warn(g){this.d(l.default.Warning,g)}info(g){this.d(l.default.Info,g)}}e.ExtensionMessageCollector=k;class D{static a(g){const i=new Set;for(let s=0,r=g.length;s<r;s++)i.add(y.ExtensionIdentifier.toKey(g[s].description.identifier));return i}static compute(g,i){if(!g||!g.length)return new D(i,[]);if(!i||!i.length)return new D([],g);const s=this.a(g),r=this.a(i),o=i.filter(m=>!s.has(y.ExtensionIdentifier.toKey(m.description.identifier))),c=g.filter(m=>!r.has(y.ExtensionIdentifier.toKey(m.description.identifier)));return new D(o,c)}constructor(g,i){this.added=g,this.removed=i}}e.ExtensionPointUserDelta=D;class f{constructor(g,i){this.name=g,this.defaultExtensionKind=i,this.a=null,this.b=null,this.c=null}setHandler(g){if(this.a!==null)throw new Error("Handler already set!");this.a=g,this.d()}acceptUsers(g){this.c=D.compute(this.b,g),this.b=g,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(g){(0,L.onUnexpectedError)(g)}}}e.ExtensionPoint=f;const u={type:"string",enum:["ui","workspace"],enumDescriptions:[a.localize(0,null),a.localize(1,null)]},h="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:a.localize(2,null),properties:{vscode:{type:"string",description:a.localize(3,null),default:"^1.22.0"}}},publisher:{description:a.localize(4,null),type:"string"},displayName:{description:a.localize(5,null),type:"string"},categories:{description:a.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:y.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:a.localize(7,null)}]}},galleryBanner:{type:"object",description:a.localize(8,null),properties:{color:{description:a.localize(9,null),type:"string"},theme:{description:a.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:a.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:a.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:a.localize(13,null)},enabledApiProposals:{markdownDescription:a.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(I.allApiProposals),markdownEnumDescriptions:Object.values(I.allApiProposals)}},api:{markdownDescription:a.localize(15,null),type:"string",enum:["none"],enumDescriptions:[a.localize(16,null)]},activationEvents:{description:a.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:a.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:a.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:a.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:a.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:a.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:a.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:a.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:a.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:a.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:a.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:a.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:a.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:a.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:a.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:a.localize(32,null)},{label:"onUri",body:"onUri",description:a.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:a.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:a.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:a.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:a.localize(37,null)},{label:"onRenderer",description:a.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:a.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:a.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:a.localize(41,null)},{label:"*",description:a.localize(42,null),body:"*"}]}},badges:{type:"array",description:a.localize(43,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:a.localize(44,null)},href:{type:"string",description:a.localize(45,null)},description:{type:"string",description:a.localize(46,null)}}}},markdown:{type:"string",description:a.localize(47,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:a.localize(48,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:a.localize(49,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:a.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:R.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:a.localize(51,null),type:"array",items:u,default:["workspace"],defaultSnippets:[{body:["ui"],description:a.localize(52,null)},{body:["workspace"],description:a.localize(53,null)},{body:["ui","workspace"],description:a.localize(54,null)},{body:["workspace","ui"],description:a.localize(55,null)},{body:[],description:a.localize(56,null)}]},capabilities:{description:a.localize(57,null),type:"object",properties:{virtualWorkspaces:{description:a.localize(58,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:a.localize(59,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[a.localize(60,null),a.localize(61,null),a.localize(62,null)]},description:{type:"string",markdownDescription:a.localize(63,null)}}},untrustedWorkspaces:{description:a.localize(64,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:a.localize(65,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[a.localize(66,null),a.localize(67,null),a.localize(68,null)]},restrictedConfigurations:{description:a.localize(69,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:a.localize(70,null)}}}}},sponsor:{description:a.localize(71,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:a.localize(72,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:a.localize(73,null),type:"string"},"vscode:uninstall":{description:a.localize(74,null),type:"string"}}},icon:{type:"string",description:a.localize(75,null)},l10n:{type:"string",description:a.localize(76,null)}}};class p{constructor(){this.a=new Map}registerExtensionPoint(g){if(this.a.has(g.extensionPoint))throw new Error("Duplicate extension point: "+g.extensionPoint);const i=new f(g.extensionPoint,g.defaultExtensionKind);return this.a.set(g.extensionPoint,i),g.activationEventsGenerator&&P.ImplicitActivationEvents.register(g.extensionPoint,g.activationEventsGenerator),e.schema.properties.contributes.properties[g.extensionPoint]=g.jsonSchema,v.registerSchema(h,e.schema),i}getExtensionPoints(){return Array.from(this.a.values())}}e.ExtensionsRegistryImpl=p;const b={ExtensionsRegistry:"ExtensionsRegistry"};A.Registry.add(b.ExtensionsRegistry,new p),e.ExtensionsRegistry=A.Registry.as(b.ExtensionsRegistry),v.registerSchema(h,e.schema),v.registerSchema(O.productSchemaId,{properties:{extensionEnabledApiProposals:{description:a.localize(77,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(I.allApiProposals),markdownEnumDescriptions:Object.values(I.allApiProposals)}}]}}}})}),define(ye[246],De([1,0,191,10,23,245,55,3]),function(re,e,a,L,l,R,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=void 0;const y={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:a.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:a.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:a.localize(2,null),default:""}}};var I;(function(v){function k(D,f,u){if(!D)return;const h=L.isString(D.type)?D.type:void 0;if(!h||h.length===0){u.error(a.localize(3,null));return}const p=[];if(Array.isArray(D.required))for(const b of D.required)L.isString(b)&&p.push(b);return{extensionId:f.value,taskType:h,required:p,properties:D.properties?l.deepClone(D.properties):{},when:D.when?S.ContextKeyExpr.deserialize(D.when):void 0}}v.from=k})(I||(I={}));const O=R.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(v,k)=>{for(const D of v)D.type&&k.push(`onTaskType:${D.type}`)},jsonSchema:{description:a.localize(4,null),type:"array",items:y}});class P{constructor(){this.d=new A.Emitter,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((k,D)=>{O.setHandler((f,u)=>{this.c=void 0;try{for(const h of u.removed){const p=h.value;for(const b of p)this.a&&b.type&&this.a[b.type]&&delete this.a[b.type]}for(const h of u.added){const p=h.value;for(const b of p){const C=I.from(b,h.description.identifier,h.collector);C&&(this.a[C.taskType]=C)}}(u.removed.length>0||u.added.length>0)&&this.d.fire()}catch{}k(void 0)})})}onReady(){return this.b}get(k){return this.a[k]}all(){return Object.keys(this.a).map(k=>this.a[k])}getJsonSchema(){if(this.c===void 0){const k=[];for(const D of this.all()){const f={type:"object",additionalProperties:!1};D.required.length>0&&(f.required=D.required.slice(0)),D.properties!==void 0?f.properties=l.deepClone(D.properties):f.properties=Object.create(null),f.properties.type={type:"string",enum:[D.taskType]},k.push(f)}this.c={oneOf:k}}return this.c}}e.TaskDefinitionRegistry=new P}),define(ye[247],De([1,0,192,10,24,23,55,246]),function(re,e,a,L,l,R,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new S.RawContextKey("taskRunning",!1,a.localize(0,null)),e.TASKS_CATEGORY={value:a.localize(1,null),original:"Tasks"};var y;(function(U){U[U.Escape=1]="Escape",U[U.Strong=2]="Strong",U[U.Weak=3]="Weak"})(y=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(U){function T(F){if(!F)return U.Strong;switch(F.toLowerCase()){case"escape":return U.Escape;case"strong":return U.Strong;case"weak":return U.Weak;default:return U.Strong}}U.from=T}(y=e.ShellQuoting||(e.ShellQuoting={}));var I;(function(U){U.defaults={cwd:"${workspaceFolder}"}})(I=e.CommandOptions||(e.CommandOptions={}));var O;(function(U){U[U.Always=1]="Always",U[U.Silent=2]="Silent",U[U.Never=3]="Never"})(O=e.RevealKind||(e.RevealKind={})),function(U){function T(F){switch(F.toLowerCase()){case"always":return U.Always;case"silent":return U.Silent;case"never":return U.Never;default:return U.Always}}U.fromString=T}(O=e.RevealKind||(e.RevealKind={}));var P;(function(U){U[U.Never=1]="Never",U[U.OnProblem=2]="OnProblem",U[U.Always=3]="Always"})(P=e.RevealProblemKind||(e.RevealProblemKind={})),function(U){function T(F){switch(F.toLowerCase()){case"always":return U.Always;case"never":return U.Never;case"onproblem":return U.OnProblem;default:return U.OnProblem}}U.fromString=T}(P=e.RevealProblemKind||(e.RevealProblemKind={}));var v;(function(U){U[U.Shared=1]="Shared",U[U.Dedicated=2]="Dedicated",U[U.New=3]="New"})(v=e.PanelKind||(e.PanelKind={})),function(U){function T(F){switch(F.toLowerCase()){case"shared":return U.Shared;case"dedicated":return U.Dedicated;case"new":return U.New;default:return U.Shared}}U.fromString=T}(v=e.PanelKind||(e.PanelKind={}));var k;(function(U){U.defaults={echo:!0,reveal:O.Always,revealProblems:P.Never,focus:!1,panel:v.Shared,showReuseMessage:!0,clear:!1}})(k=e.PresentationOptions||(e.PresentationOptions={}));var D;(function(U){U[U.Shell=1]="Shell",U[U.Process=2]="Process",U[U.CustomExecution=3]="CustomExecution"})(D=e.RuntimeType||(e.RuntimeType={})),function(U){function T(B){switch(B.toLowerCase()){case"shell":return U.Shell;case"process":return U.Process;case"customExecution":return U.CustomExecution;default:return U.Process}}U.fromString=T;function F(B){switch(B){case U.Shell:return"shell";case U.Process:return"process";case U.CustomExecution:return"customExecution";default:return"process"}}U.toString=F}(D=e.RuntimeType||(e.RuntimeType={}));var f;(function(U){function T(F){return L.isString(F)?F:F.value}U.value=T})(f=e.CommandString||(e.CommandString={}));var u;(function(U){U.Clean={_id:"clean",isDefault:!1},U.Build={_id:"build",isDefault:!1},U.Rebuild={_id:"rebuild",isDefault:!1},U.Test={_id:"test",isDefault:!1};function T(B){return B===U.Clean._id||B===U.Build._id||B===U.Rebuild._id||B===U.Test._id}U.is=T;function F(B){if(B!==void 0)return L.isString(B)?T(B)?{_id:B,isDefault:!1}:void 0:B}U.from=F})(u=e.TaskGroup||(e.TaskGroup={}));var h;(function(U){U[U.Global=1]="Global",U[U.Workspace=2]="Workspace",U[U.Folder=3]="Folder"})(h=e.TaskScope||(e.TaskScope={}));var p;(function(U){U.Workspace="workspace",U.Extension="extension",U.InMemory="inMemory",U.WorkspaceFile="workspaceFile",U.User="user";function T(F){switch(F){case U.User:return 2;case U.WorkspaceFile:return 5;default:return 6}}U.toConfigurationTarget=T})(p=e.TaskSourceKind||(e.TaskSourceKind={}));var b;(function(U){U.parallel="parallel",U.sequence="sequence"})(b=e.DependsOrder||(e.DependsOrder={}));var C;(function(U){U[U.default=1]="default",U[U.folderOpen=2]="folderOpen"})(C=e.RunOnOptions||(e.RunOnOptions={}));var g;(function(U){U.defaults={reevaluateOnRerun:!0,runOn:C.default,instanceLimit:1}})(g=e.RunOptions||(e.RunOptions={}));class i{constructor(T,F,B,Z,_,H){this._label="",this._id=T,F&&(this._label=F),B&&(this.type=B),this.runOptions=Z,this.configurationProperties=_,this._source=H}getDefinition(T){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const T={folder:this.d(),id:this._id};return JSON.stringify(T)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(T,F=!1){if(T===void 0)return!1;if(L.isString(T))return T===this._label||T===this.configurationProperties.identifier||F&&T===this._id;const B=this.getDefinition(!0);return B!==void 0&&B._key===T._key}getQualifiedLabel(){const T=this.getWorkspaceFolder();return T?`${this._label} (${T.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(T){this.c===void 0&&(this.c=[]),T&&(this.c=this.c.concat(T))}get taskLoadMessages(){return this.c}}e.CommonTask=i;class s extends i{constructor(T,F,B,Z,_,H,Y,ie){super(T,B,void 0,Y,ie,F),this.command={},this._source=F,this.hasDefinedMatchers=H,_&&(this.command=_)}clone(){return new s(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(T=!1){if(T&&this._source.customizes!==void 0)return this._source.customizes;{let F;switch(this.command?this.command.runtime:void 0){case D.Shell:F="shell";break;case D.Process:F="process";break;case D.CustomExecution:F="customExecution";break;case void 0:F="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:F,_key:this._id,id:this._id}}}static is(T){return T instanceof s}getMapKey(){const T=this._source.config.workspaceFolder;return T?`${T.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===p.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const T=this.d();if(!T)return;let F=this.configurationProperties.identifier;this._source.kind!==p.Workspace&&(F+=this._source.kind);const B={type:e.CUSTOMIZED_TASK_TYPE,folder:T,id:F};return JSON.stringify(B)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?l.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(T){return new s(T._id,T._source,T._label,T.type,T.command,T.hasDefinedMatchers,T.runOptions,T.configurationProperties)}}e.CustomTask=s;class r extends i{constructor(T,F,B,Z,_,H,Y){super(T,B,Z,H,Y,F),this._source=F,this.configures=_}static is(T){return T instanceof r}f(T){return T}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?l.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===p.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const T=this.d();if(!T)return;let F=this.configurationProperties.identifier;this._source.kind!==p.Workspace&&(F+=this._source.kind);const B={type:e.CUSTOMIZED_TASK_TYPE,folder:T,id:F};return JSON.stringify(B)}}e.ConfiguringTask=r;class o extends i{constructor(T,F,B,Z,_,H,Y,ie,ge){super(T,B,Z,ie,ge,F),this.defines=_,this.hasDefinedMatchers=Y,this.command=H,this.icon=ge.icon,this.hide=ge.hide}clone(){return new o(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(T){return T instanceof o}getMapKey(){const T=this._source.workspaceFolder;return T?`${this._source.scope.toString()}|${T.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const T={type:"contributed",scope:this._source.scope,id:this._id};return T.folder=this.d(),JSON.stringify(T)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(T){return new o(T._id,T._source,T._label,T.type,T.defines,T.command,T.hasDefinedMatchers,T.runOptions,T.configurationProperties)}}e.ContributedTask=o;class c extends i{constructor(T,F,B,Z,_,H){super(T,B,Z,_,H,F),this._source=F}clone(){return new c(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(T){return T instanceof c}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(T){return new c(T._id,T._source,T._label,T.type,T.runOptions,T.configurationProperties)}}e.InMemoryTask=c;var m;(function(U){U[U.Process=1]="Process",U[U.Terminal=2]="Terminal"})(m=e.ExecutionEngine||(e.ExecutionEngine={})),function(U){U._default=U.Terminal}(m=e.ExecutionEngine||(e.ExecutionEngine={}));var n;(function(U){U[U.V0_1_0=1]="V0_1_0",U[U.V2_0_0=2]="V2_0_0"})(n=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class t{constructor(T){this.c=new Map;for(let F=0;F<T.length;F++)this.c.set(T[F].uri.toString(),F)}compare(T,F){const B=T.getWorkspaceFolder(),Z=F.getWorkspaceFolder();if(B&&Z){let _=this.c.get(B.uri.toString());_=_===void 0?0:_+1;let H=this.c.get(Z.uri.toString());return H=H===void 0?0:H+1,_===H?T._label.localeCompare(F._label):_-H}else return!B&&Z?-1:B&&!Z?1:0}}e.TaskSorter=t;var d;(function(U){U.DependsOnStarted="dependsOnStarted",U.AcquiredInput="acquiredInput",U.Start="start",U.ProcessStarted="processStarted",U.Active="active",U.Inactive="inactive",U.Changed="changed",U.Terminated="terminated",U.ProcessEnded="processEnded",U.End="end"})(d=e.TaskEventKind||(e.TaskEventKind={}));var E;(function(U){U.SingleRun="singleRun",U.Background="background"})(E=e.TaskRunType||(e.TaskRunType={}));var w;(function(U){U[U.System=0]="System",U[U.User=1]="User",U[U.FolderOpen=2]="FolderOpen",U[U.ConfigurationChange=3]="ConfigurationChange",U[U.Reconnect=4]="Reconnect"})(w=e.TaskRunSource||(e.TaskRunSource={}));var N;(function(U){function T(F,B,Z,_){if(B){const H={kind:F,taskId:B._id,taskName:B.configurationProperties.name,runType:B.configurationProperties.isBackground?"background":"singleRun",group:B.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:Z,__task:B};return F==="start"?H.resolvedVariables=_:F==="processStarted"?H.processId=_:F==="processEnded"&&(H.exitCode=_),Object.freeze(H)}else return Object.freeze({kind:"changed"})}U.create=T})(N=e.TaskEvent||(e.TaskEvent={}));var j;(function(U){function T(B){const Z=Object.keys(B).sort();let _="";for(const H of Z){let Y=B[H];Y instanceof Object?Y=T(Y):typeof Y=="string"&&(Y=Y.replace(/,/g,",,")),_+=H+","+Y+","}return _}function F(B){const _={_key:T(B),type:B.taskType};return Object.assign(_,B),_}U.create=F})(j=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var V;(function(U){U.AutoDetect="task.autoDetect",U.SaveBeforeRun="task.saveBeforeRun",U.ShowDecorations="task.showDecorations",U.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",U.SlowProviderWarning="task.slowProviderWarning",U.QuickOpenHistory="task.quickOpen.history",U.QuickOpenDetail="task.quickOpen.detail",U.QuickOpenSkip="task.quickOpen.skip",U.QuickOpenShowAll="task.quickOpen.showAll",U.AllowAutomaticTasks="task.allowAutomaticTasks",U.Reconnection="task.reconnection"})(V=e.TaskSettingId||(e.TaskSettingId={}));var Q;(function(U){U.Tasks="tasks",U.SuppressTaskName="tasks.suppressTaskName",U.Windows="tasks.windows",U.Osx="tasks.osx",U.Linux="tasks.linux",U.ShowOutput="tasks.showOutput",U.IsShellCommand="tasks.isShellCommand",U.ServiceTestSetting="tasks.service.testSetting"})(Q=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var x;(function(U){function T(F,B){const Z=A.TaskDefinitionRegistry.get(F.type);if(Z===void 0){const ie=R.deepClone(F);return delete ie._key,j.create(ie)}const _=Object.create(null);_.type=Z.taskType;const H=new Set;Z.required.forEach(ie=>H.add(ie));const Y=Z.properties;for(const ie of Object.keys(Y)){const ge=F[ie];if(ge!=null)_[ie]=ge;else if(H.has(ie)){const X=Y[ie];if(X.default!==void 0)_[ie]=R.deepClone(X.default);else switch(X.type){case"boolean":_[ie]=!1;break;case"number":case"integer":_[ie]=0;break;case"string":_[ie]="";break;default:B.error(a.localize(2,null,JSON.stringify(F,void 0,0),ie));return}}}return j.create(_)}U.createTaskIdentifier=T})(x=e.TaskDefinition||(e.TaskDefinition={}))}),define(ye[248],De([1,0,11]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class L{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((S,A)=>{this.b=S,this.d=A,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(S){this.f||this.h||(this.f=!0,this.g=S,this.a&&this.b(S))}resolveErr(S){this.f||this.h||(this.h=!0,this.i=S,this.a?this.d(S):(0,a.onUnexpectedError)(S))}then(S,A){return this.j().then(S,A)}catch(S){return this.j().then(void 0,S)}finally(S){return this.j().finally(S)}}e.LazyPromise=L;class l extends L{constructor(){super(),this.h=!0,this.i=new a.CancellationError}}e.CanceledLazyPromise=l}),define(ye[59],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class a{constructor(y){this._proxyIdentifierBrand=void 0,this.sid=y,this.nid=++a.count}}a.count=0,e.ProxyIdentifier=a;const L=[];function l(A){const y=new a(A);return L[y.nid]=y,y}e.createProxyIdentifier=l;function R(A){return L[A].sid}e.getStringIdentifierForProxy=R;class S{constructor(y){this.value=y}}e.SerializableObjectWithBuffers=S}),define(ye[5],De([1,0,59]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var L;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(L=e.TextEditorRevealType||(e.TextEditorRevealType={}));var l;(function(f){f[f.UnknownInput=0]="UnknownInput",f[f.TextInput=1]="TextInput",f[f.TextDiffInput=2]="TextDiffInput",f[f.TextMergeInput=3]="TextMergeInput",f[f.NotebookInput=4]="NotebookInput",f[f.NotebookDiffInput=5]="NotebookDiffInput",f[f.CustomEditorInput=6]="CustomEditorInput",f[f.WebviewEditorInput=7]="WebviewEditorInput",f[f.TerminalEditorInput=8]="TerminalEditorInput",f[f.InteractiveEditorInput=9]="InteractiveEditorInput"})(l=e.TabInputKind||(e.TabInputKind={}));var R;(function(f){f[f.TAB_OPEN=0]="TAB_OPEN",f[f.TAB_CLOSE=1]="TAB_CLOSE",f[f.TAB_UPDATE=2]="TAB_UPDATE",f[f.TAB_MOVE=3]="TAB_MOVE"})(R=e.TabModelOperationKind||(e.TabModelOperationKind={}));var S;(function(f){f[f.Editable=0]="Editable",f[f.SupportsHotExit=1]="SupportsHotExit"})(S=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var A;(function(f){f[f.Int8Array=1]="Int8Array",f[f.Uint8Array=2]="Uint8Array",f[f.Uint8ClampedArray=3]="Uint8ClampedArray",f[f.Int16Array=4]="Int16Array",f[f.Uint16Array=5]="Uint16Array",f[f.Int32Array=6]="Int32Array",f[f.Uint32Array=7]="Uint32Array",f[f.Float32Array=8]="Float32Array",f[f.Float64Array=9]="Float64Array",f[f.BigInt64Array=10]="BigInt64Array",f[f.BigUint64Array=11]="BigUint64Array"})(A=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var y;(function(f){f[f.Text=1]="Text",f[f.Error=2]="Error",f[f.Rich=3]="Rich"})(y=e.CellOutputKind||(e.CellOutputKind={}));var I;(function(f){f[f.Default=0]="Default",f[f.InCenter=1]="InCenter",f[f.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",f[f.AtTop=3]="AtTop"})(I=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var O;(function(f){f[f.None=0]="None",f[f.Process=1]="Process",f[f.Output=2]="Output"})(O=e.CandidatePortSource||(e.CandidatePortSource={}));class P{static mixin(u){return u._id=P.a++,u}}P.a=0,e.IdObject=P;var v;(function(f){f.label="a",f.kind="b",f.detail="c",f.documentation="d",f.sortText="e",f.filterText="f",f.preselect="g",f.insertText="h",f.insertTextRules="i",f.range="j",f.commitCharacters="k",f.additionalTextEdits="l",f.kindModifier="m",f.commandIdent="n",f.commandId="o",f.commandArguments="p"})(v=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var k;(function(f){f.defaultRanges="a",f.completions="b",f.isIncomplete="c",f.duration="d"})(k=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var D;(function(f){f[f.Workspace=0]="Workspace",f[f.TextDocument=1]="TextDocument"})(D=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,a.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,a.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,a.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,a.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,a.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,a.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,a.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,a.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,a.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,a.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,a.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,a.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,a.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,a.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,a.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,a.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,a.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,a.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,a.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,a.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,a.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,a.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,a.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,a.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,a.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,a.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickDiff:(0,a.createProxyIdentifier)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,a.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,a.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,a.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,a.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,a.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,a.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,a.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,a.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,a.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,a.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,a.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,a.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,a.createProxyIdentifier)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,a.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,a.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,a.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,a.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,a.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,a.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,a.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,a.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,a.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,a.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,a.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,a.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,a.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,a.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,a.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,a.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,a.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,a.createProxyIdentifier)("MainThreadTesting"),MainThreadLocalization:(0,a.createProxyIdentifier)("MainThreadLocalizationShape")},e.ExtHostContext={ExtHostCommands:(0,a.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,a.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,a.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,a.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,a.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,a.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,a.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,a.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,a.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,a.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,a.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,a.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,a.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,a.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,a.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,a.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,a.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,a.createProxyIdentifier)("ExtHostQuickDiff"),ExtHostExtensionService:(0,a.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,a.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,a.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,a.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,a.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,a.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,a.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,a.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,a.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,a.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,a.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,a.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,a.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,a.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,a.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,a.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,a.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,a.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,a.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,a.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,a.createProxyIdentifier)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,a.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,a.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,a.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,a.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,a.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,a.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,a.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,a.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,a.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,a.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,a.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,a.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,a.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,a.createProxyIdentifier)("ExtHostTelemetry"),ExtHostLocalization:(0,a.createProxyIdentifier)("ExtHostLocalization")}}),define(ye[78],De([1,0,4,13,5,18]),function(re,e,a,L,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,a.createDecorator)("IExtHostApiDeprecationService");let S=class{constructor(y,I){this.c=I,this.a=new Set,this.b=y.getProxy(l.MainContext.MainThreadTelemetry)}report(y,I,O){const P=this.d(y,I);this.a.has(P)||(this.a.add(P),I.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${y}' is deprecated. ${O}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:I.identifier.value,apiId:y}))}d(y,I){return`${y}-${I.identifier.value}`}};S=qe([ze(0,R.IExtHostRpcService),ze(1,L.ILogService)],S),e.ExtHostApiDeprecationService=S,e.NullApiDeprecationService=Object.freeze(new class{report(A,y,I){}})}),define(ye[249],De([1,0,3,5,7,27]),function(re,e,a,L,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class S{constructor(y){this.b=new Map,this.c=[],this.d=new a.Emitter,this.onDidChangeSessions=this.d.event,this.f=new Map,this.a=y.getProxy(L.MainContext.MainThreadAuthentication)}$setProviders(y){return this.c=y,Promise.resolve()}async getSession(y,I,O,P={}){const v=R.ExtensionIdentifier.toKey(y.identifier),k=this.f.get(v)||[],D=[...O].sort().join(" ");let f=k.find(u=>u.providerId===I&&u.scopes===D);if(f)return f.result;{const u=this.g(y,v,I,O,P);f={providerId:I,scopes:D,result:u},k.push(f),this.f.set(v,k);try{await u}finally{const h=k.findIndex(p=>p.providerId===I&&p.scopes===D);h>-1&&(k.splice(h),this.f.set(v,k))}return u}}async g(y,I,O,P,v={}){await this.a.$ensureProvider(O);const k=y.displayName||y.name;return this.a.$getSession(O,P,I,k,v)}async removeSession(y,I){const O=this.b.get(y);return O?O.provider.removeSession(I):this.a.$removeSession(y,I)}registerAuthenticationProvider(y,I,O,P){if(this.b.get(y))throw new Error(`An authentication provider with id '${y}' is already registered.`);this.b.set(y,{label:I,provider:O,options:P??{supportsMultipleAccounts:!1}}),this.c.find(k=>k.id===y)||this.c.push({id:y,label:I});const v=O.onDidChangeSessions(k=>{this.a.$sendDidChangeSessions(y,{added:k.added??[],changed:k.changed??[],removed:k.removed??[]})});return this.a.$registerAuthenticationProvider(y,I,P?.supportsMultipleAccounts??!1),new l.Disposable(()=>{v.dispose(),this.b.delete(y);const k=this.c.findIndex(D=>D.id===y);k>-1&&this.c.splice(k),this.a.$unregisterAuthenticationProvider(y)})}$createSession(y,I){const O=this.b.get(y);if(O)return Promise.resolve(O.provider.createSession(I));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$removeSession(y,I){const O=this.b.get(y);if(O)return Promise.resolve(O.provider.removeSession(I));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$getSessions(y,I){const O=this.b.get(y);if(O)return Promise.resolve(O.provider.getSessions(I));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$onDidChangeAuthenticationSessions(y,I){return this.d.fire({provider:{id:y,label:I}}),Promise.resolve()}}e.ExtHostAuthentication=S}),define(ye[250],De([1,0,5,18,14]),function(re,e,a,L,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let R=class{constructor(A,y){this.a=A.getProxy(a.MainContext.MainThreadBulkEdits),this.b={getTextDocumentVersion:I=>y.getDocument(I)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(A,y,I){const O=l.WorkspaceEdit.from(A,this.b);return this.a.$tryApplyWorkspaceEdit(O,void 0,I?.isRefactoring??!1)}};R=qe([ze(0,L.IExtHostRpcService)],R),e.ExtHostBulkEdits=R}),define(ye[251],De([1,0,5]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class L{constructor(R){const S=R.getProxy(a.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return S.$readText()},writeText(A){return S.$writeText(A)}})}}e.ExtHostClipboard=L});var _e=this&&this.__classPrivateFieldSet||function(re,e,a,L,l){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!l:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?l.call(re,a):l?l.value=a:e.set(re,a),a},Ue=this&&this.__classPrivateFieldGet||function(re,e,a,L){if(a==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!L:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?L:a==="a"?L.call(re):L?L.value:e.get(re)};define(ye[40],De([1,0,10,7,14,23,5,15,13,70,33,53,2,6,4,18,137,22,59,45,43,74,77]),function(re,e,a,L,l,R,S,A,y,I,O,P,v,k,D,f,u,h,p,b,C,g,i){"use strict";var s,r,o;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let c=class{constructor(w,N,j){s.set(this,void 0),this.b=new Map,this.c=new Map,r.set(this,void 0),o.set(this,void 0),_e(this,s,w.getProxy(S.MainContext.MainThreadCommands),"f"),this.d=N,_e(this,o,j,"f"),_e(this,r,w.getProxy(S.MainContext.MainThreadTelemetry),"f"),this.converter=new m(this,V=>{const Q=this.c.get(V);return Q?.result===t.Void?Q:void 0},N),this.f=[{processArgument(V){return(0,I.revive)(V)}},{processArgument(V){return(0,R.cloneAndChange)(V,function(Q){if(O.Range.isIRange(Q))return l.Range.to(Q);if(P.Position.isIPosition(Q))return l.Position.to(Q);if(O.Range.isIRange(Q.range)&&v.URI.isUri(Q.uri))return l.location.to(Q);if(Q instanceof h.VSBuffer)return Q.buffer.buffer;if(!Array.isArray(Q))return Q})}}]}registerArgumentProcessor(w){this.f.push(w)}registerApiCommand(w){const N=this.registerCommand(!1,w.id,async(...j)=>{const V=w.args.map((x,U)=>{if(!x.validate(j[U]))throw new Error(`Invalid argument '${x.name}' when running '${w.id}', received: ${j[U]}`);return x.convert(j[U])}),Q=await this.executeCommand(w.internalId,...V);return w.result.convert(Q,j,this.converter)},void 0,{description:w.description,args:w.args,returns:w.result.description});return this.c.set(w.id,w),new L.Disposable(()=>{N.dispose(),this.c.delete(w.id)})}registerCommand(w,N,j,V,Q,x){if(this.d.trace("ExtHostCommands#registerCommand",N),!N.trim().length)throw new Error("invalid id");if(this.b.has(N))throw new Error(`command '${N}' already exists`);return this.b.set(N,{callback:j,thisArg:V,description:Q,extension:x}),w&&Ue(this,s,"f").$registerCommand(N),new L.Disposable(()=>{this.b.delete(N)&&w&&Ue(this,s,"f").$unregisterCommand(N)})}executeCommand(w,...N){return this.d.trace("ExtHostCommands#executeCommand",w),this.g(w,N,!0)}async g(w,N,j){if(this.b.has(w))return Ue(this,s,"f").$fireCommandActivationEvent(w),this.h(w,N,!1);{let V=!1;const Q=(0,R.cloneAndChange)(N,function(x){if(x instanceof L.Position)return l.Position.from(x);if(x instanceof L.Range)return l.Range.from(x);if(x instanceof L.Location)return l.location.from(x);if(L.NotebookRange.isNotebookRange(x))return l.NotebookRange.from(x);if(x instanceof ArrayBuffer)return V=!0,h.VSBuffer.wrap(new Uint8Array(x));if(x instanceof Uint8Array)return V=!0,h.VSBuffer.wrap(x);if(x instanceof h.VSBuffer)return V=!0,x;if(!Array.isArray(x))return x});try{const x=await Ue(this,s,"f").$executeCommand(w,V?new p.SerializableObjectWithBuffers(Q):Q,j);return(0,I.revive)(x)}catch(x){if(x instanceof Error&&x.message==="$executeCommand:retry")return this.g(w,N,!1);throw x}}}async h(w,N,j){const V=this.b.get(w);if(!V)throw new Error("Unknown command");const{callback:Q,thisArg:x,description:U}=V;if(U)for(let F=0;F<U.args.length;F++)try{(0,a.validateConstraint)(N[F],U.args[F].constraint)}catch{throw new Error(`Running the contributed command: '${w}' failed. Illegal argument '${U.args[F].name}' - ${U.args[F].description}`)}const T=C.StopWatch.create();try{return await Q.apply(x,N)}catch(F){if(w===this.converter.delegatingCommandId){const B=this.converter.getActualCommand(...N);B&&(w=B.command)}if(this.d.error(F,w,V.extension?.identifier),!j)throw F;if(V.extension?.identifier){const B=Ue(this,o,"f").onExtensionError(V.extension.identifier,F);this.d.trace("forwarded error to extension?",B,V.extension?.identifier)}throw new class extends Error{constructor(){super((0,b.toErrorMessage)(F)),this.id=w,this.source=V.extension?.displayName??V.extension?.name}}}finally{this.j(V,w,T.elapsed())}}j(w,N,j){!w.extension||Ue(this,r,"f").$publicLog2("Extension:ActionExecuted",{extensionId:w.extension.identifier.value,id:new g.TelemetryTrustedValue(N),duration:j})}$executeContributedCommand(w,...N){this.d.trace("ExtHostCommands#$executeContributedCommand",w);const j=this.b.get(w);return j?(N=N.map(V=>this.f.reduce((Q,x)=>x.processArgument(Q,j.extension?.identifier),V)),this.h(w,N,!0)):Promise.reject(new Error(`Contributed command '${w}' does not exist.`))}getCommands(w=!1){return this.d.trace("ExtHostCommands#getCommands",w),Ue(this,s,"f").$getCommands().then(N=>(w&&(N=N.filter(j=>j[0]!=="_")),N))}$getContributedCommandHandlerDescriptions(){const w=Object.create(null);for(const[N,j]of this.b){const{description:V}=j;V&&(w[N]=V)}return Promise.resolve(w)}};s=new WeakMap,r=new WeakMap,o=new WeakMap,c=qe([ze(0,f.IExtHostRpcService),ze(1,y.ILogService),ze(2,i.IExtHostTelemetry)],c),e.ExtHostCommands=c,e.IExtHostCommands=(0,D.createDecorator)("IExtHostCommands");class m{constructor(w,N,j){this.d=w,this.f=N,this.g=j,this.delegatingCommandId=`__vsc${Date.now().toString(36)}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(w,N){if(!w)return;const j={$ident:void 0,id:w.command,title:w.title,tooltip:w.tooltip};if(!w.command)return j;const V=this.f(w.command);if(V)j.id=V.internalId,j.arguments=V.args.map((Q,x)=>Q.convert(w.arguments&&w.arguments[x]));else if((0,A.isNonEmptyArray)(w.arguments)){const Q=`${w.command}/${++this.c}`;this.b.set(Q,w),N.add((0,k.toDisposable)(()=>{this.b.delete(Q),this.g.trace("CommandsConverter#DISPOSE",Q)})),j.$ident=Q,j.id=this.delegatingCommandId,j.arguments=[Q],this.g.trace("CommandsConverter#CREATE",w.command,Q)}return j}fromInternal(w){return typeof w.$ident=="string"?this.b.get(w.$ident):{command:w.id,title:w.title,arguments:w.arguments}}getActualCommand(...w){return this.b.get(w[0])}h(...w){const N=this.getActualCommand(...w);return this.g.trace("CommandsConverter#EXECUTE",w[0],N?N.command:"MISSING"),N?this.d.executeCommand(N.command,...N.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${w[0]}`)}}e.CommandsConverter=m;class n{constructor(w,N,j,V){this.name=w,this.description=N,this.validate=j,this.convert=V}optional(){return new n(this.name,`(optional) ${this.description}`,w=>w==null||this.validate(w),w=>w===void 0?void 0:w===null?null:this.convert(w))}with(w,N){return new n(w??this.name,N??this.description,this.validate,this.convert)}}n.Uri=new n("uri","Uri of a text document",E=>v.URI.isUri(E),E=>E),n.Position=new n("position","A position in a text document",E=>L.Position.isPosition(E),l.Position.from),n.Range=new n("range","A range in a text document",E=>L.Range.isRange(E),l.Range.from),n.Selection=new n("selection","A selection in a text document",E=>L.Selection.isSelection(E),l.Selection.from),n.Number=new n("number","",E=>typeof E=="number",E=>E),n.String=new n("string","",E=>typeof E=="string",E=>E),n.CallHierarchyItem=new n("item","A call hierarchy item",E=>E instanceof L.CallHierarchyItem,l.CallHierarchyItem.from),n.TypeHierarchyItem=new n("item","A type hierarchy item",E=>E instanceof L.TypeHierarchyItem,l.TypeHierarchyItem.from),n.TestItem=new n("testItem","A VS Code TestItem",E=>E instanceof u.TestItemImpl,l.TestItem.from),e.ApiCommandArgument=n;class t{constructor(w,N){this.description=w,this.convert=N}}t.Void=new t("no result",E=>E),e.ApiCommandResult=t;class d{constructor(w,N,j,V,Q){this.id=w,this.internalId=N,this.description=j,this.args=V,this.result=Q}}e.ApiCommand=d}),define(ye[252],De([1,0,2,14,7,72,40,15,120,125,16]),function(re,e,a,L,l,R,S,A,y,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const P=[new S.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",k(L.DocumentHighlight.to))),new S.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(f,u)=>{if((0,A.isFalsyOrEmpty)(f))return;class h extends l.SymbolInformation{static to(b){const C=new h(b.name,L.SymbolKind.to(b.kind),b.containerName||"",new l.Location(u[0],L.Range.to(b.range)));return C.detail=b.detail,C.range=C.location.range,C.selectionRange=L.Range.to(b.selectionRange),C.children=b.children?b.children.map(h.to):[],C}}return f.map(h.to)})),new S.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("options","Formatting options",f=>!0,f=>f)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",k(L.TextEdit.to))),new S.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range,new S.ApiCommandArgument("options","Formatting options",f=>!0,f=>f)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",k(L.TextEdit.to))),new S.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,new S.ApiCommandArgument("ch","Trigger character",f=>typeof f=="string",f=>f),new S.ApiCommandArgument("options","Formatting options",f=>!0,f=>f)],new S.ApiCommandResult("A promise that resolves to an array of TextEdits.",k(L.TextEdit.to))),new S.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",D)),new S.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",D)),new S.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",D)),new S.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",D)),new S.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Location-instances.",k(L.location.to))),new S.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of Hover-instances.",k(L.Hover.to))),new S.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("position","A position in a text document",f=>Array.isArray(f)&&f.every(u=>l.Position.isPosition(u)),f=>f.map(L.Position.from))],new S.ApiCommandResult("A promise that resolves to an array of ranges.",f=>f.map(u=>{let h;for(const p of u.reverse())h=new l.SelectionRange(L.Range.to(p),h);return h}))),new S.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[S.ApiCommandArgument.String.with("query","Search string")],new S.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",f=>f.map(L.WorkspaceSymbol.to))),new S.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of CallHierarchyItem-instances",f=>f.map(L.CallHierarchyItem.to))),new S.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[S.ApiCommandArgument.CallHierarchyItem],new S.ApiCommandResult("A promise that resolves to an array of CallHierarchyIncomingCall-instances",f=>f.map(L.CallHierarchyIncomingCall.to))),new S.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[S.ApiCommandArgument.CallHierarchyItem],new S.ApiCommandResult("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",f=>f.map(L.CallHierarchyOutgoingCall.to))),new S.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to a range and placeholder text.",f=>{if(!!f)return{range:L.Range.to(f.range),placeholder:f.text}})),new S.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("newName","The new symbol name")],new S.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",f=>{if(!!f){if(f.rejectReason)throw new Error(f.rejectReason);return L.WorkspaceEdit.to(f)}})),new S.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new S.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",f=>f.map(L.DocumentLink.to))),new S.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",f=>{if(!!f)return new l.SemanticTokensLegend(f.tokenTypes,f.tokenModifiers)})),new S.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to SemanticTokens.",f=>{if(!f)return;const u=(0,y.decodeSemanticTokensDto)(f);if(u.type==="full")return new l.SemanticTokens(u.data,void 0)})),new S.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range.optional()],new S.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",f=>{if(!!f)return new l.SemanticTokensLegend(f.tokenTypes,f.tokenModifiers)})),new S.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to SemanticTokens.",f=>{if(!f)return;const u=(0,y.decodeSemanticTokensDto)(f);if(u.type==="full")return new l.SemanticTokens(u.data,void 0)})),new S.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),S.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new S.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(f,u,h)=>{if(!f)return new l.CompletionList([]);const p=f.suggestions.map(b=>L.CompletionItem.to(b,h));return new l.CompletionList(p,f.incomplete)})),new S.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position,S.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new S.ApiCommandResult("A promise that resolves to SignatureHelp.",f=>{if(f)return L.SignatureHelp.to(f)})),new S.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new S.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(f,u,h)=>k(p=>new l.CodeLens(L.Range.to(p.range),p.command&&h.fromInternal(p.command)))(f))),new S.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[S.ApiCommandArgument.Uri,new S.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",f=>l.Range.isRange(f),f=>l.Selection.isSelection(f)?L.Selection.from(f):L.Range.from(f)),S.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),S.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new S.ApiCommandResult("A promise that resolves to an array of Command-instances.",(f,u,h)=>k(p=>{if(p._isSynthetic){if(!p.command)throw new Error("Synthetic code actions must have a command");return h.fromInternal(p.command)}else{const b=new l.CodeAction(p.title,p.kind?new l.CodeActionKind(p.kind):void 0);return p.edit&&(b.edit=L.WorkspaceEdit.to(p.edit)),p.command&&(b.command=h.fromInternal(p.command)),b.isPreferred=p.isPreferred,b}})(f))),new S.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",f=>f?f.map(u=>new l.ColorInformation(L.Range.to(u.range),L.Color.to(u.color))):[])),new S.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new S.ApiCommandArgument("color","The color to show and insert",f=>f instanceof l.Color,L.Color.from),new S.ApiCommandArgument("context","Context object with uri and range",f=>!0,f=>({uri:f.uri,range:L.Range.from(f.range)}))],new S.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",f=>f?f.map(L.ColorPresentation.to):[])),new S.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to an array of Inlay objects",(f,u,h)=>f.map(L.InlayHint.to.bind(void 0,h)))),new S.ApiCommand("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[S.ApiCommandArgument.Uri],new S.ApiCommandResult("A promise that resolves to an array of FoldingRange objects",(f,u)=>{if(f)return f.map(L.FoldingRange.to)})),new S.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new S.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",k(f=>({viewType:f.viewType,displayName:f.displayName,options:{transientOutputs:f.options.transientOutputs,transientCellMetadata:f.options.transientCellMetadata,transientDocumentMetadata:f.options.transientDocumentMetadata},filenamePattern:f.filenamePattern.map(u=>L.NotebookExclusiveDocumentPattern.to(u))})))),new S.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Range],new S.ApiCommandResult("A promise that resolves to an array of InlineValue objects",f=>f.map(L.InlineValue.to))),new S.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new S.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",f=>a.URI.isUri(f)||typeof f=="string"&&(0,I.matchesSomeScheme)(f,O.Schemas.http,O.Schemas.https),f=>f),new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",f=>f===void 0||typeof f=="number"||typeof f=="object",f=>f&&(typeof f=="number"?[L.ViewColumn.from(f),void 0]:[L.ViewColumn.from(f.viewColumn),L.TextEditorOpenOptions.from(f)])).optional(),S.ApiCommandArgument.String.with("label","").optional()],S.ApiCommandResult.Void),new S.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[S.ApiCommandArgument.Uri.with("resource","Resource to open"),S.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",f=>f===void 0||typeof f=="number"||typeof f=="object",f=>f&&(typeof f=="number"?[L.ViewColumn.from(f),void 0]:[L.ViewColumn.from(f.viewColumn),L.TextEditorOpenOptions.from(f)])).optional()],S.ApiCommandResult.Void),new S.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[S.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),S.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),S.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new S.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",f=>f===void 0||typeof f=="object",f=>f&&[L.ViewColumn.from(f.viewColumn),L.TextEditorOpenOptions.from(f)]).optional()],S.ApiCommandResult.Void),new S.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[S.ApiCommandArgument.Uri,S.ApiCommandArgument.Position],new S.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",f=>f.map(L.TypeHierarchyItem.to))),new S.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[S.ApiCommandArgument.TypeHierarchyItem],new S.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",f=>f.map(L.TypeHierarchyItem.to))),new S.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[S.ApiCommandArgument.TypeHierarchyItem],new S.ApiCommandResult("A promise that resolves to an array of TypeHierarchyItem-instances",f=>f.map(L.TypeHierarchyItem.to))),new S.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[S.ApiCommandArgument.TestItem],S.ApiCommandResult.Void),new S.ApiCommand("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[S.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],S.ApiCommandResult.Void),new S.ApiCommand("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[S.ApiCommandArgument.String.with("name","The context key name"),new S.ApiCommandArgument("value","The context key value",()=>!0,f=>f)],S.ApiCommandResult.Void)];class v{static register(u){P.forEach(u.registerApiCommand,u)}}e.ExtHostApiCommands=v;function k(f){return u=>{if(Array.isArray(u))return u.map(f)}}function D(f){if(!Array.isArray(f))return;const u=[];for(const h of f)R.isLocationLink(h)?u.push(L.DefinitionLink.to(h)):u.push(L.location.to(h));return u}}),define(ye[253],De([1,0,17,63,3,6,2,72,27,14,7,5]),function(re,e,a,L,l,R,S,A,y,I,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function v(k,D,f){const u=k.getProxy(P.MainContext.MainThreadComments);class h{constructor(){this.b=new Map,this.c=new Map,D.registerArgumentProcessor({processArgument:c=>{if(c&&c.$mid===6){const m=this.b.get(c.handle);return m?m.value:c}else if(c&&c.$mid===7){const m=this.b.get(c.commentControlHandle);if(!m)return c;const n=m.getCommentThread(c.commentThreadHandle);return n?n.value:c}else if(c&&(c.$mid===9||c.$mid===8)){const m=this.b.get(c.thread.commentControlHandle);if(!m)return c;const n=m.getCommentThread(c.thread.commentThreadHandle);return n?c.$mid===8?n.value:{thread:n.value,text:c.text}:c}else if(c&&c.$mid===10){const m=this.b.get(c.thread.commentControlHandle);if(!m)return c;const n=m.getCommentThread(c.thread.commentThreadHandle);if(!n)return c;const t=c.commentUniqueId,d=n.getCommentByUniqueId(t);return d||c}else if(c&&c.$mid===11){const m=this.b.get(c.thread.commentControlHandle);if(!m)return c;const n=m.getCommentThread(c.thread.commentThreadHandle);if(!n)return c;const t=c.text,d=c.commentUniqueId,E=n.getCommentByUniqueId(d);return E?(typeof E.body=="string"?E.body=t:E.body=new O.MarkdownString(t),E):c}return c}})}createCommentController(c,m,n){const t=h.a++,d=new b(c,t,m,n);this.b.set(d.handle,d);const E=this.c.get(y.ExtensionIdentifier.toKey(c.identifier))||[];return E.push(d),this.c.set(y.ExtensionIdentifier.toKey(c.identifier),E),d.value}$createCommentThreadTemplate(c,m,n){const t=this.b.get(c);!t||t.$createCommentThreadTemplate(m,n)}async $updateCommentThreadTemplate(c,m,n){const t=this.b.get(c);!t||t.$updateCommentThreadTemplate(m,n)}$deleteCommentThread(c,m){this.b.get(c)?.$deleteCommentThread(m)}$provideCommentingRanges(c,m,n){const t=this.b.get(c);if(!t||!t.commentingRangeProvider)return Promise.resolve(void 0);const d=f.getDocument(S.URI.revive(m));return(0,a.asPromise)(()=>t.commentingRangeProvider.provideCommentingRanges(d,n)).then(E=>E?E.map(w=>I.Range.from(w)):void 0)}$toggleReaction(c,m,n,t,d){const E=this.b.get(c);return!E||!E.reactionHandler?Promise.resolve(void 0):(0,a.asPromise)(()=>{const w=E.getCommentThread(m);if(w){const N=w.getCommentByUniqueId(t.uniqueIdInThread);if(E!==void 0&&N&&E.reactionHandler)return E.reactionHandler(N,i(d))}return Promise.resolve(void 0)})}dispose(){}}h.a=0;class p{set threadId(c){this.n=c}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(c){c.isEqual(this.p)||(this.p=c,this.b.range=c,this.c.fire())}get range(){return this.p}set canReply(c){this.d!==c&&(this.d=c,this.b.canReply=c,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(c){this.e=c,this.b.label=c,this.c.fire()}get contextValue(){return this.f}set contextValue(c){this.f=c,this.b.contextValue=c,this.c.fire()}get comments(){return this.q}set comments(c){this.q=c,this.b.comments=c,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(c){this.g=c,this.b.collapsibleState=c,this.c.fire()}get state(){return this.h}set state(c){this.h=c,this.b.state=c,this.c.fire()}get isDisposed(){return this.j}constructor(c,m,n,t,d,E,w,N){this.m=m,this.n=n,this.o=t,this.p=d,this.q=E,this.extensionDescription=w,this.r=N,this.handle=p.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new l.Emitter,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new R.MutableDisposable,this.l.value=new R.DisposableStore,this.n===void 0&&(this.n=`${c}.${this.handle}`),u.$createCommentThread(m,this.handle,this.n,this.o,I.Range.from(this.p),w.identifier,this.r),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=E,this.i.push({dispose:()=>{u.$deleteCommentThread(m,this.handle)}});const j=this;this.value={get uri(){return j.uri},get range(){return j.range},set range(V){j.range=V},get comments(){return j.comments},set comments(V){j.comments=V},get collapsibleState(){return j.collapsibleState},set collapsibleState(V){j.collapsibleState=V},get canReply(){return j.canReply},set canReply(V){j.canReply=V},get contextValue(){return j.contextValue},set contextValue(V){j.contextValue=V},get label(){return j.label},set label(V){j.label=V},get state(){return j.state},set state(V){j.state=V},dispose:()=>{j.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new R.DisposableStore);const c=n=>Object.prototype.hasOwnProperty.call(this.b,n),m={};c("range")&&(m.range=I.Range.from(this.p)),c("label")&&(m.label=this.label),c("contextValue")&&(m.contextValue=this.contextValue??null),c("comments")&&(m.comments=this.q.map(n=>C(this,n,this.k))),c("collapsibleState")&&(m.collapseState=s(this.g)),c("canReply")&&(m.canReply=this.canReply),c("state")&&(m.state=r(this.h)),c("isTemplate")&&(m.isTemplate=this.r),this.b={},u.$updateCommentThread(this.m,this.handle,this.n,this.o,m)}getCommentByUniqueId(c){for(const m of this.k){const n=m[0],t=m[1];if(c===t)return n}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(c=>c.dispose())}}p.a=0,qe([(0,L.debounce)(100)],p.prototype,"eventuallyUpdateCommentThread",null);class b{get id(){return this.h}get label(){return this.i}get handle(){return this.g}get commentingRangeProvider(){return this.b}set commentingRangeProvider(c){this.b=c,u.$updateCommentingRanges(this.handle)}get reactionHandler(){return this.c}set reactionHandler(c){this.c=c,u.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!c})}get options(){return this.d}set options(c){this.d=c,u.$updateCommentControllerFeatures(this.handle,{options:this.d})}constructor(c,m,n,t){this.f=c,this.g=m,this.h=n,this.i=t,this.a=new Map,u.$registerCommentController(this.handle,n,t);const d=this;this.value=Object.freeze({id:d.id,label:d.label,get options(){return d.options},set options(E){d.options=E},get commentingRangeProvider(){return d.commentingRangeProvider},set commentingRangeProvider(E){d.commentingRangeProvider=E},get reactionHandler(){return d.reactionHandler},set reactionHandler(E){d.reactionHandler=E},createCommentThread(E,w,N){return d.createCommentThread(E,w,N).value},dispose:()=>{d.dispose()}}),this.e=[],this.e.push({dispose:()=>{u.$unregisterCommentController(this.handle)}})}createCommentThread(c,m,n,t){if(typeof c=="string"){const d=new p(this.id,this.handle,c,m,n,t,this.f,!1);return this.a.set(d.handle,d),d}else{const d=new p(this.id,this.handle,void 0,c,m,n,this.f,!1);return this.a.set(d.handle,d),d}}$createCommentThreadTemplate(c,m){const n=new p(this.id,this.handle,void 0,S.URI.revive(c),I.Range.to(m),[],this.f,!0);return n.collapsibleState=A.CommentThreadCollapsibleState.Expanded,this.a.set(n.handle,n),n}$updateCommentThreadTemplate(c,m){const n=this.a.get(c);n&&(n.range=I.Range.to(m))}$deleteCommentThread(c){this.a.get(c)?.dispose(),this.a.delete(c)}getCommentThread(c){return this.a.get(c)}dispose(){this.a.forEach(c=>{c.dispose()}),this.e.forEach(c=>c.dispose())}}function C(o,c,m){let n=m.get(c);n||(n=++o.commentHandle,m.set(c,n));const t=c.author&&c.author.iconPath?c.author.iconPath.toString():void 0;return{mode:c.mode,contextValue:c.contextValue,uniqueIdInThread:n,body:typeof c.body=="string"?c.body:I.MarkdownString.from(c.body),userName:c.author.name,userIconPath:t,label:c.label,commentReactions:c.reactions?c.reactions.map(d=>g(d)):void 0,timestamp:c.timestamp?.toJSON()}}function g(o){return{label:o.label,iconPath:o.iconPath?I.pathOrURIToURI(o.iconPath):void 0,count:o.count,hasReacted:o.authorHasReacted}}function i(o){return{label:o.label||"",count:o.count||0,iconPath:o.iconPath?S.URI.revive(o.iconPath):"",authorHasReacted:o.hasReacted||!1}}function s(o){if(o!==void 0)switch(o){case O.CommentThreadCollapsibleState.Expanded:return A.CommentThreadCollapsibleState.Expanded;case O.CommentThreadCollapsibleState.Collapsed:return A.CommentThreadCollapsibleState.Collapsed}return A.CommentThreadCollapsibleState.Collapsed}function r(o){if(o!==void 0)switch(o){case O.CommentThreadState.Unresolved:return A.CommentThreadState.Unresolved;case O.CommentThreadState.Resolved:return A.CommentThreadState.Resolved}return A.CommentThreadState.Unresolved}return new h}e.createExtHostComments=v}),define(ye[254],De([1,0,23,5,25,18]),function(re,e,a,L,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let S=class{constructor(O,P){this.a=O.getProxy(L.MainContext.MainThreadConsole),this.b=P.consoleForward.includeStack,this.c=P.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("error","error")}d(O,P){const v=this,k=console[O];Object.defineProperty(console,O,{set:()=>{},get:()=>function(){v.e(O,P,k,arguments)}})}e(O,P,v,k){this.a.$logExtensionHostMessage({type:"__$console",severity:P,arguments:y(k,this.b)}),this.c&&this.f(O,v,k)}};S=qe([ze(0,R.IExtHostRpcService),ze(1,l.IExtHostInitDataService)],S),e.AbstractExtHostConsoleForwarder=S;const A=1e5;function y(I,O){const P=[];if(I.length)for(let v=0;v<I.length;v++){let k=I[v];if(typeof k>"u")k="undefined";else if(k instanceof Error){const D=k;D.stack?k=D.stack:k=D.toString()}P.push(k)}if(O){const v=new Error().stack;v&&P.push({__$stack:v.split(`
`).slice(3).join(`
`)})}try{const v=(0,a.safeStringify)(P);return v.length>A?"Output omitted for a large object that exceeds the limits":v}catch(v){return`Output omitted for an object that cannot be inspected ('${v.toString()}')`}}}),define(ye[139],De([1,0,2,5,7,4,18,13,15,8,9,26]),function(re,e,a,L,l,R,S,A,y,I,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let v=class Mi{constructor(D,f){this.h=f,this.f=new Map,this.g=D.getProxy(L.MainContext.MainThreadDecorations)}registerFileDecorationProvider(D,f){const u=Mi.c++;this.f.set(u,{provider:D,extensionDescription:f}),this.g.$registerDecorationProvider(u,f.identifier.value);const h=D.onDidChangeFileDecorations&&D.onDidChangeFileDecorations(p=>{if(!p){this.g.$onDidChange(u,null);return}const b=(0,y.asArray)(p);if(b.length<=Mi.d){this.g.$onDidChange(u,b);return}this.h.warn("[Decorations] CAPPING events from decorations provider",f.identifier.value,b.length);const C=b.map(s=>({uri:s,rank:(0,I.count)(s.path,"/")})),g=(0,y.groupBy)(C,(s,r)=>s.rank-r.rank||(0,I.compare)(s.uri.path,r.uri.path)),i=[];e:for(const s of g){let r;for(const o of s){const c=(0,O.dirname)(o.uri.path);if(r!==c&&(r=c,i.push(o.uri)>=Mi.d))break e}}this.g.$onDidChange(u,i)});return new l.Disposable(()=>{h?.dispose(),this.g.$unregisterDecorationProvider(u),this.f.delete(u)})}async $provideDecorations(D,f,u){if(!this.f.has(D))return Object.create(null);const h=Object.create(null),{provider:p,extensionDescription:b}=this.f.get(D);return await Promise.all(f.map(async C=>{try{const{uri:g,id:i}=C,s=await Promise.resolve(p.provideFileDecoration(a.URI.revive(g),u));if(!s)return;try{l.FileDecoration.validate(s),s.badge&&typeof s.badge!="string"&&(0,P.checkProposedApiEnabled)(b,"codiconDecoration"),h[i]=[s.propagate,s.tooltip,s.badge,s.color]}catch(r){this.h.warn(`INVALID decoration from extension '${b}': ${r}`)}}catch(g){this.h.error(g)}})),h}};v.c=0,v.d=250,v=qe([ze(0,S.IExtHostRpcService),ze(1,A.ILogService)],v),e.ExtHostDecorations=v,e.IExtHostDecorations=(0,R.createDecorator)("IExtHostDecorations")});var _e=this&&this.__classPrivateFieldSet||function(re,e,a,L,l){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!l:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?l.call(re,a):l?l.value=a:e.set(re,a),a},Ue=this&&this.__classPrivateFieldGet||function(re,e,a,L){if(a==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!L:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?L:a==="a"?L.call(re):L?L.value:e.get(re)};define(ye[255],De([1,0,176,124,2,5,7,14,3,13,28,48]),function(re,e,a,L,l,R,S,A,y,I,O,P){"use strict";var v,k,D;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class f{constructor(p,b,C,g,i,s,r){this.d=p,this.e=b,this.f=C,this.g=g,v.set(this,void 0),k.set(this,void 0),D.set(this,void 0),this.c=!1,_e(this,D,new O.ResourceMap(o=>i.getComparisonKey(o)),"f"),_e(this,v,s,"f"),_e(this,k,r,"f")}dispose(){this.c||(Ue(this,k,"f").fire([...Ue(this,D,"f").keys()]),Ue(this,v,"f")?.$clear(this.e),Ue(this,D,"f").clear(),this.c=!0)}get name(){return this.h(),this.d}set(p,b){if(!p){this.clear();return}this.h();let C=[];if(l.URI.isUri(p)){if(!b){this.delete(p);return}Ue(this,D,"f").set(p,b.slice()),C=[p]}else if(Array.isArray(p)){C=[];let i;p=[...p].sort(f.j);for(const s of p){const[r,o]=s;if((!i||r.toString()!==i.toString())&&(i&&Ue(this,D,"f").get(i).length===0&&Ue(this,D,"f").delete(i),i=r,C.push(r),Ue(this,D,"f").set(r,[])),o)Ue(this,D,"f").get(r)?.push(...o);else{const c=Ue(this,D,"f").get(r);c&&(c.length=0)}}}if(Ue(this,k,"f").fire(C),!Ue(this,v,"f"))return;const g=[];for(const i of C){let s=[];const r=Ue(this,D,"f").get(i);if(r)if(r.length>this.f){s=[];const o=[S.DiagnosticSeverity.Error,S.DiagnosticSeverity.Warning,S.DiagnosticSeverity.Information,S.DiagnosticSeverity.Hint];e:for(let c=0;c<4;c++)for(const m of r)if(m.severity===o[c]&&s.push({...A.Diagnostic.from(m),modelVersionId:this.g(i)})===this.f)break e;s.push({severity:L.MarkerSeverity.Info,message:(0,a.localize)(0,null,r.length-this.f),startLineNumber:s[s.length-1].startLineNumber,startColumn:s[s.length-1].startColumn,endLineNumber:s[s.length-1].endLineNumber,endColumn:s[s.length-1].endColumn})}else s=r.map(o=>({...A.Diagnostic.from(o),modelVersionId:this.g(i)}));g.push([i,s])}Ue(this,v,"f").$changeMany(this.e,g)}delete(p){this.h(),Ue(this,k,"f").fire([p]),Ue(this,D,"f").delete(p),Ue(this,v,"f")?.$changeMany(this.e,[[p,void 0]])}clear(){this.h(),Ue(this,k,"f").fire([...Ue(this,D,"f").keys()]),Ue(this,D,"f").clear(),Ue(this,v,"f")?.$clear(this.e)}forEach(p,b){this.h();for(const[C,g]of this)p.call(b,C,g,this)}*[(v=new WeakMap,k=new WeakMap,D=new WeakMap,Symbol.iterator)](){this.h();for(const p of Ue(this,D,"f").keys())yield[p,this.get(p)]}get(p){this.h();const b=Ue(this,D,"f").get(p);return Array.isArray(b)?Object.freeze(b.slice(0)):[]}has(p){return this.h(),Array.isArray(Ue(this,D,"f").get(p))}h(){if(this.c)throw new Error("illegal state - object is disposed")}static j(p,b){return p[0].toString()<b[0].toString()?-1:p[0].toString()>b[0].toString()?1:0}}e.DiagnosticCollection=f;let u=class pi{static _mapper(p){const b=new O.ResourceMap;for(const C of p)b.set(C,C);return{uris:Object.freeze(Array.from(b.values()))}}constructor(p,b,C,g){this.h=b,this.j=C,this.k=g,this.f=new Map,this.g=new y.DebounceEmitter({merge:i=>i.flat(),delay:50}),this.onDidChangeDiagnostics=y.Event.map(this.g.event,pi._mapper),this.e=p.getProxy(R.MainContext.MainThreadDiagnostics)}createDiagnosticCollection(p,b){const{f:C,e:g,g:i,h:s,j:r,k:o}=this,c=new class{$changeMany(t,d){g.$changeMany(t,d),s.trace("[DiagnosticCollection] change many (extension, owner, uris)",p.value,t,d.length===0?"CLEARING":d)}$clear(t){g.$clear(t),s.trace("[DiagnosticCollection] remove all (extension, owner)",p.value,t)}dispose(){g.dispose()}};let m;if(!b)b="_generated_diagnostic_collection_name_#"+pi.c++,m=b;else if(!C.has(b))m=b;else{this.h.warn(`DiagnosticCollection with name '${b}' does already exist.`);do m=b+pi.c++;while(C.has(m))}return new class extends f{constructor(){super(b,m,pi.d,t=>o.getDocument(t)?.version,r.extUri,c,i),C.set(m,this)}dispose(){super.dispose(),C.delete(m)}}}getDiagnostics(p){if(p)return this.l(p);{const b=new Map,C=[];for(const g of this.f.values())g.forEach((i,s)=>{let r=b.get(i.toString());typeof r>"u"&&(r=C.length,b.set(i.toString(),r),C.push([i,[]])),C[r][1]=C[r][1].concat(...s)});return C}}l(p){let b=[];for(const C of this.f.values())C.has(p)&&(b=b.concat(C.get(p)));return b}$acceptMarkersChange(p){if(!this.m){const b="_generated_mirror",C=new f(b,b,pi.d,g=>{},this.j.extUri,void 0,this.g);this.f.set(b,C),this.m=C}for(const[b,C]of p)this.m.set(l.URI.revive(b),C.map(A.Diagnostic.to))}};u.c=0,u.d=1e3,u=qe([ze(1,I.ILogService),ze(2,P.IExtHostFileSystemInfo)],u),e.ExtHostDiagnostics=u}),define(ye[256],De([1,0,2,5,26]),function(re,e,a,L,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class R{constructor(A){this.a=A.getProxy(L.MainContext.MainThreadDialogs)}showOpenDialog(A,y){return y?.allowUIResources&&(0,l.checkProposedApiEnabled)(A,"showLocal"),this.a.$showOpenDialog(y).then(I=>I?I.map(O=>a.URI.revive(O)):void 0)}showSaveDialog(A){return this.a.$showSaveDialog(A).then(y=>y?a.URI.revive(y):void 0)}}e.ExtHostDialogs=R}),define(ye[257],De([1,0,11,2,7,5,16,21,8]),function(re,e,a,L,l,R,S,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class I{constructor(P,v,k){this.d=v,this.e=k,this.b=new Map,this.c=P.getProxy(R.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(P,v){if(Object.keys(S.Schemas).indexOf(P)>=0)throw new Error(`scheme '${P}' already registered`);const k=I.a++;this.b.set(k,v),this.c.$registerTextContentProvider(k,P);let D;return typeof v.onDidChange=="function"&&(D=v.onDidChange(f=>{if(f.scheme!==P){this.e.warn(`Provider for scheme '${P}' is firing event for schema '${f.scheme}' which will be IGNORED`);return}this.d.getDocument(f)&&this.$provideTextDocumentContent(k,f).then(u=>{if(!u&&typeof u!="string")return;const h=this.d.getDocument(f);if(!h)return;const p=(0,y.splitLines)(u);if(!h.equalLines(p))return this.c.$onVirtualDocumentChange(f,u)},a.onUnexpectedError)})),new l.Disposable(()=>{this.b.delete(k)&&this.c.$unregisterTextContentProvider(k),D&&(D.dispose(),D=void 0)})}$provideTextDocumentContent(P,v){const k=this.b.get(P);return k?Promise.resolve(k.provideTextDocumentContent(L.URI.revive(v),A.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${v.scheme}`))}}I.a=0,e.ExtHostDocumentContentProvider=I}),define(ye[258],De([1,0,3,6,2,5,135,14,10,23,7]),function(re,e,a,L,l,R,S,A,y,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class P{constructor(k,D){this.a=new a.Emitter,this.b=new a.Emitter,this.c=new a.Emitter,this.d=new a.Emitter,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new L.DisposableStore,this.h=new Map,this.f=k.getProxy(R.MainContext.MainThreadDocuments),this.g=D,this.g.onDidRemoveDocuments(f=>{for(const u of f)this.b.fire(u.document)},void 0,this.e),this.g.onDidAddDocuments(f=>{for(const u of f)this.a.fire(u.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(k){if(!k)return;const D=this.g.getDocument(k);if(D)return D}getDocument(k){const D=this.getDocumentData(k);if(!D?.document)throw new Error(`Unable to retrieve document from URI '${k}'`);return D.document}ensureDocumentData(k){const D=this.g.getDocument(k);if(D)return Promise.resolve(D);let f=this.h.get(k.toString());return f||(f=this.f.$tryOpenDocument(k).then(u=>{this.h.delete(k.toString());const h=l.URI.revive(u);return(0,y.assertIsDefined)(this.g.getDocument(h))},u=>(this.h.delete(k.toString()),Promise.reject(u))),this.h.set(k.toString(),f)),f}createDocumentData(k){return this.f.$tryCreateDocument(k).then(D=>l.URI.revive(D))}$acceptModelLanguageChanged(k,D){const f=l.URI.revive(k),u=this.g.getDocument(f);if(!u)throw new Error("unknown document");this.b.fire(u.document),u._acceptLanguageId(D),this.a.fire(u.document)}$acceptModelSaved(k){const D=l.URI.revive(k),f=this.g.getDocument(D);if(!f)throw new Error("unknown document");this.$acceptDirtyStateChanged(k,!1),this.d.fire(f.document)}$acceptDirtyStateChanged(k,D){const f=l.URI.revive(k),u=this.g.getDocument(f);if(!u)throw new Error("unknown document");u._acceptIsDirty(D),this.c.fire({document:u.document,contentChanges:[],reason:void 0})}$acceptModelChanged(k,D,f){const u=l.URI.revive(k),h=this.g.getDocument(u);if(!h)throw new Error("unknown document");h._acceptIsDirty(f),h.onEvents(D);let p;D.isUndoing?p=O.TextDocumentChangeReason.Undo:D.isRedoing&&(p=O.TextDocumentChangeReason.Redo),this.c.fire((0,I.deepFreeze)({document:h.document,contentChanges:D.changes.map(b=>({range:A.Range.to(b.range),rangeOffset:b.rangeOffset,rangeLength:b.rangeLength,text:b.text})),reason:p}))}setWordDefinitionFor(k,D){(0,S.setWordDefinitionFor)(k,D)}}e.ExtHostDocuments=P}),define(ye[60],De([1,0,50,3,6,2,4,5,135,18,138,14,13,28,16,65,66]),function(re,e,a,L,l,R,S,A,y,I,O,P,v,k,D,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class h{constructor(C){this.value=C,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let p=class{constructor(C,g){this.h=C,this.i=g,this.a=null,this.b=new Map,this.c=new k.ResourceMap,this.d=new L.Emitter,this.e=new L.Emitter,this.f=new L.Emitter,this.g=new L.Emitter,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(C){this.acceptDocumentsAndEditorsDelta(C)}acceptDocumentsAndEditorsDelta(C){const g=[],i=[],s=[];if(C.removedDocuments)for(const r of C.removedDocuments){const o=R.URI.revive(r),c=this.c.get(o);c?.unref()&&(this.c.delete(o),g.push(c.value))}if(C.addedDocuments)for(const r of C.addedDocuments){const o=R.URI.revive(r.uri);let c=this.c.get(o);if(c&&o.scheme!==D.Schemas.vscodeNotebookCell&&o.scheme!==D.Schemas.vscodeInteractiveInput)throw new Error(`document '${o} already exists!'`);c||(c=new h(new y.ExtHostDocumentData(this.h.getProxy(A.MainContext.MainThreadDocuments),o,r.lines,r.EOL,r.versionId,r.languageId,r.isDirty,r.notebook)),this.c.set(o,c),i.push(c.value)),c.ref()}if(C.removedEditors)for(const r of C.removedEditors){const o=this.b.get(r);this.b.delete(r),o&&s.push(o)}if(C.addedEditors)for(const r of C.addedEditors){const o=R.URI.revive(r.documentUri);a.ok(this.c.has(o),`document '${o}' does not exist`),a.ok(!this.b.has(r.id),`editor '${r.id}' already exists!`);const c=this.c.get(o).value,m=new O.ExtHostTextEditor(r.id,this.h.getProxy(A.MainContext.MainThreadTextEditors),this.i,new u.Lazy(()=>c.document),r.selections.map(P.Selection.to),r.options,r.visibleRanges.map(n=>P.Range.to(n)),typeof r.editorPosition=="number"?P.ViewColumn.to(r.editorPosition):void 0);this.b.set(r.id,m)}C.newActiveEditor!==void 0&&(a.ok(C.newActiveEditor===null||this.b.has(C.newActiveEditor),`active editor '${C.newActiveEditor}' does not exist`),this.a=C.newActiveEditor),(0,l.dispose)(g),(0,l.dispose)(s),C.removedDocuments&&this.e.fire(g),C.addedDocuments&&this.d.fire(i),(C.removedEditors||C.addedEditors)&&this.f.fire(this.allEditors().map(r=>r.value)),C.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(C){return this.c.get(C)?.value}allDocuments(){return f.Iterable.map(this.c.values(),C=>C.value)}getEditor(C){return this.b.get(C)}activeEditor(C){if(!this.a)return;const g=this.b.get(this.a);return C?g:g?.value}allEditors(){return[...this.b.values()]}};p=qe([ze(0,I.IExtHostRpcService),ze(1,v.ILogService)],p),e.ExtHostDocumentsAndEditors=p,e.IExtHostDocumentsAndEditors=(0,S.createDecorator)("IExtHostDocumentsAndEditors")}),define(ye[61],De([1,0,14,5,2,3,4,7,18,10,62]),function(re,e,a,L,l,R,S,A,y,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,S.createDecorator)("IExtHostEditorTabs");class P{constructor(u,h,p){this.e=p,this.d=h,this.acceptDtoUpdate(u)}get apiObject(){if(!this.a){const u=this,h={get isActive(){return u.b.id===u.e()},get label(){return u.b.label},get input(){return u.c},get isDirty(){return u.b.isDirty},get isPinned(){return u.b.isPinned},get isPreview(){return u.b.isPreview},get group(){return u.d.apiObject}};this.a=Object.freeze(h)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(u){this.b=u,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new A.TextTabInput(l.URI.revive(this.b.input.uri));case 2:return new A.TextDiffTabInput(l.URI.revive(this.b.input.original),l.URI.revive(this.b.input.modified));case 3:return new A.TextMergeTabInput(l.URI.revive(this.b.input.base),l.URI.revive(this.b.input.input1),l.URI.revive(this.b.input.input2),l.URI.revive(this.b.input.result));case 6:return new A.CustomEditorTabInput(l.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new A.WebviewEditorTabInput(this.b.input.viewType);case 4:return new A.NotebookEditorTabInput(l.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new A.NotebookDiffEditorTabInput(l.URI.revive(this.b.input.original),l.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new A.TerminalEditorTabInput;case 9:return new A.InteractiveWindowInput(l.URI.revive(this.b.input.uri),l.URI.revive(this.b.input.inputBoxUri));default:return}}}class v{constructor(u,h){this.c=[],this.d="",this.b=u,this.e=h;for(const p of u.tabs)p.isActive&&(this.d=p.id),this.c.push(new P(p,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const u=this,h={get isActive(){return u.b.groupId===u.e()},get viewColumn(){return a.ViewColumn.to(u.b.viewColumn)},get activeTab(){return u.c.find(p=>p.tabId===u.d)?.apiObject},get tabs(){return Object.freeze(u.c.map(p=>p.apiObject))}};this.a=Object.freeze(h)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(u){this.b=u}acceptTabOperation(u){if(u.kind===0){const p=new P(u.tabDto,this,()=>this.activeTabId());return this.c.splice(u.index,0,p),u.tabDto.isActive&&(this.d=p.tabId),p}else if(u.kind===1){const p=this.c.splice(u.index,1)[0];if(!p)throw new Error(`Tab close updated received for index ${u.index} which does not exist`);return p.tabId===this.d&&(this.d=""),p}else if(u.kind===3){if(u.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const p=this.c.splice(u.oldIndex,1)[0];if(!p)throw new Error(`Tab move updated received for index ${u.oldIndex} which does not exist`);return this.c.splice(u.index,0,p),p}const h=this.c.find(p=>p.tabId===u.tabDto.id);if(!h)throw new Error("INVALID tab");return u.tabDto.isActive?this.d=u.tabDto.id:this.d===u.tabDto.id&&!u.tabDto.isActive&&(this.d=""),h.acceptDtoUpdate(u.tabDto),h}activeTabId(){return this.d}}let k=class{constructor(u){this.b=new R.Emitter,this.c=new R.Emitter,this.e=[],this.a=u.getProxy(L.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const u=this,h={onDidChangeTabGroups:u.c.event,onDidChangeTabs:u.b.event,get all(){return Object.freeze(u.e.map(p=>p.apiObject))},get activeTabGroup(){const p=u.d;return(0,I.assertIsDefined)(u.e.find(C=>C.groupId===p)?.apiObject)},close:async(p,b)=>{const C=Array.isArray(p)?p:[p];return C.length?D(C[0])?this.j(C,b):this.i(C,b):!0}};this.f=Object.freeze(h)}return this.f}$acceptEditorTabModel(u){const h=new Set(this.e.map(r=>r.groupId)),p=new Set(u.map(r=>r.groupId)),b=(0,O.diffSets)(h,p),C=this.e.filter(r=>b.removed.includes(r.groupId)).map(r=>r.apiObject),g=[],i=[];this.e=u.map(r=>{const o=new v(r,()=>this.d);return b.added.includes(o.groupId)?g.push(o.apiObject):i.push(o.apiObject),o});const s=(0,I.assertIsDefined)(u.find(r=>r.isActive===!0)?.groupId);s!==void 0&&this.d!==s&&(this.d=s),this.c.fire(Object.freeze({opened:g,closed:C,changed:i}))}$acceptTabGroupUpdate(u){const h=this.e.find(p=>p.groupId===u.groupId);if(!h)throw new Error("Update Group IPC call received before group creation.");h.acceptGroupDtoUpdate(u),u.isActive&&(this.d=u.groupId),this.c.fire(Object.freeze({changed:[h.apiObject],opened:[],closed:[]}))}$acceptTabOperation(u){const h=this.e.find(b=>b.groupId===u.groupId);if(!h)throw new Error("Update Tabs IPC call received before group creation.");const p=h.acceptTabOperation(u);switch(u.kind){case 0:this.b.fire(Object.freeze({opened:[p.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[p.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[p.apiObject]}));return}}g(u){for(const h of this.e)for(const p of h.tabs)if(p.apiObject===u)return p}h(u){return this.e.find(h=>h.apiObject===u)}async i(u,h){const p=[];for(const b of u){const C=this.g(b);if(!C)throw new Error("Tab close: Invalid tab not found!");p.push(C.tabId)}return this.a.$closeTab(p,h)}async j(u,h){const p=[];for(const b of u){const C=this.h(b);if(!C)throw new Error("Group close: Invalid group not found!");p.push(C.groupId)}return this.a.$closeGroup(p,h)}};k=qe([ze(0,y.IExtHostRpcService)],k),e.ExtHostEditorTabs=k;function D(f){return f.tabs!==void 0}}),define(ye[259],De([1,0,2,5,6,7,14,157,8,22,26]),function(re,e,a,L,l,R,S,A,y,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class P{constructor(){this.a=[]}add(D){this.b=void 0,this.a.push(D)}delete(D){const f=this.a.indexOf(D);f>=0&&(this.a.splice(f,1),this.b=void 0)}c(){if(!this.b){const D=this.a.sort(),f=[];let u,h,p=14,b=14;for(const C of D){let g=u?(0,y.commonPrefixLength)(u,C):0;for(g===0?h=1:h=b;g<C.length;g++)g+1===C.length?(p=b,b=9):b+=1,f.push([h,C.toUpperCase().charCodeAt(g),b]),f.push([h,C.toLowerCase().charCodeAt(g),b]),h=b;u=C,b=p}f.push([9,58,10]),f.push([10,47,12]),this.b=new A.StateMachine(f)}}provideDocumentLinks(D){this.c();const f=[],u=A.LinkComputer.computeLinks({getLineContent(h){return D.lineAt(h-1).text},getLineCount(){return D.lineCount}},this.b);for(const h of u){const p=S.DocumentLink.to(h);p.target&&f.push(p)}return f}}class v{constructor(D,f){this.i=f,this.b=new P,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=D.getProxy(L.MainContext.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(D,f,u,h={}){if(this.d.has(f))throw new Error(`a provider for the scheme '${f}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(D,"*",this.b));const p=this.h++;this.b.add(f),this.d.add(f),this.c.set(p,u);let b=2;h.isCaseSensitive&&(b+=1024),h.isReadonly&&(b+=2048),typeof u.copy=="function"&&(b+=8),typeof u.open=="function"&&typeof u.close=="function"&&typeof u.read=="function"&&typeof u.write=="function"&&((0,O.checkProposedApiEnabled)(D,"fsChunks"),b+=4),this.a.$registerFileSystemProvider(p,f,b).catch(g=>{console.error(`FAILED to register filesystem provider of ${D.identifier.value}-extension for the scheme ${f}`),console.error(g)});const C=u.onDidChangeFile(g=>{const i=[];for(const s of g){const{uri:r,type:o}=s;if(r.scheme!==f)continue;let c;switch(o){case R.FileChangeType.Changed:c=0;break;case R.FileChangeType.Created:c=1;break;case R.FileChangeType.Deleted:c=2;break;default:throw new Error("Unknown FileChangeType")}i.push({resource:r,type:c})}this.a.$onFileSystemChange(p,i)});return(0,l.toDisposable)(()=>{C.dispose(),this.b.delete(f),this.d.delete(f),this.c.delete(p),this.a.$unregisterProvider(p)})}static j(D){const{type:f,ctime:u,mtime:h,size:p,permissions:b}=D;return{type:f,ctime:u,mtime:h,size:p,permissions:b}}$stat(D,f){return Promise.resolve(this.k(D).stat(a.URI.revive(f))).then(u=>v.j(u))}$readdir(D,f){return Promise.resolve(this.k(D).readDirectory(a.URI.revive(f)))}$readFile(D,f){return Promise.resolve(this.k(D).readFile(a.URI.revive(f))).then(u=>I.VSBuffer.wrap(u))}$writeFile(D,f,u,h){return Promise.resolve(this.k(D).writeFile(a.URI.revive(f),u.buffer,h))}$delete(D,f,u){return Promise.resolve(this.k(D).delete(a.URI.revive(f),u))}$rename(D,f,u,h){return Promise.resolve(this.k(D).rename(a.URI.revive(f),a.URI.revive(u),h))}$copy(D,f,u,h){const p=this.k(D);if(!p.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(p.copy(a.URI.revive(f),a.URI.revive(u),h))}$mkdir(D,f){return Promise.resolve(this.k(D).createDirectory(a.URI.revive(f)))}$watch(D,f,u,h){const p=this.k(D).watch(a.URI.revive(u),h);this.f.set(f,p)}$unwatch(D,f){const u=this.f.get(f);u&&(u.dispose(),this.f.delete(f))}$open(D,f,u){const h=this.k(D);if(!h.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(h.open(a.URI.revive(f),u))}$close(D,f){const u=this.k(D);if(!u.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(u.close(f))}$read(D,f,u,h){const p=this.k(D);if(!p.read)throw new Error('FileSystemProvider does not implement "read"');const b=I.VSBuffer.alloc(h);return Promise.resolve(p.read(f,u,b.buffer,0,h)).then(C=>b.slice(0,C))}$write(D,f,u,h){const p=this.k(D);if(!p.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(p.write(f,u,h.buffer,0,h.byteLength))}k(D){const f=this.c.get(D);if(!f){const u=new Error;throw u.name="ENOPRO",u.message="no provider",u}return f}}e.ExtHostFileSystem=v}),define(ye[79],De([1,0,5,44,7,22,4,18,48,6]),function(re,e,a,L,l,R,S,A,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let O=class Yt{constructor(v,k){this.b=new Map,this.a=v.getProxy(a.MainContext.MainThreadFileSystem);const D=this;this.value=Object.freeze({async stat(f){try{const u=D.b.get(f.scheme);if(!u)return await D.a.$stat(f);await D.a.$ensureActivation(f.scheme);const h=await u.stat(f);return{type:h.type,ctime:h.ctime,mtime:h.mtime,size:h.size,permissions:h.permissions}}catch(u){Yt.c(u)}},async readDirectory(f){try{const u=D.b.get(f.scheme);return u?(await D.a.$ensureActivation(f.scheme),(await u.readDirectory(f)).slice()):await D.a.$readdir(f)}catch(u){return Yt.c(u)}},async createDirectory(f){try{return await D.a.$mkdir(f)}catch(u){return Yt.c(u)}},async readFile(f){try{const u=D.b.get(f.scheme);return u?(await D.a.$ensureActivation(f.scheme),(await u.readFile(f)).slice()):(await D.a.$readFile(f)).buffer}catch(u){return Yt.c(u)}},async writeFile(f,u){try{return await D.a.$writeFile(f,R.VSBuffer.wrap(u))}catch(h){return Yt.c(h)}},async delete(f,u){try{const h=D.b.get(f.scheme);return h?(await D.a.$ensureActivation(f.scheme),await h.delete(f,{recursive:!1,...u})):await D.a.$delete(f,{recursive:!1,useTrash:!1,...u})}catch(h){return Yt.c(h)}},async rename(f,u,h){try{return await D.a.$rename(f,u,{overwrite:!1,...h})}catch(p){return Yt.c(p)}},async copy(f,u,h){try{return await D.a.$copy(f,u,{overwrite:!1,...h})}catch(p){return Yt.c(p)}},isWritableFileSystem(f){const u=k.getCapabilities(f);if(typeof u=="number")return!(u&2048)}})}static c(v){if(v instanceof l.FileSystemError)throw v;if(!(v instanceof Error))throw new l.FileSystemError(String(v));if(v.name==="ENOPRO"||v.message.includes("ENOPRO"))throw l.FileSystemError.Unavailable(v.message);switch(v.name){case L.FileSystemProviderErrorCode.FileExists:throw l.FileSystemError.FileExists(v.message);case L.FileSystemProviderErrorCode.FileNotFound:throw l.FileSystemError.FileNotFound(v.message);case L.FileSystemProviderErrorCode.FileNotADirectory:throw l.FileSystemError.FileNotADirectory(v.message);case L.FileSystemProviderErrorCode.FileIsADirectory:throw l.FileSystemError.FileIsADirectory(v.message);case L.FileSystemProviderErrorCode.NoPermissions:throw l.FileSystemError.NoPermissions(v.message);case L.FileSystemProviderErrorCode.Unavailable:throw l.FileSystemError.Unavailable(v.message);default:throw new l.FileSystemError(v.message,v.name)}}addFileSystemProvider(v,k){return this.b.set(v,k),(0,I.toDisposable)(()=>this.b.delete(v))}};O=qe([ze(0,A.IExtHostRpcService),ze(1,y.IExtHostFileSystemInfo)],O),e.ExtHostConsumerFileSystem=O,e.IExtHostConsumerFileSystem=(0,S.createDecorator)("IExtHostConsumerFileSystem")}),define(ye[260],De([1,0,3,38,2,5,14,7]),function(re,e,a,L,l,R,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class y{get ignoreCreateEvents(){return Boolean(this.g&1)}get ignoreChangeEvents(){return Boolean(this.g&2)}get ignoreDeleteEvents(){return Boolean(this.g&4)}constructor(P,v,k,D,f,u,h,p){this.a=new a.Emitter,this.b=new a.Emitter,this.c=new a.Emitter;const b=this.h(P,k,f);this.g=0,u&&(this.g+=1),h&&(this.g+=2),p&&(this.g+=4);const C=(0,L.parse)(f),g=typeof f=="string",i=D(s=>{if(!u)for(const r of s.created){const o=l.URI.revive(r);C(o.fsPath)&&(!g||v.getWorkspaceFolder(o))&&this.a.fire(o)}if(!h)for(const r of s.changed){const o=l.URI.revive(r);C(o.fsPath)&&(!g||v.getWorkspaceFolder(o))&&this.b.fire(o)}if(!p)for(const r of s.deleted){const o=l.URI.revive(r);C(o.fsPath)&&(!g||v.getWorkspaceFolder(o))&&this.c.fire(o)}});this.d=A.Disposable.from(b,this.a,this.b,this.c,i)}h(P,v,k){const D=A.Disposable.from();if(typeof k=="string")return D;const f=P.getProxy(R.MainContext.MainThreadFileSystem);let u=!1;(k.pattern.includes(L.GLOBSTAR)||k.pattern.includes(L.GLOB_SPLIT))&&(u=!0);const h=Math.random();return f.$watch(v.identifier.value,h,k.baseUri,{recursive:u,excludes:[]}),A.Disposable.from({dispose:()=>f.$unwatch(h)})}dispose(){this.d.dispose()}get onDidCreate(){return this.a.event}get onDidChange(){return this.b.event}get onDidDelete(){return this.c.event}}class I{constructor(P,v,k){this.j=P,this.k=v,this.l=k,this.a=new a.Emitter,this.b=new a.Emitter,this.c=new a.Emitter,this.d=new a.Emitter,this.g=new a.AsyncEmitter,this.h=new a.AsyncEmitter,this.i=new a.AsyncEmitter,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(P,v,k,D,f,u){return new y(this.j,P,v,this.a.event,S.GlobPattern.from(k),D,f,u)}$onFileEvent(P){this.a.fire(P)}$onDidRunFileOperation(P,v){switch(P){case 2:this.b.fire(Object.freeze({files:v.map(k=>({oldUri:l.URI.revive(k.source),newUri:l.URI.revive(k.target)}))}));break;case 1:this.d.fire(Object.freeze({files:v.map(k=>l.URI.revive(k.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:v.map(k=>l.URI.revive(k.target))}));break;default:}}getOnWillRenameFileEvent(P){return this.m(P,this.g)}getOnWillCreateFileEvent(P){return this.m(P,this.h)}getOnWillDeleteFileEvent(P){return this.m(P,this.i)}m(P,v){return(k,D,f)=>{const u=function(p){k.call(D,p)};return u.extension=P,v.event(u,void 0,f)}}async $onWillRunFileOperation(P,v,k,D){switch(P){case 2:return await this.n(this.g,{files:v.map(f=>({oldUri:l.URI.revive(f.source),newUri:l.URI.revive(f.target)}))},k,D);case 1:return await this.n(this.i,{files:v.map(f=>l.URI.revive(f.target))},k,D);case 0:case 3:return await this.n(this.h,{files:v.map(f=>l.URI.revive(f.target))},k,D)}}async n(P,v,k,D){const f=new Set,u=[];if(await P.fireAsync(v,D,async(p,b)=>{const C=Date.now(),g=await Promise.resolve(p);g instanceof A.WorkspaceEdit&&(u.push([b.extension,g]),f.add(b.extension.displayName??b.extension.identifier.value)),Date.now()-C>k&&this.k.warn("SLOW file-participant",b.extension.identifier)}),D.isCancellationRequested||u.length===0)return;const h={edits:[]};for(const[,p]of u){const{edits:b}=S.WorkspaceEdit.from(p,{getTextDocumentVersion:C=>this.l.getDocument(C)?.version,getNotebookDocumentVersion:()=>{}});h.edits=h.edits.concat(b)}return{edit:h,extensionNames:Array.from(f)}}}e.ExtHostFileSystemEventService=I}),define(ye[261],De([1,0,2,40]),function(re,e,a,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class l{constructor(S,A,y,I,O){this.a=A,this.b=y,this.c=I;const P=new L.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new L.ApiCommandArgument("showOptions","Show Options",v=>!0,v=>v),new L.ApiCommandArgument("resource","Interactive resource Uri",v=>!0,v=>v),new L.ApiCommandArgument("controllerId","Notebook controller Id",v=>!0,v=>v),new L.ApiCommandArgument("title","Interactive editor title",v=>!0,v=>v)],new L.ApiCommandResult("Notebook and input URI",v=>{if(O.debug("[ExtHostInteractive] open iw with notebook editor id",v.notebookEditorId),v.notebookEditorId!==void 0){const k=this.a.getEditorById(v.notebookEditorId);return O.debug("[ExtHostInteractive] notebook editor found",k.id),{notebookUri:a.URI.revive(v.notebookUri),inputUri:a.URI.revive(v.inputUri),notebookEditor:k.apiEditor}}return O.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",v.notebookUri,v.inputUri),{notebookUri:a.URI.revive(v.notebookUri),inputUri:a.URI.revive(v.inputUri)}}));this.c.registerApiCommand(P)}$willAddInteractiveDocument(S,A,y,I){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:A,lines:[""],languageId:y,uri:S,isDirty:!1,versionId:1,notebook:this.a.getNotebookDocument(a.URI.revive(I))?.apiNotebook}]})}$willRemoveInteractiveDocument(S,A){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[S]})}}e.ExtHostInteractive=l}),define(ye[262],De([1,0,6,5]),function(re,e,a,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class l{constructor(S){this.b=0,this.a=S.getProxy(L.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(S){const A=this.b++;return this.a.$registerResourceLabelFormatter(A,S),(0,a.toDisposable)(()=>{this.a.$unregisterResourceLabelFormatter(A)})}}e.ExtHostLabelService=l}),define(ye[263],De([1,0,2,23,14,7,72,5,8,33,15,10,152,21,6,120,101,75,43,11,17,26]),function(re,e,a,L,l,R,S,A,y,I,O,P,v,k,D,f,u,h,p,b,C,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=void 0;class i{constructor(M,z){this.d=M,this.e=z}async provideDocumentSymbols(M,z){const G=this.d.getDocument(M),te=await this.e.provideDocumentSymbols(G,z);if(!(0,O.isFalsyOrEmpty)(te))return te[0]instanceof R.DocumentSymbol?te.map(l.DocumentSymbol.from):i.f(te)}static f(M){M=M.slice(0).sort((te,de)=>{let we=te.location.range.start.compareTo(de.location.range.start);return we===0&&(we=de.location.range.end.compareTo(te.location.range.end)),we});const z=[],G=[];for(const te of M){const de={name:te.name||"!!MISSING: name!!",kind:l.SymbolKind.from(te.kind),tags:te.tags?.map(l.SymbolTag.from)||[],detail:"",containerName:te.containerName,range:l.Range.from(te.location.range),selectionRange:l.Range.from(te.location.range),children:[]};for(;;){if(G.length===0){G.push(de),z.push(de);break}const we=G[G.length-1];if(I.Range.containsRange(we.range,de.range)&&!I.Range.equalsRange(we.range,de.range)){we.children?.push(de),G.push(de);break}G.pop()}}return z}}class s{constructor(M,z,G){this.g=M,this.h=z,this.j=G,this.e=new h.Cache("CodeLens"),this.f=new Map}async provideCodeLenses(M,z){const G=this.g.getDocument(M),te=await this.j.provideCodeLenses(G,z);if(!te||z.isCancellationRequested)return;const de=this.e.add(te),we=new D.DisposableStore;this.f.set(de,we);const Pe={cacheId:de,lenses:[]};for(let be=0;be<te.length;be++)Pe.lenses.push({cacheId:[de,be],range:l.Range.from(te[be].range),command:this.h.toInternal(te[be].command,we)});return Pe}async resolveCodeLens(M,z){const G=M.cacheId&&this.e.get(...M.cacheId);if(!G)return;let te;if(typeof this.j.resolveCodeLens!="function"||G.isResolved?te=G:te=await this.j.resolveCodeLens(G,z),te||(te=G),z.isCancellationRequested)return;const de=M.cacheId&&this.f.get(M.cacheId[0]);if(!!de)return M.command=this.h.toInternal(te.command??s.d,de),M}releaseCodeLenses(M){this.f.get(M)?.dispose(),this.f.delete(M),this.e.delete(M)}}s.d={command:"missing",title:"!!MISSING: command!!"};function r(oe){return Array.isArray(oe)?oe.map(l.DefinitionLink.from):oe?[l.DefinitionLink.from(oe)]:[]}class o{constructor(M,z){this.d=M,this.e=z}async provideDefinition(M,z,G){const te=this.d.getDocument(M),de=l.Position.to(z),we=await this.e.provideDefinition(te,de,G);return r(we)}}class c{constructor(M,z){this.d=M,this.e=z}async provideDeclaration(M,z,G){const te=this.d.getDocument(M),de=l.Position.to(z),we=await this.e.provideDeclaration(te,de,G);return r(we)}}class m{constructor(M,z){this.d=M,this.e=z}async provideImplementation(M,z,G){const te=this.d.getDocument(M),de=l.Position.to(z),we=await this.e.provideImplementation(te,de,G);return r(we)}}class n{constructor(M,z){this.d=M,this.e=z}async provideTypeDefinition(M,z,G){const te=this.d.getDocument(M),de=l.Position.to(z),we=await this.e.provideTypeDefinition(te,de,G);return r(we)}}class t{constructor(M,z){this.d=M,this.e=z}async provideHover(M,z,G){const te=this.d.getDocument(M),de=l.Position.to(z),we=await this.e.provideHover(te,de,G);if(!(!we||(0,O.isFalsyOrEmpty)(we.contents)))return we.range||(we.range=te.getWordRangeAtPosition(de)),we.range||(we.range=new R.Range(de,de)),l.Hover.from(we)}}class d{constructor(M,z){this.d=M,this.e=z}async provideEvaluatableExpression(M,z,G){const te=this.d.getDocument(M),de=l.Position.to(z),we=await this.e.provideEvaluatableExpression(te,de,G);if(we)return l.EvaluatableExpression.from(we)}}class E{constructor(M,z){this.d=M,this.e=z}async provideInlineValues(M,z,G,te){const de=this.d.getDocument(M),we=await this.e.provideInlineValues(de,l.Range.to(z),l.InlineValueContext.to(G),te);if(Array.isArray(we))return we.map(Pe=>l.InlineValue.from(Pe))}}class w{constructor(M,z){this.d=M,this.e=z}async provideDocumentHighlights(M,z,G){const te=this.d.getDocument(M),de=l.Position.to(z),we=await this.e.provideDocumentHighlights(te,de,G);if(Array.isArray(we))return we.map(l.DocumentHighlight.from)}}class N{constructor(M,z){this.d=M,this.e=z}async provideLinkedEditingRanges(M,z,G){const te=this.d.getDocument(M),de=l.Position.to(z),we=await this.e.provideLinkedEditingRanges(te,de,G);if(we&&Array.isArray(we.ranges))return{ranges:(0,O.coalesce)(we.ranges.map(l.Range.from)),wordPattern:we.wordPattern}}}class j{constructor(M,z){this.d=M,this.e=z}async provideReferences(M,z,G,te){const de=this.d.getDocument(M),we=l.Position.to(z),Pe=await this.e.provideReferences(de,we,G,te);if(Array.isArray(Pe))return Pe.map(l.location.from)}}class V{constructor(M,z,G,te,de,we,Pe){this.g=M,this.h=z,this.j=G,this.k=te,this.l=de,this.m=we,this.n=Pe,this.e=new h.Cache("CodeAction"),this.f=new Map}async provideCodeActions(M,z,G,te){const de=this.g.getDocument(M),we=v.Selection.isISelection(z)?l.Selection.to(z):l.Range.to(z),Pe=[];for(const nt of this.j.getDiagnostics(M))if(we.intersection(nt.range)&&Pe.push(nt)>V.d)break;const be={diagnostics:Pe,only:G.only?new R.CodeActionKind(G.only):void 0,triggerKind:l.CodeActionTriggerKind.to(G.trigger)},Ce=await this.k.provideCodeActions(de,we,be,te);if(!(0,O.isNonEmptyArray)(Ce)||te.isCancellationRequested)return;const ke=this.e.add(Ce),He=new D.DisposableStore;this.f.set(ke,He);const Ge=[];for(let nt=0;nt<Ce.length;nt++){const Qe=Ce[nt];!Qe||(V.o(Qe)?(this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),Ge.push({_isSynthetic:!0,title:Qe.title,command:this.h.toInternal(Qe,He)})):(be.only&&(Qe.kind?be.only.contains(Qe.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${be.only.value} 'requested but returned code action is of kind '${Qe.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${be.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Ge.push({cacheId:[ke,nt],title:Qe.title,command:Qe.command&&this.h.toInternal(Qe.command,He),diagnostics:Qe.diagnostics&&Qe.diagnostics.map(l.Diagnostic.from),edit:Qe.edit&&l.WorkspaceEdit.from(Qe.edit,void 0),kind:Qe.kind&&Qe.kind.value,isPreferred:Qe.isPreferred,disabled:Qe.disabled?.reason})))}return{cacheId:ke,actions:Ge}}async resolveCodeAction(M,z){const[G,te]=M,de=this.e.get(G,te);if(!de||V.o(de)||!this.k.resolveCodeAction)return;const we=await this.k.resolveCodeAction(de,z)??de;return we?.edit?l.WorkspaceEdit.from(we.edit,void 0):void 0}releaseCodeActions(M){this.f.get(M)?.dispose(),this.f.delete(M),this.e.delete(M)}static o(M){return typeof M.command=="string"&&typeof M.title=="string"}}V.d=1e3;class Q{constructor(M,z,G,te){this.d=M,this.e=z,this.f=G,this.g=te}async prepareDocumentPaste(M,z,G,te){if(!this.f.prepareDocumentPaste)return;const de=this.e.getDocument(M),we=z.map(be=>l.Range.to(be)),Pe=l.DataTransfer.toDataTransfer(G,()=>{throw new b.NotImplementedError});return await this.f.prepareDocumentPaste(de,we,Pe,te),l.DataTransfer.toDataTransferDTO(Pe)}async providePasteEdits(M,z,G,te,de){const we=this.e.getDocument(z),Pe=G.map(ke=>l.Range.to(ke)),be=l.DataTransfer.toDataTransfer(te,async ke=>(await this.d.$resolvePasteFileData(this.g,M,ke)).buffer),Ce=await this.f.provideDocumentPasteEdits(we,Pe,be,de);if(!!Ce)return{insertText:typeof Ce.insertText=="string"?Ce.insertText:{snippet:Ce.insertText.value},additionalEdit:Ce.additionalEdit?l.WorkspaceEdit.from(Ce.additionalEdit,void 0):void 0}}}class x{constructor(M,z){this.d=M,this.e=z}async provideDocumentFormattingEdits(M,z,G){const te=this.d.getDocument(M),de=await this.e.provideDocumentFormattingEdits(te,z,G);if(Array.isArray(de))return de.map(l.TextEdit.from)}}class U{constructor(M,z){this.d=M,this.e=z}async provideDocumentRangeFormattingEdits(M,z,G,te){const de=this.d.getDocument(M),we=l.Range.to(z),Pe=await this.e.provideDocumentRangeFormattingEdits(de,we,G,te);if(Array.isArray(Pe))return Pe.map(l.TextEdit.from)}}class T{constructor(M,z){this.d=M,this.e=z,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(M,z,G,te,de){const we=this.d.getDocument(M),Pe=l.Position.to(z),be=await this.e.provideOnTypeFormattingEdits(we,Pe,G,te,de);if(Array.isArray(be))return be.map(l.TextEdit.from)}}class F{constructor(M,z){this.e=M,this.f=z,this.d=new h.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(M,z){const G=await this.e.provideWorkspaceSymbols(M,z);if(!(0,O.isNonEmptyArray)(G))return{symbols:[]};const te=this.d.add(G),de={cacheId:te,symbols:[]};for(let we=0;we<G.length;we++){const Pe=G[we];if(!Pe||!Pe.name){this.f.warn("INVALID SymbolInformation",Pe);continue}de.symbols.push({...l.WorkspaceSymbol.from(Pe),cacheId:[te,we]})}return de}async resolveWorkspaceSymbol(M,z){if(typeof this.e.resolveWorkspaceSymbol!="function"||!M.cacheId)return M;const G=this.d.get(...M.cacheId);if(G){const te=await this.e.resolveWorkspaceSymbol(G,z);return te&&(0,L.mixin)(M,l.WorkspaceSymbol.from(te),!0)}}releaseWorkspaceSymbols(M){this.d.delete(M)}}class B{static supportsResolving(M){return typeof M.prepareRename=="function"}constructor(M,z,G){this.d=M,this.e=z,this.f=G}async provideRenameEdits(M,z,G,te){const de=this.d.getDocument(M),we=l.Position.to(z);try{const Pe=await this.e.provideRenameEdits(de,we,G,te);return Pe?l.WorkspaceEdit.from(Pe):void 0}catch(Pe){const be=B.g(Pe);return be?{rejectReason:be,edits:void 0}:Promise.reject(Pe)}}async resolveRenameLocation(M,z,G){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const te=this.d.getDocument(M),de=l.Position.to(z);try{const we=await this.e.prepareRename(te,de,G);let Pe,be;if(R.Range.isRange(we)?(Pe=we,be=te.getText(we)):(0,P.isObject)(we)&&(Pe=we.range,be=we.placeholder),!Pe||!be)return;if(Pe.start.line>de.line||Pe.end.line<de.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:l.Range.from(Pe),text:be}}catch(we){const Pe=B.g(we);return Pe?{rejectReason:Pe,range:void 0,text:void 0}:Promise.reject(we)}}static g(M){return typeof M=="string"?M:M instanceof Error&&typeof M.message=="string"?M.message:void 0}}class Z{constructor(M,z){this.resultId=M,this.tokens=z}}class _{constructor(M,z){this.f=M,this.g=z,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(M,z,G){const te=this.f.getDocument(M),de=z!==0?this.d.get(z):null;let we=typeof de?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(te,de.resultId,G):await this.g.provideDocumentSemanticTokens(te,G);return de&&this.d.delete(z),we?(we=_.h(we),this.o(_.n(de,we),we)):null}async releaseDocumentSemanticColoring(M){this.d.delete(M)}static h(M){return _.j(M)?_.k(M)?M:new R.SemanticTokens(new Uint32Array(M.data),M.resultId):_.l(M)?_.m(M)?M:new R.SemanticTokensEdits(M.edits.map(z=>new R.SemanticTokensEdit(z.start,z.deleteCount,z.data?new Uint32Array(z.data):z.data)),M.resultId):M}static j(M){return M&&!!M.data}static k(M){return M.data instanceof Uint32Array}static l(M){return M&&Array.isArray(M.edits)}static m(M){for(const z of M.edits)if(!(z.data instanceof Uint32Array))return!1;return!0}static n(M,z){if(!_.j(z)||!M||!M.tokens)return z;const G=M.tokens,te=G.length,de=z.data,we=de.length;let Pe=0;const be=Math.min(te,we);for(;Pe<be&&G[Pe]===de[Pe];)Pe++;if(Pe===te&&Pe===we)return new R.SemanticTokensEdits([],z.resultId);let Ce=0;const ke=be-Pe;for(;Ce<ke&&G[te-Ce-1]===de[we-Ce-1];)Ce++;return new R.SemanticTokensEdits([{start:Pe,deleteCount:te-Pe-Ce,data:de.subarray(Pe,we-Ce)}],z.resultId)}o(M,z){if(_.j(M)){const G=this.e++;return this.d.set(G,new Z(M.resultId,M.data)),(0,f.encodeSemanticTokensDto)({id:G,type:"full",data:M.data})}if(_.l(M)){const G=this.e++;return _.j(z)?this.d.set(G,new Z(z.resultId,z.data)):this.d.set(G,new Z(M.resultId)),(0,f.encodeSemanticTokensDto)({id:G,type:"delta",deltas:(M.edits||[]).map(te=>({start:te.start,deleteCount:te.deleteCount,data:te.data}))})}return null}}class H{constructor(M,z){this.d=M,this.e=z}async provideDocumentRangeSemanticTokens(M,z,G){const te=this.d.getDocument(M),de=await this.e.provideDocumentRangeSemanticTokens(te,l.Range.to(z),G);return de?this.f(de):null}f(M){return(0,f.encodeSemanticTokensDto)({id:0,type:"full",data:M.data})}}class Y{static supportsResolving(M){return typeof M.resolveCompletionItem=="function"}constructor(M,z,G,te,de){this.f=M,this.g=z,this.h=G,this.j=te,this.k=de,this.d=new h.Cache("CompletionItem"),this.e=new Map}async provideCompletionItems(M,z,G,te){const de=this.f.getDocument(M),we=l.Position.to(z),Pe=de.getWordRangeAtPosition(we)||new R.Range(we,we),be=Pe.with({end:we}),Ce=new p.StopWatch(!0),ke=await this.h.provideCompletionItems(de,we,te,l.CompletionContext.to(G));if(!ke||te.isCancellationRequested)return;const He=Array.isArray(ke)?new R.CompletionList(ke):ke,Ge=Y.supportsResolving(this.h)?this.d.add(He.items):this.d.add([]),nt=new D.DisposableStore;this.e.set(Ge,nt);const Qe=[],tt={x:Ge,b:Qe,a:{replace:l.Range.from(Pe),insert:l.Range.from(be)},c:He.isIncomplete||void 0,d:Ce.elapsed()};for(let rt=0;rt<He.items.length;rt++){const Be=He.items[rt],it=this.l(Be,[Ge,rt],be,Pe);Qe.push(it)}return tt}async resolveCompletionItem(M,z){if(typeof this.h.resolveCompletionItem!="function")return;const G=this.d.get(...M);if(!G)return;const te=await this.h.resolveCompletionItem(G,z);if(!!te)return this.l(te,M)}releaseCompletionItems(M){this.e.get(M)?.dispose(),this.e.delete(M),this.d.delete(M)}l(M,z,G,te){const de=this.e.get(z[0]);if(!de)throw Error("DisposableStore is missing...");const we=this.g.toInternal(M.command,de),Pe={x:z,a:M.label,b:M.kind!==void 0?l.CompletionItemKind.from(M.kind):void 0,m:M.tags&&M.tags.map(l.CompletionItemTag.from),c:M.detail,d:typeof M.documentation>"u"?void 0:l.MarkdownString.fromStrict(M.documentation),e:M.sortText!==M.label?M.sortText:void 0,f:M.filterText!==M.label?M.filterText:void 0,g:M.preselect||void 0,i:M.keepWhitespace?1:0,k:M.commitCharacters?.join(""),l:M.additionalTextEdits&&M.additionalTextEdits.map(l.TextEdit.from),n:we?.$ident,o:we?.id,p:we?.$ident?void 0:we?.arguments};M.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Pe.h=M.textEdit.newText):typeof M.insertText=="string"?Pe.h=M.insertText:M.insertText instanceof R.SnippetString&&(Pe.h=M.insertText.value,Pe.i|=4);let be;return M.textEdit?be=M.textEdit.range:M.range&&(be=M.range),R.Range.isRange(be)?Pe.j=l.Range.from(be):be&&(!G?.isEqual(be.inserting)||!te?.isEqual(be.replacing))&&(Pe.j={insert:l.Range.from(be.inserting),replace:l.Range.from(be.replacing)}),Pe}}class ie{async provideInlineCompletions(M,z,G,te){}disposeCompletions(M){}handleDidShowCompletionItem(M,z){}handlePartialAccept(M,z,G){}}class ge extends ie{constructor(M,z,G,te){super(),this.f=M,this.g=z,this.h=G,this.j=te,this.d=new X,this.e=(0,g.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions"),this.k={[S.InlineCompletionTriggerKind.Automatic]:R.InlineCompletionTriggerKind.Automatic,[S.InlineCompletionTriggerKind.Explicit]:R.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,g.isProposedApiEnabled)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(M,z,G,te){const de=this.g.getDocument(M),we=l.Position.to(z),Pe=await this.h.provideInlineCompletionItems(de,we,{selectedCompletionInfo:G.selectedSuggestionInfo?{range:l.Range.to(G.selectedSuggestionInfo.range),text:G.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[G.triggerKind]},te);if(!Pe||te.isCancellationRequested)return;const be=Array.isArray(Pe)?Pe:Pe.items,Ce=this.e?Array.isArray(Pe)?[]:Pe.commands||[]:[];let ke;return{pid:this.d.createReferenceId({dispose(){ke?.dispose()},items:be}),items:be.map((Ge,nt)=>{let Qe;Ge.command&&(ke||(ke=new D.DisposableStore),Qe=this.j.toInternal(Ge.command,ke));const tt=Ge.insertText;return{insertText:typeof tt=="string"?tt:{snippet:tt.value},filterText:Ge.filterText,range:Ge.range?l.Range.from(Ge.range):void 0,command:Qe,idx:nt,completeBracketPairs:this.e?Ge.completeBracketPairs:!1}}),commands:Ce.map(Ge=>(ke||(ke=new D.DisposableStore),this.j.toInternal(Ge,ke)))}}disposeCompletions(M){this.d.disposeReferenceId(M)?.dispose()}handleDidShowCompletionItem(M,z){const G=this.d.get(M)?.items[z];G&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(G)}handlePartialAccept(M,z,G){const te=this.d.get(M)?.items[z];te&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&this.h.handleDidPartiallyAcceptCompletionItem(te,G)}}class X{constructor(){this.d=new Map,this.e=1}createReferenceId(M){const z=this.e++;return this.d.set(z,M),z}disposeReferenceId(M){const z=this.d.get(M);return this.d.delete(M),z}get(M){return this.d.get(M)}}class J{constructor(M,z){this.e=M,this.f=z,this.d=new h.Cache("SignatureHelp")}async provideSignatureHelp(M,z,G,te){const de=this.e.getDocument(M),we=l.Position.to(z),Pe=this.g(G),be=await this.f.provideSignatureHelp(de,we,te,Pe);if(be){const Ce=this.d.add([be]);return{...l.SignatureHelp.from(be),id:Ce}}}g(M){let z;if(M.activeSignatureHelp){const G=l.SignatureHelp.to(M.activeSignatureHelp),te=this.d.get(M.activeSignatureHelp.id,0);te?(z=te,z.activeSignature=G.activeSignature,z.activeParameter=G.activeParameter):z=G}return{...M,activeSignatureHelp:z}}releaseSignatureHelp(M){this.d.delete(M)}}class ee{constructor(M,z,G,te,de){this.f=M,this.g=z,this.h=G,this.j=te,this.k=de,this.d=new h.Cache("InlayHints"),this.e=new Map}async provideInlayHints(M,z,G){const te=this.f.getDocument(M),de=l.Range.to(z),we=await this.h.provideInlayHints(te,de,G);if(!Array.isArray(we)||we.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for ${z}`);return}if(G.isCancellationRequested)return;const Pe=this.d.add(we);this.e.set(Pe,new D.DisposableStore);const be={hints:[],cacheId:Pe};for(let Ce=0;Ce<we.length;Ce++)this.l(we[Ce],de)&&be.hints.push(this.m(we[Ce],[Pe,Ce]));return this.j.trace(`[InlayHints] ${be.hints.length} inlay hints from '${this.k.identifier.value}' for ${z}`),be}async resolveInlayHint(M,z){if(typeof this.h.resolveInlayHint!="function")return;const G=this.d.get(...M);if(!G)return;const te=await this.h.resolveInlayHint(G,z);if(!!te&&!!this.l(te))return this.m(te,M)}releaseHints(M){this.e.get(M)?.dispose(),this.e.delete(M),this.d.delete(M)}l(M,z){return M.label.length===0||Array.isArray(M.label)&&M.label.every(G=>G.value.length===0)?(console.log("INVALID inlay hint, empty label",M),!1):!(z&&!z.contains(M.position))}m(M,z){const G=this.e.get(z[0]);if(!G)throw Error("DisposableStore is missing...");const te={label:"",cacheId:z,tooltip:l.MarkdownString.fromStrict(M.tooltip),position:l.Position.from(M.position),textEdits:M.textEdits&&M.textEdits.map(l.TextEdit.from),kind:M.kind&&l.InlayHintKind.from(M.kind),paddingLeft:M.paddingLeft,paddingRight:M.paddingRight};return typeof M.label=="string"?te.label=M.label:te.label=M.label.map(de=>{const we={label:de.value};return we.tooltip=l.MarkdownString.fromStrict(de.tooltip),R.Location.isLocation(de.location)&&(we.location=l.location.from(de.location)),de.command&&(we.command=this.g.toInternal(de.command,G)),we}),te}}class me{constructor(M,z){this.e=M,this.f=z,this.d=new h.Cache("DocumentLink")}async provideLinks(M,z){const G=this.e.getDocument(M),te=await this.f.provideDocumentLinks(G,z);if(!(!Array.isArray(te)||te.length===0)&&!z.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:te.filter(me.g).map(l.DocumentLink.from)};{const de=this.d.add(te),we={links:[],cacheId:de};for(let Pe=0;Pe<te.length;Pe++){if(!me.g(te[Pe]))continue;const be=l.DocumentLink.from(te[Pe]);be.cacheId=[de,Pe],we.links.push(be)}return we}}}static g(M){return M.target&&M.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(M,z){if(typeof this.f.resolveDocumentLink!="function")return;const G=this.d.get(...M);if(!G)return;const te=await this.f.resolveDocumentLink(G,z);if(!(!te||!me.g(te)))return l.DocumentLink.from(te)}releaseLinks(M){this.d.delete(M)}}class ve{constructor(M,z){this.d=M,this.e=z}async provideColors(M,z){const G=this.d.getDocument(M),te=await this.e.provideDocumentColors(G,z);return Array.isArray(te)?te.map(we=>({color:l.Color.from(we.color),range:l.Range.from(we.range)})):[]}async provideColorPresentations(M,z,G){const te=this.d.getDocument(M),de=l.Range.to(z.range),we=l.Color.to(z.color),Pe=await this.e.provideColorPresentations(we,{document:te,range:de},G);if(!!Array.isArray(Pe))return Pe.map(l.ColorPresentation.from)}}class Ie{constructor(M,z){this.d=M,this.e=z}async provideFoldingRanges(M,z,G){const te=this.d.getDocument(M),de=await this.e.provideFoldingRanges(te,z,G);if(!!Array.isArray(de))return de.map(l.FoldingRange.from)}}class Re{constructor(M,z,G){this.d=M,this.e=z,this.f=G}async provideSelectionRanges(M,z,G){const te=this.d.getDocument(M),de=z.map(l.Position.to),we=await this.e.provideSelectionRanges(te,de,G);if(!(0,O.isNonEmptyArray)(we))return[];if(we.length!==de.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Pe=[];for(let be=0;be<de.length;be++){const Ce=[];Pe.push(Ce);let ke=de[be],He=we[be];for(;;){if(!He.range.contains(ke))throw new Error("INVALID selection range, must contain the previous range");if(Ce.push(l.SelectionRange.from(He)),!He.parent)break;ke=He.range,He=He.parent}}return Pe}}class ae{constructor(M,z){this.f=M,this.g=z,this.d=new u.IdGenerator(""),this.e=new Map}async prepareSession(M,z,G){const te=this.f.getDocument(M),de=l.Position.to(z),we=await this.g.prepareCallHierarchy(te,de,G);if(!we)return;const Pe=this.d.nextId();return this.e.set(Pe,new Map),Array.isArray(we)?we.map(be=>this.h(Pe,be)):[this.h(Pe,we)]}async provideCallsTo(M,z,G){const te=this.j(M,z);if(!te)throw new Error("missing call hierarchy item");const de=await this.g.provideCallHierarchyIncomingCalls(te,G);if(!!de)return de.map(we=>({from:this.h(M,we.from),fromRanges:we.fromRanges.map(Pe=>l.Range.from(Pe))}))}async provideCallsFrom(M,z,G){const te=this.j(M,z);if(!te)throw new Error("missing call hierarchy item");const de=await this.g.provideCallHierarchyOutgoingCalls(te,G);if(!!de)return de.map(we=>({to:this.h(M,we.to),fromRanges:we.fromRanges.map(Pe=>l.Range.from(Pe))}))}releaseSession(M){this.e.delete(M)}h(M,z){const G=this.e.get(M),te=l.CallHierarchyItem.from(z,M,G.size.toString(36));return G.set(te._itemId,z),te}j(M,z){return this.e.get(M)?.get(z)}}class le{constructor(M,z){this.f=M,this.g=z,this.d=new u.IdGenerator(""),this.e=new Map}async prepareSession(M,z,G){const te=this.f.getDocument(M),de=l.Position.to(z),we=await this.g.prepareTypeHierarchy(te,de,G);if(!we)return;const Pe=this.d.nextId();return this.e.set(Pe,new Map),Array.isArray(we)?we.map(be=>this.h(Pe,be)):[this.h(Pe,we)]}async provideSupertypes(M,z,G){const te=this.j(M,z);if(!te)throw new Error("missing type hierarchy item");const de=await this.g.provideTypeHierarchySupertypes(te,G);if(!!de)return de.map(we=>this.h(M,we))}async provideSubtypes(M,z,G){const te=this.j(M,z);if(!te)throw new Error("missing type hierarchy item");const de=await this.g.provideTypeHierarchySubtypes(te,G);if(!!de)return de.map(we=>this.h(M,we))}releaseSession(M){this.e.delete(M)}h(M,z){const G=this.e.get(M),te=l.TypeHierarchyItem.from(z,M,G.size.toString(36));return G.set(te._itemId,z),te}j(M,z){return this.e.get(M)?.get(z)}}class ue{constructor(M,z,G,te){this.d=M,this.e=z,this.f=G,this.g=te}async provideDocumentOnDropEdits(M,z,G,te,de){const we=this.e.getDocument(z),Pe=l.Position.to(G),be=l.DataTransfer.toDataTransfer(te,async ke=>(await this.d.$resolveDocumentOnDropFileData(this.g,M,ke)).buffer),Ce=await this.f.provideDocumentDropEdits(we,Pe,be,de);if(!!Ce)return{insertText:typeof Ce.insertText=="string"?Ce.insertText:{snippet:Ce.insertText.value},additionalEdit:Ce.additionalEdit?l.WorkspaceEdit.from(Ce.additionalEdit,void 0):void 0}}}class ne{constructor(M,z){this.adapter=M,this.extension=z}}class ce{constructor(M,z,G,te,de,we,Pe,be){this.g=z,this.h=G,this.j=te,this.k=de,this.l=we,this.m=Pe,this.n=be,this.f=new Map,this.e=M.getProxy(A.MainContext.MainThreadLanguageFeatures)}o(M){return l.DocumentSelector.from(M,this.g)}p(M){return new R.Disposable(()=>{this.f.delete(M),this.e.$unregister(M)})}q(){return ce.d++}async s(M,z,G,te,de,we=!1){const Pe=this.f.get(M);if(!Pe||!(Pe.adapter instanceof z))return te;const be=Date.now();we||this.l.trace(`[${Pe.extension.identifier.value}] INVOKE provider '${G.toString().replace(/[\r\n]/g,"")}'`);const Ce=G(Pe.adapter,Pe.extension);return Promise.resolve(Ce).catch(ke=>{(0,b.isCancellationError)(ke)||(this.l.error(`[${Pe.extension.identifier.value}] provider FAILED`),this.l.error(ke),this.n.onExtensionError(Pe.extension.identifier,ke))}).finally(()=>{we||this.l.trace(`[${Pe.extension.identifier.value}] provider DONE after ${Date.now()-be}ms`)}),k.CancellationToken.isCancellationToken(de)?(0,C.raceCancellationError)(Ce,de):Ce}t(M,z){const G=this.q();return this.f.set(G,new ne(M,z)),G}static u(M){return M.displayName||M.name}registerDocumentSymbolProvider(M,z,G,te){const de=this.t(new i(this.h,G),M),we=te&&te.label||ce.u(M);return this.e.$registerDocumentSymbolProvider(de,this.o(z),we),this.p(de)}$provideDocumentSymbols(M,z,G){return this.s(M,i,te=>te.provideDocumentSymbols(a.URI.revive(z),G),void 0,G)}registerCodeLensProvider(M,z,G){const te=this.q(),de=typeof G.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(te,new ne(new s(this.h,this.j.converter,G),M)),this.e.$registerCodeLensSupport(te,this.o(z),de);let we=this.p(te);if(de!==void 0){const Pe=G.onDidChangeCodeLenses(be=>this.e.$emitCodeLensEvent(de));we=R.Disposable.from(we,Pe)}return we}$provideCodeLenses(M,z,G){return this.s(M,s,te=>te.provideCodeLenses(a.URI.revive(z),G),void 0,G)}$resolveCodeLens(M,z,G){return this.s(M,s,te=>te.resolveCodeLens(z,G),void 0,void 0)}$releaseCodeLenses(M,z){this.s(M,s,G=>Promise.resolve(G.releaseCodeLenses(z)),void 0,void 0)}registerDefinitionProvider(M,z,G){const te=this.t(new o(this.h,G),M);return this.e.$registerDefinitionSupport(te,this.o(z)),this.p(te)}$provideDefinition(M,z,G,te){return this.s(M,o,de=>de.provideDefinition(a.URI.revive(z),G,te),[],te)}registerDeclarationProvider(M,z,G){const te=this.t(new c(this.h,G),M);return this.e.$registerDeclarationSupport(te,this.o(z)),this.p(te)}$provideDeclaration(M,z,G,te){return this.s(M,c,de=>de.provideDeclaration(a.URI.revive(z),G,te),[],te)}registerImplementationProvider(M,z,G){const te=this.t(new m(this.h,G),M);return this.e.$registerImplementationSupport(te,this.o(z)),this.p(te)}$provideImplementation(M,z,G,te){return this.s(M,m,de=>de.provideImplementation(a.URI.revive(z),G,te),[],te)}registerTypeDefinitionProvider(M,z,G){const te=this.t(new n(this.h,G),M);return this.e.$registerTypeDefinitionSupport(te,this.o(z)),this.p(te)}$provideTypeDefinition(M,z,G,te){return this.s(M,n,de=>de.provideTypeDefinition(a.URI.revive(z),G,te),[],te)}registerHoverProvider(M,z,G,te){const de=this.t(new t(this.h,G),M);return this.e.$registerHoverProvider(de,this.o(z)),this.p(de)}$provideHover(M,z,G,te){return this.s(M,t,de=>de.provideHover(a.URI.revive(z),G,te),void 0,te)}registerEvaluatableExpressionProvider(M,z,G,te){const de=this.t(new d(this.h,G),M);return this.e.$registerEvaluatableExpressionProvider(de,this.o(z)),this.p(de)}$provideEvaluatableExpression(M,z,G,te){return this.s(M,d,de=>de.provideEvaluatableExpression(a.URI.revive(z),G,te),void 0,te)}registerInlineValuesProvider(M,z,G,te){const de=typeof G.onDidChangeInlineValues=="function"?this.q():void 0,we=this.t(new E(this.h,G),M);this.e.$registerInlineValuesProvider(we,this.o(z),de);let Pe=this.p(we);if(de!==void 0){const be=G.onDidChangeInlineValues(Ce=>this.e.$emitInlineValuesEvent(de));Pe=R.Disposable.from(Pe,be)}return Pe}$provideInlineValues(M,z,G,te,de){return this.s(M,E,we=>we.provideInlineValues(a.URI.revive(z),G,te,de),void 0,de)}registerDocumentHighlightProvider(M,z,G){const te=this.t(new w(this.h,G),M);return this.e.$registerDocumentHighlightProvider(te,this.o(z)),this.p(te)}$provideDocumentHighlights(M,z,G,te){return this.s(M,w,de=>de.provideDocumentHighlights(a.URI.revive(z),G,te),void 0,te)}registerLinkedEditingRangeProvider(M,z,G){const te=this.t(new N(this.h,G),M);return this.e.$registerLinkedEditingRangeProvider(te,this.o(z)),this.p(te)}$provideLinkedEditingRanges(M,z,G,te){return this.s(M,N,async de=>{const we=await de.provideLinkedEditingRanges(a.URI.revive(z),G,te);if(we)return{ranges:we.ranges,wordPattern:we.wordPattern?ce.w(we.wordPattern):void 0}},void 0,te)}registerReferenceProvider(M,z,G){const te=this.t(new j(this.h,G),M);return this.e.$registerReferenceSupport(te,this.o(z)),this.p(te)}$provideReferences(M,z,G,te,de){return this.s(M,j,we=>we.provideReferences(a.URI.revive(z),G,te,de),void 0,de)}registerCodeActionProvider(M,z,G,te){const de=new D.DisposableStore,we=this.t(new V(this.h,this.j.converter,this.k,G,this.l,M,this.m),M);return this.e.$registerQuickFixSupport(we,this.o(z),{providedKinds:te?.providedCodeActionKinds?.map(Pe=>Pe.value),documentation:te?.documentation?.map(Pe=>({kind:Pe.kind.value,command:this.j.converter.toInternal(Pe.command,de)}))},ce.u(M),Boolean(G.resolveCodeAction)),de.add(this.p(we)),de}$provideCodeActions(M,z,G,te,de){return this.s(M,V,we=>we.provideCodeActions(a.URI.revive(z),G,te,de),void 0,de)}$resolveCodeAction(M,z,G){return this.s(M,V,te=>te.resolveCodeAction(z,G),void 0,void 0)}$releaseCodeActions(M,z){this.s(M,V,G=>Promise.resolve(G.releaseCodeActions(z)),void 0,void 0)}registerDocumentFormattingEditProvider(M,z,G){const te=this.t(new x(this.h,G),M);return this.e.$registerDocumentFormattingSupport(te,this.o(z),M.identifier,M.displayName||M.name),this.p(te)}$provideDocumentFormattingEdits(M,z,G,te){return this.s(M,x,de=>de.provideDocumentFormattingEdits(a.URI.revive(z),G,te),void 0,te)}registerDocumentRangeFormattingEditProvider(M,z,G){const te=this.t(new U(this.h,G),M);return this.e.$registerRangeFormattingSupport(te,this.o(z),M.identifier,M.displayName||M.name),this.p(te)}$provideDocumentRangeFormattingEdits(M,z,G,te,de){return this.s(M,U,we=>we.provideDocumentRangeFormattingEdits(a.URI.revive(z),G,te,de),void 0,de)}registerOnTypeFormattingEditProvider(M,z,G,te){const de=this.t(new T(this.h,G),M);return this.e.$registerOnTypeFormattingSupport(de,this.o(z),te,M.identifier),this.p(de)}$provideOnTypeFormattingEdits(M,z,G,te,de,we){return this.s(M,T,Pe=>Pe.provideOnTypeFormattingEdits(a.URI.revive(z),G,te,de,we),void 0,we)}registerWorkspaceSymbolProvider(M,z){const G=this.t(new F(z,this.l),M);return this.e.$registerNavigateTypeSupport(G,typeof z.resolveWorkspaceSymbol=="function"),this.p(G)}$provideWorkspaceSymbols(M,z,G){return this.s(M,F,te=>te.provideWorkspaceSymbols(z,G),{symbols:[]},G)}$resolveWorkspaceSymbol(M,z,G){return this.s(M,F,te=>te.resolveWorkspaceSymbol(z,G),void 0,void 0)}$releaseWorkspaceSymbols(M,z){this.s(M,F,G=>G.releaseWorkspaceSymbols(z),void 0,void 0)}registerRenameProvider(M,z,G){const te=this.t(new B(this.h,G,this.l),M);return this.e.$registerRenameSupport(te,this.o(z),B.supportsResolving(G)),this.p(te)}$provideRenameEdits(M,z,G,te,de){return this.s(M,B,we=>we.provideRenameEdits(a.URI.revive(z),G,te,de),void 0,de)}$resolveRenameLocation(M,z,G,te){return this.s(M,B,de=>de.resolveRenameLocation(a.URI.revive(z),G,te),void 0,te)}registerDocumentSemanticTokensProvider(M,z,G,te){const de=this.t(new _(this.h,G),M),we=typeof G.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(de,this.o(z),te,we);let Pe=this.p(de);if(we){const be=G.onDidChangeSemanticTokens(Ce=>this.e.$emitDocumentSemanticTokensEvent(we));Pe=R.Disposable.from(Pe,be)}return Pe}$provideDocumentSemanticTokens(M,z,G,te){return this.s(M,_,de=>de.provideDocumentSemanticTokens(a.URI.revive(z),G,te),null,te)}$releaseDocumentSemanticTokens(M,z){this.s(M,_,G=>G.releaseDocumentSemanticColoring(z),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(M,z,G,te){const de=this.t(new H(this.h,G),M);return this.e.$registerDocumentRangeSemanticTokensProvider(de,this.o(z),te),this.p(de)}$provideDocumentRangeSemanticTokens(M,z,G,te){return this.s(M,H,de=>de.provideDocumentRangeSemanticTokens(a.URI.revive(z),G,te),null,te)}registerCompletionItemProvider(M,z,G,te){const de=this.t(new Y(this.h,this.j.converter,G,this.m,M),M);return this.e.$registerCompletionsProvider(de,this.o(z),te,Y.supportsResolving(G),`${M.identifier.value}(${te.join("")})`),this.p(de)}$provideCompletionItems(M,z,G,te,de){return this.s(M,Y,we=>we.provideCompletionItems(a.URI.revive(z),G,te,de),void 0,de)}$resolveCompletionItem(M,z,G){return this.s(M,Y,te=>te.resolveCompletionItem(z,G),void 0,G)}$releaseCompletionItems(M,z){this.s(M,Y,G=>G.releaseCompletionItems(z),void 0,void 0)}registerInlineCompletionsProvider(M,z,G){const te=new ge(M,this.h,G,this.j.converter),de=this.t(te,M);return this.e.$registerInlineCompletionsSupport(de,this.o(z),te.supportsHandleEvents),this.p(de)}$provideInlineCompletions(M,z,G,te,de){return this.s(M,ie,we=>we.provideInlineCompletions(a.URI.revive(z),G,te,de),void 0,de)}$handleInlineCompletionDidShow(M,z,G){this.s(M,ie,async te=>{te.handleDidShowCompletionItem(z,G)},void 0,void 0)}$handleInlineCompletionPartialAccept(M,z,G,te){this.s(M,ie,async de=>{de.handlePartialAccept(z,G,te)},void 0,void 0)}$freeInlineCompletionsList(M,z){this.s(M,ie,async G=>{G.disposeCompletions(z)},void 0,void 0)}registerSignatureHelpProvider(M,z,G,te){const de=Array.isArray(te)?{triggerCharacters:te,retriggerCharacters:[]}:te,we=this.t(new J(this.h,G),M);return this.e.$registerSignatureHelpProvider(we,this.o(z),de),this.p(we)}$provideSignatureHelp(M,z,G,te,de){return this.s(M,J,we=>we.provideSignatureHelp(a.URI.revive(z),G,te,de),void 0,de)}$releaseSignatureHelp(M,z){this.s(M,J,G=>G.releaseSignatureHelp(z),void 0,void 0)}registerInlayHintsProvider(M,z,G){const te=typeof G.onDidChangeInlayHints=="function"?this.q():void 0,de=this.t(new ee(this.h,this.j.converter,G,this.l,M),M);this.e.$registerInlayHintsProvider(de,this.o(z),typeof G.resolveInlayHint=="function",te,ce.u(M));let we=this.p(de);if(te!==void 0){const Pe=G.onDidChangeInlayHints(be=>this.e.$emitInlayHintsEvent(te));we=R.Disposable.from(we,Pe)}return we}$provideInlayHints(M,z,G,te){return this.s(M,ee,de=>de.provideInlayHints(a.URI.revive(z),G,te),void 0,te)}$resolveInlayHint(M,z,G){return this.s(M,ee,te=>te.resolveInlayHint(z,G),void 0,G)}$releaseInlayHints(M,z){this.s(M,ee,G=>G.releaseHints(z),void 0,void 0)}registerDocumentLinkProvider(M,z,G){const te=this.t(new me(this.h,G),M);return this.e.$registerDocumentLinkProvider(te,this.o(z),typeof G.resolveDocumentLink=="function"),this.p(te)}$provideDocumentLinks(M,z,G){return this.s(M,me,te=>te.provideLinks(a.URI.revive(z),G),void 0,G,z.scheme==="output")}$resolveDocumentLink(M,z,G){return this.s(M,me,te=>te.resolveLink(z,G),void 0,void 0,!0)}$releaseDocumentLinks(M,z){this.s(M,me,G=>G.releaseLinks(z),void 0,void 0,!0)}registerColorProvider(M,z,G){const te=this.t(new ve(this.h,G),M);return this.e.$registerDocumentColorProvider(te,this.o(z)),this.p(te)}$provideDocumentColors(M,z,G){return this.s(M,ve,te=>te.provideColors(a.URI.revive(z),G),[],G)}$provideColorPresentations(M,z,G,te){return this.s(M,ve,de=>de.provideColorPresentations(a.URI.revive(z),G,te),void 0,te)}registerFoldingRangeProvider(M,z,G){const te=this.q(),de=typeof G.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(te,new ne(new Ie(this.h,G),M)),this.e.$registerFoldingRangeProvider(te,this.o(z),M.identifier,de);let we=this.p(te);if(de!==void 0){const Pe=G.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(de));we=R.Disposable.from(we,Pe)}return we}$provideFoldingRanges(M,z,G,te){return this.s(M,Ie,de=>de.provideFoldingRanges(a.URI.revive(z),G,te),void 0,te)}registerSelectionRangeProvider(M,z,G){const te=this.t(new Re(this.h,G,this.l),M);return this.e.$registerSelectionRangeProvider(te,this.o(z)),this.p(te)}$provideSelectionRanges(M,z,G,te){return this.s(M,Re,de=>de.provideSelectionRanges(a.URI.revive(z),G,te),[],te)}registerCallHierarchyProvider(M,z,G){const te=this.t(new ae(this.h,G),M);return this.e.$registerCallHierarchyProvider(te,this.o(z)),this.p(te)}$prepareCallHierarchy(M,z,G,te){return this.s(M,ae,de=>Promise.resolve(de.prepareSession(a.URI.revive(z),G,te)),void 0,te)}$provideCallHierarchyIncomingCalls(M,z,G,te){return this.s(M,ae,de=>de.provideCallsTo(z,G,te),void 0,te)}$provideCallHierarchyOutgoingCalls(M,z,G,te){return this.s(M,ae,de=>de.provideCallsFrom(z,G,te),void 0,te)}$releaseCallHierarchy(M,z){this.s(M,ae,G=>Promise.resolve(G.releaseSession(z)),void 0,void 0)}registerTypeHierarchyProvider(M,z,G){const te=this.t(new le(this.h,G),M);return this.e.$registerTypeHierarchyProvider(te,this.o(z)),this.p(te)}$prepareTypeHierarchy(M,z,G,te){return this.s(M,le,de=>Promise.resolve(de.prepareSession(a.URI.revive(z),G,te)),void 0,te)}$provideTypeHierarchySupertypes(M,z,G,te){return this.s(M,le,de=>de.provideSupertypes(z,G,te),void 0,te)}$provideTypeHierarchySubtypes(M,z,G,te){return this.s(M,le,de=>de.provideSubtypes(z,G,te),void 0,te)}$releaseTypeHierarchy(M,z){this.s(M,le,G=>Promise.resolve(G.releaseSession(z)),void 0,void 0)}registerDocumentOnDropEditProvider(M,z,G){const te=this.q();return this.f.set(te,new ne(new ue(this.e,this.h,G,te),M)),this.e.$registerDocumentOnDropEditProvider(te,this.o(z)),this.p(te)}$provideDocumentOnDropEdits(M,z,G,te,de,we){return this.s(M,ue,Pe=>Promise.resolve(Pe.provideDocumentOnDropEdits(z,a.URI.revive(G),te,de,we)),void 0,void 0)}registerDocumentPasteEditProvider(M,z,G,te){const de=this.q();return this.f.set(de,new ne(new Q(this.e,this.h,G,de),M)),this.e.$registerPasteEditProvider(de,this.o(z),!!G.prepareDocumentPaste,te.pasteMimeTypes),this.p(de)}$prepareDocumentPaste(M,z,G,te,de){return this.s(M,Q,we=>we.prepareDocumentPaste(a.URI.revive(z),G,te,de),void 0,de)}$providePasteEdits(M,z,G,te,de,we){return this.s(M,Q,Pe=>Pe.providePasteEdits(z,a.URI.revive(G),te,de,we),void 0,we)}static w(M){return{pattern:M.source,flags:(0,y.regExpFlags)(M)}}static y(M){return{decreaseIndentPattern:ce.w(M.decreaseIndentPattern),increaseIndentPattern:ce.w(M.increaseIndentPattern),indentNextLinePattern:M.indentNextLinePattern?ce.w(M.indentNextLinePattern):void 0,unIndentedLinePattern:M.unIndentedLinePattern?ce.w(M.unIndentedLinePattern):void 0}}static z(M){return{beforeText:ce.w(M.beforeText),afterText:M.afterText?ce.w(M.afterText):void 0,previousLineText:M.previousLineText?ce.w(M.previousLineText):void 0,action:M.action}}static B(M){return M.map(ce.z)}setLanguageConfiguration(M,z,G){const{wordPattern:te}=G;if(te&&(0,y.regExpLeadsToEndlessLoop)(te))throw new Error(`Invalid language configuration: wordPattern '${te}' is not allowed to match the empty string.`);te?this.h.setWordDefinitionFor(z,te):this.h.setWordDefinitionFor(z,void 0),G.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",M,"Do not use."),G.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",M,"Do not use.");const de=this.q(),we={comments:G.comments,brackets:G.brackets,wordPattern:G.wordPattern?ce.w(G.wordPattern):void 0,indentationRules:G.indentationRules?ce.y(G.indentationRules):void 0,onEnterRules:G.onEnterRules?ce.B(G.onEnterRules):void 0,__electricCharacterSupport:G.__electricCharacterSupport,__characterPairSupport:G.__characterPairSupport};return this.e.$setLanguageConfiguration(de,z,we),this.p(de)}$setWordDefinitions(M){for(const z of M)this.h.setWordDefinitionFor(z.languageId,new RegExp(z.regexSource,z.regexFlags))}}ce.d=0,e.ExtHostLanguageFeatures=ce}),define(ye[264],De([1,0,5,14,7,37,17,6]),function(re,e,a,L,l,R,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class y{constructor(O,P,v,k){this.c=P,this.d=v,this.e=k,this.b=[],this.f=0,this.g=new Set,this.a=O.getProxy(a.MainContext.MainThreadLanguages)}$acceptLanguageIds(O){this.b=O}async getLanguages(){return this.b.slice(0)}async changeLanguage(O,P){await this.a.$changeLanguage(O,P);const v=this.c.getDocumentData(O);if(!v)throw new Error(`document '${O.toString()}' NOT found`);return v.document}async tokenAtPosition(O,P){const v=O.version,k=L.Position.from(P),D=await this.a.$tokensAtPosition(O.uri,k),f={type:l.StandardTokenType.Other,range:O.getWordRangeAtPosition(P)??new l.Range(P.line,P.character,P.line,P.character)};if(!D)return f;const u={range:L.Range.to(D.range),type:L.TokenType.to(D.type)};return!u.range.contains(P)||v!==O.version?f:u}createLanguageStatusItem(O,P,v){const k=this.f++,D=this.a,f=this.g,u=`${O.identifier.value}/${P}`;if(f.has(u))throw new Error(`LanguageStatusItem with id '${P}' ALREADY exists`);f.add(u);const h={selector:v,id:P,name:O.displayName??O.name,severity:l.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let p;const b=new A.DisposableStore,C=()=>{p?.dispose(),p=(0,S.disposableTimeout)(()=>{b.clear(),this.a.$setLanguageStatus(k,{id:u,name:h.name??O.displayName??O.name,source:O.displayName??O.name,selector:L.DocumentSelector.from(h.selector,this.e),label:h.text,detail:h.detail??"",severity:h.severity===l.LanguageStatusSeverity.Error?R.default.Error:h.severity===l.LanguageStatusSeverity.Warning?R.default.Warning:R.default.Info,command:h.command&&this.d.toInternal(h.command,b),accessibilityInfo:h.accessibilityInformation,busy:h.busy})},0)},g={dispose(){b.dispose(),p?.dispose(),D.$removeLanguageStatus(k),f.delete(u)},get id(){return h.id},get name(){return h.name},set name(i){h.name=i,C()},get selector(){return h.selector},set selector(i){h.selector=i,C()},get text(){return h.text},set text(i){h.text=i,C()},get detail(){return h.detail},set detail(i){h.detail=i,C()},get severity(){return h.severity},set severity(i){h.severity=i,C()},get accessibilityInformation(){return h.accessibilityInformation},set accessibilityInformation(i){h.accessibilityInformation=i,C()},get command(){return h.command},set command(i){h.command=i,C()},get busy(){return h.busy},set busy(i){h.busy=i,C()}};return C(),g}}e.ExtHostLanguages=y}),define(ye[97],De([1,0,12,8,2,4,13,5,25,18]),function(re,e,a,L,l,R,S,A,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostLocalizationService=e.ExtHostLocalizationService=void 0;let O=class{constructor(v,k,D){this.f=D,this.d=new Map,this.a=k.getProxy(A.MainContext.MainThreadLocalization),this.b=v.environment.appLanguage,this.c=this.b===a.LANGUAGE_DEFAULT}getMessage(v,k){const{message:D,args:f,comment:u}=k;if(this.c)return(0,L.format2)(D,f??{});let h=D;u&&u.length>0&&(h+=`/${Array.isArray(u)?u.join(""):u}`);const p=this.d.get(v)?.contents[h];return p||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${h}`),(0,L.format2)(p??D,f??{})}getBundle(v){return this.d.get(v)?.contents}getBundleUri(v){return this.d.get(v)?.uri}async initializeLocalizedMessages(v){if(this.c||!v.l10n&&!v.isBuiltin||this.d.has(v.identifier.value))return;let k;const D=await this.g(v);if(!D){this.f.error(`No bundle location found for extension ${v.identifier.value}`);return}try{const f=await this.a.$fetchBundleContents(D),u=JSON.parse(f);k=v.isBuiltin?u.contents?.bundle:u}catch(f){this.f.error(`Failed to load translations for ${v.identifier.value} from ${D}: ${f.message}`);return}k&&this.d.set(v.identifier.value,{contents:k,uri:D})}async g(v){if(v.isBuiltin){const k=await this.a.$fetchBuiltInBundleUri(v.identifier.value,this.b);return l.URI.revive(k)}return v.l10n?l.URI.joinPath(v.extensionLocation,v.l10n,`bundle.l10n.${this.b}.json`):void 0}};O=qe([ze(0,y.IExtHostInitDataService),ze(1,I.IExtHostRpcService),ze(2,S.ILogService)],O),e.ExtHostLocalizationService=O,e.IExtHostLocalizationService=(0,R.createDecorator)("IExtHostLocalizationService")}),define(ye[140],De([1,0,13,5,25,18,2,70]),function(re,e,a,L,l,R,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let y=class extends a.AbstractLoggerService{constructor(P,v){super(v.logLevel,v.loggers.map(k=>(0,A.revive)(k))),this.l=P.getProxy(L.MainContext.MainThreadLogger)}$setLogLevel(P,v){v?this.setLogLevel(S.URI.revive(v),P):this.setLogLevel(P)}setVisibility(P,v){super.setVisibility(P,v),this.l.$setVisibility(P,v)}k(P,v,k){return new I(this.l,P,v,k)}};y=qe([ze(0,R.IExtHostRpcService),ze(1,l.IExtHostInitDataService)],y),e.ExtHostLoggerService=y;class I extends a.AbstractMessageLogger{constructor(P,v,k,D){super(D?.logLevel==="always"),this.m=P,this.n=v,this.k=!1,this.l=[],this.setLevel(k),this.m.$createLogger(v,D).then(()=>{this.r(this.l),this.k=!0})}g(P,v){const k=[[P,v]];this.k?this.r(k):this.l.push(...k)}r(P){this.m.$log(this.n,P)}}}),define(ye[265],De([1,0,5,13,26]),function(re,e,a,L,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function R(A){return A&&A.title}let S=class{constructor(y,I){this.b=I,this.a=y.getProxy(a.MainContext.MainThreadMessageService)}showMessage(y,I,O,P,v){const k={source:{identifier:y.identifier,label:y.displayName||y.name}};let D;typeof P=="string"||R(P)?D=[P,...v]:(k.modal=P?.modal,k.useCustom=P?.useCustom,k.detail=P?.detail,D=v),k.useCustom&&(0,l.checkProposedApiEnabled)(y,"resolvers");const f=[];for(let u=0;u<D.length;u++){const h=D[u];if(typeof h=="string")f.push({title:h,handle:u,isCloseAffordance:!1});else if(typeof h=="object"){const{title:p,isCloseAffordance:b}=h;f.push({title:p,isCloseAffordance:!!b,handle:u})}else this.b.warn("Invalid message item:",h)}return this.a.$showMessage(I,O,k,f).then(u=>{if(typeof u=="number")return D[u]})}};S=qe([ze(1,L.ILogService)],S),e.ExtHostMessageService=S}),define(ye[266],De([1,0,22,3,6,28,8,10,2,75,5,40,14,7,59,241,136]),function(re,e,a,L,l,R,S,A,y,I,O,P,v,k,D,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class h{get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(b=>b.apiEditor)}constructor(b,C,g,i){this.q=g,this.r=i,this.f=new Map,this.g=new R.ResourceMap,this.h=new Map,this.j=new L.Emitter,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new L.Emitter,this.onDidOpenNotebookDocument=this.m.event,this.n=new L.Emitter,this.onDidCloseNotebookDocument=this.n.event,this.o=new L.Emitter,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new I.Cache("NotebookCellStatusBarCache"),this.t=0,this.u=new Map,this.b=b.getProxy(O.MainContext.MainThreadNotebook),this.c=b.getProxy(O.MainContext.MainThreadNotebookDocuments),this.d=b.getProxy(O.MainContext.MainThreadNotebookEditors),this.i=C.converter,C.registerArgumentProcessor({processArgument:s=>{if(s&&s.$mid===13){const r=s.notebookEditor?.notebookUri,o=s.cell.handle,m=this.g.get(r)?.getCell(o);if(m)return m.apiCell}if(s&&s.$mid===14){const r=s.uri,o=this.g.get(r);if(o)return o.apiNotebook}return s}}),h.x(C)}getEditorById(b){const C=this.h.get(b);if(!C)throw new Error(`unknown text editor: ${b}. known editors: ${[...this.h.keys()]} `);return C}getIdByEditor(b){for(const[C,g]of this.h)if(g.apiEditor===b)return C}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(b,C){const g=this.g.get(b);if(!g&&!C)throw new Error(`NO notebook document for '${b}'`);return g}static s(b,C){if(!C)return;const g=C.filenamePattern.map(i=>v.NotebookExclusiveDocumentPattern.from(i)).filter(i=>i!==void 0);if(C.filenamePattern&&!g){console.warn(`Notebook content provider view options file name pattern is invalid ${C.filenamePattern}`);return}return{extension:b.identifier,providerDisplayName:b.displayName||b.name,displayName:C.displayName,filenamePattern:g,exclusive:C.exclusive||!1}}registerNotebookCellStatusBarItemProvider(b,C,g){const i=h.a++,s=typeof g.onDidChangeCellStatusBarItems=="function"?h.a++:void 0;this.f.set(i,g),this.b.$registerNotebookCellStatusBarItemProvider(i,s,C);let r;return s!==void 0&&(r=g.onDidChangeCellStatusBarItems(o=>this.b.$emitCellStatusBarEvent(s))),new k.Disposable(()=>{this.f.delete(i),this.b.$unregisterNotebookCellStatusBarItemProvider(i,s),r?.dispose()})}async createNotebookDocument(b){const C=await this.c.$tryCreateNotebook({viewType:b.viewType,content:b.content&&v.NotebookData.from(b.content)});return y.URI.revive(C)}async openNotebookDocument(b){const C=this.g.get(b);if(C)return C.apiNotebook;const g=await this.c.$tryOpenNotebook(b),i=this.g.get(y.URI.revive(g));return(0,A.assertIsDefined)(i?.apiNotebook)}async showNotebookDocument(b,C){y.URI.isUri(b)&&(b=await this.openNotebookDocument(b));let g;typeof C=="object"?g={position:v.ViewColumn.from(C.viewColumn),preserveFocus:C.preserveFocus,selections:C.selections&&C.selections.map(v.NotebookRange.from),pinned:typeof C.preview=="boolean"?!C.preview:void 0}:g={preserveFocus:!1};const i=await this.d.$tryShowNotebookDocument(b.uri,b.notebookType,g),s=i&&this.h.get(i)?.apiEditor;if(s)return s;throw i?new Error(`Could NOT open editor for "${b.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${b.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(b,C,g,i){const s=this.f.get(b),r=y.URI.revive(C),o=this.g.get(r);if(!o||!s)return;const c=o.getCellFromIndex(g);if(!c)return;const m=await s.provideCellStatusBarItems(c.apiCell,i);if(!m)return;const n=new l.DisposableStore,t=this.p.add([n]),E=(Array.isArray(m)?m:[m]).map(w=>v.NotebookStatusBarItem.from(w,this.i,n));return{cacheId:t,items:E}}$releaseNotebookCellStatusBarItems(b){this.p.delete(b)}registerNotebookSerializer(b,C,g,i,s){if((0,S.isFalsyOrWhitespace)(C))throw new Error("viewType cannot be empty or just whitespace");const r=this.t++;return this.u.set(r,g),this.b.$registerNotebookSerializer(r,{id:b.identifier,location:b.extensionLocation},C,v.NotebookDocumentContentOptions.from(i),h.s(b,s)),(0,l.toDisposable)(()=>{this.b.$unregisterNotebookSerializer(r)})}async $dataToNotebook(b,C,g){const i=this.u.get(b);if(!i)throw new Error("NO serializer found");const s=await i.deserializeNotebook(C.buffer,g);return new D.SerializableObjectWithBuffers(v.NotebookData.from(s))}async $notebookToData(b,C,g){const i=this.u.get(b);if(!i)throw new Error("NO serializer found");const s=await i.serializeNotebook(v.NotebookData.to(C.value),g);return a.VSBuffer.wrap(s)}w(b,C,g){if(this.h.has(C))throw new Error(`editor with id ALREADY EXSIST: ${C}`);const i=new u.ExtHostNotebookEditor(C,this.d,b,g.visibleRanges.map(v.NotebookRange.to),g.selections.map(v.NotebookRange.to),typeof g.viewColumn=="number"?v.ViewColumn.to(g.viewColumn):void 0);this.h.set(C,i)}$acceptDocumentAndEditorsDelta(b){if(b.value.removedDocuments)for(const g of b.value.removedDocuments){const i=y.URI.revive(g),s=this.g.get(i);s&&(s.dispose(),this.g.delete(i),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:s.apiNotebook.getCells().map(r=>r.document.uri)}),this.n.fire(s.apiNotebook));for(const r of this.h.values())r.notebookData.uri.toString()===i.toString()&&this.h.delete(r.id)}if(b.value.addedDocuments){const g=[];for(const i of b.value.addedDocuments){const s=y.URI.revive(i.uri);if(this.g.has(s))throw new Error(`adding EXISTING notebook ${s} `);const r=new f.ExtHostNotebookDocument(this.c,this.q,this.r,s,i);g.push(...i.cells.map(o=>f.ExtHostCell.asModelAddData(r.apiNotebook,o))),this.g.get(s)?.dispose(),this.g.set(s,r),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:g}),this.m.fire(r.apiNotebook)}}if(b.value.addedEditors)for(const g of b.value.addedEditors){if(this.h.has(g.id))return;const i=y.URI.revive(g.documentUri),s=this.g.get(i);s&&this.w(s,g.id,g)}const C=[];if(b.value.removedEditors)for(const g of b.value.removedEditors){const i=this.h.get(g);i&&(this.h.delete(g),this.k?.id===i.id&&(this.k=void 0),C.push(i))}if(b.value.visibleEditors){this.l=b.value.visibleEditors.map(i=>this.h.get(i)).filter(i=>!!i);const g=new Set;this.l.forEach(i=>g.add(i.id));for(const i of this.h.values()){const s=g.has(i.id);i._acceptVisibility(s)}this.l=[...this.h.values()].map(i=>i).filter(i=>i.visible),this.o.fire(this.visibleNotebookEditors)}b.value.newActiveEditor===null?this.k=void 0:b.value.newActiveEditor&&(this.h.get(b.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${b.value.newActiveEditor}`),this.k=this.h.get(b.value.newActiveEditor)),b.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static x(b){const C=P.ApiCommandArgument.String.with("notebookType","A notebook type"),g=new P.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[C,new P.ApiCommandArgument("data","Bytes to convert to data",s=>s instanceof Uint8Array,s=>a.VSBuffer.wrap(s))],new P.ApiCommandResult("Notebook Data",s=>v.NotebookData.to(s.value))),i=new P.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[C,new P.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",s=>!0,s=>new D.SerializableObjectWithBuffers(v.NotebookData.from(s)))],new P.ApiCommandResult("Bytes",s=>s.buffer));b.registerApiCommand(g),b.registerApiCommand(i)}}h.a=0,e.ExtHostNotebookController=h}),define(ye[267],De([1,0,15,17,21,3,6,28,2,27,13,75,5,40,14,7,95,231,26,59]),function(re,e,a,L,l,R,S,A,y,I,O,P,v,k,D,f,u,h,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let C=class{constructor(c,m,n,t,d){this.k=m,this.l=n,this.m=t,this.n=d,this.b=new A.ResourceMap,this.c=new Map,this.d=0,this.e=new Map,this.f=0,this.g=new P.Cache("NotebookKernelSourceActionProviderCache"),this.h=new Map,this.i=0,this.j=new R.Emitter,this.onDidChangeNotebookCellExecutionState=this.j.event,this.a=c.getProxy(v.MainContext.MainThreadNotebookKernels);const E=new k.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new k.ApiCommandArgument("options","Select kernel options",w=>!0,w=>{if(w&&"notebookEditor"in w&&"id"in w){const N=this.l.getIdByEditor(w.notebookEditor);return{id:w.id,extension:w.extension,notebookEditorId:N}}else if(w&&"notebookEditor"in w){const N=this.l.getIdByEditor(w.notebookEditor);if(N===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${w.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:N}}return w})],k.ApiCommandResult.Void);this.m.registerApiCommand(E)}createNotebookController(c,m,n,t,d,E){for(const ie of this.h.values())if(ie.controller.id===m&&I.ExtensionIdentifier.equals(c.identifier,ie.extensionId))throw new Error(`notebook controller with id '${m}' ALREADY exist`);const w=this.i++,N=this;this.n.trace(`NotebookController[${w}], CREATED by ${c.identifier.value}, ${m}`);const j=()=>console.warn(`NO execute handler from notebook controller '${T.id}' of extension: '${c.identifier}'`);let V=!1;const Q=new S.DisposableStore,x=new R.Emitter,U=new R.Emitter,T={id:r(c.identifier,m),notebookType:n,extensionId:c.identifier,extensionLocation:c.extensionLocation,label:t||c.identifier.value,preloads:E?E.map(D.NotebookRendererScript.from):[]};let F=d??j,B;this.a.$addKernel(w,T).catch(ie=>{console.log(ie),V=!0});let Z=0;const _=()=>{if(V)return;const ie=++Z;Promise.resolve().then(()=>{ie===Z&&this.a.$updateKernel(w,T)})},H=new A.ResourceMap,Y={get id(){return m},get notebookType(){return T.notebookType},onDidChangeSelectedNotebooks:x.event,get label(){return T.label},set label(ie){T.label=ie??c.displayName??c.name,_()},get detail(){return T.detail??""},set detail(ie){T.detail=ie,_()},get description(){return T.description??""},set description(ie){T.description=ie,_()},get kind(){return(0,p.checkProposedApiEnabled)(c,"notebookControllerKind"),T.kind??""},set kind(ie){(0,p.checkProposedApiEnabled)(c,"notebookControllerKind"),T.kind=ie,_()},get supportedLanguages(){return T.supportedLanguages},set supportedLanguages(ie){T.supportedLanguages=ie,_()},get supportsExecutionOrder(){return T.supportsExecutionOrder??!1},set supportsExecutionOrder(ie){T.supportsExecutionOrder=ie,_()},get rendererScripts(){return T.preloads?T.preloads.map(D.NotebookRendererScript.to):[]},get executeHandler(){return F},set executeHandler(ie){F=ie??j},get interruptHandler(){return B},set interruptHandler(ie){B=ie,T.supportsInterrupt=Boolean(ie),_()},createNotebookCellExecution(ie){if(V)throw new Error("notebook controller is DISPOSED");if(!H.has(ie.notebook.uri))throw N.n.trace(`NotebookController[${w}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(H.keys()).map(ge=>ge.toString())),new Error(`notebook controller is NOT associated to notebook: ${ie.notebook.uri.toString()}`);return N._createNotebookCellExecution(ie,r(c.identifier,this.id))},dispose:()=>{V||(this.n.trace(`NotebookController[${w}], DISPOSED`),V=!0,this.h.delete(w),Q.dispose(),x.dispose(),U.dispose(),this.a.$removeKernel(w))},updateNotebookAffinity(ie,ge){ge===f.NotebookControllerAffinity2.Hidden&&(0,p.checkProposedApiEnabled)(c,"notebookControllerAffinityHidden"),N.a.$updateNotebookPriority(w,ie.uri,ge)},onDidReceiveMessage:U.event,postMessage(ie,ge){return(0,p.checkProposedApiEnabled)(c,"notebookMessaging"),N.a.$postMessage(w,ge&&N.l.getIdByEditor(ge),ie)},asWebviewUri(ie){return(0,p.checkProposedApiEnabled)(c,"notebookMessaging"),(0,u.asWebviewUri)(ie,N.k.remote)}};return this.h.set(w,{extensionId:c.identifier,controller:Y,onDidReceiveMessage:U,onDidChangeSelection:x,associatedNotebooks:H}),Y}getIdByController(c){for(const[m,n]of this.h)if(n.controller===c)return r(n.extensionId,c.id);return null}createNotebookControllerDetectionTask(c,m){const n=this.d++,t=this;this.n.trace(`NotebookControllerDetectionTask[${n}], CREATED by ${c.identifier.value}`),this.a.$addKernelDetectionTask(n,m);const d={dispose:()=>{this.c.delete(n),t.a.$removeKernelDetectionTask(n)}};return this.c.set(n,d),d}registerKernelSourceActionProvider(c,m,n){const t=this.f++,d=typeof n.onDidChangeNotebookKernelSourceActions=="function"?t:void 0,E=this;this.e.set(t,n),this.n.trace(`NotebookKernelSourceActionProvider[${t}], CREATED by ${c.identifier.value}`),this.a.$addKernelSourceActionProvider(t,t,m);let w;return d!==void 0&&(w=n.onDidChangeNotebookKernelSourceActions(N=>this.a.$emitNotebookKernelSourceActionsChangeEvent(d))),{dispose:()=>{this.e.delete(t),E.a.$removeKernelSourceActionProvider(t,t),w?.dispose()}}}async $provideKernelSourceActions(c,m){const n=this.e.get(c);if(n){const t=new S.DisposableStore;return this.g.add([t]),(await n.provideNotebookKernelSourceActions(m)??[]).map(E=>D.NotebookKernelSourceAction.from(E,this.m.converter,t))}return[]}$acceptNotebookAssociation(c,m,n){const t=this.h.get(c);if(t){const d=this.l.getNotebookDocument(y.URI.revive(m));n?t.associatedNotebooks.set(d.uri,!0):t.associatedNotebooks.delete(d.uri),this.n.trace(`NotebookController[${c}] ASSOCIATE notebook`,d.uri.toString(),n),t.onDidChangeSelection.fire({selected:n,notebook:d.apiNotebook})}}async $executeCells(c,m,n){const t=this.h.get(c);if(!t)return;const d=this.l.getNotebookDocument(y.URI.revive(m)),E=[];for(const w of n){const N=d.getCell(w);N&&E.push(N.apiCell)}try{this.n.trace(`NotebookController[${c}] EXECUTE cells`,d.uri.toString(),E.length),await t.controller.executeHandler.call(t.controller,E,d.apiNotebook,t.controller)}catch(w){this.n.error(`NotebookController[${c}] execute cells FAILED`,w),console.error(w)}}async $cancelCells(c,m,n){const t=this.h.get(c);if(!t)return;const d=this.l.getNotebookDocument(y.URI.revive(m));if(t.controller.interruptHandler)await t.controller.interruptHandler.call(t.controller,d.apiNotebook);else for(const E of n){const w=d.getCell(E);w&&this.b.get(w.uri)?.cancel()}}$acceptKernelMessageFromRenderer(c,m,n){const t=this.h.get(c);if(!t)return;const d=this.l.getEditorById(m);t.onDidReceiveMessage.fire(Object.freeze({editor:d.apiEditor,message:n}))}$cellExecutionChanged(c,m,n){const d=this.l.getNotebookDocument(y.URI.revive(c)).getCell(m);if(d){const E=n?D.NotebookCellExecutionState.to(n):f.NotebookCellExecutionState.Idle;E!==void 0&&this.j.fire({cell:d.apiCell,state:E})}}_createNotebookCellExecution(c,m){if(c.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const t=this.l.getNotebookDocument(c.notebook.uri).getCellFromApiCell(c);if(!t)throw new Error("invalid cell");if(this.b.has(t.uri))throw new Error(`duplicate execution for ${t.uri}`);const d=new i(m,t,this.a);this.b.set(t.uri,d);const E=d.onDidChangeState(()=>{d.state===g.Resolved&&(d.dispose(),E.dispose(),this.b.delete(t.uri))});return d.asApiObject()}};C=qe([ze(4,O.ILogService)],C),e.ExtHostNotebookKernels=C;var g;(function(o){o[o.Init=0]="Init",o[o.Started=1]="Started",o[o.Resolved=2]="Resolved"})(g||(g={}));class i extends S.Disposable{get state(){return this.f}constructor(c,m,n){super(),this.j=m,this.k=n,this.b=i.a++,this.c=new R.Emitter,this.onDidChangeState=this.c.event,this.f=g.Init,this.g=this.B(new l.CancellationTokenSource),this.h=new s(10,t=>this.m(t)),this.i=m.internalMetadata.executionOrder,this.k.$createExecution(this.b,c,this.j.notebook.uri,this.j.handle)}cancel(){this.g.cancel()}async l(c){await this.h.addItem(c)}async m(c){const m=Array.isArray(c)?c:[c];return this.k.$updateExecution(this.b,new b.SerializableObjectWithBuffers(m))}n(){if(this.f===g.Init)throw new Error("Must call start before modifying cell output");if(this.f===g.Resolved)throw new Error("Cannot modify cell output after calling resolve")}r(c){let m=this.j;if(c&&(m=this.j.notebook.getCellFromApiCell(c)),!m)throw new Error("INVALID cell");return m.handle}s(c){return c.map(m=>{const n=f.NotebookCellOutput.ensureUniqueMimeTypes(m.items,!0);return n===m.items?D.NotebookCellOutput.from(m):D.NotebookCellOutput.from({items:n,id:m.id,metadata:m.metadata})})}async t(c,m,n){const t=this.r(m),d=this.s((0,a.asArray)(c));return this.l({editType:h.CellExecutionUpdateType.Output,cellHandle:t,append:n,outputs:d})}async w(c,m,n){return c=f.NotebookCellOutput.ensureUniqueMimeTypes((0,a.asArray)(c),!0),this.l({editType:h.CellExecutionUpdateType.OutputItems,items:c.map(D.NotebookCellOutputItem.from),outputId:m.id,append:n})}asApiObject(){const c=this;return Object.freeze({get token(){return c.g.token},get cell(){return c.j.apiCell},get executionOrder(){return c.i},set executionOrder(n){c.i=n,c.m([{editType:h.CellExecutionUpdateType.ExecutionState,executionOrder:c.i}])},start(n){if(c.f===g.Resolved||c.f===g.Started)throw new Error("Cannot call start again");c.f=g.Started,c.c.fire(),c.m({editType:h.CellExecutionUpdateType.ExecutionState,runStartTime:n})},end(n,t){if(c.f===g.Resolved)throw new Error("Cannot call resolve twice");c.f=g.Resolved,c.c.fire(),c.h.flush(),c.k.$completeExecution(c.b,new b.SerializableObjectWithBuffers({runEndTime:t,lastRunSuccess:n}))},clearOutput(n){return c.n(),c.t([],n,!1)},appendOutput(n,t){return c.n(),c.t(n,t,!0)},replaceOutput(n,t){return c.n(),c.t(n,t,!1)},appendOutputItems(n,t){return c.n(),c.w(n,t,!0)},replaceOutputItems(n,t){return c.n(),c.w(n,t,!1)}})}}i.a=0;class s{constructor(c,m){this.d=c,this.e=m,this.a=[],this.b=Date.now()}addItem(c){return this.a.push(c),this.c||(this.c=new L.DeferredPromise,this.b=Date.now(),(0,L.timeout)(this.d).then(()=>this.flush())),Date.now()-this.b>this.d?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const c=this.c;this.c=void 0;const m=this.a;return this.a=[],this.e(m).finally(()=>c.complete())}}function r(o,c){return`${o.value}/${c}`}e.createKernelId=r}),define(ye[268],De([1,0,3,5,136]),function(re,e,a,L,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class R{constructor(A,y){this.c=y,this.a=new Map,this.b=A.getProxy(L.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(A,y,I){const O=this.c.getEditorById(A);this.a.get(y)?.fire({editor:O.apiEditor,message:I})}createRendererMessaging(A,y){if(!A.contributes?.notebookRenderer?.some(O=>O.id===y))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${y})`);return{onDidReceiveMessage:(O,P,v)=>this.d(y).event(O,P,v),postMessage:(O,P)=>{l.ExtHostNotebookEditor.apiEditorsToExtHost.has(O)&&([O,P]=[P,O]);const v=P&&l.ExtHostNotebookEditor.apiEditorsToExtHost.get(P);return this.b.$postMessage(v?.id,y,O)}}}d(A){let y=this.a.get(A);return y||(y=new a.Emitter({onDidRemoveLastListener:()=>{y?.dispose(),this.a.delete(A)}}),this.a.set(A,y),y)}}e.ExtHostNotebookRenderers=R}),define(ye[269],De([1,0,6,10,2,26,5]),function(re,e,a,L,l,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProfileContentHandlers=void 0;class A{constructor(I){this.b=new Map,this.a=I.getProxy(S.MainContext.MainThreadProfileContentHandlers)}registrProfileContentHandler(I,O,P){if((0,R.checkProposedApiEnabled)(I,"profileContentHandlers"),this.b.has(O))throw new Error(`Handler with id '${O}' already registered`);return this.b.set(O,P),this.a.$registerProfileContentHandler(O,P.name,P.description,I.identifier.value),(0,a.toDisposable)(()=>{this.b.delete(O),this.a.$unregisterProfileContentHandler(O)})}async $saveProfile(I,O,P,v){const k=this.b.get(I);if(!k)throw new Error(`Unknown handler with id: ${I}`);return k.saveProfile(O,P,v)}async $readProfile(I,O,P){const v=this.b.get(I);if(!v)throw new Error(`Unknown handler with id: ${I}`);return v.readProfile((0,L.isString)(O)?O:l.URI.revive(O),P)}}e.ExtHostProfileContentHandlers=A}),define(ye[270],De([1,0,2,5,17,14]),function(re,e,a,L,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostQuickDiff=void 0;class S{constructor(y,I){this.d=I,this.c=new Map,this.b=y.getProxy(L.MainContext.MainThreadQuickDiff)}$provideOriginalResource(y,I,O){const P=a.URI.revive(I),v=this.c.get(y);return v?(0,l.asPromise)(()=>v.provideOriginalResource(P,O)).then(k=>k||null):Promise.resolve(null)}registerQuickDiffProvider(y,I,O,P){const v=S.a++;return this.c.set(v,I),this.b.$registerQuickDiffProvider(v,R.DocumentSelector.from(y,this.d),O,P),{dispose:()=>{this.b.$unregisterQuickDiffProvider(v),this.c.delete(v)}}}}S.a=0,e.ExtHostQuickDiff=S}),define(ye[271],De([1,0,21,3,6,5,2,7,11,15,37,51,26,14]),function(re,e,a,L,l,R,S,A,y,I,O,P,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function D(f,u,h){const p=f.getProxy(R.MainContext.MainThreadQuickOpen);class b{constructor(n,t){this.e=new Map,this.f=0,this.a=n,this.b=t}showQuickPick(n,t,d,E=a.CancellationToken.None){this.c=void 0;const w=Promise.resolve(t),N=++this.f,j=p.$show(N,{title:d?.title,placeHolder:d?.placeHolder,matchOnDescription:d?.matchOnDescription,matchOnDetail:d?.matchOnDetail,ignoreFocusLost:d?.ignoreFocusOut,canPickMany:d?.canPickMany},E),V={},Q=j.then(()=>V);return Promise.race([Q,w]).then(x=>{if(x===V)return;const U=(0,v.isProposedApiEnabled)(n,"quickPickItemTooltip");return w.then(T=>{const F=[];for(let B=0;B<T.length;B++){const Z=T[B];typeof Z=="string"?F.push({label:Z,handle:B}):Z.kind===A.QuickPickItemKind.Separator?F.push({type:"separator",label:Z.label}):(Z.tooltip&&!U&&console.warn(`Extension '${n.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${n.identifier.value}`),F.push({label:Z.label,description:Z.description,detail:Z.detail,picked:Z.picked,alwaysShow:Z.alwaysShow,tooltip:U?k.MarkdownString.fromStrict(Z.tooltip):void 0,handle:B}))}return d&&typeof d.onDidSelectItem=="function"&&(this.c=B=>{d.onDidSelectItem(T[B])}),p.$setItems(N,F),j.then(B=>{if(typeof B=="number")return T[B];if(Array.isArray(B))return B.map(Z=>T[Z])})})}).then(void 0,x=>{if(!(0,y.isCancellationError)(x))return p.$setError(N,x),Promise.reject(x)})}$onItemSelected(n){this.c?.(n)}showInput(n,t=a.CancellationToken.None){return this.d=n?.validateInput,p.$input(n,typeof this.d=="function",t).then(void 0,d=>{if(!(0,y.isCancellationError)(d))return Promise.reject(d)})}async $validateInput(n){if(!this.d)return;const t=await this.d(n);if(!t||typeof t=="string")return t;let d;switch(t.severity){case A.InputBoxValidationSeverity.Info:d=O.default.Info;break;case A.InputBoxValidationSeverity.Warning:d=O.default.Warning;break;case A.InputBoxValidationSeverity.Error:d=O.default.Error;break;default:d=t.message?O.default.Error:O.default.Ignore;break}return{content:t.message,severity:d}}async showWorkspaceFolderPick(n,t=a.CancellationToken.None){const d=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[n]);if(!d)return;const E=await this.a.getWorkspaceFolders2();if(!!E)return E.find(w=>w.uri.toString()===d.uri.toString())}createQuickPick(n){const t=new o(n,()=>this.e.delete(t._id));return this.e.set(t._id,t),t}createInputBox(n){const t=new c(n,()=>this.e.delete(t._id));return this.e.set(t._id,t),t}$onDidChangeValue(n,t){this.e.get(n)?._fireDidChangeValue(t)}$onDidAccept(n){this.e.get(n)?._fireDidAccept()}$onDidChangeActive(n,t){const d=this.e.get(n);d instanceof o&&d._fireDidChangeActive(t)}$onDidChangeSelection(n,t){const d=this.e.get(n);d instanceof o&&d._fireDidChangeSelection(t)}$onDidTriggerButton(n,t){this.e.get(n)?._fireDidTriggerButton(t)}$onDidTriggerItemButton(n,t,d){const E=this.e.get(n);E instanceof o&&E._fireDidTriggerItemButton(t,d)}$onDidHide(n){this.e.get(n)?._fireDidHide()}}class C{constructor(n,t){this.x=n,this.y=t,this._id=o.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new L.Emitter,this.q=new L.Emitter,this.r=new L.Emitter,this.s=new L.Emitter,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(n){this.b=n,this.z({title:n})}get step(){return this.c}set step(n){this.c=n,this.z({step:n})}get totalSteps(){return this.d}set totalSteps(n){this.d=n,this.z({totalSteps:n})}get enabled(){return this.g}set enabled(n){this.g=n,this.z({enabled:n})}get busy(){return this.j}set busy(n){this.j=n,this.z({busy:n})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(n){this.k=n,this.z({ignoreFocusOut:n})}get value(){return this.l}set value(n){this.l=n,this.z({value:n})}get placeholder(){return this.m}set placeholder(n){this.m=n,this.z({placeholder:n})}get buttons(){return this.n}set buttons(n){this.n=n.slice(),this.o.clear(),n.forEach((t,d)=>{const E=t===A.QuickInputButtons.Back?-1:d;this.o.set(E,t)}),this.z({buttons:n.map((t,d)=>({...r(t),tooltip:t.tooltip,handle:t===A.QuickInputButtons.Back?-1:d}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(n){this.l=n,this.q.fire(n)}_fireDidTriggerButton(n){const t=this.o.get(n);t&&this.r.fire(t)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,l.dispose)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),p.$dispose(this._id))}z(n){if(!this.v){for(const t of Object.keys(n)){const d=n[t];this.u[t]=d===void 0?null:d}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){p.$createOrUpdate(this.u),this.u={id:this._id}}}C.a=1;function g(m){if(m instanceof A.ThemeIcon)return{id:m.id};const n=s(m),t=i(m);return{dark:typeof n=="string"?S.URI.file(n):n,light:typeof t=="string"?S.URI.file(t):t}}function i(m){return typeof m=="object"&&"light"in m?m.light:m}function s(m){return typeof m=="object"&&"dark"in m?m.dark:m}function r(m){const n=g(m.iconPath);let t,d;return"id"in n?d=P.ThemeIcon.asClassName(n):t=n,{iconPath:t,iconClass:d}}class o extends C{constructor(n,t){super(n.identifier,t),this.O=n,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new L.Emitter,this.L=[],this.M=new L.Emitter,this.N=new L.Emitter,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(n){this.B=n.slice(),this.C.clear(),this.D.clear(),n.forEach((E,w)=>{this.C.set(w,E),this.D.set(E,w)});const t=(0,v.isProposedApiEnabled)(this.O,"quickPickItemTooltip"),d=[];for(let E=0;E<n.length;E++){const w=n[E];w.kind===A.QuickPickItemKind.Separator?d.push({type:"separator",label:w.label}):(w.tooltip&&!t&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`),d.push({handle:E,label:w.label,description:w.description,detail:w.detail,picked:w.picked,alwaysShow:w.alwaysShow,tooltip:t?k.MarkdownString.fromStrict(w.tooltip):void 0,buttons:w.buttons?.map((N,j)=>({...r(N),tooltip:N.tooltip,handle:j}))}))}this.z({items:d})}get canSelectMany(){return this.E}set canSelectMany(n){this.E=n,this.z({canSelectMany:n})}get matchOnDescription(){return this.F}set matchOnDescription(n){this.F=n,this.z({matchOnDescription:n})}get matchOnDetail(){return this.G}set matchOnDetail(n){this.G=n,this.z({matchOnDetail:n})}get sortByLabel(){return this.H}set sortByLabel(n){this.H=n,this.z({sortByLabel:n})}get keepScrollPosition(){return this.I}set keepScrollPosition(n){this.I=n,this.z({keepScrollPosition:n})}get activeItems(){return this.J}set activeItems(n){this.J=n.filter(t=>this.D.has(t)),this.z({activeItems:this.J.map(t=>this.D.get(t))})}get selectedItems(){return this.L}set selectedItems(n){this.L=n.filter(t=>this.D.has(t)),this.z({selectedItems:this.L.map(t=>this.D.get(t))})}_fireDidChangeActive(n){const t=(0,I.coalesce)(n.map(d=>this.C.get(d)));this.J=t,this.K.fire(t)}_fireDidChangeSelection(n){const t=(0,I.coalesce)(n.map(d=>this.C.get(d)));this.L=t,this.M.fire(t)}_fireDidTriggerItemButton(n,t){const d=this.C.get(n);if(!d||!d.buttons||!d.buttons.length)return;const E=d.buttons[t];E&&this.N.fire({button:E,item:d})}}class c extends C{constructor(n,t){super(n.identifier,t),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(n){this.B=n,this.z({password:n})}get prompt(){return this.C}set prompt(n){this.C=n,this.z({prompt:n})}get valueSelection(){return this.D}set valueSelection(n){this.D=n,this.z({valueSelection:n})}get validationMessage(){return this.E}set validationMessage(n){this.E=n,n?typeof n=="string"?this.z({validationMessage:n,severity:O.default.Error}):this.z({validationMessage:n.message,severity:n.severity??O.default.Error}):this.z({validationMessage:void 0,severity:O.default.Ignore})}}return new b(u,h)}e.createExtHostQuickOpen=D});var Ue=this&&this.__classPrivateFieldGet||function(re,e,a,L){if(a==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!L:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?L:a==="a"?L.call(re):L?L.value:e.get(re)},_e=this&&this.__classPrivateFieldSet||function(re,e,a,L,l){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!l:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?l.call(re,a):l?l.value=a:e.set(re,a),a};define(ye[272],De([1,0,2,3,63,6,17,5,15,103,13,27,51,14,26]),function(re,e,a,L,l,R,S,A,y,I,O,P,v,k,D){"use strict";var f,u;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function h(t){if(t)return typeof t.iconPath=="string"?a.URI.file(t.iconPath):a.URI.isUri(t.iconPath)||v.ThemeIcon.isThemeIcon(t.iconPath)?t.iconPath:void 0}function p(t,d){if(!t.iconPath&&!d.iconPath)return 0;if(t.iconPath){if(!d.iconPath)return 1}else return-1;const E=typeof t.iconPath=="string"?t.iconPath:a.URI.isUri(t.iconPath)?t.iconPath.fsPath:t.iconPath.id,w=typeof d.iconPath=="string"?d.iconPath:a.URI.isUri(d.iconPath)?d.iconPath.fsPath:d.iconPath.id;return(0,I.comparePaths)(E,w)}function b(t,d){let E=0;if(t.strikeThrough!==d.strikeThrough)return t.strikeThrough?1:-1;if(t.faded!==d.faded)return t.faded?1:-1;if(t.tooltip!==d.tooltip)return(t.tooltip||"").localeCompare(d.tooltip||"");if(E=p(t,d),E!==0)return E;if(t.light&&d.light)E=p(t.light,d.light);else{if(t.light)return 1;if(d.light)return-1}if(E!==0)return E;if(t.dark&&d.dark)E=p(t.dark,d.dark);else{if(t.dark)return 1;if(d.dark)return-1}return E}function C(t,d){if(t.command!==d.command)return t.command<d.command?-1:1;if(t.title!==d.title)return t.title<d.title?-1:1;if(t.tooltip!==d.tooltip){if(t.tooltip!==void 0&&d.tooltip!==void 0)return t.tooltip<d.tooltip?-1:1;if(t.tooltip!==void 0)return 1;if(d.tooltip!==void 0)return-1}if(t.arguments===d.arguments)return 0;if(t.arguments)if(d.arguments){if(t.arguments.length!==d.arguments.length)return t.arguments.length-d.arguments.length}else return 1;else return-1;for(let E=0;E<t.arguments.length;E++){const w=t.arguments[E],N=d.arguments[E];if(w!==N)return w<N?-1:1}return 0}function g(t,d){let E=(0,I.comparePaths)(t.resourceUri.fsPath,d.resourceUri.fsPath,!0);if(E!==0)return E;if(t.command&&d.command)E=C(t.command,d.command);else{if(t.command)return 1;if(d.command)return-1}if(E!==0)return E;if(t.decorations&&d.decorations)E=b(t.decorations,d.decorations);else{if(t.decorations)return 1;if(d.decorations)return-1}return E}function i(t,d){for(let E=0;E<t.length;E++)if(t[E]!==d[E])return!1;return!0}function s(t,d){return t.command===d.command&&t.title===d.title&&t.tooltip===d.tooltip&&(t.arguments&&d.arguments?i(t.arguments,d.arguments):t.arguments===d.arguments)}function r(t,d){return(0,y.equals)(t,d,s)}class o{get value(){return this.d}set value(d){d=d??"",Ue(this,f,"f").$setInputBoxValue(this.l,d),this.m(d)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(d){Ue(this,f,"f").$setInputBoxPlaceholder(this.l,d),this.f=d}get validateInput(){return(0,D.checkProposedApiEnabled)(this.k,"scmValidation"),this.g}set validateInput(d){if((0,D.checkProposedApiEnabled)(this.k,"scmValidation"),d&&typeof d!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=d,Ue(this,f,"f").$setValidationProviderIsEnabled(this.l,!!d)}get enabled(){return this.h}set enabled(d){d=!!d,this.h!==d&&(this.h=d,Ue(this,f,"f").$setInputBoxEnablement(this.l,d))}get visible(){return this.j}set visible(d){d=!!d,this.j!==d&&(this.j=d,Ue(this,f,"f").$setInputBoxVisibility(this.l,d))}constructor(d,E,w){this.k=d,this.l=w,f.set(this,void 0),this.d="",this.e=new L.Emitter,this.f="",this.h=!0,this.j=!0,_e(this,f,E,"f")}showValidationMessage(d,E){(0,D.checkProposedApiEnabled)(this.k,"scmValidation"),Ue(this,f,"f").$showValidationMessage(this.l,d,E)}$onInputBoxValueChange(d){this.m(d)}m(d){this.d=d,this.e.fire(d)}}e.ExtHostSCMInputBox=o,f=new WeakMap;class c{get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(d){this.v=d,this.q.$updateGroupLabel(this.t,this.handle,d)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(d){this.p=d,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(d){this.f=[...d],this.k.fire()}constructor(d,E,w,N,j){this.q=d,this.s=E,this.t=w,this.u=N,this.v=j,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new L.Emitter,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new L.Emitter,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=c.d++}getResourceState(d){return this.g.get(d)}$executeResourceCommand(d,E){const w=this.h.get(d);return w?(0,S.asPromise)(()=>this.s.executeCommand(w.command,...w.arguments||[],E)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const d=[...this.f].sort(g),w=(0,y.sortedDiff)(this.o,d,g).map(V=>{const Q=V.toInsert.map(x=>{const U=this.e++;this.g.set(U,x);const T=x.resourceUri;let F;if(x.command)if(x.command.command==="vscode.open"||x.command.command==="vscode.diff"){const ee=new R.DisposableStore;F=this.s.converter.toInternal(x.command,ee),this.j.set(U,ee)}else this.h.set(U,x.command);const B=h(x.decorations),Z=x.decorations&&h(x.decorations.light)||B,_=x.decorations&&h(x.decorations.dark)||B,H=[Z,_],Y=x.decorations&&x.decorations.tooltip||"",ie=x.decorations&&!!x.decorations.strikeThrough,ge=x.decorations&&!!x.decorations.faded,X=x.contextValue||"";return{rawResource:[U,T,H,Y,ie,ge,X,F],handle:U}});return{start:V.start,deleteCount:V.deleteCount,toInsert:Q}}),N=w.map(({start:V,deleteCount:Q,toInsert:x})=>[V,Q,x.map(U=>U.rawResource)]),j=w.reverse();for(const{start:V,deleteCount:Q,toInsert:x}of j){const U=x.map(F=>F.handle),T=this.n.splice(V,Q,...U);for(const F of T)this.g.delete(F),this.h.delete(F),this.j.get(F)?.dispose(),this.j.delete(F)}return this.o=d,N}dispose(){this.l=!0,this.m.fire()}}c.d=0;class m{get id(){return this.w}get label(){return this.x}get rootUri(){return this.y}get inputBox(){return this.f}get count(){return this.g}set count(d){this.g!==d&&(this.g=d,Ue(this,u,"f").$updateSourceControl(this.t,{count:d}))}get quickDiffProvider(){return this.h}set quickDiffProvider(d){this.h=d;let E;(0,D.isProposedApiEnabled)(this.u,"quickDiffProvider")&&(E=d?.label),Ue(this,u,"f").$updateSourceControl(this.t,{hasQuickDiffProvider:!!d,quickDiffLabel:E})}get commitTemplate(){return this.j}set commitTemplate(d){d!==this.j&&(this.j=d,Ue(this,u,"f").$updateSourceControl(this.t,{commitTemplate:d}))}get acceptInputCommand(){return this.l}set acceptInputCommand(d){this.k.value=new R.DisposableStore,this.l=d;const E=this.v.converter.toInternal(d,this.k.value);Ue(this,u,"f").$updateSourceControl(this.t,{acceptInputCommand:E})}get actionButton(){return(0,D.checkProposedApiEnabled)(this.u,"scmActionButton"),this.n}set actionButton(d){(0,D.checkProposedApiEnabled)(this.u,"scmActionButton"),this.m.value=new R.DisposableStore,this.n=d;const E=d!==void 0?{command:this.v.converter.toInternal(d.command,this.m.value),secondaryCommands:d.secondaryCommands?.map(w=>w.map(N=>this.v.converter.toInternal(N,this.m.value))),description:d.description,enabled:d.enabled}:void 0;Ue(this,u,"f").$updateSourceControl(this.t,{actionButton:E??null})}get statusBarCommands(){return this.p}set statusBarCommands(d){if(this.p&&d&&r(this.p,d))return;this.o.value=new R.DisposableStore,this.p=d;const E=(d||[]).map(w=>this.v.converter.toInternal(w,this.o.value));Ue(this,u,"f").$updateSourceControl(this.t,{statusBarCommands:E})}get selected(){return this.q}constructor(d,E,w,N,j,V){this.u=d,this.v=w,this.w=N,this.x=j,this.y=V,u.set(this,void 0),this.e=new Map,this.g=void 0,this.h=void 0,this.j=void 0,this.k=new R.MutableDisposable,this.l=void 0,this.m=new R.MutableDisposable,this.o=new R.MutableDisposable,this.p=void 0,this.q=!1,this.s=new L.Emitter,this.onDidChangeSelection=this.s.event,this.t=m.d++,this.z=new Map,this.A=new Set,_e(this,u,E,"f"),this.f=new o(d,Ue(this,u,"f"),this.t),Ue(this,u,"f").$registerSourceControl(this.t,N,j,V)}createResourceGroup(d,E){const w=new c(Ue(this,u,"f"),this.v,this.t,d,E),N=L.Event.once(w.onDidDispose)(()=>this.z.delete(w));return this.z.set(w,N),this.eventuallyAddResourceGroups(),w}eventuallyAddResourceGroups(){const d=[],E=[];for(const[w,N]of this.z){N.dispose();const j=w.onDidUpdateResourceStates(()=>{this.A.add(w),this.eventuallyUpdateResourceStates()});L.Event.once(w.onDidDispose)(()=>{this.A.delete(w),j.dispose(),this.e.delete(w.handle),Ue(this,u,"f").$unregisterGroup(this.t,w.handle)}),d.push([w.handle,w.id,w.label,w.features]);const V=w._takeResourceStateSnapshot();V.length>0&&E.push([w.handle,V]),this.e.set(w.handle,w)}Ue(this,u,"f").$registerGroups(this.t,d,E),this.z.clear()}eventuallyUpdateResourceStates(){const d=[];this.A.forEach(E=>{const w=E._takeResourceStateSnapshot();w.length!==0&&d.push([E.handle,w])}),d.length>0&&Ue(this,u,"f").$spliceResourceStates(this.t,d),this.A.clear()}getResourceGroup(d){return this.e.get(d)}setSelectionState(d){this.q=d,this.s.fire(d)}dispose(){this.k.dispose(),this.m.dispose(),this.o.dispose(),this.e.forEach(d=>d.dispose()),Ue(this,u,"f").$unregisterSourceControl(this.t)}}u=new WeakMap,m.d=0,qe([(0,l.debounce)(100)],m.prototype,"eventuallyAddResourceGroups",null),qe([(0,l.debounce)(100)],m.prototype,"eventuallyUpdateResourceStates",null);let n=class on{get onDidChangeActiveProvider(){return this.j.event}constructor(d,E,w){this.l=E,this.m=w,this.g=new Map,this.h=new Map,this.j=new L.Emitter,this.e=d.getProxy(A.MainContext.MainThreadSCM),this.f=d.getProxy(A.MainContext.MainThreadTelemetry),E.registerArgumentProcessor({processArgument:N=>{if(N&&N.$mid===3){const j=this.g.get(N.sourceControlHandle);if(!j)return N;const V=j.getResourceGroup(N.groupHandle);return V?V.getResourceState(N.handle):N}else if(N&&N.$mid===4){const j=this.g.get(N.sourceControlHandle);return j?j.getResourceGroup(N.groupHandle):N}else if(N&&N.$mid===5){const j=this.g.get(N.handle);return j||N}return N}})}createSourceControl(d,E,w,N){this.m.trace("ExtHostSCM#createSourceControl",d.identifier.value,E,w,N),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:d.identifier.value});const j=on.d++,V=new m(d,this.e,this.l,E,w,N);this.g.set(j,V);const Q=this.h.get(P.ExtensionIdentifier.toKey(d.identifier))||[];return Q.push(V),this.h.set(P.ExtensionIdentifier.toKey(d.identifier),Q),V}getLastInputBox(d){this.m.trace("ExtHostSCM#getLastInputBox",d.identifier.value);const E=this.h.get(P.ExtensionIdentifier.toKey(d.identifier)),w=E&&E[E.length-1];return w&&w.inputBox}$provideOriginalResource(d,E,w){const N=a.URI.revive(E);this.m.trace("ExtHostSCM#$provideOriginalResource",d,N.toString());const j=this.g.get(d);return!j||!j.quickDiffProvider||!j.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,S.asPromise)(()=>j.quickDiffProvider.provideOriginalResource(N,w)).then(V=>V||null)}$onInputBoxValueChange(d,E){this.m.trace("ExtHostSCM#$onInputBoxValueChange",d);const w=this.g.get(d);return w&&w.inputBox.$onInputBoxValueChange(E),Promise.resolve(void 0)}$executeResourceCommand(d,E,w,N){this.m.trace("ExtHostSCM#$executeResourceCommand",d,E,w);const j=this.g.get(d);if(!j)return Promise.resolve(void 0);const V=j.getResourceGroup(E);return V?V.$executeResourceCommand(w,N):Promise.resolve(void 0)}$validateInput(d,E,w){this.m.trace("ExtHostSCM#$validateInput",d);const N=this.g.get(d);return!N||!N.inputBox.validateInput?Promise.resolve(void 0):(0,S.asPromise)(()=>N.inputBox.validateInput(E,w)).then(j=>{if(!j)return Promise.resolve(void 0);const V=k.MarkdownString.fromStrict(j.message);return V?Promise.resolve([V,j.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(d){return this.m.trace("ExtHostSCM#$setSelectedSourceControl",d),d!==void 0&&this.g.get(d)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=d,Promise.resolve(void 0)}};n.d=0,n=qe([ze(2,O.ILogService)],n),e.ExtHostSCM=n}),define(ye[98],De([1,0,5,3,4]),function(re,e,a,L,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class R{constructor(A){this.b=new L.Emitter,this.onDidChangePassword=this.b.event,this.a=A.getProxy(a.MainContext.MainThreadSecretState)}async $onDidChangePassword(A){this.b.fire(A)}get(A,y){return this.a.$getPassword(A,y)}store(A,y,I){return this.a.$setPassword(A,y,I)}delete(A,y){return this.a.$deletePassword(A,y)}}e.ExtHostSecretState=R,e.IExtHostSecretState=(0,l.createDecorator)("IExtHostSecretState")});var _e=this&&this.__classPrivateFieldSet||function(re,e,a,L,l){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!l:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?l.call(re,a):l?l.value=a:e.set(re,a),a},Ue=this&&this.__classPrivateFieldGet||function(re,e,a,L){if(a==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!L:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?L:a==="a"?L.call(re):L?L.value:e.get(re)};define(ye[273],De([1,0,7,5,179,6,14,10]),function(re,e,a,L,l,R,S,A){"use strict";var y,I;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class O{constructor(D,f,u,h,p=a.StatusBarAlignment.Left,b){y.set(this,void 0),I.set(this,void 0),this.i=!1,this.j=!1,this.k="",this.q=new R.DisposableStore,_e(this,y,D,"f"),_e(this,I,f,"f"),this.c=O.a++,this.e=u,this.f=h,this.g=p,this.h=this.u(b)}u(D){if(!!(0,A.isNumber)(D))return D===Number.POSITIVE_INFINITY?Number.MAX_VALUE:D===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:D}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(D){this.k=D,this.v()}set name(D){this.m=D,this.v()}set tooltip(D){this.l=D,this.v()}set color(D){this.n=D,this.v()}set backgroundColor(D){D&&!O.b.has(D.id)&&(D=void 0),this.o=D,this.v()}set command(D){this.r?.fromApi!==D&&(this.p&&this.q.add(this.p),this.p=new R.DisposableStore,typeof D=="string"?this.r={fromApi:D,internal:Ue(this,I,"f").toInternal({title:"",command:D},this.p)}:D?this.r={fromApi:D,internal:Ue(this,I,"f").toInternal(D,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(D){this.t=D,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,Ue(this,y,"f").$dispose(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let D;this.e?this.f?D=`${this.e.identifier.value}.${this.f}`:D=this.e.identifier.value:D=this.f;let f;this.m?f=this.m:f=(0,l.localize)(0,null,this.e.displayName||this.e.name);let u=this.n;this.o&&(u=O.b.get(this.o.id));const h=S.MarkdownString.fromStrict(this.l);Ue(this,y,"f").$setEntry(this.c,D,f,this.k,h,this.r?.internal,u,this.o,this.g===a.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}y=new WeakMap,I=new WeakMap,O.a=0,O.b=new Map([["statusBarItem.errorBackground",new a.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new a.ThemeColor("statusBarItem.warningForeground")]]),e.ExtHostStatusBarEntry=O;class P{constructor(D){this.b=[],this.a=D.createStatusBarEntry(void 0,"status.extensionMessage",a.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,l.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(D){const f={message:D};return this.b.unshift(f),this.c(),new a.Disposable(()=>{const u=this.b.indexOf(f);u>=0&&(this.b.splice(u,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class v{constructor(D,f){this.a=D.getProxy(L.MainContext.MainThreadStatusBar),this.b=f,this.c=new P(this)}createStatusBarEntry(D,f,u,h){return new O(this.a,this.b,D,f,u,h)}setStatusBarMessage(D,f){const u=this.c.setMessage(D);let h;return typeof f=="number"?h=setTimeout(()=>u.dispose(),f):typeof f<"u"&&f.then(()=>u.dispose(),()=>u.dispose()),new a.Disposable(()=>{u.dispose(),clearTimeout(h)})}}e.ExtHostStatusBar=v}),define(ye[99],De([1,0,5,3,4]),function(re,e,a,L,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class R{constructor(A,y){this.c=y,this.b=new L.Emitter,this.onDidChangeStorage=this.b.event,this.a=A.getProxy(a.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(A,y){this.a.$registerExtensionStorageKeysToSync(A,y)}async initializeExtensionStorage(A,y,I){const O=await this.a.$initializeExtensionStorage(A,y);let P;return O&&(P=this.d(A,y,O)),P||I}setValue(A,y,I){return this.a.$setValue(A,y,I)}$acceptValue(A,y,I){const O=this.d(A,y,I);O&&this.b.fire({shared:A,key:y,value:O})}d(A,y,I){try{return JSON.parse(I)}catch(O){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${y}, global: ${A}): ${O}`)}}}e.ExtHostStorage=R,e.IExtHostStorage=(0,l.createDecorator)("IExtHostStorage")}),define(ye[80],De([1,0,4,25,13,79,2]),function(re,e,a,L,l,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,a.createDecorator)("IExtensionStoragePaths");let A=class{constructor(I,O,P){this.d=O,this.f=P,this.a=I.workspace??void 0,this.b=I.environment,this.whenReady=this.h().then(v=>this.c=v)}async g(I){return S.URI.joinPath(this.b.workspaceStorageHome,I)}async h(){if(!this.a)return Promise.resolve(void 0);const I=this.a.id,O=await this.g(I);try{return await this.f.value.stat(O),this.d.trace("[ExtHostStorage] storage dir already exists",O),O}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",O),await this.f.value.createDirectory(O),await this.f.value.writeFile(S.URI.joinPath(O,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:S.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),O}catch(P){this.d.error("[ExtHostStorage]",P);return}}workspaceValue(I){if(this.c)return S.URI.joinPath(this.c,I.identifier.value)}globalValue(I){return S.URI.joinPath(this.b.globalStorageHome,I.identifier.value.toLowerCase())}onWillDeactivateAll(){}};A=qe([ze(0,L.IExtHostInitDataService),ze(1,l.ILogService),ze(2,R.IExtHostConsumerFileSystem)],A),e.ExtensionStoragePaths=A}),define(ye[41],De([1,0,3,5,4,2,18,6,7,181,11,214,21,30,215,51,10,17,14]),function(re,e,a,L,l,R,S,A,y,I,O,P,v,k,D,f,u,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.BaseExtHostTerminalService=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,l.createDecorator)("IExtHostTerminalService");class b{constructor(n,t,d,E){this.k=n,this._id=t,this.l=d,this.m=E,this.a=!1,this.j={isInteractedWith:!1},this.isOpen=!1,this.l=Object.freeze(this.l),this.b=new Promise(N=>this.f=N);const w=this;this.value={get name(){return w.m||""},get processId(){return w.b},get creationOptions(){return w.l},get exitStatus(){return w.h},get state(){return w.j},sendText(N,j=!0){w.o(),w.k.$sendText(w._id,N,j)},show(N){w.o(),w.k.$show(w._id,N)},hide(){w.o(),w.k.$hide(w._id)},dispose(){w.a||(w.a=!0,w.k.$dispose(w._id))},get dimensions(){if(!(w.d===void 0||w.g===void 0))return{columns:w.d,rows:w.g}}}}async create(n,t){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.k.$createTerminal(this._id,{name:n.name,shellPath:(0,u.withNullAsUndefined)(n.shellPath),shellArgs:(0,u.withNullAsUndefined)(n.shellArgs),cwd:(0,u.withNullAsUndefined)(n.cwd),env:(0,u.withNullAsUndefined)(n.env),icon:(0,u.withNullAsUndefined)(o(n.iconPath)),color:f.ThemeColor.isThemeColor(n.color)?n.color.id:void 0,initialText:(0,u.withNullAsUndefined)(n.message),strictEnv:(0,u.withNullAsUndefined)(n.strictEnv),hideFromUser:(0,u.withNullAsUndefined)(n.hideFromUser),isFeatureTerminal:(0,u.withNullAsUndefined)(t?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,u.withNullAsUndefined)(t?.useShellEnvironment),location:t?.location||this.n(n.location,t?.resolvedExtHostIdentifier),isTransient:(0,u.withNullAsUndefined)(n.isTransient)})}async createExtensionTerminal(n,t,d,E){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.k.$createTerminal(this._id,{name:this.m,isExtensionCustomPtyTerminal:!0,icon:d,color:f.ThemeColor.isThemeColor(E)?E.id:void 0,location:this.n(n,t),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}n(n,t){return typeof n=="object"?"parentTerminal"in n&&n.parentTerminal&&t?{parentTerminal:t}:"viewColumn"in n?{viewColumn:p.ViewColumn.from(n.viewColumn),preserveFocus:n.preserveFocus}:void 0:n}o(){if(this.a)throw new Error("Terminal has already been disposed")}set name(n){this.m=n}setExitStatus(n,t){this.h=Object.freeze({code:n,reason:t})}setDimensions(n,t){return n===this.d&&t===this.g||n===0||t===0?!1:(this.d=n,this.g=t,!0)}setInteractedWith(){return this.j.isInteractedWith?!1:(this.j={isInteractedWith:!0},!0)}_setProcessId(n){this.f?(this.f(n),this.f=void 0):this.b.then(t=>{t!==n&&(this.b=Promise.resolve(n))})}}e.ExtHostTerminal=b;class C{get onProcessReady(){return this.b.event}constructor(n){this.g=n,this.id=0,this.shouldPersist=!1,this.a=new a.Emitter,this.onProcessData=this.a.event,this.b=new a.Emitter,this.d=new a.Emitter,this.onDidChangeProperty=this.d.event,this.f=new a.Emitter,this.onProcessExit=this.f.event}refreshProperty(n){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${n}`)}updateProperty(n,t){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${n}, value: ${t}`)}async start(){}shutdown(){this.g.close()}input(n){this.g.handleInput?.(n)}resize(n,t){this.g.setDimensions?.({columns:n,rows:t})}async processBinary(n){}acknowledgeDataEvent(n){}async setUnicodeVersion(n){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(n){this.g.onDidWrite(t=>this.a.fire(t)),this.g.onDidClose?.((t=void 0)=>{this.f.fire(t===void 0?void 0:t)}),this.g.onDidOverrideDimensions?.(t=>{t&&this.d.fire({type:"overrideDimensions",value:{cols:t.columns,rows:t.rows}})}),this.g.onDidChangeName?.(t=>{this.d.fire({type:"title",value:t})}),this.g.open(n||void 0),n&&this.g.setDimensions?.(n),this.b.fire({pid:-1,cwd:""})}}let g=1,i=class extends A.Disposable{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(n=>n.value)}get onDidWriteTerminalData(){return this.I.event}constructor(n,t){super(),this.f=[],this.g=new Map,this.h={},this.j={},this.k={},this.l=new Map,this.u=new Set,this.v=new Map,this.w=new Map,this.y=new Map,this.z=new Map,this.C=new a.Emitter,this.onDidCloseTerminal=this.C.event,this.D=new a.Emitter,this.onDidOpenTerminal=this.D.event,this.F=new a.Emitter,this.onDidChangeActiveTerminal=this.F.event,this.G=new a.Emitter,this.onDidChangeTerminalDimensions=this.G.event,this.H=new a.Emitter,this.onDidChangeTerminalState=this.H.event,this.J=new a.Emitter,this.onDidChangeShell=this.J.event,this.a=t.getProxy(L.MainContext.MainThreadTerminalService),this.s=new D.TerminalDataBufferer(this.a.$sendProcessData),this.I=new a.Emitter({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.a.$registerProcessSupport(n),this.B({dispose:()=>{for(const[d,E]of this.g)E.shutdown(!0)}})}getDefaultShell(n){return(n?this.n:this.m)?.path||""}getDefaultShellArgs(n){return(n?this.n:this.m)?.args||[]}createExtensionTerminal(n,t){const d=new b(this.a,(0,k.generateUuid)(),n,n.name),E=new C(n.pty);return d.createExtensionTerminal(n.location,this.L(n,t).resolvedExtHostIdentifier,o(n.iconPath),c(n.color)).then(w=>{const N=this.M(w,E);this.h[w]=N}),this.f.push(d),d.value}L(n,t){if(t=t||{},n.location&&typeof n.location=="object"&&"parentTerminal"in n.location){const d=n.location.parentTerminal;if(d){const E=this.f.find(w=>w.value===d);E&&(t.resolvedExtHostIdentifier=E._id)}}else n.location&&typeof n.location!="object"?t.location=n.location:t.location&&typeof t.location=="object"&&"splitActiveTerminal"in t.location&&(t.location={splitActiveTerminal:!0});return t}attachPtyToTerminal(n,t){if(!this.O(n))throw new Error(`Cannot resolve terminal with id ${n} for virtual process`);const E=new C(t),w=this.M(n,E);this.h[n]=w}async $acceptActiveTerminalChanged(n){const t=this.b;if(n===null){this.b=void 0,t!==this.b&&this.F.fire(this.b);return}const d=this.O(n);d&&(this.b=d,t!==this.b&&this.F.fire(this.b.value))}async $acceptTerminalProcessData(n,t){const d=this.O(n);d&&this.I.fire({terminal:d.value,data:t})}async $acceptTerminalDimensions(n,t,d){const E=this.O(n);E&&E.setDimensions(t,d)&&this.G.fire({terminal:E.value,dimensions:E.value.dimensions})}async $acceptTerminalMaximumDimensions(n,t,d){this.g.get(n)?.resize(t,d)}async $acceptTerminalTitleChange(n,t){const d=this.O(n);d&&(d.name=t)}async $acceptTerminalClosed(n,t,d){const E=this.Q(this.f,n);if(E!==null){const w=this.f.splice(E,1)[0];w.setExitStatus(t,d),this.C.fire(w.value)}}$acceptTerminalOpened(n,t,d,E){if(t){const j=this.Q(this.f,t);if(j!==null){this.f[j]._id=n,this.D.fire(this.terminals[j]),this.f[j].isOpen=!0;return}}const w={name:E.name,shellPath:E.executable,shellArgs:E.args,cwd:typeof E.cwd=="string"?E.cwd:R.URI.revive(E.cwd),env:E.env,hideFromUser:E.hideFromUser},N=new b(this.a,n,w,d);this.f.push(N),this.D.fire(N.value),N.isOpen=!0}async $acceptTerminalProcessId(n,t){this.O(n)?._setProcessId(t)}async $startExtensionTerminal(n,t){const d=this.O(n);if(!d)return{message:(0,I.localize)(0,null,n)};d.isOpen||await new Promise(w=>{const N=this.onDidOpenTerminal(async j=>{j===d.value&&(N.dispose(),w())})});const E=this.g.get(n);E?E.startSendingEvents(t):this.j[n]={initialDimensions:t}}M(n,t){const d=new A.DisposableStore;d.add(t.onProcessReady(w=>this.a.$sendProcessReady(n,w.pid,w.cwd))),d.add(t.onDidChangeProperty(w=>this.a.$sendProcessProperty(n,w))),this.s.startBuffering(n,t.onProcessData),d.add(t.onProcessExit(w=>this.N(n,w))),this.g.set(n,t);const E=this.j[n];return E&&t instanceof C&&(t.startSendingEvents(E.initialDimensions),delete this.j[n]),d}$acceptProcessAckDataEvent(n,t){this.g.get(n)?.acknowledgeDataEvent(t)}$acceptProcessInput(n,t){this.g.get(n)?.input(t)}$acceptTerminalInteraction(n){const t=this.O(n);t?.setInteractedWith()&&this.H.fire(t.value)}$acceptProcessResize(n,t,d){try{this.g.get(n)?.resize(t,d)}catch(E){if(E.code!=="EPIPE"&&E.code!=="ERR_IPC_CHANNEL_CLOSED")throw E}}$acceptProcessShutdown(n,t){this.g.get(n)?.shutdown(t)}$acceptProcessRequestInitialCwd(n){this.g.get(n)?.getInitialCwd().then(t=>this.a.$sendProcessProperty(n,{type:"initialCwd",value:t}))}$acceptProcessRequestCwd(n){this.g.get(n)?.getCwd().then(t=>this.a.$sendProcessProperty(n,{type:"cwd",value:t}))}$acceptProcessRequestLatency(n){return Promise.resolve(n)}registerLinkProvider(n){return this.u.add(n),this.u.size===1&&this.a.$startLinkProvider(),new y.Disposable(()=>{this.u.delete(n),this.u.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(n,t,d){if(this.v.has(t))throw new Error(`Terminal profile provider "${t}" already registered`);return this.v.set(t,d),this.a.$registerProfileProvider(t,n.identifier.value),new y.Disposable(()=>{this.v.delete(t),this.a.$unregisterProfileProvider(t)})}registerTerminalQuickFixProvider(n,t,d){if(this.w.has(n))throw new Error(`Terminal quick fix provider "${n}" is already registered`);return this.w.set(n,d),this.a.$registerQuickFixProvider(n,t),new y.Disposable(()=>{this.w.delete(n),this.a.$unregisterQuickFixProvider(n)})}async $provideTerminalQuickFixes(n,t){const d=new v.CancellationTokenSource().token;if(d.isCancellationRequested)return;const E=this.w.get(n);if(!E)return;const w=await E.provideTerminalQuickFixes(t,d);if(w!==null)return w}async $createContributedProfileTerminal(n,t){const d=new v.CancellationTokenSource().token;let E=await this.v.get(n)?.provideTerminalProfile(d);if(!d.isCancellationRequested){if(E&&!("options"in E)&&(E={options:E}),!E||!("options"in E))throw new Error(`No terminal profile options provided for id "${n}"`);if("pty"in E.options){this.createExtensionTerminal(E.options,t);return}this.createTerminalFromOptions(E.options,t)}}async $provideLinks(n,t){const d=this.O(n);if(!d)return[];this.y.delete(n),this.z.get(n)?.dispose(!0);const w=new v.CancellationTokenSource;this.z.set(n,w);const N=[],j={terminal:d.value,line:t},V=[];for(const U of this.u)V.push(h.Promises.withAsyncBody(async T=>{w.token.onCancellationRequested(()=>T({provider:U,links:[]}));const F=await U.provideTerminalLinks(j,w.token)||[];w.token.isCancellationRequested||T({provider:U,links:F})}));const Q=await Promise.all(V);if(w.token.isCancellationRequested)return[];const x=new Map;for(const U of Q)U&&U.links.length>0&&N.push(...U.links.map(T=>{const F={id:g++,startIndex:T.startIndex,length:T.length,label:T.tooltip};return x.set(F.id,{provider:U.provider,link:T}),F}));return this.y.set(n,x),N}$activateLink(n,t){const d=this.y.get(n)?.get(t);!d||d.provider.handleTerminalLink(d.link)}N(n,t){this.s.stopBuffering(n),this.g.delete(n),delete this.j[n];const d=this.h[n];d&&(d.dispose(),delete this.h[n]),this.a.$sendProcessExit(n,t)}O(n){return this.P(this.f,n)}P(n,t){const d=this.Q(n,t);return d!==null?n[d]:null}Q(n,t){let d=null;return n.some((E,w)=>E._id===t?(d=w,!0):!1),d}getEnvironmentVariableCollection(n){let t=this.l.get(n.identifier.value);return t||(t=new s,this.S(n.identifier.value,t)),t}R(n,t){const d=(0,P.serializeEnvironmentVariableCollection)(t.map);this.a.$setEnvironmentVariableCollection(n,t.persistent,d.length===0?void 0:d)}$initEnvironmentVariableCollections(n){n.forEach(t=>{const d=t[0],E=new s(t[1]);this.S(d,E)})}$acceptDefaultProfile(n,t){const d=this.m;this.m=n,this.n=t,d?.path!==n.path&&this.J.fire(n.path)}S(n,t){this.l.set(n,t),t.onDidChangeCollection(()=>{this.R(n,t)})}};i=qe([ze(1,S.IExtHostRpcService)],i),e.BaseExtHostTerminalService=i;class s{get persistent(){return this.a}set persistent(n){this.a=n,this.b.fire()}get onDidChangeCollection(){return this.b&&this.b.event}constructor(n){this.map=new Map,this.a=!0,this.b=new a.Emitter,this.map=new Map(n)}get size(){return this.map.size}replace(n,t){this.d(n,{value:t,type:y.EnvironmentVariableMutatorType.Replace})}append(n,t){this.d(n,{value:t,type:y.EnvironmentVariableMutatorType.Append})}prepend(n,t){this.d(n,{value:t,type:y.EnvironmentVariableMutatorType.Prepend})}d(n,t){const d=this.map.get(n);(!d||d.value!==t.value||d.type!==t.type)&&(this.map.set(n,t),this.b.fire())}get(n){return this.map.get(n)}forEach(n,t){this.map.forEach((d,E)=>n.call(t,E,d,this))}[Symbol.iterator](){return this.map.entries()}delete(n){this.map.delete(n),this.b.fire()}clear(){this.map.clear(),this.b.fire()}}let r=class extends i{constructor(n){super(!1,n)}createTerminal(n,t,d){throw new O.NotSupportedError}createTerminalFromOptions(n,t){throw new O.NotSupportedError}};r=qe([ze(0,S.IExtHostRpcService)],r),e.WorkerExtHostTerminalService=r;function o(m){if(!(!m||typeof m=="string"))return"id"in m?{id:m.id,color:m.color}:m}function c(m){return f.ThemeColor.isThemeColor(m)?m:void 0}});var Ue=this&&this.__classPrivateFieldGet||function(re,e,a,L){if(a==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!L:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?L:a==="a"?L.call(re):L?L.value:e.get(re)},_e=this&&this.__classPrivateFieldSet||function(re,e,a,L,l){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!l:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?l.call(re,a):l?l.value=a:e.set(re,a),a};define(ye[274],De([1,0,15,17,22,21,3,64,89,6,23,10,30,5,18,137,14,7,58,94,76,26]),function(re,e,a,L,l,R,S,A,y,I,O,P,v,k,D,f,u,h,p,b,C,g){"use strict";var i,s;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let r=class{constructor(U,T,F){this.j=F,this.c=new S.Emitter,this.d=new Map,this.onResultsChanged=this.c.event,this.results=[],this.f=U.getProxy(k.MainContext.MainThreadTesting),this.h=new j(this.f),this.g=new n(this.f),T.registerArgumentProcessor({processArgument:B=>{if(B?.$mid!==15)return B;const Z=B,_=Z.tests[Z.tests.length-1].item.extId;return this.d.get(p.TestId.root(_))?.collection.tree.get(_)?.actual??(0,f.toItemFromContext)(B)}})}createTestController(U,T,F,B){if(this.d.has(T))throw new Error(`Attempt to insert a duplicate controller with ID "${T}"`);const Z=new I.DisposableStore,_=Z.add(new f.ExtHostTestItemCollection(T,F,this.j));_.root.label=F;const H=new Map,Y=this.f,ie={items:_.root.children,get label(){return F},set label(X){F=X,_.root.label=X,Y.$updateController(T,{label:F})},get refreshHandler(){return B},set refreshHandler(X){B=X,Y.$updateController(T,{canRefresh:!!X})},get id(){return T},createRunProfile:(X,J,ee,me,ve,Ie)=>{let Re=(0,y.hash)(X);for(;H.has(Re);)Re++;return Ie!==void 0&&(0,g.checkProposedApiEnabled)(U,"testContinuousRun"),new V(this.f,H,T,Re,X,J,ee,me,ve,Ie)},createTestItem(X,J,ee){return new f.TestItemImpl(T,X,J,ee)},createTestRun:(X,J,ee=!0)=>this.g.createTestRun(T,_,X,J,ee),set resolveHandler(X){_.resolveHandler=X},get resolveHandler(){return _.resolveHandler},dispose:()=>{Z.dispose()}};Y.$registerTestController(T,F,!!B),Z.add((0,I.toDisposable)(()=>Y.$unregisterTestController(T)));const ge={controller:ie,collection:_,profiles:H};return this.d.set(T,ge),Z.add((0,I.toDisposable)(()=>this.d.delete(T))),Z.add(_.onDidGenerateDiff(X=>Y.$publishDiff(T,X.map(C.TestsDiffOp.serialize)))),ie}createTestObserver(){return this.h.checkout()}async runTests(U,T=R.CancellationToken.None){const F=t(U);if(!F)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const B=this.d.get(F.controllerId);if(!B)throw new Error("Controller not found");await this.f.$runTests({isUiTriggered:!1,targets:[{testIds:U.include?.map(Z=>p.TestId.fromExtHostTestItem(Z,B.collection.root.id).toString())??[B.collection.root.id],profileGroup:Q[F.kind],profileId:F.profileId,controllerId:F.controllerId}],exclude:U.exclude?.map(Z=>Z.id)},T)}$syncTests(){for(const{collection:U}of this.d.values())U.flushDiff();return Promise.resolve()}$provideFileCoverage(U,T,F){return(0,a.mapFind)(this.g.trackers,Z=>Z.id===U?Z.getCoverage(T):void 0)?.provideFileCoverage(F)??Promise.resolve([])}$resolveFileCoverage(U,T,F,B){return(0,a.mapFind)(this.g.trackers,_=>_.id===U?_.getCoverage(T):void 0)?.resolveFileCoverage(F,B)??Promise.resolve([])}$configureRunProfile(U,T){this.d.get(U)?.profiles.get(T)?.configureHandler?.()}async $refreshTests(U,T){await this.d.get(U)?.controller.refreshHandler?.(T)}$publishTestResults(U){this.results=Object.freeze(U.map(T=>(0,O.deepFreeze)(u.TestResults.to(T))).concat(this.results).sort((T,F)=>F.completedAt-T.completedAt).slice(0,32)),this.c.fire()}async $expandTest(U,T){const F=this.d.get(p.TestId.fromString(U).controllerId)?.collection;F&&(await F.expand(U,T<0?1/0:T),F.flushDiff())}$acceptDiff(U){this.h.applyDiff(U.map(C.TestsDiffOp.deserialize))}async $runControllerTests(U,T){return Promise.all(U.map(F=>this.k(F,!1,T)))}async $startContinuousRun(U,T){const F=new R.CancellationTokenSource(T),B=await Promise.all(U.map(Z=>this.k(Z,!0,F.token)));return!T.isCancellationRequested&&!B.some(Z=>Z.error)&&await new Promise(Z=>T.onCancellationRequested(Z)),F.dispose(!0),B}async k(U,T,F){const B=this.d.get(U.controllerId);if(!B)return{};const{collection:Z,profiles:_}=B,H=_.get(U.profileId);if(!H)return{};const Y=U.testIds.map(J=>Z.tree.get(J)).filter(P.isDefined),ie=U.excludeExtIds.map(J=>B.collection.tree.get(J)).filter(P.isDefined).filter(J=>Y.some(ee=>ee.fullId.compare(J.fullId)===2));if(!Y.length)return{};const ge=new h.TestRunRequest2(Y.some(J=>J.actual instanceof f.TestItemRootImpl)?void 0:Y.map(J=>J.actual),ie.map(J=>J.actual),H,T),X=(0,C.isStartControllerTests)(U)&&this.g.prepareForMainThreadTestRun(ge,d.fromInternal(U,B.collection),F);try{return await H.runHandler(ge,F),{}}catch(J){return{error:String(J)}}finally{X&&(X.hasRunningTasks&&!F.isCancellationRequested&&await S.Event.toPromise(X.onEnd),X.dispose())}}$cancelExtensionTestRun(U){U===void 0?this.g.cancelAllRuns():this.g.cancelRunById(U)}};r=qe([ze(0,D.IExtHostRpcService)],r),e.ExtHostTesting=r;const o=1e4;var c;(function(x){x[x.Running=0]="Running",x[x.Cancelling=1]="Cancelling",x[x.Ended=2]="Ended"})(c||(c={}));class m extends I.Disposable{get hasRunningTasks(){return this.f.size>0}get id(){return this.k.id}constructor(U,T,F){super(),this.k=U,this.l=T,this.c=0,this.f=new Map,this.g=new Set,this.j=this.B(new S.Emitter),this.onEnd=this.j.event,this.h=this.B(new R.CancellationTokenSource(F));const B=this.B(new L.RunOnceScheduler(()=>this.m(),o));this.B(this.h.token.onCancellationRequested(()=>B.schedule()))}cancel(){this.c===0?(this.h.cancel(),this.c=1):this.c===1&&this.m()}getCoverage(U){return this.f.get(U)?.coverage}createRun(U){const T=this.k.id,F=this.k.controllerId,B=(0,v.generateUuid)(),Z=new E(this.l,T,B),_=ge=>(X,...J)=>{if(Y){console.warn(`Setting the state of test "${X.id}" is a no-op after the run ends.`);return}!this.k.isIncluded(X)||(this.s(X),ge(X,...J))},H=(ge,X)=>{const J=X instanceof Array?X.map(u.TestMessage.from):[u.TestMessage.from(X)];if(ge.uri&&ge.range){const ee={range:u.Range.from(ge.range),uri:ge.uri};for(const me of J)me.location=me.location||ee}this.l.$appendTestMessagesInRun(T,B,p.TestId.fromExtHostTestItem(ge,F).toString(),J)};let Y=!1;const ie={isPersisted:this.k.isPersisted,token:this.h.token,name:U,get coverageProvider(){return Z.coverageProvider},set coverageProvider(ge){Z.coverageProvider=ge},enqueued:_(ge=>{this.l.$updateTestStateInRun(T,B,p.TestId.fromExtHostTestItem(ge,F).toString(),1)}),skipped:_(ge=>{this.l.$updateTestStateInRun(T,B,p.TestId.fromExtHostTestItem(ge,F).toString(),5)}),started:_(ge=>{this.l.$updateTestStateInRun(T,B,p.TestId.fromExtHostTestItem(ge,F).toString(),2)}),errored:_((ge,X,J)=>{H(ge,X),this.l.$updateTestStateInRun(T,B,p.TestId.fromExtHostTestItem(ge,F).toString(),6,J)}),failed:_((ge,X,J)=>{H(ge,X),this.l.$updateTestStateInRun(T,B,p.TestId.fromExtHostTestItem(ge,F).toString(),4,J)}),passed:_((ge,X)=>{this.l.$updateTestStateInRun(T,B,p.TestId.fromExtHostTestItem(ge,this.k.controllerId).toString(),3,X)}),appendOutput:(ge,X,J)=>{Y||(J&&(this.k.isIncluded(J)?this.s(J):J=void 0),this.l.$appendOutputToRun(T,B,l.VSBuffer.fromString(ge),X&&u.location.from(X),J&&p.TestId.fromExtHostTestItem(J,F).toString()))},end:()=>{Y||(Y=!0,this.l.$finishedTestRunTask(T,B),this.f.delete(B),this.f.size||this.p())}};return this.f.set(B,{run:ie,coverage:Z}),this.l.$startedTestRunTask(T,{id:B,name:U,running:!0}),ie}m(){for(const{run:U}of this.f.values())U.end()}p(){this.c!==2&&(this.c=2,this.j.fire())}s(U){if(!(U instanceof f.TestItemImpl))throw new b.InvalidTestItemError(U.id);if(this.g.has(p.TestId.fromExtHostTestItem(U,this.k.controllerId).toString()))return;const T=[],F=this.k.colllection.root;for(;;){const B=u.TestItem.from(U);if(T.unshift(B),this.g.has(B.extId)||(this.g.add(B.extId),U===F))break;U=U.parent||F}this.l.$addTestsToRun(this.k.controllerId,this.k.id,T)}}class n{get trackers(){return this.c.values()}constructor(U){this.d=U,this.c=new Map}prepareForMainThreadTestRun(U,T,F){return this.f(U,T,F)}cancelRunById(U){for(const T of this.c.values())if(T.id===U){T.cancel();return}}cancelAllRuns(){for(const U of this.c.values())U.cancel()}createTestRun(U,T,F,B,Z){const _=this.c.get(F);if(_)return _.createRun(B);const H=d.fromPublic(U,T,F,Z),Y=t(F);this.d.$startedExtensionTestRun({controllerId:U,continuous:!!F.continuous,profile:Y&&{group:Q[Y.kind],id:Y.profileId},exclude:F.exclude?.map(ge=>p.TestId.fromExtHostTestItem(ge,T.root.id).toString())??[],id:H.id,include:F.include?.map(ge=>p.TestId.fromExtHostTestItem(ge,T.root.id).toString())??[T.root.id],persist:Z});const ie=this.f(F,H);return ie.onEnd(()=>{this.d.$finishedExtensionTestRun(H.id),ie.dispose()}),ie.createRun(B)}f(U,T,F){const B=new m(T,this.d,F);return this.c.set(U,B),B.onEnd(()=>this.c.delete(U)),B}}e.TestRunCoordinator=n;const t=x=>{if(!!x.profile){if(!(x.profile instanceof V))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return x.profile}};class d{static fromPublic(U,T,F,B){return new d(U,(0,v.generateUuid)(),F.include?.map(Z=>p.TestId.fromExtHostTestItem(Z,U).toString())??[U],F.exclude?.map(Z=>p.TestId.fromExtHostTestItem(Z,U).toString())??[],B,T)}static fromInternal(U,T){return new d(U.controllerId,U.runId,U.testIds,U.excludeExtIds,!0,T)}constructor(U,T,F,B,Z,_){this.controllerId=U,this.id=T,this.isPersisted=Z,this.colllection=_,this.c=F.map(H=>H+"\0"),this.d=B.map(H=>H+"\0")}isIncluded(U){const T=p.TestId.fromExtHostTestItem(U,this.controllerId).toString()+"\0";for(const F of this.d)if(T===F||T.startsWith(F))return!1;for(const F of this.c)if(T===F||T.startsWith(F))return!0;return!1}}e.TestRunDto=d;class E{set coverageProvider(U){if(this.c)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!U||(this.c=U,this.f.$signalCoverageAvailable(this.g,this.h))}get coverageProvider(){return this.c}constructor(U,T,F){this.f=U,this.g=T,this.h=F}async provideFileCoverage(U){if(!this.c)return[];this.d||(this.d=(async()=>this.c.provideFileCoverage(U))());try{return(await this.d)?.map(u.TestCoverage.fromFile)??[]}catch(T){throw this.d=void 0,T}}async resolveFileCoverage(U,T){const F=await this.d;let B=F?.[U];return!this.c||!F||!B?[]:(B.detailedCoverage||(B=F[U]=await this.c.resolveFileCoverage?.(B,T)??B),B.detailedCoverage?.map(u.TestCoverage.fromDetailed)??[])}}class w{get isEmpty(){return this.c.size===0&&this.f.size===0&&this.d.size===0}constructor(U){this.h=U,this.c=new Set,this.d=new Set,this.f=new Set,this.g=new Set}add(U){this.c.add(U)}update(U){Object.assign(U.revived,u.TestItem.toPlain(U.item)),this.c.has(U)||this.d.add(U)}remove(U){if(this.c.has(U)){this.c.delete(U);return}this.d.delete(U);const T=p.TestId.parentId(U.item.extId);if(T&&this.g.has(T.toString())){this.g.add(U.item.extId);return}this.f.add(U)}getChangeEvent(){const{c:U,d:T,f:F}=this;return{get added(){return[...U].map(B=>B.revived)},get updated(){return[...T].map(B=>B.revived)},get removed(){return[...F].map(B=>B.revived)}}}complete(){this.isEmpty||this.h.fire(this.getChangeEvent())}}class N extends C.AbstractIncrementalTestCollection{constructor(){super(...arguments),this.q=new S.Emitter,this.onDidChangeTests=this.q.event}get rootTests(){return super.f}getMirroredTestDataById(U){return this.d.get(U)}getMirroredTestDataByReference(U){return this.d.get(U.id)}p(U,T){return{...U,revived:u.TestItem.toPlain(U.item),depth:T?T.depth+1:0,children:new Set}}o(){return new w(this.q)}}class j{constructor(U){this.d=U}checkout(){this.c||(this.c=this.f());const U=this.c;return U.observers++,{onDidChangeTest:U.tests.onDidChangeTests,get tests(){return[...U.tests.rootTests].map(T=>T.revived)},dispose:(0,A.once)(()=>{--U.observers===0&&(this.d.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(U){return this.c?.tests.getMirroredTestDataByReference(U)}applyDiff(U){this.c?.tests.apply(U)}f(){const U=new N;return this.d.$subscribeToDiffs(),{observers:0,tests:U}}}class V{get label(){return this.d}set label(U){U!==this.d&&(this.d=U,Ue(this,i,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:U}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(U){U!==this.g&&(this.g=U,Ue(this,i,"f").$updateTestRunConfig(this.controllerId,this.profileId,{supportsContinuousRun:U}))}get isDefault(){return this.f}set isDefault(U){U!==this.f&&(this.f=U,Ue(this,i,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:U}))}get tag(){return this._tag}set tag(U){U?.id!==this._tag?.id&&(this._tag=U,Ue(this,i,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:U?u.TestTag.namespace(this.controllerId,U.id):null}))}get configureHandler(){return this.c}set configureHandler(U){U!==this.c&&(this.c=U,Ue(this,i,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!U}))}constructor(U,T,F,B,Z,_,H,Y=!1,ie=void 0,ge=!1){this.controllerId=F,this.profileId=B,this.d=Z,this.kind=_,this.runHandler=H,this.f=Y,this._tag=ie,this.g=ge,i.set(this,void 0),s.set(this,void 0),_e(this,i,U,"f"),_e(this,s,T,"f"),T.set(B,this);const X=Q[_];if(typeof X!="number")throw new Error(`Unknown TestRunProfile.group ${_}`);Ue(this,i,"f").$publishTestRunProfile({profileId:B,controllerId:F,tag:ie?u.TestTag.namespace(this.controllerId,ie.id):null,label:Z,group:X,isDefault:Y,hasConfigurationHandler:!1,supportsContinuousRun:ge})}dispose(){Ue(this,s,"f")?.delete(this.profileId)&&(_e(this,s,void 0,"f"),Ue(this,i,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=V,i=new WeakMap,s=new WeakMap;const Q={[h.TestRunProfileKind.Coverage]:8,[h.TestRunProfileKind.Debug]:4,[h.TestRunProfileKind.Run]:2}}),define(ye[275],De([1,0,15,3,5,138,14,7]),function(re,e,a,L,l,R,S,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class y{constructor(O,P){this.i=P,this.a=new L.Emitter,this.b=new L.Emitter,this.c=new L.Emitter,this.d=new L.Emitter,this.f=new L.Emitter,this.g=new L.Emitter,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=O.getProxy(l.MainContext.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(v=>this.g.fire(v)),this.i.onDidChangeActiveTextEditor(v=>this.f.fire(v))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(O){const P=this.i.allEditors();return O?P:P.map(v=>v.value)}async showTextDocument(O,P,v){let k;typeof P=="number"?k={position:S.ViewColumn.from(P),preserveFocus:v}:typeof P=="object"?k={position:S.ViewColumn.from(P.viewColumn),preserveFocus:P.preserveFocus,selection:typeof P.selection=="object"?S.Range.from(P.selection):void 0,pinned:typeof P.preview=="boolean"?!P.preview:void 0}:k={preserveFocus:!1};const D=await this.h.$tryShowTextDocument(O.uri,k),f=D&&this.i.getEditor(D);if(f)return f.value;throw D?new Error(`Could NOT open editor for "${O.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${O.uri.toString()}".`)}createTextEditorDecorationType(O,P){return new R.TextEditorDecorationType(this.h,O,P).value}$acceptEditorPropertiesChanged(O,P){const v=this.i.getEditor(O);if(!v)throw new Error("unknown text editor");if(P.options&&v._acceptOptions(P.options),P.selections){const k=P.selections.selections.map(S.Selection.to);v._acceptSelections(k)}if(P.visibleRanges){const k=a.coalesce(P.visibleRanges.map(S.Range.to));v._acceptVisibleRanges(k)}if(P.options&&this.b.fire({textEditor:v.value,options:{...P.options,lineNumbers:S.TextEditorLineNumbersStyle.to(P.options.lineNumbers)}}),P.selections){const k=A.TextEditorSelectionChangeKind.fromValue(P.selections.source),D=P.selections.selections.map(S.Selection.to);this.a.fire({textEditor:v.value,selections:D,kind:k})}if(P.visibleRanges){const k=a.coalesce(P.visibleRanges.map(S.Range.to));this.c.fire({textEditor:v.value,visibleRanges:k})}}$acceptEditorPositionData(O){for(const P in O){const v=this.i.getEditor(P);if(!v)throw new Error("Unknown text editor");const k=S.ViewColumn.to(O[P]);v.value.viewColumn!==k&&(v._acceptViewColumn(k),this.d.fire({textEditor:v.value,viewColumn:k}))}}getDiffInformation(O){return Promise.resolve(this.h.$getDiffInformation(O))}}e.ExtHostEditors=y}),define(ye[276],De([1,0,2,4,5,6,7,14,27,10]),function(re,e,a,L,l,R,S,A,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,L.createDecorator)("IExtHostTimeline");class O{constructor(k,D){this.b=new Map,this.c=new Map,this.a=k.getProxy(l.MainContext.MainThreadTimeline),D.registerArgumentProcessor({processArgument:(f,u)=>{if(f&&f.$mid===12)if(this.b.get(f.source)&&y.ExtensionIdentifier.equals(u,this.b.get(f.source)?.extension)){const h=f.uri===void 0?void 0:a.URI.revive(f.uri);return this.c.get(f.source)?.get(P(h))?.get(f.handle)}else return;return f}})}async $getTimeline(k,D,f,u){return this.b.get(k)?.provider.provideTimeline(a.URI.revive(D),f,u)}registerTimelineProvider(k,D,f,u){const h=new R.DisposableStore,p=this.d(D.id,u,h).bind(this);let b;D.onDidChange&&(b=D.onDidChange(g=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...g,id:D.id}),this));const C=this.c;return this.f({...D,scheme:k,onDidChange:void 0,async provideTimeline(g,i,s){i?.resetCache&&(h.clear(),C.get(D.id)?.clear());const r=await D.provideTimeline(g,i,s);if(r==null)return;const o=p(g,i);return{...r,source:D.id,items:r.items.map(o)}},dispose(){for(const g of C.values())g.get(D.id)?.clear();b?.dispose(),h.dispose()}},f)}d(k,D,f){return(u,h)=>{let p;if(h?.cacheResults){let b=this.c.get(k);b===void 0&&(b=new Map,this.c.set(k,b));const C=P(u);p=b.get(C),p===void 0&&(p=new Map,b.set(C,p))}return b=>{const{iconPath:C,...g}=b,i=`${k}|${b.id??b.timestamp}`;p?.set(i,b);let s,r,o;b.iconPath&&(C instanceof S.ThemeIcon?o={id:C.id,color:C.color}:a.URI.isUri(C)?(s=C,r=C):{light:s,dark:r}=C);let c;return S.MarkdownString.isMarkdownString(g.tooltip)?c=A.MarkdownString.from(g.tooltip):(0,I.isString)(g.tooltip)?c=g.tooltip:S.MarkdownString.isMarkdownString(g.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),c=A.MarkdownString.from(g.detail)):(0,I.isString)(g.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),c=g.detail),{...g,id:g.id??void 0,handle:i,source:k,command:b.command?D.toInternal(b.command,f):void 0,icon:s,iconDark:r,themeIcon:o,tooltip:c,accessibilityInformation:b.accessibilityInformation}}}}f(k,D){if(this.b.get(k.id))throw new Error(`Timeline Provider ${k.id} already exists.`);return this.a.$registerTimelineProvider({id:k.id,label:k.label,scheme:k.scheme}),this.b.set(k.id,{provider:k,extension:D}),(0,R.toDisposable)(()=>{for(const u of this.c.values())u.get(k.id)?.clear();this.b.delete(k.id),this.a.$unregisterTimelineProvider(k.id),k.dispose()})}}e.ExtHostTimeline=O;function P(v){return v?.toString()}}),define(ye[277],De([1,0,6,16,2,5]),function(re,e,a,L,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class S{constructor(y){this.c=new Map,this.b=y.getProxy(R.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(y,I,O,P){if(this.c.has(I))throw new Error(`Opener with id '${I}' already registered`);const v=P.schemes.find(k=>!S.a.has(k));if(v)throw new Error(`Scheme '${v}' is not supported. Only http and https are currently supported.`);return this.c.set(I,O),this.b.$registerUriOpener(I,P.schemes,y,P.label),(0,a.toDisposable)(()=>{this.c.delete(I),this.b.$unregisterUriOpener(I)})}async $canOpenUri(y,I,O){const P=this.c.get(y);if(!P)throw new Error(`Unknown opener with id: ${y}`);const v=l.URI.revive(I);return P.canOpenExternalUri(v,O)}async $openUri(y,I,O){const P=this.c.get(y);if(!P)throw new Error(`Unknown opener id: '${y}'`);return P.openExternalUri(l.URI.revive(I.resolvedUri),{sourceUri:l.URI.revive(I.sourceUri)},O)}}S.a=new Set([L.Schemas.http,L.Schemas.https]),e.ExtHostUriOpeners=S}),define(ye[278],De([1,0,5,2,6,11,27]),function(re,e,a,L,l,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class A{constructor(I){this.c=new Set,this.d=new Map,this.b=I.getProxy(a.MainContext.MainThreadUrls)}registerUriHandler(I,O){if(this.c.has(S.ExtensionIdentifier.toKey(I)))throw new Error(`Protocol handler already registered for extension ${I}`);const P=A.a++;return this.c.add(S.ExtensionIdentifier.toKey(I)),this.d.set(P,O),this.b.$registerUriHandler(P,I),(0,l.toDisposable)(()=>{this.c.delete(S.ExtensionIdentifier.toKey(I)),this.d.delete(P),this.b.$unregisterUriHandler(P)})}$handleExternalUri(I,O){const P=this.d.get(I);if(!P)return Promise.resolve(void 0);try{P.handleUri(L.URI.revive(O))}catch(v){(0,R.onUnexpectedError)(v)}return Promise.resolve(void 0)}async createAppUri(I){return L.URI.revive(await this.b.$createAppUri(I))}}A.a=0,e.ExtHostUrls=A});var _e=this&&this.__classPrivateFieldSet||function(re,e,a,L,l){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!l:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?l.call(re,a):l?l.value=a:e.set(re,a),a},Ue=this&&this.__classPrivateFieldGet||function(re,e,a,L){if(a==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!L:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?L:a==="a"?L.call(re):L?L.value:e.get(re)};define(ye[81],De([1,0,3,16,23,2,198,223,95,5]),function(re,e,a,L,l,R,S,A,y,I){"use strict";var O,P,v,k,D,f,u,h,p,b,C,g,i;Object.defineProperty(e,"__esModule",{value:!0}),e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class s{constructor(w,N,j,V,Q,x,U){O.set(this,void 0),P.set(this,void 0),v.set(this,void 0),k.set(this,void 0),D.set(this,void 0),f.set(this,void 0),u.set(this,""),h.set(this,void 0),p.set(this,!1),b.set(this,!1),C.set(this,void 0),g.set(this,void 0),this._onMessageEmitter=new a.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,i.set(this,new a.Emitter),this._onDidDispose=Ue(this,i,"f").event,_e(this,O,w,"f"),_e(this,P,N,"f"),_e(this,h,j,"f"),_e(this,k,V,"f"),_e(this,D,Q,"f"),_e(this,f,x,"f"),_e(this,C,r(x),"f"),_e(this,g,o(x),"f"),_e(this,v,U,"f")}dispose(){_e(this,p,!0,"f"),Ue(this,i,"f").fire(),Ue(this,i,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(w){return _e(this,b,!0,"f"),(0,y.asWebviewUri)(w,Ue(this,k,"f"))}get cspSource(){const w=Ue(this,f,"f").extensionLocation;if(w.scheme===L.Schemas.https||w.scheme===L.Schemas.http){let N=w.toString();return N.endsWith("/")||(N+="/"),N+" "+y.webviewGenericCspSource}return y.webviewGenericCspSource}get html(){return this.a(),Ue(this,u,"f")}set html(w){this.a(),Ue(this,u,"f")!==w&&(_e(this,u,w,"f"),Ue(this,g,"f")&&!Ue(this,b,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(w)&&(_e(this,b,!0,"f"),Ue(this,v,"f").report("Webview vscode-resource: uris",Ue(this,f,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Ue(this,P,"f").$setHtml(Ue(this,O,"f"),this.b(w)))}get options(){return this.a(),Ue(this,h,"f")}set options(w){this.a(),l.equals(Ue(this,h,"f"),w)||Ue(this,P,"f").$setOptions(Ue(this,O,"f"),n(Ue(this,f,"f"),Ue(this,D,"f"),w)),_e(this,h,w,"f")}async postMessage(w){if(Ue(this,p,"f"))return!1;const N=(0,A.serializeWebviewMessage)(w,{serializeBuffersForPostMessage:Ue(this,C,"f")});return Ue(this,P,"f").$postMessage(Ue(this,O,"f"),N.message,...N.buffers)}a(){if(Ue(this,p,"f"))throw new Error("Webview is disposed")}b(w){if(!Ue(this,g,"f"))return w;const N=Ue(this,f,"f").extensionLocation?.scheme===L.Schemas.vscodeRemote,j=Ue(this,f,"f").extensionLocation.scheme===L.Schemas.vscodeRemote?Ue(this,f,"f").extensionLocation.authority:void 0;return w.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(V,Q,x,U,T,F)=>{const B=R.URI.from({scheme:U||"file",path:decodeURIComponent(T)}),Z=(0,y.asWebviewUri)(B,{isRemote:N,authority:j}).toString();return`${Q}${Z}${F}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(V,Q,x,U,T,F)=>{const B=R.URI.from({scheme:U||"file",path:decodeURIComponent(T)}),Z=(0,y.asWebviewUri)(B,{isRemote:N,authority:j}).toString();return`${Q}${Z}${F}`})}}e.ExtHostWebview=s,O=new WeakMap,P=new WeakMap,v=new WeakMap,k=new WeakMap,D=new WeakMap,f=new WeakMap,u=new WeakMap,h=new WeakMap,p=new WeakMap,b=new WeakMap,C=new WeakMap,g=new WeakMap,i=new WeakMap;function r(E){try{const w=(0,S.normalizeVersion)((0,S.parseVersion)(E.engines.vscode));return!!w&&w.majorBase>=1&&w.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=r;function o(E){try{const w=(0,S.normalizeVersion)((0,S.parseVersion)(E.engines.vscode));return w?w.majorBase<1||w.majorBase===1&&w.minorBase<60:!1}catch{return!1}}class c{constructor(w,N,j,V,Q){this.c=N,this.d=j,this.e=V,this.f=Q,this.b=new Map,this.a=w.getProxy(I.MainContext.MainThreadWebviews)}$onMessage(w,N,j){const V=this.g(w);if(V){const{message:Q}=(0,A.deserializeWebviewMessage)(N,j.value);V._onMessageEmitter.fire(Q)}}$onMissingCsp(w,N){this.e.warn(`${N} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(w,N,j){const V=new s(w,this.a,t(N),this.c,this.d,j,this.f);return this.b.set(w,V),V._onDidDispose(()=>{this.b.delete(w)}),V}deleteWebview(w){this.b.delete(w)}g(w){return this.b.get(w)}}e.ExtHostWebviews=c;function m(E){return{id:E.identifier,location:E.extensionLocation}}e.toExtensionData=m;function n(E,w,N){return{enableCommandUris:N.enableCommandUris,enableScripts:N.enableScripts,enableForms:N.enableForms,portMapping:N.portMapping,localResourceRoots:N.localResourceRoots||d(E,w)}}e.serializeWebviewOptions=n;function t(E){return{enableCommandUris:E.enableCommandUris,enableScripts:E.enableScripts,enableForms:E.enableForms,portMapping:E.portMapping,localResourceRoots:E.localResourceRoots?.map(w=>R.URI.from(w))}}function d(E,w){return[...(w?.getWorkspaceFolders()||[]).map(N=>N.uri),E.extensionLocation]}}),define(ye[279],De([1,0,21,89,6,16,24,2,14,81,75,5,7]),function(re,e,a,L,l,R,S,A,y,I,O,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class k{constructor(s,r){this.document=s,this.b=r,this.a=1,this.c=new O.Cache("custom documents")}addEdit(s){return this.c.add([s])}async undo(s,r){await this.f(s).undo(),r||this.disposeBackup()}async redo(s,r){await this.f(s).redo(),r||this.disposeBackup()}disposeEdits(s){for(const r of s)this.c.delete(r)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const s=g(this.document.uri)+this.a++;return(0,S.joinPath)(this.b,s)}updateBackup(s){this.d?.delete(),this.d=s}disposeBackup(){this.d?.delete(),this.d=void 0}f(s){const r=this.c.get(s,0);if(!r)throw new Error("No edit found");return r}}class D{constructor(){this.a=new Map}get(s,r){return this.a.get(this.b(s,r))}add(s,r,o){const c=this.b(s,r.uri);if(this.a.has(c))throw new Error(`Document already exists for viewType:${s} resource:${r.uri}`);const m=new k(r,o);return this.a.set(c,m),m}delete(s,r){const o=this.b(s,r.uri);this.a.delete(o)}b(s,r){return`${s}@@@${r}`}}var f;(function(i){i[i.Text=0]="Text",i[i.Custom=1]="Custom"})(f||(f={}));class u{constructor(){this.a=new Map}addTextProvider(s,r,o){return this.b(0,s,r,o)}addCustomProvider(s,r,o){return this.b(1,s,r,o)}get(s){return this.a.get(s)}b(s,r,o,c){if(this.a.has(r))throw new Error(`Provider for viewType:${r} already registered`);return this.a.set(r,{type:s,extension:o,provider:c}),new v.Disposable(()=>this.a.delete(r))}}class h{constructor(s,r,o,c,m){this.d=r,this.f=o,this.g=c,this.h=m,this.b=new u,this.c=new D,this.a=s.getProxy(P.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(s,r,o,c){const m=new l.DisposableStore;return b(o)?(m.add(this.b.addTextProvider(r,s,o)),this.a.$registerTextEditorProvider((0,I.toExtensionData)(s),r,c.webviewOptions||{},{supportsMove:!!o.moveCustomTextEditor},(0,I.shouldSerializeBuffersForPostMessage)(s))):(m.add(this.b.addCustomProvider(r,s,o)),p(o)&&m.add(o.onDidChangeCustomDocument(n=>{const t=this.i(r,n.document.uri);if(C(n)){const d=t.addEdit(n);this.a.$onDidEdit(n.document.uri,r,d,n.label)}else this.a.$onContentChange(n.document.uri,r)})),this.a.$registerCustomEditorProvider((0,I.toExtensionData)(s),r,c.webviewOptions||{},!!c.supportsMultipleEditorsPerDocument,(0,I.shouldSerializeBuffersForPostMessage)(s))),v.Disposable.from(m,new v.Disposable(()=>{this.a.$unregisterEditorProvider(r)}))}async $createCustomDocument(s,r,o,c,m){const n=this.b.get(r);if(!n)throw new Error(`No provider found for '${r}'`);if(n.type!==1)throw new Error(`Invalid provide type for '${r}'`);const t=A.URI.revive(s),d=await n.provider.openCustomDocument(t,{backupId:o,untitledDocumentData:c?.buffer},m);let E;return p(n.provider)&&this.f&&(E=this.f.workspaceValue(n.extension)??this.f.globalValue(n.extension)),this.c.add(r,d,E),{editable:p(n.provider)}}async $disposeCustomDocument(s,r){const o=this.b.get(r);if(!o)throw new Error(`No provider found for '${r}'`);if(o.type!==1)throw new Error(`Invalid provider type for '${r}'`);const c=A.URI.revive(s),{document:m}=this.i(r,c);this.c.delete(r,m),m.dispose()}async $resolveCustomEditor(s,r,o,c,m,n){const t=this.b.get(o);if(!t)throw new Error(`No provider found for '${o}'`);const d=y.ViewColumn.to(m),E=this.g.createNewWebview(r,c.contentOptions,t.extension),w=this.h.createNewWebviewPanel(r,o,c.title,d,c.options,E,!0),N=A.URI.revive(s);switch(t.type){case 1:{const{document:j}=this.i(o,N);return t.provider.resolveCustomEditor(j,w,n)}case 0:{const j=this.d.getDocument(N);return t.provider.resolveCustomTextEditor(j,w,n)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(s,r,o){this.i(r,s).disposeEdits(o)}async $onMoveCustomEditor(s,r,o){const c=this.b.get(o);if(!c)throw new Error(`No provider found for '${o}'`);if(!c.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${o}'`);const m=this.h.getWebviewPanel(s);if(!m)throw new Error("No webview found");const n=A.URI.revive(r),t=this.d.getDocument(n);await c.provider.moveCustomTextEditor(t,m,a.CancellationToken.None)}async $undo(s,r,o,c){return this.i(r,s).undo(o,c)}async $redo(s,r,o,c){return this.i(r,s).redo(o,c)}async $revert(s,r,o){const c=this.i(r,s);await this.j(r).revertCustomDocument(c.document,o),c.disposeBackup()}async $onSave(s,r,o){const c=this.i(r,s);await this.j(r).saveCustomDocument(c.document,o),c.disposeBackup()}async $onSaveAs(s,r,o,c){const m=this.i(r,s);return this.j(r).saveCustomDocumentAs(m.document,A.URI.revive(o),c)}async $backup(s,r,o){const c=this.i(r,s),n=await this.j(r).backupCustomDocument(c.document,{destination:c.getNewBackupUri()},o);return c.updateBackup(n),n.id}i(s,r){const o=this.c.get(s,A.URI.revive(r));if(!o)throw new Error("No custom document found");return o}j(s){const o=this.b.get(s)?.provider;if(!o||!p(o))throw new Error("Custom document is not editable");return o}}e.ExtHostCustomEditors=h;function p(i){return!!i.onDidChangeCustomDocument}function b(i){return typeof i.resolveCustomTextEditor=="function"}function C(i){return typeof i.undo=="function"&&typeof i.redo=="function"}function g(i){const s=i.scheme===R.Schemas.file||i.scheme===R.Schemas.untitled?i.fsPath:i.toString();return(0,L.hash)(s)+""}});var _e=this&&this.__classPrivateFieldSet||function(re,e,a,L,l){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!l:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?l.call(re,a):l?l.value=a:e.set(re,a),a},Ue=this&&this.__classPrivateFieldGet||function(re,e,a,L){if(a==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!L:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?L:a==="a"?L.call(re):L?L.value:e.get(re)};define(ye[280],De([1,0,3,6,2,30,14,81,5,7]),function(re,e,a,L,l,R,S,A,y,I){"use strict";var O,P,v,k,D,f,u,h,p,b,C,g,i;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class s extends L.Disposable{constructor(m,n,t,d){super(),O.set(this,void 0),P.set(this,void 0),v.set(this,void 0),k.set(this,void 0),D.set(this,void 0),f.set(this,void 0),u.set(this,void 0),h.set(this,void 0),p.set(this,!0),b.set(this,void 0),C.set(this,!1),g.set(this,this.B(new a.Emitter)),this.onDidDispose=Ue(this,g,"f").event,i.set(this,this.B(new a.Emitter)),this.onDidChangeViewState=Ue(this,i,"f").event,_e(this,O,m,"f"),_e(this,P,n,"f"),_e(this,k,t,"f"),_e(this,v,d.viewType,"f"),_e(this,D,d.panelOptions,"f"),_e(this,h,d.viewColumn,"f"),_e(this,f,d.title,"f"),_e(this,b,d.active,"f")}dispose(){Ue(this,C,"f")||(_e(this,C,!0,"f"),Ue(this,g,"f").fire(),Ue(this,P,"f").$disposeWebview(Ue(this,O,"f")),Ue(this,k,"f").dispose(),super.dispose())}get webview(){return this.c(),Ue(this,k,"f")}get viewType(){return this.c(),Ue(this,v,"f")}get title(){return this.c(),Ue(this,f,"f")}set title(m){this.c(),Ue(this,f,"f")!==m&&(_e(this,f,m,"f"),Ue(this,P,"f").$setTitle(Ue(this,O,"f"),m))}get iconPath(){return this.c(),Ue(this,u,"f")}set iconPath(m){this.c(),Ue(this,u,"f")!==m&&(_e(this,u,m,"f"),Ue(this,P,"f").$setIconPath(Ue(this,O,"f"),l.URI.isUri(m)?{light:m,dark:m}:m))}get options(){return Ue(this,D,"f")}get viewColumn(){if(this.c(),!(typeof Ue(this,h,"f")=="number"&&Ue(this,h,"f")<0))return Ue(this,h,"f")}get active(){return this.c(),Ue(this,b,"f")}get visible(){return this.c(),Ue(this,p,"f")}_updateViewState(m){Ue(this,C,"f")||(this.active!==m.active||this.visible!==m.visible||this.viewColumn!==m.viewColumn)&&(_e(this,b,m.active,"f"),_e(this,p,m.visible,"f"),_e(this,h,m.viewColumn,"f"),Ue(this,i,"f").fire({webviewPanel:this}))}reveal(m,n){this.c(),Ue(this,P,"f").$reveal(Ue(this,O,"f"),{viewColumn:typeof m>"u"?void 0:S.ViewColumn.from(m),preserveFocus:!!n})}c(){if(Ue(this,C,"f"))throw new Error("Webview is disposed")}}O=new WeakMap,P=new WeakMap,v=new WeakMap,k=new WeakMap,D=new WeakMap,f=new WeakMap,u=new WeakMap,h=new WeakMap,p=new WeakMap,b=new WeakMap,C=new WeakMap,g=new WeakMap,i=new WeakMap;class r{static c(){return(0,R.generateUuid)()}constructor(m,n,t){this.g=n,this.h=t,this.e=new Map,this.f=new Map,this.d=m.getProxy(y.MainContext.MainThreadWebviewPanels)}createWebviewPanel(m,n,t,d,E={}){const w=typeof d=="object"?d.viewColumn:d,N={viewColumn:S.ViewColumn.from(w),preserveFocus:typeof d=="object"&&!!d.preserveFocus},j=(0,A.shouldSerializeBuffersForPostMessage)(m),V=r.c();this.d.$createWebviewPanel((0,A.toExtensionData)(m),V,n,{title:t,panelOptions:o(E),webviewOptions:(0,A.serializeWebviewOptions)(m,this.h,E),serializeBuffersForPostMessage:j},N);const Q=this.g.createNewWebview(V,E,m);return this.createNewWebviewPanel(V,n,t,w,E,Q,!0)}$onDidChangeWebviewPanelViewStates(m){const n=Object.keys(m);n.sort((t,d)=>{const E=m[t],w=m[d];return E.active?1:w.active?-1:+E.visible-+w.visible});for(const t of n){const d=this.getWebviewPanel(t);if(!d)continue;const E=m[t];d._updateViewState({active:E.active,visible:E.visible,viewColumn:S.ViewColumn.to(E.position)})}}async $onDidDisposeWebviewPanel(m){this.getWebviewPanel(m)?.dispose(),this.e.delete(m),this.g.deleteWebview(m)}registerWebviewPanelSerializer(m,n,t){if(this.f.has(n))throw new Error(`Serializer for '${n}' already registered`);return this.f.set(n,{serializer:t,extension:m}),this.d.$registerSerializer(n,{serializeBuffersForPostMessage:(0,A.shouldSerializeBuffersForPostMessage)(m)}),new I.Disposable(()=>{this.f.delete(n),this.d.$unregisterSerializer(n)})}async $deserializeWebviewPanel(m,n,t,d){const E=this.f.get(n);if(!E)throw new Error(`No serializer found for '${n}'`);const{serializer:w,extension:N}=E,j=this.g.createNewWebview(m,t.webviewOptions,N),V=this.createNewWebviewPanel(m,n,t.title,d,t.panelOptions,j,t.active);await w.deserializeWebviewPanel(V,t.state)}createNewWebviewPanel(m,n,t,d,E,w,N){const j=new s(m,this.d,w,{viewType:n,title:t,viewColumn:d,panelOptions:E,active:N});return this.e.set(m,j),j}getWebviewPanel(m){return this.e.get(m)}}e.ExtHostWebviewPanels=r;function o(c){return{enableFindWidget:c.enableFindWidget,retainContextWhenHidden:c.retainContextWhenHidden}}});var _e=this&&this.__classPrivateFieldSet||function(re,e,a,L,l){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!l:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?l.call(re,a):l?l.value=a:e.set(re,a),a},Ue=this&&this.__classPrivateFieldGet||function(re,e,a,L){if(a==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!L:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?L:a==="a"?L.call(re):L?L.value:e.get(re)};define(ye[281],De([1,0,3,6,81,14,5,7]),function(re,e,a,L,l,R,S,A){"use strict";var y,I,O,P,v,k,D,f,u,h,p;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class b extends L.Disposable{constructor(i,s,r,o,c,m){super(),y.set(this,void 0),I.set(this,void 0),O.set(this,void 0),P.set(this,void 0),v.set(this,!1),k.set(this,void 0),D.set(this,void 0),f.set(this,void 0),u.set(this,void 0),h.set(this,this.B(new a.Emitter)),this.onDidChangeVisibility=Ue(this,h,"f").event,p.set(this,this.B(new a.Emitter)),this.onDidDispose=Ue(this,p,"f").event,_e(this,O,r,"f"),_e(this,D,o,"f"),_e(this,y,i,"f"),_e(this,I,s,"f"),_e(this,P,c,"f"),_e(this,k,m,"f")}dispose(){Ue(this,v,"f")||(_e(this,v,!0,"f"),Ue(this,p,"f").fire(),Ue(this,P,"f").dispose(),super.dispose())}get title(){return this.a(),Ue(this,D,"f")}set title(i){this.a(),Ue(this,D,"f")!==i&&(_e(this,D,i,"f"),Ue(this,I,"f").$setWebviewViewTitle(Ue(this,y,"f"),i))}get description(){return this.a(),Ue(this,f,"f")}set description(i){this.a(),Ue(this,f,"f")!==i&&(_e(this,f,i,"f"),Ue(this,I,"f").$setWebviewViewDescription(Ue(this,y,"f"),i))}get visible(){return Ue(this,k,"f")}get webview(){return Ue(this,P,"f")}get viewType(){return Ue(this,O,"f")}_setVisible(i){i===Ue(this,k,"f")||Ue(this,v,"f")||(_e(this,k,i,"f"),Ue(this,h,"f").fire())}get badge(){return this.a(),Ue(this,u,"f")}set badge(i){this.a(),!(i?.value===Ue(this,u,"f")?.value&&i?.tooltip===Ue(this,u,"f")?.tooltip)&&(_e(this,u,R.ViewBadge.from(i),"f"),Ue(this,I,"f").$setWebviewViewBadge(Ue(this,y,"f"),i))}show(i){this.a(),Ue(this,I,"f").$show(Ue(this,y,"f"),!!i)}a(){if(Ue(this,v,"f"))throw new Error("Webview is disposed")}}y=new WeakMap,I=new WeakMap,O=new WeakMap,P=new WeakMap,v=new WeakMap,k=new WeakMap,D=new WeakMap,f=new WeakMap,u=new WeakMap,h=new WeakMap,p=new WeakMap;class C{constructor(i,s){this.d=s,this.b=new Map,this.c=new Map,this.a=i.getProxy(S.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(i,s,r,o){if(this.b.has(s))throw new Error(`View provider for '${s}' already registered`);return this.b.set(s,{provider:r,extension:i}),this.a.$registerWebviewViewProvider((0,l.toExtensionData)(i),s,{retainContextWhenHidden:o?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,l.shouldSerializeBuffersForPostMessage)(i)}),new A.Disposable(()=>{this.b.delete(s),this.a.$unregisterWebviewViewProvider(s)})}async $resolveWebviewView(i,s,r,o,c){const m=this.b.get(s);if(!m)throw new Error(`No view provider found for '${s}'`);const{provider:n,extension:t}=m,d=this.d.createNewWebview(i,{},t),E=new b(i,this.a,s,r,d,!0);this.c.set(i,E),await n.resolveWebviewView(E,{state:o},c)}async $onDidChangeWebviewViewVisibility(i,s){this.e(i)._setVisible(s)}async $disposeWebviewView(i){const s=this.e(i);this.c.delete(i),s.dispose(),this.d.deleteWebview(i)}e(i){const s=this.c.get(i);if(!s)throw new Error("No webview found");return s}}e.ExtHostWebviewViews=C}),define(ye[141],De([1,0,3,5,2,16,8,4,18]),function(re,e,a,L,l,R,S,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let I=class an{get state(){return this.d}constructor(P){this.c=new a.Emitter,this.onDidChangeWindowState=this.c.event,this.d=an.a,this.b=P.getProxy(L.MainContext.MainThreadWindow),this.b.$getWindowVisibility().then(v=>this.$onDidChangeWindowFocus(v))}$onDidChangeWindowFocus(P){P!==this.d.focused&&(this.d={...this.d,focused:P},this.c.fire(this.d))}openUri(P,v){let k;if(typeof P=="string"){k=P;try{P=l.URI.parse(P)}catch{return Promise.reject(`Invalid uri - '${P}'`)}}return(0,S.isFalsyOrWhitespace)(P.scheme)?Promise.reject("Invalid scheme - cannot be empty"):P.scheme===R.Schemas.command?Promise.reject(`Invalid scheme '${P.scheme}'`):this.b.$openUri(P,k,v)}async asExternalUri(P,v){if((0,S.isFalsyOrWhitespace)(P.scheme))return Promise.reject("Invalid scheme - cannot be empty");const k=await this.b.$asExternalUri(P,v);return l.URI.from(k)}};I.a={focused:!0},I=qe([ze(0,y.IExtHostRpcService)],I),e.ExtHostWindow=I,e.IExtHostWindow=(0,A.createDecorator)("IExtHostWindow")}),define(ye[282],De([1,0,116,283,52,40,2,13,47]),function(re,e,a,L,l,R,S,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class I{constructor(v,k,D){this.b=v,this.c=k,this.f=D,this.a=L.createServer((f,u)=>this.h(f,u)),this.g().catch(f=>(k.error(f),""))}get ipcHandlePath(){return this.f}async g(){try{this.a.listen(this.ipcHandlePath),this.a.on("error",v=>this.c.error(v))}catch{this.c.error("Could not start open from terminal server.")}return this.f}h(v,k){const D=(u,h)=>{k.writeHead(u,{"content-type":"application/json"}),k.end(JSON.stringify(h||null),p=>p&&this.c.error(p))},f=[];v.setEncoding("utf8"),v.on("data",u=>f.push(u)),v.on("end",async()=>{try{const u=JSON.parse(f.join(""));let h;switch(u.type){case"open":h=await this.i(u);break;case"openExternal":h=await this.j(u);break;case"status":h=await this.l(u);break;case"extensionManagement":h=await this.k(u);break;default:D(404,`Unknown message type: ${u.type}`);break}D(200,h)}catch(u){const h=u instanceof Error?u.message:JSON.stringify(u);D(500,h),this.c.error("Error while processing pipe request",u)}})}async i(v){const{fileURIs:k,folderURIs:D,forceNewWindow:f,diffMode:u,mergeMode:h,addMode:p,forceReuseWindow:b,gotoLineMode:C,waitMarkerFilePath:g,remoteAuthority:i}=v,s=[];if(Array.isArray(D))for(const m of D)try{s.push({folderUri:S.URI.parse(m)})}catch{}if(Array.isArray(k))for(const m of k)try{(0,y.hasWorkspaceFileExtension)(m)?s.push({workspaceUri:S.URI.parse(m)}):s.push({fileUri:S.URI.parse(m)})}catch{}const r=g?S.URI.file(g):void 0,c={forceNewWindow:f,diffMode:u,mergeMode:h,addMode:p,gotoLineMode:C,forceReuseWindow:b,preferNewWindow:!b&&!r&&!p,waitMarkerFileURI:r,remoteAuthority:i};return this.b.executeCommand("_remoteCLI.windowOpen",s,c),""}async j(v){for(const k of v.uris){const D=S.URI.parse(k),f=D.scheme==="file"?D:k;await this.b.executeCommand("_remoteCLI.openExternal",f)}}async k(v){const k=f=>f?.map(u=>/\.vsix$/i.test(u)?S.URI.parse(u):u),D={list:v.list,install:k(v.install),uninstall:k(v.uninstall),force:v.force};return await this.b.executeCommand("_remoteCLI.manageExtensions",D)}async l(v){return await this.b.executeCommand("_remoteCLI.getSystemStatus")}dispose(){this.a.close(),this.f&&process.platform!=="win32"&&l.existsSync(this.f)&&l.unlinkSync(this.f)}}e.CLIServerBase=I;let O=class extends I{constructor(v,k){super(v,k,(0,a.createRandomIPCHandle)())}};O=qe([ze(0,R.IExtHostCommands),ze(1,A.ILogService)],O),e.CLIServer=O}),define(ye[284],De([1,0,254,25,18]),function(re,e,a,L,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;const R=1024*1024;let S=class extends a.AbstractExtHostConsoleForwarder{constructor(y,I){super(y,I),this.g=!1,this.j("stderr","error"),this.j("stdout","log")}f(y,I,O){const P=y==="error"||y==="warn"?process.stderr:process.stdout;this.g=!0,P.write(`
START_NATIVE_LOG
`),I.apply(console,O),P.write(`
END_NATIVE_LOG
`),this.g=!1}j(y,I){const O=process[y],P=O.write;let v="";Object.defineProperty(O,"write",{set:()=>{},get:()=>(k,D,f)=>{if(!this.g){v+=k.toString(D);const u=v.length>R?v.length:v.lastIndexOf(`
`);u!==-1&&(console[I](v.slice(0,u)),v=v.slice(u+1))}P.call(O,k,D,f)}})}};S=qe([ze(0,l.IExtHostRpcService),ze(1,L.IExtHostInitDataService)],S),e.ExtHostConsoleForwarder=S}),define(ye[285],De([1,0,9,71,30,40,6,5,2,18]),function(re,e,a,L,l,R,S,A,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDownloadService=void 0;let O=class extends S.Disposable{constructor(v,k){super();const D=v.getProxy(A.MainContext.MainThreadDownloadService);k.registerCommand(!1,"_workbench.downloadResource",async f=>{const u=y.URI.file((0,a.join)((0,L.tmpdir)(),(0,l.generateUuid)()));return await D.$download(f,u),u})}};O=qe([ze(0,I.IExtHostRpcService),ze(1,R.IExtHostCommands)],O),e.ExtHostDownloadService=O}),define(ye[286],De([1,0,140,16,205,30]),function(re,e,a,L,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;class S extends a.ExtHostLoggerService{k(y,I,O){return y.scheme===L.Schemas.file?new l.SpdLogLogger(O?.name||(0,R.generateUuid)(),y.fsPath,!O?.donotRotate,!!O?.donotUseFormatters,I):super.k(y,I,O)}registerLogger(y){super.registerLogger(y),this.l.$registerLogger(y)}deregisterLogger(y){super.deregisterLogger(y),this.l.$deregisterLogger(y)}}e.ExtHostLoggerService=S}),define(ye[287],De([1,0,52,9,2,80,6,16,17,29]),function(re,e,a,L,l,R,S,A,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=void 0;class O extends R.ExtensionStoragePaths{constructor(){super(...arguments),this.i=null}async g(i){const s=await super.g(i);if(s.scheme!==A.Schemas.file)return s;if(this.b.skipWorkspaceStorageLock)return this.d.info(`Skipping acquiring lock for ${s.fsPath}.`),s;const r=s.fsPath;let o=0;do{let c;o===0?c=r:c=/[/\\]$/.test(r)?`${r.substr(0,r.length-1)}-${o}`:`${r}-${o}`,await P(c);const m=L.join(c,"vscode.lock"),n=await f(this.d,m,!1);if(n)return this.i=n,process.on("exit",()=>{n.dispose()}),l.URI.file(c);o++}while(o<10);return s}onWillDeactivateAll(){this.i?.setWillRelease(6e3)}}e.ExtensionStoragePaths=O;async function P(g){try{await I.Promises.stat(g);return}catch{}try{await I.Promises.mkdir(g,{recursive:!0})}catch{}}const v=1e3,k=10*60*1e3;class D extends S.Disposable{constructor(i,s){super(),this.b=i,this.c=s,this.a=this.B(new y.IntervalTimer),this.a.cancelAndSet(async()=>{const r=await u(i,s);(!r||r.pid!==process.pid)&&(i.info(`Lock '${s}': The lock was lost unexpectedly.`),this.a.cancel());try{await I.Promises.utimes(s,new Date,new Date)}catch(o){i.error(o),i.info(`Lock '${s}': Could not update mtime.`)}},v)}dispose(){super.dispose();try{a.unlinkSync(this.c)}catch{}}async setWillRelease(i){this.b.info(`Lock '${this.c}': Marking the lockfile as scheduled to be released in ${i} ms.`);try{const s={pid:process.pid,willReleaseAt:Date.now()+i};await I.Promises.writeFile(this.c,JSON.stringify(s),{flag:"w"})}catch(s){this.b.error(s)}}}async function f(g,i,s){try{const o={pid:process.pid,willReleaseAt:0};await I.Promises.writeFile(i,JSON.stringify(o),{flag:"wx"})}catch(o){g.error(o)}const r=await u(g,i);return!r||r.pid!==process.pid?s?(g.info(`Lock '${i}': Could not acquire lock, giving up.`),null):(g.info(`Lock '${i}': Could not acquire lock, checking if the file is stale.`),b(g,i)):(g.info(`Lock '${i}': Lock acquired.`),new D(g,i))}async function u(g,i){let s;try{s=await I.Promises.readFile(i)}catch(r){return g.error(r),null}try{return JSON.parse(String(s))}catch(r){return g.error(r),null}}async function h(g,i){let s;try{s=await I.Promises.stat(i)}catch(r){return g.error(r),0}return s.mtime.getTime()}function p(g){try{return process.kill(g,0),!0}catch{return!1}}async function b(g,i){const s=await u(g,i);if(!s)return g.info(`Lock '${i}': Could not read pid of lock holder.`),C(g,i);if(s.willReleaseAt){let n=s.willReleaseAt-Date.now();if(n<5e3){for(n>0?g.info(`Lock '${i}': The lockfile is scheduled to be released in ${n} ms.`):g.info(`Lock '${i}': The lockfile is scheduled to have been released.`);n>0;){if(await(0,y.timeout)(Math.min(100,n)),await h(g,i)===0)return C(g,i);n=s.willReleaseAt-Date.now()}return C(g,i)}}if(!p(s.pid))return g.info(`Lock '${i}': The pid ${s.pid} appears to be gone.`),C(g,i);const r=await h(g,i),o=Date.now()-r;if(o<=k)return g.info(`Lock '${i}': The lock does not look stale, elapsed: ${o} ms, giving up.`),null;g.info(`Lock '${i}': The lock looks stale, waiting for 2s.`),await(0,y.timeout)(2e3);const c=await h(g,i),m=Date.now()-c;return m<=k?(g.info(`Lock '${i}': The lock does not look stale, elapsed: ${m} ms, giving up.`),null):(g.info(`Lock '${i}': The lock looks stale even after waiting for 2s.`),C(g,i))}async function C(g,i){g.info(`Lock '${i}': Deleting a stale lock.`);try{await I.Promises.unlink(i)}catch{}return f(g,i,!0)}}),define(ye[288],De([1,0,30,18,41]),function(re,e,a,L,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTerminalService=void 0;let R=class extends l.BaseExtHostTerminalService{constructor(A){super(!0,A)}createTerminal(A,y,I){return this.createTerminalFromOptions({name:A,shellPath:y,shellArgs:I})}createTerminalFromOptions(A,y){const I=new l.ExtHostTerminal(this.a,(0,a.generateUuid)(),A,A.name);return this.f.push(I),I.create(A,this.L(A,y)),I.value}};R=qe([ze(0,L.IExtHostRpcService)],R),e.ExtHostTerminalService=R}),define(ye[289],De([1,0,5,18,185,6,25,2,46,24,29,7,12,56,3,129,102,13]),function(re,e,a,L,l,R,S,A,y,I,O,P,v,k,D,f,u,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.tryFindRootPorts=e.findPorts=e.getRootProcesses=e.loadConnectionTable=e.loadListeningPorts=e.getSockets=void 0;class p extends f.DisposableTunnel{}function b(n){const t=n.trim().split(`
`),d=[];return t.forEach(w=>{const N=/\/proc\/(\d+)\/fd\/\d+ -> socket:\[(\d+)\]/.exec(w);N&&N.length>=3&&d.push({pid:parseInt(N[1],10),socket:parseInt(N[2],10)})}),d.reduce((w,N)=>(w[N.socket]=N,w),{})}e.getSockets=b;function C(...n){const t=[].concat(...n.map(i));return[...new Map(t.filter(d=>d.st==="0A").map(d=>{const E=d.local_address.split(":");return{socket:parseInt(d.inode,10),ip:g(E[0]),port:parseInt(E[1],16)}}).map(d=>[d.ip+":"+d.port,d])).values()]}e.loadListeningPorts=C;function g(n){let t="";if(n.length===8)for(let d=n.length-2;d>=0;d-=2)t+=parseInt(n.substr(d,2),16),d!==0&&(t+=".");else for(let d=n.length-4;d>=0;d-=4)t+=parseInt(n.substr(d,4),16).toString(16),d!==0&&(t+=":");return t}function i(n){const t=n.trim().split(`
`),d=t.shift().trim().split(/\s+/).filter(w=>w!=="rx_queue"&&w!=="tm->when");return t.map(w=>w.trim().split(/\s+/).reduce((N,j,V)=>(N[d[V]||V]=j,N),{}))}e.loadConnectionTable=i;function s(n){return!!n.match(/.*\.vscode-server-[a-zA-Z]+\/bin.*/)||n.indexOf("out/server-main.js")!==-1||n.indexOf("_productName=VSCode")!==-1}function r(n){const t=n.trim().split(`
`),d=[];return t.forEach(E=>{const w=/^\d+\s+\D+\s+root\s+(\d+)\s+(\d+).+\d+\:\d+\:\d+\s+(.+)$/.exec(E);w&&w.length>=4&&d.push({pid:parseInt(w[1],10),ppid:parseInt(w[2]),cmd:w[3]})}),d}e.getRootProcesses=r;async function o(n,t,d){const E=d.reduce((N,j)=>(N[j.pid]=j,N),{}),w=[];return n.forEach(({socket:N,ip:j,port:V})=>{const Q=t[N]?t[N].pid:void 0,x=Q?E[Q]?.cmd:void 0;Q&&x&&!s(x)&&w.push({host:j,port:V,detail:x,pid:Q})}),w}e.findPorts=o;function c(n,t,d){const E=new Map,w=r(t);for(const N of n){const j=d.get(N.port);if(j){E.set(N.port,j);continue}const V=w.find(Q=>Q.cmd.includes(`${N.port}`));if(V){let Q=V,x;do x=w.find(U=>U.ppid===Q.pid),x&&(Q=x);while(x);E.set(N.port,{host:N.ip,port:N.port,pid:Q.pid,detail:Q.cmd,ppid:Q.ppid})}else E.set(N.port,{host:N.ip,port:N.port,ppid:Number.MAX_VALUE})}return E}e.tryFindRootPorts=c;let m=class extends R.Disposable{constructor(t,d,E){super(),this.n=E,this.c=()=>Promise.resolve(!0),this.f=new Map,this.g=new D.Emitter,this.onDidChangeTunnels=this.g.event,this.h=!1,this.j=new Map,this.k=0,this.l=new Map,this.a=t.getProxy(a.MainContext.MainThreadTunnelService),v.isLinux&&d.remote.isRemote&&d.remote.authority&&this.a.$setRemoteTunnelService(process.pid)}async openTunnel(t,d){this.n.trace(`ForwardedPorts: (ExtHostTunnelService) ${t.identifier.value} called openTunnel API for ${d.remoteAddress.host}:${d.remoteAddress.port}.`);const E=await this.a.$openTunnel(d,t.displayName);if(E){const w=new p(E.remoteAddress,E.localAddress,()=>this.a.$closeTunnel(E.remoteAddress));return this.B(w),w}}async getTunnels(){return this.a.$getTunnels()}p(t){return Math.max(t*20,2e3)}r(){return this.k++}registerPortsAttributesProvider(t,d){const E=this.r();return this.l.set(E,{selector:t,provider:d}),this.a.$registerPortsAttributesProvider(t,E),new P.Disposable(()=>{this.l.delete(E),this.a.$unregisterPortsAttributesProvider(E)})}async $providePortAttributes(t,d,E,w,N){const j=[];for(const Q of t){const x=this.l.get(Q);if(!x)return[];j.push(...await Promise.all(d.map(async U=>x.provider.providePortAttributes(U,E,w,N))))}const V=j.filter(Q=>!!Q);return V.length>0?V.map(Q=>({autoForwardAction:Q.autoForwardAction,port:Q.port})):[]}async $registerCandidateFinder(t){if(t&&this.h)return;this.h=t;const d=new u.MovingAverage;let E;for(;this.h;){const w=new Date().getTime(),N=(await this.findCandidatePorts()).filter(V=>(0,f.isLocalhost)(V.host)||(0,f.isAllInterfaces)(V.host));this.n.trace(`ForwardedPorts: (ExtHostTunnelService) found candidate ports ${N.map(V=>V.port).join(", ")}`);const j=new Date().getTime()-w;d.update(j),(!E||JSON.stringify(E)!==JSON.stringify(N))&&(E=N,await this.a.$onFoundNewCandidates(E)),await new Promise(V=>setTimeout(()=>V(),this.p(d.value)))}}async setTunnelFactory(t){if(t){if(t.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(t.candidatePortSource),t.showCandidatePort&&(this.c=t.showCandidatePort,this.a.$setCandidateFilter()),t.tunnelFactory){this.b=t.tunnelFactory;let d=t.tunnelFeatures?.privacyOptions??[];t.tunnelFeatures?.public&&d.length===0&&(d=[{id:"private",label:l.localize(0,null),themeIcon:"lock"},{id:"public",label:l.localize(1,null),themeIcon:"eye"}]);const E=t.tunnelFeatures?{elevation:!!t.tunnelFeatures?.elevation,public:!!t.tunnelFeatures?.public,privacyOptions:d}:void 0;this.a.$setTunnelProvider(E)}}else this.b=void 0;return(0,R.toDisposable)(()=>{this.b=void 0})}async $closeTunnel(t,d){if(this.f.has(t.host)){const E=this.f.get(t.host);E.has(t.port)&&(d&&E.get(t.port).disposeListener.dispose(),await E.get(t.port).tunnel.dispose(),E.delete(t.port))}}async $onDidTunnelsChange(){this.g.fire()}async $forwardPort(t,d){if(this.b)try{this.n.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const E=this.b(t,d);if(this.n.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),E!==void 0){const w=await E;this.n.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),this.f.has(t.remoteAddress.host)||this.f.set(t.remoteAddress.host,new Map);const N=this.B(w.onDidDispose(()=>(this.n.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(w.remoteAddress))));return this.f.get(t.remoteAddress.host).set(t.remoteAddress.port,{tunnel:w,disposeListener:N}),k.TunnelDtoConverter.fromApiTunnel(w)}else this.n.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch{this.n.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error")}}async $applyCandidateFilter(t){const d=await Promise.all(t.map(w=>this.c(w.host,w.port,w.detail??""))),E=t.filter((w,N)=>d[N]);return this.n.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${t.map(w=>w.port).join(", ")} to ${E.map(w=>w.port).join(", ")}`),E}async findCandidatePorts(){let t="",d="";try{t=await O.Promises.readFile("/proc/net/tcp","utf8"),d=await O.Promises.readFile("/proc/net/tcp6","utf8")}catch{}const E=C(t,d),w=await new Promise(F=>{(0,y.exec)("ls -l /proc/[0-9]*/fd/[0-9]* | grep socket:",(B,Z,_)=>{F(Z)})}),N=b(w),j=await O.Promises.readdir("/proc"),V=[];for(const F of j)try{const B=Number(F),Z=I.joinPath(A.URI.file("/proc"),F);if((await O.Promises.stat(Z.fsPath)).isDirectory()&&!isNaN(B)){const H=await O.Promises.readlink(I.joinPath(Z,"cwd").fsPath),Y=await O.Promises.readFile(I.joinPath(Z,"cmdline").fsPath,"utf8");V.push({pid:B,cwd:H,cmd:Y})}}catch{}const Q=[],x=E.filter(F=>{const B=N[F.socket];return B||Q.push(F),B}),U=o(x,N,V);let T;if(this.n.trace(`ForwardedPorts: (ExtHostTunnelService) number of possible root ports ${Q.length}`),Q.length>0){const F=await new Promise(B=>{(0,y.exec)("ps -F -A -l | grep root",(Z,_,H)=>{B(_)})});this.j=c(Q,F,this.j),T=Array.from(this.j.values()),this.n.trace(`ForwardedPorts: (ExtHostTunnelService) heuristic ports ${T.map(B=>B.port).join(", ")}`)}return U.then(F=>T?F.concat(T):F)}};m=qe([ze(0,L.IExtHostRpcService),ze(1,S.IExtHostInitDataService),ze(2,h.ILogService)],m),e.ExtHostTunnelService=m}),define(ye[290],De([1,0,17,22,21,11,3,6,111,248,59]),function(re,e,a,L,l,R,S,A,y,I,O){"use strict";var P;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function v(E,w){try{return JSON.stringify(E,w)}catch{return"null"}}const k="$$ref$$",D={[k]:-1};class f{constructor(w,N){this.jsonString=w,this.referencedBuffers=N}}function u(E,w=null,N=!1){const j=[];return{jsonString:(N?v:JSON.stringify)(E,(Q,x)=>{if(typeof x>"u")return D;if(typeof x=="object"){if(x instanceof L.VSBuffer){const U=j.push(x)-1;return{[k]:U}}if(w)return w(Q,x)}return x}),referencedBuffers:j}}e.stringifyJsonWithBufferRefs=u;function h(E,w,N){return JSON.parse(E,(j,V)=>{if(V){const Q=V[k];if(typeof Q=="number")return w[Q];if(N&&V.$mid===1)return N.transformIncoming(V)}return V})}e.parseJsonAndRestoreBufferRefs=h;function p(E,w){return JSON.stringify(E,w)}function b(E){return E?(w,N)=>N&&N.$mid===1?E.transformOutgoing(N):N:null}var C;(function(E){E[E.LocalSide=0]="LocalSide",E[E.OtherSide=1]="OtherSide"})(C=e.RequestInitiator||(e.RequestInitiator={}));var g;(function(E){E[E.Responsive=0]="Responsive",E[E.Unresponsive=1]="Unresponsive"})(g=e.ResponsiveState||(e.ResponsiveState={}));const i=()=>{},s=Symbol.for("rpcProtocol"),r=Symbol.for("rpcProxy");class o extends A.Disposable{constructor(w,N=null,j=null){super(),this[P]=!0,this.b=this.B(new S.Emitter),this.onDidChangeResponsiveState=this.b.event,this.c=w,this.f=N,this.g=j,this.h=b(this.g),this.j=!1,this.k=[],this.l=[];for(let V=0,Q=O.ProxyIdentifier.count;V<Q;V++)this.k[V]=null,this.l[V]=null;this.m=0,this.p=Object.create(null),this.s={},this.t=0,this.u=0,this.v=0,this.w=this.B(new a.RunOnceScheduler(()=>this.C(),1e3)),this.c.onMessage(V=>this.G(V))}dispose(){this.j=!0,Object.keys(this.s).forEach(w=>{this.s[w].resolveErr(R.canceled())})}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}y(w){this.u===0&&(this.v=Date.now()+o.a),this.u++,this.w.isScheduled()||this.w.schedule()}z(w){this.v=Date.now()+o.a,this.u--,this.u===0&&this.w.cancel(),this.D(0)}C(){this.u!==0&&(Date.now()>this.v?this.D(1):this.w.schedule())}D(w){this.t!==w&&(this.t=w,this.b.fire(this.t))}get responsiveState(){return this.t}transformIncomingURIs(w){return this.g?(0,y.transformIncomingURIs)(w,this.g):w}getProxy(w){const{nid:N,sid:j}=w;return this.l[N]||(this.l[N]=this.F(N,j)),this.l[N]}F(w,N){const j={get:(V,Q)=>(typeof Q=="string"&&!V[Q]&&Q.charCodeAt(0)===36&&(V[Q]=(...x)=>this.O(w,Q,x)),Q===r?N:V[Q])};return new Proxy(Object.create(null),j)}set(w,N){return this.k[w.nid]=N,N}assertRegistered(w){for(let N=0,j=w.length;N<j;N++){const V=w[N];if(!this.k[V.nid])throw new Error(`Missing proxy instance ${V.sid}`)}}G(w){if(this.j)return;const N=w.byteLength,j=c.read(w,0),V=j.readUInt8(),Q=j.readUInt32();switch(V){case 1:case 2:{let{rpcId:x,method:U,args:T}=n.deserializeRequestJSONArgs(j);this.g&&(T=(0,y.transformIncomingURIs)(T,this.g)),this.H(N,Q,x,U,T,V===2);break}case 3:case 4:{let{rpcId:x,method:U,args:T}=n.deserializeRequestMixedArgs(j);this.g&&(T=(0,y.transformIncomingURIs)(T,this.g)),this.H(N,Q,x,U,T,V===4);break}case 5:{this.f?.logIncoming(N,Q,0,"ack"),this.z(Q);break}case 6:{this.I(N,Q);break}case 7:{this.J(N,Q,void 0);break}case 9:{let x=n.deserializeReplyOKJSON(j);this.g&&(x=(0,y.transformIncomingURIs)(x,this.g)),this.J(N,Q,x);break}case 10:{const x=n.deserializeReplyOKJSONWithBuffers(j,this.g);this.J(N,Q,x);break}case 8:{const x=n.deserializeReplyOKVSBuffer(j);this.J(N,Q,x);break}case 11:{let x=n.deserializeReplyErrError(j);this.g&&(x=(0,y.transformIncomingURIs)(x,this.g)),this.L(N,Q,x);break}case 12:{this.L(N,Q,void 0);break}default:console.error("received unexpected message"),console.error(w)}}H(w,N,j,V,Q,x){this.f?.logIncoming(w,N,1,`receiveRequest ${(0,O.getStringIdentifierForProxy)(j)}.${V}(`,Q);const U=String(N);let T,F;if(x){const Z=new l.CancellationTokenSource;Q.push(Z.token),T=this.M(j,V,Q),F=()=>Z.cancel()}else T=this.M(j,V,Q),F=i;this.p[U]=F;const B=n.serializeAcknowledged(N);this.f?.logOutgoing(B.byteLength,N,1,"ack"),this.c.send(B),T.then(Z=>{delete this.p[U];const _=n.serializeReplyOK(N,Z,this.h);this.f?.logOutgoing(_.byteLength,N,1,"reply:",Z),this.c.send(_)},Z=>{delete this.p[U];const _=n.serializeReplyErr(N,Z);this.f?.logOutgoing(_.byteLength,N,1,"replyErr:",Z),this.c.send(_)})}I(w,N){this.f?.logIncoming(w,N,1,"receiveCancel");const j=String(N);this.p[j]?.()}J(w,N,j){this.f?.logIncoming(w,N,0,"receiveReply:",j);const V=String(N);if(!this.s.hasOwnProperty(V))return;const Q=this.s[V];delete this.s[V],Q.resolveOk(j)}L(w,N,j){this.f?.logIncoming(w,N,0,"receiveReplyErr:",j);const V=String(N);if(!this.s.hasOwnProperty(V))return;const Q=this.s[V];delete this.s[V];let x;j&&(j.$isError?(x=new Error,x.name=j.name,x.message=j.message,x.stack=j.stack):x=j),Q.resolveErr(x)}M(w,N,j){try{return Promise.resolve(this.N(w,N,j))}catch(V){return Promise.reject(V)}}N(w,N,j){const V=this.k[w];if(!V)throw new Error("Unknown actor "+(0,O.getStringIdentifierForProxy)(w));const Q=V[N];if(typeof Q!="function")throw new Error("Unknown method "+N+" on actor "+(0,O.getStringIdentifierForProxy)(w));return Q.apply(V,j)}O(w,N,j){if(this.j)return new I.CanceledLazyPromise;let V=null;if(j.length>0&&l.CancellationToken.isCancellationToken(j[j.length-1])&&(V=j.pop()),V&&V.isCancellationRequested)return Promise.reject(R.canceled());const Q=n.serializeRequestArguments(j,this.h),x=++this.m,U=String(x),T=new I.LazyPromise;V&&V.onCancellationRequested(()=>{const B=n.serializeCancel(x);this.f?.logOutgoing(B.byteLength,x,0,"cancel"),this.c.send(n.serializeCancel(x))}),this.s[U]=T,this.y(x);const F=n.serializeRequest(x,w,N,Q,!!V);return this.f?.logOutgoing(F.byteLength,x,0,`request: ${(0,O.getStringIdentifierForProxy)(w)}.${N}(`,j),this.c.send(F),T}}P=s,o.a=3*1e3,e.RPCProtocol=o;class c{static alloc(w,N,j){const V=new c(L.VSBuffer.alloc(j+1+4),0);return V.writeUInt8(w),V.writeUInt32(N),V}static read(w,N){return new c(w,N)}get buffer(){return this.a}constructor(w,N){this.a=w,this.b=N}static sizeUInt8(){return 1}writeUInt8(w){this.a.writeUInt8(w,this.b),this.b+=1}readUInt8(){const w=this.a.readUInt8(this.b);return this.b+=1,w}writeUInt32(w){this.a.writeUInt32BE(w,this.b),this.b+=4}readUInt32(){const w=this.a.readUInt32BE(this.b);return this.b+=4,w}static sizeShortString(w){return 1+w.byteLength}writeShortString(w){this.a.writeUInt8(w.byteLength,this.b),this.b+=1,this.a.set(w,this.b),this.b+=w.byteLength}readShortString(){const w=this.a.readUInt8(this.b);this.b+=1;const j=this.a.slice(this.b,this.b+w).toString();return this.b+=w,j}static sizeLongString(w){return 4+w.byteLength}writeLongString(w){this.a.writeUInt32BE(w.byteLength,this.b),this.b+=4,this.a.set(w,this.b),this.b+=w.byteLength}readLongString(){const w=this.a.readUInt32BE(this.b);this.b+=4;const j=this.a.slice(this.b,this.b+w).toString();return this.b+=w,j}writeBuffer(w){this.a.writeUInt32BE(w.byteLength,this.b),this.b+=4,this.a.set(w,this.b),this.b+=w.byteLength}static sizeVSBuffer(w){return 4+w.byteLength}writeVSBuffer(w){this.a.writeUInt32BE(w.byteLength,this.b),this.b+=4,this.a.set(w,this.b),this.b+=w.byteLength}readVSBuffer(){const w=this.a.readUInt32BE(this.b);this.b+=4;const N=this.a.slice(this.b,this.b+w);return this.b+=w,N}static sizeMixedArray(w){let N=0;N+=1;for(let j=0,V=w.length;j<V;j++){const Q=w[j];switch(N+=1,Q.type){case 1:N+=this.sizeLongString(Q.value);break;case 2:N+=this.sizeVSBuffer(Q.value);break;case 3:N+=this.sizeUInt32,N+=this.sizeLongString(Q.value);for(let x=0;x<Q.buffers.length;++x)N+=this.sizeVSBuffer(Q.buffers[x]);break;case 4:break}}return N}writeMixedArray(w){this.a.writeUInt8(w.length,this.b),this.b+=1;for(let N=0,j=w.length;N<j;N++){const V=w[N];switch(V.type){case 1:this.writeUInt8(1),this.writeLongString(V.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(V.value);break;case 3:this.writeUInt8(3),this.writeUInt32(V.buffers.length),this.writeLongString(V.value);for(let Q=0;Q<V.buffers.length;++Q)this.writeBuffer(V.buffers[Q]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const w=this.a.readUInt8(this.b);this.b+=1;const N=new Array(w);for(let j=0;j<w;j++)switch(this.readUInt8()){case 1:N[j]=this.readLongString();break;case 2:N[j]=this.readVSBuffer();break;case 3:{const Q=this.readUInt32(),x=this.readLongString(),U=[];for(let T=0;T<Q;++T)U.push(this.readVSBuffer());N[j]=new O.SerializableObjectWithBuffers(h(x,U,null));break}case 4:N[j]=void 0;break}return N}}c.sizeUInt32=4;var m;(function(E){E[E.Simple=0]="Simple",E[E.Mixed=1]="Mixed"})(m||(m={}));class n{static a(w){for(let N=0,j=w.length;N<j;N++)if(w[N]instanceof L.VSBuffer||w[N]instanceof O.SerializableObjectWithBuffers||typeof w[N]>"u")return!0;return!1}static serializeRequestArguments(w,N){if(this.a(w)){const j=[];for(let V=0,Q=w.length;V<Q;V++){const x=w[V];if(x instanceof L.VSBuffer)j[V]={type:2,value:x};else if(typeof x>"u")j[V]={type:4};else if(x instanceof O.SerializableObjectWithBuffers){const{jsonString:U,referencedBuffers:T}=u(x.value,N);j[V]={type:3,value:L.VSBuffer.fromString(U),buffers:T}}else j[V]={type:1,value:L.VSBuffer.fromString(p(x,N))}}return{type:1,args:j}}return{type:0,args:p(w,N)}}static serializeRequest(w,N,j,V,Q){switch(V.type){case 0:return this.b(w,N,j,V.args,Q);case 1:return this.c(w,N,j,V.args,Q)}}static b(w,N,j,V,Q){const x=L.VSBuffer.fromString(j),U=L.VSBuffer.fromString(V);let T=0;T+=c.sizeUInt8(),T+=c.sizeShortString(x),T+=c.sizeLongString(U);const F=c.alloc(Q?2:1,w,T);return F.writeUInt8(N),F.writeShortString(x),F.writeLongString(U),F.buffer}static deserializeRequestJSONArgs(w){const N=w.readUInt8(),j=w.readShortString(),V=w.readLongString();return{rpcId:N,method:j,args:JSON.parse(V)}}static c(w,N,j,V,Q){const x=L.VSBuffer.fromString(j);let U=0;U+=c.sizeUInt8(),U+=c.sizeShortString(x),U+=c.sizeMixedArray(V);const T=c.alloc(Q?4:3,w,U);return T.writeUInt8(N),T.writeShortString(x),T.writeMixedArray(V),T.buffer}static deserializeRequestMixedArgs(w){const N=w.readUInt8(),j=w.readShortString(),V=w.readMixedArray(),Q=new Array(V.length);for(let x=0,U=V.length;x<U;x++){const T=V[x];typeof T=="string"?Q[x]=JSON.parse(T):Q[x]=T}return{rpcId:N,method:j,args:Q}}static serializeAcknowledged(w){return c.alloc(5,w,0).buffer}static serializeCancel(w){return c.alloc(6,w,0).buffer}static serializeReplyOK(w,N,j){if(typeof N>"u")return this.d(w);if(N instanceof L.VSBuffer)return this.e(w,N);if(N instanceof O.SerializableObjectWithBuffers){const{jsonString:V,referencedBuffers:Q}=u(N.value,j,!0);return this.g(w,V,Q)}else return this.f(w,v(N,j))}static d(w){return c.alloc(7,w,0).buffer}static e(w,N){let j=0;j+=c.sizeVSBuffer(N);const V=c.alloc(8,w,j);return V.writeVSBuffer(N),V.buffer}static deserializeReplyOKVSBuffer(w){return w.readVSBuffer()}static f(w,N){const j=L.VSBuffer.fromString(N);let V=0;V+=c.sizeLongString(j);const Q=c.alloc(9,w,V);return Q.writeLongString(j),Q.buffer}static g(w,N,j){const V=L.VSBuffer.fromString(N);let Q=0;Q+=c.sizeUInt32,Q+=c.sizeLongString(V);for(const U of j)Q+=c.sizeVSBuffer(U);const x=c.alloc(10,w,Q);x.writeUInt32(j.length),x.writeLongString(V);for(const U of j)x.writeBuffer(U);return x.buffer}static deserializeReplyOKJSON(w){const N=w.readLongString();return JSON.parse(N)}static deserializeReplyOKJSONWithBuffers(w,N){const j=w.readUInt32(),V=w.readLongString(),Q=[];for(let x=0;x<j;++x)Q.push(w.readVSBuffer());return new O.SerializableObjectWithBuffers(h(V,Q,N))}static serializeReplyErr(w,N){const j=N?v(R.transformErrorForSerialization(N),null):void 0;if(typeof j!="string")return this.h(w);const V=L.VSBuffer.fromString(j);let Q=0;Q+=c.sizeLongString(V);const x=c.alloc(11,w,Q);return x.writeLongString(V),x.buffer}static deserializeReplyErrError(w){const N=w.readLongString();return JSON.parse(N)}static h(w){return c.alloc(12,w,0).buffer}}var t;(function(E){E[E.RequestJSONArgs=1]="RequestJSONArgs",E[E.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",E[E.RequestMixedArgs=3]="RequestMixedArgs",E[E.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",E[E.Acknowledged=5]="Acknowledged",E[E.Cancel=6]="Cancel",E[E.ReplyOKEmpty=7]="ReplyOKEmpty",E[E.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",E[E.ReplyOKJSON=9]="ReplyOKJSON",E[E.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",E[E.ReplyErrError=11]="ReplyErrError",E[E.ReplyErrEmpty=12]="ReplyErrEmpty"})(t||(t={}));var d;(function(E){E[E.String=1]="String",E[E.VSBuffer=2]="VSBuffer",E[E.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",E[E.Undefined=4]="Undefined"})(d||(d={}))}),define(ye[291],De([1,0,3,39,55,4]),function(re,e,a,L,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.CONTEXT_IN_OUTPUT=new l.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new l.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new l.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,R.createDecorator)("outputService");var S;(function(y){y[y.Append=1]="Append",y[y.Replace=2]="Replace",y[y.Clear=3]="Clear"})(S=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class A{constructor(){this.a=new Map,this.b=new a.Emitter,this.onDidRegisterChannel=this.b.event,this.c=new a.Emitter,this.onDidRemoveChannel=this.c.event}registerChannel(I){this.a.has(I.id)||(this.a.set(I.id,I),this.b.fire(I.id))}getChannels(){const I=[];return this.a.forEach(O=>I.push(O)),I}getChannel(I){return this.a.get(I)}removeChannel(I){this.a.delete(I),this.c.fire(I)}}L.Registry.add(e.Extensions.OutputChannels,new A),e.ACTIVE_OUTPUT_CHANNEL_CONTEXT=new l.RawContextKey("activeOutputChannel","")}),define(ye[142],De([1,0,5,4,18,27,13,291,79,25,48,165,22,10,44,3,6]),function(re,e,a,L,l,R,S,A,y,I,O,P,v,k,D,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=void 0;class h extends S.AbstractMessageLogger{get disposed(){return this.l}constructor(g,i,s,r,o){super(),this.id=g,this.name=i,this.m=s,this.n=r,this.extension=o,this.k=0,this.l=!1,this.visible=!1,this.setLevel(s.getLevel()),this.B(s.onDidChangeLogLevel(c=>this.setLevel(c)))}get logLevel(){return this.getLevel()}appendLine(g){this.append(g+`
`)}append(g){this.info(g)}clear(){const g=this.k;this.m.flush(),this.n.$update(this.id,A.OutputChannelUpdateMode.Clear,g)}replace(g){const i=this.k;this.info(g),this.n.$update(this.id,A.OutputChannelUpdateMode.Replace,i),this.visible&&this.m.flush()}show(g,i){this.m.flush(),this.n.$reveal(this.id,!!(typeof g=="boolean"?g:i))}hide(){this.n.$close(this.id)}g(g,i){this.k+=v.VSBuffer.fromString(i).byteLength,(0,S.log)(this.m,g,i),this.visible&&(this.m.flush(),this.n.$update(this.id,A.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.l||(this.n.$dispose(this.id),this.l=!0)}}class p extends h{appendLine(g){this.append(g)}}let b=class{constructor(g,i,s,r,o,c){this.i=i,this.j=s,this.k=r,this.l=o,this.m=c,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=g.getProxy(a.MainContext.MainThreadOutputService),this.b=this.k.extUri.joinPath(i.logsLocation,`output_logging_${(0,P.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(g){this.h=g;for(const[i,s]of this.g)s.visible=i===this.h}createOutputChannel(g,i,s){if(g=g.trim(),!g)throw new Error("illegal argument `name`. must not be falsy");const r=typeof i=="object"&&i.log,o=(0,k.isString)(i)?i:void 0;if((0,k.isString)(o)&&!o.trim())throw new Error("illegal argument `languageId`. must not be empty");let c;const m=this.i.environment.extensionLogLevel?.find(([t])=>R.ExtensionIdentifier.equals(s.identifier,t))?.[1];m&&(c=(0,S.parseLogLevel)(m));const n=r?this.o(g,c,s):this.n(g,o,s);return n.then(t=>{this.g.set(t.id,t),t.visible=t.id===this.h}),r?this.r(g,c??this.m.getLevel(),n):this.q(g,n)}async n(g,i,s){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const r=await this.c,o=this.k.extUri.joinPath(r,`${this.f++}-${g.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),c=this.l.createLogger(o,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),m=await this.a.$register(g,o,i,s.identifier.value);return new h(m,g,c,this.a,s)}async o(g,i,s){const r=await this.p(s),o=this.k.extUri.joinPath(r,`${g.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),c=o.toString(),m=this.l.createLogger(o,{id:c,name:g,logLevel:i,extensionId:s.identifier.value});return new p(c,g,m,this.a,s)}p(g){let i=this.d.get(g.identifier.value);if(!i){const s=this.k.extUri.joinPath(this.i.logsLocation,g.identifier.value);this.d.set(g.identifier.value,i=(async()=>{try{await this.j.value.createDirectory(s)}catch(r){if((0,D.toFileSystemProviderErrorCode)(r)!==D.FileSystemProviderErrorCode.FileExists)throw r}return s})())}return i}q(g,i){let s=!1;const r=()=>{if(s)throw new Error("Channel has been closed")};return{get name(){return g},append(o){r(),i.then(c=>c.append(o))},appendLine(o){r(),i.then(c=>c.appendLine(o))},clear(){r(),i.then(o=>o.clear())},replace(o){r(),i.then(c=>c.replace(o))},show(o,c){r(),i.then(m=>m.show(o,c))},hide(){r(),i.then(o=>o.hide())},dispose(){s=!0,i.then(o=>o.dispose())}}}r(g,i,s){const r=new u.DisposableStore,o=()=>{if(r.isDisposed)throw new Error("Channel has been closed")},c=r.add(new f.Emitter);function m(n){i=n,c.fire(n)}return s.then(n=>{r.add(n),n.logLevel!==i&&m(n.logLevel),r.add(n.onDidChangeLogLevel(t=>m(t)))}),{...this.q(g,s),get logLevel(){return i},onDidChangeLogLevel:c.event,trace(n,...t){o(),s.then(d=>d.trace(n,...t))},debug(n,...t){o(),s.then(d=>d.debug(n,...t))},info(n,...t){o(),s.then(d=>d.info(n,...t))},warn(n,...t){o(),s.then(d=>d.warn(n,...t))},error(n,...t){o(),s.then(d=>d.error(n,...t))},dispose(){r.dispose()}}}};b=qe([ze(0,l.IExtHostRpcService),ze(1,I.IExtHostInitDataService),ze(2,y.IExtHostConsumerFileSystem),ze(3,O.IExtHostFileSystemInfo),ze(4,S.ILoggerService),ze(5,S.ILogService)],b),e.ExtHostOutputService=b,e.IExtHostOutputService=(0,L.createDecorator)("IExtHostOutputService")}),define(ye[292],De([1,0,4]),function(re,e,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,a.createDecorator)("remoteAgentService")}),define(ye[293],De([1,0,32,16,9,12,24,2,4,218,47,236,292]),function(re,e,a,L,l,R,S,A,y,I,O,P,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,y.createDecorator)("pathService");let k=class cn{constructor(f,u,h,p){this.d=f,this.e=u,this.f=h,this.g=p,this.a=(async()=>(await this.e.getEnvironment())?.os||R.OS)(),this.b=(async()=>{const b=await this.e.getEnvironment();return this.c=b?.userHome??f})()}hasValidBasename(f,u,h){return typeof u=="string"||typeof u>"u"?this.a.then(p=>this.h(f,p,u)):this.h(f,u,h)}h(f,u,h){return f.scheme===L.Schemas.file||f.scheme===L.Schemas.vscodeRemote?(0,a.isValidBasename)(h??(0,S.basename)(f),u===1):!0}get defaultUriScheme(){return cn.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(f,u){if(f.remoteAuthority)return L.Schemas.vscodeRemote;const h=(0,I.getVirtualWorkspaceScheme)(u.getWorkspace());if(h)return h;const p=u.getWorkspace().folders[0];if(p)return p.uri.scheme;const b=u.getWorkspace().configuration;return b?b.scheme:L.Schemas.file}userHome(f){return f?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(f=>f===1?l.win32:l.posix)}async fileURI(f){let u="";if(await this.a===1&&(f=f.replace(/\\/g,"/")),f[0]==="/"&&f[1]==="/"){const p=f.indexOf("/",2);p===-1?(u=f.substring(2),f="/"):(u=f.substring(2,p),f=f.substring(p)||"/")}return A.URI.from({scheme:L.Schemas.file,authority:u,path:f,query:"",fragment:""})}};k=qe([ze(1,v.IRemoteAgentService),ze(2,P.IWorkbenchEnvironmentService),ze(3,O.IWorkspaceContextService)],k),e.AbstractPathService=k}),define(ye[82],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class a{constructor(S,A){this.line=S,this.character=A}isBefore(S){return!1}isBeforeOrEqual(S){return!1}isAfter(S){return!1}isAfterOrEqual(S){return!1}isEqual(S){return!1}compareTo(S){return 0}translate(S,A){return new a(0,0)}with(S){return new a(0,0)}}e.Position=a;class L{constructor(S,A,y,I){this.isEmpty=!1,this.isSingleLine=!1,this.start=new a(S,A),this.end=new a(y,I)}contains(S){return!1}isEqual(S){return!1}intersection(S){}union(S){return new L(0,0,0,0)}with(S){return new L(0,0,0,0)}}e.Range=L;var l;(function(R){R[R.Information=1]="Information",R[R.Warning=2]="Warning"})(l=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(ye[31],De([1,0,15,38,23,32,8,4,9,11,82,17]),function(re,e,a,L,l,R,S,A,y,I,O,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.ViewMode=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return O.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const v="\u27EA ",k=" characters skipped \u27EB",D=(v.length+k.length+5)*2;e.ISearchService=(0,A.createDecorator)("searchService");var f;(function(Y){Y[Y.file=0]="file",Y[Y.text=1]="text"})(f=e.SearchProviderType||(e.SearchProviderType={}));var u;(function(Y){Y[Y.File=1]="File",Y[Y.Text=2]="Text"})(u=e.QueryType||(e.QueryType={}));function h(Y){return!!Y.preview}e.resultIsMatch=h;function p(Y){return!!Y.resource}e.isFileMatch=p;function b(Y){return!!Y.message}e.isProgressMessage=b;var C;(function(Y){Y[Y.Normal=0]="Normal",Y[Y.NewSearchStarted=1]="NewSearchStarted"})(C=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class g{constructor(ie){this.resource=ie,this.results=[]}}e.FileMatch=g;class i{constructor(ie,ge,X){this.ranges=ge;const J=Array.isArray(ge)?ge:[ge];if(X&&X.matchLines===1&&s(J)){ie=(0,S.getNLines)(ie,X.matchLines);let ee="",me=0,ve=0;const Ie=Math.floor(X.charsPerLine/5),Re=[];for(const ae of J){const le=Math.max(ae.startColumn-Ie,0),ue=ae.startColumn+X.charsPerLine;if(le>ve+Ie+D){const ne=v+(le-ve)+k;ee+=ne+ie.slice(le,ue),me+=le-(ve+ne.length)}else ee+=ie.slice(ve,ue);Re.push(new o(0,ae.startColumn-me,ae.endColumn-me)),ve=ue}this.preview={text:ee,matches:Array.isArray(this.ranges)?Re:Re[0]}}else{const ee=Array.isArray(ge)?ge[0].startLineNumber:ge.startLineNumber;this.preview={text:ie,matches:(0,a.mapArrayOrNot)(ge,me=>new r(me.startLineNumber-ee,me.startColumn,me.endLineNumber-ee,me.endColumn))}}}}e.TextSearchMatch=i;function s(Y){const ie=Y[0].startLineNumber;for(const ge of Y)if(ge.startLineNumber!==ie||ge.endLineNumber!==ie)return!1;return!0}class r{constructor(ie,ge,X,J){this.startLineNumber=ie,this.startColumn=ge,this.endLineNumber=X,this.endColumn=J}}e.SearchRange=r;class o extends r{constructor(ie,ge,X){super(ie,ge,ie,X)}}e.OneLineRange=o;var c;(function(Y){Y.List="list",Y.Tree="tree"})(c=e.ViewMode||(e.ViewMode={}));var m;(function(Y){Y.Default="default",Y.FileNames="fileNames",Y.Type="type",Y.Modified="modified",Y.CountDescending="countDescending",Y.CountAscending="countAscending"})(m=e.SearchSortOrder||(e.SearchSortOrder={}));function n(Y,ie=!0){const ge=Y&&Y.files&&Y.files.exclude,X=ie&&Y&&Y.search&&Y.search.exclude;if(!ge&&!X)return;if(!ge||!X)return ge||X;let J=Object.create(null);return J=l.mixin(J,l.deepClone(ge)),J=l.mixin(J,l.deepClone(X),!0),J}e.getExcludes=n;function t(Y,ie){return Y.excludePattern&&L.match(Y.excludePattern,ie)?!1:Y.includePattern||Y.usingSearchPaths?Y.includePattern&&L.match(Y.includePattern,ie)?!0:Y.usingSearchPaths?!!Y.folderQueries&&Y.folderQueries.some(ge=>{const X=ge.folder.fsPath;if(R.isEqualOrParent(ie,X)){const J=y.relative(X,ie);return!ge.includePattern||!!L.match(ge.includePattern,J)}else return!1}):!1:!0}e.pathIncludedInQuery=t;var d;(function(Y){Y[Y.unknownEncoding=1]="unknownEncoding",Y[Y.regexParseError=2]="regexParseError",Y[Y.globParseError=3]="globParseError",Y[Y.invalidLiteral=4]="invalidLiteral",Y[Y.rgProcessError=5]="rgProcessError",Y[Y.other=6]="other",Y[Y.canceled=7]="canceled"})(d=e.SearchErrorCode||(e.SearchErrorCode={}));class E extends Error{constructor(ie,ge){super(ie),this.code=ge}}e.SearchError=E;function w(Y){const ie=Y.message;if((0,I.isCancellationError)(Y))return new E(ie,d.canceled);try{const ge=JSON.parse(ie);return new E(ge.message,ge.code)}catch{return new E(ie,d.other)}}e.deserializeSearchError=w;function N(Y){const ie={message:Y.message,code:Y.code};return new Error(JSON.stringify(ie))}e.serializeSearchError=N;function j(Y){return Y.type==="error"?!0:Y.type==="success"}e.isSerializedSearchComplete=j;function V(Y){return Y.type==="success"}e.isSerializedSearchSuccess=V;function Q(Y){return!!Y.path}e.isSerializedFileMatch=Q;function x(Y,ie){const ge=Y.searchPath?Y.searchPath:Y.relativePath;return(0,S.fuzzyContains)(ge,ie)}e.isFilePatternMatch=x;class U{constructor(ie){this.path=ie,this.results=[]}addMatch(ie){this.results.push(ie)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=U;function T(Y,ie){const ge={...Y||{},...ie||{}};return Object.keys(ge).filter(X=>{const J=ge[X];return typeof J=="boolean"&&J})}e.resolvePatternsForProvider=T;class F{constructor(ie,ge){this.c=null,this.a={...ie.excludePattern||{},...ge.excludePattern||{}},this.b=L.parse(this.a);let X=ie.includePattern;ge.includePattern&&(X?X={...X,...ge.includePattern}:X=ge.includePattern),X&&(this.c=L.parse(X))}matchesExcludesSync(ie,ge,X){return!!(this.b&&this.b(ie,ge,X))}includedInQuerySync(ie,ge,X){return!(this.b&&this.b(ie,ge,X)||this.c&&!this.c(ie,ge,X))}includedInQuery(ie,ge,X){const J=this.b(ie,ge,X),ee=()=>this.c?!!this.c(ie,ge,X):!0;return(0,P.isThenable)(J)?J.then(me=>me?!1:ee()):ee()}hasSiblingExcludeClauses(){return B(this.a)}}e.QueryGlobTester=F;function B(Y){for(const ie in Y)if(typeof Y[ie]!="boolean")return!0;return!1}function Z(Y){if(!Y)return;let ie;return ge=>(ie||(ie=(Y()||Promise.resolve([])).then(X=>X?H(X):{})),ie.then(X=>!!X[ge]))}e.hasSiblingPromiseFn=Z;function _(Y){if(!Y)return;let ie;return ge=>{if(!ie){const X=Y();ie=X?H(X):{}}return!!ie[ge]}}e.hasSiblingFn=_;function H(Y){const ie={};for(const ge of Y)ie[ge]=!0;return ie}}),define(ye[34],De([1,0,15,17,21,3,6,68,16,102,24,8,10,2,183,4,13,206,47,48,25,18,14,7,57,31,5]),function(re,e,a,L,l,R,S,A,y,I,O,P,v,k,D,f,u,h,p,b,C,g,i,s,r,o,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function m(V,Q,x){return new O.ExtUri(U=>E(U,x)).isEqual(V,Q)}function n(V,Q,x){return m(V.uri,Q.uri,x)?0:(0,P.compare)(V.uri.toString(),Q.uri.toString())}function t(V,Q,x){return V.index!==Q.index?V.index<Q.index?-1:1:m(V.uri,Q.uri,x)?(0,P.compare)(V.name,Q.name):(0,P.compare)(V.uri.toString(),Q.uri.toString())}function d(V,Q,x,U){const T=V.slice(0).sort((B,Z)=>x(B,Z,U)),F=Q.slice(0).sort((B,Z)=>x(B,Z,U));return(0,a.delta)(T,F,(B,Z)=>x(B,Z,U))}function E(V,Q){const x=Q.getCapabilities(V.scheme);return!(x&&x&1024)}class w extends p.Workspace{static toExtHostWorkspace(Q,x,U,T){if(!Q)return{workspace:null,added:[],removed:[]};const{id:F,name:B,folders:Z,configuration:_,transient:H,isUntitled:Y}=Q,ie=[],ge=x;x?Z.forEach((me,ve)=>{const Ie=k.URI.revive(me.uri),Re=w.o(U||x,Ie,T);Re?(Re.name=me.name,Re.index=me.index,ie.push(Re)):ie.push({uri:Ie,name:me.name,index:ve})}):ie.push(...Z.map(({uri:me,name:ve,index:Ie})=>({uri:k.URI.revive(me),name:ve,index:Ie}))),ie.sort((me,ve)=>me.index<ve.index?-1:1);const X=new w(F,B,ie,!!H,_?k.URI.revive(_):null,!!Y,me=>E(me,T)),{added:J,removed:ee}=d(ge?ge.workspaceFolders:[],X.workspaceFolders,n,T);return{workspace:X,added:J,removed:ee}}static o(Q,x,U){for(let T=0;T<Q.folders.length;T++){const F=Q.workspaceFolders[T];if(m(F.uri,x,U))return F}}constructor(Q,x,U,T,F,B,Z){super(Q,U.map(_=>new p.WorkspaceFolder(_)),T,F,Z),this.t=x,this.u=B,this.q=[],this.s=A.TernarySearchTree.forUris(Z),U.forEach(_=>{this.q.push(_),this.s.set(_.uri,_)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(Q,x){return x&&this.s.get(Q)&&(Q=(0,O.dirname)(Q)),this.s.findSubstr(Q)}resolveWorkspaceFolder(Q){return this.s.get(Q)}}let N=class{constructor(Q,x,U,T,F){this.c=new R.Emitter,this.onDidChangeWorkspace=this.c.event,this.g=new R.Emitter,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.z=0,this.A=new R.AsyncEmitter,this.h=T,this.s=U,this.t=F,this.j=new I.Counter,this.k=new L.Barrier,this.o=Q.getProxy(c.MainContext.MainThreadWorkspace),this.q=Q.getProxy(c.MainContext.MainThreadMessageService);const B=x.workspace;this.l=B?new w(B.id,B.name,[],!!B.transient,B.configuration?k.URI.revive(B.configuration):null,!!B.isUntitled,Z=>E(Z,U)):void 0}$initializeWorkspace(Q,x){this.v=x,this.$acceptWorkspaceData(Q),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?k.URI.from({scheme:y.Schemas.untitled,path:(0,O.basename)((0,O.dirname)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(!!this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(Q,x,U,...T){const F=[];if(Array.isArray(T)&&T.forEach(Y=>{k.URI.isUri(Y.uri)&&!F.some(ie=>m(ie.uri,Y.uri,this.s))&&F.push({uri:Y.uri,name:Y.name||(0,O.basenameOrAuthority)(Y.uri)})}),this.n||[x,U].some(Y=>typeof Y!="number"||Y<0)||U===0&&F.length===0)return!1;const B=this.x?this.x.workspaceFolders:[];if(x+U>B.length)return!1;const Z=B.slice(0);Z.splice(x,U,...F.map(Y=>({uri:Y.uri,name:Y.name||(0,O.basenameOrAuthority)(Y.uri),index:void 0})));for(let Y=0;Y<Z.length;Y++){const ie=Z[Y];if(Z.some((ge,X)=>X!==Y&&m(ie.uri,ge.uri,this.s)))return!1}Z.forEach((Y,ie)=>Y.index=ie);const{added:_,removed:H}=d(B,Z,t,this.s);if(_.length===0&&H.length===0)return!1;if(this.o){const Y=Q.displayName||Q.name;this.o.$updateWorkspaceFolders(Y,x,U,F).then(void 0,ie=>{this.n=void 0;const ge={source:{identifier:Q.identifier,label:Q.displayName||Q.name}};this.q.$showMessage(h.Severity.Error,(0,D.localize)(0,null,Y,ie.toString()),ge,[])})}return this.y(Z),!0}getWorkspaceFolder(Q,x){if(!!this.x)return this.x.getWorkspaceFolder(Q,x)}async getWorkspaceFolder2(Q,x){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(Q,x)}async resolveWorkspaceFolder(Q){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(Q)}getPath(){if(!this.x)return;const{folders:Q}=this.x;if(Q.length!==0)return Q[0].uri.fsPath}getRelativePath(Q,x){let U,T="";if(typeof Q=="string"?(U=k.URI.file(Q),T=Q):typeof Q<"u"&&(U=Q,T=Q.fsPath),!U)return T;const F=this.getWorkspaceFolder(U,!0);if(!F)return T;typeof x>"u"&&this.x&&(x=this.x.folders.length>1);let B=(0,O.relativePath)(F.uri,U);return x&&F.name&&(B=`${F.name}/${B}`),B}y(Q){this.x&&(this.n=w.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:Q,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(Q){const{workspace:x,added:U,removed:T}=w.toExtHostWorkspace(Q,this.l,this.n,this.s);this.l=x||void 0,this.n=void 0,this.c.fire(Object.freeze({added:U,removed:T}))}findFiles(Q,x,U,T,F=l.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${T.value}, entryPoint: findFiles`);let B;if(x===null?B=!1:x&&(typeof x=="string"?B=x:B=x.pattern),F&&F.isCancellationRequested)return Promise.resolve([]);const{includePattern:Z,folder:_}=j(i.GlobPattern.from(Q));return this.o.$startFileSearch((0,v.withUndefinedAsNull)(Z),(0,v.withUndefinedAsNull)(_),(0,v.withUndefinedAsNull)(B),(0,v.withUndefinedAsNull)(U),F).then(H=>Array.isArray(H)?H.map(Y=>k.URI.revive(Y)):[])}async findTextInFiles(Q,x,U,T,F=l.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${T.value}, entryPoint: findTextInFiles`);const B=this.j.getNext(),Z=typeof x.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:x.previewOptions,{includePattern:_,folder:H}=j(i.GlobPattern.from(x.include)),Y=typeof x.exclude=="string"?x.exclude:x.exclude?x.exclude.pattern:void 0,ie={ignoreSymlinks:typeof x.followSymlinks=="boolean"?!x.followSymlinks:void 0,disregardIgnoreFiles:typeof x.useIgnoreFiles=="boolean"?!x.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof x.useGlobalIgnoreFiles=="boolean"?!x.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof x.useParentIgnoreFiles=="boolean"?!x.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof x.useDefaultExcludes=="boolean"?!x.useDefaultExcludes:!0,fileEncoding:x.encoding,maxResults:x.maxResults,previewOptions:Z,afterContext:x.afterContext,beforeContext:x.beforeContext,includePattern:_,excludePattern:Y},ge=!1;if(this.u[B]=X=>{if(ge)return;const J=k.URI.revive(X.resource);X.results.forEach(ee=>{(0,o.resultIsMatch)(ee)?U({uri:J,preview:{text:ee.preview.text,matches:(0,a.mapArrayOrNot)(ee.preview.matches,me=>new s.Range(me.startLineNumber,me.startColumn,me.endLineNumber,me.endColumn))},ranges:(0,a.mapArrayOrNot)(ee.ranges,me=>new s.Range(me.startLineNumber,me.startColumn,me.endLineNumber,me.endColumn))}):U({uri:J,text:ee.text,lineNumber:ee.lineNumber})})},F.isCancellationRequested)return{};try{const X=await this.o.$startTextSearch(Q,(0,v.withUndefinedAsNull)(H),ie,B,F);return delete this.u[B],X||{}}catch(X){throw delete this.u[B],X}}$handleTextSearchResult(Q,x){this.u[x]?.(Q)}saveAll(Q){return this.o.$saveAll(Q)}resolveProxy(Q){return this.o.$resolveProxy(Q)}get trusted(){return this.v}requestWorkspaceTrust(Q){return this.o.$requestWorkspaceTrust(Q)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(Q,x){if(this.w.has(Q))throw new Error(`A provider has already been registered for scheme ${Q}`);this.w.set(Q,x);const U=this.t.transformOutgoingScheme(Q),T=this.z++;return this.o.$registerEditSessionIdentityProvider(T,U),(0,S.toDisposable)(()=>{this.w.delete(Q),this.o.$unregisterEditSessionIdentityProvider(T)})}async $getEditSessionIdentifier(Q,x){this.h.info("Getting edit session identifier for workspaceFolder",Q);const U=await this.resolveWorkspaceFolder(k.URI.revive(Q));if(!U){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",U);const T=this.w.get(U.uri.scheme);if(this.h.info(`Provider for scheme ${U.uri.scheme} is defined: `,!!T),!T)return;const F=await T.provideEditSessionIdentity(U,x);if(this.h.info("Provider returned edit session identifier: ",F),!!F)return F}async $provideEditSessionIdentityMatch(Q,x,U,T){this.h.info("Getting edit session identifier for workspaceFolder",Q);const F=await this.resolveWorkspaceFolder(k.URI.revive(Q));if(!F){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",F);const B=this.w.get(F.uri.scheme);if(this.h.info(`Provider for scheme ${F.uri.scheme} is defined: `,!!B),!B)return;const Z=await B.provideEditSessionIdentityMatch?.(x,U,T);if(this.h.info("Provider returned edit session identifier match result: ",Z),!!Z)return Z}getOnWillCreateEditSessionIdentityEvent(Q){return(x,U,T)=>{const F=function(Z){x.call(U,Z)};return F.extension=Q,this.A.event(F,void 0,T)}}async $onWillCreateEditSessionIdentity(Q,x,U){const T=await this.resolveWorkspaceFolder(k.URI.revive(Q));if(T===void 0)throw new Error("Unable to resolve workspace folder");await this.A.fireAsync({workspaceFolder:T},x,async(F,B)=>{const Z=Date.now();await Promise.resolve(F),Date.now()-Z>U&&this.h.warn("SLOW edit session create-participant",B.extension.identifier)}),x.isCancellationRequested}};N=qe([ze(0,g.IExtHostRpcService),ze(1,C.IExtHostInitDataService),ze(2,b.IExtHostFileSystemInfo),ze(3,u.ILogService),ze(4,r.IURITransformerService)],N),e.ExtHostWorkspace=N,e.IExtHostWorkspace=(0,f.createDecorator)("IExtHostWorkspace");function j(V){let Q,x;return V&&(typeof V=="string"?Q=V:(Q=V.pattern,x=k.URI.revive(V.baseUri))),{includePattern:Q,folder:x}}}),define(ye[35],De([1,0,23,3,34,5,7,209,127,10,17,4,18,13,2]),function(re,e,a,L,l,R,S,A,y,I,O,P,v,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function f(s,r){if(r){const o=r.split(".");let c=s;for(let m=0;c&&m<o.length;m++)c=c[o[m]];return c}}function u(s){return s instanceof D.URI}function h(s){return s&&s.uri instanceof D.URI&&s.languageId&&typeof s.languageId=="string"}function p(s){return s&&!s.uri&&s.languageId&&typeof s.languageId=="string"}function b(s){return s&&s.uri instanceof D.URI&&(!s.name||typeof s.name=="string")&&(!s.index||typeof s.index=="number")}function C(s){if(u(s))return{resource:s};if(h(s))return{resource:s.uri,overrideIdentifier:s.languageId};if(p(s))return{overrideIdentifier:s.languageId};if(b(s))return{resource:s.uri};if(s===null)return{resource:null}}let g=class{constructor(r,o,c){this.a=r.getProxy(R.MainContext.MainThreadConfiguration),this.c=o,this.b=c,this.d=new O.Barrier,this.e=null}getConfigProvider(){return this.d.wait().then(r=>this.e)}$initializeConfiguration(r){this.e=new i(this.a,this.c,r,this.b),this.d.open()}$acceptConfigurationChanged(r,o){this.getConfigProvider().then(c=>c.$acceptConfigurationChanged(r,o))}};g=qe([ze(0,v.IExtHostRpcService),ze(1,l.IExtHostWorkspace),ze(2,k.ILogService)],g),e.ExtHostConfiguration=g;class i{constructor(r,o,c,m){this.a=new L.Emitter,this.b=r,this.f=m,this.c=o,this.e=A.Configuration.parse(c),this.d=this.k(c.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(r,o){const c={data:this.e.toData(),workspace:this.c.workspace};this.e=A.Configuration.parse(r),this.d=this.k(r.configurationScopes),this.a.fire(this.j(o,c))}getConfiguration(r,o,c){const m=C(o)||{},n=this.g(r?f(this.e.getValue(void 0,m,this.c.workspace),r):this.e.getValue(void 0,m,this.c.workspace));r&&this.h(r,m,c?.identifier);function t(E){if(E==null)return null;if(typeof E=="boolean")return E?2:5;switch(E){case S.ConfigurationTarget.Global:return 2;case S.ConfigurationTarget.Workspace:return 5;case S.ConfigurationTarget.WorkspaceFolder:return 6}}const d={has(E){return typeof f(n,E)<"u"},get:(E,w)=>{this.h(r?`${r}.${E}`:E,m,c?.identifier);let N=f(n,E);if(typeof N>"u")N=w;else{let j;const V=(Q,x)=>{let U;const T=()=>{j=j||(0,a.deepClone)(n),U=U||f(j,x)};return(0,I.isObject)(Q)?new Proxy(Q,{get:(F,B)=>{if(typeof B=="string"&&B.toLowerCase()==="tojson")return T(),()=>U;if(j)return U=U||f(j,x),U[B];const Z=F[B];return typeof B=="string"?V(Z,`${x}.${B}`):Z},set:(F,B,Z)=>(T(),U&&(U[B]=Z),!0),deleteProperty:(F,B)=>(T(),U&&delete U[B],!0),defineProperty:(F,B,Z)=>(T(),U&&Object.defineProperty(U,B,Z),!0)}):Q};N=V(N,E)}return N},update:(E,w,N,j)=>{E=r?`${r}.${E}`:E;const V=t(N);return w!==void 0?this.b.$updateConfigurationOption(V,E,w,m,j):this.b.$removeConfigurationOption(V,E,m,j)},inspect:E=>{E=r?`${r}.${E}`:E;const w=this.e.inspect(E,m,this.c.workspace);if(w)return{key:E,defaultValue:(0,a.deepClone)(w.policy?.value??w.default?.value),globalValue:(0,a.deepClone)(w.user?.value??w.application?.value),workspaceValue:(0,a.deepClone)(w.workspace?.value),workspaceFolderValue:(0,a.deepClone)(w.workspaceFolder?.value),defaultLanguageValue:(0,a.deepClone)(w.default?.override),globalLanguageValue:(0,a.deepClone)(w.user?.override??w.application?.override),workspaceLanguageValue:(0,a.deepClone)(w.workspace?.override),workspaceFolderLanguageValue:(0,a.deepClone)(w.workspaceFolder?.override),languageIds:(0,a.deepClone)(w.overrideIdentifiers)}}};return typeof n=="object"&&(0,a.mixin)(d,n,!1),Object.freeze(d)}g(r){const o=c=>(0,I.isObject)(c)?new Proxy(c,{get:(m,n)=>o(m[n]),set:(m,n,t)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(n)}' of object`)},deleteProperty:(m,n)=>{throw new Error(`TypeError: Cannot delete read only property '${String(n)}' of object`)},defineProperty:(m,n)=>{throw new Error(`TypeError: Cannot define property '${String(n)}' for a readonly object`)},setPrototypeOf:m=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):c;return o(r)}h(r,o,c){const m=y.OVERRIDE_PROPERTY_REGEX.test(r)?4:this.d.get(r),n=c?`[${c.value}] `:"";if(m===4){typeof o?.resource>"u"&&this.f.warn(`${n}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${r}', provide the URI of a resource or 'null' for any resource.`);return}if(m===3){o?.resource&&this.f.warn(`${n}Accessing a window scoped configuration for a resource is not expected. To associate '${r}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(r,o){const c=new A.ConfigurationChangeEvent(r,o,this.e,this.c.workspace);return Object.freeze({affectsConfiguration:(m,n)=>c.affectsConfiguration(m,C(n))})}k(r){return r.reduce((o,c)=>(o.set(c[0],c[1]),o),new Map)}}e.ExtHostConfigProvider=i,e.IExtHostConfiguration=(0,P.createDecorator)("IExtHostConfiguration")});var _e=this&&this.__classPrivateFieldSet||function(re,e,a,L,l){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!l:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?l.call(re,a):l?l.value=a:e.set(re,a),a},Ue=this&&this.__classPrivateFieldGet||function(re,e,a,L){if(a==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!L:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?L:a==="a"?L.call(re):L?L.value:e.get(re)};define(ye[83],De([1,0,2,17,3,5,7,34,60,35,21,41,18,25,4,16,12,13,78,247,11]),function(re,e,a,L,l,R,S,A,y,I,O,P,v,k,D,f,u,h,p,b,C){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var i;(function(Q){function x(T){if(T!=null)return T}Q.from=x;function U(T){if(T!=null)return T}Q.to=U})(i||(i={}));var s;(function(Q){function x(T){if(T!=null)return T}Q.from=x;function U(T){if(T!=null)return T}Q.to=U})(s||(s={}));var r;(function(Q){function x(T){if(T!=null)return T}Q.from=x;function U(T){if(T!=null)return T}Q.to=U})(r||(r={}));var o;(function(Q){function x(F){if(F){const B=F;return B&&!!B.process}else return!1}Q.is=x;function U(F){if(F==null)return;const B={process:F.process,args:F.args};return F.options&&(B.options=r.from(F.options)),B}Q.from=U;function T(F){if(F!=null)return new S.ProcessExecution(F.process,F.args,F.options)}Q.to=T})(o||(o={}));var c;(function(Q){function x(T){if(T!=null)return T}Q.from=x;function U(T){if(T!=null)return T}Q.to=U})(c||(c={}));var m;(function(Q){function x(F){if(F){const B=F;return B&&(!!B.commandLine||!!B.command)}else return!1}Q.is=x;function U(F){if(F==null)return;const B={};return F.commandLine!==void 0?B.commandLine=F.commandLine:(B.command=F.command,B.args=F.args),F.options&&(B.options=c.from(F.options)),B}Q.from=U;function T(F){if(!(F==null||F.command===void 0&&F.commandLine===void 0))return F.commandLine?new S.ShellExecution(F.commandLine,F.options):new S.ShellExecution(F.command,F.args?F.args:[],F.options)}Q.to=T})(m||(m={}));var n;(function(Q){function x(F){if(F){const B=F;return B&&B.customExecution==="customExecution"}else return!1}Q.is=x;function U(F){return{customExecution:"customExecution"}}Q.from=U;function T(F,B){return B.get(F)}Q.to=T})(n=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var t;(function(Q){function x(U,T){let F;return U.scope!==void 0&&typeof U.scope!="number"?F=U.scope.uri:U.scope!==void 0&&typeof U.scope=="number"&&(U.scope===S.TaskScope.Workspace&&T&&T.workspaceFile?F=T.workspaceFile:F=b.USER_TASKS_GROUP_KEY),{id:U._id,workspaceFolder:F}}Q.from=x})(t=e.TaskHandleDTO||(e.TaskHandleDTO={}));var d;(function(Q){function x(U){if(U!=null)return{_id:U.id,isDefault:U.isDefault}}Q.from=x})(d||(d={}));var E;(function(Q){function x(F,B){if(F==null)return[];const Z=[];for(const _ of F){const H=U(_,B);H&&Z.push(H)}return Z}Q.fromMany=x;function U(F,B){if(F==null)return;let Z;F.execution instanceof S.ProcessExecution?Z=o.from(F.execution):F.execution instanceof S.ShellExecution?Z=m.from(F.execution):F.execution&&F.execution instanceof S.CustomExecution&&(Z=n.from(F.execution));const _=i.from(F.definition);let H;return F.scope?typeof F.scope=="number"?H=F.scope:H=F.scope.uri:H=S.TaskScope.Workspace,!_||!H?void 0:{_id:F._id,definition:_,name:F.name,source:{extensionId:B.identifier.value,label:F.source,scope:H},execution:Z,isBackground:F.isBackground,group:d.from(F.group),presentationOptions:s.from(F.presentationOptions),problemMatchers:F.problemMatchers,hasDefinedMatchers:F.hasDefinedMatchers,runOptions:F.runOptions?F.runOptions:{reevaluateOnRerun:!0},detail:F.detail}}Q.from=U;async function T(F,B,Z){if(F==null)return;let _;o.is(F.execution)?_=o.to(F.execution):m.is(F.execution)?_=m.to(F.execution):n.is(F.execution)&&(_=n.to(F._id,Z));const H=i.to(F.definition);let Y;if(F.source&&(F.source.scope!==void 0?typeof F.source.scope=="number"?Y=F.source.scope:Y=await B.resolveWorkspaceFolder(a.URI.revive(F.source.scope)):Y=S.TaskScope.Workspace),!H||!Y)return;const ie=new S.Task(H,Y,F.name,F.source.label,_,F.problemMatchers);return F.isBackground!==void 0&&(ie.isBackground=F.isBackground),F.group!==void 0&&(ie.group=S.TaskGroup.from(F.group._id),ie.group&&F.group.isDefault&&(ie.group=new S.TaskGroup(ie.group.id,ie.group.label),F.group.isDefault===!0&&(ie.group.isDefault=F.group.isDefault))),F.presentationOptions&&(ie.presentationOptions=s.to(F.presentationOptions)),F._id&&(ie._id=F._id),F.detail&&(ie.detail=F.detail),ie}Q.to=T})(E=e.TaskDTO||(e.TaskDTO={}));var w;(function(Q){function x(T){return T}Q.from=x;function U(T){if(!!T)return Object.assign(Object.create(null),T)}Q.to=U})(w||(w={}));class N{constructor(x,U,T){this._id=U,this.a=T,g.set(this,void 0),_e(this,g,x,"f")}get task(){return this.a}terminate(){Ue(this,g,"f").terminateTask(this)}fireDidStartProcess(x){}fireDidEndProcess(x){}}g=new WeakMap;let j=class{constructor(x,U,T,F,B,Z,_,H){this.q=new l.Emitter,this.r=new l.Emitter,this.s=new l.Emitter,this.t=new l.Emitter,this.a=x.getProxy(R.MainContext.MainThreadTask),this.b=T,this.c=F,this.d=B,this.e=Z,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=_,this.g=H,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(x,U,T){if(!T)return new S.Disposable(()=>{});const F=this.w();return this.j.set(F,{type:U,provider:T,extension:x}),this.a.$registerTaskProvider(F,U),new S.Disposable(()=>{this.j.delete(F),this.a.$unregisterTaskProvider(F)})}registerTaskSystem(x,U){this.a.$registerTaskSystem(x,U)}fetchTasks(x){return this.a.$fetchTasks(w.from(x)).then(async U=>{const T=[];for(const F of U){const B=await E.to(F,this.b,this.m);B&&T.push(B)}return T})}get taskExecutions(){const x=[];return this.k.forEach(U=>x.push(U)),x}terminateTask(x){if(!(x instanceof N))throw new Error("No valid task execution provided");return this.a.$terminateTask(x._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(x,U,T){const F=this.m.get(x.id);F&&(this.o.set(x.id,F),this.e.attachPtyToTerminal(U,await F.callback(T))),this.p=x.id,this.q.fire({execution:await this.y(x)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(x){const U=await this.y(x);this.l.delete(x.id),this.k.delete(x.id),this.A(x),this.r.fire({execution:U})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(x){const U=await this.y(x.id);this.s.fire({execution:U,processId:x.processId})}get onDidEndTaskProcess(){return this.t.event}async $onDidEndTaskProcess(x){const U=await this.y(x.id);this.t.fire({execution:U,exitCode:x.exitCode})}$provideTasks(x,U){const T=this.j.get(x);if(!T)return Promise.reject(new Error("no handler found"));const F=[],B=(0,L.asPromise)(()=>T.provider.provideTasks(O.CancellationToken.None)).then(Z=>this.u(U,F,T,Z));return new Promise(Z=>{B.then(_=>{Promise.all(F).then(()=>{Z(_)})})})}async $resolveTask(x,U){const T=this.j.get(x);if(!T)return Promise.reject(new Error("no handler found"));if(U.definition.type!==T.type)throw new Error(`Unexpected: Task of type [${U.definition.type}] cannot be resolved by provider of type [${T.type}].`);const F=await E.to(U,this.b,this.m);if(!F)throw new Error("Unexpected: Task cannot be resolved.");const B=await T.provider.resolveTask(F,O.CancellationToken.None);if(!B)return;this.z(B,T);const Z=E.from(B,T.extension);if(!Z)throw new Error("Unexpected: Task cannot be resolved.");if(B.definition!==F.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return n.is(Z.execution)&&await this.x(Z,B,!0),await this.v(Z)}w(){return this.h++}async x(x,U,T){const F=await this.a.$createTaskId(x);!T&&!this.m.has(F)&&(this.n.add(F),this.o.set(F,U.execution)),this.m.set(F,U.execution)}async y(x,U){if(typeof x=="string"){const B=this.l.get(x);if(!B)throw new C.ErrorNoTelemetry("Unexpected: The specified task is missing an execution");return B}const T=this.l.get(x.id);if(T)return T;const F=new Promise((B,Z)=>{function _(H,Y,ie){ie?B(new N(H,Y.id,ie)):Z("Unexpected: Task does not exist.")}U?_(this,x,U):E.to(x.task,this.b,this.m).then(H=>_(this,x,H))});return this.l.set(x.id,F),F.then(B=>(this.k.set(x.id,B),B),B=>Promise.reject(B))}z(x,U){x._deprecated&&this.g.report("Task.constructor",U.extension,"Use the Task constructor that takes a `scope` instead.")}A(x){this.o.get(x.id)&&this.o.delete(x.id),this.n.has(x.id)&&this.p!==x.id&&(this.m.delete(x.id),this.n.delete(x.id));const T=this.n.values();let F=T.next();for(;!F.done;)!this.o.has(F.value)&&this.p!==F.value&&(this.m.delete(F.value),this.n.delete(F.value)),F=T.next()}};j=qe([ze(0,v.IExtHostRpcService),ze(1,k.IExtHostInitDataService),ze(2,A.IExtHostWorkspace),ze(3,y.IExtHostDocumentsAndEditors),ze(4,I.IExtHostConfiguration),ze(5,P.IExtHostTerminalService),ze(6,h.ILogService),ze(7,p.IExtHostApiDeprecationService)],j),e.ExtHostTaskBase=j;let V=class extends j{constructor(x,U,T,F,B,Z,_,H){super(x,U,T,F,B,Z,_,H),this.registerTaskSystem(f.Schemas.vscodeRemote,{scheme:f.Schemas.vscodeRemote,authority:"",platform:u.PlatformToString(0)})}async executeTask(x,U){if(!U.execution)throw new Error("Tasks to execute must include an execution");const T=E.from(U,x);if(T===void 0)throw new Error("Task is not valid");if(n.is(T.execution))await this.x(T,U,!1);else throw new C.NotSupportedError;const F=await this.y(await this.a.$getTaskExecution(T),U);return this.a.$executeTask(T).catch(B=>{throw new Error(B)}),F}u(x,U,T,F){const B=[];if(F)for(const Z of F){this.z(Z,T),(!Z.definition||!x[Z.definition.type])&&this.f.warn(`The task [${Z.source}, ${Z.name}] uses an undefined task type. The task will be ignored in the future.`);const _=E.from(Z,T.extension);_&&n.is(_.execution)?(B.push(_),U.push(this.x(_,Z,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:B,extension:T.extension}}async v(x){if(n.is(x.execution))return x;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(x,U){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(x,U,T){}};V=qe([ze(0,v.IExtHostRpcService),ze(1,k.IExtHostInitDataService),ze(2,A.IExtHostWorkspace),ze(3,y.IExtHostDocumentsAndEditors),ze(4,I.IExtHostConfiguration),ze(5,P.IExtHostTerminalService),ze(6,h.ILogService),ze(7,p.IExtHostApiDeprecationService)],V),e.WorkerExtHostTask=V,e.IExtHostTask=(0,D.createDecorator)("IExtHostTask")}),define(ye[294],De([1,0,9,21,45,38,24,43,31]),function(re,e,a,L,l,R,S,A,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class I{constructor(v,k,D){this.k=v,this.l=k,this.o=D,this.e=!1,this.f=0,this.g=!1,this.a=v.filePattern,this.b=v.includePattern&&R.parse(v.includePattern),this.c=v.maxResults||void 0,this.d=v.exists,this.h=new Set,this.j=v.excludePattern&&R.parse(v.excludePattern)}cancel(){this.g=!0,this.h.forEach(v=>v.cancel()),this.h=new Set}search(v){const k=this.k.folderQueries||[];return new Promise((D,f)=>{const u=h=>{this.f++,v(h)};if(this.g)return D({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(h=>{const p=h.toString(),b=a.basename(p);this.j&&this.j(p,b)||this.v(u,{base:h,basename:b})}),Promise.all(k.map(h=>this.p(h,u))).then(h=>{D({limitHit:this.e,stats:h[0]||void 0})},h=>{f(new Error((0,l.toErrorMessage)(h)))})})}async p(v,k){const D=new L.CancellationTokenSource,f=this.q(v),u=this.r(),h=new y.QueryGlobTester(this.k,v),p=!h.hasSiblingExcludeClauses();let b;try{this.h.add(D),b=A.StopWatch.create();const C=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},f,D.token),g=b.elapsed(),i=A.StopWatch.create();return this.g&&!this.e||(C&&C.forEach(s=>{const r=a.posix.relative(v.folder.path,s.path);if(p){const o=a.basename(s.path);this.v(k,{base:v.folder,relativePath:r,basename:o});return}this.s(u,v.folder,r,k)}),this.g&&!this.e)?null:(this.u(u,h,k),{providerTime:g,postProcessTime:i.elapsed()})}finally{D.dispose(),this.h.delete(D)}}q(v){const k=(0,y.resolvePatternsForProvider)(this.k.includePattern,v.includePattern),D=(0,y.resolvePatternsForProvider)(this.k.excludePattern,v.excludePattern);return{folder:v.folder,excludes:D,includes:k,useIgnoreFiles:!v.disregardIgnoreFiles,useGlobalIgnoreFiles:!v.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!v.disregardParentIgnoreFiles,followSymlinks:!v.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const v={rootEntries:[],pathToEntries:Object.create(null)};return v.pathToEntries["."]=v.rootEntries,v}s({pathToEntries:v},k,D,f){if(D===this.a){const h=a.basename(this.a);this.v(f,{base:k,relativePath:this.a,basename:h})}function u(h){const p=a.basename(h),b=a.dirname(h);let C=v[b];C||(C=v[b]=[],u(b)),C.push({base:k,relativePath:h,basename:p})}u(D)}u({rootEntries:v,pathToEntries:k},D,f){const u=this,h=this.a;function p(b){const C=(0,y.hasSiblingFn)(()=>b.map(g=>g.basename));for(let g=0,i=b.length;g<i;g++){const s=b[g],{relativePath:r,basename:o}=s;if(D.matchesExcludesSync(r,o,h!==o?C:void 0))continue;const c=k[r];if(c)p(c);else{if(r===h)continue;u.v(f,s)}if(u.e)break}}p(v)}v(v,k){(!this.b||k.relativePath&&this.b(k.relativePath,k.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||v(k))}}class O{constructor(){this.b=new Map}fileSearch(v,k,D,f){const u=this.c(v.cacheKey),h=new I(v,k,u&&u.token);let p=0;const b=C=>{p+=C.length,D(C.map(g=>this.d(g)))};return this.e(h,O.a,b,f).then(C=>({limitHit:C.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:p,detailStats:C.stats}}))}clearCache(v){this.c(v)?.cancel()}c(v){if(!!v)return this.b.has(v)||this.b.set(v,new L.CancellationTokenSource),this.b.get(v)}d(v){return v.relativePath?{resource:S.joinPath(v.base,v.relativePath)}:{resource:v.base}}e(v,k,D,f){f.onCancellationRequested(()=>{v.cancel()});const u=p=>{p&&(h.push(p),k>0&&h.length>=k&&(D(h),h=[]))};let h=[];return v.search(u).then(p=>(h.length&&D(h),p),p=>(h.length&&D(h),Promise.reject(p)))}}O.a=512,e.FileSearchManager=O}),define(ye[295],De([1,0,15,62,38,110,28,16,9,24,8,10,2,160,195,54,13,47,133,293,31]),function(re,e,a,L,l,R,S,A,y,I,O,P,v,k,D,f,u,h,p,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let g=class{constructor(E,w,N,j,V){this.a=E,this.b=w,this.c=N,this.d=j,this.e=V}text(E,w,N={}){E=this.f(E,N);const j=this.a.getValue(),V=w&&w.some(x=>!this.a.getValue({resource:x}).search.useRipgrep);return{...this.h(w?.map(h.toWorkspaceFolder),N),type:2,contentPattern:E,previewOptions:N.previewOptions,maxFileSize:N.maxFileSize,usePCRE2:j.search.usePCRE2||V||!1,beforeContext:N.beforeContext,afterContext:N.afterContext,userDisabledExcludesAndIgnoreFiles:N.disregardExcludeSettings&&N.disregardIgnoreFiles}}f(E,w){const N=this.a.getValue();E.isRegExp&&(E.pattern=E.pattern.replace(/\r?\n/g,"\\n"));const j={...E,wordSeparators:N.editor.wordSeparators};return this.j(E,w)&&(j.isCaseSensitive=!0),this.k(E)&&(j.isMultiline=!0),j}file(E,w={}){return{...this.h(E,w),type:1,filePattern:w.filePattern?w.filePattern.trim():w.filePattern,exists:w.exists,sortByScore:w.sortByScore,cacheKey:w.cacheKey}}g(E,w){return E?(E=Array.isArray(E)?E.map(c):c(E),w?this.parseSearchPaths(E):{pattern:s(...Array.isArray(E)?E:[E])}):{}}h(E=[],w={}){const N=this.g(w.includePattern,w.expandPatterns),j=this.g(w.excludePattern,w.expandPatterns),V=E.length>1,Q=(N.searchPaths&&N.searchPaths.length?N.searchPaths.map(T=>this.q(T,w,j)):E.map(T=>this.r(T,w,j,V))).filter(T=>!!T),x={_reason:w._reason,folderQueries:Q,usingSearchPaths:!!(N.searchPaths&&N.searchPaths.length),extraFileResources:w.extraFileResources,excludePattern:j.pattern,includePattern:N.pattern,onlyOpenEditors:w.onlyOpenEditors,maxResults:w.maxResults};if(w.onlyOpenEditors){const T=a.coalesce(a.flatten(this.c.groups.map(Z=>Z.editors.map(_=>_.resource))));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(T));const F=T.filter(Z=>(0,C.pathIncludedInQuery)(x,Z.fsPath)),B=this.i(F);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(B)),{...x,...B}}const U=w.extraFileResources&&w.extraFileResources.filter(T=>(0,C.pathIncludedInQuery)(x,T.fsPath));return x.extraFileResources=U&&U.length?U:void 0,x}i(E){const w=[],N=new S.ResourceMap,j={};let V=!1;return E.forEach(Q=>{if(Q.scheme===A.Schemas.walkThrough)return;if((0,I.isAbsolutePath)(Q)){const U=this.b.getWorkspaceFolder(Q)?.uri??Q.with({path:y.dirname(Q.fsPath)});let T=N.get(U);T||(V=!0,T={folder:U,includePattern:{}},w.push(T),N.set(U,T));const F=y.relative(U.fsPath,Q.fsPath);(0,P.assertIsDefined)(T.includePattern)[F.replace(/\\/g,"/")]=!0}else Q.fsPath&&(V=!0,j[Q.fsPath]=!0)}),{folderQueries:w,includePattern:j,usingSearchPaths:!0,excludePattern:V?void 0:{"**/*":!0}}}j(E,w){if(w.isSmartCase){if(E.isRegExp){if(O.containsUppercaseCharacter(E.pattern,!0))return!0}else if(O.containsUppercaseCharacter(E.pattern))return!0}return!!E.isCaseSensitive}k(E){return E.isMultiline||E.isRegExp&&(0,k.isMultilineRegexSource)(E.pattern)||E.pattern.indexOf(`
`)>=0?!0:!!E.isMultiline}parseSearchPaths(E){const w=B=>y.isAbsolute(B)||/^\.\.?([\/\\]|$)/.test(B),j=(Array.isArray(E)?E:r(E)).map(B=>{const Z=this.e.resolvedUserHome;return Z?(0,R.untildify)(B,Z.scheme===A.Schemas.file?Z.fsPath:Z.path):B}),V=L.groupBy(j,B=>w(B)?"searchPaths":"exprSegments"),Q=(V.exprSegments||[]).map(B=>O.rtrim(B,"/")).map(B=>O.rtrim(B,"\\")).map(B=>(B[0]==="."&&(B="*"+B),o(B))),x={},U=this.m(V.searchPaths||[]);U&&U.length&&(x.searchPaths=U);const T=a.flatten(Q),F=s(...T);return F&&(x.pattern=F),x}l(E,w){return w.disregardExcludeSettings?void 0:(0,C.getExcludes)(E,!w.disregardSearchExcludeSettings)}m(E){if(!E||!E.length)return[];const w=E.flatMap(j=>{let{pathPortion:V,globPortion:Q}=i(j);return Q&&(Q=m(Q)),this.n(V).flatMap(U=>this.o(U,Q))}),N=new Map;return w.forEach(j=>{const V=j.searchPath.toString(),Q=N.get(V);Q?j.pattern&&(Q.pattern=Q.pattern||{},Q.pattern[j.pattern]=!0):N.set(V,{searchPath:j.searchPath,pattern:j.pattern?s(j.pattern):void 0})}),Array.from(N.values())}n(E){if(y.isAbsolute(E)){const w=this.b.getWorkspace().folders;return w[0]&&w[0].uri.scheme!==A.Schemas.file?[{searchPath:w[0].uri.with({path:E})}]:[{searchPath:v.URI.file(y.normalize(E))}]}if(this.b.getWorkbenchState()===2){const w=this.b.getWorkspace().folders[0].uri;if(E=c(E),E.startsWith("../")||E===".."){const j=y.posix.resolve(w.path,E);return[{searchPath:w.with({path:j})}]}const N=m(E);return[{searchPath:w,pattern:N}]}else{if(E==="./"||E===".\\")return[];{const w=E.replace(/^\.[\/\\]/,""),j=this.b.getWorkspace().folders.map(V=>{const Q=w.match(new RegExp(`^${O.escapeRegExpCharacters(V.name)}(?:/(.*)|$)`));return Q?{match:Q,folder:V}:null}).filter(P.isDefined);if(j.length)return j.map(V=>{const Q=V.match[1];return{searchPath:V.folder.uri,pattern:Q&&m(Q)}});{const V=E.match(/\.[\/\\](.+)[\/\\]?/),Q=V?V[1]:E,x=D.localize(0,null,Q);throw new Error(x)}}}}o(E,w){const N=E.pattern&&w?`${E.pattern}/${w}`:E.pattern||w,j=[{searchPath:E.searchPath,pattern:N}];return N&&!N.endsWith("**")&&j.push({searchPath:E.searchPath,pattern:N+"/**"}),j}q(E,w,N){const j=this.r((0,h.toWorkspaceFolder)(E.searchPath),w,N,!1);return j?{...j,includePattern:E.pattern}:null}r(E,w,N,j){let V;const Q=v.URI.isUri(E)?E:E.uri;if(N.searchPaths){const B=N.searchPaths.filter(Z=>(0,I.isEqual)(Z.searchPath,Q))[0];if(B&&!B.pattern)return null;B&&(V=B.pattern)}const x=this.a.getValue({resource:Q}),T={...this.l(x,w)||{},...V||{}},F=v.URI.isUri(E)?(0,I.basename)(E):E.name;return{folder:Q,folderName:j?F:void 0,excludePattern:Object.keys(T).length>0?T:void 0,fileEncoding:x.files&&x.files.encoding,disregardIgnoreFiles:typeof w.disregardIgnoreFiles=="boolean"?w.disregardIgnoreFiles:!x.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof w.disregardGlobalIgnoreFiles=="boolean"?w.disregardGlobalIgnoreFiles:!x.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof w.disregardParentIgnoreFiles=="boolean"?w.disregardParentIgnoreFiles:!x.search.useParentIgnoreFiles,ignoreSymlinks:typeof w.ignoreSymlinks=="boolean"?w.ignoreSymlinks:!x.search.followSymlinks}}};g=qe([ze(0,f.IConfigurationService),ze(1,h.IWorkspaceContextService),ze(2,p.IEditorGroupsService),ze(3,u.ILogService),ze(4,b.IPathService)],g),e.QueryBuilder=g;function i(d){const E=d.match(/[\*\{\}\(\)\[\]\?]/);if(E){const w=E.index,N=d.substr(0,w).match(/[/|\\][^/\\]*$/);if(N){let j=d.substr(0,N.index);return j.match(/[/\\]/)||(j+="/"),{pathPortion:j,globPortion:d.substr((N.index||0)+1)}}}return{pathPortion:d}}function s(...d){return d.length?d.reduce((E,w)=>(E[w]=!0,E),Object.create(null)):void 0}function r(d){return l.splitGlobAware(d,",").map(E=>E.trim()).filter(E=>!!E.length)}function o(d){return[`**/${d}/**`,`**/${d}`].map(w=>w.replace(/\*\*\/\*\*/g,"**"))}function c(d){return d.replace(/\\/g,"/")}function m(d){return c(d).replace(/^\.\//,"").replace(/\/+$/g,"")}function n(d){return d.replace(/([?*[\]])/g,"[$1]")}function t(d,E){d=a.distinct(d,j=>j.toString());const w=[],N=E.getWorkspace();return d&&d.forEach(j=>{let V;if(E.getWorkbenchState()===2)V=(0,I.relativePath)(N.folders[0].uri,j),V&&V!=="."&&(V="./"+V);else{const Q=E.getWorkspaceFolder(j);if(Q){const x=Q.name;if(N.folders.filter(T=>T.name===x).length===1){const T=(0,I.relativePath)(Q.uri,j);T===""?V=`./${Q.name}`:V=`./${Q.name}/${T}`}else V=j.fsPath}}V&&w.push(n(V))}),w}e.resolveResourcesForSearchIncludes=t}),define(ye[296],De([1,0,24,2,21,11,4,295,31,47]),function(re,e,a,L,l,R,S,A,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const O=7e3;function P(f,u){const h=u.activationEvents;if(!h)return Promise.resolve(void 0);const p=[],b=[];for(const o of h)if(/^workspaceContains:/.test(o)){const c=o.substr(18);c.indexOf("*")>=0||c.indexOf("?")>=0||f.forceUsingSearch?b.push(c):p.push(c)}if(p.length===0&&b.length===0)return Promise.resolve(void 0);let C;const g=new Promise((o,c)=>{C=o}),i=o=>C({activationEvent:o}),s=Promise.all(p.map(o=>v(f,o,i))).then(()=>{}),r=k(f,u.identifier,b,i);return Promise.all([s,r]).then(()=>{C(void 0)}),g}e.checkActivateWorkspaceContainsExtension=P;async function v(f,u,h){for(const p of f.folders)if(await f.exists(a.joinPath(L.URI.revive(p),u))){h(`workspaceContains:${u}`);return}}async function k(f,u,h,p){if(h.length===0)return Promise.resolve(void 0);const b=new l.CancellationTokenSource,C=f.checkExists(f.folders,h,b.token),g=setTimeout(async()=>{b.cancel(),f.logService.info(`Not activating extension '${u.value}': Timed out while searching for 'workspaceContains' pattern ${h.join(",")}`)},O);let i=!1;try{i=await C}catch(s){R.isCancellationError(s)||R.onUnexpectedError(s)}b.dispose(),clearTimeout(g),i&&p(`workspaceContains:${h.join(",")}`)}function D(f,u,h,p){const b=f.get(S.IInstantiationService),C=f.get(y.ISearchService),i=b.createInstance(A.QueryBuilder).file(u.map(s=>(0,I.toWorkspaceFolder)(L.URI.revive(s))),{_reason:"checkExists",includePattern:h,exists:!0});return C.fileSearch(i,p).then(s=>!!s.limitHit,s=>R.isCancellationError(s)?!1:Promise.reject(s))}e.checkGlobFileExists=D});var _e=this&&this.__classPrivateFieldSet||function(re,e,a,L,l){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!l)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!l:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?l.call(re,a):l?l.value=a:e.set(re,a),a},Ue=this&&this.__classPrivateFieldGet||function(re,e,a,L){if(a==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!L:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return a==="m"?L:a==="a"?L.call(re):L?L.value:e.get(re)};define(ye[42],De([1,0,177,9,84,24,17,6,68,2,13,5,35,238,99,34,26,134,11,27,22,220,7,128,4,25,80,18,91,56,41,3,296,98,222,16,97,43,12]),function(re,e,a,L,l,R,S,A,y,I,O,P,v,k,D,f,u,h,p,b,C,g,i,s,r,o,c,m,n,t,d,E,w,N,j,V,Q,x,U){"use strict";var T,F,B;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,r.createDecorator)("IHostUtils");let Z=class Ui extends A.Disposable{constructor(X,J,ee,me,ve,Ie,Re,ae,le,ue,ne){super(),this.a=this.B(new E.Emitter),this.onDidChangeRemoteConnectionData=this.a.event,this.O=!1,this.c=J,this.g=ee,this.f=Re,this.j=me,this.k=ve,this.l=Ie,this.m=le,this.p=ue,this.s=ne,this.t=this.g.getProxy(P.MainContext.MainThreadWorkspace),this.u=this.g.getProxy(P.MainContext.MainThreadTelemetry),this.v=this.g.getProxy(P.MainContext.MainThreadExtensionService),this.w=new S.Barrier,this.y=new S.Barrier,this.z=new S.Barrier,this.C=new S.Barrier,this.F=new h.ExtensionDescriptionRegistry(this.f.allExtensions);const ce=(0,u.extensionIdentifiersArrayToSet)(this.f.myExtensions);this.D=new h.ExtensionDescriptionRegistry(Y(this.F,ce)),this.G=new D.ExtHostStorage(this.g,this.l),this.H=new N.ExtHostSecretState(this.g),this.I=ae,this.h=X.createChild(new n.ServiceCollection([D.IExtHostStorage,this.G],[N.IExtHostSecretState,this.H])),this.J=this.B(new k.ExtensionsActivator(this.D,this.F,{onExtensionActivationError:(oe,M,z)=>{this.v.$onExtensionActivationError(oe,p.transformErrorForSerialization(M),z)},actualActivateExtension:async(oe,M)=>{if(h.ExtensionDescriptionRegistry.isHostExtension(oe,this.D,this.F))return await this.v.$activateExtension(oe,M),new k.HostExtension;const z=this.D.getExtensionDescription(oe);return this.Y(z,M)}},this.l)),this.L=null,this.M=Object.create(null),this.N=!1,this.P=this.f.remote.connectionData}getRemoteConnectionData(){return this.P}async initialize(){try{await this.ob(),this.w.open(),await this.j.waitForInitializeCall(),l.mark("code/extHost/ready"),this.y.open(),this.f.autoStart&&this.lb()}catch(X){p.onUnexpectedError(X)}}async Q(){this.I.onWillDeactivateAll();let X=[];try{X=this.D.getAllExtensionDescriptions().map(ve=>ve.identifier).filter(ve=>this.isActivated(ve)).map(ve=>this.X(ve))}catch{}await Promise.all(X)}terminate(X,J=0){if(this.O)return;this.O=!0,this.l.info(`Extension host terminating: ${X}`),this.l.flush(),this.p.dispose(),this.J.dispose(),p.setUnexpectedErrorHandler(me=>{this.l.error(me)}),this.g.dispose();const ee=this.Q();Promise.race([(0,S.timeout)(5e3),ee]).finally(()=>{this.c.pid?this.l.info(`Extension host with pid ${this.c.pid} exiting with code ${J}`):this.l.info(`Extension host exiting with code ${J}`),this.l.flush(),this.l.dispose(),this.c.exit(J)})}isActivated(X){return this.z.isOpen()?this.J.isActivated(X):!1}async getExtension(X){const J=await this.v.$getExtension(X);let ee;if(J?.browserNlsBundleUris){ee={};for(const me of Object.keys(J.browserNlsBundleUris))ee[me]=I.URI.revive(J.browserNlsBundleUris[me])}return J&&{...J,identifier:new b.ExtensionIdentifier(J.identifier.value),extensionLocation:I.URI.revive(J.extensionLocation),browserNlsBundleUris:ee}}R(X,J){return this.J.activateByEvent(X,J)}S(X,J){return this.J.activateById(X,J)}activateByIdWithErrors(X,J){return this.S(X,J).then(()=>{const ee=this.J.getActivatedExtension(X);if(ee.activationFailed)return Promise.reject(ee.activationFailedError)})}getExtensionRegistry(){return this.z.wait().then(X=>this.D)}getExtensionExports(X){return this.z.isOpen()?this.J.getActivatedExtension(X).exports:null}async U(X){if(X.scheme!==V.Schemas.file)return X;const J=await this.c.realpath(X.fsPath);return I.URI.file(J)}async getExtensionPathIndex(){return this.L||(this.L=this.W(this.D.getAllExtensionDescriptions()).then(X=>new ie(X))),this.L}async W(X){const J=y.TernarySearchTree.forUris(ee=>R.extUriBiasedIgnorePathCase.ignorePathCasing(ee));return await Promise.all(X.map(async ee=>{if(this.pb(ee)){const me=await this.U(ee.extensionLocation);J.set(me,ee)}})),J}X(X){let J=Promise.resolve(void 0);if(!this.z.isOpen()||!this.J.isActivated(X))return J;const ee=this.J.getActivatedExtension(X);if(!ee)return J;try{typeof ee.module.deactivate=="function"&&(J=Promise.resolve(ee.module.deactivate()).then(void 0,me=>(this.l.error(me),Promise.resolve(void 0))))}catch(me){this.l.error(`An error occurred when deactivating the extension '${X.value}':`),this.l.error(me)}try{(0,A.dispose)(ee.subscriptions)}catch(me){this.l.error(`An error occurred when deactivating the subscriptions for extension '${X.value}':`),this.l.error(me)}return J}async Y(X,J){return this.f.remote.isRemote?this.v.$onWillActivateExtension(X.identifier):await this.v.$onWillActivateExtension(X.identifier),this.ab(X,J).then(ee=>{const me=ee.activationTimes;return this.v.$onDidActivateExtension(X.identifier,me.codeLoadingTime,me.activateCallTime,me.activateResolvedTime,J),this.Z(X,J,"success",me),ee},ee=>{throw this.Z(X,J,"failure"),ee})}Z(X,J,ee,me){const ve=_(X,J);this.u.$publicLog2("extensionActivationTimes",{...ve,...me||{},outcome:ee})}ab(X,J){const ee=_(X,J);this.u.$publicLog2("activatePlugin",ee);const me=this.pb(X);if(!me)return Promise.resolve(new k.EmptyExtension(k.ExtensionActivationTimes.NONE));this.l.info(`ExtensionService#_doActivateExtension ${X.identifier.value}, startup: ${J.startup}, activationEvent: '${J.activationEvent}'${X.identifier.value!==J.extensionId.value?`, root cause: ${J.extensionId.value}`:""}`),this.l.flush();const ve=new k.ExtensionActivationTimesBuilder(J.startup);return Promise.all([this.qb(X,(0,R.joinPath)(X.extensionLocation,me),ve),this.bb(X)]).then(Ie=>(l.mark(`code/extHost/willActivateExtension/${X.identifier.value}`),Ui.cb(this.l,X.identifier,Ie[0],Ie[1],ve))).then(Ie=>(l.mark(`code/extHost/didActivateExtension/${X.identifier.value}`),Ie))}bb(X){const J=new g.ExtensionGlobalMemento(X,this.G),ee=new g.ExtensionMemento(X.identifier.value,!1,this.G),me=new j.ExtensionSecrets(X,this.H),ve=X.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,Ie=this.f.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this.l.trace(`ExtensionService#loadExtensionContext ${X.identifier.value}`),Promise.all([J.whenReady,ee.whenReady,this.I.whenReady]).then(()=>{const Re=this;let ae,le;const ue=(0,u.isProposedApiEnabled)(X,"ipc")?this.f.messagePorts?.get(b.ExtensionIdentifier.toKey(X.identifier)):void 0;return Object.freeze({globalState:J,workspaceState:ee,secrets:me,subscriptions:[],get extensionUri(){return X.extensionLocation},get extensionPath(){return X.extensionLocation.fsPath},asAbsolutePath(ne){return L.join(X.extensionLocation.fsPath,ne)},get storagePath(){return Re.I.workspaceValue(X)?.fsPath},get globalStoragePath(){return Re.I.globalValue(X).fsPath},get logPath(){return L.join(Re.f.logsLocation.fsPath,X.identifier.value)},get logUri(){return I.URI.joinPath(Re.f.logsLocation,X.identifier.value)},get storageUri(){return Re.I.workspaceValue(X)},get globalStorageUri(){return Re.I.globalValue(X)},get extensionMode(){return ve},get extension(){return ae===void 0&&(ae=new H(Re,X.identifier,X,Ie,!1)),ae},get extensionRuntime(){return(0,u.checkProposedApiEnabled)(X,"extensionRuntime"),Re.extensionRuntime},get environmentVariableCollection(){return Re.p.getEnvironmentVariableCollection(X)},get messagePassingProtocol(){if(!le){if(!ue)return;const ne=E.Event.buffer(E.Event.fromDOMEventEmitter(ue,"message",ce=>ce.data));ue.start(),le={onDidReceiveMessage:ne,postMessage:ue.postMessage.bind(ue)}}return le}})})}static cb(X,J,ee,me,ve){return ee=ee||{activate:void 0,deactivate:void 0},this.db(X,J,ee,me,ve).then(Ie=>new k.ActivatedExtension(!1,null,ve.build(),ee,Ie,me.subscriptions))}static db(X,J,ee,me,ve){if(typeof ee.activate=="function")try{ve.activateCallStart(),X.trace(`ExtensionService#_callActivateOptional ${J.value}`);const Ie=typeof global=="object"?global:self,Re=ee.activate.apply(Ie,[me]);return ve.activateCallStop(),ve.activateResolveStart(),Promise.resolve(Re).then(ae=>(ve.activateResolveStop(),ae))}catch(Ie){return Promise.reject(Ie)}else return Promise.resolve(ee)}eb(X,J){this.S(X.identifier,{startup:!1,extensionId:X.identifier,activationEvent:J}).then(void 0,ee=>{this.l.error(ee)})}fb(X,J=0){const me=Date.now();(0,U.setTimeout0)(()=>{for(let ve=J;ve<X.length;ve+=1){const Ie=X[ve];for(const Re of Ie.activationEvents??[])if(Re==="onStartupFinished")if(Date.now()-me>50){this.fb(X,ve);break}else this.eb(Ie,Re)}})}gb(){this.v.$setPerformanceMarks(l.getMarks()),this.k.getConfigProvider().then(X=>{const J=X.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ee=this.D.getAllExtensionDescriptions();if(J)this.fb(ee);else for(const me of ee)if(me.activationEvents)for(const ve of me.activationEvents)ve==="onStartupFinished"&&this.eb(me,ve)})}hb(){const X=this.R("*",!0).then(void 0,ve=>{this.l.error(ve)});this.B(this.j.onDidChangeWorkspace(ve=>this.ib(ve.added)));const J=this.j.workspace?this.j.workspace.folders:[],ee=this.ib(J),me=Promise.all([X,ee]).then(()=>{});return Promise.race([me,(0,S.timeout)(1e4)]).then(()=>{this.gb()}),me}ib(X){return X.length===0?Promise.resolve(void 0):Promise.all(this.D.getAllExtensionDescriptions().map(J=>this.jb(X,J))).then(()=>{})}async jb(X,J){if(this.isActivated(J.identifier))return;const ee=!this.f.remote.isRemote&&!!this.f.remote.authority,me={logService:this.l,folders:X.map(Ie=>Ie.uri),forceUsingSearch:ee,exists:Ie=>this.c.exists(Ie.fsPath),checkExists:(Ie,Re,ae)=>this.t.$checkExists(Ie,Re,ae)},ve=await(0,w.checkActivateWorkspaceContainsExtension)(me,J);if(!!ve)return this.S(J.identifier,{startup:!0,extensionId:J.identifier,activationEvent:ve.activationEvent}).then(void 0,Ie=>this.l.error(Ie))}async $extensionTestsExecute(){await this.C.wait();try{return await this.kb()}catch(X){throw console.error(X),X}}async kb(){const{extensionDevelopmentLocationURI:X,extensionTestsLocationURI:J}=this.f.environment;if(!X||!J)throw new Error(a.localize(0,null));const ee=await this.qb(null,J,new k.ExtensionActivationTimesBuilder(!1));if(!ee||typeof ee.run!="function")throw new Error(a.localize(1,null,J.toString()));return new Promise((me,ve)=>{const Ie=(le,ue)=>{le?ve(le):me(typeof ue=="number"&&ue>0?1:0)},Re=(0,R.originalFSPath)(J),ae=ee.run(Re,Ie);ae&&ae.then&&ae.then(()=>{me(0)}).catch(le=>{ve(le instanceof Error&&le.stack?le.stack:String(le))})})}lb(){if(this.N)throw new Error("Extension host is already started!");return this.N=!0,this.y.wait().then(()=>this.z.open()).then(()=>this.hb()).then(()=>{this.C.open(),this.l.info("Eager extensions activated")})}registerRemoteAuthorityResolver(X,J){return this.M[X]=J,(0,A.toDisposable)(()=>{delete this.M[X]})}async mb(X){const J=X.indexOf("+");if(J===-1)throw new Error("Not an authority that can be resolved!");const ee=X.substr(0,J);return await this.w.wait(),await this.R(`onResolveRemoteAuthority:${ee}`,!1),{authorityPrefix:ee,resolver:this.M[ee]}}async $resolveAuthority(X,J){const ee=x.StopWatch.create(!1),me=()=>`[resolveAuthority(${(0,s.getRemoteAuthorityPrefix)(X)},${J})][${ee.elapsed()}ms] `,ve=ue=>this.l.info(`${me()}${ue}`),Ie=(ue,ne=void 0)=>this.l.error(`${me()}${ue}`,ne);ve("activating resolver...");const{authorityPrefix:Re,resolver:ae}=await this.mb(X);if(!ae)return Ie("no resolver"),{type:"error",error:{code:s.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${Re}.`,detail:void 0}};const le=new S.IntervalTimer;try{ve("setting tunnel factory..."),this.B(await this.m.setTunnelFactory(ae)),le.cancelAndSet(()=>ve("waiting..."),1e3),ve("invoking resolve()..."),l.mark(`code/extHost/willResolveAuthority/${Re}`);const ue=await ae.resolve(X,{resolveAttempt:J});l.mark(`code/extHost/didResolveAuthorityOK/${Re}`),le.dispose(),ve(`returned ${ue.host}:${ue.port}`);const ne={authority:X,host:ue.host,port:ue.port,connectionToken:ue.connectionToken},ce={extensionHostEnv:ue.extensionHostEnv,isTrusted:ue.isTrusted,authenticationSession:ue.authenticationSessionForInitializingExtensions?{id:ue.authenticationSessionForInitializingExtensions.id,providerId:ue.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:ne,options:ce,tunnelInformation:{environmentTunnels:ue.environmentTunnels,features:ue.tunnelFeatures}}}}catch(ue){if(l.mark(`code/extHost/didResolveAuthorityError/${Re}`),le.dispose(),Ie("returned an error",ue),ue instanceof i.RemoteAuthorityResolverError)return{type:"error",error:{code:ue._code,message:ue._message,detail:ue._detail}};throw ue}}async $getCanonicalURI(X,J){this.l.info(`$getCanonicalURI invoked for authority (${(0,s.getRemoteAuthorityPrefix)(X)})`);const{resolver:ee}=await this.mb(X);if(!ee)return null;const me=I.URI.revive(J);if(typeof ee.getCanonicalURI>"u")return me;const ve=await(0,S.asPromise)(()=>ee.getCanonicalURI(me));return ve||me}static nb(X,J,ee){const me=new h.ExtensionDescriptionRegistry(X.getAllExtensionDescriptions());me.deltaExtensions(ee.toAdd,ee.toRemove);const ve=(0,u.extensionIdentifiersArrayToSet)(J.getAllExtensionDescriptions().map(Re=>Re.identifier));for(const Re of ee.myToRemove)ve.delete(b.ExtensionIdentifier.toKey(Re));for(const Re of ee.myToAdd)ve.add(b.ExtensionIdentifier.toKey(Re));const Ie=Y(me,ve);return{globalRegistry:me,myExtensions:Ie}}$startExtensionHost(X){X.toAdd.forEach(me=>me.extensionLocation=I.URI.revive(me.extensionLocation));const{globalRegistry:J,myExtensions:ee}=Ui.nb(this.F,this.D,X);return this.F.set(J.getAllExtensionDescriptions()),this.D.set(ee),this.lb()}$activateByEvent(X,J){return J===1?this.R(X,!1):this.z.wait().then(ee=>this.R(X,!1))}async $activate(X,J){return await this.z.wait(),this.D.getExtensionDescription(X)?(await this.S(X,J),!0):!1}async $deltaExtensions(X){X.toAdd.forEach(Ie=>Ie.extensionLocation=I.URI.revive(Ie.extensionLocation));const{globalRegistry:J,myExtensions:ee}=Ui.nb(this.F,this.D,X),me=await this.W(ee);return(await this.getExtensionPathIndex()).setSearchTree(me),this.F.set(J.getAllExtensionDescriptions()),this.D.set(ee),Promise.resolve(void 0)}async $test_latency(X){return X}async $test_up(X){return X.byteLength}async $test_down(X){const J=C.VSBuffer.alloc(X),ee=Math.random()%256;for(let me=0;me<X;me++)J.writeUInt8(ee,me);return J}async $updateRemoteConnectionData(X){this.P=X,this.a.fire()}};Z=qe([ze(0,r.IInstantiationService),ze(1,e.IHostUtils),ze(2,m.IExtHostRpcService),ze(3,f.IExtHostWorkspace),ze(4,v.IExtHostConfiguration),ze(5,O.ILogService),ze(6,o.IExtHostInitDataService),ze(7,c.IExtensionStoragePaths),ze(8,t.IExtHostTunnelService),ze(9,d.IExtHostTerminalService),ze(10,Q.IExtHostLocalizationService)],Z),e.AbstractExtHostExtensionService=Z;function _(ge,X){return{id:ge.identifier.value,name:ge.name,extensionVersion:ge.version,publisherDisplayName:ge.publisher,activationEvents:ge.activationEvents?ge.activationEvents.join(","):null,isBuiltin:ge.isBuiltin,reason:X.activationEvent,reasonId:X.extensionId.value}}e.IExtHostExtensionService=(0,r.createDecorator)("IExtHostExtensionService");class H{constructor(X,J,ee,me,ve){T.set(this,void 0),F.set(this,void 0),B.set(this,void 0),_e(this,T,X,"f"),_e(this,F,J,"f"),_e(this,B,ee.identifier,"f"),this.id=ee.identifier.value,this.extensionUri=ee.extensionLocation,this.extensionPath=L.normalize((0,R.originalFSPath)(ee.extensionLocation)),this.packageJSON=ee,this.extensionKind=me,this.isFromDifferentExtensionHost=ve}get isActive(){return Ue(this,T,"f").isActivated(Ue(this,B,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Ue(this,T,"f").getExtensionExports(Ue(this,B,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Ue(this,T,"f").activateByIdWithErrors(Ue(this,B,"f"),{startup:!1,extensionId:Ue(this,F,"f"),activationEvent:"api"}),this.exports}}e.Extension=H,T=new WeakMap,F=new WeakMap,B=new WeakMap;function Y(ge,X){return ge.getAllExtensionDescriptions().filter(J=>X.has(b.ExtensionIdentifier.toKey(J.identifier)))}class ie{constructor(X){this.a=X}setSearchTree(X){this.a=X}findSubstr(X){return this.a.findSubstr(X)}forEach(X){return this.a.forEach(X)}}e.ExtensionPaths=ie}),define(ye[297],De([1,0,84,2,5,35,26,27,18,25,4,42,36,13,8]),function(re,e,a,L,l,R,S,A,y,I,O,P,v,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let f=class{constructor(g,i,s,r,o,c,m){this.c=g,this.d=i,this.e=s,this.f=r,this.g=o,this.h=c,this.i=m,this.a=new Map,this.b=[]}async install(){this.j(),a.mark("code/extHost/willWaitForConfig");const g=await this.f.getConfigProvider();a.mark("code/extHost/didWaitForConfig");const i=await this.g.getExtensionPathIndex();this.register(new h(this.c,i,this.d,g,this.i)),this.register(this.e.createInstance(p,i)),this.register(this.e.createInstance(u)),this.h.remote.isRemote&&this.register(this.e.createInstance(b,i,this.h.environment.appUriScheme))}register(g){if("nodeModuleName"in g)if(Array.isArray(g.nodeModuleName))for(const i of g.nodeModuleName)this.a.set(i,g);else this.a.set(g.nodeModuleName,g);typeof g.alternativeModuleName=="function"&&this.b.push(i=>g.alternativeModuleName(i))}};f=qe([ze(2,O.IInstantiationService),ze(3,R.IExtHostConfiguration),ze(4,P.IExtHostExtensionService),ze(5,I.IExtHostInitDataService),ze(6,k.ILogService)],f),e.RequireInterceptor=f;let u=class rn{constructor(g){if(g.environment.appRoot&&rn.a.size){const i=(0,D.escapeRegExpCharacters)(this.c(g.environment.appRoot.fsPath)),s="[a-z0-9_.-]",r=`@${s}+\\/${s}+|${s}+`,o="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${i}/${o}\\/)(${r})(.*)$`,"i")}}alternativeModuleName(g){if(!this.b)return;const i=this.b.exec(this.c(g));if(!i)return;const[,s,r,o]=i,c=rn.a.get(r);if(c!==void 0)return console.warn(`${r} as been renamed to ${c}, please update your imports`),s+c+o}c(g){return g.replace(/\\/g,"/")}};u.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),u=qe([ze(0,I.IExtHostInitDataService)],u);class h{constructor(g,i,s,r,o){this.c=g,this.d=i,this.e=s,this.f=r,this.g=o,this.nodeModuleName="vscode",this.a=new Map}load(g,i){const s=this.d.findSubstr(i);if(s){let r=this.a.get(A.ExtensionIdentifier.toKey(s.identifier));return r||(r=this.c(s,this.e,this.f),this.a.set(A.ExtensionIdentifier.toKey(s.identifier),r)),r}if(!this.b){let r="";this.d.forEach((o,c)=>r+=`	${c} -> ${o.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${i}. These are the extension path mappings: 
${r}`),this.b=this.c(S.nullExtensionDescription,this.e,this.f)}return this.b}}let p=class{constructor(g,i,s){this.d=g,this.nodeModuleName="keytar",this.a=i.getProxy(l.MainContext.MainThreadTelemetry);const{environment:r}=s,o=i.getProxy(l.MainContext.MainThreadKeytar);if(r.appRoot){let c=r.appRoot.fsPath;v.platform==="win32"&&(c=c.replace(/\\/g,"/")),c[c.length-1]==="/"&&(c=c.substr(0,c.length-1)),this.b=new Set,this.b.add(`${c}/node_modules.asar/keytar`),this.b.add(`${c}/node_modules/keytar`)}this.c={getPassword:(c,m)=>o.$getPassword(c,m),setPassword:(c,m,n)=>o.$setPassword(c,m,n),deletePassword:(c,m)=>o.$deletePassword(c,m),findPassword:c=>o.$findPassword(c),findCredentials(c){return o.$findCredentials(c)}}}load(g,i){const s=this.d.findSubstr(i);return this.a.$publicLog2("shimming.keytar",{extension:s?.identifier.value??"unknown_extension"}),this.c}alternativeModuleName(g){const i=g.length;if(i<=7||!this.b)return;const s=i-7;if((g.charAt(s)==="/"||g.charAt(s)==="\\")&&g.endsWith("keytar")&&(g=g.replace(/\\/g,"/"),this.b.has(g)))return"keytar"}};p=qe([ze(1,y.IExtHostRpcService),ze(2,I.IExtHostInitDataService)],p);let b=class{constructor(g,i,s){this.e=g,this.f=i,this.nodeModuleName=["open","opn"],this.d=s.getProxy(l.MainContext.MainThreadTelemetry);const r=s.getProxy(l.MainContext.MainThreadWindow);this.c=(o,c)=>{const m=L.URI.parse(o);return c?this.g(o,c):m.scheme==="http"||m.scheme==="https"?r.$openUri(m,o,{allowTunneling:!0}):m.scheme==="mailto"||m.scheme===this.f?r.$openUri(m,o,{}):this.g(o,c)}}load(g,i,s){const r=this.e.findSubstr(i);return r&&(this.a=r.identifier.value,this.h()),this.b=s(g),this.c}g(g,i){return this.i(),this.b(g,i)}h(){!this.a||this.d.$publicLog2("shimming.open",{extension:this.a})}i(){!this.a||this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};b=qe([ze(2,y.IExtHostRpcService)],b)}),define(ye[49],De([1,0,66,6,9,36,4,60,61,42,7,34,234,35]),function(re,e,a,L,l,R,S,A,y,I,O,P,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,S.createDecorator)("IExtHostVariableResolverProvider");class D extends v.AbstractVariableResolverService{constructor(h,p,b,C,g,i,s){function r(){if(b){const o=b.activeEditor();if(o)return o.document.uri;const c=C.tabGroups.all.find(m=>m.isActive)?.activeTab;if(c!==void 0){if(c.input instanceof O.TextDiffTabInput||c.input instanceof O.NotebookDiffEditorTabInput)return c.input.modified;if(c.input instanceof O.TextTabInput||c.input instanceof O.NotebookEditorTabInput||c.input instanceof O.CustomEditorTabInput)return c.input.uri}}}super({getFolderUri:o=>{const c=i.folders.filter(m=>m.name===o);if(c&&c.length>0)return c[0].uri},getWorkspaceFolderCount:()=>i.folders.length,getConfigurationValue:(o,c)=>g.getConfiguration(void 0,o).get(c),getAppRoot:()=>R.cwd(),getExecPath:()=>R.env.VSCODE_EXEC_PATH,getFilePath:()=>{const o=r();if(o)return l.normalize(o.fsPath)},getWorkspaceFolderPathForFile:()=>{if(p){const o=r();if(o){const c=p.getWorkspaceFolder(o);if(c)return l.normalize(c.uri.fsPath)}}},getSelectedText:()=>{if(b){const o=b.activeEditor();if(o&&!o.selection.isEmpty)return o.document.getText(o.selection)}},getLineNumber:()=>{if(b){const o=b.activeEditor();if(o)return String(o.selection.end.line+1)}},getExtension:o=>h.getExtension(o)},void 0,s?Promise.resolve(s):void 0,Promise.resolve(R.env))}}let f=class extends L.Disposable{constructor(h,p,b,C,g){super(),this.b=h,this.c=p,this.g=b,this.h=C,this.i=g,this.a=new a.Lazy(async()=>{const i=await this.h.getConfigProvider(),r={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async o=>{r.folders=await this.c.getWorkspaceFolders2()||[]})),new D(this.b,this.c,this.g,this.i,i,r,this.j())})}getResolver(){return this.a.value}j(){}};f=qe([ze(0,I.IExtHostExtensionService),ze(1,P.IExtHostWorkspace),ze(2,A.IExtHostDocumentsAndEditors),ze(3,k.IExtHostConfiguration),ze(4,y.IExtHostEditorTabs)],f),e.ExtHostVariableResolverProviderService=f}),define(ye[85],De([1,0,17,3,10,2,4,5,61,42,18,7,34,131,227,35,49]),function(re,e,a,L,l,R,S,A,y,I,O,P,v,k,D,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,S.createDecorator)("IExtHostDebugService");let h=class{get onDidStartDebugSession(){return this.m.event}get onDidTerminateDebugSession(){return this.n.event}get onDidChangeActiveDebugSession(){return this.o.event}get activeDebugSession(){return this.q}get onDidReceiveDebugSessionCustomEvent(){return this.u.event}get activeDebugConsole(){return this.v.value}constructor(r,o,c,m,n,t){this.D=o,this.E=c,this.F=m,this.G=n,this.H=t,this.l=new Map,this.d=0,this.f=[],this.g=0,this.h=[],this.i=0,this.j=[],this.A=new Map,this.B=new Map,this.m=new L.Emitter,this.n=new L.Emitter,this.o=new L.Emitter,this.u=new L.Emitter,this.k=r.getProxy(A.MainContext.MainThreadDebugService),this.z=new L.Emitter({onWillAddFirstListener:()=>{this.T()}}),this.v=new b(this.k),this.w=new Map,this.y=!1,this.E.getExtensionRegistry().then(d=>{d.onDidChange(E=>{this.I(d)}),this.I(d)})}asDebugSourceUri(r,o){const c=r;if(typeof c.sourceReference=="number"&&c.sourceReference>0){let m=`debug:${encodeURIComponent(c.path||"")}`,n="?";return o&&(m+=`${n}session=${encodeURIComponent(o.id)}`,n="&"),m+=`${n}ref=${c.sourceReference}`,R.URI.parse(m)}else{if(c.path)return R.URI.file(c.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}I(r){const o=[];for(const c of r.getAllExtensionDescriptions())if(c.contributes){const m=c.contributes.debuggers;if(m&&m.length>0)for(const n of m)(0,D.isDebuggerMainContribution)(n)&&o.push(n.type)}this.k.$registerDebugTypes(o)}get onDidChangeBreakpoints(){return this.z.event}get breakpoints(){this.T();const r=[];return this.w.forEach(o=>r.push(o)),r}addBreakpoints(r){this.T();const o=r.filter(n=>{const t=n.id;return this.w.has(t)?!1:(this.w.set(t,n),!0)});this.U(o,[],[]);const c=[],m=new Map;for(const n of o)if(n instanceof P.SourceBreakpoint){let t=m.get(n.location.uri.toString());t||(t={type:"sourceMulti",uri:n.location.uri,lines:[]},m.set(n.location.uri.toString(),t),c.push(t)),t.lines.push({id:n.id,enabled:n.enabled,condition:n.condition,hitCondition:n.hitCondition,logMessage:n.logMessage,line:n.location.range.start.line,character:n.location.range.start.character})}else n instanceof P.FunctionBreakpoint&&c.push({type:"function",id:n.id,enabled:n.enabled,hitCondition:n.hitCondition,logMessage:n.logMessage,condition:n.condition,functionName:n.functionName});return this.k.$registerBreakpoints(c)}removeBreakpoints(r){this.T();const o=r.filter(t=>this.w.delete(t.id));this.U([],o,[]);const c=o.filter(t=>t instanceof P.SourceBreakpoint).map(t=>t.id),m=o.filter(t=>t instanceof P.FunctionBreakpoint).map(t=>t.id),n=o.filter(t=>t instanceof P.DataBreakpoint).map(t=>t.id);return this.k.$unregisterBreakpoints(c,m,n)}startDebugging(r,o,c){return this.k.$startDebugging(r?r.uri:void 0,o,{parentSessionID:c.parentSession?c.parentSession.id:void 0,lifecycleManagedByParent:c.lifecycleManagedByParent,repl:c.consoleMode===P.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:c.noDebug,compact:c.compact,suppressSaveBeforeStart:c.suppressSaveBeforeStart,suppressDebugStatusbar:c.suppressDebugStatusbar??c.debugUI?.simple,suppressDebugToolbar:c.suppressDebugToolbar??c.debugUI?.simple,suppressDebugView:c.suppressDebugView??c.debugUI?.simple})}stopDebugging(r){return this.k.$stopDebugging(r?r.id:void 0)}registerDebugConfigurationProvider(r,o,c){if(!o)return new P.Disposable(()=>{});const m=this.d++;return this.f.push({type:r,handle:m,provider:o}),this.k.$registerDebugConfigurationProvider(r,c,!!o.provideDebugConfigurations,!!o.resolveDebugConfiguration,!!o.resolveDebugConfigurationWithSubstitutedVariables,m),new P.Disposable(()=>{this.f=this.f.filter(n=>n.provider!==o),this.k.$unregisterDebugConfigurationProvider(m)})}registerDebugAdapterDescriptorFactory(r,o,c){if(!c)return new P.Disposable(()=>{});if(!this.P(r,o))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${o}' debugger.`);if(this.M(o))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const m=this.g++;return this.h.push({type:o,handle:m,factory:c}),this.k.$registerDebugAdapterDescriptorFactory(o,m),new P.Disposable(()=>{this.h=this.h.filter(n=>n.factory!==c),this.k.$unregisterDebugAdapterDescriptorFactory(m)})}registerDebugAdapterTrackerFactory(r,o){if(!o)return new P.Disposable(()=>{});const c=this.i++;return this.j.push({type:r,handle:c,factory:o}),new P.Disposable(()=>{this.j=this.j.filter(m=>m.factory!==o)})}async $runInTerminal(r,o){return Promise.resolve(void 0)}async $substituteVariables(r,o){let c;const m=await this.W(r);return m&&(c={uri:m.uri,name:m.name,index:m.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.H.getResolver()).resolveAnyAsync(c,o)}J(r,o){if(r.type==="implementation")return new g(r.implementation)}K(){}async $startDASession(r,o){const c=this,m=await this.V(o);return this.R(this.M(m.type),m).then(n=>{if(!n)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${m.type}' (extension might have failed to activate)`);const t=this.L(n),d=this.J(t,m);if(!d)throw new Error(`Couldn't create a debug adapter for type '${m.type}'.`);const E=d;return this.A.set(r,E),this.Q(m).then(w=>(w&&this.B.set(r,w),E.onMessage(async N=>{if(N.type==="request"&&N.command==="handshake"){const j=N,V={type:"response",seq:0,command:j.command,request_seq:j.seq,success:!0};this.C||(this.C=this.K());try{if(this.C){const Q=await this.C.sign(j.arguments.value);V.body={signature:Q},E.sendResponse(V)}else throw new Error("no signer")}catch(Q){V.success=!1,V.message=Q.message,E.sendResponse(V)}}else w&&w.onDidSendMessage&&w.onDidSendMessage(N),N=(0,D.convertToVSCPaths)(N,!0),c.k.$acceptDAMessage(r,N)}),E.onError(N=>{w&&w.onError&&w.onError(N),this.k.$acceptDAError(r,N.name,N.message,N.stack)}),E.onExit(N=>{w&&w.onExit&&w.onExit((0,l.withNullAsUndefined)(N),void 0),this.k.$acceptDAExit(r,(0,l.withNullAsUndefined)(N),void 0)}),w&&w.onWillStartSession&&w.onWillStartSession(),E.startSession()))})}$sendDAMessage(r,o){o=(0,D.convertToDAPaths)(o,!1);const c=this.B.get(r);c&&c.onWillReceiveMessage&&c.onWillReceiveMessage(o),this.A.get(r)?.sendMessage(o)}$stopDASession(r){const o=this.B.get(r);this.B.delete(r),o&&o.onWillStopSession&&o.onWillStopSession();const c=this.A.get(r);return this.A.delete(r),c?c.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(r){const o=[],c=[],m=[];if(r.added)for(const n of r.added){const t=n.id;if(t&&!this.w.has(t)){let d;if(n.type==="function")d=new P.FunctionBreakpoint(n.functionName,n.enabled,n.condition,n.hitCondition,n.logMessage);else if(n.type==="data")d=new P.DataBreakpoint(n.label,n.dataId,n.canPersist,n.enabled,n.hitCondition,n.condition,n.logMessage);else{const E=R.URI.revive(n.uri);d=new P.SourceBreakpoint(new P.Location(E,new P.Position(n.line,n.character)),n.enabled,n.condition,n.hitCondition,n.logMessage)}(0,P.setBreakpointId)(d,t),this.w.set(t,d),o.push(d)}}if(r.removed)for(const n of r.removed){const t=this.w.get(n);t&&(this.w.delete(n),c.push(t))}if(r.changed){for(const n of r.changed)if(n.id){const t=this.w.get(n.id);if(t){if(t instanceof P.FunctionBreakpoint&&n.type==="function"){const d=t;d.enabled=n.enabled,d.condition=n.condition,d.hitCondition=n.hitCondition,d.logMessage=n.logMessage,d.functionName=n.functionName}else if(t instanceof P.SourceBreakpoint&&n.type==="source"){const d=t;d.enabled=n.enabled,d.condition=n.condition,d.hitCondition=n.hitCondition,d.logMessage=n.logMessage,d.location=new P.Location(R.URI.revive(n.uri),new P.Position(n.line,n.character))}m.push(t)}}}this.U(o,c,m)}$provideDebugConfigurations(r,o,c){return(0,a.asPromise)(async()=>{const m=this.O(r);if(!m)throw new Error("no DebugConfigurationProvider found");if(!m.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const n=await this.W(o);return m.provideDebugConfigurations(n,c)}).then(m=>{if(!m)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return m})}$resolveDebugConfiguration(r,o,c,m){return(0,a.asPromise)(async()=>{const n=this.O(r);if(!n)throw new Error("no DebugConfigurationProvider found");if(!n.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const t=await this.W(o);return n.resolveDebugConfiguration(t,c,m)})}$resolveDebugConfigurationWithSubstitutedVariables(r,o,c,m){return(0,a.asPromise)(async()=>{const n=this.O(r);if(!n)throw new Error("no DebugConfigurationProvider found");if(!n.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const t=await this.W(o);return n.resolveDebugConfigurationWithSubstitutedVariables(t,c,m)})}async $provideDebugAdapter(r,o){const c=this.N(r);if(!c)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const m=await this.V(o);return this.R(c,m).then(n=>{if(!n)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${m.type}'`);return this.L(n)})}async $acceptDebugSessionStarted(r){const o=await this.V(r);this.m.fire(o)}async $acceptDebugSessionTerminated(r){const o=await this.V(r);o&&(this.n.fire(o),this.l.delete(o.id))}async $acceptDebugSessionActiveChanged(r){this.q=r?await this.V(r):void 0,this.o.fire(this.q)}async $acceptDebugSessionNameChanged(r,o){(await this.V(r))?._acceptNameChanged(o)}async $acceptDebugSessionCustomEvent(r,o){const m={session:await this.V(r),event:o.event,body:o.body};this.u.fire(m)}L(r){if(r instanceof P.DebugAdapterExecutable)return{type:"executable",command:r.command,args:r.args,options:r.options};if(r instanceof P.DebugAdapterServer)return{type:"server",port:r.port,host:r.host};if(r instanceof P.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:r.path};if(r instanceof P.DebugAdapterInlineImplementation)return{type:"implementation",implementation:r.implementation};throw new Error("convertToDto unexpected type")}M(r){const o=this.h.filter(c=>c.type===r);if(o.length>0)return o[0].factory}N(r){const o=this.h.filter(c=>c.handle===r);if(o.length>0)return o[0].factory}O(r){const o=this.f.filter(c=>c.handle===r);if(o.length>0)return o[0].provider}P(r,o){if(r.contributes){const c=r.contributes.debuggers;if(c&&c.length>0){for(const m of c)if(m.label&&m.type&&m.type===o)return!0}}return!1}Q(r){const c=r.configuration.type,m=this.j.filter(n=>n.type===c||n.type==="*").map(n=>(0,a.asPromise)(()=>n.factory.createDebugAdapterTracker(r)).then(t=>t,t=>null));return Promise.race([Promise.all(m).then(n=>{const t=n.filter(d=>!!d);if(t.length>0)return new C(t)}),new Promise(n=>setTimeout(()=>n(void 0),1e3))]).catch(n=>{})}async R(r,o){const c=o.configuration.debugServer;if(typeof c=="number")return Promise.resolve(new P.DebugAdapterServer(c));if(r){const n=await this.E.getExtensionRegistry();return(0,a.asPromise)(()=>r.createDebugAdapterDescriptor(o,this.S(o,n))).then(t=>{if(t)return t})}const m=await this.E.getExtensionRegistry();return Promise.resolve(this.S(o,m))}S(r,o){}T(){this.y||(this.y=!0,this.k.$startBreakpointEvents())}U(r,o,c){(r.length>0||o.length>0||c.length>0)&&this.z.fire(Object.freeze({added:r,removed:o,changed:c}))}async V(r){if(r)if(typeof r=="string"){const o=this.l.get(r);if(o)return o}else{let o=this.l.get(r.id);if(!o){const c=await this.W(r.folderUri),m=r.parent?this.l.get(r.parent):void 0;o=new p(this.k,r.id,r.type,r.name,c,r.configuration,m),this.l.set(o.id,o),this.k.$sessionCached(o.id)}return o}throw new Error("cannot find session")}W(r){if(r){const o=R.URI.revive(r);return this.D.resolveWorkspaceFolder(o)}return Promise.resolve(void 0)}};h=qe([ze(0,O.IExtHostRpcService),ze(1,v.IExtHostWorkspace),ze(2,I.IExtHostExtensionService),ze(3,f.IExtHostConfiguration),ze(4,y.IExtHostEditorTabs),ze(5,u.IExtHostVariableResolverProvider)],h),e.ExtHostDebugServiceBase=h;class p{constructor(r,o,c,m,n,t,d){this.d=r,this.f=o,this.g=c,this.h=m,this.i=n,this.j=t,this.k=d}get id(){return this.f}get type(){return this.g}get name(){return this.h}set name(r){this.h=r,this.d.$setDebugSessionName(this.f,r)}get parentSession(){return this.k}_acceptNameChanged(r){this.h=r}get workspaceFolder(){return this.i}get configuration(){return this.j}customRequest(r,o){return this.d.$customDebugAdapterRequest(this.f,r,o)}getDebugProtocolBreakpoint(r){return this.d.$getDebugProtocolBreakpoint(this.f,r.id)}}e.ExtHostDebugSession=p;class b{constructor(r){this.value=Object.freeze({append(o){r.$appendDebugConsole(o)},appendLine(o){this.append(o+`
`)}})}}e.ExtHostDebugConsole=b;class C{constructor(r){this.d=r}onWillStartSession(){this.d.forEach(r=>r.onWillStartSession?r.onWillStartSession():void 0)}onWillReceiveMessage(r){this.d.forEach(o=>o.onWillReceiveMessage?o.onWillReceiveMessage(r):void 0)}onDidSendMessage(r){this.d.forEach(o=>o.onDidSendMessage?o.onDidSendMessage(r):void 0)}onWillStopSession(){this.d.forEach(r=>r.onWillStopSession?r.onWillStopSession():void 0)}onError(r){this.d.forEach(o=>o.onError?o.onError(r):void 0)}onExit(r,o){this.d.forEach(c=>c.onExit?c.onExit(r,o):void 0)}}class g extends k.AbstractDebugAdapter{constructor(r){super(),this.h=r,r.onDidSendMessage(o=>{this.acceptMessage(o)})}startSession(){return Promise.resolve(void 0)}sendMessage(r){this.h.handleMessage(r)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let i=class extends h{constructor(r,o,c,m,n,t){super(r,o,c,m,n,t)}};i=qe([ze(0,O.IExtHostRpcService),ze(1,v.IExtHostWorkspace),ze(2,I.IExtHostExtensionService),ze(3,f.IExtHostConfiguration),ze(4,y.IExtHostEditorTabs),ze(5,u.IExtHostVariableResolverProvider)],i),e.WorkerExtHostDebugService=i}),define(ye[298],De([1,0,11,84,2,5,290,13,90,91,25,203,18,57,42,77]),function(re,e,a,L,l,R,S,A,y,I,O,P,v,k,D,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class u{static async installEarlyHandler(b){const C=b.get(A.ILogService),i=b.get(v.IExtHostRpcService).getProxy(R.MainContext.MainThreadErrors);a.setUnexpectedErrorHandler(s=>{C.error(s);const r=a.transformErrorForSerialization(s);i.$onUnexpectedError(r)})}static async installFullHandler(b){const C=b.get(A.ILogService),g=b.get(v.IExtHostRpcService),i=b.get(D.IExtHostExtensionService),s=b.get(f.IExtHostTelemetry),r=g.getProxy(R.MainContext.MainThreadExtensionService),o=g.getProxy(R.MainContext.MainThreadErrors),c=await i.getExtensionPathIndex(),m=new WeakMap;Error.prepareStackTrace=(n,t)=>{let d="",E,w;for(const N of t)d+=`
	at ${N.toString()}`,w=N.getFileName(),!E&&w&&(E=c.findSubstr(l.URI.file(w)));return m.set(n,E?.identifier),`${n.name||"Error"}: ${n.message||""}${d}`},a.setUnexpectedErrorHandler(n=>{C.error(n);const t=a.transformErrorForSerialization(n),d=m.get(n);if(!d){o.$onUnexpectedError(t);return}r.$onExtensionRuntimeError(d,t);const E=s.onExtensionError(d,n);C.trace("forwarded error to extension?",E,d)})}}Error.stackTraceLimit=100;class h{constructor(b,C,g,i,s){this.a=g,this.b=new S.RPCProtocol(b,null,i),C=h.e(C,this.b);const r=new I.ServiceCollection(...(0,y.getSingletonServiceDescriptors)());r.set(O.IExtHostInitDataService,{_serviceBrand:void 0,...C,messagePorts:s}),r.set(v.IExtHostRpcService,new v.ExtHostRpcService(this.b)),r.set(k.IURITransformerService,new k.URITransformerService(i)),r.set(D.IHostUtils,g);const o=new P.InstantiationService(r,!0);o.invokeFunction(u.installEarlyHandler),this.d=o.invokeFunction(c=>c.get(A.ILogService)),L.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",C),this.c=o.invokeFunction(c=>c.get(D.IExtHostExtensionService)),this.c.initialize(),o.invokeFunction(u.installFullHandler)}async asBrowserUri(b){const C=this.b.getProxy(R.MainContext.MainThreadExtensionService);return l.URI.revive(await C.$asBrowserUri(b))}terminate(b){this.c.terminate(b)}static e(b,C){b.allExtensions.forEach(i=>{i.extensionLocation=l.URI.revive(C.transformIncomingURIs(i.extensionLocation));const s={};i.browserNlsBundleUris&&(Object.keys(i.browserNlsBundleUris).forEach(r=>s[r]=l.URI.revive(C.transformIncomingURIs(i.browserNlsBundleUris[r]))),i.browserNlsBundleUris=s)}),b.environment.appRoot=l.URI.revive(C.transformIncomingURIs(b.environment.appRoot));const g=b.environment.extensionDevelopmentLocationURI;return g&&(b.environment.extensionDevelopmentLocationURI=g.map(i=>l.URI.revive(C.transformIncomingURIs(i)))),b.environment.extensionTestsLocationURI=l.URI.revive(C.transformIncomingURIs(b.environment.extensionTestsLocationURI)),b.environment.globalStorageHome=l.URI.revive(C.transformIncomingURIs(b.environment.globalStorageHome)),b.environment.workspaceStorageHome=l.URI.revive(C.transformIncomingURIs(b.environment.workspaceStorageHome)),b.environment.extensionTelemetryLogResource=l.URI.revive(C.transformIncomingURIs(b.environment.extensionTelemetryLogResource)),b.nlsBaseUrl=l.URI.revive(C.transformIncomingURIs(b.nlsBaseUrl)),b.logsLocation=l.URI.revive(C.transformIncomingURIs(b.logsLocation)),b.logFile=l.URI.revive(C.transformIncomingURIs(b.logFile)),b.workspace=C.transformIncomingURIs(b.workspace),b}}e.ExtensionHostMain=h}),define(ye[299],De([1,0,17,12,184,202,210,85,61,42,18,41,7,49,34,228,230,35]),function(re,e,a,L,l,R,S,A,y,I,O,P,v,k,D,f,u,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDebugService=void 0;let p=class extends A.ExtHostDebugServiceBase{constructor(s,r,o,c,m,n,t){super(s,r,o,c,n,t),this.Z=m,this.X=new g}J(s,r){switch(s.type){case"server":return new f.SocketDebugAdapter(s);case"pipeServer":return new f.NamedPipeDebugAdapter(s);case"executable":return new f.ExecutableDebugAdapter(s,r.type)}return super.J(s,r)}S(s,r){const o=f.ExecutableDebugAdapter.platformAdapterExecutable(r.getAllExtensionDescriptions(),s.type);if(o)return new v.DebugAdapterExecutable(o.command,o.args,o.options)}K(){return new S.SignService}async $runInTerminal(s,r){if(s.kind==="integrated"){this.Y||(this.Y=this.Z.onDidCloseTerminal(Q=>{this.X.onTerminalClosed(Q)}));const o=await this.F.getConfigProvider(),c=this.Z.getDefaultShell(!0),m=this.Z.getDefaultShellArgs(!0),n=s.title||l.localize(0,null),t=JSON.stringify({shell:c,shellArgs:m});let d=await this.X.checkout(t,n),E,w=!1;if(d)E=s.cwd;else{const Q={shellPath:c,shellArgs:m,cwd:s.cwd,name:n,iconPath:new v.ThemeIcon("debug")};w=!0,d=this.Z.createTerminalFromOptions(Q,{isFeatureTerminal:!0,useShellEnvironment:!0}),this.X.insert(d,t)}d.show(!0);const N=await d.processId;w?await new Promise(Q=>setTimeout(Q,1e3)):o.getConfiguration("debug.terminal").get("clearBeforeReusing")&&(c.indexOf("powershell")>=0||c.indexOf("pwsh")>=0||c.indexOf("cmd.exe")>=0?d.sendText("cls"):c.indexOf("bash")>=0?d.sendText("clear"):L.isWindows?d.sendText("cls"):d.sendText("clear"));const j=(0,u.prepareCommand)(c,s.args,!!s.argsCanBeInterpretedByShell,E,s.env);d.sendText(j);const V=this.onDidTerminateDebugSession(Q=>{Q.id===r&&(this.X.free(d),V.dispose())});return N}else if(s.kind==="external")return C(s,await this.F.getConfigProvider());return super.$runInTerminal(s,r)}};p=qe([ze(0,O.IExtHostRpcService),ze(1,D.IExtHostWorkspace),ze(2,I.IExtHostExtensionService),ze(3,h.IExtHostConfiguration),ze(4,P.IExtHostTerminalService),ze(5,y.IExtHostEditorTabs),ze(6,k.IExtHostVariableResolverProvider)],p),e.ExtHostDebugService=p;let b;function C(i,s){if(!b)if(L.isWindows)b=new R.WindowsExternalTerminalService;else if(L.isMacintosh)b=new R.MacExternalTerminalService;else if(L.isLinux)b=new R.LinuxExternalTerminalService;else throw new Error("external terminals not supported on this platform");const r=s.getConfiguration("terminal");return b.runInTerminal(i.title,i.cwd,i.args,i.env||{},r.external||{})}class g{constructor(){this.b=new Map}async checkout(s,r){const c=[...this.b.entries()].map(([m,n])=>(0,a.createCancelablePromise)(async t=>{if(m.name!==r||n.lastUsedAt!==-1&&await(0,u.hasChildProcesses)(await m.processId))return null;const d=Date.now();return n.lastUsedAt+g.a>d||t.isCancellationRequested||n.config!==s?null:(n.lastUsedAt=d,m)}));return await(0,a.firstParallel)(c,m=>!!m)}insert(s,r){this.b.set(s,{lastUsedAt:Date.now(),config:r})}free(s){const r=this.b.get(s);r&&(r.lastUsedAt=-1)}onTerminalClosed(s){this.b.delete(s)}}g.a=1e3}),define(ye[300],De([1,0,9,2,113,34,60,35,47,41,18,25,83,16,13,78,24,71,49]),function(re,e,a,L,l,R,S,A,y,I,O,P,v,k,D,f,u,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTask=void 0;let b=class extends v.ExtHostTaskBase{constructor(g,i,s,r,o,c,m,n,t){super(g,i,s,r,o,c,m,n),this.B=s,this.C=t,i.remote.isRemote&&i.remote.authority?this.registerTaskSystem(k.Schemas.vscodeRemote,{scheme:k.Schemas.vscodeRemote,authority:i.remote.authority,platform:process.platform}):this.registerTaskSystem(k.Schemas.file,{scheme:k.Schemas.file,authority:"",platform:process.platform}),this.a.$registerSupportedExecutions(!0,!0,!0)}async executeTask(g,i){const s=i;if(!i.execution&&s._id===void 0)throw new Error("Tasks to execute must include an execution");if(s._id!==void 0){const r=v.TaskHandleDTO.from(s,this.B),o=await this.a.$getTaskExecution(r);if(o.task===void 0)throw new Error("Task from execution DTO is undefined");const c=await this.y(o,i);return this.a.$executeTask(r).catch(()=>{}),c}else{const r=v.TaskDTO.from(i,g);if(r===void 0)return Promise.reject(new Error("Task is not valid"));v.CustomExecutionDTO.is(r.execution)&&await this.x(r,i,!1);const o=await this.y(await this.a.$getTaskExecution(r),i);return this.a.$executeTask(r).catch(()=>{}),o}}u(g,i,s,r){const o=[];if(r)for(const c of r){this.z(c,s),(!c.definition||!g[c.definition.type])&&this.f.warn(`The task [${c.source}, ${c.name}] uses an undefined task type. The task will be ignored in the future.`);const m=v.TaskDTO.from(c,s.extension);m&&(o.push(m),v.CustomExecutionDTO.is(m.execution)&&i.push(this.x(m,c,!0)))}return{tasks:o,extension:s.extension}}async v(g){return g}async F(g){let i=g&&g.length>0?g[0]:void 0;if(!i){const s=L.URI.file((0,h.homedir)());i=new y.WorkspaceFolder({uri:s,name:u.basename(s),index:0})}return{uri:i.uri,name:i.name,index:i.index,toResource:()=>{throw new Error("Not implemented")}}}async $resolveVariables(g,i){const s=L.URI.revive(g),r={process:void 0,variables:Object.create(null)},o=await this.b.resolveWorkspaceFolder(s),c=await this.b.getWorkspaceFolders2()??[],m=await this.C.getResolver(),n=o?{uri:o.uri,name:o.name,index:o.index,toResource:()=>{throw new Error("Not implemented")}}:await this.F(c);for(const t of i.variables)r.variables[t]=await m.resolveAsync(n,t);if(i.process!==void 0){let t;if(i.process.path!==void 0){t=i.process.path.split(a.delimiter);for(let d=0;d<t.length;d++)t[d]=await m.resolveAsync(n,t[d])}r.process=await l.win32.findExecutable(await m.resolveAsync(n,i.process.name),i.process.cwd!==void 0?await m.resolveAsync(n,i.process.cwd):void 0,t)}return r}async $jsonTasksSupported(){return!0}async $findExecutable(g,i,s){return l.win32.findExecutable(g,i,s)}};b=qe([ze(0,O.IExtHostRpcService),ze(1,P.IExtHostInitDataService),ze(2,R.IExtHostWorkspace),ze(3,S.IExtHostDocumentsAndEditors),ze(4,A.IExtHostConfiguration),ze(5,I.IExtHostTerminalService),ze(6,D.ILogService),ze(7,f.IExtHostApiDeprecationService),ze(8,p.IExtHostVariableResolverProvider)],b),e.ExtHostTask=b}),define(ye[301],De([1,0,71,49]),function(re,e,a,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeExtHostVariableResolverProviderService=void 0;class l extends L.ExtHostVariableResolverProviderService{j(){return(0,a.homedir)()}}e.NodeExtHostVariableResolverProviderService=l}),define(ye[143],De([1,0,15,17,21,45,16,9,24,2,31]),function(re,e,a,L,l,R,S,A,y,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class P{constructor(p,b,C,g){this.d=p,this.e=b,this.f=C,this.g=g,this.a=null,this.b=!1,this.c=0}search(p,b){const C=this.d.folderQueries||[],g=new l.CancellationTokenSource;return b.onCancellationRequested(()=>g.cancel()),new Promise((i,s)=>{this.a=new k(p);let r=!1;const o=(c,m)=>{if(!r&&!this.b){const n=this.h(c);f(c)&&typeof this.d.maxResults=="number"&&this.c+n>this.d.maxResults&&(this.b=!0,r=!0,g.cancel(),c=this.j(c,this.d.maxResults-this.c));const t=this.h(c);this.c+=t,(t>0||!f(c))&&this.a.add(c,m)}};Promise.all(C.map((c,m)=>this.k(c,n=>o(n,m),g.token))).then(c=>{g.dispose(),this.a.flush();const m=c.some(n=>!!n&&!!n.limitHit);i({limitHit:this.b||m,messages:(0,a.flatten)(c.map(n=>n?.message?Array.isArray(n.message)?n.message:[n.message]:[])),stats:{type:this.g}})},c=>{g.dispose();const m=(0,R.toErrorMessage)(c);s(new Error(m))})})}h(p){return f(p)?Array.isArray(p.ranges)?p.ranges.length:1:0}j(p,b){const C=Array.isArray(p.ranges)?p.ranges:[p.ranges],g=Array.isArray(p.preview.matches)?p.preview.matches:[p.preview.matches];return{ranges:C.slice(0,b),preview:{matches:g.slice(0,b),text:p.preview.text},uri:p.uri}}async k(p,b,C){const g=new O.QueryGlobTester(this.d,p),i=[],s={report:c=>{if(!this.l(c))return;const m=p.folder.scheme===S.Schemas.file?(0,O.hasSiblingPromiseFn)(()=>this.f.readdir(y.dirname(c.uri))):void 0,n=y.relativePath(p.folder,c.uri);if(n){const t=g.includedInQuery(n,A.basename(n),m);(0,L.isThenable)(t)?i.push(t.then(d=>{d&&b(c)})):t&&b(c)}}},r=this.n(p),o=await this.e.provideTextSearchResults(v(this.d.contentPattern),r,s,C);return i.length&&await Promise.all(i),o}l(p){if(f(p)){if(Array.isArray(p.ranges)){if(!Array.isArray(p.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(p.preview.matches.length!==p.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(p.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(p){const b=(0,O.resolvePatternsForProvider)(this.d.includePattern,p.includePattern),C=(0,O.resolvePatternsForProvider)(this.d.excludePattern,p.excludePattern),g={folder:I.URI.from(p.folder),excludes:C,includes:b,useIgnoreFiles:!p.disregardIgnoreFiles,useGlobalIgnoreFiles:!p.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!p.disregardParentIgnoreFiles,followSymlinks:!p.ignoreSymlinks,encoding:p.fileEncoding&&this.f.toCanonicalName(p.fileEncoding),maxFileSize:this.d.maxFileSize,maxResults:this.d.maxResults,previewOptions:this.d.previewOptions,afterContext:this.d.afterContext,beforeContext:this.d.beforeContext};return g.usePCRE2=this.d.usePCRE2,g}}e.TextSearchManager=P;function v(h){return{isCaseSensitive:h.isCaseSensitive||!1,isRegExp:h.isRegExp||!1,isWordMatch:h.isWordMatch||!1,isMultiline:h.isMultiline||!1,pattern:h.pattern}}class k{constructor(p){this.e=p,this.b=-1,this.d=null,this.a=new u(512,b=>this.g(b))}add(p,b){this.d&&(this.b!==b||!y.isEqual(this.c,p.uri))&&(this.f(),this.d=null),this.d||(this.b=b,this.d={resource:p.uri,results:[]}),this.d.results.push(D(p))}f(){const p=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,p)}flush(){this.f(),this.a.flush()}g(p){this.e(p)}}e.TextSearchResultsCollector=k;function D(h){return f(h)?{preview:{matches:(0,a.mapArrayOrNot)(h.preview.matches,p=>({startLineNumber:p.start.line,startColumn:p.start.character,endLineNumber:p.end.line,endColumn:p.end.character})),text:h.preview.text},ranges:(0,a.mapArrayOrNot)(h.ranges,p=>({startLineNumber:p.start.line,startColumn:p.start.character,endLineNumber:p.end.line,endColumn:p.end.character}))}:{text:h.text,lineNumber:h.lineNumber}}function f(h){return!!h.preview}e.extensionResultIsMatch=f;class u{constructor(p,b){this.g=p,this.h=b,this.c=0,this.d=[],this.e=0}addItem(p,b){!p||this.j(p,b)}addItems(p,b){!p||this.k(p,b)}j(p,b){this.d.push(p),this.e+=b,this.l()}k(p,b){this.d=this.d.concat(p),this.e+=b,this.l()}l(){this.c<u.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},u.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}u.a=4e3,u.b=50,e.BatchedCollector=u}),define(ye[86],De([1,0,6,5,4,294,18,57,13,2,143]),function(re,e,a,L,l,R,S,A,y,I,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,l.createDecorator)("IExtHostSearch");let P=class{constructor(f,u,h){this.k=f,this.l=u,this.n=h,this.c=this.k.getProxy(L.MainContext.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new R.FileSearchManager}o(f){return this.l.transformOutgoingScheme(f)}registerTextSearchProvider(f,u){if(this.g.has(f))throw new Error(`a text search provider for the scheme '${f}' is already registered`);this.g.add(f);const h=this.d++;return this.e.set(h,u),this.c.$registerTextSearchProvider(h,this.o(f)),(0,a.toDisposable)(()=>{this.g.delete(f),this.e.delete(h),this.c.$unregisterProvider(h)})}registerFileSearchProvider(f,u){if(this.i.has(f))throw new Error(`a file search provider for the scheme '${f}' is already registered`);this.i.add(f);const h=this.d++;return this.h.set(h,u),this.c.$registerFileSearchProvider(h,this.o(f)),(0,a.toDisposable)(()=>{this.i.delete(f),this.h.delete(h),this.c.$unregisterProvider(h)})}$provideFileSearchResults(f,u,h,p){const b=v(h),C=this.h.get(f);if(C)return this.j.fileSearch(b,C,g=>{this.c.$handleFileMatch(f,u,g.map(i=>i.resource))},p);throw new Error("unknown provider: "+f)}$clearCache(f){return this.j.clearCache(f),Promise.resolve(void 0)}$provideTextSearchResults(f,u,h,p){const b=this.e.get(f);if(!b||!b.provideTextSearchResults)throw new Error(`Unknown provider ${f}`);const C=v(h);return this.q(C,b).search(i=>this.c.$handleTextMatch(f,u,i),p)}$enableExtensionHostSearch(){}q(f,u){return new O.TextSearchManager(f,u,{readdir:h=>Promise.resolve([]),toCanonicalName:h=>h},"textSearchProvider")}};P=qe([ze(0,S.IExtHostRpcService),ze(1,A.IURITransformerService),ze(2,y.ILogService)],P),e.ExtHostSearch=P;function v(D){return{...D,folderQueries:D.folderQueries&&D.folderQueries.map(k),extraFileResources:D.extraFileResources&&D.extraFileResources.map(f=>I.URI.revive(f))}}e.reviveQuery=v;function k(D){return{...D,folder:I.URI.revive(D.folder)}}}),define(ye[302],De([1,0,90,142,34,139,35,40,60,41,83,85,86,99,56,78,141,79,48,98,77,61,140,13,219,49,97]),function(re,e,a,L,l,R,S,A,y,I,O,P,v,k,D,f,u,h,p,b,C,g,i,s,r,o,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,a.registerSingleton)(c.IExtHostLocalizationService,c.ExtHostLocalizationService,1),(0,a.registerSingleton)(s.ILoggerService,i.ExtHostLoggerService,1),(0,a.registerSingleton)(s.ILogService,r.ExtHostLogService,1),(0,a.registerSingleton)(f.IExtHostApiDeprecationService,f.ExtHostApiDeprecationService,1),(0,a.registerSingleton)(A.IExtHostCommands,A.ExtHostCommands,0),(0,a.registerSingleton)(S.IExtHostConfiguration,S.ExtHostConfiguration,0),(0,a.registerSingleton)(h.IExtHostConsumerFileSystem,h.ExtHostConsumerFileSystem,0),(0,a.registerSingleton)(P.IExtHostDebugService,P.WorkerExtHostDebugService,0),(0,a.registerSingleton)(R.IExtHostDecorations,R.ExtHostDecorations,0),(0,a.registerSingleton)(y.IExtHostDocumentsAndEditors,y.ExtHostDocumentsAndEditors,0),(0,a.registerSingleton)(p.IExtHostFileSystemInfo,p.ExtHostFileSystemInfo,0),(0,a.registerSingleton)(L.IExtHostOutputService,L.ExtHostOutputService,1),(0,a.registerSingleton)(v.IExtHostSearch,v.ExtHostSearch,0),(0,a.registerSingleton)(k.IExtHostStorage,k.ExtHostStorage,0),(0,a.registerSingleton)(O.IExtHostTask,O.WorkerExtHostTask,0),(0,a.registerSingleton)(I.IExtHostTerminalService,I.WorkerExtHostTerminalService,0),(0,a.registerSingleton)(D.IExtHostTunnelService,D.ExtHostTunnelService,0),(0,a.registerSingleton)(u.IExtHostWindow,u.ExtHostWindow,0),(0,a.registerSingleton)(l.IExtHostWorkspace,l.ExtHostWorkspace,0),(0,a.registerSingleton)(b.IExtHostSecretState,b.ExtHostSecretState,0),(0,a.registerSingleton)(C.IExtHostTelemetry,C.ExtHostTelemetry,0),(0,a.registerSingleton)(g.IExtHostEditorTabs,g.ExtHostEditorTabs,0),(0,a.registerSingleton)(o.IExtHostVariableResolverProvider,o.ExtHostVariableResolverProviderService,0)}),define(ye[100],De([1,0,15,13,31,82]),function(re,e,a,L,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutputChannel=e.createTextSearchResult=e.anchorGlob=void 0;function S(P){return P.startsWith("**")||P.startsWith("/")?P:`/${P}`}e.anchorGlob=S;function A(P,v,k,D){const f=(0,a.mapArrayOrNot)(k,y),u=new l.TextSearchMatch(v,f,D),h=u.preview.matches;return{ranges:(0,a.mapArrayOrNot)(f,I),uri:P,preview:{text:u.preview.text,matches:(0,a.mapArrayOrNot)(h,I)}}}e.createTextSearchResult=A;function y(P){return new l.SearchRange(P.start.line,P.start.character,P.end.line,P.end.character)}function I(P){return new R.Range(P.startLineNumber,P.startColumn,P.endLineNumber,P.endColumn)}let O=class{constructor(v,k){this.a=v,this.b=k}appendLine(v){this.b.debug(`${this.a}#search`,v)}};O=qe([ze(1,L.ILogService)],O),e.OutputChannel=O}),define(ye[303],De([1,0,46,9,87,32,12,8,100,304]),function(re,e,a,L,l,R,S,A,y,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fixDriveC=e.getAbsoluteGlob=e.spawnRipgrepCmd=void 0;const O=I.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");function P(b,C,g,i){const s=v(b,C,g,i),r=C.folder.fsPath;return{cmd:a.spawn(O,s.args,{cwd:r}),rgDiskPath:O,siblingClauses:s.siblingClauses,rgArgs:s,cwd:r}}e.spawnRipgrepCmd=P;function v(b,C,g,i){const s=["--files","--hidden","--case-sensitive"];D([C],g,!1).forEach(o=>{const c=(0,y.anchorGlob)(o);if(s.push("-g",c),S.isMacintosh){const m=(0,l.normalizeNFD)(c);m!==c&&s.push("-g",m)}});const r=k([C],i,void 0,!1);return r.globArgs.forEach(o=>{const c=`!${(0,y.anchorGlob)(o)}`;if(s.push("-g",c),S.isMacintosh){const m=(0,l.normalizeNFD)(c);m!==c&&s.push("-g",m)}}),C.disregardIgnoreFiles!==!1?s.push("--no-ignore"):C.disregardParentIgnoreFiles!==!1&&s.push("--no-ignore-parent"),C.ignoreSymlinks||s.push("--follow"),b.exists&&s.push("--quiet"),s.push("--no-config"),C.disregardGlobalIgnoreFiles&&s.push("--no-ignore-global"),{args:s,siblingClauses:r.siblingClauses}}function k(b,C,g,i=!0){const s=[];let r={};return b.forEach(o=>{const c=Object.assign({},o.excludePattern||{},C||{}),m=f(c,i?o.folder.fsPath:void 0,g);s.push(...m.globArgs),m.siblingClauses&&(r=Object.assign(r,m.siblingClauses))}),{globArgs:s,siblingClauses:r}}function D(b,C,g=!0){const i=[];return b.forEach(s=>{const r=Object.assign({},C||{},s.includePattern||{}),o=f(r,g?s.folder.fsPath:void 0);i.push(...o.globArgs)}),i}function f(b,C,g){const i=[],s={};return Object.keys(b).forEach(r=>{if(g&&g.has(r)||!r)return;const o=b[r];r=h(C?u(C,r):r),r.startsWith("\\\\")?r="\\\\"+r.substr(2).replace(/\\/g,"/"):r=r.replace(/\\/g,"/"),typeof o=="boolean"&&o?(r.startsWith("\\\\")&&(r+="**"),i.push(p(r))):o&&o.when&&(s[r]=o)}),{globArgs:i,siblingClauses:s}}function u(b,C){return L.isAbsolute(C)?C:L.join(b,C)}e.getAbsoluteGlob=u;function h(b){return b=A.rtrim(b,"\\"),A.rtrim(b,"/")}function p(b){return R.getRoot(b).toLowerCase()==="c:/"?b.replace(/^c:[/\\]/i,"/"):b}e.fixDriveC=p}),define(ye[305],De([1,0,46,52,9,306,15,45,38,87,32,12,43,8,10,29,31,303,107]),function(re,e,a,L,l,R,S,A,y,I,O,P,v,k,D,f,u,h,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Engine=e.FileWalker=void 0;const b=new Set;process.on("exit",()=>{b.forEach(r=>r())});class C{constructor(o){this.c=null,this.h=null,this.l=!1,this.m=null,this.r=null,this.s=0,this.a=o,this.b=o.filePattern||"",this.d=o.includePattern&&y.parse(o.includePattern),this.f=o.maxResults||null,this.g=!!o.exists,this.v=Object.create(null),this.k=0,this.j=!1,this.o=0,this.p=0,this.q=[],this.b&&(this.c=(0,p.prepareQuery)(this.b).normalizedLowercase),this.u=o.excludePattern&&y.parse(o.excludePattern),this.t=new Map,o.folderQueries.forEach(c=>{const m=Object.assign({},c.excludePattern||{},this.a.excludePattern||{}),n=c.folder.fsPath;o.folderQueries.map(t=>t.folder.fsPath).filter(t=>t!==n).forEach(t=>{(0,O.isEqualOrParent)(t,n)&&(m[l.relative(n,t)]=!0)}),this.t.set(n,new i(m,n))})}cancel(){this.l=!0,b.forEach(o=>o())}walk(o,c,m,n,t){if(this.m=v.StopWatch.create(!1),this.l)return t(null,this.j);c.forEach(d=>{const E=l.basename(d.fsPath);this.u&&this.u(d.fsPath,E)||this.J(m,{relativePath:d.fsPath,searchPath:void 0})}),this.r=v.StopWatch.create(!1),this.w(o,(d,E)=>{this.x(this.y,this,d,m,n,w=>{if(w){const N=(0,A.toErrorMessage)(w);console.error(N),this.q.push(N),E(w,void 0)}else E(null,void 0)})},(d,E)=>{this.m.stop();const w=d?S.coalesce(d)[0]:null;t(w,this.j)})}w(o,c,m){const n=new Array(o.length),t=new Array(o.length);let d=!1,E=0;if(o.length===0)return m(null,[]);o.forEach((w,N)=>{c(w,(j,V)=>{if(j?(d=!0,n[N]=null,t[N]=j):(n[N]=V,t[N]=null),++E===o.length)return m(d?t:null,n)})})}x(o,c,...m){try{o.apply(c,m)}catch(n){m[m.length-1](n)}}y(o,c,m,n){const t=o.folder.fsPath,d=P.isMacintosh,E=()=>Q&&Q.kill();b.add(E);let w=F=>{b.delete(E),w=()=>{},n(F)},N="";const j=this.D(),V=(0,h.spawnRipgrepCmd)(this.a,o,this.a.includePattern,this.t.get(o.folder.fsPath).expression),Q=V.cmd,x=!Object.keys(V.siblingClauses).length,U=V.rgArgs.args.map(F=>F.match(/^-/)?F:`'${F}'`).join(" ");let T=`${V.rgDiskPath} ${U}
 - cwd: ${V.cwd}`;V.rgArgs.siblingClauses&&(T+=`
 - Sibling clauses: ${JSON.stringify(V.rgArgs.siblingClauses)}`),m({message:T}),this.s=0,this.z(Q,"utf8",m,(F,B,Z)=>{if(F){w(F);return}if(this.j){w();return}const H=(N+(d?I.normalizeNFC(B||""):B)).split(`
`);if(Z){const Y=H.length;H[Y-1]=H[Y-1].trim(),H[Y-1]||H.pop()}else N=H.pop()||"";if(H.length&&H[0].indexOf(`
`)!==-1){w(new Error("Splitting up files failed"));return}if(this.s+=H.length,x){for(const Y of H)if(this.J(c,{base:t,relativePath:Y,searchPath:this.N(o,Y)}),this.j){E();break}(Z||this.j)&&w();return}this.G(o,j,t,H,c),Z&&(this.H(j,t,c),w())})}spawnFindCmd(o){const c=this.t.get(o.folder.fsPath),m=c.getBasenameTerms(),n=c.getPathTerms(),t=["-L","."];if(m.length||n.length){t.push("-not","(","(");for(const d of m)t.push("-name",d),t.push("-o");for(const d of n)t.push("-path",d),t.push("-o");t.pop(),t.push(")","-prune",")")}return t.push("-type","f"),a.spawn("find",t,{cwd:o.folder.fsPath})}readStdout(o,c,m){let n="";this.z(o,c,()=>{},(t,d,E)=>{if(t){m(t);return}n+=d,E&&m(null,n)})}z(o,c,m,n){let t=(w,N,j)=>{(w||j)&&(t=()=>{},this.r?.stop()),n(w,N,j)},d=!1;o.stdout?(this.A(o.stdout,c,t),o.stdout.once("data",()=>d=!0)):m({message:"stdout is null"});let E;o.stderr?E=this.B(o.stderr):m({message:"stderr is null"}),o.on("error",w=>{t(w)}),o.on("close",w=>{let N;!d&&(N=this.C(E,c))&&s(N)?t(new Error(`command failed with error code ${w}: ${this.C(E,c)}`)):(this.g&&w===0&&(this.j=!0),t(null,"",!0))})}A(o,c,m){const n=new R.StringDecoder(c);return o.on("data",t=>{m(null,n.write(t))}),n}B(o){const c=[];return o.on("data",m=>{c.push(m)}),c}C(o,c){const m=new R.StringDecoder(c);return o.map(n=>m.write(n)).join("")}D(){const o={rootEntries:[],pathToEntries:Object.create(null)};return o.pathToEntries["."]=o.rootEntries,o}G(o,{pathToEntries:c},m,n,t){n.indexOf(this.b)!==-1&&this.J(t,{base:m,relativePath:this.b,searchPath:this.N(o,this.b)});const d=E=>{const w=l.basename(E),N=l.dirname(E);let j=c[N];j||(j=c[N]=[],d(N)),j.push({base:m,relativePath:E,basename:w,searchPath:this.N(o,E)})};n.forEach(d)}H({rootEntries:o,pathToEntries:c},m,n){const t=this,d=this.t.get(m),E=this.b;function w(N){t.o++;const j=(0,u.hasSiblingFn)(()=>N.map(V=>V.basename));for(let V=0,Q=N.length;V<Q;V++){const x=N[V],{relativePath:U,basename:T}=x;if(d.test(U,T,E!==T?j:void 0))continue;const F=c[U];if(F)w(F);else{if(t.p++,U===E)continue;t.J(n,x)}if(t.j)break}}w(o)}getStats(){return{cmdTime:this.r.elapsed(),fileWalkTime:this.m.elapsed(),directoriesWalked:this.o,filesWalked:this.p,cmdResultCount:this.s}}I(o,c,m,n,t){const d=o.folder,E=(0,u.hasSiblingFn)(()=>m);this.w(m,(w,N)=>{if(this.l||this.j)return N(null);const j=c?[c,w].join(l.sep):w;if(this.t.get(o.folder.fsPath).test(j,w,this.a.filePattern!==w?E:void 0))return N(null);const V=[d.fsPath,j].join(l.sep);L.lstat(V,(Q,x)=>{if(Q||this.l||this.j)return N(null);this.L(V,x,(U,T)=>U||this.l||this.j?N(null):T.isDirectory()?(this.o++,this.M(V,x,(F,B)=>F||this.l||this.j||(B=B||"",this.v[B])?N(null):(this.v[B]=!0,f.Promises.readdir(V).then(Z=>{if(this.l||this.j)return N(null);this.I(o,j,Z,n,_=>N(_||null))},Z=>{N(null)})))):(this.p++,j===this.b||this.h&&D.isNumber(T.size)&&T.size>this.h||this.J(n,{base:d.fsPath,relativePath:j,searchPath:this.N(o,j)}),N(null,void 0)))})},w=>{const N=w&&S.coalesce(w);return t(N&&N.length>0?N[0]:void 0)})}J(o,c){this.K(c)&&(!this.d||this.d(c.relativePath,l.basename(c.relativePath)))&&(this.k++,(this.g||this.f&&this.k>this.f)&&(this.j=!0),this.j||o(c))}K(o){if(this.b){if(this.b==="*")return!0;if(this.c)return(0,u.isFilePatternMatch)(o,this.c)}return!0}L(o,c,m){return c.isSymbolicLink()?L.stat(o,m):m(null,c)}M(o,c,m){return c.isSymbolicLink()?L.realpath(o,(n,t)=>n?m(n):m(null,t)):m(null,o)}N(o,c){return o.folderName?l.join(o.folderName,c):c}}e.FileWalker=C;class g{constructor(o){this.a=o.folderQueries,this.b=o.extraFileResources||[],this.c=new C(o)}search(o,c,m){this.c.walk(this.a,this.b,o,c,(n,t)=>{m(n,{limitHit:t,stats:this.c.getStats(),messages:[]})})}cancel(){this.c.cancel()}}e.Engine=g;class i{constructor(o,c){this.expression=o,this.c=c,this.d(o)}d(o){let c,m;Object.keys(o).filter(n=>o[n]).forEach(n=>{l.isAbsolute(n)?(c=c||y.getEmptyExpression(),c[n]=o[n]):(m=m||y.getEmptyExpression(),m[n]=o[n])}),this.a=c&&y.parse(c,{trimForExclusions:!0}),this.b=m&&y.parse(m,{trimForExclusions:!0})}test(o,c,m){return this.b&&this.b(o,c,m)||this.a&&this.a(l.join(this.c,o),c,m)}getBasenameTerms(){const o=[];return this.a&&o.push(...y.getBasenameTerms(this.a)),this.b&&o.push(...y.getBasenameTerms(this.b)),o}getPathTerms(){const o=[];return this.a&&o.push(...y.getPathTerms(this.a)),this.b&&o.push(...y.getPathTerms(this.b)),o}}function s(r){const o=r.trim().split(`
`),c=o[0].trim();if(c.startsWith("Error parsing regex"))return c;if(c.startsWith("regex parse error"))return k.uppercaseFirstLetter(o[o.length-1].trim());if(c.startsWith("error parsing glob")||c.startsWith("unsupported encoding"))return c.charAt(0).toUpperCase()+c.substr(1);if(c==="Literal '\\n' not allowed.")return"Literal '\\n' currently not supported";if(c.startsWith("Literal "))return c}}),define(ye[307],De([1,0,105,22]),function(re,e,a,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SUPPORTED_ENCODINGS=e.detectEncodingFromBuffer=e.toCanonicalName=e.detectEncodingByBOMFromBuffer=e.toNodeEncoding=e.encodingExists=e.toEncodeReadable=e.toDecodeStream=e.DecodeStreamError=e.DecodeStreamErrorKind=e.UTF8_BOM=e.UTF16le_BOM=e.UTF16be_BOM=e.isUTFEncoding=e.UTF16le=e.UTF16be=e.UTF8_with_bom=e.UTF8=void 0,e.UTF8="utf8",e.UTF8_with_bom="utf8bom",e.UTF16be="utf16be",e.UTF16le="utf16le";function l(r){return[e.UTF8,e.UTF8_with_bom,e.UTF16be,e.UTF16le].some(o=>o===r)}e.isUTFEncoding=l,e.UTF16be_BOM=[254,255],e.UTF16le_BOM=[255,254],e.UTF8_BOM=[239,187,191];const R=512,S=512,A=512*8,y=512*128;var I;(function(r){r[r.STREAM_IS_BINARY=1]="STREAM_IS_BINARY"})(I=e.DecodeStreamErrorKind||(e.DecodeStreamErrorKind={}));class O extends Error{constructor(o,c){super(o),this.decodeStreamErrorKind=c}}e.DecodeStreamError=O;class P{static async create(o){let c;if(o!==e.UTF8)c=(await new Promise((n,t)=>{re(["@vscode/iconv-lite-umd"],n,t)})).getDecoder(f(o));else{const m=new TextDecoder;c={write(n){return m.decode(n,{stream:!0})},end(){return m.decode()}}}return new P(c)}constructor(o){this.a=o}write(o){return this.a.write(o)}end(){return this.a.end()}}function v(r,o){const c=o.minBytesRequiredForDetection??o.guessEncoding?A:S;return new Promise((m,n)=>{const t=(0,a.newWriteableStream)(V=>V.join("")),d=[];let E=0,w;const N=async()=>{try{const V=await s({buffer:L.VSBuffer.concat(d),bytesRead:E},o.guessEncoding);if(V.seemsBinary&&o.acceptTextOnly)throw new O("Stream is binary but only text is accepted for decoding",1);V.encoding=await o.overwriteEncoding(V.encoding),w=await P.create(V.encoding);const Q=w.write(L.VSBuffer.concat(d).buffer);t.write(Q),d.length=0,E=0,m({stream:t,detected:V})}catch(V){j?.dispose(),t.destroy(),n(V)}},j=(0,a.listenStream)(r,{onData:async V=>{w?t.write(w.write(V.buffer)):(d.push(V),E+=V.byteLength,E>=c&&(r.pause(),await N(),setTimeout(()=>r.resume())))},onError:V=>t.error(V),onEnd:async()=>{w||await N(),t.end(w?.end())}})})}e.toDecodeStream=v;async function k(r,o,c){const n=(await new Promise((E,w)=>{re(["@vscode/iconv-lite-umd"],E,w)})).getEncoder(f(o),c);let t=!1,d=!1;return{read(){if(d)return null;const E=r.read();if(typeof E!="string"){if(d=!0,!t&&c?.addBOM)switch(o){case e.UTF8:case e.UTF8_with_bom:return L.VSBuffer.wrap(Uint8Array.from(e.UTF8_BOM));case e.UTF16be:return L.VSBuffer.wrap(Uint8Array.from(e.UTF16be_BOM));case e.UTF16le:return L.VSBuffer.wrap(Uint8Array.from(e.UTF16le_BOM))}const w=n.end();return w&&w.length>0?(t=!0,L.VSBuffer.wrap(w)):null}return t=!0,L.VSBuffer.wrap(n.write(E))}}}e.toEncodeReadable=k;async function D(r){return(await new Promise((c,m)=>{re(["@vscode/iconv-lite-umd"],c,m)})).encodingExists(f(r))}e.encodingExists=D;function f(r){return r===e.UTF8_with_bom||r===null?e.UTF8:r}e.toNodeEncoding=f;function u(r,o){if(!r||o<e.UTF16be_BOM.length)return null;const c=r.readUInt8(0),m=r.readUInt8(1);if(c===e.UTF16be_BOM[0]&&m===e.UTF16be_BOM[1])return e.UTF16be;if(c===e.UTF16le_BOM[0]&&m===e.UTF16le_BOM[1])return e.UTF16le;if(o<e.UTF8_BOM.length)return null;const n=r.readUInt8(2);return c===e.UTF8_BOM[0]&&m===e.UTF8_BOM[1]&&n===e.UTF8_BOM[2]?e.UTF8_with_bom:null}e.detectEncodingByBOMFromBuffer=u;const h=["ascii","utf-16","utf-32"];async function p(r){const o=await new Promise((d,E)=>{re(["jschardet"],d,E)}),c=r.slice(0,y),m=g(c.buffer),n=o.detect(m);if(!n||!n.encoding)return null;const t=n.encoding.toLowerCase();return 0<=h.indexOf(t)?null:C(n.encoding)}const b={ibm866:"cp866",big5:"cp950"};function C(r){const o=r.replace(/[^a-zA-Z0-9]/g,"").toLowerCase();return b[o]||o}function g(r){let o="";for(let c=0;c<r.length;c++)o+=String.fromCharCode(r[c]);return o}function i(r){switch(r){case"shiftjis":return"shift-jis";case"utf16le":return"utf-16le";case"utf16be":return"utf-16be";case"big5hkscs":return"big5-hkscs";case"eucjp":return"euc-jp";case"euckr":return"euc-kr";case"koi8r":return"koi8-r";case"koi8u":return"koi8-u";case"macroman":return"x-mac-roman";case"utf8bom":return"utf8";default:{const o=r.match(/windows(\d+)/);return o?"windows-"+o[1]:r}}}e.toCanonicalName=i;function s({buffer:r,bytesRead:o},c){let m=u(r,o),n=!1;if(m!==e.UTF16be&&m!==e.UTF16le&&r){let t=!0,d=!0,E=!1;for(let w=0;w<o&&w<R;w++){const N=w%2===1,j=r.readUInt8(w)===0;if(j&&(E=!0),t&&(N&&!j||!N&&j)&&(t=!1),d&&(N&&j||!N&&!j)&&(d=!1),j&&!t&&!d)break}E&&(t?m=e.UTF16le:d?m=e.UTF16be:n=!0)}return c&&!n&&!m&&r?p(r.slice(0,o)).then(t=>({seemsBinary:!1,encoding:t})):{seemsBinary:n,encoding:m}}e.detectEncodingFromBuffer=s,e.SUPPORTED_ENCODINGS={utf8:{labelLong:"UTF-8",labelShort:"UTF-8",order:1,alias:"utf8bom"},utf8bom:{labelLong:"UTF-8 with BOM",labelShort:"UTF-8 with BOM",encodeOnly:!0,order:2,alias:"utf8"},utf16le:{labelLong:"UTF-16 LE",labelShort:"UTF-16 LE",order:3},utf16be:{labelLong:"UTF-16 BE",labelShort:"UTF-16 BE",order:4},windows1252:{labelLong:"Western (Windows 1252)",labelShort:"Windows 1252",order:5},iso88591:{labelLong:"Western (ISO 8859-1)",labelShort:"ISO 8859-1",order:6},iso88593:{labelLong:"Western (ISO 8859-3)",labelShort:"ISO 8859-3",order:7},iso885915:{labelLong:"Western (ISO 8859-15)",labelShort:"ISO 8859-15",order:8},macroman:{labelLong:"Western (Mac Roman)",labelShort:"Mac Roman",order:9},cp437:{labelLong:"DOS (CP 437)",labelShort:"CP437",order:10},windows1256:{labelLong:"Arabic (Windows 1256)",labelShort:"Windows 1256",order:11},iso88596:{labelLong:"Arabic (ISO 8859-6)",labelShort:"ISO 8859-6",order:12},windows1257:{labelLong:"Baltic (Windows 1257)",labelShort:"Windows 1257",order:13},iso88594:{labelLong:"Baltic (ISO 8859-4)",labelShort:"ISO 8859-4",order:14},iso885914:{labelLong:"Celtic (ISO 8859-14)",labelShort:"ISO 8859-14",order:15},windows1250:{labelLong:"Central European (Windows 1250)",labelShort:"Windows 1250",order:16},iso88592:{labelLong:"Central European (ISO 8859-2)",labelShort:"ISO 8859-2",order:17},cp852:{labelLong:"Central European (CP 852)",labelShort:"CP 852",order:18},windows1251:{labelLong:"Cyrillic (Windows 1251)",labelShort:"Windows 1251",order:19},cp866:{labelLong:"Cyrillic (CP 866)",labelShort:"CP 866",order:20},iso88595:{labelLong:"Cyrillic (ISO 8859-5)",labelShort:"ISO 8859-5",order:21},koi8r:{labelLong:"Cyrillic (KOI8-R)",labelShort:"KOI8-R",order:22},koi8u:{labelLong:"Cyrillic (KOI8-U)",labelShort:"KOI8-U",order:23},iso885913:{labelLong:"Estonian (ISO 8859-13)",labelShort:"ISO 8859-13",order:24},windows1253:{labelLong:"Greek (Windows 1253)",labelShort:"Windows 1253",order:25},iso88597:{labelLong:"Greek (ISO 8859-7)",labelShort:"ISO 8859-7",order:26},windows1255:{labelLong:"Hebrew (Windows 1255)",labelShort:"Windows 1255",order:27},iso88598:{labelLong:"Hebrew (ISO 8859-8)",labelShort:"ISO 8859-8",order:28},iso885910:{labelLong:"Nordic (ISO 8859-10)",labelShort:"ISO 8859-10",order:29},iso885916:{labelLong:"Romanian (ISO 8859-16)",labelShort:"ISO 8859-16",order:30},windows1254:{labelLong:"Turkish (Windows 1254)",labelShort:"Windows 1254",order:31},iso88599:{labelLong:"Turkish (ISO 8859-9)",labelShort:"ISO 8859-9",order:32},windows1258:{labelLong:"Vietnamese (Windows 1258)",labelShort:"Windows 1258",order:33},gbk:{labelLong:"Simplified Chinese (GBK)",labelShort:"GBK",order:34},gb18030:{labelLong:"Simplified Chinese (GB18030)",labelShort:"GB18030",order:35},cp950:{labelLong:"Traditional Chinese (Big5)",labelShort:"Big5",order:36},big5hkscs:{labelLong:"Traditional Chinese (Big5-HKSCS)",labelShort:"Big5-HKSCS",order:37},shiftjis:{labelLong:"Japanese (Shift JIS)",labelShort:"Shift JIS",order:38},eucjp:{labelLong:"Japanese (EUC-JP)",labelShort:"EUC-JP",order:39},euckr:{labelLong:"Korean (EUC-KR)",labelShort:"EUC-KR",order:40},windows874:{labelLong:"Thai (Windows 874)",labelShort:"Windows 874",order:41},iso885911:{labelLong:"Latin/Thai (ISO 8859-11)",labelShort:"ISO 8859-11",order:42},koi8ru:{labelLong:"Cyrillic (KOI8-RU)",labelShort:"KOI8-RU",order:43},koi8t:{labelLong:"Tajik (KOI8-T)",labelShort:"KOI8-T",order:44},gb2312:{labelLong:"Simplified Chinese (GB 2312)",labelShort:"GB 2312",order:45},cp865:{labelLong:"Nordic DOS (CP 865)",labelShort:"CP 865",order:46},cp850:{labelLong:"Western European DOS (CP 850)",labelShort:"CP 850",order:47}}}),define(ye[144],De([1,0,307,29,143]),function(re,e,a,L,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeTextSearchManager=void 0;class R extends l.TextSearchManager{constructor(A,y,I=L,O="searchProcess"){super(A,y,{readdir:P=>I.Promises.readdir(P.fsPath),toCanonicalName:P=>(0,a.toCanonicalName)(P)},O)}}e.NativeTextSearchManager=R}),define(ye[308],De([1,0]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class a{constructor(){this.a=new Map,this.b=new Map}removeDragOperationTransfer(l){if(l&&this.a.has(l)){const R=this.a.get(l);return this.a.delete(l),R}}addDragOperationTransfer(l,R){this.a.set(l,R)}getRenderedTreeElement(l){if(this.b.has(l))return this.b.get(l)}addRenderedTreeItemElement(l,R){this.b.set(l,R)}removeRenderedTreeItemElement(l){this.b.has(l)&&this.b.delete(l)}}e.TreeviewsService=a}),define(ye[309],De([1,0,182,7,24,2,3,6,225,17,7,10,15,14,21,308,26]),function(re,e,a,L,l,R,S,A,y,I,O,P,v,k,D,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function h(C,g){if((0,P.isString)(C))return{label:C};if(C&&typeof C=="object"&&typeof C.label=="string"){let i;return Array.isArray(C.highlights)&&(i=C.highlights.filter(s=>s.length===2&&typeof s[0]=="number"&&typeof s[1]=="number"),i=i.length?i:void 0),{label:C.label,highlights:i}}}class p{constructor(g,i,s){this.d=g,this.e=i,this.f=s,this.a=new Map,this.b=new f.TreeviewsService;function r(o){return o&&o.$treeViewId&&(o.$treeItemHandle||o.$selectedTreeItems||o.$focusedTreeItem)}i.registerArgumentProcessor({processArgument:o=>r(o)?this.i(o):Array.isArray(o)&&o.length>0?o.map(c=>r(c)?this.i(c):c):o})}registerTreeDataProvider(g,i,s){const r=this.createTreeView(g,{treeDataProvider:i},s);return{dispose:()=>r.dispose()}}createTreeView(g,i,s){if(!i||!i.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const r=i.dragAndDropController?.dropMimeTypes??[],o=i.dragAndDropController?.dragMimeTypes??[],c=!!i.dragAndDropController?.handleDrag,m=!!i.dragAndDropController?.handleDrop,n=this.h(g,i,s),t=this.d.$registerTreeViewDataProvider(g,{showCollapseAll:!!i.showCollapseAll,canSelectMany:!!i.canSelectMany,dropMimeTypes:r,dragMimeTypes:o,hasHandleDrag:c,hasHandleDrop:m});return{get onDidCollapseElement(){return n.onDidCollapseElement},get onDidExpandElement(){return n.onDidExpandElement},get selection(){return n.selectedElements},get onDidChangeSelection(){return n.onDidChangeSelection},get visible(){return n.visible},get onDidChangeVisibility(){return n.onDidChangeVisibility},get onDidChangeCheckboxState(){return(0,u.checkProposedApiEnabled)(s,"treeItemCheckbox"),n.onDidChangeCheckboxState},get message(){return n.message},set message(d){n.message=d},get title(){return n.title},set title(d){n.title=d},get description(){return n.description},set description(d){n.description=d},get badge(){return n.badge},set badge(d){d!==void 0&&O.ViewBadge.isViewBadge(d)?n.badge={value:Math.floor(Math.abs(d.value)),tooltip:d.tooltip}:d===void 0&&(n.badge=void 0)},reveal:(d,E)=>n.reveal(d,E),dispose:async()=>{await t,this.a.delete(g),n.dispose()}}}$getChildren(g,i){const s=this.a.get(g);return s?s.getChildren(i):Promise.reject(new y.NoTreeViewError(g))}async $handleDrop(g,i,s,r,o,c,m,n){const t=this.a.get(g);if(!t)return Promise.reject(new y.NoTreeViewError(g));const d=k.DataTransfer.toDataTransfer(s,async E=>(await this.d.$resolveDropFileData(g,i,E)).buffer);return m===g&&n&&await this.g(d,t,n,o,c),t.onDrop(d,r,o)}async g(g,i,s,r,o){const c=this.b.removeDragOperationTransfer(o);if(c)(await c)?.forEach((m,n)=>{m&&g.set(n,m)});else if(o&&i.handleDrag){const m=i.handleDrag(s,g,r);this.b.addDragOperationTransfer(o,m),await m}return g}async $handleDrag(g,i,s,r){const o=this.a.get(g);if(!o)return Promise.reject(new y.NoTreeViewError(g));const c=await this.g(new L.DataTransfer,o,i,r,s);if(!!c)return k.DataTransfer.toDataTransferDTO(c)}async $hasResolve(g){const i=this.a.get(g);if(!i)throw new y.NoTreeViewError(g);return i.hasResolve}$resolve(g,i,s){const r=this.a.get(g);if(!r)throw new y.NoTreeViewError(g);return r.resolveTreeItem(i,s)}$setExpanded(g,i,s){const r=this.a.get(g);if(!r)throw new y.NoTreeViewError(g);r.setExpanded(i,s)}$setSelection(g,i){const s=this.a.get(g);if(!s)throw new y.NoTreeViewError(g);s.setSelection(i)}$setFocus(g,i){const s=this.a.get(g);if(!s)throw new y.NoTreeViewError(g);s.setFocus(i)}$setVisible(g,i){const s=this.a.get(g);if(!s)throw new y.NoTreeViewError(g);s.setVisible(i)}$changeCheckboxState(g,i){const s=this.a.get(g);if(!s)throw new y.NoTreeViewError(g);s.setCheckboxState(i)}h(g,i,s){const r=new b(g,i,this.d,this.e.converter,this.f,s);return this.a.set(g,r),r}i(g){const i=this.a.get(g.$treeViewId);return i&&"$treeItemHandle"in g?i.getExtensionElement(g.$treeItemHandle):i&&"$focusedTreeItem"in g&&g.$focusedTreeItem?i.focusedElement:null}}e.ExtHostTreeViews=p;class b extends A.Disposable{get visible(){return this.k}get selectedElements(){return this.l.map(g=>this.getExtensionElement(g)).filter(g=>!(0,P.isUndefinedOrNull)(g))}get focusedElement(){return this.m?this.getExtensionElement(this.m):void 0}constructor(g,i,s,r,o,c){if(super(),this.C=g,this.D=s,this.F=r,this.G=o,this.H=c,this.h=void 0,this.i=new Map,this.j=new Map,this.k=!1,this.l=[],this.m=void 0,this.r=this.B(new S.Emitter),this.onDidExpandElement=this.r.event,this.s=this.B(new S.Emitter),this.onDidCollapseElement=this.s.event,this.t=this.B(new S.Emitter),this.onDidChangeSelection=this.t.event,this.u=this.B(new S.Emitter),this.onDidChangeVisibility=this.u.event,this.v=this.B(new S.Emitter),this.onDidChangeCheckboxState=this.v.event,this.w=this.B(new S.Emitter),this.y=Promise.resolve(),this.z=Promise.resolve(),this.I="",this.J="",this.S=new D.CancellationTokenSource,c.contributes&&c.contributes.views)for(const t in c.contributes.views)for(const d of c.contributes.views[t])d.id===g&&(this.J=d.name);this.f=i.treeDataProvider,this.g=i.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(t=>this.w.fire({message:!1,element:t})));let m,n;this.B(S.Event.debounce(this.w.event,(t,d)=>(t||(t={message:!1,elements:[]}),d.element!==!1&&(m||(m=new Promise(E=>n=E),this.y=this.y.then(()=>m)),Array.isArray(d.element)?t.elements.push(...d.element):t.elements.push(d.element)),d.message&&(t.message=!0),t),200,!0)(({message:t,elements:d})=>{d.length&&(this.z=this.z.then(()=>{const E=n;return m=null,this.U(d).then(()=>E())})),t&&this.D.$setMessage(this.C,this.I)}))}async getChildren(g){const i=g?this.getExtensionElement(g):void 0;if(g&&!i)return this.G.error(`No tree item with id '${g}' found.`),Promise.resolve([]);let s=this.Q(g);return s||(s=await this.R(i)),s?s.map(r=>r.item):void 0}getExtensionElement(g){return this.i.get(g)}reveal(g,i){i=i||{select:!0,focus:!1};const s=(0,P.isUndefinedOrNull)(i.select)?!0:i.select,r=(0,P.isUndefinedOrNull)(i.focus)?!1:i.focus,o=(0,P.isUndefinedOrNull)(i.expand)?!1:i.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):g?this.y.then(()=>this.N(g)).then(c=>this.P(g,c[c.length-1]).then(m=>this.D.$reveal(this.C,{item:m.item,parentChain:c.map(n=>n.item)},{select:s,focus:r,expand:o})),c=>this.G.error(c)):this.D.$reveal(this.C,void 0,{select:s,focus:r,expand:o})}get message(){return this.I}set message(g){this.I=g,this.w.fire({message:!0,element:!1})}get title(){return this.J}set title(g){this.J=g,this.D.$setTitle(this.C,g,this.L)}get description(){return this.L}set description(g){this.L=g,this.D.$setTitle(this.C,this.J,g)}get badge(){return this.M}set badge(g){this.M?.value===g?.value&&this.M?.tooltip===g?.tooltip||(this.M=k.ViewBadge.from(g),this.D.$setBadge(this.C,g))}setExpanded(g,i){const s=this.getExtensionElement(g);s&&(i?this.r.fire(Object.freeze({element:s})):this.s.fire(Object.freeze({element:s})))}setSelection(g){(0,v.equals)(this.l,g)||(this.l=g,this.t.fire(Object.freeze({selection:this.selectedElements})))}setFocus(g){this.m=g}setVisible(g){g!==this.k&&(this.k=g,this.u.fire(Object.freeze({visible:this.k})))}async setCheckboxState(g){const i=(await Promise.all(g.map(async s=>{const r=this.getExtensionElement(s.treeItemHandle);return r?{extensionItem:r,treeItem:await this.f.getTreeItem(r),newState:s.newState?O.TreeItemCheckboxState.Checked:O.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(s=>s!==void 0);i.forEach(s=>{s.treeItem.checkboxState=s.newState?O.TreeItemCheckboxState.Checked:O.TreeItemCheckboxState.Unchecked}),this.v.fire({items:i.map(s=>[s.extensionItem,s.newState])})}async handleDrag(g,i,s){const r=[];for(const o of g){const c=this.getExtensionElement(o);c&&r.push(c)}if(!(!this.g?.handleDrag||r.length===0))return await this.g.handleDrag(r,i,s),i}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(g,i,s){const r=i?this.getExtensionElement(i):void 0;if(!(!r&&i||!this.g?.handleDrop))return(0,I.asPromise)(()=>this.g?.handleDrop?this.g.handleDrop(r,g,s):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(g,i){if(!this.f.resolveTreeItem)return;const s=this.i.get(g);if(s){const r=this.j.get(s);if(r){const o=await this.f.resolveTreeItem(r.extensionItem,s,i)??r.extensionItem;return this.db(o),r.item.tooltip=this.ab(o.tooltip),r.item.command=this.bb(r.disposableStore,o.command),r.item}}}N(g){return this.O(g).then(i=>i?this.N(i).then(s=>this.P(i,s[s.length-1]).then(r=>(s.push(r),s))):Promise.resolve([]))}O(g){const i=this.j.get(g);return i?Promise.resolve(i.parent?this.i.get(i.parent.item.handle):void 0):(0,I.asPromise)(()=>this.f.getParent(g))}P(g,i){const s=this.j.get(g);return s?Promise.resolve(s):(0,I.asPromise)(()=>this.f.getTreeItem(g)).then(r=>this.gb(g,r,i,!0)).then(r=>this.getChildren(i?i.item.handle:void 0).then(()=>{const o=this.getExtensionElement(r);if(o){const c=this.j.get(o);if(c)return Promise.resolve(c)}throw new Error(`Cannot resolve tree item for element ${r}`)}))}Q(g){if(g){let i;if(typeof g=="string"){const s=this.getExtensionElement(g);i=s?this.j.get(s):void 0}else i=g;return i&&i.children||void 0}return this.h}async R(g){this.nb(g);const i=new D.CancellationTokenSource(this.S.token);try{const s=g?this.j.get(g):void 0,r=await this.f.getChildren(g);if(i.token.isCancellationRequested)return;const o=await Promise.all((0,v.coalesce)(r||[]).map(async c=>{const m=await this.f.getTreeItem(c);return m&&!i.token.isCancellationRequested?this.Z(c,m,s):null}));return i.token.isCancellationRequested?void 0:(0,v.coalesce)(o)}finally{i.dispose()}}U(g){if(g.some(s=>!s))return this.S.dispose(!0),this.S=new D.CancellationTokenSource,this.pb(),this.D.$refresh(this.C);{const s=this.W(g);if(s.length)return this.X(s)}return Promise.resolve(void 0)}W(g){const i=new Set,s=g.map(o=>this.j.get(o));for(const o of s)if(o&&!i.has(o.item.handle)){let c=o;for(;c&&c.parent&&s.findIndex(m=>c&&c.parent&&m&&m.item.handle===c.parent.item.handle)===-1;){const m=this.i.get(c.parent.item.handle);c=m?this.j.get(m):void 0}c&&!c.parent&&i.add(o.item.handle)}const r=[];return i.forEach(o=>{const c=this.i.get(o);if(c){const m=this.j.get(c);m&&(!m.parent||!i.has(m.parent.item.handle))&&r.push(o)}}),r}X(g){const i={};return Promise.all(g.map(s=>this.Y(s).then(r=>{r&&(i[s]=r.item)}))).then(()=>Object.keys(i).length?this.D.$refresh(this.C,i):void 0)}Y(g){const i=this.getExtensionElement(g);if(i){const s=this.j.get(i);if(s)return this.nb(i),(0,I.asPromise)(()=>this.f.getTreeItem(i)).then(r=>{if(r){const o=this.eb(i,r,s.parent);return this.lb(i,o,s,s.parent),s.dispose(),o}return null})}return Promise.resolve(null)}Z(g,i,s){const r=this.eb(g,i,s);if(i.id&&this.i.has(r.item.handle))throw new Error((0,a.localize)(0,null,i.id));return this.kb(g,r),this.mb(r,s),r}ab(g){return O.MarkdownString.isMarkdownString(g)?k.MarkdownString.from(g):g}bb(g,i){return i?{...this.F.toInternal(i,g),originalId:i.command}:void 0}cb(g){if(!g.checkboxState)return;let i,s;return typeof g.checkboxState=="number"?i=g.checkboxState:(i=g.checkboxState.state,s=g.checkboxState.tooltip),{isChecked:i===O.TreeItemCheckboxState.Checked,tooltip:s}}db(g){if(!O.TreeItem.isTreeItem(g,this.H))throw new Error(`Extension ${this.H.identifier.value} has provided an invalid tree item.`)}eb(g,i,s){this.db(i);const r=new A.DisposableStore,o=this.gb(g,i,s),c=this.hb(i);return{item:{handle:o,parentHandle:s?s.item.handle:void 0,label:h(i.label,this.H),description:i.description,resourceUri:i.resourceUri,tooltip:this.ab(i.tooltip),command:this.bb(r,i.command),contextValue:i.contextValue,icon:c,iconDark:this.ib(i)||c,themeIcon:this.fb(i),collapsibleState:(0,P.isUndefinedOrNull)(i.collapsibleState)?O.TreeItemCollapsibleState.None:i.collapsibleState,accessibilityInformation:i.accessibilityInformation,checkbox:this.cb(i)},extensionItem:i,parent:s,children:void 0,disposableStore:r,dispose(){r.dispose()}}}fb(g){return g.iconPath instanceof O.ThemeIcon?g.iconPath:void 0}gb(g,{id:i,label:s,resourceUri:r},o,c){if(i)return`${b.b}/${i}`;const m=h(s,this.H),n=o?o.item.handle:b.a;let t=m?m.label:r?(0,l.basename)(r):"";t=t.indexOf("/")!==-1?t.replace("/","//"):t;const d=this.j.has(g)?this.j.get(g).item.handle:void 0,E=this.Q(o)||[];let w,N=0;do{if(w=`${n}/${N}:${t}`,c||!this.i.has(w)||d===w)break;N++}while(N<=E.length);return w}hb(g){if(g.iconPath&&!(g.iconPath instanceof O.ThemeIcon))return typeof g.iconPath=="string"||R.URI.isUri(g.iconPath)?this.jb(g.iconPath):this.jb(g.iconPath.light)}ib(g){if(g.iconPath&&!(g.iconPath instanceof O.ThemeIcon)&&g.iconPath.dark)return this.jb(g.iconPath.dark)}jb(g){return R.URI.isUri(g)?g:R.URI.file(g)}kb(g,i){this.i.set(i.item.handle,g),this.j.set(g,i)}lb(g,i,s,r){this.i.delete(i.item.handle),this.j.delete(g),i.item.handle!==s.item.handle&&this.i.delete(s.item.handle),this.kb(g,i);const o=this.Q(r)||[],c=o.filter(m=>m.item.handle===s.item.handle)[0];c&&o.splice(o.indexOf(c),1,i)}mb(g,i){i?(i.children||(i.children=[]),i.children.push(g)):(this.h||(this.h=[]),this.h.push(g))}nb(g){if(g){const i=this.j.get(g);if(i){if(i.children)for(const s of i.children){const r=this.i.get(s.item.handle);r&&this.ob(r)}i.children=void 0}}else this.pb()}ob(g){const i=this.j.get(g);if(i){if(i.children)for(const s of i.children){const r=this.i.get(s.item.handle);r&&this.ob(r)}this.j.delete(g),this.i.delete(i.item.handle),i.dispose()}}pb(){this.h=void 0,this.i.clear(),this.j.forEach(g=>g.dispose()),this.j.clear()}dispose(){this.S.dispose(),this.pb(),this.D.$disposeTree(this.C)}}b.a="0",b.b="1"}),define(ye[310],De([1,0,21,11,3,37,2,121,119,156,155,44,5,96,252,251,40,253,35,255,256,257,240,258,60,42,259,260,263,264,265,142,243,271,272,273,99,41,275,309,14,7,74,278,81,141,34,232,262,73,139,83,85,86,13,57,18,25,266,239,56,78,249,276,80,79,281,279,280,250,48,274,277,98,61,77,267,82,268,16,125,242,221,261,6,26,226,97,217,269,270]),function(re,e,a,L,l,R,S,A,y,I,O,P,v,k,D,f,u,h,p,b,C,g,i,s,r,o,c,m,n,t,d,E,w,N,j,V,Q,x,U,T,F,B,Z,_,H,Y,ie,ge,X,J,ee,me,ve,Ie,Re,ae,le,ue,ne,ce,oe,M,z,G,te,de,we,Pe,be,Ce,ke,He,Ge,nt,Qe,tt,rt,Be,it,$,K,he,Le,Ne,xe,je,Ze,st,at,mt,gt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function Et(lt){const pt=lt.get(ue.IExtHostInitDataService),qt=lt.get(ke.IExtHostFileSystemInfo),jt=lt.get(de.IExtHostConsumerFileSystem),kt=lt.get(o.IExtHostExtensionService),ft=lt.get(ie.IExtHostWorkspace),Tt=lt.get(tt.IExtHostTelemetry),Bt=lt.get(p.IExtHostConfiguration),At=lt.get(ae.IURITransformerService),Xe=lt.get(le.IExtHostRpcService),Nt=lt.get(Q.IExtHostStorage),Gt=lt.get(te.IExtensionStoragePaths),Ft=lt.get(Re.ILoggerService),bt=lt.get(Re.ILogService),Ae=lt.get(oe.IExtHostTunnelService),Oe=lt.get(M.IExtHostApiDeprecationService),Se=lt.get(Y.IExtHostWindow),se=lt.get(nt.IExtHostSecretState),Fe=lt.get(Qe.IExtHostEditorTabs);Xe.set(v.ExtHostContext.ExtHostFileSystemInfo,qt),Xe.set(v.ExtHostContext.ExtHostLogLevelServiceShape,Ft),Xe.set(v.ExtHostContext.ExtHostWorkspace,ft),Xe.set(v.ExtHostContext.ExtHostConfiguration,Bt),Xe.set(v.ExtHostContext.ExtHostExtensionService,kt),Xe.set(v.ExtHostContext.ExtHostStorage,Nt),Xe.set(v.ExtHostContext.ExtHostTunnelService,Ae),Xe.set(v.ExtHostContext.ExtHostWindow,Se),Xe.set(v.ExtHostContext.ExtHostSecretState,se),Xe.set(v.ExtHostContext.ExtHostTelemetry,Tt),Xe.set(v.ExtHostContext.ExtHostEditorTabs,Fe);const We=Xe.set(v.ExtHostContext.ExtHostDecorations,lt.get(ee.IExtHostDecorations)),Ye=Xe.set(v.ExtHostContext.ExtHostDocumentsAndEditors,lt.get(r.IExtHostDocumentsAndEditors)),Ve=Xe.set(v.ExtHostContext.ExtHostCommands,lt.get(u.IExtHostCommands)),et=Xe.set(v.ExtHostContext.ExtHostTerminalService,lt.get(x.IExtHostTerminalService)),ut=Xe.set(v.ExtHostContext.ExtHostDebugService,lt.get(ve.IExtHostDebugService)),Pt=Xe.set(v.ExtHostContext.ExtHostSearch,lt.get(Ie.IExtHostSearch)),St=Xe.set(v.ExtHostContext.ExtHostTask,lt.get(me.IExtHostTask)),Dt=Xe.set(v.ExtHostContext.ExtHostOutputService,lt.get(E.IExtHostOutputService)),wt=Xe.set(v.ExtHostContext.ExtHostLocalization,lt.get(st.IExtHostLocalizationService)),Rt=Xe.set(v.ExtHostContext.ExtHostUrls,new _.ExtHostUrls(Xe)),yt=Xe.set(v.ExtHostContext.ExtHostDocuments,new s.ExtHostDocuments(Xe,Ye)),ri=Xe.set(v.ExtHostContext.ExtHostDocumentContentProviders,new g.ExtHostDocumentContentProvider(Xe,Ye,bt)),ei=Xe.set(v.ExtHostContext.ExtHostDocumentSaveParticipant,new i.ExtHostDocumentSaveParticipant(bt,yt,Xe.getProxy(v.MainContext.MainThreadBulkEdits))),Ct=Xe.set(v.ExtHostContext.ExtHostNotebook,new ne.ExtHostNotebookController(Xe,Ve,Ye,yt)),si=Xe.set(v.ExtHostContext.ExtHostNotebookDocuments,new Le.ExtHostNotebookDocuments(Ct)),oi=Xe.set(v.ExtHostContext.ExtHostNotebookEditors,new he.ExtHostNotebookEditors(bt,Ct)),Jt=Xe.set(v.ExtHostContext.ExtHostNotebookKernels,new rt.ExtHostNotebookKernels(Xe,pt,Ct,Ve,bt)),bi=Xe.set(v.ExtHostContext.ExtHostNotebookRenderers,new it.ExtHostNotebookRenderers(Xe,Ct)),Lt=Xe.set(v.ExtHostContext.ExtHostEditors,new U.ExtHostEditors(Xe,Ye)),zt=Xe.set(v.ExtHostContext.ExtHostTreeViews,new T.ExtHostTreeViews(Xe.getProxy(v.MainContext.MainThreadTreeViews),Ve,bt)),vi=Xe.set(v.ExtHostContext.ExtHostEditorInsets,new ge.ExtHostEditorInsets(Xe.getProxy(v.MainContext.MainThreadEditorInsets),Lt,pt.remote)),ai=Xe.set(v.ExtHostContext.ExtHostDiagnostics,new b.ExtHostDiagnostics(Xe,bt,qt,Ye)),_t=Xe.set(v.ExtHostContext.ExtHostLanguages,new t.ExtHostLanguages(Xe,yt,Ve.converter,At)),dt=Xe.set(v.ExtHostContext.ExtHostLanguageFeatures,new n.ExtHostLanguageFeatures(Xe,At,yt,Ve,ai,bt,Oe,Tt)),Bi=Xe.set(v.ExtHostContext.ExtHostFileSystem,new c.ExtHostFileSystem(Xe,dt)),Ut=Xe.set(v.ExtHostContext.ExtHostFileSystemEventService,new m.ExtHostFileSystemEventService(Xe,bt,Ye)),Xt=Xe.set(v.ExtHostContext.ExtHostQuickOpen,(0,N.createExtHostQuickOpen)(Xe,ft,Ve)),ci=Xe.set(v.ExtHostContext.ExtHostSCM,new j.ExtHostSCM(Xe,Ve,bt)),wi=Xe.set(v.ExtHostContext.ExtHostQuickDiff,new gt.ExtHostQuickDiff(Xe,At)),Ei=Xe.set(v.ExtHostContext.ExtHostComments,(0,h.createExtHostComments)(Xe,Ve,yt)),li=Xe.set(v.ExtHostContext.ExtHostProgress,new w.ExtHostProgress(Xe.getProxy(v.MainContext.MainThreadProgress))),Si=Xe.set(v.ExtHostContext.ExtHosLabelService,new X.ExtHostLabelService(Xe)),ui=Xe.set(v.ExtHostContext.ExtHostTheming,new ce.ExtHostTheming(Xe)),Zt=Xe.set(v.ExtHostContext.ExtHostAuthentication,new z.ExtHostAuthentication(Xe)),$i=Xe.set(v.ExtHostContext.ExtHostTimeline,new G.ExtHostTimeline(Xe,Ve)),ti=Xe.set(v.ExtHostContext.ExtHostWebviews,new H.ExtHostWebviews(Xe,pt.remote,ft,bt,Oe)),ii=Xe.set(v.ExtHostContext.ExtHostWebviewPanels,new be.ExtHostWebviewPanels(Xe,ti,ft)),yi=Xe.set(v.ExtHostContext.ExtHostCustomEditors,new Pe.ExtHostCustomEditors(Xe,yt,Gt,ti,ii)),Di=Xe.set(v.ExtHostContext.ExtHostWebviewViews,new we.ExtHostWebviewViews(Xe,ti)),ni=Xe.set(v.ExtHostContext.ExtHostTesting,new He.ExtHostTesting(Xe,Ve,Ye)),Ci=Xe.set(v.ExtHostContext.ExtHostUriOpeners,new Ge.ExtHostUriOpeners(Xe)),Ii=Xe.set(v.ExtHostContext.ExtHostProfileContentHandlers,new mt.ExtHostProfileContentHandlers(Xe));Xe.set(v.ExtHostContext.ExtHostInteractive,new Ne.ExtHostInteractive(Xe,Ct,Ye,Ve,bt));const zi=Object.values(v.ExtHostContext);Xe.assertRegistered(zi);const Wi=new Ce.ExtHostBulkEdits(Xe,Ye),Hi=new f.ExtHostClipboard(Xe),ki=new d.ExtHostMessageService(Xe,bt),Ri=new C.ExtHostDialogs(Xe),Li=new V.ExtHostStatusBar(Xe,Ve.converter);return D.ExtHostApiCommands.register(Ve),function($e,Wt,Oi){const vt=function(){let pe=!$e.isUnderDevelopment;function Ee(){pe||(bt.info(`Extension '${$e.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),pe=!0)}return function Me(ot){if(Array.isArray(ot))ot.forEach(Me);else if(typeof ot=="string")Ee();else{const It=ot;typeof It.scheme>"u"&&Ee(),typeof It.exclusive=="boolean"&&(0,je.checkProposedApiEnabled)($e,"documentFiltersExclusive")}return ot}}(),ji={getSession(pe,Ee,Me){return Zt.getSession($e,pe,Ee,Me)},async hasSession(pe,Ee){return(0,je.checkProposedApiEnabled)($e,"authSession"),!!await Zt.getSession($e,pe,Ee,{silent:!0})},get onDidChangeSessions(){return Zt.onDidChangeSessions},registerAuthenticationProvider(pe,Ee,Me,ot){return Zt.registerAuthenticationProvider(pe,Ee,Me,ot)}},di={registerCommand(pe,Ee,Me){return Ve.registerCommand(!0,pe,Ee,Me,void 0,$e)},registerTextEditorCommand(pe,Ee,Me){return Ve.registerCommand(!0,pe,(...ot)=>{const It=Lt.getActiveTextEditor();if(!It){bt.warn("Cannot execute "+pe+" because there is no active text editor.");return}return It.edit(Ot=>{Ee.apply(Me,[It,Ot,...ot])}).then(Ot=>{Ot||bt.warn("Edits from command "+pe+" were not applied.")},Ot=>{bt.warn("An error occurred while running command "+pe,Ot)})},void 0,void 0,$e)},registerDiffInformationCommand:(pe,Ee,Me)=>((0,je.checkProposedApiEnabled)($e,"diffCommand"),Ve.registerCommand(!0,pe,async(...ot)=>{const It=Ye.activeEditor(!0);if(!It){bt.warn("Cannot execute "+pe+" because there is no active text editor.");return}const Ot=await Lt.getDiffInformation(It.id);Ee.apply(Me,[Ot,...ot])},void 0,void 0,$e)),executeCommand(pe,...Ee){return Ve.executeCommand(pe,...Ee)},getCommands(pe=!1){return Ve.getCommands(pe)}},Ni={get machineId(){return pt.telemetryInfo.machineId},get sessionId(){return pt.telemetryInfo.sessionId},get language(){return pt.environment.appLanguage},get appName(){return pt.environment.appName},get appRoot(){return pt.environment.appRoot?.fsPath??""},get appHost(){return pt.environment.appHost},get uriScheme(){return pt.environment.appUriScheme},get clipboard(){return Hi.value},get shell(){return et.getDefaultShell(!1)},get onDidChangeShell(){return(0,je.checkProposedApiEnabled)($e,"envShellEvent"),et.onDidChangeShell},get isTelemetryEnabled(){return Tt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Tt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,je.checkProposedApiEnabled)($e,"telemetry"),Tt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,je.checkProposedApiEnabled)($e,"telemetry"),Tt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){return(0,tt.isNewAppInstall)(pt.telemetryInfo.firstSessionDate)},createTelemetryLogger(pe){return tt.ExtHostTelemetryLogger.validateSender(pe),Tt.instantiateLogger($e,pe)},openExternal(pe,Ee){return Se.openUri(pe,{allowTunneling:!!pt.remote.authority,allowContributedOpeners:Ee?.allowContributedOpeners})},async asExternalUri(pe){if(pe.scheme===pt.environment.appUriScheme)return Rt.createAppUri(pe);try{return await Se.asExternalUri(pe,{allowTunneling:!!pt.remote.authority})}catch(Ee){if((0,K.matchesScheme)(pe,$.Schemas.http)||(0,K.matchesScheme)(pe,$.Schemas.https))return pe;throw Ee}},get remoteName(){return(0,J.getRemoteName)(pt.remote.authority)},get remoteAuthority(){return(0,je.checkProposedApiEnabled)($e,"resolvers"),pt.remote.authority},get uiKind(){return pt.uiKind},get logLevel(){return bt.getLevel()},get onDidChangeLogLevel(){return bt.onDidChangeLogLevel}};pt.environment.extensionTestsLocationURI||Object.freeze(Ni);const Vi={createTestController(pe,Ee,Me){return ni.createTestController($e,pe,Ee,Me)},createTestObserver(){return(0,je.checkProposedApiEnabled)($e,"testObserver"),ni.createTestObserver()},runTests(pe){return(0,je.checkProposedApiEnabled)($e,"testObserver"),ni.runTests(pe)},get onDidChangeTestResults(){return(0,je.checkProposedApiEnabled)($e,"testObserver"),ni.onResultsChanged},get testResults(){return(0,je.checkProposedApiEnabled)($e,"testObserver"),ni.results}},hi=pt.remote.isRemote?B.ExtensionKind.Workspace:B.ExtensionKind.UI,xi={getExtension(pe,Ee){(0,je.isProposedApiEnabled)($e,"extensionsAny")||(Ee=!1);const Me=Wt.mine.getExtensionDescription(pe);if(Me)return new o.Extension(kt,$e.identifier,Me,hi,!1);if(Ee){const ot=Wt.all.getExtensionDescription(pe);if(ot)return new o.Extension(kt,$e.identifier,ot,hi,!0)}},get all(){const pe=[];for(const Ee of Wt.mine.getAllExtensionDescriptions())pe.push(new o.Extension(kt,$e.identifier,Ee,hi,!1));return pe},get allAcrossExtensionHosts(){(0,je.checkProposedApiEnabled)($e,"extensionsAny");const pe=new je.ExtensionIdentifierSet(Wt.mine.getAllExtensionDescriptions().map(Me=>Me.identifier)),Ee=[];for(const Me of Wt.all.getAllExtensionDescriptions()){const ot=!pe.has(Me.identifier);Ee.push(new o.Extension(kt,$e.identifier,Me,hi,ot))}return Ee},get onDidChange(){return(0,je.isProposedApiEnabled)($e,"extensionsAny")?l.Event.any(Wt.mine.onDidChange,Wt.all.onDidChange):Wt.mine.onDidChange}},Ti={createDiagnosticCollection(pe){return ai.createDiagnosticCollection($e.identifier,pe)},get onDidChangeDiagnostics(){return ai.onDidChangeDiagnostics},getDiagnostics:pe=>ai.getDiagnostics(pe),getLanguages(){return _t.getLanguages()},setTextDocumentLanguage(pe,Ee){return _t.changeLanguage(pe.uri,Ee)},match(pe,Ee){const Me=yt.getDocumentData(Ee.uri)?.notebook;return(0,O.score)(F.LanguageSelector.from(pe),Ee.uri,Ee.languageId,!0,Me?.uri,Me?.notebookType)},registerCodeActionsProvider(pe,Ee,Me){return dt.registerCodeActionProvider($e,vt(pe),Ee,Me)},registerDocumentPasteEditProvider(pe,Ee,Me){return(0,je.checkProposedApiEnabled)($e,"documentPaste"),dt.registerDocumentPasteEditProvider($e,vt(pe),Ee,Me)},registerCodeLensProvider(pe,Ee){return dt.registerCodeLensProvider($e,vt(pe),Ee)},registerDefinitionProvider(pe,Ee){return dt.registerDefinitionProvider($e,vt(pe),Ee)},registerDeclarationProvider(pe,Ee){return dt.registerDeclarationProvider($e,vt(pe),Ee)},registerImplementationProvider(pe,Ee){return dt.registerImplementationProvider($e,vt(pe),Ee)},registerTypeDefinitionProvider(pe,Ee){return dt.registerTypeDefinitionProvider($e,vt(pe),Ee)},registerHoverProvider(pe,Ee){return dt.registerHoverProvider($e,vt(pe),Ee,$e.identifier)},registerEvaluatableExpressionProvider(pe,Ee){return dt.registerEvaluatableExpressionProvider($e,vt(pe),Ee,$e.identifier)},registerInlineValuesProvider(pe,Ee){return dt.registerInlineValuesProvider($e,vt(pe),Ee,$e.identifier)},registerDocumentHighlightProvider(pe,Ee){return dt.registerDocumentHighlightProvider($e,vt(pe),Ee)},registerLinkedEditingRangeProvider(pe,Ee){return dt.registerLinkedEditingRangeProvider($e,vt(pe),Ee)},registerReferenceProvider(pe,Ee){return dt.registerReferenceProvider($e,vt(pe),Ee)},registerRenameProvider(pe,Ee){return dt.registerRenameProvider($e,vt(pe),Ee)},registerDocumentSymbolProvider(pe,Ee,Me){return dt.registerDocumentSymbolProvider($e,vt(pe),Ee,Me)},registerWorkspaceSymbolProvider(pe){return dt.registerWorkspaceSymbolProvider($e,pe)},registerDocumentFormattingEditProvider(pe,Ee){return dt.registerDocumentFormattingEditProvider($e,vt(pe),Ee)},registerDocumentRangeFormattingEditProvider(pe,Ee){return dt.registerDocumentRangeFormattingEditProvider($e,vt(pe),Ee)},registerOnTypeFormattingEditProvider(pe,Ee,Me,...ot){return dt.registerOnTypeFormattingEditProvider($e,vt(pe),Ee,[Me].concat(ot))},registerDocumentSemanticTokensProvider(pe,Ee,Me){return dt.registerDocumentSemanticTokensProvider($e,vt(pe),Ee,Me)},registerDocumentRangeSemanticTokensProvider(pe,Ee,Me){return dt.registerDocumentRangeSemanticTokensProvider($e,vt(pe),Ee,Me)},registerSignatureHelpProvider(pe,Ee,Me,...ot){return typeof Me=="object"?dt.registerSignatureHelpProvider($e,vt(pe),Ee,Me):dt.registerSignatureHelpProvider($e,vt(pe),Ee,typeof Me>"u"?[]:[Me,...ot])},registerCompletionItemProvider(pe,Ee,...Me){return dt.registerCompletionItemProvider($e,vt(pe),Ee,Me)},registerInlineCompletionItemProvider(pe,Ee){return Ee.handleDidShowCompletionItem&&(0,je.checkProposedApiEnabled)($e,"inlineCompletionsAdditions"),Ee.handleDidPartiallyAcceptCompletionItem&&(0,je.checkProposedApiEnabled)($e,"inlineCompletionsAdditions"),dt.registerInlineCompletionsProvider($e,vt(pe),Ee)},registerDocumentLinkProvider(pe,Ee){return dt.registerDocumentLinkProvider($e,vt(pe),Ee)},registerColorProvider(pe,Ee){return dt.registerColorProvider($e,vt(pe),Ee)},registerFoldingRangeProvider(pe,Ee){return dt.registerFoldingRangeProvider($e,vt(pe),Ee)},registerSelectionRangeProvider(pe,Ee){return dt.registerSelectionRangeProvider($e,pe,Ee)},registerCallHierarchyProvider(pe,Ee){return dt.registerCallHierarchyProvider($e,pe,Ee)},registerTypeHierarchyProvider(pe,Ee){return dt.registerTypeHierarchyProvider($e,pe,Ee)},setLanguageConfiguration:(pe,Ee)=>dt.setLanguageConfiguration($e,pe,Ee),getTokenInformationAtPosition(pe,Ee){return(0,je.checkProposedApiEnabled)($e,"tokenInformation"),_t.tokenAtPosition(pe,Ee)},registerInlayHintsProvider(pe,Ee){return dt.registerInlayHintsProvider($e,pe,Ee)},createLanguageStatusItem(pe,Ee){return _t.createLanguageStatusItem($e,pe,Ee)},registerDocumentDropEditProvider(pe,Ee){return dt.registerDocumentOnDropEditProvider($e,pe,Ee)}},qi={get activeTextEditor(){return Lt.getActiveTextEditor()},get visibleTextEditors(){return Lt.getVisibleTextEditors()},get activeTerminal(){return et.activeTerminal},get terminals(){return et.terminals},async showTextDocument(pe,Ee,Me){const ot=await(S.URI.isUri(pe)?Promise.resolve(Vt.openTextDocument(pe)):Promise.resolve(pe));return Lt.showTextDocument(ot,Ee,Me)},createTextEditorDecorationType(pe){return Lt.createTextEditorDecorationType($e,pe)},onDidChangeActiveTextEditor(pe,Ee,Me){return Lt.onDidChangeActiveTextEditor(pe,Ee,Me)},onDidChangeVisibleTextEditors(pe,Ee,Me){return Lt.onDidChangeVisibleTextEditors(pe,Ee,Me)},onDidChangeTextEditorSelection(pe,Ee,Me){return Lt.onDidChangeTextEditorSelection(pe,Ee,Me)},onDidChangeTextEditorOptions(pe,Ee,Me){return Lt.onDidChangeTextEditorOptions(pe,Ee,Me)},onDidChangeTextEditorVisibleRanges(pe,Ee,Me){return Lt.onDidChangeTextEditorVisibleRanges(pe,Ee,Me)},onDidChangeTextEditorViewColumn(pe,Ee,Me){return Lt.onDidChangeTextEditorViewColumn(pe,Ee,Me)},onDidCloseTerminal(pe,Ee,Me){return et.onDidCloseTerminal(pe,Ee,Me)},onDidOpenTerminal(pe,Ee,Me){return et.onDidOpenTerminal(pe,Ee,Me)},onDidChangeActiveTerminal(pe,Ee,Me){return et.onDidChangeActiveTerminal(pe,Ee,Me)},onDidChangeTerminalDimensions(pe,Ee,Me){return(0,je.checkProposedApiEnabled)($e,"terminalDimensions"),et.onDidChangeTerminalDimensions(pe,Ee,Me)},onDidChangeTerminalState(pe,Ee,Me){return et.onDidChangeTerminalState(pe,Ee,Me)},onDidWriteTerminalData(pe,Ee,Me){return(0,je.checkProposedApiEnabled)($e,"terminalDataWriteEvent"),et.onDidWriteTerminalData(pe,Ee,Me)},get state(){return Se.state},onDidChangeWindowState(pe,Ee,Me){return Se.onDidChangeWindowState(pe,Ee,Me)},showInformationMessage(pe,...Ee){return ki.showMessage($e,R.default.Info,pe,Ee[0],Ee.slice(1))},showWarningMessage(pe,...Ee){return ki.showMessage($e,R.default.Warning,pe,Ee[0],Ee.slice(1))},showErrorMessage(pe,...Ee){return ki.showMessage($e,R.default.Error,pe,Ee[0],Ee.slice(1))},showQuickPick(pe,Ee,Me){return Xt.showQuickPick($e,pe,Ee,Me)},showWorkspaceFolderPick(pe){return Xt.showWorkspaceFolderPick(pe)},showInputBox(pe,Ee){return Xt.showInput(pe,Ee)},showOpenDialog(pe){return Ri.showOpenDialog($e,pe)},showSaveDialog(pe){return Ri.showSaveDialog(pe)},createStatusBarItem(pe,Ee,Me){let ot,It,Ot;return typeof pe=="string"?(ot=pe,It=Ee,Ot=Me):(It=pe,Ot=Ee),Li.createStatusBarEntry($e,ot,It,Ot)},setStatusBarMessage(pe,Ee){return Li.setStatusBarMessage(pe,Ee)},withScmProgress(pe){return Oe.report("window.withScmProgress",$e,"Use 'withProgress' instead."),li.withProgress($e,{location:B.ProgressLocation.SourceControl},(Ee,Me)=>pe({report(ot){}}))},withProgress(pe,Ee){return li.withProgress($e,pe,Ee)},createOutputChannel(pe,Ee){return Dt.createOutputChannel(pe,Ee,$e)},createWebviewPanel(pe,Ee,Me,ot){return ii.createWebviewPanel($e,pe,Ee,Me,ot)},createWebviewTextEditorInset(pe,Ee,Me,ot){return(0,je.checkProposedApiEnabled)($e,"editorInsets"),vi.createWebviewEditorInset(pe,Ee,Me,ot,$e)},createTerminal(pe,Ee,Me){return typeof pe=="object"?"pty"in pe?et.createExtensionTerminal(pe):et.createTerminalFromOptions(pe):et.createTerminal(pe,Ee,Me)},registerTerminalLinkProvider(pe){return et.registerLinkProvider(pe)},registerTerminalProfileProvider(pe,Ee){return et.registerProfileProvider($e,pe,Ee)},registerTerminalQuickFixProvider(pe,Ee){return(0,je.checkProposedApiEnabled)($e,"terminalQuickFixProvider"),et.registerTerminalQuickFixProvider(pe,$e.identifier.value,Ee)},registerTreeDataProvider(pe,Ee){return zt.registerTreeDataProvider(pe,Ee,$e)},createTreeView(pe,Ee){return zt.createTreeView(pe,Ee,$e)},registerWebviewPanelSerializer:(pe,Ee)=>ii.registerWebviewPanelSerializer($e,pe,Ee),registerCustomEditorProvider:(pe,Ee,Me={})=>yi.registerCustomEditorProvider($e,pe,Ee,Me),registerFileDecorationProvider(pe){return We.registerFileDecorationProvider(pe,$e)},registerUriHandler(pe){return Rt.registerUriHandler($e.identifier,pe)},createQuickPick(){return Xt.createQuickPick($e)},createInputBox(){return Xt.createInputBox($e)},get activeColorTheme(){return ui.activeColorTheme},onDidChangeActiveColorTheme(pe,Ee,Me){return ui.onDidChangeActiveColorTheme(pe,Ee,Me)},registerWebviewViewProvider(pe,Ee,Me){return Di.registerWebviewViewProvider($e,pe,Ee,Me?.webviewOptions)},get activeNotebookEditor(){return Ct.activeNotebookEditor},onDidChangeActiveNotebookEditor(pe,Ee,Me){return Ct.onDidChangeActiveNotebookEditor(pe,Ee,Me)},get visibleNotebookEditors(){return Ct.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return Ct.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(pe,Ee,Me){return oi.onDidChangeNotebookEditorSelection(pe,Ee,Me)},onDidChangeNotebookEditorVisibleRanges(pe,Ee,Me){return oi.onDidChangeNotebookEditorVisibleRanges(pe,Ee,Me)},showNotebookDocument(pe,Ee){return Ct.showNotebookDocument(pe,Ee)},registerExternalUriOpener(pe,Ee,Me){return(0,je.checkProposedApiEnabled)($e,"externalUriOpener"),Ci.registerExternalUriOpener($e.identifier,pe,Ee,Me)},registerProfileContentHandler(pe,Ee){return(0,je.checkProposedApiEnabled)($e,"profileContentHandlers"),Ii.registrProfileContentHandler($e,pe,Ee)},registerQuickDiffProvider(pe,Ee,Me,ot){return(0,je.checkProposedApiEnabled)($e,"quickDiffProvider"),wi.registerQuickDiffProvider(vt(pe),Ee,Me,ot)},get tabGroups(){return Fe.tabGroups}},Vt={get rootPath(){return Oe.report("workspace.rootPath",$e,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath(pe){throw L.readonly()},getWorkspaceFolder(pe){return ft.getWorkspaceFolder(pe)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name(pe){throw L.readonly()},get workspaceFile(){return ft.workspaceFile},set workspaceFile(pe){throw L.readonly()},updateWorkspaceFolders:(pe,Ee,...Me)=>ft.updateWorkspaceFolders($e,pe,Ee||0,...Me),onDidChangeWorkspaceFolders:function(pe,Ee,Me){return ft.onDidChangeWorkspace(pe,Ee,Me)},asRelativePath:(pe,Ee)=>ft.getRelativePath(pe,Ee),findFiles:(pe,Ee,Me,ot)=>ft.findFiles(pe,Ee,Me,$e.identifier,ot),findTextInFiles:(pe,Ee,Me,ot)=>{(0,je.checkProposedApiEnabled)($e,"findTextInFiles");let It,Ot;return typeof Ee=="object"?(It=Ee,Ot=Me):(It={},Ot=Ee,ot=Me),ft.findTextInFiles(pe,It||{},Ot,$e.identifier,ot)},saveAll:pe=>ft.saveAll(pe),applyEdit(pe,Ee){return Wi.applyWorkspaceEdit(pe,$e,Ee)},createFileSystemWatcher:(pe,Ee,Me,ot)=>Ut.createFileSystemWatcher(ft,$e,pe,Ee,Me,ot),get textDocuments(){return yt.getAllDocumentData().map(pe=>pe.document)},set textDocuments(pe){throw L.readonly()},openTextDocument(pe){let Ee;const Me=pe;if(typeof pe=="string")Ee=Promise.resolve(S.URI.file(pe));else if(S.URI.isUri(pe))Ee=Promise.resolve(pe);else if(!Me||typeof Me=="object")Ee=yt.createDocumentData(Me);else throw new Error("illegal argument - uriOrFileNameOrOptions");return Ee.then(ot=>yt.ensureDocumentData(ot).then(It=>It.document))},onDidOpenTextDocument:(pe,Ee,Me)=>yt.onDidAddDocument(pe,Ee,Me),onDidCloseTextDocument:(pe,Ee,Me)=>yt.onDidRemoveDocument(pe,Ee,Me),onDidChangeTextDocument:(pe,Ee,Me)=>yt.onDidChangeDocument(pe,Ee,Me),onDidSaveTextDocument:(pe,Ee,Me)=>yt.onDidSaveDocument(pe,Ee,Me),onWillSaveTextDocument:(pe,Ee,Me)=>ei.getOnWillSaveTextDocumentEvent($e)(pe,Ee,Me),get notebookDocuments(){return Ct.notebookDocuments.map(pe=>pe.apiNotebook)},async openNotebookDocument(pe,Ee){let Me;if(S.URI.isUri(pe))Me=pe,await Ct.openNotebookDocument(pe);else if(typeof pe=="string")Me=S.URI.revive(await Ct.createNotebookDocument({viewType:pe,content:Ee}));else throw new Error("Invalid arguments");return Ct.getNotebookDocument(Me).apiNotebook},onDidSaveNotebookDocument(pe,Ee,Me){return si.onDidSaveNotebookDocument(pe,Ee,Me)},onDidChangeNotebookDocument(pe,Ee,Me){return si.onDidChangeNotebookDocument(pe,Ee,Me)},get onDidOpenNotebookDocument(){return Ct.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return Ct.onDidCloseNotebookDocument},registerNotebookSerializer(pe,Ee,Me,ot){return Ct.registerNotebookSerializer($e,pe,Ee,Me,(0,je.isProposedApiEnabled)($e,"notebookLiveShare")?ot:void 0)},onDidChangeConfiguration:(pe,Ee,Me)=>Oi.onDidChangeConfiguration(pe,Ee,Me),getConfiguration(pe,Ee){return Ee=arguments.length===1?void 0:Ee,Oi.getConfiguration(pe,Ee,$e)},registerTextDocumentContentProvider(pe,Ee){return ri.registerTextDocumentContentProvider(pe,Ee)},registerTaskProvider:(pe,Ee)=>(Oe.report("window.registerTaskProvider",$e,"Use the corresponding function on the 'tasks' namespace instead"),St.registerTaskProvider($e,pe,Ee)),registerFileSystemProvider(pe,Ee,Me){return(0,xe.combinedDisposable)(Bi.registerFileSystemProvider($e,pe,Ee,Me),jt.addFileSystemProvider(pe,Ee))},get fs(){return jt.value},registerFileSearchProvider:(pe,Ee)=>((0,je.checkProposedApiEnabled)($e,"fileSearchProvider"),Pt.registerFileSearchProvider(pe,Ee)),registerTextSearchProvider:(pe,Ee)=>((0,je.checkProposedApiEnabled)($e,"textSearchProvider"),Pt.registerTextSearchProvider(pe,Ee)),registerRemoteAuthorityResolver:(pe,Ee)=>((0,je.checkProposedApiEnabled)($e,"resolvers"),kt.registerRemoteAuthorityResolver(pe,Ee)),registerResourceLabelFormatter:pe=>((0,je.checkProposedApiEnabled)($e,"resolvers"),Si.$registerResourceLabelFormatter(pe)),onDidCreateFiles:(pe,Ee,Me)=>Ut.onDidCreateFile(pe,Ee,Me),onDidDeleteFiles:(pe,Ee,Me)=>Ut.onDidDeleteFile(pe,Ee,Me),onDidRenameFiles:(pe,Ee,Me)=>Ut.onDidRenameFile(pe,Ee,Me),onWillCreateFiles:(pe,Ee,Me)=>Ut.getOnWillCreateFileEvent($e)(pe,Ee,Me),onWillDeleteFiles:(pe,Ee,Me)=>Ut.getOnWillDeleteFileEvent($e)(pe,Ee,Me),onWillRenameFiles:(pe,Ee,Me)=>Ut.getOnWillRenameFileEvent($e)(pe,Ee,Me),openTunnel:pe=>((0,je.checkProposedApiEnabled)($e,"tunnels"),Ae.openTunnel($e,pe).then(Ee=>{if(!Ee)throw new Error("cannot open tunnel");return Ee})),get tunnels(){return(0,je.checkProposedApiEnabled)($e,"tunnels"),Ae.getTunnels()},onDidChangeTunnels:(pe,Ee,Me)=>((0,je.checkProposedApiEnabled)($e,"tunnels"),Ae.onDidChangeTunnels(pe,Ee,Me)),registerPortAttributesProvider:(pe,Ee)=>((0,je.checkProposedApiEnabled)($e,"portsAttributes"),Ae.registerPortsAttributesProvider(pe,Ee)),registerTimelineProvider:(pe,Ee)=>((0,je.checkProposedApiEnabled)($e,"timeline"),$i.registerTimelineProvider(pe,Ee,$e.identifier,Ve.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:pe=>((0,je.checkProposedApiEnabled)($e,"workspaceTrust"),ft.requestWorkspaceTrust(pe)),onDidGrantWorkspaceTrust:(pe,Ee,Me)=>ft.onDidGrantWorkspaceTrust(pe,Ee,Me),registerEditSessionIdentityProvider:(pe,Ee)=>((0,je.checkProposedApiEnabled)($e,"editSessionIdentityProvider"),ft.registerEditSessionIdentityProvider(pe,Ee)),onWillCreateEditSessionIdentity:(pe,Ee,Me)=>((0,je.checkProposedApiEnabled)($e,"editSessionIdentityProvider"),ft.getOnWillCreateEditSessionIdentityEvent($e)(pe,Ee,Me))},fi={get inputBox(){return Oe.report("scm.inputBox",$e,"Use 'SourceControl.inputBox' instead"),ci.getLastInputBox($e)},createSourceControl(pe,Ee,Me){return ci.createSourceControl($e,pe,Ee,Me)}},Gi={createCommentController(pe,Ee){return Ei.createCommentController($e,pe,Ee)}},$t={get activeDebugSession(){return ut.activeDebugSession},get activeDebugConsole(){return ut.activeDebugConsole},get breakpoints(){return ut.breakpoints},onDidStartDebugSession(pe,Ee,Me){return ut.onDidStartDebugSession(pe,Ee,Me)},onDidTerminateDebugSession(pe,Ee,Me){return ut.onDidTerminateDebugSession(pe,Ee,Me)},onDidChangeActiveDebugSession(pe,Ee,Me){return ut.onDidChangeActiveDebugSession(pe,Ee,Me)},onDidReceiveDebugSessionCustomEvent(pe,Ee,Me){return ut.onDidReceiveDebugSessionCustomEvent(pe,Ee,Me)},onDidChangeBreakpoints(pe,Ee,Me){return ut.onDidChangeBreakpoints(pe,Ee,Me)},registerDebugConfigurationProvider(pe,Ee,Me){return ut.registerDebugConfigurationProvider(pe,Ee,Me||Ze.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(pe,Ee){return ut.registerDebugAdapterDescriptorFactory($e,pe,Ee)},registerDebugAdapterTrackerFactory(pe,Ee){return ut.registerDebugAdapterTrackerFactory(pe,Ee)},startDebugging(pe,Ee,Me){return!Me||typeof Me=="object"&&"configuration"in Me?ut.startDebugging(pe,Ee,{parentSession:Me}):ut.startDebugging(pe,Ee,Me||{})},stopDebugging(pe){return ut.stopDebugging(pe)},addBreakpoints(pe){return ut.addBreakpoints(pe)},removeBreakpoints(pe){return ut.removeBreakpoints(pe)},asDebugSourceUri(pe,Ee){return ut.asDebugSourceUri(pe,Ee)}},mi={registerTaskProvider:(pe,Ee)=>St.registerTaskProvider($e,pe,Ee),fetchTasks:pe=>St.fetchTasks(pe),executeTask:pe=>St.executeTask($e,pe),get taskExecutions(){return St.taskExecutions},onDidStartTask:(pe,Ee,Me)=>St.onDidStartTask(pe,Ee,Me),onDidEndTask:(pe,Ee,Me)=>St.onDidEndTask(pe,Ee,Me),onDidStartTaskProcess:(pe,Ee,Me)=>St.onDidStartTaskProcess(pe,Ee,Me),onDidEndTaskProcess:(pe,Ee,Me)=>St.onDidEndTaskProcess(pe,Ee,Me)},Ki={createNotebookController(pe,Ee,Me,ot,It){return Jt.createNotebookController($e,pe,Ee,Me,ot,(0,je.isProposedApiEnabled)($e,"notebookMessaging")?It:void 0)},registerNotebookCellStatusBarItemProvider:(pe,Ee)=>Ct.registerNotebookCellStatusBarItemProvider($e,pe,Ee),createRendererMessaging(pe){return bi.createRendererMessaging($e,pe)},createNotebookControllerDetectionTask(pe){return(0,je.checkProposedApiEnabled)($e,"notebookKernelSource"),Jt.createNotebookControllerDetectionTask($e,pe)},registerKernelSourceActionProvider(pe,Ee){return(0,je.checkProposedApiEnabled)($e,"notebookKernelSource"),Jt.registerKernelSourceActionProvider($e,pe,Ee)},onDidChangeNotebookCellExecutionState(pe,Ee,Me){return(0,je.checkProposedApiEnabled)($e,"notebookCellExecutionState"),Jt.onDidChangeNotebookCellExecutionState(pe,Ee,Me)}},Xi={t(...pe){if(typeof pe[0]=="string"){const Ee=pe.shift(),Me=!pe||typeof pe[0]!="object"?pe:pe[0];return wt.getMessage($e.identifier.value,{message:Ee,args:Me})}return wt.getMessage($e.identifier.value,pe[0])},get bundle(){return wt.getBundle($e.identifier.value)},get uri(){return wt.getBundleUri($e.identifier.value)}};return{version:pt.version,authentication:ji,commands:di,comments:Gi,debug:$t,env:Ni,extensions:xi,l10n:Xi,languages:Ti,notebooks:Ki,scm:fi,tasks:mi,tests:Vi,window:qi,workspace:Vt,Breakpoint:B.Breakpoint,TerminalOutputAnchor:B.TerminalOutputAnchor,CallHierarchyIncomingCall:B.CallHierarchyIncomingCall,CallHierarchyItem:B.CallHierarchyItem,CallHierarchyOutgoingCall:B.CallHierarchyOutgoingCall,CancellationError:L.CancellationError,CancellationTokenSource:a.CancellationTokenSource,CandidatePortSource:v.CandidatePortSource,CodeAction:B.CodeAction,CodeActionKind:B.CodeActionKind,CodeActionTriggerKind:B.CodeActionTriggerKind,CodeLens:B.CodeLens,Color:B.Color,ColorInformation:B.ColorInformation,ColorPresentation:B.ColorPresentation,ColorThemeKind:B.ColorThemeKind,CommentMode:B.CommentMode,CommentThreadCollapsibleState:B.CommentThreadCollapsibleState,CommentThreadState:B.CommentThreadState,CompletionItem:B.CompletionItem,CompletionItemKind:B.CompletionItemKind,CompletionItemTag:B.CompletionItemTag,CompletionList:B.CompletionList,CompletionTriggerKind:B.CompletionTriggerKind,ConfigurationTarget:B.ConfigurationTarget,CustomExecution:B.CustomExecution,DebugAdapterExecutable:B.DebugAdapterExecutable,DebugAdapterInlineImplementation:B.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:B.DebugAdapterNamedPipeServer,DebugAdapterServer:B.DebugAdapterServer,DebugConfigurationProviderTriggerKind:Ze.DebugConfigurationProviderTriggerKind,DebugConsoleMode:B.DebugConsoleMode,DecorationRangeBehavior:B.DecorationRangeBehavior,Diagnostic:B.Diagnostic,DiagnosticRelatedInformation:B.DiagnosticRelatedInformation,DiagnosticSeverity:B.DiagnosticSeverity,DiagnosticTag:B.DiagnosticTag,Disposable:B.Disposable,DocumentHighlight:B.DocumentHighlight,DocumentHighlightKind:B.DocumentHighlightKind,DocumentLink:B.DocumentLink,DocumentSymbol:B.DocumentSymbol,EndOfLine:B.EndOfLine,EnvironmentVariableMutatorType:B.EnvironmentVariableMutatorType,EvaluatableExpression:B.EvaluatableExpression,InlineValueText:B.InlineValueText,InlineValueVariableLookup:B.InlineValueVariableLookup,InlineValueEvaluatableExpression:B.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:B.InlineCompletionTriggerKind,EventEmitter:l.Emitter,ExtensionKind:B.ExtensionKind,ExtensionMode:B.ExtensionMode,ExternalUriOpenerPriority:B.ExternalUriOpenerPriority,FileChangeType:B.FileChangeType,FileDecoration:B.FileDecoration,FileDecoration2:B.FileDecoration,FileSystemError:B.FileSystemError,FileType:P.FileType,FilePermission:P.FilePermission,FoldingRange:B.FoldingRange,FoldingRangeKind:B.FoldingRangeKind,FunctionBreakpoint:B.FunctionBreakpoint,InlineCompletionItem:B.InlineSuggestion,InlineCompletionList:B.InlineSuggestionList,Hover:B.Hover,IndentAction:I.IndentAction,Location:B.Location,MarkdownString:B.MarkdownString,OverviewRulerLane:y.OverviewRulerLane,ParameterInformation:B.ParameterInformation,PortAutoForwardAction:B.PortAutoForwardAction,Position:B.Position,ProcessExecution:B.ProcessExecution,ProgressLocation:B.ProgressLocation,QuickInputButtons:B.QuickInputButtons,Range:B.Range,RelativePattern:B.RelativePattern,Selection:B.Selection,SelectionRange:B.SelectionRange,SemanticTokens:B.SemanticTokens,SemanticTokensBuilder:B.SemanticTokensBuilder,SemanticTokensEdit:B.SemanticTokensEdit,SemanticTokensEdits:B.SemanticTokensEdits,SemanticTokensLegend:B.SemanticTokensLegend,ShellExecution:B.ShellExecution,ShellQuoting:B.ShellQuoting,SignatureHelp:B.SignatureHelp,SignatureHelpTriggerKind:B.SignatureHelpTriggerKind,SignatureInformation:B.SignatureInformation,SnippetString:B.SnippetString,SourceBreakpoint:B.SourceBreakpoint,StandardTokenType:B.StandardTokenType,StatusBarAlignment:B.StatusBarAlignment,SymbolInformation:B.SymbolInformation,SymbolKind:B.SymbolKind,SymbolTag:B.SymbolTag,Task:B.Task,TaskGroup:B.TaskGroup,TaskPanelKind:B.TaskPanelKind,TaskRevealKind:B.TaskRevealKind,TaskScope:B.TaskScope,TerminalLink:B.TerminalLink,TerminalQuickFixCommand:B.TerminalQuickFixCommand,TerminalQuickFixOpener:B.TerminalQuickFixOpener,TerminalLocation:B.TerminalLocation,TerminalProfile:B.TerminalProfile,TerminalExitReason:B.TerminalExitReason,TerminalQuickFixType:B.TerminalQuickFixType,TextDocumentSaveReason:B.TextDocumentSaveReason,TextEdit:B.TextEdit,SnippetTextEdit:B.SnippetTextEdit,TextEditorCursorStyle:A.TextEditorCursorStyle,TextEditorLineNumbersStyle:B.TextEditorLineNumbersStyle,TextEditorRevealType:B.TextEditorRevealType,TextEditorSelectionChangeKind:B.TextEditorSelectionChangeKind,TextDocumentChangeReason:B.TextDocumentChangeReason,ThemeColor:B.ThemeColor,ThemeIcon:B.ThemeIcon,TreeItem:B.TreeItem,TreeItem2:B.TreeItem,TreeItemCheckboxState:B.TreeItemCheckboxState,TreeItemCollapsibleState:B.TreeItemCollapsibleState,TypeHierarchyItem:B.TypeHierarchyItem,UIKind:k.UIKind,Uri:S.URI,ViewColumn:B.ViewColumn,WorkspaceEdit:B.WorkspaceEdit,DocumentDropEdit:B.DocumentDropEdit,DocumentPasteEdit:B.DocumentPasteEdit,InlayHint:B.InlayHint,InlayHintLabelPart:B.InlayHintLabelPart,InlayHintKind:B.InlayHintKind,RemoteAuthorityResolverError:B.RemoteAuthorityResolverError,ResolvedAuthority:B.ResolvedAuthority,SourceControlInputBoxValidationType:B.SourceControlInputBoxValidationType,ExtensionRuntime:B.ExtensionRuntime,TimelineItem:B.TimelineItem,NotebookRange:B.NotebookRange,NotebookCellKind:B.NotebookCellKind,NotebookCellExecutionState:B.NotebookCellExecutionState,NotebookCellData:B.NotebookCellData,NotebookData:B.NotebookData,NotebookRendererScript:B.NotebookRendererScript,NotebookCellStatusBarAlignment:B.NotebookCellStatusBarAlignment,NotebookEditorRevealType:B.NotebookEditorRevealType,NotebookCellOutput:B.NotebookCellOutput,NotebookCellOutputItem:B.NotebookCellOutputItem,NotebookCellStatusBarItem:B.NotebookCellStatusBarItem,NotebookControllerAffinity:B.NotebookControllerAffinity,NotebookControllerAffinity2:B.NotebookControllerAffinity2,NotebookEdit:B.NotebookEdit,NotebookKernelSourceAction:B.NotebookKernelSourceAction,PortAttributes:B.PortAttributes,LinkedEditingRanges:B.LinkedEditingRanges,TestResultState:B.TestResultState,TestRunRequest:B.TestRunRequest,TestRunRequest2:B.TestRunRequest2,TestMessage:B.TestMessage,TestTag:B.TestTag,TestRunProfileKind:B.TestRunProfileKind,TextSearchCompleteMessageType:Be.TextSearchCompleteMessageType,DataTransfer:B.DataTransfer,DataTransferItem:B.DataTransferItem,CoveredCount:B.CoveredCount,FileCoverage:B.FileCoverage,StatementCoverage:B.StatementCoverage,BranchCoverage:B.BranchCoverage,FunctionCoverage:B.FunctionCoverage,WorkspaceTrustState:B.WorkspaceTrustState,LanguageStatusSeverity:B.LanguageStatusSeverity,QuickPickItemKind:B.QuickPickItemKind,InputBoxValidationSeverity:B.InputBoxValidationSeverity,TabInputText:B.TextTabInput,TabInputTextDiff:B.TextDiffTabInput,TabInputTextMerge:B.TextMergeTabInput,TabInputCustom:B.CustomEditorTabInput,TabInputNotebook:B.NotebookEditorTabInput,TabInputNotebookDiff:B.NotebookDiffEditorTabInput,TabInputWebview:B.WebviewEditorTabInput,TabInputTerminal:B.TerminalEditorTabInput,TabInputInteractiveWindow:B.InteractiveWindowInput,TelemetryTrustedValue:Z.TelemetryTrustedValue,LogLevel:Re.LogLevel,EditSessionIdentityMatch:at.EditSessionIdentityMatch}}}e.createApiFactoryAndRegisterActors=Et}),define(ye[311],De([1,0,283,320,321,2,322]),function(re,e,a,L,l,R,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connectProxyResolver=void 0;function A(P,v,k,D,f,u){const h=u.environment.useHostProxy,p=typeof h=="boolean"?h:!u.remote.isRemote,b=(0,S.createProxyResolver)({resolveProxy:g=>P.resolveProxy(g),getHttpProxySetting:()=>v.getConfiguration("http").get("proxy"),log:(g,i,...s)=>{switch(g){case S.LogLevel.Trace:D.trace(i,...s);break;case S.LogLevel.Debug:D.debug(i,...s);break;case S.LogLevel.Info:D.info(i,...s);break;case S.LogLevel.Warning:D.warn(i,...s);break;case S.LogLevel.Error:D.error(i,...s);break;case S.LogLevel.Critical:D.error(i,...s);break;case S.LogLevel.Off:break;default:r(g,i,s);break}function r(o,c,...m){D.error("Unknown log level",o),D.error(c,...m)}},getLogLevel:()=>D.getLevel(),proxyResolveTelemetry:()=>{},useHostProxy:p,env:process.env}),C=y(v,b);return O(k,C)}e.connectProxyResolver=A;function y(P,v){const k={config:P.getConfiguration("http").get("proxySupport")||"off"};P.onDidChangeConfiguration(f=>{k.config=P.getConfiguration("http").get("proxySupport")||"off"});const D={config:!!P.getConfiguration("http").get("systemCertificates")};return P.onDidChangeConfiguration(f=>{D.config=!!P.getConfiguration("http").get("systemCertificates")}),{http:{off:Object.assign({},a,(0,S.createHttpPatch)(a,v,{config:"off"},D,!0)),on:Object.assign({},a,(0,S.createHttpPatch)(a,v,{config:"on"},D,!0)),override:Object.assign({},a,(0,S.createHttpPatch)(a,v,{config:"override"},D,!0)),onRequest:Object.assign({},a,(0,S.createHttpPatch)(a,v,k,D,!0)),default:Object.assign(a,(0,S.createHttpPatch)(a,v,k,D,!1))},https:{off:Object.assign({},L,(0,S.createHttpPatch)(L,v,{config:"off"},D,!0)),on:Object.assign({},L,(0,S.createHttpPatch)(L,v,{config:"on"},D,!0)),override:Object.assign({},L,(0,S.createHttpPatch)(L,v,{config:"override"},D,!0)),onRequest:Object.assign({},L,(0,S.createHttpPatch)(L,v,k,D,!0)),default:Object.assign(L,(0,S.createHttpPatch)(L,v,k,D,!1))},tls:Object.assign(l,(0,S.createTlsPatch)(l))}}const I=new Map;function O(P,v){return P.getExtensionPathIndex().then(k=>{const D=globalThis._VSCODE_NODE_MODULES.module,f=D._load;D._load=function(h,p,b){if(h==="tls")return v.tls;if(h!=="http"&&h!=="https")return f.apply(this,arguments);const C=v[h],g=k.findSubstr(R.URI.file(p.filename));let i=I.get(g);if(i||I.set(g,i={}),!i[h]){const s=C.default;i[h]={...s}}return i[h]}})}}),define(ye[312],De([1,0,52,71,9,84,310,297,311,42,285,2,16,7,282,112,284]),function(re,e,a,L,l,R,S,A,y,I,O,P,v,k,D,f,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class h extends A.RequireInterceptor{j(){const C=this,g=globalThis._VSCODE_NODE_MODULES.module,i=g._load;g._load=function(c,m,n){return c=r(c),C.a.has(c)?C.a.get(c).load(c,P.URI.file((0,f.realpathSync)(m.filename)),t=>i.apply(this,[t,m,n])):i.apply(this,arguments)};const s=g._resolveLookupPaths;g._resolveLookupPaths=(o,c)=>s.call(this,r(o),c);const r=o=>{for(const c of C.b){const m=c(o);if(m){o=m;break}}return o}}}class p extends I.AbstractExtHostExtensionService{constructor(){super(...arguments),this.extensionRuntime=k.ExtensionRuntime.Node}async ob(){this.h.createInstance(u.ExtHostConsoleForwarder);const C=this.h.invokeFunction(S.createApiFactoryAndRegisterActors);if(this.h.createInstance(O.ExtHostDownloadService),this.f.remote.isRemote&&this.f.remote.authority){const s=this.h.createInstance(D.CLIServer);process.env.VSCODE_IPC_HOOK_CLI=s.ipcHandlePath,a.promises.writeFile(l.join(L.tmpdir(),"vscode-ipc"),s.ipcHandlePath).catch(r=>{this.l.error(r)})}await this.h.createInstance(h,C,{mine:this.D,all:this.F}).install(),R.mark("code/extHost/didInitAPI");const i=await this.k.getConfigProvider();await(0,y.connectProxyResolver)(this.j,i,this,this.l,this.u,this.f),R.mark("code/extHost/didInitProxyResolver")}pb(C){return C.main}async qb(C,g,i){if(g.scheme!==v.Schemas.file)throw new Error(`Cannot load URI: '${g}', must be of file-scheme`);let s=null;i.codeLoadingStart(),this.l.trace(`ExtensionService#loadCommonJSModule ${g.toString(!0)}`),this.l.flush();const r=C?.identifier.value;C&&await this.s.initializeLocalizedMessages(C);try{r&&R.mark(`code/extHost/willLoadExtensionCode/${r}`),s=re.__$__nodeRequire(g.fsPath)}finally{r&&R.mark(`code/extHost/didLoadExtensionCode/${r}`),i.codeLoadingStop()}return s}async $setRemoteEnvironment(C){if(!!this.f.remote.isRemote)for(const g in C){const i=C[g];i===null?delete process.env[g]:process.env[g]=i}}}e.ExtHostExtensionService=p}),define(ye[145],De([1,0,46,323,306,15,62,38,9,8,2,31,82,324,304,100]),function(re,e,a,L,l,R,S,A,y,I,O,P,v,k,D,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.performBraceExpansionForRipgrep=e.fixNewline=e.fixRegexNewline=e.unicodeEscapesToPCRE2=e.getRgArgs=e.RipgrepParser=e.RipgrepTextSearchEngine=void 0;const u=D.rgPath.replace(/\bnode_modules\.asar\b/,"node_modules.asar.unpacked");class h{constructor(w){this.a=w}provideTextSearchResults(w,N,j,V){return this.a.appendLine(`provideTextSearchResults ${w.pattern}, ${JSON.stringify({...N,folder:N.folder.toString()})}`),new Promise((Q,x)=>{V.onCancellationRequested(()=>Y());const U=s(w,N),T=N.folder.fsPath,F=U.map(ee=>ee.match(/^-/)?ee:`'${ee}'`).join(" ");this.a.appendLine(`${u} ${F}
 - cwd: ${T}`);let B=a.spawn(u,U,{cwd:T});B.on("error",ee=>{console.error(ee),this.a.appendLine("Error: "+(ee&&ee.message)),x((0,P.serializeSearchError)(new P.SearchError(ee&&ee.message,P.SearchErrorCode.rgProcessError)))});let Z=!1;const _=new C(N.maxResults,T,N.previewOptions);_.on("result",ee=>{Z=!0,ge="",j.report(ee)});let H=!1;const Y=()=>{H=!0,B?.kill(),_?.cancel()};let ie=!1;_.on("hitLimit",()=>{ie=!0,Y()});let ge="";B.stdout.on("data",ee=>{_.handleData(ee),Z||(ge+=ee)});let X=!1;B.stdout.once("data",()=>X=!0);let J="";B.stderr.on("data",ee=>{const me=ee.toString();this.a.appendLine(me),J.length+me.length<1e6&&(J+=me)}),B.on("close",()=>{if(this.a.appendLine(X?"Got data from stdout":"No data from stdout"),this.a.appendLine(Z?"Got result from parser":"No result from parser"),ge&&this.a.appendLine(`Got data without result: ${ge}`),this.a.appendLine(""),H)Q({limitHit:ie});else{_.flush(),B=null;let ee;J&&!X&&(ee=p(J))?x((0,P.serializeSearchError)(new P.SearchError(ee.message,ee.code))):Q({limitHit:ie})}})})}}e.RipgrepTextSearchEngine=h;function p(E){const w=E.split(`
`),N=w[0].trim();if(w.some(V=>V.startsWith("regex parse error")))return new P.SearchError(b(w),P.SearchErrorCode.regexParseError);const j=N.match(/grep config error: unknown encoding: (.*)/);if(j)return new P.SearchError(`Unknown encoding: ${j[1]}`,P.SearchErrorCode.unknownEncoding);if(N.startsWith("error parsing glob"))return new P.SearchError(N.charAt(0).toUpperCase()+N.substr(1),P.SearchErrorCode.globParseError);if(N.startsWith("the literal"))return new P.SearchError(N.charAt(0).toUpperCase()+N.substr(1),P.SearchErrorCode.invalidLiteral);if(N.startsWith("PCRE2: error compiling pattern"))return new P.SearchError(N,P.SearchErrorCode.regexParseError)}function b(E){const w=["Regex parse error"],N=E.filter(j=>j.startsWith("PCRE2:"));if(N.length>=1){const j=N[0].replace("PCRE2:","");if(j.indexOf(":")!==-1&&j.split(":").length>=2){const V=j.split(":")[1];w.push(":"+V)}}return w.join("")}class C extends L.EventEmitter{constructor(w,N,j){super(),this.g=w,this.h=N,this.j=j,this.a="",this.b=!1,this.c=!1,this.f=0,this.d=new l.StringDecoder}cancel(){this.b=!0}flush(){this.k(this.d.end())}on(w,N){return super.on(w,N),this}handleData(w){if(this.b)return;const N=typeof w=="string"?w:this.d.write(w);this.k(N)}k(w){let N=w.indexOf(`
`);const j=this.a+w;if(N>=0)N+=this.a.length;else{this.a=j;return}let V=0;for(;N>=0;)this.m(j.substring(V,N).trim()),V=N+1,N=j.indexOf(`
`,V);this.a=j.substring(V)}m(w){if(this.b||!w)return;let N;try{N=JSON.parse(w)}catch{throw new Error(`malformed line from rg: ${w}`)}if(N.type==="match"){const j=g(N.data.path),V=O.URI.file(y.join(this.h,j)),Q=this.n(N.data,V);this.p(Q),this.c&&(this.cancel(),this.emit("hitLimit"))}else if(N.type==="context"){const j=g(N.data.path),V=O.URI.file(y.join(this.h,j));this.o(N.data,V).forEach(x=>this.p(x))}}n(w,N){const j=w.line_number-1,V=g(w.lines),Q=Buffer.from(V);let x=0,U=0,T=j;w.submatches.length===0&&w.submatches.push(V.length?{start:0,end:1,match:{text:V[0]}}:{start:0,end:0,match:{text:""}});const F=(0,R.coalesce)(w.submatches.map((B,Z)=>{if(this.c)return null;this.f++,this.f>=this.g&&(this.c=!0);const _=g(B.match),H=Q.slice(x,B.start).toString(),Y=i(H),ie=Y.numLines>0?Y.lastLineLength:Y.lastLineLength+U,ge=i(_),X=Y.numLines+T,J=ge.numLines+X,ee=ge.numLines>0?ge.lastLineLength:ge.lastLineLength+ie;return x=B.end,U=ee,T=J,new v.Range(X,ie,J,ee)}));return(0,f.createTextSearchResult)(N,V,F,this.j)}o(w,N){const j=g(w.lines),V=w.line_number;return j.replace(/\r?\n$/,"").split(`
`).map((Q,x)=>({text:Q,uri:N,lineNumber:V+x}))}p(w){this.emit("result",w)}}e.RipgrepParser=C;function g(E){return E.bytes?Buffer.from(E.bytes,"base64").toString():E.text}function i(E){const w=/\n/g;let N=0,j=-1,V;for(;V=w.exec(E);)N++,j=V.index;const Q=j>=0?E.length-j-1:E.length;return{numLines:N,lastLineLength:Q}}function s(E,w){const N=["--hidden"];N.push(E.isCaseSensitive?"--case-sensitive":"--ignore-case");const{doubleStarIncludes:j,otherIncludes:V}=(0,S.groupBy)(w.includes,x=>x.startsWith("**")?"doubleStarIncludes":"otherIncludes");if(V&&V.length){const x=new Set;V.forEach(U=>{x.add(U)}),N.push("-g","!*"),x.forEach(U=>{r(U).map(f.anchorGlob).forEach(T=>{N.push("-g",T)})})}j&&j.length&&j.forEach(x=>{N.push("-g",x)}),w.excludes.map(f.anchorGlob).forEach(x=>N.push("-g",`!${x}`)),w.maxFileSize&&N.push("--max-filesize",w.maxFileSize+""),w.useIgnoreFiles?w.useParentIgnoreFiles||N.push("--no-ignore-parent"):N.push("--no-ignore"),w.followSymlinks&&N.push("--follow"),w.encoding&&w.encoding!=="utf8"&&N.push("--encoding",w.encoding),E.pattern==="--"&&(E.isRegExp=!0,E.pattern="\\-\\-"),E.isMultiline&&!E.isRegExp&&(E.pattern=(0,I.escapeRegExpCharacters)(E.pattern),E.isRegExp=!0),w.usePCRE2&&N.push("--pcre2"),N.push("--crlf"),E.isRegExp&&(E.pattern=o(E.pattern),N.push("--engine","auto"));let Q;if(E.isWordMatch){const U=(0,I.createRegExp)(E.pattern,!!E.isRegExp,{wholeWord:E.isWordMatch}).source.replace(/\\\//g,"/");N.push("--regexp",U)}else if(E.isRegExp){let x=m(E.pattern);x=n(x),N.push("--regexp",x)}else Q=E.pattern,N.push("--fixed-strings");return N.push("--no-config"),w.useGlobalIgnoreFiles||N.push("--no-ignore-global"),N.push("--json"),E.isMultiline&&N.push("--multiline"),w.beforeContext&&N.push("--before-context",w.beforeContext+""),w.afterContext&&N.push("--after-context",w.afterContext+""),N.push("--"),Q&&N.push(Q),N.push("."),N}e.getRgArgs=s;function r(E){return d(E).flatMap(N=>{const j=(0,A.splitGlobAware)(N,"/");return j.map((V,Q)=>j.slice(0,Q+1).join("/"))})}function o(E){const w=/((?:[^\\]|^)(?:\\\\)*)\\u([a-z0-9]{4})/gi;for(;E.match(w);)E=E.replace(w,"$1\\x{$2}");const N=/((?:[^\\]|^)(?:\\\\)*)\\u\{([a-z0-9]{4})\}/gi;for(;E.match(N);)E=E.replace(N,"$1\\x{$2}");return E}e.unicodeEscapesToPCRE2=o;const c=E=>E.type==="Assertion"&&E.kind==="lookbehind";function m(E){let w;try{w=new k.RegExpParser().parsePattern(E)}catch{return E}let N="",j=0;const V=(U,T,F)=>{N+=E.slice(j,U)+F,j=T},Q=[];return new k.RegExpVisitor({onCharacterEnter(U){if(U.raw!=="\\n")return;const T=Q[0];if(!T)V(U.start,U.end,"\\r?\\n");else if(!Q.some(c))if(T.type==="CharacterClass")if(T.negate){const F=E.slice(T.start+2,U.start)+E.slice(U.end,T.end-1);T.parent?.type==="Quantifier"?V(T.start,T.end,F?`[^${F}]`:"."):V(T.start,T.end,"(?!\\r?\\n"+(F?`|[${F}]`:"")+")")}else{const F=E.slice(T.start+1,U.start)+E.slice(U.end,T.end-1);V(T.start,T.end,F===""?"\\r?\\n":`(?:[${F}]|\\r?\\n)`)}else T.type==="Quantifier"&&V(U.start,U.end,"(?:\\r?\\n)")},onQuantifierEnter(U){Q.unshift(U)},onQuantifierLeave(){Q.shift()},onCharacterClassRangeEnter(U){Q.unshift(U)},onCharacterClassRangeLeave(){Q.shift()},onCharacterClassEnter(U){Q.unshift(U)},onCharacterClassLeave(){Q.shift()},onAssertionEnter(U){c(U)&&Q.push(U)},onAssertionLeave(U){Q[0]===U&&Q.shift()}}).visit(w),N+=E.slice(j),N}e.fixRegexNewline=m;function n(E){return E.replace(/\n/g,"\\r?\\n")}e.fixNewline=n;function t(E){let w=!1,N=!1,j="",V="";for(let Q=0;Q<E.length;Q++){const x=E[Q];switch(x){case"\\":N?(w?V+="\\"+x:j+="\\"+x,N=!1):N=!0;break;case"{":if(N)w?V+=x:j+=x,N=!1;else{if(w)return{strInBraces:j+"{"+V+"{"+E.substring(Q+1)};w=!0}break;case"}":if(N)w?V+=x:j+=x,N=!1;else{if(w)return{fixedStart:j,strInBraces:V,fixedEnd:E.substring(Q+1)};j+=x}break;default:w?V+=(N?"\\":"")+x:j+=(N?"\\":"")+x,N=!1;break}}return{strInBraces:j+(w?"{"+V:"")}}function d(E){const{fixedStart:w,strInBraces:N,fixedEnd:j}=t(E);if(w===void 0||j===void 0)return[N];let V=(0,A.splitGlobAware)(N,",");V.length||(V=[""]);const Q=d(j);return V.flatMap(x=>{const U=w+x;return Q.map(T=>U+T)})}e.performBraceExpansionForRipgrep=d}),define(ye[313],De([1,0,21,145,126,16]),function(re,e,a,L,l,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RipgrepSearchProvider=void 0;class S{constructor(I){this.b=I,this.a=new Set,process.once("exit",()=>this.d())}provideTextSearchResults(I,O,P,v){const k=new L.RipgrepTextSearchEngine(this.b);if(O.folder.scheme===R.Schemas.vscodeUserData){const D={...O,folder:O.folder.with({scheme:R.Schemas.file})},f=new l.Progress(u=>P.report({...u,uri:u.uri.with({scheme:O.folder.scheme})}));return this.c(v,u=>k.provideTextSearchResults(I,D,f,u))}else return this.c(v,D=>k.provideTextSearchResults(I,O,P,D))}async c(I,O){const P=A(I);this.a.add(P);const v=await O(P.token);return this.a.delete(P),v}d(){this.a.forEach(I=>I.cancel())}}e.RipgrepSearchProvider=S;function A(y){const I=new a.CancellationTokenSource;return y.onCancellationRequested(()=>I.cancel()),I}}),define(ye[314],De([1,0,29,145,144]),function(re,e,a,L,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchEngineAdapter=void 0;class R{constructor(y){this.a=y}search(y,I,O){if((!this.a.folderQueries||!this.a.folderQueries.length)&&(!this.a.extraFileResources||!this.a.extraFileResources.length))return Promise.resolve({type:"success",limitHit:!1,stats:{type:"searchProcess"}});const P={appendLine(k){O({message:k})}},v=new l.NativeTextSearchManager(this.a,new L.RipgrepTextSearchEngine(P),a);return new Promise((k,D)=>v.search(f=>{I(f.map(S))},y).then(f=>k({limitHit:f.limitHit,type:"success",stats:f.stats}),D))}}e.TextSearchEngineAdapter=R;function S(A){return{path:A.resource&&A.resource.fsPath,results:A.results,numMatches:(A.results||[]).reduce((y,I)=>{if(I.ranges){const O=I;return y+(Array.isArray(O.ranges)?O.ranges.length:1)}else return y+1},0)}}}),define(ye[315],De([1,0,15,17,11,3,107,9,43,2,44,31,305,314]),function(re,e,a,L,l,R,S,A,y,I,O,P,v,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SearchService=void 0;class D{constructor(C="searchProcess"){this.d=C,this.b=Object.create(null)}fileSearch(C){let g;const i=h(C),s=new R.Emitter({onDidAddFirstListener:()=>{g=(0,L.createCancelablePromise)(r=>this.doFileSearchWithEngine(v.Engine,i,o=>s.fire(o),r)),g.then(r=>s.fire(r),r=>s.fire({type:"error",error:{message:r.message,stack:r.stack}}))},onDidRemoveLastListener:()=>{g.cancel()}});return s.event}textSearch(C){let g;const i=h(C),s=new R.Emitter({onDidAddFirstListener:()=>{g=(0,L.createCancelablePromise)(r=>this.f(i,o=>s.fire(o),r)),g.then(r=>s.fire(r),r=>s.fire({type:"error",error:{message:r.message,stack:r.stack}}))},onDidRemoveLastListener:()=>{g.cancel()}});return s.event}f(C,g,i){return C.maxFileSize=(0,O.getPlatformFileLimits)(process.arch==="ia32"?0:1).maxFileSize,new k.TextSearchEngineAdapter(C).search(i,g,g)}doFileSearch(C,g,i){return this.doFileSearchWithEngine(v.Engine,C,g,i)}doFileSearchWithEngine(C,g,i,s,r=D.a){let o=0;const c=n=>{Array.isArray(n)?(o+=n.length,i(n.map(t=>this.g(t)))):n.relativePath?(o++,i(this.g(n))):i(n)};if(g.sortByScore){let n=this.k(g,c,s);if(!n){const t=g.maxResults?Object.assign({},g,{maxResults:null}):g,d=new C(t);n=this.h(d,g,i,c,s)}return new Promise((t,d)=>{n.then(([E,w])=>{const N=w.map(j=>this.g(j));this.n(N,i,r),t(E)},d)})}const m=new C(g);return this.q(m,c,r,s).then(n=>({limitHit:n.limitHit,type:"success",stats:{detailStats:n.stats,type:this.d,fromCache:!1,resultCount:o,sortingTime:void 0}}))}g(C){return{path:C.base?(0,A.join)(C.base,C.relativePath):C.relativePath}}h(C,g,i,s,r){const o=new R.Emitter;let c=(0,L.createCancelablePromise)(n=>{let t=[];const d=E=>{Array.isArray(E)?t=E:(s(E),o.fire(E))};return this.q(C,d,-1,n).then(E=>[E,t])}),m;if(g.cacheKey){m=this.j(g.cacheKey);const n={promise:c,event:o.event,resolved:!1};m.resultsToSearchCache[g.filePattern||""]=n,c.then(()=>{n.resolved=!0},t=>{delete m.resultsToSearchCache[g.filePattern||""]}),c=this.r(c)}return c.then(([n,t])=>{const d=m?m.scorerCache:Object.create(null),E=(typeof g.maxResults!="number"||g.maxResults>0)&&y.StopWatch.create(!1);return this.l(g,t,d,r).then(w=>{const N=E?E.elapsed():-1;return[{type:"success",stats:{detailStats:n.stats,sortingTime:N,fromCache:!1,type:this.d,workspaceFolderCount:g.folderQueries.length,resultCount:w.length},messages:n.messages,limitHit:n.limitHit||typeof g.maxResults=="number"&&t.length>g.maxResults},w]})})}j(C){const g=this.b[C];return g||(this.b[C]=new f)}k(C,g,i){const s=C.cacheKey&&this.b[C.cacheKey];if(!s)return;const r=this.o(s,C.filePattern||"",g,i);if(r)return r.then(([o,c,m])=>{const n=y.StopWatch.create(!1);return this.l(C,c,s.scorerCache,i).then(t=>{const d=n.elapsed(),E={fromCache:!0,detailStats:m,type:this.d,resultCount:c.length,sortingTime:d};return[{type:"success",limitHit:o.limitHit||typeof C.maxResults=="number"&&c.length>C.maxResults,stats:E},t]})})}l(C,g,i,s){const r=(0,S.prepareQuery)(C.filePattern||""),o=(m,n)=>(0,S.compareItemsByFuzzyScore)(m,n,r,!0,u,i),c=typeof C.maxResults=="number"?C.maxResults:Number.MAX_VALUE;return a.topAsync(g,o,c,1e4,s)}n(C,g,i){if(i&&i>0)for(let s=0;s<C.length;s+=i)g(C.slice(s,s+i));else g(C)}o(C,g,i,s){const r=y.StopWatch.create(!1),o=g.indexOf(A.sep)>=0;let c;for(const d in C.resultsToSearchCache)if(g.startsWith(d)){if(o&&d.indexOf(A.sep)<0&&d!=="")continue;const E=C.resultsToSearchCache[d];c={promise:this.r(E.promise),event:E.event,resolved:E.resolved};break}if(!c)return null;const m=r.elapsed(),n=y.StopWatch.create(!1),t=c.event(i);return s&&s.onCancellationRequested(()=>{t.dispose()}),c.promise.then(([d,E])=>{if(s&&s.isCancellationRequested)throw(0,l.canceled)();const w=[],N=(0,S.prepareQuery)(g).normalizedLowercase;for(const j of E)!(0,P.isFilePatternMatch)(j,N)||w.push(j);return[d,w,{cacheWasResolved:c.resolved,cacheLookupTime:m,cacheFilterTime:n.elapsed(),cacheEntryCount:E.length}]})}q(C,g,i,s){return new Promise((r,o)=>{let c=[];s?.onCancellationRequested(()=>C.cancel()),C.search(m=>{m&&(i?(c.push(m),i>0&&c.length>=i&&(g(c),c=[])):g(m))},m=>{g(m)},(m,n)=>{c.length&&g(c),m?o(m):r(n)})})}clearCache(C){return delete this.b[C],Promise.resolve(void 0)}r(C){return new class{get[Symbol.toStringTag](){return this.toString()}cancel(){}then(g,i){return C.then(g,i)}catch(g){return this.then(void 0,g)}finally(g){return C.finally(g)}}}}D.a=512,e.SearchService=D;class f{constructor(){this.resultsToSearchCache=Object.create(null),this.scorerCache=Object.create(null)}}const u=new class{getItemLabel(b){return(0,A.basename)(b.relativePath)}getItemDescription(b){return(0,A.dirname)(b.relativePath)}getItemPath(b){return b.relativePath}};function h(b){return{...b,folderQueries:b.folderQueries&&b.folderQueries.map(p),extraFileResources:b.extraFileResources&&b.extraFileResources.map(C=>I.URI.revive(C))}}function p(b){return{...b,folder:I.URI.revive(b.folder)}}}),define(ye[316],De([1,0,6,16,2,29,13,25,18,86,57,31,315,313,100,144]),function(re,e,a,L,l,R,S,A,y,I,O,P,v,k,D,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtHostSearch=void 0;let u=class extends I.ExtHostSearch{constructor(p,b,C,g){super(p,C,g),this.s=R,this.t=-1,this.v=null,this.w=!1;const i=new D.OutputChannel("RipgrepSearchUD",this.n);this.registerTextSearchProvider(L.Schemas.vscodeUserData,new k.RipgrepSearchProvider(i)),b.remote.isRemote&&b.remote.authority&&this.x()}$enableExtensionHostSearch(){this.x()}x(){if(this.w)return;this.w=!0;const p=new D.OutputChannel("RipgrepSearchEH",this.n);this.registerTextSearchProvider(L.Schemas.file,new k.RipgrepSearchProvider(p)),this.y(L.Schemas.file,new v.SearchService("fileSearchProvider"))}y(p,b){const C=this.d++;return this.v=b,this.t=C,this.c.$registerFileSearchProvider(C,this.o(p)),(0,a.toDisposable)(()=>{this.v=null,this.c.$unregisterProvider(C)})}$provideFileSearchResults(p,b,C,g){const i=(0,I.reviveQuery)(C);return p===this.t?this.z(p,b,i,g):super.$provideFileSearchResults(p,b,C,g)}z(p,b,C,g){const i=s=>{if((0,P.isSerializedFileMatch)(s)&&(s=[s]),Array.isArray(s)){this.c.$handleFileMatch(p,b,s.map(r=>l.URI.file(r.path)));return}s.message&&this.n.debug("ExtHostSearch",s.message)};if(!this.v)throw new Error("No internal file search handler");return this.v.doFileSearch(C,i,g)}$clearCache(p){return this.v?.clearCache(p),super.$clearCache(p)}q(p,b){return new f.NativeTextSearchManager(p,b,void 0,"textSearchProvider")}};u=qe([ze(0,y.IExtHostRpcService),ze(1,A.IExtHostInitDataService),ze(2,O.IURITransformerService),ze(3,S.ILogService)],u),e.NativeExtHostSearch=u}),define(ye[317],De([1,0,90,288,300,299,316,312,289,85,42,86,83,41,56,80,287,286,13,301,49]),function(re,e,a,L,l,R,S,A,y,I,O,P,v,k,D,f,u,h,p,b,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,a.registerSingleton)(O.IExtHostExtensionService,A.ExtHostExtensionService,0),(0,a.registerSingleton)(p.ILoggerService,h.ExtHostLoggerService,1),(0,a.registerSingleton)(f.IExtensionStoragePaths,u.ExtensionStoragePaths,0),(0,a.registerSingleton)(I.IExtHostDebugService,R.ExtHostDebugService,0),(0,a.registerSingleton)(P.IExtHostSearch,S.NativeExtHostSearch,0),(0,a.registerSingleton)(v.IExtHostTask,l.ExtHostTask,0),(0,a.registerSingleton)(k.IExtHostTerminalService,L.ExtHostTerminalService,0),(0,a.registerSingleton)(D.IExtHostTunnelService,y.ExtHostTunnelService,0),(0,a.registerSingleton)(C.IExtHostVariableResolverProvider,b.NodeExtHostVariableResolverProviderService,0)}),define(ye[325],De([1,0,229,326,84,11,115,116,207,96,298,22,29,112,17,121,224,237,302,317]),function(re,e,a,L,l,R,S,A,y,I,O,P,v,k,D,f,u,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),function(){for(let m=0;m<process.execArgv.length;m++)process.execArgv[m]==="--inspect-port=0"&&(process.execArgv.splice(m,1),m--)}();const p=L(process.argv.slice(2),{boolean:["transformURIs","skipWorkspaceStorageLock"],string:["useHostProxy"]});(function(){const c=globalThis._VSCODE_NODE_MODULES.module,m=c._load;c._load=function(n){if(n==="natives")throw new Error('Either the extension or an NPM dependency is using the [unsupported "natives" node module](https://go.microsoft.com/fwlink/?linkid=871887).');return m.apply(this,arguments)}})();const b=process.exit.bind(process);function C(c){process.exit=function(m){if(c)b(m);else{const n=new Error("An extension called process.exit() and this was prevented.");console.warn(n.stack)}},process.crash=function(){const m=new Error("An extension called process.crash() and this was prevented.");console.warn(m.stack)},process.env.ELECTRON_RUN_AS_NODE="1"}let g=function(c){b()};function i(){const c=(0,h.readExtHostConnection)(process.env);if(c.type===3)return new Promise((m,n)=>{const t=d=>{const E=d[0],w=new S.BufferedEmitter;E.on("message",N=>w.fire(P.VSBuffer.wrap(N.data))),E.on("close",()=>{g("renderer closed the MessagePort")}),E.start(),m({onMessage:w.event,send:N=>E.postMessage(N.buffer)})};process.parentPort.on("message",d=>t(d.ports))});if(c.type===2)return new Promise((m,n)=>{let t=null;const d=setTimeout(()=>{g("VSCODE_EXTHOST_IPC_SOCKET timeout")},6e4),E=108e5,w=3e5,N=new D.ProcessTimeRunOnceScheduler(()=>g("renderer disconnected for too long (1)"),E),j=new D.ProcessTimeRunOnceScheduler(()=>g("renderer disconnected for too long (2)"),w);process.on("message",(Q,x)=>{if(Q&&Q.type==="VSCODE_EXTHOST_IPC_SOCKET"){x.setNoDelay(!0);const U=P.VSBuffer.wrap(Buffer.from(Q.initialDataChunk,"base64"));let T;if(Q.skipWebSocketFrames)T=new A.NodeSocket(x,"extHost-socket");else{const F=P.VSBuffer.wrap(Buffer.from(Q.inflateBytes,"base64"));T=new A.WebSocketNodeSocket(new A.NodeSocket(x,"extHost-socket"),Q.permessageDeflate,F,!1)}t?(N.cancel(),j.cancel(),t.beginAcceptReconnection(T,U),t.endAcceptReconnection(),t.sendResume()):(clearTimeout(d),t=new S.PersistentProtocol({socket:T,initialChunk:U}),t.sendResume(),t.onDidDispose(()=>g("renderer disconnected")),m(t),t.onSocketClose(()=>{N.schedule()}))}if(Q&&Q.type==="VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"){if(j.isScheduled())return;N.isScheduled()&&j.schedule()}});const V={type:"VSCODE_EXTHOST_IPC_READY"};process.send?.(V)});{const m=c.pipeName;return new Promise((n,t)=>{const d=a.createConnection(m,()=>{d.removeListener("error",t);const E=new S.PersistentProtocol({socket:new A.NodeSocket(d,"extHost-renderer")});E.sendResume(),n(E)});d.once("error",t),d.on("close",()=>{g("renderer closed the socket")})})}}async function s(){const c=await i();return new class{constructor(){this.a=new S.BufferedEmitter,this.onMessage=this.a.event,this.b=!1,c.onMessage(m=>{(0,I.isMessageOfType)(m,2)?(this.b=!0,g("received terminate message from renderer")):this.a.fire(m)})}send(m){this.b||c.send(m)}async drain(){if(c.drain)return c.drain()}}}function r(c){return new Promise(m=>{const n=c.onMessage(t=>{n.dispose();const d=JSON.parse(t.toString()),E=d.commit,w=y.default.commit;if(E&&w&&E!==w&&b(55),d.parentPid){let N=0;setInterval(function(){try{process.kill(d.parentPid,0),N=0}catch(V){V&&V.code==="EPERM"?(N++,N>=3&&g(`parent process ${d.parentPid} does not exist anymore (3 x EPERM): ${V.message} (code: ${V.code}) (errno: ${V.errno})`)):g(`parent process ${d.parentPid} does not exist anymore: ${V.message} (code: ${V.code}) (errno: ${V.errno})`)}},1e3);let j;try{j=globalThis._VSCODE_NODE_MODULES["native-watchdog"],j.start(d.parentPid)}catch(V){(0,R.onUnexpectedError)(V)}}c.send((0,I.createMessageOfType)(0)),m({protocol:c,initData:d})});c.send((0,I.createMessageOfType)(1))})}async function o(){const c=[];process.on("unhandledRejection",(N,j)=>{c.push(j),setTimeout(()=>{const V=c.indexOf(j);V>=0&&j.catch(Q=>{c.splice(V,1),(0,R.isCancellationError)(Q)||(console.warn(`rejected promise not handled within 1 second: ${Q}`),Q&&Q.stack&&console.warn(`stack trace: ${Q.stack}`),N&&(0,R.onUnexpectedError)(N))})},1e3)}),process.on("rejectionHandled",N=>{const j=c.indexOf(N);j>=0&&c.splice(j,1)}),process.on("uncaughtException",function(N){(0,R.isSigPipeError)(N)||(0,R.onUnexpectedError)(N)}),l.mark("code/extHost/willConnectToRenderer");const m=await s();l.mark("code/extHost/didConnectToRenderer");const n=await r(m);l.mark("code/extHost/didWaitForInitData");const{initData:t}=n;C(!!t.environment.extensionTestsLocationURI),t.environment.useHostProxy=p.useHostProxy!==void 0?p.useHostProxy!=="false":void 0,t.environment.skipWorkspaceStorageLock=(0,f.boolean)(p.skipWorkspaceStorageLock,!1);const d=new class{constructor(){this.pid=process.pid}exit(j){b(j)}exists(j){return v.Promises.exists(j)}realpath(j){return(0,k.realpath)(j)}};let E=null;t.remote.authority&&p.transformURIs&&(E=(0,u.createURITransformer)(t.remote.authority));const w=new O.ExtensionHostMain(n.protocol,t,d,E);g=N=>w.terminate(N)}o().catch(c=>console.log(c))})}).call(this);

//# sourceMappingURL=extensionHostProcess.js.map
